(**************************************************************************

    This file is part of the AtomicDensityMatrix package for Mathematica
    Copyright (C) 2004-2020 Simon M. Rochester <simon@rochesterscientific.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

**************************************************************************)

(*Usage Messages*)

(*Messing with System` symbols*)

(*Information[] bug*)
(*Fix for general Mathematica bug in Information[]. *)

System`Dump`fixmessagestring[System`Dump`s_] := ToString@InputForm@System`Dump`s;

(*Original Definition:*)
(*System`Dump`fixmessagestring[System`Dump`s_]:="\""<>StringReplace[System`Dump`s,{"\n"\[Rule]"\\n","\\"\[Rule]"\\\\","\""\[Rule]"\\\""}]<>"\""*)

(*Overload WignerD*)

(*Unprotect WignerD if defined*)

If[$VersionNumber >= 8., ToExpression["Unprotect[WignerD];WignerD[{1,1,1},0]"]];

BeginPackage["AtomicDensityMatrix`"];

Unprotect[Evaluate[$Context <> "*"]];

(* General messages *)

General::adminvopt = "Invalid value `2` for option `1`.";

(*Usage messages for ADMPerturbativeSolve.m*)

ComplexFrequencyMatrix::usage = "";

SteadyStatePerturbativeSolve::usage = "";

TDPerturbativeSolve::usage = "";

(*Usage messages for Arrow3D.m*)

Axes3D::usage = "";

AutoLengthScale::usage = "";

RenderStyle::usage = "";

Arrow3D::usage = "";

ArrowShape::usage = "";

Width::usage = "";

LabelPosition::usage = "";

HeadAngle::usage = "";

ColorAll::usage = "";

FatHead::usage = "";

FlatHead::usage = "";

Opening::usage = "";

Cone3D::usage = "";

Disk3D::usage = "";

Circle3D::usage = "";

OutlineShadow::usage = "";

WireCylinder::usage = "";

WireFrame::usage = "";

fixArrowheadSpecs::usage = "";

TripleOption::usage = "";

(*Usage messages for AtomicData.m*)

StateLabels::usage = "";

AtomicSystem::usage = "";

AtomicTransition::usage = "AtomicTransition[\!\(\*
StyleBox[\"atom\", \"TI\"]\),\!\(\*
StyleBox[\"line\", \"TI\"]\)]
 returns the designations of the two states involved in the transition specified by the strings \!\(\*
StyleBox[\"atom\", \"TI\"]\) and \!\(\*
StyleBox[\"line\", \"TI\"]\).";

$AtomicDataFields::usage = "$AtomicDataFields contains a list of data types (fields) in the AtomicData database.";

ElementName::usage = "ElementName is a type of data for AtomicData, giving the name of the element.";

ElementSymbol::usage = "";

AtomicNumber::usage = "";

AtomicWeight::usage = "";

Abundance::usage = "";

Wavenumber::usage = "Wavenumber[state] returns the spectroscopic wavenumber \!\(\*OverscriptBox[\(\[Nu]\), \(_\)]\) = \[Omega]/(2\[Pi]c).";

DopplerWidth::usage = "";

MostProbableSpeed::usage = "";

Lifetime::usage = "";

AtomicDataDefinedQ::usage = "";

AtomicConfiguration::usage = "";

AtomicTerm::usage = "";

TermSymbol::usage = "";

ValenceElectrons::usage = "";

CoreSymbol::usage = "";

SpinMultiplicity::usage = "";

LSymbol::usage = "";

PrincipalQuantumNumber::usage = "";

ElectronL::usage = "";

ElectronEquivalency::usage = "";

VaporPressure::usage = "";

AtomicDensity::usage = "";

PartialWidth::usage = "";
NaturalWidthFromPartialWidths::usage = "";
PossibleDecays::usage = "";

(*Usage messages for AtomicDensityMatrix.m*)

(*Meta info*)

$ADMVersion::usage = "$ADMVersion returns the version number of the AtomicDensityMatrix package.";

(*Usage messages for AtomicSystem.m*)

AtomicSystemPattern::usage = "";

CountZeemanSublevels::usage = "";

HyperfineTypeSystem::usage = "";

(*Atomic system*)

HyperfineC::usage = "";

PolarizationMoments::usage = "";

(*Hamiltonians*)

StateMatchQ::usage = "";

StateEvaluate::usage = "";

SelectState::usage = "";

MatrixElementPosition::usage = "";

MatrixElement::usage = "";

MatrixElements::usage = "";

MatrixElementMask::usage = "";

SublevelMultiplicity::usage = "SublevelMultiplicity[\!\(\*
StyleBox[\"state\", \"TI\"]\)], where \!\(\*
StyleBox[\"state\", \"TI\"]\) is an AtomicState object, returns the number of magnetic sublevels corresponding to the F, J, and NuclearSpin quantum numbers of \!\(\*
StyleBox[\"state\", \"TI\"]\). If F is defined, (2F+1) is returned; otherwise (2J+1)(2NuclearSpin+1) is returned, where NuclearSpin is assumed to be zero if it is not defined.

SublevelMultiplicity[\!\(\*
StyleBox[\"system\", \"TI\"]\)], where \!\(\*
StyleBox[\"system\", \"TI\"]\) is a list of AtomicState objects, returns the total number of unique magnetic sublevels of all of the states, as given by J and NuclearSpin of each AtomicState. Any F quantum numbers that may be defined are ignored, and only one AtomicState corresponding to each unique StateLabel is considered.";

Polarizability::usage = "Polarizability[\!\(\*
StyleBox[\"k\", \"TI\"]\)] is a parameter specified in an AtomicState expression that specifies the scalar (\!\(\*
StyleBox[\"k\", \"TI\"]\)=0), vector (\!\(\*
StyleBox[\"k\", \"TI\"]\)=1), or tensor (\!\(\*
StyleBox[\"k\", \"TI\"]\)=2) polarizability for the state. The value can be numeric or symbolic. 
Polarizability[\!\(\*
StyleBox[\"k\", \"TI\"]\)][\!\(\*
StyleBox[\"state\", \"TI\"]\)] returns the corresponding specified value for the polarizability of AtomicState \!\(\*
StyleBox[\"state\", \"TI\"]\), or Polarizability[\!\(\*
StyleBox[\"k\", \"TI\"]\)][StateLabel[\!\(\*
StyleBox[\"state\", \"TI\"]\)]] if it is not specified.";

TransitionPolarizability::usage = "";

GroundStateQ::usage = "GroundStateQ[\!\(\*
StyleBox[\"state\", \"TI\"]\)] returns True if NaturalWidth[\!\(\*
StyleBox[\"state\", \"TI\"]\)] is zero, and False otherwise.";

FineStructureStatesQ::usage = "";

LevelPosition::usage = "";

t::usage = "t is the default value for the option TimeVariable in DensityMatrix and other functions.";

StateParameters::usage = "StateParameters[\!\(\*
StyleBox[\"state\", \"TI\"]\)] returns the state parameters of the AtomicState \!\(\*
StyleBox[\"state\", \"TI\"]\).";

StateParameterPattern::usage = "";

StateParameterQ::usage = "StateParameterQ[\!\(\*
StyleBox[\"expr\", \"TI\"]\)] returns True if \!\(\*
StyleBox[\"expr\", \"TI\"]\) is a valid parameter for an AtomicState expression, and False otherwise.";

StateLabelQ::usage = "";

DefinedQ::usage = "DefinedQ[\!\(\*
StyleBox[\"state\", \"TI\"]\),\!\(\*
StyleBox[\"param\", \"TI\"]\)] returns True if state parameter \!\(\*
StyleBox[\"param\", \"TI\"]\) is specified in AtomicState \!\(\*
StyleBox[\"state\", \"TI\"]\), and False otherwise.
DefinedQ[\!\(\*
StyleBox[\"state\", \"TI\"]\),{\!\(\*SubscriptBox[
StyleBox[\"param\", \"TI\"], \"1\"]\),\!\(\*SubscriptBox[
StyleBox[\"param\", \"TI\"], \"2\"]\),\[Ellipsis]}] returns True if all of the \!\(\*
StyleBox[SubscriptBox[\"param\", \"i\"], \"TI\"]\) are specified in \!\(\*
StyleBox[\"state\", \"TI\"]\), and False otherwise.
DefinedQ[{\!\(\*SubscriptBox[
StyleBox[\"state\", \"TI\"], \"1\"]\),\!\(\*SubscriptBox[
StyleBox[\"state\", \"TI\"], \"2\"]\),\[Ellipsis]},\!\(\*
StyleBox[\"param\", \"TI\"]\)] checks if \!\(\*
StyleBox[\"param\", \"TI\"]\) is specified in all of the states.
DefinedQ behaves analogously with region parameters and regions in place of state parameters and states.";

DeleteParameter::usage = "DeleteParameter[\!\(\*
StyleBox[\"state\", \"TI\"]\),\!\(\*
StyleBox[\"param\", \"TI\"]\)] deletes any specification for state parameter \!\(\*
StyleBox[\"param\", \"TI\"]\) from the AtomicState \!\(\*
StyleBox[\"state\", \"TI\"]\).
If a list of states is supplied, the parameter is deleted from all of the states. If a list of parameters is supplied, all of the parameters are deleted.
DeleteParameter behaves analogously with region parameters and regions in place of state parameters and states.";

AddParameter::usage = "AddParameter[\!\(\*
StyleBox[\"state\", \"TI\"]\),\!\(\*
StyleBox[\"param\", \"TI\"]\)->\!\(\*
StyleBox[\"value\", \"TI\"]\)] adds the supplied parameter specification to AtomicState \!\(\*
StyleBox[\"state\", \"TI\"]\), or replaces the existing specification.
AddParameter behaves analogously with region parameters and regions in place of state parameters and states.";

SetSystemType::usage = "";

LevelLabel::usage = "";

SublevelLabel::usage = "";

HyperfineSublevels::usage = "HyperfineSublevels[{\!\(\*SubscriptBox[
StyleBox[\"state\", \"TI\"], \"1\"]\),\!\(\*SubscriptBox[
StyleBox[\"state\", \"TI\"], \"2\"]\),\[Ellipsis]}] returns a list of AtomicState objects in which each \!\(\*
StyleBox[SubscriptBox[\"state\", \"i\"], \"TI\"]\) that has a specified J and NuclearSpin parameter has been expanded into states representing each hyperfine sublevel of the state.";

ZeemanSublevels::usage = "Sublevels[{\!\(\*SubscriptBox[
StyleBox[\"state\", \"TI\"], \"1\"]\),\!\(\*SubscriptBox[
StyleBox[\"state\", \"TI\"], \"2\"]\),\[Ellipsis]}] returns a list of AtomicState objects in which each \!\(\*
StyleBox[SubscriptBox[\"state\", \"i\"], \"TI\"]\) that has a specified J or F parameter has been expanded into states representing each Zeeman sublevel of the state.";

ZeemanSystem::usage = "ZeemanSystem[\!\(\*
StyleBox[\"j\", \"TI\"]\)] returns a list of AtomicState objects describing the Zeeman sublevels of an atomic system with angular momentum \!\(\*
StyleBox[\"j\", \"TI\"]\).
ZeemanSystem[\!\(\*
StyleBox[\"label\", \"TI\"]\),\!\(\*
StyleBox[\"j\", \"TI\"]\)] provides a specific label for the AtomicState objects.";

(*Usage messages for Common.m*)

SmartThread;

QuietCheck;

PerturbativeLinearSolve::usage = "";

StepFunction::usage = "";

FunctionDefinedQ::usage = "";

FalseQ::usage = "";

ZeroMatrix::usage = "";

HalfIntegerQ::usage = "HalfIntegerQ[expr] gives True if expr is integer or half-integer, and False otherwise.";

BlockDiagonal::usage = "BlockDiagonal[matlist] forms a block diagonal matrix from a list of matrices matlist.";

Commutator::usage = "Commutator[mat1, mat2] gives the commutator of matrices mat1 and mat2.";

Anticommutator::usage = "Anticommutator[mat1, mat2] gives the anticommutator of matrices mat1 and mat2.";

LowerTriangle::usage = "LowerTriangle[mat] gives a list of the elements in the lower triangle of mat, including the diagonal.";

UpperTriangle::usage = "UpperTriangle[mat] gives a list of the elements in the upper triangle of mat, including the diagonal.";

DirectProduct::usage = "";

DirectSelfProduct::usage = "";

EnsureList::usage = "";

AllSameQ::usage = "";

Slope::usage = "";

(*ReplaceAt::usage = "ReplaceAt[expr, rules, pos] applies a rule or list of rules in an attempt to transform the part of expression expr specified by pos.*)
(*ReplaceAt[expr, rules, pos, levelspec] applies rules at part of expression expr specified by pos and below according to the level specification levelspec relative to the position pos.*)
(*ReplaceAt uses the default options of Replace.";*)

ReplaceAllAt::usage = "ReplaceAllAt[expr, rules, pos] applies a rule or list of rules in an attempt to transform all parts of the part of expression expr specified by pos.";

RationalizeMachineNumbers::usage = "TruncateMachineNumbers[expr] truncates digits from the end of machine numbers in expr.";

removeAutomaticOptions::usage = "";

genericOptionsPattern::usage = "";

EvaluatedFunction::usage = "";

(*Usage messages for CouplingCoefficients.m*)

CG::usage = "";

TJS::usage = "";

SJS::usage = "";

NJS::usage = "";

(*Usage messages for DensityMatrix.m*)

RepresentationTransform::usage = "";

AllowedPositions::usage = "";

AllowedUpperTrianglePositions::usage = "";

DMElementPattern::usage = "";

DMElementPartPattern::usage = "";

DMElementPart::usage = "";

Subscripts::usage = "";

M1::usage = "";

M2::usage = "";

F1::usage = "";

F2::usage = "";

TimeDerivative::usage = "";

StateLabel1::usage = "";

StateLabel2::usage = "";

State1::usage = "";

State2::usage = "";

Time::usage = "";

LevelLabelPattern::usage = "";

LevelLabelPattern1::usage = "";

LevelLabelPattern2::usage = "";

AllowedElements::usage = "";

NeglectedElements::usage = "";

\[Rho]::usage = "Default variable used for the density matrix.";

ExpandDMVariablesRule::usage = "";

ExprToReIm::usage = "";

ERI::usage = "";

(*Usage messages for AMPSPlot*)

ProjectionProbability::usage = "";

ProjectionState::usage = "";

(*Usage messages for ExperimentalSystem.m*)

ExperimentalRegion::usage = "";

TransitRate::usage = "";

VelocityGroupRecoilMomentum::usage = "";

RecoilRepopulation::usage = "";

SDampingRate::usage = "";

OpticalWidth::usage = "";

VoidRegion::usage = "";

Density::usage = "";

OpticalParameters::usage = "";

RegionParameters::usage = "";

RegionParameterPattern::usage = "";

RegionParameterQ::usage = "";

ExperimentalSystemQ::usage = "";

SelectRegions::usage = "";

RegionLabel::usage = "";

SelectRegion::usage = "";

DeleteRegions::usage = "";

RegionPosition::usage = "";

(*Usage messages for GraphicsUtilities.m*)

GetLines::usage = "";

TranslateX::usage = "";

TranslateY::usage = "";

TranslateZ::usage = "";

RotateX::usage = "";

RotateY::usage = "";

RotateZ::usage = "";

Crop::usage = "";

(*Usage messages for Hamiltonian.m*)

Energies::usage = "";

TransitionFrequencies::usage = "";

Internal::usage = "";

E1::usage = "";

Magnetic::usage = "";

RestrictCoupling::usage = "";

InternalHamiltonian::usage = "";

E1Hamiltonian::usage = "";

MagneticHamiltonian::usage = "";

PolarizabilityHamiltonian::usage = "";

(*Usage messages for LevelDiagram.m*)

MinLabelSpacing::usage = "";

StateLabelPosition::usage = "";

PixelHeight::usage = "";

AbsoluteHeight::usage = "";

AbsoluteWidth::usage = "";

spaceLabels::usage = "";

ConnectArc::usage = "";

TakeFraction::usage = "TakeFraction[\!\(\*
StyleBox[\"list\", \"TI\"]\),\!\(\*
StyleBox[\"f\", \"TI\"]\)] takes a fraction \!\(\*
StyleBox[\"f\", \"TI\"]\) of the elements of \!\(\*
StyleBox[\"list\", \"TI\"]\), rounded to the nearest element.";

PointTriangle::usage = "Draws a filled triangle made up of individual points.";

DiskTriangle::usage = "Draws a filled triangle made up of individual disks.";

OldLevelDiagram::usage = "";

ArrowStyle::usage = "";

StaticArrowStyle::usage = "";

ExtraArrows::usage = "";

ArrowSpacing::usage = "";

ArrowSetback::usage = "";

LevelStyle::usage = "";

ParityOffset::usage = "";

LevelOffset::usage = "";

ArcRadius::usage = "";

MaxArcSlope::usage = "";

LevelSpacing::usage = "";

LevelLength::usage = "";

AbsoluteScale::usage = "";

AbsoluteSize::usage = "";

AdjustArrows::usage = "";

MLabel::usage = "";

JLabel::usage = "";

FLabel::usage = "";

MLabelPosition::usage = "";

JLabelOffset::usage = "";

QN::usage = "";

LevelLabelStyle::usage = "";

SuppressOffResonantCouplings::usage = "";

PopulationFunction::usage = "";

PopulationStyle::usage = "";

ArrowFunction::usage = "";

ArrowOffset::usage = "";

QuantumNumberSymbols::usage = "";

QuantumNumberSubscripts::usage = "";

RibbonArrow::usage = "";

ArrowheadHeight::usage = "";

ArrowheadWidth::usage = "";

FrameOptions::usage = "";

SquiggleArrow::usage = "";

SquiggleFrequency::usage = "";

SquiggleAmplitude::usage = "";

SquiggleTaper::usage = "";

DeleteAllDuplicates::usage = "";

PopAppend::usage = "";

TextOnTop::usage = "";

(*Usage messages for LiouvilleEquation.m*)

BroadLineApproximation::usage = "";

(*Relaxation and repopulation*)

Relaxation::usage = "";

OpticalRepopulationOperator::usage = "";

OpticalRepopulation::usage = "";

OpticalRepopulationPM::usage = "";

OpticalRepopulationZ::usage = "";

HyperfineCoherenceTransfer::usage = "";

SDamping::usage = "";

OpticalBroadening::usage = "";

Repopulation::usage = "";

(*FluorescenceOperator*)

FluorescenceOperator::"usage" = "";

Fluorescence::"usage" = "";

FluorescenceTensor::usage = "";

(*Density matrix evolution equation*)

LiouvilleRHS::usage = "";

(*Usage messages for MatrixRSolve.m*)

MatrixRSolve::usage = "";

EquationsToMatrixRecursion::usage = "";

FourierExpandVariables::usage = "FourierExpandVariables[expr,vars,\[Omega],t,n] replaces variables vars (as functions of t) appearing in expr, e.g. v[t], with symbols FE representing Fourier series in frequency \[Omega] with index n, e.g., FE[v[n],\[Omega],n].";

IntegrateFourierTerms::usage = "IntegrateFourierTerms[expr,vars,\[Omega],t,n] takes a symbolic Fourier expansion generated by FourierExpandVariables and symbolically multiplies by Exp[\[ImaginaryI] \[Omega] t n] and integrates over a period, to find a representation entirely in terms of Fourier coefficients.";

FourierExpandAndIntegrate::usage = "FourierExpandAndIntegrate[expr,vars,\[Omega],t] finds the time-average of expressions expr containing variables vars depending on a time variable t in terms of the Fourier components of vars at harmonics of frequency \[Omega].";

SparseReplaceAll::usage = "";

(*Usage messages for Observables.m*)

(*Solution of wave equation*)

WaveEqnSolution::usage = "";

(*Find dipole polarization*)

PolarizationComponents::usage = "";

(*LinearAbsorption*)

Voigt::usage = "";

InternalEnergy::usage = "";

(*Usage messages for OpticalField.m*)

standardizeOpticalFieldArguments::usage = "";

defaultPolarization::usage = "";

ReparameterizeField::usage = "";

If[!MemberQ[Contexts[], "VectorAnalysis`"],
    ToExpression[
        "Xx::usage=\"\";\[IndentingNewLine]Yy::usage=\"\";\[IndentingNewLine]Zz::usage=\"\";"]
];

(*Other messages for OpticalField.m*)

OpticalField::trans = "PolarizationVector `1` must be transverse to PropagationVector `2`.";

(*Usage messages for PlotAndFit.m*)

PlotAndFit::usage = "";

DoFit::usage = "";

ShowPlot::usage = "";

HoldFixed::usage = "";

(*Usage messages for PolarizationMoments.m*)

TensorRecompose;

MaxRanks::usage = "";

PMVariables::usage = "";

PolarizationMomentPosition::usage = "";

ZeroTensorDecompositionMatrix::usage = "";

PolarizationMoment::usage = "";

(*Tensor decomposition*)

PolarizationMatrices::usage = "";

(*Angular momentum probability distribution*)

\[Rho]JJ::usage = "";

MaxProjectionProbability::usage = "";

(*Usage messages for Relaxation.m*)

(*Usage messages for RotatingWaveApproximation.m*)

DropFastTerms::usage = "DropFastTerms[expr,omega,t] sets terms in expr sinusoidally oscillating at twice the frequency omega (assuming time variable t) to zero.
DropFastTerms[expr,{\!\(\*SubscriptBox[\(omega\), \(1\)]\),\!\(\*SubscriptBox[\(omega\), \(2\)]\),...},t] drops terms oscillating at twice any of the \!\(\*SubscriptBox[\(omega\), \(i\)]\).";

ReturnFrequencyReplacements::usage = "";

DMFromRotatingDM::usage = "";

(*Usage messages for TensorAlgebra.m*)

TensorTrace::usage = "";

TensorMultiply::usage = "";

TraceOver::usage = "";

InnerAt::usage = "";

StretchedState::usage = "";

ListDepth::usage = "";

TensorTypePattern::usage = "";

TypedTensorPattern::usage = "";

TensorTypeQ::usage = "";

TensorDepth::usage = "";

AddTensorTypeToCall::usage = "";

(*Testing and component extraction*)

TensorOperatorQ;

ContravariantQ::usage = "ContravariantQ[expr] gives True if expr is in the form of a contravariant spherical tensor or state vector, i.e., a n x 1 array (the elements of which could be operators), and gives False otherwise.";

CovariantQ::usage = "CovariantQ[expr] gives True if expr is in the form of a covariant spherical tensor or state vector, i.e., a 1 x n array (the elements of which could be operators), and gives False otherwise.";

SphericalTensorQ::usage = "SphericalTensorQ[expr] gives True if expr is in the form of a covariant or contravariant spherical tensor or state vector, i.e., a 1 x n or n x 1 array (the elements of which could be operators), and gives False otherwise.";

TensorDecompositionQ::usage = "TensorDecompositionQ[expr] gives True if expr is in the form of a list of spherical tensors of rank m,m+1,...,n, for some m>n, and gives False otherwise.";

CovariantDecompositionQ::usage = "";

ContravariantDecompositionQ::usage = "";

TensorDecompositionMatrixQ::usage = "TensorDecompositionMatrixQ[expr] gives True if expr is a matrix of tensor decompositions, and gives False otherwise.";

CovariantDecompositionMatrixQ::usage = "";

ContravariantDecompositionMatrixQ::usage = "";

OperatorQ::usage = "OperatorQ[expr] gives True if expr is in the form of a matrix operator, i.e., an n x n matrix, and gives False otherwise.";

ScalarQ::usage = "ScalarQ[expr] gives True if expr is not in the form of a Cartesian vector, spherical tensor, matrix operator or tensor decomposition, and gives False otherwise.";

CartesianQ::usage = "CartesianQ[expr] gives True if expr is in the form of a Cartesian vector, i.e., a one-dimensional list (the elements of which could be operators), and gives False otherwise.";

OneByOneQ::usage = "";

TensorDecompositionComponent::usage = "";

SphericalTensorComponent::usage = "";

Components::usage = "";

ComponentMap::usage = "";

(*Matrix multiplication*)

TensorNorm::usage = "TensorNorm[a] gives the norm of a spherical tensor or Cartesian vector.";

ScalarizeOneByOnes::usage = "";

(*Conjugation*)

ExplicitConjugate::usage = "ExplicitConjugate[expr] takes the complex conjugate of expr, explicitly assuming that all variables are real.";

EC::usage = "EC[expr] takes the complex conjugate of expr, explicitly assuming that all variables are real.";

ExplicitConjugateTranspose::usage = "ExplicitConjugateTranspose[expr] takes the Hermitian conjugate of a variety of types of expressions, explicitly assuming that all variables are real. If expr is a spherical tensor or matrix operator, the conjugate transpose is taken (converting covariant to contravariant, and vice versa). If expr is a tensor decomposition, the conjugate transpose of each tensor in the decomposition is taken. If expr is a Cartesian vector or a scalar, the complex conjugate is taken.";

ECT::usage = "ECT[expr] takes the Hermitian conjugate of a variety of types of expressions, explicitly assuming that all variables are real. If expr is a spherical tensor or matrix operator, the conjugate transpose is taken (converting covariant to contravariant, and vice versa). If expr is a tensor decomposition, the conjugate transpose of each tensor in the decomposition is taken. If expr is a Cartesian vector or a scalar, the complex conjugate is taken.";

GeneralizedConjugateTranspose::usage = "GeneralizedConjugateTranspose[expr] takes the Hermitian conjugate of a variety of types of expressions. If expr is a spherical tensor or matrix operator, the conjugate transpose is taken (converting covariant to contravariant, and vice versa). If expr is a tensor decomposition, the conjugate transpose of each tensor in the decomposition is taken. If expr is a Cartesian vector or a scalar, the complex conjugate is taken.";

GCT::usage = "";

ToCovariant::usage = "ToCovariant[expr] converts any spherical tensor or Cartesian vector to a covariant spherical tensor.";

(*Dual*)

DualMatrix::usage = "";

Dual::usage = "";

TensorConjugate::usage = "";

ToCartesianMatrix::usage = "";

(*Tensor product*)

SphericalTensorProduct::usage = "";

(*Error messages*)

MatrixMultiply::"coco" = "Inner product attempted between two covariant or two contravariant tensors.";

MatrixMultiply::"opco" = "Operator multiplication attempted on wrong side of covariant or contravariant tensor.";

MatrixMultiply::"sphca" = "Inner product attempted between spherical and Cartesian tensors.";

(*Usage messages for WignerEckart.m*)

NeglectedCouplings::usage = "";

hyperfineRMEFactor::usage = "";

ReducedME::usage = "";

EvaluateHyperfineShift::usage = "";

HyperfineShift::usage = "";

Zero::usage = "";

GroundState::usage = "";

ExcitedState::usage = "";

Polarization::usage = "";

StatisticalWeight::usage = "";

Dipole::usage = "";

ExpandDipoleRME::usage = "";

ReducedRabiFrequency::usage = "";

SpontaneousEmission::usage = "";

LandeGJ::usage = "";

LandeGF::usage = "";

DipoleExpansion::usage = "";

MagneticMoment::usage = "";

MagneticDipole::usage = "";

(*Usage messages for WignerRotate.m*)

ADMWignerD::usage = "";

WignerD::usage = "WignerD[{j,m,m'},{alpha,beta,gamma}] returns the Wigner D-function (matrix element). WignerD[j,{alpha,beta,gamma}] returns the rotation matrix for a system with angular momentum j. WignerD[s1,{alpha,beta,gamma},s2] returns the rotation matrix element between the atomic states s1 and s2. WignerD[syst,{alpha,beta,gamma}] returns the rotation matrix for the atomic system syst.";

WignerDLargeJ::usage = "";

Wignerd::usage = "";

WignerRotate::usage = "WignerRotate[tensor, {alpha,beta,gamma}, opts] rotates tensor by the specified Euler angles. The supplied tensor can be a matrix operator, an irreducible tensor, or a tensor decomposition.";

RotationSense::usage = "RotationSense is an option for WignerRotate that specifies the rotation sense. Possible values are \"Active\" and \"Passive\".";

Active::usage = "Active is a possible value for the RotationSense option for WignerRotate, specifying an active rotation.";

Passive::usage = "Passive is a possible value for the RotationSense option for WignerRotate, specifying a passive rotation.";

StandardOperator::usage = "StandardOperator is an option for WignerRotate that specifies whether objects are considered to rotate like standard operators, as opposed to density matrices.";

ADMLogo::usage = "";

$ADMDirectory::usage = "";

Subspace::usage = "";

Submatrix::usage = "";

DMSubstitute::usage = "";

ADMTheme::usage = "";

TransitionEvaluate::usage = "";

DirectedTransitionQ::usage = "";

TransitionQ::usage = "";

TransitionPosition::usage = "";

PopulatedDM::usage = "";

(*Import usage messages*)

Get["AtomicDensityMatrix`Interface`"];

Begin["`Private`"];

$ADMVersion = "23.04.11";

$ADMDirectory = FileNameDrop[$InputFileName, -2];

ADMLogo[] := Show[Import@FileNameJoin@{$ADMDirectory, "Resources", "header.png"}, ImageSize->Large];

ADMTheme[theme_] := If[theme === "SlideShow",
    Off[ScientificForm::reqsigz];
    $PrePrint = TraditionalForm@ScientificForm[TensorForm[#, TableForm -> True], 3, ExponentFunction -> (If[-4 < # < 4, Null, #] &)]&;
    SetOptions[AMPSPlot, ViewAngle -> .3];
    SetOptions[SphericalPlot3D, Boxed -> False, Axes -> False, PlotRange -> All, ViewAngle -> .3];
    SetOptions[LevelDiagram, ImageSize -> 5 72, LabelStyle -> 16, LevelStyle -> Thick, ArrowFunction -> Automatic];
    SetOptions[Plot, PlotTheme -> "Web", BaseStyle -> {20}, ImageSize -> Large];
    SetOptions[Manipulate, LabelStyle -> 20];
];

End[];

(*Protect exported symbols*)

(*Protect[Evaluate[$Context<>"*"]]*)

EndPackage[];
