(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     20955,        546]
NotebookOptionsPosition[     16596,        455]
NotebookOutlinePosition[     18775,        510]
CellTagsIndexPosition[     18690,        505]
WindowTitle->AtomicSystemQ
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "2dd17954-78f7-4034-9c6e-6fc566a93444"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "65d544ca-77bc-4d64-8210-d69779440b4d"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "c2e0e98b-b762-404b-b6dd-46bf99e308c1"]
         }],ExpressionUUID->"0ce34c70-395d-4217-8268-41284fbba569"],
         StripOnInput->False], {"\<\"AtomicState\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/AtomicState"], \
"\<\"AtomicSystemType\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/AtomicSystemType"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "347856bc-6966-4642-90bf-1c7c15dbdbc6"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "3109d708-27c9-4329-9a23-d97cd081441b"]
         }],ExpressionUUID->"f9493e41-424d-4d1c-99ff-735e38676f04"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "829f6682-9193-4daf-8c8d-ecda28f4efc0"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "d3f9fdb7-d322-4733-bac3-21c04177a70f"]
         }],ExpressionUUID->"d047dbca-9266-4344-b346-86618fd45a8a"],
         StripOnInput->False], {"\<\"Specifying the Atomic System\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"Tutorials"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "7bcd9e8c-05da-46e3-83ca-21dfbe84aa47"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "0bb8c417-bcca-4d74-bf0c-3588d8ce7bc4"]
         }],ExpressionUUID->"1e027552-c2e3-4b5e-abce-6f3b2ace5648"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/ref/AtomicSystemQ\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/AtomicSystemQ"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/AtomicSystemQ.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$33758], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/AtomicSystemQ" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "412b2910-f5d0-43ab-b8a2-8cefcfee12bd"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "a810a792-bd05-4bd5-807f-3b842d72486e"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"ea8d1865-5635-45f7-82b4-3bef87410ac8"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"5ee9f0bd-13bf-41a2-9a5e-2f914305f5ae"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "AtomicSystemQ", "ObjectName",ExpressionUUID->
      "3fdc966d-81c6-468e-97e1-415591029901"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"64df9e71-63ed-4e28-9062-cbaca0e58feb"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "dcee1484-e93b-45b0-b8eb-5895fd6021d3"]
    }],ExpressionUUID->"d61f806e-388e-48b4-9b2f-a50737f37e78"], 
    "\[SpanFromLeft]"}
  }]], "ObjectNameGrid",ExpressionUUID->"7c479bd8-fa95-4d0a-9477-\
8ed363967f40"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"AtomicSystemQ", "[", 
       StyleBox["expr", "TI"], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "da7ac8ad-62f0-4852-b426-8ef799e5d9ae"],
     " \[LineSeparator]tests if expression ",
     Cell[BoxData[
      StyleBox["expr", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "ce5b7885-084f-4f31-b74a-1a83afe9b41f"],
     " has the form of an atomic system (list of ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["AtomicState"]], 
        "paclet:AtomicDensityMatrix/ref/AtomicState", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "0e991659-4d6e-4797-8860-b8ea912c61ad"],
     " objects)."
    }],ExpressionUUID->"01112c58-fb9d-43b0-b1d8-320026f8937d"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"807d386a-289e-48f4-8797-0a89c744ba56"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "8c769f63-4440-4ef9-b2ea-084459cdac4b"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"71164bb0-0e25-4848-8b35-48a112afd9e6"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "a2321613-92b2-42cb-a4a0-e65472d15cbb"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->351006023,ExpressionUUID->"1833ef24-668d-4a1c-9fcc-9bdf2f1a69ff"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "1d29142f-04a9-4cfe-ae22-91d1b21081fd"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"c6531aed-1fbf-40c2-828c-26c79bf04ffc"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "1acb9d17-7391-4185-b203-6511d0d32c52"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->220650252,ExpressionUUID->"23023e37-1380-4514-be26-cd436a7364da"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->335917597,ExpressionUUID->"9105fa16-4c97-4c9e-abf4-226704cf042b"],

Cell["An atomic system:", "ExampleText",
 CellID->32544816,ExpressionUUID->"7fd4d3ab-ad29-4060-9987-286ff2b034a4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", "1"}]}], "]"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->385383276,ExpressionUUID->"42b9c630-1823-4582-9cfe-96a2bd3ab1f6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1117984164,ExpressionUUID->"23969e10-9757-4d4e-9ac3-5c2f86c8ccef"]
}, Open  ]],

Cell["Test that it is an atomic system:", "ExampleText",
 CellID->1625416745,ExpressionUUID->"0775e21c-2807-4204-8d7b-8f4dca7e967c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AtomicSystemQ", "[", "sys", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->659121064,ExpressionUUID->"e353d4b4-413e-4092-a315-ca76de28225a"],

Cell[BoxData["True"], "Output",
 CellLabel->"Out[3]=",
 CellID->1857885091,ExpressionUUID->"8c3d620f-7a14-48ed-a956-6a9e0f7371bd"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedFunction.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"See", " ", "Also"}], "SeeAlsoSection"]},
      {Cell[TextData[{
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicState"]], 
           "paclet:AtomicDensityMatrix/ref/AtomicState", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "3a9a3d39-9f81-4919-9b77-804968987faa"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicSystemType"]], 
           "paclet:AtomicDensityMatrix/ref/AtomicSystemType", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "09514f50-07ff-45ba-a756-5290ceaafb24"]
       }], "SeeAlso",ExpressionUUID->"ca6eaa57-8e9e-47e2-a776-e7e2f103fe8f"]}
     }]}
  }]], "SeeAlsoSection",ExpressionUUID->"f48da04e-17a4-46c4-aec6-\
c1b0d5d9ef7c"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Tech", " ", "Notes"}], "TutorialsSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Specifying the Atomic System"]], 
           "paclet:AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "d87f76d0-01eb-47c0-bf1d-19e21b22d913"]}]}
     }]}
  }]], "TutorialsSection",ExpressionUUID->"270f2200-b7bf-408a-801f-\
51fa2e1f2088"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "321f63b6-76f1-477c-94d7-e78255bf1e4b"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"31d084d6-06ac-4de4-9a00-\
523b55a99040"],

Cell[" ", "FooterCell",ExpressionUUID->"05784360-5c10-4251-8ae0-4df133a881db"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"AtomicSystemQ",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}}, 
  "NewStyles" -> True, "CitationPopupData" -> $Failed, "ShowCitation" -> 
  False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 17, 59, 10.300957}", 
    "history" -> {"17.06", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "AtomicSystemQ[expr] tests if expression expr has the form of an atomic \
system (list of AtomicState objects).", "synonyms" -> {}, "tabletags" -> {}, 
    "title" -> "AtomicSystemQ", "titlemodifier" -> "", "metadescription" -> 
    "", "windowtitle" -> "AtomicSystemQ", "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/AtomicSystemQ"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"59bc988a-821f-43f9-b618-e6ac0b6966b5"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8790, 230, 1389, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"1833ef24-668d-4a1c-9fcc-9bdf2f1a69ff",
   CellTags->"PrimaryExamplesSection",
   CellID->351006023]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 18491, 498}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[585, 21, 6416, 156, 57, "AnchorBarGrid",ExpressionUUID->"ea8d1865-5635-45f7-82b4-3bef87410ac8",
 CellID->1],
Cell[7004, 179, 102, 0, 23, "ContextNameCell",ExpressionUUID->"5ee9f0bd-13bf-41a2-9a5e-2f914305f5ae"],
Cell[CellGroupData[{
Cell[7131, 183, 556, 14, 60, "ObjectNameGrid",ExpressionUUID->"7c479bd8-fa95-4d0a-9477-8ed363967f40"],
Cell[7690, 199, 1063, 26, 114, "Usage",ExpressionUUID->"807d386a-289e-48f4-8797-0a89c744ba56",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[8790, 230, 1389, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"1833ef24-668d-4a1c-9fcc-9bdf2f1a69ff",
 CellTags->"PrimaryExamplesSection",
 CellID->351006023],
Cell[CellGroupData[{
Cell[10204, 271, 1367, 36, 31, "ExampleSection",ExpressionUUID->"23023e37-1380-4514-be26-cd436a7364da",
 CellID->220650252],
Cell[11574, 309, 183, 3, 29, "Input",ExpressionUUID->"9105fa16-4c97-4c9e-abf4-226704cf042b",
 CellID->335917597],
Cell[11760, 314, 114, 1, 38, "ExampleText",ExpressionUUID->"7fd4d3ab-ad29-4060-9987-286ff2b034a4",
 CellID->32544816],
Cell[CellGroupData[{
Cell[11899, 319, 308, 8, 29, "Input",ExpressionUUID->"42b9c630-1823-4582-9cfe-96a2bd3ab1f6",
 CellID->385383276],
Cell[12210, 329, 618, 17, 37, "Output",ExpressionUUID->"23969e10-9757-4d4e-9ac3-5c2f86c8ccef",
 CellID->1117984164]
}, Open  ]],
Cell[12843, 349, 132, 1, 38, "ExampleText",ExpressionUUID->"0775e21c-2807-4204-8d7b-8f4dca7e967c",
 CellID->1625416745],
Cell[CellGroupData[{
Cell[13000, 354, 166, 3, 29, "Input",ExpressionUUID->"e353d4b4-413e-4092-a315-ca76de28225a",
 CellID->659121064],
Cell[13169, 359, 130, 2, 37, "Output",ExpressionUUID->"8c3d620f-7a14-48ed-a956-6a9e0f7371bd",
 CellID->1857885091]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[13541, 370, 1441, 38, 114, "SeeAlsoSection",ExpressionUUID->"f48da04e-17a4-46c4-aec6-c1b0d5d9ef7c"],
Cell[14985, 410, 770, 20, 114, "TutorialsSection",ExpressionUUID->"270f2200-b7bf-408a-801f-51fa2e1f2088"],
Cell[15758, 432, 753, 19, 114, "MoreAboutSection",ExpressionUUID->"31d084d6-06ac-4de4-9a00-523b55a99040"],
Cell[16514, 453, 78, 0, 70, "FooterCell",ExpressionUUID->"05784360-5c10-4251-8ae0-4df133a881db"]
}
]
*)

(* End of internal cache information *)

