(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     26077,        691]
NotebookOptionsPosition[     20969,        587]
NotebookOutlinePosition[     23252,        643]
CellTagsIndexPosition[     23167,        638]
WindowTitle->CartesianCoordinates
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "3360e93d-00bc-4450-85e4-07d98df60c97"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "811ca353-872d-44d7-b418-4b99798d45b7"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "413d9c77-dd25-4585-979a-efb87475d826"]
         }],ExpressionUUID->"a92c9c40-f5e9-454c-86a6-0336a8b8f191"],
         StripOnInput->False], {"\<\"OpticalField\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/OpticalField"], "\<\"Observables\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/Observables"], \
"\<\"PolarizationComponents\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/PolarizationComponents"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "6492bb43-fa21-41cd-9fb0-86d63bc37302"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "5398fbc6-a6dc-4063-80ba-a64df35854e3"]
         }],ExpressionUUID->"e025ac71-5e1a-420c-8015-0ce5eb665663"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "0d1474bb-a36b-4951-b036-32b88803b77a"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "e90a93e7-25e9-4b24-adfb-2bdac3fda186"]
         }],ExpressionUUID->"8f1585fc-f044-4112-9267-2ef24b591c5f"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/ref/CartesianCoordinates\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/CartesianCoordinates"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/CartesianCoordinates.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$35376], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/CartesianCoordinates" <> ".html"], 
            None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "19cb6284-7727-41bb-b126-b166a8fc632c"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "f17d7965-5302-40b2-b59f-ec5adcf50e78"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"f56ba46f-57d4-4164-8a90-14526e5d59b4"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"3d009087-280f-4a02-8abf-4ec0cbbbecab"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "CartesianCoordinates", "ObjectName",ExpressionUUID->
      "68fbcfe3-1807-4498-9e5d-2aae19e39a20"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"4ec3942c-6a05-4d7d-bf4a-7aa1b5a62995"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "dea5a510-a9b0-410b-9235-9b7958948346"]
    }],ExpressionUUID->"23996b96-0022-43c2-a006-e18e5428f057"], 
    "\[SpanFromLeft]"}
  }]], "ObjectNameGrid",ExpressionUUID->"13b825f7-3272-40e8-9d82-\
ed9f5e852c69"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["CartesianCoordinates"], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "de10b0ea-f809-419e-80b8-48dec0bc1be9"],
     " \[LineSeparator]is an option for ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["OpticalField"]], 
        "paclet:AtomicDensityMatrix/ref/OpticalField", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "7124c1bf-ab92-4a0f-960a-315f27b5bf35"],
     " and related functions that specifies the variables to be used to \
denote the Cartesian coordinates."
    }],ExpressionUUID->"e29e7e6a-9eeb-4c09-bc04-8b65b3fad91c"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"7130c3ec-f67b-4e61-9060-309687f640d9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"bafb61cb-9cda-4950-b93f-d9ba2c71c531"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"bf7a711d-71d9-457d-91e6-9c0e48fe66ac"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"847aad4f-c64f-49eb-8a02-dfcb80100340"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"329c8b62-9b68-49a2-a0e1-fa056198ae06"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->908320406,ExpressionUUID->"68a6d6b4-1bde-4487-8cf5-bc002eaa10db"],

Cell[TextData[{
 Cell[BoxData["CartesianCoordinates"], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "15845a9b-a3f9-4121-ac5b-8a52d436e923"],
 " is specified as a three-component Cartesian vector."
}], "Notes",
 CellID->1362295892,ExpressionUUID->"930e9ead-e29f-4c35-b323-d1cfedb1102d"],

Cell[TextData[{
 "A value of ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["Automatic"]], "paclet:ref/Automatic"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "1035179f-8f5a-42cd-9cb8-66a50f6343b4"],
 " means that the default value for ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["OpticalField"]], "paclet:AtomicDensityMatrix/ref/OpticalField",
     "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "8a315e02-1aed-47cb-b541-8c8a8df9b650"],
 " is used."
}], "Notes",
 CellID->1779052493,ExpressionUUID->"fd898e51-b58f-4c4a-8f6f-b0fe5eb2c9f8"],

Cell[TextData[{
 "The Cartesian coordinate variables are only used if a wavenumber is \
specified in ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["OpticalField"]], "paclet:AtomicDensityMatrix/ref/OpticalField",
     "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "ea73ef72-14b6-4da9-8f8d-fa7af16440ad"],
 ". "
}], "Notes",
 CellID->899155636,ExpressionUUID->"957d843e-48e5-4b44-9335-e476638f63c7"],

Cell[TextData[{
 "The default value for ",
 Cell[BoxData["CartesianCoordinates"], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "a6f1d64d-ae8b-42d8-9174-e2ed8c694574"],
 " for ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["OpticalField"]], "paclet:AtomicDensityMatrix/ref/OpticalField",
     "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "fbc274aa-901b-442d-9ce1-59bd5739acb3"],
 " is ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    TemplateBox[{
      Cell[
       TextData["Xx"]], "paclet:AtomicDensityMatrix/ref/Xx", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"InlineFormula"], ",", 
    TemplateBox[{
      Cell[
       TextData["Yy"]], "paclet:AtomicDensityMatrix/ref/Yy", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"InlineFormula"], ",", 
    TemplateBox[{
      Cell[
       TextData["Zz"]], "paclet:AtomicDensityMatrix/ref/Zz", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"InlineFormula"]}], "}"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "2111df29-8f6a-49f9-bb29-4e8f257facad"],
 "."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"5dfb7a9c-8285-48c1-99da-ba44d815cbc0"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "a10454c5-ca17-49cf-97e5-0a4afeff7d7b"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"55fbf06a-e9ae-47f7-a92b-8f5762c5c864"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "6f92cc9c-839e-4c48-9b7e-92175c04bd2f"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->1827300766,ExpressionUUID->"7520cca9-0e7b-4ccb-9ad9-92c70089a052"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "79a297af-9605-49bc-bca1-13b8a9f1dabe"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"4a54d0e2-377f-428c-87d5-948ff330f7e8"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "a23ef669-1715-4971-9a3b-26e40fe447f5"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->280338415,ExpressionUUID->"846f6660-4567-4f08-a075-f1ba0fcc8c86"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->798635108,ExpressionUUID->"edec49de-3158-4dcb-afbf-49d5b1fdce88"],

Cell[TextData[{
 "The default value for ",
 Cell[BoxData["CartesianCoordinates"], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "390c031d-5a6f-40ca-be41-f91bc808a384"],
 ":"
}], "ExampleText",
 CellID->50400861,ExpressionUUID->"0d4a2cb2-40d2-4f03-a1a6-85a330e5f5ac"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Omega]", ",", "k"}], "}"}], ",", "E0", ",", 
   RowBox[{"PropagationVector", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"PolarizationVector", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->300804433,ExpressionUUID->"5ae35d4b-cbc1-4908-9f9d-cf8df983b30f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox["Xx", 
            SqrtBox["2"]], "+", 
           FractionBox["Yy", 
            SqrtBox["2"]]}], ")"}]}], "-", 
        RowBox[{"t", " ", "\[Omega]"}]}], ")"}]}]], " ", "E0"}]}], 
  "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->60283001,ExpressionUUID->"2759c66a-5fec-4d91-8f78-45433773909c"]
}, Open  ]],

Cell["Specify different coordinate variables:", "ExampleText",
 CellID->1342466122,ExpressionUUID->"099864b2-3ded-4601-a9c2-7063c0765fdb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Omega]", ",", "k"}], "}"}], ",", "E0", ",", 
   RowBox[{"CartesianCoordinates", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], ",", 
   RowBox[{"PropagationVector", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"PolarizationVector", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1874145498,ExpressionUUID->"c92af01b-ecac-4ebc-9ee4-c23f8e27b1ce"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox["x", 
            SqrtBox["2"]], "+", 
           FractionBox["y", 
            SqrtBox["2"]]}], ")"}]}], "-", 
        RowBox[{"t", " ", "\[Omega]"}]}], ")"}]}]], " ", "E0"}]}], 
  "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->1959245748,ExpressionUUID->"8be1fbfe-25af-4cf3-9212-cc1fc6d017f9"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedFunction.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"See", " ", "Also"}], "SeeAlsoSection"]},
      {Cell[TextData[{
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["OpticalField"]], 
           "paclet:AtomicDensityMatrix/ref/OpticalField", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "383a8aa8-16f9-4547-b191-5d665b5346e5"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Observables"]], 
           "paclet:AtomicDensityMatrix/ref/Observables", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "684e8cc1-8562-4ed9-9c1c-2dca215791cb"]
       }], "SeeAlso",ExpressionUUID->"86962e98-96fb-40a0-b5d6-f54e0756ace1"]}
     }]}
  }]], "SeeAlsoSection",ExpressionUUID->"f4fdc724-ff31-4a34-950c-\
02f00d250a74"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "378de4cb-8f22-485a-b5f6-92f76dd2eca1"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"2a463c51-55ad-456c-a752-\
369bb2cfd4ee"],

Cell[" ", "FooterCell",ExpressionUUID->"e0f72ca6-fbcb-4b73-ba4b-064d3c443edf"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"CartesianCoordinates",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}, 
    "NotesSection" -> Closed}, "NewStyles" -> True, 
  "CitationPopupData" -> $Failed, "ShowCitation" -> False, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2023, 4, 18, 17, 59, 12.575421}", 
    "history" -> {"18.09", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "CartesianCoordinates is an option for OpticalField and related functions \
that specifies the variables to be used to denote the Cartesian coordinates.",
     "synonyms" -> {}, "tabletags" -> {}, "title" -> "CartesianCoordinates", 
    "titlemodifier" -> "", "metadescription" -> "", "windowtitle" -> 
    "CartesianCoordinates", "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/CartesianCoordinates"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"dff6d485-1b69-4183-b080-0f89cb872a57"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[12762, 345, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"7520cca9-0e7b-4ccb-9ad9-92c70089a052",
   CellTags->"PrimaryExamplesSection",
   CellID->1827300766]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 22966, 631}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 5566, 133, 57, "AnchorBarGrid",ExpressionUUID->"f56ba46f-57d4-4164-8a90-14526e5d59b4",
 CellID->1],
Cell[6161, 156, 102, 0, 23, "ContextNameCell",ExpressionUUID->"3d009087-280f-4a02-8abf-4ec0cbbbecab"],
Cell[CellGroupData[{
Cell[6288, 160, 563, 14, 60, "ObjectNameGrid",ExpressionUUID->"13b825f7-3272-40e8-9d82-ed9f5e852c69"],
Cell[6854, 176, 882, 20, 114, "Usage",ExpressionUUID->"7130c3ec-f67b-4e61-9060-309687f640d9",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[7773, 201, 1898, 47, 37, "NotesSection",ExpressionUUID->"68a6d6b4-1bde-4487-8cf5-bc002eaa10db",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->908320406],
Cell[9674, 250, 308, 6, 70, "Notes",ExpressionUUID->"930e9ead-e29f-4c35-b323-d1cfedb1102d",
 CellID->1362295892],
Cell[9985, 258, 749, 22, 70, "Notes",ExpressionUUID->"fd898e51-b58f-4c4a-8f6f-b0fe5eb2c9f8",
 CellID->1779052493],
Cell[10737, 282, 521, 14, 70, "Notes",ExpressionUUID->"957d843e-48e5-4b44-9335-e476638f63c7",
 CellID->899155636],
Cell[11261, 298, 1374, 41, 70, "Notes",ExpressionUUID->"5dfb7a9c-8285-48c1-99da-ba44d815cbc0",
 CellID->1067943069]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[12762, 345, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"7520cca9-0e7b-4ccb-9ad9-92c70089a052",
 CellTags->"PrimaryExamplesSection",
 CellID->1827300766],
Cell[CellGroupData[{
Cell[14177, 386, 1367, 36, 31, "ExampleSection",ExpressionUUID->"846f6660-4567-4f08-a075-f1ba0fcc8c86",
 CellID->280338415],
Cell[15547, 424, 183, 3, 29, "Input",ExpressionUUID->"edec49de-3158-4dcb-afbf-49d5b1fdce88",
 CellID->798635108],
Cell[15733, 429, 288, 7, 39, "ExampleText",ExpressionUUID->"0d4a2cb2-40d2-4f03-a1a6-85a330e5f5ac",
 CellID->50400861],
Cell[CellGroupData[{
Cell[16046, 440, 478, 12, 29, "Input",ExpressionUUID->"5ae35d4b-cbc1-4908-9f9d-cf8df983b30f",
 CellID->300804433],
Cell[16527, 454, 573, 18, 56, "Output",ExpressionUUID->"2759c66a-5fec-4d91-8f78-45433773909c",
 CellID->60283001]
}, Open  ]],
Cell[17115, 475, 138, 1, 38, "ExampleText",ExpressionUUID->"099864b2-3ded-4601-a9c2-7063c0765fdb",
 CellID->1342466122],
Cell[CellGroupData[{
Cell[17278, 480, 599, 15, 48, "Input",ExpressionUUID->"c92af01b-ecac-4ebc-9ee4-c23f8e27b1ce",
 CellID->1874145498],
Cell[17880, 497, 573, 18, 56, "Output",ExpressionUUID->"8be1fbfe-25af-4cf3-9212-cc1fc6d017f9",
 CellID->1959245748]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[18695, 524, 1433, 38, 114, "SeeAlsoSection",ExpressionUUID->"f4fdc724-ff31-4a34-950c-02f00d250a74"],
Cell[20131, 564, 753, 19, 114, "MoreAboutSection",ExpressionUUID->"2a463c51-55ad-456c-a752-369bb2cfd4ee"],
Cell[20887, 585, 78, 0, 70, "FooterCell",ExpressionUUID->"e0f72ca6-fbcb-4b73-ba4b-064d3c443edf"]
}
]
*)

(* End of internal cache information *)

