(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     64411,       1821]
NotebookOptionsPosition[     53577,       1599]
NotebookOutlinePosition[     56380,       1663]
CellTagsIndexPosition[     56294,       1658]
WindowTitle->Component
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "f65c8b0f-dbaa-4656-8367-630e439cccac"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "dabcb052-1a9b-419e-aece-7fce70e53763"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "41cc31b1-866b-4a6d-acd7-552b5ed63742"]
         }],ExpressionUUID->"d08b804c-fdc0-4150-b113-d6f73c295601"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "d27ff0b3-298a-4d4a-a4f1-e2fc07400ce5"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "7d5fdc60-45cc-4518-ae8f-6a747ff9d1b1"]
         }],ExpressionUUID->"20bf354c-6d19-4f15-9c95-712b2f827030"],
         StripOnInput->False], {"\<\"Matrix Notation\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/MatrixNotation"], "\<\"Tensor \
Component Operations and Extraction\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/\
TensorComponentOperationsAndExtraction"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"Tutorials"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "90289edc-ab1b-4a17-b3cc-58704521f63a"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "3c3ef8ed-d103-4a87-87dc-2824e14def1a"]
         }],ExpressionUUID->"9686c625-5596-4682-9421-824ee17adf0b"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix/ref/Component\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/Component"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/Component.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$36470], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/Component" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "31c20f2c-b8cf-4a21-94ee-db4abb151e86"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "3710a8be-ce80-43f4-9aac-a2f6ba83f64c"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"dcc4f851-3485-4a47-b2b2-261de60fce02"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"17d3e144-c65c-4c3b-8a13-08ebf7ea29c5"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "Component", "ObjectName",ExpressionUUID->
      "f19c8ff0-1ff3-4c56-a926-603faf37feb5"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"105fced1-4930-4998-a5c9-f8e278de6a00"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "d78a417a-08c1-4173-a570-ba60bad28355"]
    }],ExpressionUUID->"136fe786-b484-4f7d-b9e7-47e52a41bbc7"], 
    "\[SpanFromLeft]"}
  }]], "ObjectNameGrid",ExpressionUUID->"abbbda25-5886-4ccd-8d62-\
3f6644869051"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Component", "[", 
       StyleBox[
        RowBox[{"tens", ",", "q"}], "TI"], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "cc269f43-45ec-4e95-8a3e-f9998b024409"],
     " \[LineSeparator]extracts the ",
     Cell[BoxData[
      StyleBox["q", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "cfbbb212-4959-4631-ba66-5ea336307511"],
     "\[Hyphen]th component of a spherical tensor ",
     Cell[BoxData[
      StyleBox["tens", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "2a01bbbb-f93c-4f5d-9653-a077749d7c67"],
     "."
    }],ExpressionUUID->"703885b4-059e-4004-bba7-7f449d21b388"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Component", "[", 
       RowBox[{
        StyleBox["cart", "TI"], ",", 
        StyleBox["i", "TI"]}], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "3ec4d4f6-16b9-4c5e-bf0d-4a1c0f8d3e1c"],
     "\[LineSeparator]extracts the ",
     Cell[BoxData[
      StyleBox["i", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "d6079cfb-7df3-42ad-b2fc-57d290b14ab3"],
     "\[Hyphen]th component of a Cartesian vector ",
     Cell[BoxData[
      StyleBox["cart", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "557b14f8-e44e-4b85-b9ff-0ea283c72927"],
     "."
    }],ExpressionUUID->"eaaf72cf-929a-46cd-9ee2-d914cfc0fd67"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Component", "[", 
       RowBox[{
        StyleBox["decomp", "TI"], ",", " ", 
        StyleBox["k", "TI"]}], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "3bfe99b5-9fc5-4a91-b0a3-f7b7d8d9b15d"],
     "\[LineSeparator]extracts the spherical tensor of rank ",
     Cell[BoxData[
      StyleBox["k", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "2540b669-7d06-4c5e-b8fa-f335a776bcca"],
     " from a tensor decomposition ",
     Cell[BoxData[
      StyleBox["decomp", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "64840d0b-69d9-4fd5-ae15-97950aa4d8ed"],
     "."
    }],ExpressionUUID->"bb1d88f6-0007-4bff-afb6-955b9ede4aa4"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Component", "[", 
       RowBox[{
        StyleBox["op", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["m", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["m", "TI"], 
           StyleBox["2", "TR"]]}], "}"}]}], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "f1210878-df56-4f73-b62a-8c939e81f77f"],
     "\[LineSeparator]extracts the matrix element corresponding to sublevels \
with angular\[Hyphen]momentum\[Hyphen]projection quantum numbers ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["m", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "51bd576e-59cc-4f28-a963-4028b56ded14"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["m", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "cfbe208b-8c02-4713-accc-81cf7fe46471"],
     " from an operator ",
     Cell[BoxData[
      StyleBox["op", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "de1cd6e0-9b55-4ea7-87e2-65d876829c34"],
     "."
    }],ExpressionUUID->"2898efc8-18ce-4eb1-84e8-27294e7981f4"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Component", "[", 
       RowBox[{
        StyleBox["sys", "TI"], ",", 
        StyleBox["op", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["s", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["s", "TI"], 
           StyleBox["2", "TR"]]}], "}"}]}], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "6dfcacca-f5fc-4341-ad3f-d96213a37d19"],
     "\[LineSeparator]extracts the matrix element of operator ",
     Cell[BoxData[
      StyleBox["op", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "0e84710d-339a-45c0-a3df-970ae6c130c5"],
     " corresponding to the states ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["s", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "cbd0fe71-ea03-4cad-93d2-84d991896431"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["s", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "d4f1e2a8-7ff6-4295-a9b3-45c347ca29bb"],
     " of atomic system ",
     Cell[BoxData[
      StyleBox["sys", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "eb687213-0bb7-4557-9526-f1a5213a5d91"],
     "."
    }],ExpressionUUID->"b496de0c-340d-4b4d-bc8c-f6c97c8c083e"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Component", "[", 
       RowBox[{
        StyleBox["sys", "TI"], ",", 
        StyleBox["mat", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["s", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["s", "TI"], 
           StyleBox["2", "TR"]]}], "}"}]}], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "0f2d81cd-8406-4f40-a25e-d5ab1f95c09c"],
     "\[LineSeparator]extracts the tensor decomposition from the tensor\
\[Hyphen]decomposition matrix ",
     Cell[BoxData[
      StyleBox["mat", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "f5de3d2d-acbd-4419-8b1c-8c5999304025"],
     " corresponding to the states ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["s", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "51bac509-4dd6-4d0d-971e-6f8f88ad00e4"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["s", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "e588bcd2-0434-4c17-967b-b54a7f0fc8b7"],
     "."
    }],ExpressionUUID->"ad010437-12bd-4502-ba95-efe63ef6f590"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"7a20e213-33af-481a-a494-085543699c83"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"92937e79-a6d8-468b-a87b-f8c6e1e5d19f"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"3ff2d6cc-adff-4b95-8890-7354a90be0b5"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"ce0cf5f6-53d4-4f30-be60-83cef1ec64a8"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"89b74261-d48d-4e30-8308-fc7f10598a31"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->49307673,ExpressionUUID->"ab0febf6-58bc-4215-8d65-f682caa741a3"],

Cell[TextData[{
 "The component index ",
 Cell[BoxData[
  StyleBox["q", "TI"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "ef97055c-f777-42d9-9dc9-ff5c7deb2ae1"],
 " must be a integer or half-integer from the range ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"-", "\[Kappa]"}], ",", " ", 
    RowBox[{
     RowBox[{"-", "\[Kappa]"}], "+", "1"}], ",", "...", ",", " ", 
    "\[Kappa]"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "1aa0323e-764a-4e30-8575-4571c8254960"],
 ", where ",
 Cell[BoxData[
  FormBox["\[Kappa]", TraditionalForm]], "InlineMath",ExpressionUUID->
  "813b1ac1-ec2b-4eea-a971-14bcdf792230"],
 " is the rank of the spherical tensor."
}], "Notes",
 CellID->656996691,ExpressionUUID->"c59ea524-8382-4dc6-bc8d-0243d6bc6cb9"],

Cell[TextData[{
 "The quantum numbers ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["m", "TI"], 
   StyleBox["i", "TI"]]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "2b8c2bab-197f-4ad4-9b50-90b20dd2d45b"],
 " be a integers or half-integers from the range ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"-", "j"}], ",", " ", 
    RowBox[{
     RowBox[{"-", "j"}], "+", "1"}], ",", "...", ",", " ", "j"}], 
   TraditionalForm]], "InlineMath",ExpressionUUID->
  "4efe7534-36ad-4409-86cc-69578127f046"],
 ", where ",
 Cell[BoxData[
  FormBox["j", TraditionalForm]], "InlineMath",ExpressionUUID->
  "013c7a38-7ef5-463a-b33d-97bce4c53f0a"],
 " is the rank of the operator."
}], "Notes",
 CellID->317781180,ExpressionUUID->"1fadde80-c75d-4f86-b6ca-c77c4135cd08"],

Cell[TextData[{
 "The Cartesian component index ",
 Cell[BoxData[
  StyleBox["i", "TI"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "0d1beca2-4b4b-4605-8d3d-96d6d9b36952"],
 " must be a positive integer."
}], "Notes",
 CellID->368017552,ExpressionUUID->"189abba6-3fa1-4c2f-9480-88acecdac16b"],

Cell[TextData[{
 "Additional indices or states ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["n", "TI"], 
   StyleBox["i", "TI"]]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "eb9f5f1a-e3d9-45bb-832b-64a67af63e34"],
 " may be given as ",
 Cell[BoxData[
  RowBox[{"Component", "[", 
   RowBox[{
    StyleBox["tens", "TI"], ",", 
    SubscriptBox[
     StyleBox["n", "TI"], 
     StyleBox["1", "TR"]], ",", 
    SubscriptBox[
     StyleBox["n", "TI"], 
     StyleBox["2", "TR"]], ",", 
    StyleBox["\[Ellipsis]", "TR"]}], 
   StyleBox["]", "TR"]}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "a1c64c06-d3b1-413e-938a-780d261d9b48"],
 " or ",
 Cell[BoxData[
  RowBox[{"Component", "[", 
   RowBox[{
    StyleBox["sys", "TI"], ",", 
    StyleBox["tens", "TI"], ",", 
    SubscriptBox[
     StyleBox["n", "TI"], 
     StyleBox["1", "TR"]], ",", 
    SubscriptBox[
     StyleBox["n", "TI"], 
     StyleBox["2", "TR"]], ",", 
    StyleBox["\[Ellipsis]", "TR"]}], 
   StyleBox["]", "TR"]}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "03ddd782-2603-4f63-be47-c612ca5f2512"],
 "  to extract a component from a nested tensor structure. The index ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["n", "TI"], 
   StyleBox["1", "TR"]]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "ff9f00ee-41f8-4435-b2cf-1c981d15fd13"],
 " refers to the top-level tensor, the index ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["n", "TI"], 
   StyleBox["2", "TR"]]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "541a439e-ebdd-4033-b25a-916e00c737a6"],
 " to the second level, and so on."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"a17eec98-dde2-414a-9680-35ceb0067516"],

Cell[TextData[{
 Cell[BoxData[
  RowBox[{"Component", "[", 
   StyleBox["tens", "TI"], "]"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "21c954f1-c100-45e7-9b04-dccf39de74d4"],
 " extracts the single component from a rank\[Hyphen]zero tensor, the single \
matrix element from a rank-zero operator, or the single tensor decomposition \
from a tensor\[Hyphen]decomposition matrix for a single angular-momentum \
state."
}], "Notes",
 CellID->402896142,ExpressionUUID->"a86bb8cc-4d4e-4f65-bae0-0cb020e99dcf"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "6a6fec9d-0753-4433-9315-61791e9597f5"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"486b3bc2-e5f8-4cc3-b99a-2bab066b7861"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "999a0076-c168-473a-a6ef-af34bb2af0f8"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->1932856016,ExpressionUUID->"d3ad1b4b-c426-4567-a956-b1a61039988f"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"d1e22235-f094-457d-80a4-6fb57cffbfc1"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"840e77b1-b3b2-4b62-b804-37aa82655b02"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "742ec5f4-5118-4d6e-83e0-b1c68204296b"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->525932743,ExpressionUUID->"e9bc31a8-9945-49c0-93c9-8e0537221530"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1805505445,ExpressionUUID->"84c473ba-69e4-40b8-b12e-0ea671c07328"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]], "InlineMath",ExpressionUUID->
  "dc40047c-adb7-4974-bb98-7b846499bebd"],
 StyleBox[" component of a Cartesian vector:",
  Deletable->True]
}], "ExampleText",
 CellID->2046613925,ExpressionUUID->"d5729ad9-5fe3-4e5f-808b-fea6de35cfcc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vec", "=", 
  RowBox[{"{", 
   RowBox[{"x", ",", "y", ",", "z"}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->523602237,ExpressionUUID->"212933b2-bf5b-4555-a2e9-d81dcdd411cd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", ",", "y", ",", "z"}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->929643559,ExpressionUUID->"fd4e6ff8-2605-4013-a78d-03c34ba9af33"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Rank", "[", 
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"{", "1", "}"}], "}"}], "}"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->872696550,ExpressionUUID->"1ebf7f01-708d-412f-8d8d-e117b2f305e8"],

Cell[BoxData[
 RowBox[{"{", "0", "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->1438388673,ExpressionUUID->"fcbfe2d6-210c-4350-bce7-71f8fae25fbc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Component", "[", 
  RowBox[{"vec", ",", "2"}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1318885456,ExpressionUUID->"1f6f1ea2-32fc-4fd7-9e08-abdca8e560a6"],

Cell[BoxData["y"], "Output",
 CellLabel->"Out[4]=",
 CellID->1517083260,ExpressionUUID->"86d6e20e-2d2b-44cd-a06d-f05e282ccb6d"]
}, Open  ]],

Cell[TextData[{
 StyleBox["The",
  Deletable->True],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{"q", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "3a419fd9-9930-4020-8039-2483fcae1511"],
 " component of a contravariant spherical tensor:"
}], "ExampleText",
 CellID->795311142,ExpressionUUID->"235117d6-756f-4b6b-93cc-e28b635eca06"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorForm", "[", 
  RowBox[{"cov", "=", 
   RowBox[{"ToCovariant", "[", "vec", "]"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1061097104,ExpressionUUID->"1ddf7323-aa69-46de-8a6f-01d00116bdb2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["x", 
         SqrtBox["2"]]}], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "y"}], 
        SqrtBox["2"]]}], "z", 
      RowBox[{
       FractionBox["x", 
        SqrtBox["2"]], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "y"}], 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[5]//MatrixForm=",
 CellID->1874518345,ExpressionUUID->"ebdf489a-001a-4ef3-9452-a44dfae1f532"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Component", "[", 
  RowBox[{"cov", ",", "1"}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->128046301,ExpressionUUID->"211f8ac6-e2a7-4546-a9c6-565721c40211"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["x", 
    SqrtBox["2"]]}], "-", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", "y"}], 
   SqrtBox["2"]]}]], "Output",
 CellLabel->"Out[6]=",
 CellID->930493057,ExpressionUUID->"309e4206-d5d0-40d1-8267-9b78ad73345e"]
}, Open  ]],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  FormBox[
   RowBox[{"q", "=", "0"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "83315c24-955b-46e3-a565-e5d47f55ff44"],
 StyleBox[" component of a covariant tensor operator:",
  Deletable->True]
}], "ExampleText",
 CellID->1432770597,ExpressionUUID->"c9815b4a-537e-4df1-8374-f411af9261b5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorForm", "[", 
  RowBox[{"jcov", "=", 
   RowBox[{"WignerEckart", "[", 
    RowBox[{
     RowBox[{"1", "/", "2"}], ",", 
     RowBox[{"{", 
      RowBox[{"J", ",", "1"}], "}"}]}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->396109937,ExpressionUUID->"374440f9-fa27-4e19-a1a9-04a68360f366"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", 
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["2"]]}]},
         {"0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          FractionBox["1", "2"], "0"},
         {"0", 
          RowBox[{"-", 
           FractionBox["1", "2"]}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0"},
         {
          FractionBox["1", 
           SqrtBox["2"]], "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[7]//MatrixForm=",
 CellID->82704882,ExpressionUUID->"00120bff-4f8d-4a52-a2c9-293cf6467cc8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorForm", "[", 
  RowBox[{"jz", "=", 
   RowBox[{"Component", "[", 
    RowBox[{"jcov", ",", "0"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->990654636,ExpressionUUID->"6363778d-6885-4482-b04d-46983fcc30fe"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[8]//MatrixForm=",
 CellID->1081557463,ExpressionUUID->"abcc2f4f-4c6e-4ff1-b0e2-ba84e967c237"]
}, Open  ]],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["m", "1"], "=", 
     RowBox[{"1", "/", "2"}]}], ",", " ", 
    RowBox[{
     SubscriptBox["m", "2"], "=", 
     RowBox[{"1", "/", "2"}]}]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"29fec32e-83ed-4acc-83ad-62a098b3f833"],
 " matrix element of an operator on a ",
 Cell[BoxData[
  FormBox[
   RowBox[{"j", "=", 
    RowBox[{"1", "/", "2"}]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "10e05001-893b-4275-9903-145170509d7c"],
 " angular-momentum space:"
}], "ExampleText",
 CellID->2044765061,ExpressionUUID->"183ed810-6c83-430a-9e43-5dd19a8e11d4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Component", "[", 
  RowBox[{"jz", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "/", "2"}], ",", 
     RowBox[{"1", "/", "2"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->139922697,ExpressionUUID->"7a590cb3-db82-4c1d-8d51-7b19f7e8de7f"],

Cell[BoxData[
 FractionBox["1", "2"]], "Output",
 CellLabel->"Out[9]=",
 CellID->690769590,ExpressionUUID->"fb20d8f6-c806-4165-b7eb-4d4c9cce9557"]
}, Open  ]],

Cell[TextData[{
 "The rank ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Kappa]", "=", "1"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"074de2d1-63de-47b7-95c7-d15f472fe20e"],
 " tensor from a contravariant spherical-tensor decomposition: "
}], "ExampleText",
 CellID->1666530778,ExpressionUUID->"e007e752-497f-41b9-8231-0b5f6b843c52"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorForm", "[", 
  RowBox[{"decomp", "=", 
   RowBox[{"Decomposition", "[", "jz", "]"}]}], "]"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->1320700020,ExpressionUUID->"7e00040c-255c-4978-940e-a23904135eb7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {
        FractionBox["1", 
         SqrtBox["2"]]},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellLabel->"Out[10]=",
 CellID->1606812117,ExpressionUUID->"fe87cbdc-a839-46ab-af92-4a6488e4f578"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorForm", "[", 
  RowBox[{"Component", "[", 
   RowBox[{"decomp", ",", "1"}], "]"}], "]"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->905268760,ExpressionUUID->"416137dc-95f6-448e-bbff-bbd4b610fe9e"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[11]//MatrixForm=",
 CellID->2019596222,ExpressionUUID->"90812708-59f5-46e9-891f-2e59e815d839"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "77dc8972-2053-4509-b4ad-4a0fc4fdd73e"]
}], "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->1293636265,ExpressionUUID->"406487fc-2fcb-4633-99fa-ff5406bf1736"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]], "InlineMath",ExpressionUUID->
  "ab7a037c-c289-404d-be83-314a8182712b"],
 StyleBox[" component of a Cartesian vector operator:",
  Deletable->True]
}], "ExampleText",
 CellID->1613726245,ExpressionUUID->"f319954a-9604-43f9-94e4-272d53d59805"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "@", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "0"}]}], "]"}]}], "}"}]}]}]], "Input",
 CellLabel->"In[9]:=",
 CellID->1002331642,ExpressionUUID->"ade8a9dc-536e-47b9-b723-bb2ed08fab14"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[9]=",
 CellID->1692197728,ExpressionUUID->"af335dec-0682-4c90-8232-e6b5bb7b3d85"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorForm", "[", 
  RowBox[{"dcart", "=", 
   RowBox[{"ToCartesian", "@", 
    RowBox[{"WignerEckart", "[", 
     RowBox[{"sys", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<NormalizedDipole\>\"", ",", "1"}], "}"}]}], "]"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->187310524,ExpressionUUID->"dad9e689-47ae-4b19-80ae-4986ab3b0648"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0", "0", 
        RowBox[{"-", 
         FractionBox["1", 
          SqrtBox["6"]]}]},
       {"0", "0", "0", "0"},
       {"0", "0", "0", 
        FractionBox["1", 
         SqrtBox["6"]]},
       {
        RowBox[{"-", 
         FractionBox["1", 
          SqrtBox["6"]]}], "0", 
        FractionBox["1", 
         SqrtBox["6"]], "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0", "0", 
        FractionBox["\[ImaginaryI]", 
         SqrtBox["6"]]},
       {"0", "0", "0", "0"},
       {"0", "0", "0", 
        FractionBox["\[ImaginaryI]", 
         SqrtBox["6"]]},
       {
        RowBox[{"-", 
         FractionBox["\[ImaginaryI]", 
          SqrtBox["6"]]}], "0", 
        RowBox[{"-", 
         FractionBox["\[ImaginaryI]", 
          SqrtBox["6"]]}], "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0", "0", "0"},
       {"0", "0", "0", 
        FractionBox["1", 
         SqrtBox["3"]]},
       {"0", "0", "0", "0"},
       {"0", 
        FractionBox["1", 
         SqrtBox["3"]], "0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellLabel->"Out[10]=",
 CellID->1506909364,ExpressionUUID->"330c4e78-7eb4-43bd-9b15-c8edaeea6d10"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorForm", "[", 
  RowBox[{"dy", "=", 
   RowBox[{"Component", "[", 
    RowBox[{"dcart", ",", "2"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->83789679,ExpressionUUID->"5231af55-f631-4cfc-98b0-eb8c0ab26172"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      FractionBox["\[ImaginaryI]", 
       SqrtBox["6"]]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", 
      FractionBox["\[ImaginaryI]", 
       SqrtBox["6"]]},
     {
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", 
        SqrtBox["6"]]}], "0", 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", 
        SqrtBox["6"]]}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[11]//MatrixForm=",
 CellID->1908702634,ExpressionUUID->"59c4e948-ab05-4f5f-acc7-0841200bd8f8"]
}, Open  ]],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"J", "=", "1"}], ",", 
      RowBox[{"M", "=", "1"}]}], ")"}], ",", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"J", "=", "0"}], ",", " ", 
      RowBox[{"M", "=", "0"}]}], ")"}]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"7c28ce30-92c7-4f3c-beb1-1a763bf994b8"],
 " matrix element of an operator:"
}], "ExampleText",
 CellID->1427213194,ExpressionUUID->"cb1f9d7b-225e-4d79-84bb-c19efd354c14"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Component", "[", 
  RowBox[{"sys", ",", "dy", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "1"}], ",", 
       RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "0"}], ",", 
       RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[12]:=",
 CellID->1506330185,ExpressionUUID->"ca97daeb-7bb2-4ef7-8f57-8db0d9fd8569"],

Cell[BoxData[
 FractionBox["\[ImaginaryI]", 
  SqrtBox["6"]]], "Output",
 CellLabel->"Out[12]=",
 CellID->186991349,ExpressionUUID->"6e2088f1-64a1-45e2-b011-e3ae819c6b93"]
}, Open  ]],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"J", "=", "0"}], ",", " ", 
    RowBox[{"J", "=", "1"}]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "fc468bb4-cf88-4e50-8f40-c03abae9355f"],
 " tensor decomposition of a tensor decomposition matrix:"
}], "ExampleText",
 CellID->1491464241,ExpressionUUID->"e139e8de-e971-43d3-9225-330626083498"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorForm", "[", 
  RowBox[{"dymat", "=", 
   RowBox[{"Decomposition", "[", 
    RowBox[{"sys", ",", "dy"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->452447984,ExpressionUUID->"d1577de9-e1f7-4465-999c-d8f13afb37de"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"{", 
       RowBox[{
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]], ",", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0"},
            {"0"},
            {"0"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]], ",", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0"},
            {"0"},
            {"0"},
            {"0"},
            {"0"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}], "}"}], 
      RowBox[{"{", 
       TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {
            FractionBox["\[ImaginaryI]", 
             SqrtBox["6"]]},
           {"0"},
           {
            FractionBox["\[ImaginaryI]", 
             SqrtBox["6"]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]], "}"}]},
     {
      RowBox[{"{", 
       TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {
            RowBox[{"-", 
             FractionBox["\[ImaginaryI]", 
              SqrtBox["6"]]}]},
           {"0"},
           {
            RowBox[{"-", 
             FractionBox["\[ImaginaryI]", 
              SqrtBox["6"]]}]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]], "}"}], 
      RowBox[{"{", 
       TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"0"}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]], "}"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellLabel->"Out[13]//MatrixForm=",
 CellID->640464630,ExpressionUUID->"741242da-4c3a-4104-bf23-1df941e7c78e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorForm", "[", 
  RowBox[{"Component", "[", 
   RowBox[{"sys", ",", "dymat", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"AtomicState", "[", 
       RowBox[{"2", ",", 
        RowBox[{"J", "\[Rule]", "0"}]}], "]"}], ",", 
      RowBox[{"AtomicState", "[", 
       RowBox[{"1", ",", 
        RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], "}"}]}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->570797330,ExpressionUUID->"4b12fbea-564d-4401-9d8b-4aef84699af5"],

Cell[BoxData[
 RowBox[{"{", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", 
         SqrtBox["6"]]}]},
      {"0"},
      {
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", 
         SqrtBox["6"]]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], "}"}]], "Output",
 CellLabel->"Out[14]=",
 CellID->351702348,ExpressionUUID->"ae9ec161-54a6-473c-a4a8-0c2107dc7dab"]
}, Open  ]],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  FormBox[
   RowBox[{"q", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "c99cbdd9-7f18-4db1-ba4c-3fadfa6eee19"],
 " component of the rank ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Kappa]", "=", "1"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"7f5f9498-0984-4431-b6a9-c93cf1c54fed"],
 " spherical tensor of the ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"J", "=", "0"}], ",", " ", 
    RowBox[{"J", "=", "1"}]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "3f5e1f26-1b40-478f-9f18-fffac596700d"],
 " tensor decomposition:"
}], "ExampleText",
 CellID->312430524,ExpressionUUID->"b685d3fa-d5ce-40d5-bef8-544f3a056f19"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Component", "[", 
  RowBox[{"sys", ",", "dymat", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "0"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], "}"}], ",", "1", ",", "1"}], 
  "]"}]], "Input",
 CellLabel->"In[15]:=",
 CellID->1085457949,ExpressionUUID->"164f1fb6-19d8-492e-9721-ae4313e17e59"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox["\[ImaginaryI]", 
   SqrtBox["6"]]}]], "Output",
 CellLabel->"Out[15]=",
 CellID->1226170318,ExpressionUUID->"74621c70-0c44-4921-bfc6-5902bd6437ea"]
}, Open  ]]
}, Hold[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox["Tutorials", "TutorialsSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Matrix Notation"]], 
           "paclet:AtomicDensityMatrix/tutorial/MatrixNotation"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "f8b94975-745d-4a16-ad45-3b310225c0f3"]}]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Tensor Component Operations and Extraction"]], 
           "paclet:AtomicDensityMatrix/tutorial/\
TensorComponentOperationsAndExtraction"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "dbe880c0-ef5b-4939-be4a-1214dd4f6ebd"]}]}
     }]}
  }]], "TutorialsSection",ExpressionUUID->"d60b09a7-b7ba-4c59-b215-\
2ab12d9b6d4d"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "97094dc1-4fc0-47ce-bc5b-c11a394a44c2"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"a22f1983-47e5-4142-b870-\
ee8c289d2ae6"],

Cell[" ", "FooterCell",ExpressionUUID->"c60d5098-361d-40fb-bfa4-77b5f2d7b03f"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Component",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, 
    "ExampleSection" -> {"0" -> Open, "1" -> Closed}, "NotesSection" -> 
    Closed}, "NewStyles" -> True, "CitationPopupData" -> $Failed, 
  "ShowCitation" -> False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 17, 59, 14.038324}", 
    "history" -> {"18.09", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "Component[tens, q] extracts the q-th component of a spherical tensor \
tens. Component[cart, i] extracts the i-th component of a Cartesian vector \
cart. Component[decomp, k] extracts the spherical tensor of rank k from a \
tensor decomposition decomp. Component[op, {m1, m2}] extracts the matrix \
element corresponding to sublevels with angular-momentum-projection quantum \
numbers m1 and m2 from an operator op. Component[sys, op, {s1, s2}] extracts \
the matrix element of operator op corresponding to the states s1 and s2 of \
atomic system sys. Component[sys, mat, {s1, s2}] extracts the tensor \
decomposition from the tensor-decomposition matrix mat corresponding to the \
states s1 and s2.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "Component", "titlemodifier" -> "", "metadescription" -> "", 
    "windowtitle" -> "Component", "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/Component"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"8b0a8c37-3f51-4153-a3f9-0fa8bd8023e0"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[19623, 536, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"d3ad1b4b-c426-4567-a956-b1a61039988f",
   CellTags->"PrimaryExamplesSection",
   CellID->1932856016]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 56093, 1651}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[581, 21, 5427, 129, 57, "AnchorBarGrid",ExpressionUUID->"dcc4f851-3485-4a47-b2b2-261de60fce02",
 CellID->1],
Cell[6011, 152, 102, 0, 23, "ContextNameCell",ExpressionUUID->"17d3e144-c65c-4c3b-8a13-08ebf7ea29c5"],
Cell[CellGroupData[{
Cell[6138, 156, 552, 14, 60, "ObjectNameGrid",ExpressionUUID->"abbbda25-5886-4ccd-8d62-3f6644869051"],
Cell[6693, 172, 6662, 178, 510, "Usage",ExpressionUUID->"7a20e213-33af-481a-a494-085543699c83",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[13392, 355, 1897, 47, 37, "NotesSection",ExpressionUUID->"ab0febf6-58bc-4215-8d65-f682caa741a3",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->49307673],
Cell[15292, 404, 784, 21, 70, "Notes",ExpressionUUID->"c59ea524-8382-4dc6-bc8d-0243d6bc6cb9",
 CellID->656996691],
Cell[16079, 427, 787, 23, 70, "Notes",ExpressionUUID->"1fadde80-c75d-4f86-b6ca-c77c4135cd08",
 CellID->317781180],
Cell[16869, 452, 318, 8, 70, "Notes",ExpressionUUID->"189abba6-3fa1-4c2f-9480-88acecdac16b",
 CellID->368017552],
Cell[17190, 462, 1771, 55, 70, "Notes",ExpressionUUID->"a17eec98-dde2-414a-9680-35ceb0067516",
 CellID->1067943069],
Cell[18964, 519, 532, 11, 70, "Notes",ExpressionUUID->"a86bb8cc-4d4e-4f65-bae0-0cb020e99dcf",
 CellID->402896142]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[19623, 536, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"d3ad1b4b-c426-4567-a956-b1a61039988f",
 CellTags->"PrimaryExamplesSection",
 CellID->1932856016],
Cell[CellGroupData[{
Cell[21038, 577, 1402, 36, 30, "ExampleSection",ExpressionUUID->"e9bc31a8-9945-49c0-93c9-8e0537221530",
 CellID->525932743],
Cell[22443, 615, 184, 3, 70, "Input",ExpressionUUID->"84c473ba-69e4-40b8-b12e-0ea671c07328",
 CellID->1805505445],
Cell[22630, 620, 307, 8, 70, "ExampleText",ExpressionUUID->"d5729ad9-5fe3-4e5f-808b-fea6de35cfcc",
 CellID->2046613925],
Cell[CellGroupData[{
Cell[22962, 632, 206, 5, 70, "Input",ExpressionUUID->"212933b2-bf5b-4555-a2e9-d81dcdd411cd",
 CellID->523602237],
Cell[23171, 639, 181, 4, 37, "Output",ExpressionUUID->"fd4e6ff8-2605-4013-a78d-03c34ba9af33",
 CellID->929643559]
}, Open  ]],
Cell[CellGroupData[{
Cell[23389, 648, 227, 6, 70, "Input",ExpressionUUID->"1ebf7f01-708d-412f-8d8d-e117b2f305e8",
 CellID->872696550],
Cell[23619, 656, 149, 3, 37, "Output",ExpressionUUID->"fcbfe2d6-210c-4350-bce7-71f8fae25fbc",
 CellID->1438388673]
}, Open  ]],
Cell[CellGroupData[{
Cell[23805, 664, 186, 4, 70, "Input",ExpressionUUID->"1f6f1ea2-32fc-4fd7-9e08-abdca8e560a6",
 CellID->1318885456],
Cell[23994, 670, 127, 2, 37, "Output",ExpressionUUID->"86d6e20e-2d2b-44cd-a06d-f05e282ccb6d",
 CellID->1517083260]
}, Open  ]],
Cell[24136, 675, 349, 10, 70, "ExampleText",ExpressionUUID->"235117d6-756f-4b6b-93cc-e28b635eca06",
 CellID->795311142],
Cell[CellGroupData[{
Cell[24510, 689, 228, 5, 70, "Input",ExpressionUUID->"1ddf7323-aa69-46de-8a6f-01d00116bdb2",
 CellID->1061097104],
Cell[24741, 696, 1021, 31, 60, "Output",ExpressionUUID->"ebdf489a-001a-4ef3-9452-a44dfae1f532",
 CellID->1874518345]
}, Open  ]],
Cell[CellGroupData[{
Cell[25799, 732, 185, 4, 70, "Input",ExpressionUUID->"211f8ac6-e2a7-4546-a9c6-565721c40211",
 CellID->128046301],
Cell[25987, 738, 272, 9, 56, "Output",ExpressionUUID->"309e4206-d5d0-40d1-8267-9b78ad73345e",
 CellID->930493057]
}, Open  ]],
Cell[26274, 750, 340, 9, 70, "ExampleText",ExpressionUUID->"c9815b4a-537e-4df1-8374-f411af9261b5",
 CellID->1432770597],
Cell[CellGroupData[{
Cell[26639, 763, 331, 9, 70, "Input",ExpressionUUID->"374440f9-fa27-4e19-a1a9-04a68360f366",
 CellID->396109937],
Cell[26973, 774, 2581, 71, 82, "Output",ExpressionUUID->"00120bff-4f8d-4a52-a2c9-293cf6467cc8",
 CellID->82704882]
}, Open  ]],
Cell[CellGroupData[{
Cell[29591, 850, 250, 6, 70, "Input",ExpressionUUID->"6363778d-6885-4482-b04d-46983fcc30fe",
 CellID->990654636],
Cell[29844, 858, 769, 22, 82, "Output",ExpressionUUID->"abcc2f4f-4c6e-4ff1-b0e2-ba84e967c237",
 CellID->1081557463]
}, Open  ]],
Cell[30628, 883, 662, 20, 70, "ExampleText",ExpressionUUID->"183ed810-6c83-430a-9e43-5dd19a8e11d4",
 CellID->2044765061],
Cell[CellGroupData[{
Cell[31315, 907, 285, 8, 70, "Input",ExpressionUUID->"7a590cb3-db82-4c1d-8d51-7b19f7e8de7f",
 CellID->139922697],
Cell[31603, 917, 146, 3, 52, "Output",ExpressionUUID->"fb20d8f6-c806-4165-b7eb-4d4c9cce9557",
 CellID->690769590]
}, Open  ]],
Cell[31764, 923, 342, 8, 70, "ExampleText",ExpressionUUID->"e007e752-497f-41b9-8231-0b5f6b843c52",
 CellID->1666530778],
Cell[CellGroupData[{
Cell[32131, 935, 233, 5, 70, "Input",ExpressionUUID->"7e00040c-255c-4978-940e-a23904135eb7",
 CellID->1320700020],
Cell[32367, 942, 1381, 40, 79, "Output",ExpressionUUID->"fe87cbdc-a839-46ab-af92-4a6488e4f578",
 CellID->1606812117]
}, Open  ]],
Cell[CellGroupData[{
Cell[33785, 987, 227, 5, 70, "Input",ExpressionUUID->"416137dc-95f6-448e-bbff-bbd4b610fe9e",
 CellID->905268760],
Cell[34015, 994, 741, 22, 92, "Output",ExpressionUUID->"90812708-59f5-46e9-891f-2e59e815d839",
 CellID->2019596222]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"}, Closed]]]],
Cell[CellGroupData[{
Cell[34905, 1024, 305, 8, 24, "ExampleSection",ExpressionUUID->"406487fc-2fcb-4633-99fa-ff5406bf1736",
 CellID->1293636265],
Cell[35213, 1034, 316, 8, 70, "ExampleText",ExpressionUUID->"f319954a-9604-43f9-94e4-272d53d59805",
 CellID->1613726245],
Cell[CellGroupData[{
Cell[35554, 1046, 434, 12, 70, "Input",ExpressionUUID->"ade8a9dc-536e-47b9-b723-bb2ed08fab14",
 CellID->1002331642],
Cell[35991, 1060, 766, 21, 55, "Output",ExpressionUUID->"af335dec-0682-4c90-8232-e6b5bb7b3d85",
 CellID->1692197728]
}, Open  ]],
Cell[CellGroupData[{
Cell[36794, 1086, 373, 10, 70, "Input",ExpressionUUID->"dad9e689-47ae-4b19-80ae-4986ab3b0648",
 CellID->187310524],
Cell[37170, 1098, 2802, 85, 117, "Output",ExpressionUUID->"330c4e78-7eb4-43bd-9b15-c8edaeea6d10",
 CellID->1506909364]
}, Open  ]],
Cell[CellGroupData[{
Cell[40009, 1188, 251, 6, 70, "Input",ExpressionUUID->"5231af55-f631-4cfc-98b0-eb8c0ab26172",
 CellID->83789679],
Cell[40263, 1196, 1035, 31, 130, "Output",ExpressionUUID->"59c4e948-ab05-4f5f-acc7-0841200bd8f8",
 CellID->1908702634]
}, Open  ]],
Cell[41313, 1230, 520, 16, 70, "ExampleText",ExpressionUUID->"cb1f9d7b-225e-4d79-84bb-c19efd354c14",
 CellID->1427213194],
Cell[CellGroupData[{
Cell[41858, 1250, 539, 14, 70, "Input",ExpressionUUID->"ca97daeb-7bb2-4ef7-8f57-8db0d9fd8569",
 CellID->1506330185],
Cell[42400, 1266, 171, 4, 56, "Output",ExpressionUUID->"6e2088f1-64a1-45e2-b011-e3ae819c6b93",
 CellID->186991349]
}, Open  ]],
Cell[42586, 1273, 379, 10, 70, "ExampleText",ExpressionUUID->"e139e8de-e971-43d3-9225-330626083498",
 CellID->1491464241],
Cell[CellGroupData[{
Cell[42990, 1287, 258, 6, 70, "Input",ExpressionUUID->"d1577de9-e1f7-4465-999c-d8f13afb37de",
 CellID->452447984],
Cell[43251, 1295, 5272, 146, 190, "Output",ExpressionUUID->"741242da-4c3a-4104-bf23-1df941e7c78e",
 CellID->640464630]
}, Open  ]],
Cell[CellGroupData[{
Cell[48560, 1446, 502, 14, 70, "Input",ExpressionUUID->"4b12fbea-564d-4401-9d8b-4aef84699af5",
 CellID->570797330],
Cell[49065, 1462, 888, 27, 89, "Output",ExpressionUUID->"ae9ec161-54a6-473c-a4a8-0c2107dc7dab",
 CellID->351702348]
}, Open  ]],
Cell[49968, 1492, 702, 20, 70, "ExampleText",ExpressionUUID->"b685d3fa-d5ce-40d5-bef8-544f3a056f19",
 CellID->312430524],
Cell[CellGroupData[{
Cell[50695, 1516, 477, 13, 70, "Input",ExpressionUUID->"164f1fb6-19d8-492e-9721-ae4313e17e59",
 CellID->1085457949],
Cell[51175, 1531, 191, 5, 56, "Output",ExpressionUUID->"74621c70-0c44-4921-bfc6-5902bd6437ea",
 CellID->1226170318]
}, Open  ]]
}, Hold[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[51605, 1545, 1131, 29, 124, "TutorialsSection",ExpressionUUID->"d60b09a7-b7ba-4c59-b215-2ab12d9b6d4d"],
Cell[52739, 1576, 753, 19, 70, "MoreAboutSection",ExpressionUUID->"a22f1983-47e5-4142-b870-ee8c289d2ae6"],
Cell[53495, 1597, 78, 0, 70, "FooterCell",ExpressionUUID->"c60d5098-361d-40fb-bfa4-77b5f2d7b03f"]
}
]
*)

(* End of internal cache information *)

