(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     80509,       2318]
NotebookOptionsPosition[     67757,       2066]
NotebookOutlinePosition[     70181,       2125]
CellTagsIndexPosition[     70095,       2120]
WindowTitle->DMVariables
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "bb36d8ad-4b88-48a2-adac-ff923215e334"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "3f709dca-93b0-4ced-8ff9-80ea2487cfe2"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "363c7387-4ffa-4caf-a754-2fd88bc8b0cf"]
         }],ExpressionUUID->"81f4c5e3-a517-4879-abae-a90be5164b48"],
         StripOnInput->False], {"\<\"DensityMatrix\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/DensityMatrix"], "\<\"Ket\"\>":>
        Documentation`HelpLookup["paclet:AtomicDensityMatrix/ref/Ket"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "0f6ce992-47dd-4982-85ab-7a95c125e272"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "568f2de6-1f7b-4892-b2e2-1c8a56c8dcdd"]
         }],ExpressionUUID->"64105bcb-2cd3-4de9-b4a4-16ec9bf16ed3"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "0e03418a-5206-4478-ac16-806636ae21c5"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "2e5ee94d-25ba-4778-ac4f-22a82476d486"]
         }],ExpressionUUID->"10177ae0-9468-44c7-9a21-1656369477c4"],
         StripOnInput->False], {"\<\"Displaying the Density Matrix\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"Tutorials"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "02eabba5-deaf-4ebe-993c-f500b81f7e99"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "25175294-7220-4a48-8edb-7f873e05c842"]
         }],ExpressionUUID->"f550ee01-572f-472d-bfad-79bb782b129b"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix/ref/DMVariables\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/DMVariables"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/DMVariables.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$39766], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/DMVariables" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "4199cac3-7a33-4b87-a15e-4b028b2904a8"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "23f1a58f-f71a-4ffe-bd60-5bb38861ad80"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"d643683f-21f8-4b64-baa7-f8cf75cdebf3"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"b2dd4682-7089-4cb7-86b6-01eac685f317"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "DMVariables", "ObjectName",ExpressionUUID->
      "63a979db-f8d5-4f2c-8363-fe11ec43ae75"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"a91ecee1-c68f-4d01-9d0b-8db558f90a63"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "db9314c8-5f2a-480d-80d0-da305acfd768"]
    }],ExpressionUUID->"6801a8f4-e225-4f54-a6d9-a62cea2d9046"], 
    "\[SpanFromLeft]"}
  }]], "ObjectNameGrid",ExpressionUUID->"56c7f9df-eb9c-4511-90d0-\
dab8861e04fb"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       TemplateBox[{
         Cell[
          TextData["DMVariables"]], 
         "paclet:AtomicDensityMatrix/ref/DMVariables", 
         "AtomicDensityMatrix Package Symbol"},
        "PackageLink",
        BaseStyle->"InlineFormula"], "[", 
       StyleBox["sys", "TI"], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "249f26a7-2ac5-4fb5-8a12-45658cb7e996"],
     " \[LineSeparator]returns the list of variables representing the density\
\[Hyphen]matrix elements for an atomic system (list of ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["AtomicState"]], 
        "paclet:AtomicDensityMatrix/ref/AtomicState", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "bd6cf807-9b1a-46c1-886b-8a543a76111a"],
     " objects) ",
     Cell[BoxData[
      StyleBox["sys", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "989708e7-1a0e-4594-b826-77332aa7888b"],
     "."
    }],ExpressionUUID->"3fb54d95-0892-48f6-b7e7-234f8447faec"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"4bf11c3c-b9ba-42eb-ad73-a304b7d9b645"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"0cda6436-fe12-4abe-98d6-cebe83ea5ae4"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"cd44111f-f263-4196-9d0f-02de4f0738c5"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"ae8949bf-3378-4b94-9c75-004c4228d8ca"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"a427a1b0-d453-49ce-a74f-850b56f6da07"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->1139249869,ExpressionUUID->"eccf2b6e-1a5f-4735-84d3-9ac6822d57a6"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["DMVariables"]], "paclet:AtomicDensityMatrix/ref/DMVariables", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "0aff2d13-ebc6-4550-9760-781f2ac467d6"],
 " takes the same options as ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["DensityMatrix"]], 
    "paclet:AtomicDensityMatrix/ref/DensityMatrix", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "fc948f3b-d5f9-4301-88de-bc80e5ad974d"],
 ", with the default value for each being ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["Automatic"]], "paclet:ref/Automatic"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "9e2adfc6-be01-491e-9936-2e2d4bb819a3"],
 ", indicating that the corresponding default value for ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["DensityMatrix"]], 
    "paclet:AtomicDensityMatrix/ref/DensityMatrix", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "f8306b1d-ff4e-4d22-a581-7717a26f5fae"],
 " is used."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"baf9892a-ff72-4f29-aa32-f2de3ced85c3"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "d2b2b556-ff5f-4ae4-8eb4-32ad3606fc9a"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"2762e45f-e34c-4d91-a87f-70e300770c02"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(10)", "ExampleCount",ExpressionUUID->
  "b656025c-c72c-48d5-8765-af6319aa7ba3"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->408351631,ExpressionUUID->"7a28d317-6d45-45d1-81cb-9b071d9a4209"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "5a346997-621b-423a-a415-7e75fbdee03a"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"abeda5fa-8c88-4763-9ed2-65138e2304a9"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount",ExpressionUUID->
  "a4923a4c-d148-4b55-9e88-7db8072e28e0"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->1955610052,ExpressionUUID->"6a03e301-15d5-4819-a50c-0db3607afcf3"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->40423541,ExpressionUUID->"e9eb5604-f7c2-4cc1-8574-9a83379a2c6d"],

Cell["\<\
Density-matrix variables for a system with no angular momentum:\
\>", "ExampleText",
 CellID->135693201,ExpressionUUID->"fe4058e9-ced2-489b-9102-8c4785f797d8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", "1", "]"}], ",", 
    RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->90393259,ExpressionUUID->"01ca6141-8ec9-466d-ac4a-1e1b8c3d849d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", "1", "]"}], ",", 
   RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1347333078,ExpressionUUID->"6a436bca-2abe-48ab-985d-637f29ec6bb9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", "sys", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->71264253,ExpressionUUID->"e1ba409f-730f-400c-a2e9-76c410bedc98"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"1", ",", "1"}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"1", ",", "2"}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"2", ",", "1"}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"2", ",", "2"}]], "[", "t", "]"}]}], "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->1559467978,ExpressionUUID->"db3289c6-c7ae-4675-b149-8048f259b89b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[
  "\t", "ExampleDelimiter",ExpressionUUID->
   "879a54a9-18b1-4747-afb5-f60e0a18ae81"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->719744508,ExpressionUUID->"056805e4-ed16-48fc-b72b-db7f6d260b52"],

Cell["Density-matrix variables for a system with Zeeman structure:", \
"ExampleText",
 CellID->453682541,ExpressionUUID->"522f05e5-5dd1-498e-b491-fab145525ef0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"\"\<a\>\"", ",", 
       RowBox[{"J", "\[Rule]", "0"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"\"\<b\>\"", ",", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1002736892,ExpressionUUID->"3cb584d9-f4f6-400e-add0-4a334c480071"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"a\"\>", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"b\"\>", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"b\"\>", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"b\"\>", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[1]=",
 CellID->2087878258,ExpressionUUID->"179e43ab-67a7-46af-848e-d6823c610a46"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", "sys", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->115787309,ExpressionUUID->"69bc1485-589a-47b6-827d-f6804f2ddbc9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"a\"\>", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"a\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"a\"\>", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"a\"\>", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"a\"\>", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"a\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"a\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"a\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"b\"\>", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1087090226,ExpressionUUID->"51ee61d4-a324-4192-b50d-a2d17ba44a5a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[
  "\t", "ExampleDelimiter",ExpressionUUID->
   "3e539705-a06b-48f9-b4a0-ac5054f1b864"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->422283026,ExpressionUUID->"bb168146-36e4-41ec-ad57-09f0d51baed3"],

Cell["\<\
Density-matrix variables for a system with hyperfine structure:\
\>", "ExampleText",
 CellID->27102674,ExpressionUUID->"091f5b62-64da-4e6d-be2c-6e8ea3e1ae7b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", 
       RowBox[{"1", "/", "2"}]}], ",", 
      RowBox[{"NuclearSpin", "\[Rule]", 
       RowBox[{"1", "/", "2"}]}]}], "]"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->53916052,ExpressionUUID->"8741e1d3-f4c3-4a2b-abed-2672d54fb384"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[1]=",
 CellID->2082043353,ExpressionUUID->"9e02933b-bbe0-4aca-8381-7e4572cc6448"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", "sys", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->89018852,ExpressionUUID->"7c3ec0a8-09af-41af-b1ef-e20ec26f877b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], 
  "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1804089653,ExpressionUUID->"06282d98-939b-4c07-8030-979efd5feab0"]
}, Open  ]]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"6d17b624-d211-4fda-91ce-8519ea6c3249"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"86b35861-0bd8-48a4-ba5d-a95060fc3433"],
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(7)", "ExampleCount",ExpressionUUID->
  "fb4fa398-e3c6-43fb-a420-70caf91291c1"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->253621532,ExpressionUUID->"6b4ea8e1-f02d-4928-abaf-d50e29ad7dd4"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "0"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"d0bea6a7-b3b5-4d77-b0ab-8417b06597e0"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"fe5a5eed-3a9f-45b5-a738-403de78f7af7"],
 "AllowedElements",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "2c0f3b7c-08a8-4581-82f5-33afe47b2e62"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->435889856,ExpressionUUID->"f5514f9b-d1c0-4983-8fc7-86d78a82deb3"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1271543587,ExpressionUUID->"e24955e4-4773-4283-9f68-50dd6291accf"],

Cell[TextData[{
 "List the density-matrix elements, allowing only those between states with \
",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "0"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "3bf6d3b4-b749-4420-8cae-1a0c95e34622"],
 StyleBox[" and ",
  Deletable->True],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"|", " ", "M", "|"}], "=", "1"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"35e962e8-eb1b-4479-b832-5d231494f876"],
 StyleBox[":",
  Deletable->True]
}], "ExampleText",
 CellID->1223295412,ExpressionUUID->"26624264-a78a-447a-a7c6-0bcf1cf402f0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", 
  RowBox[{
   RowBox[{"Sublevels", "@", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", " ", 
      RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
   RowBox[{"AllowedElements", "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"Abs", "[", "M", "]"}], "\[Equal]", "1"}], "\[Rule]", 
     RowBox[{"M", "\[Equal]", "0"}]}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1984201695,ExpressionUUID->"6360e5bf-46cf-4057-9695-abe538286883"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "}"}]], "Output",\

 CellLabel->"Out[2]=",
 CellID->673169276,ExpressionUUID->"12ff7166-525f-49be-89ee-a646f57e1d85"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "0"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "1"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"b3652668-1ca1-461f-95cb-71be351e6557"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"77097138-76cf-4c4d-b0f2-0e405aaa1bfe"],
 "ComplexExpandVariables",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "1b9e5102-1a75-4caf-a861-80d7f7c94487"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->124303609,ExpressionUUID->"a3d70b97-92d3-4ff2-a932-a4a90d1ba9ff"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->23655700,ExpressionUUID->"9cec5710-ae8a-455b-8459-7a7aaf92bb9c"],

Cell["\<\
Write density matrix variables in terms of real and imaginary parts:\
\>", "ExampleText",
 CellID->131826769,ExpressionUUID->"e182b721-4352-466a-8100-729f8ad34b9d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "@", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", " ", 
     RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->141331294,ExpressionUUID->"40037395-dd59-4e06-bccb-04f07c46f277"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1013185978,ExpressionUUID->"df037d61-0699-433d-9ebb-a6f2c4cf2686"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"ComplexExpandVariables", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->675428486,ExpressionUUID->"8a2b0d2a-2fbd-40ba-ba57-c9feee889e27"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Re", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], "]"}], ",", 
   RowBox[{"Re", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}], ",", 
   RowBox[{"Im", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}], ",", 
   RowBox[{"Re", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}], ",", 
   RowBox[{"Re", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}], ",", 
   RowBox[{"Im", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}], ",", 
   RowBox[{"Re", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}], ",", 
   RowBox[{"Im", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}], ",", 
   RowBox[{"Re", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}]}], 
  "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->1218895183,ExpressionUUID->"75cf97a6-36b2-4082-a1a5-0d90a6d9c3bc"]
}, Open  ]],

Cell["Indicate real and imaginary parts using labels:", "ExampleText",
 CellID->276259480,ExpressionUUID->"38a7183f-da87-4974-98f9-ceedc507a88e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"ComplexExpandVariables", "\[Rule]", "Subscript"}]}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->395829546,ExpressionUUID->"a8c18439-39ed-42b5-89df-d50d6884441e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"Re", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"Re", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"Im", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"Re", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"Re", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"Im", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"Re", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"Im", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"Re", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}], "}"}]], "Output",
 CellLabel->"Out[4]=",
 CellID->1124831948,ExpressionUUID->"6d91df0e-f86b-4b4e-ad57-b70425ce8655"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "1"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "2"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"7a45df43-23fa-4dae-afdd-c17a04b8f772"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"74a8f83b-410c-4ec0-835b-1da5968bec4e"],
 "DMLabel",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "fa95c765-07a4-4e04-96f4-07468a7b5eda"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->239804243,ExpressionUUID->"6d35071e-b1d9-4cf1-a32c-5578cef52a86"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->330352135,ExpressionUUID->"3e8b516b-a084-47a8-a8b7-4ea8d9df7625"],

Cell["Provide an additional label for the density-matrix elements:", \
"ExampleText",
 CellID->11034410,ExpressionUUID->"eea2c68f-c482-44c0-bc1e-75360e1eff13"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", 
  RowBox[{
   RowBox[{"Sublevels", "@", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", " ", 
      RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
   RowBox[{"DMLabel", "\[Rule]", "\"\<lab\>\""}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->731005036,ExpressionUUID->"dcbab747-2536-4233-b653-c08110f89392"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"\<\"lab\"\>", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"\<\"lab\"\>", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"\<\"lab\"\>", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"\<\"lab\"\>", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"\<\"lab\"\>", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"\<\"lab\"\>", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"\<\"lab\"\>", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"\<\"lab\"\>", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"\<\"lab\"\>", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->752005495,ExpressionUUID->"1c44b88a-ee0e-4077-a0d0-33d1483f2a0e"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "2"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "3"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"b5f50b2d-8781-486c-83ee-aa53306e1ff7"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"614f302f-8b7f-4dde-bf3b-938057bc44bc"],
 "DMSymbol",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "ae08c0bd-0fcd-4c73-9ab1-1b41dd2e7b8d"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->33314988,ExpressionUUID->"50392b53-b89f-4b1f-90fe-34abfaa30265"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->307732332,ExpressionUUID->"829d3541-2c43-4496-92c8-0aa67eab749b"],

Cell["Use a different symbol for the density matrix:", "ExampleText",
 CellID->916681948,ExpressionUUID->"c90c2106-a144-4b13-bd36-44b0b4232a05"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", 
  RowBox[{
   RowBox[{"Sublevels", "@", 
    RowBox[{"{", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}], "}"}]}], ",", 
   RowBox[{"DMSymbol", "\[Rule]", "\[Sigma]"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->247747826,ExpressionUUID->"a8a1a38b-17ef-4b15-ad75-3ccac753e509"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Sigma]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Sigma]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Sigma]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Sigma]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Sigma]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Sigma]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Sigma]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Sigma]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Sigma]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->416636273,ExpressionUUID->"8a682588-28d5-4e7b-9f8c-edc76f1bda25"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "3"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "4"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"e03a7239-1d66-47c5-983c-d6c872be197d"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"9371f4fa-db1d-4360-8cdf-3fac04ab8d5f"],
 "NeglectedElements",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "e842941f-9a16-49cb-953f-5f301bb88c47"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->934089875,ExpressionUUID->"31a83b93-e619-4d7f-9353-aa87f08616ff"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->311015445,ExpressionUUID->"27db42ce-fef2-4025-9585-a7c25bef245e"],

Cell[TextData[{
 "List the density-matrix elements, neglecting those between states with ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "0"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "78bcaac7-d2b4-49be-a8bc-f7c6c85db08b"],
 StyleBox[" and ",
  Deletable->True],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"|", " ", "M", "|"}], "=", "1"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"9e5afa17-88ec-4016-b773-ee9640da67a8"],
 StyleBox[":",
  Deletable->True]
}], "ExampleText",
 CellID->261387317,ExpressionUUID->"60950630-c4de-4a2e-a93e-f8eb64b406d4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", 
  RowBox[{
   RowBox[{"Sublevels", "@", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", " ", 
      RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
   RowBox[{"NeglectedElements", "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"Abs", "[", "M", "]"}], "\[Equal]", "1"}], "\[Rule]", 
     RowBox[{"M", "\[Equal]", "0"}]}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1532578704,ExpressionUUID->"b2f5ee1d-e0b9-4bd5-979b-d78502b91d73"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->47815046,ExpressionUUID->"f1520bb1-b972-46d5-ab63-ba50325da47e"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "4"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "5"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"5103d437-1d39-45a4-bd60-eb7914681051"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"da0b7e48-4ea3-4461-957b-2d49cfd02f6e"],
 "TimeDependence",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "b7245463-cbe0-4a23-a26b-05bee320f2f0"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->302951700,ExpressionUUID->"b7a1ca97-847a-4065-8961-be22d3738a18"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->689187939,ExpressionUUID->"6616f136-c961-4825-a124-5c0f3c531678"],

Cell["Remove explicit time dependence:", "ExampleText",
 CellID->173529821,ExpressionUUID->"405c13a0-9b0c-4d64-8baa-47ae13b515ea"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", 
  RowBox[{
   RowBox[{"Sublevels", "@", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", " ", 
      RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
   RowBox[{"TimeDependence", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->173556418,ExpressionUUID->"064550e1-a087-4769-8e20-c969c1e40d8f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1015091870,ExpressionUUID->"dd9ab6e7-44c0-49f9-802f-b36cf2a50103"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "5"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "6"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"a7406f80-2c8a-47a6-a9d5-d13aa19c2f73"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"f97b4e05-9b06-441a-9689-4a46c80bc552"],
 "TimeVariable",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "2eab3200-d7a3-4b8e-b2d2-6c28ba396097"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->51745731,ExpressionUUID->"def93339-3ac6-4f81-b26c-16c0d1ac9bac"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1289603855,ExpressionUUID->"b1378793-08d9-463e-ad16-08cb19c5f42c"],

Cell["Use a different time variable:", "ExampleText",
 CellID->1967025461,ExpressionUUID->"577ade43-e7e5-42b2-9079-07f6e810079b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", 
  RowBox[{
   RowBox[{"Sublevels", "@", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", " ", 
      RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
   RowBox[{"TimeVariable", "\[Rule]", "s"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->952170122,ExpressionUUID->"bcc6830f-004c-43a1-b206-88c4c5c91222"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "s", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "s", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "s", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "s", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "s", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "s", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}]], "[", "s", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]], "[", "s", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]], "[", "s", "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1144085164,ExpressionUUID->"a51e4ccc-09cf-4a8c-9673-5ea7828d37ca"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "6"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedFunction.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"See", " ", "Also"}], "SeeAlsoSection"]},
      {Cell[TextData[{
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["DensityMatrix"]], 
           "paclet:AtomicDensityMatrix/ref/DensityMatrix", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "603f3e31-3b4c-4b58-923f-aad07f79efb0"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Ket"]], "paclet:AtomicDensityMatrix/ref/Ket", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "ab12be33-f1ba-4089-b1c7-26bc53605748"]
       }], "SeeAlso",ExpressionUUID->"8ed37099-5e18-4f6c-b1a0-ae32baaddf20"]}
     }]}
  }]], "SeeAlsoSection",ExpressionUUID->"3f52b0f3-b78f-4995-b695-\
adc6a4ab84d0"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox["Tutorials", "TutorialsSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Displaying the Density Matrix"]], 
           "paclet:AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "4d08713f-12c4-4d52-a413-0535ea96dd01"]}]}
     }]}
  }]], "TutorialsSection",ExpressionUUID->"b339d28d-fbb3-4a2f-a758-\
2213ba6a20a2"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "7444a198-d514-4d57-b711-4899b7e29b2c"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"b67fea9f-9e92-40a7-a4c4-\
afe546d887e2"],

Cell[" ", "FooterCell",ExpressionUUID->"0eb05a02-2f3a-46f9-b7b9-1701f3afe222"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DMVariables",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, 
    "ExampleSection" -> {"0" -> Open, "1" -> Closed}, "NotesSection" -> 
    Closed, "ExampleSubsection" -> {
     "0" -> Closed, "1" -> Closed, "2" -> Closed, "3" -> Closed, "4" -> 
      Closed, "5" -> Closed, "6" -> Closed}}, "NewStyles" -> True, 
  "CitationPopupData" -> $Failed, "ShowCitation" -> False, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2023, 4, 18, 17, 59, 20.129054}", 
    "history" -> {"12.06", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "DMVariables[sys] returns the list of variables representing the \
density-matrix elements for an atomic system (list of AtomicState objects) \
sys.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "DMVariables", 
    "titlemodifier" -> "", "metadescription" -> "", "windowtitle" -> 
    "DMVariables", "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/DMVariables"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"194e4d1a-bc62-44b7-bf93-acbcdb038e89"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[12532, 334, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"7a28d317-6d45-45d1-81cb-9b071d9a4209",
   CellTags->"PrimaryExamplesSection",
   CellID->408351631]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 69895, 2113}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[583, 21, 6375, 154, 57, "AnchorBarGrid",ExpressionUUID->"d643683f-21f8-4b64-baa7-f8cf75cdebf3",
 CellID->1],
Cell[6961, 177, 102, 0, 23, "ContextNameCell",ExpressionUUID->"b2dd4682-7089-4cb7-86b6-01eac685f317"],
Cell[CellGroupData[{
Cell[7088, 181, 554, 14, 60, "ObjectNameGrid",ExpressionUUID->"56c7f9df-eb9c-4511-90d0-dab8861e04fb"],
Cell[7645, 197, 1331, 34, 116, "Usage",ExpressionUUID->"4bf11c3c-b9ba-42eb-ad73-a304b7d9b645",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[9013, 236, 1899, 47, 37, "NotesSection",ExpressionUUID->"eccf2b6e-1a5f-4735-84d3-9ac6822d57a6",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1139249869],
Cell[10915, 285, 1490, 43, 70, "Notes",ExpressionUUID->"baf9892a-ff72-4f29-aa32-f2de3ced85c3",
 CellID->1067943069]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[12532, 334, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"7a28d317-6d45-45d1-81cb-9b071d9a4209",
 CellTags->"PrimaryExamplesSection",
 CellID->408351631],
Cell[CellGroupData[{
Cell[13947, 375, 1368, 36, 31, "ExampleSection",ExpressionUUID->"6a03e301-15d5-4819-a50c-0db3607afcf3",
 CellID->1955610052],
Cell[15318, 413, 182, 3, 29, "Input",ExpressionUUID->"e9eb5604-f7c2-4cc1-8574-9a83379a2c6d",
 CellID->40423541],
Cell[15503, 418, 169, 3, 38, "ExampleText",ExpressionUUID->"fe4058e9-ced2-489b-9102-8c4785f797d8",
 CellID->135693201],
Cell[CellGroupData[{
Cell[15697, 425, 275, 7, 29, "Input",ExpressionUUID->"01ca6141-8ec9-466d-ac4a-1e1b8c3d849d",
 CellID->90393259],
Cell[15975, 434, 250, 6, 37, "Output",ExpressionUUID->"6a436bca-2abe-48ab-985d-637f29ec6bb9",
 CellID->1347333078]
}, Open  ]],
Cell[CellGroupData[{
Cell[16262, 445, 163, 3, 29, "Input",ExpressionUUID->"e1ba409f-730f-400c-a2e9-76c410bedc98",
 CellID->71264253],
Cell[16428, 450, 528, 16, 40, "Output",ExpressionUUID->"db3289c6-c7ae-4675-b149-8048f259b89b",
 CellID->1559467978]
}, Open  ]],
Cell[CellGroupData[{
Cell[16993, 471, 242, 5, 14, "ExampleDelimiter",ExpressionUUID->"056805e4-ed16-48fc-b72b-db7f6d260b52",
 CellID->719744508],
Cell[17238, 478, 160, 2, 38, "ExampleText",ExpressionUUID->"522f05e5-5dd1-498e-b491-fab145525ef0",
 CellID->453682541],
Cell[CellGroupData[{
Cell[17423, 484, 455, 12, 29, "Input",ExpressionUUID->"3cb584d9-f4f6-400e-add0-4a334c480071",
 CellID->1002736892],
Cell[17881, 498, 798, 21, 55, "Output",ExpressionUUID->"179e43ab-67a7-46af-848e-d6823c610a46",
 CellID->2087878258]
}, Open  ]],
Cell[CellGroupData[{
Cell[18716, 524, 164, 3, 29, "Input",ExpressionUUID->"69bc1485-589a-47b6-827d-f6804f2ddbc9",
 CellID->115787309],
Cell[18883, 529, 3864, 124, 78, "Output",ExpressionUUID->"51ee61d4-a324-4192-b50d-a2d17ba44a5a",
 CellID->1087090226]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22796, 659, 242, 5, 14, "ExampleDelimiter",ExpressionUUID->"bb168146-36e4-41ec-ad57-09f0d51baed3",
 CellID->422283026],
Cell[23041, 666, 168, 3, 38, "ExampleText",ExpressionUUID->"091f5b62-64da-4e6d-be2c-6e8ea3e1ae7b",
 CellID->27102674],
Cell[CellGroupData[{
Cell[23234, 673, 416, 11, 29, "Input",ExpressionUUID->"8741e1d3-f4c3-4a2b-abed-2672d54fb384",
 CellID->53916052],
Cell[23653, 686, 1342, 37, 84, "Output",ExpressionUUID->"9e02933b-bbe0-4aca-8381-7e4572cc6448",
 CellID->2082043353]
}, Open  ]],
Cell[CellGroupData[{
Cell[25032, 728, 163, 3, 70, "Input",ExpressionUUID->"7c3ec0a8-09af-41af-b1ef-e20ec26f877b",
 CellID->89018852],
Cell[25198, 733, 3931, 125, 78, "Output",ExpressionUUID->"06282d98-939b-4c07-8030-979efd5feab0",
 CellID->1804089653]
}, Open  ]]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]],
Cell[CellGroupData[{
Cell[29290, 867, 1395, 36, 70, "ExampleSection",ExpressionUUID->"6b4ea8e1-f02d-4928-abaf-d50e29ad7dd4",
 CellID->253621532],
Cell[CellGroupData[{
Cell[30710, 907, 1412, 36, 70, "ExampleSubsection",ExpressionUUID->"f5514f9b-d1c0-4983-8fc7-86d78a82deb3",
 CellID->435889856],
Cell[32125, 945, 184, 3, 70, "Input",ExpressionUUID->"e24955e4-4773-4283-9f68-50dd6291accf",
 CellID->1271543587],
Cell[32312, 950, 586, 17, 70, "ExampleText",ExpressionUUID->"26624264-a78a-447a-a7c6-0bcf1cf402f0",
 CellID->1223295412],
Cell[CellGroupData[{
Cell[32923, 971, 497, 13, 70, "Input",ExpressionUUID->"6360e5bf-46cf-4057-9695-abe538286883",
 CellID->1984201695],
Cell[33423, 986, 1017, 35, 40, "Output",ExpressionUUID->"12ff7166-525f-49be-89ee-a646f57e1d85",
 CellID->673169276]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "0"}, Closed]]]],
Cell[CellGroupData[{
Cell[34592, 1029, 1419, 36, 70, "ExampleSubsection",ExpressionUUID->"a3d70b97-92d3-4ff2-a932-a4a90d1ba9ff",
 CellID->124303609],
Cell[36014, 1067, 182, 3, 70, "Input",ExpressionUUID->"9cec5710-ae8a-455b-8459-7a7aaf92bb9c",
 CellID->23655700],
Cell[36199, 1072, 174, 3, 70, "ExampleText",ExpressionUUID->"e182b721-4352-466a-8100-729f8ad34b9d",
 CellID->131826769],
Cell[CellGroupData[{
Cell[36398, 1079, 281, 7, 70, "Input",ExpressionUUID->"40037395-dd59-4e06-bccb-04f07c46f277",
 CellID->141331294],
Cell[36682, 1088, 618, 17, 37, "Output",ExpressionUUID->"df037d61-0699-433d-9ebb-a6f2c4cf2686",
 CellID->1013185978]
}, Open  ]],
Cell[CellGroupData[{
Cell[37337, 1110, 241, 5, 70, "Input",ExpressionUUID->"8a2b0d2a-2fbd-40ba-ba57-c9feee889e27",
 CellID->675428486],
Cell[37581, 1117, 2474, 83, 59, "Output",ExpressionUUID->"75cf97a6-36b2-4082-a1a5-0d90a6d9c3bc",
 CellID->1218895183]
}, Open  ]],
Cell[40070, 1203, 145, 1, 70, "ExampleText",ExpressionUUID->"38a7183f-da87-4974-98f9-ceedc507a88e",
 CellID->276259480],
Cell[CellGroupData[{
Cell[40240, 1208, 249, 6, 70, "Input",ExpressionUUID->"a8c18439-39ed-42b5-89df-d50d6884441e",
 CellID->395829546],
Cell[40492, 1216, 2231, 73, 59, "Output",ExpressionUUID->"6d91df0e-f86b-4b4e-ad57-b70425ce8655",
 CellID->1124831948]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "1"}, Closed]]]],
Cell[CellGroupData[{
Cell[42875, 1297, 1404, 36, 70, "ExampleSubsection",ExpressionUUID->"6d35071e-b1d9-4cf1-a32c-5578cef52a86",
 CellID->239804243],
Cell[44282, 1335, 183, 3, 70, "Input",ExpressionUUID->"3e8b516b-a084-47a8-a8b7-4ea8d9df7625",
 CellID->330352135],
Cell[44468, 1340, 159, 2, 70, "ExampleText",ExpressionUUID->"eea2c68f-c482-44c0-bc1e-75360e1eff13",
 CellID->11034410],
Cell[CellGroupData[{
Cell[44652, 1346, 367, 9, 70, "Input",ExpressionUUID->"dcbab747-2536-4233-b653-c08110f89392",
 CellID->731005036],
Cell[45022, 1357, 2311, 73, 59, "Output",ExpressionUUID->"1c44b88a-ee0e-4077-a0d0-33d1483f2a0e",
 CellID->752005495]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "2"}, Closed]]]],
Cell[CellGroupData[{
Cell[47485, 1438, 1404, 36, 70, "ExampleSubsection",ExpressionUUID->"50392b53-b89f-4b1f-90fe-34abfaa30265",
 CellID->33314988],
Cell[48892, 1476, 183, 3, 70, "Input",ExpressionUUID->"829d3541-2c43-4496-92c8-0aa67eab749b",
 CellID->307732332],
Cell[49078, 1481, 144, 1, 70, "ExampleText",ExpressionUUID->"c90c2106-a144-4b13-bd36-44b0b4232a05",
 CellID->916681948],
Cell[CellGroupData[{
Cell[49247, 1486, 388, 10, 70, "Input",ExpressionUUID->"a8a1a38b-17ef-4b15-ad75-3ccac753e509",
 CellID->247747826],
Cell[49638, 1498, 2149, 73, 59, "Output",ExpressionUUID->"8a682588-28d5-4e7b-9f8c-edc76f1bda25",
 CellID->416636273]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "3"}, Closed]]]],
Cell[CellGroupData[{
Cell[51939, 1579, 1414, 36, 70, "ExampleSubsection",ExpressionUUID->"31a83b93-e619-4d7f-9353-aa87f08616ff",
 CellID->934089875],
Cell[53356, 1617, 183, 3, 70, "Input",ExpressionUUID->"27db42ce-fef2-4025-9585-a7c25bef245e",
 CellID->311015445],
Cell[53542, 1622, 580, 16, 70, "ExampleText",ExpressionUUID->"60950630-c4de-4a2e-a93e-f8eb64b406d4",
 CellID->261387317],
Cell[CellGroupData[{
Cell[54147, 1642, 499, 13, 70, "Input",ExpressionUUID->"b2f5ee1d-e0b9-4bd5-979b-d78502b91d73",
 CellID->1532578704],
Cell[54649, 1657, 1266, 43, 40, "Output",ExpressionUUID->"f1520bb1-b972-46d5-ab63-ba50325da47e",
 CellID->47815046]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "4"}, Closed]]]],
Cell[CellGroupData[{
Cell[56067, 1708, 1411, 36, 70, "ExampleSubsection",ExpressionUUID->"b7a1ca97-847a-4065-8961-be22d3738a18",
 CellID->302951700],
Cell[57481, 1746, 183, 3, 70, "Input",ExpressionUUID->"6616f136-c961-4825-a124-5c0f3c531678",
 CellID->689187939],
Cell[57667, 1751, 130, 1, 70, "ExampleText",ExpressionUUID->"405c13a0-9b0c-4d64-8baa-47ae13b515ea",
 CellID->173529821],
Cell[CellGroupData[{
Cell[57822, 1756, 368, 9, 70, "Input",ExpressionUUID->"064550e1-a087-4769-8e20-c969c1e40d8f",
 CellID->173556418],
Cell[58193, 1767, 1811, 64, 40, "Output",ExpressionUUID->"dd9ab6e7-44c0-49f9-802f-b36cf2a50103",
 CellID->1015091870]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "5"}, Closed]]]],
Cell[CellGroupData[{
Cell[60156, 1839, 1408, 36, 70, "ExampleSubsection",ExpressionUUID->"def93339-3ac6-4f81-b26c-16c0d1ac9bac",
 CellID->51745731],
Cell[61567, 1877, 184, 3, 70, "Input",ExpressionUUID->"b1378793-08d9-463e-ad16-08cb19c5f42c",
 CellID->1289603855],
Cell[61754, 1882, 129, 1, 70, "ExampleText",ExpressionUUID->"577ade43-e7e5-42b2-9079-07f6e810079b",
 CellID->1967025461],
Cell[CellGroupData[{
Cell[61908, 1887, 362, 9, 70, "Input",ExpressionUUID->"bcc6830f-004c-43a1-b206-88c4c5c91222",
 CellID->952170122],
Cell[62273, 1898, 2132, 73, 59, "Output",ExpressionUUID->"a51e4ccc-09cf-4a8c-9673-5ea7828d37ca",
 CellID->1144085164]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "6"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[64762, 1983, 1407, 37, 70, "SeeAlsoSection",ExpressionUUID->"3f52b0f3-b78f-4995-b695-adc6a4ab84d0"],
Cell[66172, 2022, 744, 19, 70, "TutorialsSection",ExpressionUUID->"b339d28d-fbb3-4a2f-a758-2213ba6a20a2"],
Cell[66919, 2043, 753, 19, 70, "MoreAboutSection",ExpressionUUID->"b67fea9f-9e92-40a7-a4c4-afe546d887e2"],
Cell[67675, 2064, 78, 0, 70, "FooterCell",ExpressionUUID->"0eb05a02-2f3a-46f9-b7b9-1701f3afe222"]
}
]
*)

(* End of internal cache information *)

