(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    109830,       3083]
NotebookOptionsPosition[     95849,       2809]
NotebookOutlinePosition[     98252,       2868]
CellTagsIndexPosition[     98166,       2863]
WindowTitle->DensityMatrix
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "bcc6ffbc-0797-4dad-9eea-bc1d2f9e2e69"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "abaef070-c722-4c33-9f5c-e0e89e2661f7"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "36f572ec-9cad-4d90-8d82-e0ed59305c04"]
         }],ExpressionUUID->"117a3ba4-5087-4fb6-87e1-fedccb79ef6b"],
         StripOnInput->False], {"\<\"DMVariables\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/DMVariables"], "\<\"Ket\"\>":>
        Documentation`HelpLookup["paclet:AtomicDensityMatrix/ref/Ket"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "05bd638b-c953-4175-8b8b-ff062f03efef"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "38515df2-d076-4651-8143-73fdca71e3e9"]
         }],ExpressionUUID->"27a80cb9-351d-48ab-bca0-37e158f5db68"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "6d196926-8fc6-49c0-b88f-c7af9e6ddd23"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "fd1e93ab-4044-4c07-8c0f-710cef258eaa"]
         }],ExpressionUUID->"8a4dc145-8c3a-4467-852d-e165d0d46c10"],
         StripOnInput->
          False], {"\<\"The Density Matrix and the Liouville Equation\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/\
TheDensityMatrixAndTheLiouvilleEquation"], "\<\"Displaying the Density Matrix\
\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix"], \
"\<\"Visualizing Polarization Moments and Quantum Beats\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/\
VisualizingPolarizationMomentsAndQuantumBeats"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"Tutorials"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "dca07b66-a064-445b-a59e-2a42003bd264"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "f0abfe8c-8ac0-4b20-82fc-ede3720d2aa6"]
         }],ExpressionUUID->"c6a55c28-e0f1-4359-b0a5-66cee3cf16c0"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/ref/DensityMatrix\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/DensityMatrix"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/DensityMatrix.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$38191], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/DensityMatrix" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "8067f664-4bf2-4e10-a21e-32c26536eff1"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "d22417fe-a84e-4d43-9158-63715045950f"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"a079393a-19ba-454f-9dc3-16d143cb4e4e"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"daeb85e4-c592-469b-bfe4-606686cefc67"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "DensityMatrix", "ObjectName",ExpressionUUID->
      "e9318041-6a20-4a1a-a8e3-510373c68b97"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"055d045c-3c32-443d-8c29-5183da5db4ed"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "6711597a-c3bc-4e20-b22a-73ca9dbbc0db"]
    }],ExpressionUUID->"ee81d7cc-629d-4366-8163-55671cf75430"], 
    "\[SpanFromLeft]"}
  }]], "ObjectNameGrid",ExpressionUUID->"f5224fdf-c444-42cb-af8f-\
dd8aea7b4d6b"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       TemplateBox[{
         Cell[
          TextData["DensityMatrix"]], 
         "paclet:AtomicDensityMatrix/ref/DensityMatrix", 
         "AtomicDensityMatrix Package Symbol"},
        "PackageLink",
        BaseStyle->"InlineFormula"], "[", 
       StyleBox["sys", "TI"], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "71f90f5c-9516-4ca4-971a-6198bd2db3b4"],
     "\[LineSeparator]forms the density matrix for an atomic system (list of ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["AtomicState"]], 
        "paclet:AtomicDensityMatrix/ref/AtomicState", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "cd00aa21-cdac-4c86-854a-14ca35d90af4"],
     " objects) ",
     Cell[BoxData[
      StyleBox["sys", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "5711dd66-0cd2-4714-8ff2-88686cce9cf6"],
     "."
    }],ExpressionUUID->"6a195bdc-529d-4b76-861c-a958dc5217dd"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"727b5c2f-445f-47eb-a759-069ad9040ab1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"430c5f02-b387-44a5-92c1-29f6f8f0ee82"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"ca33cc3d-d9ae-4fc7-9be3-35e94b03c6be"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"e66d1186-50f3-431e-b488-4ef0a399d61d"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"9815a6c4-cc78-49ad-a890-bbec73f00152"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->1435535600,ExpressionUUID->"eebff1b4-de79-40b3-94a5-a7303305658e"],

Cell["The following options can be given:", "Notes",
 CellID->1067943069,ExpressionUUID->"96d97947-4fb9-4a8b-8b7e-4324673b156f"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "41dda9fc-db4a-4c27-ad6f-846105ff7111"], 
    TemplateBox[{
      Cell[
       TextData["AllowedElements"]], 
      "paclet:AtomicDensityMatrix/ref/AllowedElements", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"3ColumnTableMod"], 
    TemplateBox[{
      Cell[
       TextData["All"]], "paclet:ref/All"},
     "RefLink",
     BaseStyle->{"3ColumnTableMod"}], Cell[TextData[Cell[
    "density-matrix elements that are allowed to be nonzero", "TableText",
     ExpressionUUID->"09b13cd3-f31d-4acb-be91-ff82b4b6e1ae"]], "TableText",
     ExpressionUUID->"af1893ce-e327-49d1-b950-7cc080a04cf3"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "09d48f06-5a2d-4d75-a599-6c153578bc74"], 
    TemplateBox[{
      Cell[
       TextData["ComplexExpandVariables"]], 
      "paclet:AtomicDensityMatrix/ref/ComplexExpandVariables", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"3ColumnTableMod"], 
    TemplateBox[{
      Cell[
       TextData["False"]], "paclet:ref/False"},
     "RefLink",
     BaseStyle->{"3ColumnTableMod"}], Cell["\<\
whether to express density-matrix elements in terms of real and imaginary \
parts\
\>", "TableText",ExpressionUUID->"4582f6fb-2809-4cc8-840a-c09c06779184"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "d2a72335-2ca4-49a4-8fdb-56c0388680c3"], 
    TemplateBox[{
      Cell[
       TextData["DMLabel"]], "paclet:ref/DMLabel"},
     "RefLink",
     BaseStyle->{"3ColumnTableMod"}], 
    TemplateBox[{
      Cell[
       TextData["None"]], "paclet:ref/None"},
     "RefLink",
     BaseStyle->{"3ColumnTableMod"}], Cell[
    "additional label for density-matrix elements", "TableText",
     ExpressionUUID->"5a05c303-0013-4d07-898e-321d51d777af"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "73507488-7625-4d6b-9d82-73a41dd398ef"], 
    TemplateBox[{
      Cell[
       TextData["DMSymbol"]], "paclet:AtomicDensityMatrix/ref/DMSymbol", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"3ColumnTableMod"], "\[Rho]", Cell[
    "symbol to use for density-matrix elements", "TableText",ExpressionUUID->
     "b7d238d8-bea1-40a5-aeec-6d98bb82bc3b"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "503cc0e4-b5d4-4837-8a0c-4139cac16fc2"], 
    TemplateBox[{
      Cell[
       TextData["NeglectedElements"]], 
      "paclet:AtomicDensityMatrix/ref/NeglectedElements", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"3ColumnTableMod"], 
    TemplateBox[{
      Cell[
       TextData["None"]], "paclet:ref/None"},
     "RefLink",
     BaseStyle->{"3ColumnTableMod"}], Cell[TextData[Cell[
    "density-matrix elements that are required to be zero", "TableText",
     ExpressionUUID->"9d539f1a-d7da-4626-a6bc-bb6521ce3fc1"]], "TableText",
     ExpressionUUID->"7bb87fa6-016f-49d4-b94b-13637509f3d8"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "b8aa305e-9fe1-426b-90c9-b46df160b5f9"], 
    TemplateBox[{
      Cell[
       TextData["Representation"]], 
      "paclet:AtomicDensityMatrix/ref/Representation", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"3ColumnTableMod"], 
    TemplateBox[{
      Cell[
       TextData["\"Zeeman\""]], "paclet:AtomicDensityMatrix/ref/Zeeman", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"3ColumnTableMod"], Cell[
    "Zeeman or polarization-moment representation", "TableText",
     ExpressionUUID->"d8a87afc-2ba0-41e9-bebe-b77139cf29f4"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "a90b70aa-35cc-4da4-9491-2d169e88c255"], 
    TemplateBox[{
      Cell[
       TextData["TimeDependence"]], 
      "paclet:AtomicDensityMatrix/ref/TimeDependence", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"3ColumnTableMod"], 
    TemplateBox[{
      Cell[
       TextData["True"]], "paclet:ref/True"},
     "RefLink",
     BaseStyle->{"3ColumnTableMod"}], Cell["\<\
whether density-matrix elements should have explicit time dependence\
\>", "TableText",ExpressionUUID->"e5120539-c723-472b-8dbb-aa3d6291c93a"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "7f3d66ec-bb80-4e61-a38b-609af411b0b6"], 
    TemplateBox[{
      Cell[
       TextData["TimeVariable"]], 
      "paclet:AtomicDensityMatrix/ref/TimeVariable", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"3ColumnTableMod"], 
    TemplateBox[{
      Cell[
       TextData["t"]], "paclet:AtomicDensityMatrix/ref/t", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"3ColumnTableMod"], Cell[
    "symbol to use for time variable", "TableText",ExpressionUUID->
     "4ce28e8d-d3fd-4f06-9c64-2da792ec63ec"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, 
   "Rows" -> {None, None, None, None, None, None, None, {None}}},
 GridBoxDividers->{
  "Rows" -> {{True, True, True, True, True, True, True, True, True}}}},
 CellID->264018771,ExpressionUUID->"2ce7524e-fc35-44dc-8ff2-480bd1671e7e"],

Cell[TextData[{
 "Possible values for the ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["Representation"]], 
    "paclet:AtomicDensityMatrix/ref/Representation", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "07ed026b-c71a-4c87-845b-03c5f19194f9"],
 " option include ",
 Cell[BoxData["\"\<Zeeman\>\""], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "95a51200-4c8f-4316-859d-8c665ef36432"],
 " and ",
 Cell[BoxData["\"\<PolarizationMoments\>\""], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "d533123c-f0bb-4468-ad63-06c61ddc86c2"],
 "."
}], "Notes",
 CellID->539936808,ExpressionUUID->"c123e603-740f-42ad-9655-a1443595e6b1"],

Cell[TextData[{
 "Possible values for the ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["ComplexExpandVariables"]], 
    "paclet:AtomicDensityMatrix/ref/ComplexExpandVariables", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "267f05ea-97be-4353-8ed2-52d3a70cdafc"],
 " option are ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["True"]], "paclet:ref/True"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "5ebce555-fa71-47c9-bb1e-6733a450fe40"],
 ", ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["False"]], "paclet:ref/False"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "ae26d84a-9dbb-4876-82e7-39dffeb95b3a"],
 ", and ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["Subscript"]], "paclet:ref/Subscript"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "58d63418-6c4b-4bbe-bbc8-352e28602ef0"],
 ", meaning real and imaginary parts are indicated in a subscript."
}], "Notes",
 CellID->1112017354,ExpressionUUID->"fdf2b84f-b33c-4973-8a3c-6be92816b4e0"],

Cell[TextData[{
 "Density-matrix elements are set to zero if they are specified by the ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["NeglectedElements"]], 
    "paclet:AtomicDensityMatrix/ref/NeglectedElements", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "a67c93b2-5b69-4d6f-bada-bf183e376ca4"],
 " option or if they are not specified by the ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["AllowedElements"]], 
    "paclet:AtomicDensityMatrix/ref/AllowedElements", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "1ca97ba1-b169-4e79-8847-6d0f0609615b"],
 " option."
}], "Notes",
 CellID->1301036698,ExpressionUUID->"a42ae5b5-1571-46bd-ba54-00a77d0a3515"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "f3e551db-f844-4584-825f-abaeb694a06f"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"da0d3d8f-0f83-4392-a780-b13b17cc36a7"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(11)", "ExampleCount",ExpressionUUID->
  "fb47263b-b2cb-467a-b890-44b230e04a3a"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->68055155,ExpressionUUID->"829c6162-a5d0-43d0-b530-039e68740c95"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "8206f644-6464-4412-b7cd-a54d70df0c04"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"b1abd81f-ac9b-4d45-815b-390f5fe97839"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount",ExpressionUUID->
  "86bffe53-4d6c-404a-be2f-bfd26f5d1656"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->1341689881,ExpressionUUID->"28c2dcdd-f813-4d03-b5d6-8b62b1d1b941"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->79203784,ExpressionUUID->"2f9c6a02-b589-4757-8ad6-cb874a0d85c2"],

Cell["Density matrix for a system with no angular momentum:", "ExampleText",
 CellID->282740562,ExpressionUUID->"3d390fb9-9c7e-4f2e-a97f-f541328a7175"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", "1", "]"}], ",", 
    RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->313233494,ExpressionUUID->"01b04aa5-ded8-4df7-9314-a59a77ed2037"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", "1", "]"}], ",", 
   RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1881837238,ExpressionUUID->"8376264d-58ac-4853-abed-87932d361ab9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", "sys", "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->39827372,ExpressionUUID->"c79aa728-7c87-474f-a3b9-4b6a41207a10"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"1", ",", "1"}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"1", ",", "2"}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"2", ",", "1"}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"2", ",", "2"}]], "[", "t", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[3]//MatrixForm=",
 CellID->1178124118,ExpressionUUID->"da46e925-e237-4455-9360-8d190d419d4a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[
  "\t", "ExampleDelimiter",ExpressionUUID->
   "b135b5d0-741e-4df0-8ac7-40cbf47d55af"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->176211259,ExpressionUUID->"4078585d-ff47-46ef-b3ea-14b545c72eac"],

Cell["Density matrix for a system with Zeeman structure:", "ExampleText",
 CellID->343098914,ExpressionUUID->"e95fcdb6-411e-442a-b5e7-6c206ee1d2b2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"\"\<a\>\"", ",", 
       RowBox[{"J", "\[Rule]", "0"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"\"\<b\>\"", ",", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->932950030,ExpressionUUID->"67e268e7-11a9-4c27-aca6-d60afcaf228e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"a\"\>", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"b\"\>", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"b\"\>", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"b\"\>", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[1]=",
 CellID->1714991093,ExpressionUUID->"707f0667-45b2-402e-9730-a97c40e9c0ee"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", "sys", "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->104442822,ExpressionUUID->"c2d1568f-b9e4-47f4-8f6d-f79b2be8b458"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"a\"\>", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"a\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"a\"\>", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"a\"\>", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"a\"\>", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"a\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"a\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"a\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[2]//MatrixForm=",
 CellID->329790017,ExpressionUUID->"1b3c2b36-c245-4cd9-8dfe-a111926da2af"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[
  "\t", "ExampleDelimiter",ExpressionUUID->
   "475001c6-fca1-47eb-9f60-a38a0a68b95d"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->133916380,ExpressionUUID->"2b9f13fe-aef8-4d1b-8e84-6482205123ca"],

Cell["Density matrix for a system with hyperfine structure:", "ExampleText",
 CellID->396876126,ExpressionUUID->"e93e6070-bbee-458c-84de-38e9fae7d6c0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", 
       RowBox[{"1", "/", "2"}]}], ",", 
      RowBox[{"NuclearSpin", "\[Rule]", 
       RowBox[{"1", "/", "2"}]}]}], "]"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->282938609,ExpressionUUID->"636281a5-de0a-4f80-82c3-d36a2a183c43"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[1]=",
 CellID->125522812,ExpressionUUID->"92ac43c8-9a40-406c-ba51-2e1c81cb07fc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", "sys", "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->22237377,ExpressionUUID->"1af22be2-f6b7-4655-889f-72d376b87b91"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]], "[", "t", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[2]//MatrixForm=",
 CellID->832959930,ExpressionUUID->"c2fd946f-908f-40ac-b4cc-9d4009fdea42"]
}, Open  ]]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"dd3d266a-1b6d-448a-a3f0-6ba797f73bfd"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"8736a0ce-23cd-40ce-baa3-d738ed4a5e8f"],
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(8)", "ExampleCount",ExpressionUUID->
  "703bb513-6bda-4e81-b232-60ba0fca44e5"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->1848392594,ExpressionUUID->"adef2b90-85fe-4426-afd1-db6e7e82fe41"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "0"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"9694d65c-0cba-4f85-8cbd-97083fce52bd"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"126d175e-8aa7-4196-839f-7402f87c329d"],
 "AllowedElements",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "f9c7bb77-d020-487a-8376-d9813b082292"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->435889856,ExpressionUUID->"089cb4df-4817-4ffb-b3a6-f571efbb95cf"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1271543587,ExpressionUUID->"a46c02b2-65bd-4d6f-aeeb-f0f521bb5977"],

Cell[TextData[{
 "Write a density matrix allowing only matrix elements between states with ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "0"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "5eeda499-382d-448c-8321-c20bf248ff48"],
 StyleBox[" and ",
  Deletable->True],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"|", " ", "M", "|"}], "=", "1"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"abf84bbb-b3fd-480c-9f80-08a68e0c4982"],
 StyleBox[":",
  Deletable->True]
}], "ExampleText",
 CellID->1223295412,ExpressionUUID->"3876a294-20cd-47ea-bad6-5ee489318b9f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", 
   RowBox[{
    RowBox[{"Sublevels", "@", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", " ", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
    RowBox[{"AllowedElements", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"Abs", "[", "M", "]"}], "\[Equal]", "1"}], "\[Rule]", 
      RowBox[{"M", "\[Equal]", "0"}]}]}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1984201695,ExpressionUUID->"4dd33f16-773e-42cd-b755-1d7726f7ec9e"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], "0"},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], "0", 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]},
     {"0", 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[2]//MatrixForm=",
 CellID->23797547,ExpressionUUID->"2ff390ad-db5c-4f8b-a80e-d096144cb815"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "0"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "1"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"b68a283f-8cd1-4847-848c-d0895ff3cca4"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"6ec21534-b0e7-4667-9d6f-bfc2f8c0c0f2"],
 "ComplexExpandVariables",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "525b6c7d-b341-4c9e-aa8d-66d97d1db7c6"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->726865425,ExpressionUUID->"3f2a4eb9-1c25-4a0f-80a6-23af4b075de2"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->220702645,ExpressionUUID->"298dbaa5-52ac-4aef-ad08-caa4088c7b0d"],

Cell["Write density matrix in terms of real and imaginary parts:", \
"ExampleText",
 CellID->226270345,ExpressionUUID->"7cfd7c30-e7e5-4b8a-8dad-291304aa2b51"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "@", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", " ", 
     RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->204344010,ExpressionUUID->"7283436b-1773-4368-90c7-3e18aaa57c16"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->111648717,ExpressionUUID->"cae8c80f-5365-4656-ae37-f2fef5fe9b59"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", 
   RowBox[{"sys", ",", 
    RowBox[{"ComplexExpandVariables", "\[Rule]", "True"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->248152200,ExpressionUUID->"9f96b98e-fb53-4ea3-b6fa-e35c4785a121"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Re", "[", 
       RowBox[{
        SubscriptBox["\[Rho]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], "]"}], 
      RowBox[{
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"Im", "[", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}]}], "+", 
       RowBox[{"Re", "[", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}]}], 
      RowBox[{
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"Im", "[", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}]}], "+", 
       RowBox[{"Re", "[", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}]}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", 
        RowBox[{"Im", "[", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}]}], "+", 
       RowBox[{"Re", "[", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}]}], 
      RowBox[{"Re", "[", 
       RowBox[{
        SubscriptBox["\[Rho]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}], 
      RowBox[{
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"Im", "[", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}]}], "+", 
       RowBox[{"Re", "[", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}]}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", 
        RowBox[{"Im", "[", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}]}], "+", 
       RowBox[{"Re", "[", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}]}], 
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", 
        RowBox[{"Im", "[", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}]}], "+", 
       RowBox[{"Re", "[", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}]}], 
      RowBox[{"Re", "[", 
       RowBox[{
        SubscriptBox["\[Rho]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}], "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[3]//MatrixForm=",
 CellID->1726762788,ExpressionUUID->"db56bee5-e5ca-4a96-bb22-585385e20c2c"]
}, Open  ]],

Cell["Indicate real and imaginary parts using subscript labels:", \
"ExampleText",
 CellID->12223885,ExpressionUUID->"51d0bc82-1424-4ec0-9966-ceb85e6fab17"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", 
   RowBox[{"sys", ",", 
    RowBox[{"ComplexExpandVariables", "\[Rule]", "Subscript"}]}], "]"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->213780995,ExpressionUUID->"f531ba92-883b-4b09-b9d1-303e65d8640c"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{"Im", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "+", 
       RowBox[{
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], 
      RowBox[{
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{"Im", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}], "+", 
       RowBox[{
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{"Im", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "+", 
       RowBox[{
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{"Im", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}], "+", 
       RowBox[{
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{"Im", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}], "+", 
       RowBox[{
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}], 
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{"Im", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}], "+", 
       RowBox[{
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[4]//MatrixForm=",
 CellID->608172358,ExpressionUUID->"859949f7-dd24-4497-b9ed-7baf78ac5411"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "1"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "2"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"83f395b3-a3e3-4738-ba36-d85b795cc004"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"fdf90e7d-1aab-4085-9474-cc6ba68942ec"],
 "DMLabel",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "bf8e029b-5f78-49aa-a7ca-1456a3b8134f"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->722695695,ExpressionUUID->"7e5dfbdd-d69d-4dd5-98a8-a0e3d14e9a23"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->57942322,ExpressionUUID->"a104beb5-4c54-4245-a781-b5909e6bd91c"],

Cell["Label the density matrix elements:", "ExampleText",
 CellID->158245489,ExpressionUUID->"88eb52fd-d324-497c-a98b-16307272d1c8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", 
   RowBox[{
    RowBox[{"Sublevels", "@", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", " ", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
    RowBox[{"DMLabel", "\[Rule]", "\"\<a\>\""}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->71521896,ExpressionUUID->"b045215f-99a9-41f5-be2a-f60058d6e18d"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[2]//MatrixForm=",
 CellID->1678144833,ExpressionUUID->"b7998572-3d86-4fe0-ac2e-dba39c8f680c"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "2"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "3"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"43a99212-0156-466c-98d1-573c8ecade27"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"64a5e6db-e281-475a-9483-a300a3db54c7"],
 "DMSymbol",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "5f1d6ff1-473f-4a56-abf5-864c2c88a6ff"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->33314988,ExpressionUUID->"5179c39b-3233-40c9-9479-841369d0a291"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->307732332,ExpressionUUID->"503114c1-62c4-4f41-b201-a8ff3dbbff53"],

Cell["Use a different symbol for the density matrix:", "ExampleText",
 CellID->916681948,ExpressionUUID->"bb62086e-99e2-4eb8-964b-a01e9a83e116"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", 
   RowBox[{
    RowBox[{"Sublevels", "@", 
     RowBox[{"{", 
      RowBox[{"AtomicState", "[", 
       RowBox[{"1", ",", 
        RowBox[{"J", "\[Rule]", "1"}]}], "]"}], "}"}]}], ",", 
    RowBox[{"DMSymbol", "\[Rule]", "\[Sigma]"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->247747826,ExpressionUUID->"ca8f6628-f686-4881-bded-759da3f80aab"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["\[Sigma]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Sigma]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Sigma]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Sigma]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Sigma]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Sigma]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Sigma]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Sigma]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Sigma]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[2]//MatrixForm=",
 CellID->116957040,ExpressionUUID->"3da29d63-8678-40eb-a1b5-c7faaf7009ad"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "3"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "4"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"394804cf-bb8b-47f8-88a2-8d240138971e"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"4cc2e610-7ade-43e1-a103-e94481ec66e3"],
 "NeglectedElements",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "3f118d1e-0972-41db-a98c-569599749f85"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->934089875,ExpressionUUID->"47de8c8e-a96f-4da5-b88e-8bfb7f64d6b7"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->311015445,ExpressionUUID->"18a1c623-1865-4970-988d-ee59fbea9a53"],

Cell[TextData[{
 "Write a density matrix neglecting the matrix elements between states with \
",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "0"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "86b77fb6-e983-469d-ba0b-67887b28733d"],
 StyleBox[" and ",
  Deletable->True],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"|", " ", "M", "|"}], "=", "1"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"357c6d25-6772-43f1-a8e8-a5a404e6e7c2"],
 StyleBox[":",
  Deletable->True]
}], "ExampleText",
 CellID->261387317,ExpressionUUID->"4a7f7cbf-2833-44ad-8f51-bf20e3da9557"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", 
   RowBox[{
    RowBox[{"Sublevels", "@", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", " ", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
    RowBox[{"NeglectedElements", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"Abs", "[", "M", "]"}], "\[Equal]", "1"}], "\[Rule]", 
      RowBox[{"M", "\[Equal]", "0"}]}]}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1532578704,ExpressionUUID->"b9157d13-6fa6-44cb-977e-e162c7f2632e"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], "0", 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]},
     {"0", 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}], "0"},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}], "0", 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[2]//MatrixForm=",
 CellID->832177138,ExpressionUUID->"0ab9d5e3-b1c4-46ef-adb1-bb0728214f1d"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "4"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "5"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"fc320fff-8d15-400a-a732-3564ca482235"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"60b6e841-4cb1-4861-91a3-f77615e5204c"],
 "Representation",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "3b456efa-69bc-4f86-b975-a7971fd5a4ce"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->417470545,ExpressionUUID->"0263c7e2-1903-4e04-9d74-6e9148b7f67f"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->282498195,ExpressionUUID->"e3500129-6508-46a9-a3a4-02b958760e27"],

Cell["\<\
Write the density matrix in the polarization-moment representation:\
\>", "ExampleText",
 CellID->2008303495,ExpressionUUID->"05b39ebc-e48d-4265-aaa6-47695e9580b6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", 
   RowBox[{
    RowBox[{"Sublevels", "@", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", " ", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
    RowBox[{"Representation", "\[Rule]", "\"\<PolarizationMoments\>\""}]}], 
   "]"}], "//", "TensorForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->224080200,ExpressionUUID->"90959756-ba27-4eb0-929c-252276109ce2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"{", 
       RowBox[{
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {
             RowBox[{
              SubscriptBox["\[Rho]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}]}]], "[", "t", "]"}]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]], ",", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {
             RowBox[{
              SubscriptBox["\[Rho]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}]}]], "[", "t", "]"}]},
            {
             RowBox[{
              SubscriptBox["\[Rho]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0"}], "}"}]}]], "[", "t", "]"}]},
            {
             RowBox[{
              SubscriptBox["\[Rho]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", 
                  RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]], ",", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {
             RowBox[{
              SubscriptBox["\[Rho]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}]}]], "[", "t", "]"}]},
            {
             RowBox[{
              SubscriptBox["\[Rho]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "1"}], "}"}]}]], "[", "t", "]"}]},
            {
             RowBox[{
              SubscriptBox["\[Rho]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]},
            {
             RowBox[{
              SubscriptBox["\[Rho]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", 
                  RowBox[{"-", "1"}]}], "}"}]}]], "[", "t", "]"}]},
            {
             RowBox[{
              SubscriptBox["\[Rho]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", 
                  RowBox[{"-", "2"}]}], "}"}]}]], "[", "t", "]"}]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}], "}"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellLabel->"Out[2]//MatrixForm=",
 CellID->1124013171,ExpressionUUID->"dbd42ff2-bc1b-4c1d-bfd7-a1d825d02033"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "5"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "6"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"803fa285-44ed-45cd-89b2-7a090e54fc23"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"7d08b7ec-6043-4855-bc43-3e8d34d1b2d9"],
 "TimeDependence",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "6470c3c4-7f69-4547-a66e-21607b02ac79"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->841132874,ExpressionUUID->"5e7d455a-a777-46fe-969c-6d4848245b85"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->309288205,ExpressionUUID->"d2a5dab4-25ea-400f-b773-684dc2d82543"],

Cell["Remove explicit time dependence:", "ExampleText",
 CellID->137270048,ExpressionUUID->"7b94a491-7c1a-4043-ba46-9023c6eef2a1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", 
   RowBox[{
    RowBox[{"Sublevels", "@", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", " ", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
    RowBox[{"TimeDependence", "\[Rule]", "False"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->60846088,ExpressionUUID->"892438cb-0a18-4ab8-8d88-554005afe0b6"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SubscriptBox["\[Rho]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}]}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}]}]]},
     {
      SubscriptBox["\[Rho]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}]}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}]}]]},
     {
      SubscriptBox["\[Rho]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}]}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}]}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[2]//MatrixForm=",
 CellID->1677472180,ExpressionUUID->"198ee0ce-6818-4cc3-8e4e-20527339f69b"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "6"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "ExampleSubsection", "7"}, Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"83344d20-22ac-40ce-a0e1-d09cd0bdd3e7"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"fdb6b29c-5afc-44f7-bce3-6154a18cf49f"],
 "TimeVariable",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "bd38535d-5f22-4f77-b49f-462c0d32373e"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->51745731,ExpressionUUID->"21290758-12cf-43c9-8aa0-b315e9c2ee4d"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1289603855,ExpressionUUID->"ce55832f-cfc6-4535-960c-271aa0bd27e1"],

Cell["Use a different time variable:", "ExampleText",
 CellID->1967025461,ExpressionUUID->"1a763d31-7a74-4aa9-9f65-e53fe57262e8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", 
   RowBox[{
    RowBox[{"Sublevels", "@", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", " ", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
    RowBox[{"TimeVariable", "\[Rule]", "s"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->952170122,ExpressionUUID->"948e1d06-0bac-4dd5-bbfa-e94038989e69"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "s", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "s", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "s", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "s", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "s", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "s", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "s", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "s", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "s", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[2]//MatrixForm=",
 CellID->657240693,ExpressionUUID->"2e982344-a912-48f2-b40d-7f2e9fefc13b"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "7"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedFunction.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"See", " ", "Also"}], "SeeAlsoSection"]},
      {Cell[TextData[{
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["DMVariables"]], 
           "paclet:AtomicDensityMatrix/ref/DMVariables", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "743b4ada-1aa7-4110-8357-1e9d8d67cd04"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Ket"]], "paclet:AtomicDensityMatrix/ref/Ket", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "7c8daf2f-949b-49ad-953f-59c655d849d5"]
       }], "SeeAlso",ExpressionUUID->"57387fdb-b2fc-4806-bb13-45b8911a7282"]}
     }]}
  }]], "SeeAlsoSection",ExpressionUUID->"fabc0db2-315b-4126-92ec-\
b28491fd763c"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox["Tutorials", "TutorialsSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["The Density Matrix and the Liouville Equation"]], 
           "paclet:AtomicDensityMatrix/tutorial/\
TheDensityMatrixAndTheLiouvilleEquation"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "dbe9b8ce-b9a0-4062-a415-96eaea453aba"]}]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Displaying the Density Matrix"]], 
           "paclet:AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "d32f17b3-4afe-4acc-b629-f3dd49e550fc"]}]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Visualizing Polarization Moments and Quantum Beats"]], 
           "paclet:AtomicDensityMatrix/tutorial/\
VisualizingPolarizationMomentsAndQuantumBeats"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "6b92781f-74f4-4c50-bd05-5b35338a9a1f"]}]}
     }]}
  }]], "TutorialsSection",ExpressionUUID->"98c2b953-9dad-4329-bf8d-\
7aeb26de47e4"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "ae1c3345-d9a4-4c98-840f-7522b5cc55f4"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"b3ffa611-f1ed-4256-9e31-\
041ea79f67d4"],

Cell[" ", "FooterCell",ExpressionUUID->"fd13e82f-3157-4ab2-bf0c-7ed73702c02c"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DensityMatrix",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, 
    "ExampleSection" -> {"0" -> Open, "1" -> Closed}, "NotesSection" -> 
    Closed, "ExampleSubsection" -> {
     "0" -> Closed, "1" -> Closed, "2" -> Closed, "3" -> Closed, "4" -> 
      Closed, "5" -> Closed, "6" -> Closed, "7" -> Closed}}, "NewStyles" -> 
  True, "CitationPopupData" -> $Failed, "ShowCitation" -> False, 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 17, 59, 17.360618}", 
    "history" -> {"10.03", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "DensityMatrix[sys] forms the density matrix for an atomic system (list \
of AtomicState objects) sys.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "DensityMatrix", "titlemodifier" -> "", "metadescription" -> "", 
    "windowtitle" -> "DensityMatrix", "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/DensityMatrix"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"9ccc41db-867a-41ad-aa44-7c67b5d68f24"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[19774, 529, 1389, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"829c6162-a5d0-43d0-b530-039e68740c95",
   CellTags->"PrimaryExamplesSection",
   CellID->68055155]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 97967, 2856}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[585, 21, 6771, 163, 57, "AnchorBarGrid",ExpressionUUID->"a079393a-19ba-454f-9dc3-16d143cb4e4e",
 CellID->1],
Cell[7359, 186, 102, 0, 23, "ContextNameCell",ExpressionUUID->"daeb85e4-c592-469b-bfe4-606686cefc67"],
Cell[CellGroupData[{
Cell[7486, 190, 556, 14, 60, "ObjectNameGrid",ExpressionUUID->"f5224fdf-c444-42cb-af8f-dd8aea7b4d6b"],
Cell[8045, 206, 1278, 33, 116, "Usage",ExpressionUUID->"727b5c2f-445f-47eb-a759-069ad9040ab1",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[9360, 244, 1899, 47, 37, "NotesSection",ExpressionUUID->"eebff1b4-de79-40b3-94a5-a7303305658e",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1435535600],
Cell[11262, 293, 128, 1, 70, "Notes",ExpressionUUID->"96d97947-4fb9-4a8b-8b7e-4324673b156f",
 CellID->1067943069],
Cell[11393, 296, 5208, 133, 70, "3ColumnTableMod",ExpressionUUID->"2ce7524e-fc35-44dc-8ff2-480bd1671e7e",
 CellID->264018771],
Cell[16604, 431, 798, 22, 70, "Notes",ExpressionUUID->"c123e603-740f-42ad-9655-a1443595e6b1",
 CellID->539936808],
Cell[17405, 455, 1326, 41, 70, "Notes",ExpressionUUID->"fdf2b84f-b33c-4973-8a3c-6be92816b4e0",
 CellID->1112017354],
Cell[18734, 498, 913, 25, 70, "Notes",ExpressionUUID->"a42ae5b5-1571-46bd-ba54-00a77d0a3515",
 CellID->1301036698]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[19774, 529, 1389, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"829c6162-a5d0-43d0-b530-039e68740c95",
 CellTags->"PrimaryExamplesSection",
 CellID->68055155],
Cell[CellGroupData[{
Cell[21188, 570, 1368, 36, 31, "ExampleSection",ExpressionUUID->"28c2dcdd-f813-4d03-b5d6-8b62b1d1b941",
 CellID->1341689881],
Cell[22559, 608, 182, 3, 29, "Input",ExpressionUUID->"2f9c6a02-b589-4757-8ad6-cb874a0d85c2",
 CellID->79203784],
Cell[22744, 613, 151, 1, 38, "ExampleText",ExpressionUUID->"3d390fb9-9c7e-4f2e-a97f-f541328a7175",
 CellID->282740562],
Cell[CellGroupData[{
Cell[22920, 618, 276, 7, 29, "Input",ExpressionUUID->"01b04aa5-ded8-4df7-9314-a59a77ed2037",
 CellID->313233494],
Cell[23199, 627, 250, 6, 37, "Output",ExpressionUUID->"8376264d-58ac-4853-abed-87932d361ab9",
 CellID->1881837238]
}, Open  ]],
Cell[CellGroupData[{
Cell[23486, 638, 198, 4, 29, "Input",ExpressionUUID->"c79aa728-7c87-474f-a3b9-4b6a41207a10",
 CellID->39827372],
Cell[23687, 644, 1068, 31, 70, "Output",ExpressionUUID->"da46e925-e237-4455-9360-8d190d419d4a",
 CellID->1178124118]
}, Open  ]],
Cell[CellGroupData[{
Cell[24792, 680, 242, 5, 14, "ExampleDelimiter",ExpressionUUID->"4078585d-ff47-46ef-b3ea-14b545c72eac",
 CellID->176211259],
Cell[25037, 687, 148, 1, 38, "ExampleText",ExpressionUUID->"e95fcdb6-411e-442a-b5e7-6c206ee1d2b2",
 CellID->343098914],
Cell[CellGroupData[{
Cell[25210, 692, 454, 12, 29, "Input",ExpressionUUID->"67e268e7-11a9-4c27-aca6-d60afcaf228e",
 CellID->932950030],
Cell[25667, 706, 798, 21, 55, "Output",ExpressionUUID->"707f0667-45b2-402e-9730-a97c40e9c0ee",
 CellID->1714991093]
}, Open  ]],
Cell[CellGroupData[{
Cell[26502, 732, 199, 4, 29, "Input",ExpressionUUID->"c2d1568f-b9e4-47f4-8f6d-f79b2be8b458",
 CellID->104442822],
Cell[26704, 738, 4681, 141, 108, "Output",ExpressionUUID->"1b3c2b36-c245-4cd9-8dfe-a111926da2af",
 CellID->329790017]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31434, 885, 242, 5, 14, "ExampleDelimiter",ExpressionUUID->"2b9f13fe-aef8-4d1b-8e84-6482205123ca",
 CellID->133916380],
Cell[31679, 892, 151, 1, 70, "ExampleText",ExpressionUUID->"e93e6070-bbee-458c-84de-38e9fae7d6c0",
 CellID->396876126],
Cell[CellGroupData[{
Cell[31855, 897, 417, 11, 70, "Input",ExpressionUUID->"636281a5-de0a-4f80-82c3-d36a2a183c43",
 CellID->282938609],
Cell[32275, 910, 1341, 37, 84, "Output",ExpressionUUID->"92ac43c8-9a40-406c-ba51-2e1c81cb07fc",
 CellID->125522812]
}, Open  ]],
Cell[CellGroupData[{
Cell[33653, 952, 198, 4, 70, "Input",ExpressionUUID->"1af22be2-f6b7-4655-889f-72d376b87b91",
 CellID->22237377],
Cell[33854, 958, 4745, 141, 108, "Output",ExpressionUUID->"c2fd946f-908f-40ac-b4cc-9d4009fdea42",
 CellID->832959930]
}, Open  ]]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]],
Cell[CellGroupData[{
Cell[38760, 1108, 1396, 36, 70, "ExampleSection",ExpressionUUID->"adef2b90-85fe-4426-afd1-db6e7e82fe41",
 CellID->1848392594],
Cell[CellGroupData[{
Cell[40181, 1148, 1412, 36, 70, "ExampleSubsection",ExpressionUUID->"089cb4df-4817-4ffb-b3a6-f571efbb95cf",
 CellID->435889856],
Cell[41596, 1186, 184, 3, 70, "Input",ExpressionUUID->"a46c02b2-65bd-4d6f-aeeb-f0f521bb5977",
 CellID->1271543587],
Cell[41783, 1191, 583, 16, 70, "ExampleText",ExpressionUUID->"3876a294-20cd-47ea-bad6-5ee489318b9f",
 CellID->1223295412],
Cell[CellGroupData[{
Cell[42391, 1211, 545, 15, 70, "Input",ExpressionUUID->"4dd33f16-773e-42cd-b755-1d7726f7ec9e",
 CellID->1984201695],
Cell[42939, 1228, 1640, 50, 88, "Output",ExpressionUUID->"2ff390ad-db5c-4f8b-a80e-d096144cb815",
 CellID->23797547]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "0"}, Closed]]]],
Cell[CellGroupData[{
Cell[44731, 1286, 1419, 36, 70, "ExampleSubsection",ExpressionUUID->"3f2a4eb9-1c25-4a0f-80a6-23af4b075de2",
 CellID->726865425],
Cell[46153, 1324, 183, 3, 70, "Input",ExpressionUUID->"298dbaa5-52ac-4aef-ad08-caa4088c7b0d",
 CellID->220702645],
Cell[46339, 1329, 158, 2, 70, "ExampleText",ExpressionUUID->"7cfd7c30-e7e5-4b8a-8dad-291304aa2b51",
 CellID->226270345],
Cell[CellGroupData[{
Cell[46522, 1335, 281, 7, 70, "Input",ExpressionUUID->"7283436b-1773-4368-90c7-3e18aaa57c16",
 CellID->204344010],
Cell[46806, 1344, 617, 17, 37, "Output",ExpressionUUID->"cae8c80f-5365-4656-ae37-f2fef5fe9b59",
 CellID->111648717]
}, Open  ]],
Cell[CellGroupData[{
Cell[47460, 1366, 281, 7, 70, "Input",ExpressionUUID->"9f96b98e-fb53-4ea3-b6fa-e35c4785a121",
 CellID->248152200],
Cell[47744, 1375, 5463, 165, 94, "Output",ExpressionUUID->"db56bee5-e5ca-4a96-bb22-585385e20c2c",
 CellID->1726762788]
}, Open  ]],
Cell[53222, 1543, 156, 2, 70, "ExampleText",ExpressionUUID->"51d0bc82-1424-4ec0-9966-ceb85e6fab17",
 CellID->12223885],
Cell[CellGroupData[{
Cell[53403, 1549, 286, 7, 70, "Input",ExpressionUUID->"f531ba92-883b-4b09-b9d1-303e65d8640c",
 CellID->213780995],
Cell[53692, 1558, 4999, 150, 88, "Output",ExpressionUUID->"859949f7-dd24-4497-b9ed-7baf78ac5411",
 CellID->608172358]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "1"}, Closed]]]],
Cell[CellGroupData[{
Cell[58843, 1716, 1404, 36, 70, "ExampleSubsection",ExpressionUUID->"7e5dfbdd-d69d-4dd5-98a8-a0e3d14e9a23",
 CellID->722695695],
Cell[60250, 1754, 182, 3, 70, "Input",ExpressionUUID->"a104beb5-4c54-4245-a781-b5909e6bd91c",
 CellID->57942322],
Cell[60435, 1759, 132, 1, 70, "ExampleText",ExpressionUUID->"88eb52fd-d324-497c-a98b-16307272d1c8",
 CellID->158245489],
Cell[CellGroupData[{
Cell[60592, 1764, 408, 11, 70, "Input",ExpressionUUID->"b045215f-99a9-41f5-be2a-f60058d6e18d",
 CellID->71521896],
Cell[61003, 1777, 2987, 89, 88, "Output",ExpressionUUID->"b7998572-3d86-4fe0-ac2e-dba39c8f680c",
 CellID->1678144833]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "2"}, Closed]]]],
Cell[CellGroupData[{
Cell[64142, 1874, 1404, 36, 70, "ExampleSubsection",ExpressionUUID->"5179c39b-3233-40c9-9479-841369d0a291",
 CellID->33314988],
Cell[65549, 1912, 183, 3, 70, "Input",ExpressionUUID->"503114c1-62c4-4f41-b201-a8ff3dbbff53",
 CellID->307732332],
Cell[65735, 1917, 144, 1, 70, "ExampleText",ExpressionUUID->"bb62086e-99e2-4eb8-964b-a01e9a83e116",
 CellID->916681948],
Cell[CellGroupData[{
Cell[65904, 1922, 433, 12, 70, "Input",ExpressionUUID->"ca8f6628-f686-4881-bded-759da3f80aab",
 CellID->247747826],
Cell[66340, 1936, 2842, 89, 88, "Output",ExpressionUUID->"3da29d63-8678-40eb-a1b5-c7faaf7009ad",
 CellID->116957040]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "3"}, Closed]]]],
Cell[CellGroupData[{
Cell[69334, 2033, 1414, 36, 70, "ExampleSubsection",ExpressionUUID->"47de8c8e-a96f-4da5-b88e-8bfb7f64d6b7",
 CellID->934089875],
Cell[70751, 2071, 183, 3, 70, "Input",ExpressionUUID->"18a1c623-1865-4970-988d-ee59fbea9a53",
 CellID->311015445],
Cell[70937, 2076, 585, 17, 70, "ExampleText",ExpressionUUID->"4a7f7cbf-2833-44ad-8f51-bf20e3da9557",
 CellID->261387317],
Cell[CellGroupData[{
Cell[71547, 2097, 547, 15, 70, "Input",ExpressionUUID->"b9157d13-6fa6-44cb-977e-e162c7f2632e",
 CellID->1532578704],
Cell[72097, 2114, 1910, 59, 88, "Output",ExpressionUUID->"0ab9d5e3-b1c4-46ef-adb1-bb0728214f1d",
 CellID->832177138]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "4"}, Closed]]]],
Cell[CellGroupData[{
Cell[74159, 2181, 1411, 36, 70, "ExampleSubsection",ExpressionUUID->"0263c7e2-1903-4e04-9d74-6e9148b7f67f",
 CellID->417470545],
Cell[75573, 2219, 183, 3, 70, "Input",ExpressionUUID->"e3500129-6508-46a9-a3a4-02b958760e27",
 CellID->282498195],
Cell[75759, 2224, 174, 3, 70, "ExampleText",ExpressionUUID->"05b39ebc-e48d-4265-aaa6-47695e9580b6",
 CellID->2008303495],
Cell[CellGroupData[{
Cell[75958, 2231, 435, 11, 70, "Input",ExpressionUUID->"90959756-ba27-4eb0-929c-252276109ce2",
 CellID->224080200],
Cell[76396, 2244, 5325, 143, 128, "Output",ExpressionUUID->"dbd42ff2-bc1b-4c1d-bfd7-a1d825d02033",
 CellID->1124013171]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "5"}, Closed]]]],
Cell[CellGroupData[{
Cell[81873, 2395, 1411, 36, 70, "ExampleSubsection",ExpressionUUID->"5e7d455a-a777-46fe-969c-6d4848245b85",
 CellID->841132874],
Cell[83287, 2433, 183, 3, 70, "Input",ExpressionUUID->"d2a5dab4-25ea-400f-b773-684dc2d82543",
 CellID->309288205],
Cell[83473, 2438, 130, 1, 70, "ExampleText",ExpressionUUID->"7b94a491-7c1a-4043-ba46-9023c6eef2a1",
 CellID->137270048],
Cell[CellGroupData[{
Cell[83628, 2443, 411, 11, 70, "Input",ExpressionUUID->"892438cb-0a18-4ab8-8d88-554005afe0b6",
 CellID->60846088],
Cell[84042, 2456, 2477, 80, 88, "Output",ExpressionUUID->"198ee0ce-6818-4cc3-8e4e-20527339f69b",
 CellID->1677472180]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "6"}, Closed]]]],
Cell[CellGroupData[{
Cell[86671, 2544, 1408, 36, 70, "ExampleSubsection",ExpressionUUID->"21290758-12cf-43c9-8aa0-b315e9c2ee4d",
 CellID->51745731],
Cell[88082, 2582, 184, 3, 70, "Input",ExpressionUUID->"ce55832f-cfc6-4535-960c-271aa0bd27e1",
 CellID->1289603855],
Cell[88269, 2587, 129, 1, 70, "ExampleText",ExpressionUUID->"1a763d31-7a74-4aa9-9f65-e53fe57262e8",
 CellID->1967025461],
Cell[CellGroupData[{
Cell[88423, 2592, 406, 11, 70, "Input",ExpressionUUID->"948e1d06-0bac-4dd5-bbfa-e94038989e69",
 CellID->952170122],
Cell[88832, 2605, 2824, 89, 88, "Output",ExpressionUUID->"2e982344-a912-48f2-b40d-7f2e9fefc13b",
 CellID->657240693]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSubsection", "7"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[92013, 2706, 1403, 37, 70, "SeeAlsoSection",ExpressionUUID->"fabc0db2-315b-4126-92ec-b28491fd763c"],
Cell[93419, 2745, 1589, 39, 70, "TutorialsSection",ExpressionUUID->"98c2b953-9dad-4329-bf8d-7aeb26de47e4"],
Cell[95011, 2786, 753, 19, 70, "MoreAboutSection",ExpressionUUID->"b3ffa611-f1ed-4256-9e31-041ea79f67d4"],
Cell[95767, 2807, 78, 0, 70, "FooterCell",ExpressionUUID->"fd13e82f-3157-4ab2-bf0c-7ed73702c02c"]
}
]
*)

(* End of internal cache information *)

