(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     48955,       1322]
NotebookOptionsPosition[     41523,       1170]
NotebookOutlinePosition[     43922,       1229]
CellTagsIndexPosition[     43836,       1224]
WindowTitle->GFactor
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "9cc1a587-a986-4046-88e9-d8d36a65ba4d"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "a706698b-6c68-4e21-82e5-ae24baf4b171"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "8879bfc1-86a9-4738-bf8d-e33c738d2b4b"]
         }],ExpressionUUID->"3c1a243e-26d8-4aba-b319-7b022dc40917"],
         StripOnInput->False], {"\<\"AtomicState\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/AtomicState"], "\<\"J\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/J"], "\<\"L\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/L"], "\<\"S\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/S"], "\<\"M\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/M"], "\<\"NuclearSpin\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/NuclearSpin"], \
"\<\"AtomicSystemType\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/AtomicSystemType"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "aad1799b-0385-41d4-9ce3-6348fce97642"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "97dd8fa7-43b0-46be-bc23-5aa703b89feb"]
         }],ExpressionUUID->"1c61ceaf-c8e1-4f0d-a24d-c53a17668cb7"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "a3247f7b-6c89-42ed-aaef-a94312ac7efa"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "c04526d8-2d0b-44b1-afd0-4b64d5c6201c"]
         }],ExpressionUUID->"b7a1f3f4-4d13-4f78-a8dd-61d86e5bd446"],
         StripOnInput->False], {"\<\"Specifying the Atomic System\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem"], "\<\
\"Constructing the Hamiltonian\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"Tutorials"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "55250038-37d5-43aa-b44e-4d3922abf73b"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "cd18d65e-2214-40f2-9cc1-5a9913d8a8d0"]
         }],ExpressionUUID->"66d49bd1-135f-40c8-a020-4007aa6b72b7"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix/ref/GFactor\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/GFactor"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/GFactor.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$43497], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/GFactor" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "53506532-afdc-49bb-bdcf-5374f0544f8b"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "b085920b-4f44-40e5-95c0-1a66fb555aaf"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"afba9943-b4c4-4ac2-8d60-93d750b3cddd"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"ad25da07-b69c-414c-9d4e-be3fb64a6d5c"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "GFactor", "ObjectName",ExpressionUUID->
      "26441bea-c89d-4fcc-bcd2-abadc97ba4d6"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"830df7a8-8990-4e8f-9ab4-6bed9cfbe13f"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "1209a6ac-efd7-49ab-915b-adf0fe28a037"]
    }],ExpressionUUID->"5e228f92-f35b-4d22-9723-d2341ee314ff"], 
    "\[SpanFromLeft]"}
  }]], "ObjectNameGrid",ExpressionUUID->"84883d3c-cfcc-4ba7-b694-\
fbbfb524d004"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["GFactor"], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "a45dc0c9-a6bd-4a23-92c3-038b6850777e"],
     " \[LineSeparator]is a parameter for ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["AtomicState"]], 
        "paclet:AtomicDensityMatrix/ref/AtomicState", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "d56ad171-da78-45d3-b148-8d7c89ee4c5a"],
     " that specifies the Land\[EAcute] ",
     Cell[BoxData[
      FormBox[
       SubscriptBox["g", "J"], TraditionalForm]], "InlineMath",ExpressionUUID->
      "1fb54364-bcfa-4a03-9431-e61f7ae9ebc0"],
     "\[Hyphen]factor for the state, as an alternative to specifying values \
for ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["L"]], "paclet:AtomicDensityMatrix/ref/L", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "a8b3f4fd-71ed-4e82-bc4c-dbfee8d2f4f8"],
     " and ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["S"]], "paclet:AtomicDensityMatrix/ref/S", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "2e8118c5-569d-4ef2-a57a-d03e39a33ffa"],
     " for the state. "
    }],ExpressionUUID->"729ac555-91ba-4c14-8b72-9b1d0a5cfe25"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"GFactor", "[", 
       StyleBox["state", "TI"], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "47e93adf-3251-40a7-b90f-70ad7fdf0132"],
     "\[LineSeparator]returns the value specified for ",
     Cell[BoxData["GFactor"], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "72de1a47-a828-401e-a689-897c1608f5e8"],
     " in ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["AtomicState"]], 
        "paclet:AtomicDensityMatrix/ref/AtomicState", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "52c82b47-587d-46c4-a4b0-4b838cfca6bf"],
     " ",
     Cell[BoxData[
      StyleBox["state", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "57cfcb18-2375-4ff2-9ae8-31323b4046bb"],
     ", or ",
     Cell[BoxData[
      RowBox[{"GFactor", "[", 
       RowBox[{
        TemplateBox[{
          Cell[
           TextData["StateLabel"]], 
          "paclet:AtomicDensityMatrix/ref/StateLabel", 
          "AtomicDensityMatrix Package Symbol"},
         "PackageLink",
         BaseStyle->"InlineFormula"], "[", 
        StyleBox["state", "TI"], "]"}], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "b13f2c6d-205e-4957-aff9-f4c80f563141"],
     " if it is not specified."
    }],ExpressionUUID->"1278ebc1-7320-4669-8270-9e0f988db340"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"a983053f-419f-45d8-a95d-4a28b535e709"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"923429d8-b1ff-468c-80e7-e823be4c0aa0"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"26df4eff-ac5a-41a4-994c-f9ccf50973e2"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"e1f334e2-b657-49f7-b00d-ae1c1869c5a2"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"8ca3fc10-f7e5-4bdd-80fe-9b92b04470eb"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->1922134797,ExpressionUUID->"5cfac4c2-38d7-490e-bafa-0345ce3d2cba"],

Cell[TextData[{
 "If ",
 Cell[BoxData["GFactor"], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "5b8f92d9-ff4e-40ee-8fdb-38d272d9500c"],
 " is specified for a state, it is used in calculating the \
magnetic-field-interaction Hamiltonian for that state. If it is not \
specified, the values for ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["J"]], "paclet:AtomicDensityMatrix/ref/J", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "9d8842f4-56ac-4876-9f1e-ba57dc7d2a1d"],
 ", ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["L"]], "paclet:AtomicDensityMatrix/ref/L", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "0376f936-6eb8-4000-8ba5-821b7f0dfc9e"],
 ", and ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["S"]], "paclet:AtomicDensityMatrix/ref/S", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "ab37acdf-5691-4fda-ab34-1e132d4da96e"],
 " are used to calculate the Land\[EAcute] ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["g", "J"], TraditionalForm]], "InlineMath",ExpressionUUID->
  "98c9b1c9-3dfe-4584-bbce-a695e4523e6a"],
 "-factor. If they are not specified, then the placeholder ",
 Cell[BoxData[
  RowBox[{"GFactor", "[", 
   RowBox[{
    TemplateBox[{
      Cell[
       TextData["StateLabel"]], "paclet:AtomicDensityMatrix/ref/StateLabel", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"InlineFormula"], "[", 
    StyleBox["state", "TI"], "]"}], "]"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "296eaf1d-4b60-4545-8afe-074e0a6e4c74"],
 " is used."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"cbac530c-75ef-4a11-aa0a-1d1fce48b312"],

Cell[TextData[{
 Cell[BoxData["GFactor"], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "e191388f-c8c0-4170-a6c0-d416559bc416"],
 " is automatically threaded over a list of ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["AtomicState"]], "paclet:AtomicDensityMatrix/ref/AtomicState", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "309c8add-4c9a-4ee8-8541-f841b18fb094"],
 " objects appearing as its argument."
}], "Notes",
 CellID->1007068185,ExpressionUUID->"a0887830-5ce2-47ac-99ed-565b2325b5b3"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "3c105682-52c3-4b80-a44c-a071c8cf465f"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"98eeee8e-36c7-4d8d-8804-ee59dee3a580"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "d4a44a5f-82a8-4f2e-ab9e-a122a76748e5"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->723031358,ExpressionUUID->"2ab31638-1396-481c-b62b-843eb828acff"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "dcf0d851-efb6-4baa-8a23-ae527eff9d02"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"05740d22-f33f-475e-b2ea-cab2af405603"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "034deed5-2f09-4ac4-a8ea-df4504e6e7dd"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->1525559180,ExpressionUUID->"7f2d58de-a84c-4468-b179-2b105ebc0cba"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1318339194,ExpressionUUID->"9b371a0d-b3f5-4ecb-aecd-2b29e2a0476c"],

Cell[TextData[{
 "Define an atomic system with explicit ",
 Cell[BoxData[
  FormBox["g", TraditionalForm]], "InlineMath",ExpressionUUID->
  "2c7bcb7e-829b-46f0-84a6-fb6e5b46b3ec"],
 "-factors specified for the states:"
}], "ExampleText",
 CellID->1356269762,ExpressionUUID->"fe9a097a-57f7-4c21-b0a6-bf2891a1f3bf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"GFactor", "\[Rule]", 
      RowBox[{"1", "/", "2"}]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1738047459,ExpressionUUID->"75b02096-745b-4a3f-9780-53f1bbe0c84f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"GFactor", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"GFactor", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"GFactor", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->998442419,ExpressionUUID->"1a99a5d7-2a9d-40cd-b6f1-f079b368933c"]
}, Open  ]],

Cell[TextData[{
 "The value for ",
 Cell[BoxData["GFactor"], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "a83f6812-b070-4cac-84a1-808496dbec44"],
 " is used when constructing the magnetic-field-interaction Hamiltonian:"
}], "ExampleText",
 CellID->412999393,ExpressionUUID->"5c7c8b09-0bd1-43a4-80d3-34c8bbad5267"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Hamiltonian", "[", 
   RowBox[{"sys", ",", 
    RowBox[{"MagneticField", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "B"}], "}"}]}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1567061572,ExpressionUUID->"9a9aeb0e-d8db-48d1-95a6-18d6562c0c11"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       RowBox[{"B", " ", "BohrMagneton"}], "2"], "0", "0"},
     {"0", "0", "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"B", " ", "BohrMagneton"}], "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[3]//MatrixForm=",
 CellID->1506853552,ExpressionUUID->"1e02623e-15d5-4459-995f-2502e81e3616"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "2"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"0dc18a23-89bf-471d-8623-4838eaafd101"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"6ea76ab8-6590-4821-9aa6-66a56a9d145d"],
 "Properties & Relations",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "89eb5691-9ddb-478b-a8a7-2528a4dcc45c"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->2123667759,ExpressionUUID->"3bd8069b-3e1c-4f60-8149-ba9590260a8d"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->467187045,ExpressionUUID->"acdbdf93-b190-441e-92ea-25ada9f3da85"],

Cell[TextData[{
 "If the values for ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["L"]], "paclet:AtomicDensityMatrix/ref/L", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "53526316-c606-42c6-b8ad-aaa3ab0d6649"],
 " and ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["S"]], "paclet:AtomicDensityMatrix/ref/S", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "4a716053-d02d-4fc4-8197-ecc03b41891c"],
 " are specified, they are used to calculate the ",
 Cell[BoxData[
  FormBox["g", TraditionalForm]], "InlineMath",ExpressionUUID->
  "b8e36760-1f0a-4a8b-8431-56ada2489141"],
 StyleBox["-factor when forming the Hamiltonian:",
  Deletable->True]
}], "ExampleText",
 CellID->812451883,ExpressionUUID->"7c8094fb-888d-40af-bb2e-afb2f0cacd72"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1177769955,ExpressionUUID->"d4077c8a-af69-4859-b141-a6a50edc75a8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->534960750,ExpressionUUID->"e8ebde0c-f4e6-4608-a307-f3173f425552"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Hamiltonian", "[", 
   RowBox[{"sys", ",", 
    RowBox[{"MagneticField", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "B"}], "}"}]}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->685916553,ExpressionUUID->"391e6fd3-480e-4d8e-bc3e-2ac1e78d8fe9"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"B", " ", "BohrMagneton"}], "0", "0"},
     {"0", "0", "0"},
     {"0", "0", 
      RowBox[{
       RowBox[{"-", "B"}], " ", "BohrMagneton"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[3]//MatrixForm=",
 CellID->1935832180,ExpressionUUID->"d2adfd9f-b43b-43db-bea0-568b250b1535"]
}, Open  ]],

Cell[TextData[{
 "If ",
 Cell[BoxData["GFactor"], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "e0616f9b-5e76-4bb3-b75b-83b621ec813f"],
 " is specified, it takes precedence over the values for ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["L"]], "paclet:AtomicDensityMatrix/ref/L", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "cf64b340-8919-495c-8524-0203cd5bd44c"],
 " and ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["S"]], "paclet:AtomicDensityMatrix/ref/S", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "856e54de-a50f-4620-960e-893791ad628e"],
 StyleBox[":",
  Deletable->True]
}], "ExampleText",
 CellID->1105111469,ExpressionUUID->"ff212ba7-9c63-4dbb-9133-e1f7a52642ee"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"GFactor", "\[Rule]", "g"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->22396580,ExpressionUUID->"d7967431-a198-45c3-a109-b79f659a05a5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"GFactor", "\[Rule]", "g"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"GFactor", "\[Rule]", "g"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"GFactor", "\[Rule]", "g"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[4]=",
 CellID->1671632686,ExpressionUUID->"d104ce3e-d548-458b-a348-222655ddba2d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Hamiltonian", "[", 
   RowBox[{"sys", ",", 
    RowBox[{"MagneticField", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "B"}], "}"}]}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1278121008,ExpressionUUID->"fb14c566-94b1-4a0a-8504-58030c638101"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"B", " ", "BohrMagneton", " ", "g"}], "0", "0"},
     {"0", "0", "0"},
     {"0", "0", 
      RowBox[{
       RowBox[{"-", "B"}], " ", "BohrMagneton", " ", "g"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[5]//MatrixForm=",
 CellID->637327640,ExpressionUUID->"874bd8c6-3d5e-4e93-8a46-8c5e758a5315"]
}, Open  ]],

Cell[TextData[{
 "If neither ",
 Cell[BoxData["GFactor"], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "4bb5526f-8f09-4c3d-bdec-89cfd366d3db"],
 " nor ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["L"]], "paclet:AtomicDensityMatrix/ref/L", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "d9e32198-a18d-4bee-bb44-bebf746750e4"],
 " and ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["S"]], "paclet:AtomicDensityMatrix/ref/S", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "1d8b50b3-0890-4373-8d55-2054237a5f65"],
 " are specified, a placeholder value is used",
 StyleBox[":",
  Deletable->True]
}], "ExampleText",
 CellID->2064697891,ExpressionUUID->"94ef4ab4-713d-48d1-a046-a03c6a5fe5ba"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], "]"}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->189202164,ExpressionUUID->"f43530ba-b154-4946-a020-b6f46686ba19"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[6]=",
 CellID->159309414,ExpressionUUID->"5e9927cf-deb9-4bbb-8545-9d8a8d696081"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Hamiltonian", "[", 
   RowBox[{"sys", ",", 
    RowBox[{"MagneticField", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "B"}], "}"}]}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->353176438,ExpressionUUID->"78d28501-2834-44b9-a020-db48c09ea446"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"B", " ", "BohrMagneton", " ", 
       RowBox[{"GFactor", "[", "1", "]"}]}], "0", "0"},
     {"0", "0", "0"},
     {"0", "0", 
      RowBox[{
       RowBox[{"-", "B"}], " ", "BohrMagneton", " ", 
       RowBox[{"GFactor", "[", "1", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[7]//MatrixForm=",
 CellID->202232695,ExpressionUUID->"ca91bbbc-24f7-4049-ba6e-a88492166002"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "2"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedFunction.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"See", " ", "Also"}], "SeeAlsoSection"]},
      {Cell[TextData[{
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicState"]], 
           "paclet:AtomicDensityMatrix/ref/AtomicState", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "6876e3c4-3bf6-4f50-88af-5897b3269495"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["J"]], "paclet:AtomicDensityMatrix/ref/J", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "9b36545f-7642-4dd9-a36e-6ce1b4a3e915"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["L"]], "paclet:AtomicDensityMatrix/ref/L", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "0826b6db-e939-4c47-82b1-9865869effd6"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["S"]], "paclet:AtomicDensityMatrix/ref/S", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "a91ef7f7-478e-4919-8d21-ee977334c383"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["M"]], "paclet:AtomicDensityMatrix/ref/M", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "93b0415a-efba-4e3f-aa7a-1831787cc235"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["NuclearSpin"]], 
           "paclet:AtomicDensityMatrix/ref/NuclearSpin", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "62520926-8c5e-46e8-8b2a-fbb56073f385"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicSystemType"]], 
           "paclet:AtomicDensityMatrix/ref/AtomicSystemType", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "eb4f1d0d-51f1-4ea2-9951-92d0d411658b"]
       }], "SeeAlso",ExpressionUUID->"8f812757-9a65-41c2-bd6c-5ef5971380e9"]}
     }]}
  }]], "SeeAlsoSection",ExpressionUUID->"ed2a1280-db07-435d-9fd4-\
2389cb490fc7"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox["Tutorials", "TutorialsSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Specifying the Atomic System"]], 
           "paclet:AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "c66ddf96-f288-4399-b9a1-848acca53026"]}]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Constructing the Hamiltonian"]], 
           "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "1203e4a7-abdc-479a-904d-20e6b5f9428e"]}]}
     }]}
  }]], "TutorialsSection",ExpressionUUID->"176e210d-20c0-4a1e-8114-\
faed26cc5c7b"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "46f523e3-1d15-46b9-91a9-572e677d0b6f"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"b4291427-93a2-49d9-9e9c-\
fcaea347dfca"],

Cell[" ", "FooterCell",ExpressionUUID->"f0ca5503-cf13-485a-afee-18f4662b52b6"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"GFactor",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, 
    "ExampleSection" -> {"0" -> Open, "2" -> Closed}, "NotesSection" -> 
    Closed}, "NewStyles" -> True, "CitationPopupData" -> $Failed, 
  "ShowCitation" -> False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 17, 59, 25.918759}", 
    "history" -> {"17.06", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "GFactor is a parameter for AtomicState that specifies the Land\[EAcute] \
gJ-factor for the state, as an alternative to specifying values for L and S \
for the state. GFactor[state] returns the value specified for GFactor in \
AtomicState state, or GFactor[StateLabel[state]] if it is not specified.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "GFactor", 
    "titlemodifier" -> "", "metadescription" -> "", "windowtitle" -> 
    "GFactor", "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/GFactor"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"697337e4-3f49-455c-8a7b-c5ffb6e7c960"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[16335, 431, 1389, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"2ab31638-1396-481c-b62b-843eb828acff",
   CellTags->"PrimaryExamplesSection",
   CellID->723031358]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 43636, 1217}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[579, 21, 6994, 166, 57, "AnchorBarGrid",ExpressionUUID->"afba9943-b4c4-4ac2-8d60-93d750b3cddd",
 CellID->1],
Cell[7576, 189, 102, 0, 23, "ContextNameCell",ExpressionUUID->"ad25da07-b69c-414c-9d4e-be3fb64a6d5c"],
Cell[CellGroupData[{
Cell[7703, 193, 550, 14, 60, "ObjectNameGrid",ExpressionUUID->"84883d3c-cfcc-4ba7-b694-fbbfb524d004"],
Cell[8256, 209, 3346, 87, 214, "Usage",ExpressionUUID->"a983053f-419f-45d8-a95d-4a28b535e709",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[11639, 301, 1899, 47, 37, "NotesSection",ExpressionUUID->"5cfac4c2-38d7-490e-bafa-0345ce3d2cba",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1922134797],
Cell[13541, 350, 2017, 57, 70, "Notes",ExpressionUUID->"cbac530c-75ef-4a11-aa0a-1d1fce48b312",
 CellID->1067943069],
Cell[15561, 409, 647, 16, 70, "Notes",ExpressionUUID->"a0887830-5ce2-47ac-99ed-565b2325b5b3",
 CellID->1007068185]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[16335, 431, 1389, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"2ab31638-1396-481c-b62b-843eb828acff",
 CellTags->"PrimaryExamplesSection",
 CellID->723031358],
Cell[CellGroupData[{
Cell[17749, 472, 1368, 36, 31, "ExampleSection",ExpressionUUID->"7f2d58de-a84c-4468-b179-2b105ebc0cba",
 CellID->1525559180],
Cell[19120, 510, 184, 3, 29, "Input",ExpressionUUID->"9b371a0d-b3f5-4ecb-aecd-2b29e2a0476c",
 CellID->1318339194],
Cell[19307, 515, 313, 7, 38, "ExampleText",ExpressionUUID->"fe9a097a-57f7-4c21-b0a6-bf2891a1f3bf",
 CellID->1356269762],
Cell[CellGroupData[{
Cell[19645, 526, 404, 10, 29, "Input",ExpressionUUID->"75b02096-745b-4a3f-9780-53f1bbe0c84f",
 CellID->1738047459],
Cell[20052, 538, 977, 26, 84, "Output",ExpressionUUID->"1a99a5d7-2a9d-40cd-b6f1-f079b368933c",
 CellID->998442419]
}, Open  ]],
Cell[21044, 567, 337, 7, 39, "ExampleText",ExpressionUUID->"5c7c8b09-0bd1-43a4-80d3-34c8bbad5267",
 CellID->412999393],
Cell[CellGroupData[{
Cell[21406, 578, 331, 9, 29, "Input",ExpressionUUID->"9a9aeb0e-d8db-48d1-95a6-18d6562c0c11",
 CellID->1567061572],
Cell[21740, 589, 880, 25, 102, "Output",ExpressionUUID->"1e02623e-15d5-4459-995f-2502e81e3616",
 CellID->1506853552]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]],
Cell[CellGroupData[{
Cell[22769, 622, 1411, 36, 30, "ExampleSection",ExpressionUUID->"3bd8069b-3e1c-4f60-8149-ba9590260a8d",
 CellID->2123667759],
Cell[24183, 660, 183, 3, 70, "Input",ExpressionUUID->"acdbdf93-b190-441e-92ea-25ada9f3da85",
 CellID->467187045],
Cell[24369, 665, 990, 28, 70, "ExampleText",ExpressionUUID->"7c8094fb-888d-40af-bb2e-afb2f0cacd72",
 CellID->812451883],
Cell[CellGroupData[{
Cell[25384, 697, 413, 10, 70, "Input",ExpressionUUID->"d4077c8a-af69-4859-b141-a6a50edc75a8",
 CellID->1177769955],
Cell[25800, 709, 1010, 26, 55, "Output",ExpressionUUID->"e8ebde0c-f4e6-4608-a307-f3173f425552",
 CellID->534960750]
}, Open  ]],
Cell[CellGroupData[{
Cell[26847, 740, 330, 9, 70, "Input",ExpressionUUID->"391e6fd3-480e-4d8e-bc3e-2ac1e78d8fe9",
 CellID->685916553],
Cell[27180, 751, 827, 23, 82, "Output",ExpressionUUID->"d2adfd9f-b43b-43db-bea0-568b250b1535",
 CellID->1935832180]
}, Open  ]],
Cell[28022, 777, 961, 28, 70, "ExampleText",ExpressionUUID->"ff212ba7-9c63-4dbb-9133-e1f7a52642ee",
 CellID->1105111469],
Cell[CellGroupData[{
Cell[29008, 809, 459, 11, 70, "Input",ExpressionUUID->"d7967431-a198-45c3-a109-b79f659a05a5",
 CellID->22396580],
Cell[29470, 822, 1155, 29, 72, "Output",ExpressionUUID->"d104ce3e-d548-458b-a348-222655ddba2d",
 CellID->1671632686]
}, Open  ]],
Cell[CellGroupData[{
Cell[30662, 856, 331, 9, 70, "Input",ExpressionUUID->"fb14c566-94b1-4a0a-8504-58030c638101",
 CellID->1278121008],
Cell[30996, 867, 846, 23, 82, "Output",ExpressionUUID->"874bd8c6-3d5e-4e93-8a46-8c5e758a5315",
 CellID->637327640]
}, Open  ]],
Cell[31857, 893, 967, 29, 70, "ExampleText",ExpressionUUID->"94ef4ab4-713d-48d1-a046-a03c6a5fe5ba",
 CellID->2064697891],
Cell[CellGroupData[{
Cell[32849, 926, 328, 8, 70, "Input",ExpressionUUID->"f43530ba-b154-4946-a020-b6f46686ba19",
 CellID->189202164],
Cell[33180, 936, 758, 20, 55, "Output",ExpressionUUID->"5e9927cf-deb9-4bbb-8545-9d8a8d696081",
 CellID->159309414]
}, Open  ]],
Cell[CellGroupData[{
Cell[33975, 961, 330, 9, 70, "Input",ExpressionUUID->"78d28501-2834-44b9-a020-db48c09ea446",
 CellID->353176438],
Cell[34308, 972, 924, 25, 82, "Output",ExpressionUUID->"ca91bbbc-24f7-4049-ba6e-a88492166002",
 CellID->202232695]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "2"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[35474, 1006, 4078, 109, 114, "SeeAlsoSection",ExpressionUUID->"ed2a1280-db07-435d-9fd4-2389cb490fc7"],
Cell[39555, 1117, 1127, 28, 70, "TutorialsSection",ExpressionUUID->"176e210d-20c0-4a1e-8114-faed26cc5c7b"],
Cell[40685, 1147, 753, 19, 70, "MoreAboutSection",ExpressionUUID->"b4291427-93a2-49d9-9e9c-fcaea347dfca"],
Cell[41441, 1168, 78, 0, 70, "FooterCell",ExpressionUUID->"f0ca5503-cf13-485a-afee-18f4662b52b6"]
}
]
*)

(* End of internal cache information *)

