(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     26706,        694]
NotebookOptionsPosition[     21106,        580]
NotebookOutlinePosition[     23365,        636]
CellTagsIndexPosition[     23280,        631]
WindowTitle->IntrinsicRelaxation
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "615525cf-4788-428c-a0bd-a6528c464fea"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "9be87dd8-96b6-4a2a-a836-d3c298fc8a91"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "6b492c2e-2403-448b-b08b-593150651d14"]
         }],ExpressionUUID->"9aab4488-c376-455b-a36c-5fd2ae4385ad"],
         StripOnInput->False], {"\<\"BranchingRatio\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/BranchingRatio"], \
"\<\"OpticalRepopulation\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/OpticalRepopulation"], \
"\<\"TransitRelaxation\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/TransitRelaxation"], \
"\<\"TransitRepopulation\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/TransitRepopulation"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "ef824bfd-b774-466b-ab65-c03ec340478e"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "5bfe38a6-78b0-4e08-9cca-e6bac7066bed"]
         }],ExpressionUUID->"72ee7f45-8d88-47b5-93eb-35100354f44a"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "10f283f4-aded-42f9-8366-57a55c95e8d5"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "0239583e-9fcd-4faf-a7df-58ec9805b315"]
         }],ExpressionUUID->"36217bd7-38fd-47f0-b56d-96a96d6091e2"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/ref/IntrinsicRelaxation\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/IntrinsicRelaxation"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/IntrinsicRelaxation.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$47478], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/IntrinsicRelaxation" <> ".html"], 
            None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "0a6c487e-c325-4949-a00d-b9088b46c67f"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "62a9419d-74a3-4ffb-9748-3c6c3d1ccc41"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"e947a74d-ad9a-489e-86c1-4b5a920a7903"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"08489221-0814-4572-8591-7cdcebfe3a76"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "IntrinsicRelaxation", "ObjectName",ExpressionUUID->
      "d5e528b9-24ba-4ff1-a69c-e6416b8eafa7"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"da19a9ea-a937-4c43-b605-4a46f6d8e2e3"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "0534afe9-348b-4d03-9266-e4035ff8768e"]
    }],ExpressionUUID->"a59baf4a-d7cf-4795-be01-a4ad8824a28b"], 
    "\[SpanFromLeft]"}
  }]], "ObjectNameGrid",ExpressionUUID->"d1587f58-d224-4438-987d-\
106b12f22dbe"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"IntrinsicRelaxation", "[", 
       StyleBox["sys", "TI"], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "92115d4a-17b0-4e0c-8651-1578af17dc83"],
     " \[LineSeparator]returns the relaxation matrix describing spontaneous \
decay for atomic system ",
     Cell[BoxData[
      StyleBox["sys", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "72f457c4-07f0-4027-bc71-51568b353b6f"],
     ". "
    }],ExpressionUUID->"bc636352-b0c4-46aa-ac82-ed090dbce57d"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"55e62397-0ccb-4364-8f53-52c9814880e8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"b2ac484c-51bc-4b76-b2b1-231342101535"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"4a588ce3-de8b-4beb-89a6-2e16bbc43170"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"693178b8-1674-4a7f-b8cc-783907d277af"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"8be2c854-d4f3-4ddf-b106-e1130ead28c1"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->1642403745,ExpressionUUID->"e00c3dca-27ec-497b-9b3b-2bdf328aa4a5"],

Cell[TextData[{
 "The atomic system ",
 Cell[BoxData[
  StyleBox["sys", "TI"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "1a62ac0a-feee-409d-8299-fa0d88a1862e"],
 " is specified as a list of ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["AtomicState"]], "paclet:AtomicDensityMatrix/ref/AtomicState", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "6b97132f-077e-4ab6-a4f4-c31e84d0414b"],
 " objects."
}], "Notes",
 CellID->1436462212,ExpressionUUID->"689c0f71-c0bf-4fcf-a0d6-d1f6963c6d3d"],

Cell[TextData[{
 "The decay rate for each state is determined by the value of its ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["NaturalWidth"]], "paclet:AtomicDensityMatrix/ref/NaturalWidth",
     "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "fa8b77cd-4699-4879-b886-aa5dbe4b82a2"],
 " parameter."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"06d51deb-9111-4e47-b901-2c18bc15c463"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "15687e32-5526-4444-ac06-ab3a59dc6220"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"17aee4ec-ac19-415e-a01b-40fbafc0d853"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "a856f79e-2012-46d0-ad7a-e45e232feea4"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->124943677,ExpressionUUID->"6457773e-dbd8-474c-a5a4-dc78975bf8d9"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "2762f8b0-2466-4e64-afd5-74567cbb9965"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"b615aeed-7140-4640-b220-935e63221b8d"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "97aebb61-1042-47d0-b94e-755544ab23dd"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->1836856220,ExpressionUUID->"39984601-4030-4fb4-a627-d71b602de9f9"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->275173414,ExpressionUUID->"09f17e18-bd5a-46df-a0ba-9552c5409662"],

Cell["Define a three level system:", "ExampleText",
 CellID->1616161582,ExpressionUUID->"98b7c89b-c4f8-40a4-aa2d-1382735bfeb7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sys", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", " ", 
       RowBox[{"NaturalWidth", "\[Rule]", "0"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", "2", "]"}], ",", 
     RowBox[{"AtomicState", "[", "3", "]"}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1307277107,ExpressionUUID->"e3fdca62-d37b-4b47-bfdf-b3381b6ff43e"],

Cell["The relaxation matrix for spontaneous decay:", "ExampleText",
 CellID->2081854976,ExpressionUUID->"dd0f49fb-8718-4b2a-8a28-279be0eb1dd0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"IntrinsicRelaxation", "[", "sys", "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->529330763,ExpressionUUID->"a1e2e027-c3d2-45f1-bbb6-e5af089d98cd"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0"},
     {"0", 
      RowBox[{"NaturalWidth", "[", "2", "]"}], "0"},
     {"0", "0", 
      RowBox[{"NaturalWidth", "[", "3", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[3]//MatrixForm=",
 CellID->1243642687,ExpressionUUID->"36af7d88-2289-4944-8c78-e9dac406e538"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[
  "\t", "ExampleDelimiter",ExpressionUUID->
   "137fa6dc-052e-4623-ade9-afffe8cf12ad"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->95360542,ExpressionUUID->"3db0bf1f-7371-49b3-8b3f-6477c7346c90"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->701828732,ExpressionUUID->"901c1b26-9894-48c2-98e5-c2f5fd16d03e"],

Cell["A Zeeman system:", "ExampleText",
 CellID->1476589212,ExpressionUUID->"e3d24805-91b8-487c-8565-c6aa99925d04"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sys", "=", 
   RowBox[{"Sublevels", "@", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"AtomicState", "[", 
       RowBox[{"1", ",", 
        RowBox[{"J", "\[Rule]", "0"}], ",", 
        RowBox[{"NaturalWidth", "\[Rule]", "0"}]}], "]"}], ",", 
      RowBox[{"AtomicState", "[", 
       RowBox[{"2", ",", 
        RowBox[{"J", "\[Rule]", "1"}], ",", 
        RowBox[{"NaturalWidth", "\[Rule]", "\[CapitalGamma]"}]}], "]"}]}], 
     "}"}]}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1527607022,ExpressionUUID->"55a15ccb-d4c5-4ccb-ad32-13f590214a3b"],

Cell["The relaxation matrix for spontaneous decay:", "ExampleText",
 CellID->1422128218,ExpressionUUID->"e23a32b0-1287-435a-a1cc-1f6ba2cb51de"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"IntrinsicRelaxation", "[", "sys", "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->215968816,ExpressionUUID->"2a9141ef-3b47-4005-8715-2c4adfd1df6d"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "\[CapitalGamma]", "0", "0"},
     {"0", "0", "\[CapitalGamma]", "0"},
     {"0", "0", "0", "\[CapitalGamma]"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[3]//MatrixForm=",
 CellID->1713176226,ExpressionUUID->"d253b4b5-e2c4-4540-801d-71954a6c482b"]
}, Open  ]]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedFunction.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"See", " ", "Also"}], "SeeAlsoSection"]},
      {Cell[TextData[{
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["BranchingRatio"]], 
           "paclet:AtomicDensityMatrix/ref/BranchingRatio", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "7574e6cb-5c4f-41b2-b9ad-f8dc43c6aad4"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["TransitRelaxation"]], 
           "paclet:AtomicDensityMatrix/ref/TransitRelaxation", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "57fee1ce-f749-4d2f-b75f-1990d87a2964"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["TransitRepopulation"]], 
           "paclet:AtomicDensityMatrix/ref/TransitRepopulation", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "768ea88c-7d46-43f0-9f80-609534c8eb26"]
       }], "SeeAlso",ExpressionUUID->"a23de1c2-5c34-4e6a-8d8b-e6b556b688b9"]}
     }]}
  }]], "SeeAlsoSection",ExpressionUUID->"672e12a8-05ab-4258-8182-\
cb2085e0da45"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "6c0bfdaf-e834-44ba-afe0-1494bfd45bd1"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"afb68625-a995-4346-aeb1-\
8c12838487e1"],

Cell[" ", "FooterCell",ExpressionUUID->"69eedcb6-4db1-4a57-93a8-fb695d02bd25"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"IntrinsicRelaxation",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}, 
    "NotesSection" -> Closed}, "NewStyles" -> True, 
  "CitationPopupData" -> $Failed, "ShowCitation" -> False, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2023, 4, 18, 17, 59, 32.984355}", 
    "history" -> {"17.06", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "IntrinsicRelaxation[sys] returns the relaxation matrix describing \
spontaneous decay for atomic system sys. ", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "IntrinsicRelaxation", "titlemodifier" -> 
    "", "metadescription" -> "", "windowtitle" -> "IntrinsicRelaxation", 
    "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/IntrinsicRelaxation"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"47173769-74d3-459a-a40d-e3f10acfedd7"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[10897, 287, 1389, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"6457773e-dbd8-474c-a5a4-dc78975bf8d9",
   CellTags->"PrimaryExamplesSection",
   CellID->124943677]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 23080, 624}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 5687, 135, 57, "AnchorBarGrid",ExpressionUUID->"e947a74d-ad9a-489e-86c1-4b5a920a7903",
 CellID->1],
Cell[6281, 158, 102, 0, 23, "ContextNameCell",ExpressionUUID->"08489221-0814-4572-8591-7cdcebfe3a76"],
Cell[CellGroupData[{
Cell[6408, 162, 562, 14, 60, "ObjectNameGrid",ExpressionUUID->"d1587f58-d224-4438-987d-106b12f22dbe"],
Cell[6973, 178, 699, 16, 112, "Usage",ExpressionUUID->"55e62397-0ccb-4364-8f53-52c9814880e8",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[7709, 199, 1899, 47, 37, "NotesSection",ExpressionUUID->"e00c3dca-27ec-497b-9b3b-2bdf328aa4a5",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1642403745],
Cell[9611, 248, 644, 18, 70, "Notes",ExpressionUUID->"689c0f71-c0bf-4fcf-a0d6-d1f6963c6d3d",
 CellID->1436462212],
Cell[10258, 268, 512, 13, 70, "Notes",ExpressionUUID->"06d51deb-9111-4e47-b901-2c18bc15c463",
 CellID->1067943069]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[10897, 287, 1389, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"6457773e-dbd8-474c-a5a4-dc78975bf8d9",
 CellTags->"PrimaryExamplesSection",
 CellID->124943677],
Cell[CellGroupData[{
Cell[12311, 328, 1368, 36, 31, "ExampleSection",ExpressionUUID->"39984601-4030-4fb4-a627-d71b602de9f9",
 CellID->1836856220],
Cell[13682, 366, 183, 3, 29, "Input",ExpressionUUID->"09f17e18-bd5a-46df-a0ba-9552c5409662",
 CellID->275173414],
Cell[13868, 371, 127, 1, 38, "ExampleText",ExpressionUUID->"98b7c89b-c4f8-40a4-aa2d-1382735bfeb7",
 CellID->1616161582],
Cell[13998, 374, 427, 11, 29, "Input",ExpressionUUID->"e3fdca62-d37b-4b47-bfdf-b3381b6ff43e",
 CellID->1307277107],
Cell[14428, 387, 143, 1, 38, "ExampleText",ExpressionUUID->"dd0f49fb-8718-4b2a-8a28-279be0eb1dd0",
 CellID->2081854976],
Cell[CellGroupData[{
Cell[14596, 392, 208, 5, 29, "Input",ExpressionUUID->"a1e2e027-c3d2-45f1-bbb6-e5af089d98cd",
 CellID->529330763],
Cell[14807, 399, 814, 22, 82, "Output",ExpressionUUID->"36af7d88-2289-4944-8c78-e9dac406e538",
 CellID->1243642687]
}, Open  ]],
Cell[CellGroupData[{
Cell[15658, 426, 241, 5, 14, "ExampleDelimiter",ExpressionUUID->"3db0bf1f-7371-49b3-8b3f-6477c7346c90",
 CellID->95360542],
Cell[15902, 433, 183, 3, 29, "Input",ExpressionUUID->"901c1b26-9894-48c2-98e5-c2f5fd16d03e",
 CellID->701828732],
Cell[16088, 438, 115, 1, 38, "ExampleText",ExpressionUUID->"e3d24805-91b8-487c-8565-c6aa99925d04",
 CellID->1476589212],
Cell[16206, 441, 593, 16, 29, "Input",ExpressionUUID->"55a15ccb-d4c5-4ccb-ad32-13f590214a3b",
 CellID->1527607022],
Cell[16802, 459, 143, 1, 38, "ExampleText",ExpressionUUID->"e23a32b0-1287-435a-a1cc-1f6ba2cb51de",
 CellID->1422128218],
Cell[CellGroupData[{
Cell[16970, 464, 208, 5, 29, "Input",ExpressionUUID->"2a9141ef-3b47-4005-8715-2c4adfd1df6d",
 CellID->215968816],
Cell[17181, 471, 812, 21, 100, "Output",ExpressionUUID->"d253b4b5-e2c4-4540-801d-71954a6c482b",
 CellID->1713176226]
}, Open  ]]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[18247, 502, 2018, 53, 70, "SeeAlsoSection",ExpressionUUID->"672e12a8-05ab-4258-8182-cb2085e0da45"],
Cell[20268, 557, 753, 19, 70, "MoreAboutSection",ExpressionUUID->"afb68625-a995-4346-aeb1-8c12838487e1"],
Cell[21024, 578, 78, 0, 70, "FooterCell",ExpressionUUID->"69eedcb6-4db1-4a57-93a8-fb695d02bd25"]
}
]
*)

(* End of internal cache information *)

