(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     40085,       1078]
NotebookOptionsPosition[     33921,        953]
NotebookOutlinePosition[     36225,       1009]
CellTagsIndexPosition[     36140,       1004]
WindowTitle->M
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "d170a118-a11d-4037-8ff8-2d61bf73c2fe"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "c043d72e-8743-4971-a935-93c233bc7790"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "5e775794-c575-42db-a670-c2067c696ebd"]
         }],ExpressionUUID->"463086bb-7b91-45e0-b365-5bd3951b306c"],
         StripOnInput->False], {"\<\"AtomicState\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/AtomicState"], "\<\"J\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/J"], "\<\"L\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/L"], "\<\"S\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/S"], "\<\"M\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/M"], "\<\"NuclearSpin\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/NuclearSpin"], "\<\"F\"\>":>
        Documentation`HelpLookup["paclet:AtomicDensityMatrix/ref/F"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "9fbe3e0f-0ef8-4019-93bf-2201ca0c1281"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "a6b5e9b8-e55c-4009-bcd1-40c8cde7c3f9"]
         }],ExpressionUUID->"41505714-fa04-4221-8c3d-8b71ed7d9ee9"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "7cd10bc4-9e70-481c-966c-537d457eaaca"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "096da930-64c0-4293-a39a-3de586db1997"]
         }],ExpressionUUID->"a9f16f5b-f0ad-4624-acb4-dd1a10c98852"],
         StripOnInput->False], {"\<\"Specifying the Atomic System\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem"], "\<\
\"Constructing the Hamiltonian\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"Tutorials"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "6b0515bb-1440-46fc-a7af-24512158fdf5"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "0f06b7e7-3169-407f-897e-75b67cd39f74"]
         }],ExpressionUUID->"ed561870-ef09-4243-92d2-fb629202cf5c"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix/ref/M\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/M"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/M.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
             Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$52478], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/M" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "f3d60339-2773-470b-a5d7-a82960815d49"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "982627da-c031-4c92-b4b4-1437b1a74c4c"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"c1d477ab-64a7-413e-93f6-e68d3a7100e1"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"c3683e2a-9307-4670-9b3d-6c4cfa4bcb7f"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "M", "ObjectName",ExpressionUUID->"0a47d481-9716-487a-b20b-acf25f9a3551"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"d6cfe1c1-3a7f-464e-b771-53719146b129"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "4c0af74d-ff5a-4e53-887d-adfdef8a4441"]
    }],ExpressionUUID->"49812aed-2cee-48bb-95cd-d88da43613c0"], Cell[BoxData[
     TooltipBox[
      StyleBox[
       TagBox[
        StyleBox[
         GraphicsBox[InsetBox[
           StyleBox["\<\"NEW IN 13.07\"\>",
            StripOnInput->False,
            FontFamily->"Source Sans Pro",
            FontSize->18,
            FontWeight->"Bold",
            FontSlant->"Italic",
            FontColor->RGBColor[0.968627, 0.466667, 0]], {Right, Center}, {
           Right, Center}],
          ImageSize->{125, 24}], "NewInGraphic",
         StripOnInput->False],
        Deploy,
        DefaultBaseStyle->"Deploy"], "NewInGraphic",
       StripOnInput->False],
      "New in 13.2",
      TooltipDelay->0.3]],
     Magnification->1,ExpressionUUID->
     "609f4882-7b1c-48ef-bfa0-99aef47929dc"]}
  }]], "ObjectNameGrid",
 CacheGraphics->False,ExpressionUUID->"7207f71b-20fc-4f67-a04a-df3be16bddd8"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["M"]], "paclet:AtomicDensityMatrix/ref/M", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "98cf5ee6-05d9-4f71-b507-8e9f97a01333"],
     " \[LineSeparator]is a parameter for ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["AtomicState"]], 
        "paclet:AtomicDensityMatrix/ref/AtomicState", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "ddc33b74-8715-4e7c-83cc-0583e5d3246f"],
     " that specifies the total angular\[Hyphen]momentum projection quantum \
number for the state. "
    }],ExpressionUUID->"fd866588-d9a0-4cac-8c7d-ebeb78712c5e"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       TemplateBox[{
         Cell[
          TextData["M"]], "paclet:AtomicDensityMatrix/ref/M", 
         "AtomicDensityMatrix Package Symbol"},
        "PackageLink",
        BaseStyle->"InlineFormula"], "[", 
       StyleBox["state", "TI"], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "03748e48-18e3-44ec-ab6c-194882954ff5"],
     "\[LineSeparator]returns the value specified for ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["M"]], "paclet:AtomicDensityMatrix/ref/M", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "59274ddb-7e71-4cc7-afe5-d586d66c063b"],
     " in ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["AtomicState"]], 
        "paclet:AtomicDensityMatrix/ref/AtomicState", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "cca2f399-a701-437c-a406-5464bf0ec23d"],
     " ",
     Cell[BoxData[
      StyleBox["state", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "86f25f67-3268-4f2a-9177-2025a5b6e5d2"],
     ", or ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{
         Cell[
          TextData["M"]], "paclet:AtomicDensityMatrix/ref/M", 
         "AtomicDensityMatrix Package Symbol"},
        "PackageLink",
        BaseStyle->"InlineFormula"], "[", 
       RowBox[{
        TemplateBox[{
          Cell[
           TextData["StateLabel"]], 
          "paclet:AtomicDensityMatrix/ref/StateLabel", 
          "AtomicDensityMatrix Package Symbol"},
         "PackageLink",
         BaseStyle->"InlineFormula"], "[", 
        StyleBox["state", "TI"], "]"}], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "f12aae72-7428-445d-be0b-1e19b04b87a7"],
     " if it is not specified. "
    }],ExpressionUUID->"453db966-5637-4e7f-afc0-7ec6c91e7e7a"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"6895656d-04e7-49d9-84f1-8502b754d2ab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"5f6a6017-1d27-459e-8e32-d864171bb673"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"a813fc10-ddcc-484e-af86-c58e1416169f"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"ddc190ce-87b1-4142-aa64-fe94aa783135"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"de9d89bf-3907-4810-89f3-0a5bbd63198e"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->317236638,ExpressionUUID->"9f9b36ef-81a7-4469-89e8-6189d26d6137"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["M"]], "paclet:AtomicDensityMatrix/ref/M", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "09cf6908-1653-4db7-8a94-30302a169fd3"],
 " should be set to integer or half-integer values."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"33ffb16c-3d3d-4747-9501-569c76a56f8e"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["M"]], "paclet:AtomicDensityMatrix/ref/M", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "126400c8-73b2-4e65-ae11-a721485293a8"],
 " is automatically threaded over a list of ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["AtomicState"]], "paclet:AtomicDensityMatrix/ref/AtomicState", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "d2a12953-59be-4581-8706-cc19e0b54144"],
 " objects appearing as its argument."
}], "Notes",
 CellID->123562875,ExpressionUUID->"a8495389-a68b-4b4c-b96d-47eb244eeed2"],

Cell[TextData[{
 "If ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["J"]], "paclet:AtomicDensityMatrix/ref/J", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "23d35fe5-6908-4be2-bd39-9a4dea410717"],
 " is specified for ",
 Cell[BoxData[
  StyleBox["state", "TI"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "f3108c91-6ad5-4c00-882e-2cff7fce4ee0"],
 ", values of ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["M"]], "paclet:AtomicDensityMatrix/ref/M", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "52c5bc00-af95-4c7e-a273-c94744159094"],
 " are automatically assigned to its sublevels returned by ",
 Cell[BoxData[
  RowBox[{
   TemplateBox[{
     Cell[
      TextData["Sublevels"]], "paclet:AtomicDensityMatrix/ref/Sublevels", 
     "AtomicDensityMatrix Package Symbol"},
    "PackageLink",
    BaseStyle->"InlineFormula"], "[", 
   StyleBox["state", "TI"], "]"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "bc41bc14-86e9-407e-9551-05023b360969"],
 "."
}], "Notes",
 CellID->84473524,ExpressionUUID->"c7a19ac3-67fb-46cb-b8cb-534302c2ff49"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "38480d7d-443f-493e-ac26-c99df84595fd"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"3669e42f-bf8e-423d-b35a-b1a665532950"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "85643552-fe87-4cea-b679-f4a05e043a1d"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->1741763012,ExpressionUUID->"c9354c8d-7cd7-42f2-99fa-131d4ff70dcb"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "f71026c6-8dee-4cd8-99f4-e92b2045995a"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"7206d5e9-9b7b-4318-870d-cd83ac181b30"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "ec35fc3a-641e-4db3-9b4f-fb547d98856b"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->1461350427,ExpressionUUID->"dde18da5-9e2c-4050-990c-f920e47b8354"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->110230884,ExpressionUUID->"55fba74d-9b33-4950-9105-abd647993bd8"],

Cell[TextData[{
 "Find the Zeeman sublevels of a state with ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["J"]], "paclet:AtomicDensityMatrix/ref/J", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "65bcebea-7ae2-4ec3-9b12-41359018eec8"],
 " specified:"
}], "ExampleText",
 CellID->154114338,ExpressionUUID->"5fc2ce42-68b1-4fd7-b7ee-af4788e463ed"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", "2"}]}], "]"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->23312004,ExpressionUUID->"3922da5c-f171-4e4f-84fc-f006c00096ee"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "2"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "2"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->644347263,ExpressionUUID->"32fddff3-87d8-4e1e-b153-871d9b0d1bb7"]
}, Open  ]],

Cell[TextData[{
 "Get the ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["M"]], "paclet:AtomicDensityMatrix/ref/M", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "ce65200b-cfab-4892-a6c1-2b57e7467edb"],
 " values from the sublevels: "
}], "ExampleText",
 CellID->105424110,ExpressionUUID->"c858c632-496c-40b4-958d-8745c242e4f9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M", "[", "sys", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->618644920,ExpressionUUID->"14cad2e9-6468-4526-bb5a-dc2501c25e26"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "1", ",", "0", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "2"}]}], "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->1931901067,ExpressionUUID->"662e91ad-ef71-4ff6-93a2-19c2b64280cd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[
  "\t", "ExampleDelimiter",ExpressionUUID->
   "ff63a65d-9206-472c-97a9-a3b4106cc03c"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->18296601,ExpressionUUID->"3eb50ff1-7c4a-432e-8c1e-cabb5cab5dd7"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->156324369,ExpressionUUID->"5fdf4798-9b06-4756-8dbc-8816bf39fee4"],

Cell[TextData[{
 "Find the hyperfine and Zeeman sublevels of a state with ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["J"]], "paclet:AtomicDensityMatrix/ref/J", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "51b75569-7128-4d48-8482-161f68b2e37f"],
 " and ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["NuclearSpin"]], "paclet:AtomicDensityMatrix/ref/NuclearSpin", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "3c4a0c0e-a258-4c05-b9ee-b7893bdd5ae7"],
 " specified:"
}], "ExampleText",
 CellID->418665473,ExpressionUUID->"32153ffa-207e-42f6-985b-8805d5723ea8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", 
       RowBox[{"1", "/", "2"}]}], ",", 
      RowBox[{"NuclearSpin", "\[Rule]", 
       RowBox[{"3", "/", "2"}]}]}], "]"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->108377153,ExpressionUUID->"1209fc42-3dc6-4e16-9987-ade3dc003c0a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "2"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "2"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1655974076,ExpressionUUID->"227025c9-5f13-4775-a9ff-c1fb4cae0d7d"]
}, Open  ]],

Cell[TextData[{
 "Get the ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["M"]], "paclet:AtomicDensityMatrix/ref/M", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "dcc46095-80d7-4707-94a6-dfaf298c670c"],
 " values from the sublevels:"
}], "ExampleText",
 CellID->339390173,ExpressionUUID->"037a85f6-8be3-4307-8f58-6038a27e0855"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M", "[", "sys", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->130203947,ExpressionUUID->"82da5fd7-dba8-4a63-ad3c-dcdb3b2ec5d1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "1", ",", "0", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "2"}], ",", "1", ",", "0", ",", 
   RowBox[{"-", "1"}]}], "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->568230212,ExpressionUUID->"e0e132f5-71f1-434c-9d22-ca56ea8474c0"]
}, Open  ]]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedFunction.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"See", " ", "Also"}], "SeeAlsoSection"]},
      {Cell[TextData[{
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicState"]], 
           "paclet:AtomicDensityMatrix/ref/AtomicState", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "62bae6f6-5422-475a-982c-6e2627573436"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["J"]], "paclet:AtomicDensityMatrix/ref/J", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "b03bcc72-e763-47d0-81c4-deddd8ca2230"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["L"]], "paclet:AtomicDensityMatrix/ref/L", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "61a0efa2-f103-4040-9047-e187ccf72a4a"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["S"]], "paclet:AtomicDensityMatrix/ref/S", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "efb4c970-19de-4b46-9bfc-71987b443d80"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["M"]], "paclet:AtomicDensityMatrix/ref/M", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "52276f92-78e8-492f-a9be-ab039828e20c"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["NuclearSpin"]], 
           "paclet:AtomicDensityMatrix/ref/NuclearSpin", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "52031e30-643d-434e-bd0f-5738f6db8251"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["F"]], "paclet:AtomicDensityMatrix/ref/F", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "ec510b86-7d72-4dab-8224-2d259c60d3ff"]
       }], "SeeAlso",ExpressionUUID->"26ed94c1-b0fd-4269-bd04-8072e875cb48"]}
     }]}
  }]], "SeeAlsoSection",ExpressionUUID->"55f5140a-9a25-4212-89cf-\
9512d95ef640"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox["Tutorials", "TutorialsSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Specifying the Atomic System"]], 
           "paclet:AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "a7020248-cff2-4dcb-ab61-ef265dd27a4d"]}]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Constructing the Hamiltonian"]], 
           "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "6a7ce864-b716-430c-94cd-68e4d03689e9"]}]}
     }]}
  }]], "TutorialsSection",ExpressionUUID->"8a5388de-58f1-484c-a309-\
c04b0a91ba89"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "319bcd1e-c14d-46c2-ab9c-025c63592cd5"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"d566f79b-4f18-41af-8f5e-\
e2dce1620e83"],

Cell[" ", "FooterCell",ExpressionUUID->"8a76d81a-f1be-49c7-b408-362786c490c0"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"M",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}, 
    "NotesSection" -> Closed}, "NewStyles" -> True, 
  "CitationPopupData" -> $Failed, "ShowCitation" -> False, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2023, 4, 18, 17, 59, 42.871190}", 
    "history" -> {"13.07", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "M is a parameter for AtomicState that specifies the total \
angular-momentum projection quantum number for the state. M[state] returns \
the value specified for M in AtomicState state, or M[StateLabel[state]] if it \
is not specified. ", "synonyms" -> {}, "tabletags" -> {}, "title" -> "M", 
    "titlemodifier" -> "", "metadescription" -> "", "windowtitle" -> "M", 
    "type" -> "Symbol", "uri" -> "AtomicDensityMatrix/ref/M"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"f22f3122-c1b0-4ce7-9dd4-c47acb8671bf"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[16827, 452, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"c9354c8d-7cd7-42f2-99fa-131d4ff70dcb",
   CellTags->"PrimaryExamplesSection",
   CellID->1741763012]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 35939, 997}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[573, 21, 6936, 165, 57, "AnchorBarGrid",ExpressionUUID->"c1d477ab-64a7-413e-93f6-e68d3a7100e1",
 CellID->1],
Cell[7512, 188, 102, 0, 23, "ContextNameCell",ExpressionUUID->"c3683e2a-9307-4670-9b3d-6c4cfa4bcb7f"],
Cell[CellGroupData[{
Cell[7639, 192, 1271, 34, 60, "ObjectNameGrid",ExpressionUUID->"7207f71b-20fc-4f67-a04a-df3be16bddd8"],
Cell[8913, 228, 3222, 86, 196, "Usage",ExpressionUUID->"6895656d-04e7-49d9-84f1-8502b754d2ab",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[12172, 319, 1898, 47, 37, "NotesSection",ExpressionUUID->"9f9b36ef-81a7-4469-89e8-6189d26d6137",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->317236638],
Cell[14073, 368, 459, 12, 70, "Notes",ExpressionUUID->"33ffb16c-3d3d-4747-9501-569c76a56f8e",
 CellID->1067943069],
Cell[14535, 382, 813, 22, 70, "Notes",ExpressionUUID->"a8495389-a68b-4b4c-b96d-47eb244eeed2",
 CellID->123562875],
Cell[15351, 406, 1349, 40, 70, "Notes",ExpressionUUID->"c7a19ac3-67fb-46cb-b8cb-534302c2ff49",
 CellID->84473524]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[16827, 452, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"c9354c8d-7cd7-42f2-99fa-131d4ff70dcb",
 CellTags->"PrimaryExamplesSection",
 CellID->1741763012],
Cell[CellGroupData[{
Cell[18242, 493, 1368, 36, 31, "ExampleSection",ExpressionUUID->"dde18da5-9e2c-4050-990c-f920e47b8354",
 CellID->1461350427],
Cell[19613, 531, 183, 3, 29, "Input",ExpressionUUID->"55fba74d-9b33-4950-9105-abd647993bd8",
 CellID->110230884],
Cell[19799, 536, 473, 13, 40, "ExampleText",ExpressionUUID->"5fc2ce42-68b1-4fd7-b7ee-af4788e463ed",
 CellID->154114338],
Cell[CellGroupData[{
Cell[20297, 553, 307, 8, 29, "Input",ExpressionUUID->"3922da5c-f171-4e4f-84fc-f006c00096ee",
 CellID->23312004],
Cell[20607, 563, 935, 26, 55, "Output",ExpressionUUID->"32fddff3-87d8-4e1e-b153-871d9b0d1bb7",
 CellID->644347263]
}, Open  ]],
Cell[21557, 592, 456, 13, 40, "ExampleText",ExpressionUUID->"c858c632-496c-40b4-958d-8745c242e4f9",
 CellID->105424110],
Cell[CellGroupData[{
Cell[22038, 609, 154, 3, 29, "Input",ExpressionUUID->"14cad2e9-6468-4526-bb5a-dc2501c25e26",
 CellID->618644920],
Cell[22195, 614, 240, 6, 37, "Output",ExpressionUUID->"662e91ad-ef71-4ff6-93a2-19c2b64280cd",
 CellID->1931901067]
}, Open  ]],
Cell[CellGroupData[{
Cell[22472, 625, 241, 5, 14, "ExampleDelimiter",ExpressionUUID->"3eb50ff1-7c4a-432e-8c1e-cabb5cab5dd7",
 CellID->18296601],
Cell[22716, 632, 183, 3, 29, "Input",ExpressionUUID->"5fdf4798-9b06-4756-8dbc-8816bf39fee4",
 CellID->156324369],
Cell[22902, 637, 819, 23, 40, "ExampleText",ExpressionUUID->"32153ffa-207e-42f6-985b-8805d5723ea8",
 CellID->418665473],
Cell[CellGroupData[{
Cell[23746, 664, 417, 11, 29, "Input",ExpressionUUID->"1209fc42-3dc6-4e16-9987-ade3dc003c0a",
 CellID->108377153],
Cell[24166, 677, 2554, 71, 148, "Output",ExpressionUUID->"227025c9-5f13-4775-a9ff-c1fb4cae0d7d",
 CellID->1655974076]
}, Open  ]],
Cell[26735, 751, 455, 13, 70, "ExampleText",ExpressionUUID->"037a85f6-8be3-4307-8f58-6038a27e0855",
 CellID->339390173],
Cell[CellGroupData[{
Cell[27215, 768, 154, 3, 70, "Input",ExpressionUUID->"82da5fd7-dba8-4a63-ad3c-dcdb3b2ec5d1",
 CellID->130203947],
Cell[27372, 773, 288, 7, 37, "Output",ExpressionUUID->"e0e132f5-71f1-434c-9d22-ca56ea8474c0",
 CellID->568230212]
}, Open  ]]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[27914, 790, 4036, 108, 70, "SeeAlsoSection",ExpressionUUID->"55f5140a-9a25-4212-89cf-9512d95ef640"],
Cell[31953, 900, 1127, 28, 70, "TutorialsSection",ExpressionUUID->"8a5388de-58f1-484c-a309-c04b0a91ba89"],
Cell[33083, 930, 753, 19, 70, "MoreAboutSection",ExpressionUUID->"d566f79b-4f18-41af-8f5e-e2dce1620e83"],
Cell[33839, 951, 78, 0, 70, "FooterCell",ExpressionUUID->"8a76d81a-f1be-49c7-b408-362786c490c0"]
}
]
*)

(* End of internal cache information *)

