(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     36038,        948]
NotebookOptionsPosition[     30456,        836]
NotebookOutlinePosition[     32835,        893]
CellTagsIndexPosition[     32750,        888]
WindowTitle->NuclearSpin
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "3b9cc575-884a-4910-84ab-304ee2d07eff"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "c622b8c1-a6a7-4c2d-ae8e-6b58b7bd7baf"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "ebecdc51-809d-4628-a45b-148dd5986787"]
         }],ExpressionUUID->"2988c59c-a6c8-477d-a59e-dd927c918042"],
         StripOnInput->False], {"\<\"J\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/J"], "\<\"S\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/S"], "\<\"F\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/F"], "\<\"M\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/M"], "\<\"Sublevels\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/Sublevels"], \
"\<\"AtomicSystemType\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/AtomicSystemType"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "f35d12d3-f871-4c3c-b903-e076a20a1884"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "e8c30684-2d96-4bc5-8779-d9aa1e4867bb"]
         }],ExpressionUUID->"2fe23969-2110-4e22-af34-7d748bad43a6"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "cc027c32-22c8-4d84-ba12-a25cab55c753"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "9ffbc6bb-7f42-423b-ba6c-c1e9a8c7626c"]
         }],ExpressionUUID->"2763efc7-9d21-4e27-b2f7-e092fc89e2f0"],
         StripOnInput->False], {"\<\"Specifying the Atomic System\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem"], "\<\
\"Constructing the Hamiltonian\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"Tutorials"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "921331ca-19e9-42a1-9300-f778f11375d2"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "83127fe8-5ae2-4d26-8af3-4cc534fdba40"]
         }],ExpressionUUID->"516c47fc-67a3-4ea6-bea1-7788f1f4ab84"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix/ref/NuclearSpin\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/NuclearSpin"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/NuclearSpin.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$53592], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/NuclearSpin" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "d044b87e-8f42-4983-bbfa-2d37e5508f6f"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "cb521937-ba6e-44b2-a30d-d668450fdb95"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"916fc846-bad0-4e05-aad4-b822bd4d153c"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"d653a52d-f736-4670-8767-3d8782b0ae7f"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "NuclearSpin", "ObjectName",ExpressionUUID->
      "2cf4eafb-3639-4bfc-8725-fea6a0b3a6af"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"5beba44e-30c4-4168-9e54-94b8642d1647"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "ab5d1d7e-80b4-477a-8671-e7c78cc165dd"]
    }],ExpressionUUID->"3e470c31-6dc6-4fdf-80a0-33e69f9ef6dd"], Cell[BoxData[
     TooltipBox[
      StyleBox[
       TagBox[
        StyleBox[
         GraphicsBox[InsetBox[
           StyleBox["\<\"NEW IN 13.07\"\>",
            StripOnInput->False,
            FontFamily->"Source Sans Pro",
            FontSize->18,
            FontWeight->"Bold",
            FontSlant->"Italic",
            FontColor->RGBColor[0.968627, 0.466667, 0]], {Right, Center}, {
           Right, Center}],
          ImageSize->{125, 24}], "NewInGraphic",
         StripOnInput->False],
        Deploy,
        DefaultBaseStyle->"Deploy"], "NewInGraphic",
       StripOnInput->False],
      "New in 13.2",
      TooltipDelay->0.3]],
     Magnification->1,ExpressionUUID->
     "83bed133-feeb-4149-a0f3-b78bda36f19b"]}
  }]], "ObjectNameGrid",
 CacheGraphics->False,ExpressionUUID->"c9ffe1a7-c0cb-4bb0-acd2-64f44e12f5c7"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["NuclearSpin"]], 
        "paclet:AtomicDensityMatrix/ref/NuclearSpin", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "8e11e5ba-ffbd-4be5-8569-500e226c2ae6"],
     " \[LineSeparator]is a parameter for ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["AtomicState"]], 
        "paclet:AtomicDensityMatrix/ref/AtomicState", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "d7e97130-461b-42ac-a09c-8fbcb8dd4506"],
     " that specifies the nuclear angular\[Hyphen]momentum quantum number for \
the atom. "
    }],ExpressionUUID->"1e3e37a7-acc4-4184-89e0-ad8ae5141dfc"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       TemplateBox[{
         Cell[
          TextData["NuclearSpin"]], 
         "paclet:AtomicDensityMatrix/ref/NuclearSpin", 
         "AtomicDensityMatrix Package Symbol"},
        "PackageLink",
        BaseStyle->"InlineFormula"], "[", 
       StyleBox["state", "TI"], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "06ea2bfe-6bd9-4b98-b0ee-f9f00984e74e"],
     "\[LineSeparator]returns the value specified for ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["NuclearSpin"]], 
        "paclet:AtomicDensityMatrix/ref/NuclearSpin", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "a3cf1fc7-9fca-4af8-8386-822f9b2d304b"],
     " in ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["AtomicState"]], 
        "paclet:AtomicDensityMatrix/ref/AtomicState", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "2325e99f-3ee2-4e4b-984b-9430c7ba65c9"],
     " ",
     Cell[BoxData[
      StyleBox["state", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "7ba14f72-27d6-47f0-ba3d-4a0fe3a375e6"],
     ", or ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{
         Cell[
          TextData["NuclearSpin"]], 
         "paclet:AtomicDensityMatrix/ref/NuclearSpin", 
         "AtomicDensityMatrix Package Symbol"},
        "PackageLink",
        BaseStyle->"InlineFormula"], "[", 
       RowBox[{
        TemplateBox[{
          Cell[
           TextData["StateLabel"]], 
          "paclet:AtomicDensityMatrix/ref/StateLabel", 
          "AtomicDensityMatrix Package Symbol"},
         "PackageLink",
         BaseStyle->"InlineFormula"], "[", 
        StyleBox["state", "TI"], "]"}], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "1dc861c5-0d1b-4f86-af42-6199ca3e071e"],
     " if it is not specified. "
    }],ExpressionUUID->"4a7679b3-d26c-42fe-8a2f-b1a495adb0ca"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"2df4b8a0-308b-4076-b8c1-150982f39e7c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"8fc6b563-5950-4ce4-abc4-84c98602b60f"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"4d1acfa2-af7f-4beb-8e8e-cd77aa40e2e0"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"1c873f17-f9ad-4784-b3df-cb822cda57c0"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"ba78704e-90b4-4edd-aba7-4d2215f66579"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->279041764,ExpressionUUID->"59accbe1-85fe-4d79-a429-e932b6733bd3"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["NuclearSpin"]], "paclet:AtomicDensityMatrix/ref/NuclearSpin", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "cae48d3d-d3af-4813-8253-1ed149a6c344"],
 " should be set to integer or half-integer values."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"c5643337-2102-4797-8a9f-a1ddf9ab7e73"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["NuclearSpin"]], "paclet:AtomicDensityMatrix/ref/NuclearSpin", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "5fc1141f-f9e8-43aa-a08f-a63e07bd4017"],
 " is automatically threaded over a list of ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["AtomicState"]], "paclet:AtomicDensityMatrix/ref/AtomicState", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "4ab70116-85ac-44db-8a9f-af6414b2aa40"],
 " objects appearing as its argument."
}], "Notes",
 CellID->262012501,ExpressionUUID->"d69f5eaf-7b0b-4de3-84bb-6f740d9424e6"],

Cell[TextData[{
 "An atomic state with ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["NuclearSpin"]], "paclet:AtomicDensityMatrix/ref/NuclearSpin", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "e57df3af-d9e7-48b9-a363-683e01ff35be"],
 " specified is considered to be part of an atomic system of type ",
 Cell[BoxData["\"\<HyperfineZeeman\>\""], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "8cf34f1c-e3c0-4245-b573-f291a05de53c"],
 ", and ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["Sublevels"]], "paclet:AtomicDensityMatrix/ref/Sublevels", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "8591cc89-1d08-4140-8296-6bcb4a0a1d5a"],
 " will expand it to its list of hyperfine and Zeeman sublevels."
}], "Notes",
 CellID->176497880,ExpressionUUID->"4daa1831-da59-431a-875e-c64c0accfb3c"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "e8890c66-d942-4776-83ea-354767dc938d"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"02f41cfb-b86c-446e-b9dd-93b854c7c5cd"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "b64e5b0d-0223-4922-8c81-7389dbf8d0f0"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->1898126147,ExpressionUUID->"3ca5215c-6320-45b0-ab01-10105007d70e"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "163ab553-a431-4877-a625-e8219a71101c"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"91ffa898-aa31-463b-a3f6-2c142bdb7e75"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "2e5d0f90-e655-4887-839d-5cc1b0adbb23"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->936576444,ExpressionUUID->"811dc242-95d1-4d38-b969-b716480a3b5a"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->379932833,ExpressionUUID->"dd31f10e-440e-431d-b804-c1cacb748c5e"],

Cell[TextData[{
 "Find the hyperfine and Zeeman sublevels of a state with ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["J"]], "paclet:AtomicDensityMatrix/ref/J", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "72b22957-4d52-4fd0-a17a-4d4e63a41b84"],
 " and ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["NuclearSpin"]], "paclet:AtomicDensityMatrix/ref/NuclearSpin", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "fba62729-ea08-411d-8d59-7f824537383a"],
 " specified:"
}], "ExampleText",
 CellID->418665473,ExpressionUUID->"8edae5e7-d6eb-4a6d-ad98-f40b85a13e14"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", 
       RowBox[{"1", "/", "2"}]}], ",", 
      RowBox[{"NuclearSpin", "\[Rule]", 
       RowBox[{"3", "/", "2"}]}]}], "]"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->108377153,ExpressionUUID->"84b314f4-61c3-4853-83b0-833303d2896a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "2"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "2"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->313217444,ExpressionUUID->"8afa6558-0b7d-4ce4-849d-23c75ed99b42"]
}, Open  ]],

Cell["Get the nuclear spin values from the sublevels:", "ExampleText",
 CellID->339390173,ExpressionUUID->"ef2cbcac-f039-4df6-ad5a-3cdbe86d9d5a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NuclearSpin", "[", "sys", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->130203947,ExpressionUUID->"2d31098e-c6af-4aec-a733-4049afb49536"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["3", "2"], ",", 
   FractionBox["3", "2"], ",", 
   FractionBox["3", "2"], ",", 
   FractionBox["3", "2"], ",", 
   FractionBox["3", "2"], ",", 
   FractionBox["3", "2"], ",", 
   FractionBox["3", "2"], ",", 
   FractionBox["3", "2"]}], "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->763162511,ExpressionUUID->"6f380b28-d047-459a-9b79-3de5b7e59648"]
}, Open  ]],

Cell["This is a hyperfine-Zeeman system:", "ExampleText",
 CellID->381930195,ExpressionUUID->"5a01fdf2-0081-4619-9f99-2901da658f4f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AtomicSystemType", "[", "sys", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->140506746,ExpressionUUID->"1d065432-bf45-449d-bc3f-57bff8e89af8"],

Cell[BoxData["\<\"HyperfineZeeman\"\>"], "Output",
 CellLabel->"Out[4]=",
 CellID->1699982493,ExpressionUUID->"573099c9-6e7e-43b0-bb11-b39a5a443138"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedFunction.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"See", " ", "Also"}], "SeeAlsoSection"]},
      {Cell[TextData[{
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["J"]], "paclet:AtomicDensityMatrix/ref/J", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "eb611f5e-efec-4f18-9ba7-bb3e922af5b7"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["S"]], "paclet:AtomicDensityMatrix/ref/S", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "f2e54320-1390-452c-bcd6-b24e2abd384b"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["F"]], "paclet:AtomicDensityMatrix/ref/F", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "33dd256c-698d-45c7-8750-470e559092e3"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["M"]], "paclet:AtomicDensityMatrix/ref/M", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "9f6c07fc-08f8-4230-97e9-4fa0c340dc9f"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Sublevels"]], 
           "paclet:AtomicDensityMatrix/ref/Sublevels", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "e602578a-ae36-4252-98c5-5d22ba483bca"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicSystemType"]], 
           "paclet:AtomicDensityMatrix/ref/AtomicSystemType", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "6bf400af-8446-4872-8f6d-3ad090f1f107"]
       }], "SeeAlso",ExpressionUUID->"4a633f8d-4a08-4c8c-bd5a-818207f1699a"]}
     }]}
  }]], "SeeAlsoSection",ExpressionUUID->"17de8778-fa9e-4a97-96d2-\
d6261357ca00"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox["Tutorials", "TutorialsSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Specifying the Atomic System"]], 
           "paclet:AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "6e47b873-4441-4ba4-8158-aa5d173f40b0"]}]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Constructing the Hamiltonian"]], 
           "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "5158748d-43f6-4499-81c5-e33d60827015"]}]}
     }]}
  }]], "TutorialsSection",ExpressionUUID->"7fc2c8eb-7369-4170-b70e-\
9497cec4c3f3"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "ba02dfd5-2416-4cfe-b7b4-253a4b81ad11"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"584865ce-fa1f-45db-8764-\
65b821d4da6e"],

Cell[" ", "FooterCell",ExpressionUUID->"1bdebd42-4d9d-4aa1-a575-da90908de17f"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"NuclearSpin",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}, 
    "NotesSection" -> Closed}, "NewStyles" -> True, 
  "CitationPopupData" -> $Failed, "ShowCitation" -> False, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2023, 4, 18, 17, 59, 44.218273}", 
    "history" -> {"13.07", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "NuclearSpin is a parameter for AtomicState that specifies the nuclear \
angular-momentum quantum number for the atom. NuclearSpin[state] returns the \
value specified for NuclearSpin in AtomicState state, or \
NuclearSpin[StateLabel[state]] if it is not specified. ", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "NuclearSpin", "titlemodifier" -> "", 
    "metadescription" -> "", "windowtitle" -> "NuclearSpin", "type" -> 
    "Symbol", "uri" -> "AtomicDensityMatrix/ref/NuclearSpin"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"cd72c697-cc59-451c-8040-9e495b4fd861"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[16682, 443, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"3ca5215c-6320-45b0-ab01-10105007d70e",
   CellTags->"PrimaryExamplesSection",
   CellID->1898126147]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 32549, 881}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[583, 21, 6899, 164, 57, "AnchorBarGrid",ExpressionUUID->"916fc846-bad0-4e05-aad4-b822bd4d153c",
 CellID->1],
Cell[7485, 187, 102, 0, 23, "ContextNameCell",ExpressionUUID->"d653a52d-f736-4670-8767-3d8782b0ae7f"],
Cell[CellGroupData[{
Cell[7612, 191, 1288, 35, 60, "ObjectNameGrid",ExpressionUUID->"c9ffe1a7-c0cb-4bb0-acd2-64f44e12f5c7"],
Cell[8903, 228, 3330, 90, 196, "Usage",ExpressionUUID->"2df4b8a0-308b-4076-b8c1-150982f39e7c",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[12270, 323, 1898, 47, 37, "NotesSection",ExpressionUUID->"59accbe1-85fe-4d79-a429-e932b6733bd3",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->279041764],
Cell[14171, 372, 479, 12, 70, "Notes",ExpressionUUID->"c5643337-2102-4797-8a9f-a1ddf9ab7e73",
 CellID->1067943069],
Cell[14653, 386, 833, 22, 70, "Notes",ExpressionUUID->"d69f5eaf-7b0b-4de3-84bb-6f740d9424e6",
 CellID->262012501],
Cell[15489, 410, 1066, 27, 70, "Notes",ExpressionUUID->"4daa1831-da59-431a-875e-c64c0accfb3c",
 CellID->176497880]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[16682, 443, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"3ca5215c-6320-45b0-ab01-10105007d70e",
 CellTags->"PrimaryExamplesSection",
 CellID->1898126147],
Cell[CellGroupData[{
Cell[18097, 484, 1367, 36, 31, "ExampleSection",ExpressionUUID->"811dc242-95d1-4d38-b969-b716480a3b5a",
 CellID->936576444],
Cell[19467, 522, 183, 3, 29, "Input",ExpressionUUID->"dd31f10e-440e-431d-b804-c1cacb748c5e",
 CellID->379932833],
Cell[19653, 527, 819, 23, 40, "ExampleText",ExpressionUUID->"8edae5e7-d6eb-4a6d-ad98-f40b85a13e14",
 CellID->418665473],
Cell[CellGroupData[{
Cell[20497, 554, 417, 11, 29, "Input",ExpressionUUID->"84b314f4-61c3-4853-83b0-833303d2896a",
 CellID->108377153],
Cell[20917, 567, 2553, 71, 148, "Output",ExpressionUUID->"8afa6558-0b7d-4ce4-849d-23c75ed99b42",
 CellID->313217444]
}, Open  ]],
Cell[23485, 641, 145, 1, 38, "ExampleText",ExpressionUUID->"ef2cbcac-f039-4df6-ad5a-3cdbe86d9d5a",
 CellID->339390173],
Cell[CellGroupData[{
Cell[23655, 646, 164, 3, 29, "Input",ExpressionUUID->"2d31098e-c6af-4aec-a733-4049afb49536",
 CellID->130203947],
Cell[23822, 651, 407, 12, 52, "Output",ExpressionUUID->"6f380b28-d047-459a-9b79-3de5b7e59648",
 CellID->763162511]
}, Open  ]],
Cell[24244, 666, 132, 1, 38, "ExampleText",ExpressionUUID->"5a01fdf2-0081-4619-9f99-2901da658f4f",
 CellID->381930195],
Cell[CellGroupData[{
Cell[24401, 671, 169, 3, 29, "Input",ExpressionUUID->"1d065432-bf45-449d-bc3f-57bff8e89af8",
 CellID->140506746],
Cell[24573, 676, 149, 2, 37, "Output",ExpressionUUID->"573099c9-6e7e-43b0-bb11-b39a5a443138",
 CellID->1699982493]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[24964, 687, 3521, 94, 70, "SeeAlsoSection",ExpressionUUID->"17de8778-fa9e-4a97-96d2-d6261357ca00"],
Cell[28488, 783, 1127, 28, 70, "TutorialsSection",ExpressionUUID->"7fc2c8eb-7369-4170-b70e-9497cec4c3f3"],
Cell[29618, 813, 753, 19, 70, "MoreAboutSection",ExpressionUUID->"584865ce-fa1f-45db-8764-65b821d4da6e"],
Cell[30374, 834, 78, 0, 70, "FooterCell",ExpressionUUID->"1bdebd42-4d9d-4aa1-a575-da90908de17f"]
}
]
*)

(* End of internal cache information *)

