(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     35716,        950]
NotebookOptionsPosition[     29781,        831]
NotebookOutlinePosition[     32041,        887]
CellTagsIndexPosition[     31956,        882]
WindowTitle->Parameterization
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "f5e4f5e7-ecca-4a53-9cba-e7e14e78de02"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "2a353633-c6e2-455d-ab35-d89231bf7cb4"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "2bd347ef-7b60-4d43-9daa-60fab6a4bb50"]
         }],ExpressionUUID->"94be43b9-ac52-4302-a588-2d70b82f45e8"],
         StripOnInput->False], {"\<\"OpticalField\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/OpticalField"], "\<\"Observables\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/Observables"], \
"\<\"PolarizationComponents\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/PolarizationComponents"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "e9caab1d-e575-4fb6-90eb-8a7027cdc968"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "bcc78d04-9e6b-48f2-8913-a3e67be407f9"]
         }],ExpressionUUID->"e19538ef-57ac-4046-9784-d446a00d03c0"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "be9b8819-b59c-4af0-8e50-b4cf180f0aca"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "dea5cd11-f676-47b5-b190-8a63b245bbaf"]
         }],ExpressionUUID->"eb5e7218-d152-43b0-a4db-0286df1af743"],
         StripOnInput->False], {"\<\"Light Polarization Demonstration\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/LightPolarizationDemonstration"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"Tutorials"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "3cdf84d7-bedf-444f-8c6a-7c802389452f"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "24f8c33f-17cb-449b-b55f-c69b36a20df2"]
         }],ExpressionUUID->"79fd3cdd-dd6c-4d4a-a5e2-db718c265f2f"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/ref/Parameterization\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/Parameterization"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/Parameterization.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$56113], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/Parameterization" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "76195843-db85-4e1e-a2b4-fb96b28eb821"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "4cf8abe4-144a-4432-aaeb-10e225eb9c76"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"3c93c5b2-68ff-4126-8dec-cfe4a6a385ce"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"a359c6af-443b-4ffc-92f2-cd1765c802d4"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "Parameterization", "ObjectName",ExpressionUUID->
      "b55c89c8-172b-4bb0-9322-e7da3a46fac2"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"863f06c4-5606-4e56-bded-363b6ba31d67"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "e4016418-4f4b-40af-8097-8cbedea8a7dd"]
    }],ExpressionUUID->"07d110ac-e82e-41d5-a772-cee276e6cf55"], 
    "\[SpanFromLeft]"}
  }]], "ObjectNameGrid",ExpressionUUID->"5f33263a-fe64-47fc-b4d5-\
3af3d3a22726"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["Parameterization"], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "7b7a1958-4f27-44b0-9a46-7a09ac7da173"],
     " \[LineSeparator]is an option for ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["OpticalField"]], 
        "paclet:AtomicDensityMatrix/ref/OpticalField", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "b737c8eb-4bba-452d-bf35-adb2bc8e58a8"],
     " and related functions that specifies the parameterization used to \
describe the light polarization. "
    }],ExpressionUUID->"a672f8e6-c600-494d-b8e2-576be2385bb6"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"a2fbe3fa-c812-459e-b9fc-92ca85e776eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"c5310563-f7d0-4104-830e-160578b978e0"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"e4cce9cf-21a8-41ae-a3b4-95fe338ce392"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"6e84d214-68b2-4329-8b79-ebad68f8dcd6"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"0817b631-1d2a-4844-b056-a189960c0e1e"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->1034221638,ExpressionUUID->"3ae89abe-8038-49a6-a3e1-33a3330e7986"],

Cell[TextData[{
 "Possible settings for ",
 Cell[BoxData["Parameterization"], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "4db70e34-a93c-4129-a3a0-048ff951ecc1"],
 " include:"
}], "Notes",
 CellID->1067943069,ExpressionUUID->"c845019a-a1a2-44ca-93ed-b216bd171415"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "4827a157-9385-42f2-a264-b7765a2fd86d"], "\"\<AngleEllipticity\>\"", 
    Cell[TextData[Cell[BoxData[
     RowBox[{"{", 
      RowBox[{
       StyleBox["\[Alpha]", "TR"], ",", 
       StyleBox["\[Epsilon]", "TR"]}], "}"}]], "InlineFormula",
     FontFamily->"Source Sans Pro",ExpressionUUID->
     "1f587aa8-8810-4aec-b596-3d4c44d2b0f6"]], "TableText",ExpressionUUID->
     "19456f31-eb13-43a4-bc36-dfc3b494286b"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "54a47971-448b-460f-8458-f8773ad4c84b"], "\"\<RatioPhase\>\"", Cell[
    TextData[Cell[BoxData[
     RowBox[{"{", 
      RowBox[{
       StyleBox["\[Chi]", "TR"], ",", 
       StyleBox["\[Phi]", "TR"]}], "}"}]], "InlineFormula",
     FontFamily->"Source Sans Pro",ExpressionUUID->
     "04567796-6290-41fb-90cf-442684fc0bb2"]], "TableText",ExpressionUUID->
     "a5e2407b-52ed-41ad-983a-42ad337371cc"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "a6f7b402-124b-4f20-af94-e33f5d8b7e39"], "\"\<Stokes\>\"", Cell[TextData[
    Cell[BoxData[
     RowBox[{"{", 
      RowBox[{
       SubscriptBox[
        StyleBox["s", "TI"], 
        StyleBox["1", "TR"]], ",", 
       SubscriptBox[
        StyleBox["s", "TI"], 
        StyleBox["2", "TR"]], ",", 
       SubscriptBox[
        StyleBox["s", "TI"], 
        StyleBox["3", "TR"]]}], "}"}]], "InlineFormula",
     FontFamily->"Source Sans Pro",ExpressionUUID->
     "d91dc923-6aae-4056-8ee7-968c64340c6a"]], "TableText",ExpressionUUID->
     "fc956f54-7627-4700-9210-db60d5decd25"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{"Columns" -> {{None}}, "Rows" -> {None, None, {None}}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True}}}},
 CellID->739121194,ExpressionUUID->"a9d5807b-732f-44a5-aa92-b2c7016044cc"],

Cell[TextData[{
 "In the ",
 Cell[BoxData["\"\<AngleEllipticity\>\""], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "b5c54469-dd04-4117-92b0-8f855443c124"],
 " parameterization, the polarization parameters are specified as ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    StyleBox["\[Alpha]", "TR"], ",", 
    StyleBox["\[Epsilon]", "TR"]}], "}"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "2c56bf52-a14f-4887-9b82-c939316e0260"],
 ", where ",
 Cell[BoxData[
  StyleBox["\[Alpha]", "TR"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "d8e1b72b-92b7-4549-b537-5c7b55c3cf86"],
 " is the polarization angle (relative to ",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["e", "^"], 
   StyleBox["1", "TR"]]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "07a5a311-a57d-4a0f-b237-9725f033cba5"],
 " with respect to rotation about ",
 Cell[BoxData[
  OverscriptBox[
   StyleBox["k", "TI"], "^"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "2fb98fde-06db-4410-821d-7557e683400f"],
 ") and ",
 Cell[BoxData[
  StyleBox["\[Epsilon]", "TR"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "f2470e46-fc43-4b28-a80e-76482c23e78e"],
 " is the ellipticity. If instead of a list a single value is specified, it \
is taken as the value of ",
 Cell[BoxData[
  StyleBox["\[Alpha]", "TR"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "2d9faa5b-602a-416d-be47-995ea3ae1f68"],
 ", with ",
 Cell[BoxData[
  StyleBox["\[Epsilon]", "TR"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "8a0c6119-3538-4e89-a2b3-e863f77d44c1"],
 " assumed to be zero."
}], "Notes",
 CellID->67102925,ExpressionUUID->"17040c73-1737-4ca3-85f0-4585fe5cec42"],

Cell[TextData[{
 "In the ",
 Cell[BoxData["\"\<RatioPhase\>\""], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "f9ca50b2-5bfd-4f18-b9e3-13fd457881ac"],
 " parameterization, the polarization parameters are specified as ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    StyleBox["\[Chi]", "TR"], ",", 
    StyleBox["\[Phi]", "TR"]}], "}"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "838a8181-16e7-424e-9188-8895d17e59e6"],
 ", where ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"tan", "(", "\[Chi]", ")"}], "=", 
    RowBox[{
     SubscriptBox["a", "2"], "/", 
     SubscriptBox["a", "1"]}]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"af32e976-4769-4b74-84b0-8326eef9ab05"],
 ", and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", "1"], TraditionalForm]], "InlineMath",ExpressionUUID->
  "d700e8f2-f295-4c30-8be9-3804537baa4c"],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", "2"], TraditionalForm]], "InlineMath",ExpressionUUID->
  "08d08ac1-6188-4591-8943-f0e21b726092"],
 " are the field amplitudes of the components along ",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["e", "^"], 
   StyleBox["1", "TR"]]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "25b1a0fa-6d09-4b8d-af10-4093394dce8c"],
 " and ",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["e", "^"], "2"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "c9bb8d15-3128-432e-9255-09d0b04fe071"],
 ", respectively, and \[Phi] is the relative phase angle between the \
components. If instead of a list a single value is specified, it is taken as \
the value of ",
 Cell[BoxData[
  StyleBox["\[Chi]", "TR"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "fd59f139-60d6-4fef-8390-1b7647f747ff"],
 ", with ",
 Cell[BoxData[
  StyleBox["\[Phi]", "TR"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "40f51d29-0a58-48c3-9ec5-0ef224c2f052"],
 " assumed to be zero."
}], "Notes",
 CellID->169132515,ExpressionUUID->"9121b8ea-5e77-44a0-b930-937454719641"],

Cell[TextData[{
 "In the ",
 Cell[BoxData["\"\<Stokes\>\""], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "22dcca76-a87e-4a55-9709-9c6c2eb6fa16"],
 " parameterization, the polarization parameters are specified as ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    SubscriptBox[
     StyleBox["s", "TI"], "1"], ",", 
    SubscriptBox[
     StyleBox["s", "TI"], "2"], ",", 
    SubscriptBox[
     StyleBox["s", "TI"], "3"]}], "}"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "068e2364-4e9e-42d4-8351-d4ce2b39eb94"],
 ", where ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["s", "TI"], "1"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "5836fe07-e427-4708-b3f3-654f6ce54e7c"],
 ", ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["s", "TI"], 
   StyleBox["2", "TR"]]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "5a25209d-5180-4f6a-83e7-d74532545d7c"],
 ", and ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["s", "TI"], 
   StyleBox["3", "TR"]]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "3445caf0-758c-4e0f-afc6-0b23ce2bbc07"],
 " are the normalized Stokes parameters relative to the axes ",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["e", "^"], 
   StyleBox["1", "TR"]]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "c3f78758-baab-4f84-9d03-72d68f0c9b94"],
 " and ",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["e", "^"], "2"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "41a599e5-9f81-4f9a-894e-032424d3bcbd"],
 "."
}], "Notes",
 CellID->659303226,ExpressionUUID->"d1358339-a276-4ba1-bf0a-b57cf5faa124"],

Cell[TextData[{
 "A value of ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["Automatic"]], "paclet:ref/Automatic"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "a089705e-5c85-4b13-98cc-15955c5cdb86"],
 " means that the default value for ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["OpticalField"]], "paclet:AtomicDensityMatrix/ref/OpticalField",
     "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "e7fe92f7-c223-49a6-aba8-8bb069e14488"],
 " is used."
}], "Notes",
 CellID->1779052493,ExpressionUUID->"e6d69161-572e-479a-bf00-64b0d05d081c"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "33e4d791-7eb5-4b25-af11-bc355212d24e"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"221ac67c-817d-4d09-8273-6fa58601bf19"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "20716583-5c1e-4121-a820-ae0cc1a05816"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->430431048,ExpressionUUID->"df08648f-1e23-4db0-b01a-95661279dfb8"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "cbacd0fa-0c6f-4626-81bf-334444293620"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"7b36860f-123b-4048-8905-9ea938fc4a4a"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "daa592c3-985d-4c00-9ca5-b849c3cf964d"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->1529700640,ExpressionUUID->"b71009af-60d1-47ed-8a96-252f1d912473"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2054036296,ExpressionUUID->"7001f672-a4b1-4f32-8947-4906886aa41e"],

Cell[TextData[{
 "The default value is ",
 Cell[BoxData["\"\<AngleEllipticity\>\""], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "7e412a08-7936-4a55-80ba-559dd5fca968"],
 ":"
}], "ExampleText",
 CellID->1388401347,ExpressionUUID->"13389abf-7d8e-493f-8900-17d59617220a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{"\[Omega]", ",", "E0", ",", 
   RowBox[{"{", 
    RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->295891880,ExpressionUUID->"611df36f-0f1b-4401-a4dc-11da2123ad9d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", "E0",
     " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", "E0",
     " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], "+", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}], ",", "0"}], 
  "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1977061076,ExpressionUUID->"37cbb42f-c9e9-42a5-a3dc-a6dbfe7375d5"]
}, Open  ]],

Cell["Specify polarization using the ratio-phase parameterization:", \
"ExampleText",
 CellID->5650014,ExpressionUUID->"67d0a61b-af19-4ff4-9089-178fe84f79bd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{"\[Omega]", ",", "E0", ",", 
   RowBox[{"{", 
    RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], ",", 
   RowBox[{"Parameterization", "\[Rule]", "\"\<RatioPhase\>\""}]}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->47645834,ExpressionUUID->"7edfb49e-8929-437b-9280-810143309d73"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", "E0",
     " ", 
    RowBox[{"Cos", "[", "\[Chi]", "]"}]}], ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"\[ImaginaryI]", " ", "\[Phi]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]}]], " ", "E0", " ", 
    RowBox[{"Sin", "[", "\[Chi]", "]"}]}], ",", "0"}], "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->2045445057,ExpressionUUID->"fb47f558-49eb-48f4-9d86-00d94bd18f54"]
}, Open  ]],

Cell["Specify polarization using the Stokes parameterization:", "ExampleText",
 CellID->65390182,ExpressionUUID->"693c9b86-8029-47ab-adb4-ca192f69ff51"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{"\[Omega]", ",", "E0", ",", 
   RowBox[{"{", 
    RowBox[{"s1", ",", "s2", ",", "s3"}], "}"}], ",", 
   RowBox[{"Parameterization", "\[Rule]", "\"\<Stokes\>\""}]}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->331923263,ExpressionUUID->"09f4aa8a-f34f-4012-bf66-d421439ada0d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
     "E0", " ", 
     SqrtBox[
      RowBox[{"1", "+", "s1"}]]}], 
    SqrtBox["2"]], ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}], "+", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"ArcTan", "[", 
        RowBox[{"s2", ",", "s3"}], "]"}]}]}]], " ", "E0", " ", 
    SqrtBox[
     RowBox[{
      FractionBox["1", "2"], "-", 
      FractionBox["s1", "2"]}]]}], ",", "0"}], "}"}]], "Output",
 CellLabel->"Out[4]=",
 CellID->940945970,ExpressionUUID->"074404a1-b26a-4856-9237-1066dd5fff37"]
}, Open  ]],

Cell["", "ExampleText",
 CellID->1882183985,ExpressionUUID->"49760aab-ec59-4411-b1a2-4480a8629b88"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedFunction.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"See", " ", "Also"}], "SeeAlsoSection"]},
      {Cell[TextData[{
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["OpticalField"]], 
           "paclet:AtomicDensityMatrix/ref/OpticalField", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "78b859b4-6e73-427d-97a5-d6cc48e6ea80"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Observables"]], 
           "paclet:AtomicDensityMatrix/ref/Observables", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "8a98ccd9-567e-4388-b05b-4cfb710aea40"]
       }], "SeeAlso",ExpressionUUID->"15cba482-36fb-4c05-ac42-8643b5248462"]}
     }]}
  }]], "SeeAlsoSection",ExpressionUUID->"f044b862-4f0b-4e2a-8ea9-\
5cb2c9622f58"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox["Tutorials", "TutorialsSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Light Polarization Demonstration"]], 
           "paclet:AtomicDensityMatrix/tutorial/\
LightPolarizationDemonstration"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "0391e33b-1e3a-4006-ae17-7594095e18a2"]}]}
     }]}
  }]], "TutorialsSection",ExpressionUUID->"aa1a61a7-6723-4031-a6fc-\
1d715b3c78f3"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "ae84a476-63de-473a-8889-db0eec24d3d1"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"bc708200-11b5-475e-b93b-\
70e61148ec44"],

Cell[" ", "FooterCell",ExpressionUUID->"736b2f76-95d0-4f61-8a62-7adbd2686222"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Parameterization",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}, 
    "NotesSection" -> Closed}, "NewStyles" -> True, 
  "CitationPopupData" -> $Failed, "ShowCitation" -> False, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2023, 4, 18, 17, 59, 48.100699}", 
    "history" -> {"18.09", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "Parameterization is an option for OpticalField and related functions \
that specifies the parameterization used to describe the light polarization. \
", "synonyms" -> {}, "tabletags" -> {}, "title" -> "Parameterization", 
    "titlemodifier" -> "", "metadescription" -> "", "windowtitle" -> 
    "Parameterization", "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/Parameterization"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"502345af-ac8e-468f-8753-b5c78f6fa3db"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[19263, 522, 1389, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"df08648f-1e23-4db0-b01a-95661279dfb8",
   CellTags->"PrimaryExamplesSection",
   CellID->430431048]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 31756, 875}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[588, 21, 6564, 158, 57, "AnchorBarGrid",ExpressionUUID->"3c93c5b2-68ff-4126-8dec-cfe4a6a385ce",
 CellID->1],
Cell[7155, 181, 102, 0, 23, "ContextNameCell",ExpressionUUID->"a359c6af-443b-4ffc-92f2-cd1765c802d4"],
Cell[CellGroupData[{
Cell[7282, 185, 559, 14, 60, "ObjectNameGrid",ExpressionUUID->"5f33263a-fe64-47fc-b4d5-3af3d3a22726"],
Cell[7844, 201, 879, 20, 114, "Usage",ExpressionUUID->"a2fbe3fa-c812-459e-b9fc-92ca85e776eb",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[8760, 226, 1899, 47, 37, "NotesSection",ExpressionUUID->"3ae89abe-8038-49a6-a3e1-33a3330e7986",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1034221638],
Cell[10662, 275, 288, 7, 70, "Notes",ExpressionUUID->"c845019a-a1a2-44ca-93ed-b216bd171415",
 CellID->1067943069],
Cell[10953, 284, 1848, 42, 70, "2ColumnTableMod",ExpressionUUID->"a9d5807b-732f-44a5-aa92-b2c7016044cc",
 CellID->739121194],
Cell[12804, 328, 1808, 49, 70, "Notes",ExpressionUUID->"17040c73-1737-4ca3-85f0-4585fe5cec42",
 CellID->67102925],
Cell[14615, 379, 2083, 59, 70, "Notes",ExpressionUUID->"9121b8ea-5e77-44a0-b930-937454719641",
 CellID->169132515],
Cell[16701, 440, 1683, 52, 70, "Notes",ExpressionUUID->"d1358339-a276-4ba1-bf0a-b57cf5faa124",
 CellID->659303226],
Cell[18387, 494, 749, 22, 70, "Notes",ExpressionUUID->"e6d69161-572e-479a-bf00-64b0d05d081c",
 CellID->1779052493]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[19263, 522, 1389, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"df08648f-1e23-4db0-b01a-95661279dfb8",
 CellTags->"PrimaryExamplesSection",
 CellID->430431048],
Cell[CellGroupData[{
Cell[20677, 563, 1368, 36, 31, "ExampleSection",ExpressionUUID->"b71009af-60d1-47ed-8a96-252f1d912473",
 CellID->1529700640],
Cell[22048, 601, 184, 3, 29, "Input",ExpressionUUID->"7001f672-a4b1-4f32-8947-4906886aa41e",
 CellID->2054036296],
Cell[22235, 606, 293, 7, 39, "ExampleText",ExpressionUUID->"13389abf-7d8e-493f-8900-17d59617220a",
 CellID->1388401347],
Cell[CellGroupData[{
Cell[22553, 617, 269, 6, 29, "Input",ExpressionUUID->"611df36f-0f1b-4401-a4dc-11da2123ad9d",
 CellID->295891880],
Cell[22825, 625, 1097, 31, 40, "Output",ExpressionUUID->"37cbb42f-c9e9-42a5-a3dc-a6dbfe7375d5",
 CellID->1977061076]
}, Open  ]],
Cell[23937, 659, 158, 2, 38, "ExampleText",ExpressionUUID->"67d0a61b-af19-4ff4-9089-178fe84f79bd",
 CellID->5650014],
Cell[CellGroupData[{
Cell[24120, 665, 337, 8, 29, "Input",ExpressionUUID->"7edfb49e-8929-437b-9280-810143309d73",
 CellID->47645834],
Cell[24460, 675, 614, 16, 40, "Output",ExpressionUUID->"fb47f558-49eb-48f4-9d86-00d94bd18f54",
 CellID->2045445057]
}, Open  ]],
Cell[25089, 694, 152, 1, 38, "ExampleText",ExpressionUUID->"693c9b86-8029-47ab-adb4-ca192f69ff51",
 CellID->65390182],
Cell[CellGroupData[{
Cell[25266, 699, 337, 8, 29, "Input",ExpressionUUID->"09f4aa8a-f34f-4012-bf66-d421439ada0d",
 CellID->331923263],
Cell[25606, 709, 801, 25, 60, "Output",ExpressionUUID->"074404a1-b26a-4856-9237-1066dd5fff37",
 CellID->940945970]
}, Open  ]],
Cell[26422, 737, 99, 1, 38, "ExampleText",ExpressionUUID->"49760aab-ec59-4411-b1a2-4480a8629b88",
 CellID->1882183985]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[26751, 746, 1433, 38, 114, "SeeAlsoSection",ExpressionUUID->"f044b862-4f0b-4e2a-8ea9-5cb2c9622f58"],
Cell[28187, 786, 753, 20, 70, "TutorialsSection",ExpressionUUID->"aa1a61a7-6723-4031-a6fc-1d715b3c78f3"],
Cell[28943, 808, 753, 19, 70, "MoreAboutSection",ExpressionUUID->"bc708200-11b5-475e-b93b-70e61148ec44"],
Cell[29699, 829, 78, 0, 70, "FooterCell",ExpressionUUID->"736b2f76-95d0-4f61-8a62-7adbd2686222"]
}
]
*)

(* End of internal cache information *)

