(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     27900,        736]
NotebookOptionsPosition[     22677,        630]
NotebookOutlinePosition[     24931,        686]
CellTagsIndexPosition[     24846,        681]
WindowTitle->PropagationVector
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "1274fe45-5d4d-44d8-ab92-b77378b7a399"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "390c6b0d-ab55-4039-850d-14391413be59"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "93cceadc-1a07-4e65-91d7-de84d5db0db3"]
         }],ExpressionUUID->"b7b3cf6e-9fe3-4df0-9cc8-d9868d6f74da"],
         StripOnInput->False], {"\<\"OpticalField\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/OpticalField"], "\<\"Observables\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/Observables"], \
"\<\"PolarizationComponents\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/PolarizationComponents"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "dbc18b62-4fcb-4f0a-89ad-69466cc01c7e"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "3b487c13-f1a7-4853-89a7-c22e653ff8c0"]
         }],ExpressionUUID->"eb695310-8b4b-4544-89b2-1c17da4d0bf7"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "6686ac06-8adb-4e7b-a29a-42d350bbc003"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "7e00e519-899e-410a-aad0-121c404fe890"]
         }],ExpressionUUID->"e76db6f1-76ac-4944-982f-1241878cfcaa"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/ref/PropagationVector\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/PropagationVector"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/PropagationVector.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$57672], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/PropagationVector" <> ".html"], 
            None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "4c2ac3eb-d586-48de-b401-f2e9e59f8f74"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "1996814b-6edc-417e-8853-213f315aaa60"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"265d8e06-6996-4c30-9e8f-fa4313f12dfb"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"b0d05849-1d20-4984-b7db-46f371cda4e9"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "PropagationVector", "ObjectName",ExpressionUUID->
      "0c4c7445-000d-4a11-a858-95743ad0a4fa"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"eb78d687-3a56-4fe4-9969-7af9774373a3"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "cc2db9c9-3916-45bc-bc8d-1e3af4770768"]
    }],ExpressionUUID->"2734d156-aab5-4d07-a07b-7d5dbdd2a81b"], 
    "\[SpanFromLeft]"}
  }]], "ObjectNameGrid",ExpressionUUID->"c3317083-91b0-4d1d-82a4-\
20023340e110"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["PropagationVector"], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "4ba2bfa0-2d41-48fd-8a07-8e3cf6a9bb73"],
     " \[LineSeparator]is an option for ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["OpticalField"]], 
        "paclet:AtomicDensityMatrix/ref/OpticalField", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "e5586f08-a58e-4f79-88a1-ea6d78181417"],
     " and related functions that specifies the light propagation direction."
    }],ExpressionUUID->"712d23ba-0e9d-4b29-83cf-e44cc437b9c1"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"a7b42c4c-45f2-45b4-94c3-e826688426e8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"4f2e22bb-4299-48c4-9c51-3c34deb58fee"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"e86a9b3d-299b-46f3-a514-13bfcc06b046"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"45c79022-448a-419e-8bac-63ba2e9d20d3"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"dfa0cdc3-5b8b-4e60-beb7-68f928e59635"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->1142147347,ExpressionUUID->"20058734-2ad3-4ec4-94fd-f9931bdbf5c7"],

Cell[TextData[{
 Cell[BoxData["PropagationVector"], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "4f0bd6de-c0dc-42d8-b0f5-68fd60eff3b9"],
 " is specified as a three-component Cartesian or spherical vector."
}], "Notes",
 CellID->1362295892,ExpressionUUID->"7be3bc12-d83d-4b85-b7ad-10eedf4dcfe3"],

Cell[TextData[{
 "A value of ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["Automatic"]], "paclet:ref/Automatic"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "55fbec15-2bf6-47df-9975-b8e0333c71e3"],
 " means that the default value for ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["OpticalField"]], "paclet:AtomicDensityMatrix/ref/OpticalField",
     "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "339a482b-ab6e-4655-9523-43ac1781efbf"],
 " is used."
}], "Notes",
 CellID->1779052493,ExpressionUUID->"4f20ab61-7c2a-4241-83c9-1dd80e99116d"],

Cell[TextData[{
 "The specified value for ",
 Cell[BoxData["PropagationVector"], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "08d286ee-d641-4313-8ce3-3bda2a228d59"],
 " must be perpendicular to the value for ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["PolarizationVector"]], 
    "paclet:AtomicDensityMatrix/ref/PolarizationVector", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "7f9d3c2c-3f95-4c7a-a9b7-eaf021bfa077"],
 "."
}], "Notes",
 CellID->828856652,ExpressionUUID->"0976bd51-2325-4aeb-aef9-c54e3bd0b2bc"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "91c3defe-bf9e-41a7-8d95-767a32e677cb"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"e3137a96-c718-4297-bb8b-6f7f216637e6"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "d3d20960-be2b-419c-b5a5-84ab0d1376bd"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->1861624143,ExpressionUUID->"5930fb69-cf29-4e27-88f3-adfd88286280"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "3a46e367-e493-40ae-9fd6-17b34b98790b"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"88719cd9-57ea-4e75-b9c2-632c018383fe"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "8bfa0a53-2e24-44ad-b50e-305630199253"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->1627718258,ExpressionUUID->"37a35ef8-170b-4f67-a21b-7af81d754020"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->846274332,ExpressionUUID->"6ec3640b-4dbd-4863-a6b2-0337b38065c6"],

Cell[TextData[{
 "An optical field propagating along ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]], "InlineMath",ExpressionUUID->
  "2a53bbfe-21b5-4029-acfc-db11cb9b4dc3"],
 StyleBox[":",
  Deletable->True]
}], "ExampleText",
 CellID->484150937,ExpressionUUID->"f58880c8-2b0a-4a2c-a5ab-dc2db4f3c72a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Omega]", ",", "k"}], "}"}], ",", "E0", ",", 
   RowBox[{"{", 
    RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], ",", 
   RowBox[{"PropagationVector", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1027197310,ExpressionUUID->"16a11725-96f3-42b5-9eb5-a7cde7dd1e53"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", "Yy"}], "-", 
        RowBox[{"t", " ", "\[Omega]"}]}], ")"}]}]], " ", "E0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}], ",", "0", ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", "Yy"}], "-", 
        RowBox[{"t", " ", "\[Omega]"}]}], ")"}]}]], " ", "E0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}]}], 
  "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->171094270,ExpressionUUID->"03566457-0001-4851-8271-d7bf3321d384"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"3801fcc6-b9c4-4c14-a77c-c2a61a7c3c62"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"954cc0d0-57af-4136-996e-a5cb0b3b6f84"],
 "Generalizations & Extensions",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "a3756610-ce98-4765-88c4-734e3a5aebbd"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->1020263627,ExpressionUUID->"8940e501-8347-4848-b635-0ae86a81cb7e"],

Cell["Specify the propagation direction in the spherical basis:", \
"ExampleText",
 CellID->1997963021,ExpressionUUID->"5bb4de85-bd8c-47e3-a6dc-a3e728acdad4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Omega]", ",", "k"}], "}"}], ",", "E0", ",", 
   RowBox[{"{", 
    RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], ",", 
   RowBox[{"PropagationVector", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", 
         SqrtBox["2"]]}], ",", "0", ",", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", 
         SqrtBox["2"]]}]}], "}"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1885012869,ExpressionUUID->"0e06a1c2-dcbf-4580-bbe0-f6ce367cf6ea"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", "Yy"}], "-", 
        RowBox[{"t", " ", "\[Omega]"}]}], ")"}]}]], " ", "E0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}], ",", "0", ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", "Yy"}], "-", 
        RowBox[{"t", " ", "\[Omega]"}]}], ")"}]}]], " ", "E0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}]}], 
  "}"}]], "Output",
 CellLabel->"Out[1]=",
 CellID->1874339462,ExpressionUUID->"f1c5ae8e-5e6c-4c64-87ad-523a07eddc08"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedFunction.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"See", " ", "Also"}], "SeeAlsoSection"]},
      {Cell[TextData[{
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["OpticalField"]], 
           "paclet:AtomicDensityMatrix/ref/OpticalField", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "ecf2fc6a-6653-4eaf-8d1d-e3d494995440"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Observables"]], 
           "paclet:AtomicDensityMatrix/ref/Observables", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "e143a2f9-2ba2-49f7-8355-ae4df151a6cf"]
       }], "SeeAlso",ExpressionUUID->"babe9e49-450e-44ec-bce1-2b7ccf93e733"]}
     }]}
  }]], "SeeAlsoSection",ExpressionUUID->"41822633-ca61-42a5-bc6a-\
ddc5db81e06f"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "1d84e080-020d-4e7a-ab97-35314f061152"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"de4e2c4b-ef21-47c7-9b09-\
39ed331f2fd2"],

Cell[" ", "FooterCell",ExpressionUUID->"8aa664c6-219c-4584-9c39-1cd34b9417ee"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PropagationVector",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, 
    "ExampleSection" -> {"0" -> Open, "1" -> Closed}, "NotesSection" -> 
    Closed}, "NewStyles" -> True, "CitationPopupData" -> $Failed, 
  "ShowCitation" -> False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 17, 59, 51.062148}", 
    "history" -> {"18.09", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "PropagationVector is an option for OpticalField and related functions \
that specifies the light propagation direction.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "PropagationVector", "titlemodifier" -> "", 
    "metadescription" -> "", "windowtitle" -> "PropagationVector", "type" -> 
    "Symbol", "uri" -> "AtomicDensityMatrix/ref/PropagationVector"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"3d58cc36-6dc1-43d6-bafa-a4cf64c96d69"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[11491, 305, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"5930fb69-cf29-4e27-88f3-adfd88286280",
   CellTags->"PrimaryExamplesSection",
   CellID->1861624143]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 24645, 674}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[589, 21, 5554, 133, 57, "AnchorBarGrid",ExpressionUUID->"265d8e06-6996-4c30-9e8f-fa4313f12dfb",
 CellID->1],
Cell[6146, 156, 102, 0, 23, "ContextNameCell",ExpressionUUID->"b0d05849-1d20-4984-b7db-46f371cda4e9"],
Cell[CellGroupData[{
Cell[6273, 160, 560, 14, 60, "ObjectNameGrid",ExpressionUUID->"c3317083-91b0-4d1d-82a4-20023340e110"],
Cell[6836, 176, 848, 19, 114, "Usage",ExpressionUUID->"a7b42c4c-45f2-45b4-94c3-e826688426e8",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[7721, 200, 1899, 47, 37, "NotesSection",ExpressionUUID->"20058734-2ad3-4ec4-94fd-f9931bdbf5c7",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1142147347],
Cell[9623, 249, 318, 6, 70, "Notes",ExpressionUUID->"7be3bc12-d83d-4b85-b7ad-10eedf4dcfe3",
 CellID->1362295892],
Cell[9944, 257, 749, 22, 70, "Notes",ExpressionUUID->"4f20ab61-7c2a-4241-83c9-1dd80e99116d",
 CellID->1779052493],
Cell[10696, 281, 668, 18, 70, "Notes",ExpressionUUID->"0976bd51-2325-4aeb-aef9-c54e3bd0b2bc",
 CellID->828856652]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[11491, 305, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"5930fb69-cf29-4e27-88f3-adfd88286280",
 CellTags->"PrimaryExamplesSection",
 CellID->1861624143],
Cell[CellGroupData[{
Cell[12906, 346, 1368, 36, 31, "ExampleSection",ExpressionUUID->"37a35ef8-170b-4f67-a21b-7af81d754020",
 CellID->1627718258],
Cell[14277, 384, 183, 3, 29, "Input",ExpressionUUID->"6ec3640b-4dbd-4863-a6b2-0337b38065c6",
 CellID->846274332],
Cell[14463, 389, 305, 8, 38, "ExampleText",ExpressionUUID->"f58880c8-2b0a-4a2c-a5ab-dc2db4f3c72a",
 CellID->484150937],
Cell[CellGroupData[{
Cell[14793, 401, 436, 11, 29, "Input",ExpressionUUID->"16a11725-96f3-42b5-9eb5-a7cde7dd1e53",
 CellID->1027197310],
Cell[15232, 414, 1274, 36, 44, "Output",ExpressionUUID->"03566457-0001-4851-8271-d7bf3321d384",
 CellID->171094270]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]],
Cell[CellGroupData[{
Cell[16655, 458, 1417, 36, 30, "ExampleSection",ExpressionUUID->"8940e501-8347-4848-b635-0ae86a81cb7e",
 CellID->1020263627],
Cell[18075, 496, 158, 2, 70, "ExampleText",ExpressionUUID->"5bb4de85-bd8c-47e3-a6dc-a3e728acdad4",
 CellID->1997963021],
Cell[CellGroupData[{
Cell[18258, 502, 625, 18, 70, "Input",ExpressionUUID->"0e06a1c2-dcbf-4580-bbe0-f6ce367cf6ea",
 CellID->1885012869],
Cell[18886, 522, 1275, 36, 44, "Output",ExpressionUUID->"f1c5ae8e-5e6c-4c64-87ad-523a07eddc08",
 CellID->1874339462]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[20403, 567, 1433, 38, 114, "SeeAlsoSection",ExpressionUUID->"41822633-ca61-42a5-bc6a-ddc5db81e06f"],
Cell[21839, 607, 753, 19, 114, "MoreAboutSection",ExpressionUUID->"de4e2c4b-ef21-47c7-9b09-39ed331f2fd2"],
Cell[22595, 628, 78, 0, 24, "FooterCell",ExpressionUUID->"8aa664c6-219c-4584-9c39-1cd34b9417ee"]
}
]
*)

(* End of internal cache information *)

