(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     35260,        947]
NotebookOptionsPosition[     29667,        832]
NotebookOutlinePosition[     31888,        887]
CellTagsIndexPosition[     31803,        882]
WindowTitle->SelectStates
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "f1bedcd5-3f7e-4d05-8b51-88c0af88fff0"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "a027b227-9863-41d5-9c98-8da10f1cfe59"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "22386ddd-b6ad-4038-8ef3-a71ee7a037c9"]
         }],ExpressionUUID->"d8f4d4ab-7004-434a-9676-324238db2a1e"],
         StripOnInput->False], {"\<\"StatePosition\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/StatePosition"], \
"\<\"DeleteStates\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/DeleteStates"], \
"\<\"GroundStates\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/GroundStates"], \
"\<\"ExcitedStates\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/ExcitedStates"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "e5b1af27-93f2-4219-9b56-6fd88534d890"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "9bb98654-f6b4-4368-b16a-5262ebd75d9e"]
         }],ExpressionUUID->"6fe059b4-a5a4-45cc-9932-91be97b7fb0f"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "b01c458f-5f59-4882-b409-930fd104ec5a"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "13a99da1-304f-48f1-b70b-09edc7b6c9af"]
         }],ExpressionUUID->"018603dc-6fa9-4882-a17c-6d4ee1cc6626"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/ref/SelectStates\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/SelectStates"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/SelectStates.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$61715], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/SelectStates" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "546130d3-164a-46e7-9bee-b00a58b35104"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "5cee7891-0da6-4d96-b94a-9ccffb228f4b"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"ca5b2458-2573-4348-bb13-8191088d2c33"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"0842d842-66c2-4b47-9383-68625c4db334"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "SelectStates", "ObjectName",ExpressionUUID->
      "69ee1ec7-2b10-462b-a5a1-c08f35a0c38a"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"7feae7c5-5eca-499b-a082-57f0a75a858a"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "21a3a035-fd22-4fc4-82a6-474fe8dac641"]
    }],ExpressionUUID->"268bc170-ca8d-4956-82f5-f7bcbc06d98d"], 
    "\[SpanFromLeft]"}
  }]], "ObjectNameGrid",ExpressionUUID->"4a839feb-0312-46f2-bef8-\
d33bad24aa90"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"SelectStates", "[", 
       RowBox[{
        StyleBox["sys", "TI"], ",", " ", 
        StyleBox["crit", "TI"]}], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "2a89344b-55d3-41ba-96f7-92bf65b0f113"],
     " \[LineSeparator]selects the atomic states from the atomic system ",
     Cell[BoxData[
      StyleBox["sys", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "8942c597-f5ed-4736-b9bc-055f93154b4f"],
     " that satisfy the state\[Hyphen]selection criteria ",
     Cell[BoxData[
      StyleBox["crit", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "68130689-85b7-44ad-bed1-deeb86faeb76"],
     ". "
    }],ExpressionUUID->"586f1b2a-f0f7-480c-86d2-22d29f8243dc"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"5719a8a9-f1a1-440f-bf88-df626d5b7ff5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"b2481daf-75d8-46f9-925d-703a24a3834d"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"0fee7789-8b2d-4290-9a14-87d2d0d04d1d"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"c473e119-0154-4efb-be00-3b6ba8aec42f"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"098e21da-d739-4df9-94f1-ffb0f7fcfc31"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->293547935,ExpressionUUID->"2446cbc7-8347-47bc-b787-bbab1e24d435"],

Cell[TextData[{
 "An atomic system is a list of ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["AtomicState"]], "paclet:AtomicDensityMatrix/ref/AtomicState", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "4fe6b04a-c1d4-4890-b760-574f5b226176"],
 " expressions."
}], "Notes",
 CellID->1970689651,ExpressionUUID->"7f6f8ee7-1abb-4236-ad4b-15cc361609d5"],

Cell[TextData[{
 "State-selection criteria are specified as for ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["StatePosition"]], 
    "paclet:AtomicDensityMatrix/ref/StatePosition", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "4e55973e-c4bc-412d-b1d0-1e7722fae5f4"],
 ": Boolean expressions involving the state parameters, such as ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    TemplateBox[{
      Cell[
       TextData["StateLabel"]], "paclet:ref/StateLabel"},
     "RefLink",
     BaseStyle->{"InlineFormula"}], "\[Equal]", "2"}], "&&", 
   RowBox[{
    TemplateBox[{
      Cell[
       TextData["F"]], "paclet:AtomicDensityMatrix/ref/F", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"InlineFormula"], "\[Equal]", "1"}]}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "4cbc5451-417c-4d88-b861-bfd3031f2b02"],
 ". As a shorthand, if all states with a particular label are to be selected, \
just the label itself can be specified."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"339c1539-9909-481e-b30a-7f7e3ff4d328"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "bf15355f-602c-4d2c-bac0-1228f34ca599"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"9c1ce655-cf8f-41fd-9635-280a42754393"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "0bb31b50-b254-45b6-85a5-a50ace768655"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->890206386,ExpressionUUID->"86f6679f-8960-4d74-b43d-407765531f49"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "3b0494e0-3fe2-4f2c-a8a0-5f3d34cccf0e"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"c36294b9-9848-4b41-8940-df17bdaebb29"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "22b6efb9-97cf-409d-9ba4-63fa3a591d74"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->180160853,ExpressionUUID->"a18efdbe-01dd-4215-bde2-2a6f7b95135e"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1350851026,ExpressionUUID->"1e893206-568b-46f7-bdc3-82ede7c32398"],

Cell["Define a hyperfine-Zeeman system:", "ExampleText",
 CellID->1932195541,ExpressionUUID->"6e277e5b-4ff3-4e6f-8cd5-ceaa6bd63cd7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "@", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", 
        RowBox[{"1", "/", "2"}]}], ",", 
       RowBox[{"NuclearSpin", "\[Rule]", 
        RowBox[{"1", "/", "2"}]}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", 
        RowBox[{"3", "/", "2"}]}], ",", 
       RowBox[{"NuclearSpin", "\[Rule]", 
        RowBox[{"1", "/", "2"}]}]}], "]"}]}], "}"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->597582555,ExpressionUUID->"85eb5629-2ac0-45c1-8042-0fe652fb0155"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "2"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "2"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1647687867,ExpressionUUID->"cbf5a7f8-127b-4343-a9c9-884104bc87dc"]
}, Open  ]],

Cell[TextData[{
 "Select states with ",
 Cell[BoxData[
  FormBox[
   RowBox[{"F", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "6b89019f-053e-4a07-97fe-28fdd94d36ba"],
 StyleBox[":",
  Deletable->True]
}], "ExampleText",
 CellID->794100613,ExpressionUUID->"fe7276d4-e2f1-4f67-b4df-d55af89b34d2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SelectStates", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"F", "\[Equal]", "1"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1795995912,ExpressionUUID->"0acbd21d-08d8-4a61-aea5-a5a7d482bfd8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->190256550,ExpressionUUID->"75696c07-cd2d-468d-b38a-4a15a11c2d76"]
}, Open  ]],

Cell[TextData[{
 "Select states labeled 1 with ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"|", " ", "M", " ", "|"}], "=", "1"}], TraditionalForm]], 
  "InlineMath",ExpressionUUID->"e6536002-624b-42f4-b4af-ada993c581c2"],
 StyleBox[":",
  Deletable->True]
}], "ExampleText",
 CellID->1057989510,ExpressionUUID->"9d2daad8-2aaf-4d44-ac7f-005061b4ccec"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SelectStates", "[", 
  RowBox[{"sys", ",", 
   RowBox[{
    RowBox[{"StateLabel", "\[Equal]", "1"}], "&&", 
    RowBox[{
     RowBox[{"Abs", "[", "M", "]"}], "\[Equal]", "1"}]}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->254989679,ExpressionUUID->"714314ee-f167-4e10-bb51-a8684167bc36"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[4]=",
 CellID->1292513920,ExpressionUUID->"98d70cb2-2391-4ca3-b68a-f9e728d9a3e5"]
}, Open  ]],

Cell["Select all states with label 2:", "ExampleText",
 CellID->1055481225,ExpressionUUID->"761bfae5-fa8f-4e82-ac8a-c30b8ecddbd5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SelectStates", "[", 
  RowBox[{"sys", ",", "2"}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1447195371,ExpressionUUID->"fcd0702d-4dc0-4395-8227-2df7ca00827e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "2"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "2"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[5]=",
 CellID->16163131,ExpressionUUID->"4472a53a-5d58-400c-8a5e-acb965d147d3"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedFunction.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"See", " ", "Also"}], "SeeAlsoSection"]},
      {Cell[TextData[{
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["StatePosition"]], 
           "paclet:AtomicDensityMatrix/ref/StatePosition", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "1d88e989-f27e-4ce9-9493-c3ae08dd963c"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["DeleteStates"]], 
           "paclet:AtomicDensityMatrix/ref/DeleteStates", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "1ae5eaf8-a62f-4b97-9767-d7791d84e92a"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["GroundStates"]], 
           "paclet:AtomicDensityMatrix/ref/GroundStates", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "0905c823-2e56-4a2f-9b88-de3f0c51f0ed"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["ExcitedStates"]], 
           "paclet:AtomicDensityMatrix/ref/ExcitedStates", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "34f4b5b8-f08e-4d72-b003-67276df5f0cd"]
       }], "SeeAlso",ExpressionUUID->"86acd5b9-e147-43af-9583-94485fc810ec"]}
     }]}
  }]], "SeeAlsoSection",ExpressionUUID->"7bd8e5ba-a49f-4e87-8ad8-\
70c2473a01a6"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "ed90e2ae-26ee-411e-a60a-683fa9a7d18e"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"355d10b3-ef24-46f3-9895-\
d31b7fc92453"],

Cell[" ", "FooterCell",ExpressionUUID->"5af26e57-4d89-4410-9d5c-c3c02343cbae"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"SelectStates",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}, 
    "NotesSection" -> Closed}, "NewStyles" -> True, 
  "CitationPopupData" -> $Failed, "ShowCitation" -> False, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2023, 4, 18, 17, 59, 59.148094}", 
    "history" -> {"17.08", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "SelectStates[sys, crit] selects the atomic states from the atomic system \
sys that satisfy the state-selection criteria crit. ", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "SelectStates", "titlemodifier" -> "", 
    "metadescription" -> "", "windowtitle" -> "SelectStates", "type" -> 
    "Symbol", "uri" -> "AtomicDensityMatrix/ref/SelectStates"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"a66e1003-2ff9-41fc-96ae-39acb38a92c6"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[11587, 307, 1389, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"86f6679f-8960-4d74-b43d-407765531f49",
   CellTags->"PrimaryExamplesSection",
   CellID->890206386]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 31603, 875}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[584, 21, 5608, 134, 57, "AnchorBarGrid",ExpressionUUID->"ca5b2458-2573-4348-bb13-8191088d2c33",
 CellID->1],
Cell[6195, 157, 102, 0, 23, "ContextNameCell",ExpressionUUID->"0842d842-66c2-4b47-9383-68625c4db334"],
Cell[CellGroupData[{
Cell[6322, 161, 555, 14, 60, "ObjectNameGrid",ExpressionUUID->"4a839feb-0312-46f2-bef8-d33bad24aa90"],
Cell[6880, 177, 951, 22, 112, "Usage",ExpressionUUID->"5719a8a9-f1a1-440f-bf88-df626d5b7ff5",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[7868, 204, 1898, 47, 37, "NotesSection",ExpressionUUID->"2446cbc7-8347-47bc-b787-bbab1e24d435",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->293547935],
Cell[9769, 253, 478, 13, 70, "Notes",ExpressionUUID->"7f6f8ee7-1abb-4236-ad4b-15cc361609d5",
 CellID->1970689651],
Cell[10250, 268, 1210, 33, 70, "Notes",ExpressionUUID->"339c1539-9909-481e-b30a-7f7e3ff4d328",
 CellID->1067943069]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[11587, 307, 1389, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"86f6679f-8960-4d74-b43d-407765531f49",
 CellTags->"PrimaryExamplesSection",
 CellID->890206386],
Cell[CellGroupData[{
Cell[13001, 348, 1367, 36, 31, "ExampleSection",ExpressionUUID->"a18efdbe-01dd-4215-bde2-2a6f7b95135e",
 CellID->180160853],
Cell[14371, 386, 184, 3, 29, "Input",ExpressionUUID->"1e893206-568b-46f7-bdc3-82ede7c32398",
 CellID->1350851026],
Cell[14558, 391, 132, 1, 38, "ExampleText",ExpressionUUID->"6e277e5b-4ff3-4e6f-8cd5-ceaa6bd63cd7",
 CellID->1932195541],
Cell[CellGroupData[{
Cell[14715, 396, 657, 18, 48, "Input",ExpressionUUID->"85eb5629-2ac0-45c1-8042-0fe652fb0155",
 CellID->597582555],
Cell[15375, 416, 3744, 104, 212, "Output",ExpressionUUID->"cbf5a7f8-127b-4343-a9c9-884104bc87dc",
 CellID->1647687867]
}, Open  ]],
Cell[19134, 523, 313, 9, 38, "ExampleText",ExpressionUUID->"fe7276d4-e2f1-4f67-b4df-d55af89b34d2",
 CellID->794100613],
Cell[CellGroupData[{
Cell[19472, 536, 220, 5, 29, "Input",ExpressionUUID->"0acbd21d-08d8-4a61-aea5-a5a7d482bfd8",
 CellID->1795995912],
Cell[19695, 543, 1947, 54, 116, "Output",ExpressionUUID->"75696c07-cd2d-468d-b38a-4a15a11c2d76",
 CellID->190256550]
}, Open  ]],
Cell[21657, 600, 359, 10, 40, "ExampleText",ExpressionUUID->"9d2daad8-2aaf-4d44-ac7f-005061b4ccec",
 CellID->1057989510],
Cell[CellGroupData[{
Cell[22041, 614, 319, 8, 70, "Input",ExpressionUUID->"714314ee-f167-4e10-bb51-a8684167bc36",
 CellID->254989679],
Cell[22363, 624, 758, 21, 52, "Output",ExpressionUUID->"98d70cb2-2391-4ca3-b68a-f9e728d9a3e5",
 CellID->1292513920]
}, Open  ]],
Cell[23136, 648, 130, 1, 70, "ExampleText",ExpressionUUID->"761bfae5-fa8f-4e82-ac8a-c30b8ecddbd5",
 CellID->1055481225],
Cell[CellGroupData[{
Cell[23291, 653, 189, 4, 70, "Input",ExpressionUUID->"fcd0702d-4dc0-4395-8227-2df7ca00827e",
 CellID->1447195371],
Cell[23483, 659, 2552, 71, 148, "Output",ExpressionUUID->"4472a53a-5d58-400c-8a5e-acb965d147d3",
 CellID->16163131]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[26277, 739, 2549, 68, 70, "SeeAlsoSection",ExpressionUUID->"7bd8e5ba-a49f-4e87-8ad8-70c2473a01a6"],
Cell[28829, 809, 753, 19, 70, "MoreAboutSection",ExpressionUUID->"355d10b3-ef24-46f3-9895-d31b7fc92453"],
Cell[29585, 830, 78, 0, 70, "FooterCell",ExpressionUUID->"5af26e57-4d89-4410-9d5c-c3c02343cbae"]
}
]
*)

(* End of internal cache information *)

