(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     84119,       2263]
NotebookOptionsPosition[     72757,       2024]
NotebookOutlinePosition[     75003,       2081]
CellTagsIndexPosition[     74917,       2076]
WindowTitle->TensorType
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "8c693e0e-3489-4d71-bbae-2afc177f6e62"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "b8bb77ab-8556-4144-a420-4e3bee1f0edd"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "8178dc0e-e1d6-4640-8cf4-350634057a38"]
         }],ExpressionUUID->"aab79250-54d8-4a5a-9ecc-5b01fe9ee677"],
         StripOnInput->False], {"\<\"ScalarQ\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/ScalarQ"], "\<\"CartesianQ\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/CartesianQ"], "\<\"CovariantQ\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/CovariantQ"], \
"\<\"ContravariantQ\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/ContravariantQ"], \
"\<\"SphericalTensorQ\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/SphericalTensorQ"], \
"\<\"OperatorQ\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/OperatorQ"], "\<\"OneByOneQ\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/OneByOneQ"], \
"\<\"CovariantDecompositionQ\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/CovariantDecompositionQ"], \
"\<\"ContravariantDecompositionQ\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/ContravariantDecompositionQ"], \
"\<\"TensorDecompositionQ\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/TensorDecompositionQ"], \
"\<\"TensorDecompositionMatrixQ\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/TensorDecompositionMatrixQ"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "2461f878-ccd1-46c7-b084-bed969f89ccc"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "ecf836e1-4f6b-475a-94a3-bec271ee807d"]
         }],ExpressionUUID->"80675383-171d-44a6-bd2b-16f90f6b3760"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "dd686dff-6347-4e71-ad2a-9e0b5b4196bd"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "a81b0202-47e7-418a-858b-78a268a7da06"]
         }],ExpressionUUID->"9d68a39f-efc5-44fc-a6d2-2aeffa326f72"],
         StripOnInput->False], {"\<\"Matrix Notation\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/MatrixNotation"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"Tutorials"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "fbbb6b2e-cec5-4b9b-a3c5-72667a4b38b5"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "682bae46-f006-45fe-911b-91dec15b9c5b"]
         }],ExpressionUUID->"4784974d-8b74-4f4e-8e3e-4ba90f158d6f"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix/ref/TensorType\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/TensorType"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/TensorType.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$65042], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/TensorType" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "6779de66-ca20-4c4f-b0d2-35972e164807"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "1202a5bb-f08a-418d-8c21-884fc4c50552"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"3bb66950-62dc-4a32-89c1-df4e92c2ca55"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"283d48ec-54de-4c43-bfbc-b71c847d09aa"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "TensorType", "ObjectName",ExpressionUUID->
      "fd212452-1e03-4103-ad30-341fd1927f77"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"6a50350b-7087-426d-90e3-349fbb577956"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "ec6de1d6-042f-46f6-b5de-d21b119a4064"]
    }],ExpressionUUID->"20ce2304-0e6a-43c8-92ae-6392a36afc8c"], 
    "\[SpanFromLeft]"}
  }]], "ObjectNameGrid",ExpressionUUID->"6b45e095-56a0-4091-9e11-\
6d9a40a80f58"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TensorType", "[", 
       StyleBox["tens", "TI"], "]"}]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "ddcaed2b-e2ed-4ba5-b1a6-c8887ec626b9"],
     " \[LineSeparator]returns a list describing the structure of the tensor ",
     Cell[BoxData[
      StyleBox["tens", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "57649585-225b-42ce-b031-79d8e8397ad4"],
     ", from top level (outermost), to bottom level (innermost)."
    }],ExpressionUUID->"0c26b278-008b-433a-aabc-bd0e363d20b9"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"225edffe-8ccd-4bbb-ba30-1c756dc483e2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"103cc47e-3435-47ab-bc3a-a59eb819e9db"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"d1610387-4c74-4815-8712-3722b36489c7"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"6a639c7d-cf66-4142-8302-59c2e2f52ff6"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"47e872d1-47ec-40e1-9fbb-46d4ca465665"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->1658708540,ExpressionUUID->"3bb2d23d-4c32-4ee1-b962-b855b1b0345d"],

Cell["Possible elements of the returned list are", "Notes",
 CellID->1067943069,ExpressionUUID->"9b1e5eca-5790-454b-adf3-bf3f20278716"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "b4fa977e-b73e-4a03-be40-7e0e0b5e70d5"], "\"\<Scalar\>\"", Cell[
    "a scalar (any expression that is not a list)", "TableText",
     ExpressionUUID->"29c999ed-07ec-437b-a4b7-0d6d4f0942fa"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "8b2e65e9-b26a-4448-9330-6a780909e276"], "\"\<Cartesian\>\"", Cell[
    "a Cartesian vector", "TableText",ExpressionUUID->
     "06aec818-fa2a-4e09-970b-ebfea3a9cead"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "7b5304d8-8373-4359-9d5f-c4b36062c280"], "\"\<Covariant\>\"", Cell[
    "a covariant spherical tensor", "TableText",ExpressionUUID->
     "72636421-f143-49f0-90e8-b357176c4cdc"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "ce43f5f3-ebe4-442f-9cb6-4e6cda58a598"], "\"\<Contravariant\>\"", Cell[
    "a contravariant spherical tensor", "TableText",ExpressionUUID->
     "f467173e-ac3f-41a8-bd42-e262e7b2278b"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "8b0e70f3-88b6-455b-8099-1ef4564401a9"], "\"\<Operator\>\"", Cell[
    "a square matrix operator", "TableText",ExpressionUUID->
     "af0c8a9f-2d53-42b2-a4db-263f702f7489"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "7aa267e9-206a-48d9-8bea-3d462ad99268"], "\"\<OneByOne\>\"", Cell[
    "a 1\[Times]1 matrix", "TableText",ExpressionUUID->
     "9c5e767e-11f9-4abd-9a69-8f8bad846f86"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "221aa902-4e43-49c0-a56e-ab8cb6f339e9"], "\"\<TensorDecomposition\>\"", 
    Cell["\<\
a list of spherical tensors describing a tensor decomposition\
\>", "TableText",ExpressionUUID->"11ee4641-be7d-41f1-b3c3-8e1159296576"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "8c67c376-7f1a-462b-be87-13692dcae634"], 
    "\"\<TensorDecompositionMatrix\>\"", Cell["\<\
a matrix of tensor decompositions describing a multilevel system\
\>", "TableText",ExpressionUUID->"838c9c99-f87f-42d5-97cd-ecca04ef57e3"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, 
   "Rows" -> {None, None, None, None, None, None, None, {None}}},
 GridBoxDividers->{
  "Rows" -> {{True, True, True, True, True, True, True, True, True}}}},
 CellID->1237998268,ExpressionUUID->"39140f53-70e2-402a-8524-86c41e6a89a7"],

Cell[TextData[{
 "The ",
 Cell[BoxData["\"\<Scalar\>\""], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "9a84d9f9-1fef-4444-b405-0cd209850965"],
 " type is omitted from the end of the list unless it is the only (i.e., \
top-level) element."
}], "Notes",
 CellID->384640264,ExpressionUUID->"d1cefbb0-e149-49b3-b424-16a084288acb"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "3804d466-001d-4ae7-8659-9efaf68ef652"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"b7c88255-040e-4160-99d1-d462d0eb6339"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "27dccf63-db50-4336-b14b-b5e7abe0a2fa"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->1429210073,ExpressionUUID->"1013f8f6-3620-4894-9c44-a9b834cbe3e6"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "8a27cd8e-4625-4195-b0ee-8399aab526c7"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"f91ee844-78f8-4ea9-a25f-71acba73121e"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "81e2e612-d308-4278-b8eb-943ec5ad5307"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->1129105216,ExpressionUUID->"1caa91a9-6f81-49f6-8f01-421ab0ac8987"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1968454397,ExpressionUUID->"652aee72-ca41-4b15-b23d-5f3ee0603968"],

Cell["A scalar:", "ExampleText",
 CellID->1244508620,ExpressionUUID->"21ffa706-84bb-42a4-9326-9c0b426c725b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorType", "[", "a", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->105733567,ExpressionUUID->"9f6f8e2c-260d-491a-b3f2-40fd09a737a8"],

Cell[BoxData[
 RowBox[{"{", "\<\"Scalar\"\>", "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->841627125,ExpressionUUID->"ac330999-7c95-4019-bca2-6ce04a645c8f"]
}, Open  ]],

Cell["A Cartesian vector:", "ExampleText",
 CellID->1121145203,ExpressionUUID->"dbdc73b6-dd37-4524-84d0-e9e1d9e0bc53"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorType", "[", 
  RowBox[{"{", 
   RowBox[{"x", ",", "y", ",", "z"}], "}"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1572170205,ExpressionUUID->"8421a2a1-4b08-448c-aa09-bcbd6d4008ce"],

Cell[BoxData[
 RowBox[{"{", "\<\"Cartesian\"\>", "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->144098568,ExpressionUUID->"e4e87fb5-cc33-48b5-b606-13d5419d683f"]
}, Open  ]],

Cell["A covariant spherical vector operator:", "ExampleText",
 CellID->1031250077,ExpressionUUID->"1044e78d-c52c-4cb0-b050-52456c5d9231"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"jcov", "=", 
    RowBox[{"WignerEckart", "[", 
     RowBox[{
      RowBox[{"1", "/", "2"}], ",", 
      RowBox[{"{", 
       RowBox[{"J", ",", "1"}], "}"}]}], "]"}]}], ")"}], "//", 
  "TensorForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->819331085,ExpressionUUID->"e91c7287-49bb-4d37-b4d2-d22b874ce9db"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", 
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["2"]]}]},
         {"0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          FractionBox["1", "2"], "0"},
         {"0", 
          RowBox[{"-", 
           FractionBox["1", "2"]}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0"},
         {
          FractionBox["1", 
           SqrtBox["2"]], "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[4]//MatrixForm=",
 CellID->705668831,ExpressionUUID->"23f5fcd2-54c0-4671-837c-7defc9f58bc8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorType", "[", "jcov", "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1967762807,ExpressionUUID->"a14f4d43-b14c-4750-ace4-902e0aaf396e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Covariant\"\>", ",", "\<\"Operator\"\>"}], "}"}]], "Output",
 CellLabel->"Out[5]=",
 CellID->1330892079,ExpressionUUID->"0e143d7c-551b-4fb2-a6d3-8b3eeef326ca"]
}, Open  ]],

Cell["A Cartesian vector operator:", "ExampleText",
 CellID->1625229230,ExpressionUUID->"dc6be693-506d-44ad-a22f-542a88ae8a5e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"jcart", "=", 
    RowBox[{"ToCartesian", "@", "jcov"}]}], ")"}], "//", 
  "TensorForm"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->1893366296,ExpressionUUID->"1758062c-969e-4480-984d-ab453c50d03e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", 
        FractionBox["1", "2"]},
       {
        FractionBox["1", "2"], "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", 
        RowBox[{"-", 
         FractionBox["\[ImaginaryI]", "2"]}]},
       {
        FractionBox["\[ImaginaryI]", "2"], "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["1", "2"], "0"},
       {"0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellLabel->"Out[6]=",
 CellID->453759341,ExpressionUUID->"641684e1-bea5-4386-a749-ea006036aec3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorType", "[", "jcart", "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->1920076248,ExpressionUUID->"ed1c0dac-ab9b-4e1e-bf06-9f0ef8b992b1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Cartesian\"\>", ",", "\<\"Operator\"\>"}], "}"}]], "Output",
 CellLabel->"Out[7]=",
 CellID->1816307083,ExpressionUUID->"bc358eea-d578-472c-a32a-408307663c98"]
}, Open  ]],

Cell["A tensor decomposition:", "ExampleText",
 CellID->1718456422,ExpressionUUID->"ac94890a-019a-4fff-b038-c15e291c73da"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"dec", "=", 
    RowBox[{"Decomposition", "@", 
     RowBox[{"DensityMatrix", "@", 
      RowBox[{"ZeemanSystem", "[", 
       RowBox[{"1", ",", 
        RowBox[{"1", "/", "2"}]}], "]"}]}]}]}], ")"}], "//", 
  "TensorForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->705316750,ExpressionUUID->"532ecf3a-fcc6-4843-bb22-fb2fc1e947e9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{
         FractionBox[
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", 
                FractionBox["1", "2"]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", 
                FractionBox["1", "2"]}]}], "}"}]}]], "[", "t", "]"}], 
          SqrtBox["2"]], "+", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               FractionBox["1", "2"]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               FractionBox["1", "2"]}], "}"}]}]], "[", "t", "]"}], 
          SqrtBox["2"]]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", 
              FractionBox["1", "2"]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", 
               FractionBox["1", "2"]}]}], "}"}]}]], "[", "t", "]"}]}]},
       {
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{
            SubscriptBox["\[Rho]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", 
                 FractionBox["1", "2"]}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", 
                 FractionBox["1", "2"]}]}], "}"}]}]], "[", "t", "]"}], 
           SqrtBox["2"]]}], "+", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               FractionBox["1", "2"]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               FractionBox["1", "2"]}], "}"}]}]], "[", "t", "]"}], 
          SqrtBox["2"]]}]},
       {
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", 
              FractionBox["1", "2"]}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             FractionBox["1", "2"]}], "}"}]}]], "[", "t", "]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellLabel->"Out[8]=",
 CellID->1481863787,ExpressionUUID->"fcfdc1d2-26bb-4f66-96c8-4f1dd5609462"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorType", "[", "dec", "]"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->134045102,ExpressionUUID->"a3c5b866-faed-478e-96f8-f05427f89015"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"TensorDecomposition\"\>", ",", "\<\"Contravariant\"\>"}], 
  "}"}]], "Output",
 CellLabel->"Out[9]=",
 CellID->45365938,ExpressionUUID->"70e31b24-cce1-4edf-9bd0-8e4a771087dc"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
  ExpressionUUID->"2cd87c17-67f7-4bb4-9feb-f737dc9094da"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"c33da938-a785-43db-bf56-345092942afb"],
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "abaa8801-4b46-4ff5-a099-5adcc2d7805b"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->1293636265,ExpressionUUID->"d8ae9127-73a3-46ab-aac4-c29485e17626"],

Cell["A covariant vector of contravariant kets:", "ExampleText",
 CellID->614433153,ExpressionUUID->"f616d74f-3f78-44c9-a569-712da275974e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"covket", "=", 
    RowBox[{
     RowBox[{"WignerEckart", "[", 
      RowBox[{
       RowBox[{"1", "/", "2"}], ",", 
       RowBox[{"{", 
        RowBox[{"J", ",", "1"}], "}"}]}], "]"}], "\[Vee]", 
     RowBox[{"StretchedState", "[", 
      RowBox[{"1", "/", "2"}], "]"}]}]}], ")"}], "//", 
  "TensorForm"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1703958928,ExpressionUUID->"709815d7-2e4e-4aac-97f3-343607235099"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0"},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          FractionBox["1", "2"]},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0"},
         {
          FractionBox["1", 
           SqrtBox["2"]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[1]//MatrixForm=",
 CellID->1264602901,ExpressionUUID->"a690bf9c-35d2-4e51-a70e-afcd8141f369"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorType", "[", "covket", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->364889602,ExpressionUUID->"5afbf262-007c-489f-a8f6-d0d2d93abf9b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Covariant\"\>", ",", "\<\"Contravariant\"\>"}], 
  "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->2124258459,ExpressionUUID->"cbe8dc1b-cef3-4c3a-8115-29926cf42a25"]
}, Open  ]],

Cell["A Cartesian vector of contravariant kets:", "ExampleText",
 CellID->1175147473,ExpressionUUID->"685f049a-4f6e-41a6-842c-6381450e3c39"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"cartket", "=", 
    RowBox[{"ToCartesian", "[", "covket", "]"}]}], ")"}], "//", 
  "TensorForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1652509801,ExpressionUUID->"2002a320-12d9-4d7f-9d47-f683f403baf7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {
        FractionBox["1", "2"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {
        FractionBox["\[ImaginaryI]", "2"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["1", "2"]},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->288865145,ExpressionUUID->"d4fc167d-961d-46e7-82e4-a673adda77bb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorType", "[", "cartket", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1133461155,ExpressionUUID->"a481e588-e988-4699-ac7a-3af3e4791035"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Cartesian\"\>", ",", "\<\"Contravariant\"\>"}], 
  "}"}]], "Output",
 CellLabel->"Out[4]=",
 CellID->1007340944,ExpressionUUID->"309917fd-834a-429d-85c3-8a095907b467"]
}, Open  ]],

Cell["A Cartesian vector of covariant bras:", "ExampleText",
 CellID->529002313,ExpressionUUID->"3dc1e4a3-ede9-437c-b7bc-690f1f286a0d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"cartbra", "=", 
    RowBox[{"ComponentMap", "[", 
     RowBox[{"ToCovariant", ",", "cartket"}], "]"}]}], ")"}], "//", 
  "TensorForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->768722796,ExpressionUUID->"436b18cc-f82d-4a01-96ca-698d46737317"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["\[ImaginaryI]", "2"]}], "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["1", "2"], "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", 
        FractionBox["\[ImaginaryI]", "2"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellLabel->"Out[5]=",
 CellID->574295666,ExpressionUUID->"f9f6271d-9032-4186-b305-090f69090e11"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorType", "[", "cartbra", "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->93924520,ExpressionUUID->"80224e6f-54d2-461d-99a5-0e58e6a2cbd6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Cartesian\"\>", ",", "\<\"Covariant\"\>"}], "}"}]], "Output",
 CellLabel->"Out[6]=",
 CellID->929005375,ExpressionUUID->"8e01dd88-9928-4e1d-810d-89a4952918c9"]
}, Open  ]],

Cell["An operator-valued tensor decomposition:", "ExampleText",
 CellID->320022720,ExpressionUUID->"552407b2-238a-4a28-95f5-3139a2b76fee"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"pm", "=", 
    RowBox[{"PolarizationMatrices", "[", 
     RowBox[{"1", "/", "2"}], "]"}]}], ")"}], "//", "TensorForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->1882132021,ExpressionUUID->"07edb915-3361-4ac4-b502-82da3d55d18d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {
            FractionBox["1", 
             SqrtBox["2"]], "0"},
           {"0", 
            FractionBox["1", 
             SqrtBox["2"]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"0", 
            RowBox[{"-", "1"}]},
           {"0", "0"}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {
            FractionBox["1", 
             SqrtBox["2"]], "0"},
           {"0", 
            RowBox[{"-", 
             FractionBox["1", 
              SqrtBox["2"]]}]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"0", "0"},
           {"1", "0"}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellLabel->"Out[7]=",
 CellID->516242361,ExpressionUUID->"2a789a76-1024-4c3b-a943-76d3d15d4dca"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorType", "[", "pm", "]"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->1348202453,ExpressionUUID->"b9157f2f-86e2-4f21-a667-1a1b41ca87e2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"TensorDecomposition\"\>", ",", "\<\"Covariant\"\>", 
   ",", "\<\"Operator\"\>"}], "}"}]], "Output",
 CellLabel->"Out[8]=",
 CellID->790073943,ExpressionUUID->"ebe44c51-4118-4de3-897f-e6ba96385b29"]
}, Open  ]],

Cell["A contravariant tensor-decomposition matrix:", "ExampleText",
 CellID->158495034,ExpressionUUID->"25bf22ad-0334-4a71-8d44-11882abe5dad"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "@", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "1"}], ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "0"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "0"}]}], "]"}]}], "}"}]}]}]], "Input",
 CellLabel->"In[9]:=",
 CellID->1959658587,ExpressionUUID->"f1b096eb-687c-472f-b1eb-4297f3fb7b3a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[9]=",
 CellID->1986906778,ExpressionUUID->"a17c10d5-2d63-44b3-a9c0-388e1fd4e067"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"decmat", "=", 
    RowBox[{"Decomposition", "[", 
     RowBox[{"sys", ",", 
      RowBox[{"TransitRepopulation", "[", 
       RowBox[{"sys", ",", "1"}], "]"}]}], "]"}]}], ")"}], "//", 
  "TensorForm"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->2060525409,ExpressionUUID->"6ec52bdd-cedd-4476-96c0-57bd1f1b39b0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"{", 
       RowBox[{
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {
             FractionBox["1", 
              SqrtBox["3"]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]], ",", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0"},
            {"0"},
            {"0"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]], ",", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0"},
            {"0"},
            {"0"},
            {"0"},
            {"0"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}], "}"}], 
      RowBox[{"{", 
       TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"0"},
           {"0"},
           {"0"}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]], "}"}]},
     {
      RowBox[{"{", 
       TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"0"},
           {"0"},
           {"0"}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]], "}"}], 
      RowBox[{"{", 
       TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"0"}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]], "}"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellLabel->"Out[10]//MatrixForm=",
 CellID->237456295,ExpressionUUID->"1af4bf36-036d-4d32-92ee-1a1b56c1dc6e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorType", "[", "decmat", "]"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->1268887389,ExpressionUUID->"52ad708e-bb64-416f-be83-4907b1e5c3f6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"TensorDecompositionMatrix\"\>", 
   ",", "\<\"TensorDecomposition\"\>", ",", "\<\"Contravariant\"\>"}], 
  "}"}]], "Output",
 CellLabel->"Out[11]=",
 CellID->1680008918,ExpressionUUID->"1efce52a-cbce-4882-abdd-04c2f54173ff"]
}, Open  ]],

Cell["\<\
A covariant vector of contravariant tensor-decomposition matrices:\
\>", "ExampleText",
 CellID->1583545122,ExpressionUUID->"37bbe108-3f02-45bc-9350-195e9394ebfa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"covdecmat", "=", 
    RowBox[{"ComponentMap", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Decomposition", "[", 
        RowBox[{"sys", ",", "#"}], "]"}], "&"}], ",", 
      RowBox[{
       RowBox[{"WignerEckart", "[", 
        RowBox[{"sys", ",", 
         RowBox[{"{", 
          RowBox[{"J", ",", "1"}], "}"}]}], "]"}], "\[Vee]", 
       RowBox[{"TransitRepopulation", "[", 
        RowBox[{"sys", ",", "1"}], "]"}]}]}], "]"}]}], ")"}], "//", 
  "TensorForm"}]], "Input",
 CellLabel->"In[12]:=",
 CellID->452883312,ExpressionUUID->"ca5a8184-7c53-4515-9513-85d21da2f9c3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"{", 
           RowBox[{
            TagBox[
             RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0"}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
             Function[BoxForm`e$, 
              MatrixForm[BoxForm`e$]]], ",", 
            TagBox[
             RowBox[{"(", "\[NoBreak]", GridBox[{
                {
                 FractionBox[
                  SqrtBox["2"], "3"]},
                {"0"},
                {"0"}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
             Function[BoxForm`e$, 
              MatrixForm[BoxForm`e$]]], ",", 
            TagBox[
             RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0"},
                {"0"},
                {"0"},
                {"0"},
                {"0"}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
             Function[BoxForm`e$, 
              MatrixForm[BoxForm`e$]]]}], "}"}], 
          RowBox[{"{", 
           TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
               {"0"},
               {"0"},
               {"0"}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.7]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]], "}"}]},
         {
          RowBox[{"{", 
           TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
               {"0"},
               {"0"},
               {"0"}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.7]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]], "}"}], 
          RowBox[{"{", 
           TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
               {"0"}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.7]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]], "}"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"{", 
           RowBox[{
            TagBox[
             RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0"}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
             Function[BoxForm`e$, 
              MatrixForm[BoxForm`e$]]], ",", 
            TagBox[
             RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0"},
                {
                 FractionBox[
                  SqrtBox["2"], "3"]},
                {"0"}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
             Function[BoxForm`e$, 
              MatrixForm[BoxForm`e$]]], ",", 
            TagBox[
             RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0"},
                {"0"},
                {"0"},
                {"0"},
                {"0"}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
             Function[BoxForm`e$, 
              MatrixForm[BoxForm`e$]]]}], "}"}], 
          RowBox[{"{", 
           TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
               {"0"},
               {"0"},
               {"0"}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.7]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]], "}"}]},
         {
          RowBox[{"{", 
           TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
               {"0"},
               {"0"},
               {"0"}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.7]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]], "}"}], 
          RowBox[{"{", 
           TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
               {"0"}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.7]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]], "}"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"{", 
           RowBox[{
            TagBox[
             RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0"}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
             Function[BoxForm`e$, 
              MatrixForm[BoxForm`e$]]], ",", 
            TagBox[
             RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0"},
                {"0"},
                {
                 FractionBox[
                  SqrtBox["2"], "3"]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
             Function[BoxForm`e$, 
              MatrixForm[BoxForm`e$]]], ",", 
            TagBox[
             RowBox[{"(", "\[NoBreak]", GridBox[{
                {"0"},
                {"0"},
                {"0"},
                {"0"},
                {"0"}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
             Function[BoxForm`e$, 
              MatrixForm[BoxForm`e$]]]}], "}"}], 
          RowBox[{"{", 
           TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
               {"0"},
               {"0"},
               {"0"}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.7]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]], "}"}]},
         {
          RowBox[{"{", 
           TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
               {"0"},
               {"0"},
               {"0"}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.7]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]], "}"}], 
          RowBox[{"{", 
           TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
               {"0"}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.7]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]], "}"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableDepth -> 4]]]], "Output",
 CellLabel->"Out[12]//MatrixForm=",
 CellID->1221911456,ExpressionUUID->"52ba2dbd-5826-4a41-929d-668c571e6f42"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorType", "[", "covdecmat", "]"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->491817166,ExpressionUUID->"3e2cdfb8-b870-42db-a488-b173915aec27"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Covariant\"\>", ",", "\<\"TensorDecompositionMatrix\"\>", 
   ",", "\<\"TensorDecomposition\"\>", ",", "\<\"Contravariant\"\>"}], 
  "}"}]], "Output",
 CellLabel->"Out[13]=",
 CellID->1665161750,ExpressionUUID->"e62dba01-20db-4bed-b4e4-59c34f6e78ba"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox["Tutorials", "TutorialsSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Matrix Notation"]], 
           "paclet:AtomicDensityMatrix/tutorial/MatrixNotation"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "e0e8cbe0-e2dd-4140-a0ff-182e3b960eae"]}]}
     }]}
  }]], "TutorialsSection",ExpressionUUID->"555874bf-4e90-47fd-9aa2-\
7fadb5ac12c3"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "4bd3e414-7267-4988-b0ce-6ea25a93d61b"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"496bd382-4578-41eb-be5f-\
db6e4f014399"],

Cell[" ", "FooterCell",ExpressionUUID->"ea6bd91b-0639-42d2-8a27-9a7871eaaaf0"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"TensorType",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, 
    "ExampleSection" -> {"0" -> Open, "1" -> Closed}, "NotesSection" -> 
    Closed}, "NewStyles" -> True, "CitationPopupData" -> $Failed, 
  "ShowCitation" -> False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 18, 0, 4.204494}", 
    "history" -> {"18.09", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "TensorType[tens] returns a list describing the structure of the tensor \
tens, from top level (outermost), to bottom level (innermost).", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "TensorType", 
    "titlemodifier" -> "", "metadescription" -> "", "windowtitle" -> 
    "TensorType", "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/TensorType"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"c59e14a9-3315-433e-9717-7af0c54c1a9d"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[14289, 344, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"1013f8f6-3620-4894-9c44-a9b834cbe3e6",
   CellTags->"PrimaryExamplesSection",
   CellID->1429210073]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 74716, 2069}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[582, 21, 7410, 171, 57, "AnchorBarGrid",ExpressionUUID->"3bb66950-62dc-4a32-89c1-df4e92c2ca55",
 CellID->1],
Cell[7995, 194, 102, 0, 23, "ContextNameCell",ExpressionUUID->"283d48ec-54de-4c43-bfbc-b71c847d09aa"],
Cell[CellGroupData[{
Cell[8122, 198, 553, 14, 60, "ObjectNameGrid",ExpressionUUID->"6b45e095-56a0-4091-9e11-6d9a40a80f58"],
Cell[8678, 214, 723, 15, 112, "Usage",ExpressionUUID->"225edffe-8ccd-4bbb-ba30-1c756dc483e2",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[9438, 234, 1899, 47, 37, "NotesSection",ExpressionUUID->"3bb2d23d-4c32-4ee1-b962-b855b1b0345d",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1658708540],
Cell[11340, 283, 135, 1, 70, "Notes",ExpressionUUID->"9b1e5eca-5790-454b-adf3-bf3f20278716",
 CellID->1067943069],
Cell[11478, 286, 2331, 42, 70, "2ColumnTableMod",ExpressionUUID->"39140f53-70e2-402a-8524-86c41e6a89a7",
 CellID->1237998268],
Cell[13812, 330, 350, 8, 70, "Notes",ExpressionUUID->"d1cefbb0-e149-49b3-b424-16a084288acb",
 CellID->384640264]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[14289, 344, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"1013f8f6-3620-4894-9c44-a9b834cbe3e6",
 CellTags->"PrimaryExamplesSection",
 CellID->1429210073],
Cell[CellGroupData[{
Cell[15704, 385, 1368, 36, 31, "ExampleSection",ExpressionUUID->"1caa91a9-6f81-49f6-8f01-421ab0ac8987",
 CellID->1129105216],
Cell[17075, 423, 184, 3, 29, "Input",ExpressionUUID->"652aee72-ca41-4b15-b23d-5f3ee0603968",
 CellID->1968454397],
Cell[17262, 428, 108, 1, 38, "ExampleText",ExpressionUUID->"21ffa706-84bb-42a4-9326-9c0b426c725b",
 CellID->1244508620],
Cell[CellGroupData[{
Cell[17395, 433, 161, 3, 29, "Input",ExpressionUUID->"9f6f8e2c-260d-491a-b3f2-40fd09a737a8",
 CellID->105733567],
Cell[17559, 438, 161, 3, 37, "Output",ExpressionUUID->"ac330999-7c95-4019-bca2-6ce04a645c8f",
 CellID->841627125]
}, Open  ]],
Cell[17735, 444, 118, 1, 38, "ExampleText",ExpressionUUID->"dbdc73b6-dd37-4524-84d0-e9e1d9e0bc53",
 CellID->1121145203],
Cell[CellGroupData[{
Cell[17878, 449, 219, 5, 29, "Input",ExpressionUUID->"8421a2a1-4b08-448c-aa09-bcbd6d4008ce",
 CellID->1572170205],
Cell[18100, 456, 164, 3, 37, "Output",ExpressionUUID->"e4e87fb5-cc33-48b5-b606-13d5419d683f",
 CellID->144098568]
}, Open  ]],
Cell[18279, 462, 137, 1, 38, "ExampleText",ExpressionUUID->"1044e78d-c52c-4cb0-b050-52456c5d9231",
 CellID->1031250077],
Cell[CellGroupData[{
Cell[18441, 467, 359, 11, 29, "Input",ExpressionUUID->"e91c7287-49bb-4d37-b4d2-d22b874ce9db",
 CellID->819331085],
Cell[18803, 480, 2582, 71, 82, "Output",ExpressionUUID->"23f5fcd2-54c0-4671-837c-7defc9f58bc8",
 CellID->705668831]
}, Open  ]],
Cell[CellGroupData[{
Cell[21422, 556, 165, 3, 29, "Input",ExpressionUUID->"a14f4d43-b14c-4750-ace4-902e0aaf396e",
 CellID->1967762807],
Cell[21590, 561, 203, 4, 37, "Output",ExpressionUUID->"0e143d7c-551b-4fb2-a6d3-8b3eeef326ca",
 CellID->1330892079]
}, Open  ]],
Cell[21808, 568, 127, 1, 38, "ExampleText",ExpressionUUID->"dc6be693-506d-44ad-a22f-542a88ae8a5e",
 CellID->1625229230],
Cell[CellGroupData[{
Cell[21960, 573, 250, 7, 29, "Input",ExpressionUUID->"1758062c-969e-4480-984d-ab453c50d03e",
 CellID->1893366296],
Cell[22213, 582, 2190, 63, 69, "Output",ExpressionUUID->"641684e1-bea5-4386-a749-ea006036aec3",
 CellID->453759341]
}, Open  ]],
Cell[CellGroupData[{
Cell[24440, 650, 166, 3, 70, "Input",ExpressionUUID->"ed1c0dac-ab9b-4e1e-bf06-9f0ef8b992b1",
 CellID->1920076248],
Cell[24609, 655, 203, 4, 37, "Output",ExpressionUUID->"bc358eea-d578-472c-a32a-408307663c98",
 CellID->1816307083]
}, Open  ]],
Cell[24827, 662, 122, 1, 70, "ExampleText",ExpressionUUID->"ac94890a-019a-4fff-b038-c15e291c73da",
 CellID->1718456422],
Cell[CellGroupData[{
Cell[24974, 667, 384, 11, 70, "Input",ExpressionUUID->"532ecf3a-fcc6-4843-bb22-fb2fc1e947e9",
 CellID->705316750],
Cell[25361, 680, 3674, 110, 113, "Output",ExpressionUUID->"fcfdc1d2-26bb-4f66-96c8-4f1dd5609462",
 CellID->1481863787]
}, Open  ]],
Cell[CellGroupData[{
Cell[29072, 795, 163, 3, 70, "Input",ExpressionUUID->"a3c5b866-faed-478e-96f8-f05427f89015",
 CellID->134045102],
Cell[29238, 800, 219, 5, 37, "Output",ExpressionUUID->"70e31b24-cce1-4edf-9bd0-8e4a771087dc",
 CellID->45365938]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]],
Cell[CellGroupData[{
Cell[29606, 813, 1394, 36, 70, "ExampleSection",ExpressionUUID->"d8ae9127-73a3-46ab-aac4-c29485e17626",
 CellID->1293636265],
Cell[31003, 851, 139, 1, 70, "ExampleText",ExpressionUUID->"f616d74f-3f78-44c9-a569-712da275974e",
 CellID->614433153],
Cell[CellGroupData[{
Cell[31167, 856, 468, 14, 70, "Input",ExpressionUUID->"709815d7-2e4e-4aac-97f3-343607235099",
 CellID->1703958928],
Cell[31638, 872, 2419, 66, 76, "Output",ExpressionUUID->"a690bf9c-35d2-4e51-a70e-afcd8141f369",
 CellID->1264602901]
}, Open  ]],
Cell[CellGroupData[{
Cell[34094, 943, 166, 3, 70, "Input",ExpressionUUID->"5afbf262-007c-489f-a8f6-d0d2d93abf9b",
 CellID->364889602],
Cell[34263, 948, 211, 5, 37, "Output",ExpressionUUID->"cbe8dc1b-cef3-4c3a-8115-29926cf42a25",
 CellID->2124258459]
}, Open  ]],
Cell[34489, 956, 140, 1, 70, "ExampleText",ExpressionUUID->"685f049a-4f6e-41a6-842c-6381450e3c39",
 CellID->1175147473],
Cell[CellGroupData[{
Cell[34654, 961, 259, 7, 70, "Input",ExpressionUUID->"2002a320-12d9-4d7f-9d47-f683f403baf7",
 CellID->1652509801],
Cell[34916, 970, 2017, 58, 61, "Output",ExpressionUUID->"d4fc167d-961d-46e7-82e4-a673adda77bb",
 CellID->288865145]
}, Open  ]],
Cell[CellGroupData[{
Cell[36970, 1033, 168, 3, 70, "Input",ExpressionUUID->"a481e588-e988-4699-ac7a-3af3e4791035",
 CellID->1133461155],
Cell[37141, 1038, 211, 5, 37, "Output",ExpressionUUID->"309917fd-834a-429d-85c3-8a095907b467",
 CellID->1007340944]
}, Open  ]],
Cell[37367, 1046, 135, 1, 70, "ExampleText",ExpressionUUID->"3dc1e4a3-ede9-437c-b7bc-690f1f286a0d",
 CellID->529002313],
Cell[CellGroupData[{
Cell[37527, 1051, 296, 8, 70, "Input",ExpressionUUID->"436b18cc-f82d-4a01-96ca-698d46737317",
 CellID->768722796],
Cell[37826, 1061, 2027, 56, 44, "Output",ExpressionUUID->"f9f6271d-9032-4186-b305-090f69090e11",
 CellID->574295666]
}, Open  ]],
Cell[CellGroupData[{
Cell[39890, 1122, 166, 3, 70, "Input",ExpressionUUID->"80224e6f-54d2-461d-99a5-0e58e6a2cbd6",
 CellID->93924520],
Cell[40059, 1127, 203, 4, 37, "Output",ExpressionUUID->"8e01dd88-9928-4e1d-810d-89a4952918c9",
 CellID->929005375]
}, Open  ]],
Cell[40277, 1134, 138, 1, 70, "ExampleText",ExpressionUUID->"552407b2-238a-4a28-95f5-3139a2b76fee",
 CellID->320022720],
Cell[CellGroupData[{
Cell[40440, 1139, 281, 7, 70, "Input",ExpressionUUID->"07edb915-3361-4ac4-b502-82da3d55d18d",
 CellID->1882132021],
Cell[40724, 1148, 3949, 106, 73, "Output",ExpressionUUID->"2a789a76-1024-4c3b-a943-76d3d15d4dca",
 CellID->516242361]
}, Open  ]],
Cell[CellGroupData[{
Cell[44710, 1259, 163, 3, 70, "Input",ExpressionUUID->"b9157f2f-86e2-4f21-a667-1a1b41ca87e2",
 CellID->1348202453],
Cell[44876, 1264, 242, 5, 37, "Output",ExpressionUUID->"ebe44c51-4118-4de3-897f-e6ba96385b29",
 CellID->790073943]
}, Open  ]],
Cell[45133, 1272, 142, 1, 70, "ExampleText",ExpressionUUID->"25bf22ad-0334-4a71-8d44-11882abe5dad",
 CellID->158495034],
Cell[CellGroupData[{
Cell[45300, 1277, 489, 13, 70, "Input",ExpressionUUID->"f1b096eb-687c-472f-b1eb-4297f3fb7b3a",
 CellID->1959658587],
Cell[45792, 1292, 925, 24, 55, "Output",ExpressionUUID->"a17c10d5-2d63-44b3-a9c0-388e1fd4e067",
 CellID->1986906778]
}, Open  ]],
Cell[CellGroupData[{
Cell[46754, 1321, 364, 10, 70, "Input",ExpressionUUID->"6ec52bdd-cedd-4476-96c0-57bd1f1b39b0",
 CellID->2060525409],
Cell[47121, 1333, 5004, 138, 170, "Output",ExpressionUUID->"1af4bf36-036d-4d32-92ee-1a1b56c1dc6e",
 CellID->237456295]
}, Open  ]],
Cell[CellGroupData[{
Cell[52162, 1476, 168, 3, 70, "Input",ExpressionUUID->"52ad708e-bb64-416f-be83-4907b1e5c3f6",
 CellID->1268887389],
Cell[52333, 1481, 268, 6, 37, "Output",ExpressionUUID->"1efce52a-cbce-4882-abdd-04c2f54173ff",
 CellID->1680008918]
}, Open  ]],
Cell[52616, 1490, 173, 3, 70, "ExampleText",ExpressionUUID->"37bbe108-3f02-45bc-9350-195e9394ebfa",
 CellID->1583545122],
Cell[CellGroupData[{
Cell[52814, 1497, 631, 18, 70, "Input",ExpressionUUID->"ca5a8184-7c53-4515-9513-85d21da2f9c3",
 CellID->452883312],
Cell[53448, 1517, 17004, 438, 170, "Output",ExpressionUUID->"52ba2dbd-5826-4a41-929d-668c571e6f42",
 CellID->1221911456]
}, Open  ]],
Cell[CellGroupData[{
Cell[70489, 1960, 170, 3, 70, "Input",ExpressionUUID->"3e2cdfb8-b870-42db-a488-b173915aec27",
 CellID->491817166],
Cell[70662, 1965, 294, 6, 37, "Output",ExpressionUUID->"e62dba01-20db-4bed-b4e4-59c34f6e78ba",
 CellID->1665161750]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "1"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[71198, 1980, 718, 19, 70, "TutorialsSection",ExpressionUUID->"555874bf-4e90-47fd-9aa2-7fadb5ac12c3"],
Cell[71919, 2001, 753, 19, 70, "MoreAboutSection",ExpressionUUID->"496bd382-4578-41eb-be5f-db6e4f014399"],
Cell[72675, 2022, 78, 0, 70, "FooterCell",ExpressionUUID->"ea6bd91b-0639-42d2-8a27-9a7871eaaaf0"]
}
]
*)

(* End of internal cache information *)

