(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     26517,        710]
NotebookOptionsPosition[     21973,        618]
NotebookOutlinePosition[     24197,        673]
CellTagsIndexPosition[     24112,        668]
WindowTitle->TimeVariable
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX SYMBOL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "652de031-7a65-4306-a3bc-699c88b70846"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "7aab66f9-a7ad-46f8-af2e-ca9392d4a785"],
        Background->RGBColor[0.490196, 0.576471, 0.690196],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "See Also",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "85822f1e-c25c-4f0c-837c-52ac6296a8b4"]
         }],ExpressionUUID->"760affb5-9b1a-4216-aac0-3eb2634d6c0d"],
         StripOnInput->False], {"\<\"DMVariables\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/DMVariables"], "\<\"Ket\"\>":>
        Documentation`HelpLookup["paclet:AtomicDensityMatrix/ref/Ket"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"SeeAlso"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "d2b88dad-c6f6-4993-a41a-422442a2e377"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "bb7efec3-7d42-48b3-807a-2b71fed65fab"]
         }],ExpressionUUID->"77a91691-08d3-46f0-902f-1904e06ca0ee"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"MoreAbout"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "d8f75ba2-1b35-4ee1-abb3-da0e9fcb9bb3"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "aabfb97c-84b4-4b7f-9bb6-e11b4e38fe8e"]
         }],ExpressionUUID->"0beaa0ad-845e-4912-9fed-153d36ed5a08"],
         StripOnInput->False], {"\<\"Displaying the Density Matrix\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"Tutorials"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "68ebecfa-84f5-4278-8be9-41cae46f1661"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "7ed2a15b-564c-4f0c-81bc-6fd005f7922a"]
         }],ExpressionUUID->"46d7cb61-39a6-4218-8076-b79d43820ad6"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/ref/TimeVariable\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/ref/TimeVariable"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
ref/TimeVariable.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$66217], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/ref/TimeVariable" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "15094e38-ab90-41f3-bdab-3ff1ad455667"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "a0bf7546-ab52-45b5-8b86-a5b220feea26"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"43bc0826-152c-4f48-9006-cbec70fe89b6"],

Cell["AtomicDensityMatrix`", "ContextNameCell",ExpressionUUID->"27e2462f-8e1d-4a41-9182-c75af5c0acb0"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {Cell[TextData[{
     Cell[
     "TimeVariable", "ObjectName",ExpressionUUID->
      "547d117c-0bcb-46f1-b69a-3a25159a80b1"],
     Cell[BoxData[
      TemplateBox[{8},
       "Spacer1"]],ExpressionUUID->"2552d4dd-9a52-437c-9608-697cb7a3fe1f"],
     Cell[BoxData[
     ""], "ObjectNameTranslation",ExpressionUUID->
      "6f2c4076-320a-40f2-9879-fb2e2b6c38be"]
    }],ExpressionUUID->"779eee60-71f8-47a8-85a5-11a2d41b9eac"], 
    "\[SpanFromLeft]"}
  }]], "ObjectNameGrid",ExpressionUUID->"5cd85489-2083-4413-8c50-\
1e3aea219ba3"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["TimeVariable"], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "27f666e4-661e-4f64-801b-907461256861"],
     " \[LineSeparator]is an option for ",
     Cell[BoxData[
      TemplateBox[{
        Cell[
         TextData["DensityMatrix"]], 
        "paclet:AtomicDensityMatrix/ref/DensityMatrix", 
        "AtomicDensityMatrix Package Symbol"},
       "PackageLink",
       BaseStyle->"InlineFormula"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "858a7dba-8e89-48f0-8b8f-8b21a14ba579"],
     " and related functions that specifies what symbol is to be used for the \
time variable."
    }],ExpressionUUID->"8b8edb6d-55b4-4aab-9606-6fb43a93ade5"]}
  }]], "Usage",
 CellID->982511436,ExpressionUUID->"edde0667-d14f-4fb2-be3c-61ae96376f13"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    DynamicBox[ToBoxes[
      If[
       MatchQ[
        CurrentValue[
         EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, 
         Closed], 
        Alternatives[Open, True]], 
       Style[
        Graphics[{
          Thickness[0.18], 
          RGBColor[0.8509803921568627, 0.396078431372549, 0], 
          Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
         PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
        0.68 Inherited], 
       Rotate[
        Style[
         Graphics[{
           Thickness[0.18], 
           RGBColor[0.8509803921568627, 0.396078431372549, 0], 
           Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
          PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
         0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
     ImageSizeCache->{14., {0.45000000000000107`, 13.549999999999999`}}]],
    ExpressionUUID->"7949dd12-ce9f-47e3-8b8c-f4151f8b12fa"],
   Cell[BoxData[
    TemplateBox[{1},
     "Spacer1"]],ExpressionUUID->"d318892a-81a6-4479-87b6-31b1e36cb337"],
   "Details and Options"
  }], "NotesFrameText",ExpressionUUID->"bfdc93fb-cf30-4066-ac88-042e217aa906"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"78f93d36-a034-411c-b703-9c9631c3bd6d"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CacheGraphics->False,
 CellID->588098496,ExpressionUUID->"d7fb20fd-8276-41e9-83b6-22dd677a3252"],

Cell[TextData[{
 "The default value is ",
 Cell[BoxData["t"], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "c4ed8afd-1fbf-4bd0-b139-15fe1999beec"],
 "."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"1800b3fe-dd76-4c99-9d3f-8bca838a7292"],

Cell[TextData[{
 "The value ",
 Cell[BoxData[
  RowBox[{
   TemplateBox[{
     Cell[
      TextData["TimeVariable"]], 
     "paclet:AtomicDensityMatrix/ref/TimeVariable", 
     "AtomicDensityMatrix Package Symbol"},
    "PackageLink",
    BaseStyle->"InlineFormula"], "->", 
   TemplateBox[{
     Cell[
      TextData["Automatic"]], "paclet:ref/Automatic"},
    "RefLink",
    BaseStyle->{"InlineFormula"}]}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "d90ed64b-811a-4fc6-9cb7-87f6a30519ac"],
 " specified for any function other than ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["DensityMatrix"]], 
    "paclet:AtomicDensityMatrix/ref/DensityMatrix", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "f8bd87c0-05a6-4854-9814-bce73909cf3d"],
 " means to use the default value specified in ",
 Cell[BoxData[
  RowBox[{
   TemplateBox[{
     Cell[
      TextData["Options"]], "paclet:ref/Options"},
    "RefLink",
    BaseStyle->{"InlineFormula"}], "[", 
   TemplateBox[{
     Cell[
      TextData["DensityMatrix"]], 
     "paclet:AtomicDensityMatrix/ref/DensityMatrix", 
     "AtomicDensityMatrix Package Symbol"},
    "PackageLink",
    BaseStyle->"InlineFormula"], "]"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "1247c81a-ed92-42d7-80e5-47751741462f"],
 "."
}], "Notes",
 CellID->509804380,ExpressionUUID->"6ecb0ab4-327f-495f-82af-d1a2f91f953d"]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {
       TaggingRules, "Openers", "PrimaryExamplesSection"}, Open], 
      Alternatives[True, Open]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "5db12973-fa4b-4ff8-ac23-8dc316062951"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"d8921c2a-4d59-496c-87df-1adcd75016fb"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "dc6667d8-1cb2-492e-9b14-62ee2062ea3d"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellTags->"PrimaryExamplesSection",
 CellID->1451678778,ExpressionUUID->"d1e74f9a-2af3-4278-95b6-4bfd40ff27e1"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  DynamicBox[ToBoxes[
    If[
     MatchQ[
      CurrentValue[
       EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"},
        Closed], 
      Alternatives[Open, True]], 
     Style[
      Graphics[{
        Thickness[0.18], 
        RGBColor[0.8509803921568627, 0.396078431372549, 0], 
        Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
       PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
      0.68 Inherited], 
     Rotate[
      Style[
       Graphics[{
         Thickness[0.18], 
         RGBColor[0.8509803921568627, 0.396078431372549, 0], 
         Line[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited], Rational[1, 2] Pi, {-1.65, -1}]]],
   ImageSizeCache->{14., {5., 9.}}]],ExpressionUUID->
  "683f2a0f-6ae8-401e-a0ef-7a0dbb529516"],
 Cell[BoxData[
  TemplateBox[{1},
   "Spacer1"]],ExpressionUUID->"3639291a-6393-437a-bd86-26d6b9b886be"],
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "d3c89b27-f056-4ec6-96fd-b9cf4d7a6fc6"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CacheGraphics->False,
 CellID->803508279,ExpressionUUID->"aee0cb3b-c772-4ace-b308-ec79cd402b14"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1289603855,ExpressionUUID->"58f1a802-dd33-4fc2-a352-76ac7d50c2f3"],

Cell["Use a different time variable:", "ExampleText",
 CellID->1967025461,ExpressionUUID->"a3fe86d1-4e31-4bf9-9931-a3f92c71ab11"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", 
   RowBox[{
    RowBox[{"Sublevels", "@", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", " ", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
    RowBox[{"TimeVariable", "\[Rule]", "s"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->952170122,ExpressionUUID->"1b186450-4fdc-4f26-927e-4b4162cac44c"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "s", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "s", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "s", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "s", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "s", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "s", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]], "[", "s", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]], "[", "s", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]], "[", "s", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[2]//MatrixForm=",
 CellID->847482513,ExpressionUUID->"26672a6a-68e6-4545-835a-25b04f6d2a99"]
}, Open  ]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, 
  Closed]]]]
}, Dynamic[CurrentValue[
 EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, 
  Closed]]]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedFunction.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"See", " ", "Also"}], "SeeAlsoSection"]},
      {Cell[TextData[{
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["DMVariables"]], 
           "paclet:AtomicDensityMatrix/ref/DMVariables", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "c857a37c-a520-41e5-b9b5-9149f48346e6"],
        "\[NonBreakingSpace]",
        StyleBox[
        "\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
         "InlineSeparator"],
        " ",
        Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Ket"]], "paclet:AtomicDensityMatrix/ref/Ket", 
           "AtomicDensityMatrix Package Symbol"},
          "PackageLink",
          BaseStyle->"InlineFormula"]], "InlineFormula",
         FontFamily->"Source Sans Pro",ExpressionUUID->
         "48a0d8c1-96f4-42d9-af34-dedf55aeed3f"]
       }], "SeeAlso",ExpressionUUID->"4e18f000-492c-41d7-bb20-b9d501be7f6c"]}
     }]}
  }]], "SeeAlsoSection",ExpressionUUID->"59250988-511d-4f1b-bacc-\
5b13999d9fd2"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox["Tutorials", "TutorialsSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["Displaying the Density Matrix"]], 
           "paclet:AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"Tutorials"}]], "Tutorials",ExpressionUUID->
         "4bb4eeba-78a5-434c-9450-860f26cad845"]}]}
     }]}
  }]], "TutorialsSection",ExpressionUUID->"43d648a6-91cd-4823-8548-\
9af773cc481c"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "MoreAboutSection"]},
      {
       RowBox[{"\[FilledVerySmallSquare]", Cell[BoxData[
         TemplateBox[{
           Cell[
            TextData["AtomicDensityMatrix Package"]], 
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"},
          "RefLinkPlain",
          BaseStyle->{"MoreAbout"}]], "MoreAbout",ExpressionUUID->
         "55ca23da-359c-4769-a2a3-37d21fd19cba"]}]}
     }]}
  }]], "MoreAboutSection",ExpressionUUID->"82d1aad2-de8e-4b55-8abe-\
936e7c8d3b4f"],

Cell[" ", "FooterCell",ExpressionUUID->"a8f415b1-f4a8-4a3f-9220-27301b20f50c"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"TimeVariable",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "HasOptions" -> True, "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}, 
    "NotesSection" -> Closed}, "NewStyles" -> True, 
  "CitationPopupData" -> $Failed, "ShowCitation" -> False, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2023, 4, 18, 18, 0, 6.164976}", 
    "history" -> {"17.08", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Symbol", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "TimeVariable is an option for DensityMatrix and related functions that \
specifies what symbol is to be used for the time variable.", "synonyms" -> {},
     "tabletags" -> {}, "title" -> "TimeVariable", "titlemodifier" -> "", 
    "metadescription" -> "", "windowtitle" -> "TimeVariable", "type" -> 
    "Symbol", "uri" -> "AtomicDensityMatrix/ref/TimeVariable"}},
CellContext->"Global`",
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"6fc3a5af-36d8-40b2-a37b-92c85023b569"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[12381, 335, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"d1e74f9a-2af3-4278-95b6-4bfd40ff27e1",
   CellTags->"PrimaryExamplesSection",
   CellID->1451678778]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 23911, 661}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[584, 21, 6386, 155, 57, "AnchorBarGrid",ExpressionUUID->"43bc0826-152c-4f48-9006-cbec70fe89b6",
 CellID->1],
Cell[6973, 178, 102, 0, 23, "ContextNameCell",ExpressionUUID->"27e2462f-8e1d-4a41-9182-c75af5c0acb0"],
Cell[CellGroupData[{
Cell[7100, 182, 555, 14, 60, "ObjectNameGrid",ExpressionUUID->"5cd85489-2083-4413-8c50-1e3aea219ba3"],
Cell[7658, 198, 863, 20, 114, "Usage",ExpressionUUID->"edde0667-d14f-4fb2-be3c-61ae96376f13",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[8558, 223, 1898, 47, 37, "NotesSection",ExpressionUUID->"d7fb20fd-8276-41e9-83b6-22dd677a3252",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->588098496],
Cell[10459, 272, 264, 7, 70, "Notes",ExpressionUUID->"1800b3fe-dd76-4c99-9d3f-8bca838a7292",
 CellID->1067943069],
Cell[10726, 281, 1528, 48, 70, "Notes",ExpressionUUID->"6ecb0ab4-327f-495f-82af-d1a2f91f953d",
 CellID->509804380]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "NotesSection"}, Closed]]]],
Cell[CellGroupData[{
Cell[12381, 335, 1390, 37, 36, "PrimaryExamplesSection",ExpressionUUID->"d1e74f9a-2af3-4278-95b6-4bfd40ff27e1",
 CellTags->"PrimaryExamplesSection",
 CellID->1451678778],
Cell[CellGroupData[{
Cell[13796, 376, 1367, 36, 31, "ExampleSection",ExpressionUUID->"aee0cb3b-c772-4ace-b308-ec79cd402b14",
 CellID->803508279],
Cell[15166, 414, 184, 3, 29, "Input",ExpressionUUID->"58f1a802-dd33-4fc2-a352-76ac7d50c2f3",
 CellID->1289603855],
Cell[15353, 419, 129, 1, 38, "ExampleText",ExpressionUUID->"a3fe86d1-4e31-4bf9-9931-a3f92c71ab11",
 CellID->1967025461],
Cell[CellGroupData[{
Cell[15507, 424, 406, 11, 29, "Input",ExpressionUUID->"1b186450-4fdc-4f26-927e-4b4162cac44c",
 CellID->952170122],
Cell[15916, 437, 2824, 89, 88, "Output",ExpressionUUID->"26672a6a-68e6-4545-835a-25b04f6d2a99",
 CellID->847482513]
}, Open  ]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "ExampleSection", "0"}, Closed]]]]
}, Dynamic[CurrentValue[EvaluationNotebook[], {TaggingRules, "Openers", "PrimaryExamplesSection"}, Closed]]]],
Cell[18982, 535, 1403, 37, 114, "SeeAlsoSection",ExpressionUUID->"59250988-511d-4f1b-bacc-5b13999d9fd2"],
Cell[20388, 574, 744, 19, 114, "TutorialsSection",ExpressionUUID->"43d648a6-91cd-4823-8548-9af773cc481c"],
Cell[21135, 595, 753, 19, 114, "MoreAboutSection",ExpressionUUID->"82d1aad2-de8e-4b55-8abe-936e7c8d3b4f"],
Cell[21891, 616, 78, 0, 70, "FooterCell",ExpressionUUID->"a8f415b1-f4a8-4a3f-9220-27301b20f50c"]
}
]
*)

(* End of internal cache information *)

