(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    103432,       2021]
NotebookOptionsPosition[     97235,       1888]
NotebookOutlinePosition[    100161,       1957]
CellTagsIndexPosition[    100081,       1952]
WindowTitle->Crossed Electric and Magnetic Fields
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "8e4e598a-48fd-4a82-9a08-857224e5d368"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "de144147-520b-4d2b-b16c-8433c9370e2f"],
        Background->RGBColor[
         0.7450980392156863, 0.3254901960784314, 0.1411764705882353],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "eb3fb246-ac97-4164-bbfc-1458d0fc85e8"]
         }],ExpressionUUID->"88044ac5-4d26-4d55-9e89-9ffa20af596c"],
         StripOnInput->False], {"\<\"Stark Mixing\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/StarkMixing"], "\<\"Hyperfine \
Structure: Breit-Rabi Diagram\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/\
HyperfineStructureBreitRabiDiagram"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"RelatedTutorialsSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "689c2647-ad33-44ca-a165-0e67168400af"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "82bc8402-273e-42ea-97b1-a83c0cd0dac2"]
         }],ExpressionUUID->"d5e41314-7f5c-4f21-9b96-e2ea05e8551a"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"TutorialMoreAboutSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "4edc760c-e5ce-4b19-b86f-0065ba79ef5c"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "e7cab79c-be02-43f1-a235-6a8f407564f5"]
         }],ExpressionUUID->"c5f15cb6-83a7-4d35-b589-5357e88aaa4d"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/tutorial/\
CrossedElectricAndMagneticFields\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
              "AtomicDensityMatrix/tutorial/CrossedElectricAndMagneticFields"]\
}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
tutorial/CrossedElectricAndMagneticFields.html"], StandardForm]], "Input", 
               TextClipboardType -> "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$70572], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/tutorial/CrossedElectricAndMagneticFields" <> 
             ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "58f9721b-5534-4978-85ee-8c0d2361573b"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "1bf10ade-611a-4bdf-9f96-b450760145d3"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"df4307a1-bf8f-4196-8277-e1dc1ad6f5a7"],

Cell[CellGroupData[{

Cell["Crossed Electric and Magnetic Fields", "Title",
 CellID->147735377,ExpressionUUID->"2158d5cb-8a3f-4341-a371-288914cc1176"],

Cell[TextData[{
 "Here we analyze a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "1"}], "InlineMath"]],ExpressionUUID->
  "b8b871bc-58bd-46c3-8b30-380005a58ca1"],
 " state subject to crossed electric and magnetic fields. The effects of \
Stark mixing on the sublevels of a single state can be accounted for to \
second order in the electric field by writing an effective Hamiltonian in \
terms of the polarizability of the atomic state."
}], "Text",
 CellID->455402839,ExpressionUUID->"1198a25e-1c54-43f9-9277-1cbc14457ef5"],

Cell["This loads the package.", "MathCaption",
 CellID->159403208,ExpressionUUID->"3194c527-a7cd-4445-a7a1-7b0e4d693102"],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->75905070,ExpressionUUID->"65e2e29d-5272-4c12-b6d3-23fa820374ec"],

Cell["\<\
Define the atomic system. The state is assumed to have a tensor \
polarizability but no scalar polarizability.\
\>", "MathCaption",
 CellID->451740640,ExpressionUUID->"97055047-48e8-4228-8653-8bff39422b11"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"system", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", "1"}], ",", 
      RowBox[{"L", "\[Rule]", "1"}], ",", 
      RowBox[{"S", "\[Rule]", "0"}], ",", 
      RowBox[{"Energy", "\[Rule]", "0"}], ",", 
      RowBox[{
       RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
      RowBox[{
       RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}]}], 
     "]"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->162218567,ExpressionUUID->"9049b043-0b55-46b6-a92c-ab147afcabd6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}], 
     ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}], 
     ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "\[Alpha]2"}], 
     ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1361106502,ExpressionUUID->"9cd20050-34bd-485a-a2e0-ec9f6d8ede82"]
}, Open  ]],

Cell[TextData[{
 "The Hamiltonian for the system subject to the magnetic and electric fields. \
We must explicitly specify the ",
 Cell[BoxData["\"\<Polarizability\>\""], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "791c0c9d-ecc4-4293-bb1e-d3927da2f09d"],
 " interaction, because it is not included by default."
}], "MathCaption",
 CellID->106825082,ExpressionUUID->"39056690-2617-4e39-ba2c-40e630faf291"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"h", "=", 
   RowBox[{"Hamiltonian", "[", 
    RowBox[{"system", ",", 
     RowBox[{"ElectricField", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Ex", ",", "0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"MagneticField", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{"\[CapitalOmega]L", "/", "BohrMagneton"}]}], "}"}]}], ",", 
     RowBox[{"Interaction", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Internal\>\"", ",", "\"\<MagneticDipole\>\"", ",", 
        "\"\<Polarizability\>\""}], "}"}]}]}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->247023563,ExpressionUUID->"53de68ec-4355-45c6-b4c0-d929cae905f4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "4"], "+", 
       "\[CapitalOmega]L"}], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"3", " ", 
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "4"]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "2"]}], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{"3", " ", 
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "4"]}], "0", 
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "4"], "-", 
       "\[CapitalOmega]L"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[3]//MatrixForm=",
 CellID->1121171270,ExpressionUUID->"9d53845d-e64e-49b1-a333-b79560247955"]
}, Open  ]],

Cell["\<\
The eigenenergies and eigenstates of the system in the presence of the fields.\
\>", "MathCaption",
 CellID->185247108,ExpressionUUID->"0351f392-febe-4e49-ac82-4a40f533011b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"energies", ",", "states"}], "}"}], "=", 
  RowBox[{"Eigensystem", "[", "h", "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->500586757,ExpressionUUID->"a47c4148-4438-4a42-b8ae-d017b6ef89f4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "2"]}], ",", 
     RowBox[{
      FractionBox["1", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "-", 
        SqrtBox[
         RowBox[{
          RowBox[{"9", " ", 
           SuperscriptBox["Ex", "4"], " ", 
           SuperscriptBox["\[Alpha]2", "2"]}], "+", 
          RowBox[{"16", " ", 
           SuperscriptBox["\[CapitalOmega]L", "2"]}]}]]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}], "+", 
        SqrtBox[
         RowBox[{
          RowBox[{"9", " ", 
           SuperscriptBox["Ex", "4"], " ", 
           SuperscriptBox["\[Alpha]2", "2"]}], "+", 
          RowBox[{"16", " ", 
           SuperscriptBox["\[CapitalOmega]L", "2"]}]}]]}], ")"}]}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"4", " ", "\[CapitalOmega]L"}], "-", 
          SqrtBox[
           RowBox[{
            RowBox[{"9", " ", 
             SuperscriptBox["Ex", "4"], " ", 
             SuperscriptBox["\[Alpha]2", "2"]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["\[CapitalOmega]L", "2"]}]}]]}], 
         RowBox[{"3", " ", 
          SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}]]}], ",", "0", ",", 
       "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"4", " ", "\[CapitalOmega]L"}], "+", 
          SqrtBox[
           RowBox[{
            RowBox[{"9", " ", 
             SuperscriptBox["Ex", "4"], " ", 
             SuperscriptBox["\[Alpha]2", "2"]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["\[CapitalOmega]L", "2"]}]}]]}], 
         RowBox[{"3", " ", 
          SuperscriptBox["Ex", "2"], " ", "\[Alpha]2"}]]}], ",", "0", ",", 
       "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellLabel->"Out[4]=",
 CellID->1504016112,ExpressionUUID->"83d297d7-037a-41cf-98a7-4a7923fbabaf"]
}, Open  ]],

Cell["\<\
An energy plot as a function of electric field for fixed magnetic field.\
\>", "MathCaption",
 CellID->994177565,ExpressionUUID->"303d9740-252f-4129-90fd-a2f214c95660"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"energies", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[CapitalOmega]L", "\[Rule]", "1"}], ",", 
       RowBox[{"\[Alpha]2", "\[Rule]", "1"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"Ex", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->46048850,ExpressionUUID->"fbdcf1bb-e281-42df-8b1e-68018056c189"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3Qd4VGW+P3BYUe/6l7vLWu7e/6PP/9777N3iXvduk0VdXXVdRddFRdxV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    "], {{0, 149.}, {240., 0}}, {0, 255},
    ColorFunction->RGBColor,
    ImageResolution->{144., 144.},
    SmoothingQuality->"High"],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{240., 149.},
  PlotRange->{{0, 240.}, {0, 149.}}]], "Output",
 CellTags->"RasterizedOutput",
 CellLabel->"Out[5]=",
 CellID->500467471,ExpressionUUID->"35ea2ca2-4364-4e6c-aa61-90253fd6f878"]
}, Open  ]],

Cell["\<\
An energy plot as a function of magnetic field for fixed electric field.\
\>", "MathCaption",
 CellID->187075318,ExpressionUUID->"992f49b7-3299-437b-a10f-711896c59bbb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"energies", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Ex", "\[Rule]", "1"}], ",", 
       RowBox[{"\[Alpha]2", "\[Rule]", "1"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalOmega]L", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->813397135,ExpressionUUID->"4590c499-f3fc-4946-b548-36420da88b0e"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQrWcv9ur/f/4DDGDwYH9Q+9nVxvEIfvn5ltz0fXxw
/pUr3K8OJvLC+bIH8kXMZXjg/K3ZR1j573LB+Qk9hh9uNnHC+T8mVXfst+eA
8xfz3ZOc8ZANzp/jZVh0uZMVzm/KSazQ9GSB86uZV5UXvWWC8xMbzqtcW8EI
50/d+3TGnCwGOH/XfQ2eNUr/9sP4ygIOTiHzfsP5m7Q6sh49/gHn3z+6UcHM
7Buc/1RnqtH+bZ/hfMG6lWZ6jB/hfB2z9zpLP7+B85td3l7YWfEczhcNWTch
UvwRwr5vR/lPqNyC85feftr7suUcnB8bKLPldvIWOH8nV/XVQ6Wb7WF800eM
co0R5+F85Q+7f1odugnney6+edYv4hGc7+orxPx163M4vz/+eoPB9jdw/nE/
Wd4AoY9w/ltF0bpLsz7D+aUl2on9Yt/g/Ot3BILSTvyA8xMqbZ6z+/yG8w9r
m3cdZv0H56tx7nmxxIPBAcaX3ZPtytrBCOcz/GJaWfSICc7/Hrg37qgqC5x/
2yReWrWFFc4vCBcQVLrDBudLTnkSwSLLAeevi16w/HMFJ5wfblvvcWIvF5y/
MS5XyeoPN5z/g8uZeWcoL5wfdNHaTHYGH5zvwKE5gc+HH86H5hc4HwAauhm+

       "]]},
     Annotation[#, "Charting`Private`Tag$258851#1"]& ], 
    TagBox[
     {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJw1l2k01V0bxo3hcM5BIoVCydQgEkn7T6XJ3OAUJfWIDA1kqpTQYKgkSTJl
KCRDVAj3xlGSKWOm/M855ociMiW9513rfT/stdfvw97r3td13WuvW/HUeWtH
Ph4eHg53/XffgKRH/v6l48BiLf/yezR8fk75ztw8HTdmiK37EkLDuflaKpO/
6Li2Pb2dDKbhzapmpwb+peN5Yy0znis0vFUiuLO2nY7ZAh0hyImGCc5EzZMc
Os5sQ6aAaNj6dt1LbXs69tTIEmWOU7FPQ7C7UxkND6P76znWVNzSIjpS7kDF
Wyl6bxYWRLE8Pi+1VU4M5695/NmyjILfuDIF6T0U3BRA7rpxSwSfDNca7wgU
weDou1xsizCejbxyB5AwPtbxXnVqfglOoX2TjWEtwZvlmYzkF4I4br+WR3OI
ID7C6KiushXAgW4Ovmr7BLDOdz3W3XX8+Ap/po/HGB/u+uqyc2kXL3YIaFjT
ls6LYxX6y9Oe8+BHpf0xcS48+PViirbgr0Uo7lUVy1JahJ9rjhQ1nl8AZXHC
+FDCbwiWPVHaKzcPr9XvuLA5s+DRU9Bc8WwGeqvyVuvqTsNZxQjGwo5f0K/5
aDO8nYRRB+9z2lKTIHEtQ3cD7wQMZv0unm8YB03dH5ppk6MQ6yXQuPLpGATt
Gmss8h2EeomZ1PoHw1Cxd9RC5/QgfH/HP1cVOAw8Zv/WZ5sNghR7+jTTcxiu
Hh6uTVEaBF3Vr6lth4fB+0x/9d3aAWiq28GyWjEMznd6sMPqAfhut7HvZeoQ
mNbW5YpU90Fy6u/8LTAIyw5lRxyVYYMWQ5YhTBuA1yphxbv52XBM0Q5P8w6A
5ZxTn9YPFsS2uuOxX/0QmqCoR/nIgrnSoLxfPf2wOBTVW+zNghmsdPVcdj8M
+F/ZINdGwrXMv7/ErPrhnMWDmFK1Xig5K87YF98H6VP7Rx/x9kK1l5q/fWQf
sJ8IEOc6voF2elb09dt9cKTPZ1Ah5BtIH4ls6bnYB8jvhG7AUA/MZRSXLN3T
B+IpGi3GL7pBPcDr2PlJDryerqJXr+kE6wqdpq2HOHAvM7lix1wHyIhPibTu
44Drieteb+o6wKtXL/c64sCaD3pdyd4doGxx9+YfdQ5EP3r53L/6Kyz9HcMT
z8eByzoPDLXd2kGTZZ7uW8AGYw8714T8FninsoqgKbNBQUVfYdmdFhD5Ps/r
s4INvzuWfQmzawGhTYZyPyTYUGDUoOsn2AK9pHE0lZcNKhLGfIdsmqFVO3eX
IMkCSu66JyK/v8DGtAP3R5NYkNbVf3c4uB4CL/Tf4dnIgs6r0onx2vXg8iop
vVeVBTSFPblW7Dp4nNpWWKfEAu+T6U1FqA5yHsy0tkmzwKTfRSZ0/jNMLe7e
kPCXhKHvP5LUL3yCs9b+3pQWEuQiVr/+pvAJ4o+/COupJ8FSy6oysq4a4nbr
6eJPJBR6vu6fV6+G4afSHgVAQsjsJfXP/R/g3rPsu0ezSFDnm893tWWCnP8a
y4Q7JJxIUa9aRWFC98aH4ueDSYjcZdvWXFgJ6vNLpi0CSJi/VTJrIF0JvP7X
LY19Sfgset1Q7Es5OInaKY44k8DzKsccXy+H6XSroe2OJOiYk/aXNpQDTIVK
JjmQEBdhFNgdhkHQofnV42MkfFUXvnf0bhlcmU5lmpqRQLifzS0fKYXcFc6u
yvtJSM+paVLbWwr7um5mUfaQ4KdzV2aerwTOyK+SETUiYcUOyWexvkXgenKZ
XssWEgIDPCv52grhKW6w26RNwr8VLf0u2oWwLdHsQPwmEkr2PFY3+P4WRqQH
YjM0SDhuJVfQdboAdMMiIsOVSBid/KXvxcyHbx+MKZdXk3A1ugFoa/Mh3Maw
xkeBW39X4GejgTzw/LtZO3UFCZrX7Ky6TPLA/9RPTtNyEt6v1m2/9CIXDv8T
OCohQ0LB56Yqiy/ZYDJjsLR8KQkt4re+BEa+gi1eqnpakiRMHtbveXMwCw6t
c63IEydhM5k4tbItA0TlJZf2UUmwWnuQx+JxOuzN1O59JEbCBZclYoGMF5DJ
XCvHECUhZ8pNeagzFeJUQ39SRUio11+9cWVcCjA8cyN4hUn4fq15m/nxZPCU
p2cICpFAZd4yuaHwDFiXswxXLCGBIXkp1RkSIZlwt0SCJDyO63xfbxQPNhel
OJcESGhTMWrWYcaCyoGdM8X8JEjlvRiJNYmBGV2/exJcPmhA4+P99AgoRUsz
ffm4eam6JOt04CEMnjI/MM5LQqNF16a6ugh4+cHY05fLCgVBEWeSwiHLdUhJ
gstPqy1hc9ptCGJK2RbzkLC8R/77YkYguKtckbvEZQ1Oq3708SsgWZHltIPL
KmIXHm9wugjp8csNZbkc0KLasrLyOFyKEI0X4LImvcdFcP0uVIByb/NwuW0i
MFF81hkNyNH/iHF53GLdz/Me3ui8I+2PGpevPDSpcdUJQGnKHrdtuLx4ze9p
4sabaLtW99NH/73fJcutWT0USRnU6vdxmf9Ir6GQyn3k+CHx5E5u/ZWrQ27H
i0cis62R9HwuB0crXdh6LwqVfy3Zrc3Vw0SshPFF9DH62i/Nx+SyUOBhI9eQ
J8g7ymunI1e/6pnvaoJCcYihGC4sw9U71P2OZGJwAvLq+deig8vPJyL85W4k
obLtAsuzuP44OamfebuYjLyqPJWDuH7uVfI5FmSYinbK856+zfVbtafS3PJq
GuI8zV8Zx83DiPXxrSNzL9Blh6Af09y81FAzNd7pZaBT/TWChtx8vayeXhXs
k4mcDcLDHtJIcNsRIazwKwuNDp3uvChBgtlc98KIdjZakvw0fo6b1w0FahPv
PHKQjGYE84EUCbNRrFHV2VxUFxS6aZKb9yLKldYKr3zUn5Ypf3kVCUnrlzXn
KBWg8ji513mKJNyyzGmMayhAT5qt3ReUSTgUzfnsrfYWHV8rYfxZleuPommF
ek8h2tEUXm7G7d/2XQMgE1qE2txFR+R1SShzCigV2FqMbCJ4RHj1SQh7VVD4
LeI9StEQofMgbj705XMid5Why/yVnuQBEsTs3mVdnyhDh833heyx4PbbNatM
twRAGs1Jx8qtSTjJrrBWvoqRCPOG+NhR7vtUZ8z+tJYja6Hhb8pnSfiUb78r
L4SJTG3p24XCSNhepVm5jmQi+8axuUf3SchtmzNK0K1CGoszLN0oEqLnHqIw
ThXa0OYilBNPwj+oepuj4Uf00a0pwCePhL81m7RkJz6h3r+sB/bdJHh0/8m5
v6cGHep0IkXZJAyM1WxYklCDjr5ve/5pkIRacUfNyf2f0XgfzdVvkoTYI0/W
1aXWIv8zzb7poizYwuZVuMFoQCL1y+P0EQs2FNtMbMpoQM7d1cVBu1mgEvmK
Sc41IPuF+RPdB1gg+ixrS5JZIyqjaIgVMViwYMno/vu9EeWkZDEVPFnQk5uj
BlpNiK8ju/tBJgsSL5xgGr5rQWWmeKyK+z/G2YlkP+ptQU6F2gU1GmyI2Vvw
eEyoFeXX99zt1mZDxGqKazyjFVWq3Nu/bhcbAhrfSPyZa0WeSZejbRzZ4LCJ
al+yvR1tc5dqW57JBuXx93PbKjpQY67MlertHLhatzN4aqwDqUg5la3dw4G2
zM+0bNlOJDkpHhlhxYFQxy5lxYudyMX+Wta9MxwY75w3E1rdhXjtOQvqDzhQ
VqWf3OzfjTTlQqLahjhw7Om7/W76vWjpNobG/Wd9sC+lo86cwUa16ijPfMsA
jN/MPlPlzkYXr0mZ2BkPQIxz0F+DIDayaMg752kxAEPr12upZbPRaGnlvrKz
A3CnMCCKX4CDkpT9GpgJA1Bdt862MIeDBtLEg0Mpg7Bn1mtIUagftdvuuP18
aBB2m0ny/3oziI4ci13yvmQY7tu3B2x6N4oCj7qkpLqNwUdzeaql5AQyKuFc
XugZhzHFZdeaYieRbWptyvGFn+B1ScPhvvQ00mzfNbVO+Re0d4tbn6meRbVa
2l78ITNw0m/7oJDpb3RJTDPC+8scVGpsDa0UXESzyJgyc2gBVERKhlL38hAm
tiY+O94sgnyJ627BO7yEc8Ahn+jbPJhnni/Dg81HSCsNnXjcyItnrEpPVK0V
IMjpIoMkQX7cpWO/cm2wIDH2MaHd9IgAvmAjLqHUvYQgWfWSx5IFsWxUH0NA
XpigJB5+saNjCc62TXox6StCGIWy9c5qCGMbw+t7q0sphG6I0shvJxGcd8Jd
aduCKHHvlrSQSCIFz1J28hcdphIKWVTtzROi2PqLga58DI0Y62QcslhPxRQD
0fKSeBpxEMv9bt5MxeWpnQfsUmhE+EG/lww9Kt7k6+fwNJtG9GwcUj21k4pp
q96Fy1bRiOWG9Givo1T8yW0zZ9lPGiEmpbQl4SYVE8JqETRTOmF/gPLPdA8V
z16cXZFtRSfIcVOdqxwqzun6mGZmQydydMKpfMNUrJBz5n34KTpxY3KskzpF
xQuHUwcofnRC/VYJuZZCw+9SVhkKPacTr2UCo2x0afgc9cfH5y/phN2C488e
AxpW8SmzNsmjE2uO/2H8Y0TDUfuPO98soRMxb3WIi6Y07DER+5C/mU7oue7z
DjtFw+q2LgopX+nErVJTWUlnGmYx9TOMv9EJc0WSGeNOw5YxX8tuDNOJ5KS0
Lc99aViYL32f4g/uecGGec1rNAyuPi14ik4wqD7V+UE07N1qYn9ynk50/vMk
YRt3/vvffEj8fz78D7H4ZgQ=
       "]]},
     Annotation[#, "Charting`Private`Tag$258851#2"]& ], 
    TagBox[
     {RGBColor[0.560181, 0.691569, 0.194885], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJw113k0Vd0bB3AZwsUdeqOQuUxJGVKIZyuk3ghF3krkrRQqSVRKN5krSRkq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       "]]},
     Annotation[#, "Charting`Private`Tag$258851#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
         Part[#, 1]], 
        (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
         Part[#, 1]], 
        (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-4, 4}, {-3.8197049885559986`, 4.319704988555999}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellLabel->"Out[6]=",
 CellID->1512181944,ExpressionUUID->"3448c57c-c4e0-4b1f-9962-4a186e7ff429"]
}, Open  ]],

Cell["\<\
A three-dimensional energy plot as a function of both the electric and \
magnetic fields.\
\>", "MathCaption",
 CellID->6363395,ExpressionUUID->"7140885b-d75d-490c-a133-0b22d1b121ec"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot3D", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"energies", "/.", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]2", "\[Rule]", "1"}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"Ex", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalOmega]L", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"Mesh", "\[Rule]", "False"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#", ",", 
         RowBox[{"Specularity", "[", 
          RowBox[{"White", ",", "20"}], "]"}], ",", 
         RowBox[{"Opacity", "[", "0.7", "]"}]}], "}"}], "&"}], "/@", 
      RowBox[{"{", 
       RowBox[{"Yellow", ",", "Green", ",", "Blue"}], "}"}]}], "]"}]}], ",", 
   RowBox[{"BoxRatios", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->209556660,ExpressionUUID->"8d233332-c225-4c22-bc95-a4ce0bfb7b6e"],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJx1m3ucT3X+x+dm3McIQ2vbkEtp0daUbHJOJeVSKtalRW2LnYjQ0MUlpEhY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   "], {{
     {RGBColor[1, 1, 0], Opacity[0.7], EdgeForm[None], Specularity[
       GrayLevel[1], 20], 
      StyleBox[GraphicsGroup3DBox[
        TagBox[Polygon3DBox[CompressedData["
1:eJxNmQeYVtURhu+VtoBIE1gQqUsRleYqS1vaLl2aoEhRQSQWBAQl0YhgjCZR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          "]],
         Annotation[#, "Charting`Private`Tag$258898#1"]& ]],
       Lighting->Automatic]}, 
     {RGBColor[0, 1, 0], Opacity[0.7], EdgeForm[None], Specularity[
       GrayLevel[1], 20], 
      StyleBox[GraphicsGroup3DBox[
        TagBox[Polygon3DBox[CompressedData["
1:eJxNmgn4l8MWx//vvJaQncpSikpRskQU2jcR2bkuruxrdhJZU9YkVLIvyb5E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          "]],
         Annotation[#, "Charting`Private`Tag$258898#2"]& ]],
       Lighting->Automatic]}, 
     {RGBColor[0, 0, 1], Opacity[0.7], EdgeForm[None], Specularity[
       GrayLevel[1], 20], 
      StyleBox[GraphicsGroup3DBox[
        TagBox[Polygon3DBox[CompressedData["
1:eJxNmXu81/Mdx+P32WzDLq5z2dwvY8bYWDYzhtmMjRAVKXSji0oSCt3vUpRz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          "]],
         Annotation[#, "Charting`Private`Tag$258898#3"]& ]],
       Lighting->Automatic]}, {}, {}, {}, {}, {}, {}}, {
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0EtKgmEUBuBfLbW8bqBCwgaCrUBXUCLUpHvgzAY2rRXoCmoFuoJcga2g
i5mZF4QI2kTPj4Pne184HA58hcbtUSsSBEGNCyXsJ56lzLPDPlUOOeeGezo8
0qPPM1t2r3jVz2SdN/2dIR+M+KRgNpa78ktO+GbKjDlFs2sW4W15zIs+4Iku
D7S5oxne5YAKZbb549JuTp7KElk9Q5oUm2zwS5IfEsRZZ40YUfYiq//6B0HL
IxY=
       "]]}, 
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0MtNQkEUBuABhQakAbUCH4gKIgVoYi4NCL4fcCvACqACISbgSivQCmCp
G6lAlrrRrX4TFl/+cydnztyZ5WaatDMhhENyCyEc+/jKhnBAqr6jR59nXpkw
ZcYvOb0FVhmwZM66/KPPBg9sUmSLEtvssEuZCntUeWOfYZxtXk0uyne5xko8
J67x4x8++WDMC0/c06VDXV/e/njZb3VCS30kb+UN11xxyQXnnHHKCU0e9Tfk
KDt/r39zQCO9
       "]]}, 
     {GrayLevel[0], 
      Line3DBox[{1204, 853, 1191, 1085, 868, 883, 898, 913, 928, 943, 958, 
       973, 988, 1003, 1018, 1033, 1048, 1138, 1219, 1063, 1202, 1170, 1064, 
       1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076,
        1140, 1220, 1077, 1203, 1171, 1062, 1047, 1032, 1017, 1002, 987, 972, 
       957, 942, 927, 912, 897, 882, 1087, 1205, 867, 1197, 1142, 866, 865, 
       864, 863, 862, 861, 860, 859, 858, 857, 856, 855, 854, 1141, 1204}]}}},
   
   VertexNormals->CompressedData["
1:eJztfHk0lu23P5oTigYpzUoTTYZKdhqlSbNGUqTe5nl6JSWhUpGKkql5kqJM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    "]],
  Axes->True,
  AxesLabel->{None, None, None},
  BoxRatios->{1, 1},
  DisplayFunction->Identity,
  FaceGridsStyle->Automatic,
  Method->{"DefaultBoundaryStyle" -> Directive[
      GrayLevel[0.3]], "RotationControl" -> "Globe"},
  PlotRange->{{-2, 2}, {-4, 4}, {-4., 6.}},
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{Automatic, Automatic, Automatic}]], "Output",
 CellLabel->"Out[7]=",
 CellID->1920454210,ExpressionUUID->"4ba72b51-0e15-471d-843c-c7a9223e057d"]
}, Open  ]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "TutorialMoreAboutSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "AtomicDensityMatrix Package",
         BaseStyle->"Link",
         ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]],
          "TutorialMoreAbout",ExpressionUUID->
         "9284cc06-4061-4343-b213-6fc7f94fbdd5"]}]}
     }]}
  }]], "TutorialMoreAboutSection",ExpressionUUID->"9a4802d6-c3b9-4160-a4b8-\
79de607cbec6"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Tech", " ", "Notes"}], 
        "RelatedTutorialsSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox["Stark Mixing",
         BaseStyle->"Link",
         ButtonData->"paclet:AtomicDensityMatrix/tutorial/StarkMixing"]], 
         "RelatedTutorials",ExpressionUUID->
         "c1a2f204-54d6-4fdb-8944-97b5d52ea95b"]}]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "Hyperfine Structure: Breit-Rabi Diagram",
         BaseStyle->"Link",
         ButtonData->
          "paclet:AtomicDensityMatrix/tutorial/\
HyperfineStructureBreitRabiDiagram"]], "RelatedTutorials",ExpressionUUID->
         "c098fa41-3d5b-454d-a2c9-68876848ef84"]}]}
     }]}
  }]], "RelatedTutorialsSection",ExpressionUUID->"35d23d95-c24f-4009-88ac-\
76b3d52f70d3"],

Cell[BoxData[""], "Input",ExpressionUUID->"6c414d84-8211-47dd-862f-6bbdc5f83fe4"]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"7370cd99-45f7-43bf-b7ee-2039bc1e4296"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Crossed Electric and Magnetic Fields",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}}, 
  "NewStyles" -> True, "CitationPopupData" -> {$Failed, ""}, "ShowCitation" -> 
  False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 18, 0, 15.953784}", 
    "history" -> {"10.07", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Tutorial", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "Here we analyze a J=1 state subject to crossed electric and magnetic \
fields. The effects of Stark mixing on the sublevels of a single state can be \
accounted for to second order in the electric field by writing an effective \
Hamiltonian in terms of the polarizability of the atomic state. This loads \
the package. Define the atomic system. The state is assumed to have a tensor \
polarizability but no scalar polarizability.", "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$70540, "title" -> 
    "Crossed Electric and Magnetic Fields", "titlemodifier" -> "", 
    "metadescription" -> "", "windowtitle" -> 
    "Crossed Electric and Magnetic Fields", "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/CrossedElectricAndMagneticFields"}},
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> Notebook], 
   Cell[
    StyleData["Output"], CellContext -> Notebook], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"2b5c0d89-fe15-419f-b208-ca71c834c257"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "RasterizedOutput"->{
  Cell[15822, 444, 21697, 362, 170, "Output",ExpressionUUID->"35ea2ca2-4364-4e6c-aa61-90253fd6f878",
   CellTags->"RasterizedOutput",
   CellID->500467471]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"RasterizedOutput", 99900, 1945}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[608, 21, 5649, 135, 57, "AnchorBarGrid",ExpressionUUID->"df4307a1-bf8f-4196-8277-e1dc1ad6f5a7",
 CellID->1],
Cell[CellGroupData[{
Cell[6282, 160, 128, 1, 63, "Title",ExpressionUUID->"2158d5cb-8a3f-4341-a371-288914cc1176",
 CellID->147735377],
Cell[6413, 163, 530, 11, 84, "Text",ExpressionUUID->"1198a25e-1c54-43f9-9277-1cbc14457ef5",
 CellID->455402839],
Cell[6946, 176, 121, 1, 36, "MathCaption",ExpressionUUID->"3194c527-a7cd-4445-a7a1-7b0e4d693102",
 CellID->159403208],
Cell[7070, 179, 161, 3, 29, "Input",ExpressionUUID->"65e2e29d-5272-4c12-b6d3-23fa820374ec",
 CellID->75905070],
Cell[7234, 184, 216, 4, 36, "MathCaption",ExpressionUUID->"97055047-48e8-4228-8653-8bff39422b11",
 CellID->451740640],
Cell[CellGroupData[{
Cell[7475, 192, 637, 16, 48, "Input",ExpressionUUID->"9049b043-0b55-46b6-a92c-ab147afcabd6",
 CellID->162218567],
Cell[8115, 210, 1575, 41, 72, "Output",ExpressionUUID->"9cd20050-34bd-485a-a2e0-ec9f6d8ede82",
 CellID->1361106502]
}, Open  ]],
Cell[9705, 254, 429, 8, 56, "MathCaption",ExpressionUUID->"39056690-2617-4e39-ba2c-40e630faf291",
 CellID->106825082],
Cell[CellGroupData[{
Cell[10159, 266, 728, 18, 66, "Input",ExpressionUUID->"53de68ec-4355-45c6-b4c0-d929cae905f4",
 CellID->247023563],
Cell[10890, 286, 1389, 42, 118, "Output",ExpressionUUID->"9d53845d-e64e-49b1-a333-b79560247955",
 CellID->1121171270]
}, Open  ]],
Cell[12294, 331, 184, 3, 36, "MathCaption",ExpressionUUID->"0351f392-febe-4e49-ac82-4a40f533011b",
 CellID->185247108],
Cell[CellGroupData[{
Cell[12503, 338, 244, 6, 29, "Input",ExpressionUUID->"a47c4148-4438-4a42-b8ae-d017b6ef89f4",
 CellID->500586757],
Cell[12750, 346, 2380, 73, 94, "Output",ExpressionUUID->"83d297d7-037a-41cf-98a7-4a7923fbabaf",
 CellID->1504016112]
}, Open  ]],
Cell[15145, 422, 178, 3, 36, "MathCaption",ExpressionUUID->"303d9740-252f-4129-90fd-a2f214c95660",
 CellID->994177565],
Cell[CellGroupData[{
Cell[15348, 429, 471, 13, 29, "Input",ExpressionUUID->"fbdcf1bb-e281-42df-8b1e-68018056c189",
 CellID->46048850],
Cell[15822, 444, 21697, 362, 170, "Output",ExpressionUUID->"35ea2ca2-4364-4e6c-aa61-90253fd6f878",
 CellTags->"RasterizedOutput",
 CellID->500467471]
}, Open  ]],
Cell[37534, 809, 178, 3, 70, "MathCaption",ExpressionUUID->"992f49b7-3299-437b-a10f-711896c59bbb",
 CellID->187075318],
Cell[CellGroupData[{
Cell[37737, 816, 472, 13, 70, "Input",ExpressionUUID->"4590c499-f3fc-4946-b548-36420da88b0e",
 CellID->813397135],
Cell[38212, 831, 12235, 220, 171, "Output",ExpressionUUID->"3448c57c-c4e0-4b1f-9962-4a186e7ff429",
 CellID->1512181944]
}, Open  ]],
Cell[50462, 1054, 193, 4, 70, "MathCaption",ExpressionUUID->"7140885b-d75d-490c-a133-0b22d1b121ec",
 CellID->6363395],
Cell[CellGroupData[{
Cell[50680, 1062, 1050, 29, 70, "Input",ExpressionUUID->"8d233332-c225-4c22-bc95-a4ce0bfb7b6e",
 CellID->209556660],
Cell[51733, 1093, 43457, 734, 261, "Output",ExpressionUUID->"4ba72b51-0e15-471d-843c-c7a9223e057d",
 CellID->1920454210]
}, Open  ]],
Cell[95205, 1830, 725, 18, 70, "TutorialMoreAboutSection",ExpressionUUID->"9a4802d6-c3b9-4160-a4b8-79de607cbec6"],
Cell[CellGroupData[{
Cell[95955, 1852, 1087, 28, 70, "RelatedTutorialsSection",ExpressionUUID->"35d23d95-c24f-4009-88ac-76b3d52f70d3"],
Cell[97045, 1882, 81, 0, 70, "Input",ExpressionUUID->"6c414d84-8211-47dd-862f-6bbdc5f83fe4"]
}, Open  ]]
}, Open  ]],
Cell[97153, 1886, 78, 0, 70, "FooterCell",ExpressionUUID->"7370cd99-45f7-43bf-b7ee-2039bc1e4296"]
}
]
*)

(* End of internal cache information *)

