(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    833465,      16552]
NotebookOptionsPosition[    811681,      16120]
NotebookOutlinePosition[    815601,      16204]
CellTagsIndexPosition[    815519,      16199]
WindowTitle->Electromagnetically Induced Transparency and Atomic Polarization
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "4341b43c-803a-47c9-a3be-f016f55bba0d"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "591944b9-6696-41ac-b7c6-9fdbf02b9c01"],
        Background->RGBColor[
         0.7450980392156863, 0.3254901960784314, 0.1411764705882353],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "89a8c4d9-f980-45f3-8a16-4b264b64758d"]
         }],ExpressionUUID->"186ee617-782d-4edd-a74a-96aa61ba3432"],
         StripOnInput->
          False], {"\<\"Three-level System: Electromagnetically Induced \
Transparency\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency"], \
"\<\"Angular-momentum Probability Surfaces\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/\
AngularMomentumProbabilitySurfaces"], "\<\"Visualizing Polarization Moments \
and Quantum Beats\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/\
VisualizingPolarizationMomentsAndQuantumBeats"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"RelatedTutorialsSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "b681d51b-ef0d-4135-a099-db26e3f1cd2b"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "09ab7b79-2158-4a9c-92c8-5f99b327a936"]
         }],ExpressionUUID->"c745d07f-39a0-455e-a762-61bdb011a35a"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"TutorialMoreAboutSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "7de7352f-b480-43ce-9a80-d9563620044f"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "38167c87-4681-4474-9c70-b6c359ee8e3f"]
         }],ExpressionUUID->"702bef9e-1c79-4257-b0eb-0fe77f5442a2"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
              "AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
tutorial/ElectromagneticallyInducedTransparencyAndAtomicPolarization.html"], 
                 StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
             Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$71164], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization" <> ".html"], 
            None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "5048fd91-41bb-473a-8f86-d5513c446863"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "7315cd77-91f8-4748-b656-81ed10d814ae"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"7e327527-56b2-4ab1-aff1-6aa113bff033"],

Cell[CellGroupData[{

Cell["\<\
Electromagnetically Induced Transparency and Atomic Polarization\
\>", "Title",
 CellID->509267359,ExpressionUUID->"3b068c8a-899c-4277-a57f-266d97296c6c"],

Cell[BoxData[GridBox[{
   {
    TemplateBox[{
      Cell["Solve the system"], 
      "paclet:AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization#773580667", 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.3843137254901961, 0.4627450980392157, 0.7019607843137254], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False], 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.9686274509803922, 0.4666666666666667, 0.], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False]},
     "GrayLinkWithIcon",
     BaseStyle->{"TutorialJumpBoxLink"}], 
    TemplateBox[{
      Cell["Cartesian populations"], 
      "paclet:AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization#69945931", 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.3843137254901961, 0.4627450980392157, 0.7019607843137254], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False], 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.9686274509803922, 0.4666666666666667, 0.], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False]},
     "GrayLinkWithIcon",
     BaseStyle->{"TutorialJumpBoxLink"}]},
   {
    TemplateBox[{
      Cell["Absorption signal"], 
      "paclet:AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization#248714767", 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.3843137254901961, 0.4627450980392157, 0.7019607843137254], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False], 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.9686274509803922, 0.4666666666666667, 0.], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False]},
     "GrayLinkWithIcon",
     BaseStyle->{"TutorialJumpBoxLink"}], 
    TemplateBox[{
      Cell["Angular-momentum probability surfaces"], 
      "paclet:AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization#164439161", 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.3843137254901961, 0.4627450980392157, 0.7019607843137254], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False], 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.9686274509803922, 0.4666666666666667, 0.], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False]},
     "GrayLinkWithIcon",
     BaseStyle->{"TutorialJumpBoxLink"}]},
   {
    TemplateBox[{
      Cell["Zeeman populations"], 
      "paclet:AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization#29539545", 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.3843137254901961, 0.4627450980392157, 0.7019607843137254], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False], 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.9686274509803922, 0.4666666666666667, 0.], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False]},
     "GrayLinkWithIcon",
     BaseStyle->{"TutorialJumpBoxLink"}], 
    TemplateBox[{
      Cell["Animation"], 
      "paclet:AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization#772480329", 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.3843137254901961, 0.4627450980392157, 0.7019607843137254], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False], 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.9686274509803922, 0.4666666666666667, 0.], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False]},
     "GrayLinkWithIcon",
     BaseStyle->{"TutorialJumpBoxLink"}]},
   {
    TemplateBox[{
      Cell["The light polarization"], 
      "paclet:AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization#185542063", 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.3843137254901961, 0.4627450980392157, 0.7019607843137254], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False], 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.9686274509803922, 0.4666666666666667, 0.], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False]},
     "GrayLinkWithIcon",
     BaseStyle->{"TutorialJumpBoxLink"}], ""}
  }]], "TutorialJumpBox",ExpressionUUID->"099fd93b-2243-4bca-867b-\
0c4c32caa0fe"],

Cell[TextData[{
 "An atomic system consisting of two lower states connected to one upper \
state by two coherent light fields (a \"\[CapitalLambda] system\") can \
exhibit the phenomenon known as electromagnetically induced transparency \
(EIT), discussed in the example \"",
 ButtonBox["Three-level System: Electromagnetically Induced Transparency",
  BaseStyle->"Link",
  ButtonData->
   "paclet:AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency"],
 "\". Such a system can take the form of the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", 
    RowBox[{"\[PlusMinus]", "1"}]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"0d4662cb-a0a4-4c51-84ed-3ba4dd92288d"],
 " levels of a ",
 Cell[BoxData[
  FormBox[
   RowBox[{"J", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "92f95fbb-9e90-4e48-b0b0-a67231ce03ec"],
 " ground state connected to a ",
 Cell[BoxData[
  FormBox[
   RowBox[{"J", "=", "0"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "f4b06ae7-4ca6-4d38-a194-9aaaeec89ed3"],
 " excited state by two light beams with opposite circular polarizations (",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[Sigma]", "+"], TraditionalForm]], "InlineMath",
  ExpressionUUID->"72761f62-4a34-4bc9-b762-f05948ddeb1b"],
 " and ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[Sigma]", "-"], TraditionalForm]], "InlineMath",
  ExpressionUUID->"1c836245-3df3-434c-86c5-a719b4a1fb72"],
 "). If the frequency of one light field (the \"pump\") is held fixed while \
the frequency of the other (the \"probe\") is varied, a drop in absorption of \
the probe beam is seen when the probe frequency matches that of the pump. \
This EIT resonance is associated with coherence between the two ground-state \
levels, which in the case considered here can be interpreted as \
angular-momentum polarization of the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"J", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "37e3e1a5-34dc-45db-af86-2f421f7023a3"],
 " ground state."
}], "Text",
 CellID->1534169418,ExpressionUUID->"9b3788a8-e461-4be6-b80b-9ba488206d88"],

Cell[TextData[{
 "In this example we calculate the EIT signal measured on a ",
 Cell[BoxData[
  FormBox[
   RowBox[{"1", "\[Rule]", "0"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"a9fd5d9d-4535-4e88-8ef0-13f42a2e1c93"],
 " transition, and show how the EIT resonance can be understood in terms of \
the ground-state polarization, which we illustrate using population plots and \
angular-momentum probability surfaces (see \"",
 ButtonBox["Angular-momentum Probability Surfaces",
  BaseStyle->"Link",
  ButtonData->
   "paclet:AtomicDensityMatrix/tutorial/AngularMomentumProbabilitySurfaces"],
 "\")."
}], "Text",
 CellID->224963010,ExpressionUUID->"c45b8bb7-c1f2-4285-8e41-a8221f101132"],

Cell[CellGroupData[{

Cell["Solve the system", "Section",
 CellID->773580667,ExpressionUUID->"af8f3817-0316-43c6-aad9-c1226f66e53d"],

Cell["This loads the package.", "MathCaption",
 CellID->21129096,ExpressionUUID->"fca7337d-9ace-4e03-aacf-dafc9aa671ea"],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->195332175,ExpressionUUID->"5a13b300-899b-45c1-886e-2dcdc76bc8e5"],

Cell["\<\
We first define the atomic system and form the Hamiltonian. We will perform \
the calculation in a frame in which the Hamiltonian is time independent, and \
there is a steady-state solution to the Bloch equations. Thus it is \
convenient to write the density-matrix elements without explicit time \
dependence. \
\>", "Text",
 CellID->105311105,ExpressionUUID->"d1056015-993f-446f-9e6d-f7c3a7824131"],

Cell[TextData[{
 "Set the option ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["TimeDependence"]], 
    "paclet:AtomicDensityMatrix/ref/TimeDependence", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "55bebcc5-8da4-4457-a137-f0382c38a77a"],
 " for the ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["DensityMatrix"]], 
    "paclet:AtomicDensityMatrix/ref/DensityMatrix", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "e0859f62-86f5-4861-84fe-9456c2829721"],
 " function."
}], "MathCaption",
 CellID->333920660,ExpressionUUID->"23483500-b454-40f3-9ff5-26c45be838d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"DensityMatrix", ",", 
    RowBox[{"TimeDependence", "\[Rule]", "False"}]}], "]"}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->96283744,ExpressionUUID->"0fdbc8af-41ec-4bc6-921d-1de3299bf3a8"],

Cell["Define the atomic system.", "MathCaption",
 CellID->399507665,ExpressionUUID->"b69ab4f2-97be-48cd-9134-8ece2e2613eb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "1"}], ",", 
       RowBox[{"Energy", "\[Rule]", "0"}], ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "0"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "0"}], ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "\[CapitalGamma]"}], ",", 
       RowBox[{
        RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}]}], 
      "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->105219035,ExpressionUUID->"d69f9ffe-7a89-4793-bffd-258832e26b72"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "\[CapitalGamma]"}], ",", 
     RowBox[{
      RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[6]=",
 CellID->426343123,ExpressionUUID->"aa665b7c-29d9-4642-b004-dec3240651b9"]
}, Open  ]],

Cell[TextData[{
 "The total optical field consists of the sum of the pump field: ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[Sigma]", "+"], TraditionalForm]], "InlineMath",
  ExpressionUUID->"bedf36ed-3495-4a77-b696-afc12c305367"],
 " light (ellipticity ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Pi]", "/", "4"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"cfc021e2-92fb-428d-9097-65e3c2aa727d"],
 ") with frequency ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Omega]", "1"], TraditionalForm]], "InlineMath",
  ExpressionUUID->"5dec7399-0422-4376-af82-d9cc3cd200a8"],
 " and \"reduced\" Rabi frequency ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[CapitalOmega]", 
    RowBox[{"R", ",", "1"}]], TraditionalForm]], "InlineMath",ExpressionUUID->
  "048878b0-68f3-422b-8976-6d531a08f4e2"],
 ", and the probe field: ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[Sigma]", "-"], TraditionalForm]], "InlineMath",
  ExpressionUUID->"71dc2252-5ec5-4479-9086-4bcf3869f9f0"],
 " light (ellipticity ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"-", "\[Pi]"}], "/", "4"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"457bacdc-d2d6-4612-ab53-cb978f07c6d6"],
 ") with frequency ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Omega]", "2"], "=", 
    RowBox[{
     SubscriptBox["\[Omega]", "1"], "+", 
     SubscriptBox["\[CapitalDelta]", 
      RowBox[{"1", ",", "2"}]]}]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"88866a8b-cf63-42ca-bdf7-9737726010b4"],
 " and reduced Rabi frequency ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[CapitalOmega]", 
    RowBox[{"R", ",", "2"}]], TraditionalForm]], "InlineMath",ExpressionUUID->
  "65f978b3-a6d4-4a51-b4a9-3367a658b825"],
 "."
}], "Text",
 CellID->121947581,ExpressionUUID->"83b64e9b-c607-48b2-9b63-44c617f5caf1"],

Cell["Define the total optical field.", "MathCaption",
 CellID->98030042,ExpressionUUID->"1e9eccdc-4746-4f95-8fcd-536ee4edd4e2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Etot", "=", 
  RowBox[{
   RowBox[{"OpticalField", "[", 
    RowBox[{
     SubscriptBox["\[Omega]", "1"], ",", 
     RowBox[{
      SubscriptBox["\[CapitalOmega]", 
       RowBox[{"R", ",", "1"}]], "/", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"\[Pi]", "/", "4"}]}], "}"}]}], "]"}], "+", 
   RowBox[{"OpticalField", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["\[Omega]", "1"], "+", 
      SubscriptBox["\[CapitalDelta]", 
       RowBox[{"1", ",", "2"}]]}], ",", 
     RowBox[{
      SubscriptBox["\[CapitalOmega]", 
       RowBox[{"R", ",", "2"}]], "/", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{
        RowBox[{"-", "\[Pi]"}], "/", "4"}]}], "}"}]}], "]"}]}]}]], "Input",
 CellLabel->"In[7]:=",
 CellID->47980269,ExpressionUUID->"c8a3e0be-6c91-4c99-84bd-a6c2ee29c6e5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
        SubscriptBox["\[Omega]", "1"]}]], " ", 
      SubscriptBox["\[CapitalOmega]", 
       RowBox[{"R", ",", "1"}]]}], 
     RowBox[{
      SqrtBox["2"], " ", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]], "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["\[Omega]", "1"], "+", 
          SubscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}]]}], ")"}]}]], " ", 
      SubscriptBox["\[CapitalOmega]", 
       RowBox[{"R", ",", "2"}]]}], 
     RowBox[{
      SqrtBox["2"], " ", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]]}], ",", 
   RowBox[{
    FractionBox[
     RowBox[{"\[ImaginaryI]", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
        SubscriptBox["\[Omega]", "1"]}]], " ", 
      SubscriptBox["\[CapitalOmega]", 
       RowBox[{"R", ",", "1"}]]}], 
     RowBox[{
      SqrtBox["2"], " ", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]], "-", 
    FractionBox[
     RowBox[{"\[ImaginaryI]", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["\[Omega]", "1"], "+", 
          SubscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}]]}], ")"}]}]], " ", 
      SubscriptBox["\[CapitalOmega]", 
       RowBox[{"R", ",", "2"}]]}], 
     RowBox[{
      SqrtBox["2"], " ", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]]}], ",", 
   "0"}], "}"}]], "Output",
 CellLabel->"Out[7]=",
 CellID->1543421869,ExpressionUUID->"d12c1742-a3c3-4be4-9198-fb0b699694b9"]
}, Open  ]],

Cell["\<\
The Hamiltonian for the system subject to the combined light field.\
\>", "MathCaption",
 CellID->37038723,ExpressionUUID->"36d60d22-e4bb-432e-a2c4-1cb6c425bdbf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h0", "=", 
    RowBox[{
     RowBox[{"Hamiltonian", "[", 
      RowBox[{"sys", ",", 
       RowBox[{"ElectricField", "\[Rule]", "Etot"}]}], "]"}], "//", 
     "FullSimplify"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->229107480,ExpressionUUID->"b14209df-fefb-460d-9ab4-517f9775b5e9"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      FractionBox[
       RowBox[{
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
           SubscriptBox["\[Omega]", "1"]}]], " ", 
         SubscriptBox["\[CapitalOmega]", 
          RowBox[{"R", ",", "1"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["\[Omega]", "1"], "+", 
             SubscriptBox["\[CapitalDelta]", 
              RowBox[{"1", ",", "2"}]]}], ")"}]}]], " ", 
         SubscriptBox["\[CapitalOmega]", 
          RowBox[{"R", ",", "2"}]]}]}], 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"\[ImaginaryI]", " ", "t", " ", 
            SubscriptBox["\[Omega]", "1"]}]]}], " ", 
         SubscriptBox["\[CapitalOmega]", 
          RowBox[{"R", ",", "1"}]]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["\[Omega]", "1"], "+", 
             SubscriptBox["\[CapitalDelta]", 
              RowBox[{"1", ",", "2"}]]}], ")"}]}]], " ", 
         SubscriptBox["\[CapitalOmega]", 
          RowBox[{"R", ",", "2"}]]}]}], 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]]},
     {
      FractionBox[
       RowBox[{
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", 
           SubscriptBox["\[Omega]", "1"]}]], " ", 
         SubscriptBox["\[CapitalOmega]", 
          RowBox[{"R", ",", "1"}]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["\[Omega]", "1"], "+", 
             SubscriptBox["\[CapitalDelta]", 
              RowBox[{"1", ",", "2"}]]}], ")"}]}]], " ", 
         SubscriptBox["\[CapitalOmega]", 
          RowBox[{"R", ",", "2"}]]}]}], 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
           SubscriptBox["\[Omega]", "1"]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["\[CapitalOmega]", 
            RowBox[{"R", ",", "1"}]], "+", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"\[ImaginaryI]", " ", "t", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 SubscriptBox["\[Omega]", "1"]}], "+", 
                SubscriptBox["\[CapitalDelta]", 
                 RowBox[{"1", ",", "2"}]]}], ")"}]}]], " ", 
            SubscriptBox["\[CapitalOmega]", 
             RowBox[{"R", ",", "2"}]]}]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]]}], 
      RowBox[{"Energy", "[", "2", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[8]//MatrixForm=",
 CellID->836380170,ExpressionUUID->"fa81b2b3-5cec-4ed0-8ad3-cd077105fd53"]
}, Open  ]],

Cell["\<\
The level diagram for the system and the Hamiltonian, showing a resonant pump \
field and detuned probe field.\
\>", "MathCaption",
 CellID->89487683,ExpressionUUID->"c134a19b-13f9-467d-a514-d8e93ba481cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LevelDiagram", ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", ".3"}], ",", "1.7"}], "}"}]}]}], "]"}], ";"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->125734499,ExpressionUUID->"d9ab74bd-9f28-4598-a152-fa05500b8896"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"h0", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", "1.4"}], ",", 
      RowBox[{
       SubscriptBox["\[Omega]", "1"], "\[Rule]", "1.4"}], ",", 
      RowBox[{
       SubscriptBox["\[CapitalDelta]", 
        RowBox[{"1", ",", "2"}]], "\[Rule]", 
       RowBox[{"-", ".2"}]}]}], "}"}]}], ",", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Text", "[", 
       RowBox[{
       "\"\<\!\(\*SuperscriptBox[\(\[Sigma]\), \(+\)]\), \
\!\(\*SubscriptBox[\(\[Omega]\), \(1\)]\)\>\"", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", ".7"}], "}"}]}], "]"}], ",", 
      RowBox[{"Text", "[", 
       RowBox[{
       "\"\<\!\(\*SuperscriptBox[\(\[Sigma]\), \(-\)]\), \
\!\(\*SubscriptBox[\(\[Omega]\), \(2\)]\)\>\"", ",", 
        RowBox[{"{", 
         RowBox[{".9", ",", ".7"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}]}]}], "]"}]], "Input",\

 CellLabel->"In[10]:=",
 CellID->95768827,ExpressionUUID->"9b1d82b0-00e0-48b0-ba8d-9965aeb08e53"],

Cell[BoxData[
 GraphicsBox[{{{{{}, LineBox[{{0.6, 0.}, {1.4, 0.}}]}, {{}, 
      LineBox[{{-0.4, 0.}, {0.4, 0.}}]}, {{}, 
      LineBox[{{-1.4, 0.}, {-0.6, 0.}}]}, {{}, 
      LineBox[{{-0.4, 1.4}, {0.4, 1.4}}]}}, {}, {}, 
    {EdgeForm[Hue[0.61, 0.54, 0.56]], FaceForm[None]}, 
    {RGBColor[0.9, 0.01, 0.01], 
     Arrowheads[{-0.057142857142857155`, 0.057142857142857155`}], 
     ArrowBox[{{-0.9199999999999999, 0.}, {-0.08000000000000002, 1.4}}], 
     ArrowBox[{{0.9199999999999999, 0.}, {0.08000000000000002, 
      1.2}}]}}, {{{{}, {}}, {{}, {}}, {{}, {}}, {{}, {}}}, {}, {}, 
    {EdgeForm[Hue[0.61, 0.54, 0.56]], FaceForm[None]}, 
    {RGBColor[0.9, 0.01, 0.01], 
     Arrowheads[{-0.057142857142857155`, 0.057142857142857155`}], {}, {}}}},
  Epilog->{{{}, {}}, {
     InsetBox[
      FormBox[
      "\"\\!\\(\\*SuperscriptBox[\\(\[Sigma]\\), \\(+\\)]\\), \
\\!\\(\\*SubscriptBox[\\(\[Omega]\\), \\(1\\)]\\)\"", TraditionalForm], {-1, 
       0.7}], 
     InsetBox[
      FormBox[
      "\"\\!\\(\\*SuperscriptBox[\\(\[Sigma]\\), \\(-\\)]\\), \
\\!\\(\\*SubscriptBox[\\(\[Omega]\\), \\(2\\)]\\)\"", TraditionalForm], {0.9, 
      0.7}, {0, 0}]}},
  ImageSize->{{350}, {100}},
  PlotRange->{-0.3, 1.7}]], "Output",
 CellLabel->"Out[10]=",
 CellID->1761047575,ExpressionUUID->"be6a84ba-3692-47c7-a95a-f821741d1ed7"]
}, Open  ]],

Cell[TextData[{
 "We then apply the rotating-wave approximation, going into the frame \
\"rotating\" at the pump frequency, and writing ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Omega]", "1"], TraditionalForm]], "InlineMath",
  ExpressionUUID->"ca0c7728-4ff8-4c83-b663-e0fb119a6a32"],
 " in terms of its detuning from resonance ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[CapitalDelta]", "1"], TraditionalForm]], "InlineMath",
  ExpressionUUID->"b40bcdfc-af25-4c1e-b183-b555ea30bd9c"],
 ". In this frame, the Hamiltonian has time dependence at the difference of \
the two light frequencies, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[CapitalDelta]", 
     RowBox[{"1", ",", "2"}]], "=", 
    RowBox[{
     SubscriptBox["\[Omega]", "2"], "-", 
     SubscriptBox["\[Omega]", "1"]}]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"fee0640d-5a33-4c9d-8cab-2d8e0e57a0f2"],
 "."
}], "Text",
 CellID->120111978,ExpressionUUID->"cd33c153-db1d-46d3-829a-facab903a8dc"],

Cell["\<\
Apply the rotating-wave approximation, removing all frequencies in the \
optical range from the Hamiltonian.\
\>", "MathCaption",
 CellID->57652465,ExpressionUUID->"a3732c15-e51a-4d5c-b7e4-615586c76d75"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{"RotatingWaveApproximation", "[", 
     RowBox[{"sys", ",", "h0", ",", 
      RowBox[{"{", 
       RowBox[{
        SubscriptBox["\[Omega]", "1"], ",", 
        RowBox[{"{", 
         RowBox[{"1", "\[Rule]", "2"}], "}"}], ",", 
        SubscriptBox["\[CapitalDelta]", "1"]}], "}"}]}], "]"}]}], ")"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->283782337,ExpressionUUID->"76e953a1-febb-48d4-88a6-fa83174081ab"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", 
          SubscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}]]}]], " ", 
        SubscriptBox["\[CapitalOmega]", 
         RowBox[{"R", ",", "2"}]]}], 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]", 
         RowBox[{"R", ",", "1"}]], 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]]}]},
     {
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
          SubscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}]]}]], " ", 
        SubscriptBox["\[CapitalOmega]", 
         RowBox[{"R", ",", "2"}]]}], 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]], "0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]", 
         RowBox[{"R", ",", "1"}]], 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]]}], 
      RowBox[{"-", 
       SubscriptBox["\[CapitalDelta]", "1"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[11]//MatrixForm=",
 CellID->1306970071,ExpressionUUID->"738b7933-ed97-4180-8727-fd22e6ecf89b"]
}, Open  ]],

Cell[TextData[{
 "In performing the RWA, we have used a unitary transformation with a term \
oscillating at the pump frequency ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Omega]", "1"], TraditionalForm]], "InlineMath",
  ExpressionUUID->"aaebc3bf-6d52-4956-842c-c3f59efdfe1b"],
 "."
}], "Text",
 CellID->39910472,ExpressionUUID->"f3388a35-eddc-428f-929c-11b19650e041"],

Cell["\<\
The unitary transformation used for the rotating-wave approximation.\
\>", "MathCaption",
 CellID->520728161,ExpressionUUID->"361bb1d8-1fba-40c3-bc20-3f62a0b8a31e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"u", "=", 
    RowBox[{"RotatingWaveTransformMatrix", "[", 
     RowBox[{"sys", ",", 
      SubscriptBox["\[Omega]", "1"]}], "]"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[12]:=",
 CellID->35501205,ExpressionUUID->"579022fc-f605-4597-b6d6-b36379027896"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
        SubscriptBox["\[Omega]", "1"]}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[12]//MatrixForm=",
 CellID->1783241781,ExpressionUUID->"76d2dc96-248d-4a89-9929-057d15d77a79"]
}, Open  ]],

Cell[TextData[{
 "The remaining time dependence can be removed by making an additional \
unitary transformation, with a term oscillating at the difference frequency \
",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[CapitalDelta]", 
    RowBox[{"1", ",", "2"}]], TraditionalForm]], "InlineMath",ExpressionUUID->
  "3666eb90-520b-4baf-adf9-4f0713989c38"],
 "."
}], "Text",
 CellID->270075583,ExpressionUUID->"74ab092f-2068-4367-b5fc-a3c22b3ac49b"],

Cell[TextData[{
 "Define a unitary matrix ",
 Cell[BoxData[
  FormBox["v", TraditionalForm]], "InlineMath",ExpressionUUID->
  "be59b458-8342-41ba-a52c-34c06a6d5f56"],
 " with a term oscillating at the difference frequency."
}], "MathCaption",
 CellID->45168219,ExpressionUUID->"a6485ad9-e329-46ee-94fc-eba7f1b2b88e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"v", "=", 
    RowBox[{"MatrixExp", "[", 
     RowBox[{"\[ImaginaryI]", " ", "t", " ", 
      RowBox[{"DiagonalMatrix", "[", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[CapitalDelta]", 
          RowBox[{"1", ",", "2"}]], ",", "0", ",", "0", ",", "0"}], "}"}], 
       "]"}]}], "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->765659243,ExpressionUUID->"7a06d150-aee5-4953-bd27-304ed26bb681"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"\[ImaginaryI]", " ", "t", " ", 
        SubscriptBox["\[CapitalDelta]", 
         RowBox[{"1", ",", "2"}]]}]], "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[13]//MatrixForm=",
 CellID->662835735,ExpressionUUID->"18c569f9-3284-46dc-9c67-1cc21cb3d280"]
}, Open  ]],

Cell[TextData[{
 "Transform the Hamiltonian into the frame specified by ",
 Cell[BoxData[
  FormBox["v", TraditionalForm]], "InlineMath",ExpressionUUID->
  "d6fff260-a8a8-4a27-8f71-a223e249f0b6"],
 StyleBox[".",
  Deletable->True]
}], "MathCaption",
 CellID->348736122,ExpressionUUID->"0b258dc3-7459-4d38-8306-ed16b615bb68"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h1", "=", 
    RowBox[{"EffectiveHamiltonian", "[", 
     RowBox[{"h", ",", "v", ",", "t"}], "]"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->544384484,ExpressionUUID->"9529e6dc-5feb-47b8-adc3-13d1361ed32b"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SubscriptBox["\[CapitalDelta]", 
       RowBox[{"1", ",", "2"}]], "0", "0", 
      FractionBox[
       SubscriptBox["\[CapitalOmega]", 
        RowBox[{"R", ",", "2"}]], 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]", 
         RowBox[{"R", ",", "1"}]], 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]]}]},
     {
      FractionBox[
       SubscriptBox["\[CapitalOmega]", 
        RowBox[{"R", ",", "2"}]], 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]], "0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]", 
         RowBox[{"R", ",", "1"}]], 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]]}], 
      RowBox[{"-", 
       SubscriptBox["\[CapitalDelta]", "1"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[14]//MatrixForm=",
 CellID->1282521156,ExpressionUUID->"79ab3182-f4bb-48df-9adb-5d6ea795db04"]
}, Open  ]],

Cell["\<\
Note that no terms are dropped in this step; this is just a change of basis, \
not a further approximation.\
\>", "Text",
 CellID->146612425,ExpressionUUID->"be97e0f8-f868-42b9-bd85-362e8ec36c64"],

Cell[TextData[{
 "In addition to the Hamiltonian, terms describing relaxation and \
repopulation are needed to form the Liouville equation. The relaxation matrix \
describes transit relaxation (atoms leaving the light beam) at a rate ",
 Cell[BoxData[
  FormBox["\[Gamma]", TraditionalForm]], "InlineMath",ExpressionUUID->
  "be4ca296-81a0-415b-9574-d7d7c5aaf720"],
 " and spontaneous decay of the upper state at the specified rate ",
 Cell[BoxData[
  FormBox["\[CapitalGamma]", TraditionalForm]], "InlineMath",ExpressionUUID->
  "208e2590-99b4-400b-b8c7-70089fbc8879"],
 "."
}], "Text",
 CellID->171394912,ExpressionUUID->"5063135d-5c42-4974-ae35-9162be68f52f"],

Cell["Form the relaxation matrix.", "MathCaption",
 CellID->424837104,ExpressionUUID->"9c170241-349b-40ee-8b61-ffd650125440"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"rel", "=", 
    RowBox[{
     RowBox[{"TransitRelaxation", "[", 
      RowBox[{"sys", ",", "\[Gamma]"}], "]"}], "+", 
     RowBox[{"IntrinsicRelaxation", "[", "sys", "]"}]}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[15]:=",
 CellID->485314701,ExpressionUUID->"d86437dc-7572-4e4a-af79-0015ad9e9e6c"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"\[Gamma]", "0", "0", "0"},
     {"0", "\[Gamma]", "0", "0"},
     {"0", "0", "\[Gamma]", "0"},
     {"0", "0", "0", 
      RowBox[{"\[Gamma]", "+", "\[CapitalGamma]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[15]//MatrixForm=",
 CellID->1039703953,ExpressionUUID->"3a941483-4512-400f-88f6-cad9751828f0"]
}, Open  ]],

Cell["\<\
The repopulation matrix describes transit repopulation (atoms entering the \
light beam) and repopulation due to atoms that have decayed from the upper \
state.\
\>", "Text",
 CellID->4106716,ExpressionUUID->"8adefa17-5a2e-4604-b421-efbf311bd37c"],

Cell["Form the repopulation matrix.", "MathCaption",
 CellID->103033569,ExpressionUUID->"596016ad-10dc-4766-b42e-83e7cadb28cc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"rep", "=", 
    RowBox[{
     RowBox[{"TransitRepopulation", "[", 
      RowBox[{"sys", ",", "\[Gamma]"}], "]"}], "+", 
     RowBox[{"OpticalRepopulation", "[", "sys", "]"}]}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[16]:=",
 CellID->432373522,ExpressionUUID->"3b7e876c-c030-4497-8736-0b5cf0830bed"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["\[Gamma]", "3"], "+", 
       RowBox[{
        FractionBox["1", "3"], " ", "\[CapitalGamma]", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}]}]]}]}], "0", "0", "0"},
     {"0", 
      RowBox[{
       FractionBox["\[Gamma]", "3"], "+", 
       RowBox[{
        FractionBox["1", "3"], " ", "\[CapitalGamma]", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}]}]]}]}], "0", "0"},
     {"0", "0", 
      RowBox[{
       FractionBox["\[Gamma]", "3"], "+", 
       RowBox[{
        FractionBox["1", "3"], " ", "\[CapitalGamma]", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}]}]]}]}], "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[16]//MatrixForm=",
 CellID->229902432,ExpressionUUID->"de6e432b-c146-4fad-9c84-d51c52e11bd6"]
}, Open  ]],

Cell["\<\
We can now form and solve the Liouville equation (Bloch equations) under the \
steady-state condition.\
\>", "Text",
 CellID->104746948,ExpressionUUID->"b3bd176f-2307-4e64-baf5-d1fde46ff9b2"],

Cell["The evolution equations.", "MathCaption",
 CellID->249540538,ExpressionUUID->"f36d6c09-c92b-4ac0-91eb-d7bf11a6db27"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "[", 
  RowBox[{
   RowBox[{"eqs", "=", 
    RowBox[{"LiouvilleEquation", "[", 
     RowBox[{"sys", ",", "h1", ",", "rel", ",", "rep"}], "]"}]}], ",", "7"}], 
  "]"}]], "Input",
 CellLabel->"In[17]:=",
 CellID->60934029,ExpressionUUID->"6fc0966d-76c6-4fc6-b9cd-1b6de030e693"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"0", "\[Equal]", 
     RowBox[{
      FractionBox["\[Gamma]", "3"], "-", 
      RowBox[{"\[Gamma]", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]]}], "+", 
      RowBox[{
       FractionBox["1", "3"], " ", "\[CapitalGamma]", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "0"}], "}"}]}]]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{
            SubscriptBox["\[Rho]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "0"}], "}"}]}]], " ", 
            SubscriptBox["\[CapitalOmega]", 
             RowBox[{"R", ",", "2"}]]}], 
           RowBox[{"2", " ", 
            SqrtBox["3"]}]]}], "+", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}]], " ", 
           SubscriptBox["\[CapitalOmega]", 
            RowBox[{"R", ",", "2"}]]}], 
          RowBox[{"2", " ", 
           SqrtBox["3"]}]]}], ")"}]}]}]}], ",", 
    RowBox[{"0", "\[Equal]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[Gamma]"}], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}]], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0"}], "}"}]}]]}], "+", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0"}], "}"}]}]], " ", 
           SubscriptBox["\[CapitalOmega]", 
            RowBox[{"R", ",", "2"}]]}], 
          RowBox[{"2", " ", 
           SqrtBox["3"]}]]}], ")"}]}]}]}], ",", 
    RowBox[{"\[LeftSkeleton]", "12", "\[RightSkeleton]"}], ",", 
    RowBox[{"0", "\[Equal]", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Gamma]"}], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Gamma]", "+", "\[CapitalGamma]"}], ")"}], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}]}], ")"}]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           SubscriptBox["\[CapitalDelta]", "1"]}], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "-", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]], " ", 
           SubscriptBox["\[CapitalOmega]", 
            RowBox[{"R", ",", "1"}]]}], 
          RowBox[{"2", " ", 
           SqrtBox["3"]}]], "+", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}]], " ", 
           SubscriptBox["\[CapitalOmega]", 
            RowBox[{"R", ",", "1"}]]}], 
          RowBox[{"2", " ", 
           SqrtBox["3"]}]], "+", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]], " ", 
           SubscriptBox["\[CapitalOmega]", 
            RowBox[{"R", ",", "2"}]]}], 
          RowBox[{"2", " ", 
           SqrtBox["3"]}]]}], ")"}]}]}]}], ",", 
    RowBox[{"0", "\[Equal]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{"\[Gamma]", "+", "\[CapitalGamma]"}], ")"}]}], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "0"}], "}"}]}]]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{
            SubscriptBox["\[Rho]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "0"}], "}"}]}]], " ", 
            SubscriptBox["\[CapitalOmega]", 
             RowBox[{"R", ",", "1"}]]}], 
           RowBox[{"2", " ", 
            SqrtBox["3"]}]]}], "+", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]], " ", 
           SubscriptBox["\[CapitalOmega]", 
            RowBox[{"R", ",", "1"}]]}], 
          RowBox[{"2", " ", 
           SqrtBox["3"]}]], "+", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}]], " ", 
           SubscriptBox["\[CapitalOmega]", 
            RowBox[{"R", ",", "2"}]]}], 
          RowBox[{"2", " ", 
           SqrtBox["3"]}]], "-", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}]], " ", 
           SubscriptBox["\[CapitalOmega]", 
            RowBox[{"R", ",", "2"}]]}], 
          RowBox[{"2", " ", 
           SqrtBox["3"]}]]}], ")"}]}]}]}]}], "}"}],
  Short[#, 7]& ]], "Output",
 CellLabel->"Out[17]//Short=",
 CellID->647093671,ExpressionUUID->"1b79e269-1623-4fad-9efb-b76519a2af38"]
}, Open  ]],

Cell["\<\
In order to speed up the computation, we specialize to the case of \
equal-intensity light beams and pump light on resonance.\
\>", "Text",
 CellID->42128096,ExpressionUUID->"3bd3ae3b-7a2e-4ad1-939f-d37be8b26f0a"],

Cell["Find the analytical steady-state solution.", "MathCaption",
 CellID->304445345,ExpressionUUID->"e50f1f7b-1f2c-41af-9369-7f8fccd0c6f9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "[", 
  RowBox[{
   RowBox[{"sol", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{"eqs", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            SubscriptBox["\[CapitalOmega]", 
             RowBox[{"R", ",", "1"}]], "\[Rule]", 
            SubscriptBox["\[CapitalOmega]", "R"]}], ",", 
           RowBox[{
            SubscriptBox["\[CapitalOmega]", 
             RowBox[{"R", ",", "2"}]], "\[Rule]", 
            SubscriptBox["\[CapitalOmega]", "R"]}], ",", 
           RowBox[{
            SubscriptBox["\[CapitalDelta]", "1"], "\[Rule]", "0"}]}], "}"}]}],
         ",", 
        RowBox[{"DMVariables", "[", "sys", "]"}]}], "]"}], "//", "First"}], "//",
      "Simplify"}]}], ",", "5"}], "]"}]], "Input",
 CellLabel->"In[18]:=",
 CellID->345181482,ExpressionUUID->"fafa72d3-0941-436f-83bc-b6304a3eae51"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}]], "\[Rule]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[Gamma]", " ", 
        RowBox[{"(", 
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}]}], ")"}],
       "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", "\[Gamma]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"6", " ", 
            SuperscriptBox["\[Gamma]", "2"]}], "+", 
           RowBox[{"5", " ", "\[Gamma]", " ", "\[CapitalGamma]"}], "+", 
           SuperscriptBox["\[CapitalGamma]", "2"]}], ")"}], " ", 
         SubsuperscriptBox["\[CapitalOmega]", "R", "6"]}], "+", 
        RowBox[{"81", " ", 
         SuperscriptBox["\[Gamma]", "2"], " ", 
         RowBox[{"\[LeftSkeleton]", "3", "\[RightSkeleton]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], 
            "2"], "+", 
           RowBox[{"4", " ", 
            SubsuperscriptBox["\[CapitalDelta]", 
             RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "2"]}]}], 
          ")"}]}], "+", 
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "+", 
        RowBox[{"18", " ", "\[Gamma]", " ", 
         SubsuperscriptBox["\[CapitalOmega]", "R", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox["\[Gamma]", "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], 
              ")"}], "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"9", " ", "\[Gamma]"}], "+", 
              RowBox[{"5", " ", "\[CapitalGamma]"}]}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"72", " ", 
               SuperscriptBox["\[Gamma]", "4"]}], "+", 
              RowBox[{"102", " ", 
               SuperscriptBox["\[Gamma]", "3"], " ", "\[CapitalGamma]"}], "+", 
              RowBox[{"55", " ", 
               SuperscriptBox["\[Gamma]", "2"], " ", 
               SuperscriptBox["\[CapitalGamma]", "2"]}], "+", 
              RowBox[{"15", " ", "\[Gamma]", " ", 
               SuperscriptBox["\[CapitalGamma]", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["\[CapitalGamma]", "4"]}]}], ")"}], " ", 
            SubsuperscriptBox["\[CapitalDelta]", 
             RowBox[{"1", ",", "2"}], "2"]}], "+", 
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"6", " ", 
               SuperscriptBox["\[Gamma]", "2"]}], "+", 
              RowBox[{"5", " ", "\[Gamma]", " ", "\[CapitalGamma]"}], "+", 
              SuperscriptBox["\[CapitalGamma]", "2"]}], ")"}], " ", 
            SubsuperscriptBox["\[CapitalDelta]", 
             RowBox[{"1", ",", "2"}], "4"]}]}], ")"}]}]}], ")"}]}]}], ",", 
    RowBox[{"\[LeftSkeleton]", "14", "\[RightSkeleton]"}], ",", 
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "0"}], "}"}]}]], "\[Rule]", 
     FractionBox[
      RowBox[{"2", " ", "\[Gamma]", " ", 
       RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Gamma]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], 
          " ", 
          SubsuperscriptBox["\[CapitalOmega]", "R", "4"]}], "+", 
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "+", 
         RowBox[{"3", " ", 
          SubsuperscriptBox["\[CapitalOmega]", "R", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             SuperscriptBox["\[Gamma]", "2"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], 
               ")"}], "2"]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[Gamma]", "2"]}], "+", 
               RowBox[{"4", " ", "\[Gamma]", " ", "\[CapitalGamma]"}], "+", 
               SuperscriptBox["\[CapitalGamma]", "2"]}], ")"}], " ", 
             SubsuperscriptBox["\[CapitalDelta]", 
              RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "2"]}]}], 
           ")"}]}]}], ")"}]}], 
      RowBox[{
       RowBox[{"4", " ", "\[Gamma]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"6", " ", 
           SuperscriptBox["\[Gamma]", "2"]}], "+", 
          RowBox[{"5", " ", "\[Gamma]", " ", "\[CapitalGamma]"}], "+", 
          SuperscriptBox["\[CapitalGamma]", "2"]}], ")"}], " ", 
        SubsuperscriptBox["\[CapitalOmega]", "R", "6"]}], "+", 
       RowBox[{"81", " ", 
        SuperscriptBox["\[Gamma]", "2"], " ", 
        RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[Gamma]", "2"], "+", 
          RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], ")"}], " ", 
        
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], 
           "2"], "+", 
          RowBox[{"4", " ", 
           SubsuperscriptBox["\[CapitalDelta]", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "2"]}]}], 
         ")"}]}], "+", 
       RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "+", 
       RowBox[{"18", " ", 
        RowBox[{"\[LeftSkeleton]", "3", "\[RightSkeleton]"}]}]}]]}]}], "}"}],
  Short[#, 5]& ]], "Output",
 CellLabel->"Out[18]//Short=",
 CellID->846140089,ExpressionUUID->"592e047c-300f-4cec-907c-e3ec9d9432a8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Absorption signal", "Section",
 CellID->248714767,ExpressionUUID->"6c964572-24c4-49d3-b117-ba095c19d531"],

Cell["\<\
In a classic EIT experiment, the pump frequency is held fixed, the probe \
frequency is swept, and the absorption of the probe light is measured. We can \
plot this absorption spectrum using the solution we have found. We consider \
here the case of equal-intensity pump and probe beams, because the resulting \
population and angular-momentum probability plots more clearly illustrate the \
effect in this case. When equal-intensity beams are used, the effect is \
sometimes referred to as coherent population trapping (CPT), in order to \
distinguish it from the classic EIT case of a strong pump and weak probe, but \
the physical mechanism of the effect is identical in the two cases.\
\>", "Text",
 CellID->80909269,ExpressionUUID->"213c89a1-6538-4805-8d9a-8d9320bad5b3"],

Cell[TextData[{
 "The function ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["Observables"]], "paclet:AtomicDensityMatrix/ref/Observables", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "7540a2f5-e7eb-474e-8687-711560d6b687"],
 " takes the transition frequency, light electric field, and light \
polarization as arguments and returns the change induced in the various light \
polarization parameters due to interaction with the atoms, in terms of the \
rotating-frame density-matrix elements. Here we use the probe frequency ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Omega]", "1"], "+", 
    SubscriptBox["\[CapitalDelta]", 
     RowBox[{"1", ",", "2"}]]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"dc5d61ac-4e89-4135-87b8-8cf8a8f6f9f3"],
 ". We also need to specify the transform from the stationary frame that we \
have used to eliminate time dependence in the density matrix; the total \
transform is given by ",
 Cell[BoxData[
  FormBox[
   RowBox[{"u", "\[CenterDot]", "v"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"3ff5407d-1165-4706-991a-7947ff8cb5d1"],
 "."
}], "Text",
 CellID->489699383,ExpressionUUID->"2af22813-603a-47d2-962f-3de2377e59d6"],

Cell["\<\
The absorption of the probe in terms of the density-matrix elements.\
\>", "MathCaption",
 CellID->818921601,ExpressionUUID->"1991be86-061b-423c-a35c-8803c8523b40"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"abs", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"Observables", "[", 
         RowBox[{"sys", ",", 
          RowBox[{
           SubscriptBox["\[Omega]", "1"], "+", 
           SubscriptBox["\[CapitalDelta]", 
            RowBox[{"1", ",", "2"}]]}], ",", 
          RowBox[{
           SubscriptBox["\[CapitalOmega]", 
            RowBox[{"R", ",", "2"}]], "/", 
           RowBox[{"ReducedME", "[", 
            RowBox[{"1", ",", 
             RowBox[{"{", 
              RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{
             RowBox[{"-", "\[Pi]"}], "/", "4"}]}], "}"}], ",", 
          RowBox[{"TransformMatrix", "\[Rule]", 
           RowBox[{"u", ".", "v"}]}]}], "]"}], "\[LeftDoubleBracket]", 
        RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], "/.", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Omega]", "1"], "+", 
         SubscriptBox["\[CapitalDelta]", 
          RowBox[{"1", ",", "2"}]]}], ")"}], "\[Rule]", 
       RowBox[{"Energy", "[", "2", "]"}]}]}], "/.", 
     RowBox[{
      RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", 
      RowBox[{"2", 
       RowBox[{"\[Pi]", "/", "\[Lambda]"}]}]}]}], "/.", 
    RowBox[{
     SubscriptBox["\[CapitalOmega]", 
      RowBox[{"R", ",", "2"}]], "\[Rule]", 
     SubscriptBox["\[CapitalOmega]", "R"]}]}], "//", "Simplify"}]}]], "Input",\

 CellLabel->"In[19]:=",
 CellID->27732173,ExpressionUUID->"e5ab41fa-993e-446d-9879-095164dbe1da"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SqrtBox["3"], " ", "\[CapitalGamma]", " ", 
   SuperscriptBox["\[Lambda]", "2"], " ", 
   RowBox[{"Im", "[", 
    SubscriptBox["\[Rho]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "0"}], "}"}]}]], "]"}]}], 
  RowBox[{"4", " ", "\[Pi]", " ", 
   SubscriptBox["\[CapitalOmega]", "R"]}]]], "Output",
 CellLabel->"Out[19]=",
 CellID->439765389,ExpressionUUID->"2acc50bf-d1ab-40e3-a9cf-729aec884c7f"]
}, Open  ]],

Cell["\<\
Substitute the density matrix into the expression for the absorption.\
\>", "MathCaption",
 CellID->663291271,ExpressionUUID->"88a6ff72-d1d9-47ce-a58d-37c9390aaa50"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"abs1", "=", 
  RowBox[{"FullSimplify", "@", 
   RowBox[{"ComplexExpand", "[", 
    RowBox[{"abs", "/.", "sol"}], "]"}]}]}]], "Input",
 CellLabel->"In[20]:=",
 CellID->78157562,ExpressionUUID->"5c7ea910-6666-4ddd-aca5-bdf4123b910b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"3", " ", "\[Gamma]", " ", "\[CapitalGamma]", " ", 
    RowBox[{"(", 
     RowBox[{"\[Gamma]", "+", "\[CapitalGamma]"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], " ", 
    SuperscriptBox["\[Lambda]", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[Gamma]", " ", 
       SubsuperscriptBox["\[CapitalOmega]", "R", "4"]}], "+", 
      RowBox[{"9", " ", "\[Gamma]", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], 
        "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["\[Gamma]", "2"], "+", 
         SubsuperscriptBox["\[CapitalDelta]", 
          RowBox[{"1", ",", "2"}], "2"]}], ")"}]}], "+", 
      RowBox[{"3", " ", 
       SubsuperscriptBox["\[CapitalOmega]", "R", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          SuperscriptBox["\[Gamma]", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}]}],
          "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"3", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], 
          " ", 
          SubsuperscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}], "2"]}]}], ")"}]}]}], ")"}]}], ")"}], "/", 
  
  RowBox[{"(", 
   RowBox[{"4", " ", "\[Pi]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "\[Gamma]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], " ", 
       SubsuperscriptBox["\[CapitalOmega]", "R", "6"]}], "+", 
      RowBox[{"81", " ", 
       SuperscriptBox["\[Gamma]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"\[Gamma]", "+", "\[CapitalGamma]"}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], 
        "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["\[Gamma]", "2"], "+", 
         SubsuperscriptBox["\[CapitalDelta]", 
          RowBox[{"1", ",", "2"}], "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], 
          "2"], "+", 
         RowBox[{"4", " ", 
          SubsuperscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}], "2"]}]}], ")"}]}], "+", 
      RowBox[{"3", " ", 
       SubsuperscriptBox["\[CapitalOmega]", "R", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox["\[Gamma]", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], 
           "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"27", " ", "\[Gamma]"}], "+", 
            RowBox[{"11", " ", "\[CapitalGamma]"}]}], ")"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"39", " ", 
             SuperscriptBox["\[Gamma]", "3"]}], "+", 
            RowBox[{"29", " ", 
             SuperscriptBox["\[Gamma]", "2"], " ", "\[CapitalGamma]"}], "+", 
            RowBox[{"7", " ", "\[Gamma]", " ", 
             SuperscriptBox["\[CapitalGamma]", "2"]}], "+", 
            SuperscriptBox["\[CapitalGamma]", "3"]}], ")"}], " ", 
          SubsuperscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}], "2"]}]}], ")"}]}], "+", 
      RowBox[{"18", " ", "\[Gamma]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], " ", 
       SubsuperscriptBox["\[CapitalOmega]", "R", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox["\[Gamma]", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], 
           "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"9", " ", "\[Gamma]"}], "+", 
            RowBox[{"5", " ", "\[CapitalGamma]"}]}], ")"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"36", " ", 
             SuperscriptBox["\[Gamma]", "3"]}], "+", 
            RowBox[{"33", " ", 
             SuperscriptBox["\[Gamma]", "2"], " ", "\[CapitalGamma]"}], "+", 
            RowBox[{"11", " ", "\[Gamma]", " ", 
             SuperscriptBox["\[CapitalGamma]", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["\[CapitalGamma]", "3"]}]}], ")"}], " ", 
          SubsuperscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}], "2"]}], "+", 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"3", " ", "\[Gamma]"}], "+", "\[CapitalGamma]"}], ")"}], 
          " ", 
          SubsuperscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}], "4"]}]}], ")"}]}]}], ")"}]}], 
   ")"}]}]], "Output",
 CellLabel->"Out[20]=",
 CellID->1645663596,ExpressionUUID->"40c812f8-9d71-45fe-982a-83a5021294b2"]
}, Open  ]],

Cell[TextData[{
 "We can simplify the expression for absorption by writing the Rabi frequency \
in terms of the saturation parameter ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Kappa]", "=", 
    RowBox[{
     SubsuperscriptBox["\[CapitalOmega]", "R", "2"], "/", 
     RowBox[{"(", 
      RowBox[{"\[Gamma]", " ", "\[CapitalGamma]"}], ")"}]}]}], 
   TraditionalForm]], "InlineMath",ExpressionUUID->
  "1536b1f1-71d5-4237-b069-331482aa2ad1"],
 ", and making the assumption that the transit relaxation rate is much slower \
than the excited-state decay rate: ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Gamma]", "\[LessLess]", "\[CapitalGamma]"}], TraditionalForm]], 
  "InlineMath",ExpressionUUID->"9aabbb99-7e71-4b15-a5bb-39f62f0fdd99"],
 "."
}], "Text",
 CellID->865174207,ExpressionUUID->"06ca266b-566a-43ec-9708-87870736b2b9"],

Cell["Apply a replacement rule that neglects \[Gamma] compared to \
\[CapitalGamma].", "MathCaption",
 CellID->190807129,ExpressionUUID->"c499f1b2-43a0-4a2a-81df-8b8a49486d4a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"abs2", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"HornerForm", "[", 
     RowBox[{
      RowBox[{"abs1", "/.", 
       RowBox[{
        SubscriptBox["\[CapitalOmega]", "R"], "\[Rule]", 
        SqrtBox[
         RowBox[{"\[Gamma]", " ", "\[CapitalGamma]", " ", "\[Kappa]"}]]}]}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"\[Lambda]", ",", "\[Kappa]", ",", 
        SubscriptBox["\[CapitalDelta]", 
         RowBox[{"1", ",", "2"}]], ",", "\[CapitalGamma]"}], "}"}]}], "]"}], "//.", 
    RowBox[{
     RowBox[{
      RowBox[{"n_.", "\[CapitalGamma]"}], "+", 
      RowBox[{"m_.", " ", 
       SuperscriptBox["\[Gamma]", "j_."]}]}], "\[Rule]", 
     RowBox[{"n", " ", "\[CapitalGamma]"}]}]}], "//", 
   "FullSimplify"}]}]], "Input",
 CellLabel->"In[21]:=",
 CellID->489853664,ExpressionUUID->"c170427c-5b88-4f85-bf20-2b4537359582"],

Cell[BoxData[
 FractionBox[
  RowBox[{"3", " ", 
   SuperscriptBox["\[CapitalGamma]", "2"], " ", 
   RowBox[{"(", 
    RowBox[{"3", "+", "\[Kappa]"}], ")"}], " ", 
   SuperscriptBox["\[Lambda]", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["\[Gamma]", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "\[Kappa]"}], ")"}]}], "+", 
     RowBox[{"3", " ", 
      SubsuperscriptBox["\[CapitalDelta]", 
       RowBox[{"1", ",", "2"}], "2"]}]}], ")"}]}], 
  RowBox[{"4", " ", "\[Pi]", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["\[Gamma]", "2"], " ", 
      SuperscriptBox["\[CapitalGamma]", "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"3", "+", "\[Kappa]"}], ")"}], "2"], " ", 
      RowBox[{"(", 
       RowBox[{"9", "+", 
        RowBox[{"4", " ", "\[Kappa]"}]}], ")"}]}], "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["\[CapitalGamma]", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "\[Kappa]"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"9", "+", "\[Kappa]"}], ")"}], " ", 
      SubsuperscriptBox["\[CapitalDelta]", 
       RowBox[{"1", ",", "2"}], "2"]}], "+", 
     RowBox[{"36", " ", 
      RowBox[{"(", 
       RowBox[{"9", "+", 
        RowBox[{"2", " ", "\[Kappa]"}]}], ")"}], " ", 
      SubsuperscriptBox["\[CapitalDelta]", 
       RowBox[{"1", ",", "2"}], "4"]}]}], ")"}]}]]], "Output",
 CellLabel->"Out[21]=",
 CellID->1226168259,ExpressionUUID->"4c115ee8-b84c-411b-8d36-8854766b6a77"]
}, Open  ]],

Cell["\<\
A list of experimental parameters that we will use for the plots.\
\>", "MathCaption",
 CellID->547991346,ExpressionUUID->"96075737-d91c-41df-a0ab-2b90f031a648"],

Cell[BoxData[
 RowBox[{
  RowBox[{"params", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[CapitalGamma]", "\[Rule]", "1"}], ",", 
     RowBox[{"\[Kappa]", "\[Rule]", "100"}], ",", 
     RowBox[{"\[Gamma]", "\[Rule]", ".01"}], ",", 
     RowBox[{"\[Lambda]", "\[Rule]", "1"}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[22]:=",
 CellID->899459234,ExpressionUUID->"c48afddd-2e96-43d8-a4b0-1f66bf6a89d6"],

Cell["Plot the absorption.", "MathCaption",
 CellID->2911107,ExpressionUUID->"af9d96f0-29a6-4800-82a6-e7465d069600"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"colors", "=", 
   RowBox[{"RGBColor", "@@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"225", ",", "242", ",", "255"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"239", ",", "226", ",", "255"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"230", ",", "255", ",", "207"}], "}"}]}], "}"}], "/", 
      "255."}], ")"}]}]}], ";", 
  RowBox[{"regimes", "=", 
   RowBox[{"{", 
    RowBox[{"11", ",", "3", ",", ".3"}], "}"}]}], ";", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{"abs2", "/.", "params"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["\[CapitalDelta]", 
       RowBox[{"1", ",", "2"}]], ",", 
      RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "All"}], "}"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"Prolog", "\[Rule]", 
     RowBox[{"MapThread", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"#1", ",", 
          RowBox[{"Rectangle", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "#2"}], ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"#2", ",", ".003"}], "}"}]}], "]"}]}], "}"}], "&"}], ",", 
       RowBox[{"{", 
        RowBox[{"colors", ",", "regimes"}], "}"}]}], "]"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}]}]], "Input",
 CellLabel->"In[23]:=",
 CellID->40739372,ExpressionUUID->"dd9e53a4-a338-4713-ba94-b3c34fd6e8fd"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJw1mXk0lV/Ux2XOPHNF6BoyDyFF7UfXkLFryOzea0wlyTw3KCWiiCJDKFOi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       "]]},
     Annotation[#, "Charting`Private`Tag$7518#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{False, False},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->FrontEndValueCache[{{Automatic, 
      Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
      Charting`ScaledFrameTicks[{Identity, Identity}]}}, {{Automatic, {{0., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0005, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {0.001, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0015, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {0.002, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0001, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0002, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0003, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0004, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0006, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0007, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0008, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0009, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0011, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0012, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0013, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0014, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0016, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0017, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0018, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0019, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0021, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0022, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0023, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0024, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.0025, 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}}}, {Automatic, {{-10., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-5., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {0., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {5., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {10., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-15., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-14., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-13., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-12., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-11., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-9., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-8., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-7., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-6., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-1., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {3., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {4., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {6., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {7., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {8., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {9., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {11., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {12., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {13., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {14., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {15., 
        FormBox[
         TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}}}}],
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->300,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-9.999999591836735, 9.999999591836735}, {0, All}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {0, 
     Scaled[0.05]}},
  Prolog->{{
     RGBColor[0.8823529411764706, 0.9490196078431372, 1.], 
     RectangleBox[{-11, 0}, {11, 0.003}]}, {
     RGBColor[0.9372549019607843, 0.8862745098039215, 1.], 
     RectangleBox[{-3, 0}, {3, 0.003}]}, {
     RGBColor[0.9019607843137255, 1., 0.8117647058823529], 
     RectangleBox[{-0.3, 0}, {0.3, 0.003}]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellLabel->"Out[23]=",
 CellID->956852401,ExpressionUUID->"eb6d7599-13f8-49b1-8b0e-9c13d076b8f7"]
}, Open  ]],

Cell["\<\
We see a classic EIT/CPT absorption spectrum. There are three regimes:\
\>", "Text",
 CellID->400119040,ExpressionUUID->"8a865bef-a750-43f8-8331-04cbc7164a71"],

Cell["\<\
(1) When the probe detuning is much larger than the power-broadened natural \
width, the probe is off resonance and there is little absorption.\
\>", "Text",
 Background->RGBColor[0.8823529411764706, 0.9490196078431372, 1.],
 CellID->467904709,ExpressionUUID->"02e7d1a7-8d3a-4680-b5fc-a0c9287b5f34"],

Cell["\<\
(2) When the probe detuning is less than the power-broadened natural width, \
but greater than the power-broadened ground-state transit width, there is \
absorption with a spectrum that is qualitatively the same as if there were no \
pump field. \
\>", "Text",
 Background->RGBColor[0.9372549019607843, 0.8862745098039215, 1.],
 CellID->21941573,ExpressionUUID->"8e619bc9-08fb-4cb6-b07d-85535972b474"],

Cell["\<\
(3) When the pump-probe detuning is within the power-broadened ground-state \
transit width, a sharp EIT resonance is seen: the absorption is dramatically \
reduced.\
\>", "Text",
 Background->RGBColor[0.9019607843137255, 1., 0.8117647058823529],
 CellID->862120582,ExpressionUUID->"46396611-2af1-4a8d-acfb-8de37865c47c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Zeeman populations", "Section",
 CellID->29539545,ExpressionUUID->"acc6f21e-f509-4428-9580-2860cf107e30"],

Cell["\<\
In order to understand the EIT spectrum, we can plot the atomic density \
matrix in different ways. One way is to display the populations of the Zeeman \
sublevels.\
\>", "Text",
 CellID->122229125,ExpressionUUID->"88198573-be4d-4b97-b468-f010f45e3589"],

Cell["Write the solution for the density matrix in terms of \[Kappa].", \
"MathCaption",
 CellID->204481718,ExpressionUUID->"991b4a13-9a9e-4851-adcb-4e4dfbc386ee"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sol1", "=", 
   RowBox[{"sol", "/.", 
    RowBox[{
     SubscriptBox["\[CapitalOmega]", "R"], "\[Rule]", 
     SqrtBox[
      RowBox[{"\[Gamma]", " ", "\[CapitalGamma]", " ", "\[Kappa]"}]]}]}]}], 
  ";"}]], "Input",
 CellLabel->"In[24]:=",
 CellID->899057428,ExpressionUUID->"c4a25d0e-7f9a-4387-b2cb-c8f8b784742c"],

Cell["\<\
Make an interactive diagram showing the level structure, the light fields, \
and the population of each Zeeman sublevel as the probe frequency is changed.\
\
\>", "MathCaption",
 CellID->513934487,ExpressionUUID->"e811ed84-c18a-41f5-9c25-c9f1f3a2333e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"regimefunc", "[", "x_", "]"}], "=", 
   RowBox[{"Piecewise", "@", 
    RowBox[{"Reverse", "@", 
     RowBox[{"MapThread", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"#1", ",", 
          RowBox[{
           RowBox[{"-", "#2"}], "<", "x", "<", "#2"}]}], "}"}], "&"}], ",", 
       RowBox[{"{", 
        RowBox[{"colors", ",", "regimes"}], "}"}]}], "]"}]}]}]}], ";", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"sys", "=", "sys"}], ",", 
      RowBox[{"dm1", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"DensityMatrix", "[", "sys", "]"}], "/.", "sol1"}], "/.", 
        "params"}]}], ",", 
      RowBox[{"h01", "=", 
       RowBox[{"h0", "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", "1.4"}], ",", 
          RowBox[{
           SubscriptBox["\[Omega]", "1"], "\[Rule]", "1.4"}], ",", 
          RowBox[{
           SubscriptBox["\[CapitalDelta]", 
            RowBox[{"1", ",", "2"}]], "\[Rule]", 
           RowBox[{
            SubscriptBox["\[CapitalDelta]", 
             RowBox[{"1", ",", "2"}]], "/", "25."}]}]}], "}"}]}]}]}], "}"}], 
    ",", 
    RowBox[{"Manipulate", "[", 
     RowBox[{
      RowBox[{"Magnify", "@", 
       RowBox[{"LevelDiagram", "[", 
        RowBox[{"sys", ",", "h01", ",", "dm1", ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"regimefunc", "[", 
           SubscriptBox["\[CapitalDelta]", 
            RowBox[{"1", ",", "2"}]], "]"}]}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          SubscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}]], ",", ".05"}], "}"}], ",", 
        RowBox[{"-", "6"}], ",", "6"}], "}"}], ",", 
      RowBox[{"SaveDefinitions", "\[Rule]", "True"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[25]:=",
 CellID->34176881,ExpressionUUID->"a89ff774-b1a0-490e-93a2-be8ead0f84a2"],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`$13$$ = 0.05, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`$13$$], 0.05, 
       RawBoxes[
        SubscriptBox["\[CapitalDelta]", 
         RowBox[{"1", ",", "2"}]]]}, -6, 6}}, Typeset`size$$ = {
    237., {77., 85.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = False, $CellContext`$13$7653$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`$13$$ = 0.05}, 
      "ControllerVariables" :> {
        Hold[$CellContext`$13$$, $CellContext`$13$7653$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Magnify[
        AtomicDensityMatrix`LevelDiagram[{
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NaturalWidth -> 0, 
           AtomicDensityMatrix`M -> -1], 
          AtomicDensityMatrix`AtomicState[
          2, AtomicDensityMatrix`J -> 0, 
           AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
           AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
           0]}, {{0, 0, 
           0, (Rational[1, 2] 3^Rational[-1, 2]) (
            E^(Complex[0., -1.4] AtomicDensityMatrix`t) 
             Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 1] + 
            E^((Complex[0, 1] AtomicDensityMatrix`t) (1.4 + 
                0.04 $CellContext`$13$$)) 
             Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 2])}, {0,
           0, 0, 0}, {
          0, 0, 0, (Rational[1, 2] 
            3^Rational[-1, 2]) ((-E^(Complex[0., 1.4] AtomicDensityMatrix`t)) 
             Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 1] - 
            E^((Complex[0, -1] AtomicDensityMatrix`t) (1.4 + 
               0.04 $CellContext`$13$$)) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 2])}, {(
            Rational[1, 2] 3^Rational[-1, 2]) (
            E^(Complex[0., 1.4] AtomicDensityMatrix`t) 
             Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 1] + 
            E^((Complex[0, -1] AtomicDensityMatrix`t) (1.4 + 
                0.04 $CellContext`$13$$)) 
             Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 2]), 
           0, ((Rational[-1, 2] 3^Rational[-1, 2]) 
            E^(Complex[0., -1.4] AtomicDensityMatrix`t)) (
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 1] + 
            E^((Complex[0, 1] AtomicDensityMatrix`t) (2.8 + 
                0.04 $CellContext`$13$$)) 
             Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 2]), 
           1.4}}, {{
          0.01 ((1.0506000000000002` + 
             3.0000000000000004` (0.03194028 - 
               0.9793 $CellContext`$13$$^2) + (
               0.28371708 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
               4 $CellContext`$13$$^2) + 
             9. (0.00032366843999999997` + 1.0728564 $CellContext`$13$$^2 + 
               4.1616 $CellContext`$13$$^4))/(0.042024 + 
            3.0000000000000004` (0.0011725308 + 
              1.072939 $CellContext`$13$$^2) + (
              0.0085115124 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
              4 $CellContext`$13$$^2) + 
            0.18000000000000002` (0.0005401548719999999 + 
              2.15560272 $CellContext`$13$$^2 + 
              4.2024 $CellContext`$13$$^4))), 0, 
           0.0101 ((1.0200000000000002` + 
             3.0000000000000004` (0.020808 + 
               Complex[0., -1.0506] $CellContext`$13$$ - 
               1.01 $CellContext`$13$$^2) + (
               0.0918 (0.01 + Complex[0, -1] $CellContext`$13$$)) (1.0404 + 
               Complex[0., -1.02] $CellContext`$13$$ + 
               2 $CellContext`$13$$^2))/(0.042024 + 
            3.0000000000000004` (0.0011725308 + 
              1.072939 $CellContext`$13$$^2) + (
              0.0085115124 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
              4 $CellContext`$13$$^2) + 
            0.18000000000000002` (0.0005401548719999999 + 
              2.15560272 $CellContext`$13$$^2 + 
              4.2024 $CellContext`$13$$^4))), 
           0.01749371315644566 ((
             Complex[0., 1.] (0.0102 + 
               Complex[0., 1.01] $CellContext`$13$$) + (
               3. (0.01 + Complex[0, 1] $CellContext`$13$$)) (
               Complex[0., 0.020808] + 1.071 $CellContext`$13$$ + 
               Complex[0., -2.04] $CellContext`$13$$^2) + (
               Complex[0., 0.093636] (1.02 + 
                Complex[0, -2] $CellContext`$13$$)) (
               0.0001 + $CellContext`$13$$^2))/(0.042024 + 
            3.0000000000000004` (0.0011725308 + 
              1.072939 $CellContext`$13$$^2) + (
              0.0085115124 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
              4 $CellContext`$13$$^2) + 
            0.18000000000000002` (0.0005401548719999999 + 
              2.15560272 $CellContext`$13$$^2 + 
              4.2024 $CellContext`$13$$^4)))}, {
          0, (0.020808 + 
            3.0000000000000004` (0.0005295636 + 
              1.051313 $CellContext`$13$$^2) + (
              0.0028371708000000002` (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
              4 $CellContext`$13$$^2) + 
            0.18000000000000002` (0.00021542522399999996` + 
              1.07233824 $CellContext`$13$$^2 + 
              2.0808 $CellContext`$13$$^4))/(0.042024 + 
           3.0000000000000004` (0.0011725308 + 
             1.072939 $CellContext`$13$$^2) + (
             0.0085115124 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
             4 $CellContext`$13$$^2) + 
           0.18000000000000002` (0.0005401548719999999 + 
             2.15560272 $CellContext`$13$$^2 + 4.2024 $CellContext`$13$$^4)), 
           0, 0}, {0.0101 ((1.0200000000000002` + 
             3.0000000000000004` (0.020808 + 
               Complex[0., 1.0506] $CellContext`$13$$ - 
               1.01 $CellContext`$13$$^2) + (
               0.0918 (0.01 + Complex[0, 1] $CellContext`$13$$)) (1.0404 + 
               Complex[0., 1.02] $CellContext`$13$$ + 
               2 $CellContext`$13$$^2))/(0.042024 + 
            3.0000000000000004` (0.0011725308 + 
              1.072939 $CellContext`$13$$^2) + (
              0.0085115124 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
              4 $CellContext`$13$$^2) + 
            0.18000000000000002` (0.0005401548719999999 + 
              2.15560272 $CellContext`$13$$^2 + 
              4.2024 $CellContext`$13$$^4))), 0, 
           0.01 ((1.0506000000000002` + 
             3.0000000000000004` (0.03194028 + 
               1.0609 $CellContext`$13$$^2) + (
               0.28371708 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
               4 $CellContext`$13$$^2) + 
             9.18 (0.000317322 + 1.051416 $CellContext`$13$$^2 + 
               0.04 $CellContext`$13$$^4))/(0.042024 + 
            3.0000000000000004` (0.0011725308 + 
              1.072939 $CellContext`$13$$^2) + (
              0.0085115124 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
              4 $CellContext`$13$$^2) + 
            0.18000000000000002` (0.0005401548719999999 + 
              2.15560272 $CellContext`$13$$^2 + 
              4.2024 $CellContext`$13$$^4))), 
           Complex[0., -0.017320508075688773`] ((
             1.01 (0.0102 + Complex[0., -1.03] $CellContext`$13$$) + (
               3.03 (0.01 + Complex[0, -1] $CellContext`$13$$)) (0.020808 + 
               Complex[0., 1.0302] $CellContext`$13$$ + 
               0.02 $CellContext`$13$$^2) + (
               0.092718 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
               4 $CellContext`$13$$^2))/(0.042024 + 
            3.0000000000000004` (0.0011725308 + 
              1.072939 $CellContext`$13$$^2) + (
              0.0085115124 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
              4 $CellContext`$13$$^2) + 
            0.18000000000000002` (0.0005401548719999999 + 
              2.15560272 $CellContext`$13$$^2 + 
              4.2024 $CellContext`$13$$^4)))}, {
          Complex[0., -0.01749371315644566] ((
             1. (0.0102 + Complex[0., -1.01] $CellContext`$13$$) + (
               3. (0.01 + Complex[0, -1] $CellContext`$13$$)) (0.020808 + 
               Complex[0., 1.071] $CellContext`$13$$ - 
               2.04 $CellContext`$13$$^2) + (
               0.093636 (1.02 + Complex[0, 2] $CellContext`$13$$)) (
               0.0001 + $CellContext`$13$$^2))/(0.042024 + 
            3.0000000000000004` (0.0011725308 + 
              1.072939 $CellContext`$13$$^2) + (
              0.0085115124 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
              4 $CellContext`$13$$^2) + 
            0.18000000000000002` (0.0005401548719999999 + 
              2.15560272 $CellContext`$13$$^2 + 
              4.2024 $CellContext`$13$$^4))), 0, 
           Complex[0., 0.017320508075688773`] ((
             1.01 (0.0102 + Complex[0., 1.03] $CellContext`$13$$) + (
               3.03 (0.01 + Complex[0, 1] $CellContext`$13$$)) (0.020808 + 
               Complex[0., -1.0302] $CellContext`$13$$ + 
               0.02 $CellContext`$13$$^2) + (
               0.092718 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
               4 $CellContext`$13$$^2))/(0.042024 + 
            3.0000000000000004` (0.0011725308 + 
              1.072939 $CellContext`$13$$^2) + (
              0.0085115124 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
              4 $CellContext`$13$$^2) + 
            0.18000000000000002` (0.0005401548719999999 + 
              2.15560272 $CellContext`$13$$^2 + 
              4.2024 $CellContext`$13$$^4))), 
           0.02 ((0.010200000000000002` + 
             3. (0.00020808 + 1.0405 $CellContext`$13$$^2) + (
               0.09179999999999999 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
               2 $CellContext`$13$$^2))/(0.042024 + 
            3.0000000000000004` (0.0011725308 + 
              1.072939 $CellContext`$13$$^2) + (
              0.0085115124 (0.0001 + $CellContext`$13$$^2)) (1.0404 + 
              4 $CellContext`$13$$^2) + 
            0.18000000000000002` (0.0005401548719999999 + 
              2.15560272 $CellContext`$13$$^2 + 
              4.2024 $CellContext`$13$$^4)))}}, 
         Background -> $CellContext`regimefunc[$CellContext`$13$$]]], 
      "Specifications" :> {{{$CellContext`$13$$, 0.05, 
          RawBoxes[
           SubscriptBox["\[CapitalDelta]", 
            RowBox[{"1", ",", "2"}]]]}, -6, 6}}, "Options" :> {}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{279., {123., 128.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>({AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, 
         AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`LevelDiagram`Private`sys], {{0}}, 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
          Except[
           PatternTest[
            Blank[], MatchQ[
             Flatten[{#}], {
              RepeatedNull[
               Alternatives[
                Blank[Rule], 
                Blank[RuleDelayed]]]}]& ]]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, 
         AtomicDensityMatrix`LevelDiagram`Private`h, {{0}}, 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`energies, 
           Blank[]], VectorQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
          Except[
           PatternTest[
            Blank[], MatchQ[
             Flatten[{#}], {
              RepeatedNull[
               Alternatives[
                Blank[Rule], 
                Blank[RuleDelayed]]]}]& ]]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, 
         DiagonalMatrix[AtomicDensityMatrix`LevelDiagram`Private`energies], 
         AtomicDensityMatrix`LevelDiagram`Private`rho, 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
          Except[
           PatternTest[
            Blank[], MatchQ[
             Flatten[{#}], {
              RepeatedNull[
               Alternatives[
                Blank[Rule], 
                Blank[RuleDelayed]]]}]& ]]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pops, {
           Repeated[
            PatternTest[
             Blank[], NumericQ]]}], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, 
         AtomicDensityMatrix`LevelDiagram`Private`h, 
         DiagonalMatrix[AtomicDensityMatrix`LevelDiagram`Private`pops], 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
           Blank[]], AtomicDensityMatrix`OperatorQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
           Blank[]], AtomicDensityMatrix`OperatorQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, {{
          AtomicDensityMatrix`LevelDiagram`Private`h, 
           
           FilterRules[{AtomicDensityMatrix`LevelDiagram`Private`opts}, 
            AtomicDensityMatrix`ExtraArrows]}}, 
         AtomicDensityMatrix`LevelDiagram`Private`rho, 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`hlist, {
           Repeated[{
             PatternTest[
              Blank[], AtomicDensityMatrix`OperatorQ], 
             PatternTest[
              BlankNullSequence[], MatchQ[
               Flatten[{#}], {
                RepeatedNull[
                 Alternatives[
                  Blank[Rule], 
                  Blank[RuleDelayed]]]}]& ]}]}], 
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
           Blank[]], AtomicDensityMatrix`OperatorQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
          AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          AtomicDensityMatrix`LevelDiagram`Private`jflabels, 
          AtomicDensityMatrix`LevelDiagram`Private`levels, 
          AtomicDensityMatrix`LevelDiagram`Private`mlabels, 
          AtomicDensityMatrix`LevelDiagram`Private`populations, 
          AtomicDensityMatrix`LevelDiagram`Private`pos, 
          AtomicDensityMatrix`LevelDiagram`Private`width, 
          AtomicDensityMatrix`LevelDiagram`Private`xmax, 
          AtomicDensityMatrix`LevelDiagram`Private`xmin, 
          AtomicDensityMatrix`LevelDiagram`Private`ymax, 
          AtomicDensityMatrix`LevelDiagram`Private`ymin, 
          AtomicDensityMatrix`LevelDiagram`Private`height, 
          AtomicDensityMatrix`LevelDiagram`Private`defaultarrsty, 
          AtomicDensityMatrix`LevelDiagram`Private`defaultpopsty}, 
         AtomicDensityMatrix`LevelDiagram`Private`subscripts = PadRight[{}, 3, 
            OptionValue[AtomicDensityMatrix`QuantumNumberSubscripts]]; 
         AtomicDensityMatrix`LevelDiagram`Private`statelabels = Union[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`LevelDiagram`Private`sys]]; {
           AtomicDensityMatrix`LevelDiagram`Private`pos, 
            AtomicDensityMatrix`LevelDiagram`Private`xmin, 
            AtomicDensityMatrix`LevelDiagram`Private`xmax, 
            AtomicDensityMatrix`LevelDiagram`Private`width, 
            AtomicDensityMatrix`LevelDiagram`Private`ymin, 
            AtomicDensityMatrix`LevelDiagram`Private`ymax, 
            AtomicDensityMatrix`LevelDiagram`Private`height} = 
          AtomicDensityMatrix`LevelDiagram`Private`findLevelPositions[
           AtomicDensityMatrix`LevelDiagram`Private`sys, 
            First[
             First[AtomicDensityMatrix`LevelDiagram`Private`hlist]], 
            AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
            OptionValue[AtomicDensityMatrix`LevelLength], 
            OptionValue[AtomicDensityMatrix`LevelSpacing], 
            OptionValue[AtomicDensityMatrix`ParityOffset], 
            OptionValue[AtomicDensityMatrix`LevelOffset]]; 
         AtomicDensityMatrix`LevelDiagram`Private`levels = 
          AtomicDensityMatrix`LevelDiagram`Private`makeLevels[
           AtomicDensityMatrix`LevelDiagram`Private`pos, 
            OptionValue[AtomicDensityMatrix`LevelStyle], 
            OptionValue[AtomicDensityMatrix`LevelLength]]; 
         AtomicDensityMatrix`LevelDiagram`Private`mlabels = 
          AtomicDensityMatrix`LevelDiagram`Private`makeMLabels[
           AtomicDensityMatrix`LevelDiagram`Private`sys, 
            AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
            AtomicDensityMatrix`LevelDiagram`Private`pos, 
            AtomicDensityMatrix`LevelDiagram`Private`ymin, 
            AtomicDensityMatrix`LevelDiagram`Private`ymax, 
            AtomicDensityMatrix`LevelDiagram`Private`height, 
            OptionValue[AtomicDensityMatrix`MLabel], 
            OptionValue[AtomicDensityMatrix`MLabelPosition], 
            Part[
             OptionValue[AtomicDensityMatrix`QuantumNumberSymbols], 3], 
            Part[AtomicDensityMatrix`LevelDiagram`Private`subscripts, 3], 
            OptionValue[LabelStyle]]; 
         AtomicDensityMatrix`LevelDiagram`Private`jflabels = 
          AtomicDensityMatrix`LevelDiagram`Private`makeJFLabels[
           AtomicDensityMatrix`LevelDiagram`Private`sys, 
            AtomicDensityMatrix`LevelDiagram`Private`pos, 
            AtomicDensityMatrix`LevelDiagram`Private`xmin, 
            AtomicDensityMatrix`LevelDiagram`Private`xmax, 
            AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
            OptionValue[AtomicDensityMatrix`QuantumNumberSymbols], 
            AtomicDensityMatrix`LevelDiagram`Private`subscripts, 
            OptionValue[LabelStyle], 
            OptionValue[AtomicDensityMatrix`LevelLength], 
            OptionValue[AtomicDensityMatrix`LevelSpacing], 
            OptionValue[AtomicDensityMatrix`MinLabelSpacing], 
            OptionValue[AtomicDensityMatrix`FLabel], 
            OptionValue[AtomicDensityMatrix`JLabel], 
            OptionValue[AtomicDensityMatrix`MLabel], 
            OptionValue[AtomicDensityMatrix`StateLabel], 
            OptionValue[AtomicDensityMatrix`StateLabelPosition]]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrows = Apply[Join, 
            Map[
            AtomicDensityMatrix`LevelDiagram`Private`setupArrows[
             AtomicDensityMatrix`LevelDiagram`Private`sys, 
              First[#], AtomicDensityMatrix`LevelDiagram`Private`pos, 
              FilterRules[{
                Rest[#], 
                FilterRules[{AtomicDensityMatrix`LevelDiagram`Private`opts, 
                  Options[AtomicDensityMatrix`LevelDiagram]}, 
                 Except[AtomicDensityMatrix`ExtraArrows]]}, 
               Options[
               AtomicDensityMatrix`LevelDiagram`Private`setupArrows]]]& , 
             AtomicDensityMatrix`LevelDiagram`Private`hlist]]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrows = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustArrows[
           AtomicDensityMatrix`LevelDiagram`Private`arrows, 
            OptionValue[AtomicDensityMatrix`ArrowSpacing], 
            OptionValue[AtomicDensityMatrix`LevelLength]]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrows = 
          ReplaceAll[
           AtomicDensityMatrix`LevelDiagram`Private`arrows, 
            AtomicDensityMatrix`LevelDiagram`Private`arf -> (#3[#, #2]& )]; 
         AtomicDensityMatrix`LevelDiagram`Private`populations = 
          AtomicDensityMatrix`LevelDiagram`Private`makePopulations[
           AtomicDensityMatrix`LevelDiagram`Private`rho, 
            AtomicDensityMatrix`LevelDiagram`Private`pos, 
            OptionValue[AtomicDensityMatrix`PopulationFunction], 
            OptionValue[AtomicDensityMatrix`PopulationStyle], 
            OptionValue[AtomicDensityMatrix`LevelLength]]; 
         AtomicDensityMatrix`LevelDiagram`Private`defaultarrsty = Directive[
            RGBColor[0.9, 0.01, 0.01], 
            
            Arrowheads[({-0.2, 0.2} 
              OptionValue[AtomicDensityMatrix`LevelLength])/
             AtomicDensityMatrix`LevelDiagram`Private`width]]; 
         AtomicDensityMatrix`LevelDiagram`Private`defaultpopsty = Directive[
            EdgeForm[
             Hue[0.61, 0.54, 0.56]], 
            FaceForm[]]; If[
           OptionValue[AtomicDensityMatrix`TextOnTop], 
           AtomicDensityMatrix`TextOnTop, Identity][
           
           Graphics[{
            AtomicDensityMatrix`LevelDiagram`Private`levels, 
             AtomicDensityMatrix`LevelDiagram`Private`mlabels, 
             AtomicDensityMatrix`LevelDiagram`Private`jflabels, {
             AtomicDensityMatrix`LevelDiagram`Private`defaultpopsty, 
              AtomicDensityMatrix`LevelDiagram`Private`populations}, {
             AtomicDensityMatrix`LevelDiagram`Private`defaultarrsty, 
              AtomicDensityMatrix`LevelDiagram`Private`arrows}}, 
            DeleteCases[
             FilterRules[
              Join[{AtomicDensityMatrix`LevelDiagram`Private`opts}, 
               Options[AtomicDensityMatrix`LevelDiagram]], 
              Options[Graphics]], 
             Apply[Alternatives, 
              Options[Graphics]]]]]], 
       Options[AtomicDensityMatrix`LevelDiagram] := {
        AtomicDensityMatrix`ArrowStyle -> {}, 
         AtomicDensityMatrix`ArrowSpacing -> 0.1, 
         AtomicDensityMatrix`ExtraArrows -> {}, 
         AtomicDensityMatrix`LevelStyle -> {}, 
         AtomicDensityMatrix`LevelLength -> 0.8, 
         AtomicDensityMatrix`LevelSpacing -> 0.2, AtomicDensityMatrix`MLabel -> 
         None, AtomicDensityMatrix`MLabelPosition -> Automatic, 
         AtomicDensityMatrix`FLabel -> None, AtomicDensityMatrix`JLabel -> 
         None, AtomicDensityMatrix`StateLabel -> None, 
         AtomicDensityMatrix`StateLabelPosition -> Left, LabelStyle -> {}, 
         AtomicDensityMatrix`MinLabelSpacing -> 0.3, 
         AtomicDensityMatrix`ParityOffset -> Automatic, 
         AtomicDensityMatrix`LevelOffset -> None, 
         AtomicDensityMatrix`MaxArcSlope -> 0.2, 
         AtomicDensityMatrix`ArcRadius -> -0.5, 
         AtomicDensityMatrix`SuppressOffResonantCouplings -> True, 
         AtomicDensityMatrix`PopulationFunction -> Automatic, 
         AtomicDensityMatrix`PopulationStyle -> {}, 
         AtomicDensityMatrix`ArrowFunction -> Automatic, 
         AtomicDensityMatrix`ArrowOffset -> {0, 0}, 
         AtomicDensityMatrix`ArrowSetback -> 0, 
         AtomicDensityMatrix`QuantumNumberSymbols -> {
          AtomicDensityMatrix`J, AtomicDensityMatrix`F, 
           AtomicDensityMatrix`M}, 
         AtomicDensityMatrix`QuantumNumberSubscripts -> {True, True, False}, 
         AtomicDensityMatrix`TextOnTop -> True, ImageSize -> {{350}, {100}}, 
         AlignmentPoint -> Center, AspectRatio -> Automatic, Axes -> False, 
         AxesLabel -> None, AxesOrigin -> Automatic, AxesStyle -> {}, 
         Background -> None, BaselinePosition -> Automatic, BaseStyle -> {}, 
         ColorOutput -> Automatic, ContentSelectable -> Automatic, 
         CoordinatesToolOptions -> Automatic, 
         DisplayFunction :> $DisplayFunction, Epilog -> {}, FormatType :> 
         TraditionalForm, Frame -> False, FrameLabel -> None, 
         FrameStyle -> {}, FrameTicks -> Automatic, FrameTicksStyle -> {}, 
         GridLines -> None, GridLinesStyle -> {}, ImageMargins -> 0., 
         ImagePadding -> All, ImageSizeRaw -> Automatic, Method -> Automatic, 
         PlotLabel -> None, PlotRange -> {-0.3, 1.7}, PlotRangeClipping -> 
         False, PlotRangePadding -> Automatic, PlotRegion -> Automatic, 
         PreserveImageOptions -> Automatic, Prolog -> {}, RotateLabel -> True,
          Ticks -> Automatic, TicksStyle -> {}}, 
       TagSet[AtomicDensityMatrix`LevelDiagram, 
        MessageName[AtomicDensityMatrix`LevelDiagram, "usage"], 
        "\!\(\*TagBox[RowBox[{\"LevelDiagram[\", StyleBox[\"sys\", \"TI\"], \
\"] draws a level diagram for atomic system \", StyleBox[\"sys\", \"TI\"], \" \
using specified values of the AtomicState Energy parameter for the level \
energies, or default values if they are not specified.\", \
\"\[LineSeparator]\", \"LevelDiagram[\", StyleBox[RowBox[{\"sys, h\"}], \
\"TI\"], \"] uses energies specified in the Hamiltonian \", StyleBox[\"h\", \
\"TI\"], \" and draws arrows representing level couplings.\", \"\
\[LineSeparator]\", \"LevelDiagram[\", StyleBox[\"sys\", \"TI\"], \", \", \
StyleBox[\"h\", \"TI\"], \", \", StyleBox[\"dm\", \"TI\"], \"] draws \
populations for each level as specified by the diagonal elements of the \
density matrix \", StyleBox[\"dm\", \"TI\"], \".\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`AtomicSystemQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := MatchQ[AtomicDensityMatrix`AtomicSystem`Private`expr, 
         AtomicDensityMatrix`AtomicSystemPattern[]], 
       TagSet[AtomicDensityMatrix`AtomicSystemQ, 
        MessageName[AtomicDensityMatrix`AtomicSystemQ, "usage"], 
        "\!\(\*TagBox[RowBox[{\"AtomicSystemQ[\", StyleBox[\"expr\", \"TI\"], \
\"] tests if expression \", StyleBox[\"expr\", \"TI\"], \" has the form of an \
atomic system (list of AtomicState objects).\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`AtomicSystemPattern[] = {
         Repeated[
          Blank[AtomicDensityMatrix`AtomicState]]}, 
       TagSet[AtomicDensityMatrix`AtomicSystemPattern, 
        MessageName[AtomicDensityMatrix`AtomicSystemPattern, "usage"], ""], 
       UpSetDelayed[
        AtomicDensityMatrix`StateParameters[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]], 
        Rest[
         Apply[List, AtomicDensityMatrix`AtomicSystem`Private`state]]], 
       AtomicDensityMatrix`AtomicState[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`label, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`rules, 
           BlankNullSequence[Rule]]}] := 
       AtomicDensityMatrix`AtomicState[
        AtomicDensityMatrix`AtomicSystem`Private`label, 
         AtomicDensityMatrix`AtomicSystem`Private`rules], 
       TagSet[AtomicDensityMatrix`AtomicState, 
        MessageName[AtomicDensityMatrix`AtomicState, "usage"], 
        "\!\(\*TagBox[RowBox[{\"AtomicState[\", StyleBox[\"label\", \"TI\"], \
\"] represents a labeled atomic state. \", \"\[LineSeparator]\", \
\"AtomicState[\", StyleBox[\"label\", \"TI\"], \",\", \
SubscriptBox[StyleBox[\"par\", \"TI\"], StyleBox[\"1\", \"TR\"]], \
\"\[Rule]\", StyleBox[\"val\", \"TI\"], \",\", SubscriptBox[StyleBox[\"par\", \
\"TI\"], StyleBox[\"2\", \"TR\"]], \"\[Rule]\", StyleBox[\"val\", \"TI\"], \
\",\", StyleBox[\"\[Ellipsis]\", \"TR\"], \"] represents an atomic state with \
one or more specified atomic parameters\"}], DisplayForm]\)"], 
       TagSet[AtomicDensityMatrix`StateParameters, 
        MessageName[AtomicDensityMatrix`StateParameters, "usage"], 
        "StateParameters[\!\(\*\nStyleBox[\"state\", \"TI\"]\)] returns the \
state parameters of the AtomicState \!\(\*\nStyleBox[\"state\", \"TI\"]\)."], 
       AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0]] = 0, 
       AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1]] = 
       AtomicDensityMatrix`Energy[2], AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = 0, AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       0, AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       0, AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = AtomicDensityMatrix`Energy[2], 
       AtomicDensityMatrix`Energy[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = (
         2.1055962340701206`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = (
         2.2099578666293674`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         2.4949718469632683`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         2.110179504793416*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         5.751786570324602*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         5.798576475256555*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         2.4949718469632683`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         2.110179504793416*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         5.751786570324602*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         5.798576475256555*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = (
         1.5494714188784714`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = (
         1.5494783111595566`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = (3.1850255752395*^10 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = (
         3.1850069663593517`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = (
         3.1850055267711067`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = (
         3.1320876072969864`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = (
         3.011129565898232*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = (2.445956596069698*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = (2.456827149264637*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`Energy[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = (
         2.8073302517638264`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = (
         2.807394295917115*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = (5.49515580877772*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = (5.495146390519883*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = (3.193951666696825*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = (
         3.1971907769791055`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = (6.507783722448681*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}]
         = (6.507777129668197*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = (5.701246315122138*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = (5.702299276348264*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = (4.848517438966578*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (
         2.3694355849920673`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (2.414190843897715*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (2.36943607313472*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (
         2.4141913345832973`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`Energy, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`Energy -> AtomicDensityMatrix`Energy[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`Energy[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`Energy, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`Energy, 
        MessageName[AtomicDensityMatrix`Energy, "usage"], 
        "\!\(\*TagBox[RowBox[{\"Energy is a parameter for AtomicState that \
specifies the (fine\[Hyphen]structure) energy of the state in units of \
angular frequency.\", \"\[LineSeparator]\", \"Energy[\", StyleBox[\"state\", \
\"TI\"], \"] returns the value specified for Energy in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or Energy[StateLabel[\", StyleBox[\"state\", \
\"TI\"], \"]] if it is not specified.\"}], DisplayForm]\)"], 
       TagSet[Units`Mega, 
        MessageName[Units`Mega, "symbol"], "M"], 
       TagSet[Units`Mega, 
        MessageName[Units`Mega, "usage"], 
        "Mega is the SI unit prefix denoting \!\(\*SuperscriptBox[\"10\", \"6\
\"]\)."], 
       TagSet[Units`Second, 
        MessageName[Units`Second, "symbol"], "s"], 
       TagSet[Units`Second, 
        MessageName[Units`Second, "usage"], 
        "Second is the fundamental SI unit of time."], AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0]] = 1, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1]] = 0, 
       AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = 1, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       1, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       1, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = 0, 
       AtomicDensityMatrix`J[{"Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 5/2, 
       AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 5/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 
       0, AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 
       1, AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 
       2, AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 
       0, AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 
       1, AtomicDensityMatrix`J[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 5/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 
       5/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`J[AtomicDensityMatrix`AtomicSystem`Private`state] = 
        ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`J, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state]], 
          AtomicDensityMatrix`J -> 0]), AtomicDensityMatrix`J[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`J, 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`J, 
        MessageName[AtomicDensityMatrix`J, "usage"], 
        "\!\(\*TagBox[RowBox[{\"J is a parameter for AtomicState that \
specifies the total electronic angular\[Hyphen]momentum (orbital plus spin) \
quantum number for the state. \", \"\[LineSeparator]\", \"J[\", \
StyleBox[\"state\", \"TI\"], \"] returns the value specified for J in \
AtomicState \", StyleBox[\"state\", \"TI\"], \", or J[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified. \"}], \
DisplayForm]\)"], AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0]] = 0, 
       AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 
          1]] = $CellContext`\[CapitalGamma], AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = 0, 
       AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       0, AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       0, AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = $CellContext`\[CapitalGamma], 
       AtomicDensityMatrix`NaturalWidth[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = (28.743065735391337` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = (32.8893274132544 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         131.57894736842104` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         131.57894736842104` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         131.57894736842104` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         131.57894736842104` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`NaturalWidth[{
         "H", 1, {{2, "p"}}, {2, "P", 1/2}}] = (625. Units`Mega)/Units`Second,
        AtomicDensityMatrix`NaturalWidth[{
         "H", 1, {{2, "p"}}, {2, "P", 3/2}}] = (625. Units`Mega)/Units`Second,
        AtomicDensityMatrix`NaturalWidth[{
         "He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = (10.178760197630933` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = (10.178760197630933` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = (10.178760197630933` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = (37.32736095558044 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = (37.80718336483932 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = (
         36.764705882352935` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = (
         36.764705882352935` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = (51.47 Units`Mega)/
        Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = (51.4 Units`Mega)/
        Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = (61.35345726731702 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = (61.54149127341653 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = (19.130000000000003` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = (19.11 Units`Mega)/
        Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = (9.507000000000001 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = (9.692 Units`Mega)/
        Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = (26.400000000000002` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (36.12847284945265 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (38.11730983274124 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (36.12847284945265 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (38.11730983274124 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`NaturalWidth, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`NaturalWidth -> AtomicDensityMatrix`NaturalWidth[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`NaturalWidth[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`NaturalWidth, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`NaturalWidth, 
        MessageName[AtomicDensityMatrix`NaturalWidth, "usage"], 
        "\!\(\*TagBox[RowBox[{\"NaturalWidth is a parameter for AtomicState \
that specifies the natural width (radiative decay rate) of the state. \", \"\
\[LineSeparator]\", \"NaturalWidth[\", StyleBox[\"state\", \"TI\"], \"] \
returns the value specified for NaturalWidth in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or NaturalWidth[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified.\"}], \
DisplayForm]\)"], 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 0.01651414747028505, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 0.016405282707387538`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 0.014754436648782503`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 0.8334952399455994, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 0, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 0.5279665446941976, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 0.3333333333333333, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 0.16650476005440062`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 1, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 0.1055933089388395, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 0.6331763474620618, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 0.6666666666666666, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 0.28715683180814133`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 0.28373916632274043`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 0.3052796654469419, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 0.061160480920020896`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 0.36682365253793825`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 0.6963290207215735, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 0.6851011143210896, 
       AtomicDensityMatrix`BranchingRatio[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := If[
         Or[
          And[
           AtomicDensityMatrix`DefinedQ[
           AtomicDensityMatrix`AtomicSystem`Private`state1, 
            AtomicDensityMatrix`BranchingRatio[
             AtomicDensityMatrix`StateLabel[
             AtomicDensityMatrix`AtomicSystem`Private`state2]]], 
           AtomicDensityMatrix`BranchingRatio[
             AtomicDensityMatrix`StateLabel[
             AtomicDensityMatrix`AtomicSystem`Private`state2]][
            AtomicDensityMatrix`AtomicSystem`Private`state1] =!= 0], 
          AtomicDensityMatrix`Parity[
           AtomicDensityMatrix`AtomicSystem`Private`state1] === 
          AtomicDensityMatrix`Parity[
           AtomicDensityMatrix`AtomicSystem`Private`state2]], 0, 
         AtomicDensityMatrix`BranchingRatio[
          AtomicDensityMatrix`StateLabel[
          AtomicDensityMatrix`AtomicSystem`Private`state1]][
         AtomicDensityMatrix`AtomicSystem`Private`state2]], 
       AtomicDensityMatrix`BranchingRatio[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`label, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`value}, 
         If[
          Or[
          AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state] === 
           AtomicDensityMatrix`AtomicSystem`Private`label, 
           AtomicDensityMatrix`NaturalWidth[
            AtomicDensityMatrix`AtomicSystem`Private`state] === 0], 0, 
          If[(AtomicDensityMatrix`AtomicSystem`Private`value = ReplaceAll[
              AtomicDensityMatrix`BranchingRatio[
              AtomicDensityMatrix`AtomicSystem`Private`label], 
              AtomicDensityMatrix`StateParameters[
              AtomicDensityMatrix`AtomicSystem`Private`state]]) =!= 
           AtomicDensityMatrix`BranchingRatio[
            AtomicDensityMatrix`AtomicSystem`Private`label], 
           AtomicDensityMatrix`AtomicSystem`Private`value, 
           AtomicDensityMatrix`BranchingRatio[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state], 
            AtomicDensityMatrix`AtomicSystem`Private`label]]]], 
       TagSet[AtomicDensityMatrix`BranchingRatio, 
        MessageName[AtomicDensityMatrix`BranchingRatio, "usage"], 
        "\!\(\*TagBox[RowBox[{\"BranchingRatio[\", StyleBox[\"label\", \
\"TI\"], \"] is a parameter for AtomicState that specifies the branching \
ratio for radiative decay to the state with label \", StyleBox[\"label\", \
\"TI\"], \".\", \"\[LineSeparator]\", \"BranchingRatio[\", \
StyleBox[\"label\", \"TI\"], \"][\", StyleBox[\"state\", \"TI\"], \"] returns \
the branching ratio for the AtomicState \", StyleBox[\"state\", \"TI\"], \" \
to the state with label \", StyleBox[\"label\", \"TI\"], \", or \
BranchingRatio[StateLabel[\", StyleBox[\"state]\", \"TI\"], \",\", \
StyleBox[\"label\", \"TI\"], \"] if it is not specified.\"}], \
DisplayForm]\)"], AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`x, 
          Alternatives[
          AtomicDensityMatrix`S, AtomicDensityMatrix`L, AtomicDensityMatrix`J,
            AtomicDensityMatrix`NuclearSpin, AtomicDensityMatrix`F, 
           AtomicDensityMatrix`M, AtomicDensityMatrix`Parity, 
           AtomicDensityMatrix`Energy, AtomicDensityMatrix`NaturalWidth, 
           AtomicDensityMatrix`GFactor, 
           AtomicDensityMatrix`BranchingRatio[
            Blank[]], AtomicDensityMatrix`LevelPosition, 
           AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
           AtomicDensityMatrix`Polarizability[
            Blank[]], 
           AtomicDensityMatrix`TransitionPolarizability[
            Blank[]]]]] := MemberQ[
         Rest[AtomicDensityMatrix`AtomicSystem`Private`state], 
         AtomicDensityMatrix`AtomicSystem`Private`x -> Blank[]], 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
          Alternatives[
           Blank[AtomicDensityMatrix`AtomicState], {
            Repeated[
             Blank[AtomicDensityMatrix`AtomicState]]}]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`x, 
          Alternatives[{
            Repeated[
             Alternatives[
             AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
              AtomicDensityMatrix`J, AtomicDensityMatrix`NuclearSpin, 
              AtomicDensityMatrix`F, AtomicDensityMatrix`M, 
              AtomicDensityMatrix`Parity, AtomicDensityMatrix`Energy, 
              AtomicDensityMatrix`NaturalWidth, AtomicDensityMatrix`GFactor, 
              AtomicDensityMatrix`BranchingRatio[
               Blank[]], AtomicDensityMatrix`LevelPosition, 
              AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
              
              AtomicDensityMatrix`Polarizability[
               Blank[]], 
              AtomicDensityMatrix`TransitionPolarizability[
               Blank[]]]]}, 
           Repeated[
            Alternatives[
            AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
             AtomicDensityMatrix`J, AtomicDensityMatrix`NuclearSpin, 
             AtomicDensityMatrix`F, AtomicDensityMatrix`M, 
             AtomicDensityMatrix`Parity, AtomicDensityMatrix`Energy, 
             AtomicDensityMatrix`NaturalWidth, AtomicDensityMatrix`GFactor, 
             AtomicDensityMatrix`BranchingRatio[
              Blank[]], AtomicDensityMatrix`LevelPosition, 
             AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
             AtomicDensityMatrix`Polarizability[
              Blank[]], 
             AtomicDensityMatrix`TransitionPolarizability[
              Blank[]]]]]]] := Apply[And, 
         Flatten[
          Outer[AtomicDensityMatrix`DefinedQ, 
           Flatten[{AtomicDensityMatrix`AtomicSystem`Private`sys}], 
           Flatten[{AtomicDensityMatrix`AtomicSystem`Private`x}]]]], 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, 
          Alternatives[
          AtomicDensityMatrix`OpticalParameters, 
           AtomicDensityMatrix`ElectricField, 
           AtomicDensityMatrix`MagneticField, 
           AtomicDensityMatrix`TransitRate[
            Blank[]], AtomicDensityMatrix`Density]]] := 
       ReplaceAll[AtomicDensityMatrix`ExperimentalSystem`Private`x, 
          AtomicDensityMatrix`RegionParameters[
          AtomicDensityMatrix`ExperimentalSystem`Private`region]] =!= 
        AtomicDensityMatrix`ExperimentalSystem`Private`x, 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, {
           Repeated[
            Alternatives[
            AtomicDensityMatrix`OpticalParameters, 
             AtomicDensityMatrix`ElectricField, 
             AtomicDensityMatrix`MagneticField, 
             AtomicDensityMatrix`TransitRate[
              Blank[]], AtomicDensityMatrix`Density]]}]] := Apply[And, 
         Map[
         AtomicDensityMatrix`DefinedQ[
          AtomicDensityMatrix`ExperimentalSystem`Private`region, #]& , 
          AtomicDensityMatrix`ExperimentalSystem`Private`x]], 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, 
          Blank[]]] := Apply[And, 
         Map[
         AtomicDensityMatrix`DefinedQ[#, 
           AtomicDensityMatrix`ExperimentalSystem`Private`x]& , 
          AtomicDensityMatrix`ExperimentalSystem`Private`sys]], 
       TagSet[AtomicDensityMatrix`DefinedQ, 
        MessageName[AtomicDensityMatrix`DefinedQ, "usage"], 
        "DefinedQ[\!\(\*\nStyleBox[\"state\", \"TI\"]\),\!\(\*\n\
StyleBox[\"param\", \"TI\"]\)] returns True if state parameter \!\(\*\n\
StyleBox[\"param\", \"TI\"]\) is specified in AtomicState \!\(\*\n\
StyleBox[\"state\", \"TI\"]\), and False otherwise.\nDefinedQ[\!\(\*\n\
StyleBox[\"state\", \"TI\"]\),{\!\(\*SubscriptBox[\nStyleBox[\"param\", \
\"TI\"], \"1\"]\),\!\(\*SubscriptBox[\nStyleBox[\"param\", \"TI\"], \"2\"]\),\
\[Ellipsis]}] returns True if all of the \!\(\*\n\
StyleBox[SubscriptBox[\"param\", \"i\"], \"TI\"]\) are specified in \!\(\*\n\
StyleBox[\"state\", \"TI\"]\), and False otherwise.\n\
DefinedQ[{\!\(\*SubscriptBox[\nStyleBox[\"state\", \"TI\"], \
\"1\"]\),\!\(\*SubscriptBox[\nStyleBox[\"state\", \"TI\"], \"2\"]\),\
\[Ellipsis]},\!\(\*\nStyleBox[\"param\", \"TI\"]\)] checks if \!\(\*\n\
StyleBox[\"param\", \"TI\"]\) is specified in all of the states.\nDefinedQ \
behaves analogously with region parameters and regions in place of state \
parameters and states."], 
       AtomicDensityMatrix`S[{"Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 
       1, AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 
       1, AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 
       1, AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 
       0, AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 
       1, AtomicDensityMatrix`S[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`S[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`S, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`S -> AtomicDensityMatrix`S[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`S[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`S, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`S, 
        MessageName[AtomicDensityMatrix`S, "usage"], 
        "\!\(\*TagBox[RowBox[{\"S is a parameter for AtomicState that \
specifies the electronic spin angular\[Hyphen]momentum quantum number. \", \"\
\[LineSeparator]\", \"S[\", StyleBox[\"state\", \"TI\"], \"] returns the \
value specified for S in AtomicState \", StyleBox[\"state\", \"TI\"], \", or \
S[StateLabel[\", StyleBox[\"state\", \"TI\"], \"]] if it is not \
specified.\"}], DisplayForm]\)"], 
       Attributes[AtomicDensityMatrix`AtomicSystem`Private`state$] = {
        Temporary}, AtomicDensityMatrix`StateLabel[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       First[AtomicDensityMatrix`AtomicSystem`Private`state], 
       AtomicDensityMatrix`StateLabel[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`StateLabel, 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`StateLabel, 
        MessageName[AtomicDensityMatrix`StateLabel, "usage"], 
        "\!\(\*TagBox[RowBox[{\"StateLabel[\", StyleBox[\"state\", \"TI\"], \
\"] gives the label (first argument) for the AtomicState \", StyleBox[\"state\
\", \"TI\"], \".\"}], DisplayForm]\)"], 
       Attributes[AtomicDensityMatrix`AtomicSystem`Private`sys$] = {
        Temporary}, AtomicDensityMatrix`L[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = AtomicDensityMatrix`L[1], 
       AtomicDensityMatrix`L[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = AtomicDensityMatrix`L[2], 
       AtomicDensityMatrix`L[{"Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`L[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`L[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`L[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`L[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 
       1, AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 
       1, AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 
       1, AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 
       0, AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 
       0, AtomicDensityMatrix`L[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 2,
        AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 
       2, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 
       2, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 
       2, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{"Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`L[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`L, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`L -> AtomicDensityMatrix`L[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`L[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`L, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`L, 
        MessageName[AtomicDensityMatrix`L, "usage"], 
        "\!\(\*TagBox[RowBox[{\"L is a parameter for AtomicState that \
specifies the electronic orbital angular\[Hyphen]momentum quantum number for \
the state. \", \"\[LineSeparator]\", \"L[\", StyleBox[\"state\", \"TI\"], \"] \
returns the value specified for L in AtomicState \", StyleBox[\"state\", \"TI\
\"], \", or L[StateLabel[\", StyleBox[\"state\", \"TI\"], \"]] if it is not \
specified.\"}], DisplayForm]\)"], AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = -1, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       0, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       1, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = 0, AtomicDensityMatrix`M[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`M, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`M -> AtomicDensityMatrix`M[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`M[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`M, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`M, 
        MessageName[AtomicDensityMatrix`M, "usage"], 
        "\!\(\*TagBox[RowBox[{\"M is a parameter for AtomicState that \
specifies the total angular\[Hyphen]momentum projection quantum number for \
the state. \", \"\[LineSeparator]\", \"M[\", StyleBox[\"state\", \"TI\"], \"] \
returns the value specified for M in AtomicState \", StyleBox[\"state\", \"TI\
\"], \", or M[StateLabel[\", StyleBox[\"state\", \"TI\"], \"]] if it is not \
specified. \"}], DisplayForm]\)"], 
       AtomicDensityMatrix`NuclearSpin[{"Cs", 133}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{"Cu", 63}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"Cu", 65}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"H", 1}] = 1/2, 
       AtomicDensityMatrix`NuclearSpin[{"He", 2}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{"K", 39}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"Li", 3}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"Na", 23}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"Rb", 85}] = 5/2, 
       AtomicDensityMatrix`NuclearSpin[{"Rb", 87}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`NuclearSpin[{
         "H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`NuclearSpin[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 
       1/2, AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 5/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 5/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 5/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`NuclearSpin[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`NuclearSpin, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`NuclearSpin -> AtomicDensityMatrix`NuclearSpin[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`NuclearSpin[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`NuclearSpin, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`NuclearSpin, 
        MessageName[AtomicDensityMatrix`NuclearSpin, "usage"], 
        "\!\(\*TagBox[RowBox[{\"NuclearSpin is a parameter for AtomicState \
that specifies the nuclear angular\[Hyphen]momentum quantum number for the \
atom. \", \"\[LineSeparator]\", \"NuclearSpin[\", StyleBox[\"state\", \
\"TI\"], \"] returns the value specified for NuclearSpin in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or NuclearSpin[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified. \"}], \
DisplayForm]\)"], AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = 1, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       1, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       1, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = 0, AtomicDensityMatrix`F[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`F[AtomicDensityMatrix`AtomicSystem`Private`state] = 
        ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`F, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state]], 
          AtomicDensityMatrix`F -> 
          AtomicDensityMatrix`J[
           AtomicDensityMatrix`AtomicSystem`Private`state]]), 
       AtomicDensityMatrix`F[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`F, 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`F, 
        MessageName[AtomicDensityMatrix`F, "usage"], 
        "\!\(\*TagBox[RowBox[{\"F is a parameter for AtomicState that \
specifies the total angular\[Hyphen]momentum (electronic plus nuclear) \
quantum number for the state. \", \"\[LineSeparator]\", \"F[\", \
StyleBox[\"state\", \"TI\"], \"] returns the value specified for F in \
AtomicState \", StyleBox[\"state\", \"TI\"], \", or J[\", StyleBox[\"state\", \
\"TI\"], \"] if it is not specified. \"}], DisplayForm]\)"], 
       AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0]] = 
       AtomicDensityMatrix`Parity[1], AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1]] = 
       AtomicDensityMatrix`Parity[2], AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = AtomicDensityMatrix`Parity[1], 
       AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       AtomicDensityMatrix`Parity[1], AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       AtomicDensityMatrix`Parity[1], AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = AtomicDensityMatrix`Parity[2], 
       AtomicDensityMatrix`Parity[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, AtomicDensityMatrix`Parity[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`Parity, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`Parity -> AtomicDensityMatrix`Parity[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`Parity[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`Parity, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`Parity, 
        MessageName[AtomicDensityMatrix`Parity, "usage"], 
        "\!\(\*TagBox[RowBox[{\"Parity is a parameter for AtomicState that \
specifies the parity of the state.\", \"\[LineSeparator]\", \"Parity[\", \
StyleBox[\"state\", \"TI\"], \"] returns the value specified for Parity in \
AtomicState \", StyleBox[\"state\", \"TI\"], \", or Parity[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified.\"}], \
DisplayForm]\)"], 
       TagSet[AtomicDensityMatrix`Odd, 
        MessageName[AtomicDensityMatrix`Odd, "usage"], 
        "Odd is a possible value for the AtomicState parameter Parity \
specifying that the parity of the state is odd."], 
       TagSet[AtomicDensityMatrix`Even, 
        MessageName[AtomicDensityMatrix`Even, "usage"], 
        "Even is a possible value for the AtomicState parameter Parity \
specifying that the parity of the state is even."], 
       AtomicDensityMatrix`GFactor[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`GFactor[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`GFactor, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`GFactor -> AtomicDensityMatrix`GFactor[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`GFactor[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`GFactor, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`GFactor, 
        MessageName[AtomicDensityMatrix`GFactor, "usage"], 
        "\!\(\*TagBox[RowBox[{\"GFactor is a parameter for AtomicState that \
specifies the Land\[EAcute] \", SubscriptBox[\"g\", \"J\"], \"\[Hyphen]factor \
for the state, as an alternative to specifying values for L and S for the \
state. \", \"\[LineSeparator]\", \"GFactor[\", StyleBox[\"state\", \"TI\"], \
\"] returns the value specified for GFactor in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or GFactor[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified.\"}], \
DisplayForm]\)"], AtomicDensityMatrix`LevelPosition[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`LevelPosition[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`LevelPosition, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`LevelPosition -> 
          AtomicDensityMatrix`LevelPosition[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`LevelPosition[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`LevelPosition, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`LevelPosition, 
        MessageName[AtomicDensityMatrix`LevelPosition, "usage"], ""], 
       AtomicDensityMatrix`HyperfineA[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = (1834.1880831903954` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = (315.97051918747997` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = (14439.752217894069` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         11565.620623276358` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         4690.292402599044 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         3176.778491309999 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         1224.5928163693013` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = (
         36862.94554239806 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         12356.754281546078` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         4746.80194961831 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         3411.1413032677974` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         1306.2742253626361` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = (
         39486.112576292464` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = (
         8922.123136195012 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 
       0, AtomicDensityMatrix`HyperfineA[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 
       0, AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = (181.26989611213108` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = (38.07610296150829 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = (1450.5352809978547` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = (
         289.1773205776333 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {
          2, "P", 3/2}}] = ((-19.195131113433636`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = (
         2524.282535591937 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = (3.311238656883642 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = (593.3840204100401 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = (116.45255648326645` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = (5565.7276311458045` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = (1269.2034320502764` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (757.293475518434 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (157.092199050104 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = (6358.02315241775 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (2558.7643844958147` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (532.3020344462938 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = (21471.788680034824` 
         Units`Mega)/Units`Second, AtomicDensityMatrix`HyperfineA[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`HyperfineA[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`HyperfineA, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`HyperfineA -> AtomicDensityMatrix`HyperfineA[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`HyperfineA[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`HyperfineA, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`HyperfineA, 
        MessageName[AtomicDensityMatrix`HyperfineA, "usage"], 
        "\!\(\*TagBox[RowBox[{\"HyperfineA is a parameter for AtomicState \
that parameterizes the hyperfine splitting of the state due to the electronic \
interaction with the nuclear magnetic dipole moment.\", \"\[LineSeparator]\", \
\"HyperfineA[\", StyleBox[\"state\", \"TI\"], \"] returns the value specified \
for HyperfineA in AtomicState \", StyleBox[\"state\", \"TI\"], \", or \
HyperfineA[StateLabel[\", StyleBox[\"state\", \"TI\"], \"]] if it is not \
specified.\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`HyperfineB[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = ((-3.100123630562408) 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         35.41264946540644 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = ((
          1349066061 Units`Mega) Pi)/(250000000 Units`Second), 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {
          2, "P", 3/2}}] = ((-182.84069243892597`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = ((
          1349066061 Units`Mega) Pi)/(250000000 Units`Second), 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         6.969510799042757 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {
          2, "P", 3/2}}] = ((-169.01768476313086`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`HyperfineB[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 
       0, AtomicDensityMatrix`HyperfineB[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 
       0, AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = (17.781414419318228` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {
          2, "P", 3/2}}] = ((-1.3885839528866886`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = (0.7916813487046279 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = (17.115396776757194` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (162.04334907216153` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (78.51782519116969 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`HyperfineB[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`HyperfineB, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`HyperfineB -> AtomicDensityMatrix`HyperfineB[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`HyperfineB[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`HyperfineB, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`HyperfineB, 
        MessageName[AtomicDensityMatrix`HyperfineB, "usage"], 
        "\!\(\*TagBox[RowBox[{\"HyperfineB is a parameter for AtomicState \
that parameterizes the hyperfine splitting of the state due to the electronic \
interaction with the nuclear electric quadrupole moment.\", \
\"\[LineSeparator]\", \"HyperfineB[\", StyleBox[\"state\", \"TI\"], \"] \
returns the value specified for HyperfineB in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or HyperfineB[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified.\"}], \
DisplayForm]\)"], AtomicDensityMatrix`Polarizability[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`k, 
          BlankSequence[]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`value}, 
         If[(AtomicDensityMatrix`AtomicSystem`Private`value = ReplaceAll[
             AtomicDensityMatrix`Polarizability[
             AtomicDensityMatrix`AtomicSystem`Private`k], 
             AtomicDensityMatrix`StateParameters[
             AtomicDensityMatrix`AtomicSystem`Private`state]]) =!= 
          AtomicDensityMatrix`Polarizability[
           AtomicDensityMatrix`AtomicSystem`Private`k], 
          AtomicDensityMatrix`AtomicSystem`Private`value, 
          AtomicDensityMatrix`Polarizability[
          AtomicDensityMatrix`AtomicSystem`Private`k][
           AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`AtomicSystem`Private`state]]]], 
       TagSet[AtomicDensityMatrix`Polarizability, 
        MessageName[AtomicDensityMatrix`Polarizability, "usage"], 
        "Polarizability[\!\(\*\nStyleBox[\"k\", \"TI\"]\)] is a parameter \
specified in an AtomicState expression that specifies the scalar (\!\(\*\n\
StyleBox[\"k\", \"TI\"]\)=0), vector (\!\(\*\nStyleBox[\"k\", \"TI\"]\)=1), \
or tensor (\!\(\*\nStyleBox[\"k\", \"TI\"]\)=2) polarizability for the state. \
The value can be numeric or symbolic. \nPolarizability[\!\(\*\n\
StyleBox[\"k\", \"TI\"]\)][\!\(\*\nStyleBox[\"state\", \"TI\"]\)] returns the \
corresponding specified value for the polarizability of AtomicState \!\(\*\n\
StyleBox[\"state\", \"TI\"]\), or Polarizability[\!\(\*\nStyleBox[\"k\", \"TI\
\"]\)][StateLabel[\!\(\*\nStyleBox[\"state\", \"TI\"]\)]] if it is not \
specified."], AtomicDensityMatrix`TransitionPolarizability[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`k, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`value}, 
         Which[(AtomicDensityMatrix`AtomicSystem`Private`value = ReplaceAll[
             AtomicDensityMatrix`TransitionPolarizability[
             AtomicDensityMatrix`AtomicSystem`Private`k][
              AtomicDensityMatrix`StateLabel[
              AtomicDensityMatrix`AtomicSystem`Private`state1]], 
             AtomicDensityMatrix`StateParameters[
             AtomicDensityMatrix`AtomicSystem`Private`state2]]) =!= 
          AtomicDensityMatrix`TransitionPolarizability[
           AtomicDensityMatrix`AtomicSystem`Private`k][
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state1]], 
          AtomicDensityMatrix`AtomicSystem`Private`value, (
           AtomicDensityMatrix`AtomicSystem`Private`value = ReplaceAll[
             AtomicDensityMatrix`TransitionPolarizability[
             AtomicDensityMatrix`AtomicSystem`Private`k][
              AtomicDensityMatrix`StateLabel[
              AtomicDensityMatrix`AtomicSystem`Private`state2]], 
             AtomicDensityMatrix`StateParameters[
             AtomicDensityMatrix`AtomicSystem`Private`state1]]) =!= 
          AtomicDensityMatrix`TransitionPolarizability[
           AtomicDensityMatrix`AtomicSystem`Private`k][
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state2]], 
          AtomicDensityMatrix`AtomicSystem`Private`value, True, 
          AtomicDensityMatrix`TransitionPolarizability[
          AtomicDensityMatrix`AtomicSystem`Private`k][
           Apply[Sequence, 
            Sort[
             Map[
             AtomicDensityMatrix`StateLabel, {
              AtomicDensityMatrix`AtomicSystem`Private`state1, 
               AtomicDensityMatrix`AtomicSystem`Private`state2}]]]]]], 
       TagSet[AtomicDensityMatrix`TransitionPolarizability, 
        MessageName[AtomicDensityMatrix`TransitionPolarizability, "usage"], 
        ""], 
       UpSetDelayed[
        AtomicDensityMatrix`RegionParameters[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]], 
        Rest[
         Apply[List, AtomicDensityMatrix`ExperimentalSystem`Private`reg]]], 
       AtomicDensityMatrix`ExperimentalRegion[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`label, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`rules, 
           BlankNullSequence[Rule]]}] := 
       AtomicDensityMatrix`ExperimentalRegion[
        AtomicDensityMatrix`ExperimentalSystem`Private`label, 
         AtomicDensityMatrix`ExperimentalSystem`Private`rules], 
       TagSet[AtomicDensityMatrix`ExperimentalRegion, 
        MessageName[AtomicDensityMatrix`ExperimentalRegion, "usage"], ""], 
       TagSet[AtomicDensityMatrix`RegionParameters, 
        MessageName[AtomicDensityMatrix`RegionParameters, "usage"], ""], 
       AtomicDensityMatrix`OpticalParameters[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`OpticalParameters[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`OpticalParameters, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`OpticalParameters -> 
          AtomicDensityMatrix`OpticalParameters[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`OpticalParameters[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`OpticalParameters, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`OpticalParameters, 
        MessageName[AtomicDensityMatrix`OpticalParameters, "usage"], ""], 
       Attributes[AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = {
        Temporary}, AtomicDensityMatrix`RegionLabel[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := 
       First[AtomicDensityMatrix`ExperimentalSystem`Private`reg], 
       AtomicDensityMatrix`RegionLabel[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`RegionLabel, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`RegionLabel, 
        MessageName[AtomicDensityMatrix`RegionLabel, "usage"], ""], 
       Attributes[AtomicDensityMatrix`ExperimentalSystem`Private`sys$] = {
        Temporary}, AtomicDensityMatrix`ElectricField[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`ElectricField[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`ElectricField, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`ElectricField -> 
          AtomicDensityMatrix`ElectricField[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`ElectricField[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`ElectricField, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`ElectricField, 
        MessageName[AtomicDensityMatrix`ElectricField, "usage"], 
        "ElectricField is an option for Hamiltonian that specifies the \
applied external electric field."], AtomicDensityMatrix`MagneticField[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`MagneticField[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`MagneticField, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`MagneticField -> 
          AtomicDensityMatrix`MagneticField[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`MagneticField[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`MagneticField, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`MagneticField, 
        MessageName[AtomicDensityMatrix`MagneticField, "usage"], 
        "MagneticField is an option for Hamiltonian that specifies the \
applied external magnetic field."], AtomicDensityMatrix`TransitRate[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg1, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]][
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg2, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := 
       AtomicDensityMatrix`TransitRate[
         AtomicDensityMatrix`RegionLabel[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg1]][
        AtomicDensityMatrix`ExperimentalSystem`Private`reg2], 
       AtomicDensityMatrix`TransitRate[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`label, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := 
       Module[{AtomicDensityMatrix`ExperimentalSystem`Private`value}, 
         If[
         AtomicDensityMatrix`RegionLabel[
           AtomicDensityMatrix`ExperimentalSystem`Private`region] === 
          AtomicDensityMatrix`ExperimentalSystem`Private`label, 0, 
          
          If[(AtomicDensityMatrix`ExperimentalSystem`Private`value = 
            ReplaceAll[
              AtomicDensityMatrix`TransitRate[
              AtomicDensityMatrix`ExperimentalSystem`Private`label], 
              AtomicDensityMatrix`RegionParameters[
              AtomicDensityMatrix`ExperimentalSystem`Private`region]]) =!= 
           AtomicDensityMatrix`TransitRate[
            AtomicDensityMatrix`ExperimentalSystem`Private`label], 
           AtomicDensityMatrix`ExperimentalSystem`Private`value, 
           AtomicDensityMatrix`TransitRate[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`region], 
            AtomicDensityMatrix`ExperimentalSystem`Private`label]]]], 
       TagSet[AtomicDensityMatrix`TransitRate, 
        MessageName[AtomicDensityMatrix`TransitRate, "usage"], ""], 
       AtomicDensityMatrix`Density[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`Density[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`Density, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`Density -> AtomicDensityMatrix`Density[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`Density[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`Density, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`Density, 
        MessageName[AtomicDensityMatrix`Density, "usage"], ""], 
       AtomicDensityMatrix`OperatorQ[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`expr, 
          Blank[]]] := MatchQ[
         AtomicDensityMatrix`TensorType[
         AtomicDensityMatrix`TensorAlgebra`Private`expr], {
          Alternatives["Operator", "OneByOne"]}], 
       TagSet[AtomicDensityMatrix`OperatorQ, 
        MessageName[AtomicDensityMatrix`OperatorQ, "usage"], 
        "OperatorQ[expr] gives True if expr is in the form of a matrix \
operator, i.e., an n x n matrix, and gives False otherwise."], 
       AtomicDensityMatrix`TensorType[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Alternatives[
           Blank[List], 
           Blank[SparseArray]]], 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`default, 
           Blank[List]], {}]] := 
       AtomicDensityMatrix`TensorType[
        AtomicDensityMatrix`TensorAlgebra`Private`a, 
         AtomicDensityMatrix`ListDepth[
         AtomicDensityMatrix`TensorAlgebra`Private`a], 
         AtomicDensityMatrix`TensorAlgebra`Private`default], 
       AtomicDensityMatrix`TensorType[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Alternatives[
           Blank[List], 
           Blank[SparseArray]]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`depth, 
          Blank[Integer]], 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`default, 
           Blank[List]], {}]] := 
       Switch[{AtomicDensityMatrix`TensorAlgebra`Private`depth, 
          Dimensions[AtomicDensityMatrix`TensorAlgebra`Private`a], 
          Map[Dimensions, AtomicDensityMatrix`TensorAlgebra`Private`a]}, {1, 
          Blank[], 
          Blank[]}, {"Cartesian"}, {2, {1, 1}, 
          Blank[]}, {"OneByOne"}, {2, {1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]]}, 
          Blank[]}, {"Covariant"}, {2, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1}, 
          Blank[]}, {"Contravariant"}, {2, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]]}, 
          Blank[]}, {"Operator"}, {3, {1, 1, 1}, 
          Blank[]}, {"TensorDecomposition", "OneByOne"}, 
         Alternatives[{3, {1, 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           Blank[]}, {3, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1}, 
           AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{1, 
             Blank[]}]}], {"TensorDecomposition", "Covariant"}, 
         Alternatives[{3, {1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1}, 
           Blank[]}, {3, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{
             Blank[], 1}]}], {"TensorDecomposition", "Contravariant"}, 
         Alternatives[{3, {1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           Blank[]}, {3, {
            Blank[]}, 
           AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{
             Blank[], 
             Blank[]}]}], {"TensorDecomposition", "Operator"}, {3, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 1}, 
          Blank[]}, {"Cartesian", "OneByOne"}, {3, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]]}, 
          Blank[]}, {"Cartesian", "Covariant"}, {3, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]], 1}, 
          Blank[]}, {"Cartesian", "Contravariant"}, {3, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]]}, 
          Blank[]}, {"Cartesian", "Operator"}, {4, {1, 1, 1, 1}, 
          Blank[]}, {"OneByOne", "OneByOne"}, {4, {1, 1, 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]]}, 
          Blank[]}, {"OneByOne", "Covariant"}, {4, {1, 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1}, 
          Blank[]}, {"OneByOne", "Contravariant"}, {4, {1, 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]]}, 
          Blank[]}, {"OneByOne", "Operator"}, {4, {1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 1}, 
          Blank[]}, {"Covariant", "OneByOne"}, {4, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 1, 1}, 
          Blank[]}, {"Contravariant", "OneByOne"}, {4, {1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]]}, 
          Blank[]}, {"Covariant", "Covariant"}, {4, {1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]], 1}, 
          Blank[]}, {"Covariant", "Contravariant"}, {4, {1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]]}, 
          Blank[]}, {"Covariant", "Operator"}, {4, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]]}, 
          Blank[]}, {"Contravariant", "Covariant"}, {4, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]], 1}, 
          Blank[]}, {"Contravariant", "Contravariant"}, {4, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]]}, 
          Blank[]}, {"Contravariant", "Operator"}, {5, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 1, 1}, 
          Blank[]}, {
         "TensorDecompositionMatrix", "TensorDecomposition", "OneByOne"}, {
         5, {1, 1, 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]]}, 
          Blank[]}, {"TensorDecomposition", "OneByOne", "Operator"}, 
         Alternatives[{5, {1, 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]]}, 
           Blank[]}, {5, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1}, 
           AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{1, 
             Blank[], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
              Blank[]]}]}], {"TensorDecomposition", "Covariant", "Operator"}, 
         
         Alternatives[{5, {1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]]}, 
           Blank[]}, {5, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{
             Blank[], 1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
              Blank[]]}]}], {
         "TensorDecomposition", "Contravariant", "Operator"}, {
          Alternatives[5, 7], 
          Blank[], 
          Blank[]}, 
         Switch[{
           Dimensions[AtomicDensityMatrix`TensorAlgebra`Private`a], 
           Flatten[
            ReplaceAll[
             Map[
             AtomicDensityMatrix`TensorType[#, 
               AtomicDensityMatrix`TensorAlgebra`Private`depth - 2, 
               AtomicDensityMatrix`TensorAlgebra`Private`default]& , 
              AtomicDensityMatrix`TensorAlgebra`Private`a, {2}], 
             AtomicDensityMatrix`TensorAlgebra`Private`assumeDecomposition], \
{{3}, {1, 2}}]}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated["OneByOne"]}, {
             Repeated["Operator"]}}}, {
          "TensorDecompositionMatrix", "TensorDecomposition", "OneByOne", 
           "Operator"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Covariant", "OneByOne"]]}}}, {
          "TensorDecompositionMatrix", "TensorDecomposition", "Covariant"}, {{
           
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Covariant", "OneByOne"]]}, {
             Repeated["Operator"]}}}, {
          "TensorDecompositionMatrix", "TensorDecomposition", "Covariant", 
           "Operator"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Contravariant", "OneByOne"]]}}}, {
          "TensorDecompositionMatrix", "TensorDecomposition", 
           "Contravariant"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Contravariant", "OneByOne"]]}, {
             Repeated["Operator"]}}}, {
          "TensorDecompositionMatrix", "TensorDecomposition", "Contravariant",
            "Operator"}, {{1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated["OneByOne"]}}}, {
          "Covariant", "TensorDecomposition", "OneByOne"}, {{1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Covariant", "OneByOne"]]}}}, {
          "Covariant", "TensorDecomposition", "Covariant"}, {{1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Contravariant", "OneByOne"]]}}}, {
          "Covariant", "TensorDecomposition", "Contravariant"}, {{1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecompositionMatrix"]}, {
             Repeated["TensorDecomposition"]}, {
             Repeated["OneByOne"]}}}, {
          "Covariant", "TensorDecompositionMatrix", "TensorDecomposition", 
           "OneByOne"}, {{1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecompositionMatrix"]}, {
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Covariant", "OneByOne"]]}}}, {
          "Covariant", "TensorDecompositionMatrix", "TensorDecomposition", 
           "Covariant"}, {{1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecompositionMatrix"]}, {
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Contravariant", "OneByOne"]]}}}, {
          "Covariant", "TensorDecompositionMatrix", "TensorDecomposition", 
           "Contravariant"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated["OneByOne"]}}}, {
          "Contravariant", "TensorDecomposition", "OneByOne"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Covariant", "OneByOne"]]}}}, {
          "Contravariant", "TensorDecomposition", "Covariant"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Contravariant", "OneByOne"]]}}}, {
          "Contravariant", "TensorDecomposition", "Contravariant"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            BlankNullSequence[]}, {{
             Repeated["TensorDecompositionMatrix"]}, {
             Repeated["TensorDecomposition"]}, {
             Repeated["OneByOne"]}}}, {
          "Contravariant", "TensorDecompositionMatrix", "TensorDecomposition",
            "OneByOne"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            BlankNullSequence[]}, {{
             Repeated["TensorDecompositionMatrix"]}, {
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Covariant", "OneByOne"]]}}}, {
          "Contravariant", "TensorDecompositionMatrix", "TensorDecomposition",
            "Covariant"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            BlankNullSequence[]}, {{
             Repeated["TensorDecompositionMatrix"]}, {
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Contravariant", "OneByOne"]]}}}, {
          "Contravariant", "TensorDecompositionMatrix", "TensorDecomposition",
            "Contravariant"}, 
          Blank[], 
          If[AtomicDensityMatrix`TensorAlgebra`Private`default === {}, 
            Message[
             MessageName[AtomicDensityMatrix`TensorType, "unrec"], 
             AtomicDensityMatrix`TensorAlgebra`Private`a]]; 
          AtomicDensityMatrix`TensorAlgebra`Private`default], 
         Blank[], If[AtomicDensityMatrix`TensorAlgebra`Private`default === {}, 
           Message[
            MessageName[AtomicDensityMatrix`TensorType, "unrec"], 
            AtomicDensityMatrix`TensorAlgebra`Private`a]]; 
         AtomicDensityMatrix`TensorAlgebra`Private`default], 
       AtomicDensityMatrix`TensorType[
         Blank[], 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`default, 
           Blank[List]], {}]] := {"Scalar"}, 
       TagSet[AtomicDensityMatrix`TensorType, 
        MessageName[AtomicDensityMatrix`TensorType, "unrec"], 
        "The expression `1` does not have a recognized tensor structure."], 
       TagSet[AtomicDensityMatrix`TensorType, 
        MessageName[AtomicDensityMatrix`TensorType, "usage"], ""], 
       AtomicDensityMatrix`ListDepth[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[SparseArray]]] := 
       ArrayDepth[AtomicDensityMatrix`TensorAlgebra`Private`a], 
       AtomicDensityMatrix`ListDepth[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[List]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`i = 0, 
          AtomicDensityMatrix`TensorAlgebra`Private`depths}, While[
           AtomicDensityMatrix`TensorAlgebra`Private`matchAtLevel[
           AtomicDensityMatrix`TensorAlgebra`Private`a, 
            Blank[List], AtomicDensityMatrix`TensorAlgebra`Private`i], 
           Increment[AtomicDensityMatrix`TensorAlgebra`Private`i]]; Which[
           And[
            AtomicDensityMatrix`TensorAlgebra`Private`matchAtLevel[
            AtomicDensityMatrix`TensorAlgebra`Private`a, 
             Blank[SparseArray], AtomicDensityMatrix`TensorAlgebra`Private`i], 
            MatchQ[
            AtomicDensityMatrix`TensorAlgebra`Private`depths = Flatten[
               Map[
               AtomicDensityMatrix`ListDepth, 
                AtomicDensityMatrix`TensorAlgebra`Private`a, {
                AtomicDensityMatrix`TensorAlgebra`Private`i}]], {
              Repeated[
               Pattern[AtomicDensityMatrix`TensorAlgebra`Private`x, 
                Blank[Integer]]]}]], 
           AtomicDensityMatrix`TensorAlgebra`Private`i + 
           First[AtomicDensityMatrix`TensorAlgebra`Private`depths], 
           AtomicDensityMatrix`TensorAlgebra`Private`matchAtLevel[
           AtomicDensityMatrix`TensorAlgebra`Private`a, 
            Except[
             Alternatives[
              Blank[List], 
              Blank[SparseArray]]], 
            AtomicDensityMatrix`TensorAlgebra`Private`i], 
           AtomicDensityMatrix`TensorAlgebra`Private`i, True, Indeterminate]],
        AtomicDensityMatrix`ListDepth[
         Blank[]] := 0, 
       TagSet[AtomicDensityMatrix`ListDepth, 
        MessageName[AtomicDensityMatrix`ListDepth, "usage"], ""], 
       AtomicDensityMatrix`TensorAlgebra`Private`matchAtLevel[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`expr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`patt, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`level, 
          Blank[]]] := 
       MatchQ[AtomicDensityMatrix`TensorAlgebra`Private`expr, 
         Nest[{
           Repeated[#]}& , AtomicDensityMatrix`TensorAlgebra`Private`patt, 
          AtomicDensityMatrix`TensorAlgebra`Private`level]], 
       AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`dims, 
          Blank[]]] := 
       With[{AtomicDensityMatrix`TensorAlgebra`Private`index = Flatten[
            Position[AtomicDensityMatrix`TensorAlgebra`Private`dims, 
             Verbatim[
              Blank[]], {1}, 1, Heads -> False]]}, 
         HoldPattern[
          Condition[
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`expr, {
             Repeated[AtomicDensityMatrix`TensorAlgebra`Private`dims]}], 
           And[
            Apply[And, 
             OddQ[
              Part[
              AtomicDensityMatrix`TensorAlgebra`Private`expr, 1, 
               AtomicDensityMatrix`TensorAlgebra`Private`index]]], 
            Or[Length[AtomicDensityMatrix`TensorAlgebra`Private`expr] == 1, 
             MatchQ[
              Differences[
               Part[
               AtomicDensityMatrix`TensorAlgebra`Private`expr, All, 
                AtomicDensityMatrix`TensorAlgebra`Private`index]], {
               Repeated[{
                 Repeated[2]}]}]]]]]], 
       AtomicDensityMatrix`TensorAlgebra`Private`assumeDecomposition = {
         "TensorDecompositionMatrix", "TensorDecomposition", "OneByOne"} -> {
         "TensorDecomposition", "OneByOne", "Operator"}, 
       TagSet[AtomicDensityMatrix`ExtraArrows, 
        MessageName[AtomicDensityMatrix`ExtraArrows, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`subscripts = {
        True, True, False}, 
       TagSet[AtomicDensityMatrix`QuantumNumberSubscripts, 
        MessageName[AtomicDensityMatrix`QuantumNumberSubscripts, "usage"], 
        ""], AtomicDensityMatrix`LevelDiagram`Private`findLevelPositions[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`spacing, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`parityOffsetValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelOffsetValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`pos, 
          AtomicDensityMatrix`LevelDiagram`Private`xmin, 
          AtomicDensityMatrix`LevelDiagram`Private`xmax, 
          AtomicDensityMatrix`LevelDiagram`Private`width, 
          AtomicDensityMatrix`LevelDiagram`Private`ymin, 
          AtomicDensityMatrix`LevelDiagram`Private`ymax, 
          AtomicDensityMatrix`LevelDiagram`Private`height}, 
         AtomicDensityMatrix`LevelDiagram`Private`pos = ReplaceAll[
            
            Transpose[{(AtomicDensityMatrix`LevelDiagram`Private`length + 
               AtomicDensityMatrix`LevelDiagram`Private`spacing) 
              Map[AtomicDensityMatrix`M, 
                AtomicDensityMatrix`LevelDiagram`Private`sys], 
              ReplaceAll[
               ReplaceAll[
                Diagonal[AtomicDensityMatrix`LevelDiagram`Private`h], 
                Thread[
                Map[AtomicDensityMatrix`Energy, 
                   AtomicDensityMatrix`LevelDiagram`Private`statelabels] -> 
                 Range[
                    Length[
                    AtomicDensityMatrix`LevelDiagram`Private`statelabels]] - 
                  1]], {AtomicDensityMatrix`HyperfineA[
                  Blank[]] -> 0.2, AtomicDensityMatrix`HyperfineB[
                  Blank[]] -> 0.05}]}], AtomicDensityMatrix`M[
              Blank[]] -> 0]; If[
           And[
            AtomicDensityMatrix`DefinedQ[
            AtomicDensityMatrix`LevelDiagram`Private`sys, 
             AtomicDensityMatrix`Parity], 
            Or[
             NumericQ[
             AtomicDensityMatrix`LevelDiagram`Private`parityOffsetValue], 
             ReplaceAll[
             AtomicDensityMatrix`LevelDiagram`Private`parityOffsetValue, 
              Automatic -> 
              And[Length[
                 AtomicDensityMatrix`LevelDiagram`Private`statelabels] > 2, 
                AtomicDensityMatrix`AtomicSystemType[
                 AtomicDensityMatrix`LevelDiagram`Private`sys] != 
                "HyperfineZeeman"]]]], 
           AtomicDensityMatrix`LevelDiagram`Private`width = -Apply[Subtract, 
               AtomicDensityMatrix`LevelDiagram`Private`xMinMax[
               AtomicDensityMatrix`LevelDiagram`Private`pos, 
                AtomicDensityMatrix`LevelDiagram`Private`length]]; 
           AddTo[AtomicDensityMatrix`LevelDiagram`Private`pos, 
             Thread[{
               
               ReplaceAll[(((AtomicDensityMatrix`LevelDiagram`Private`width + 
                   AtomicDensityMatrix`LevelDiagram`Private`spacing) 
                  AtomicDensityMatrix`LevelDiagram`Private`parityOffsetValue) 
                 AtomicDensityMatrix`Parity[
                  AtomicDensityMatrix`LevelDiagram`Private`sys])/2, {
                Alternatives[True, Automatic] -> 1, 
                 AtomicDensityMatrix`Even -> -1, AtomicDensityMatrix`Odd -> 
                 1}], 0}]]; Null]; 
         AddTo[AtomicDensityMatrix`LevelDiagram`Private`pos, 
           Thread[{
             AtomicDensityMatrix`LevelDiagram`Private`levelOffsetList[
             AtomicDensityMatrix`LevelDiagram`Private`sys, 
              AtomicDensityMatrix`LevelDiagram`Private`levelOffsetValue], 
             0}]]; {AtomicDensityMatrix`LevelDiagram`Private`xmin, 
            AtomicDensityMatrix`LevelDiagram`Private`xmax} = 
          AtomicDensityMatrix`LevelDiagram`Private`xMinMax[
           AtomicDensityMatrix`LevelDiagram`Private`pos, 
            AtomicDensityMatrix`LevelDiagram`Private`length]; 
         AtomicDensityMatrix`LevelDiagram`Private`width = 
          AtomicDensityMatrix`LevelDiagram`Private`xmax - 
           AtomicDensityMatrix`LevelDiagram`Private`xmin; {
           AtomicDensityMatrix`LevelDiagram`Private`ymin, 
            AtomicDensityMatrix`LevelDiagram`Private`ymax} = 
          AtomicDensityMatrix`LevelDiagram`Private`yMinMax[
           AtomicDensityMatrix`LevelDiagram`Private`pos]; 
         AtomicDensityMatrix`LevelDiagram`Private`height = 
          AtomicDensityMatrix`LevelDiagram`Private`ymax - 
           AtomicDensityMatrix`LevelDiagram`Private`ymin; {
          AtomicDensityMatrix`LevelDiagram`Private`pos, 
           AtomicDensityMatrix`LevelDiagram`Private`xmin, 
           AtomicDensityMatrix`LevelDiagram`Private`xmax, 
           AtomicDensityMatrix`LevelDiagram`Private`width, 
           AtomicDensityMatrix`LevelDiagram`Private`ymin, 
           AtomicDensityMatrix`LevelDiagram`Private`ymax, 
           AtomicDensityMatrix`LevelDiagram`Private`height}], 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0]] = "Fine", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1]] = "Fine", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = "Zeeman", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       "Zeeman", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       "Zeeman", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = "Zeeman", AtomicDensityMatrix`AtomicSystemType[{
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NaturalWidth -> 0, 
           AtomicDensityMatrix`M -> -1], 
          AtomicDensityMatrix`AtomicState[
          2, AtomicDensityMatrix`J -> 0, 
           AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
           AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
           0]}] = "Zeeman", AtomicDensityMatrix`AtomicSystemType[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`noMessage = True, 
          AtomicDensityMatrix`AtomicSystem`Private`result}, 
         AtomicDensityMatrix`AtomicSystem`Private`result = Check[
            
            Module[{AtomicDensityMatrix`AtomicSystem`Private`fDefined, 
              AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
              AtomicDensityMatrix`AtomicSystem`Private`mDefined}, {
               AtomicDensityMatrix`AtomicSystem`Private`fDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`mDefined} = 
              Map[AtomicDensityMatrix`AtomicSystem`Private`\
ValidQuantumNumberQ[AtomicDensityMatrix`AtomicSystem`Private`s, #]& , {
                AtomicDensityMatrix`F, AtomicDensityMatrix`J, 
                 AtomicDensityMatrix`M}]; Which[
               And[
               AtomicDensityMatrix`AtomicSystem`Private`fDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`mDefined], 
               "HyperfineZeeman", 
               And[
               AtomicDensityMatrix`AtomicSystem`Private`fDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                Not[AtomicDensityMatrix`AtomicSystem`Private`mDefined]], 
               "Hyperfine", 
               And[
                Not[AtomicDensityMatrix`AtomicSystem`Private`fDefined], 
                AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`mDefined], "Zeeman", 
               
               And[AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                Not[AtomicDensityMatrix`AtomicSystem`Private`mDefined]], 
               "Fine", 
               And[
                Not[AtomicDensityMatrix`AtomicSystem`Private`jDefined], 
                Not[AtomicDensityMatrix`AtomicSystem`Private`mDefined]], 
               "Toy", True, 
               Message[
                MessageName[AtomicDensityMatrix`AtomicSystemType, "unrec"], 
                AtomicDensityMatrix`AtomicSystem`Private`s]]], 
            AtomicDensityMatrix`AtomicSystem`Private`noMessage = False]; 
         Condition[
          AtomicDensityMatrix`AtomicSystemType[
            AtomicDensityMatrix`AtomicSystem`Private`s] = 
           AtomicDensityMatrix`AtomicSystem`Private`result, 
           AtomicDensityMatrix`AtomicSystem`Private`noMessage]], 
       AtomicDensityMatrix`AtomicSystemType[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`noMessage = True, 
          AtomicDensityMatrix`AtomicSystem`Private`result}, 
         AtomicDensityMatrix`AtomicSystem`Private`result = Check[
            
            With[{AtomicDensityMatrix`AtomicSystem`Private`types = 
              Map[AtomicDensityMatrix`AtomicSystemType, 
                AtomicDensityMatrix`AtomicSystem`Private`sys]}, 
             If[
              MatchQ[
               Hold[AtomicDensityMatrix`AtomicSystem`Private`types], 
               Hold[{
                 Repeated[
                  Blank[String]]}]], 
              If[
               MatchQ[AtomicDensityMatrix`AtomicSystem`Private`types, {
                 Repeated[
                  First[AtomicDensityMatrix`AtomicSystem`Private`types]]}], 
               First[AtomicDensityMatrix`AtomicSystem`Private`types], 
               Message[
                MessageName[
                AtomicDensityMatrix`AtomicSystemType, "difftypes"], 
                First[AtomicDensityMatrix`AtomicSystem`Private`types]]]]], 
            AtomicDensityMatrix`AtomicSystem`Private`noMessage = False]; 
         Condition[
          AtomicDensityMatrix`AtomicSystemType[
            AtomicDensityMatrix`AtomicSystem`Private`sys] = 
           AtomicDensityMatrix`AtomicSystem`Private`result, 
           AtomicDensityMatrix`AtomicSystem`Private`noMessage]], 
       TagSet[AtomicDensityMatrix`AtomicSystemType, 
        MessageName[AtomicDensityMatrix`AtomicSystemType, "difftypes"], 
        "All atomic states in the system are not of the same type, `1`, as \
the first state."], 
       TagSet[AtomicDensityMatrix`AtomicSystemType, 
        MessageName[AtomicDensityMatrix`AtomicSystemType, "unrec"], 
        "The type of the atomic state `1` is not recognized."], 
       TagSet[AtomicDensityMatrix`AtomicSystemType, 
        MessageName[AtomicDensityMatrix`AtomicSystemType, "usage"], 
        "\!\(\*TagBox[RowBox[{\"AtomicSystemType[\", StyleBox[\"sys\", \
\"TI\"], \"] determines the type of atomic system \", StyleBox[\"sys\", \
\"TI\"], \".\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`AtomicSystem`Private`ValidQuantumNumberQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`j, 
          Blank[]]] := And[
         AtomicDensityMatrix`DefinedQ[
         AtomicDensityMatrix`AtomicSystem`Private`s, 
          AtomicDensityMatrix`AtomicSystem`Private`j], 
         AtomicDensityMatrix`HalfIntegerQ[
          AtomicDensityMatrix`AtomicSystem`Private`j[
          AtomicDensityMatrix`AtomicSystem`Private`s]]], 
       AtomicDensityMatrix`HalfIntegerQ[
         Pattern[AtomicDensityMatrix`Common`Private`x, 
          Blank[]]] := IntegerQ[2 AtomicDensityMatrix`Common`Private`x], 
       TagSet[AtomicDensityMatrix`HalfIntegerQ, 
        MessageName[AtomicDensityMatrix`HalfIntegerQ, "usage"], 
        "HalfIntegerQ[expr] gives True if expr is integer or half-integer, \
and False otherwise."], AtomicDensityMatrix`LevelDiagram`Private`xMinMax[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]]] := {Min[
           Part[AtomicDensityMatrix`LevelDiagram`Private`pos, All, 1]] - 
         AtomicDensityMatrix`LevelDiagram`Private`length/2, Max[
           Part[AtomicDensityMatrix`LevelDiagram`Private`pos, All, 1]] + 
         AtomicDensityMatrix`LevelDiagram`Private`length/2}, 
       AtomicDensityMatrix`LevelDiagram`Private`levelOffsetList[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelOffsetValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`offsetVal = 
          Flatten[{
            AtomicDensityMatrix`LevelDiagram`Private`levelOffsetValue}]}, 
         Switch[AtomicDensityMatrix`LevelDiagram`Private`offsetVal, 
          Alternatives[{}, {None}], 
          ConstantArray[0, 
           Length[AtomicDensityMatrix`LevelDiagram`Private`sys]], {
           Repeated[
            PatternTest[
             Blank[], NumericQ]]}, 
          PadRight[{}, 
           Length[AtomicDensityMatrix`LevelDiagram`Private`sys], 
           AtomicDensityMatrix`LevelDiagram`Private`offsetVal], {
           Repeated[
            Blank[Rule]]}, 
          Total[
           Apply[Boole[
              AtomicDensityMatrix`StateMatchQ[
              AtomicDensityMatrix`LevelDiagram`Private`sys, #]] 
            AtomicDensityMatrix`StateEvaluate[
             AtomicDensityMatrix`LevelDiagram`Private`sys, #2]& , 
            AtomicDensityMatrix`LevelDiagram`Private`offsetVal, {1}]]]], 
       Condition[
         AtomicDensityMatrix`StateMatchQ[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
           Blank[AtomicDensityMatrix`AtomicState]], 
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
           Blank[]]], 
         AtomicDensityMatrix`StateLabelQ[
         AtomicDensityMatrix`AtomicSystem`Private`state, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]] := True, 
       AtomicDensityMatrix`StateMatchQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]]] := TrueQ[
         AtomicDensityMatrix`StateEvaluate[
         AtomicDensityMatrix`AtomicSystem`Private`state, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]], 
       AtomicDensityMatrix`StateMatchQ[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]]] := 
       Map[AtomicDensityMatrix`StateMatchQ[#, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]& , 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`StateMatchQ, 
        MessageName[AtomicDensityMatrix`StateMatchQ, "usage"], ""], 
       AtomicDensityMatrix`StateLabelQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       AtomicDensityMatrix`StateLabel[
         AtomicDensityMatrix`AtomicSystem`Private`state] === 
        AtomicDensityMatrix`AtomicSystem`Private`expr, 
       AtomicDensityMatrix`StateLabelQ[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := MemberQ[
         AtomicDensityMatrix`StateLabel[
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
         AtomicDensityMatrix`AtomicSystem`Private`expr], 
       TagSet[AtomicDensityMatrix`StateLabelQ, 
        MessageName[AtomicDensityMatrix`StateLabelQ, "usage"], ""], 
       AtomicDensityMatrix`StateEvaluate[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`AtomicSystem`Private`expr, 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`param, 
           Alternatives[
            AtomicDensityMatrix`StateParameterPattern[], 
            AtomicDensityMatrix`StateLabel]] :> 
         AtomicDensityMatrix`AtomicSystem`Private`param[
          AtomicDensityMatrix`AtomicSystem`Private`state]], 
       AtomicDensityMatrix`StateEvaluate[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       Map[AtomicDensityMatrix`StateEvaluate[#, 
          AtomicDensityMatrix`AtomicSystem`Private`expr]& , 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`StateEvaluate, 
        MessageName[AtomicDensityMatrix`StateEvaluate, "usage"], ""], 
       AtomicDensityMatrix`StateParameterPattern[] := 
       Alternatives[
        AtomicDensityMatrix`S, AtomicDensityMatrix`L, AtomicDensityMatrix`J, 
         AtomicDensityMatrix`NuclearSpin, AtomicDensityMatrix`F, 
         AtomicDensityMatrix`M, AtomicDensityMatrix`Parity, 
         AtomicDensityMatrix`Energy, AtomicDensityMatrix`NaturalWidth, 
         AtomicDensityMatrix`GFactor, 
         AtomicDensityMatrix`BranchingRatio[
          Blank[]], AtomicDensityMatrix`LevelPosition, 
         AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
         AtomicDensityMatrix`Polarizability[
          Blank[]], 
         AtomicDensityMatrix`TransitionPolarizability[
          Blank[]]], 
       TagSet[AtomicDensityMatrix`StateParameterPattern, 
        MessageName[AtomicDensityMatrix`StateParameterPattern, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`yMinMax[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]]] := {
         Min[
          Part[AtomicDensityMatrix`LevelDiagram`Private`pos, All, 2]], 
         Max[
          Part[AtomicDensityMatrix`LevelDiagram`Private`pos, All, 2]]}, 
       TagSet[AtomicDensityMatrix`LevelLength, 
        MessageName[AtomicDensityMatrix`LevelLength, "usage"], ""], 
       TagSet[AtomicDensityMatrix`LevelSpacing, 
        MessageName[AtomicDensityMatrix`LevelSpacing, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ParityOffset, 
        MessageName[AtomicDensityMatrix`ParityOffset, "usage"], ""], 
       TagSet[AtomicDensityMatrix`LevelOffset, 
        MessageName[AtomicDensityMatrix`LevelOffset, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`makeLevels[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelStyle, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`levels, 
          AtomicDensityMatrix`LevelDiagram`Private`levsty}, 
         AtomicDensityMatrix`LevelDiagram`Private`levsty = (Replace[
            AtomicDensityMatrix`EnsureList[#], {} -> {{}}]& )[
           AtomicDensityMatrix`LevelDiagram`Private`levelStyle]; 
         AtomicDensityMatrix`LevelDiagram`Private`levels = 
          Map[Line[{#, #} + 
             AtomicDensityMatrix`LevelDiagram`Private`length {{(-1)/2, 0}, {
                1/2, 0}}]& , AtomicDensityMatrix`LevelDiagram`Private`pos]; 
         AtomicDensityMatrix`LevelDiagram`Private`levsty = 
          PadRight[AtomicDensityMatrix`LevelDiagram`Private`levsty, 
            Length[AtomicDensityMatrix`LevelDiagram`Private`levels], 
            AtomicDensityMatrix`LevelDiagram`Private`levsty]; 
         AtomicDensityMatrix`LevelDiagram`Private`levels = 
          ReplacePart[
           AtomicDensityMatrix`LevelDiagram`Private`levels, 
            Position[AtomicDensityMatrix`LevelDiagram`Private`levsty, 
              Alternatives[None, False]] -> {}]; 
         AtomicDensityMatrix`LevelDiagram`Private`levsty = 
          ReplaceAll[
           AtomicDensityMatrix`LevelDiagram`Private`levsty, 
            Alternatives[None, False] -> {}]; 
         Transpose[{
           AtomicDensityMatrix`LevelDiagram`Private`levsty, 
            AtomicDensityMatrix`LevelDiagram`Private`levels}]], 
       AtomicDensityMatrix`EnsureList[
         Pattern[AtomicDensityMatrix`PlotAndFit`Private`expr, 
          Blank[]]] := 
       If[Head[AtomicDensityMatrix`PlotAndFit`Private`expr] === List, 
         AtomicDensityMatrix`PlotAndFit`Private`expr, {
         AtomicDensityMatrix`PlotAndFit`Private`expr}], 
       TagSet[AtomicDensityMatrix`EnsureList, 
        MessageName[AtomicDensityMatrix`EnsureList, "usage"], ""], 
       TagSet[AtomicDensityMatrix`LevelStyle, 
        MessageName[AtomicDensityMatrix`LevelStyle, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`makeMLabels[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`ymin, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`ymax, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`height, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`mLabelValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`mLabelPositionValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`m, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`msub, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`labelStyleValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`mlabopt, 
          AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, 
          AtomicDensityMatrix`LevelDiagram`Private`mlabtext, 
          AtomicDensityMatrix`LevelDiagram`Private`shortPos, 
          AtomicDensityMatrix`LevelDiagram`Private`dupPos}, If[
           MatchQ[AtomicDensityMatrix`LevelDiagram`Private`mLabelValue, 
            Alternatives[False, None]], 
           Return[{}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`mlabopt = PadRight[{}, 
            Length[AtomicDensityMatrix`LevelDiagram`Private`sys], 
            Replace[
            AtomicDensityMatrix`LevelDiagram`Private`mLabelValue, All -> 
             True]]; AtomicDensityMatrix`LevelDiagram`Private`mlabelpos = 
          PadRight[{}, 
            Length[AtomicDensityMatrix`LevelDiagram`Private`sys], 
            AtomicDensityMatrix`LevelDiagram`Private`mLabelPositionValue]; 
         AtomicDensityMatrix`LevelDiagram`Private`mlabelpos = Map[If[
             ListQ[#], #, {#, {0, 0}}]& , 
            AtomicDensityMatrix`LevelDiagram`Private`mlabelpos]; 
         AtomicDensityMatrix`LevelDiagram`Private`mlabelpos = MapThread[Switch[
              Part[#, 1], Top, {{
                Part[#2, 1], AtomicDensityMatrix`LevelDiagram`Private`ymax}, 
               1}, Bottom, {{
                Part[#2, 1], 
                AtomicDensityMatrix`LevelDiagram`Private`ymin}, -1}, 
              Above, {#2, 1}, Below, {#2, -1}, Automatic, {#2, 
               If[
               Part[#2, 2] > 
                AtomicDensityMatrix`LevelDiagram`Private`height/2, 1, -1]}] + {
              Part[#, 2], 0}& , {
            AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, 
             AtomicDensityMatrix`LevelDiagram`Private`pos}]; 
         AtomicDensityMatrix`LevelDiagram`Private`mlabtext = MapThread[If[
             Not[
              AtomicDensityMatrix`DefinedQ[#2, AtomicDensityMatrix`M]], "", 
             Switch[#, 
              Alternatives[True, Automatic, Short, "Short"], 
              AtomicDensityMatrix`QN[#2, 
                AtomicDensityMatrix`LevelDiagram`Private`m, 
                AtomicDensityMatrix`LevelDiagram`Private`msub, 
                AtomicDensityMatrix`LevelDiagram`Private`statelabels] == 
              AtomicDensityMatrix`M[#2], "Bare", 
              AtomicDensityMatrix`M[#2], 
              Alternatives[False, None], "", 
              Blank[], #]]& , {
            AtomicDensityMatrix`LevelDiagram`Private`mlabopt, 
             AtomicDensityMatrix`LevelDiagram`Private`sys}]; 
         AtomicDensityMatrix`LevelDiagram`Private`dupPos = SortBy[
            Range[
             Length[AtomicDensityMatrix`LevelDiagram`Private`mlabelpos]], {
             Part[AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, #], 
             AtomicDensityMatrix`F[
              Part[AtomicDensityMatrix`LevelDiagram`Private`sys, #]]}& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`dupPos = Flatten[
            Map[Most, 
             SplitBy[
             AtomicDensityMatrix`LevelDiagram`Private`dupPos, Part[
              AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, #]& ]]]; 
         Part[AtomicDensityMatrix`LevelDiagram`Private`mlabtext, 
            AtomicDensityMatrix`LevelDiagram`Private`dupPos] = ""; 
         AtomicDensityMatrix`LevelDiagram`Private`shortPos = Flatten[
            Position[
            AtomicDensityMatrix`LevelDiagram`Private`mlabopt 
             AtomicDensityMatrix`LevelDiagram`Private`mlabtext, 
             Alternatives[Short Except[""], "Short" Except[""]]]]; 
         AtomicDensityMatrix`LevelDiagram`Private`shortPos = 
          SortBy[AtomicDensityMatrix`LevelDiagram`Private`shortPos, Reverse[
             Flatten[
              Part[
              AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, #]]]& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`shortPos = Flatten[
            Map[Rest, 
             SplitBy[AtomicDensityMatrix`LevelDiagram`Private`shortPos, Most[
               Reverse[
                Flatten[
                 Part[
                 AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, #]]]]& \
]]]; Part[AtomicDensityMatrix`LevelDiagram`Private`mlabtext, 
            AtomicDensityMatrix`LevelDiagram`Private`shortPos] = Part[
            AtomicDensityMatrix`M[
            AtomicDensityMatrix`LevelDiagram`Private`sys], 
            AtomicDensityMatrix`LevelDiagram`Private`shortPos]; Union[
           If[
           Union[AtomicDensityMatrix`LevelDiagram`Private`mlabtext] === {
             ""}, {}, 
            MapThread[Text[
              
              Style[#2, "InlineMath", Background -> None, 
               AtomicDensityMatrix`LevelDiagram`Private`labelStyleValue], 
              First[#], {
               If[
                And[#3 === Short, Head[#2] === Equal], 0.75, 0], 0.1 - 1.3 
               Part[#, 2]}]& , {
             AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, 
              AtomicDensityMatrix`LevelDiagram`Private`mlabtext, 
              AtomicDensityMatrix`LevelDiagram`Private`mlabopt}]]]], 
       AtomicDensityMatrix`QN[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`state, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sym, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sub, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`labs, 
          Blank[]]] := 
       Which[AtomicDensityMatrix`LevelDiagram`Private`sub === True, 
         Subscript[AtomicDensityMatrix`LevelDiagram`Private`sym, 
          AtomicDensityMatrix`StateLabel[
          AtomicDensityMatrix`LevelDiagram`Private`state]], 
         AtomicDensityMatrix`LevelDiagram`Private`sub === Primes, 
         Derivative[Part[
            Position[AtomicDensityMatrix`LevelDiagram`Private`labs, 
             AtomicDensityMatrix`StateLabel[
             AtomicDensityMatrix`LevelDiagram`Private`state], {1}, 1, Heads -> 
             False], 1, 1] - 1][AtomicDensityMatrix`LevelDiagram`Private`sym],
          True, AtomicDensityMatrix`LevelDiagram`Private`sym], 
       TagSet[AtomicDensityMatrix`QN, 
        MessageName[AtomicDensityMatrix`QN, "usage"], ""], 
       Attributes[Subscript] = {NHoldRest}, 
       Attributes[Derivative] = {NHoldAll, ReadProtected}, 
       TagSet[AtomicDensityMatrix`MLabel, 
        MessageName[AtomicDensityMatrix`MLabel, "usage"], ""], 
       TagSet[AtomicDensityMatrix`MLabelPosition, 
        MessageName[AtomicDensityMatrix`MLabelPosition, "usage"], ""], 
       TagSet[AtomicDensityMatrix`QuantumNumberSymbols, 
        MessageName[AtomicDensityMatrix`QuantumNumberSymbols, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`makeJFLabels[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`xmin, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`xmax, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSymbolsValue, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`\
quantumNumberSubscriptsValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`labelStyleValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelSpacingValue, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`minLabelSpacingValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`fLabelValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`jLabelValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`mLabelValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`stateLabelValue, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`stateLabelPositionValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`j, 
          AtomicDensityMatrix`LevelDiagram`Private`f, 
          AtomicDensityMatrix`LevelDiagram`Private`m, 
          AtomicDensityMatrix`LevelDiagram`Private`jsub, 
          AtomicDensityMatrix`LevelDiagram`Private`fsub, 
          AtomicDensityMatrix`LevelDiagram`Private`msub, 
          AtomicDensityMatrix`LevelDiagram`Private`fstates, 
          AtomicDensityMatrix`LevelDiagram`Private`flabeltext, 
          AtomicDensityMatrix`LevelDiagram`Private`jstates, 
          AtomicDensityMatrix`LevelDiagram`Private`jlabeltext, 
          AtomicDensityMatrix`LevelDiagram`Private`statelabeltext, 
          AtomicDensityMatrix`LevelDiagram`Private`labeltext, 
          AtomicDensityMatrix`LevelDiagram`Private`positions, 
          AtomicDensityMatrix`LevelDiagram`Private`labelpos, 
          AtomicDensityMatrix`LevelDiagram`Private`statepos}, {
           AtomicDensityMatrix`LevelDiagram`Private`j, 
            AtomicDensityMatrix`LevelDiagram`Private`f, 
            AtomicDensityMatrix`LevelDiagram`Private`m} = 
          AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSymbolsValue; \
{AtomicDensityMatrix`LevelDiagram`Private`jsub, 
            AtomicDensityMatrix`LevelDiagram`Private`fsub, 
            AtomicDensityMatrix`LevelDiagram`Private`msub} = 
          AtomicDensityMatrix`LevelDiagram`Private`\
quantumNumberSubscriptsValue; 
         AtomicDensityMatrix`LevelDiagram`Private`fstates = 
          Union[AtomicDensityMatrix`LevelDiagram`Private`sys, 
            SameTest -> (And[
             AtomicDensityMatrix`StateLabel[#] === 
              AtomicDensityMatrix`StateLabel[#2], AtomicDensityMatrix`F[#] === 
              AtomicDensityMatrix`F[#2]]& )]; 
         AtomicDensityMatrix`LevelDiagram`Private`flabeltext = If[
            And[
            AtomicDensityMatrix`AtomicSystemType[
              AtomicDensityMatrix`LevelDiagram`Private`sys] == 
             "HyperfineZeeman", 
             Not[
              MatchQ[AtomicDensityMatrix`LevelDiagram`Private`fLabelValue, 
               Alternatives[None, False]]]], 
            Replace[
            AtomicDensityMatrix`LevelDiagram`Private`fLabelValue, 
             Alternatives[Automatic, All, True] -> 
             Map[AtomicDensityMatrix`QN[#, 
                 AtomicDensityMatrix`LevelDiagram`Private`f, 
                 AtomicDensityMatrix`LevelDiagram`Private`fsub, 
                 AtomicDensityMatrix`LevelDiagram`Private`statelabels] == 
               AtomicDensityMatrix`F[#]& , 
               AtomicDensityMatrix`LevelDiagram`Private`fstates]], {}]; 
         AtomicDensityMatrix`LevelDiagram`Private`jstates = Map[Last, 
            Split[
             SortBy[AtomicDensityMatrix`LevelDiagram`Private`fstates, {
               AtomicDensityMatrix`StateLabel[#], 
               AtomicDensityMatrix`J[#], 
               AtomicDensityMatrix`F[#]}& ], And[
             AtomicDensityMatrix`StateLabel[#] === 
              AtomicDensityMatrix`StateLabel[#2], AtomicDensityMatrix`J[#] === 
              AtomicDensityMatrix`J[#2]]& ]]; 
         AtomicDensityMatrix`LevelDiagram`Private`jlabeltext = If[
            And[
            AtomicDensityMatrix`AtomicSystemType[
              AtomicDensityMatrix`LevelDiagram`Private`sys] != "Toy", 
             Not[
              MatchQ[AtomicDensityMatrix`LevelDiagram`Private`jLabelValue, 
               Alternatives[None, False]]]], 
            Replace[
            AtomicDensityMatrix`LevelDiagram`Private`jLabelValue, 
             Alternatives[Automatic, All, True] -> 
             Map[AtomicDensityMatrix`QN[#, 
                 AtomicDensityMatrix`LevelDiagram`Private`j, 
                 AtomicDensityMatrix`LevelDiagram`Private`jsub, 
                 AtomicDensityMatrix`LevelDiagram`Private`statelabels] == 
               AtomicDensityMatrix`J[#]& , 
               AtomicDensityMatrix`LevelDiagram`Private`jstates]], Null]; 
         AtomicDensityMatrix`LevelDiagram`Private`statelabeltext = If[
            Not[
             MatchQ[
             AtomicDensityMatrix`LevelDiagram`Private`stateLabelValue, 
              Alternatives[None, False]]], 
            Replace[
            AtomicDensityMatrix`LevelDiagram`Private`stateLabelValue, 
             Alternatives[Automatic, All, True] -> 
             AtomicDensityMatrix`StateLabel[
              AtomicDensityMatrix`LevelDiagram`Private`jstates]], Null]; 
         AtomicDensityMatrix`LevelDiagram`Private`statelabeltext = 
          If[AtomicDensityMatrix`LevelDiagram`Private`jlabeltext === 
            AtomicDensityMatrix`LevelDiagram`Private`statelabeltext === 
            Null, {}, 
            ReplaceAll[
             Map[Row[#, ","]& , 
              Thread[
               Map[PadRight[{}, 
                 Length[
                 AtomicDensityMatrix`LevelDiagram`Private`jstates], #]& , {
                AtomicDensityMatrix`LevelDiagram`Private`statelabeltext, 
                 AtomicDensityMatrix`LevelDiagram`Private`jlabeltext}]]], 
             Null -> Sequence[]]]; If[
           And[
           AtomicDensityMatrix`LevelDiagram`Private`flabeltext == {}, 
            AtomicDensityMatrix`LevelDiagram`Private`statelabeltext == {}], 
           Return[{}]]; 
         If[AtomicDensityMatrix`LevelDiagram`Private`flabeltext == {}, 
           AtomicDensityMatrix`LevelDiagram`Private`labeltext = 
            AtomicDensityMatrix`LevelDiagram`Private`statelabeltext; 
           AtomicDensityMatrix`LevelDiagram`Private`positions = 
            Map[Map[Extract[
               AtomicDensityMatrix`LevelDiagram`Private`pos, #]& , 
               AtomicDensityMatrix`StatePosition[
               AtomicDensityMatrix`LevelDiagram`Private`sys, 
                And[
                AtomicDensityMatrix`StateLabel == 
                 AtomicDensityMatrix`StateLabel[#], AtomicDensityMatrix`F == 
                 AtomicDensityMatrix`F[#]]]]& , 
              AtomicDensityMatrix`LevelDiagram`Private`jstates], 
           AtomicDensityMatrix`LevelDiagram`Private`positions = 
            Map[Map[Extract[
               AtomicDensityMatrix`LevelDiagram`Private`pos, #]& , 
               AtomicDensityMatrix`StatePosition[
               AtomicDensityMatrix`LevelDiagram`Private`sys, 
                And[
                AtomicDensityMatrix`StateLabel == 
                 AtomicDensityMatrix`StateLabel[#], AtomicDensityMatrix`F == 
                 AtomicDensityMatrix`F[#]]]]& , 
              AtomicDensityMatrix`LevelDiagram`Private`fstates]; 
           If[AtomicDensityMatrix`LevelDiagram`Private`statelabeltext == {}, 
             AtomicDensityMatrix`LevelDiagram`Private`labeltext = 
             AtomicDensityMatrix`LevelDiagram`Private`flabeltext, 
             AtomicDensityMatrix`LevelDiagram`Private`labeltext = 
             MapThread[Row[
                Join[
                 
                 If[(AtomicDensityMatrix`LevelDiagram`Private`statepos = 
                   Position[
                    AtomicDensityMatrix`LevelDiagram`Private`jstates, #]) != \
{}, {
                   Extract[
                   AtomicDensityMatrix`LevelDiagram`Private`statelabeltext, 
                    First[AtomicDensityMatrix`LevelDiagram`Private`statepos]],
                    ", "}, {}], {#2}]]& , {
               AtomicDensityMatrix`LevelDiagram`Private`fstates, 
                AtomicDensityMatrix`LevelDiagram`Private`flabeltext}]]]; 
         If[AtomicDensityMatrix`LevelDiagram`Private`stateLabelPositionValue === 
           Automatic, AtomicDensityMatrix`LevelDiagram`Private`labelpos = 
           Apply[(
             AtomicDensityMatrix`LevelDiagram`Private`side = 
              Sign[# - Mean[{
                 AtomicDensityMatrix`LevelDiagram`Private`xmin, 
                  AtomicDensityMatrix`LevelDiagram`Private`xmax}] - 
                10^(-6)]; {{(
                  AtomicDensityMatrix`LevelDiagram`Private`side (
                   AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue + 
                   AtomicDensityMatrix`LevelDiagram`Private`levelSpacingValue)\
)/2 + #, #2}, {-AtomicDensityMatrix`LevelDiagram`Private`side, 0}})& , 
             Map[Mean, AtomicDensityMatrix`LevelDiagram`Private`positions], {
             1}], AtomicDensityMatrix`LevelDiagram`Private`labelpos = 
            Map[{{AtomicDensityMatrix`LevelDiagram`Private`xmin - 
                AtomicDensityMatrix`LevelDiagram`Private`levelSpacingValue, \
#}, {1, 0}}& , 
              AtomicDensityMatrix`LevelDiagram`Private`spacePoints[
               Map[Last, 
                Map[
                Mean, AtomicDensityMatrix`LevelDiagram`Private`positions]], 
               AtomicDensityMatrix`LevelDiagram`Private`minLabelSpacingValue]]\
; If[
             Alternatives[
             AtomicDensityMatrix`LevelDiagram`Private`mLabelValue === Short, 
              "Short"], AtomicDensityMatrix`LevelDiagram`Private`labeltext = 
             Map[Row[{#, 
                 Invisible["M="]}]& , 
               AtomicDensityMatrix`LevelDiagram`Private`labeltext]]]; 
         MapThread[Text[
            TraditionalForm[
             
             Style[#2, "InlineMath", Background -> None, 
              AtomicDensityMatrix`LevelDiagram`Private`labelStyleValue]], 
            Part[#, 1], 
            Part[#, 2]]& , {
           AtomicDensityMatrix`LevelDiagram`Private`labelpos, 
            AtomicDensityMatrix`LevelDiagram`Private`labeltext}]], Condition[
         AtomicDensityMatrix`StatePosition[
          PatternTest[
           Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
            Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
           Blank[]], 
          Optional[
           Pattern[AtomicDensityMatrix`AtomicSystem`Private`n, 
            Alternatives[
             Blank[Integer], Infinity]], Infinity]], 
         AtomicDensityMatrix`StateLabelQ[
         AtomicDensityMatrix`AtomicSystem`Private`sys, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]] := 
       AtomicDensityMatrix`StatePosition[
        AtomicDensityMatrix`AtomicSystem`Private`sys, 
         AtomicDensityMatrix`StateLabel == 
         AtomicDensityMatrix`AtomicSystem`Private`crit, 
         AtomicDensityMatrix`AtomicSystem`Private`n], 
       AtomicDensityMatrix`StatePosition[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]], 
         Optional[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`n, 
           Blank[]], Infinity]] := 
       Position[AtomicDensityMatrix`AtomicSystem`Private`sys, 
         Condition[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
           Blank[]], 
          AtomicDensityMatrix`StateEvaluate[
          AtomicDensityMatrix`AtomicSystem`Private`state, 
           AtomicDensityMatrix`AtomicSystem`Private`crit]], {1}, 
         AtomicDensityMatrix`AtomicSystem`Private`n, Heads -> False], 
       TagSet[AtomicDensityMatrix`StatePosition, 
        MessageName[AtomicDensityMatrix`StatePosition, "usage"], 
        "\!\(\*TagBox[RowBox[{\"StatePosition[\", StyleBox[\"sys\", \"TI\"], \
\",\", StyleBox[\"crit\", \"TI\"], \"] gives the position in the atomic \
system \", StyleBox[\"sys\", \"TI\"], \" of the states satisfying the state\
\[Hyphen]selection criteria \", StyleBox[\"crit\", \"TI\"], \".\", \"\
\[LineSeparator]\", \"StatePosition[\", StyleBox[\"sys\", \"TI\"], \",\", \
StyleBox[\"crit\", \"TI\"], \",\", StyleBox[\"n\", \"TI\"], \"] gives the \
positions of the first \", StyleBox[\"n\", \"TI\"], \" atomic states \
found.\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`LevelDiagram`Private`spacePoints[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`minSpacing, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`pos, 
          AtomicDensityMatrix`LevelDiagram`Private`p, 
          AtomicDensityMatrix`LevelDiagram`Private`startpos, 
          AtomicDensityMatrix`LevelDiagram`Private`ord, 
          AtomicDensityMatrix`LevelDiagram`Private`sortpos}, 
         AtomicDensityMatrix`LevelDiagram`Private`ord = 
          Ordering[AtomicDensityMatrix`LevelDiagram`Private`opos]; 
         AtomicDensityMatrix`LevelDiagram`Private`sortpos = 
          Part[AtomicDensityMatrix`LevelDiagram`Private`opos, 
            AtomicDensityMatrix`LevelDiagram`Private`ord]; If[Min[
             Differences[AtomicDensityMatrix`LevelDiagram`Private`sortpos]] >= 
           AtomicDensityMatrix`LevelDiagram`Private`minSpacing, 
           Return[AtomicDensityMatrix`LevelDiagram`Private`opos]]; 
         AtomicDensityMatrix`LevelDiagram`Private`pos = 
          Array[AtomicDensityMatrix`LevelDiagram`Private`p, 
            Length[AtomicDensityMatrix`LevelDiagram`Private`opos]]; 
         AtomicDensityMatrix`LevelDiagram`Private`startpos = 
          AtomicDensityMatrix`LevelDiagram`Private`minSpacing (Range[
              Length[AtomicDensityMatrix`LevelDiagram`Private`opos]] - (
             Length[AtomicDensityMatrix`LevelDiagram`Private`opos] - 1)/2 - 
            1.); Part[
           AtomicDensityMatrix`LevelDiagram`Private`sortpos, 
            AtomicDensityMatrix`LevelDiagram`Private`ord] = 
          ReplaceAll[AtomicDensityMatrix`LevelDiagram`Private`pos, 
            Last[
             FindMinimum[{
               
               Total[(AtomicDensityMatrix`LevelDiagram`Private`pos - 
                 AtomicDensityMatrix`LevelDiagram`Private`sortpos)^2], 
               Apply[And, 
                Thread[
                Most[AtomicDensityMatrix`LevelDiagram`Private`pos] + 
                  AtomicDensityMatrix`LevelDiagram`Private`minSpacing/2 < 
                 Rest[AtomicDensityMatrix`LevelDiagram`Private`pos] - 
                  AtomicDensityMatrix`LevelDiagram`Private`minSpacing/2]]}, 
              
              Transpose[{
               AtomicDensityMatrix`LevelDiagram`Private`pos, 
                AtomicDensityMatrix`LevelDiagram`Private`startpos}]]]]; 
         AtomicDensityMatrix`LevelDiagram`Private`sortpos], 
       TagSet[AtomicDensityMatrix`MinLabelSpacing, 
        MessageName[AtomicDensityMatrix`MinLabelSpacing, "usage"], ""], 
       TagSet[AtomicDensityMatrix`FLabel, 
        MessageName[AtomicDensityMatrix`FLabel, "usage"], ""], 
       TagSet[AtomicDensityMatrix`JLabel, 
        MessageName[AtomicDensityMatrix`JLabel, "usage"], ""], 
       TagSet[AtomicDensityMatrix`StateLabelPosition, 
        MessageName[AtomicDensityMatrix`StateLabelPosition, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`setupArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`mixing, 
          AtomicDensityMatrix`LevelDiagram`Private`arcrad, 
          AtomicDensityMatrix`LevelDiagram`Private`arrowoff, 
          AtomicDensityMatrix`LevelDiagram`Private`arrowsetback, 
          AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          AtomicDensityMatrix`LevelDiagram`Private`arrowfunc, 
          AtomicDensityMatrix`LevelDiagram`Private`thisarrsty, 
          AtomicDensityMatrix`LevelDiagram`Private`matelem, 
          AtomicDensityMatrix`LevelDiagram`Private`freqs, 
          AtomicDensityMatrix`LevelDiagram`Private`x1, 
          AtomicDensityMatrix`LevelDiagram`Private`y1, 
          AtomicDensityMatrix`LevelDiagram`Private`x2, 
          AtomicDensityMatrix`LevelDiagram`Private`y2, 
          AtomicDensityMatrix`LevelDiagram`Private`arr, 
          AtomicDensityMatrix`LevelDiagram`Private`arrsty, 
          AtomicDensityMatrix`LevelDiagram`Private`setback, 
          AtomicDensityMatrix`LevelDiagram`Private`thisarcrad, 
          AtomicDensityMatrix`LevelDiagram`Private`\
suppressOffResonantCouplings = 
          OptionValue[AtomicDensityMatrix`SuppressOffResonantCouplings], 
          AtomicDensityMatrix`LevelDiagram`Private`levelLength = 
          OptionValue[AtomicDensityMatrix`LevelLength], 
          AtomicDensityMatrix`LevelDiagram`Private`maxArcSlope = 
          OptionValue[AtomicDensityMatrix`MaxArcSlope]}, 
         AtomicDensityMatrix`LevelDiagram`Private`mixing = DeleteCases[
            Join[
             Position[AtomicDensityMatrix`LevelDiagram`Private`h, 
              Condition[
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                Blank[]], 
               Not[
                PossibleZeroQ[AtomicDensityMatrix`LevelDiagram`Private`x]]], {
              2}, Heads -> False], 
             Apply[List, 
              Union[
               Flatten[
                Map[{
                  Reverse[#], #}& , 
                 Flatten[
                  Map[Tuples, 
                   Flatten[
                    Map[Flatten[
                    AtomicDensityMatrix`StatePosition[
                    AtomicDensityMatrix`LevelDiagram`Private`sys, #]]& , 
                    Flatten[{
                    OptionValue[AtomicDensityMatrix`ExtraArrows]}], {
                    2}]]]]]]], {1}]], {
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
              Blank[]]}]; 
         If[AtomicDensityMatrix`LevelDiagram`Private`mixing == {}, 
           Return[{}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`arcrad = RotateRight[
            AtomicDensityMatrix`EnsureList[
             OptionValue[AtomicDensityMatrix`ArcRadius]]]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrowoff = Replace[
            OptionValue[AtomicDensityMatrix`ArrowOffset], {
            None -> {{0, 0}}, PatternTest[
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                Blank[]], NumericQ] -> {{
               AtomicDensityMatrix`LevelDiagram`Private`x, 0}}, 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, {
                PatternTest[
                 Blank[], NumericQ], 
                PatternTest[
                 Blank[], NumericQ]}] -> {
              AtomicDensityMatrix`LevelDiagram`Private`x}}]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrowoff = 
          Replace[AtomicDensityMatrix`LevelDiagram`Private`arrowoff, {
            Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, {
                PatternTest[
                 Blank[], NumericQ], 
                PatternTest[
                 Blank[], NumericQ]}] -> {
              AtomicDensityMatrix`LevelDiagram`Private`x, 
               AtomicDensityMatrix`LevelDiagram`Private`x}, None -> {0, 0}, 
             PatternTest[
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                Blank[]], NumericQ] -> {
              AtomicDensityMatrix`LevelDiagram`Private`x, 0}}, {1}]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrowsetback = Replace[
            OptionValue[AtomicDensityMatrix`ArrowSetback], {
            None -> {{0, 0}}, PatternTest[
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                Blank[]], NumericQ] -> {{
               0, AtomicDensityMatrix`LevelDiagram`Private`x}}, 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, {
                PatternTest[
                 Blank[], NumericQ], 
                PatternTest[
                 Blank[], NumericQ]}] -> {
              AtomicDensityMatrix`LevelDiagram`Private`x}}]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrowsetback = 
          Replace[AtomicDensityMatrix`LevelDiagram`Private`arrowsetback, {
            PatternTest[
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                Blank[]], NumericQ] -> {
              0, AtomicDensityMatrix`LevelDiagram`Private`x}, 
             None -> {0, 0}}, {1}]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrsty = Replace[
            AtomicDensityMatrix`EnsureList[
             OptionValue[AtomicDensityMatrix`ArrowStyle]], {} -> {{}}]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrowfunc = ReplaceAll[
            OptionValue[AtomicDensityMatrix`ArrowFunction], 
            Automatic -> (Arrow[#]& )]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrows = Last[
            Last[
             Reap[
              
              Map[({{AtomicDensityMatrix`LevelDiagram`Private`x1, 
                   AtomicDensityMatrix`LevelDiagram`Private`y1}, {
                  AtomicDensityMatrix`LevelDiagram`Private`x2, 
                   AtomicDensityMatrix`LevelDiagram`Private`y2}} = 
                Part[AtomicDensityMatrix`LevelDiagram`Private`pos, #]; If[
                 And[
                  Or[
                  AtomicDensityMatrix`LevelDiagram`Private`y1 < 
                   AtomicDensityMatrix`LevelDiagram`Private`y2, 
                   And[
                   AtomicDensityMatrix`LevelDiagram`Private`y1 == 
                    AtomicDensityMatrix`LevelDiagram`Private`y2, 
                    AtomicDensityMatrix`LevelDiagram`Private`x1 < 
                    AtomicDensityMatrix`LevelDiagram`Private`x2]], (
                   AtomicDensityMatrix`LevelDiagram`Private`thisarrsty = 
                   AtomicDensityMatrix`PopAppend[
                    AtomicDensityMatrix`LevelDiagram`Private`arrsty]) =!= 
                  None], AtomicDensityMatrix`LevelDiagram`Private`matelem = 
                  ExpandAll[
                    TrigToExp[
                    Extract[AtomicDensityMatrix`LevelDiagram`Private`h, #]]]; 
                 AtomicDensityMatrix`LevelDiagram`Private`freqs = ReplaceAll[
                    Union[
                    
                    Cases[{AtomicDensityMatrix`LevelDiagram`Private`matelem}, 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
                    Blank[]] E^((Complex[
                    Alternatives[0, 0.], 
                    PatternTest[
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                    Blank[]], NumericQ]] Optional[
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`w, 
                    Blank[]]]) AtomicDensityMatrix`t) :> {
                    AtomicDensityMatrix`LevelDiagram`Private`x, 
                    AtomicDensityMatrix`LevelDiagram`Private`a, 
                    AtomicDensityMatrix`LevelDiagram`Private`w}, 2]], {} -> {{
                    AtomicDensityMatrix`LevelDiagram`Private`y2 - 
                    AtomicDensityMatrix`LevelDiagram`Private`y1, 
                    AtomicDensityMatrix`LevelDiagram`Private`matelem, 
                    AtomicDensityMatrix`LevelDiagram`Private`w}}]; 
                 If[AtomicDensityMatrix`LevelDiagram`Private`\
suppressOffResonantCouplings, AtomicDensityMatrix`LevelDiagram`Private`freqs = 
                   DeleteCases[AtomicDensityMatrix`LevelDiagram`Private`freqs, 
                    Condition[
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`f, 
                    Blank[]], 
                    Negative[
                    First[AtomicDensityMatrix`LevelDiagram`Private`f]]]]]; 
                 AtomicDensityMatrix`LevelDiagram`Private`freqs = 
                  ReplaceAll[
                   AtomicDensityMatrix`LevelDiagram`Private`freqs, {Condition[{
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                    Blank[]], 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
                    Blank[]], 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`w, 
                    Blank[]]}, 
                    Not[
                    NumericQ[
                    AtomicDensityMatrix`LevelDiagram`Private`w]]] :> {
                    AtomicDensityMatrix`LevelDiagram`Private`y2 - 
                    AtomicDensityMatrix`LevelDiagram`Private`y1, 
                    AtomicDensityMatrix`LevelDiagram`Private`a}, {
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                    Blank[]], 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
                    Blank[]], 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`w, 
                    Blank[]]} :> {
                    AtomicDensityMatrix`LevelDiagram`Private`x, 
                    AtomicDensityMatrix`LevelDiagram`Private`a}}]; 
                 AtomicDensityMatrix`LevelDiagram`Private`arr = 
                  Map[(AtomicDensityMatrix`LevelDiagram`Private`y2 = 
                    AtomicDensityMatrix`LevelDiagram`Private`y1 + 
                    Part[#, 1]; {{
                    AtomicDensityMatrix`LevelDiagram`Private`x1, 
                    AtomicDensityMatrix`LevelDiagram`Private`y1}, {
                    AtomicDensityMatrix`LevelDiagram`Private`x2, 
                    AtomicDensityMatrix`LevelDiagram`Private`y2}} + (
                    AtomicDensityMatrix`LevelDiagram`Private`levelLength 
                    AtomicDensityMatrix`PopAppend[
                    AtomicDensityMatrix`LevelDiagram`Private`arrowoff]) {{
                    Order[AtomicDensityMatrix`LevelDiagram`Private`x1, 
                    AtomicDensityMatrix`LevelDiagram`Private`x2], 
                    Order[
                    AtomicDensityMatrix`LevelDiagram`Private`y1, 
                    AtomicDensityMatrix`LevelDiagram`Private`y2]}, {
                    Order[
                    AtomicDensityMatrix`LevelDiagram`Private`x2, 
                    AtomicDensityMatrix`LevelDiagram`Private`x1], 
                    Order[
                    AtomicDensityMatrix`LevelDiagram`Private`y2, 
                    AtomicDensityMatrix`LevelDiagram`Private`y1]}})& , 
                    AtomicDensityMatrix`LevelDiagram`Private`freqs]; 
                 AtomicDensityMatrix`LevelDiagram`Private`arr = 
                  Map[(AtomicDensityMatrix`LevelDiagram`Private`setback = (
                    AtomicDensityMatrix`LevelDiagram`Private`levelLength 
                    AtomicDensityMatrix`PopAppend[
                    AtomicDensityMatrix`LevelDiagram`Private`arrowsetback])/
                    Norm[
                    Apply[Subtract, #]]; {
                    AtomicDensityMatrix`LevelDiagram`Private`line[#, 
                    Part[
                    AtomicDensityMatrix`LevelDiagram`Private`setback, 1]], 
                    
                    AtomicDensityMatrix`LevelDiagram`Private`line[#, 1 - Part[
                    AtomicDensityMatrix`LevelDiagram`Private`setback, 2]]})& ,
                     AtomicDensityMatrix`LevelDiagram`Private`arr]; 
                 AtomicDensityMatrix`LevelDiagram`Private`thisarcrad = 
                  First[AtomicDensityMatrix`LevelDiagram`Private`arcrad = 
                    RotateLeft[
                    AtomicDensityMatrix`LevelDiagram`Private`arcrad]]; 
                 AtomicDensityMatrix`LevelDiagram`Private`thisarrsty = 
                  Replace[
                   AtomicDensityMatrix`LevelDiagram`Private`thisarrsty, List -> 
                    Sequence, {1}, Heads -> True]; 
                 Apply[Sow[{
                    AtomicDensityMatrix`LevelDiagram`Private`thisarrsty, 
                    If[Abs[
                    AtomicDensityMatrix`Slope[#]] <= 
                    AtomicDensityMatrix`LevelDiagram`Private`maxArcSlope, 
                    
                    AtomicDensityMatrix`LevelDiagram`Private`arf[#, 
                    AtomicDensityMatrix`LevelDiagram`Private`thisarcrad, 
                    AtomicDensityMatrix`ConnectArc], 
                    
                    AtomicDensityMatrix`LevelDiagram`Private`arf[#, #2, 
                    AtomicDensityMatrix`LevelDiagram`Private`arrowfunc]]}]& , 
                   
                   Transpose[{AtomicDensityMatrix`LevelDiagram`Private`arr, 
                    Part[
                    AtomicDensityMatrix`LevelDiagram`Private`freqs, All, 
                    2]}], {1}]]; Null)& , 
               AtomicDensityMatrix`LevelDiagram`Private`mixing]]]]], 
       Options[AtomicDensityMatrix`LevelDiagram`Private`setupArrows] = {
        AtomicDensityMatrix`ExtraArrows -> {}, 
         AtomicDensityMatrix`ArcRadius -> {}, 
         AtomicDensityMatrix`ArrowOffset -> {}, 
         AtomicDensityMatrix`ArrowSetback -> {}, 
         AtomicDensityMatrix`ArrowStyle -> {}, 
         AtomicDensityMatrix`SuppressOffResonantCouplings -> {}, 
         AtomicDensityMatrix`MaxArcSlope -> {}, 
         AtomicDensityMatrix`ArrowFunction -> {}, 
         AtomicDensityMatrix`LevelLength -> {}}, 
       TagSet[AtomicDensityMatrix`SuppressOffResonantCouplings, 
        MessageName[
        AtomicDensityMatrix`SuppressOffResonantCouplings, "usage"], ""], 
       TagSet[AtomicDensityMatrix`MaxArcSlope, 
        MessageName[AtomicDensityMatrix`MaxArcSlope, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArcRadius, 
        MessageName[AtomicDensityMatrix`ArcRadius, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArrowOffset, 
        MessageName[AtomicDensityMatrix`ArrowOffset, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArrowSetback, 
        MessageName[AtomicDensityMatrix`ArrowSetback, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArrowStyle, 
        MessageName[AtomicDensityMatrix`ArrowStyle, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArrowFunction, 
        MessageName[AtomicDensityMatrix`ArrowFunction, "usage"], ""], 
       Attributes[AtomicDensityMatrix`PopAppend] = {HoldFirst}, 
       AtomicDensityMatrix`PopAppend[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`list, 
          Blank[]]] := (
        AtomicDensityMatrix`LevelDiagram`Private`list = 
         RotateLeft[AtomicDensityMatrix`LevelDiagram`Private`list]; 
        Last[AtomicDensityMatrix`LevelDiagram`Private`list]), 
       TagSet[AtomicDensityMatrix`PopAppend, 
        MessageName[AtomicDensityMatrix`PopAppend, "usage"], ""], 
       TagSet[AtomicDensityMatrix`t, 
        MessageName[AtomicDensityMatrix`t, "usage"], 
        "t is the default value for the option TimeVariable in DensityMatrix \
and other functions."], AtomicDensityMatrix`LevelDiagram`Private`line[{{
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`x1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`y1, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`x2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`y2, 
            Blank[]]}}, 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`s, 
          Blank[]]] = {
        AtomicDensityMatrix`LevelDiagram`Private`x1 + 
         AtomicDensityMatrix`LevelDiagram`Private`s (-
            AtomicDensityMatrix`LevelDiagram`Private`x1 + 
           AtomicDensityMatrix`LevelDiagram`Private`x2), 
         AtomicDensityMatrix`LevelDiagram`Private`y1 + 
         AtomicDensityMatrix`LevelDiagram`Private`s (-
            AtomicDensityMatrix`LevelDiagram`Private`y1 + 
           AtomicDensityMatrix`LevelDiagram`Private`y2)}, 
       AtomicDensityMatrix`Slope[{{
           Pattern[AtomicDensityMatrix`Common`Private`x1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`Common`Private`y1, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`Common`Private`x2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`Common`Private`y2, 
            Blank[]]}}] := 
       If[AtomicDensityMatrix`Common`Private`x2 != 
         AtomicDensityMatrix`Common`Private`x1, (
          AtomicDensityMatrix`Common`Private`y2 - 
          AtomicDensityMatrix`Common`Private`y1)/(
         AtomicDensityMatrix`Common`Private`x2 - 
         AtomicDensityMatrix`Common`Private`x1), Infinity], 
       TagSet[AtomicDensityMatrix`Slope, 
        MessageName[AtomicDensityMatrix`Slope, "usage"], ""], 
       AtomicDensityMatrix`ConnectArc[{
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`p1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`p2, 
           Blank[]]}, 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`o, 
          Blank[]]] := Cases[
         Flatten[
          First[
           ParametricPlot[
            Evaluate[
             
             Splines`SplineFit[{
              AtomicDensityMatrix`LevelDiagram`Private`p1, 
               Mean[{AtomicDensityMatrix`LevelDiagram`Private`p1, 
                  AtomicDensityMatrix`LevelDiagram`Private`p2}] + 
               AtomicDensityMatrix`LevelDiagram`Private`o 
                Dot[{{0, -1}, {1, 0}}, 
                  Abs[
                  AtomicDensityMatrix`LevelDiagram`Private`p2 - 
                   AtomicDensityMatrix`LevelDiagram`Private`p1]], 
               AtomicDensityMatrix`LevelDiagram`Private`p2}, Splines`Bezier][
             AtomicDensityMatrix`LevelDiagram`Private`x]], {
            AtomicDensityMatrix`LevelDiagram`Private`x, 0, 2}]]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`line, 
           Blank[Line]] :> 
         Apply[Arrow, AtomicDensityMatrix`LevelDiagram`Private`line], 
         Infinity], 
       TagSet[AtomicDensityMatrix`ConnectArc, 
        MessageName[AtomicDensityMatrix`ConnectArc, "usage"], ""], 
       Splines`SplineFit[
         PatternTest[
          Pattern[Splines`Private`pts, 
           Blank[List]], MatrixQ[#, NumberQ[
            N[#]]& ]& ], 
         PatternTest[
          Pattern[Splines`Private`type, 
           Blank[Symbol]], 
          MemberQ[{
           Splines`Cubic, Splines`Bezier, Splines`CompositeBezier}, #]& ]] := 
       Splines`SplineFunction[Splines`Private`type, {0., 
          N[Length[Splines`Private`pts] - 1]}, Splines`Private`pts, 
         Splines`Private`splineinternal[
         Splines`Private`pts, Splines`Private`type]], 
       TagSet[Splines`SplineFit, 
        MessageName[Splines`SplineFit, "cbezlen"], 
        "Points are needed to generate a spline."], 
       TagSet[Splines`SplineFit, 
        MessageName[Splines`SplineFit, "usage"], 
        "\!\(\*RowBox[{\"SplineFit\", \"[\", RowBox[{RowBox[{\"{\", \
RowBox[{SubscriptBox[StyleBox[\"pt\", \"TI\"], StyleBox[\"1\", \"TR\"]], \
\",\", SubscriptBox[StyleBox[\"pt\", \"TI\"], StyleBox[\"2\", \"TR\"]], \
\",\", StyleBox[\"\[Ellipsis]\", \"TR\"]}], \"}\"}], \",\", \
StyleBox[\"type\", \"TI\"]}], \"]\"}]\) generates a SplineFunction object of \
the specified \!\(\*StyleBox[\"type\", \"TI\"]\) from the points \
\!\(\*RowBox[{SubscriptBox[StyleBox[\"pt\", \"TI\"], StyleBox[\"1\", \
\"TR\"]], \",\", SubscriptBox[StyleBox[\"pt\", \"TI\"], StyleBox[\"2\", \
\"TR\"]], \",\", StyleBox[\"\[Ellipsis]\", \"TR\"]}]\)."], 
       TagSet[Splines`Cubic, 
        MessageName[Splines`Cubic, "usage"], 
        "Cubic is a setting specifying the type of spline generated by Spline \
and SplineFit."], 
       TagSet[Splines`Bezier, 
        MessageName[Splines`Bezier, "usage"], 
        "Bezier is a setting specifying the type of spline generated by \
Spline and SplineFit."], 
       TagSet[Splines`CompositeBezier, 
        MessageName[Splines`CompositeBezier, "usage"], 
        "CompositeBezier is a setting specifying the type of spline generated \
by Spline and SplineFit."], Splines`SplineFunction[
         Pattern[Splines`Private`type, 
          Blank[]], {
          Pattern[Splines`Private`min, 
           Blank[]], 
          Pattern[Splines`Private`max, 
           Blank[]]}, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]][
         PatternTest[
          Pattern[Splines`Private`in, 
           Blank[]], NumberQ[
           N[#]]& ]] := Module[{Splines`Private`out}, If[
           Or[
           Splines`Private`in < Splines`Private`min, Splines`Private`in > 
            Splines`Private`max], Message[
             MessageName[Splines`SplineFunction, "dmval"], 
             Splines`Private`in]; Splines`Private`out = $Failed, 
           Splines`Private`out = Splines`Private`evalspline[
             Which[Splines`Private`in == Splines`Private`max, 
              Min[Splines`Private`max, Splines`Private`in], 
              Splines`Private`in == Splines`Private`min, 
              Max[Splines`Private`min, Splines`Private`in], True, 
              Splines`Private`in], Splines`Private`type, Splines`Private`pts, 
             Splines`Private`internal]]; 
         Condition[Splines`Private`out, Splines`Private`out =!= $Failed]], 
       UpSetDelayed[
        MakeBoxes[
         Splines`SplineFunction[
          Pattern[Splines`Private`t, 
           Blank[]], 
          Pattern[Splines`Private`r, 
           Blank[]], 
          Pattern[Splines`Private`b, 
           BlankSequence[]]], 
         Pattern[FormatType, 
          Blank[]]], 
        Format[
         Row[{
          "SplineFunction[", Splines`Private`t, ", ", Splines`Private`r, ", ",
            "<>", "]"}], FormatType]], Format[
         Splines`SplineFunction[
          Pattern[Splines`Private`t, 
           Blank[]], 
          Pattern[Splines`Private`r, 
           Blank[]], 
          Pattern[Splines`Private`b, 
           BlankSequence[]]]] := 
       Row[{"SplineFunction[", Splines`Private`t, ", ", Splines`Private`r, 
          ", ", "<>", "]"}], 
       TagSet[Splines`SplineFunction, 
        MessageName[Splines`SplineFunction, "dmval"], 
        "Input value `1` lies outside the domain of the spline function."], 
       TagSet[Splines`SplineFunction, 
        MessageName[Splines`SplineFunction, "usage"], 
        "\!\(\*RowBox[{\"SplineFunction\", \"[\", RowBox[{StyleBox[\"type\", \
\"TI\"], \",\", StyleBox[\"domain\", \"TI\"], \",\", StyleBox[\"internal\", \
\"TI\"]}], \"]\"}]\) represents a spline function created by the SplineFit \
function parametrizing a curve with the parameter in the specified \
\!\(\*StyleBox[\"domain\", \"TI\"]\). When given a parameter value as an \
argument it returns the corresponding point on the curve."], 
       Splines`Private`evalspline[
         PatternTest[
          Pattern[Splines`Private`pt, 
           Blank[]], # == 0& ], Splines`Cubic, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]] := Part[Splines`Private`internal, 1, All, 1], 
       Splines`Private`evalspline[
         Pattern[Splines`Private`pt, 
          Blank[]], Splines`Cubic, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]] := Module[{Splines`Private`tmp}, 
         Dot[
          ({1, #, #^2, #^3}& )[
           
           If[(Splines`Private`tmp = Mod[Splines`Private`pt, 1]) == 0, 1, 
            Splines`Private`tmp]], 
          Transpose[
           Part[Splines`Private`internal, 
            Ceiling[Splines`Private`pt]]]]], Splines`Private`evalspline[
         Pattern[Splines`Private`pt, 
          Blank[]], Splines`CompositeBezier, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]] := 
       Module[{Splines`Private`ln = Length[Splines`Private`pts] - 1}, 
         Splines`Private`evalspline[
          If[
          Splines`Private`ln <= 3, Splines`Private`pt/Splines`Private`ln, 
           Splines`Private`pt (1/2 - If[
             OddQ[Splines`Private`ln], 1/(2 Splines`Private`ln), 0])], 
          Splines`Cubic, Splines`Private`pts, Splines`Private`internal]], 
       Splines`Private`evalspline[
         Pattern[Splines`Private`pt, 
          Blank[]], Splines`Bezier, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]] := 
       Splines`Private`internal[
        Splines`Private`pt/(Length[Splines`Private`pts] - 1)], 
       Attributes[MakeBoxes] = {HoldAllComplete}, 
       Splines`Private`splineinternal[
         Pattern[Splines`Private`pts, 
          Blank[List]], Splines`Cubic] := Transpose[
         Map[Splines`Private`splinecoord, 
          Transpose[Splines`Private`pts]]], Splines`Private`splineinternal[
         Pattern[Splines`Private`pts, 
          Blank[List]], Splines`CompositeBezier] := 
       Module[{Splines`Private`eqns, Splines`Private`gpts = 
          Splines`Private`pts, Splines`Private`ln = 
          Length[Splines`Private`pts], Splines`Private`end}, If[
           Or[Splines`Private`ln < 3, 
            OddQ[Splines`Private`ln]], 
           Which[Splines`Private`ln == 1, Splines`Private`gpts = Flatten[
              Table[Splines`Private`gpts, {4}]], Splines`Private`ln == 2, 
            Splines`Private`gpts = {
              Part[Splines`Private`gpts, 1], 
              Part[Splines`Private`gpts, 1], 
              Part[Splines`Private`gpts, 2], 
              Part[Splines`Private`gpts, 2]}, 
            OddQ[Splines`Private`ln], 
            AppendTo[Splines`Private`gpts, 
             Last[Splines`Private`gpts]], True, Message[
              MessageName[Splines`SplineFit, "cbezlen"]]; Return[
              InString[$Line]]]]; 
         Splines`Private`end = Take[Splines`Private`gpts, -4]; 
         Splines`Private`gpts = Partition[
            Drop[Splines`Private`gpts, -2], 4, 2]; 
         Splines`Private`gpts = 
          Apply[{#, #2, #3 - (#4 - #3), #3}& , Splines`Private`gpts, {1}]; 
         AppendTo[Splines`Private`gpts, Splines`Private`end]; 
         Apply[Transpose[{#, 3 (#2 - #), 3 (#3 - 2 #2 + #), #4 - 3 #3 + 
             3 #2 - #}]& , Splines`Private`gpts, {1}]], 
       Splines`Private`splineinternal[
         Pattern[Splines`Private`pts, 
          Blank[List]], Splines`Bezier] := 
       Module[{Splines`Private`n, Splines`Private`eq, Splines`Private`deg = 
          Length[Splines`Private`pts] - 1}, 
         Splines`Private`eq = 
          Table[#^Splines`Private`n (1 - #)^(Splines`Private`deg - 
              Splines`Private`n), {
            Splines`Private`n, 0, Splines`Private`deg}]; Evaluate[
           Apply[Plus, (Splines`Private`pts Table[
               Binomial[Splines`Private`deg, Splines`Private`n], {
               Splines`Private`n, 0, Splines`Private`deg}]) 
            Splines`Private`eq]]& ], Splines`Private`splinecoord[
         Pattern[Splines`Private`vals, 
          Blank[]]] := 
       Module[{Splines`Private`lst, Splines`Private`ln = 
          Length[Splines`Private`vals], Splines`Private`d, Splines`Private`n},
          Splines`Private`lst = 
          Join[{3 (Part[Splines`Private`vals, 2] - Part[
              Splines`Private`vals, 1])}, 
            Table[
            3 (Part[Splines`Private`vals, Splines`Private`n + 2] - Part[
              Splines`Private`vals, Splines`Private`n]), {
             Splines`Private`n, Splines`Private`ln - 2}], {
            3 (Part[Splines`Private`vals, Splines`Private`ln] - Part[
              Splines`Private`vals, Splines`Private`ln - 1])}]; 
         Splines`Private`d = 
          Splines`Private`trisolve[Splines`Private`lst, Splines`Private`ln]; 
         Table[{
            Part[Splines`Private`vals, Splines`Private`n], 
            Part[Splines`Private`d, Splines`Private`n], 
            3 (Part[Splines`Private`vals, Splines`Private`n + 1] - Part[
              Splines`Private`vals, Splines`Private`n]) - 2 
            Part[Splines`Private`d, Splines`Private`n] - Part[
            Splines`Private`d, Splines`Private`n + 1], 
            2 (Part[Splines`Private`vals, Splines`Private`n] - Part[
              Splines`Private`vals, Splines`Private`n + 1]) + 
            Part[Splines`Private`d, Splines`Private`n] + 
            Part[Splines`Private`d, Splines`Private`n + 1]}, {
           Splines`Private`n, 1, Splines`Private`ln - 1}]], 
       Splines`Private`trisolve[
         Pattern[Splines`Private`lst, 
          Blank[]], 
         Pattern[Splines`Private`ln, 
          Blank[]]] := Module[{}, 
         LinearSolve[
          SparseArray[{Band[{1, 1}] -> Join[{2}, 
              Table[4, {Splines`Private`ln - 2}], {2}], Band[{1, 2}] -> 1, 
            Band[{2, 1}] -> 1}], Splines`Private`lst]], $Line = 25, 
       AtomicDensityMatrix`LevelDiagram`Private`adjustArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`xpos, 
          AtomicDensityMatrix`LevelDiagram`Private`vertxranges, 
          AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`otherArrows}, If[
           Or[
            Not[
             NumericQ[
             AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue]], 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue == 0, 
            AtomicDensityMatrix`LevelDiagram`Private`arrows == {}], 
           Return[AtomicDensityMatrix`LevelDiagram`Private`arrows]]; {
           AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`otherArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
           AtomicDensityMatrix`LevelDiagram`Private`arrows, 
            Chop[AtomicDensityMatrix`LevelDiagram`Private`tx[#] - 
              AtomicDensityMatrix`LevelDiagram`Private`bx[#]] == 0& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          SortBy[AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`bx]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Split[AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
            Abs[AtomicDensityMatrix`LevelDiagram`Private`bx[#] - 
              AtomicDensityMatrix`LevelDiagram`Private`bx[#2]] < 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Map[SortBy[#, AtomicDensityMatrix`LevelDiagram`Private`by[#] - 
             AtomicDensityMatrix`LevelDiagram`Private`ty[#]& ]& , 
            AtomicDensityMatrix`LevelDiagram`Private`vertArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Map[AtomicDensityMatrix`LevelDiagram`Private`\
partitionVerticalArrows, AtomicDensityMatrix`LevelDiagram`Private`vertArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`xpos = 
          Map[(AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue 
              AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue) (
              Range[
                Length[#]] - (Length[#] + 1)/2) + Mean[
              Map[AtomicDensityMatrix`LevelDiagram`Private`tx, 
               Part[#, All, 1]]]& , 
            AtomicDensityMatrix`LevelDiagram`Private`vertArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Map[MapThread[
            AtomicDensityMatrix`LevelDiagram`Private`setTopBottom, #]& , 
            
            Transpose[{
             AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
              AtomicDensityMatrix`LevelDiagram`Private`xpos}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertxranges = Map[{
             Min[#], 
             Max[#]}& , 
            Map[
            AtomicDensityMatrix`LevelDiagram`Private`tx, 
             AtomicDensityMatrix`LevelDiagram`Private`vertArrows, {3}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Flatten[AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 2]; 
         AtomicDensityMatrix`LevelDiagram`Private`otherArrows = 
          Map[AtomicDensityMatrix`LevelDiagram`Private`clearLeftRight[#, 
             AtomicDensityMatrix`LevelDiagram`Private`vertxranges]& , 
            AtomicDensityMatrix`LevelDiagram`Private`otherArrows]; {
           AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`otherArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
           AtomicDensityMatrix`LevelDiagram`Private`otherArrows, Or[
            AtomicDensityMatrix`LevelDiagram`Private`ar[#] > 0, 
             And[
             AtomicDensityMatrix`LevelDiagram`Private`ar[#] == 0, 
              AtomicDensityMatrix`LevelDiagram`Private`slope[#] == 0]]& ]; {
           AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`otherArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
           AtomicDensityMatrix`LevelDiagram`Private`otherArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`ar[#] < 0& ]; {
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
           AtomicDensityMatrix`LevelDiagram`Private`otherArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`slope[#] > 0& ]; {
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`lx, 
            AtomicDensityMatrix`LevelDiagram`Private`ly, 
            AtomicDensityMatrix`LevelDiagram`Private`setLeft, 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue, 
            AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue]; {
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`rx, 
            AtomicDensityMatrix`LevelDiagram`Private`ry, 
            AtomicDensityMatrix`LevelDiagram`Private`setRight, 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue, -
            AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue]; {
           AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
            Join[
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
             AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows], Or[
            AtomicDensityMatrix`LevelDiagram`Private`ar[#] < 0, 
             And[
             AtomicDensityMatrix`LevelDiagram`Private`ar[#] == 0, 
              AtomicDensityMatrix`LevelDiagram`Private`slope[#] == 0]]& ]; {
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`rx, 
            AtomicDensityMatrix`LevelDiagram`Private`ry, 
            AtomicDensityMatrix`LevelDiagram`Private`setRight, 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue, -
            AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue]; {
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`lx, 
            AtomicDensityMatrix`LevelDiagram`Private`ly, 
            AtomicDensityMatrix`LevelDiagram`Private`setLeft, 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue, 
            AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue]; 
         Join[AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
           AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
           AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows]], 
       AtomicDensityMatrix`LevelDiagram`Private`DivideList[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`list, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`func, 
          Blank[]]] := ({
         Extract[AtomicDensityMatrix`LevelDiagram`Private`list, #], 
         Delete[AtomicDensityMatrix`LevelDiagram`Private`list, #]}& )[
         Position[AtomicDensityMatrix`LevelDiagram`Private`list, 
          PatternTest[
           Blank[], AtomicDensityMatrix`LevelDiagram`Private`func], {1}, 
          Heads -> False]], AtomicDensityMatrix`LevelDiagram`Private`tx[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         AtomicDensityMatrix`LevelDiagram`Private`tpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`tpts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         SortBy[
          AtomicDensityMatrix`LevelDiagram`Private`pts[
          AtomicDensityMatrix`LevelDiagram`Private`arr], Reverse]], 
       AtomicDensityMatrix`LevelDiagram`Private`pts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := 
       Part[AtomicDensityMatrix`LevelDiagram`Private`arr, -1, 1], 
       AtomicDensityMatrix`LevelDiagram`Private`bx[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         AtomicDensityMatrix`LevelDiagram`Private`bpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`bpts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         SortBy[
          AtomicDensityMatrix`LevelDiagram`Private`pts[
          AtomicDensityMatrix`LevelDiagram`Private`arr], Reverse]], 
       AtomicDensityMatrix`LevelDiagram`Private`by[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         AtomicDensityMatrix`LevelDiagram`Private`bpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`ty[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         AtomicDensityMatrix`LevelDiagram`Private`tpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`partitions, 
          Blank[]], {}] := 
       AtomicDensityMatrix`LevelDiagram`Private`partitions, 
       AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          Blank[]]] := 
       AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[{{
           First[AtomicDensityMatrix`LevelDiagram`Private`arrows]}}, 
         Rest[AtomicDensityMatrix`LevelDiagram`Private`arrows]], 
       AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`partitions, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`interval, 
          AtomicDensityMatrix`LevelDiagram`Private`position}, 
         AtomicDensityMatrix`LevelDiagram`Private`interval = Apply[Interval, 
            Map[{
              AtomicDensityMatrix`LevelDiagram`Private`by[#], 
              AtomicDensityMatrix`LevelDiagram`Private`ty[#]}& , 
             Last[AtomicDensityMatrix`LevelDiagram`Private`partitions]]]; 
         AtomicDensityMatrix`LevelDiagram`Private`interval = 
          Interval[{10.^(-10), (-1) 10.^(-10)} + 
            First[AtomicDensityMatrix`LevelDiagram`Private`interval]]; 
         AtomicDensityMatrix`LevelDiagram`Private`position = 
          Position[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
            Condition[
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
              Blank[List]], 
             IntervalIntersection[
              AtomicDensityMatrix`LevelDiagram`Private`interval, 
               Interval[{
                 AtomicDensityMatrix`LevelDiagram`Private`by[
                 AtomicDensityMatrix`LevelDiagram`Private`arr], 
                 AtomicDensityMatrix`LevelDiagram`Private`ty[
                 AtomicDensityMatrix`LevelDiagram`Private`arr]}]] == 
             Interval[]], {1}, 1]; 
         If[AtomicDensityMatrix`LevelDiagram`Private`position == {}, 
           AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
            Append[AtomicDensityMatrix`LevelDiagram`Private`partitions, {
              First[AtomicDensityMatrix`LevelDiagram`Private`arrows]}], 
            Rest[AtomicDensityMatrix`LevelDiagram`Private`arrows]], 
           AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
            MapAt[Append[#, 
              Part[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
               Part[
               AtomicDensityMatrix`LevelDiagram`Private`position, 1, 1]]]& , 
             AtomicDensityMatrix`LevelDiagram`Private`partitions, -1], 
            Delete[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
             Part[
             AtomicDensityMatrix`LevelDiagram`Private`position, 1, 1]]]]], 
       AtomicDensityMatrix`LevelDiagram`Private`setTopBottom[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`shift, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`LevelDiagram`Private`arr, 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y1, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y2, 
              Blank[]]}}, 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
            BlankSequence[]]] -> 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
            AtomicDensityMatrix`LevelDiagram`Private`shift, 
             AtomicDensityMatrix`LevelDiagram`Private`y1}, {
            AtomicDensityMatrix`LevelDiagram`Private`shift, 
             AtomicDensityMatrix`LevelDiagram`Private`y2}}, 
           AtomicDensityMatrix`LevelDiagram`Private`a]], 
       AtomicDensityMatrix`LevelDiagram`Private`clearLeftRight[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`ranges, 
          Blank[]]] := 
       Fold[AtomicDensityMatrix`LevelDiagram`Private`clearEndpoint[#, 
          AtomicDensityMatrix`LevelDiagram`Private`ranges, #2]& , 
         AtomicDensityMatrix`LevelDiagram`Private`arr, {{
          AtomicDensityMatrix`LevelDiagram`Private`lx, 
           AtomicDensityMatrix`LevelDiagram`Private`setLeft, Max}, {
          AtomicDensityMatrix`LevelDiagram`Private`rx, 
           AtomicDensityMatrix`LevelDiagram`Private`setRight, Min}}], 
       AtomicDensityMatrix`LevelDiagram`Private`clearEndpoint[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`ranges, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`p, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`setFunc, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`minmax, 
           Blank[]]}] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`range = 
          Apply[Interval, 
            Cases[AtomicDensityMatrix`LevelDiagram`Private`ranges, 
             Condition[{
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`min, 
                Blank[]], 
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`max, 
                Blank[]]}, AtomicDensityMatrix`LevelDiagram`Private`min < 
              AtomicDensityMatrix`LevelDiagram`Private`p[
               AtomicDensityMatrix`LevelDiagram`Private`arr] < 
              AtomicDensityMatrix`LevelDiagram`Private`max]]]}, 
         If[
         AtomicDensityMatrix`LevelDiagram`Private`range === Interval[], 
          AtomicDensityMatrix`LevelDiagram`Private`arr, 
          AtomicDensityMatrix`LevelDiagram`Private`setFunc[
          AtomicDensityMatrix`LevelDiagram`Private`arr, 
           AtomicDensityMatrix`LevelDiagram`Private`minmax[
            First[AtomicDensityMatrix`LevelDiagram`Private`range]]]]], 
       AtomicDensityMatrix`LevelDiagram`Private`lx[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         AtomicDensityMatrix`LevelDiagram`Private`lpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`lpts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         Sort[
          AtomicDensityMatrix`LevelDiagram`Private`pts[
          AtomicDensityMatrix`LevelDiagram`Private`arr]]], 
       AtomicDensityMatrix`LevelDiagram`Private`setLeft[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`shift, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`LevelDiagram`Private`arr, 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y1, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y2, 
              Blank[]]}}, 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
            BlankSequence[]]] :> 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
            AtomicDensityMatrix`LevelDiagram`Private`x1 + (
               AtomicDensityMatrix`LevelDiagram`Private`shift - 
               AtomicDensityMatrix`LevelDiagram`Private`x1) 
              Boole[AtomicDensityMatrix`LevelDiagram`Private`x1 < 
                AtomicDensityMatrix`LevelDiagram`Private`x2], 
             AtomicDensityMatrix`LevelDiagram`Private`y1}, {
            AtomicDensityMatrix`LevelDiagram`Private`x2 + (
               AtomicDensityMatrix`LevelDiagram`Private`shift - 
               AtomicDensityMatrix`LevelDiagram`Private`x2) 
              Boole[AtomicDensityMatrix`LevelDiagram`Private`x2 < 
                AtomicDensityMatrix`LevelDiagram`Private`x1], 
             AtomicDensityMatrix`LevelDiagram`Private`y2}}, 
           AtomicDensityMatrix`LevelDiagram`Private`a]], 
       AtomicDensityMatrix`LevelDiagram`Private`rx[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         AtomicDensityMatrix`LevelDiagram`Private`rpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`rpts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         Sort[
          AtomicDensityMatrix`LevelDiagram`Private`pts[
          AtomicDensityMatrix`LevelDiagram`Private`arr]]], 
       AtomicDensityMatrix`LevelDiagram`Private`setRight[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`shift, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`LevelDiagram`Private`arr, 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y1, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y2, 
              Blank[]]}}, 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
            BlankSequence[]]] :> 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
            AtomicDensityMatrix`LevelDiagram`Private`x1 + (
               AtomicDensityMatrix`LevelDiagram`Private`shift - 
               AtomicDensityMatrix`LevelDiagram`Private`x1) 
              Boole[AtomicDensityMatrix`LevelDiagram`Private`x1 > 
                AtomicDensityMatrix`LevelDiagram`Private`x2], 
             AtomicDensityMatrix`LevelDiagram`Private`y1}, {
            AtomicDensityMatrix`LevelDiagram`Private`x2 + (
               AtomicDensityMatrix`LevelDiagram`Private`shift - 
               AtomicDensityMatrix`LevelDiagram`Private`x2) 
              Boole[AtomicDensityMatrix`LevelDiagram`Private`x2 > 
                AtomicDensityMatrix`LevelDiagram`Private`x1], 
             AtomicDensityMatrix`LevelDiagram`Private`y2}}, 
           AtomicDensityMatrix`LevelDiagram`Private`a]], 
       AtomicDensityMatrix`LevelDiagram`Private`ar[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := 
       If[Part[AtomicDensityMatrix`LevelDiagram`Private`arr, -1, 3] === 
         AtomicDensityMatrix`ConnectArc, 
         Part[AtomicDensityMatrix`LevelDiagram`Private`arr, -1, 2], 0], 
       AtomicDensityMatrix`LevelDiagram`Private`slope[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := AtomicDensityMatrix`Slope[
         AtomicDensityMatrix`LevelDiagram`Private`pts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`slantArrows, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`horizArrows, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`y, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`setFunc, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`xpos}, 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = Join[
            Map[{#, {0, -Abs[
                 AtomicDensityMatrix`LevelDiagram`Private`slope[#]]}}& , 
             AtomicDensityMatrix`LevelDiagram`Private`slantArrows], 
            
            Map[{#, {
              1, -(AtomicDensityMatrix`LevelDiagram`Private`rx[#] - 
                AtomicDensityMatrix`LevelDiagram`Private`lx[#])}}& , 
             AtomicDensityMatrix`LevelDiagram`Private`horizArrows]]; 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = 
          SortBy[AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, Through[
             {
             AtomicDensityMatrix`LevelDiagram`Private`y, 
              AtomicDensityMatrix`LevelDiagram`Private`x}[
              First[#]]]& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = 
          Split[AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, And[
            Chop[AtomicDensityMatrix`LevelDiagram`Private`y[
                 First[#]] - AtomicDensityMatrix`LevelDiagram`Private`y[
                First[#2]]] == 0, 
             Abs[AtomicDensityMatrix`LevelDiagram`Private`x[
                 First[#]] - AtomicDensityMatrix`LevelDiagram`Private`x[
                First[#2]]] < 
             AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue]& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = Map[Part[
             SortBy[#, Last], All, 1]& , 
            AtomicDensityMatrix`LevelDiagram`Private`shiftArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`xpos = 
          Map[(AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue 
              AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue) Range[
               Length[#]] + Mean[
              Map[AtomicDensityMatrix`LevelDiagram`Private`x, #]]& , 
            AtomicDensityMatrix`LevelDiagram`Private`shiftArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = 
          MapThread[AtomicDensityMatrix`LevelDiagram`Private`setFunc, {
             Flatten[AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, 1], 
             Flatten[AtomicDensityMatrix`LevelDiagram`Private`xpos]}]; 
         AtomicDensityMatrix`LevelDiagram`Private`DivideList[
          AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, And[
           AtomicDensityMatrix`LevelDiagram`Private`ar[#] == 0, 
            AtomicDensityMatrix`LevelDiagram`Private`slope[#] != 0]& ]], 
       AtomicDensityMatrix`LevelDiagram`Private`ly[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         AtomicDensityMatrix`LevelDiagram`Private`lpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`ry[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         AtomicDensityMatrix`LevelDiagram`Private`rpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       TagSet[AtomicDensityMatrix`ArrowSpacing, 
        MessageName[AtomicDensityMatrix`ArrowSpacing, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`makePopulations[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`populationFunctionValue, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`populationStyleValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`popsty, 
          AtomicDensityMatrix`LevelDiagram`Private`popfunc, 
          AtomicDensityMatrix`LevelDiagram`Private`pops}, 
         If[AtomicDensityMatrix`LevelDiagram`Private`rho === {{0}}, 
           Return[{}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`popsty = 
          Replace[AtomicDensityMatrix`LevelDiagram`Private`\
populationStyleValue, List -> Sequence, {1}, Heads -> True]; 
         AtomicDensityMatrix`LevelDiagram`Private`popfunc = 
          ReplaceAll[
           AtomicDensityMatrix`LevelDiagram`Private`populationFunctionValue, {
            Alternatives[Automatic, "DiskTriangle"] -> 
             AtomicDensityMatrix`LevelDiagram`Private`diskTrianglePopFunc, 
             "Bar" -> AtomicDensityMatrix`LevelDiagram`Private`barPopFunc}]; 
         AtomicDensityMatrix`LevelDiagram`Private`pops = 
          MapThread[
           AtomicDensityMatrix`LevelDiagram`Private`popfunc[#, #2, 
             AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue]& , {
            AtomicDensityMatrix`LevelDiagram`Private`pos, 
             Diagonal[AtomicDensityMatrix`LevelDiagram`Private`rho]}]; {
          AtomicDensityMatrix`LevelDiagram`Private`popsty, 
           AtomicDensityMatrix`LevelDiagram`Private`pops}], 
       AtomicDensityMatrix`LevelDiagram`Private`diskTrianglePopFunc[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pop, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]]] := AtomicDensityMatrix`TakeFraction[
         AtomicDensityMatrix`DiskTriangle[
         AtomicDensityMatrix`LevelDiagram`Private`pos + {
           0, 0.075 AtomicDensityMatrix`LevelDiagram`Private`length}, 6, 0.15 
          AtomicDensityMatrix`LevelDiagram`Private`length, 0.07 
          AtomicDensityMatrix`LevelDiagram`Private`length], 
         AtomicDensityMatrix`LevelDiagram`Private`pop], 
       AtomicDensityMatrix`TakeFraction[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`expr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
          Blank[]]] := Take[AtomicDensityMatrix`LevelDiagram`Private`expr, 
         Round[
         AtomicDensityMatrix`LevelDiagram`Private`x 
          Length[AtomicDensityMatrix`LevelDiagram`Private`expr]]], 
       TagSet[AtomicDensityMatrix`TakeFraction, 
        MessageName[AtomicDensityMatrix`TakeFraction, "usage"], 
        "TakeFraction[\!\(\*\nStyleBox[\"list\", \"TI\"]\),\!\(\*\n\
StyleBox[\"f\", \"TI\"]\)] takes a fraction \!\(\*\nStyleBox[\"f\", \"TI\"]\) \
of the elements of \!\(\*\nStyleBox[\"list\", \"TI\"]\), rounded to the \
nearest element."], AtomicDensityMatrix`DiskTriangle[{
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`x0, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`y0, 
           Blank[]]}, 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`n, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`s, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`r, 
          Blank[]]] := Flatten[
         Table[
          Disk[
          AtomicDensityMatrix`LevelDiagram`Private`s {
             AtomicDensityMatrix`LevelDiagram`Private`x, (Sqrt[3] 
               AtomicDensityMatrix`LevelDiagram`Private`y)/2.} + {
            AtomicDensityMatrix`LevelDiagram`Private`x0, 
             AtomicDensityMatrix`LevelDiagram`Private`y0}, 
           AtomicDensityMatrix`LevelDiagram`Private`r], {
          AtomicDensityMatrix`LevelDiagram`Private`y, 0, 
           AtomicDensityMatrix`LevelDiagram`Private`n - 1}, {
          AtomicDensityMatrix`LevelDiagram`Private`x, -((
             AtomicDensityMatrix`LevelDiagram`Private`n - 
             AtomicDensityMatrix`LevelDiagram`Private`y - 1)/2), (
            AtomicDensityMatrix`LevelDiagram`Private`n - 
            AtomicDensityMatrix`LevelDiagram`Private`y - 1)/2}]], 
       TagSet[AtomicDensityMatrix`DiskTriangle, 
        MessageName[AtomicDensityMatrix`DiskTriangle, "usage"], 
        "Draws a filled triangle made up of individual disks."], 
       AtomicDensityMatrix`LevelDiagram`Private`barPopFunc[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pop, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]]] := 
       Rectangle[
        AtomicDensityMatrix`LevelDiagram`Private`pos + {(-0.2) 
           AtomicDensityMatrix`LevelDiagram`Private`length, 0}, 
         AtomicDensityMatrix`LevelDiagram`Private`pos + {
          0.2 AtomicDensityMatrix`LevelDiagram`Private`length, 
           AtomicDensityMatrix`LevelDiagram`Private`pop}], 
       TagSet[AtomicDensityMatrix`PopulationFunction, 
        MessageName[AtomicDensityMatrix`PopulationFunction, "usage"], ""], 
       TagSet[AtomicDensityMatrix`PopulationStyle, 
        MessageName[AtomicDensityMatrix`PopulationStyle, "usage"], ""], 
       AtomicDensityMatrix`TextOnTop[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`g, 
          Blank[Graphics]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`heads = {
           AffineHalfSpace, AffineSpace, Annulus, Arrow, ArrowBox, Ball, 
            BezierCurve, BezierCurveBox, BoundaryMeshRegion, BSplineCurve, 
            BSplineCurveBox, BSplineSurface, BSplineSurface3DBox, 
            CapsuleShape, Circle, CircleBox, Cone, ConeBox, ConicHullRegion, 
            ConicHullRegion3DBox, ConicHullRegionBox, Cuboid, CuboidBox, 
            Cylinder, CylinderBox, Disk, DiskBox, DiskSegment, Ellipsoid, 
            FilledCurve, FilledCurveBox, GeoGraphics, GeometricTransformation,
             GeometricTransformationBox, GraphicsComplex, GraphicsComplexBox, 
            GraphicsGroup, GraphicsGroupBox, HalfLine, HalfPlane, HalfSpace, 
            Hexahedron, HexahedronBox, Hyperplane, InfiniteLine, 
            InfinitePlane, InfinitePlane, JoinedCurve, JoinedCurveBox, 
            Legended, Line, LineBox, LineLegend, MeshRegion, Panel, PanelBox, 
            Parallelepiped, Parallelogram, Placed, Point, PointBox, Polygon, 
            PolygonBox, Prism, PrismBox, Pyramid, PyramidBox, Raster, 
            Raster3D, Raster3DBox, RasterBox, Rectangle, RectangleBox, 
            RegularPolygon, Rotate, Scale, Simplex, Sphere, SphereBox, 
            SphericalShell, StadiumShape, SurfaceGraphics, Tetrahedron, 
            TetrahedronBox, Texture, Translate, Triangle, Tube, TubeBox}, 
          AtomicDensityMatrix`LevelDiagram`Private`glist, 
          AtomicDensityMatrix`LevelDiagram`Private`opts}, 
         AtomicDensityMatrix`LevelDiagram`Private`glist = 
          ReplaceAll[
           AtomicDensityMatrix`LevelDiagram`Private`g, {{Blank[Text] -> {}}, {
             Apply[Alternatives, 
                Map[
                Blank, AtomicDensityMatrix`LevelDiagram`Private`heads]] -> \
{}}}]; AtomicDensityMatrix`LevelDiagram`Private`opts = DeleteCases[
            Table[
            AtomicDensityMatrix`LevelDiagram`Private`opt -> DeleteCases[
               Map[Part[
                 Options[#, AtomicDensityMatrix`LevelDiagram`Private`opt], 1, 
                 2]& , AtomicDensityMatrix`LevelDiagram`Private`glist], {}], {
             AtomicDensityMatrix`LevelDiagram`Private`opt, {Prolog, Epilog}}],
             Blank[] -> {}]; 
         Show[AtomicDensityMatrix`LevelDiagram`Private`glist, 
           Apply[Sequence, AtomicDensityMatrix`LevelDiagram`Private`opts]]], 
       TagSet[AtomicDensityMatrix`TextOnTop, 
        MessageName[AtomicDensityMatrix`TextOnTop, "usage"], 
        ""], $DisplayFunction = Identity, $CellContext`regimefunc[
         Pattern[$CellContext`x, 
          Blank[]]] = Piecewise[{{
           RGBColor[
           0.9019607843137255, 1., 0.8117647058823529], -0.3 < $CellContext`x < 
           0.3}, {
           RGBColor[
           0.9372549019607843, 0.8862745098039215, 1.], -3 < $CellContext`x < 
           3}, {
           RGBColor[
           0.8823529411764706, 0.9490196078431372, 1.], -11 < $CellContext`x < 
           11}}, 0]}; Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellLabel->"Out[25]=",
 CellID->1460754871,ExpressionUUID->"1e70c031-7664-451e-b64f-fe5c372b2f48"]
}, Open  ]],

Cell["\<\
As the probe frequency is swept through the resonance, we see three different \
behaviors corresponding to the three regimes discussed above:\
\>", "Text",
 CellID->397609329,ExpressionUUID->"0269d88d-1261-40cc-bc7d-b7352311ad48"],

Cell[TextData[{
 "(1) When the probe is far off resonance, it has little effect on the atoms. \
The redistribution of the ground-state populations is primarily due to the \
pump light: it pumps out the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", 
    RowBox[{"-", "1"}]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "77c3e41f-22cb-4a9e-8b0e-c2e363e87af3"],
 " sublevel, and these atoms are redistributed evenly between the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "0"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "7dee21cd-ee21-4984-8474-883587de2347"],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "e400fae2-f72c-4daf-8093-197c9eca4c69"],
 " sublevels. The populations of these two sublevels are not exactly equal \
because of the residual effect of the detuned probe light. Since the probe is \
off resonance, it experiences little absorption."
}], "Text",
 Background->RGBColor[0.8823529411764706, 0.9490196078431372, 1.],
 CellID->907999431,ExpressionUUID->"4467cebe-64ce-48b0-b795-186d481b80d4"],

Cell[TextData[{
 "(2) When the probe detuning is within the natural width, the probe \
optically pumps the atoms, in addition to the pump. In this regime, the pump \
and probe act ",
 StyleBox["incoherently",
  FontSlant->"Italic"],
 ": the pump pumps out the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", 
    RowBox[{"-", "1"}]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "4ec6eb98-beef-42dc-87c6-ca2fdf8ab903"],
 " sublevel and the probe pumps out the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "052e1571-448f-4215-981c-f597ffc2be96"],
 " sublevel; the atoms are transferred to the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "0"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "ef945f2c-bcd3-4392-8a64-a92b5f56c71c"],
 " sublevel. As the probe pumps the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "adf096d0-e972-4dfb-8e4b-83a86d7d4582"],
 " sublevel, it is absorbed: this accounts for the increase of absorption in \
this regime. "
}], "Text",
 Background->RGBColor[0.9372549019607843, 0.8862745098039215, 1.],
 CellID->22367888,ExpressionUUID->"830ee906-302c-4d73-9c8a-2e5c1fbad3c2"],

Cell[TextData[{
 "(3) When the pump-probe detuning is within the ground-state transit width, \
the pump and probe act ",
 StyleBox["coherently",
  FontSlant->"Italic"],
 ": they do not act independently on the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", 
    RowBox[{"-", "1"}]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "2e8725b4-2c69-4899-8f4c-c83fb1ee706b"],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "43a6e98d-117b-47a0-b10b-4b4e568bbe61"],
 " sublevels, but rather work together to pump out a \"bright state\" \
consisting of a linear superposition of the two sublevels. Atoms remain in \
the \"dark state\" consisting of the orthogonal linear superposition, so that \
the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", 
    RowBox[{"-", "1"}]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "a9090020-7068-473d-8f9d-245de37f97b9"],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "2ee366b3-18ab-4b95-b67d-1c88570ceb43"],
 " sublevels are not completely depleted. Since the pump and probe both act \
on the same (bright) state, the bright state is very efficiently pumped, \
leaving fewer atoms to interact with the probe light. Thus the absorption of \
the probe drops in this regime. "
}], "Text",
 Background->RGBColor[0.9019607843137255, 1., 0.8117647058823529],
 CellID->239612,ExpressionUUID->"7a5ff6e1-67b4-48a9-91fb-afd0aac8681c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["The light polarization", "Section",
 CellID->185542063,ExpressionUUID->"00defea4-fc49-4d2c-9a6b-9fcbb3ed8877"],

Cell["\<\
In order to understand why the pump and probe act incoherently in regime (2) \
but coherently in regime (3), we can look at the polarization of the total \
light field consisting of the pump plus the probe. The pump and probe have \
the same amplitude but opposite circular polarizations, so that the \
combination of the two is a linearly polarized light field. However, since \
the pump and probe have different frequencies, there is a constantly changing \
phase between them. This means that the direction of the resultant linear \
polarization constantly changes. Here we make an interactive animation of the \
light polarization as a function of time.\
\>", "Text",
 CellID->287527692,ExpressionUUID->"8f2e5ee8-0533-44bb-9c3d-46c487ff380f"],

Cell[TextData[{
 "First we find the polarization of the total light field ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["E", "tot"], TraditionalForm]], "InlineMath",ExpressionUUID->
  "03b6fe28-1c7e-40c0-98ef-fcf2716c0ef5"],
 ". The optical frequency of this field is the average of the pump and probe \
frequencies; we divide out the time dependence at this frequency so that only \
the time dependence of the light polarization remains. When we take the real \
part, we find the direction of the total light electric field amplitude as a \
function of time."
}], "Text",
 CellID->103757058,ExpressionUUID->"c82e6b0f-da9c-4602-859c-07535e2e85a1"],

Cell[TextData[{
 "Find the polarization direction of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["E", "tot"], TraditionalForm]], "InlineMath",ExpressionUUID->
  "4661dac2-4d03-4b47-bd5e-fa4103cadaeb"],
 " as a function of time."
}], "MathCaption",
 CellID->57776647,ExpressionUUID->"d33d4484-44db-4228-b250-75d10d13d838"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pol", "=", 
  RowBox[{"FullSimplify", "@", 
   RowBox[{"Most", "@", 
    RowBox[{"ComplexExpand", "@", 
     RowBox[{"Re", "[", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"\[ImaginaryI]", " ", "t", 
         RowBox[{"(", " ", 
          RowBox[{
           SubscriptBox["\[Omega]", "1"], "+", 
           RowBox[{
            SubscriptBox["\[CapitalDelta]", 
             RowBox[{"1", ",", "2"}]], "/", "2"}]}], ")"}]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Etot", "/.", 
          RowBox[{
           SubscriptBox["\[CapitalOmega]", 
            RowBox[{"R", ",", "1"}]], "\[Rule]", 
           SubscriptBox["\[CapitalOmega]", 
            RowBox[{"R", ",", "2"}]]}]}], "/.", 
         RowBox[{
          SubscriptBox["\[CapitalOmega]", 
           RowBox[{"R", ",", "2"}]], "\[Rule]", 
          RowBox[{"1", "/", 
           SqrtBox["2"]}]}]}], ")"}], " ", 
       RowBox[{"ReducedME", "[", 
        RowBox[{"1", ",", 
         RowBox[{"{", 
          RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], 
      "]"}]}]}]}]}]], "Input",
 CellLabel->"In[26]:=",
 CellID->885970457,ExpressionUUID->"1a77ca86-58a1-4ced-9493-ae6dc98db216"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Cos", "[", 
    RowBox[{
     FractionBox["1", "2"], " ", "t", " ", 
     SubscriptBox["\[CapitalDelta]", 
      RowBox[{"1", ",", "2"}]]}], "]"}], ",", 
   RowBox[{"-", 
    RowBox[{"Sin", "[", 
     RowBox[{
      FractionBox["1", "2"], " ", "t", " ", 
      SubscriptBox["\[CapitalDelta]", 
       RowBox[{"1", ",", "2"}]]}], "]"}]}]}], "}"}]], "Output",
 CellLabel->"Out[25]=",
 CellID->874064393,ExpressionUUID->"0d0fdda1-eca8-48fc-9e8e-1b09c156ab47"]
}, Open  ]],

Cell["\<\
Make an interactive plot that animates the light polarization direction for a \
given pump-probe detuning.\
\>", "MathCaption",
 CellID->606322747,ExpressionUUID->"f094858c-b187-4bc2-acb6-b3a8e747e26e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DynamicModule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Phi]1", "=", "0"}], ",", 
     RowBox[{"ofp", "=", 
      RowBox[{"pol", "/.", 
       RowBox[{
        RowBox[{
         SubscriptBox["\[CapitalDelta]", 
          RowBox[{"1", ",", "2"}]], " ", "t"}], "\[Rule]", "\[Phi]"}]}]}]}], 
    "}"}], ",", 
   RowBox[{"Manipulate", "[", 
    RowBox[{
     RowBox[{"Dynamic", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Refresh", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Phi]1", "=", 
            RowBox[{"\[Phi]1", "+", 
             RowBox[{
              SubscriptBox["\[CapitalDelta]", 
               RowBox[{"1", ",", "2"}]], "/", "3."}]}]}], ";"}], ",", 
          RowBox[{"UpdateInterval", "\[Rule]", ".05"}]}], "]"}], ";", 
        RowBox[{"Graphics", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"Arrowheads", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", ".1"}], ",", ".1"}], "}"}], "]"}], ",", 
            RowBox[{"Arrow", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "ofp"}], ",", "ofp"}], "}"}], "/.", 
              RowBox[{"\[Phi]", "\[Rule]", "\[Phi]1"}]}], "]"}]}], "}"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
          RowBox[{"Axes", "\[Rule]", "True"}], ",", 
          RowBox[{"Ticks", "\[Rule]", "False"}], ",", 
          RowBox[{"AxesLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<\!\(\*StyleBox[\"x\",FontSlant->\"Italic\"]\)\>\"", ",", 
             "\"\<\!\(\*StyleBox[\"y\",FontSlant->\"Italic\"]\)\>\""}], 
            "}"}]}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "220"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"regimefunc", "[", 
            SubscriptBox["\[CapitalDelta]", 
             RowBox[{"1", ",", "2"}]], "]"}]}]}], "]"}]}], ",", 
       RowBox[{"TrackedSymbols", "\[Rule]", 
        RowBox[{"{", "}"}]}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[CapitalDelta]", 
          RowBox[{"1", ",", "2"}]], ",", ".05"}], "}"}], ",", 
       RowBox[{"-", "6"}], ",", "6"}], "}"}]}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[26]:=",
 CellID->8269313,ExpressionUUID->"cbb741d4-5f5a-4963-aedc-d47e8d04e8db"],

Cell[BoxData[
 DynamicModuleBox[{$CellContext`\[Phi]1$$ = 
  0.6000000000000002, $CellContext`ofp$$ = {
   Cos[Rational[1, 2] $CellContext`\[Phi]], -
   Sin[Rational[1, 2] $CellContext`\[Phi]]}}, 
  TagBox[
   StyleBox[
    DynamicModuleBox[{$CellContext`$14$$ = 0.05, Typeset`show$$ = True, 
     Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
     Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
     "\"untitled\"", Typeset`specs$$ = {{{
        Hold[$CellContext`$14$$], 0.05, 
        RawBoxes[
         SubscriptBox["\[CapitalDelta]", 
          RowBox[{"1", ",", "2"}]]]}, -6, 6}}, Typeset`size$$ = {
     220., {111., 115.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
     Typeset`skipInitDone$$ = True, $CellContext`$14$7805$$ = 0}, 
     DynamicBox[Manipulate`ManipulateBoxes[
      1, StandardForm, "Variables" :> {$CellContext`$14$$ = 0.05}, 
       "ControllerVariables" :> {
         Hold[$CellContext`$14$$, $CellContext`$14$7805$$, 0]}, 
       "OtherVariables" :> {
        Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
         Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
         Typeset`specs$$, Typeset`size$$, Typeset`update$$, 
         Typeset`initDone$$, Typeset`skipInitDone$$}, "Body" :> 
       Dynamic[Refresh[$CellContext`\[Phi]1$$ = $CellContext`\[Phi]1$$ + \
$CellContext`$14$$/3.; Null, UpdateInterval -> 0.05]; Graphics[{Red, 
            Arrowheads[{-0.1, 0.1}], 
            Arrow[
             
             ReplaceAll[{-$CellContext`ofp$$, $CellContext`ofp$$}, \
$CellContext`\[Phi] -> $CellContext`\[Phi]1$$]]}, 
           PlotRange -> {{-1, 1}, {-1, 1}}, Axes -> True, Ticks -> False, 
           AxesLabel -> {
            "\!\(\*StyleBox[\"x\",FontSlant->\"Italic\"]\)", 
             "\!\(\*StyleBox[\"y\",FontSlant->\"Italic\"]\)"}, ImageSize -> 
           220, Background -> $CellContext`regimefunc[$CellContext`$14$$]], 
         TrackedSymbols -> {}], 
       "Specifications" :> {{{$CellContext`$14$$, 0.05, 
           RawBoxes[
            SubscriptBox["\[CapitalDelta]", 
             RowBox[{"1", ",", "2"}]]]}, -6, 6}}, "Options" :> {}, 
       "DefaultOptions" :> {}],
      ImageSizeCache->{262., {155., 160.}},
      SingleEvaluation->True],
     Deinitialization:>None,
     DynamicModuleValues:>{},
     SynchronousInitialization->True,
     UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
     UnsavedVariables:>{Typeset`initDone$$},
     UntrackedVariables:>{Typeset`size$$}], "Manipulate",
    Deployed->True,
    StripOnInput->False],
   Manipulate`InterpretManipulate[1]],
  DynamicModuleValues:>{}]], "Output",
 CellLabel->"Out[26]=",
 CellID->1612107671,ExpressionUUID->"6f3ae1de-be1e-4e66-90e2-65b133667d20"]
}, Open  ]],

Cell[TextData[{
 "We see that the light polarization rotates at a rate given by the detuning ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[CapitalDelta]", 
    RowBox[{"1", ",", "2"}]], TraditionalForm]], "InlineMath",ExpressionUUID->
  "05ff06d5-fd85-46e5-bff0-2eaeffa1a7cb"],
 ". Only when the pump and probe frequencies are equal is the polarization \
direction fixed. This gives the distinction between regimes (2) and (3): "
}], "Text",
 CellID->248112568,ExpressionUUID->"2be3db95-5e97-4cb1-953b-b552f7612749"],

Cell[TextData[{
 "Since the result of optically pumping the ground state is effectively \
averaged over the ground-state relaxation time, when the polarization \
direction makes a complete revolution during this time, the light is seen by \
the atoms as unpolarized (it has equal polarization in every direction \
perpendicular to the light propagation direction). Unpolarized light acts \
incoherently on the different states that it interacts with. Thus, in regime \
(2), where the light polarization rotates rapidly compared to the \
ground-state relaxation time, the two light fields act independently on the \
",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", 
    RowBox[{"-", "1"}]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "859bc5c6-093b-4347-93b7-aefdccec7954"],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "a8deb80a-9fee-4ae7-aad0-2ccb11b9e51e"],
 " sublevels. "
}], "Text",
 Background->RGBColor[0.9372549019607843, 0.8862745098039215, 1.],
 CellID->56662543,ExpressionUUID->"f72d2f5b-13c9-46a6-af63-80c9885ef544"],

Cell[TextData[{
 "On the other hand, in regime (3), the light polarization rotates slowly \
compared to the ground-state relaxation time. This means that the atoms, \
rather than seeing two circularly polarized pump and probe fields,  \
effectively see light with linear polarization along some direction \
perpendicular to the light propagation direction ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "3a1b7773-96f1-415a-ae52-2d67e762b136"],
 ". Such polarization does not pump on an eigenstate of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["J", "z"], TraditionalForm]], "InlineMath",ExpressionUUID->
  "1aa25dbe-2e4a-4e87-9afe-bc5c8bbca000"],
 ", but rather on a superposition of eigenstates, namely the bright state \
discussed above."
}], "Text",
 Background->RGBColor[0.9019607843137255, 1., 0.8117647058823529],
 CellID->168805416,ExpressionUUID->"0c784ca1-2002-4b4b-9f3b-4bd72fea6874"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Cartesian populations", "Section",
 CellID->69945931,ExpressionUUID->"5da43072-7e0a-400a-b9e1-f82e02b01f90"],

Cell[TextData[{
 "We can see this from another perspective by plotting the populations of the \
sublevels, not in the Zeeman basis, but rather in the basis of the dark and \
bright states. Note that these states depend on the direction of the light \
polarization, so that in the lab frame they change continuously for ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[CapitalDelta]", 
     RowBox[{"1", ",", "2"}]], "\[NotEqual]", "0"}], TraditionalForm]], 
  "InlineMath",ExpressionUUID->"8556029b-80b7-4e79-894f-843e66848065"],
 ". By making the unitary transformation ",
 Cell[BoxData[
  FormBox["v", TraditionalForm]], "InlineMath",ExpressionUUID->
  "7f5e99b9-6d40-4497-a96b-259ae14fa045"],
 " above, we have performed the calculation in a rotating frame in which the \
bright and dark states are fixed and correspond to the ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]], "InlineMath",ExpressionUUID->
  "93756b10-824f-4a17-b08b-4ce5a512a6f8"],
 " and ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]], "InlineMath",ExpressionUUID->
  "f33e5a7f-1b13-4cc9-9343-53549efc6684"],
 " states in the Cartesian basis. The ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]], "InlineMath",ExpressionUUID->
  "79b605ef-0f1f-449d-b78b-1b771bf0136e"],
 " state is the same as the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "0"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "de3afebf-d56c-4a9d-8c90-eb03d7629794"],
 " state in the Zeeman basis with the quantization axis along ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]], "InlineMath",ExpressionUUID->
  "a5b33c6b-dbeb-4eff-9ca8-83638ac82963"],
 ", while the ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]], "InlineMath",ExpressionUUID->
  "36f99a71-c571-4587-bc8d-4fceb354806c"],
 " state is the corresponding state with the quantization axis along ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]], "InlineMath",ExpressionUUID->
  "b027c9c2-5367-4687-bffa-d72df5d65d6b"],
 StyleBox[". These states, along with the ",
  Deletable->True],
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "0"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "49b9a533-8ab2-48db-a001-7dd84d9c0fbb"],
 StyleBox[" state in the ",
  Deletable->True],
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "29804828-fa0a-45c1-a6b6-daeb998b1087"],
 StyleBox[" basis, make a complete set of sublevels for a ",
  Deletable->True],
 Cell[BoxData[
  FormBox[
   RowBox[{"J", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "dae03e01-45e0-4087-b6ca-59c4868e2898"],
 StyleBox[" state, and the density matrix can be written in terms of these \
sublevels. ",
  Deletable->True]
}], "Text",
 CellID->84302324,ExpressionUUID->"33ee0fcc-0c6b-4647-a70c-69c9f5be42ea"],

Cell["\<\
Note that, because of the finite ground-state relaxation time, the dark and \
bright states can not, in a certain sense, \"keep up\" with the light \
polarization if it is rotating very quickly, due to the averaging effect \
discussed above. Thus the light effectively interacts with both the dark and \
bright states for detuned pump and probe. Even though the dark and bright \
states are not deserving of their names in this case, they are still well \
defined as certain linear combinations of the Zeeman sublevels, and we can \
track their populations.\
\>", "Text",
 CellID->527165396,ExpressionUUID->"5a83c0d5-01cd-4b7f-a7b8-6ee3032b87e4"],

Cell["\<\
We can illustrate the averaging effect for the light by finding the effective \
optical pumping strengths of the light on the dark and bright states and \
drawing darker or lighter arrows corresponding to these strengths. We can \
find the pumping strengths by taking the time-dependent Hamiltonian in the \
lab-frame Cartesian basis and averaging it over time with a exponentially \
decaying weighting factor corresponding to the ground-state-polarization \
decay rate.\
\>", "Text",
 CellID->192463844,ExpressionUUID->"eef2732b-24fc-4105-9424-b62b4c9abb0f"],

Cell["\<\
Transform the density matrix and Hamiltonian into the Cartesian basis.\
\>", "MathCaption",
 CellID->26982531,ExpressionUUID->"99db0f72-f401-4c89-9f9c-62f74ca16f3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dmcart", "=", 
   RowBox[{"ToCartesian", "[", 
    RowBox[{"sys", ",", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"DensityMatrix", "[", "sys", "]"}], "/.", "sol1"}], "/.", 
       "params"}], ")"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[27]:=",
 CellID->259967869,ExpressionUUID->"7bb235d5-708a-4dce-98c3-f8402b42f6e6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h0cart", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"ToCartesian", "[", 
       RowBox[{"sys", ",", "h0"}], "]"}], "//", "ExpToTrig"}], "//", 
     "FullSimplify"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[28]:=",
 CellID->69001025,ExpressionUUID->"bd3cfd2b-07b4-4c99-8825-127b3d0d7dbf"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"Cos", "[", 
           RowBox[{"t", " ", 
            SubscriptBox["\[Omega]", "1"]}], "]"}], " ", 
          SubscriptBox["\[CapitalOmega]", 
           RowBox[{"R", ",", "1"}]]}], "+", 
         RowBox[{
          RowBox[{"Cos", "[", 
           RowBox[{"t", " ", 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["\[Omega]", "1"], "+", 
              SubscriptBox["\[CapitalDelta]", 
               RowBox[{"1", ",", "2"}]]}], ")"}]}], "]"}], " ", 
          SubscriptBox["\[CapitalOmega]", 
           RowBox[{"R", ",", "2"}]]}]}], 
        SqrtBox["6"]]}]},
     {"0", "0", "0", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", 
           RowBox[{"t", " ", 
            SubscriptBox["\[Omega]", "1"]}], "]"}]}], " ", 
         SubscriptBox["\[CapitalOmega]", 
          RowBox[{"R", ",", "1"}]]}], "+", 
        RowBox[{
         RowBox[{"Sin", "[", 
          RowBox[{"t", " ", 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["\[Omega]", "1"], "+", 
             SubscriptBox["\[CapitalDelta]", 
              RowBox[{"1", ",", "2"}]]}], ")"}]}], "]"}], " ", 
         SubscriptBox["\[CapitalOmega]", 
          RowBox[{"R", ",", "2"}]]}]}], 
       SqrtBox["6"]]},
     {"0", "0", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"Cos", "[", 
           RowBox[{"t", " ", 
            SubscriptBox["\[Omega]", "1"]}], "]"}], " ", 
          SubscriptBox["\[CapitalOmega]", 
           RowBox[{"R", ",", "1"}]]}], "+", 
         RowBox[{
          RowBox[{"Cos", "[", 
           RowBox[{"t", " ", 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["\[Omega]", "1"], "+", 
              SubscriptBox["\[CapitalDelta]", 
               RowBox[{"1", ",", "2"}]]}], ")"}]}], "]"}], " ", 
          SubscriptBox["\[CapitalOmega]", 
           RowBox[{"R", ",", "2"}]]}]}], 
        SqrtBox["6"]]}], 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", 
           RowBox[{"t", " ", 
            SubscriptBox["\[Omega]", "1"]}], "]"}]}], " ", 
         SubscriptBox["\[CapitalOmega]", 
          RowBox[{"R", ",", "1"}]]}], "+", 
        RowBox[{
         RowBox[{"Sin", "[", 
          RowBox[{"t", " ", 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["\[Omega]", "1"], "+", 
             SubscriptBox["\[CapitalDelta]", 
              RowBox[{"1", ",", "2"}]]}], ")"}]}], "]"}], " ", 
         SubscriptBox["\[CapitalOmega]", 
          RowBox[{"R", ",", "2"}]]}]}], 
       SqrtBox["6"]], "0", 
      RowBox[{"Energy", "[", "2", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[28]//MatrixForm=",
 CellID->2039935945,ExpressionUUID->"edbce41e-7bac-41f6-92eb-71cea4a1d2f0"]
}, Open  ]],

Cell["\<\
Find effective pumping strengths by integrating the Hamiltonian over time \
with a weighting factor.\
\>", "MathCaption",
 CellID->58653631,ExpressionUUID->"a913126d-9615-4452-87f7-0081f2901a58"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"hcart", "=", 
    RowBox[{
     RowBox[{"ToCartesian", "[", 
      RowBox[{"sys", ",", 
       RowBox[{"(", 
        RowBox[{"h", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            SubscriptBox["\[CapitalOmega]", 
             RowBox[{"R", ",", "1"}]], "\[Rule]", "1"}], ",", 
           RowBox[{
            SubscriptBox["\[CapitalOmega]", 
             RowBox[{"R", ",", "2"}]], "\[Rule]", "1"}]}], "}"}]}], ")"}]}], 
      "]"}], "//", "ExpandAll"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[29]:=",
 CellID->533762247,ExpressionUUID->"2805fbb5-f864-40bf-9665-7beb42744cc8"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", 
         RowBox[{"2", " ", 
          SqrtBox["6"]}]]}], "-", 
       FractionBox[
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", 
          SubscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}]]}]], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}]},
     {"0", "0", "0", 
      RowBox[{
       FractionBox["\[ImaginaryI]", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", 
           SubscriptBox["\[CapitalDelta]", 
            RowBox[{"1", ",", "2"}]]}]]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}]},
     {"0", "0", "0", "0"},
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", 
         RowBox[{"2", " ", 
          SqrtBox["6"]}]]}], "-", 
       FractionBox[
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
          SubscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}]]}]], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", 
         RowBox[{"2", " ", 
          SqrtBox["6"]}]]}], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
           SubscriptBox["\[CapitalDelta]", 
            RowBox[{"1", ",", "2"}]]}]]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{"-", 
       SubscriptBox["\[CapitalDelta]", "1"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[29]//MatrixForm=",
 CellID->627003260,ExpressionUUID->"ce29b336-8b5b-483f-b982-17adafed225b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h2", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Gamma]", " ", 
       RowBox[{"Integrate", "[", 
        RowBox[{
         RowBox[{"hcart", " ", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "\[Gamma]"}], " ", "t"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "0", ",", "\[Infinity]"}], "}"}], ",", 
         RowBox[{"Assumptions", "\[Rule]", 
          RowBox[{
           RowBox[{"\[Gamma]", ">", "0"}], "&&", 
           RowBox[{
            SubscriptBox["\[CapitalDelta]", 
             RowBox[{"1", ",", "2"}]], "\[Element]", "Reals"}]}]}]}], "]"}]}],
       "//", "ExpandAll"}], "//", "FullSimplify"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[30]:=",ExpressionUUID->"995a9def-ba28-48d4-99e9-6b34609ad705"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", "\[Gamma]"}], "+", 
        RowBox[{"\[ImaginaryI]", " ", 
         SubscriptBox["\[CapitalDelta]", 
          RowBox[{"1", ",", "2"}]]}]}], 
       RowBox[{"2", " ", 
        SqrtBox["6"], " ", 
        RowBox[{"(", 
         RowBox[{"\[Gamma]", "-", 
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["\[CapitalDelta]", 
            RowBox[{"1", ",", "2"}]]}]}], ")"}]}]]},
     {"0", "0", "0", 
      FractionBox[
       SubscriptBox["\[CapitalDelta]", 
        RowBox[{"1", ",", "2"}]], 
       RowBox[{
        SqrtBox["6"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "\[Gamma]"}], "-", 
          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
           SubscriptBox["\[CapitalDelta]", 
            RowBox[{"1", ",", "2"}]]}]}], ")"}]}]]},
     {"0", "0", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         RowBox[{"2", " ", "\[Gamma]"}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          SubscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}]]}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"], " ", 
         RowBox[{"(", 
          RowBox[{"\[Gamma]", "+", 
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[CapitalDelta]", 
             RowBox[{"1", ",", "2"}]]}]}], ")"}]}]]}], 
      FractionBox[
       SubscriptBox["\[CapitalDelta]", 
        RowBox[{"1", ",", "2"}]], 
       RowBox[{
        SqrtBox["6"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "\[Gamma]"}], "+", 
          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
           SubscriptBox["\[CapitalDelta]", 
            RowBox[{"1", ",", "2"}]]}]}], ")"}]}]], "0", 
      RowBox[{"-", 
       SubscriptBox["\[CapitalDelta]", "1"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[30]//MatrixForm=",
 CellID->341534991,ExpressionUUID->"01641760-023b-474c-9894-3ff4da861765"]
}, Open  ]],

Cell[TextData[{
 "Make an interactive diagram for the rotating-frame Cartesian basis. The \
arrows showing the light-induced coupling have ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["Opacity"]], "paclet:ref/Opacity"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "aeb994de-dbe3-422e-896e-852e1ba2b639"],
 " given by the effective pumping strength found above."
}], "MathCaption",
 CellID->8791936,ExpressionUUID->"056b31d5-9e84-40a2-b46c-bf59a0ce258b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"sys", "=", "sys"}], ",", 
     RowBox[{"dm1", "=", "dmcart"}], ",", 
     RowBox[{"h01", "=", 
      RowBox[{
       RowBox[{"TrigToExp", "@", "h0cart"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", "1.4"}], ",", 
         RowBox[{
          SubscriptBox["\[Omega]", "1"], "\[Rule]", "1.4"}], ",", 
         RowBox[{
          SubscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}]], "\[Rule]", 
          RowBox[{
           SubscriptBox["\[CapitalDelta]", 
            RowBox[{"1", ",", "2"}]], "/", "25."}]}]}], "}"}]}]}], ",", 
     RowBox[{"h2", "=", 
      RowBox[{
       RowBox[{"Abs", "[", 
        RowBox[{
         SqrtBox["6"], "h2"}], "]"}], "/.", 
       RowBox[{"\[Gamma]", "\[Rule]", ".3"}]}]}]}], "}"}], ",", 
   RowBox[{"Manipulate", "[", 
    RowBox[{
     RowBox[{"Magnify", "@", 
      RowBox[{"LevelDiagram", "[", 
       RowBox[{"sys", ",", "h01", ",", "dm1", ",", 
        RowBox[{"ArrowStyle", "\[RuleDelayed]", 
         RowBox[{"Opacity", "/@", 
          RowBox[{"h2", "\[LeftDoubleBracket]", 
           RowBox[{"4", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2"}], "}"}]}], "\[RightDoubleBracket]"}]}]}], 
        ",", 
        RowBox[{"MLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<bright\>\"", ",", "\"\<dark\>\"", ",", "\"\<z\>\"", ",", 
           "\"\<\>\""}], "}"}]}], ",", 
        RowBox[{"ArrowSpacing", "\[Rule]", "0"}], ",", 
        RowBox[{"Background", "\[Rule]", 
         RowBox[{"regimefunc", "[", 
          SubscriptBox["\[CapitalDelta]", 
           RowBox[{"1", ",", "2"}]], "]"}]}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[CapitalDelta]", 
          RowBox[{"1", ",", "2"}]], ",", ".05"}], "}"}], ",", 
       RowBox[{"-", "6"}], ",", "6"}], "}"}], ",", 
     RowBox[{"SaveDefinitions", "\[Rule]", "True"}]}], "]"}]}], 
  "]"}]], "Input",
 CellLabel->"In[31]:=",
 CellID->258350227,ExpressionUUID->"969e5136-c602-4e08-9ed2-aaa1ea49de7a"],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`$15$$ = -3.1, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`$15$$], 0.05, 
       RawBoxes[
        SubscriptBox["\[CapitalDelta]", 
         RowBox[{"1", ",", "2"}]]]}, -6, 6}}, Typeset`size$$ = {
    237., {77., 85.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = False, $CellContext`$15$10340$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`$15$$ = 0.05}, 
      "ControllerVariables" :> {
        Hold[$CellContext`$15$$, $CellContext`$15$10340$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Magnify[
        AtomicDensityMatrix`LevelDiagram[{
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NaturalWidth -> 0, 
           AtomicDensityMatrix`M -> -1], 
          AtomicDensityMatrix`AtomicState[
          2, AtomicDensityMatrix`J -> 0, 
           AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
           AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
           0]}, {{0, 0, 
           0, ((Rational[-1, 2] 6^Rational[-1, 2]) 
             E^(Complex[0., -1.4] AtomicDensityMatrix`t)) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 1] + ((
              Rational[-1, 2] 6^Rational[-1, 2]) 
             E^(Complex[0., 1.4] AtomicDensityMatrix`t)) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 1] + ((
              Rational[-1, 2] 6^Rational[-1, 2]) 
             E^((Complex[0, -1] AtomicDensityMatrix`t) (1.4 + 
                0.04 $CellContext`$15$$))) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 2] + ((
              Rational[-1, 2] 6^Rational[-1, 2]) 
             E^((Complex[0, 1] AtomicDensityMatrix`t) (1.4 + 
                0.04 $CellContext`$15$$))) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 2]}, {
          0, 0, 0, ((Complex[0, 
                Rational[-1, 2]] 6^Rational[-1, 2]) 
             E^(Complex[0., -1.4] AtomicDensityMatrix`t)) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 1] + ((
              Complex[0, 
                Rational[1, 2]] 6^Rational[-1, 2]) 
             E^(Complex[0., 1.4] AtomicDensityMatrix`t)) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 1] + ((
              Complex[0, 
                Rational[1, 2]] 6^Rational[-1, 2]) 
             E^((Complex[0, -1] AtomicDensityMatrix`t) (1.4 + 
                0.04 $CellContext`$15$$))) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 2] + ((
              Complex[0, 
                Rational[-1, 2]] 6^Rational[-1, 2]) 
             E^((Complex[0, 1] AtomicDensityMatrix`t) (1.4 + 
                0.04 $CellContext`$15$$))) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 2]}, {0, 
          0, 0, 0}, {((Rational[-1, 2] 6^Rational[-1, 2]) 
             E^(Complex[0., -1.4] AtomicDensityMatrix`t)) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 1] + ((
              Rational[-1, 2] 6^Rational[-1, 2]) 
             E^(Complex[0., 1.4] AtomicDensityMatrix`t)) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 1] + ((
              Rational[-1, 2] 6^Rational[-1, 2]) 
             E^((Complex[0, -1] AtomicDensityMatrix`t) (1.4 + 
                0.04 $CellContext`$15$$))) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 2] + ((
              Rational[-1, 2] 6^Rational[-1, 2]) 
             E^((Complex[0, 1] AtomicDensityMatrix`t) (1.4 + 
                0.04 $CellContext`$15$$))) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 2], ((
              Complex[0, 
                Rational[-1, 2]] 6^Rational[-1, 2]) 
             E^(Complex[0., -1.4] AtomicDensityMatrix`t)) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 1] + ((
              Complex[0, 
                Rational[1, 2]] 6^Rational[-1, 2]) 
             E^(Complex[0., 1.4] AtomicDensityMatrix`t)) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 1] + ((
              Complex[0, 
                Rational[1, 2]] 6^Rational[-1, 2]) 
             E^((Complex[0, -1] AtomicDensityMatrix`t) (1.4 + 
                0.04 $CellContext`$15$$))) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 2] + ((
              Complex[0, 
                Rational[-1, 2]] 6^Rational[-1, 2]) 
             E^((Complex[0, 1] AtomicDensityMatrix`t) (1.4 + 
                0.04 $CellContext`$15$$))) 
            Subscript[$CellContext`\[CapitalOmega], $CellContext`R, 2], 0, 
           1.4}}, {{
          2^Rational[-1, 2] (Complex[0., 0.] - 
             0.007141778489984129 ((1.0200000000000002` + 
               3.0000000000000004` (0.020808 + 
                 Complex[0., -1.0506] $CellContext`$15$$ - 
                 1.01 $CellContext`$15$$^2) + (
                 0.0918 (0.01 + Complex[0, -1] $CellContext`$15$$)) (1.0404 + 
                 Complex[0., -1.02] $CellContext`$15$$ + 
                 2 $CellContext`$15$$^2))/(0.042024 + 
              3.0000000000000004` (0.0011725308 + 
                1.072939 $CellContext`$15$$^2) + (
                0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                4 $CellContext`$15$$^2) + 
              0.18000000000000002` (0.0005401548719999999 + 
                2.15560272 $CellContext`$15$$^2 + 
                4.2024 $CellContext`$15$$^4))) + 
             0.0070710678118654745` ((1.0506000000000002` + 
                3.0000000000000004` (0.03194028 + 
                  1.0609 $CellContext`$15$$^2) + (
                  0.28371708 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                  4 $CellContext`$15$$^2) + 
                9.18 (0.000317322 + 1.051416 $CellContext`$15$$^2 + 
                  0.04 $CellContext`$15$$^4))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4)))) - 
           2^Rational[-1, 2] (Complex[0., 0.] + 
            0.007141778489984129 ((1.0200000000000002` + 
               3.0000000000000004` (0.020808 + 
                 Complex[0., 1.0506] $CellContext`$15$$ - 
                 1.01 $CellContext`$15$$^2) + (
                 0.0918 (0.01 + Complex[0, 1] $CellContext`$15$$)) (1.0404 + 
                 Complex[0., 1.02] $CellContext`$15$$ + 
                 2 $CellContext`$15$$^2))/(0.042024 + 
              3.0000000000000004` (0.0011725308 + 
                1.072939 $CellContext`$15$$^2) + (
                0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                4 $CellContext`$15$$^2) + 
              0.18000000000000002` (0.0005401548719999999 + 
                2.15560272 $CellContext`$15$$^2 + 
                4.2024 $CellContext`$15$$^4))) - 
            0.0070710678118654745` ((1.0506000000000002` + 
              3.0000000000000004` (0.03194028 - 
                0.9793 $CellContext`$15$$^2) + (
                0.28371708 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                4 $CellContext`$15$$^2) + 
              9. (0.00032366843999999997` + 1.0728564 $CellContext`$15$$^2 + 
                4.1616 $CellContext`$15$$^4))/(0.042024 + 
             3.0000000000000004` (0.0011725308 + 
               1.072939 $CellContext`$15$$^2) + (
               0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
               4 $CellContext`$15$$^2) + 
             0.18000000000000002` (0.0005401548719999999 + 
               2.15560272 $CellContext`$15$$^2 + 
               4.2024 $CellContext`$15$$^4)))), (Complex[0, 1] 
             2^Rational[-1, 2]) (Complex[0., 0.] - 
             0.007141778489984129 ((1.0200000000000002` + 
               3.0000000000000004` (0.020808 + 
                 Complex[0., -1.0506] $CellContext`$15$$ - 
                 1.01 $CellContext`$15$$^2) + (
                 0.0918 (0.01 + Complex[0, -1] $CellContext`$15$$)) (1.0404 + 
                 Complex[0., -1.02] $CellContext`$15$$ + 
                 2 $CellContext`$15$$^2))/(0.042024 + 
              3.0000000000000004` (0.0011725308 + 
                1.072939 $CellContext`$15$$^2) + (
                0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                4 $CellContext`$15$$^2) + 
              0.18000000000000002` (0.0005401548719999999 + 
                2.15560272 $CellContext`$15$$^2 + 
                4.2024 $CellContext`$15$$^4))) + 
             0.0070710678118654745` ((1.0506000000000002` + 
                3.0000000000000004` (0.03194028 + 
                  1.0609 $CellContext`$15$$^2) + (
                  0.28371708 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                  4 $CellContext`$15$$^2) + 
                9.18 (0.000317322 + 1.051416 $CellContext`$15$$^2 + 
                  0.04 $CellContext`$15$$^4))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4)))) + (Complex[0, 1] 
             2^Rational[-1, 2]) (Complex[0., 0.] + 
             0.007141778489984129 ((1.0200000000000002` + 
                3.0000000000000004` (0.020808 + 
                  Complex[0., 1.0506] $CellContext`$15$$ - 
                  1.01 $CellContext`$15$$^2) + (
                  0.0918 (0.01 + Complex[0, 1] $CellContext`$15$$)) (1.0404 + 
                  Complex[0., 1.02] $CellContext`$15$$ + 
                  2 $CellContext`$15$$^2))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4))) - 
             0.0070710678118654745` ((1.0506000000000002` + 
               3.0000000000000004` (0.03194028 - 
                 0.9793 $CellContext`$15$$^2) + (
                 0.28371708 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               9. (0.00032366843999999997` + 1.0728564 $CellContext`$15$$^2 + 
                 4.1616 $CellContext`$15$$^4))/(0.042024 + 
              3.0000000000000004` (0.0011725308 + 
                1.072939 $CellContext`$15$$^2) + (
                0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                4 $CellContext`$15$$^2) + 
              0.18000000000000002` (0.0005401548719999999 + 
                2.15560272 $CellContext`$15$$^2 + 
                4.2024 $CellContext`$15$$^4)))), 0, 0. - 
           0.012369923201055047` ((
             Complex[0., 1.] (0.0102 + 
               Complex[0., 1.01] $CellContext`$15$$) + (
               3. (0.01 + Complex[0, 1] $CellContext`$15$$)) (
               Complex[0., 0.020808] + 1.071 $CellContext`$15$$ + 
               Complex[0., -2.04] $CellContext`$15$$^2) + (
               Complex[0., 0.093636] (1.02 + 
                Complex[0, -2] $CellContext`$15$$)) (
               0.0001 + $CellContext`$15$$^2))/(0.042024 + 
            3.0000000000000004` (0.0011725308 + 
              1.072939 $CellContext`$15$$^2) + (
              0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
              4 $CellContext`$15$$^2) + 
            0.18000000000000002` (0.0005401548719999999 + 
              2.15560272 $CellContext`$15$$^2 + 
              4.2024 $CellContext`$15$$^4))) + 
           Complex[0., -0.01224744871391589] ((
              1.01 (0.0102 + Complex[0., -1.03] $CellContext`$15$$) + (
                3.03 (0.01 + Complex[0, -1] $CellContext`$15$$)) (0.020808 + 
                Complex[0., 1.0302] $CellContext`$15$$ + 
                0.02 $CellContext`$15$$^2) + (
                0.092718 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                4 $CellContext`$15$$^2))/(0.042024 + 
             3.0000000000000004` (0.0011725308 + 
               1.072939 $CellContext`$15$$^2) + (
               0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
               4 $CellContext`$15$$^2) + 
             0.18000000000000002` (0.0005401548719999999 + 
               2.15560272 $CellContext`$15$$^2 + 
               4.2024 $CellContext`$15$$^4)))}, {
          2^Rational[-1, 2] (Complex[0., 0.] + 
             Complex[0., -0.007141778489984129] ((1.0200000000000002` + 
                3.0000000000000004` (0.020808 + 
                  Complex[0., -1.0506] $CellContext`$15$$ - 
                  1.01 $CellContext`$15$$^2) + (
                  0.0918 (0.01 + Complex[0, -1] $CellContext`$15$$)) (1.0404 + 
                  Complex[0., -1.02] $CellContext`$15$$ + 
                  2 $CellContext`$15$$^2))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4))) + 
             Complex[0., -0.0070710678118654745`] ((1.0506000000000002` + 
                3.0000000000000004` (0.03194028 + 
                  1.0609 $CellContext`$15$$^2) + (
                  0.28371708 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                  4 $CellContext`$15$$^2) + 
                9.18 (0.000317322 + 1.051416 $CellContext`$15$$^2 + 
                  0.04 $CellContext`$15$$^4))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4)))) - 
           2^Rational[-1, 2] (Complex[0., 0.] + 
            Complex[0., -0.007141778489984129] ((1.0200000000000002` + 
               3.0000000000000004` (0.020808 + 
                 Complex[0., 1.0506] $CellContext`$15$$ - 
                 1.01 $CellContext`$15$$^2) + (
                 0.0918 (0.01 + Complex[0, 1] $CellContext`$15$$)) (1.0404 + 
                 Complex[0., 1.02] $CellContext`$15$$ + 
                 2 $CellContext`$15$$^2))/(0.042024 + 
              3.0000000000000004` (0.0011725308 + 
                1.072939 $CellContext`$15$$^2) + (
                0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                4 $CellContext`$15$$^2) + 
              0.18000000000000002` (0.0005401548719999999 + 
                2.15560272 $CellContext`$15$$^2 + 
                4.2024 $CellContext`$15$$^4))) + 
            Complex[0., -0.0070710678118654745`] ((1.0506000000000002` + 
               3.0000000000000004` (0.03194028 - 
                 0.9793 $CellContext`$15$$^2) + (
                 0.28371708 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               9. (0.00032366843999999997` + 1.0728564 $CellContext`$15$$^2 + 
                 4.1616 $CellContext`$15$$^4))/(0.042024 + 
              3.0000000000000004` (0.0011725308 + 
                1.072939 $CellContext`$15$$^2) + (
                0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                4 $CellContext`$15$$^2) + 
              0.18000000000000002` (0.0005401548719999999 + 
                2.15560272 $CellContext`$15$$^2 + 
                4.2024 $CellContext`$15$$^4)))), (Complex[0, 1] 
             2^Rational[-1, 2]) (Complex[0., 0.] + 
             Complex[0., -0.007141778489984129] ((1.0200000000000002` + 
                3.0000000000000004` (0.020808 + 
                  Complex[0., -1.0506] $CellContext`$15$$ - 
                  1.01 $CellContext`$15$$^2) + (
                  0.0918 (0.01 + Complex[0, -1] $CellContext`$15$$)) (1.0404 + 
                  Complex[0., -1.02] $CellContext`$15$$ + 
                  2 $CellContext`$15$$^2))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4))) + 
             Complex[0., -0.0070710678118654745`] ((1.0506000000000002` + 
                3.0000000000000004` (0.03194028 + 
                  1.0609 $CellContext`$15$$^2) + (
                  0.28371708 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                  4 $CellContext`$15$$^2) + 
                9.18 (0.000317322 + 1.051416 $CellContext`$15$$^2 + 
                  0.04 $CellContext`$15$$^4))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4)))) + (Complex[0, 1] 
             2^Rational[-1, 2]) (Complex[0., 0.] + 
             Complex[0., -0.007141778489984129] ((1.0200000000000002` + 
                3.0000000000000004` (0.020808 + 
                  Complex[0., 1.0506] $CellContext`$15$$ - 
                  1.01 $CellContext`$15$$^2) + (
                  0.0918 (0.01 + Complex[0, 1] $CellContext`$15$$)) (1.0404 + 
                  Complex[0., 1.02] $CellContext`$15$$ + 
                  2 $CellContext`$15$$^2))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4))) + 
             Complex[0., -0.0070710678118654745`] ((1.0506000000000002` + 
                3.0000000000000004` (0.03194028 - 
                  0.9793 $CellContext`$15$$^2) + (
                  0.28371708 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                  4 $CellContext`$15$$^2) + 
                9. (0.00032366843999999997` + 1.0728564 $CellContext`$15$$^2 + 
                  4.1616 $CellContext`$15$$^4))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4)))), 0, 0. + 
           Complex[0., -0.012369923201055047`] ((
              Complex[0., 1.] (0.0102 + 
                Complex[0., 1.01] $CellContext`$15$$) + (
                3. (0.01 + Complex[0, 1] $CellContext`$15$$)) (
                Complex[0., 0.020808] + 1.071 $CellContext`$15$$ + 
                Complex[0., -2.04] $CellContext`$15$$^2) + (
                Complex[0., 0.093636] (1.02 + 
                 Complex[0, -2] $CellContext`$15$$)) (
                0.0001 + $CellContext`$15$$^2))/(0.042024 + 
             3.0000000000000004` (0.0011725308 + 
               1.072939 $CellContext`$15$$^2) + (
               0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
               4 $CellContext`$15$$^2) + 
             0.18000000000000002` (0.0005401548719999999 + 
               2.15560272 $CellContext`$15$$^2 + 
               4.2024 $CellContext`$15$$^4))) + 
           Complex[-0.01224744871391589, 0.] ((
              1.01 (0.0102 + Complex[0., -1.03] $CellContext`$15$$) + (
                3.03 (0.01 + Complex[0, -1] $CellContext`$15$$)) (0.020808 + 
                Complex[0., 1.0302] $CellContext`$15$$ + 
                0.02 $CellContext`$15$$^2) + (
                0.092718 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                4 $CellContext`$15$$^2))/(0.042024 + 
             3.0000000000000004` (0.0011725308 + 
               1.072939 $CellContext`$15$$^2) + (
               0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
               4 $CellContext`$15$$^2) + 
             0.18000000000000002` (0.0005401548719999999 + 
               2.15560272 $CellContext`$15$$^2 + 
               4.2024 $CellContext`$15$$^4)))}, {
           Complex[0., 0.], 
           Complex[0., 0.], 
           Complex[0., 0.] + (0.020808 + 
             3.0000000000000004` (0.0005295636 + 
               1.051313 $CellContext`$15$$^2) + (
               0.0028371708000000002` (0.0001 + $CellContext`$15$$^2)) (
               1.0404 + 4 $CellContext`$15$$^2) + 
             0.18000000000000002` (0.00021542522399999996` + 
               1.07233824 $CellContext`$15$$^2 + 
               2.0808 $CellContext`$15$$^4))/(0.042024 + 
            3.0000000000000004` (0.0011725308 + 
              1.072939 $CellContext`$15$$^2) + (
              0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
              4 $CellContext`$15$$^2) + 
            0.18000000000000002` (0.0005401548719999999 + 
              2.15560272 $CellContext`$15$$^2 + 4.2024 $CellContext`$15$$^4)), 
           Complex[
           0., 0.]}, {(-2^Rational[-1, 2]) (0. + 
             Complex[0., -0.01749371315644566] ((
                1. (0.0102 + Complex[0., -1.01] $CellContext`$15$$) + (
                  3. (0.01 + Complex[0, -1] $CellContext`$15$$)) (0.020808 + 
                  Complex[0., 1.071] $CellContext`$15$$ - 
                  2.04 $CellContext`$15$$^2) + (
                  0.093636 (1.02 + Complex[0, 2] $CellContext`$15$$)) (
                  0.0001 + $CellContext`$15$$^2))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4)))) + 
           2^Rational[-1, 2] (0. + 
             Complex[0., 0.017320508075688773`] ((
                1.01 (0.0102 + Complex[0., 1.03] $CellContext`$15$$) + (
                  3.03 (0.01 + Complex[0, 1] $CellContext`$15$$)) (0.020808 + 
                  Complex[0., -1.0302] $CellContext`$15$$ + 
                  0.02 $CellContext`$15$$^2) + (
                  0.092718 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                  4 $CellContext`$15$$^2))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4)))), (Complex[0, 1] 
             2^Rational[-1, 2]) (0. + 
             Complex[0., -0.01749371315644566] ((
                1. (0.0102 + Complex[0., -1.01] $CellContext`$15$$) + (
                  3. (0.01 + Complex[0, -1] $CellContext`$15$$)) (0.020808 + 
                  Complex[0., 1.071] $CellContext`$15$$ - 
                  2.04 $CellContext`$15$$^2) + (
                  0.093636 (1.02 + Complex[0, 2] $CellContext`$15$$)) (
                  0.0001 + $CellContext`$15$$^2))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4)))) + (Complex[0, 1] 
             2^Rational[-1, 2]) (0. + 
             Complex[0., 0.017320508075688773`] ((
                1.01 (0.0102 + Complex[0., 1.03] $CellContext`$15$$) + (
                  3.03 (0.01 + Complex[0, 1] $CellContext`$15$$)) (0.020808 + 
                  Complex[0., -1.0302] $CellContext`$15$$ + 
                  0.02 $CellContext`$15$$^2) + (
                  0.092718 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                  4 $CellContext`$15$$^2))/(0.042024 + 
               3.0000000000000004` (0.0011725308 + 
                 1.072939 $CellContext`$15$$^2) + (
                 0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                 4 $CellContext`$15$$^2) + 
               0.18000000000000002` (0.0005401548719999999 + 
                 2.15560272 $CellContext`$15$$^2 + 
                 4.2024 $CellContext`$15$$^4)))), 0, Complex[0., 0.] + 
           0.02 ((0.010200000000000002` + 
              3. (0.00020808 + 1.0405 $CellContext`$15$$^2) + (
                0.09179999999999999 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
                2 $CellContext`$15$$^2))/(0.042024 + 
             3.0000000000000004` (0.0011725308 + 
               1.072939 $CellContext`$15$$^2) + (
               0.0085115124 (0.0001 + $CellContext`$15$$^2)) (1.0404 + 
               4 $CellContext`$15$$^2) + 
             0.18000000000000002` (0.0005401548719999999 + 
               2.15560272 $CellContext`$15$$^2 + 
               4.2024 $CellContext`$15$$^4)))}}, 
         AtomicDensityMatrix`ArrowStyle :> Map[Opacity, 
           
           Part[{{0, 0, 0, Rational[1, 2] 
              Abs[(0.3 + Complex[0, -1] $CellContext`$15$$)^(-1) (-0.6 + 
                 Complex[0, 1] $CellContext`$15$$)]}, {0, 0, 0, 
              
              Abs[(0.6 + 
                 Complex[
                   0, -2] $CellContext`$15$$)^(-1) $CellContext`$15$$]}, {0, 
             0, 0, 0}, {
             Rational[1, 2] 
              Abs[(0.3 + Complex[0, 1] $CellContext`$15$$)^(-1) (0.6 + 
                 Complex[0, 1] $CellContext`$15$$)], 
              
              Abs[(0.6 + 
                 Complex[0, 2] $CellContext`$15$$)^(-1) $CellContext`$15$$], 
              0, 6^Rational[1, 2] Abs[
                Subscript[$CellContext`\[CapitalDelta], 1]]}}, 4, {1, 2}]], 
         AtomicDensityMatrix`MLabel -> {"bright", "dark", "z", ""}, 
         AtomicDensityMatrix`ArrowSpacing -> 0, 
         Background -> $CellContext`regimefunc[$CellContext`$15$$]]], 
      "Specifications" :> {{{$CellContext`$15$$, 0.05, 
          RawBoxes[
           SubscriptBox["\[CapitalDelta]", 
            RowBox[{"1", ",", "2"}]]]}, -6, 6}}, "Options" :> {}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{279., {123., 128.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>({AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, 
         AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`LevelDiagram`Private`sys], {{0}}, 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
          Except[
           PatternTest[
            Blank[], MatchQ[
             Flatten[{#}], {
              RepeatedNull[
               Alternatives[
                Blank[Rule], 
                Blank[RuleDelayed]]]}]& ]]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, 
         AtomicDensityMatrix`LevelDiagram`Private`h, {{0}}, 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`energies, 
           Blank[]], VectorQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
          Except[
           PatternTest[
            Blank[], MatchQ[
             Flatten[{#}], {
              RepeatedNull[
               Alternatives[
                Blank[Rule], 
                Blank[RuleDelayed]]]}]& ]]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, 
         DiagonalMatrix[AtomicDensityMatrix`LevelDiagram`Private`energies], 
         AtomicDensityMatrix`LevelDiagram`Private`rho, 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
          Except[
           PatternTest[
            Blank[], MatchQ[
             Flatten[{#}], {
              RepeatedNull[
               Alternatives[
                Blank[Rule], 
                Blank[RuleDelayed]]]}]& ]]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pops, {
           Repeated[
            PatternTest[
             Blank[], NumericQ]]}], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, 
         AtomicDensityMatrix`LevelDiagram`Private`h, 
         DiagonalMatrix[AtomicDensityMatrix`LevelDiagram`Private`pops], 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
           Blank[]], AtomicDensityMatrix`OperatorQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
           Blank[]], AtomicDensityMatrix`OperatorQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, {{
          AtomicDensityMatrix`LevelDiagram`Private`h, 
           
           FilterRules[{AtomicDensityMatrix`LevelDiagram`Private`opts}, 
            AtomicDensityMatrix`ExtraArrows]}}, 
         AtomicDensityMatrix`LevelDiagram`Private`rho, 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`hlist, {
           Repeated[{
             PatternTest[
              Blank[], AtomicDensityMatrix`OperatorQ], 
             PatternTest[
              BlankNullSequence[], MatchQ[
               Flatten[{#}], {
                RepeatedNull[
                 Alternatives[
                  Blank[Rule], 
                  Blank[RuleDelayed]]]}]& ]}]}], 
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
           Blank[]], AtomicDensityMatrix`OperatorQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
          AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          AtomicDensityMatrix`LevelDiagram`Private`jflabels, 
          AtomicDensityMatrix`LevelDiagram`Private`levels, 
          AtomicDensityMatrix`LevelDiagram`Private`mlabels, 
          AtomicDensityMatrix`LevelDiagram`Private`populations, 
          AtomicDensityMatrix`LevelDiagram`Private`pos, 
          AtomicDensityMatrix`LevelDiagram`Private`width, 
          AtomicDensityMatrix`LevelDiagram`Private`xmax, 
          AtomicDensityMatrix`LevelDiagram`Private`xmin, 
          AtomicDensityMatrix`LevelDiagram`Private`ymax, 
          AtomicDensityMatrix`LevelDiagram`Private`ymin, 
          AtomicDensityMatrix`LevelDiagram`Private`height, 
          AtomicDensityMatrix`LevelDiagram`Private`defaultarrsty, 
          AtomicDensityMatrix`LevelDiagram`Private`defaultpopsty}, 
         AtomicDensityMatrix`LevelDiagram`Private`subscripts = PadRight[{}, 3, 
            OptionValue[AtomicDensityMatrix`QuantumNumberSubscripts]]; 
         AtomicDensityMatrix`LevelDiagram`Private`statelabels = Union[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`LevelDiagram`Private`sys]]; {
           AtomicDensityMatrix`LevelDiagram`Private`pos, 
            AtomicDensityMatrix`LevelDiagram`Private`xmin, 
            AtomicDensityMatrix`LevelDiagram`Private`xmax, 
            AtomicDensityMatrix`LevelDiagram`Private`width, 
            AtomicDensityMatrix`LevelDiagram`Private`ymin, 
            AtomicDensityMatrix`LevelDiagram`Private`ymax, 
            AtomicDensityMatrix`LevelDiagram`Private`height} = 
          AtomicDensityMatrix`LevelDiagram`Private`findLevelPositions[
           AtomicDensityMatrix`LevelDiagram`Private`sys, 
            First[
             First[AtomicDensityMatrix`LevelDiagram`Private`hlist]], 
            AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
            OptionValue[AtomicDensityMatrix`LevelLength], 
            OptionValue[AtomicDensityMatrix`LevelSpacing], 
            OptionValue[AtomicDensityMatrix`ParityOffset], 
            OptionValue[AtomicDensityMatrix`LevelOffset]]; 
         AtomicDensityMatrix`LevelDiagram`Private`levels = 
          AtomicDensityMatrix`LevelDiagram`Private`makeLevels[
           AtomicDensityMatrix`LevelDiagram`Private`pos, 
            OptionValue[AtomicDensityMatrix`LevelStyle], 
            OptionValue[AtomicDensityMatrix`LevelLength]]; 
         AtomicDensityMatrix`LevelDiagram`Private`mlabels = 
          AtomicDensityMatrix`LevelDiagram`Private`makeMLabels[
           AtomicDensityMatrix`LevelDiagram`Private`sys, 
            AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
            AtomicDensityMatrix`LevelDiagram`Private`pos, 
            AtomicDensityMatrix`LevelDiagram`Private`ymin, 
            AtomicDensityMatrix`LevelDiagram`Private`ymax, 
            AtomicDensityMatrix`LevelDiagram`Private`height, 
            OptionValue[AtomicDensityMatrix`MLabel], 
            OptionValue[AtomicDensityMatrix`MLabelPosition], 
            Part[
             OptionValue[AtomicDensityMatrix`QuantumNumberSymbols], 3], 
            Part[AtomicDensityMatrix`LevelDiagram`Private`subscripts, 3], 
            OptionValue[LabelStyle]]; 
         AtomicDensityMatrix`LevelDiagram`Private`jflabels = 
          AtomicDensityMatrix`LevelDiagram`Private`makeJFLabels[
           AtomicDensityMatrix`LevelDiagram`Private`sys, 
            AtomicDensityMatrix`LevelDiagram`Private`pos, 
            AtomicDensityMatrix`LevelDiagram`Private`xmin, 
            AtomicDensityMatrix`LevelDiagram`Private`xmax, 
            AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
            OptionValue[AtomicDensityMatrix`QuantumNumberSymbols], 
            AtomicDensityMatrix`LevelDiagram`Private`subscripts, 
            OptionValue[LabelStyle], 
            OptionValue[AtomicDensityMatrix`LevelLength], 
            OptionValue[AtomicDensityMatrix`LevelSpacing], 
            OptionValue[AtomicDensityMatrix`MinLabelSpacing], 
            OptionValue[AtomicDensityMatrix`FLabel], 
            OptionValue[AtomicDensityMatrix`JLabel], 
            OptionValue[AtomicDensityMatrix`MLabel], 
            OptionValue[AtomicDensityMatrix`StateLabel], 
            OptionValue[AtomicDensityMatrix`StateLabelPosition]]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrows = Apply[Join, 
            Map[
            AtomicDensityMatrix`LevelDiagram`Private`setupArrows[
             AtomicDensityMatrix`LevelDiagram`Private`sys, 
              First[#], AtomicDensityMatrix`LevelDiagram`Private`pos, 
              FilterRules[{
                Rest[#], 
                FilterRules[{AtomicDensityMatrix`LevelDiagram`Private`opts, 
                  Options[AtomicDensityMatrix`LevelDiagram]}, 
                 Except[AtomicDensityMatrix`ExtraArrows]]}, 
               Options[
               AtomicDensityMatrix`LevelDiagram`Private`setupArrows]]]& , 
             AtomicDensityMatrix`LevelDiagram`Private`hlist]]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrows = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustArrows[
           AtomicDensityMatrix`LevelDiagram`Private`arrows, 
            OptionValue[AtomicDensityMatrix`ArrowSpacing], 
            OptionValue[AtomicDensityMatrix`LevelLength]]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrows = 
          ReplaceAll[
           AtomicDensityMatrix`LevelDiagram`Private`arrows, 
            AtomicDensityMatrix`LevelDiagram`Private`arf -> (#3[#, #2]& )]; 
         AtomicDensityMatrix`LevelDiagram`Private`populations = 
          AtomicDensityMatrix`LevelDiagram`Private`makePopulations[
           AtomicDensityMatrix`LevelDiagram`Private`rho, 
            AtomicDensityMatrix`LevelDiagram`Private`pos, 
            OptionValue[AtomicDensityMatrix`PopulationFunction], 
            OptionValue[AtomicDensityMatrix`PopulationStyle], 
            OptionValue[AtomicDensityMatrix`LevelLength]]; 
         AtomicDensityMatrix`LevelDiagram`Private`defaultarrsty = Directive[
            RGBColor[0.9, 0.01, 0.01], 
            
            Arrowheads[({-0.2, 0.2} 
              OptionValue[AtomicDensityMatrix`LevelLength])/
             AtomicDensityMatrix`LevelDiagram`Private`width]]; 
         AtomicDensityMatrix`LevelDiagram`Private`defaultpopsty = Directive[
            EdgeForm[
             Hue[0.61, 0.54, 0.56]], 
            FaceForm[]]; If[
           OptionValue[AtomicDensityMatrix`TextOnTop], 
           AtomicDensityMatrix`TextOnTop, Identity][
           
           Graphics[{
            AtomicDensityMatrix`LevelDiagram`Private`levels, 
             AtomicDensityMatrix`LevelDiagram`Private`mlabels, 
             AtomicDensityMatrix`LevelDiagram`Private`jflabels, {
             AtomicDensityMatrix`LevelDiagram`Private`defaultpopsty, 
              AtomicDensityMatrix`LevelDiagram`Private`populations}, {
             AtomicDensityMatrix`LevelDiagram`Private`defaultarrsty, 
              AtomicDensityMatrix`LevelDiagram`Private`arrows}}, 
            DeleteCases[
             FilterRules[
              Join[{AtomicDensityMatrix`LevelDiagram`Private`opts}, 
               Options[AtomicDensityMatrix`LevelDiagram]], 
              Options[Graphics]], 
             Apply[Alternatives, 
              Options[Graphics]]]]]], 
       Options[AtomicDensityMatrix`LevelDiagram] := {
        AtomicDensityMatrix`ArrowStyle -> {}, 
         AtomicDensityMatrix`ArrowSpacing -> 0.1, 
         AtomicDensityMatrix`ExtraArrows -> {}, 
         AtomicDensityMatrix`LevelStyle -> {}, 
         AtomicDensityMatrix`LevelLength -> 0.8, 
         AtomicDensityMatrix`LevelSpacing -> 0.2, AtomicDensityMatrix`MLabel -> 
         None, AtomicDensityMatrix`MLabelPosition -> Automatic, 
         AtomicDensityMatrix`FLabel -> None, AtomicDensityMatrix`JLabel -> 
         None, AtomicDensityMatrix`StateLabel -> None, 
         AtomicDensityMatrix`StateLabelPosition -> Left, LabelStyle -> {}, 
         AtomicDensityMatrix`MinLabelSpacing -> 0.3, 
         AtomicDensityMatrix`ParityOffset -> Automatic, 
         AtomicDensityMatrix`LevelOffset -> None, 
         AtomicDensityMatrix`MaxArcSlope -> 0.2, 
         AtomicDensityMatrix`ArcRadius -> -0.5, 
         AtomicDensityMatrix`SuppressOffResonantCouplings -> True, 
         AtomicDensityMatrix`PopulationFunction -> Automatic, 
         AtomicDensityMatrix`PopulationStyle -> {}, 
         AtomicDensityMatrix`ArrowFunction -> Automatic, 
         AtomicDensityMatrix`ArrowOffset -> {0, 0}, 
         AtomicDensityMatrix`ArrowSetback -> 0, 
         AtomicDensityMatrix`QuantumNumberSymbols -> {
          AtomicDensityMatrix`J, AtomicDensityMatrix`F, 
           AtomicDensityMatrix`M}, 
         AtomicDensityMatrix`QuantumNumberSubscripts -> {True, True, False}, 
         AtomicDensityMatrix`TextOnTop -> True, ImageSize -> {{350}, {100}}, 
         AlignmentPoint -> Center, AspectRatio -> Automatic, Axes -> False, 
         AxesLabel -> None, AxesOrigin -> Automatic, AxesStyle -> {}, 
         Background -> None, BaselinePosition -> Automatic, BaseStyle -> {}, 
         ColorOutput -> Automatic, ContentSelectable -> Automatic, 
         CoordinatesToolOptions -> Automatic, 
         DisplayFunction :> $DisplayFunction, Epilog -> {}, FormatType :> 
         TraditionalForm, Frame -> False, FrameLabel -> None, 
         FrameStyle -> {}, FrameTicks -> Automatic, FrameTicksStyle -> {}, 
         GridLines -> None, GridLinesStyle -> {}, ImageMargins -> 0., 
         ImagePadding -> All, ImageSizeRaw -> Automatic, Method -> Automatic, 
         PlotLabel -> None, PlotRange -> {-0.3, 1.7}, PlotRangeClipping -> 
         False, PlotRangePadding -> Automatic, PlotRegion -> Automatic, 
         PreserveImageOptions -> Automatic, Prolog -> {}, RotateLabel -> True,
          Ticks -> Automatic, TicksStyle -> {}}, 
       TagSet[AtomicDensityMatrix`LevelDiagram, 
        MessageName[AtomicDensityMatrix`LevelDiagram, "usage"], 
        "\!\(\*TagBox[RowBox[{\"LevelDiagram[\", StyleBox[\"sys\", \"TI\"], \
\"] draws a level diagram for atomic system \", StyleBox[\"sys\", \"TI\"], \" \
using specified values of the AtomicState Energy parameter for the level \
energies, or default values if they are not specified.\", \
\"\[LineSeparator]\", \"LevelDiagram[\", StyleBox[RowBox[{\"sys, h\"}], \
\"TI\"], \"] uses energies specified in the Hamiltonian \", StyleBox[\"h\", \
\"TI\"], \" and draws arrows representing level couplings.\", \"\
\[LineSeparator]\", \"LevelDiagram[\", StyleBox[\"sys\", \"TI\"], \", \", \
StyleBox[\"h\", \"TI\"], \", \", StyleBox[\"dm\", \"TI\"], \"] draws \
populations for each level as specified by the diagonal elements of the \
density matrix \", StyleBox[\"dm\", \"TI\"], \".\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`AtomicSystemQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := MatchQ[AtomicDensityMatrix`AtomicSystem`Private`expr, 
         AtomicDensityMatrix`AtomicSystemPattern[]], 
       TagSet[AtomicDensityMatrix`AtomicSystemQ, 
        MessageName[AtomicDensityMatrix`AtomicSystemQ, "usage"], 
        "\!\(\*TagBox[RowBox[{\"AtomicSystemQ[\", StyleBox[\"expr\", \"TI\"], \
\"] tests if expression \", StyleBox[\"expr\", \"TI\"], \" has the form of an \
atomic system (list of AtomicState objects).\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`AtomicSystemPattern[] = {
         Repeated[
          Blank[AtomicDensityMatrix`AtomicState]]}, 
       TagSet[AtomicDensityMatrix`AtomicSystemPattern, 
        MessageName[AtomicDensityMatrix`AtomicSystemPattern, "usage"], ""], 
       UpSetDelayed[
        AtomicDensityMatrix`StateParameters[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]], 
        Rest[
         Apply[List, AtomicDensityMatrix`AtomicSystem`Private`state]]], 
       AtomicDensityMatrix`AtomicState[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`label, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`rules, 
           BlankNullSequence[Rule]]}] := 
       AtomicDensityMatrix`AtomicState[
        AtomicDensityMatrix`AtomicSystem`Private`label, 
         AtomicDensityMatrix`AtomicSystem`Private`rules], 
       TagSet[AtomicDensityMatrix`AtomicState, 
        MessageName[AtomicDensityMatrix`AtomicState, "usage"], 
        "\!\(\*TagBox[RowBox[{\"AtomicState[\", StyleBox[\"label\", \"TI\"], \
\"] represents a labeled atomic state. \", \"\[LineSeparator]\", \
\"AtomicState[\", StyleBox[\"label\", \"TI\"], \",\", \
SubscriptBox[StyleBox[\"par\", \"TI\"], StyleBox[\"1\", \"TR\"]], \
\"\[Rule]\", StyleBox[\"val\", \"TI\"], \",\", SubscriptBox[StyleBox[\"par\", \
\"TI\"], StyleBox[\"2\", \"TR\"]], \"\[Rule]\", StyleBox[\"val\", \"TI\"], \
\",\", StyleBox[\"\[Ellipsis]\", \"TR\"], \"] represents an atomic state with \
one or more specified atomic parameters\"}], DisplayForm]\)"], 
       TagSet[AtomicDensityMatrix`StateParameters, 
        MessageName[AtomicDensityMatrix`StateParameters, "usage"], 
        "StateParameters[\!\(\*\nStyleBox[\"state\", \"TI\"]\)] returns the \
state parameters of the AtomicState \!\(\*\nStyleBox[\"state\", \"TI\"]\)."], 
       AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0]] = 0, 
       AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1]] = 
       AtomicDensityMatrix`Energy[2], AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = 0, AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       0, AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       0, AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = AtomicDensityMatrix`Energy[2], 
       AtomicDensityMatrix`Energy[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = (
         2.1055962340701206`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = (
         2.2099578666293674`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         2.4949718469632683`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         2.110179504793416*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         5.751786570324602*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         5.798576475256555*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         2.4949718469632683`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         2.110179504793416*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         5.751786570324602*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         5.798576475256555*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = (
         1.5494714188784714`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = (
         1.5494783111595566`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = (3.1850255752395*^10 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = (
         3.1850069663593517`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = (
         3.1850055267711067`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = (
         3.1320876072969864`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = (
         3.011129565898232*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = (2.445956596069698*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = (2.456827149264637*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`Energy[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = (
         2.8073302517638264`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = (
         2.807394295917115*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = (5.49515580877772*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = (5.495146390519883*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = (3.193951666696825*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = (
         3.1971907769791055`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = (6.507783722448681*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = (6.507777129668197*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = (5.701246315122138*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = (5.702299276348264*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = (4.848517438966578*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (
         2.3694355849920673`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (2.414190843897715*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (2.36943607313472*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (
         2.4141913345832973`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`Energy, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`Energy -> AtomicDensityMatrix`Energy[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`Energy[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`Energy, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`Energy, 
        MessageName[AtomicDensityMatrix`Energy, "usage"], 
        "\!\(\*TagBox[RowBox[{\"Energy is a parameter for AtomicState that \
specifies the (fine\[Hyphen]structure) energy of the state in units of \
angular frequency.\", \"\[LineSeparator]\", \"Energy[\", StyleBox[\"state\", \
\"TI\"], \"] returns the value specified for Energy in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or Energy[StateLabel[\", StyleBox[\"state\", \
\"TI\"], \"]] if it is not specified.\"}], DisplayForm]\)"], 
       TagSet[Units`Mega, 
        MessageName[Units`Mega, "symbol"], "M"], 
       TagSet[Units`Mega, 
        MessageName[Units`Mega, "usage"], 
        "Mega is the SI unit prefix denoting \!\(\*SuperscriptBox[\"10\", \"6\
\"]\)."], 
       TagSet[Units`Second, 
        MessageName[Units`Second, "symbol"], "s"], 
       TagSet[Units`Second, 
        MessageName[Units`Second, "usage"], 
        "Second is the fundamental SI unit of time."], AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0]] = 1, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1]] = 0, 
       AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = 1, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       1, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       1, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = 0, 
       AtomicDensityMatrix`J[{"Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 5/2, 
       AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 5/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 
       0, AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 
       1, AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 
       2, AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 
       0, AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 
       1, AtomicDensityMatrix`J[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 5/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 
       5/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1/2, 
       AtomicDensityMatrix`J[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`J[AtomicDensityMatrix`AtomicSystem`Private`state] = 
        ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`J, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state]], 
          AtomicDensityMatrix`J -> 0]), AtomicDensityMatrix`J[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`J, 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`J, 
        MessageName[AtomicDensityMatrix`J, "usage"], 
        "\!\(\*TagBox[RowBox[{\"J is a parameter for AtomicState that \
specifies the total electronic angular\[Hyphen]momentum (orbital plus spin) \
quantum number for the state. \", \"\[LineSeparator]\", \"J[\", \
StyleBox[\"state\", \"TI\"], \"] returns the value specified for J in \
AtomicState \", StyleBox[\"state\", \"TI\"], \", or J[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified. \"}], \
DisplayForm]\)"], AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0]] = 0, 
       AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 
          1]] = $CellContext`\[CapitalGamma], AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = 0, 
       AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       0, AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       0, AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = $CellContext`\[CapitalGamma], 
       AtomicDensityMatrix`NaturalWidth[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = (28.743065735391337` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = (32.8893274132544 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         131.57894736842104` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         131.57894736842104` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         131.57894736842104` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         131.57894736842104` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`NaturalWidth[{
         "H", 1, {{2, "p"}}, {2, "P", 1/2}}] = (625. Units`Mega)/Units`Second,
        AtomicDensityMatrix`NaturalWidth[{
         "H", 1, {{2, "p"}}, {2, "P", 3/2}}] = (625. Units`Mega)/Units`Second,
        AtomicDensityMatrix`NaturalWidth[{
         "He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = (10.178760197630933` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = (10.178760197630933` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = (10.178760197630933` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = (37.32736095558044 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = (37.80718336483932 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = (
         36.764705882352935` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = (
         36.764705882352935` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = (51.47 Units`Mega)/
        Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = (51.4 Units`Mega)/
        Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = (61.35345726731702 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = (61.54149127341653 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = (19.130000000000003` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = (19.11 Units`Mega)/
        Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = (9.507000000000001 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = (9.692 Units`Mega)/
        Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = (26.400000000000002` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (36.12847284945265 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (38.11730983274124 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (36.12847284945265 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (38.11730983274124 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`NaturalWidth, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`NaturalWidth -> AtomicDensityMatrix`NaturalWidth[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`NaturalWidth[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`NaturalWidth, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`NaturalWidth, 
        MessageName[AtomicDensityMatrix`NaturalWidth, "usage"], 
        "\!\(\*TagBox[RowBox[{\"NaturalWidth is a parameter for AtomicState \
that specifies the natural width (radiative decay rate) of the state. \", \"\
\[LineSeparator]\", \"NaturalWidth[\", StyleBox[\"state\", \"TI\"], \"] \
returns the value specified for NaturalWidth in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or NaturalWidth[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified.\"}], \
DisplayForm]\)"], 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 0.01651414747028505, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 0.016405282707387538`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 0.014754436648782503`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 0.8334952399455994, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 0, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 0.5279665446941976, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 0.3333333333333333, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 0.16650476005440062`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 1, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 0.1055933089388395, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 0.6331763474620618, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 0.6666666666666666, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 0.28715683180814133`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 0.28373916632274043`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 0.3052796654469419, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 0.061160480920020896`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 0.36682365253793825`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 0.6963290207215735, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 0.6851011143210896, 
       AtomicDensityMatrix`BranchingRatio[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := If[
         Or[
          And[
           AtomicDensityMatrix`DefinedQ[
           AtomicDensityMatrix`AtomicSystem`Private`state1, 
            AtomicDensityMatrix`BranchingRatio[
             AtomicDensityMatrix`StateLabel[
             AtomicDensityMatrix`AtomicSystem`Private`state2]]], 
           AtomicDensityMatrix`BranchingRatio[
             AtomicDensityMatrix`StateLabel[
             AtomicDensityMatrix`AtomicSystem`Private`state2]][
            AtomicDensityMatrix`AtomicSystem`Private`state1] =!= 0], 
          AtomicDensityMatrix`Parity[
           AtomicDensityMatrix`AtomicSystem`Private`state1] === 
          AtomicDensityMatrix`Parity[
           AtomicDensityMatrix`AtomicSystem`Private`state2]], 0, 
         AtomicDensityMatrix`BranchingRatio[
          AtomicDensityMatrix`StateLabel[
          AtomicDensityMatrix`AtomicSystem`Private`state1]][
         AtomicDensityMatrix`AtomicSystem`Private`state2]], 
       AtomicDensityMatrix`BranchingRatio[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`label, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`value}, 
         If[
          Or[
          AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state] === 
           AtomicDensityMatrix`AtomicSystem`Private`label, 
           AtomicDensityMatrix`NaturalWidth[
            AtomicDensityMatrix`AtomicSystem`Private`state] === 0], 0, 
          If[(AtomicDensityMatrix`AtomicSystem`Private`value = ReplaceAll[
              AtomicDensityMatrix`BranchingRatio[
              AtomicDensityMatrix`AtomicSystem`Private`label], 
              AtomicDensityMatrix`StateParameters[
              AtomicDensityMatrix`AtomicSystem`Private`state]]) =!= 
           AtomicDensityMatrix`BranchingRatio[
            AtomicDensityMatrix`AtomicSystem`Private`label], 
           AtomicDensityMatrix`AtomicSystem`Private`value, 
           AtomicDensityMatrix`BranchingRatio[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state], 
            AtomicDensityMatrix`AtomicSystem`Private`label]]]], 
       TagSet[AtomicDensityMatrix`BranchingRatio, 
        MessageName[AtomicDensityMatrix`BranchingRatio, "usage"], 
        "\!\(\*TagBox[RowBox[{\"BranchingRatio[\", StyleBox[\"label\", \
\"TI\"], \"] is a parameter for AtomicState that specifies the branching \
ratio for radiative decay to the state with label \", StyleBox[\"label\", \
\"TI\"], \".\", \"\[LineSeparator]\", \"BranchingRatio[\", \
StyleBox[\"label\", \"TI\"], \"][\", StyleBox[\"state\", \"TI\"], \"] returns \
the branching ratio for the AtomicState \", StyleBox[\"state\", \"TI\"], \" \
to the state with label \", StyleBox[\"label\", \"TI\"], \", or \
BranchingRatio[StateLabel[\", StyleBox[\"state]\", \"TI\"], \",\", \
StyleBox[\"label\", \"TI\"], \"] if it is not specified.\"}], \
DisplayForm]\)"], AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`x, 
          Alternatives[
          AtomicDensityMatrix`S, AtomicDensityMatrix`L, AtomicDensityMatrix`J,
            AtomicDensityMatrix`NuclearSpin, AtomicDensityMatrix`F, 
           AtomicDensityMatrix`M, AtomicDensityMatrix`Parity, 
           AtomicDensityMatrix`Energy, AtomicDensityMatrix`NaturalWidth, 
           AtomicDensityMatrix`GFactor, 
           AtomicDensityMatrix`BranchingRatio[
            Blank[]], AtomicDensityMatrix`LevelPosition, 
           AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
           AtomicDensityMatrix`Polarizability[
            Blank[]], 
           AtomicDensityMatrix`TransitionPolarizability[
            Blank[]]]]] := MemberQ[
         Rest[AtomicDensityMatrix`AtomicSystem`Private`state], 
         AtomicDensityMatrix`AtomicSystem`Private`x -> Blank[]], 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
          Alternatives[
           Blank[AtomicDensityMatrix`AtomicState], {
            Repeated[
             Blank[AtomicDensityMatrix`AtomicState]]}]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`x, 
          Alternatives[{
            Repeated[
             Alternatives[
             AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
              AtomicDensityMatrix`J, AtomicDensityMatrix`NuclearSpin, 
              AtomicDensityMatrix`F, AtomicDensityMatrix`M, 
              AtomicDensityMatrix`Parity, AtomicDensityMatrix`Energy, 
              AtomicDensityMatrix`NaturalWidth, AtomicDensityMatrix`GFactor, 
              AtomicDensityMatrix`BranchingRatio[
               Blank[]], AtomicDensityMatrix`LevelPosition, 
              AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
              
              AtomicDensityMatrix`Polarizability[
               Blank[]], 
              AtomicDensityMatrix`TransitionPolarizability[
               Blank[]]]]}, 
           Repeated[
            Alternatives[
            AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
             AtomicDensityMatrix`J, AtomicDensityMatrix`NuclearSpin, 
             AtomicDensityMatrix`F, AtomicDensityMatrix`M, 
             AtomicDensityMatrix`Parity, AtomicDensityMatrix`Energy, 
             AtomicDensityMatrix`NaturalWidth, AtomicDensityMatrix`GFactor, 
             AtomicDensityMatrix`BranchingRatio[
              Blank[]], AtomicDensityMatrix`LevelPosition, 
             AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
             AtomicDensityMatrix`Polarizability[
              Blank[]], 
             AtomicDensityMatrix`TransitionPolarizability[
              Blank[]]]]]]] := Apply[And, 
         Flatten[
          Outer[AtomicDensityMatrix`DefinedQ, 
           Flatten[{AtomicDensityMatrix`AtomicSystem`Private`sys}], 
           Flatten[{AtomicDensityMatrix`AtomicSystem`Private`x}]]]], 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, 
          Alternatives[
          AtomicDensityMatrix`OpticalParameters, 
           AtomicDensityMatrix`ElectricField, 
           AtomicDensityMatrix`MagneticField, 
           AtomicDensityMatrix`TransitRate[
            Blank[]], AtomicDensityMatrix`Density]]] := 
       ReplaceAll[AtomicDensityMatrix`ExperimentalSystem`Private`x, 
          AtomicDensityMatrix`RegionParameters[
          AtomicDensityMatrix`ExperimentalSystem`Private`region]] =!= 
        AtomicDensityMatrix`ExperimentalSystem`Private`x, 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, {
           Repeated[
            Alternatives[
            AtomicDensityMatrix`OpticalParameters, 
             AtomicDensityMatrix`ElectricField, 
             AtomicDensityMatrix`MagneticField, 
             AtomicDensityMatrix`TransitRate[
              Blank[]], AtomicDensityMatrix`Density]]}]] := Apply[And, 
         Map[
         AtomicDensityMatrix`DefinedQ[
          AtomicDensityMatrix`ExperimentalSystem`Private`region, #]& , 
          AtomicDensityMatrix`ExperimentalSystem`Private`x]], 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, 
          Blank[]]] := Apply[And, 
         Map[
         AtomicDensityMatrix`DefinedQ[#, 
           AtomicDensityMatrix`ExperimentalSystem`Private`x]& , 
          AtomicDensityMatrix`ExperimentalSystem`Private`sys]], 
       TagSet[AtomicDensityMatrix`DefinedQ, 
        MessageName[AtomicDensityMatrix`DefinedQ, "usage"], 
        "DefinedQ[\!\(\*\nStyleBox[\"state\", \"TI\"]\),\!\(\*\n\
StyleBox[\"param\", \"TI\"]\)] returns True if state parameter \!\(\*\n\
StyleBox[\"param\", \"TI\"]\) is specified in AtomicState \!\(\*\n\
StyleBox[\"state\", \"TI\"]\), and False otherwise.\nDefinedQ[\!\(\*\n\
StyleBox[\"state\", \"TI\"]\),{\!\(\*SubscriptBox[\nStyleBox[\"param\", \
\"TI\"], \"1\"]\),\!\(\*SubscriptBox[\nStyleBox[\"param\", \"TI\"], \"2\"]\),\
\[Ellipsis]}] returns True if all of the \!\(\*\n\
StyleBox[SubscriptBox[\"param\", \"i\"], \"TI\"]\) are specified in \!\(\*\n\
StyleBox[\"state\", \"TI\"]\), and False otherwise.\n\
DefinedQ[{\!\(\*SubscriptBox[\nStyleBox[\"state\", \"TI\"], \
\"1\"]\),\!\(\*SubscriptBox[\nStyleBox[\"state\", \"TI\"], \"2\"]\),\
\[Ellipsis]},\!\(\*\nStyleBox[\"param\", \"TI\"]\)] checks if \!\(\*\n\
StyleBox[\"param\", \"TI\"]\) is specified in all of the states.\nDefinedQ \
behaves analogously with region parameters and regions in place of state \
parameters and states."], 
       AtomicDensityMatrix`S[{"Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 
       1, AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 
       1, AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 
       1, AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 
       0, AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 
       1, AtomicDensityMatrix`S[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 
       1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`S[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`S, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`S -> AtomicDensityMatrix`S[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`S[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`S, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`S, 
        MessageName[AtomicDensityMatrix`S, "usage"], 
        "\!\(\*TagBox[RowBox[{\"S is a parameter for AtomicState that \
specifies the electronic spin angular\[Hyphen]momentum quantum number. \", \"\
\[LineSeparator]\", \"S[\", StyleBox[\"state\", \"TI\"], \"] returns the \
value specified for S in AtomicState \", StyleBox[\"state\", \"TI\"], \", or \
S[StateLabel[\", StyleBox[\"state\", \"TI\"], \"]] if it is not \
specified.\"}], DisplayForm]\)"], 
       Attributes[AtomicDensityMatrix`AtomicSystem`Private`state$] = {
        Temporary}, AtomicDensityMatrix`StateLabel[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       First[AtomicDensityMatrix`AtomicSystem`Private`state], 
       AtomicDensityMatrix`StateLabel[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`StateLabel, 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`StateLabel, 
        MessageName[AtomicDensityMatrix`StateLabel, "usage"], 
        "\!\(\*TagBox[RowBox[{\"StateLabel[\", StyleBox[\"state\", \"TI\"], \
\"] gives the label (first argument) for the AtomicState \", StyleBox[\"state\
\", \"TI\"], \".\"}], DisplayForm]\)"], 
       Attributes[AtomicDensityMatrix`AtomicSystem`Private`sys$] = {
        Temporary}, AtomicDensityMatrix`L[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = AtomicDensityMatrix`L[1], 
       AtomicDensityMatrix`L[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = AtomicDensityMatrix`L[2], 
       AtomicDensityMatrix`L[{"Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`L[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`L[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`L[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`L[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 
       1, AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 
       1, AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 
       1, AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 
       0, AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 
       0, AtomicDensityMatrix`L[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 2,
        AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 
       2, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 
       2, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 
       2, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{"Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`L[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`L, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`L -> AtomicDensityMatrix`L[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`L[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`L, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`L, 
        MessageName[AtomicDensityMatrix`L, "usage"], 
        "\!\(\*TagBox[RowBox[{\"L is a parameter for AtomicState that \
specifies the electronic orbital angular\[Hyphen]momentum quantum number for \
the state. \", \"\[LineSeparator]\", \"L[\", StyleBox[\"state\", \"TI\"], \"] \
returns the value specified for L in AtomicState \", StyleBox[\"state\", \"TI\
\"], \", or L[StateLabel[\", StyleBox[\"state\", \"TI\"], \"]] if it is not \
specified.\"}], DisplayForm]\)"], AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = -1, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       0, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       1, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = 0, AtomicDensityMatrix`M[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`M, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`M -> AtomicDensityMatrix`M[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`M[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`M, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`M, 
        MessageName[AtomicDensityMatrix`M, "usage"], 
        "\!\(\*TagBox[RowBox[{\"M is a parameter for AtomicState that \
specifies the total angular\[Hyphen]momentum projection quantum number for \
the state. \", \"\[LineSeparator]\", \"M[\", StyleBox[\"state\", \"TI\"], \"] \
returns the value specified for M in AtomicState \", StyleBox[\"state\", \"TI\
\"], \", or M[StateLabel[\", StyleBox[\"state\", \"TI\"], \"]] if it is not \
specified. \"}], DisplayForm]\)"], 
       AtomicDensityMatrix`NuclearSpin[{"Cs", 133}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{"Cu", 63}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"Cu", 65}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"H", 1}] = 1/2, 
       AtomicDensityMatrix`NuclearSpin[{"He", 2}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{"K", 39}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"Li", 3}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"Na", 23}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"Rb", 85}] = 5/2, 
       AtomicDensityMatrix`NuclearSpin[{"Rb", 87}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`NuclearSpin[{
         "H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`NuclearSpin[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 
       1/2, AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 5/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 5/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 5/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`NuclearSpin[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`NuclearSpin, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`NuclearSpin -> AtomicDensityMatrix`NuclearSpin[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`NuclearSpin[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`NuclearSpin, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`NuclearSpin, 
        MessageName[AtomicDensityMatrix`NuclearSpin, "usage"], 
        "\!\(\*TagBox[RowBox[{\"NuclearSpin is a parameter for AtomicState \
that specifies the nuclear angular\[Hyphen]momentum quantum number for the \
atom. \", \"\[LineSeparator]\", \"NuclearSpin[\", StyleBox[\"state\", \
\"TI\"], \"] returns the value specified for NuclearSpin in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or NuclearSpin[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified. \"}], \
DisplayForm]\)"], AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0]] = 1, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1]] = 0, 
       AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = 1, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       1, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       1, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = 0, AtomicDensityMatrix`F[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`F[AtomicDensityMatrix`AtomicSystem`Private`state] = 
        ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`F, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state]], 
          AtomicDensityMatrix`F -> 
          AtomicDensityMatrix`J[
           AtomicDensityMatrix`AtomicSystem`Private`state]]), 
       AtomicDensityMatrix`F[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`F, 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`F, 
        MessageName[AtomicDensityMatrix`F, "usage"], 
        "\!\(\*TagBox[RowBox[{\"F is a parameter for AtomicState that \
specifies the total angular\[Hyphen]momentum (electronic plus nuclear) \
quantum number for the state. \", \"\[LineSeparator]\", \"F[\", \
StyleBox[\"state\", \"TI\"], \"] returns the value specified for F in \
AtomicState \", StyleBox[\"state\", \"TI\"], \", or J[\", StyleBox[\"state\", \
\"TI\"], \"] if it is not specified. \"}], DisplayForm]\)"], 
       AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0]] = 
       AtomicDensityMatrix`Parity[1], AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1]] = 
       AtomicDensityMatrix`Parity[2], AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = AtomicDensityMatrix`Parity[1], 
       AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       AtomicDensityMatrix`Parity[1], AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       AtomicDensityMatrix`Parity[1], AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = AtomicDensityMatrix`Parity[2], 
       AtomicDensityMatrix`Parity[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, AtomicDensityMatrix`Parity[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`Parity, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`Parity -> AtomicDensityMatrix`Parity[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`Parity[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`Parity, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`Parity, 
        MessageName[AtomicDensityMatrix`Parity, "usage"], 
        "\!\(\*TagBox[RowBox[{\"Parity is a parameter for AtomicState that \
specifies the parity of the state.\", \"\[LineSeparator]\", \"Parity[\", \
StyleBox[\"state\", \"TI\"], \"] returns the value specified for Parity in \
AtomicState \", StyleBox[\"state\", \"TI\"], \", or Parity[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified.\"}], \
DisplayForm]\)"], 
       TagSet[AtomicDensityMatrix`Odd, 
        MessageName[AtomicDensityMatrix`Odd, "usage"], 
        "Odd is a possible value for the AtomicState parameter Parity \
specifying that the parity of the state is odd."], 
       TagSet[AtomicDensityMatrix`Even, 
        MessageName[AtomicDensityMatrix`Even, "usage"], 
        "Even is a possible value for the AtomicState parameter Parity \
specifying that the parity of the state is even."], 
       AtomicDensityMatrix`GFactor[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`GFactor[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`GFactor, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`GFactor -> AtomicDensityMatrix`GFactor[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`GFactor[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`GFactor, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`GFactor, 
        MessageName[AtomicDensityMatrix`GFactor, "usage"], 
        "\!\(\*TagBox[RowBox[{\"GFactor is a parameter for AtomicState that \
specifies the Land\[EAcute] \", SubscriptBox[\"g\", \"J\"], \"\[Hyphen]factor \
for the state, as an alternative to specifying values for L and S for the \
state. \", \"\[LineSeparator]\", \"GFactor[\", StyleBox[\"state\", \"TI\"], \
\"] returns the value specified for GFactor in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or GFactor[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified.\"}], \
DisplayForm]\)"], AtomicDensityMatrix`LevelPosition[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`LevelPosition[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`LevelPosition, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`LevelPosition -> 
          AtomicDensityMatrix`LevelPosition[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`LevelPosition[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`LevelPosition, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`LevelPosition, 
        MessageName[AtomicDensityMatrix`LevelPosition, "usage"], ""], 
       AtomicDensityMatrix`HyperfineA[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = (1834.1880831903954` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = (315.97051918747997` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = (14439.752217894069` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         11565.620623276358` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         4690.292402599044 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         3176.778491309999 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         1224.5928163693013` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = (
         36862.94554239806 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         12356.754281546078` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         4746.80194961831 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         3411.1413032677974` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         1306.2742253626361` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = (
         39486.112576292464` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = (
         8922.123136195012 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 
       0, AtomicDensityMatrix`HyperfineA[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 
       0, AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = (181.26989611213108` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = (38.07610296150829 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = (1450.5352809978547` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = (
         289.1773205776333 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {
          2, "P", 3/2}}] = ((-19.195131113433636`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = (
         2524.282535591937 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = (3.311238656883642 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = (593.3840204100401 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = (116.45255648326645` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = (5565.7276311458045` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = (1269.2034320502764` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (757.293475518434 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (157.092199050104 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = (6358.02315241775 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (2558.7643844958147` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (532.3020344462938 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = (21471.788680034824` 
         Units`Mega)/Units`Second, AtomicDensityMatrix`HyperfineA[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`HyperfineA[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`HyperfineA, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`HyperfineA -> AtomicDensityMatrix`HyperfineA[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`HyperfineA[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`HyperfineA, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`HyperfineA, 
        MessageName[AtomicDensityMatrix`HyperfineA, "usage"], 
        "\!\(\*TagBox[RowBox[{\"HyperfineA is a parameter for AtomicState \
that parameterizes the hyperfine splitting of the state due to the electronic \
interaction with the nuclear magnetic dipole moment.\", \"\[LineSeparator]\", \
\"HyperfineA[\", StyleBox[\"state\", \"TI\"], \"] returns the value specified \
for HyperfineA in AtomicState \", StyleBox[\"state\", \"TI\"], \", or \
HyperfineA[StateLabel[\", StyleBox[\"state\", \"TI\"], \"]] if it is not \
specified.\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`HyperfineB[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = ((-3.100123630562408) 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         35.41264946540644 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = ((
          1349066061 Units`Mega) Pi)/(250000000 Units`Second), 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {
          2, "P", 3/2}}] = ((-182.84069243892597`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = ((
          1349066061 Units`Mega) Pi)/(250000000 Units`Second), 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         6.969510799042757 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {
          2, "P", 3/2}}] = ((-169.01768476313086`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`HyperfineB[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 
       0, AtomicDensityMatrix`HyperfineB[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 
       0, AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = (17.781414419318228` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {
          2, "P", 3/2}}] = ((-1.3885839528866886`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = (0.7916813487046279 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = (17.115396776757194` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (162.04334907216153` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (78.51782519116969 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`HyperfineB[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`HyperfineB, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`HyperfineB -> AtomicDensityMatrix`HyperfineB[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`HyperfineB[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`HyperfineB, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`HyperfineB, 
        MessageName[AtomicDensityMatrix`HyperfineB, "usage"], 
        "\!\(\*TagBox[RowBox[{\"HyperfineB is a parameter for AtomicState \
that parameterizes the hyperfine splitting of the state due to the electronic \
interaction with the nuclear electric quadrupole moment.\", \
\"\[LineSeparator]\", \"HyperfineB[\", StyleBox[\"state\", \"TI\"], \"] \
returns the value specified for HyperfineB in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or HyperfineB[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified.\"}], \
DisplayForm]\)"], AtomicDensityMatrix`Polarizability[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`k, 
          BlankSequence[]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`value}, 
         If[(AtomicDensityMatrix`AtomicSystem`Private`value = ReplaceAll[
             AtomicDensityMatrix`Polarizability[
             AtomicDensityMatrix`AtomicSystem`Private`k], 
             AtomicDensityMatrix`StateParameters[
             AtomicDensityMatrix`AtomicSystem`Private`state]]) =!= 
          AtomicDensityMatrix`Polarizability[
           AtomicDensityMatrix`AtomicSystem`Private`k], 
          AtomicDensityMatrix`AtomicSystem`Private`value, 
          AtomicDensityMatrix`Polarizability[
          AtomicDensityMatrix`AtomicSystem`Private`k][
           AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`AtomicSystem`Private`state]]]], 
       TagSet[AtomicDensityMatrix`Polarizability, 
        MessageName[AtomicDensityMatrix`Polarizability, "usage"], 
        "Polarizability[\!\(\*\nStyleBox[\"k\", \"TI\"]\)] is a parameter \
specified in an AtomicState expression that specifies the scalar (\!\(\*\n\
StyleBox[\"k\", \"TI\"]\)=0), vector (\!\(\*\nStyleBox[\"k\", \"TI\"]\)=1), \
or tensor (\!\(\*\nStyleBox[\"k\", \"TI\"]\)=2) polarizability for the state. \
The value can be numeric or symbolic. \nPolarizability[\!\(\*\n\
StyleBox[\"k\", \"TI\"]\)][\!\(\*\nStyleBox[\"state\", \"TI\"]\)] returns the \
corresponding specified value for the polarizability of AtomicState \!\(\*\n\
StyleBox[\"state\", \"TI\"]\), or Polarizability[\!\(\*\nStyleBox[\"k\", \"TI\
\"]\)][StateLabel[\!\(\*\nStyleBox[\"state\", \"TI\"]\)]] if it is not \
specified."], AtomicDensityMatrix`TransitionPolarizability[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`k, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`value}, 
         Which[(AtomicDensityMatrix`AtomicSystem`Private`value = ReplaceAll[
             AtomicDensityMatrix`TransitionPolarizability[
             AtomicDensityMatrix`AtomicSystem`Private`k][
              AtomicDensityMatrix`StateLabel[
              AtomicDensityMatrix`AtomicSystem`Private`state1]], 
             AtomicDensityMatrix`StateParameters[
             AtomicDensityMatrix`AtomicSystem`Private`state2]]) =!= 
          AtomicDensityMatrix`TransitionPolarizability[
           AtomicDensityMatrix`AtomicSystem`Private`k][
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state1]], 
          AtomicDensityMatrix`AtomicSystem`Private`value, (
           AtomicDensityMatrix`AtomicSystem`Private`value = ReplaceAll[
             AtomicDensityMatrix`TransitionPolarizability[
             AtomicDensityMatrix`AtomicSystem`Private`k][
              AtomicDensityMatrix`StateLabel[
              AtomicDensityMatrix`AtomicSystem`Private`state2]], 
             AtomicDensityMatrix`StateParameters[
             AtomicDensityMatrix`AtomicSystem`Private`state1]]) =!= 
          AtomicDensityMatrix`TransitionPolarizability[
           AtomicDensityMatrix`AtomicSystem`Private`k][
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state2]], 
          AtomicDensityMatrix`AtomicSystem`Private`value, True, 
          AtomicDensityMatrix`TransitionPolarizability[
          AtomicDensityMatrix`AtomicSystem`Private`k][
           Apply[Sequence, 
            Sort[
             Map[
             AtomicDensityMatrix`StateLabel, {
              AtomicDensityMatrix`AtomicSystem`Private`state1, 
               AtomicDensityMatrix`AtomicSystem`Private`state2}]]]]]], 
       TagSet[AtomicDensityMatrix`TransitionPolarizability, 
        MessageName[AtomicDensityMatrix`TransitionPolarizability, "usage"], 
        ""], 
       UpSetDelayed[
        AtomicDensityMatrix`RegionParameters[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]], 
        Rest[
         Apply[List, AtomicDensityMatrix`ExperimentalSystem`Private`reg]]], 
       AtomicDensityMatrix`ExperimentalRegion[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`label, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`rules, 
           BlankNullSequence[Rule]]}] := 
       AtomicDensityMatrix`ExperimentalRegion[
        AtomicDensityMatrix`ExperimentalSystem`Private`label, 
         AtomicDensityMatrix`ExperimentalSystem`Private`rules], 
       TagSet[AtomicDensityMatrix`ExperimentalRegion, 
        MessageName[AtomicDensityMatrix`ExperimentalRegion, "usage"], ""], 
       TagSet[AtomicDensityMatrix`RegionParameters, 
        MessageName[AtomicDensityMatrix`RegionParameters, "usage"], ""], 
       AtomicDensityMatrix`OpticalParameters[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`OpticalParameters[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`OpticalParameters, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`OpticalParameters -> 
          AtomicDensityMatrix`OpticalParameters[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`OpticalParameters[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`OpticalParameters, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`OpticalParameters, 
        MessageName[AtomicDensityMatrix`OpticalParameters, "usage"], ""], 
       Attributes[AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = {
        Temporary}, AtomicDensityMatrix`RegionLabel[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := 
       First[AtomicDensityMatrix`ExperimentalSystem`Private`reg], 
       AtomicDensityMatrix`RegionLabel[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`RegionLabel, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`RegionLabel, 
        MessageName[AtomicDensityMatrix`RegionLabel, "usage"], ""], 
       Attributes[AtomicDensityMatrix`ExperimentalSystem`Private`sys$] = {
        Temporary}, AtomicDensityMatrix`ElectricField[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`ElectricField[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`ElectricField, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`ElectricField -> 
          AtomicDensityMatrix`ElectricField[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`ElectricField[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`ElectricField, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`ElectricField, 
        MessageName[AtomicDensityMatrix`ElectricField, "usage"], 
        "ElectricField is an option for Hamiltonian that specifies the \
applied external electric field."], AtomicDensityMatrix`MagneticField[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`MagneticField[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`MagneticField, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`MagneticField -> 
          AtomicDensityMatrix`MagneticField[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`MagneticField[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`MagneticField, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`MagneticField, 
        MessageName[AtomicDensityMatrix`MagneticField, "usage"], 
        "MagneticField is an option for Hamiltonian that specifies the \
applied external magnetic field."], AtomicDensityMatrix`TransitRate[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg1, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]][
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg2, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := 
       AtomicDensityMatrix`TransitRate[
         AtomicDensityMatrix`RegionLabel[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg1]][
        AtomicDensityMatrix`ExperimentalSystem`Private`reg2], 
       AtomicDensityMatrix`TransitRate[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`label, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := 
       Module[{AtomicDensityMatrix`ExperimentalSystem`Private`value}, 
         If[
         AtomicDensityMatrix`RegionLabel[
           AtomicDensityMatrix`ExperimentalSystem`Private`region] === 
          AtomicDensityMatrix`ExperimentalSystem`Private`label, 0, 
          
          If[(AtomicDensityMatrix`ExperimentalSystem`Private`value = 
            ReplaceAll[
              AtomicDensityMatrix`TransitRate[
              AtomicDensityMatrix`ExperimentalSystem`Private`label], 
              AtomicDensityMatrix`RegionParameters[
              AtomicDensityMatrix`ExperimentalSystem`Private`region]]) =!= 
           AtomicDensityMatrix`TransitRate[
            AtomicDensityMatrix`ExperimentalSystem`Private`label], 
           AtomicDensityMatrix`ExperimentalSystem`Private`value, 
           AtomicDensityMatrix`TransitRate[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`region], 
            AtomicDensityMatrix`ExperimentalSystem`Private`label]]]], 
       TagSet[AtomicDensityMatrix`TransitRate, 
        MessageName[AtomicDensityMatrix`TransitRate, "usage"], ""], 
       AtomicDensityMatrix`Density[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`Density[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`Density, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`Density -> AtomicDensityMatrix`Density[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`Density[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`Density, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`Density, 
        MessageName[AtomicDensityMatrix`Density, "usage"], ""], 
       AtomicDensityMatrix`OperatorQ[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`expr, 
          Blank[]]] := MatchQ[
         AtomicDensityMatrix`TensorType[
         AtomicDensityMatrix`TensorAlgebra`Private`expr], {
          Alternatives["Operator", "OneByOne"]}], 
       TagSet[AtomicDensityMatrix`OperatorQ, 
        MessageName[AtomicDensityMatrix`OperatorQ, "usage"], 
        "OperatorQ[expr] gives True if expr is in the form of a matrix \
operator, i.e., an n x n matrix, and gives False otherwise."], 
       AtomicDensityMatrix`TensorType[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Alternatives[
           Blank[List], 
           Blank[SparseArray]]], 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`default, 
           Blank[List]], {}]] := 
       AtomicDensityMatrix`TensorType[
        AtomicDensityMatrix`TensorAlgebra`Private`a, 
         AtomicDensityMatrix`ListDepth[
         AtomicDensityMatrix`TensorAlgebra`Private`a], 
         AtomicDensityMatrix`TensorAlgebra`Private`default], 
       AtomicDensityMatrix`TensorType[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Alternatives[
           Blank[List], 
           Blank[SparseArray]]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`depth, 
          Blank[Integer]], 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`default, 
           Blank[List]], {}]] := 
       Switch[{AtomicDensityMatrix`TensorAlgebra`Private`depth, 
          Dimensions[AtomicDensityMatrix`TensorAlgebra`Private`a], 
          Map[Dimensions, AtomicDensityMatrix`TensorAlgebra`Private`a]}, {1, 
          Blank[], 
          Blank[]}, {"Cartesian"}, {2, {1, 1}, 
          Blank[]}, {"OneByOne"}, {2, {1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]]}, 
          Blank[]}, {"Covariant"}, {2, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1}, 
          Blank[]}, {"Contravariant"}, {2, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]]}, 
          Blank[]}, {"Operator"}, {3, {1, 1, 1}, 
          Blank[]}, {"TensorDecomposition", "OneByOne"}, 
         Alternatives[{3, {1, 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           Blank[]}, {3, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1}, 
           AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{1, 
             Blank[]}]}], {"TensorDecomposition", "Covariant"}, 
         Alternatives[{3, {1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1}, 
           Blank[]}, {3, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{
             Blank[], 1}]}], {"TensorDecomposition", "Contravariant"}, 
         Alternatives[{3, {1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           Blank[]}, {3, {
            Blank[]}, 
           AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{
             Blank[], 
             Blank[]}]}], {"TensorDecomposition", "Operator"}, {3, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 1}, 
          Blank[]}, {"Cartesian", "OneByOne"}, {3, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]]}, 
          Blank[]}, {"Cartesian", "Covariant"}, {3, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]], 1}, 
          Blank[]}, {"Cartesian", "Contravariant"}, {3, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]]}, 
          Blank[]}, {"Cartesian", "Operator"}, {4, {1, 1, 1, 1}, 
          Blank[]}, {"OneByOne", "OneByOne"}, {4, {1, 1, 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]]}, 
          Blank[]}, {"OneByOne", "Covariant"}, {4, {1, 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1}, 
          Blank[]}, {"OneByOne", "Contravariant"}, {4, {1, 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]]}, 
          Blank[]}, {"OneByOne", "Operator"}, {4, {1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 1}, 
          Blank[]}, {"Covariant", "OneByOne"}, {4, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 1, 1}, 
          Blank[]}, {"Contravariant", "OneByOne"}, {4, {1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]]}, 
          Blank[]}, {"Covariant", "Covariant"}, {4, {1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]], 1}, 
          Blank[]}, {"Covariant", "Contravariant"}, {4, {1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]]}, 
          Blank[]}, {"Covariant", "Operator"}, {4, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]]}, 
          Blank[]}, {"Contravariant", "Covariant"}, {4, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]], 1}, 
          Blank[]}, {"Contravariant", "Contravariant"}, {4, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
            Blank[]]}, 
          Blank[]}, {"Contravariant", "Operator"}, {5, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 1, 1, 1}, 
          Blank[]}, {
         "TensorDecompositionMatrix", "TensorDecomposition", "OneByOne"}, {
         5, {1, 1, 1, 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
            Blank[]]}, 
          Blank[]}, {"TensorDecomposition", "OneByOne", "Operator"}, 
         Alternatives[{5, {1, 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]]}, 
           Blank[]}, {5, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1}, 
           AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{1, 
             Blank[], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
              Blank[]]}]}], {"TensorDecomposition", "Covariant", "Operator"}, 
         
         Alternatives[{5, {1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]]}, 
           Blank[]}, {5, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{
             Blank[], 1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
              Blank[]]}]}], {
         "TensorDecomposition", "Contravariant", "Operator"}, {
          Alternatives[5, 7], 
          Blank[], 
          Blank[]}, 
         Switch[{
           Dimensions[AtomicDensityMatrix`TensorAlgebra`Private`a], 
           Flatten[
            ReplaceAll[
             Map[
             AtomicDensityMatrix`TensorType[#, 
               AtomicDensityMatrix`TensorAlgebra`Private`depth - 2, 
               AtomicDensityMatrix`TensorAlgebra`Private`default]& , 
              AtomicDensityMatrix`TensorAlgebra`Private`a, {2}], 
             AtomicDensityMatrix`TensorAlgebra`Private`assumeDecomposition], \
{{3}, {1, 2}}]}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated["OneByOne"]}, {
             Repeated["Operator"]}}}, {
          "TensorDecompositionMatrix", "TensorDecomposition", "OneByOne", 
           "Operator"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Covariant", "OneByOne"]]}}}, {
          "TensorDecompositionMatrix", "TensorDecomposition", "Covariant"}, {{
           
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Covariant", "OneByOne"]]}, {
             Repeated["Operator"]}}}, {
          "TensorDecompositionMatrix", "TensorDecomposition", "Covariant", 
           "Operator"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Contravariant", "OneByOne"]]}}}, {
          "TensorDecompositionMatrix", "TensorDecomposition", 
           "Contravariant"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Contravariant", "OneByOne"]]}, {
             Repeated["Operator"]}}}, {
          "TensorDecompositionMatrix", "TensorDecomposition", "Contravariant",
            "Operator"}, {{1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated["OneByOne"]}}}, {
          "Covariant", "TensorDecomposition", "OneByOne"}, {{1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Covariant", "OneByOne"]]}}}, {
          "Covariant", "TensorDecomposition", "Covariant"}, {{1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Contravariant", "OneByOne"]]}}}, {
          "Covariant", "TensorDecomposition", "Contravariant"}, {{1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecompositionMatrix"]}, {
             Repeated["TensorDecomposition"]}, {
             Repeated["OneByOne"]}}}, {
          "Covariant", "TensorDecompositionMatrix", "TensorDecomposition", 
           "OneByOne"}, {{1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecompositionMatrix"]}, {
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Covariant", "OneByOne"]]}}}, {
          "Covariant", "TensorDecompositionMatrix", "TensorDecomposition", 
           "Covariant"}, {{1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            BlankNullSequence[]}, {{
             Repeated["TensorDecompositionMatrix"]}, {
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Contravariant", "OneByOne"]]}}}, {
          "Covariant", "TensorDecompositionMatrix", "TensorDecomposition", 
           "Contravariant"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated["OneByOne"]}}}, {
          "Contravariant", "TensorDecomposition", "OneByOne"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Covariant", "OneByOne"]]}}}, {
          "Contravariant", "TensorDecomposition", "Covariant"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            BlankNullSequence[]}, {{
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Contravariant", "OneByOne"]]}}}, {
          "Contravariant", "TensorDecomposition", "Contravariant"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            BlankNullSequence[]}, {{
             Repeated["TensorDecompositionMatrix"]}, {
             Repeated["TensorDecomposition"]}, {
             Repeated["OneByOne"]}}}, {
          "Contravariant", "TensorDecompositionMatrix", "TensorDecomposition",
            "OneByOne"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            BlankNullSequence[]}, {{
             Repeated["TensorDecompositionMatrix"]}, {
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Covariant", "OneByOne"]]}}}, {
          "Contravariant", "TensorDecompositionMatrix", "TensorDecomposition",
            "Covariant"}, {{
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            BlankNullSequence[]}, {{
             Repeated["TensorDecompositionMatrix"]}, {
             Repeated["TensorDecomposition"]}, {
             Repeated[
              Alternatives["Contravariant", "OneByOne"]]}}}, {
          "Contravariant", "TensorDecompositionMatrix", "TensorDecomposition",
            "Contravariant"}, 
          Blank[], 
          If[AtomicDensityMatrix`TensorAlgebra`Private`default === {}, 
            Message[
             MessageName[AtomicDensityMatrix`TensorType, "unrec"], 
             AtomicDensityMatrix`TensorAlgebra`Private`a]]; 
          AtomicDensityMatrix`TensorAlgebra`Private`default], 
         Blank[], If[AtomicDensityMatrix`TensorAlgebra`Private`default === {}, 
           Message[
            MessageName[AtomicDensityMatrix`TensorType, "unrec"], 
            AtomicDensityMatrix`TensorAlgebra`Private`a]]; 
         AtomicDensityMatrix`TensorAlgebra`Private`default], 
       AtomicDensityMatrix`TensorType[
         Blank[], 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`default, 
           Blank[List]], {}]] := {"Scalar"}, 
       TagSet[AtomicDensityMatrix`TensorType, 
        MessageName[AtomicDensityMatrix`TensorType, "unrec"], 
        "The expression `1` does not have a recognized tensor structure."], 
       TagSet[AtomicDensityMatrix`TensorType, 
        MessageName[AtomicDensityMatrix`TensorType, "usage"], ""], 
       AtomicDensityMatrix`ListDepth[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[SparseArray]]] := 
       ArrayDepth[AtomicDensityMatrix`TensorAlgebra`Private`a], 
       AtomicDensityMatrix`ListDepth[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[List]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`i = 0, 
          AtomicDensityMatrix`TensorAlgebra`Private`depths}, While[
           AtomicDensityMatrix`TensorAlgebra`Private`matchAtLevel[
           AtomicDensityMatrix`TensorAlgebra`Private`a, 
            Blank[List], AtomicDensityMatrix`TensorAlgebra`Private`i], 
           Increment[AtomicDensityMatrix`TensorAlgebra`Private`i]]; Which[
           And[
            AtomicDensityMatrix`TensorAlgebra`Private`matchAtLevel[
            AtomicDensityMatrix`TensorAlgebra`Private`a, 
             Blank[SparseArray], AtomicDensityMatrix`TensorAlgebra`Private`i], 
            MatchQ[
            AtomicDensityMatrix`TensorAlgebra`Private`depths = Flatten[
               Map[
               AtomicDensityMatrix`ListDepth, 
                AtomicDensityMatrix`TensorAlgebra`Private`a, {
                AtomicDensityMatrix`TensorAlgebra`Private`i}]], {
              Repeated[
               Pattern[AtomicDensityMatrix`TensorAlgebra`Private`x, 
                Blank[Integer]]]}]], 
           AtomicDensityMatrix`TensorAlgebra`Private`i + 
           First[AtomicDensityMatrix`TensorAlgebra`Private`depths], 
           AtomicDensityMatrix`TensorAlgebra`Private`matchAtLevel[
           AtomicDensityMatrix`TensorAlgebra`Private`a, 
            Except[
             Alternatives[
              Blank[List], 
              Blank[SparseArray]]], 
            AtomicDensityMatrix`TensorAlgebra`Private`i], 
           AtomicDensityMatrix`TensorAlgebra`Private`i, True, Indeterminate]],
        AtomicDensityMatrix`ListDepth[
         Blank[]] := 0, 
       TagSet[AtomicDensityMatrix`ListDepth, 
        MessageName[AtomicDensityMatrix`ListDepth, "usage"], ""], 
       AtomicDensityMatrix`TensorAlgebra`Private`matchAtLevel[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`expr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`patt, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`level, 
          Blank[]]] := 
       MatchQ[AtomicDensityMatrix`TensorAlgebra`Private`expr, 
         Nest[{
           Repeated[#]}& , AtomicDensityMatrix`TensorAlgebra`Private`patt, 
          AtomicDensityMatrix`TensorAlgebra`Private`level]], 
       AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`dims, 
          Blank[]]] := 
       With[{AtomicDensityMatrix`TensorAlgebra`Private`index = Flatten[
            Position[AtomicDensityMatrix`TensorAlgebra`Private`dims, 
             Verbatim[
              Blank[]], {1}, 1, Heads -> False]]}, 
         HoldPattern[
          Condition[
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`expr, {
             Repeated[AtomicDensityMatrix`TensorAlgebra`Private`dims]}], 
           And[
            Apply[And, 
             OddQ[
              Part[
              AtomicDensityMatrix`TensorAlgebra`Private`expr, 1, 
               AtomicDensityMatrix`TensorAlgebra`Private`index]]], 
            Or[Length[AtomicDensityMatrix`TensorAlgebra`Private`expr] == 1, 
             MatchQ[
              Differences[
               Part[
               AtomicDensityMatrix`TensorAlgebra`Private`expr, All, 
                AtomicDensityMatrix`TensorAlgebra`Private`index]], {
               Repeated[{
                 Repeated[2]}]}]]]]]], 
       AtomicDensityMatrix`TensorAlgebra`Private`assumeDecomposition = {
         "TensorDecompositionMatrix", "TensorDecomposition", "OneByOne"} -> {
         "TensorDecomposition", "OneByOne", "Operator"}, 
       TagSet[AtomicDensityMatrix`ExtraArrows, 
        MessageName[AtomicDensityMatrix`ExtraArrows, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`subscripts = {
        True, True, False}, 
       TagSet[AtomicDensityMatrix`QuantumNumberSubscripts, 
        MessageName[AtomicDensityMatrix`QuantumNumberSubscripts, "usage"], 
        ""], AtomicDensityMatrix`LevelDiagram`Private`findLevelPositions[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`spacing, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`parityOffsetValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelOffsetValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`pos, 
          AtomicDensityMatrix`LevelDiagram`Private`xmin, 
          AtomicDensityMatrix`LevelDiagram`Private`xmax, 
          AtomicDensityMatrix`LevelDiagram`Private`width, 
          AtomicDensityMatrix`LevelDiagram`Private`ymin, 
          AtomicDensityMatrix`LevelDiagram`Private`ymax, 
          AtomicDensityMatrix`LevelDiagram`Private`height}, 
         AtomicDensityMatrix`LevelDiagram`Private`pos = ReplaceAll[
            
            Transpose[{(AtomicDensityMatrix`LevelDiagram`Private`length + 
               AtomicDensityMatrix`LevelDiagram`Private`spacing) 
              Map[AtomicDensityMatrix`M, 
                AtomicDensityMatrix`LevelDiagram`Private`sys], 
              ReplaceAll[
               ReplaceAll[
                Diagonal[AtomicDensityMatrix`LevelDiagram`Private`h], 
                Thread[
                Map[AtomicDensityMatrix`Energy, 
                   AtomicDensityMatrix`LevelDiagram`Private`statelabels] -> 
                 Range[
                    Length[
                    AtomicDensityMatrix`LevelDiagram`Private`statelabels]] - 
                  1]], {AtomicDensityMatrix`HyperfineA[
                  Blank[]] -> 0.2, AtomicDensityMatrix`HyperfineB[
                  Blank[]] -> 0.05}]}], AtomicDensityMatrix`M[
              Blank[]] -> 0]; If[
           And[
            AtomicDensityMatrix`DefinedQ[
            AtomicDensityMatrix`LevelDiagram`Private`sys, 
             AtomicDensityMatrix`Parity], 
            Or[
             NumericQ[
             AtomicDensityMatrix`LevelDiagram`Private`parityOffsetValue], 
             ReplaceAll[
             AtomicDensityMatrix`LevelDiagram`Private`parityOffsetValue, 
              Automatic -> 
              And[Length[
                 AtomicDensityMatrix`LevelDiagram`Private`statelabels] > 2, 
                AtomicDensityMatrix`AtomicSystemType[
                 AtomicDensityMatrix`LevelDiagram`Private`sys] != 
                "HyperfineZeeman"]]]], 
           AtomicDensityMatrix`LevelDiagram`Private`width = -Apply[Subtract, 
               AtomicDensityMatrix`LevelDiagram`Private`xMinMax[
               AtomicDensityMatrix`LevelDiagram`Private`pos, 
                AtomicDensityMatrix`LevelDiagram`Private`length]]; 
           AddTo[AtomicDensityMatrix`LevelDiagram`Private`pos, 
             Thread[{
               
               ReplaceAll[(((AtomicDensityMatrix`LevelDiagram`Private`width + 
                   AtomicDensityMatrix`LevelDiagram`Private`spacing) 
                  AtomicDensityMatrix`LevelDiagram`Private`parityOffsetValue) 
                 AtomicDensityMatrix`Parity[
                  AtomicDensityMatrix`LevelDiagram`Private`sys])/2, {
                Alternatives[True, Automatic] -> 1, 
                 AtomicDensityMatrix`Even -> -1, AtomicDensityMatrix`Odd -> 
                 1}], 0}]]; Null]; 
         AddTo[AtomicDensityMatrix`LevelDiagram`Private`pos, 
           Thread[{
             AtomicDensityMatrix`LevelDiagram`Private`levelOffsetList[
             AtomicDensityMatrix`LevelDiagram`Private`sys, 
              AtomicDensityMatrix`LevelDiagram`Private`levelOffsetValue], 
             0}]]; {AtomicDensityMatrix`LevelDiagram`Private`xmin, 
            AtomicDensityMatrix`LevelDiagram`Private`xmax} = 
          AtomicDensityMatrix`LevelDiagram`Private`xMinMax[
           AtomicDensityMatrix`LevelDiagram`Private`pos, 
            AtomicDensityMatrix`LevelDiagram`Private`length]; 
         AtomicDensityMatrix`LevelDiagram`Private`width = 
          AtomicDensityMatrix`LevelDiagram`Private`xmax - 
           AtomicDensityMatrix`LevelDiagram`Private`xmin; {
           AtomicDensityMatrix`LevelDiagram`Private`ymin, 
            AtomicDensityMatrix`LevelDiagram`Private`ymax} = 
          AtomicDensityMatrix`LevelDiagram`Private`yMinMax[
           AtomicDensityMatrix`LevelDiagram`Private`pos]; 
         AtomicDensityMatrix`LevelDiagram`Private`height = 
          AtomicDensityMatrix`LevelDiagram`Private`ymax - 
           AtomicDensityMatrix`LevelDiagram`Private`ymin; {
          AtomicDensityMatrix`LevelDiagram`Private`pos, 
           AtomicDensityMatrix`LevelDiagram`Private`xmin, 
           AtomicDensityMatrix`LevelDiagram`Private`xmax, 
           AtomicDensityMatrix`LevelDiagram`Private`width, 
           AtomicDensityMatrix`LevelDiagram`Private`ymin, 
           AtomicDensityMatrix`LevelDiagram`Private`ymax, 
           AtomicDensityMatrix`LevelDiagram`Private`height}], 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0]] = "Fine", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1]] = "Fine", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, 
          AtomicDensityMatrix`M -> -1]] = "Zeeman", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0]] = 
       "Zeeman", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1]] = 
       "Zeeman", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         2, AtomicDensityMatrix`J -> 0, 
          AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
          AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
          0]] = "Zeeman", AtomicDensityMatrix`AtomicSystemType[{
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NaturalWidth -> 0, AtomicDensityMatrix`M -> 0], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NaturalWidth -> 0, 
           AtomicDensityMatrix`M -> -1], 
          AtomicDensityMatrix`AtomicState[
          2, AtomicDensityMatrix`J -> 0, 
           AtomicDensityMatrix`NaturalWidth -> $CellContext`\[CapitalGamma], 
           AtomicDensityMatrix`BranchingRatio[1] -> 1, AtomicDensityMatrix`M -> 
           0]}] = "Zeeman", AtomicDensityMatrix`AtomicSystemType[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`noMessage = True, 
          AtomicDensityMatrix`AtomicSystem`Private`result}, 
         AtomicDensityMatrix`AtomicSystem`Private`result = Check[
            
            Module[{AtomicDensityMatrix`AtomicSystem`Private`fDefined, 
              AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
              AtomicDensityMatrix`AtomicSystem`Private`mDefined}, {
               AtomicDensityMatrix`AtomicSystem`Private`fDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`mDefined} = 
              Map[AtomicDensityMatrix`AtomicSystem`Private`\
ValidQuantumNumberQ[AtomicDensityMatrix`AtomicSystem`Private`s, #]& , {
                AtomicDensityMatrix`F, AtomicDensityMatrix`J, 
                 AtomicDensityMatrix`M}]; Which[
               And[
               AtomicDensityMatrix`AtomicSystem`Private`fDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`mDefined], 
               "HyperfineZeeman", 
               And[
               AtomicDensityMatrix`AtomicSystem`Private`fDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                Not[AtomicDensityMatrix`AtomicSystem`Private`mDefined]], 
               "Hyperfine", 
               And[
                Not[AtomicDensityMatrix`AtomicSystem`Private`fDefined], 
                AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`mDefined], "Zeeman", 
               
               And[AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                Not[AtomicDensityMatrix`AtomicSystem`Private`mDefined]], 
               "Fine", 
               And[
                Not[AtomicDensityMatrix`AtomicSystem`Private`jDefined], 
                Not[AtomicDensityMatrix`AtomicSystem`Private`mDefined]], 
               "Toy", True, 
               Message[
                MessageName[AtomicDensityMatrix`AtomicSystemType, "unrec"], 
                AtomicDensityMatrix`AtomicSystem`Private`s]]], 
            AtomicDensityMatrix`AtomicSystem`Private`noMessage = False]; 
         Condition[
          AtomicDensityMatrix`AtomicSystemType[
            AtomicDensityMatrix`AtomicSystem`Private`s] = 
           AtomicDensityMatrix`AtomicSystem`Private`result, 
           AtomicDensityMatrix`AtomicSystem`Private`noMessage]], 
       AtomicDensityMatrix`AtomicSystemType[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`noMessage = True, 
          AtomicDensityMatrix`AtomicSystem`Private`result}, 
         AtomicDensityMatrix`AtomicSystem`Private`result = Check[
            
            With[{AtomicDensityMatrix`AtomicSystem`Private`types = 
              Map[AtomicDensityMatrix`AtomicSystemType, 
                AtomicDensityMatrix`AtomicSystem`Private`sys]}, 
             If[
              MatchQ[
               Hold[AtomicDensityMatrix`AtomicSystem`Private`types], 
               Hold[{
                 Repeated[
                  Blank[String]]}]], 
              If[
               MatchQ[AtomicDensityMatrix`AtomicSystem`Private`types, {
                 Repeated[
                  First[AtomicDensityMatrix`AtomicSystem`Private`types]]}], 
               First[AtomicDensityMatrix`AtomicSystem`Private`types], 
               Message[
                MessageName[
                AtomicDensityMatrix`AtomicSystemType, "difftypes"], 
                First[AtomicDensityMatrix`AtomicSystem`Private`types]]]]], 
            AtomicDensityMatrix`AtomicSystem`Private`noMessage = False]; 
         Condition[
          AtomicDensityMatrix`AtomicSystemType[
            AtomicDensityMatrix`AtomicSystem`Private`sys] = 
           AtomicDensityMatrix`AtomicSystem`Private`result, 
           AtomicDensityMatrix`AtomicSystem`Private`noMessage]], 
       TagSet[AtomicDensityMatrix`AtomicSystemType, 
        MessageName[AtomicDensityMatrix`AtomicSystemType, "difftypes"], 
        "All atomic states in the system are not of the same type, `1`, as \
the first state."], 
       TagSet[AtomicDensityMatrix`AtomicSystemType, 
        MessageName[AtomicDensityMatrix`AtomicSystemType, "unrec"], 
        "The type of the atomic state `1` is not recognized."], 
       TagSet[AtomicDensityMatrix`AtomicSystemType, 
        MessageName[AtomicDensityMatrix`AtomicSystemType, "usage"], 
        "\!\(\*TagBox[RowBox[{\"AtomicSystemType[\", StyleBox[\"sys\", \
\"TI\"], \"] determines the type of atomic system \", StyleBox[\"sys\", \
\"TI\"], \".\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`AtomicSystem`Private`ValidQuantumNumberQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`j, 
          Blank[]]] := And[
         AtomicDensityMatrix`DefinedQ[
         AtomicDensityMatrix`AtomicSystem`Private`s, 
          AtomicDensityMatrix`AtomicSystem`Private`j], 
         AtomicDensityMatrix`HalfIntegerQ[
          AtomicDensityMatrix`AtomicSystem`Private`j[
          AtomicDensityMatrix`AtomicSystem`Private`s]]], 
       AtomicDensityMatrix`HalfIntegerQ[
         Pattern[AtomicDensityMatrix`Common`Private`x, 
          Blank[]]] := IntegerQ[2 AtomicDensityMatrix`Common`Private`x], 
       TagSet[AtomicDensityMatrix`HalfIntegerQ, 
        MessageName[AtomicDensityMatrix`HalfIntegerQ, "usage"], 
        "HalfIntegerQ[expr] gives True if expr is integer or half-integer, \
and False otherwise."], AtomicDensityMatrix`LevelDiagram`Private`xMinMax[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]]] := {Min[
           Part[AtomicDensityMatrix`LevelDiagram`Private`pos, All, 1]] - 
         AtomicDensityMatrix`LevelDiagram`Private`length/2, Max[
           Part[AtomicDensityMatrix`LevelDiagram`Private`pos, All, 1]] + 
         AtomicDensityMatrix`LevelDiagram`Private`length/2}, 
       AtomicDensityMatrix`LevelDiagram`Private`levelOffsetList[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelOffsetValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`offsetVal = 
          Flatten[{
            AtomicDensityMatrix`LevelDiagram`Private`levelOffsetValue}]}, 
         Switch[AtomicDensityMatrix`LevelDiagram`Private`offsetVal, 
          Alternatives[{}, {None}], 
          ConstantArray[0, 
           Length[AtomicDensityMatrix`LevelDiagram`Private`sys]], {
           Repeated[
            PatternTest[
             Blank[], NumericQ]]}, 
          PadRight[{}, 
           Length[AtomicDensityMatrix`LevelDiagram`Private`sys], 
           AtomicDensityMatrix`LevelDiagram`Private`offsetVal], {
           Repeated[
            Blank[Rule]]}, 
          Total[
           Apply[Boole[
              AtomicDensityMatrix`StateMatchQ[
              AtomicDensityMatrix`LevelDiagram`Private`sys, #]] 
            AtomicDensityMatrix`StateEvaluate[
             AtomicDensityMatrix`LevelDiagram`Private`sys, #2]& , 
            AtomicDensityMatrix`LevelDiagram`Private`offsetVal, {1}]]]], 
       Condition[
         AtomicDensityMatrix`StateMatchQ[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
           Blank[AtomicDensityMatrix`AtomicState]], 
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
           Blank[]]], 
         AtomicDensityMatrix`StateLabelQ[
         AtomicDensityMatrix`AtomicSystem`Private`state, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]] := True, 
       AtomicDensityMatrix`StateMatchQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]]] := TrueQ[
         AtomicDensityMatrix`StateEvaluate[
         AtomicDensityMatrix`AtomicSystem`Private`state, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]], 
       AtomicDensityMatrix`StateMatchQ[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]]] := 
       Map[AtomicDensityMatrix`StateMatchQ[#, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]& , 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`StateMatchQ, 
        MessageName[AtomicDensityMatrix`StateMatchQ, "usage"], ""], 
       AtomicDensityMatrix`StateLabelQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       AtomicDensityMatrix`StateLabel[
         AtomicDensityMatrix`AtomicSystem`Private`state] === 
        AtomicDensityMatrix`AtomicSystem`Private`expr, 
       AtomicDensityMatrix`StateLabelQ[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := MemberQ[
         AtomicDensityMatrix`StateLabel[
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
         AtomicDensityMatrix`AtomicSystem`Private`expr], 
       TagSet[AtomicDensityMatrix`StateLabelQ, 
        MessageName[AtomicDensityMatrix`StateLabelQ, "usage"], ""], 
       AtomicDensityMatrix`StateEvaluate[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`AtomicSystem`Private`expr, 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`param, 
           Alternatives[
            AtomicDensityMatrix`StateParameterPattern[], 
            AtomicDensityMatrix`StateLabel]] :> 
         AtomicDensityMatrix`AtomicSystem`Private`param[
          AtomicDensityMatrix`AtomicSystem`Private`state]], 
       AtomicDensityMatrix`StateEvaluate[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       Map[AtomicDensityMatrix`StateEvaluate[#, 
          AtomicDensityMatrix`AtomicSystem`Private`expr]& , 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`StateEvaluate, 
        MessageName[AtomicDensityMatrix`StateEvaluate, "usage"], ""], 
       AtomicDensityMatrix`StateParameterPattern[] := 
       Alternatives[
        AtomicDensityMatrix`S, AtomicDensityMatrix`L, AtomicDensityMatrix`J, 
         AtomicDensityMatrix`NuclearSpin, AtomicDensityMatrix`F, 
         AtomicDensityMatrix`M, AtomicDensityMatrix`Parity, 
         AtomicDensityMatrix`Energy, AtomicDensityMatrix`NaturalWidth, 
         AtomicDensityMatrix`GFactor, 
         AtomicDensityMatrix`BranchingRatio[
          Blank[]], AtomicDensityMatrix`LevelPosition, 
         AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
         AtomicDensityMatrix`Polarizability[
          Blank[]], 
         AtomicDensityMatrix`TransitionPolarizability[
          Blank[]]], 
       TagSet[AtomicDensityMatrix`StateParameterPattern, 
        MessageName[AtomicDensityMatrix`StateParameterPattern, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`yMinMax[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]]] := {
         Min[
          Part[AtomicDensityMatrix`LevelDiagram`Private`pos, All, 2]], 
         Max[
          Part[AtomicDensityMatrix`LevelDiagram`Private`pos, All, 2]]}, 
       TagSet[AtomicDensityMatrix`LevelLength, 
        MessageName[AtomicDensityMatrix`LevelLength, "usage"], ""], 
       TagSet[AtomicDensityMatrix`LevelSpacing, 
        MessageName[AtomicDensityMatrix`LevelSpacing, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ParityOffset, 
        MessageName[AtomicDensityMatrix`ParityOffset, "usage"], ""], 
       TagSet[AtomicDensityMatrix`LevelOffset, 
        MessageName[AtomicDensityMatrix`LevelOffset, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`makeLevels[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelStyle, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`levels, 
          AtomicDensityMatrix`LevelDiagram`Private`levsty}, 
         AtomicDensityMatrix`LevelDiagram`Private`levsty = (Replace[
            AtomicDensityMatrix`EnsureList[#], {} -> {{}}]& )[
           AtomicDensityMatrix`LevelDiagram`Private`levelStyle]; 
         AtomicDensityMatrix`LevelDiagram`Private`levels = 
          Map[Line[{#, #} + 
             AtomicDensityMatrix`LevelDiagram`Private`length {{(-1)/2, 0}, {
                1/2, 0}}]& , AtomicDensityMatrix`LevelDiagram`Private`pos]; 
         AtomicDensityMatrix`LevelDiagram`Private`levsty = 
          PadRight[AtomicDensityMatrix`LevelDiagram`Private`levsty, 
            Length[AtomicDensityMatrix`LevelDiagram`Private`levels], 
            AtomicDensityMatrix`LevelDiagram`Private`levsty]; 
         AtomicDensityMatrix`LevelDiagram`Private`levels = 
          ReplacePart[
           AtomicDensityMatrix`LevelDiagram`Private`levels, 
            Position[AtomicDensityMatrix`LevelDiagram`Private`levsty, 
              Alternatives[None, False]] -> {}]; 
         AtomicDensityMatrix`LevelDiagram`Private`levsty = 
          ReplaceAll[
           AtomicDensityMatrix`LevelDiagram`Private`levsty, 
            Alternatives[None, False] -> {}]; 
         Transpose[{
           AtomicDensityMatrix`LevelDiagram`Private`levsty, 
            AtomicDensityMatrix`LevelDiagram`Private`levels}]], 
       AtomicDensityMatrix`EnsureList[
         Pattern[AtomicDensityMatrix`PlotAndFit`Private`expr, 
          Blank[]]] := 
       If[Head[AtomicDensityMatrix`PlotAndFit`Private`expr] === List, 
         AtomicDensityMatrix`PlotAndFit`Private`expr, {
         AtomicDensityMatrix`PlotAndFit`Private`expr}], 
       TagSet[AtomicDensityMatrix`EnsureList, 
        MessageName[AtomicDensityMatrix`EnsureList, "usage"], ""], 
       TagSet[AtomicDensityMatrix`LevelStyle, 
        MessageName[AtomicDensityMatrix`LevelStyle, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`makeMLabels[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`ymin, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`ymax, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`height, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`mLabelValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`mLabelPositionValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`m, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`msub, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`labelStyleValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`mlabopt, 
          AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, 
          AtomicDensityMatrix`LevelDiagram`Private`mlabtext, 
          AtomicDensityMatrix`LevelDiagram`Private`shortPos, 
          AtomicDensityMatrix`LevelDiagram`Private`dupPos}, If[
           MatchQ[AtomicDensityMatrix`LevelDiagram`Private`mLabelValue, 
            Alternatives[False, None]], 
           Return[{}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`mlabopt = PadRight[{}, 
            Length[AtomicDensityMatrix`LevelDiagram`Private`sys], 
            Replace[
            AtomicDensityMatrix`LevelDiagram`Private`mLabelValue, All -> 
             True]]; AtomicDensityMatrix`LevelDiagram`Private`mlabelpos = 
          PadRight[{}, 
            Length[AtomicDensityMatrix`LevelDiagram`Private`sys], 
            AtomicDensityMatrix`LevelDiagram`Private`mLabelPositionValue]; 
         AtomicDensityMatrix`LevelDiagram`Private`mlabelpos = Map[If[
             ListQ[#], #, {#, {0, 0}}]& , 
            AtomicDensityMatrix`LevelDiagram`Private`mlabelpos]; 
         AtomicDensityMatrix`LevelDiagram`Private`mlabelpos = MapThread[Switch[
              Part[#, 1], Top, {{
                Part[#2, 1], AtomicDensityMatrix`LevelDiagram`Private`ymax}, 
               1}, Bottom, {{
                Part[#2, 1], 
                AtomicDensityMatrix`LevelDiagram`Private`ymin}, -1}, 
              Above, {#2, 1}, Below, {#2, -1}, Automatic, {#2, 
               If[
               Part[#2, 2] > 
                AtomicDensityMatrix`LevelDiagram`Private`height/2, 1, -1]}] + {
              Part[#, 2], 0}& , {
            AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, 
             AtomicDensityMatrix`LevelDiagram`Private`pos}]; 
         AtomicDensityMatrix`LevelDiagram`Private`mlabtext = MapThread[If[
             Not[
              AtomicDensityMatrix`DefinedQ[#2, AtomicDensityMatrix`M]], "", 
             Switch[#, 
              Alternatives[True, Automatic, Short, "Short"], 
              AtomicDensityMatrix`QN[#2, 
                AtomicDensityMatrix`LevelDiagram`Private`m, 
                AtomicDensityMatrix`LevelDiagram`Private`msub, 
                AtomicDensityMatrix`LevelDiagram`Private`statelabels] == 
              AtomicDensityMatrix`M[#2], "Bare", 
              AtomicDensityMatrix`M[#2], 
              Alternatives[False, None], "", 
              Blank[], #]]& , {
            AtomicDensityMatrix`LevelDiagram`Private`mlabopt, 
             AtomicDensityMatrix`LevelDiagram`Private`sys}]; 
         AtomicDensityMatrix`LevelDiagram`Private`dupPos = SortBy[
            Range[
             Length[AtomicDensityMatrix`LevelDiagram`Private`mlabelpos]], {
             Part[AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, #], 
             AtomicDensityMatrix`F[
              Part[AtomicDensityMatrix`LevelDiagram`Private`sys, #]]}& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`dupPos = Flatten[
            Map[Most, 
             SplitBy[
             AtomicDensityMatrix`LevelDiagram`Private`dupPos, Part[
              AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, #]& ]]]; 
         Part[AtomicDensityMatrix`LevelDiagram`Private`mlabtext, 
            AtomicDensityMatrix`LevelDiagram`Private`dupPos] = ""; 
         AtomicDensityMatrix`LevelDiagram`Private`shortPos = Flatten[
            Position[
            AtomicDensityMatrix`LevelDiagram`Private`mlabopt 
             AtomicDensityMatrix`LevelDiagram`Private`mlabtext, 
             Alternatives[Short Except[""], "Short" Except[""]]]]; 
         AtomicDensityMatrix`LevelDiagram`Private`shortPos = 
          SortBy[AtomicDensityMatrix`LevelDiagram`Private`shortPos, Reverse[
             Flatten[
              Part[
              AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, #]]]& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`shortPos = Flatten[
            Map[Rest, 
             SplitBy[AtomicDensityMatrix`LevelDiagram`Private`shortPos, Most[
               Reverse[
                Flatten[
                 Part[
                 AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, #]]]]& \
]]]; Part[AtomicDensityMatrix`LevelDiagram`Private`mlabtext, 
            AtomicDensityMatrix`LevelDiagram`Private`shortPos] = Part[
            AtomicDensityMatrix`M[
            AtomicDensityMatrix`LevelDiagram`Private`sys], 
            AtomicDensityMatrix`LevelDiagram`Private`shortPos]; Union[
           If[
           Union[AtomicDensityMatrix`LevelDiagram`Private`mlabtext] === {
             ""}, {}, 
            MapThread[Text[
              
              Style[#2, "InlineMath", Background -> None, 
               AtomicDensityMatrix`LevelDiagram`Private`labelStyleValue], 
              First[#], {
               If[
                And[#3 === Short, Head[#2] === Equal], 0.75, 0], 0.1 - 1.3 
               Part[#, 2]}]& , {
             AtomicDensityMatrix`LevelDiagram`Private`mlabelpos, 
              AtomicDensityMatrix`LevelDiagram`Private`mlabtext, 
              AtomicDensityMatrix`LevelDiagram`Private`mlabopt}]]]], 
       AtomicDensityMatrix`QN[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`state, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sym, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sub, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`labs, 
          Blank[]]] := 
       Which[AtomicDensityMatrix`LevelDiagram`Private`sub === True, 
         Subscript[AtomicDensityMatrix`LevelDiagram`Private`sym, 
          AtomicDensityMatrix`StateLabel[
          AtomicDensityMatrix`LevelDiagram`Private`state]], 
         AtomicDensityMatrix`LevelDiagram`Private`sub === Primes, 
         Derivative[Part[
            Position[AtomicDensityMatrix`LevelDiagram`Private`labs, 
             AtomicDensityMatrix`StateLabel[
             AtomicDensityMatrix`LevelDiagram`Private`state], {1}, 1, Heads -> 
             False], 1, 1] - 1][AtomicDensityMatrix`LevelDiagram`Private`sym],
          True, AtomicDensityMatrix`LevelDiagram`Private`sym], 
       TagSet[AtomicDensityMatrix`QN, 
        MessageName[AtomicDensityMatrix`QN, "usage"], ""], 
       Attributes[Subscript] = {NHoldRest}, 
       Attributes[Derivative] = {NHoldAll, ReadProtected}, 
       TagSet[AtomicDensityMatrix`MLabel, 
        MessageName[AtomicDensityMatrix`MLabel, "usage"], ""], 
       TagSet[AtomicDensityMatrix`MLabelPosition, 
        MessageName[AtomicDensityMatrix`MLabelPosition, "usage"], ""], 
       TagSet[AtomicDensityMatrix`QuantumNumberSymbols, 
        MessageName[AtomicDensityMatrix`QuantumNumberSymbols, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`makeJFLabels[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`xmin, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`xmax, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`statelabels, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSymbolsValue, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`\
quantumNumberSubscriptsValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`labelStyleValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelSpacingValue, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`minLabelSpacingValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`fLabelValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`jLabelValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`mLabelValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`stateLabelValue, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`stateLabelPositionValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`j, 
          AtomicDensityMatrix`LevelDiagram`Private`f, 
          AtomicDensityMatrix`LevelDiagram`Private`m, 
          AtomicDensityMatrix`LevelDiagram`Private`jsub, 
          AtomicDensityMatrix`LevelDiagram`Private`fsub, 
          AtomicDensityMatrix`LevelDiagram`Private`msub, 
          AtomicDensityMatrix`LevelDiagram`Private`fstates, 
          AtomicDensityMatrix`LevelDiagram`Private`flabeltext, 
          AtomicDensityMatrix`LevelDiagram`Private`jstates, 
          AtomicDensityMatrix`LevelDiagram`Private`jlabeltext, 
          AtomicDensityMatrix`LevelDiagram`Private`statelabeltext, 
          AtomicDensityMatrix`LevelDiagram`Private`labeltext, 
          AtomicDensityMatrix`LevelDiagram`Private`positions, 
          AtomicDensityMatrix`LevelDiagram`Private`labelpos, 
          AtomicDensityMatrix`LevelDiagram`Private`statepos}, {
           AtomicDensityMatrix`LevelDiagram`Private`j, 
            AtomicDensityMatrix`LevelDiagram`Private`f, 
            AtomicDensityMatrix`LevelDiagram`Private`m} = 
          AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSymbolsValue; \
{AtomicDensityMatrix`LevelDiagram`Private`jsub, 
            AtomicDensityMatrix`LevelDiagram`Private`fsub, 
            AtomicDensityMatrix`LevelDiagram`Private`msub} = 
          AtomicDensityMatrix`LevelDiagram`Private`\
quantumNumberSubscriptsValue; 
         AtomicDensityMatrix`LevelDiagram`Private`fstates = 
          Union[AtomicDensityMatrix`LevelDiagram`Private`sys, 
            SameTest -> (And[
             AtomicDensityMatrix`StateLabel[#] === 
              AtomicDensityMatrix`StateLabel[#2], AtomicDensityMatrix`F[#] === 
              AtomicDensityMatrix`F[#2]]& )]; 
         AtomicDensityMatrix`LevelDiagram`Private`flabeltext = If[
            And[
            AtomicDensityMatrix`AtomicSystemType[
              AtomicDensityMatrix`LevelDiagram`Private`sys] == 
             "HyperfineZeeman", 
             Not[
              MatchQ[AtomicDensityMatrix`LevelDiagram`Private`fLabelValue, 
               Alternatives[None, False]]]], 
            Replace[
            AtomicDensityMatrix`LevelDiagram`Private`fLabelValue, 
             Alternatives[Automatic, All, True] -> 
             Map[AtomicDensityMatrix`QN[#, 
                 AtomicDensityMatrix`LevelDiagram`Private`f, 
                 AtomicDensityMatrix`LevelDiagram`Private`fsub, 
                 AtomicDensityMatrix`LevelDiagram`Private`statelabels] == 
               AtomicDensityMatrix`F[#]& , 
               AtomicDensityMatrix`LevelDiagram`Private`fstates]], {}]; 
         AtomicDensityMatrix`LevelDiagram`Private`jstates = Map[Last, 
            Split[
             SortBy[AtomicDensityMatrix`LevelDiagram`Private`fstates, {
               AtomicDensityMatrix`StateLabel[#], 
               AtomicDensityMatrix`J[#], 
               AtomicDensityMatrix`F[#]}& ], And[
             AtomicDensityMatrix`StateLabel[#] === 
              AtomicDensityMatrix`StateLabel[#2], AtomicDensityMatrix`J[#] === 
              AtomicDensityMatrix`J[#2]]& ]]; 
         AtomicDensityMatrix`LevelDiagram`Private`jlabeltext = If[
            And[
            AtomicDensityMatrix`AtomicSystemType[
              AtomicDensityMatrix`LevelDiagram`Private`sys] != "Toy", 
             Not[
              MatchQ[AtomicDensityMatrix`LevelDiagram`Private`jLabelValue, 
               Alternatives[None, False]]]], 
            Replace[
            AtomicDensityMatrix`LevelDiagram`Private`jLabelValue, 
             Alternatives[Automatic, All, True] -> 
             Map[AtomicDensityMatrix`QN[#, 
                 AtomicDensityMatrix`LevelDiagram`Private`j, 
                 AtomicDensityMatrix`LevelDiagram`Private`jsub, 
                 AtomicDensityMatrix`LevelDiagram`Private`statelabels] == 
               AtomicDensityMatrix`J[#]& , 
               AtomicDensityMatrix`LevelDiagram`Private`jstates]], Null]; 
         AtomicDensityMatrix`LevelDiagram`Private`statelabeltext = If[
            Not[
             MatchQ[
             AtomicDensityMatrix`LevelDiagram`Private`stateLabelValue, 
              Alternatives[None, False]]], 
            Replace[
            AtomicDensityMatrix`LevelDiagram`Private`stateLabelValue, 
             Alternatives[Automatic, All, True] -> 
             AtomicDensityMatrix`StateLabel[
              AtomicDensityMatrix`LevelDiagram`Private`jstates]], Null]; 
         AtomicDensityMatrix`LevelDiagram`Private`statelabeltext = 
          If[AtomicDensityMatrix`LevelDiagram`Private`jlabeltext === 
            AtomicDensityMatrix`LevelDiagram`Private`statelabeltext === 
            Null, {}, 
            ReplaceAll[
             Map[Row[#, ","]& , 
              Thread[
               Map[PadRight[{}, 
                 Length[
                 AtomicDensityMatrix`LevelDiagram`Private`jstates], #]& , {
                AtomicDensityMatrix`LevelDiagram`Private`statelabeltext, 
                 AtomicDensityMatrix`LevelDiagram`Private`jlabeltext}]]], 
             Null -> Sequence[]]]; If[
           And[
           AtomicDensityMatrix`LevelDiagram`Private`flabeltext == {}, 
            AtomicDensityMatrix`LevelDiagram`Private`statelabeltext == {}], 
           Return[{}]]; 
         If[AtomicDensityMatrix`LevelDiagram`Private`flabeltext == {}, 
           AtomicDensityMatrix`LevelDiagram`Private`labeltext = 
            AtomicDensityMatrix`LevelDiagram`Private`statelabeltext; 
           AtomicDensityMatrix`LevelDiagram`Private`positions = 
            Map[Map[Extract[
               AtomicDensityMatrix`LevelDiagram`Private`pos, #]& , 
               AtomicDensityMatrix`StatePosition[
               AtomicDensityMatrix`LevelDiagram`Private`sys, 
                And[
                AtomicDensityMatrix`StateLabel == 
                 AtomicDensityMatrix`StateLabel[#], AtomicDensityMatrix`F == 
                 AtomicDensityMatrix`F[#]]]]& , 
              AtomicDensityMatrix`LevelDiagram`Private`jstates], 
           AtomicDensityMatrix`LevelDiagram`Private`positions = 
            Map[Map[Extract[
               AtomicDensityMatrix`LevelDiagram`Private`pos, #]& , 
               AtomicDensityMatrix`StatePosition[
               AtomicDensityMatrix`LevelDiagram`Private`sys, 
                And[
                AtomicDensityMatrix`StateLabel == 
                 AtomicDensityMatrix`StateLabel[#], AtomicDensityMatrix`F == 
                 AtomicDensityMatrix`F[#]]]]& , 
              AtomicDensityMatrix`LevelDiagram`Private`fstates]; 
           If[AtomicDensityMatrix`LevelDiagram`Private`statelabeltext == {}, 
             AtomicDensityMatrix`LevelDiagram`Private`labeltext = 
             AtomicDensityMatrix`LevelDiagram`Private`flabeltext, 
             AtomicDensityMatrix`LevelDiagram`Private`labeltext = 
             MapThread[Row[
                Join[
                 
                 If[(AtomicDensityMatrix`LevelDiagram`Private`statepos = 
                   Position[
                    AtomicDensityMatrix`LevelDiagram`Private`jstates, #]) != \
{}, {
                   Extract[
                   AtomicDensityMatrix`LevelDiagram`Private`statelabeltext, 
                    First[AtomicDensityMatrix`LevelDiagram`Private`statepos]],
                    ", "}, {}], {#2}]]& , {
               AtomicDensityMatrix`LevelDiagram`Private`fstates, 
                AtomicDensityMatrix`LevelDiagram`Private`flabeltext}]]]; 
         If[AtomicDensityMatrix`LevelDiagram`Private`stateLabelPositionValue === 
           Automatic, AtomicDensityMatrix`LevelDiagram`Private`labelpos = 
           Apply[(AtomicDensityMatrix`LevelDiagram`Private`side = 
              Sign[# - Mean[{
                 AtomicDensityMatrix`LevelDiagram`Private`xmin, 
                  AtomicDensityMatrix`LevelDiagram`Private`xmax}] - 
                10^(-6)]; {{(
                  AtomicDensityMatrix`LevelDiagram`Private`side (
                   AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue + 
                   AtomicDensityMatrix`LevelDiagram`Private`levelSpacingValue)\
)/2 + #, #2}, {-AtomicDensityMatrix`LevelDiagram`Private`side, 0}})& , 
             Map[Mean, AtomicDensityMatrix`LevelDiagram`Private`positions], {
             1}], AtomicDensityMatrix`LevelDiagram`Private`labelpos = 
            Map[{{AtomicDensityMatrix`LevelDiagram`Private`xmin - 
                AtomicDensityMatrix`LevelDiagram`Private`levelSpacingValue, \
#}, {1, 0}}& , 
              AtomicDensityMatrix`LevelDiagram`Private`spacePoints[
               Map[Last, 
                Map[
                Mean, AtomicDensityMatrix`LevelDiagram`Private`positions]], 
               AtomicDensityMatrix`LevelDiagram`Private`minLabelSpacingValue]]\
; If[
             Alternatives[
             AtomicDensityMatrix`LevelDiagram`Private`mLabelValue === Short, 
              "Short"], AtomicDensityMatrix`LevelDiagram`Private`labeltext = 
             Map[Row[{#, 
                 Invisible["M="]}]& , 
               AtomicDensityMatrix`LevelDiagram`Private`labeltext]]]; 
         MapThread[Text[
            TraditionalForm[
             
             Style[#2, "InlineMath", Background -> None, 
              AtomicDensityMatrix`LevelDiagram`Private`labelStyleValue]], 
            Part[#, 1], 
            Part[#, 2]]& , {
           AtomicDensityMatrix`LevelDiagram`Private`labelpos, 
            AtomicDensityMatrix`LevelDiagram`Private`labeltext}]], Condition[
         AtomicDensityMatrix`StatePosition[
          PatternTest[
           Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
            Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
           Blank[]], 
          Optional[
           Pattern[AtomicDensityMatrix`AtomicSystem`Private`n, 
            Alternatives[
             Blank[Integer], Infinity]], Infinity]], 
         AtomicDensityMatrix`StateLabelQ[
         AtomicDensityMatrix`AtomicSystem`Private`sys, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]] := 
       AtomicDensityMatrix`StatePosition[
        AtomicDensityMatrix`AtomicSystem`Private`sys, 
         AtomicDensityMatrix`StateLabel == 
         AtomicDensityMatrix`AtomicSystem`Private`crit, 
         AtomicDensityMatrix`AtomicSystem`Private`n], 
       AtomicDensityMatrix`StatePosition[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]], 
         Optional[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`n, 
           Blank[]], Infinity]] := 
       Position[AtomicDensityMatrix`AtomicSystem`Private`sys, 
         Condition[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
           Blank[]], 
          AtomicDensityMatrix`StateEvaluate[
          AtomicDensityMatrix`AtomicSystem`Private`state, 
           AtomicDensityMatrix`AtomicSystem`Private`crit]], {1}, 
         AtomicDensityMatrix`AtomicSystem`Private`n, Heads -> False], 
       TagSet[AtomicDensityMatrix`StatePosition, 
        MessageName[AtomicDensityMatrix`StatePosition, "usage"], 
        "\!\(\*TagBox[RowBox[{\"StatePosition[\", StyleBox[\"sys\", \"TI\"], \
\",\", StyleBox[\"crit\", \"TI\"], \"] gives the position in the atomic \
system \", StyleBox[\"sys\", \"TI\"], \" of the states satisfying the state\
\[Hyphen]selection criteria \", StyleBox[\"crit\", \"TI\"], \".\", \"\
\[LineSeparator]\", \"StatePosition[\", StyleBox[\"sys\", \"TI\"], \",\", \
StyleBox[\"crit\", \"TI\"], \",\", StyleBox[\"n\", \"TI\"], \"] gives the \
positions of the first \", StyleBox[\"n\", \"TI\"], \" atomic states \
found.\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`LevelDiagram`Private`spacePoints[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`minSpacing, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`pos, 
          AtomicDensityMatrix`LevelDiagram`Private`p, 
          AtomicDensityMatrix`LevelDiagram`Private`startpos, 
          AtomicDensityMatrix`LevelDiagram`Private`ord, 
          AtomicDensityMatrix`LevelDiagram`Private`sortpos}, 
         AtomicDensityMatrix`LevelDiagram`Private`ord = 
          Ordering[AtomicDensityMatrix`LevelDiagram`Private`opos]; 
         AtomicDensityMatrix`LevelDiagram`Private`sortpos = 
          Part[AtomicDensityMatrix`LevelDiagram`Private`opos, 
            AtomicDensityMatrix`LevelDiagram`Private`ord]; If[Min[
             Differences[AtomicDensityMatrix`LevelDiagram`Private`sortpos]] >= 
           AtomicDensityMatrix`LevelDiagram`Private`minSpacing, 
           Return[AtomicDensityMatrix`LevelDiagram`Private`opos]]; 
         AtomicDensityMatrix`LevelDiagram`Private`pos = 
          Array[AtomicDensityMatrix`LevelDiagram`Private`p, 
            Length[AtomicDensityMatrix`LevelDiagram`Private`opos]]; 
         AtomicDensityMatrix`LevelDiagram`Private`startpos = 
          AtomicDensityMatrix`LevelDiagram`Private`minSpacing (Range[
              Length[AtomicDensityMatrix`LevelDiagram`Private`opos]] - (
             Length[AtomicDensityMatrix`LevelDiagram`Private`opos] - 1)/2 - 
            1.); Part[
           AtomicDensityMatrix`LevelDiagram`Private`sortpos, 
            AtomicDensityMatrix`LevelDiagram`Private`ord] = 
          ReplaceAll[AtomicDensityMatrix`LevelDiagram`Private`pos, 
            Last[
             FindMinimum[{
               
               Total[(AtomicDensityMatrix`LevelDiagram`Private`pos - 
                 AtomicDensityMatrix`LevelDiagram`Private`sortpos)^2], 
               Apply[And, 
                Thread[
                Most[AtomicDensityMatrix`LevelDiagram`Private`pos] + 
                  AtomicDensityMatrix`LevelDiagram`Private`minSpacing/2 < 
                 Rest[AtomicDensityMatrix`LevelDiagram`Private`pos] - 
                  AtomicDensityMatrix`LevelDiagram`Private`minSpacing/2]]}, 
              
              Transpose[{
               AtomicDensityMatrix`LevelDiagram`Private`pos, 
                AtomicDensityMatrix`LevelDiagram`Private`startpos}]]]]; 
         AtomicDensityMatrix`LevelDiagram`Private`sortpos], 
       TagSet[AtomicDensityMatrix`MinLabelSpacing, 
        MessageName[AtomicDensityMatrix`MinLabelSpacing, "usage"], ""], 
       TagSet[AtomicDensityMatrix`FLabel, 
        MessageName[AtomicDensityMatrix`FLabel, "usage"], ""], 
       TagSet[AtomicDensityMatrix`JLabel, 
        MessageName[AtomicDensityMatrix`JLabel, "usage"], ""], 
       TagSet[AtomicDensityMatrix`StateLabelPosition, 
        MessageName[AtomicDensityMatrix`StateLabelPosition, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`setupArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`mixing, 
          AtomicDensityMatrix`LevelDiagram`Private`arcrad, 
          AtomicDensityMatrix`LevelDiagram`Private`arrowoff, 
          AtomicDensityMatrix`LevelDiagram`Private`arrowsetback, 
          AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          AtomicDensityMatrix`LevelDiagram`Private`arrowfunc, 
          AtomicDensityMatrix`LevelDiagram`Private`thisarrsty, 
          AtomicDensityMatrix`LevelDiagram`Private`matelem, 
          AtomicDensityMatrix`LevelDiagram`Private`freqs, 
          AtomicDensityMatrix`LevelDiagram`Private`x1, 
          AtomicDensityMatrix`LevelDiagram`Private`y1, 
          AtomicDensityMatrix`LevelDiagram`Private`x2, 
          AtomicDensityMatrix`LevelDiagram`Private`y2, 
          AtomicDensityMatrix`LevelDiagram`Private`arr, 
          AtomicDensityMatrix`LevelDiagram`Private`arrsty, 
          AtomicDensityMatrix`LevelDiagram`Private`setback, 
          AtomicDensityMatrix`LevelDiagram`Private`thisarcrad, 
          AtomicDensityMatrix`LevelDiagram`Private`\
suppressOffResonantCouplings = 
          OptionValue[AtomicDensityMatrix`SuppressOffResonantCouplings], 
          AtomicDensityMatrix`LevelDiagram`Private`levelLength = 
          OptionValue[AtomicDensityMatrix`LevelLength], 
          AtomicDensityMatrix`LevelDiagram`Private`maxArcSlope = 
          OptionValue[AtomicDensityMatrix`MaxArcSlope]}, 
         AtomicDensityMatrix`LevelDiagram`Private`mixing = DeleteCases[
            Join[
             Position[AtomicDensityMatrix`LevelDiagram`Private`h, 
              Condition[
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                Blank[]], 
               Not[
                PossibleZeroQ[AtomicDensityMatrix`LevelDiagram`Private`x]]], {
              2}, Heads -> False], 
             Apply[List, 
              Union[
               Flatten[
                Map[{
                  Reverse[#], #}& , 
                 Flatten[
                  Map[Tuples, 
                   Flatten[
                    Map[Flatten[
                    AtomicDensityMatrix`StatePosition[
                    AtomicDensityMatrix`LevelDiagram`Private`sys, #]]& , 
                    Flatten[{
                    OptionValue[AtomicDensityMatrix`ExtraArrows]}], {
                    2}]]]]]]], {1}]], {
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
              Blank[]]}]; 
         If[AtomicDensityMatrix`LevelDiagram`Private`mixing == {}, 
           Return[{}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`arcrad = RotateRight[
            AtomicDensityMatrix`EnsureList[
             OptionValue[AtomicDensityMatrix`ArcRadius]]]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrowoff = Replace[
            OptionValue[AtomicDensityMatrix`ArrowOffset], {
            None -> {{0, 0}}, PatternTest[
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                Blank[]], NumericQ] -> {{
               AtomicDensityMatrix`LevelDiagram`Private`x, 0}}, 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, {
                PatternTest[
                 Blank[], NumericQ], 
                PatternTest[
                 Blank[], NumericQ]}] -> {
              AtomicDensityMatrix`LevelDiagram`Private`x}}]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrowoff = 
          Replace[AtomicDensityMatrix`LevelDiagram`Private`arrowoff, {
            Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, {
                PatternTest[
                 Blank[], NumericQ], 
                PatternTest[
                 Blank[], NumericQ]}] -> {
              AtomicDensityMatrix`LevelDiagram`Private`x, 
               AtomicDensityMatrix`LevelDiagram`Private`x}, None -> {0, 0}, 
             PatternTest[
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                Blank[]], NumericQ] -> {
              AtomicDensityMatrix`LevelDiagram`Private`x, 0}}, {1}]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrowsetback = Replace[
            OptionValue[AtomicDensityMatrix`ArrowSetback], {
            None -> {{0, 0}}, PatternTest[
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                Blank[]], NumericQ] -> {{
               0, AtomicDensityMatrix`LevelDiagram`Private`x}}, 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, {
                PatternTest[
                 Blank[], NumericQ], 
                PatternTest[
                 Blank[], NumericQ]}] -> {
              AtomicDensityMatrix`LevelDiagram`Private`x}}]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrowsetback = 
          Replace[AtomicDensityMatrix`LevelDiagram`Private`arrowsetback, {
            PatternTest[
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                Blank[]], NumericQ] -> {
              0, AtomicDensityMatrix`LevelDiagram`Private`x}, 
             None -> {0, 0}}, {1}]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrsty = Replace[
            AtomicDensityMatrix`EnsureList[
             OptionValue[AtomicDensityMatrix`ArrowStyle]], {} -> {{}}]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrowfunc = ReplaceAll[
            OptionValue[AtomicDensityMatrix`ArrowFunction], 
            Automatic -> (Arrow[#]& )]; 
         AtomicDensityMatrix`LevelDiagram`Private`arrows = Last[
            Last[
             Reap[
              
              Map[({{AtomicDensityMatrix`LevelDiagram`Private`x1, 
                   AtomicDensityMatrix`LevelDiagram`Private`y1}, {
                  AtomicDensityMatrix`LevelDiagram`Private`x2, 
                   AtomicDensityMatrix`LevelDiagram`Private`y2}} = 
                Part[AtomicDensityMatrix`LevelDiagram`Private`pos, #]; If[
                 And[
                  Or[
                  AtomicDensityMatrix`LevelDiagram`Private`y1 < 
                   AtomicDensityMatrix`LevelDiagram`Private`y2, 
                   And[
                   AtomicDensityMatrix`LevelDiagram`Private`y1 == 
                    AtomicDensityMatrix`LevelDiagram`Private`y2, 
                    AtomicDensityMatrix`LevelDiagram`Private`x1 < 
                    AtomicDensityMatrix`LevelDiagram`Private`x2]], (
                   AtomicDensityMatrix`LevelDiagram`Private`thisarrsty = 
                   AtomicDensityMatrix`PopAppend[
                    AtomicDensityMatrix`LevelDiagram`Private`arrsty]) =!= 
                  None], AtomicDensityMatrix`LevelDiagram`Private`matelem = 
                  ExpandAll[
                    TrigToExp[
                    Extract[AtomicDensityMatrix`LevelDiagram`Private`h, #]]]; 
                 AtomicDensityMatrix`LevelDiagram`Private`freqs = ReplaceAll[
                    Union[
                    
                    Cases[{AtomicDensityMatrix`LevelDiagram`Private`matelem}, 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
                    Blank[]] E^((Complex[
                    Alternatives[0, 0.], 
                    PatternTest[
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                    Blank[]], NumericQ]] Optional[
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`w, 
                    Blank[]]]) AtomicDensityMatrix`t) :> {
                    AtomicDensityMatrix`LevelDiagram`Private`x, 
                    AtomicDensityMatrix`LevelDiagram`Private`a, 
                    AtomicDensityMatrix`LevelDiagram`Private`w}, 2]], {} -> {{
                    AtomicDensityMatrix`LevelDiagram`Private`y2 - 
                    AtomicDensityMatrix`LevelDiagram`Private`y1, 
                    AtomicDensityMatrix`LevelDiagram`Private`matelem, 
                    AtomicDensityMatrix`LevelDiagram`Private`w}}]; 
                 If[AtomicDensityMatrix`LevelDiagram`Private`\
suppressOffResonantCouplings, AtomicDensityMatrix`LevelDiagram`Private`freqs = 
                   DeleteCases[AtomicDensityMatrix`LevelDiagram`Private`freqs, 
                    Condition[
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`f, 
                    Blank[]], 
                    Negative[
                    First[AtomicDensityMatrix`LevelDiagram`Private`f]]]]]; 
                 AtomicDensityMatrix`LevelDiagram`Private`freqs = 
                  ReplaceAll[
                   AtomicDensityMatrix`LevelDiagram`Private`freqs, {Condition[{
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                    Blank[]], 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
                    Blank[]], 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`w, 
                    Blank[]]}, 
                    Not[
                    NumericQ[
                    AtomicDensityMatrix`LevelDiagram`Private`w]]] :> {
                    AtomicDensityMatrix`LevelDiagram`Private`y2 - 
                    AtomicDensityMatrix`LevelDiagram`Private`y1, 
                    AtomicDensityMatrix`LevelDiagram`Private`a}, {
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                    Blank[]], 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
                    Blank[]], 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`w, 
                    Blank[]]} :> {
                    AtomicDensityMatrix`LevelDiagram`Private`x, 
                    AtomicDensityMatrix`LevelDiagram`Private`a}}]; 
                 AtomicDensityMatrix`LevelDiagram`Private`arr = 
                  Map[(AtomicDensityMatrix`LevelDiagram`Private`y2 = 
                    AtomicDensityMatrix`LevelDiagram`Private`y1 + 
                    Part[#, 1]; {{
                    AtomicDensityMatrix`LevelDiagram`Private`x1, 
                    AtomicDensityMatrix`LevelDiagram`Private`y1}, {
                    AtomicDensityMatrix`LevelDiagram`Private`x2, 
                    AtomicDensityMatrix`LevelDiagram`Private`y2}} + (
                    AtomicDensityMatrix`LevelDiagram`Private`levelLength 
                    AtomicDensityMatrix`PopAppend[
                    AtomicDensityMatrix`LevelDiagram`Private`arrowoff]) {{
                    Order[
                    AtomicDensityMatrix`LevelDiagram`Private`x1, 
                    AtomicDensityMatrix`LevelDiagram`Private`x2], 
                    Order[
                    AtomicDensityMatrix`LevelDiagram`Private`y1, 
                    AtomicDensityMatrix`LevelDiagram`Private`y2]}, {
                    Order[
                    AtomicDensityMatrix`LevelDiagram`Private`x2, 
                    AtomicDensityMatrix`LevelDiagram`Private`x1], 
                    Order[
                    AtomicDensityMatrix`LevelDiagram`Private`y2, 
                    AtomicDensityMatrix`LevelDiagram`Private`y1]}})& , 
                    AtomicDensityMatrix`LevelDiagram`Private`freqs]; 
                 AtomicDensityMatrix`LevelDiagram`Private`arr = 
                  Map[(AtomicDensityMatrix`LevelDiagram`Private`setback = (
                    AtomicDensityMatrix`LevelDiagram`Private`levelLength 
                    AtomicDensityMatrix`PopAppend[
                    AtomicDensityMatrix`LevelDiagram`Private`arrowsetback])/
                    Norm[
                    Apply[Subtract, #]]; {
                    AtomicDensityMatrix`LevelDiagram`Private`line[#, 
                    Part[
                    AtomicDensityMatrix`LevelDiagram`Private`setback, 1]], 
                    
                    AtomicDensityMatrix`LevelDiagram`Private`line[#, 1 - Part[
                    AtomicDensityMatrix`LevelDiagram`Private`setback, 2]]})& ,
                     AtomicDensityMatrix`LevelDiagram`Private`arr]; 
                 AtomicDensityMatrix`LevelDiagram`Private`thisarcrad = 
                  First[AtomicDensityMatrix`LevelDiagram`Private`arcrad = 
                    RotateLeft[
                    AtomicDensityMatrix`LevelDiagram`Private`arcrad]]; 
                 AtomicDensityMatrix`LevelDiagram`Private`thisarrsty = 
                  Replace[
                   AtomicDensityMatrix`LevelDiagram`Private`thisarrsty, List -> 
                    Sequence, {1}, Heads -> True]; 
                 Apply[Sow[{
                    AtomicDensityMatrix`LevelDiagram`Private`thisarrsty, 
                    If[Abs[
                    AtomicDensityMatrix`Slope[#]] <= 
                    AtomicDensityMatrix`LevelDiagram`Private`maxArcSlope, 
                    
                    AtomicDensityMatrix`LevelDiagram`Private`arf[#, 
                    AtomicDensityMatrix`LevelDiagram`Private`thisarcrad, 
                    AtomicDensityMatrix`ConnectArc], 
                    
                    AtomicDensityMatrix`LevelDiagram`Private`arf[#, #2, 
                    AtomicDensityMatrix`LevelDiagram`Private`arrowfunc]]}]& , 
                   
                   Transpose[{AtomicDensityMatrix`LevelDiagram`Private`arr, 
                    Part[
                    AtomicDensityMatrix`LevelDiagram`Private`freqs, All, 
                    2]}], {1}]]; Null)& , 
               AtomicDensityMatrix`LevelDiagram`Private`mixing]]]]], 
       Options[AtomicDensityMatrix`LevelDiagram`Private`setupArrows] = {
        AtomicDensityMatrix`ExtraArrows -> {}, 
         AtomicDensityMatrix`ArcRadius -> {}, 
         AtomicDensityMatrix`ArrowOffset -> {}, 
         AtomicDensityMatrix`ArrowSetback -> {}, 
         AtomicDensityMatrix`ArrowStyle -> {}, 
         AtomicDensityMatrix`SuppressOffResonantCouplings -> {}, 
         AtomicDensityMatrix`MaxArcSlope -> {}, 
         AtomicDensityMatrix`ArrowFunction -> {}, 
         AtomicDensityMatrix`LevelLength -> {}}, 
       TagSet[AtomicDensityMatrix`SuppressOffResonantCouplings, 
        MessageName[
        AtomicDensityMatrix`SuppressOffResonantCouplings, "usage"], ""], 
       TagSet[AtomicDensityMatrix`MaxArcSlope, 
        MessageName[AtomicDensityMatrix`MaxArcSlope, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArcRadius, 
        MessageName[AtomicDensityMatrix`ArcRadius, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArrowOffset, 
        MessageName[AtomicDensityMatrix`ArrowOffset, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArrowSetback, 
        MessageName[AtomicDensityMatrix`ArrowSetback, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArrowStyle, 
        MessageName[AtomicDensityMatrix`ArrowStyle, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArrowFunction, 
        MessageName[AtomicDensityMatrix`ArrowFunction, "usage"], ""], 
       Attributes[AtomicDensityMatrix`PopAppend] = {HoldFirst}, 
       AtomicDensityMatrix`PopAppend[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`list, 
          Blank[]]] := (
        AtomicDensityMatrix`LevelDiagram`Private`list = 
         RotateLeft[AtomicDensityMatrix`LevelDiagram`Private`list]; 
        Last[AtomicDensityMatrix`LevelDiagram`Private`list]), 
       TagSet[AtomicDensityMatrix`PopAppend, 
        MessageName[AtomicDensityMatrix`PopAppend, "usage"], ""], 
       TagSet[AtomicDensityMatrix`t, 
        MessageName[AtomicDensityMatrix`t, "usage"], 
        "t is the default value for the option TimeVariable in DensityMatrix \
and other functions."], AtomicDensityMatrix`LevelDiagram`Private`line[{{
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`x1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`y1, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`x2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`y2, 
            Blank[]]}}, 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`s, 
          Blank[]]] = {
        AtomicDensityMatrix`LevelDiagram`Private`x1 + 
         AtomicDensityMatrix`LevelDiagram`Private`s (-
            AtomicDensityMatrix`LevelDiagram`Private`x1 + 
           AtomicDensityMatrix`LevelDiagram`Private`x2), 
         AtomicDensityMatrix`LevelDiagram`Private`y1 + 
         AtomicDensityMatrix`LevelDiagram`Private`s (-
            AtomicDensityMatrix`LevelDiagram`Private`y1 + 
           AtomicDensityMatrix`LevelDiagram`Private`y2)}, 
       AtomicDensityMatrix`Slope[{{
           Pattern[AtomicDensityMatrix`Common`Private`x1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`Common`Private`y1, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`Common`Private`x2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`Common`Private`y2, 
            Blank[]]}}] := 
       If[AtomicDensityMatrix`Common`Private`x2 != 
         AtomicDensityMatrix`Common`Private`x1, (
          AtomicDensityMatrix`Common`Private`y2 - 
          AtomicDensityMatrix`Common`Private`y1)/(
         AtomicDensityMatrix`Common`Private`x2 - 
         AtomicDensityMatrix`Common`Private`x1), Infinity], 
       TagSet[AtomicDensityMatrix`Slope, 
        MessageName[AtomicDensityMatrix`Slope, "usage"], ""], 
       AtomicDensityMatrix`ConnectArc[{
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`p1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`p2, 
           Blank[]]}, 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`o, 
          Blank[]]] := Cases[
         Flatten[
          First[
           ParametricPlot[
            Evaluate[
             
             Splines`SplineFit[{
              AtomicDensityMatrix`LevelDiagram`Private`p1, 
               Mean[{AtomicDensityMatrix`LevelDiagram`Private`p1, 
                  AtomicDensityMatrix`LevelDiagram`Private`p2}] + 
               AtomicDensityMatrix`LevelDiagram`Private`o 
                Dot[{{0, -1}, {1, 0}}, 
                  Abs[
                  AtomicDensityMatrix`LevelDiagram`Private`p2 - 
                   AtomicDensityMatrix`LevelDiagram`Private`p1]], 
               AtomicDensityMatrix`LevelDiagram`Private`p2}, Splines`Bezier][
             AtomicDensityMatrix`LevelDiagram`Private`x]], {
            AtomicDensityMatrix`LevelDiagram`Private`x, 0, 2}]]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`line, 
           Blank[Line]] :> 
         Apply[Arrow, AtomicDensityMatrix`LevelDiagram`Private`line], 
         Infinity], 
       TagSet[AtomicDensityMatrix`ConnectArc, 
        MessageName[AtomicDensityMatrix`ConnectArc, "usage"], ""], 
       Splines`SplineFit[
         PatternTest[
          Pattern[Splines`Private`pts, 
           Blank[List]], MatrixQ[#, NumberQ[
            N[#]]& ]& ], 
         PatternTest[
          Pattern[Splines`Private`type, 
           Blank[Symbol]], 
          MemberQ[{
           Splines`Cubic, Splines`Bezier, Splines`CompositeBezier}, #]& ]] := 
       Splines`SplineFunction[Splines`Private`type, {0., 
          N[Length[Splines`Private`pts] - 1]}, Splines`Private`pts, 
         Splines`Private`splineinternal[
         Splines`Private`pts, Splines`Private`type]], 
       TagSet[Splines`SplineFit, 
        MessageName[Splines`SplineFit, "cbezlen"], 
        "Points are needed to generate a spline."], 
       TagSet[Splines`SplineFit, 
        MessageName[Splines`SplineFit, "usage"], 
        "\!\(\*RowBox[{\"SplineFit\", \"[\", RowBox[{RowBox[{\"{\", \
RowBox[{SubscriptBox[StyleBox[\"pt\", \"TI\"], StyleBox[\"1\", \"TR\"]], \
\",\", SubscriptBox[StyleBox[\"pt\", \"TI\"], StyleBox[\"2\", \"TR\"]], \
\",\", StyleBox[\"\[Ellipsis]\", \"TR\"]}], \"}\"}], \",\", \
StyleBox[\"type\", \"TI\"]}], \"]\"}]\) generates a SplineFunction object of \
the specified \!\(\*StyleBox[\"type\", \"TI\"]\) from the points \
\!\(\*RowBox[{SubscriptBox[StyleBox[\"pt\", \"TI\"], StyleBox[\"1\", \
\"TR\"]], \",\", SubscriptBox[StyleBox[\"pt\", \"TI\"], StyleBox[\"2\", \
\"TR\"]], \",\", StyleBox[\"\[Ellipsis]\", \"TR\"]}]\)."], 
       TagSet[Splines`Cubic, 
        MessageName[Splines`Cubic, "usage"], 
        "Cubic is a setting specifying the type of spline generated by Spline \
and SplineFit."], 
       TagSet[Splines`Bezier, 
        MessageName[Splines`Bezier, "usage"], 
        "Bezier is a setting specifying the type of spline generated by \
Spline and SplineFit."], 
       TagSet[Splines`CompositeBezier, 
        MessageName[Splines`CompositeBezier, "usage"], 
        "CompositeBezier is a setting specifying the type of spline generated \
by Spline and SplineFit."], Splines`SplineFunction[
         Pattern[Splines`Private`type, 
          Blank[]], {
          Pattern[Splines`Private`min, 
           Blank[]], 
          Pattern[Splines`Private`max, 
           Blank[]]}, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]][
         PatternTest[
          Pattern[Splines`Private`in, 
           Blank[]], NumberQ[
           N[#]]& ]] := Module[{Splines`Private`out}, If[
           Or[
           Splines`Private`in < Splines`Private`min, Splines`Private`in > 
            Splines`Private`max], Message[
             MessageName[Splines`SplineFunction, "dmval"], 
             Splines`Private`in]; Splines`Private`out = $Failed, 
           Splines`Private`out = Splines`Private`evalspline[
             Which[Splines`Private`in == Splines`Private`max, 
              Min[Splines`Private`max, Splines`Private`in], 
              Splines`Private`in == Splines`Private`min, 
              Max[Splines`Private`min, Splines`Private`in], True, 
              Splines`Private`in], Splines`Private`type, Splines`Private`pts, 
             Splines`Private`internal]]; 
         Condition[Splines`Private`out, Splines`Private`out =!= $Failed]], 
       UpSetDelayed[
        MakeBoxes[
         Splines`SplineFunction[
          Pattern[Splines`Private`t, 
           Blank[]], 
          Pattern[Splines`Private`r, 
           Blank[]], 
          Pattern[Splines`Private`b, 
           BlankSequence[]]], 
         Pattern[FormatType, 
          Blank[]]], 
        Format[
         Row[{
          "SplineFunction[", Splines`Private`t, ", ", Splines`Private`r, ", ",
            "<>", "]"}], FormatType]], Format[
         Splines`SplineFunction[
          Pattern[Splines`Private`t, 
           Blank[]], 
          Pattern[Splines`Private`r, 
           Blank[]], 
          Pattern[Splines`Private`b, 
           BlankSequence[]]]] := 
       Row[{"SplineFunction[", Splines`Private`t, ", ", Splines`Private`r, 
          ", ", "<>", "]"}], 
       TagSet[Splines`SplineFunction, 
        MessageName[Splines`SplineFunction, "dmval"], 
        "Input value `1` lies outside the domain of the spline function."], 
       TagSet[Splines`SplineFunction, 
        MessageName[Splines`SplineFunction, "usage"], 
        "\!\(\*RowBox[{\"SplineFunction\", \"[\", RowBox[{StyleBox[\"type\", \
\"TI\"], \",\", StyleBox[\"domain\", \"TI\"], \",\", StyleBox[\"internal\", \
\"TI\"]}], \"]\"}]\) represents a spline function created by the SplineFit \
function parametrizing a curve with the parameter in the specified \
\!\(\*StyleBox[\"domain\", \"TI\"]\). When given a parameter value as an \
argument it returns the corresponding point on the curve."], 
       Splines`Private`evalspline[
         PatternTest[
          Pattern[Splines`Private`pt, 
           Blank[]], # == 0& ], Splines`Cubic, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]] := Part[Splines`Private`internal, 1, All, 1], 
       Splines`Private`evalspline[
         Pattern[Splines`Private`pt, 
          Blank[]], Splines`Cubic, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]] := Module[{Splines`Private`tmp}, 
         Dot[
          ({1, #, #^2, #^3}& )[
           
           If[(Splines`Private`tmp = Mod[Splines`Private`pt, 1]) == 0, 1, 
            Splines`Private`tmp]], 
          Transpose[
           Part[Splines`Private`internal, 
            Ceiling[Splines`Private`pt]]]]], Splines`Private`evalspline[
         Pattern[Splines`Private`pt, 
          Blank[]], Splines`CompositeBezier, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]] := 
       Module[{Splines`Private`ln = Length[Splines`Private`pts] - 1}, 
         Splines`Private`evalspline[
          If[
          Splines`Private`ln <= 3, Splines`Private`pt/Splines`Private`ln, 
           Splines`Private`pt (1/2 - If[
             OddQ[Splines`Private`ln], 1/(2 Splines`Private`ln), 0])], 
          Splines`Cubic, Splines`Private`pts, Splines`Private`internal]], 
       Splines`Private`evalspline[
         Pattern[Splines`Private`pt, 
          Blank[]], Splines`Bezier, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]] := 
       Splines`Private`internal[
        Splines`Private`pt/(Length[Splines`Private`pts] - 1)], 
       Attributes[MakeBoxes] = {HoldAllComplete}, 
       Splines`Private`splineinternal[
         Pattern[Splines`Private`pts, 
          Blank[List]], Splines`Cubic] := Transpose[
         Map[Splines`Private`splinecoord, 
          Transpose[Splines`Private`pts]]], Splines`Private`splineinternal[
         Pattern[Splines`Private`pts, 
          Blank[List]], Splines`CompositeBezier] := 
       Module[{Splines`Private`eqns, Splines`Private`gpts = 
          Splines`Private`pts, Splines`Private`ln = 
          Length[Splines`Private`pts], Splines`Private`end}, If[
           Or[Splines`Private`ln < 3, 
            OddQ[Splines`Private`ln]], 
           Which[Splines`Private`ln == 1, Splines`Private`gpts = Flatten[
              Table[Splines`Private`gpts, {4}]], Splines`Private`ln == 2, 
            Splines`Private`gpts = {
              Part[Splines`Private`gpts, 1], 
              Part[Splines`Private`gpts, 1], 
              Part[Splines`Private`gpts, 2], 
              Part[Splines`Private`gpts, 2]}, 
            OddQ[Splines`Private`ln], 
            AppendTo[Splines`Private`gpts, 
             Last[Splines`Private`gpts]], True, Message[
              MessageName[Splines`SplineFit, "cbezlen"]]; Return[
              InString[$Line]]]]; 
         Splines`Private`end = Take[Splines`Private`gpts, -4]; 
         Splines`Private`gpts = Partition[
            Drop[Splines`Private`gpts, -2], 4, 2]; 
         Splines`Private`gpts = 
          Apply[{#, #2, #3 - (#4 - #3), #3}& , Splines`Private`gpts, {1}]; 
         AppendTo[Splines`Private`gpts, Splines`Private`end]; 
         Apply[Transpose[{#, 3 (#2 - #), 3 (#3 - 2 #2 + #), #4 - 3 #3 + 
             3 #2 - #}]& , Splines`Private`gpts, {1}]], 
       Splines`Private`splineinternal[
         Pattern[Splines`Private`pts, 
          Blank[List]], Splines`Bezier] := 
       Module[{Splines`Private`n, Splines`Private`eq, Splines`Private`deg = 
          Length[Splines`Private`pts] - 1}, 
         Splines`Private`eq = 
          Table[#^Splines`Private`n (1 - #)^(Splines`Private`deg - 
              Splines`Private`n), {
            Splines`Private`n, 0, Splines`Private`deg}]; Evaluate[
           Apply[Plus, (Splines`Private`pts Table[
               Binomial[Splines`Private`deg, Splines`Private`n], {
               Splines`Private`n, 0, Splines`Private`deg}]) 
            Splines`Private`eq]]& ], Splines`Private`splinecoord[
         Pattern[Splines`Private`vals, 
          Blank[]]] := 
       Module[{Splines`Private`lst, Splines`Private`ln = 
          Length[Splines`Private`vals], Splines`Private`d, Splines`Private`n},
          Splines`Private`lst = 
          Join[{3 (Part[Splines`Private`vals, 2] - Part[
              Splines`Private`vals, 1])}, 
            Table[
            3 (Part[Splines`Private`vals, Splines`Private`n + 2] - Part[
              Splines`Private`vals, Splines`Private`n]), {
             Splines`Private`n, Splines`Private`ln - 2}], {
            3 (Part[Splines`Private`vals, Splines`Private`ln] - Part[
              Splines`Private`vals, Splines`Private`ln - 1])}]; 
         Splines`Private`d = 
          Splines`Private`trisolve[Splines`Private`lst, Splines`Private`ln]; 
         Table[{
            Part[Splines`Private`vals, Splines`Private`n], 
            Part[Splines`Private`d, Splines`Private`n], 
            3 (Part[Splines`Private`vals, Splines`Private`n + 1] - Part[
              Splines`Private`vals, Splines`Private`n]) - 2 
            Part[Splines`Private`d, Splines`Private`n] - Part[
            Splines`Private`d, Splines`Private`n + 1], 
            2 (Part[Splines`Private`vals, Splines`Private`n] - Part[
              Splines`Private`vals, Splines`Private`n + 1]) + 
            Part[Splines`Private`d, Splines`Private`n] + 
            Part[Splines`Private`d, Splines`Private`n + 1]}, {
           Splines`Private`n, 1, Splines`Private`ln - 1}]], 
       Splines`Private`trisolve[
         Pattern[Splines`Private`lst, 
          Blank[]], 
         Pattern[Splines`Private`ln, 
          Blank[]]] := Module[{}, 
         LinearSolve[
          SparseArray[{Band[{1, 1}] -> Join[{2}, 
              Table[4, {Splines`Private`ln - 2}], {2}], Band[{1, 2}] -> 1, 
            Band[{2, 1}] -> 1}], Splines`Private`lst]], $Line = 31, 
       AtomicDensityMatrix`LevelDiagram`Private`adjustArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`xpos, 
          AtomicDensityMatrix`LevelDiagram`Private`vertxranges, 
          AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`otherArrows}, If[
           Or[
            Not[
             NumericQ[
             AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue]], 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue == 0, 
            AtomicDensityMatrix`LevelDiagram`Private`arrows == {}], 
           Return[AtomicDensityMatrix`LevelDiagram`Private`arrows]]; {
           AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`otherArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
           AtomicDensityMatrix`LevelDiagram`Private`arrows, 
            Chop[AtomicDensityMatrix`LevelDiagram`Private`tx[#] - 
              AtomicDensityMatrix`LevelDiagram`Private`bx[#]] == 0& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          SortBy[AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`bx]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Split[AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
            Abs[AtomicDensityMatrix`LevelDiagram`Private`bx[#] - 
              AtomicDensityMatrix`LevelDiagram`Private`bx[#2]] < 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Map[SortBy[#, AtomicDensityMatrix`LevelDiagram`Private`by[#] - 
             AtomicDensityMatrix`LevelDiagram`Private`ty[#]& ]& , 
            AtomicDensityMatrix`LevelDiagram`Private`vertArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Map[AtomicDensityMatrix`LevelDiagram`Private`\
partitionVerticalArrows, AtomicDensityMatrix`LevelDiagram`Private`vertArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`xpos = 
          Map[(AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue 
              AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue) (
              Range[
                Length[#]] - (Length[#] + 1)/2) + Mean[
              Map[AtomicDensityMatrix`LevelDiagram`Private`tx, 
               Part[#, All, 1]]]& , 
            AtomicDensityMatrix`LevelDiagram`Private`vertArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Map[MapThread[
            AtomicDensityMatrix`LevelDiagram`Private`setTopBottom, #]& , 
            
            Transpose[{
             AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
              AtomicDensityMatrix`LevelDiagram`Private`xpos}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertxranges = Map[{
             Min[#], 
             Max[#]}& , 
            Map[
            AtomicDensityMatrix`LevelDiagram`Private`tx, 
             AtomicDensityMatrix`LevelDiagram`Private`vertArrows, {3}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Flatten[AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 2]; 
         AtomicDensityMatrix`LevelDiagram`Private`otherArrows = 
          Map[AtomicDensityMatrix`LevelDiagram`Private`clearLeftRight[#, 
             AtomicDensityMatrix`LevelDiagram`Private`vertxranges]& , 
            AtomicDensityMatrix`LevelDiagram`Private`otherArrows]; {
           AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`otherArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
           AtomicDensityMatrix`LevelDiagram`Private`otherArrows, Or[
            AtomicDensityMatrix`LevelDiagram`Private`ar[#] > 0, 
             And[
             AtomicDensityMatrix`LevelDiagram`Private`ar[#] == 0, 
              AtomicDensityMatrix`LevelDiagram`Private`slope[#] == 0]]& ]; {
           AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`otherArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
           AtomicDensityMatrix`LevelDiagram`Private`otherArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`ar[#] < 0& ]; {
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
           AtomicDensityMatrix`LevelDiagram`Private`otherArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`slope[#] > 0& ]; {
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`lx, 
            AtomicDensityMatrix`LevelDiagram`Private`ly, 
            AtomicDensityMatrix`LevelDiagram`Private`setLeft, 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue, 
            AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue]; {
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`rx, 
            AtomicDensityMatrix`LevelDiagram`Private`ry, 
            AtomicDensityMatrix`LevelDiagram`Private`setRight, 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue, -
            AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue]; {
           AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
            Join[
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
             AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows], Or[
            AtomicDensityMatrix`LevelDiagram`Private`ar[#] < 0, 
             And[
             AtomicDensityMatrix`LevelDiagram`Private`ar[#] == 0, 
              AtomicDensityMatrix`LevelDiagram`Private`slope[#] == 0]]& ]; {
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`rx, 
            AtomicDensityMatrix`LevelDiagram`Private`ry, 
            AtomicDensityMatrix`LevelDiagram`Private`setRight, 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue, -
            AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue]; {
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`lx, 
            AtomicDensityMatrix`LevelDiagram`Private`ly, 
            AtomicDensityMatrix`LevelDiagram`Private`setLeft, 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue, 
            AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue]; 
         Join[AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
           AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
           AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows]], 
       AtomicDensityMatrix`LevelDiagram`Private`DivideList[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`list, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`func, 
          Blank[]]] := ({
         Extract[AtomicDensityMatrix`LevelDiagram`Private`list, #], 
         Delete[AtomicDensityMatrix`LevelDiagram`Private`list, #]}& )[
         Position[AtomicDensityMatrix`LevelDiagram`Private`list, 
          PatternTest[
           Blank[], AtomicDensityMatrix`LevelDiagram`Private`func], {1}, 
          Heads -> False]], AtomicDensityMatrix`LevelDiagram`Private`tx[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         AtomicDensityMatrix`LevelDiagram`Private`tpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`tpts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         SortBy[
          AtomicDensityMatrix`LevelDiagram`Private`pts[
          AtomicDensityMatrix`LevelDiagram`Private`arr], Reverse]], 
       AtomicDensityMatrix`LevelDiagram`Private`pts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := 
       Part[AtomicDensityMatrix`LevelDiagram`Private`arr, -1, 1], 
       AtomicDensityMatrix`LevelDiagram`Private`bx[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         AtomicDensityMatrix`LevelDiagram`Private`bpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`bpts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         SortBy[
          AtomicDensityMatrix`LevelDiagram`Private`pts[
          AtomicDensityMatrix`LevelDiagram`Private`arr], Reverse]], 
       AtomicDensityMatrix`LevelDiagram`Private`by[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         AtomicDensityMatrix`LevelDiagram`Private`bpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`ty[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         AtomicDensityMatrix`LevelDiagram`Private`tpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`partitions, 
          Blank[]], {}] := 
       AtomicDensityMatrix`LevelDiagram`Private`partitions, 
       AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          Blank[]]] := 
       AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[{{
           First[AtomicDensityMatrix`LevelDiagram`Private`arrows]}}, 
         Rest[AtomicDensityMatrix`LevelDiagram`Private`arrows]], 
       AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`partitions, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`interval, 
          AtomicDensityMatrix`LevelDiagram`Private`position}, 
         AtomicDensityMatrix`LevelDiagram`Private`interval = Apply[Interval, 
            Map[{
              AtomicDensityMatrix`LevelDiagram`Private`by[#], 
              AtomicDensityMatrix`LevelDiagram`Private`ty[#]}& , 
             Last[AtomicDensityMatrix`LevelDiagram`Private`partitions]]]; 
         AtomicDensityMatrix`LevelDiagram`Private`interval = 
          Interval[{10.^(-10), (-1) 10.^(-10)} + 
            First[AtomicDensityMatrix`LevelDiagram`Private`interval]]; 
         AtomicDensityMatrix`LevelDiagram`Private`position = 
          Position[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
            Condition[
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
              Blank[List]], 
             IntervalIntersection[
              AtomicDensityMatrix`LevelDiagram`Private`interval, 
               Interval[{
                 AtomicDensityMatrix`LevelDiagram`Private`by[
                 AtomicDensityMatrix`LevelDiagram`Private`arr], 
                 AtomicDensityMatrix`LevelDiagram`Private`ty[
                 AtomicDensityMatrix`LevelDiagram`Private`arr]}]] == 
             Interval[]], {1}, 1]; 
         If[AtomicDensityMatrix`LevelDiagram`Private`position == {}, 
           AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
            Append[AtomicDensityMatrix`LevelDiagram`Private`partitions, {
              First[AtomicDensityMatrix`LevelDiagram`Private`arrows]}], 
            Rest[AtomicDensityMatrix`LevelDiagram`Private`arrows]], 
           AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
            MapAt[Append[#, 
              Part[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
               Part[
               AtomicDensityMatrix`LevelDiagram`Private`position, 1, 1]]]& , 
             AtomicDensityMatrix`LevelDiagram`Private`partitions, -1], 
            Delete[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
             Part[
             AtomicDensityMatrix`LevelDiagram`Private`position, 1, 1]]]]], 
       AtomicDensityMatrix`LevelDiagram`Private`setTopBottom[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`shift, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`LevelDiagram`Private`arr, 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y1, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y2, 
              Blank[]]}}, 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
            BlankSequence[]]] -> 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
            AtomicDensityMatrix`LevelDiagram`Private`shift, 
             AtomicDensityMatrix`LevelDiagram`Private`y1}, {
            AtomicDensityMatrix`LevelDiagram`Private`shift, 
             AtomicDensityMatrix`LevelDiagram`Private`y2}}, 
           AtomicDensityMatrix`LevelDiagram`Private`a]], 
       AtomicDensityMatrix`LevelDiagram`Private`clearLeftRight[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`ranges, 
          Blank[]]] := 
       Fold[AtomicDensityMatrix`LevelDiagram`Private`clearEndpoint[#, 
          AtomicDensityMatrix`LevelDiagram`Private`ranges, #2]& , 
         AtomicDensityMatrix`LevelDiagram`Private`arr, {{
          AtomicDensityMatrix`LevelDiagram`Private`lx, 
           AtomicDensityMatrix`LevelDiagram`Private`setLeft, Max}, {
          AtomicDensityMatrix`LevelDiagram`Private`rx, 
           AtomicDensityMatrix`LevelDiagram`Private`setRight, Min}}], 
       AtomicDensityMatrix`LevelDiagram`Private`clearEndpoint[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`ranges, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`p, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`setFunc, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`minmax, 
           Blank[]]}] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`range = 
          Apply[Interval, 
            Cases[AtomicDensityMatrix`LevelDiagram`Private`ranges, 
             Condition[{
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`min, 
                Blank[]], 
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`max, 
                Blank[]]}, AtomicDensityMatrix`LevelDiagram`Private`min < 
              AtomicDensityMatrix`LevelDiagram`Private`p[
               AtomicDensityMatrix`LevelDiagram`Private`arr] < 
              AtomicDensityMatrix`LevelDiagram`Private`max]]]}, 
         If[
         AtomicDensityMatrix`LevelDiagram`Private`range === Interval[], 
          AtomicDensityMatrix`LevelDiagram`Private`arr, 
          AtomicDensityMatrix`LevelDiagram`Private`setFunc[
          AtomicDensityMatrix`LevelDiagram`Private`arr, 
           AtomicDensityMatrix`LevelDiagram`Private`minmax[
            First[AtomicDensityMatrix`LevelDiagram`Private`range]]]]], 
       AtomicDensityMatrix`LevelDiagram`Private`lx[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         AtomicDensityMatrix`LevelDiagram`Private`lpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`lpts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         Sort[
          AtomicDensityMatrix`LevelDiagram`Private`pts[
          AtomicDensityMatrix`LevelDiagram`Private`arr]]], 
       AtomicDensityMatrix`LevelDiagram`Private`setLeft[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`shift, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`LevelDiagram`Private`arr, 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y1, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y2, 
              Blank[]]}}, 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
            BlankSequence[]]] :> 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
            AtomicDensityMatrix`LevelDiagram`Private`x1 + (
               AtomicDensityMatrix`LevelDiagram`Private`shift - 
               AtomicDensityMatrix`LevelDiagram`Private`x1) 
              Boole[AtomicDensityMatrix`LevelDiagram`Private`x1 < 
                AtomicDensityMatrix`LevelDiagram`Private`x2], 
             AtomicDensityMatrix`LevelDiagram`Private`y1}, {
            AtomicDensityMatrix`LevelDiagram`Private`x2 + (
               AtomicDensityMatrix`LevelDiagram`Private`shift - 
               AtomicDensityMatrix`LevelDiagram`Private`x2) 
              Boole[AtomicDensityMatrix`LevelDiagram`Private`x2 < 
                AtomicDensityMatrix`LevelDiagram`Private`x1], 
             AtomicDensityMatrix`LevelDiagram`Private`y2}}, 
           AtomicDensityMatrix`LevelDiagram`Private`a]], 
       AtomicDensityMatrix`LevelDiagram`Private`rx[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         AtomicDensityMatrix`LevelDiagram`Private`rpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`rpts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         Sort[
          AtomicDensityMatrix`LevelDiagram`Private`pts[
          AtomicDensityMatrix`LevelDiagram`Private`arr]]], 
       AtomicDensityMatrix`LevelDiagram`Private`setRight[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`shift, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`LevelDiagram`Private`arr, 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y1, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y2, 
              Blank[]]}}, 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
            BlankSequence[]]] :> 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
            AtomicDensityMatrix`LevelDiagram`Private`x1 + (
               AtomicDensityMatrix`LevelDiagram`Private`shift - 
               AtomicDensityMatrix`LevelDiagram`Private`x1) 
              Boole[AtomicDensityMatrix`LevelDiagram`Private`x1 > 
                AtomicDensityMatrix`LevelDiagram`Private`x2], 
             AtomicDensityMatrix`LevelDiagram`Private`y1}, {
            AtomicDensityMatrix`LevelDiagram`Private`x2 + (
               AtomicDensityMatrix`LevelDiagram`Private`shift - 
               AtomicDensityMatrix`LevelDiagram`Private`x2) 
              Boole[AtomicDensityMatrix`LevelDiagram`Private`x2 > 
                AtomicDensityMatrix`LevelDiagram`Private`x1], 
             AtomicDensityMatrix`LevelDiagram`Private`y2}}, 
           AtomicDensityMatrix`LevelDiagram`Private`a]], 
       AtomicDensityMatrix`LevelDiagram`Private`ar[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := 
       If[Part[AtomicDensityMatrix`LevelDiagram`Private`arr, -1, 3] === 
         AtomicDensityMatrix`ConnectArc, 
         Part[AtomicDensityMatrix`LevelDiagram`Private`arr, -1, 2], 0], 
       AtomicDensityMatrix`LevelDiagram`Private`slope[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := AtomicDensityMatrix`Slope[
         AtomicDensityMatrix`LevelDiagram`Private`pts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`slantArrows, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`horizArrows, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`y, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`setFunc, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`xpos}, 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = Join[
            Map[{#, {0, -Abs[
                 AtomicDensityMatrix`LevelDiagram`Private`slope[#]]}}& , 
             AtomicDensityMatrix`LevelDiagram`Private`slantArrows], 
            
            Map[{#, {
              1, -(AtomicDensityMatrix`LevelDiagram`Private`rx[#] - 
                AtomicDensityMatrix`LevelDiagram`Private`lx[#])}}& , 
             AtomicDensityMatrix`LevelDiagram`Private`horizArrows]]; 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = 
          SortBy[AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, Through[
             {
             AtomicDensityMatrix`LevelDiagram`Private`y, 
              AtomicDensityMatrix`LevelDiagram`Private`x}[
              First[#]]]& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = 
          Split[AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, And[
            Chop[AtomicDensityMatrix`LevelDiagram`Private`y[
                 First[#]] - AtomicDensityMatrix`LevelDiagram`Private`y[
                First[#2]]] == 0, 
             Abs[AtomicDensityMatrix`LevelDiagram`Private`x[
                 First[#]] - AtomicDensityMatrix`LevelDiagram`Private`x[
                First[#2]]] < 
             AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue]& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = Map[Part[
             SortBy[#, Last], All, 1]& , 
            AtomicDensityMatrix`LevelDiagram`Private`shiftArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`xpos = 
          Map[(AtomicDensityMatrix`LevelDiagram`Private`arrowSpacingValue 
              AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue) Range[
               Length[#]] + Mean[
              Map[AtomicDensityMatrix`LevelDiagram`Private`x, #]]& , 
            AtomicDensityMatrix`LevelDiagram`Private`shiftArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = 
          MapThread[AtomicDensityMatrix`LevelDiagram`Private`setFunc, {
             Flatten[AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, 1], 
             Flatten[AtomicDensityMatrix`LevelDiagram`Private`xpos]}]; 
         AtomicDensityMatrix`LevelDiagram`Private`DivideList[
          AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, And[
           AtomicDensityMatrix`LevelDiagram`Private`ar[#] == 0, 
            AtomicDensityMatrix`LevelDiagram`Private`slope[#] != 0]& ]], 
       AtomicDensityMatrix`LevelDiagram`Private`ly[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         AtomicDensityMatrix`LevelDiagram`Private`lpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`ry[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         AtomicDensityMatrix`LevelDiagram`Private`rpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       TagSet[AtomicDensityMatrix`ArrowSpacing, 
        MessageName[AtomicDensityMatrix`ArrowSpacing, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`makePopulations[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`populationFunctionValue, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`populationStyleValue, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`popsty, 
          AtomicDensityMatrix`LevelDiagram`Private`popfunc, 
          AtomicDensityMatrix`LevelDiagram`Private`pops}, 
         If[AtomicDensityMatrix`LevelDiagram`Private`rho === {{0}}, 
           Return[{}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`popsty = 
          Replace[AtomicDensityMatrix`LevelDiagram`Private`\
populationStyleValue, List -> Sequence, {1}, Heads -> True]; 
         AtomicDensityMatrix`LevelDiagram`Private`popfunc = 
          ReplaceAll[
           AtomicDensityMatrix`LevelDiagram`Private`populationFunctionValue, {
            Alternatives[Automatic, "DiskTriangle"] -> 
             AtomicDensityMatrix`LevelDiagram`Private`diskTrianglePopFunc, 
             "Bar" -> AtomicDensityMatrix`LevelDiagram`Private`barPopFunc}]; 
         AtomicDensityMatrix`LevelDiagram`Private`pops = 
          MapThread[
           AtomicDensityMatrix`LevelDiagram`Private`popfunc[#, #2, 
             AtomicDensityMatrix`LevelDiagram`Private`levelLengthValue]& , {
            AtomicDensityMatrix`LevelDiagram`Private`pos, 
             Diagonal[AtomicDensityMatrix`LevelDiagram`Private`rho]}]; {
          AtomicDensityMatrix`LevelDiagram`Private`popsty, 
           AtomicDensityMatrix`LevelDiagram`Private`pops}], 
       AtomicDensityMatrix`LevelDiagram`Private`diskTrianglePopFunc[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pop, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]]] := AtomicDensityMatrix`TakeFraction[
         AtomicDensityMatrix`DiskTriangle[
         AtomicDensityMatrix`LevelDiagram`Private`pos + {
           0, 0.075 AtomicDensityMatrix`LevelDiagram`Private`length}, 6, 0.15 
          AtomicDensityMatrix`LevelDiagram`Private`length, 0.07 
          AtomicDensityMatrix`LevelDiagram`Private`length], 
         AtomicDensityMatrix`LevelDiagram`Private`pop], 
       AtomicDensityMatrix`TakeFraction[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`expr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
          Blank[]]] := Take[AtomicDensityMatrix`LevelDiagram`Private`expr, 
         Round[
         AtomicDensityMatrix`LevelDiagram`Private`x 
          Length[AtomicDensityMatrix`LevelDiagram`Private`expr]]], 
       TagSet[AtomicDensityMatrix`TakeFraction, 
        MessageName[AtomicDensityMatrix`TakeFraction, "usage"], 
        "TakeFraction[\!\(\*\nStyleBox[\"list\", \"TI\"]\),\!\(\*\n\
StyleBox[\"f\", \"TI\"]\)] takes a fraction \!\(\*\nStyleBox[\"f\", \"TI\"]\) \
of the elements of \!\(\*\nStyleBox[\"list\", \"TI\"]\), rounded to the \
nearest element."], AtomicDensityMatrix`DiskTriangle[{
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`x0, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`y0, 
           Blank[]]}, 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`n, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`s, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`r, 
          Blank[]]] := Flatten[
         Table[
          Disk[
          AtomicDensityMatrix`LevelDiagram`Private`s {
             AtomicDensityMatrix`LevelDiagram`Private`x, (Sqrt[3] 
               AtomicDensityMatrix`LevelDiagram`Private`y)/2.} + {
            AtomicDensityMatrix`LevelDiagram`Private`x0, 
             AtomicDensityMatrix`LevelDiagram`Private`y0}, 
           AtomicDensityMatrix`LevelDiagram`Private`r], {
          AtomicDensityMatrix`LevelDiagram`Private`y, 0, 
           AtomicDensityMatrix`LevelDiagram`Private`n - 1}, {
          AtomicDensityMatrix`LevelDiagram`Private`x, -((
             AtomicDensityMatrix`LevelDiagram`Private`n - 
             AtomicDensityMatrix`LevelDiagram`Private`y - 1)/2), (
            AtomicDensityMatrix`LevelDiagram`Private`n - 
            AtomicDensityMatrix`LevelDiagram`Private`y - 1)/2}]], 
       TagSet[AtomicDensityMatrix`DiskTriangle, 
        MessageName[AtomicDensityMatrix`DiskTriangle, "usage"], 
        "Draws a filled triangle made up of individual disks."], 
       AtomicDensityMatrix`LevelDiagram`Private`barPopFunc[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pop, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]]] := 
       Rectangle[
        AtomicDensityMatrix`LevelDiagram`Private`pos + {(-0.2) 
           AtomicDensityMatrix`LevelDiagram`Private`length, 0}, 
         AtomicDensityMatrix`LevelDiagram`Private`pos + {
          0.2 AtomicDensityMatrix`LevelDiagram`Private`length, 
           AtomicDensityMatrix`LevelDiagram`Private`pop}], 
       TagSet[AtomicDensityMatrix`PopulationFunction, 
        MessageName[AtomicDensityMatrix`PopulationFunction, "usage"], ""], 
       TagSet[AtomicDensityMatrix`PopulationStyle, 
        MessageName[AtomicDensityMatrix`PopulationStyle, "usage"], ""], 
       AtomicDensityMatrix`TextOnTop[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`g, 
          Blank[Graphics]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`heads = {
           AffineHalfSpace, AffineSpace, Annulus, Arrow, ArrowBox, Ball, 
            BezierCurve, BezierCurveBox, BoundaryMeshRegion, BSplineCurve, 
            BSplineCurveBox, BSplineSurface, BSplineSurface3DBox, 
            CapsuleShape, Circle, CircleBox, Cone, ConeBox, ConicHullRegion, 
            ConicHullRegion3DBox, ConicHullRegionBox, Cuboid, CuboidBox, 
            Cylinder, CylinderBox, Disk, DiskBox, DiskSegment, Ellipsoid, 
            FilledCurve, FilledCurveBox, GeoGraphics, GeometricTransformation,
             GeometricTransformationBox, GraphicsComplex, GraphicsComplexBox, 
            GraphicsGroup, GraphicsGroupBox, HalfLine, HalfPlane, HalfSpace, 
            Hexahedron, HexahedronBox, Hyperplane, InfiniteLine, 
            InfinitePlane, InfinitePlane, JoinedCurve, JoinedCurveBox, 
            Legended, Line, LineBox, LineLegend, MeshRegion, Panel, PanelBox, 
            Parallelepiped, Parallelogram, Placed, Point, PointBox, Polygon, 
            PolygonBox, Prism, PrismBox, Pyramid, PyramidBox, Raster, 
            Raster3D, Raster3DBox, RasterBox, Rectangle, RectangleBox, 
            RegularPolygon, Rotate, Scale, Simplex, Sphere, SphereBox, 
            SphericalShell, StadiumShape, SurfaceGraphics, Tetrahedron, 
            TetrahedronBox, Texture, Translate, Triangle, Tube, TubeBox}, 
          AtomicDensityMatrix`LevelDiagram`Private`glist, 
          AtomicDensityMatrix`LevelDiagram`Private`opts}, 
         AtomicDensityMatrix`LevelDiagram`Private`glist = 
          ReplaceAll[
           AtomicDensityMatrix`LevelDiagram`Private`g, {{Blank[Text] -> {}}, {
             Apply[Alternatives, 
                Map[
                Blank, AtomicDensityMatrix`LevelDiagram`Private`heads]] -> \
{}}}]; AtomicDensityMatrix`LevelDiagram`Private`opts = DeleteCases[
            Table[
            AtomicDensityMatrix`LevelDiagram`Private`opt -> DeleteCases[
               Map[Part[
                 Options[#, AtomicDensityMatrix`LevelDiagram`Private`opt], 1, 
                 2]& , AtomicDensityMatrix`LevelDiagram`Private`glist], {}], {
             AtomicDensityMatrix`LevelDiagram`Private`opt, {Prolog, Epilog}}],
             Blank[] -> {}]; 
         Show[AtomicDensityMatrix`LevelDiagram`Private`glist, 
           Apply[Sequence, AtomicDensityMatrix`LevelDiagram`Private`opts]]], 
       TagSet[AtomicDensityMatrix`TextOnTop, 
        MessageName[AtomicDensityMatrix`TextOnTop, "usage"], 
        ""], $DisplayFunction = Identity, $CellContext`regimefunc[
         Pattern[$CellContext`x, 
          Blank[]]] = Piecewise[{{
           RGBColor[
           0.9019607843137255, 1., 0.8117647058823529], -0.3 < $CellContext`x < 
           0.3}, {
           RGBColor[
           0.9372549019607843, 0.8862745098039215, 1.], -3 < $CellContext`x < 
           3}, {
           RGBColor[
           0.8823529411764706, 0.9490196078431372, 1.], -11 < $CellContext`x < 
           11}}, 0]}; Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellLabel->"Out[31]=",
 CellID->2102288953,ExpressionUUID->"4b350e7f-1ee9-4f90-a3d5-4c7aebced31b"]
}, Open  ]],

Cell[TextData[{
 "The three ground-state sublevels now correspond to the ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "6d173e8a-597a-4422-9582-5d37d6fa6ed4"],
 " state (identical to the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "0"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "e9143781-37ca-4a76-b877-7a44cb9921c1"],
 " sublevel) and the dark and bright linear combinations of the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", 
    RowBox[{"-", "1"}]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "87f32d54-1383-4acc-872a-11100d1b86be"],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "56219f8c-75a1-42af-81d1-14d2e634c131"],
 " sublevels. For ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[CapitalDelta]", 
     RowBox[{"1", ",", "2"}]], "\[NotEqual]", "0"}], TraditionalForm]], 
  "InlineMath",ExpressionUUID->"e73102e7-dd8d-4640-b5cb-33a67c897ddc"],
 ", the pump and probe fields interact with both the dark and bright states, \
as can be seen on the diagram. We can examine the three regimes discussed \
above in terms of this diagram:"
}], "Text",
 CellID->218409195,ExpressionUUID->"e8352e86-a61e-44d5-8036-60fbf5217619"],

Cell[TextData[{
 "(1) When the probe is far detuned, only the pump beam is effective. Since \
it interacts equally with both the dark and bright states, these states are \
equally pumped into the ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "8b167563-3293-4119-9570-9d654061e250"],
 " state, which is the only true dark state in this regime."
}], "Text",
 Background->RGBColor[0.8823529411764706, 0.9490196078431372, 1.],
 CellID->445693047,ExpressionUUID->"cfcd6f25-d82b-47af-89ce-a0f67f86949d"],

Cell[TextData[{
 "(2) As the probe is tuned onto optical resonance, it also becomes \
effective, pumping more atoms into the ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "e9e1e0b6-543e-4846-bc4b-f7c9913b88c5"],
 " state. Since the pump and probe act incoherently in this regime (the \
resultant light polarization rotates too quickly for the atomic polarization \
to \"keep up\"), both the dark and bright states are pumped equally."
}], "Text",
 Background->RGBColor[0.9372549019607843, 0.8862745098039215, 1.],
 CellID->29981939,ExpressionUUID->"5d9e7fb4-f661-422d-a252-e2d58c2d7064"],

Cell[TextData[{
 "(3) When the probe frequency is tuned close enough to that of the pump, the \
pump and probe fields add coherently. The combination of the pump and probe \
field that interacts with the bright state is reinforced, while the \
combination that interacts with the dark state cancels, as seen in the \
diagram. Thus the bright state is pumped efficiently into the dark and ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "648bdfa5-c71a-40f7-ad85-517a1ba354c2"],
 " states. Since the probe light only probes the population of the bright \
state, the absorption of the probe drops in this regime."
}], "Text",
 Background->RGBColor[0.9019607843137255, 1., 0.8117647058823529],
 CellID->539741880,ExpressionUUID->"11e88b89-a911-4928-b940-eb8e82b13e2c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Angular-momentum probability surfaces", "Section",
 CellID->164439161,ExpressionUUID->"7284defd-9622-4558-a3fb-a857d3ee3122"],

Cell[TextData[{
 "The limitation of the population plots, as we can see, is that they are \
very different depending on the chosen basis; in addition, the plot for any \
given basis does not contain complete information about the system. There is \
an alternative method for displaying the ground-state polarization that is \
basis-independent and contains the complete information about the \
ground-state density matrix. This is the method of angular-momentum \
probability surfaces (see \"",
 ButtonBox["Angular-momentum Probability Surfaces",
  BaseStyle->"Link",
  ButtonData->"paclet:AtomicDensityMatrix/tutorial/Example_AMPS"],
 "\")."
}], "Text",
 CellID->12811769,ExpressionUUID->"d26e8e61-2b3f-4c60-8401-55676df3eff2"],

Cell["\<\
Here we plot the angular-momentum probability surfaces for the ground-state \
polarization in each of the three regimes.\
\>", "Text",
 CellID->73493904,ExpressionUUID->"c788fd18-bf64-4864-8275-ac2f298e7438"],

Cell["The ground-state density matrix.", "MathCaption",
 CellID->360085939,ExpressionUUID->"07e2ddae-1ddf-4827-80b9-e51ceebdf78b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"gdm", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"DensityMatrix", "[", 
      RowBox[{"SelectStates", "[", 
       RowBox[{"sys", ",", "1"}], "]"}], "]"}], "/.", "sol1"}], "/.", 
    "params"}]}], ";"}]], "Input",
 CellLabel->"In[32]:=",
 CellID->111926304,ExpressionUUID->"d5cf6d64-e037-4f79-882f-35428b02a660"],

Cell["\<\
Angular-momentum probability surfaces for regimes (1), (2), and (3).\
\>", "MathCaption",
 CellID->669161435,ExpressionUUID->"687c771f-3e54-4057-925d-7ece3ee1e8d4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Axes3D", "[", 
      RowBox[{
       RowBox[{"AMPSPlot", "[", 
        RowBox[{"gdm", ",", 
         RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
         RowBox[{"Axes", "\[Rule]", "False"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
         RowBox[{"ViewPoint", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"1.6", ",", "2.4`", ",", ".75"}], "}"}]}], ",", 
         RowBox[{"PlotRegion", "\[Rule]", 
          RowBox[{"Crop", "@", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{".3", ",", ".65"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{".2", ",", "1"}], "}"}]}], "}"}]}]}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"regimefunc", "[", 
           SubscriptBox["\[CapitalDelta]", 
            RowBox[{"1", ",", "2"}]], "]"}]}]}], "]"}], ",", ".9"}], "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["\[CapitalDelta]", 
        RowBox[{"1", ",", "2"}]], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "10"}], ",", 
         RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"Spacings", "\[Rule]", "0"}], ",", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{
          RowBox[{"\"\<(\>\"", "<>", 
           RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<)\>\""}], ",", 
          "11"}], "]"}], ",", 
        RowBox[{"ImageScaled", "@", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"i", "-", ".8"}], ")"}], "/", "3"}], ",", ".8"}], 
          "}"}]}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "3"}], "}"}]}], "]"}]}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "Large"}]}], "]"}]], "Input",
 CellLabel->"In[32]:=",
 CellID->91118326,ExpressionUUID->"846d1cd6-cd15-4a00-911d-ee8755cd0e44"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzs3Qd0VFXiBnA20/tMeqOFJr2FEurQe++dhE5I7yHl0Yt0pXcEKYqiKDb0
gQVs2BXLWnAV267Zdav7133/W2aGUGTdheRmc797ficnTIb4NCfj980tr25S
2sjZQTVq1Mgykw8jE/N6ZGYmFoxykz+MSc2aNyd11swBqdmz5szK7JikIw/u
+02NGoq+Rg36uYaBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGB
gYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGB
gYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGB
gYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGBgYGB
gYGBgYGBgYGBgYGBgYGBgYFRZcalHwAABCj7HABAgMva6wAAQqB/AYBAwjMY
AMhJeAADAGmhfwGAQMIzGADISXgAAwBpoX8BgEDCMxgAyEl4AAMAaaF/AYBA
wjMYAMhJeAADAGmhfwGAQMIzGADISXgAAwBpoX8BgEDCMxgAyEl4AAMAaaF/
AYBAwjMYAMhJeAADAGmhfwGAQMIzGADISXgAAwBpoX8BgEDCMxgAyEl4AAMA
aaF/AYBAwjMYAMhJeAADAGmhfwGAQMIzGADISXgAAwBpoX8BgEDCMxgAyEl4
AAMAaaF/AYBAwjMYAMhJeAADAGmhfwGAQMIzGADISXgAAwBpoX8BgEDCMxgA
yEl4AAMAaaF/AYBAwjMYAMhJeAADAGmhfwGAQMIzGADISXgAAwBpoX8BgEDC
MxgAyEl4AAMAaaF/AYBAwjMYAMhJeAADAGmhfwGAQMIzGADISXgAAwBpoX8B
gEDCMxgAyEl4AAMAaaF/AYBAwjMYAMhJeAADAGmhfwGAQMIzGADISXgAAwBp
oX8BgEDCMxgAyEl4AAMAaaF/AYBAwjMYAMhJeAADAGmhfwGAQMIzGADISXgA
AwBpoX8BgEDCMxgAyEl4AAMAaaF/AYBAwjMYAMhJeAADAGmhfwGAQMIzGADI
SXgAAwBpoX8BgEDCMxgAyEl4AAMAaaF/AYBAwjMYAMhJeAADAGmhfwGAQMIz
GADISXgAAwBpoX8BgEDCMxgAyEl4AAMAaaF/AYBAwjMYAMhJeAADAGmhfwGA
QMIzGADISXgAAwBpoX8BgEDCMxgAyEl4AAMAaaF/AYBAwjMYAMhJeAADAGmh
fwGAQMIzGADISXgAAwBpoX8BgEDCMxgAyEl4AAMAaaF/AYBAwjMYAMhJeAAD
AGmhfwGAQMIzGADISXgAAwBpoX8BgEDCMxgAyEl4AAMAaaF/AYBAwjMYAMhJ
eAADAGmhfwGAQMIzGADISXgAAwBpoX8BgEDCMxgAyEl4AAMAaaF/AYBAwjMY
AMhJeAADAGmhfwGAQMIzGADISXgAAwBpoX8BgEDCMxgAyEl4AAMAaaF/AYBA
wjMYAMhJeAADAGmhfwGAQMIzGADISXgAAwBpoX8BgEDCMxgAyEl4AAMAaaF/
AYBAwjMYAMhJeAADAGmhfwGAQMIzGADISXgAAwBpoX8BgEDCMxgAyEl4AAMA
aaF/AYBAwjMYAMhJeAADAGmhfwGAQMIzGADISXgAAwBpoX8BgEDCMxgAyEl4
AAMAaaF/AYBAwjMYAMhJeAADAGlVp/6VUaDUqFHjJl/t2NVb/pGjp1TyfPJR
+JUDSEt4Brtd8jPo6881D548pnZJ8HLkCUT5L5Hnk4/CrxxATsID2G2Upcwl
ryfXPHhc3dnJG8+RJ1zzJfJ88lH4lQPIqTr1L/JiQkrWDb/Eq9b17ezmlQ0A
KprwDHa7kFeS8vWqzN/IyCDlq4Z/lH/ODSsbAFQO4QHsNiKvJNc0LN7IyCDl
K/D6U75w3bCyAUDlqDb96yZNKlC+bvgE8uA182IAUGmEZ7Db4vomxR8hzSsw
wxWoY+XnvPhzhF8/gISEB7Db5fomxR8hzesmj1xmre2aRwCgclSP/sXL1w0n
v/iXbtK/SPnCKkQAUYRnsFvHi9U1k1/8BeeaZ/I1h+ULF58awypEgMonPIDd
FrxYXTP5xV9/rnkmnwgrPwV2/SMAUDmqU/+6/nHercjHX1p/eMk/O4YpMAAh
hGewW3fDZYR8z9c1D17fv65/BAAqh/AAdlvccBkhefCaRnb5Rm2L7wLDFBhA
5ase/euXChTpZYFJsV/qXzf/EgBUKOEZ7Nb9+gIVWJR4zV/HLjCAyic8gN0W
v75A3XBS7IYPAkBFqwb96yaLD8u7ScnCEkQAUYRnsFt0w8WH/9GTsQQRQAjh
AezW3XDx4TWOqzv5QYg3fCaWIAIIgf71678DANx2wjPYLfr1/euGk1//0XcA
gNtIeAC7df+2f/EVhnzccJrs1zQ4ALjtqkH/+pWzVzfpX9gCBiCK8Ax2i37l
7NUNDz/ksAUMQAjhAezW/dvZKz75xbeD3bCCYQsYgBDoX5fQvwDEEZ7BbtGv
6V83KV9l6F8AgggPYLfuP1o9yJ98TdVC/wIQAv3rEvoXgDjCM9gt+rf9iz/h
JvUK/QtACOEB7Nb9R/0rsBbx+gfRvwAqGfrXJfQvAHGEZ7BbdPP+9W/LVxn6
F4AgwgPYrful/sWXHV7/fPQvgCoC/euSv3/h/A2Ayic8g92im/Qv/qV/e7AG
7184fwOgkgkPYLfuhv3rlyrVTea/cP4GQCWrBv2Ln154K/0L5x8CiCI8g90i
vrfr+v71n56LiP4FUMmEB7Bbx0/VuH6q64anzd/wqEOcfwggRDXoX79y9eC/
7V+4/xdA5ROewW7RDVcP8gf549e7pmr9UoMDgAolPIDdun871UWKVfn7f13/
zF9qcABQoapB/7p00271a57za/46AFQE4Rns1vEXkPKPBA48vOG4pqxd/9cB
oBIID2C3xfVLCjlerMqPG27y+qW/DgAVqnr0r1uZwMLiQwCBhGewW3crE1hY
fAggivAAdlvcfAKLT3790lex+BBAlOrRv27lAEPev4T/KwDISXgGu3W3coAh
71/C/xUAJCQ8gN0Wt3KAIe9fwv8VACRUPfrXpf92CgyTXwBiCc9gt8V/NwWG
yS8AgYQHsNvlv9vDhckvAIGqTf+6xA6i/0+nwEjzwm2/AAQSnsFuF362xn/0
V0jzwm2/AEQRHsBuo07e+P90Cow0L9z2C0CU6tS/jp5SSZn69VNg/PnCLxtA
ZsIz2O1y8phKytSvnwLjzxd+2QDSEh7AbiN+wuGvnwLjzxd+2QDSqk79CwD+
5wjPYAAgJ+EBDACkhf4FAAIJz2AAICfhAQwApIX+BQACCc9gACAn4QEMAKSF
/gUAAgnPYAAgJ+EBDACkhf4FAAIJz2AAICfhAQwApIX+BQACCc9gACAn4QEM
AKSF/gUAAgnPYAAgJ+EBDACkhf4FAAIJz2AAICfhAQwApIX+BQACCc9gACAn
4QEMAKSF/gUAAgnPYAAgJ+EBDACkhf4FAAIJz2AAICfhAQwApIX+BQACCc9g
ACAn4QEMAKSF/gUAAgnPYAAgJ+EBDACkhf4FAAIJz2AAICfhAQwApIX+BQAC
Cc9gACAn4QEMAKSF/gUAAgnPYAAgJ+EBDACkhf4FAAIJz2AAICfhAQwApIX+
BQACCc9gACAn4QEMAKSF/gUAAgnPYAAgJ+EBDACkhf4FAAIJz2AAICfhAQwA
pIX+BQACCc9gACAn4QEMAKSF/gUAAgnPYAAgJ+EBDACkhf4FAAIJz2AAICfh
AQwApIX+BQACCc9gACAn4QEMAKSF/gUAAgnPYAAgJ+EBDACkhf4FAAIJz2AA
ICfhAQwApIX+BQACCc9gACAn4QEMAKSF/gUAAgnPYAAgJ+EBDACkhf4FAAIJ
z2AAICfhAQwApIX+BQACCc9gACAn4QEMAKSF/gUAAgnPYAAgJ+EBDACkhf4F
AAIJz2AAICfhAQwApIX+BQACCc9gACAn4QEMAKSF/gUAAgnPYAAgJ+EBDACk
hf4FAAIJz2AAICfhAQwApIX+BQACCc9gACAn4QEMAKSF/gUAAgnPYAAgJ+EB
DACkhf4FAAIJz2AAICfhAQwApIX+BQACCc9gACAn4QEMAKSF/gUAAgnPYAAg
J+EBDACkhf4FVc2z598Qfg1QaYRnMIDyXjj9lvBrgMohPIABgLTQv6CqOfLA
Y8KvASqN8AwGELB7xeY3zn8q/DKgcggPYADlrV6lCL8GqDToX1DVzB05+rm3
PxF+GVA5hGcwgIBjm+9Zs2GX8MuAyiE8gAEEPHP+ntSULOGXAZUG/QuqmpQp
0xev3yL8MqByCM9gAAEr0nI2bNwj/DKgcggPYAAB+7aVZKTlPP/hY8KvBCoH
+hdUKdvX3JWWOGv1lr3CrwQqh/AMBhAwZ/DgjJziF89eFH4lUAmEBzCAgNL5
UzJTc+45tU/4lUDlQP+CKmXPpi3pM+ak5ZU+duYV4RcDlUB4BgPgdi3eMH/0
mMycolfPfSz8YqASCA9gAAGJ3btmpuWu2rpB+JVA5UD/giplcvs2aTPmZOSV
nnnjI+EXA5VAeAYD4O5ZuXnBhIlZ2QtXrtsu/GKgEggPYADc3etzZg/on5ma
syC3RPjFQOVA/4Kq47GnzyV5u6bPmp+RV7Jo3Wbh1wOVQHgGA+AmtGqeMmlK
VtbC+TlFwi8GKoHwAAbA7dxUOHfosKyU7LT80mfff0T49UAlQP+CqmPL6g2z
+vXNmJ2cmVs8N3uh8OuBSiA8gwEQZ06cm9oxPnVqYlZmQUpeKbaAyUB4AAPg
ChNHzR81JnNBZnq+UrpumfDrgUqA/gVVR+7EKXMGDaT9K6c4Obf4qZfeFn5J
UNGEZzCAMrb5K8nbLXVqUlZGfhqJQEvXCr8kqGjCAxgAN6lNi+Qx40j/ysgr
XbZ5rfDrgUqA/gVVx7gWTecNG0b6V1Z2UUpeqfr6B8IvCSqa8AwGQOxdsmlm
n15p02Zkpeel5yvL12wVfklQ0YQHMIDLbPPX1IR2C8ZPzFyQkZlXOi+n6KlX
Dgu/Kqho6F9QRWxYuXZyfMt5I0bS/pW1MC1fwRYwGQjPYADE6CaNZw/onzZ9
ZmZ6bkZe6dzshcIvCSqa8AAGQGzfWJDYvUvKhEmZyRmZucUL8kqwBUwG6F9Q
RWxevWFqQrv5o8fQ/pVZmJ6vzM4sEH5VUNGEZzCAZx86N6FVszmDB6UlzsxK
y8nMK03OxV3Aqj/hAQyAGNmo0YxePVImTslMTs/MKU7NK1XWLxd+VVDR0L+g
ihjVrHlit87JY8ex/lWQwWbhT7/8jvALgwolPIMB7Fy0fkr71nOHDUtLnJVJ
+lduyYK8kkXLNwi/MKhQwgMYwBPnDoxp1mRW/74pk6aS/pWVXZTG3nwWfmFQ
0dC/oIoY06TxjF49FoybkDFnQVZGfgZ7C7pg2WrhFwYVSngGA8gbNWla5w7z
RoxInzGH96/U/NJlqzcLvzCoUMIDGMCWDbmT2rSYM2hg6pTpmfNp/6KLf7Ly
z773sPBrgwqF/gVVwaZV68a3bDazb+8FEybx/pWZV5qSV1q69m7h1wYVSngG
AxjZqFFS9y7Jo0bT/pWanZlTnJavzMkqOPvoK8KvDSqO8AAGkDtt5NSObecO
HZo2NZH1r4Wkf83LKdr9wBbh1wYVCv0LqoItqzdMbtdq9sABKROn0P6Vnsf7
14z0nCfOvSH88qDiCM9gILmtytrxLZvO6N0jeczY9BlzWf+ib0HPzV748nMf
CL88qDjCAxjA8AYNp3VqP2/48NRpSbR/ZRVm5JUuyCtRNqwQfm1QodC/oCoY
0bAhfQtoyOCUSVMy5qZkZeRl5pbQVdBZBdgCVr0Jz2Agud2LN0xo1Wxmn17J
48b7579o/5qfW1y6dJ3wy4OKIzyAgeTWrc0e07RxkrfrvBEj0qbPyEzOyMrk
/as0MSVT+OVBhUL/AuEeO31uZKNG0zp3mDt0aOqUabR/pZP+RZcAzc1eWLRq
vfArhIojPIOB5IY3bDi5fevZA/ovGD8xfea8zJTsrOyijHz6FnRiapbwy4OK
IzyAgeS2bsgb17zpjF7e+aNG05tf0P5VkJlXmppfOisTW8CqOfQvEO7uVevH
tWia2L0LnYKfMt3Xv3KK0/OV5NxiBXcBq9aEZzCQ3MhGDacmxM8eNDBlwiTW
v7KyshdmsPXPszLyz595T/gVQgURHsBActkTh05q22Jmn97zR49JT5zl619s
8c/c7IULV5UKv0KoOOhfIFzmuIkTWjWb0dM7b+Qof//K5f1rQV7JjLScJ8+/
KfwioYIIz2Ags+2L1o5t1mR6l4S5Q4akTJySPov1L7YFIyW/dE5WwT37HxJ+
kVBBhAcwkNyIBg2ntG89q1/f5LHjfP0rw9e/5uUUla5bKvwKoeKgf4Fww+s3
mBzfcmafXvNHjkydmpgxh/avrJwi/hb07MyCZy5cFH6RUEGEZzCQ2e7FG9jk
e+e5w4alTJ6aPnMu71+ZeaU8Ai1avlH4RUIFER7AQGZ3r88Z1fiOqQnt6OLn
cRPSk2bT+3/R/uV78zkpNfvp1+8Xfp1QQdC/QKy1K9aMaNhwSofWs/r1mT96
TOrUJDr/lZZLt2CwVdDzchYWrcYWsGpLeAYDmQ2tV29imxYzenafN3x4yiTW
vxZkZWUW8reg5+cWJ6ZkCr9IqCDCAxjIbNuG/LHNm0zvmjBn8CC6+ZT0r/np
9OY7/sU/szLyzr53Uvh1QgVB/wKx7lq1fkzTxlMT2s3q3y959Ni0aTNY/8rh
WzBoBMopIhFI+HVCBRGewUBaZ0+c802+9+41b8QI1r/mZS7I5Fsw/BEo/0Vs
AaumhAcwkNmwhg3GtWiW2L3L3CFDFkyYVL5/8cU/c7IKi9csEn6dUEHQv0Cs
oQ3qj2vedHqXjrMHDkgeOy5tOu1fmak5WVkLM/PoW9DJucUz0nOefvVd4ZcK
FUF4BgNp7Vi0flTjO6Z0aEP3v48YkTp5Wvqs+f7+xd+CpuufixffKfxSoSII
D2AgrSfOHRhWr/7ENi2SenSbO3Qo7V8z5tD9X+l5fPMFXfyTvXDagnThlwoV
BP0LhNu9ccv+bbsP7j1UkpYzb9yklBnJqQtyUtIL123ec/TRM8+//emzb30s
/CKhggjPYCCzlx59+fC6Hcc231MyN33OiDHJ02anzstMTSvYuGHPiePqA8fV
C+c/EX6RUEGEBzCQ2dmXDu3fUXpo/8rDh9fPHDwsedL01Dmpaal5yemF9z91
+L7TR85//NQLHz0u/DqhgqB/QdUxb/TEsZ17Tx87M2l27qS5BY8997rwS4KK
JjyDARB3lawd3rLdlKETkxIzp85buHPXCeGXBBVNeAAD4AbWbzyxz7DEycmJ
cwsLVq8Wfj1QCdC/oOq4pn+dOn1O+CVBRROewQDK0L+kJDyAAXAD66F/SQf9
C6oO9C8JCc9gAGXoX1ISHsAAuAHoX/JB/4KqA/1LQsIzGEAZ+peUhAcwAA79
S0LoX1B1oH9JSHgGAyhD/5KS8AAGwKF/SQj9C6oO9C8JCc9gAGXl+1cS+pcs
hAcwAA79S0LoX1B1oH9JSHgGAyi7vn/tRP+q/oQHMAAO/UtC6F9QdaB/SUh4
BgMoQ/+SkvAABsChf0kI/QuqDvQvCQnPYABlvv4Vj/4lFeEBDIBD/5IQ+hdU
Hax/9UL/korwDAZQhv4lJeEBDIBD/5IQ+hdUHehfEhKewQDK0L+kJDyAAXDl
+1c++pcc0L+g6kD/kpDwDAZQhv4lJeEBDIBD/5IQ+hdUHehfEhKewQCITehf
8hEewAA49C8JoX9B1TFvFPqXdIRnMIAy9C8pCQ9gABz6l4TQv6DqQP+SkPAM
BlCG/iUl4QEMgEP/khD6F1Qd6F8SEp7BAMrQv6QkPIABcOhfEkL/gqoD/UtC
wjMYQBn6l5SEBzAADv1LQuhfUHWgf0lIeAYDKEP/kpLwAAbAoX9JCP0Lqg70
LwkJz2AAZehfUhIewAA49C8JoX9B1YH+JSHhGQygDP1LSsIDGACH/iUh9C+o
OtC/JCQ8gwGU8f7VAv1LLsIDGACH/iUh9C+oOkj/GoP+JRnhGQygDP1LSsID
GACH/iUh9C+oOtC/JCQ8gwGUoX9JSXgAA+DQvySE/gVVB/qXhIRnMIAy9C8p
CQ9gABz6l4TQv6DqQP+SkPAMBlB2g/71oPBLgoomPIABcOhfEkL/gqoD/UtC
wjMYQBn6l5SEBzAA7ur+tUr49UAlQP+CqgP9S0LCMxhAGfqXlIQHMAAO/UtC
6F9QdaB/SUh4BgMoQ/+SkvAABsChf0kI/QuqjnL9Kw/9SxLCMxhAGfqXlIQH
MAAO/UtC6F9QdaB/SUh4BgMoQ/+SkvAABsChf0kI/QuqDvQvCQnPYABl6F9S
Eh7AADj0Lwmhf4FAR0+pARkFSquI6PL9q7h0OXkw8AThVwsVQXgGAyhD/5KS
8AAGwKF/SQj9CyoT71kdu3qJGteNOq7gpjXrtmrapnXbzi3iu17/BPK3yF/n
hP+7wG0hPIMBlKF/SUl4AAPg0L8khP4FFYpPXd2wbf3SaBuj+/VPRhf7Xyc8
gwGUoX9JSXgAA+DQvySE/gUVgXeum9SulpFB/JM20TpeuOJjdLtGmskn76bb
kzsa28fqFiQY+XNSEozta964lMWXK2voYv+LhGcwgDL0LykJD2AAHPqXhNC/
4DYqP9V1RxhtWKOa6puGBzWLCGoeEbSin2lVP1P59jSvg7FdLC1QyQnGe8Za
UjsZO9TUHR5vPTLB2rGWLqOL6b6J1oRa9AlZXU2dal+pWgn0q8aMzsaOrJe1
Z9+kbbQORex/jvAMBlCG/iUl4QEMgEP/khD6F9wWgebVKDRoeGN9YXdjk/Ag
3ryW9TU9MtUyqZWBfJW0rb2jLe9m2C9m2mlvqqlL7WQiVasjK1kJtXWdauu5
zrX15JEudfRcvtfE//hHxUnkdTd1rq3L7WbK6Wb6utCR1dWY2cXIZ8raxejm
tjfEx+j4ZjHh/2Xg5oRnMIAy9C8pCQ9gABz6l4TQv+AW8ebVIITOdhV0MzYO
CyLNi1jS2/TQZMvDU3zNa36C8b1Mx/tZjg+zHQfHWzvU0h2eYL2U7/ii0Hl5
ofObYmfnOvqHp9n+uMj1p8WuPy92/WWJq2td/RMzbP9Y5vpxObPMVdzLTJBP
uIU9TYU9aC8j7ez7Escfih2kkWV3pUUsrRNdwdiOrU5EC6vKhGcwgDL0LykJ
D2AAHPqXhNC/4L/Gm1f/BrqszobhjfV87V9JT9N9Ey0nJluW9TU1j+RrC020
duU4Ps51fJLnODLR1rGW/tgkG69dvy91lSmugh7mwp7mvy51/WO5+8cV7p9W
un9e5Vbn2L319Npqt3bnFUpfM0Ef5I+TjytdJb3oxrGinqa/Lnb+WXH+eZGz
Sx36j87sYiRFLLmDYU47A1pY1SQ8gwGUoX9JSXgAA+DQvySE/gX/Bd68+tbX
pSYYGoXSma8RTfT3jrWMaUanuia0MDSLoPVn/1jrB9mOj0jtynd+XkhldjMl
1NZ/Vez8rtT1vUKnuv661P335e7i3uaSPuZ/0Url0dZ4tLUebZ1HW+8h30Tb
4NE2XkUZYCGPqwsc5AkUecI6t7aWVjPyuDeONsFudfV/X+Jc2MOU192U09WY
3sm4oKNhdjxaWJUjPIMBlKF/SUl4AAPg0L8khP4F/xHSvCYM6UGKzPoBpkGN
9I3CgvK6GQ+MNh8aazky3nLfRMv4loZ2sbrkBBM/sbBjLX1GV1NWN/PxqbZO
dfQ53c2/V1xli11/Xur+23L3P1e6f17tIZ2L9ixauIK1DcHaxmBtU7B2V7B2
d7AyyEJoW0K0rSHaNvZxazC1Jdjb0EC+pKY7yUdvAwNBy1d9vdLfrPQz06mx
VS5theunZc6inqYCL21hR8aZSQvDisQqRXgGAyDOnjiP/iUb4QEMgEP/khD6
F/x6pLb0jNOt7mdM6WhoGBo0rLF+32jzPWPMh8bR8qX0MjWL0M1PMF3MdnyY
4/w4z/lpgfPYZFt2d3OOl85Mda6jDxxg2D1O761HKf0t3vq0PSkDLcpAqzKI
GcwMsXobGQhlqO8T7x30I/8O/BP61SFWNdupZjm17cHaNlrNyLciX1IGWOi8
2BpaxP61wkVaWNc6OtLCLmXb5rWnf5d0SeH/SUF4BgMoQ/+SkvAABsChf0kI
/Qt+Db7gsFecbk1/Y4OQIFK+8roZ9482HxxruXec5egEi9LbFB+r2zPWejHb
+WGu85N856VC1xdFrq+KXd+WurrU1T+SZP9hqfuvy90/rvT8tNqjznOoyU41
xUk6F+1K/sJFDWWGMcOttHPdYVAL3Gqhj3YgjNofStAv5bu0vaHUHiJE2x2i
7QwhXUwZzObONnm0DXR1oraatDA6F0b+cbndjJ9m2TARVhUIz2AAZehfUhIe
wAA49C8JoX/Bv0VKSvc6ujhPUL8GdAIrq4tx7yjzgTEWUr4Oj6fla2xzAylf
b2U43styfpDj/G2e87MC1+8Wui7T8uXuXEf/aJL9L8s9/1jp+b/VHm1NsLaO
rTPcFKLdHaJmOL0NDdqOUG1XqLabFKgwbW+Yto/UK1ay7glTF7q9jQ3aoXDt
3nDtcLh2hH3k7g0jyFfVIrd2kD5ZuydUO0B7mbaXFjHS4+hOsQyndle5Frbc
WdTDlN/d1KmWLrmDgfRK4f+FZSY8gwGUoX9JSXgAA+AGxKF/SQf9C27uzuWL
prYyLO9j5Kv+tg837xttCZSv0l6mphG6OR1Nb2Y43slyXsxxfpTn/KTA9flC
15fFrq9L3bk9zAU9zX9b4fnnKs/PdwZra4PpJi/WvOiurm2hfMLLV7to5wrX
Dob72hYrXGqJx9vEqB2L0O5j7i/nvnBCVTzepkbtaDh1JEw7HKYdCqN1jBSx
fXRGjK1RtNBdY3dfaWHd2TEdud2Mn2TaZrY1YC2iKMIzGEAZ+peUhAcwAA79
S0LoX3ATYwb1KO1hnBVvqBcclJpgGHKHflgT/YimBrrskJWvNjG67aOsb6Q7
3s50vpft/CDX+XG+6zO28pCUrzxavix/X+H5v9XBdNqLNK+NIdpdIdrmEG1r
qLY9VNsVRhcQ5rlp7brHX7uORGhHI3yFi5Ss4xHeZkZ1iUd7MFI7Eak9dLUT
EQT5KnmO9gB5crh2f7h2zN/F7iVFjM6IKcPpakZtJz27Q011eOvTrWfqbFtx
T1NeN+Pvcm04oF4U4RkMoAz9S0rCAxgAR/tXb/QvuaB/wS9JG9+zqLuxVz0d
KV8pCYatw8y7R5qHNzGQ/lWjRo0m4fTY+VdSHa+lO97McL6T5XyfTX59SspX
seubUvfDSfaudfV/X+n5iU97bQih016bQ33Na2eYtpvOedGTD3nzOuyvXbRz
RWoPRAYKl7e5UV0erD0SRT3KnOKfRFKPUMpEO6E9zBrZgxFXuhgpYmxGzNvY
oIyw8hM81AwH3Re2jk6ElfQyFXQ3fZVvRwUTQngGAyhD/5KS8AAGwKF/SQj9
C26oQ6yuoJuhV5yuT339hkGmLUPNO0eY94yy7BtjuWesZVQzQ5sY3awO9CyL
+Fj9/E6mBZ1NByfYWPlyf6O4v19Cj5T/+8pgWr7W+ae9toRq2640L21/uDLS
poyy+ZrXfZFXatdDkdrD/rZ1KkpdFeJtYdQej9KeiKaeDCCP+D0epUx2EL5G
djJSXe5Rl3qU8XZvU7p40tvEQP5ZdCvZvhBtFzspkS9HXONSetGjEb8tRAUT
QHgGAyhD/5KS8AAGwKF/SQj9C66XOr5nbhdDD1a+1g00bR5q3j7cvHMk7V/7
x1hGNjXMaG96KcXxaprj9XTnnrG25E6mlM7mjrXpjqpOdfRd6uq7xum7xRme
nudUk520fN0dSssXW3BIt3rt46sNI5TRdmWM3de8aO2KorXrpH+G67Fo7XFf
1aLTZKejtaeZZ2L8ojl1XSi1NpT2rJZGUtboJy2M3uZGZaKdFDE6I3acrktU
RpPGZ6UHdOymZyRqmz3aRrojTJ1l68Yq2M5hJlSwyiQ8gwGUoX9JSXgAA+DQ
vySE/gXXWDCuZ1Zng7eurlc9/ZoBpk2DzVuG0f61a6Rl72jLiKaGpHam8wsc
L6c6LqQ738x0vpPtvJjr+rjA9XkRnfk6meTg5aukL7uxV31D4J5f7AZeRkIZ
aVdG2Un5oifPj7Mr4+3KBIcykZnk4NNYyhSHMpVwKtMo+szpTiXR6W1l8rb2
ufKdyYOMMt1BPpIupp2O8s2OPRapnWIzYg+zdYn3hytj2KTbPeyMRLojzMPX
IpIKRr7VickWVLDKJDyDAZShf0lJeAAD4NC/JIT+BeWR3pGeYOhWR9czTreq
n2nDINNdQ1j/GkH71/AmhsR2pheSHS/SyS/n6xnOt7Kc7+U4P8p3fbbQfbnU
/fvFnh+W05WH/0eXHYaUm/kK03aFqXketcCjLvTwaS9lLOtf4x2+8jXJX7um
OAO1i3cuWrtY4VKSnOrdYdRmSjsX6/MC83yM9lwMeQ55vnYmWlPZZNlTrIg9
HuVrYQ9FaA+EK2NtymibdijUtxbRX8G0Fc6FPUwnJlnaRgfhRMTKITyDAZSh
f0lJeAAD4NC/JIT+BQGrli0ihahrbZ23rm55X9OaAaaNg82B/pXTzdQqWvfc
fMe5qye/3s9zfVLo+qLE/e0izx+XeRb2thT3tfjK111Xype2N1zbH64djGC7
vSK1+yN582KrDaPpUkO6sStGOx2jPR2jqTHamVjtbKz2HGlVtFupm8O9bUza
izWpl5iX/fgfX4ylztM6RpqaSv7Rz8VoZ2NoC3sm2jcd9jg7r4NNhNEKNoZV
sP28ggXTCsYWInato3tgkgX3BascwjMYQJmvf7W90r92oH9Vf8IDGADXH/1L
PuhfwGUUKHPi6VrBbnV0i3ubVvUzrRto2nClf1kahQVtGGZ9PtlxPsXxSprz
Nd/kl+ujAtelIvdXivsPSzwFvS1FfSw/rw2hpx2WL197ypWvY7R8aQ9E8Wkv
7RTf5BVoXrG0eT3LmtcLNbVzNbXztHOpW8O9bU3aK7WoV5kL5bxak3qFeZk8
OYyWNdLFXoihk2LPxtDpMN7CnmATYSfpqfXKOFbB7g2j28F2hZSvYPw207NH
9RT+c6n2hGcwgDL0LykJD2AAHPqXhNC/gGsTFdSxpq6WO6iOJ2hZX9Pq/qa1
A820fw2l/WtIY8O0eOPZeQ7f4sN05+uZzrezXWzyy/27Evc3izxly+jKw3+u
CdHWh2ibQulR89vC6GmHV8pXpK98PRilPRTlbW5SV4Vqj8f4ytczgeZV09e8
6FRXLe1lX+GiR3C8Vkt7nXnjOvxx8oTXamoXapKypm4L116KvaqF8RWJT7JN
YWwtorepUVXc/grGFyK6lX7m7nH6rnV0v8207Vy3SPiPpnoTnsEAyq7rXzvQ
vyQgPIABcOhfEkL/AmL/psXz29PJr8LuxsQ29JM+9fXzOxp5/xp0h35KW+Mz
cxzPzne8sMDxUqqT9K83Mp3v5rg+zHd9VuS+XOr5bomnoJd/8mtjKN32tTVM
2xGm7Q5npx1GaPdGsmWHUdoDtHxpJ9mRhrx8PR1Lp73Osub1fLnm9Yp/nuv1
2oQ33qzujtDeqk297fdOuc/pl2ppb9I6pu6M8MabfJNigRZGVySyibCn/GsR
H4qgl3GM3al5f4gy1EK3pA0wa3e6inuacrsZdw0zYSNYhRKewQDK0L+kJDyA
AXCkf01A/5IM+hfs3bh4Vrw+1vmbCS0MRT2MS/uYVvQzkf5VLySof0N9g9Cg
yW2MT822q3Np/6Kbv9KcFzKcb2a5Lua6flvo/rzY/fUiz/dLg/2TX6Fs5WEY
W3kYTrd9HYjQDkVoRyK1+1j5OkHLl/Yo61/XlK8X2GrDwJzXBVq7tDdqa2/S
bqXMdxPau3Wo9/wuMvTz2tq7DG9kb9WifW1XBJ0O4y3sRXZSR2Ai7LSvgqnL
Pd5mRi+7qbQy3KrtYIfSr3drK13d6upOTLZsTekt/GdUjQnPYABlN+hfDwi/
JKhowgMYAPfr+9dxdSeRpczt5I0nHwPIHzl+KHT5r5LnC/8XhOuhf0FiG337
WF1CTV1+N2NJT+OS3qblfU2r+pvWDDST/sV/l1tG66bHmzYNt55Lcb7MNn+9
ne36IN/16UL3F6We7xbzyS/rT+Unv3aGs5WHEVdWHh5n5ethWr6UyU5lilM7
zctXTVq+6LRXLd+0F2ler/mb19t1tHdo51L3R3rbm2nbep/54Dr88Yu+Lqbu
jfC2M/PpMF8LC0yEPRujrg9V14b47hTW3EgqmHY0TDsYqu0JobdmvotuBPt5
OT33/vMc2xsvnRX+Y6quhGcwgDL0LykJD2AA3M37F+9cvFs1Cg0a0UQ/upm+
WURQ84igGlePWe0M5c2MNyS1NVzTyIT/ywKH/iW5vRsXx8foOsTqsjobC7ob
lV6mxb1Ny/qaVvY33cn618TWxsdm2tcMsZL+1TpGR36L28bq5ySYkjubD06y
Xyp2f6V4/sAmv368k01+bSo/+RVx1cpDuu0rWnskWnsshh8yT/d88fL1Aitf
dNqrtm/ai855+ZoXm+eqqx6Iov3rw7rUR8xvr0Ye+bAOxbvYxdrk+aSFaW/T
RYnqznB1R7gyy+lt47+DWCsTqWD0RI5HI0kFUxd7tMNh2gF2FscWj7bBra12
PTXD1rm27v11/YT/pKor4RkMoAz9S0rCAxgAd8P+xTtXYEqLjKYRQZNaGlpG
0STWJlrXNka3a6R572jLxQz7R9n2tM7G9M7GT3PsnzAfZ/t8Qr7Uydg+Vtc2
Wje9taFFRBCKWFWA/iW5xNZ0his1wZDTxbjQayzpaVrU27SU9K9+pr4N9ONb
GU8m2Un/emq2g64/THacS3FuG2Wb18m8oIu5Q23f7FiXOEPXOENJP6ua4lLT
3GznV2DyK5JOfvlWHkbTlYenYrTHY/gdvrQzvHzV0s77y9drvHzV8U17seal
fVCX1y66ZJH0rI+JOO2T8ur6fEyLmHooSj0YqaS4Sf+i01vtfB+98WZljkvd
Fq6ShvjCVQsR1RXBdArsvnDtUBi9L/OOYO1udkewla6udXRHx5t3rsdBHBVC
eAYDKEP/kpLwAAbA9Y+7o3z/Kl+7moQHjWuubxHpm+riteutNPv7WfbfZjs+
y3N8UeD4eqHzuxLnyWm2rnX0C3uaH0uynUqy/XmR80/KFY9Ms3Wpo/u2yPF5
rv2dFOuWIaYpLfVoYQKhf8ls9uiebaN17WJ16Z2Med18/UvpZeJbwMhv+oPT
7A8n2k/NtD852/GMv3+9ku58K9v1fr77kyL3l/TkDTr5VdTXWtrP6m1gIALv
1XgbG71NjOxWyw5+ty91Zai6KlRdE+ZtaVKmu7Rn2YEb5/myw8DMFytfdNqr
rvY+K190qitOvTfa28GipHnUw9GEku6hMihvRwvn++d2NHs7mJVUj5Lqpp8s
cNMVie+w0zler6VdYHcNe9G3ENF3HMdjbApsiYeuQrwnVNvNjqPf6NHWuE+z
KbAP1mMKrEIIz2AAJ4+py/NXoH/JRngAA+DK96/uA8c0CvW1rcmtDK3YbBfp
XDtHmveMshwYS3NOQi1dp9r6znX05Rcfdo/Te+vRR7z19cSVJFZPr/Q1K33M
3jj907Ns/1jq/FOp4/tix9cF9g8zbDPbGtDChED/klZGgTKdTX4ldzBkdDbm
dzMWeo3FPWj/WtLH1Ku+fkxL4wO8f80I9C8n6V+vZrjeznF9UOD+rNhzWfHk
9rQU9Lb+Y03Iv64sPgxnxx5GqIXBanGwMsahjGP9a6LT28JEtaTlztvKVOM/
GbxeBaqWkhFMZVLqsWhOuxRHfRanfeqbDlMPRZEKRpcjXlvB2F6w59mJiE9H
a09EqSvZFNj94XQV4v5QbeeVgzgKvCZSUeePxe3Abj/hGQyqGVKmuPwMheiS
4OWmDuxRLzioSVhQk/Cgpgx5PRndVE+MaapPamMr37+GeVuPaqJv5n/aHaFB
Mwb34N+Hf1uO/4OE/yvDf0d4AIPqge/P4sdi/JLAc67Bj84o37+atE64Jvy0
i9X59nCRzlVbn+elS3oem2E7Pdv+8yq3ttqtrfFo6zzaBo8ywKIMtGh3k/QS
rG0JppvZtwarGU5lEH2cfxOlv5nUsZ9XuP6xxPlDqeO7hXYSb1DBKh/6l7Q6
dvW2idbFx+gWdDRkdjbmdDXmdzcW9TCVsi1g5Jf06GTb8Wn2hxLtj86wPzHb
8fRcx9n5tH9dYP3rwwL3pWLPV4uC83pZCvtYf1wTom0I1e4K8y0+3B1x9eLD
aLrz61G68lB7KlZdF0bKF5388q08rM1WHtbR3qjD9nzV9c180X1ecb6lhp+S
VlWPdy7td/WoL26EfilO+/yqFkZXLX5Y50oFe5NVMH4cx7lYeig9X4X4WKQy
0a6Mt2vHwn0HcfApsDtdf1/s7FRb1y5Gh7PobzvhGQz+p/EGxJtRg5CghiFX
ulWLSLo//anplmeSrE8lWp5OsqgzLGdnWp+dZb17iHnzUPOsdoa20bqtw8xE
Vmd7+f41uldr8py7hphnsA3s5G+dmUH/OvkmZ2ZY1/Q3EZNbGia31I9vried
zrcS29/O0Mv+JwgPYPC/KHAaBlE/OIi87AxppL+DvQgEXgpu40iopUuorcvu
Zsrtbjo5nS4s/PsyN001d3q09bRzaRuDtU3BvHMpgy3KYKu2I0TbGaLtJjEm
VNvL7KGrepRhVmWoVRliIXWsBpsmo0VsufNvi5wnJlvIv85bb+0W/p9XHuhf
0oq0/4b8As5rb0jpSOe/srvSJYiFXlNJT1OPOP2o5kbSv+6faj/B+9csX/86
n+q8kOl6J9f9UaH78xLP14vp4sO/rAr559pQ2r/uDvOffMj616FI7UgUO3kj
mh57eCpGeyJWOx2rrg+n/ev5Wtq5WtqLtf0rD8uVL7rnK46Wr9/y8lWPlC/t
83rqsWhvgoX2rC+Zy9f5MlDE/C3s07rejmb1UNSVCvY2q2Cv+Q+lfyFGO8tW
IT5JD+KgL2t8CmxfqG8XGDsI8eRUK/lSRoEi/AdXzQjPYPC/pXzhahQaNLyx
vrSHcVkf42NTLaRknU4kLYk2rHNzrG3ZRgn+7jHR3v8eMhkda+o61qJItuEJ
p2+Dq+a/JvZt06Gm7pogRL5JfKxuTnvj7PbGme0Mm4eYW0fT57SK0q0faFo3
wPQ0u4A7+5smsV5GamCgkQn/7wbXEx7A4H9FoHORwjWwoS4jwZDV2ZDTxZDX
1dCYdS7+epLe2ZTe2Rj4Iz0HI9vn3nGWtE5G/kpy/WvLLz3OZ7sKepiLeplL
epsDKwxpe2pgUAZZSdtSM53a9hDauXaF0gBD2tb+UO2eMO1gGN3Pfm8YzTP3
himjbMpIGz1hjHx1L2lnIWq2k/Q18leUfmZtpYt88kWu7eNTKcL/a0sC/UtO
p9UzraOCohy/mdfBkJJgoLPPXYy53YwFXlNRDzr5dXCC7cgk1r+m2x+ZYX98
luP0HF//ei3T9S7vX6WenJ6W/F7Wv6xm/Wsj61/bwmn/2huhHYik/eso61/0
5I0Y2r+ejNWejlWmu5REl2/y66Vyk19021dd/4Eb15Yv7Xf11PtY/7pcn/rq
hsq1MH8FUw9HkQpGD+74kJ1O/y5bhfiGfyPYef8U2FP+KbBxNt8usF1sCmyD
W1vlKmT/Wd5eg11gt5nwDAZVH19MSLoMDx4k8DQrd/Byq6igpLaGGfGGrcPM
O4ebA1WrAytZGV1MWV1NnWrrTkyxfVfs/H2J8/tSZ5ni/KPi/GGR68+LXV3r
6k8l2Z6bG1K+f22b2/67Enr7ia+LnF8UOi/lOz7OcRwcZz0w1pKcYJzf0ci7
WDzrd21idDPjjeQC7h5ifmG29bnZtABuGGgipWxa6yv7YclAF6tShAcwqPpI
7Ro3rF3DkKChd9DiM6KJvrC7sTFbxsxmpvTHJ9u+KaLHX5AXloA8r4kgz8/r
biIemmrtXFsXkNPNxLoV/eTrQgdB/kg+J4+Uf7l4LMlGahf5pLSPWelroSsM
NwYrA30zXGqOi85nDbN676AvMt7GBk67N1w7Ek6X8dwXrt0foR2P0B6glHF2
ZayNPn6ElbKD/iK2K4S3MDKeSrJ9W2j/7HFUsMqA/iWnHesWk981fvhGSkdD
WicjnwLL727sVlc/rKnhwHjbvZNsx6bYH5hup0cgznI8RfpXsvN8mr9/LfSQ
/kW+SdmKkGv7l+/k+Uh28nyUdjya9q9HYrTHeP+qSftXkss3+fWyf/KLHrtR
19+/4nwrD3n5usQXHNbXvqxP397hVetrv2/8+B/LtzB/BaNTYPdGaR+xo+kv
Xr0KMTAFdjpaezxKe4RNgR1jByHuCdG2B2ubPEpfM/nPktPVmDoeW8BuM+EZ
DKoyPtVVg931pqCb4cg480OTzHyqS51hJWXnpXnWHSPMvAfxd49J5zo20Xq5
0PHNQsfvi51lpaRnOR9PspEvlfQ2/7ySbZe4k1nj0dZ6lH4W4kJ6aPn+tS+l
A0k+C3uaf1jiKlvk+rbEdXmh81KB89M8x70TrOQflNLJdDHT/k66/fVU+7bh
5pntjKSC8QwTmBQjSP9az4oYt4E1slaRQShiVYHwAAZVFp/tahASlNHJsG+U
ed9I8z2jzcU9jIFy1Km2nnSuP5S6yhTXnxa7/rLE9belrn8sd/20wk1eZP61
iiKfeON801Xd4/Tk9ef/lrv+ucz141KquJe5qKeZf6l7XT19fJnrqZk28kfy
NHWOnXxJnefQ1vt2ddGS1dCgDLHShYX7w7QDbHrrcLh2lLYtb1MjR+ezxtuV
CXbt4UjtZCSJNNqjkdopFmzIHx+O0E6QUsba2VFWxO7xtTAvu99raS/TD6WO
z7Z0ee6VXcJ/CtUb+pechvXv0ToqaFa8oZ3/jeLAFBj54+4x1v3jbYcm2o5O
sfMtYKdmOp6c7Thz1fpDT0Z3S3YPy/fLWf9aR/pXmLaZ968If/+K0o6x/vUQ
71+xvH/RG29tiqD96yW++PCanV9x/smverR/XeKTX7R8aZf9/at87fqWubaF
XVXB1CPRdArs47q+VYjvslWIgSmwc7G+gxD5vcCaGdVFHr4EUc1xehvQNdI/
LXednEpz1wev4V7Mt5PwDAZV08uPnglMeI1qql/cyzixpWFKK8PU1obpbeie
rC1Dza/Ot+4c4ZvwOjjW8kmO/fM8ezZ7b7nAayLtieSZn1a4/rWStS1Stfpb
SJKheyXu8m2XINQMJ0k1F/LCy/evA+kdlL6W0j6Wf650/225+4cl7u8V2sLu
n2LrWEt/aIL1/WzHOxmON9Lsry6wn59n2zyUrkUkNg0xJ7alV0iuYVobw5mZ
VtITyceNg8zEJspEJLYxtIoKwoyYWMIDGFRBvHn1ra/bOtS0Y5hpL2leY2jz
ahoeRH73759s+7rY9dA0W34PWp261tUX9TL/k3SuwDkYa9lRGOs9aoqDhAdv
fT35RNtIX3z4sYTkE3prm7U+Sj8zPZ+wP7tLDvlqP7NvQeB6j7bJ421gIC9Q
apbT24hNcrGpLrqMMDDJdT+b25pgVybaWdWK0k5FKZMdBH3mFIf2VDThbWlS
14bSRT5P0HU+tJEFitgxuuFCLXSRb67tYPNrfc0/LnF+lm07tH2+8B9HNYb+
Jacox28GNNSR/jW/gyG5o4G/b5xQS1fTFTTwDsPO0da942x0CaJ/C9gjMxxP
zHao853nWP96O9f9YaEnnfWvP9ywf+1j/etwoH/F3Kx/+U7eqEv711U7vwKT
X/X55BfpX95OFvWBGFa1GmjflleuiPFZsPILES/F0eL2CTvK/oNyB3G8Vuva
JYinItXlHm9To1riprP5jQxqupO8Wv5rheuHUkfHmrqd6b2F//iqE+EZDKqa
t584q0zq1SDEt8KwaQQ9RqNFZBBvXqTdzGhrmBlPj84IvBedkmBM62S8lGv/
Ip9Oe31f4izsYSruZS7tTU9d1ta46UE6d/n3pw9h+9N30f3pap5LzXWRX/Oh
LezDm1/pX0lD29JXjPXBJE39tMrzjxW0guV4zZndTJ/kOz/Mcbyb6StfM9sZ
+ZzXxiHmM7Osz8y0PpVkXd3fvLr/Vee78umw1lE6XtPaMOXXJX525qzw//Ky
ER7AoKrZsG4eyUXbh5l3DDftGWk+QOe8TOQliDSvo5Nsl4vomzB/UFx/WuL+
6zL3jyvcz8x1KH35WRYGZYBFTXX6zsEYZPU2NPh2ZgVsCyGP+LZcDaKHYGhb
6A56elDhFvZeULqTP17j6kGakVro9s12HQlXxtiUsXa6sPDBCO0htmlikkN7
jHWr0+w852cYNUaZThdRk8SlJDrpIp8zLOc8ww4c40WMVLaHSINj33OUVdtH
XhiD+VxbcU/Tp1m2g9tQwSoK+peEtq6liw8T2xjI68zc9rSCLehoTE0wdvTv
/RzSxDCsqfHABLYEcSpdgvhwkuNx1r9eSHW+mul6K9f9QQFdfHh5UTDpX39e
FfLj2hvNf/1C/6IvOM+VO3wj0L/o4sM4/+LDer7+9Xm5/vUV71+xV8rXd+UE
Wtg1Fex35JvEeTtaVHI91+wCe72W7xSO5+lLk7o21NvC6G1OA5W3iVFd6KY3
AiMvjOvd/1rp+vMi530TLR27eoX/BKsT4RkMqojAwRoNQ4P4lvZj480PTLSc
nGJ5bJpvweGzs6wvzKFrDl+db31tgS0+Rkcy0r7RZtK/+Lb3TmxLxfcljr8s
dv64zKX0pict0zeTN3mufxuZ/5pTjY1Ok6l8/6rXuGX5/NMtTp/PVgqldzV9
lOt8N8vxVoZj+0gLm+QyPplkfWy69dFp1uV9TXxjWjPWGVf2M01qaSDN8Ynp
Fn4A45mZ1ufY2SAvzbW+Qv4Vkqk57Q1sNXhQm+ggzIVVJuEBDKqO4+pOb13d
xoGm7cNM+0ebD461HB1vIb/IHWrpj0yyfVXs+rbUVbbY/eel7r+vcP/fKg87
8j1Y28Am0zeH0DPeh1gDLy90LmlfKLXfj//Rfxoh37pFn9zIQD6hmx12szeF
GJqRdrFH2GEa3sYGtdhNJ6p45zoRqUygqxNJ8yKJRZns0J6Mps2LFKszbDPF
czHaC7GcMsPpbUPfC1JmOukjz7OvPksCT7Tv5qePRymT2MnP97GTxw6wne9b
PORlc2EP02fZNhxNX0HQvyQ0pF8PEgmms/41p51hHpsCS2H9q19Dw8ahlsFN
DEOb0peRxhG6MS2Ni/pZHkqkW8Cemed8PsX5SobrzRz3gUmOjrX1Xy4K/v2y
kB9Whfzjhv0rsP7wxHX969la9PyNF8uvP7yuf/lO3qjv61+X/f3rwV/oX4EK
dqP+xe/XfNUSxLdqk/6lbg9Xt4R5W7NbkrU0qatD1OXB6hI6Bca2gIXSIzjW
e7SVrr8scl4uoC96713AEsTbRngGA+F47arHTnLO6WLYP8pc5DU2CQ86PtHy
0GTLqan0RMF1A+m6Pn7Oxsx4w6x2htntDG1j6AkYc9sbSQt7J9X2QYbt8DhL
RhdaxHK7mUh4+HmFS7vTHbgVKZ3OznephW56FNgYW2B/urrYc33/UoZatS3k
ZS3kX2uCF/a2dK6jz+xmTu3im9Xim7xOTbeenGpd2oe+Q07+SK65pKfx2HjL
InYXj/HNDc0jfCfht4wM4vNffPKOXPyO4eY3FtjeSrGRK28fq9s7yrx7hJm8
INfwn2Mv/OdS7QkPYFBFdPLG81+9oY3194yx3DvOUtrLdxDZpwXOL4pc37E5
r3+s9Px8p0dby2rXphBSu7RtIdqOULoha2+Ytj+MvLaQrkReXrxN2D6s0Ta1
xEMXCgYcDuenEdJ0cSiMn5hBns9XFSojrbT+HGCFq9BFd2YdpE9WS1kgeSCC
bul6JJJOdZHSNMXBQwud8FL9tet5dled87HaS3RvhbetSZntom8yv1KTfEL/
KbOc9A3nc/4idpa2MBrJHmUTYcfDfYeP7b5SwUgyJOVU+M+o+kH/klCE/Td9
6ummt6b9i8SAwBRYh5q6vg0N64ZYNo+wbh9t3TPWVtjLPLqFsWkkTRotonTT
2pmS2pu2jbG9keNe0NWc1t3yxaLg75aF/GllyN/XhP5rQ5j//I1y/euov3/R
8w9jtSdi1bXs8PlA/3q5XP9654bzX/XLz38p2SHEf9a/vqjn3wJmoXdkPhil
Hoj0tjMT9OWrrcnbxqSSKycvX0/7juDQHoygr0iB/rXBo61y/WWx8+tCB0lK
+zYuFv5DrDaEZzCoUC8+deEmX+XNq64naH57w+Yhpl3DTftGmQ+OMR8dT6eW
JrDJo8DiPdK/uKSrsckj39w9qWPJHY2pnYyZXYz8kLHudfVKH7OabKcLe0il
2hdKf6+P0O3q6lKPb4v6yUjSv4Zd3b+03WHa5lBtQ8jPd9I1Qt8o7o/znW9m
OGa2N7aK1k1ubRzf0kBqF+lcjcOC8rvR+3fcERbEbwPEj0fjs2Cr+pnWDDCt
H2jeNJjedIy85M5pT151jfzMEDLIay95VUlJMH6UaXs/ndQx667h5tnxBr4u
UfhPsBoTHsCgQp1/9+i/fQ5pFrVcv7mzPz0eZ+tQ8/Amev5GCvn4Ya6TlK/f
LXR9zWa+/rrc89NqNudFmteWEG17qLbLV7u0g+HaveGkbdGWdF8E35NFt2WN
t3ub+Q7EoK82D7LZK/Yl/rYPe344R1cAjrGxSXkDR6vQUfbVByLIX/c2N9L9
EXeGkM5Fv+d0p3YmRkl0elubaO16gdWuF1nzeqWmuj2cPEfdGUH3uQe8XkuZ
4/I1spfY81+IUZKc6oZQfv6zdpJcYbh2zH/+82Z2+FgdHemnwn+a1Q/6V/V2
bM+2/OHxhWM7PHB4170Hd5FHnnzmDPmtnNxST/rXjLb+KbD2dAosxhk0p6Np
zWDLpuHWrSOtO8fY6C6wibYjk+kSxJWDrFPjTYntTW1ifW8md6itz/Racnpa
83tbn5jnejrZze6/HK7tjPCdP8/71/3R7P5f/v61hvWvs7Xo/b/O+/vX6/7+
9V4cPX+D7v/y969L9cvv/7rSv66vYN9e1b/U4zHq8Wj1/mglM9ibYCHly/ce
eAezt71Z3Reh7onw34i5Jn3t4v3rCda/TkTQeFbkprP/23j/cv91sfObhQ4S
k+aNxSmIt43wDAYVJ3do28Ix7fNGtX94z67rv0rKVy33b0jRWD/AtHmwaedw
My9fJWzDBZ85WjPQ/PQMqzrTenaW9dnZ1ufnUC9ws314BUtsY9g02ERK3Ez2
slaDbQpLqKXjRzrTXWDr3aSC0XVBh2iqoeGH5Bn2TrL2RPTQds7y/StpZLyv
f60PKeptyeth/jjfdSHNkdTOOLWN8aGp1pKeJlKyGoUFNQyl+G61oXfQ27CO
bKrnN4Dm5et0Il12SK7z5Xl0zeRbqbb30m0fZNo/yrJ/nG3/NMceuA1ZRmdj
VlfjZzn2j2kRs76dYiUvzqhgFUd4AIOKc/yQUjCq3cLxHR88vuzZN29cxLKU
uVNa6u/sZ9w4yLRlqHnXCPOBMRZSvtrV1Kd0ph0ns5s5x2v+4xL331d6/rWG
JAE+50W6SRhtXgfCtUPh2uEI7Rg93V1dGqw9FOk/dTCKHoXBTsPgB2J4W7Ai
NsmhTLLTyaZH2b6tiXbfmYQPsdMwWDtTl3iUcbYrm7+aXTl00bdKZ30oXUDI
O9e5WHVzGK1aJHqRVkXyzAVasrzxZrrD/S121Ng7fm/TbRfKXDoRpu4IV7eF
0zefN4exI6Cjr+SfB9kZ9fvZLVDv8pAXT1LBXl/TSfjPtJpB/6reprZtOrtL
i9TeLbMHteavRWNHDW0WETSppX5aa/rWMV8JM6c9XYVIfiWX9zevGmjZMNR6
9wjrtlHW3WNt++kuMHoK4skZjifnONkR9K7Xsujt1w9OdmR4Ldk9LXm9rV3r
GbrXv3KnG+8dRkIZ5VBGO5SxDmWcQ10Wqq4MU1eHKVNdyjQX7V90C1htdv+v
OnQL2Jt16fnzvH996O9fn7L+VW4Jono8lm8BUx9kTsQqOSGct7OF6uTvWZ3o
56R5kf6lHovm81/sRsx1/fu/atPzN+j+r3L9yz//pSoeeisN2r9CAv3r2yLH
obGW1lFBR0+pwn+41YPwDAYV5NCqzTMTmi/o0TJzQCv+LtCje3cd3+UrYqRW
kP+nr+xrXDvAdPdg047h5rxuRr7ti5SXpX1Mj06zTmlNTzvk/evMLLr567nZ
vv61eYh5RryhTbmDLPhxgoFR/o9pnYy53UzeOHq2mJpOF+2opR6ac1YEk1BE
902oMRc2x5bvXweKOtH+dXdoaT9avn6b73o11cGnvZTeZj7JFRiBo0L4ILVr
MjunsRU7bYM/OLcDvWvYxQxauz7JsV/Ks39Z4Dg+2co3rH1X5CDIJ7lszi67
q/Fyvv3zHNtvM2zvplpntEULqxDCAxhUkGdfuTexfbN53Vuk923F3wUqHN/x
+PGl5Z9Dy1crPXkJumuwaftw855R5nvGWppG6PaOtZHf998Vub4udZPf/cJe
/A7FFmWAVdtKKkmYtsffvI5E0Nmu45HsvHcHbVv0/RzSYqLphqyn2J4sfiCG
nzLNoUxlJxOyj7TvPM7+1il2JuEjDGtk3uZGdXkw+SN5maIzU+SZT0XRv3KG
rRs8x6a6Xq7p71w1vW3N6s4IgjQvZZ7LV7veZd6rTTPP+2znOz987O1a5Gm8
hfm2wL/ANoXxCnYyQrs/nC6S3EdvwaMMMJMXz/ROxo8u7hb+k61O0L+qt561
Gw6u12hc8yb8tWh0u/rhtt80C/f1r8Q2hsBmhPgYnbeefkk/8/IBlrVDLBuH
WbeMtO4Y7ZsCu2+q/aErR3C4to+1t6ul/6DQ81lJ8OXFwb9fHvLD6lD/ERzh
2vZwNdej5gcrI+20f42h/cvbzORtbvK2uOpMsP96+LoVE+hfvkb2YIx/8WF9
/+JDUuLitE/j1MPR3g5menPn9+qw8w/9/et8TfpW0hn/LcBOXte/Nl7pX7/N
olvAkkZiCuz2EJ7BoIIkD5s8oG7D0U0aX3kXaLDvXaCJw4bWdv9meR/jmv4m
En6yuhgbsZV7RT1MR8dbjk+0PDyFnmjxRKJ1amvfQe7T2xjOzrZuGmLmjaZt
jG52e+O24eatw81bhpnPz6WHWrxAnjDYHDjavWVk0KQW+sCLBj/lVelr1jZ7
6HliiofebKKlkb6Z/FzMhe3X9a9dYWqqq2uc/tNC16tpjpZRusV9zCOaGK55
LeKdkS81vLO/6Zkky7PshI2X59teT7G9k2YjnevDTHtqJ98JIZldTdldTSem
WDvX0Xepoz813faD4vzzIuov5KPi/EFxFLI7t5Iu9nWB/Ys8+4fp1vgYHM1x
+wkPYFBBnjp3qE+dhsMb3jGpVdNr3gU6cXzp0fuWkvI1tZWBvARtYm/+7B5p
3j/G0jg8aM9Y28UcJ/mVv1zi/n6J5+8rg39eE6ytD1EGWpXBVv4rTzdqjbZr
90VqD0RqD0WpK0JIsKG1ixSup2O0Z2Lobix+DsZZVmq45/yfsHMIlekO33cj
jWyagx5IyA+H9zWySG8Lo7o6hM3OR2lPRrFNXtHqxlC62vAcW2RIatfr/oWF
b9ZS99BNE952ZnVvxFWd64M6dM/7R34f0AeVZDd5pjLfRZva6+xbvRSrnfNX
sMfZXrD7SMcM1faww0DWubvV1R8YZRb+k61O0L+qt9XL17eNqtelZoO+7LWo
d/065FepR13dxBb6qa3oEkRewWax/tU9Tr+oj3lpP/PqQZb1Q613DbduHWXd
NcZ2YILtyBT7g4mOU7McT89zPpfimpVgntfZfLHA83Gx53eLgr9ZGvLHlSF/
WxP604awK0sQ90RevQTRtwVMmeJUpro0tRbdAvZ8bbYEsQ6dAnvdPwX2LpsC
o7vA6vlP4agfWIWo3h9DOpf2VQPqa79vAp/XL1e+6rPD59kJ9p/FaZ/EqfdG
0f5FD9+ow+7/VVu7UMt3/6/nYulrJnn9fIz1rwcitKN0+TTd/8X712r3X5e4
vlno618ZBYrwH271IDyDQQU5c+J826i4DjH1e139LlC7Wo7udXQ943R39jOl
JhgahgY1CqX7pw6OtRwZb7l/ouWhKfQswSeSrE8mWU/PoCe6T29Lt1zxuDKv
o/HNNDuVan8j1U46zoUFtleTqVfm20jreXmebesws39STNcyip59wfeRXXkD
pyG7jc54O+lf/BGnyXRHRHTLRs1bt05o2a6bOyTc28jQvZ4hobY+PlbfstxZ
8bxqNY/0TXJNY7f6Iq2QvIpeSGbLCzPsH2TaP86xf5pr/zzf8WWB46uFjm+L
6M2gH552ZVkRyTP/WEpvxkr83xVO4p/k41JnUU/awvK6m74psB8eS9+sRgW7
vYQHMKg4a9fkx0fX716rQeBdoDn+d4G6No6Z1FK/pJfxzv6mu4eYd4ww7xlF
yxdJO+9mOz/Kd31e5P5Gcf9pmefH1bR8aXeF+tYc7gvXDkaQ8qWMpTHA29yo
TGLTWKdZ7aKdi2UJ/8pAusGK7sliE0wcf+QcPZZQSXKSUqYkOoka/JT46f4u
djpKXRtCXp18E2f0YMNofqohXTG4LZzeuvQNtrzwndrqvghve7arYn8k/Uhy
F+9ctHbVpWc+f1yX3nznE/oJT0FKipsGofdqK/PdrILV8lWwF1g9PM3m405E
aMfClZFWZaiFnh87x9a5tu7tEwuE/2SrDfQvGaxevq59dBx5LfLWakB/zevq
JrTQT2mlD9zJdCbbLrGwp7mkt3lRX/PKgZY1gy0bhtFViNtH2/aOt9072X58
uv2RmY4n5zrPLnDN7Gie08n8br7no4WeS6XBXy0JoafQrw79cV2YtolPgUVo
uyO0fZHawSjtSJR2X7T2QAw9hf7RWGUy61/P1NTO+Jcg0lMQ67BTOOpetQvs
w3p0FeJ1FYy+3H3Jj0NsUE59n8tXl6/PWfn6NE77mBS6uvTvXqyjvVOHH36o
vVrLt/jw2Vj6+vlkNF2t/XAkPeX1SDg9gyjPFZj/+vNi5zdFjo+y7CTaoX/d
LsIzGFSojSVrNpZsCLwL1KtuWH5XQx1P0Ox2hv4N9KR8ZXcx7h1lvmeM5fB4
y30TLQ9Otp6cZn0skZQv2+kZtmdm2tYPNvPa9XaGY36Cid8yPjnBlJxg3DvG
8na6nXgrjSKlbPcoSzw7FHHnSBqreCN7kc2OPT+bnv2+cZB5/UB6GsaGQWZ+
rMeUVobyJvvxP/JlhJsG09Mz+NJH8t3I97zAdnK9k2a/SNpWlv3gOEsam97K
6GL6stDx9ULHd8XO70udjybaHkuykarVPY7OxHnj9OpsO3kxIZQ+Zt983Bp2
e2hutUtb5bfS9dNy2sIKvKbvFrKTV1Ote5ctEv4zrTaEBzCoUE+cO7B2TV7b
qLiO7F2gIexdoNYx4ROa60t6GJf2Nq4ZYNo81LxrpOWOsKAdo21vZznfz3V9
Uuj6ssT9hyWev60M1tbx8hVGVyPvD9cORWhHSTyg017aI9Hq6lDem+gvcpJT
meFSSfh5sSY/e9C3MpBkjAsB/BH6JW9bk7olzNfIztHio94VSr8J62KkiJFv
S3fKk9p1Npp2oufZmsOXYummrbYmUr7UPRH0GDHevA5G8sJFPqFvMvPOxWvX
p3VpBLoURz4q6R5vRzO9EQ/5Ep8Lu1hbSXYr8/0VjC9EPMPOpX+UrascbdP2
hrBToN3ktSi/L6bAbhv0L3mcOn1u9fL15Fc7zPYb0r8mtaQVjK9CHNhQX9MV
lN/DxCvYsv6WVYMsa4dYNw2nqxB3j7XdM9F+zLcE0anOd7aO1W8fa38r1/1+
oeeT4uAvFgV/uyzkjytDfVNgd4f7T+EITIFFB05B9LYwqXeGa6drXjUF9lId
3y4wXsHejfvFCvY5619f+E/k+NJfuAK160v2Jd68LrETPHj5onf+qsvfIyo3
+VXryuLDp2Posu1Ho7QTkfT8osPh9CzZRgZtK93/9fNK9w+LnCRWpXSiKWvH
ukXCf6DVg/AMBpVjY8m6aIcnu7OBJB/+hg952dk6jIQfuvLn3nGWoxMs90+y
nphifWS69fEk21MzbOtYRYqP1b2Z7iDl651Mx3tZjvezHR9kk19DE9GeLSkk
Hxd0MlEJRvL5PeOs5AkfZBG0Gb2fZb+YaX8vw/4ukW5/h3k7zT6/o5F0Ol7c
SJN6M9VGPnmb4c95lyF/kXxb4sMs+2+z7Z/kOojP8hy/K3B8UeC4TKuW89ti
5+9LaNt6ZLqta109caVw1dMT6ny7muygt7HY4LfRo23y0L3tAy3eBno11UH/
uIk9vsFNoo62zq2tJY2MtrASdhR2Xjfjl3m2A6PMJ4+pwn+a1YPwAAaVY+2a
7LVr8ttG1avlChnTVF/cw7ikt3FVP9P6QaYtw8yNwoK2jbK+kem8yMrXFyXu
7xZ7/rIi+Oe1IdomVr52+cvXsUjtgShavh6N1p6IUaY66SGEz5LOUlOZ6VJm
ubxt2Zsqc1zKXBdbGci2ObzJNpu/xW45+qbvHEIaYy74uhgtay/Flu9itIgl
Oa/M17empzRTbU3eeN8mDrrU8EAkbV7l29YndUm9IiWLxh5euz6n1GP0kHkl
w0Mf/IyVsisVjC5HpLNgr7GLIdfwXIz2zP+zdxbgUZ1ZH18y7hr3ENw9RMjg
7hAPcXf35IYY7hCCuxZ3vRSnWAu0pUChRtttu7v1rez2fu9533tnJoGutE3n
6zI8/4dnOpmZhMzc0/N7zzn/40RFKKhQvBRsk55p0kJ0mq3yc+dtWJFi8Tf0
f0NW/nrRhK7BzrY2drI2w9ryInrwZ/QUIATr5cgb6MbPCxCVDBaVDxXPHCmp
Hy2ZMw66EJdNlq6aDi4c2yPle2MURxIUp1MgLFzLUd3OV0MJrJwrgTWYlcBW
NC+BbTeVwAzdRPQcW+akK3MGl8DAiN6sC/GWp6kL0YhgpBHxMUthELiIIwcx
5TAXufO9Z+HLC2w37mP+QlSI4uFtdziYuubKXHaF+EmT4S8nsC3a58Dssme2
2dElmL9W6FDi9GOD+otqJfoVZQwUxvUR/G71r1NnL5+/fHXnhhUW/+S0kiye
g1n1+6g4h0KZT8kg4cyhQi+tjbfOZkwHPh57l2wOguLXrjDpngjpgRnSIzGy
k3GyGb2FfZx5q6ZKb2cpCH+9nqt4Mw/g62Gh8u0i5ZNiVjvCZDkBIhTBBrqz
017oBlJugIhod4RsV7jsvRLFu8UmoYeRG+j+97E+KAU9LVV+WMbqI6Ry5cfl
EPE+rVT+pUp5KFpGSlon4mQoVFYMEyPOMngBZBlpC+TNp0ZJOMjSMsu0zHIt
bHJv1IKfKhFKaVbpmNU6Oh+2QlPjJez96DErNMwy/NxFmMLmqEi/YnEgINjG
3xHBbpy4+urZ6xb/8LSSLJ6AWfV7ag+92kXZxt+dVzNMNAvgS7wcw9fyKQBf
94sQfKkJfH1Zr/1hro5ZrIcNgKtx2yGpfCH4OujEHHViTjpTURi+LuL58Wtu
bJ3rNtAWlaKmUtXseBdCmzQ1jJy/gb0vsCEGvR5KVyyO3XYD8DGxmAnEWHPC
Ky70Clu60ZZeaUevtqPX2qMXh6ffxx2GjzB2vcPRFhbiLECt972Q6N1O4P88
UII7gjCO4VpYMwQjjYiIGW8CCdLL9NAMOUMBliB77JgteB3Ycg2KRSdiZb0d
bX6f9+vc1U3X7m6z+Mem9WTlrxdNKCBM6cwf7Mmzk7fpDiMMfNJg4+PGy/EX
YQQTVw0X14yUNOAuxMUTpY1TZeuCZVvD5buj5AfjFHPHy3o68y9nqW7kqu8U
qt8s1bxdoYUpsDrd336uBLYVl8BeghIY8NdsW+a4K3PKlTnrxnYhXsJdiC0Q
7B6HYGQW7BFLYWBjuMMZamHEGtFc73LY9Q6Gtcek7ZCFLxQAcbezumXx62UX
KH6dxMNfpPlwpz1s9FgPtq6QO83XnE6Q+3vw0a/ojWxZbKvxF6KtC5ev7tq4
YkV9btOC8rrCqPqS+Pry1Lqq7FfeeGTxD09ryOI5mFW/j/o48fL8BBWDhZ4a
m+T+gsVjRWM78id04m+YJtkSLNkRKt0dLt0bIT0YJZs9WtzDkRffX3g9Q3Ez
S/Eqgq9cxetQ+VI+IORVonyvTPW0XPVhBeijClV+oLggUPxJperTKtCBaNnB
aFmRQVw0WFw8WOyPnS7+9MwfUqsyapBRXiYFerGVLPbMmcMrIKzREiQ6UwnK
UgJhsZClQzK0F9B5SiAsDFmwTAflMOv0YOmDtAFrI6cNemqSFIlZhx+2GtMZ
ArHlGjoTGzamyJhZqoohouJA0QeFss2Zw1rjPSK01ViZsWZWaW1+RF1xXH15
cl1l5vqmFRb//LSGLJ6AWfV7KjWkf66fINCTN8ybP3+MaPE4MQpBMf1EVzOU
iL/eKlK9WwHw9VWD9nsEXwt1zDLsdrjejtlsz+xAiYEjc4CFL+aMCyIUeqkd
cwUnEjfdCXkxd/F0wxseRu8LKkONxLIYvk1vdqDS1Ugsjt11NxbFTCCGK2J4
1MsWiAwvUGZnvu66oWfBSfJmB+aRB4YvT0AqTFsAWVjg/JynJR5l9B4n0y7U
ZxHsAf5R0Wv2AwdFKlEF33eJHubOUEa0zx4WRm/AJbBF6n82qHzdeHlU8m/+
7tCYtvbtrmmal7J6aV5dUXR9aWJ9RXpdVc6tJycs/uFpDVn564XSzqO0Ttpm
Uif+9K784G58smGnhwMPZTsDXHlZfkLEF7kBUAKjRohrR0lmjZUsmCBdhneB
bQyVExeO8D6iGf1E5zNUV3PUt/LV94o1D8o071RpP6zRESPE7xbY/mScAluD
S2CbcQlslxOzxxmI5pAL3gXmCl2ICMHAi969JYKxs2AYwd40K4Q9amsYIKG3
OwFeEb1jJnLPY468HmEr+7c8mTcRfKFX86DXOcBejFvuzHUy+cUVv045s8Wv
/Q7gKLvdjtlky6yF7m6UXKGMC2ViB6JkbxfI72bJYnr/Nvz1L2irlsqvqS6i
qssqqYqyqsriiqqFTRss/vlpDVk8B7Pqd9DWWTMzfASFAUIPjU1CP8G80aIl
48SNE8UTOkEj4tSugp1h0pcipPtnSBtGgcPh8knSV0zwpXwjX/lWgfJhkfJx
sfLdUtUH5aqPKlWfUOq/VIMIZP1tpvrzGvUXNeova9Vf1aq/rlN/U6f+th70
93r1dw3qH2ZpkH6crfnHbA36pmeTFTRRioJOxUprISWdrqQzQMwSLXsUg7QC
8ArGQpswWK3Ga1jX6oGt1jVjKxggLVUzm22ZLVhbsbZhoZRmB6ft7J3UVBl+
igqevl5HF0BdDHEc1MIW40IYi2DCRzmyXXNn/so3BdHWa/SNZ2mrjsqtoYqq
q0uqqPLyqsqSyqqCcurVq08s/in6zWXxBMyq300IGZZMlxYPElJDRcO94USl
nc6mhxPvQpriWqbytTzVW8Wq9zB/fT1L+4/5xrEvO2ajPbMNZQUoN4CZL+YE
wBcVo6JiVQBfKJG4hccZ7mBfL8AuT0g5iPGFeWfg255UlgbJMAB6FIkJBnhl
GCnsmXIY3YRHvW66skJfQo+5B96GCL5gzutt3ElImgw/wISF9GFbBFxkEQ+9
h9hBtwU9F8Ee4x+SDILhmh2VpIIC3AVnhnYC38WDDtCCiMLXWh0Eotmqw1Hg
A7mHXv1r3o5LtzYDbe2pRbS1pjlt1VIFM6uLKaqsgqoorawqKq+69viUxT8/
rSErf71oQhfOxE78aV1YBAvtzjc6gxEEy/YXFQSKKsCIQ1I3SjJ3nGTxJLYE
tgVKYIrQ3qLIviI6TXUpS3U9V/1aoRobIWrfq9Z+XKv76yz91/P0Pyy0ZZbi
EtgqbIS40WTEAWnMAWfmsAtz7F8jGJ4FM+9FZCnMC/hrixNbDntWjzB2PSTk
5QXBEMHX655wMHXHg14D2zEgZl5zg87DCy7MORd28gucNxzBUXanPbPVji6G
5kOIk94ClKR9U6v6sEz5IE9+K10W1euX8JeJthryVi0or30ObZUaaSu/jMou
ptILqpJyKmPTyyOTSkrrmyz+4WkNWTwHs6q1VZxDpfQTZA0UuKttYnoLZo0U
zR8jWjpevHKSeO1UycYgCeIvdKEFdRfUjhT3dOJdTJVfSVe8kqm4la24k6t8
HcFXIYIv1eMSFZS9KmAvz6fV6r8h1KrTlA6VIH1Tr/m2QfP3Bs13szTfI86a
jTlrjuanuRpmnoaZr2UWaJmFWmYxCE5U2gkQUoGWoqQC71RFWsGp0YywVulB
a/QoGoAbD1vAsmU22sIRDWGrrXbMNjs4tEHaYcfsxNoFgjXu1RqYJ92DtddM
+9h1q9Dh85IdJDm77OgqtaGzgIAYmOQXKaFw1gSFMA7BlIM8efvCJW9kSv+r
d4HQ1soqjrZKzGmr0Jy2Csup3BIqs7AqJbcyPrMiKqUsNK7Y4p+i1pDFEzCr
fh8h+OrrzEMhqAjz16xRolQfYXdHXhSepUrwEaX4ih8Uq9+rVH9ao/lmNooV
ema5LbPKjtlgz2wx6zw85syccmFoF0hjSOWLwNddAl8ceb0Nfssw+0CGsMwF
d4IPGL3NkcrkWKy/mLQp0uvszSmMXm1n6CuC20afeVz8Ip2H8DOYF7+emrAL
17ycqXwtEstfH5rxlxG+uBIYuHb0F4MjfYoK+OsaGYpnXTggRpES2AotMxcW
8aBc8b8qgWHa2r4faCt1zbJ/Q1t5pVRWEZWWV5WYVRGTVhaeULJu3yaLf4Ra
Q1b+etGErs3xHflTOjdDMGIvRobZ0R8fN76fB58gWMMYMOLgpsDk2yPlwb1E
YX1Ep7AR4pVs9c189d0izVtlmidV2qczdZ/W676Yrf92vu0/FuMuxJX2Ji/6
rQjBMH8RL8QWCGZsRCR2HMQR8TZXCDOjMEN/Cb3ZCdjqAaeHHHA9MGIXJq83
MHmB26EH85oHdAjcdIcfgIUvVxa+Tjozx5yYQ450jRbWfnUGhw1IfvJUKE+j
0xQ/zlL/rVr1XrHijRz59VRZRM9/z18sbW1qbATaqvgPaSs5pzIOaKs0OLZo
cnje2OlZw8an+A+L9QuMnLdku8U/PK0hi+dgVrW2MqYMSe4nGOjKG+TBqx4K
kxcLxoqXTmD5a1OQZGuIdEeYtIs9xJ/ovsLYfiLEX9eBv5R3cPHrAYavd8tU
H1SoOfjSIPgqGyapGC75frb2hznaH+dq/zlX+9M8rYm2FumYxTpmic4EWUBV
emq8FAmoarXeVL1aiy3O1tkCWyFtMCOszXbMFju6AiIDi1e77EG77VmwYmHK
AarnBxzgxPggXqJ6CLapwh7VWVpIY5COOrCLVo+Yr1u1Zw7aM/vt6RqNoSvr
hw+2Y9vQt9bDCtS1CAPxUBhCsHmqf9YrAzx4O0PE9+pHPvcXfm7/ZURbOxYu
XVmVuWb2s7Wtf0lbqWWh8cXTZhSMD84eMSlt0MgEP8OMpfN2WvxT1BqyeAJm
1e+jHg42qQPgCKgwQFg1RDR7lKitzmbOOAmdrLiUrkzE/AVzox784qGSUylK
1nZjrR2zCaGHA/OSI7PfiTniDMWvs7j4Fadi2w5f9WDh6z4YfMHZ72MvM+8L
bMLMirXCQPdDEvKEM8F4BPgDrYnpagRBxFgDOCgZBMfFr7mZhItfwF8PPRC7
0dsd6R1O9C6Y8OKwywlcoD9mBfegdOu5xS8sshQVXgplaK+DSQj6jnSjHZhC
v4yH4o/iFkQU9zZi/pqn/nuNMs9f6Gvo+3O/baCte4i26prmI9rK/49oK78q
MRvTVmJJUHThxNCc0VMyBo9J8h8a4+sXavHPTyvJyl8vmtBFOrYDf1InFsGC
uvJDugF/JQ0AN7C0gcJ0X+EAN54vnmR319gM8RYMby9I9xOvmCpbi0tgXRx4
tWOkRxOVZ1KVFzJV13LUtwvUr5doHpZr36XAiOOzBv2Xc0kXoh10Ia7EXYgw
COaIEAwij9GO/jDXiGicBSOOiJfNCmEtKOyep6GfhN7oxFbESFGMiPznm0bs
wo9nycsDzqluoNfEvkMEvl52QbGUnqenIhQoR4Lw1UWIUiy6TAMJGErPVuhI
8evvdepPKpVvFypey5RfSpKGdW/JX0baWtGQ+/O0VU5oq6CMyjHSVkZ5ZHJp
SGzRlMi8cUFAWwHD4/wNM2Jiy6NCc+fMXnn0zNWjpy9b/GPTerJ4DmZVq2p+
eXV8H0E/Z56vG6/MIET81YD4a4x42QRx02TJumlQ/9oSIq0cJu7uyDudKCf8
hS7GPi68JB/R+iDZ/ULVoxLVO2bw9dcazRd1mtJhkvLhkh+NzLVQxwIXS1t4
dr5RzzThAtZqbGKGCQsiwEaUWdkBWGG2Am2148pYKNnAE6CEsFjIgl2r8EQj
YR1yBK9UJJSfHMNiN6U6gU5hnQbR8/WGHiJym9UpR1YnHem5OnqOztAdxx9E
avUa5gAGsS5CZhfuTtyKB8TWYQRbjh05ZqtOxcr83XkPc6TbZs9EtHUT0dYi
Qltl/yFtpeZWJmRWRKeWhSHaigLaGjkpPXBUgt/gqMFDIuNCChbXrD138AZ6
cYt/hFpPFk/ArPodlEclJ/UTZA4U5PkJSwKFVUNFw7z5ob2EJxLk51IUVzKV
t3NVbxapn5Sr98YqSoZJAr1x30sHITVJTk2RwwLTvY7MIVz8Ou3CnHOFOHDV
DdKJ2/ho93XPZvAF5IWBi4xiPW2uD9oSXGIh6Anbmgg+GA9YQ3h6gz1Zy4VA
zGh1yEJZqpoYzhNogi/5gLcGjXKqp7jJ8GNvcyH4gn2pJvhqy46JYUdEeK6P
hN7mCDU7PAKG+ItebQ9Nj5c5/kKRbT+sQ2XrX/PVZxJkvu48I3/9DG1lPIe2
KlrQVnkEoq2YwklhuaOnZgwemxQwLNY3ICw2LiM6PHb+grITlzefuPy/Wfki
svLXiyZ0wY5uz5vQsRmCQQm+nzCpvzB5gDDVB8yWcwJEeYNEoT0FhraCoe0E
bXVwNN3eljcJH88G9RQdjFecSFKadSFq3izVPIIuRB3pQvxqrv77hbYMQbAm
E4JB7NrhxCIYONJjBCN2HGewKb2xF5EUwowUxnUkUikaJMJiz5cRu141Jy/0
am70cntDLxEVqyI7OyB8dRdR4Qq6Tgcp1i7oPIRz7zV43+JSHTVSUjlc8mWN
6oNS5f1c+fU02bl4aXA3/vRJYzBt4dpWQWQL2qp+hrYyONqagWgrrmhqZD6i
reETUgOGx/sOioiNK48Ky5szp+l/nraelcVzMKtaT4d20T0cbBKx23y+v7DU
AM0/DdB/CPUvxF9rpko2TJdsDpZ2tuPNGStB/EUnKy6kKq5mKJqmyVIGivq7
QnTycefnBIr3RMk/qdYQ+Pq6AQayEHwx8/Gk/GI8r7HMyFy25sAFE/QccNFl
uIxFIAsIywH0EhaGLK6MhbuREWQdNkEW3p2hZ/HqNN6LegbvXaWxzpEFrJzO
m0RWrMLtl53pxXokKlpJQhBs+ekhotG/4iTGt2O4LnbInq6DWhj0Je7kEGwt
bkRcCi5kTIOy1CDK9ROuniiKDx/772krrzIhC9NWQvH0qIIJITkjJ6cbRiX6
DYkeMnRGfGhh7LSs/3naelYWT8Cs+h3UyxEMf3J8hYUBwvLBoprhcN0diZOf
SVJcTFdez1beLVA9LFW/X6n5tEb7zRwdswiFEVs6X0NNllNT8Z7lrihJUFKR
SnqhLVf8coe8AuUY9/CAwwMvDr7asjUvmMMiW0qNYoewqDwtlatlPmg+hIUL
YRyCYafEezAUBp4Y6+yJAMrS1PRGB3qzA73VkfjM0zudWNsNPPllXvwinYdQ
AnvJyejLgX42AoBAbSgTg0l5T3P+Ym65wW6y5bYm/jrgAN3UiL8atXS6ghou
/kulop8zr6w46j+kraTsSkJbwZi2xkzLHDIuOWB4nN+g8Nj4zOiIuBeBtp6V
lb9eNPkEGPq52IzrwDdHMBRh4voK4vsJEzGCpfgIM/1ECMHyB4mKB4MdPTHi
yB4kntBF2NGe19me7VTs4cTv6cyP8xEn+opT/CWbIhSPK7XvV+uIF+LX82xZ
BFvBIhhdpDV0EpJGRGLHAQh20IU5gnsRT5r1Ip43ozBSC7vOghiVpKaS1cBi
RK8ZhYELMxe92gG0yp5KVBv6iA29uXOkXmzOQy+wZdsODztBroXyrl0OzDZ7
SNJQwtakhyP0RdqqEZKyoeLPqlRPihR3suSXkmUnYyToN5YQOakFbZU/Q1vx
GeVRKaWhiLZm5I8Pzh4+MW3QiHi/wMjY+Iqo8Pw5c1YdPXv9RaOtZ2XxHMyq
1lNxDtXT0aavM6+/Cy8P8Vcg8Ff9CNG8MeIl48WNkySrpkAJbHIXQVgv4bF4
+Skz/rqZrbyTBxt5HpaotkfIcwPFvpyHYYCXYFBbQWBbAZ2mhJrXEo68Vtqa
yGudHYtdUOGyh0sbMxc1XU4FyYG2WNTC23xYzsLmZsfwHooTXBnrtDMIQxaC
JnCcBrbCG9svuMCUxCWsy1hXOF1lBcbRK2ypeHCwN/QWkb+RqDgljX7mi84w
5/4yXnhKY6A7ZaIwKlROhcgBwXbYggX0Bmyi2AguZMwc1fe1Sj93XoaPwMPD
/RnaqiK0FY5oK7pgQmjOqCkZhtGJ/kOjff1C48OKYqemY9q6YvFPiGVl8QTM
qtZWHpWc2E+QNkCA4k9JoLBiiGiwFz+oh/BgjPwU5q+bbPFL81G15m/12u/m
4njSaNZ8uMeRrtdTEUpqBndm0luM8gqUhNDrHKDZBma+WsAXR16IgP5sJsxE
MJaVpzV1A5pbEZoQDJty3MP8td4eWIwI3fkmfgC2nYfqFeKv957HX+gGLnsh
+IJyG7qxm2tTROSFsq93cZ8k8d94gPnrHrZwvOUGK557i0z9h4S/NkLntqEd
n5mt/qxCMcCVFxsTxtJWFdBWfimVzdFWbHp5RBKmrXCgraHjk/EYRURsfFZ0
RPz8RVUnLm950WjrWVn560UT4q++zjZj2vPNEQzGLvoIYjGCkUJYygAWwQoC
RaVDwAtxzjjpImzEgR68OVy+c4ZiX6xi1njZvImymAHieB9xkq+4n5vJqNnX
U+DvJQhoK6gYJaNGy6ixMmqc3NBBaOgopEu0dJmOrtDRlJ6u1jP7zHoRj7s2
ozBcC6OX2dPLsVbY040OVAIgFd3kADEwCQSEhWWyiSb3oDgZr4InLrOHPR3n
YeAL4Gu+Hhq5Ua51yAkSsD0cfG0Gz3kYCVmhg1H9edryYRJEoE/LlPfzFDfS
ofh1ZIako61NZFQUS1slQFvmg+rTMG2xoxODowxDIqMjCubMXXv07A0rbT0r
i+dgVrWeFpRXo4sR8Ve6jyCXNP8MEdWNEM0dI148XrxsomTlZMmEzoJgnA4d
jZOfTAD+uogdyW7lKO/mq+4XqR6VqN8pVz+tUkPxqxbcoQd5AXxVjZQacKcQ
XO/twSeQmiADTZTRxRq6RAOu0VsJduELHFe4qGAFFaJgy1uHnYC5WODCc6Cn
nM1KWtic52UTatHLcFpyxRWsU5GuYZvo666wl6fJHgn2riapzGORoS/c5u4X
gbP0czauOnMgZkZhx2FSDDoSazRgzbEdz4Ktx12Iy6AE9lOD6gg2IhvTzyuB
HVQH2mo2OuEfFh9eHDstYzG1FNHWi1be+reyeAJmVWsrJaR/Ql8Bij/5/sLi
QKh/oUtmV6TsQIz8RKLifJryeo7q9UL143LNxzO1X87S/YByg6W2zEo7Zh3K
BxzANGwvyhOcmeMurO1hnIputIfEI0Vt6g8cIKGytVSOFrimBXx90lx/NpvJ
auGGwTYiYjfC+2wJDGpeqern8NdD7JuxHXoI4RXeb9sMwT7CPwP23CD8xRa8
djuxw2jsd/QywdcbHuDBSFbzXHM19BLRi/RwAHUETKFhLr4TCrBS2GaI+Wvz
dLGLm0c6R1uRmLbw0Hrm0HFAW/6GyLiE7OjIhPmLqBNXrLT1HFn560UT4q8+
Tjaj2vHGmiGYrazNyHb86N6CmD4CYyEsbaAwyw+6EIsM4rIh4rrRknnjpUsm
w//x14XIt0TId0Up9scpjiYqT6eqzO3o3yrTPqnS7o5V7otXHkpUlY6QIQSr
4hAMW1sAhRk6wbCVobPoT//uj6Gn2NCLE65kob8xW6kRiyGheEjEXMPFMqQr
bsxlN+aSG3PRDbDrZUReiOlcmNMu0O0zRw9510EnZp8jZGU7ucrXenx4vkIP
M/vztd/P0pQMEecHip8UK+9kyy9D8Uu6PxxOkFja4gbVjaMTQ4bOiI4sjArJ
xLR1xeJv9/9/WTwHs6r1VBU+1FHRhvBXjh/kP5VDRLXDRXNGixeMBQTL9hN1
tue9NEO2P1p+OFZ+IkF+NllxgeOvewXAX2+Xqt+rUH9IaT6t0Xxep/16FnQe
/pO0HbKVL1s6V03nqxF5UZNk1GQ5xJZOwmYxpKuQCN2mwhRUuIKKUMCZdiQc
a8MqVbxNFRSjpGKRINECxWMlgAhVAV71BZleHP8nHtCArIw0C2FDaaPAOBrG
N1JU3KIft+dsXL2E+xXPOTFn2UIYPVuLEIzZawezYFttoQtxjQ6mMHAJ7Jtq
pa8bb3gPNzI64RcQnhBZGjstC2jrgJW2/r0snoBZ1arKo5JjewsS+0L9K9df
WDRIOMiTP6WbcGcEBJxjCYpzqcpr2aq7BepHZZoPq7WfN+h+XIBCii3ThPlr
iwMe/sL8dQLxF6ISMb3cHjcf4gEHmPwC7y96mxPhL1Jg+hO2wqAKdEj0fhfm
03acAMFgBIPUwshYFjHEaFECu88uawZfRHP+Av8Njr9wCQxejfjPmyPYh970
Hpj8MpIXlMCMTiCwI5WDr4e4fvcmthBBkeo2XiR91ZVeYmvoKYIegCOOVIgc
fFxL1bDKcKn2n7MQfym3BEn09q5jp2cNxUPrvgHhcYmEtqqttPUfyspfL5p2
HqU1kjYjvHmj25sQTC9tM9ybH9lLENVbQAphcf2EydiOI8sfEKx4sLh8qBi8
ECcAf62aLlsfKt8aId8drTjQHMHADhEj2OMq7QczoRERz4LZfrfA9p+L7egs
jaG9EEzp1zrAXjDsyMFsx72IL3ETYQddmtXCyFzYWTcYDcMVMXb1xkXMVpee
Ebn/gjl2oVdwAdvYk87McWcY4mjQ455DRxj92OEAh+Qbcdshgq9GDF8LtD/M
1nxVq/bz4O+KkN3PV9xIl59LkB6eIakaItTqnaGZZ0i0r19I9IyiqOB0K239
Ylk8B7Oq9RSGvVWdFG1Q/pPtJywcBOfPM4eLGkaJ544RLxwnHt1BMLWbcHek
bF+U/FCM/Fg8DGWcT1VczVTexPWvt4rVj8vU71VCd9Bntdov6rVlw6UVI6R4
5ksPM1/LbaHtcBXuF1qPl/WwZS98rrIbb03d50jX6eh6Pbrwgb+exS6Yz1I1
Yy4MXFQiFlSvcLsR3l5hIixIh3De8jo+PSZLV5+rN9yJIFm6Z7brh7AYu3EV
U9hlrhBGEOy4IxVu1oW4GRtxNGmZJRpmrrpiiMjPHXo7d82dbaWtXyCLJ2BW
taoSg/pH9+LH9xWkovjjKywYBMcvG0NkOyJk+6LlR+MVZ1MUV7OUdzB/fTRT
+8Us3T8If61CwQTz1y4UPZyYw8Bf9EI7xF945xfmrzueRv6ClaPQfOjNfIAL
Tx970/tcgL8KdQY/jsj8JEhUIRwf0fucn1MCM3UDclNgr4MXh6GfuBl/NS+B
QQviDifitUjvciJNhsZql7HgBZHnPdweieDrCYEvr2bwdRc3H950g9L8ZdiL
SqbjIWCi+LMTz8Wvgr6g7+tUH5UqHubBWfr8RTNPXNlupa1fJit/vYBCV42X
1mZkOxOCIf4a2pYf3lMQ0VMwA1NYDFAYIFi6ryjbX5QfKCoZLK4YJp41FoLJ
simyVUGyDc9DsCscgt1HCIZnwT6u1f1lFjgi/n2B7ZkMtaGdkFlhzzpykNVg
mx2ZbdxEmInCcEfiEc6jnoDYaWAxKkpFRatYHDvHtSm+TG5j4KKxTNjlAs1F
x5zBP/aQk6GbiK7RgaMsKXuhbG2DHczpr8KVr6UcfNWpP6PUA935W0NlUPxK
kZ2Mlc4cBuFo+NARR89Yaeu3kcVzMKtaSRvqZ3a3t+nlyEvsJ3BWtpnaRVAQ
ICwbLKoeJqodIZo1SjyiHX9iF8HmUNn2cBkpgR2Ng6GMl1MVVzKUN3KUd/JV
94vVb2P++pjwF7bd+GGeDhb0LMHw1Yiv3DV2MPDFwpcDwNcu7Bq9F29NPYA7
jY84EfLCTYbgfYrbC7EV6kWcclzBawFfwTtVb+L5+tu4Iec1vFz1rgeiLRjH
QCGLUNV9D8he3sINPA/wSfLzhZ3NsAz9sc/zm+7s0tV7ZktXb+Ja2FU8R3aB
q4KddDR1Ie6ygxLYBj1pQaRGiiuHij4tU6BfyHsvv2zxt/uPKIsnYFa1quzl
bWJ6CxL6CpL7CzIHCn3deeM7CzYEQ8DZy/KX8moW1L/exv2HX83W/WMhx18b
cCTZxTnPn3SBxCNGBQPp14nz4b/iL+bP7ZhPuLLXZyD6gAu93wURGamOkUVd
ZBoLicrRUNmwnRmMNbY40psdWP5a/wx/kRLYfQ942FZHMELENoZ/Mnoh7gJH
epa2CHC925bFtBbkBTt6IKxBcHsNRzxS/FpqSybdqAgFLNHYYw+bDTfYwj7E
BZqva1Qfliru58h6Otj8yi3ML7is/PUCyifAoJG0aau18dbZEATTSdsM9uKH
dBeE9RAgCovsJZiBC2EJ/cGLI8OXHQQrGSKuHAZdNwsnSpebIxjXiHgqRfVy
BiwFu5GvvlMECPZ2JTgiflQLpvRfzNEfT1UHegsYoy89KYStRxTmCAuaW1AY
mQs7xI2GIRA7jkjKhYpUIQGOESJroVNG5kKP57DrsDN0G+6HhkOopFNatuy1
yR7OzNfgI/TlXOVrjvarOs1n1eqn5SofN/6GIOn1dDmdIAvtIehsB9YlO4/S
Fn8T/2dk8RzMqlYS4i8YLMX5z8ROfGelja8br8QgqhgCCFY3QjzMm4/SobXT
pVtCZTsjZHuj5Ifj5CcTFXSK4lIG+JK9lg+j8Y/M6l8lwyRlw6U/zMceZUuh
8xCu3NV2UPzagC/nLQ5c5YvAF24zPuzEHIXaNyl7AXnRHHldcoVG5auYvK5j
T+mbHHZxzMWWt96EdIXeDAkPC1aPcL8Q0mOzdavN5MnqMesyTfIl9nz7vmnK
HijMHMFIIyLtxJyGEhjdoAUvxN12sBFso57Oh/3RiL9+rFN9Vg6D8KtTh1n8
7f4jyuIJmFWtJ4QGPRxsejvB+U/KAEHGQCh+rZwqRfy1A/cfHsf9h4i/7vwL
/tpt3PyFdy6fd/uP+Oujds34i0MwdAMhmMFPwvYffuRNbDEQLhn5ixjLk0Vg
zTqosQW9ceLsT3hrM/tgWATmZNo7Rgzw3+GEYxHe8yUxq3lx5IWi3Ks44t1y
o1fZsy3WvUT0Qj09T2/oLgQz2N3YF3q9HvYnzmP5641sWS9HnpW/fo2s/PUC
CuFDHycbL60Ni2DteIi/DJ68oG6AYIgyEIVFYAqL6s0hGPbiKDSAFwe6PGeP
kyIEgyrYdNl6bhZsX6ziCEawc+mqy9nq63lgSv9GqeZhhfYdSvu0RvdJvf5Q
kiqgreC7Bbb/WGzHLMW+iGRBM0thuBYGHYmOzE7sUW8OYgdZFgMn2HAlS2TP
Ct1/lGMu9PgDBLucoA0JxdJdDrDhq1zLlb3s4PC8EU+RLIaZL3P4elwMrmW3
MuVLJoi7O6Dfj2DjVPjnW/wd/F+SxXMwq1pJCeOH2MvbRPXix/WB8+d0H4EP
3vAe4MEHF7K2/DEdBY2TpaumSjcGy7aGyXbPkB+MgaQIRsDSldeylLfzYDT+
Yan63QrNh9WaT2uh+PXNHDwjvwiPya/Akxpr8LCGsfi1A59a78GNQwdx7xCG
LzjBxj2HUCI/j2tel9zYmtd1vKKCFLxe82DJC7DLk2AXW956BIMeMPDeLNXx
Yucv3uPcz8iGHeO6VeO2UzziAZbR2xzx5IWH+aA9WwUjjYhXXMCR42Vn8OI4
4cgccUD8RVdr6Aq1oaPA0EFAZyuZheof61V/qVBsDRL7DzRY/O3+I8riCZhV
rafVy1Iie/IRf6Gg0d+FN8CVN7KDAPHXxhDZzkg58d94OQ3mvwh/kf7DH837
D834i56L56EQf112Z+e/zPnr7Wf46+NnEAwLD4Vpufkvbzz/1Zab//Li5r84
Qwxc7QLuu+tudKGHQtVdd/ZQ6L6H6UQIjoO8QI/NRO5BgWsL7FmGUIYC2usm
8qJX28PCr77sZCu93A48Xc+5MKed6Tl6PHzqAKs6NtvCkvrlWsJfH5Up7mXJ
ejpa61+/Slb+egFFRsCGteUhIQRD151W0qaTnc20rvzpXfnB3QSEwqAdsRd0
ISb2F6YOBDvEXEAwuE4rh4uNCNY0XQZ2HOHynRjBDicoTyYr6XTVxSz1K7nq
2wUa4shBehH3xCn9vASfz9F/g63p/4kobNkzFEbmwkg5jIAYqYjtYVmMClFS
oUqWyJ7VATPm2usEPUiAXY6QlW1zQBHV0ElIF2ugW2m1seylZxbq/jlP+91s
7Zd1mk+r1R9UAHy9mQ/81duZ18ORVzNMtHGaOM+v5eZlq36lLJ6DWdVK6mRr
083eZkZPfmwfQWI/GMHI9BXm+An98G53Dw0c/iydKFkxWbp2unQTN5RxJF4B
LYhpyiuZYA19t0D9Von6SYXmKaUpGCIpHib9eo7u+/n6n1rw13rMX1vwNb4T
X/J7cRA4hM+uMXyB905PEb3IDsOXG1v2egWfZt/EB9qEvO7hsfo3MHa9xW32
eZutcNE7MH+9a0St5itWPzRT86WrRhzDryA2LV3lBj2w+Zgbc8tYAsP7T40t
iF2FeDu8gC5RMat1kAgtUP9QR/hLYuWvXyaLJ2BWtZ7Wr0hFwSehryCpv6Cf
C1BYW50NijbrgmTbI+T7Y+Qnk+Cc55Uc1d1C9SPMX5/P0n2/AAeWppbzX1A6
j1KZ+OumB6y8geVfXhAiEH89acu868287836HxL+IghmJpa/jP7wH5AWQc6N
0Oh/aJzJuov56w7ugn4N1+VJR/RdPHyKZ07hAc26oL1MQj/bA7bgBc3PKLm6
C1GOXmvPugZhg1a6yR6Ooa7gU6mXXcADFjtvwLEPpYGt9BtsYYv9Ui0zV/MV
1L+Ur2bIelj7D3+drPz1YsonwED4y5zCbGVtOtvZBOJCWHB3AWlHjOojjOsn
TBrAIljeIOgKLhsiBgQbK10wQbp0smzlNNnaEPnmcPmOGYo9MYpD8crjycqz
aaoLmawjx50idjvzjmjlQE/Bn+tgIuwLRGHzn6GwVXguzFgOIyBGKmI7WBaj
ghRIQGQEysxF7iTAtRM/ZTtOyVAg3YwztA32YICfr4E9QSh5W6pnFul+mq/7
YY72mwbt57UYvspV28JkZPErgq+F48QHIqVbg8RrJolGteNZ+eu3lcVzMKta
SR31Nl3tbSJ68GN6C+LxCEbGQGEWRrBCHEZQOoT+HtNRkDdIvB6XwF6aIT8Y
C+fSdIoSWhBzVNCCWAyn0+9XAX8VDZV+NVv33Tz9P2H+yxabb9hB/+E6jr+2
Y/56CWdNB7ji1wnck3zGFRIVaDt04ypfzeHrLt6mSmpehLweGskLn29j7IIX
+QCv+HnafL/qx8/IbOmqOYXBK7zDzdoTBGtRArvG8he9UG/oIWT9G7sIof8Q
5r90zDLgr+/rVJ9VKB7hQXiLv91/RFk8AbOq9VQROwDxVxw+/EkZAIsqhrdj
11VM6SYM7ik8mqCgif8h5q+n1dq/Nui+m48DyzP+82DbNd8Oxswv4bhxA28a
vYvChRfzlhfzqG2zFsSnzatgZoLlX/la1h/+AzM3wiekUGVW/CL8dccdIRKN
kqJX3VnfVKTbZCjVnR1K7U+GUrlivbnexAHtdXZ2FTzzSakLveZqexqlWzfc
YeL1qhsMwBL4Oos3cRx1Yg7iYY1KDezlWYd+J2C+8Y/Z6s+rVY8LFTfSYBWR
lb9+jaz89WJq51HaS2tjjmDoUvJz53W0tUEUhm4jEOtiz0MUFtFLEM0hGLFD
dFXbhPYUEgSbNVY6f4J0yWRZ4zTZmmD5xjD59kjFS9GKA/HKY0ngyPFyBvQi
vpLHFsI2RygHeAjepXRPa3R/rtObU9g/FttCR+Ly54HYBtKa6AAstsWRmqpA
YqtjzxWuc2HmcoCRkA32cJa1Dp+Tr7KD5AeRFzQc6pkFuh/n6r6dpf2yXnMw
VrE3Sj4QH873c+WvmipF/2qEn4eipDtDJOumiJsmiqzw9ZvL4jmYVa0kmCr1
5IV150f1EpAsKNVHmI4RbKAbb0hbfsNo8dyxkpEdBO30EH8mdxVO6y4kvmSn
kxXn02E041ae6l6R+kGp5p1KDXrMZ3XQI/TtXD20CaGIsexZ/nL8Wf4668pO
cFx8HnzdMYcvTF6k7GVGXrja5Q0T7nucTcxlXK76zKIf09LV5ggGrwCz8J7N
jru5KTC6yY5utGM3xfcQ0XN1zBEHZr895ELlapjCaAIXaGae+rta1Sflige5
8l6ONod20RZ/x/9wsngCZlXrKbgrnxz+JPQVTOjE99TaoICzaIK0cYp0Ulfh
dHysMaOvKG6AeHWw/K1SzQeU9i/1um/n4cDSaAfpxyYcT15CJOIMoeOUK7h+
XSAjYB6mFsQWJbAWCEYoDAQRA5Z/oejx9OfhixgSsrYYHH+ttscbK7A5/A18
w4zCwBRonQM83mjHCvKk1zsgGafGCHnBS93E7dbXMXldw8HwErsdFWZjTznD
SsRDKIQ6UEFyaqoMnA9X65nlMB3/93r1x+XKDdMlvZx4Xe2t9a9fJSt/vbBq
UQLTSNoMdOWN78if2Ik/qTO/k50NQjB0tdrJ2nR35PV04nEIJnJR2QT1EBQZ
xKXYjqNhjHTeeOniSdIVU2WrzUwR98fBONjJFBXNFcJu5KvXhir6u/EflEM7
4nvVhMLYWtjX82z/vsD2B1IOMwexJtyaCCyG/RLXO1CT5EhAZFAgay5yJwEu
YC57YK7VgF3QatgIB+YQSBdDw+GP83QnkpRHE5T+nnxfDz4iLx93/qZQ2Wu5
yusZiosp8h6OvIZR4t1hko3TxI0TRCO9rcWv314Wz8GsaiXZy9sEevBCuvEj
e5pKYKkDAMFQDInqI5w5Qlw/SjxnjGTxREiKJnYRTukGSVE3R15EH1F0P9Gl
TBWUwArUbxarswZJcg2Sj2vgjPortgXRFjqFGvHVvRYfs2x2gGOZnThl2uuE
t7qb+Avso3uKuOKXO8dfHlzxi6RSeKCD7Tls2xy+2LSKzaBY8uI6iz59RuYU
Zmw3wghG78JNjE9M7Ub0RgcwOmPbgUSG3iIa/dPOOTOnnZjjjsxhB2afPVmB
yqzT44No8J//Fg/Cv44HMaz89Qtk8QTMqtbT9C78UHz4gyJPX2eewYtfO1I8
f7xk6STp6umyLWFggYjiTOwAcR/c6+LjISgcKi0bIaUz1JB7oKxjI44nu51g
5CFcCWHkrCvbgsiWwDzZEhhMgbVthmDvm1GYmbAtvDOe+TLbw2UOX8biVwv+
uokNgl4x82hFIIZHVqlk2I4Bw1xrHZCM2wnJDXqNA8Y3d2KvgbGrOXldwGUv
Gma+oPKF4Oswto19yYGaJqemyMAdGvbyQPPhlzUqHzce+n0uHifuamflr18l
K3+9sGpRAkO32+lsxnbgj+sIG8EIhU3pwh/kyevqwEMIRgr3TkqAMh83PkKw
QoxgFcPE1Ajx3PHSRZOwKSLnyLEzSrE3FnoRSSHsXIbqUpa6MUje15V/p0jz
RomGUBiphX1cBwaJf5ul/xKPhnEgZgtOicswi6Esa6UdsNgqe2q8nJogZ6Hs
uSLA1YSf0oj7DJdBqyGdoaLTVejnH9RWEOAFrQh+mLx2R8l3RMgfFqtez1fe
zlZcTVe8nCw/FQ/l9ZfCpZunS1ZOFC0aYy1+tYosnoNZ1RpCOAB9Pp35QV35
YT34M3oJYvsIEvqxCIa+VDpYVDlUXD1CXIcRDCVFTdOkG0JgNGPmKElYb9GM
vuxmdpQdpfqJ++PjkafV2k9qdWwJjG1BxFf6GnzesgkXvndAysTNfxHzDeAv
dm/FeXP+8uD4y5PjL9xN9IBrKHrC9RSZZVO4g0jXbLjjWfhqgWDN+Yu0IGJH
MvAuY63M+kGXEXQEwf4dbEFPOzOnnJijjsxBsICmKzF/rdHj/cuan2apv6hW
vlesIIMYVv76BbJ4AmZVK+ncK2sQf4V0gxIYijyOijaRvYUUDE1IFk2UEhcO
9P/9IwmKc2nK67mq14s126OUBUOkJcOlgd5sm6Kho5CaoqCmKwxdRYZuInD3
Ou0Ka24umpXAyBQY6UI0Itg7zSnMTHD8S+DrneZ7uB5whvBvGuHLg4x9sfx1
AzPXNVeY0kK66ko32tMr7alEdi88MdCAYa5VOIzcdGfrXGypCwTf/SrGrstG
8nIF8jqDy17HcdvhIScCX8wOe7pMY+gogMmvZVD8OpUI2y42B0uvp8nOxEk7
29lY/I3+Q8vKXy+yfAIMfZxYBEM3tJI2o9rzx7TnP0thId3BjiOqj3BMRwFC
MGeljYsKQMxVbeOmthnkxTe05Q9vL0jzE7PjYMHyTVwv4v445ZFE5Ylk5Zk0
1ZIpst4u/Fdy1bcKNITC3ioHj/p3KHDn+BCXw4wg9vU8/d9xa+KPi2x/Iiy2
FHCMGitDghMqokYzkXuW29JZajoTRI2WGrwFJKIi7EJCNxAV7o9VfERp3q9Q
PylTPyhWvVGggrJXpuJSquJsovx4LLjNB3UTbAmSNE0ULxgtGuplLX61iiye
g1nVGiL8NakTfxrJgnryo3tDFyJCsPGd+Ch65AWISgaLyoeKUVKEEGzBeMny
yXAuvSlUtiNSvi9GcTRBcSZFeSFD2ThNluwr7ufGH4B7g+HYxEuA0qTykVI6
XY2udFwCw/XxDQ7NSmDgf4itUI+5sOt7CH9d5E6w/zV/vf3r+OuTdgS+6L2w
axU9iyz6MdlH+4hNi37u4WmO227YfMMVLMiM5odwFo0toLfh3mky/DVf812d
6i+Vyrfz5a+kSrs72BTnUBZ/0/9wsngCZlUrafWy1OldWf6K6gX/00fRBrfr
SBZOkDZOla4PgThzKA6CzNVs1R0yAjaTGwFbCoe3dKGGmiynpikMXUQIwUxX
bi8xFaemEtRUIl7Lvs6RXu9Ib3RiEcz86AZRGAExEDc9Sszh0QOwM6EZeZlm
tYhLBvEnREiFIAvRFhWvMvQSEcGP0RsK5bAsHt3fWwz1rGd11c0EXJfd4Luj
6HeBdBuakdcJTF6HYeaL2cfCF7PFji7SELdVA86gAjz5H5Qp38iVX0uVHZkB
oczib/QfWlb+epFlboRIWhD7OfNGtuM/S2HTugqCCYL1FozpAAiWOhBM6ad1
FwT3EPh78NGFGejF98A+HuRPBzteRzvelO7CaT1Ewb1Eob1Fs8bLIvuKejrz
EYVdzlZfywVrjtcKNfdKYFPYQ1wOM4LYx7W6T+t1f2nQfz4bs9hc/bfz9d8t
sD2Vpq4cJUM8dSZdfTZdXTVaRoTiAxH57ugBgZi2ykdIjycrjyYqP2/Q/rVO
WzhEUjBY8rRK826F+u1S9VtFqtcLVK/mKm9kKa+kK86nyE8lyI/EyPZGSKd3
E0zuImiaJF44RtQwXGiFr1aSxXMwq1pDhL/Gd+RP7gyuqqHd+TN6ChCCxfYR
9HYCL+hsP2Guv6jIICobImbPpSdIV0yRrg2SbQ6T7ZohPxCrOJaoOJuqvJih
eiUHytZvFGtQjvQepd0bqywaJi0dASfVxkve0EEI59UoX5oCKRM1XUHP1NO1
erpeDzspTrhQM1TgYHbODZfA3NkS2A18iP2qJ4xy3ONaiYxH2Y+f01BE73E2
+ErYmY4/t6P3wVpVImxupjP4SUDG/ap41yqVpyWLfsDr7IkXlaWhMjWQepHj
7jvY1uwmPt++7MKcJ1PwpuIXs8OO2WwLuVCuklmk/Wm2+quZqo/LlG/myC8l
SbvZW/nrl8jiCZhVraRViL+4+teodnDgg0JN1XBx/WjJAhxn1gXLtkXAOc/J
ZOWlTNXtfPX9Us27VdpP6nQo2YDeG9KCuMGB2eoI2LIPr7M5hmjFlV5oT8Wq
jAgGbX7NN3PBVT9AAvIxicrWIqEvUVlacvlTGVjpGlL+ZtW3+euQhVy9gbmo
GCW92JZeBIKOQRQlLkANi14K46J4oQaRGyuEWhddyWMAuF52BQPYhXYw5HUa
j8SeIDUvZ0xeuOwFa3ocmO1Q+aImyVDAge/uLaBTlN/Waz6jVE+KlXey5ReT
ZXvCxL6GvhZ/o//QsvLXCy6EFcYuxD5ONgTHhnu3pLBJnflTMYKF9YTVzOiS
JHvB0n1FWf7gSw/bmQeLy4eKqzhfxMwAcU6geEJX4aRuwqndhdN7iro48Lo6
wgl2Dyf+n37pH3/cNxjgJQhoCyodDmkY+vtYsgpL+dVs3ZezdZ/P0v2tQffX
eu1nddpParQfz9R+SGk+qNLkBEqyB4kflqjfLFLdzVfdzlFez1JeBvJSnE2S
H4+THYiS7Q6XbguB3GkVhq+EPgJ3dRuLv1P/q7J4DmZVK8l/oKGdzmZiR/7U
LvzgbvzwHvzInoKoXoJeTrx+Ljww4vAT5vjDVkGEYLWjJHPHwSDYyqmQGm0J
l++Okh+MU5xIUtJpymVTZX1c+TAIVqJ5u0LzPqX9cy1c4ChT+mGhLelCpHM1
dL4GhkMRgk1VGE+tzQ+u2ZSmp9jQC6u3mHTssINXJP/pL2HVIoMaKGlRwDLH
KxayEH/l6+i9LlDzIh4dH3qbZu3fM83a01scUdLVEr6g8xAlSy5s5yGZgt/r
wOwi+08xf2UpmXmav9epP6uC5sPXMmV0nBT9GNb+w18giydgVrWSVi1NJZV3
FHZGYv5CoaZsqLhmpGT+eOlyfM6zNVy+J1pxLFH5crrqeq76XhGKLdoPa3R/
m6X/fgF2A2vCI+ebHYC/XsLzpEcQs7iyXYgXiBe9B5zh3PbkauheUEO/70Vv
dqK3YG1lBcCVCSZC5uRFpWmoVDW9zgG0xp71JLzOla4uA08B68UooVZ1Fh/L
nHGGQS30N9kjjwU/4TkXKGm1EO3KPvEMXsDRQ0TP0wNzHUP/FtxqiLGLrtHR
1ToqSG7oLET6E+m9nCAztBdQo6XMfO13szR/mwlLUe/nK26ky0/ESMsNwjwq
2eJv9B9aVv6yyifAYEQwxF/GjsQWFDYRI1gQRjB0ecb0EcZzvvQZfqJsf7Cm
N58ImzOeXRC2cjprjbgVD4Wh5x6IUx5OUB5PgmXNdLrqfCaMhl3NgZXNt/LV
rxZq7hZpXi/R3C+FGbFHFdonldp3q7TvUdoPqrVPZ2p9PQV7YpUf1+r+3Exa
VjXajxBtVWs/oLTvV2nerdQ8qdA8Llc/KlU/KFH3d+OvD5G9lqe6ma28lqm8
lKY4l6I4nYjIS34oWvZShHR7qHRzkGRiZwGizkVjREOxM+TOo7TF36b/VVk8
B7OqlYT4C1077fU2xi7EsB78iJ6Cno4wvp3iA36qGb7CbD9hYSC0BtWNkswb
J1kySbpymgxdpCg7eikKGoQQgkX3F8X5iFGO9FohQTAti2CzmiEYzHvCIBi2
4tnqaBoEAyMOF3CQnmuLcid6oR29yJ5eYk8vs6dX2NMrHegmB3o1yn8cja1E
oM1c+rTNid7uRO9wonc607tAiMLYdsRn5utZkS99YEZe75qNezzwpDdh/rqH
4eu2Owx3XHMzwRfKr47jKfh9GL622YEF2Ro9NVZKjZL8OAssoJ+WKR/kK15J
lUXigGzxt/uPKIsnYFa1kpqWppBjn7Du/O4ONv1debB80B+3II6GEbCmabJN
YSjCKA7HQ5H9Srbq1QL1W6VQXv8Ul8D+sYgtgdHFWkMnIey+2YsXjB7FCHbG
DMGuebQsoyMKe4MFMSimc0IhxdBfYmo1RI+8i81/XvWAIHDTnSWvK67mthhU
lJKaoYSYcAr7Y5Ci1Ql8+yS+8xS2Zzzt0kynsE5icXUuQzcR3QAtAXStngpR
wErBLpi2MHZRU+V0mYYu5bajNuqpMVJqpOT72ZovatQfV6reLlK+li0/Gy/d
EyZBUd3KX79SVv6y6vzlq0FTxoUP75YT7BMXNMy8IxFTGH9EO6jgj27Pn9CJ
P6ULTEXZydsMb8cnvvSJuBCW5ivK9BPlBIjyA0XFg8VlQ8GdvmEsWCMumsRS
2Npg+YZQWFWzY4ZidzQsaz4YD52BJ5LBoINOA7P6i5ngV3/NxGKwO+xeMUyK
AY6VaR6Wawa487fNUD6u0D4GNNOYVIFRq0LzdrnmUZnmQSlsbn2zWP16ofpu
ASwSejUPupheyVJezlCeT1WcTVKcSJAfiZUfiALy2hEm3RIsWT9NsnoyVPzT
fQReGht3dRtr52GryuI5mFWtpEO76D5O4OrTQW9DuhBROhTanW8vbzO2Ax/F
jeQBQtaR3k9YEAjdQXWjJShiYC8O2YYQaBDaE604FK+I7CuK7i++lKUyRzCU
KX1cq/vrLH1zBMN2qc9DMMg9ZttiL0RX8DFr1ojowc2CmZ1jG3sRH7Rlx8Fw
OyK9wxmvYOaaEp+r94z+Ztygvfmsx5sw5QEp06vu4GB2vTl8nTKDr90m+GIa
ddRoCTVC8nWt+s8VyseFijtZ8pg+sKjRyl+/TBZPwKxqJemkbRAgkBGwbg42
pOCeieNM9QjJnLGSpZOla4JkW7kWxAsZuARWDIHl6UyIKn+fj0tgK+2piVBS
J0aI0IVIEOxkcwS7igthZJiUUNhdAmKe7DJ3LHqDo6GfGGOXJ4x3EfK6RcjL
/ecMCWH1c6QSF62cYErrCB7UOoJ1FHSqpiOKAGWhA0/O7gKFLaKjzvRsPT1L
j4CLClOg6GfsBCDYRU2X05VaukKL9/XYM1vwCo/1dsxaO7wdVc8s0VEjpRXD
JV/Uaj6uUr1Tonw9V3ExWXYwUrItSNxeZzXf+LWy8teLJkRbl6/fWDYzY+Wc
otq80LrCqPrShPry1Lqq7Foqr4YqGjw4IHZKM2t6ohHe/DEd+ONxL2KgJx8h
WDjuRYzpa1YI8zUWwkztiLPMKWwamAquD5FvCpdvi4RyGMqv9mObxCOJUBE7
maI8Y85iWWBc/0qu+gbBsQLIvvq58deFyu8VqYleb657CNnQwwrUr+bD8qAb
Oarr2aprWcormcplk2W9nHlnkxUnE+VH4+QHo+V7ImW7wqHmtSVEumG6ZM0U
SeNE8Zj20B7pqbFBuaIVvlpbFs/BrGolIf7SSNqM8Oa119vopW0GefCmdpZG
9le56uWj2vPj+oIXRxI5vUGpkW8zBFtihmAvRSu6OfLmjpehsACO9LkQB94o
gX3uLII16L+aC8Oh4NKzDFfBVuPGoY14Y+B2R2YXLGcH3jmIO4iOc+kT7QYL
VS+4mzIo4zk2obB7ZufYD7jh+rfxED0ZDXvCDdobZbzzMRbBrode7Ig9ma/H
h95ga9ZkD0bQV5pvPuWW75hXvpiVemYpSockKKh+VqV6twRW8PRx5kX2EpQG
Cq3DX79MFk/ArGoljRvdD4Ud4r/azd6mrzOPHPXkBoDnT+0o6EJcMVW2IVS2
O0pxJEFpLIHBFBgFU2BfztH/uBCOdMBveaKc2YwjiTmCkUZEGh/jXHRvZql6
iwOx1zCLcaLXOaKrnit4eZj2cDUjr+a2GMecqHAFEjDXIeyPcQCbwx8ggi2H
KYHds4b3LBjXu2RKv7Jgn6a0HkUhEKNI9zUSFaygZ0KHIewQrNIyO/CeeoRd
iLk223M7UsmCVFvY1APbUXU/zdeWD5cUD5F8XKV+p1R1v0B5LU1+Mlb6Uphk
wxSxtfj162Xlr/9vunj52pVXrv8mL3X09GVEWxsblwJtzS2uzQt7lraqq0uq
qPIKqqK0sqqovCq/lMouptCV66W1abGgmQglTuM68v08eLayNkHdBKE9YEFz
FKGw/i3bEcmOMEJhDWOlc3FHYjs9L2eQuIkrh20Ol2/HIIayrL0xigNxwGJH
CYslK0+nKM+mqc6lq85zOHYlS9Xbhb9imuwaoqocGMxvIXQ/eszlTOXFDOX5
NOXLqUo6RXEmWXEqSRHZRxTeW3gwRr4vSrYrQrY9TLo1RLopSLoekddUSa4/
JIHeOpu2WpvY3oICP8Hc+mqLfx7+52XxHMwqo145euXmiau/1avdOHG1u6t8
xiDX7On9CiICa/Mj6kri6stTPD1cwsb5QtDoI0AUZiyE5eAx0srmCAaNiBHy
Lg68+jFSFBPAjiMTXfjq2wXq10s0D8u1KFn6sEb3Wb3uizlwZA1dQ8vsmjsi
OmJHRMxfe51JLyKbPp0yo7CLzSmM1MJMR9nNGorgpQiOET0yCqPWQwxrD3Dt
zGRr5sl5muET7xvu4BS93B5vPuXOuk/goQyUYu1xYHbima8NCL7I8h0dg9Kh
YZLiweLdEbL+rjwEX4vGiveEScZ14Fv565fJ4gmYVea6+trW3+qlVi7O6uYs
jfZ3zJ3Wp397vW9nhyQcZLL8RfmDRHhKHVqd1wTBCc/+WMWJZOV5rgT2CJfA
/tKg/3ae7U9LbA3thXS+Bkrqm7l6OkEwOMlxNRXTL3DFdBJDrnNh5JZJ9GpY
zgV3Gj3hiTnhJbfnkBdxgz/iRIUpqFAFMNc+7I/xkgNYZLzkgCe2oIews61t
ZO8u8b7d0gb3yBnZs3BCn5Jp/ctCfU7XdD5Q2ZHZhf1gMXMZOgvpci1g1yZc
7SKbUtfiHalNZEGqnlmKt6PO1X7ToPH35O+Jkj8pAfh6NVtxIVl2OEq6PRhi
jpW/fr2s/PX/R4i8FpfEV84InJk4+tC+nf/t0wltbWpauqzmP6OtCpa20guq
knMq4zMrolPLwuKLp0cVTAzNadd5gBc2M3wWxEbiXkS9tE2AB4/4InIUJozt
K0wg2RShsAB2KIx0JFYME9ePkXjpeKl+4kWTpEunyBqnwr6wtcGwtXkTHhAD
FpvBshiKigfjoD3biGOnMJGhnwqlYUR0c6F7zqQoTycrTiYpjicqjiUojsTJ
D8XKEXPtj4bWx53hsm1hUO3aGAzYtXaqBEXjXH9RO70NIS/0mKheglxfwZal
My3+kXgRZPEczCqk60evLM2NLg/3q44buW5W2S94BURbr569fmjt6tV1Bevm
VtbmRxLaqqvMrKvKraEKZ1aXUFRZJVVRVlXpH2iA6nkv1hExHrcxp/uKCIKV
snYcUjILti4Yiua7oiAgoFCAIgDKlK5mg3vq3WLNW2WaJ1XaD2bqPqmDwfmv
55FeRDtTLyJXCANo2uWEfel/nsIuuJs6EluA2GumtiJ4KdKgSKDMXFyvEQDX
s41GxuPuy26GXiIa/ZxG8jrWbPMOsxkMN5jVetIIBCPwDRoUSNG3HuDGWz1V
cj5RdiRKummqeJQ3z+Kfnz+oLJ6AWYV04vKm+fmTS4MHUDHDalLG33q4/799
hXNXN115dcueHVWNsxNXL8qqK4isK46pL0uqr8yoq8oZYvCNjQlLwF06Gb5g
F1ZkEKEIs2AChBeYAotWHE5QnklVXs5S3cYlsHeqoLD++WyoqhvaCekcDQyW
bsD19BYIdqxFMZ07ySEgdo1dvEVEr7THRvFm2HXRjTgTcuRl5klI+gwPOiH4
okIUiLzoai1NaU0WGZ2F1DT5vDDbbnYuwz3aT/DuENytc1S/rkn+3TOG9sgb
3bNoUt/S6QOgL5HqBIs5NtlD4CLMtQ5j1xq8KXUl2ZGK4oyeWaT7ab7uuzna
L+s1n80EtxAEX28WwF7US6nyE7GyvRGSokFCb621+fA3kJW//j/o4pVrS0oT
qqIHz0weX5c5vT4nvKEg+vrdt/7FUxBtXbh8dTPQViZLW0WIthL/LW1lINrK
5WgroXh6NNDWmGmZQ8Yl+w+L9Q2IMBjCfTr2U0hUxIiD8Be6DDWSNuT2CG8w
FNJK2/i48sZ3hImw6d1Ya0SgsD7PUJi/KHcQzIUVGcQlQ8TuGpvY/iIEYnPG
SedPgL7EpZNlK6ZCayJhsfUh8o2h8s0mHJPvxm2K+zCRHYgFBw/EZYeeK3iA
fH+MfG+0fE+UfPcM+a5I2Y4I2dZQWcIg14AuLigWzQnxKhgkGt9J0F4P/652
OiCv5P6CuuGiwV68QR48BF+blljh63eSxXOwF1yXD15elh9bERlQHT+yNn1K
fXZoQ37UqZcO/Otn/Ve0VVxRVVBG5ZRQmYVVqXlViVkVvfoPQpdeNwcYLwUK
w4WwZOynmuOPzVQ5BEPxAQUH9GCUJu2IlO+NURyOh6MYOl0F42B5sMDizVI4
smYLYQ36L+bovyWFsKV4G2CTPTHlgNxjK9eO2ILCjrtCEnXalTnrxs6FXXQ3
nWZfa36afZuMbmEie44wapH+olseP3vWfQ57Qc+3ZTfvEPLa48DscmC22TOb
7Jh1tkyTnlmuQxkRnaw8kaDw94C+6Ew/0e1M+YUk2bFo6c4QycoJImvx6xfL
4gnYCy4gr8JpiLyq40bUpE6qywquz41cv7LiXz8LaOs1TFtzElcvzm5BW7VU
wczqYqq6tJIqL6+qLKmsKiynfAMMvZ14CMHSBgpRQlIYKKJGSGbjKbC1nBH9
sSTluXSord8pgsL6+9WwAefLOfpAbwGdqYHDHCOCkRjSrJjuYjrGIQHkAmYr
oxU8Xr9FL7M39BLjDVwcdp1zZc0JCXkd48jLzJmQClawQ1uYvOhSDV2igQLW
JraM1RTp3MfRq7+Tt8Gt3SjP9pM7dAzr2TnWp1tKYPfsEaa+xDVpPX26ukKp
a7U5dtli7NIzC3Q/zgPy+nqW9m+1mj9Xq3MDxVkB4jfylbeyFFfS5KfjZbUj
xJ3tbFDiZC1+/Say8pdldf7iVUReJPOpywpBmU9DYVxDcVJDadrapiXGh7G0
tWrZf0FbZSxtpXC0FZ5QHBRdOCksF9HW0HHJAcPjfAdFGAZHREcURAVnHD17
4+jpK+TbLZ1bbfSiNwrdY2Qx9EcraaOTthnoyiMLwiZ3xi7TmMIizSiMdCSm
c+4ceYNEfh58f08+6UusGSVBIDYbD4gtQCw2UbpkMoyJNU6VNU2TrUY4FiRb
FwJN2ij72oIULq8YLulsz9uO0CwC8jGTIkDozm3hsq1hss2hsg3B0vVB0nVI
06UhvRxbxKKIYV3CA93njhbPHiWqHS6ihggRefm78zJ8BA111rbD308Wz8Fe
WN06eQ2RFxTck8fVZUytz41oKIhtKE5sKEmtL80wfyShrcbKdERbM/Miawv+
PW3lmtFWTFpZRFJJcEzh5Ii8cUFZwyemBo5KmNDLqYu9jZ28DQomPRx5PR15
MX0EyQMgVmT7s/ssakZCjrRwIvirr5oOVfKtEXAacyAOXKPPpKou4F7EW7gQ
dr9M87gSsqaPa6F36Mu5+r8vsP3nYlM7IkAT8eUgGdROTGEoidrvzBx0YY+y
T5iBGDnQPs8VxczOtKF1cKUDQFlLcaj1Cj76Rg8mm0+NB90k3TrtAmP1EUoY
6zCu3dkFa3dgHGM9az5GZ4L3fmBbQYAnH4XNXRGyDD8RolQCX3vCJOumiEda
i1+/QhZPwF5YnX8FkdfUquihMxNGc8EnuqEooaEkpb40/dbjY8ZHsrS1s2rl
nKT/kLbySqmsIiotvyoppzIuo3xGcmm33v7dvGH7sJPSZoAb39edj8ILTIHB
LmYILDtnyFFUASOOTDjVMXYhftagR8/6kXQ1r2RPcowtzewxzkFMYce4wdLT
BMQ4FnvZJHqxnaGniLWFP+vKYtdJF67gBXu4wJywTm/oKkQi2AWW9dPAmRBo
CwWHdXZs6cpM6DFNYY5Jvu59HNv6ungPdW8/1qv9tC6dIvt0SfDtlj64R84o
s77E4o4H89oT7Pppgf7H+brv5uq+ma39skH7eZ3205map1Xqd8rUmf7iNF/R
zSzFskkSlNF1deAh+MrxFYzw5ln88/O/ISt/WUprFy+sihtZjYJP+pT63HCc
+QB21Zdl1pXn1Jbn1ZTnN86raGJpKxrTVlpdVdbP0VYOR1sJLG2VENoaOz1z
6PiUgBHxfoGRAwcGR0cWRgWnA22dufIvfrywCYN/bgSMyFtno5UCghEc00vb
6GVt0OWJNNiLP6QtP6wHS2Hx/YWJA4TJMGUvyvAVTe0mcFHZIBArIBUx3Jo4
c6SkFrPYrLFQFzPh2CTpssmwLZEQGcrB8g3iDna8NUEypLXPaNVUad4gMdK4
ToL2tjxS4QITbI1u+s/EorKJHtmj3UO6CVxVbcZ35NfXWuHrd5XFc7AXUJi8
Yqi4EbVpkyH45EfhzAewq74sq7Y8t7Y8f1VDxeq6Qo624v9T2spGtFUeiWgr
tmgKpq0Rk9ICRyX6D4n2DQgb2NXXp12vXi5qFC7IiQ0xRezmwOvuAIseHBU2
fV14k7oIyJhGMfbwQWEBfQmFgsZpUB/fHCbfMQP6kw8nQCHsHC6EvZKrvl0A
RqlvlWlJO+Kf68DEjPhyEAoD/iK1MNKRiJIoMEh0YsthRhBjK2JcayLJpow4
honM0EtML7Vvdr5tWniKD7cvYHB72bVlrnXCBW/ecWYOOUUN0Qd0cz0+sxOz
E9e8EHltsKML1HSu2tAOb5NvKxjkxT8UK/+oUgVdQPnQen0+SXY0Wro7TLJp
mnj5eGvx61fJ4gnYC6gL1zctKJwC5JU0ri4zqCF/hhG7UPDByU/+mrXzoJNw
cTYkP81oKx/RVnV1adUztJVuRluh8cXTogomhOSMnpIxeEyS/9CYLt2HkW5n
lBj0d+UNdINSsrvGZlh7QYa/eHWQbHO4fHc01NZPpygvZqlu5sN46duV2qc1
OvTIr+fqWQRr5Fqajfaq2NvHRGFHyTEOBrFTXADhRM+3M/QQscx1ArCLWBSa
+xMCeXUR0pSWrtSCS8ZWe1goP0kG2LXGFvwxyKAW0QoQnQMRg1luS9QU7NjH
0bOvk3eAa7sRHu0ntIO+xOh+XZMCumcO7ZE3BvclBkFf4tHcDhcz7RF2/bVO
eyAWWoz2RCl2RsozA8T98a+ojwuPnI+F9RSUGURNE0WLxoisxa/fSlb++v21
ffXS8jDfmpQJ9TlhkPkUJ2LsQpEH0p6a8oLq8iKqvLiqrKSmMvc/pa1ETFvh
iLayho1PGYRoyzBjoG9I9IyiqJCMObOWHj1z9ejpy//Vz+kTYCA9h8/lr+He
sEQVIdiY9vxxHfi+bjw/d15HW5tOdja2sjZ2MpbL7OVtkHo68no68Xo58Xo7
85yUNs5KmyldBQjEpncXBPUQ5AeCX2IRHhOrGg4GywTHEgaIEn1EyUgDxam+
4jQ/0KiOAm89b3RHwcgOglEd0G0bonYcapH/RF9K8xUh4ps/Vjy6vbMxFk1s
1yHkubEoxGear9vwYaMt/vF40WTxHOyF0o3jVxuLk2YmjqnLnN6QF9lQlIgz
H9OZz8zyQhJ8qPLC/4S2YtMRbZWGINqKzBsfnD1ycrphdKLf4Ci/gPD4iJLY
6TmLq5tqi2cbPCXmoQNdp+PN6uZAYXiMdLg3H0UJFCLQA1xUNr7ufH8PfkRv
OAGeM47dJ2gqhEVDIQxPhIFd6uVsWFrxaiGsDnxQ3ozCvpyrP5GmDvQWQEci
mQsDdw4HOMreyJ1mtwCxAwiRcEJ1xIhjXE512hXWmC6ww1zWXGewINdyMcuy
XNi2osPOuNqFvoXj0SLvZifSFR1zJ3ka2gsIedGpypNJyi/rNJ9Q6vfLVQ+L
lPdyFdczoA3JCF8rJ4iGelmLX79KFk/AXijRVzctKplWGTWYLXgVxjcUJ9WX
mc58UPBByQ8KPjj5yfs52srGtJWMaSsqpdQ4tD56asaQsWSMIjwwMNynQz+f
tl2Gt1P3cRKDXXMP3JnTW5AIRXYwQgzrJRziLWir45HMoZM9r4sDL7yPKKqf
OM5HvCpY/kYJlNTRl/6CHVZhsJS0NJPoscF4hmPW0ryfgJgzGzcwjtGzbYmo
CKWhuwjUDQS0hbGLCsH+hJQOjmJ2cM6EYEsI1S5qgowaL4N2QaM/xhKsxViL
9HS6CgUNZqH+p4V6Ok11Nk1VOVLqpFA4KdR9HL0GOENf4mjP9lM6dgzr2SXW
p1tqs16gARHDugzs5jrQg+/jzh/gxkfkleIr6uPCj+svWjhecjxOdjBKti1E
smayeOk40RAva/HrN5OVv35PIfKi4kdA5sNiVzqJPObMVVlWWlZaWlpSVlJc
VlxSXmykrUJMW1lAWxGItmIKJ4fD8fKwCamDRiYAbfmFREcVR4Vkzpnd+Ato
67nKKWG9EH+uCqaVtOnvwiMLmlFCNaETf5J5TtVNMLQtf1hbfncHHmkxAgRz
4pE2ACJnJctNz/5x1/xfe+cBXoV13u+gO7UnYPYQEpos7b3QnkiA0F5oDySQ
0ATEngJjjDFgvG2GjY0XNoltkTjG2LFTx3GcNLtp0qRN/71NmjRN27T/851z
70VIskMam3Ph/L7nffRIcCVdre/5vWfaMeYLPOwWcOhkeA+7lEW6lT5EA3e0
RkK/P8u4L5PYm2Hcw0g37k437koz7kwzsF5UutQzZIY360VJll5UtiywbkIv
un+45fzTD0n/VVEH6RlMET64cv3BwdZdLfnm5NPfwqfaN+40xx7WfPq2DvYP
WZtP72A/s60hblu921rJtraabauut6iiW9hWUlZjTHJ1VExJfeVg7dquoztO
Xn3h3auXro377JVZSWP7hrs97R4VTWOchbGMVBNCS5fzA3QRc7RR87Rz3OzM
g9U+urTFukw/XVeC8aFiWpN8toIuCHtxvcurjXSH4EQL+/E284rEF+pdY711
vx+Z+scjU/90dBoNZT8wmYg9ZVmaKALVRa5jz1uM7EWzlJmvErPkK+KyhVfE
OiL+yJcswvU8v4PsWZbTZog7d4KmT60On2RE+svdi9/ZMP03u91/vd3t51vc
ftTn+kk3bX6/3upUHaIvW6a7UELydarAOJKBya+/FukBTBGYeR0bWrejIWtP
5zqxw4I1nz1DnWMHnEXzGWTNp3+wr4+9sfWGbYkjwqy2JTatF1k2rceXJyaW
11Q1V5fWXLl+7sq1J8QnbS8NpxObfTSs1UxznLJuia6UK1htKG1Ob4+m3RD9
ScY9mbTC+cRqx95k+y1p9sXLDaRg4cYVs7XWKBK1QBezUBfnrYtfpEv00RO+
+sTFHD99oj+HNmcZEgM5QTcu2zJLVvAN5xrdTdcfj+70op5wccb/PmM5n/CG
dk3ns13m0+Dp1vUsB9Kuo/x8jMOe/z1Ce7X+85DnHw96XmlyiffWWT9XHHue
C3UDKx36OX0p9kfzp4fNXMjCT8xsn5R5vjkLfSdfC7Qu8myzz+k67/c7Xd5p
c64JM1SG6F+pcXyu3OF8icMjq40n8gz70vSY/PocgX/dHs4/8sCOxuw9naV7
e+v3DLTtHupiscfadrYM3sg8PZsHu3sGN3YPdm0abO8aoq0TDeO3TsQkVUXH
ltQw2yrpPLD/wc/Ltj6Nz7Yw9l/iduasxTQRJgJVQYC2MFC7Oki7Ntg8sl3G
94VVrqA1AOxd6kLNh5418pM6miPNN7G2R9Mh8BtiaJNsVywdVbQpjlYi9SfR
qWhD/PiOyhX6rSuN2ywMc7anilcM21IMWzlbkg1DjCRD/AJt3HxNb7y+J05f
FOhu7UUr5/vmeC9mvaiS9aKY8b3o4tkzTz4BEfvCkZ7B7no+fP2908OdtNRn
cy3Trt2DnXyqq0cMNW/hmWeAZ57NvPls6h7cuGmwc+NgvVjMw2yrsjtvXWdG
YXtSNi3miYotra8cqlu78eiOU5Pa1kReujA6toGEzLTzsJ8i+sZEC2O9oipE
V8fPK2uNoiOjWccoWaZnf8gJC7UrfWkGXIQNv2mawiX61UsNLDXtyXbcn+to
tTDrisTvDXr8aKvH+WqX6AW6f9rDp8P4AR1mETs2RsTE0kSriz1p0bFzFiN7
xixlLGKZ49Nz3K2EXlm5SA8b3U4D2ozh1c7WI8sojPlRZlvg5pm58FNHgY7X
LT3XvOi7PS4fdjm/2+b8tSanL9c5si66Jlj3GA9CTL561iZL/9W605EewO56
3v7gifu3le5qKeBjzqRd1gFnMdpsHfDpZeGHNx+WfLo2DrZsYLZlOSJszKb1
mISKyMi1NdUt1aXVY21rIm9ef0h0m4jZtCZnTbBWKFj5Muotzfws+p4Eug5s
f7b9UX7bxWMltLb5Uq3za410ws87ndRD2N/s01Uuz9S6XKp3eaXR9UqL2+tt
bqMd7qNd7qMb3Ue73Uc3e4z2eYwOeIwOeo5u8Rzd6jm6jf3he1nbhZXRHV6s
ddA4zDMzzMfCm+/huufGJVziNPgxZxIOZzoMZzj8j+V8jN/v87hc78IkK3Yh
RalY5oYLdJuT7f9ppwfjH3cQv+L8w3b3nw+7//0297/b6v7Kes+Zzq4hMxaG
zlwUP8cnfYFvvu/idUsCJh0FOlXjPc3D5cUqx2fKHM6us3+kyP7BfOOhDENv
Vbj036i7CfjXF82zj5/c2Zy3t6eWaRfrPDuo7fRt4T2nl/ecbkvPYYGno3Ow
bcNAa/tAc1t/U2t/Y0t/QgYt5omOK62p7q8q6Tqw/+TlN979Qm1rUs5fHo2M
S7SegiiORhSwN7097MSh9J82EbbW0vqEhd3jPCXDV1sTQkdPjxcxfklH6zgX
i9F3xeo3xpKLsefQHUfnFwl6OX2JHP46/Xu8oYfbVnecfi1t7LLrjNa3R+na
InUtETr23PjUPPWiMNaL5ope5Cd6URPrRStv6kXPnj0zev2DT/vOvPetj1+8
dP7SpfMXnz8n/ZftTkR6BruL+Wj0gzO7e/dsqiDtojGfnuGhvi2DJFzMthg9
NzefdtZ8OgZa2nnzae3PKmxltsUX85TWFXfXFrZcffH9W7GtSenrGrYqmPV4
n7RFmokWxv5mWa+oXEEj1Q38guZZrnZMPbr5lYKD/D7B/dkOh/MdOuKNuYH6
/CA9s7CAe2j5kHUceNks7fLZ2hWztY3RxuZY+/B52oh5urNVLhdqXC7yKPVS
g+tvDnj9/tDU/zjMD0u8b8yk2Em+y8OqY49yI3v8HnPEGvJM9NcPFzmzrMVe
CoRhWSWLPEuMivvphwucRntZSHMfe9pzQ+TcWxkFerjW+2j5wperHS+W0yEk
jxTRnq+RTENpRhJTWvZd/fjtj187d/6Vs+efe+Ks9N+3Ow7pAewu5u1vPnFi
V83uDcV7exu4dtGAs5jk6u8zj/Zssgw1b+ii5tNGzWegiYefNWWd5k3r0cU1
Na3VZTUjhwevXHvyyrXHb/05iG6Txhc8W9fklNDOdF19OI3tdMWx5GDcutJ4
gN92cWoNzapf4Cf8XGly+Wqb6/UuN/a+3xG3vW/3/NWEXaXmE1ZP89sGHzE3
CvPQzdN89OasZQzn3AzWMViLIOF6ijvXE1btGncJ11TzbNcRzz+NeG5NcxhK
tRfaFbuAZuViFmifq6FDoX+xzf3vt7p3JRg7E4w/HXL7yZDbjxmDbj8adPvh
oNsPBtz+tt/te31un/S6tcYYW2KMH3W77kibuj1tOgs/kbMWJc3zyVroW+jv
V7Z8klGgPaXBB9ctOFNkfzzPuD9dnzBfc3H09Nhv7wc/uPTyq0dfvHz0uZfv
lf77dicC//rieP7so7u7yph2UewZ7BOZh9kW6zZmz+oYEJLV0Ny3vqm3rrG3
tmFzTf3m6vU9lbU9lTXdFTXdUmzr0+jqH7Za2JcsV4NZz0UcG6VyFmut5yLS
RJhlo72wsCV8uz1Nh/EtsSRioULEdPVhusldjOtYURCd3bGBSZnFy8bD/4tZ
Wwd/FyZc7HkK5wqdpZnhPIXv8actaewLYVJ5YM/IgT33il6UzHtR0af0ovuH
Wy5MWJd4+uDgrpaCXW2rdrYXDncUDrateuzsU9J/THcW0jPYXcnHb33rkYPD
e/qadw1tJOfimadnM01siagjPIuaT0tffVOfaD61luZTwZvP6aPnr15653N8
VmMVjPUQ6zAOax3pN1vY6iDdOn6rYHWIvi5MP9PFriBQJ85Q7U4wiPsEycJy
yMKOFdLtFWeK6Q7BpytoX9ilWue9OY4H8xwPFzjWRNBujvooujkrbK5WiFjk
fF3U/BuLdm6xzCuOFuvNrzO3yncSCMMiyTrDxY3lsVPCtvjpiw+ITDWVZar/
OUIHjv3hoOdMZ+f7CmaYR6T5KFDBp48CrU+ZF7fY7b4cw/40/Xw3OyZfV546
u7M5f1crNZ/tHYVb2gsvPQUF+8uQHsDuSt796OnTI+17emp3D3ZuH9rMnItG
m3tpqKdz42B7p8WzePipZ+GnkYUfSj6MqjrWfKj/dG/u/kttayJiCaJYpTNm
TQ41lppQ83VgtAox2bg11Xgw1+HYKgfzWRxVzi+td7nCj/dZMVt7utjp4z5a
z/xTfsnFr/fQ1WC/P+T1xyNT/8dqYdY59DN83EYM2ggdszA64MGaxo2Ljx+2
ate4S7i8/nSYlhf+4YAn067+lfbCuaLna5lz/WyL20+5ZP1wwO37XK/IEDe7
Mj7ucf12j+tHnG91u364yfWbG10/6HL9RqdrfaRxfaThnQ6Xa+0uX29zeavV
ZTB5Kms+tzIKtK1g/saseWNXHn7wt88/dHjDrtaCXe2rdnQUbmsvPHakU/ov
3h0H/Otzh+nSCy88v6O3dai/t6dnYEMXRZ3GFmoyNes3s2xTXt1dWrmxpGLj
uvIuRnFZ19rSzjUlGxir120oKu5gFK5tX7WGkP7lTIRZGEM4F0O4mNAxbw+7
sNl2zMLERFiO300WZp0LS16omeY0RUyHlfNrWKtWWESMz4iNcTFdY7iuKZxc
jBE2mw79aOGLFYWaWWGSxWhmhJNtCeGa6Wx+bsy5ls+0C55O6xCEeY37og7s
OSx6Uewc6kW53ovXBvlXhvJelDz5usQHd/cN1+XsaMjjKahApKChtsInz0PB
/gKkZ7C7jO9c//7Dx45t6d+8efNA58YBplpNbf3rm/pqzdmmu6xq07jmc6P/
8ObD2k4hbz7vjH7/c396TMFEr5h4w0XaIq11AIc1jcJAnZgIq1iuE0f3iMss
hIX1JJhPRzRbWB5dXfFAkSOLT4+U0EUV5yqdL9Y4v1DncrmBjkl8s9WVfV6x
LvGDbro17Dv9dGT9D7fQSR0/G/b8xQ7aJsaS1f/b68XC1W9paszrDyNT/3h4
6n8doQkyClr3cYe6fxpdydrpTkd5jOV+fpnOMQ57JHs8y1FHvP77sNd/jnj9
xyHPfz/g+dt9nqY9Hv+8y+Mf+d2mf7eFctTezKnly+aw5hM1e1HyPF8+CuQ/
6ShQ75rwqOA5TL5efeyp4dqcHfW5O5vyaQiIp6Ct7YUvPHVO+m/gHYT0AHaX
8c0fvPDQiW3DfV0DfQObNg10dNJKHmZYtQ29ovmUV2+i8HOj+YwPP9R8ePh5
6MLDf/3zyc4Ms472xMzVFPibFayET6/XhdGxzKyfiDvfWSc5RArmKBTsQpXz
i3wWbNks7fEip/c30b1grGP8aKvHz7Z7/HKX5z9bLUzMhR2zTKCf4D51ig/C
iGl0C6M97omL9ebrt06KwZmbLuGyatfvzLNduhg+4bUp0f5CldNPBt1+0O/6
vV7X7zDP6nb91ibXD0mv6FjU9zpd3tvg8u4Gl+sdZq51uLzd7vJWm8vXWl2u
ttBj3mx2fqPJ+fVG5680OF9pcH6t3vnV9U7d8Z7d8dPEWqAEyyhQyZKAmnGj
QPwe5+cu7n7ro/Pvf/e5bTXZ29fn7mzMGzv+3Fef/eV3z0n/JbyDgH997px5
+Mn7H3r++CMvNjQNN7bsTIgrTUgoT0iqTEyqSkxmVPOXVckra5JTa1JSa1PS
alemiZd1RDqH/0tr1wHpX86nwRSGWVhpXpIYxBazYNapsS/xC8J8POmqPkYM
Px2xYIyIsQfQ1jCaEdOWLNGW8VXZFWKPGNMxMS+2gnTshpGF6lbMZJ9IUx+q
EzC/E4Twf2eSZZ3hEs8hfRENrTPd83Kckp2WNFG7xnFgz6EDe47QVYazqBdl
iF60dJJeNLAuYaA0Y0tF5k2NiKegLe2FT114WvoP6E5Bega7y3j4gUsPPfDi
yfsvtTTsTEgoo+aTUJFwc/Oh/sM6D28+KawLWftPOm9B/E3GF/QM9w8MW68R
nLirNJVf784sLNePtpGuDqK73Vcu0t7jPKUmVL/esilsrIUNptAKor1Z9gdz
6dKK+83TYY6P8Tvcz1fRYfUvrqcEwkTsjRbXr7a5fn0Dbe74xka6O4y52Md9
dInz94c8frTF46fbKF/9fIfnL3d6/uMuz3/aTUHrX/Z6mvZ5/YZ72b8doCuB
WO7695v5/UHid/QAz9/u9/zNPs9/3ev5L0zodnv8mgnXTo9fbnf/+Tb3n25x
/9GgGzPE8LlaFqL+ZqPLNza4vNPu/FaLc3/i1JAZC8QoUOp839xFYhQoaNwo
UH9xwkBJ+lB55tbqbLKwxrydzTdS0AuYBbtlpAewu4zTTz5w4vETxx9/sKm1
Jza6OCG+jJpPcqWl7VRbm08ybzvJY5tP2k3N5/gTJ//653Nx9LToMCyfeDpM
sa5wXhNMY7/V/JyfFn4js1XBWA+5bxUtRGTd4zzfC7ZkpvZIgSNdNUhbSt3E
JRf8qkGPX/K5MJPYUspFjK9kNo/S0JjMAzcx2uWe6MsPir/fOkpD2kVDNBbt
esWiXWK2i2lg5DztU2VOTLs+Zs610eWDTuoY75pnsuigjOoww5F8Oh62KtRg
pTLUUBFClIcYylYYgmdo9mXRFT8v1DhdqnZ6vsrpuSqni5WOz1Q4Xih3PFvq
2BblWeA/e5JRoKjglsSbRoH616UPlmVsrcq6MQTEJ8LEEqCvfvui9N/DOwX4
1+3h8uvXDuw5fGDf8QP7T1Staa5a2xrqmxLqkxLqlxYWmBkenE0szY1YXhAZ
UhgRsioytCgyrGjk/gvSn/mtMHY6zJqpWMfz9rBb5GnHLMxzzE1h1prqOEUQ
OM0uaDoRLLjHbglBaxSX3qO5x2mKFfZe4qUo+kdnYtkM9khaAJnKI5w49D5g
mp2Xwy1p10TYD6sqf531KkPqRQH+5dZelBW1sSClp2hlX3Eaa0RbKrOGa7Kp
ETXnixTEFOzcs2el/1zuCKRnsLueq5euXb30ztFt9x0dPnF0+6nawrZQn8SQ
RUlh/umh/unhQVnW5sM6T8QKc/O5/9CFL+4pvXRh1DpiM24/6djpsKzFNJG9
KpDyEnski0yVK3QTLUzsCxNXuoutYSN5DkcLHI4XOZ5cQ+sSWZR6utyJfYSL
Nc6X6ujisFcbXYSLXW2jS5yvdbqxcPX+JspXH/W6f4fpWL/795iRDbr/kEvZ
T7ZyLxum0PXz7XQk9T/sYOmL+BV/+csdHv9AG949fsEewB427PEzvu39J1vc
fzzk/sNBWin03T63jze7fkTO5doQaVgfYXi7zeWrzc5vNDq/tt7p5Vqn5yod
z5c6tEV5tER4iVGgRDEKtPimUaCu/OTuwpW9a1KFhd0YAuKz8CwFndgzIP23
7o5AegBTgSvXHh8Z6R05snXkyHB1SWX00oyQRYmUfPzTw4KyGOFLcsKX5fHm
UxAZWij6z+f12a0Kxv5mxV05eXxgx6pgDXwjmPnO92TzXjDWPR5cTTPpZyuc
xImIX2mm7WCsUbwvjlclC3MXwzU/t0yd/wsfovndQa8/jHj952Gv/z4y9U/3
Ev9jYbTNLXGRTsyJ/9dhrz8e8vqPgzQt/m/7PFlTirFo17NVpF0/GXL7Qb8b
066wOdozax2ZdpFztdFAzdVm5zebnEdyHZbO0CyZQV8a0ytG6XI9o4SzbhlR
zGEPCOTbYwOna8bFMP9pGj/GVM3iqXYMZ71ebI0PmTl+FKhBjAJlR21albJ5
depYC9vZYJ4Io4XQbYVQsFsE/iUX7mWHDuy978C++6vWNFStaQxZEBmyMCZk
YWxVcYf0p/cXIWbExGGJ1lglklUq7e+gk2CzLLvDFnuRHMXO08TN0/hPtWOI
u5sDLQgjYyR7a1I405ymMDtjH61kibaUz5qtC9YWB2nXBtGyxtWB2oT5mqn8
3rHIuMRJFxn+n346R8S6xLgxvaguLqwtM6EjJ2ljQXLP6lRhYVuZhdXlWFPQ
to7C81CwW0B6BlMW7mXXjm4dOTp87OjwA7UFDaHerPNEi/5zdOcjX/QTOLVz
O+sPXxqzn3SiiKX7aLP5qDX7005cqF3HFy2ThYWYLayFdoYaNvCzUsV0GBOx
LSvp1uYDYl2iRcTYp3iUL01kmYrFG3KxWtrlcbmBNnq83kxrFL/a7vp10jHa
d/8eN7IPut3+ptvtQ+Zlm92+3UszZZ/00dLB7zFB445mfqWflI0Z1id9bt/p
ZZ7l9u3Nbh/1uH3Y7frNTbQF4z32MTfwFUG0HMi5io9Ov1Ln9EI1jUKfK3V4
ap3DY2sdzqy2P7XK/ni+sT2KBSGXsJkLrKNA2Qt9Vwf418aEtmYkdGQnduYm
MQvbzCysNH1LRdZwDa2F3tVMA9EsBR3fNyT9F8z2kR7AVIa87FDPyOHBkcNb
qotLwnzjQxZEhXjHhSyMGzm693P8RNmZYWKjRNhszdhNppMrWBIp2P5sh3v5
he8Pr3MaSrVn5vJiHR2KyFrEWx3mqfO/6aGG8N0B9x8M0TVhPxv2+MUODxKx
3TRd/q/7PH+7n+bKf8cRk+OvNbnEeet+t988P86ci/Ufpl2snzDteqbK+Xyl
84/FWE0vbeb6kFqHS8hs7fFVDky7RpucX29wOphtL5wr6B7NznTa1nqBz2Gd
55wrdzxbRjxd5vhUKVEYrGc8WeL4aLHDI2sdHl7jcGaNw0OrHU4zihy642kH
XFesIctPu8jTrjVS3xROWz9Kgt1WB3hYrw/LWOC7io8CtaTHt2clbshNYhbW
Y7GwbdV8CKjpxvjzte8+J/0XzPaBf9kmtnPmxv8Nq4uNPTXRvEFsFu0Ry/TV
0OpET7ssXyZlGiFlueLsRHGCvThBUSxZDNAWBVAAi59PvuY31Y7pmx83ODGt
JoSLfbq/3rkmhR/TccTai2rio9cnxTSmxLJeREEoL7mnaGXvWm5hVbwR8Ymw
YSjYLSA9g4FxCC+7PZ+LKZjoDOIk1bEH+1gvaxbLESPnaNjf+6pA84rEUr5W
mU7n4GckNkWap8NYiGJxYnOieV0iiVim/f4cmhFb5KXZEG88UUQ3OJ8ppkuc
nyijeTGWeZ6ppjWKL9QxHXN+pd7lNT47xozsjRaX0VaaI/tau+tbQs1o4SJt
JbvOfKrT9V3OdSvsfze4XutwfbvD5evtLl9rc/lqq8so+zhNzl9ppA0Xl+uc
Xqql9T/sI7Cw9FSJw+PFDo8K7Sq0fyDfviNaz1IQ65ML3O2qV+ji5mtSve03
FBZYR4GKli6rS4xuSI5tTuNBKMcchAZK0reIISBaDkQLoU/s3yL9d8nGkR7A
wET+yjM3JvLm9YesmyOYgmXwg5pZ3hBHrTIFq2EKFjGZguU7sHaxOcnoP13D
usTztdQcxGbSGxbWTTPmn/TTdNgP+UQ5E7Gfb6fZ8F+JBcycXxO0Dpk9jUt1
dBcGQacAaflUF61J/tt+t096aWMX7eoaM9vF3kVoV7BFu4ZTjedKqXsMJBv9
pmnGWxXnVBGRG6BjnCxyYDxYyLA/scr+AUaB/fEC+/vz7e/Ls783x3g428h6
zr50w+5Uw44UQ1+cvjNK11ZKp82PHNosruyJnu1TuGRZbUJ0fTILP3FiFKgr
P6W7aCWzsKHyTFoFxCfCdravgoLdCvAvcHtgZmSVMuFlgs84bUysWmR4OEyx
Pl54llAtwe38Kg7sORw737ckLKw8KqIiOrImjvWiWCZifDosceOqFGZhQ+UZ
21gj4hNhLAVduAgF+yykZzAgl7EKZr3SwpqXrNdbsNTE/iXn5mPqx06H1YWZ
D6tvjTZYRYylqd4k89LEBR529ZGGA9zF7i2gs85O8Hmxh9Y6PryOrv55gu8X
o9mxSqdnq+h45+eZlNXSNvyXycucLze4vNrgciDXcclM7ZVGF8aXOfx1vqWd
82q98yvrnV+uc36x1umFGqfnq50uVjk9U+F0rtzx6VLHx4odCgJ1+YG6h1go
YnGowL4zxpC5mAafhXvWhtAG2P54ffRczdq0pG9cviq+UTRTufVIfvCysojw
iqiI6rio9UkxrP808xFpWhHNLKyUVgRtr8/lKajw5AEo2GchPYCB28Pxo81i
CSJrKR72U8S2iBw/WttcvISOQxRXXYjbBvl9ozR0sy+bNlUdLzRPnT9d7vRs
NY3SmC2shYZlrnW6Wo70oemwT26sW3b/8Rb3n2x1P1flzIicr2WIYBM5T3u2
wvnpcucfWA4w/I5lWfL7neaNXW+10iLDNxqdrtTTWE0wXzq4baXxbKnDk+sc
WA95hNtWrr8ux1/HlIpkqsD+WD5xnyCPYO97NM+ecS8j1/4II8f+cI5xJNt4
KNt4MMu4P8NYH6ZjvXHHSsO2ZP1gor4nVt8eqSvMCRv7DRw51D1yqDd1cWBp
eHh5ZERlTGRtPIkYjQLxIWizhVVkmoeA2lYNtxeeemyP9B+9LQP/ArZDU1Hp
6qikqjV1tQ29pU190p/PpLx+9Rv5QcsLl64oWhZSHBLGslA5z0L1STHNqXEd
2RSEuIVlbq/N2dmcv7N9Fa4G+wykZzBgC+wfGB53HKL1VB/rYR2sxJE+TEzy
LJe8FwXROqJSflj9WBFriryxNLErjlxsrptd6XK9cLGdGbQVfX+2/aFcWqMo
dIwFLWFkp9fSBNkj6xwfLXF8XHgZnyk7W+50rsJpW5p9wD0a5mhWzleYOccf
c7bM8akyxydL2fs6PrbO8QwfmhYj0g8W0uCzj5dd1mIdC4FW50rx1jLtYvln
IFG/OU7fFa0Ln63p6xqe+I3KC1y2Knh50bIVa0NCS8LDyiIjqmKj6hKjG1fS
KFBXfrKwsG012bQWum3VKSjYpyM9gIHbRntp+Ngbc7x5V/F0mOJPmx00aT7a
Gq5grGlsiKF20ccULIVO9WEtwsdLszHByHoCawWsAzzLb7hgFnalkabIr7a5
HityPL7a8cE1TifXOjVGG0PnaMPmmm0rfK6W8Vip06OlTp/08rPixfrkHrdv
Mefa5PrBRtdvdNKJhW+3uXzNvMjQmWnXK7VOezLsg/idhuyZPMHXJz+82v50
kf2DfALrGNcr5owtkTTulOarZV8Fg7U+xoEsY6qPlrE/08jYx8gw7s0w7kkn
dqcZd6UZmHNVr9DNd7crX6bri9d3x+o7o3V5ftoDB5sn/R6eOj5cEEzhZ/Xy
kOLQsPLI8MroSDEjRmuBcmhFNLOwrVVZO+pzd7UWbO8ofPr5Eek/epsF/gVs
hzvCv7785nupC4PSfYLTfZZk+y8VcYi1o3Vh1I6YiDUkx7ZmUBDavCaVWdiO
ekpBzz9/Xvozt02kZzBgI1iPpp94FodYiCgikzjPh73i5TDFz7J1NGGBZm0w
rUss4TcMilstakPpfLPGCD4pFqWPmKuNnKsVLtadYF6jyHRsOM1+R7r97kz7
vdzIDuY4jOQ6HMmj1Uf3cS+7n9TM4QSzJ2Znqx1zA/S5gfpTa2gd42n+8tRq
h5OcB4scjq/iFDjcz0ekO2JoMq49xpDBhcubC5c3z4Hrw+jew+EUw5Ykw0AC
3RfPtKs9Upfvr53hPGVS+WJsKKxJWxSc4ROctXhJbsCyVUtWsDhUHBJaFsFE
LHJ9Eo1IiyDELGy4NmdXS8G2ptzrb3xL+s/XBpEewMBt483rD427dpARMYfO
nWAKNm3MuV6zXOxmu9rNcbWb62Y3z90ueRHtz8rw02X50x++3zSN/3RNwHQ6
ziJohvk4iyUztUtnapfNImojjMeLHB9Y7fhel+s3BBtd32d0ESGztQ+ucRS7
Qd/puLEh9M0mOhb+tfWkXS9UOxUv1bNPEcA+1zRNQaBOaNdJs3YZ26L03nyV
sjDKBZxkb20SZ4E7rV62fjlMr5IWahM5VSt021IMW5MNW5INg4mGuPka9jUy
7doYo98QpWsK0y2fYTfukuWxHL93S9oiCj8ZPkty/JcxF2P9Z82K0JKw8Ioo
ErHGlXHtWYmbVqVwC8ve2Zi/s73w2ZeOSP/p2ybwL2A73BH+xYiZ4x87xz9+
LiMgaX5gyoKgNO/gTF9zHGLtqDSCi1hKbEd2Yk9R6lBF5s6m/BcuQcEmQXoG
AzbF2DuaJyKOVBU7OCJZdvKiM7uYhXk53ohPLErRWT3iANUZmnRfWruYtZih
m+Fs18CNrClCz5xITI1tjDOvVGRG1ptI6462pdpv51K2M8N+V4ZZzfZxOzuQ
bb/SR8fYz97MojebIg1W0nx1DG/uWd6WuS0BS0fMtmpCdCwFJSzQDiUZ+hP0
vfG02qcrmm6Kbw7XNYbpVsywi41KfOnC6Kd9fxrzqqzNJ3FuQPKCwFTvIKZj
Of5LC/hAUElYWGV0ZF1iTEtGwsaClMHSjB0NeTvaV737JhRsPNIDGLidMAWb
eO1gug8taS7kCxHLltFVpFl+ulx/HbOeomDd2qW62Pna+IU0mcX+tJmFdcYb
NyUae5OM/Sn2gyvtxXJlsVb5RVqaSMd0fKXJ5Y1ml9FW2v5JtNFWUMHyWdqj
BY6jLS5vNju/zp3rSr3z5fXmbaE70o0B/IjCwiBdX5LxjGWFoVW7rDPmdWFk
hUymmEkNMZlKMgwwEol+Eisto5+/XrqMvgQBsy3RJOdwwWSayQw0fDZd38PM
a1VO2GfIF+Mr154S4SdubkACDz+s+aQtCs7yW5oXSPNiNCkWFVEbH92cFr8h
N6mvOG1bTc7O1oLnX7lX+k/fBoF/AdvhTvGvqvzykBmLGaEzF4fNXBwxc3Hk
bL+o2dSXWFNKnh/IOlK2H8Uh5mIsCzERY0FoW032yZEh6U/e1pCewYANIixs
UhGjTfSz7MShHGIfvdgRVhBAm8KKApndaJIWaoKma4IZ95hvoxh7b8WX6IpA
u5kuZmZZ4YEkcq4mcq5WDIATbjQMLkbCBeO2qc53t7MiBpmrQ/QsxTG28HHm
IR6NWBDqS9DHzNNEz9VsjNF3Rus3RNE+C6Fd9aG6DB9N4cqkzzAvwdVL74bM
8KX+w5tPuLn5+InmkzSPElGm7xIWh5iLlUVGrE+K6chOHCzL3NFS8M2vfVv6
T9amkB7AwG3m+NHmcVNgjAwfOhRR3HNRwi98r+FXgzVH0gJmcc8g+0vfnk6L
lg+JSwb57lHLST6OdKpqOd83Wu0kNo2+VEebQC/X025Qxmsc9oq4jevlOueX
+OZQcRXXsxWOW1Ya/flsl9CuU4W0yPB4vn3WYho+ao3UWyfNt6+kCaw48inN
5niaN98Up++KuQHrXVFzNeL1TgHrNhY6ovSFAaSTBf7asFma0FlkXtGJoZ9t
XlbGNh8KP7Oo+cTM4cNB8wJWLhRjQcuYi5WEhVXHRbVlJvSuTdten/vSq0el
//RtDfgXsB3uFP+6/Pr1kBmLOD4342uB1Ey0pri5/qwp5QYuK40Ib8tKfGBP
v/Tnb1NIz2DAZmEWFhuVOFHEWIIKnUX3/aX7aMZaWJ44NJXvC1vNr6VYa77h
nRYlli2jEWO63n2FjkWaTD4plk0XuNNwNyPPX5cfoAubrQmfo1kVqCsM0hVZ
WB2kY9lMwD4ITZndQN8TbxhHNw9Fm2LNEUjEnojZNNTcEmF2roZQXV0IaRdz
w8+e8xpHbXbZZP3H2nx8WfMJn+UXOYuaT/L8QKZja1aE1ifHDpRnfvvtj6X/
WG0H6QEM3H7aS8PZn/C4tc0ZvIfk+9Pxquv4iRzVIbo6yz2DG2INc9zsSpbp
+pONO9JpNlzcbUGXDBbSTWGn1zo+XOz4WImj2CvKXOx8hdMzdIwPcZFDr1c6
DafbB07XnK8wHxQ/kELaxZ6P3zTN5gTjKX4+4XE6PcMojiUUs10L+LE822jR
IE2aR8/VMMkqYj0qUCcmsFYF6ASzXOzYS+ZrHN0NInSs87AvcKbLlJnOU+pD
detDdNXLtcHT7TYNN936d2/k0MBnNx9r+Ime7Z8wLyB1UVBB8PKK6Iju1amv
vIxZsJuAfwHb4U7xr7/jCnZgz70hMxaMYaGFG29W5ZeYKWCUMo7uP/7eh9+W
/vxtB+kZDNg+QsSs11iIRUTsFRacJrEwywUWYjpMiFgxF7FpTlNWemuZiIkN
YlXcxapX6Fi2qQsl1ofR3Te0RjFc3xROyxSbI2h7ewvPM21ReuZlLOG0R+kn
pU0QeQOWfJojdE3hutBZmpBZmnqLc4lZOaFdt25eVo5uHdd8Juk/tdklN8gp
ZdTnll88/oj0n6btID2AgdvPxdHTonuMu+2d9RDWPVjfKAykjsEsjDUHcS4i
+/MvDNIx5RF3W/QnGben0crkfVm0XfSIuGSQbxE9uZr2hJ7hOvYonapKh/AI
HltH9PMT43sTjYunknaxl93xxpNcu6ynwY9kGw9mGhvDdeLoIfY0hHatDaax
oFkuNJVPGsUJ4Y2FKRX9o+Wl+Ef25TSwbsan17MX065SRpavpmq5ln3J0xyn
/EXmZWXkUN+fbT7VRbljyGPUrs4/8+B26T99mwL+BWyHO8i/rFx+/Z3LbzCu
M6Q/mTsR6RkM3EEwERMuJtb+WXUszXLDO92v+ukilriAUkexeVJMS5Ni/LCO
CouOMRer4Tp2w8gs1PMkE8JX7LBo1GShUcD/10q9eK8Qsq3aFbrlM2iSSzgX
e9r/Z+0ax9VL71x94bpA+o/mTkR6AANSYN4x8aifdB8awyEF4xPoa6hL8Ost
aDmiriFCP8vFjllYp+Wq995Ew9ZUs4jRJYN0dI/9SK4907Gj+Q7HCugcnhOF
dCaPOJanK87I8PUi7fL1smMfR9zAdSzP/igdC288lGU8kGncm25YH6ZbwNcz
z3Ozi52n2RSrF9o1i09dsXdnz7OWN5YaTia/m4M1Geub7HXqOfzB1qXXS++x
K1tCPTAv68/s87oVrlx7wsKT0n+gdyjwL2A73In+Bf5KpGcwcIfC/GWsi4nL
fcQBHeGzaV/5pCLGHkYuxoe41/IFimN0TEs6ZjUyHr3M02RczRgs0rB4U2NJ
PuOopkdq0xdpUr01S+6xGytcn5dzgc8R6QEMyGKigtEqRB9ak3xDwYLoUI5S
viOM/e1n0RSSXSOfEG+L0ndE6ztjDF2xtAi5P8k4mEy3Ng+nGnemG3dnGPdm
0vk8TZGG5iiDN79pQtAabaCXUQbrDVwH+Mnwe9INu1INSQu1QrvYJ+2O1UfO
MZ+vyLQrezHN0DGZWmppLKLDiAeUUe8yI74c8V/sZfJCzVR+PFF0Yij7qv96
8wKfF/AvYDvAvxREegYDdwFiXkwYmZAyq5d52NMF7j78xlVfL1rPs9iLRpUZ
cfM1hWJqzGJkQsqKhZRxSoSacYKnU+AR8SbFW8PeFExznCIQn1F8dqtzSf/m
gE9DegADEmEmwpREWJg4kSOVptHpLA7rQsTVvBuU8DGZKj78ku2nbeArk8dY
mF5YWF+iYSDZWLlCn8g1aoHlZPj6cDrNg+7e4vBjNPTmG7hSDdtXGoZTDAkL
aGgodr5m3RJdV4x+VYBWrDNcMVOT6asRc1isw0zliD7DXgmYZjf2TfG6eOnn
Rfd05GSF3frZGuA2A/8CtgP8S0GkZzBwdyNmnYSXCaxxRdwj9heVl+MUq1sV
pCRZvQ9zW3ci0gMYkI6YCHO3nyJeLuQT6JFzNOJU1XEKxuyMKVgdrUbW5/rr
8v11BQG68Dl0GgZDtIi5bnax87Vly3XlK3RDyYatKYZtK43bVhro4i0O87h5
7nbi0Hj2McWZ8DHz6FjUjihdAT8iY4bzFLF68LOLudU42JcjJrngXLYP/AvY
DvAvBZGewYCCCGka+y9XL13LC1pekVtaW7uxsnnwxLGnxz1+4ruAOx3pAQzY
AkxYxELEkJnm2/o87P+8+4jjLGa62IXO1jALKwjUtUXp26NpRmxDjJgUo0NQ
N8cbNidYYK/H63vi9ezdi5foxA0Xq4N0G6J0bfzi9Zn8Yy6bYV5YKKauIFN3
K/AvYDs0FZXAv1RDegYDwPTn/AvclUgPYMBGmLgdLG2RRhypmjd2OxgtSNYx
OUr30dJZPSHmQ1MbwnT8TB7zcamtkXQaaodwsZspCtLNdjHPlK0K0Lby2yjY
p6AJL8verqkzZkO4VAD+BWwH+JeCSM9gAJjgX0oiPYABm8I6EWZVMDpP1XLD
uzhGVVgYs6TURVpxmWCN5QKL9aFWEaNbJwQtEbSksMCyn2umyxT2odgD2Ovs
weJY+Hv4YRpBs6dmphZUNw/07t8n/VsBbgPwL2A7dJTVwr9UQ3oGA8AE/1IS
6QEM2CDCwsSJHPxcerOF5YlDOQLorJ61QdppjlOCp9uVLdVOentFFr+RUKxR
FOQs1lrvpKCTDMds74pODA2fMbdkZV5NeSv8Sx3gX8B2gH8piPQMBoAJ/qUk
0gMYsE3EKRZfGnPDIL9bUDNuLixwml3QdLt1/HBUOj7RW2O9cuIeJ5rVSuf3
ElYt1zIql9HNFNYHsMrl93CJpYbpC/zgX6oB/wK2A/lXJPxLLaRnMABM8C8l
kR7AgI1jFTFRdJmFPZ2byvDiWP9L3ECRtFCTvFBD91ZYLrBgbwbxKyrGznZN
PFID/qUg8C9gO8C/FER6BgPAJPwrEP6lFtIDGLiDENK0a18To6IwLGI2HVMv
Dujw4xcLMh3zn2rHiJ+vYS+9LM5lvfj4M07VgH8pCPwL2A4dpfAv5ZCewQAw
wb+URHoAA3c0zKeYWDEdm/QSLuFct/ih4F8KAv8CtgPmvxREegYDwHTDv0rg
X+ogPYABIIB/KQj8C9gO7eRfifAvpZCewQAwTeJfT0l/SuCLRnoAA0AA/1IQ
+BewHeBfCiI9gwFggn8pifQABoAA/qUg8C9gO8C/FER6BgPABP9SEukBDAAB
/EtB4F/AdoB/KYj0DAaACf6lJNIDGAAC+JeCwL+A7dBeCv9SDukZDADTRP+6
D/519yM9gAEggH8pCPwL2A7wLwWRnsEAMMG/lER6AANAAP9SEPgXsB3aS2tu
+Fcj/EsJpGcwAEzwLyWRHsAAEMC/FAT+BWwH+JeCSM9gAJjM/rUM/qUU0gMY
AAL4l4LAv4DtAP9SEOkZDAAT/EtJpAcwAATwLwWBfwHb4d5998K/VEN6BgPA
BP9SEukBDAAB/EtB4F/AdoB/KYj0DAaACf6lJNIDGAAC+JeCwL+A7QD/UhDp
GQwAE/xLSaQHMAAEmT5B8C/VgH8B2wH+pSDSMxgApon+dfRJ6U8JfNFID2AA
COBfCgL/ArYD/EtBpGcwAEzwLyWRHsAAEMC/FAT+BWwH+JeCSM9gAJgm+NcD
8C8FkB7AABDAvxQE/gVsB/iXgkjPYACY4F9KIj2AASCAfykI/AvYDvAvBZGe
wQAwwb+URHoAA0Bws3/tlf58wG0A/gVsB/iXgkjPYACY4F9KIj2AASC4yb/2
wb+UAP4FbAf4l4JIz2AAmOBfSiI9gAEggH8pCPwL2A7wLwWRnsEAMMG/lER6
AANAAP9SEPgXsB3gXwoiPYMBYIJ/KYn0AAaAAP6lIPAvYDvAvxREegYDwAT/
UhLpAQwAAfxLQeBfwHaAfymI9AwGgAn+pSTSAxgAAviXgsC/gO0A/1IQ6RkM
ABP8S0mkBzAABORfKfAvtYB/AdsB/qUg0jMYACb4l5JID2AACOBfCgL/ArYD
/EtBpGcwAEzwLyWRHsAAEMC/FAT+BWwH+JeCSM9gAJgm+NfX3/hE+lMCXzTS
AxgAAviXgsC/gO0w1r9K4F9qID2DAWCCfymJ9AAGgCDTJxD+pRrwL2A7wL8U
RHoGA8AE/1IS6QEMAAH8S0HgX8B2gH8piPQMBoAJ/qUk0gMYAAL4l4LAv4Dt
AP9SEOkZDAAT/EtJpAcwAATwLwWBfwHbAf6lINIzGAAm+JeSSA9gAAjgXwoC
/wK2A/xLQaRnMABM8C8lkR7AABDAvxQE/gVsB/iXgkjPYACY4F9KIj2AASCA
fykI/AvYDvAvBZGewQAwTeJf35H+lMAXjfQABoAgcxH8SzngX8B2gH8piPQM
BoAJ/qUk0gMYAAL4l4LAv4DtAP9SEOkZDAAT1h8qifQABoAA/qUg8C9gO8C/
FER6BgPABP9SEukBDAAB/EtB4F/AdoB/KYj0DAaACesPlUR6AANAAP9SEPgX
sB3gXwoiPYMBYIJ/KYn0AAaAAP6lIPAvYDvAvxREegYDwAT/UhLpAQwAwVj/
2gz/UgP4F7Ad4F8KIj2DAWCCfymJ9AAGgAD+pSDwL2A7wL8URHoGA8AE/1IS
6QEMAAH8S0HgX8B2gH8piPQMBoAJ/qUk0gMYAAL4l4LAv4DtAP9SEOkZDAAT
/EtJpAcwAATwLwWBfwHbAf6lINIzGAAm4V8B8C+1kB7AABDAvxQE/gVsB/iX
gkjPYACY4F9KIj2AASCAfykI/AvYDvAvBZGewQAwwb+URHoAA0AA/1IQ+Bew
HeBfCiI9gwFgMvvXUviXUkgPYAAI4F8KAv8CtgP8S0GkZzAATPAvJZEewAAQ
wL8UBP4FbAf4l4JIz2AAmMb71wD8SwWkBzAABPAvBYF/AdsB/qUg0jMYACb4
l5JID2AACOBfCgL/ArYD/EtBpGcwAEzm+7+Ww7+UQnoAA0DA/SsX/qUU8C9g
O8C/FER6BgPABP9SEukBDACBxb/a4F/qAP8CtgP8S0GkZzAATPAvJZEewAAQ
wL8UBP4FbAfuXwnwL6WQnsEAMMG/lER6AANAkLkoAP6lGvAvYDvAvxREegYD
wGT2r2XwL6WQHsAAEMC/FAT+BWwH+JeCSM9gAJjgX0oiPYABIIB/KQj8C9gO
8C8FkZ7BADDBv5REegADQAD/UhD4F7AdxvpXaRP8SwmkZzAATPAvJZEewAAQ
wL8UBP4FbAf4l4JIz2AAmOBfSiI9gAEggH8pCPwL2A7wLwWRnsEAMMG/lER6
AANAAP9SEPgXsB3gXwoiPYMBYIJ/KYn0AAaAAP6lIPAvYDvAvxREegYDwAT/
UhLpAQwAAfxLQeBfwHaAfymI9AwGgAn+pSTSAxgAAviXgsC/gO0A/1IQ6RkM
ABP8S0mkBzAABDf71x7pzwfcBuBfwHaAfymI9AwGgAn+pSTSAxgAAviXgsC/
gO1A/hUB/1IL6RkMABP8S0mkBzAABPAvBYF/AdsB/qUg0jMYACb4l5JID2AA
COBfCgL/ArbDlTeuW/1r6MAp6c8H3AakZzAATDf71469D0l/PuA2ID2AASB4
4N5Bq389dOkR6c8H3AbgXwAAiUjPYAAANZEewAAAygL/AgBIRHoGAwCoifQA
BgBQFvgXAEAi0jMYAEBNpAcwAICywL8AABKRnsEAAGoiPYABAJQF/gUAkIj0
DAYAUBPpAQwAoCzwLwCARKRnMACAmkgPYAAAZYF/AQAkIj2DAQDURHoAAwAo
C/wLACAR6RkMAKAm0gMYAEBZ4F8AAIlIz2AAADWRHsAAAMoC/wIASER6BgMA
qIn0AAYAUBb4FwBAItIzGABATaQHMACAssC/AAASkZ7BAABqIj2AAQCUBf4F
AJCI9AwGAFAT6QEMAKAs8C8AgESkZzAAgJpID2AAAGWBfwEAJCI9gwEA1ER6
AAMAKAv8CwAgEekZDACgJtIDGABAWeBfAACJSM9gAAA1kR7AAADKAv8CAEhE
egYDAKiJ9AAGAFAW+BcAQCLSMxgAQE2kBzAAgLLAvwAAEpGewQAAaiI9gAEA
lAX+BQCQiPQMBgBQE+kBDACgLPAvAIBEpGcwAICaSA9gAABlgX8BACQiPYMB
ANREegADACgL/AsAIBHpGQwAoCbSAxgAQFngXwAAiUjPYAAANZEewAAAygL/
AgBIRHoGAwCoifQABgBQFvgXAEAi0jMYAEBNpAcwAICywL8AABKRnsEAAGoi
PYABAJQF/gUAkIj0DAYAUBPpAQwAoCzwLwCARKRnMACAmkgPYAAAZYF/AQAk
Ij2DAQDURHoAAwAoC/wLACAR6RkMAKAm0gMYAEBZ/heFQqFQKBQKhUKhUCgU
CoVCoVAoFAqFQqFQKBQKhUKhUCgUCoVCoVAoFAqFQqFQKBQKhUKhUCgUCoVC
oVAoFAqFQqFQKBQKhUKhUCgUCoVCoVAoFAqFQqFQKBQKhUKhUCgUCoVCoVAo
FAqFQqFQKBQKhUKhUCgUCoVCoVAoFAqFQqFQKBQKhUKhUCgUCoVCoVAoFAqF
QqFQKBQKhUKhUCgUCoVCoVAoFAqFQqFQKBQKhUKhUCgUCoVCoVAoFAqFQqFQ
KBQKhUKhUCgUCoVCoVAoFAp1C/X/AVuShp8=
    "], {{0, 208.}, {576., 0}}, {0, 255},
    ColorFunction->RGBColor,
    ImageResolution->{144., 144.},
    SmoothingQuality->"High"],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{576., 208.},
  PlotRange->{{0, 576.}, {0, 208.}}]], "Output",
 CellTags->"RasterizedOutput",
 CellLabel->"Out[32]=",
 CellID->1810823445,ExpressionUUID->"e82e8148-c2bf-4e51-8fc4-311c26fafb05"]
}, Open  ]],

Cell["\<\
The above discussion can be largely summed up in terms of these plots.\
\>", "Text",
 CellID->690304662,ExpressionUUID->"d8aa2676-81b0-45ba-a22f-5af050be9dcb"],

Cell[TextData[{
 "(1) When the probe is far detuned, the pump beam depletes the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", 
    RowBox[{"-", "1"}]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "9ae63b1b-97ef-43ab-923e-bca20c4cf0b2"],
 " sublevel, i.e., the atoms with negative angular momentum projection. The \
probability surface thus preferentially points in the positive direction \
along the quantization axis ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "1e89ee17-af5e-48dd-9e15-642083892816"],
 ". Since the probe is far detuned, it experiences little absorption."
}], "Text",
 Background->RGBColor[0.8823529411764706, 0.9490196078431372, 1.],
 CellID->216379,ExpressionUUID->"2463ba7f-6b82-4057-8f75-d9c7f56b57d5"],

Cell[TextData[{
 "(2) When the probe is tuned on optical resonance, the probe pumps out the \
",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "693c7ab4-ad1a-41ef-88fa-dc77f37e19f5"],
 " sublevel, while the pump continues to pump on the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", 
    RowBox[{"-", "1"}]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "4530095a-10e6-4d28-a182-2e9762cb0f9f"],
 " sublevel, leaving the atoms in the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "0"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "039ff29f-9231-4f03-9d08-6096bef15559"],
 StyleBox[" level, i.e., the sublevel with no angular-momentum projection on \
the ",
  Deletable->True],
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "b276bbc6-0aad-483f-82b2-176c2b530ca0"],
 StyleBox[" axis.",
  Deletable->True],
 " Thus the surface does not point in either the positive or negative ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "0e1454b1-b7c4-42a3-8d57-a78bedfce997"],
 " direction, but rather forms a \"doughnut\" about the ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "3bf38628-7649-410b-a158-330aed1259e5"],
 " axis. Another way of looking at this is that the pump and probe light \
combine to form linearly polarized light in the ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]], "InlineMath",ExpressionUUID->
  "a8f5f3cb-0bc0-4a71-87c4-66d3909b3da0"],
 "-",
 Cell[BoxData[
  FormBox["y", TraditionalForm]], "InlineMath",ExpressionUUID->
  "e08049a3-d508-4cd6-b42a-5a02dcc33a1a"],
 " plane that rotates rapidly about the ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "782e9605-1754-4971-883f-37fb363018ae"],
 " axis. Thus the \"peanut\" that would form due to static linearly polarized \
light is averaged about the ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "330c846f-822e-42fa-83e3-142def0b6d4d"],
 " axis to form a doughnut. Since the probe interacts with the atoms to pump \
on the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"M", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "162f7301-4976-40c7-bea4-1e41bd401178"],
 " sublevel, the absorption of the probe increases."
}], "Text",
 Background->RGBColor[0.9372549019607843, 0.8862745098039215, 1.],
 CellID->284018439,ExpressionUUID->"323a99e2-b105-466e-b903-b84d83737c3f"],

Cell[TextData[{
 "(3) When the pump and probe frequencies are equal, they combine to form \
static linearly polarized light, which has a preferred axis in the ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]], "InlineMath",ExpressionUUID->
  "37c9b775-af22-4660-9158-18813a791228"],
 "-",
 Cell[BoxData[
  FormBox["y", TraditionalForm]], "InlineMath",ExpressionUUID->
  "7eb99cb9-93f8-4827-8d5d-44c590f58369"],
 " plane (here, the ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]], "InlineMath",ExpressionUUID->
  "4fb061f2-0f97-4c97-9f26-39c714de1069"],
 " axis). The polarization takes the form of a peanut with its preferred axis \
along the ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]], "InlineMath",ExpressionUUID->
  "73eff921-0fae-4f5f-a680-49815f016c05"],
 " axis. Since this polarization corresponds to the dark state for this light \
polarization, the atoms no longer interact with the light and the probe \
absorption drops."
}], "Text",
 Background->RGBColor[0.9019607843137255, 1., 0.8117647058823529],
 CellID->345728935,ExpressionUUID->"b6a1295f-a06f-4caf-b9ae-99a1daa9e3d0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Animation", "Section",
 CellID->772480329,ExpressionUUID->"f6c1d3f7-1f26-45ee-aa81-c23345570437"],

Cell[TextData[{
 "We can also animate the probability surfaces as the probe detuning is swept \
through resonance.  Many frames are required to show the smooth evolution of \
the density matrix, so rather than assembling the animation inside the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " notebook, it is more convenient to export the frames individually as \
images and join them with a video editor."
}], "Text",
 CellID->39089004,ExpressionUUID->"b11eabe1-fbda-4a0d-a918-7a268d5a1a3c"],

Cell["A frame from the completed animation.", "MathCaption",
 CellID->21356044,ExpressionUUID->"6fbdb722-64ae-496c-b8e6-1577fdb987a0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Import", "[", 
  "\"\<http://rochesterscientific.com//ADM//images//eitamps_frame.png\>\"", 
  "]"}]], "Input",
 CellLabel->"In[33]:=",
 CellID->340223584,ExpressionUUID->"7d60e5d8-f4e8-4eee-9a3a-df1243e3c7fa"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzsnQd4G1W6971s8MiS1btkh+Wy9e5e2Puxuxd278L2C7uw9BIgIZBGCum9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    "], {{0, 226}, {225, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag[
   "Byte", ColorSpace -> "RGB", Interleaving -> True, 
    MetaInformation -> <|
     "Comments" -> <|
       "Software" -> "Wolfram Mathematica 6.0", "Creation Time" -> 
        DateObject[{2008, 10, 27, 16, 59, 45.}, "Instant", 
          "Gregorian", -7.]|>|>],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSizeRaw->{225, 226},
  PlotRange->{{0, 225}, {0, 226}}]], "Output",
 CellLabel->"Out[33]=",
 CellID->1965876911,ExpressionUUID->"ce19d937-7655-48a0-a0c6-acd5fcd93f85"]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["Here is a link"]], 
    "http://rochesterscientific.com/ADM/movies/eitamps_24fps.mov"},
   "WebLink",
   BaseStyle->{"Text"}]],ExpressionUUID->
  "d4f4fd96-8b0c-4489-b019-fdd9d2f30390"],
 " to the exported animation on the ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["AtomicDensityMatrix website"]], 
    "http://rochesterscientific.com/ADM/"},
   "WebLink",
   BaseStyle->{"Text"}]],ExpressionUUID->
  "893f6f75-d1b0-4dca-86e8-1873c5083d9a"],
 ". \nThe probability surface, absorption spectrum, resultant light \
polarization, and level diagram are shown together. We have used the inverse \
transformation ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["v", "\[Dagger]"], TraditionalForm]], "InlineMath",
  ExpressionUUID->"a0a800db-7e17-4801-8ff3-03d03e7d8089"],
 " to transform the density matrix back into the lab frame, so that the time \
dependence of the density matrix can be observed. We have also slowed the \
probe frequency scan down when the frequency is near the EIT resonance so \
that the behavior under resonance conditions can be seen more clearly."
}], "Text",
 CellID->297645321,ExpressionUUID->"a05eb474-d33b-40be-8892-a5b8b9fdcfe5"]
}, Open  ]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "TutorialMoreAboutSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "AtomicDensityMatrix Package",
         BaseStyle->"Link",
         ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]],
          "TutorialMoreAbout",ExpressionUUID->
         "6b90953e-19a7-49d6-9b31-3c74b5828979"]}]}
     }]}
  }]], "TutorialMoreAboutSection",ExpressionUUID->"6fc9dc2b-2703-4856-9fe7-\
a8f46d0266ee"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Tech", " ", "Notes"}], 
        "RelatedTutorialsSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "Three-level System: Electromagnetically Induced Transparency",
         BaseStyle->"Link",
         ButtonData->
          "paclet:AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency"]], "RelatedTutorials",
         ExpressionUUID->"66d26526-c49b-4fdf-8f94-0e7764fb3730"]}]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "Angular-momentum Probability Surfaces",
         BaseStyle->"Link",
         ButtonData->
          "paclet:AtomicDensityMatrix/tutorial/\
AngularMomentumProbabilitySurfaces"]], "RelatedTutorials",ExpressionUUID->
         "7b17b6d4-91b6-43ac-8b4f-5e4e92b91fc5"]}]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "Visualizing Polarization Moments and Quantum Beats",
         BaseStyle->"Link",
         ButtonData->
          "paclet:AtomicDensityMatrix/tutorial/\
VisualizingPolarizationMomentsAndQuantumBeats"]], "RelatedTutorials",
         ExpressionUUID->"23519a7f-0f6a-4932-a936-bdba0ab4ac91"]}]}
     }]}
  }]], "RelatedTutorialsSection",ExpressionUUID->"0dd8fa91-f930-4d8b-8ee9-\
9b6be34518b9"],

Cell[BoxData[""], "Input",ExpressionUUID->"4963dc86-2693-4423-878e-c025f54a0c88"]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"3bd3953e-bcf2-4fd2-8f12-99847ed927a6"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Electromagnetically Induced Transparency and Atomic \
Polarization",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}}, 
  "NewStyles" -> True, "CitationPopupData" -> {$Failed, ""}, "ShowCitation" -> 
  False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 18, 0, 18.055576}", 
    "history" -> {"10.06", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Tutorial", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "An atomic system consisting of two lower states connected to one upper \
state by two coherent light fields (a \"\\[CapitalLambda] system\") can \
exhibit the phenomenon known as electromagnetically induced transparency \
(EIT), discussed in the example \"Three-level System: Electromagnetically \
Induced Transparency\". Such a system can take the form of the \
M=\\[PlusMinus]1 levels of a J=1 ground state connected to a J=0 excited \
state by two light beams with opposite circular polarizations (\\[Sigma]^+ \
and \\[Sigma]^-). If the frequency of one light field (the \"pump\") is held \
fixed while the frequency of the other (the \"probe\") is varied, a drop in \
absorption of the probe beam is seen when the probe frequency matches that of \
the pump. This EIT resonance is associated with coherence between the two \
ground-state levels, which in the case considered here can be interpreted as \
angular-momentum polarization of the J=1 ground state. In this example we \
calculate the EIT signal measured on a 1->0 transition, and show how the EIT \
resonance can be understood in terms of the ground-state polarization, which \
we illustrate using population plots and angular-momentum probability \
surfaces (see \"Angular-momentum Probability Surfaces\"). This loads the \
package.", "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$71110, "title" -> 
    "Electromagnetically Induced Transparency and Atomic Polarization", 
    "titlemodifier" -> "", "metadescription" -> "", "windowtitle" -> 
    "Electromagnetically Induced Transparency and Atomic Polarization", 
    "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization"}},
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> Notebook], 
   Cell[
    StyleData["Output"], CellContext -> Notebook], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"5f3de84a-7648-4d25-9e5f-c608bf3d2126"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "RasterizedOutput"->{
  Cell[686326, 13957, 80271, 1322, 229, "Output",ExpressionUUID->"e82e8148-c2bf-4e51-8fc4-311c26fafb05",
   CellTags->"RasterizedOutput",
   CellID->1810823445]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"RasterizedOutput", 815333, 16192}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[636, 21, 6070, 143, 57, "AnchorBarGrid",ExpressionUUID->"7e327527-56b2-4ab1-aff1-6aa113bff033",
 CellID->1],
Cell[CellGroupData[{
Cell[6731, 168, 164, 3, 110, "Title",ExpressionUUID->"3b068c8a-899c-4277-a57f-266d97296c6c",
 CellID->509267359],
Cell[6898, 173, 6489, 146, 123, "TutorialJumpBox",ExpressionUUID->"099fd93b-2243-4bca-867b-0c4c32caa0fe"],
Cell[13390, 321, 2121, 48, 204, "Text",ExpressionUUID->"9b3788a8-e461-4be6-b80b-9ba488206d88",
 CellID->1534169418],
Cell[15514, 371, 697, 15, 84, "Text",ExpressionUUID->"c45b8bb7-c1f2-4285-8e41-a8221f101132",
 CellID->224963010],
Cell[CellGroupData[{
Cell[16236, 390, 110, 1, 71, "Section",ExpressionUUID->"af8f3817-0316-43c6-aad9-c1226f66e53d",
 CellID->773580667],
Cell[16349, 393, 120, 1, 36, "MathCaption",ExpressionUUID->"fca7337d-9ace-4e03-aacf-dafc9aa671ea",
 CellID->21129096],
Cell[16472, 396, 162, 3, 29, "Input",ExpressionUUID->"5a13b300-899b-45c1-886e-2dcdc76bc8e5",
 CellID->195332175],
Cell[16637, 401, 410, 7, 84, "Text",ExpressionUUID->"d1056015-993f-446f-9e6d-f7c3a7824131",
 CellID->105311105],
Cell[17050, 410, 821, 25, 38, "MathCaption",ExpressionUUID->"23483500-b454-40f3-9ff5-26c45be838d2",
 CellID->333920660],
Cell[17874, 437, 262, 6, 29, "Input",ExpressionUUID->"0fdbc8af-41ec-4bc6-921d-1de3299bf3a8",
 CellID->96283744],
Cell[18139, 445, 123, 1, 36, "MathCaption",ExpressionUUID->"b69ab4f2-97be-48cd-9134-8ece2e2613eb",
 CellID->399507665],
Cell[CellGroupData[{
Cell[18287, 450, 709, 18, 70, "Input",ExpressionUUID->"d69f9ffe-7a89-4793-bffd-258832e26b72",
 CellID->105219035],
Cell[18999, 470, 1219, 30, 89, "Output",ExpressionUUID->"aa665b7c-29d9-4642-b004-dec3240651b9",
 CellID->426343123]
}, Open  ]],
Cell[20233, 503, 1815, 51, 70, "Text",ExpressionUUID->"83b64e9b-c607-48b2-9b63-44c617f5caf1",
 CellID->121947581],
Cell[22051, 556, 128, 1, 70, "MathCaption",ExpressionUUID->"1e9eccdc-4746-4f95-8fcd-536ee4edd4e2",
 CellID->98030042],
Cell[CellGroupData[{
Cell[22204, 561, 1147, 34, 70, "Input",ExpressionUUID->"c8a3e0be-6c91-4c99-84bd-a6c2ee29c6e5",
 CellID->47980269],
Cell[23354, 597, 2360, 71, 113, "Output",ExpressionUUID->"d12c1742-a3c3-4be4-9198-fb0b699694b9",
 CellID->1543421869]
}, Open  ]],
Cell[25729, 671, 172, 3, 70, "MathCaption",ExpressionUUID->"36d60d22-e4bb-432e-a2c4-1cb6c425bdbf",
 CellID->37038723],
Cell[CellGroupData[{
Cell[25926, 678, 367, 10, 70, "Input",ExpressionUUID->"b14209df-fefb-460d-9ab4-517f9775b5e9",
 CellID->229107480],
Cell[26296, 690, 3976, 110, 168, "Output",ExpressionUUID->"fa81b2b3-5cec-4ed0-8ad3-cd077105fd53",
 CellID->836380170]
}, Open  ]],
Cell[30287, 803, 215, 4, 70, "MathCaption",ExpressionUUID->"c134a19b-13f9-467d-a514-d8e93ba481cf",
 CellID->89487683],
Cell[30505, 809, 332, 9, 70, "Input",ExpressionUUID->"d9ab74bd-9f28-4598-a152-fa05500b8896",
 CellID->125734499],
Cell[CellGroupData[{
Cell[30862, 822, 1190, 34, 70, "Input",ExpressionUUID->"9b1d82b0-00e0-48b0-ba8d-9965aeb08e53",
 CellID->95768827],
Cell[32055, 858, 1323, 28, 121, "Output",ExpressionUUID->"be6a84ba-3692-47c7-a95a-f821741d1ed7",
 CellID->1761047575]
}, Open  ]],
Cell[33393, 889, 994, 25, 70, "Text",ExpressionUUID->"cd33c153-db1d-46d3-829a-facab903a8dc",
 CellID->120111978],
Cell[34390, 916, 213, 4, 70, "MathCaption",ExpressionUUID->"a3732c15-e51a-4d5c-b7e4-615586c76d75",
 CellID->57652465],
Cell[CellGroupData[{
Cell[34628, 924, 508, 14, 70, "Input",ExpressionUUID->"76e953a1-febb-48d4-88a6-fa83174081ab",
 CellID->283782337],
Cell[35139, 940, 1882, 56, 156, "Output",ExpressionUUID->"738b7933-ed97-4180-8727-fd22e6ecf89b",
 CellID->1306970071]
}, Open  ]],
Cell[37036, 999, 372, 9, 70, "Text",ExpressionUUID->"f3388a35-eddc-428f-929c-11b19650e041",
 CellID->39910472],
Cell[37411, 1010, 174, 3, 70, "MathCaption",ExpressionUUID->"361bb1d8-1fba-40c3-bc20-3f62a0b8a31e",
 CellID->520728161],
Cell[CellGroupData[{
Cell[37610, 1017, 324, 9, 70, "Input",ExpressionUUID->"579022fc-f605-4597-b6d6-b36379027896",
 CellID->35501205],
Cell[37937, 1028, 922, 25, 102, "Output",ExpressionUUID->"76d2dc96-248d-4a89-9929-057d15d77a79",
 CellID->1783241781]
}, Open  ]],
Cell[38874, 1056, 445, 11, 70, "Text",ExpressionUUID->"74ab092f-2068-4367-b5fc-a3c22b3ac49b",
 CellID->270075583],
Cell[39322, 1069, 316, 7, 70, "MathCaption",ExpressionUUID->"a6485ad9-e329-46ee-94fc-eba7f1b2b88e",
 CellID->45168219],
Cell[CellGroupData[{
Cell[39663, 1080, 495, 13, 70, "Input",ExpressionUUID->"7a06d150-aee5-4953-bd27-304ed26bb681",
 CellID->765659243],
Cell[40161, 1095, 934, 25, 104, "Output",ExpressionUUID->"18c569f9-3284-46dc-9c67-1cc21cb3d280",
 CellID->662835735]
}, Open  ]],
Cell[41110, 1123, 324, 8, 70, "MathCaption",ExpressionUUID->"0b258dc3-7459-4d38-8306-ed16b615bb68",
 CellID->348736122],
Cell[CellGroupData[{
Cell[41459, 1135, 294, 8, 70, "Input",ExpressionUUID->"9529e6dc-5feb-47b8-adc3-13d1361ed32b",
 CellID->544384484],
Cell[41756, 1145, 1520, 47, 142, "Output",ExpressionUUID->"79ab3182-f4bb-48df-9adb-5d6ea795db04",
 CellID->1282521156]
}, Open  ]],
Cell[43291, 1195, 206, 4, 70, "Text",ExpressionUUID->"be97e0f8-f868-42b9-bd85-362e8ec36c64",
 CellID->146612425],
Cell[43500, 1201, 662, 13, 70, "Text",ExpressionUUID->"5063135d-5c42-4974-ae35-9162be68f52f",
 CellID->171394912],
Cell[44165, 1216, 125, 1, 70, "MathCaption",ExpressionUUID->"9c170241-349b-40ee-8b61-ffd650125440",
 CellID->424837104],
Cell[CellGroupData[{
Cell[44315, 1221, 369, 10, 70, "Input",ExpressionUUID->"d86437dc-7572-4e4a-af79-0015ad9e9e6c",
 CellID->485314701],
Cell[44687, 1233, 840, 22, 100, "Output",ExpressionUUID->"3a941483-4512-400f-88f6-cad9751828f0",
 CellID->1039703953]
}, Open  ]],
Cell[45542, 1258, 257, 5, 70, "Text",ExpressionUUID->"8adefa17-5a2e-4604-b421-efbf311bd37c",
 CellID->4106716],
Cell[45802, 1265, 127, 1, 70, "MathCaption",ExpressionUUID->"596016ad-10dc-4766-b42e-83e7cadb28cc",
 CellID->103033569],
Cell[CellGroupData[{
Cell[45954, 1270, 371, 10, 70, "Input",ExpressionUUID->"3b7e876c-c030-4497-8736-0b5cf0830bed",
 CellID->432373522],
Cell[46328, 1282, 1754, 51, 124, "Output",ExpressionUUID->"de6e432b-c146-4fad-9c84-d51c52e11bd6",
 CellID->229902432]
}, Open  ]],
Cell[48097, 1336, 201, 4, 70, "Text",ExpressionUUID->"b3bd176f-2307-4e64-baf5-d1fde46ff9b2",
 CellID->104746948],
Cell[48301, 1342, 122, 1, 70, "MathCaption",ExpressionUUID->"f36d6c09-c92b-4ac0-91eb-d7bf11a6db27",
 CellID->249540538],
Cell[CellGroupData[{
Cell[48448, 1347, 307, 8, 70, "Input",ExpressionUUID->"6fc0966d-76c6-4fc6-b9cd-1b6de030e693",
 CellID->60934029],
Cell[48758, 1357, 7609, 230, 168, "Output",ExpressionUUID->"1b79e269-1623-4fad-9efb-b76519a2af38",
 CellID->647093671]
}, Open  ]],
Cell[56382, 1590, 223, 4, 70, "Text",ExpressionUUID->"3bd3ae3b-7a2e-4ad1-939f-d37be8b26f0a",
 CellID->42128096],
Cell[56608, 1596, 140, 1, 70, "MathCaption",ExpressionUUID->"e50f1f7b-1f2c-41af-9369-7f8fccd0c6f9",
 CellID->304445345],
Cell[CellGroupData[{
Cell[56773, 1601, 910, 25, 70, "Input",ExpressionUUID->"fafa72d3-0941-436f-83bc-b6304a3eae51",
 CellID->345181482],
Cell[57686, 1628, 6208, 155, 108, "Output",ExpressionUUID->"592e047c-300f-4cec-907c-e3ec9d9432a8",
 CellID->846140089]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[63943, 1789, 111, 1, 70, "Section",ExpressionUUID->"6c964572-24c4-49d3-b117-ba095c19d531",
 CellID->248714767],
Cell[64057, 1792, 786, 11, 70, "Text",ExpressionUUID->"213c89a1-6538-4805-8d9a-8d9320bad5b3",
 CellID->80909269],
Cell[64846, 1805, 1323, 31, 70, "Text",ExpressionUUID->"2af22813-603a-47d2-962f-3de2377e59d6",
 CellID->489699383],
Cell[66172, 1838, 174, 3, 70, "MathCaption",ExpressionUUID->"1991be86-061b-423c-a35c-8803c8523b40",
 CellID->818921601],
Cell[CellGroupData[{
Cell[66371, 1845, 1624, 45, 70, "Input",ExpressionUUID->"e5ab41fa-993e-446d-9879-095164dbe1da",
 CellID->27732173],
Cell[67998, 1892, 519, 15, 61, "Output",ExpressionUUID->"2acc50bf-d1ab-40e3-a9cf-729aec884c7f",
 CellID->439765389]
}, Open  ]],
Cell[68532, 1910, 175, 3, 70, "MathCaption",ExpressionUUID->"88a6ff72-d1d9-47ce-a58d-37c9390aaa50",
 CellID->663291271],
Cell[CellGroupData[{
Cell[68732, 1917, 255, 6, 70, "Input",ExpressionUUID->"5c7ea910-6666-4ddd-aca5-bdf4123b910b",
 CellID->78157562],
Cell[68990, 1925, 5465, 146, 101, "Output",ExpressionUUID->"40c812f8-9d71-45fe-982a-83a5021294b2",
 CellID->1645663596]
}, Open  ]],
Cell[74470, 2074, 827, 20, 70, "Text",ExpressionUUID->"06ca266b-566a-43ec-9708-87870736b2b9",
 CellID->865174207],
Cell[75300, 2096, 176, 2, 70, "MathCaption",ExpressionUUID->"c499f1b2-43a0-4a2a-81df-8b8a49486d4a",
 CellID->190807129],
Cell[CellGroupData[{
Cell[75501, 2102, 859, 24, 70, "Input",ExpressionUUID->"c170427c-5b88-4f85-bf20-2b4537359582",
 CellID->489853664],
Cell[76363, 2128, 1513, 43, 65, "Output",ExpressionUUID->"4c115ee8-b84c-411b-8d36-8854766b6a77",
 CellID->1226168259]
}, Open  ]],
Cell[77891, 2174, 171, 3, 70, "MathCaption",ExpressionUUID->"96075737-d91c-41df-a0ab-2b90f031a648",
 CellID->547991346],
Cell[78065, 2179, 408, 10, 70, "Input",ExpressionUUID->"c48afddd-2e96-43d8-a4b0-1f66bf6a89d6",
 CellID->899459234],
Cell[78476, 2191, 116, 1, 70, "MathCaption",ExpressionUUID->"af9d96f0-29a6-4800-82a6-e7465d069600",
 CellID->2911107],
Cell[CellGroupData[{
Cell[78617, 2196, 1698, 49, 70, "Input",ExpressionUUID->"dd9e53a4-a338-4713-ba94-b3c34fd6e8fd",
 CellID->40739372],
Cell[80318, 2247, 18727, 370, 203, "Output",ExpressionUUID->"eb6d7599-13f8-49b1-8b0e-9c13d076b8f7",
 CellID->956852401]
}, Open  ]],
Cell[99060, 2620, 169, 3, 70, "Text",ExpressionUUID->"8a865bef-a750-43f8-8331-04cbc7164a71",
 CellID->400119040],
Cell[99232, 2625, 309, 5, 70, "Text",ExpressionUUID->"02e7d1a7-8d3a-4680-b5fc-a0c9287b5f34",
 CellID->467904709],
Cell[99544, 2632, 411, 7, 70, "Text",ExpressionUUID->"8e619bc9-08fb-4cb6-b07d-85535972b474",
 CellID->21941573],
Cell[99958, 2641, 331, 6, 70, "Text",ExpressionUUID->"46396611-2af1-4a8d-acfb-8de37865c47c",
 CellID->862120582]
}, Open  ]],
Cell[CellGroupData[{
Cell[100326, 2652, 111, 1, 70, "Section",ExpressionUUID->"acc6f21e-f509-4428-9580-2860cf107e30",
 CellID->29539545],
Cell[100440, 2655, 263, 5, 70, "Text",ExpressionUUID->"88198573-be4d-4b97-b468-f010f45e3589",
 CellID->122229125],
Cell[100706, 2662, 163, 2, 70, "MathCaption",ExpressionUUID->"991b4a13-9a9e-4851-adcb-4e4dfbc386ee",
 CellID->204481718],
Cell[100872, 2666, 349, 10, 70, "Input",ExpressionUUID->"c4a25d0e-7f9a-4387-b2cb-c8f8b784742c",
 CellID->899057428],
Cell[101224, 2678, 262, 5, 70, "MathCaption",ExpressionUUID->"e811ed84-c18a-41f5-9c25-c9f1f3a2333e",
 CellID->513934487],
Cell[CellGroupData[{
Cell[101511, 2687, 2035, 59, 70, "Input",ExpressionUUID->"a89ff774-b1a0-490e-93a2-be8ead0f84a2",
 CellID->34176881],
Cell[103549, 2748, 261729, 4888, 70, "Output",ExpressionUUID->"1e70c031-7664-451e-b64f-fe5c372b2f48",
 CellID->1460754871]
}, Open  ]],
Cell[365293, 7639, 240, 4, 70, "Text",ExpressionUUID->"0269d88d-1261-40cc-bc7d-b7352311ad48",
 CellID->397609329],
Cell[365536, 7645, 1102, 24, 70, "Text",ExpressionUUID->"4467cebe-64ce-48b0-b795-186d481b80d4",
 CellID->907999431],
Cell[366641, 7671, 1244, 31, 70, "Text",ExpressionUUID->"830ee906-302c-4d73-9c8a-2e5c1fbad3c2",
 CellID->22367888],
Cell[367888, 7704, 1509, 36, 70, "Text",ExpressionUUID->"7a5ff6e1-67b4-48a9-91fb-afd0aac8681c",
 CellID->239612]
}, Open  ]],
Cell[CellGroupData[{
Cell[369434, 7745, 116, 1, 70, "Section",ExpressionUUID->"00defea4-fc49-4d2c-9a6b-9fcbb3ed8877",
 CellID->185542063],
Cell[369553, 7748, 756, 11, 70, "Text",ExpressionUUID->"8f2e5ee8-0533-44bb-9c3d-46c487ff380f",
 CellID->287527692],
Cell[370312, 7761, 646, 12, 70, "Text",ExpressionUUID->"c82e6b0f-da9c-4602-859c-07535e2e85a1",
 CellID->103757058],
Cell[370961, 7775, 322, 8, 70, "MathCaption",ExpressionUUID->"d33d4484-44db-4228-b250-75d10d13d838",
 CellID->57776647],
Cell[CellGroupData[{
Cell[371308, 7787, 1219, 34, 70, "Input",ExpressionUUID->"1a77ca86-58a1-4ced-9493-ae6dc98db216",
 CellID->885970457],
Cell[372530, 7823, 508, 15, 52, "Output",ExpressionUUID->"0d0fdda1-eca8-48fc-9e8e-1b09c156ab47",
 CellID->874064393]
}, Open  ]],
Cell[373053, 7841, 212, 4, 70, "MathCaption",ExpressionUUID->"f094858c-b187-4bc2-acb6-b3a8e747e26e",
 CellID->606322747],
Cell[CellGroupData[{
Cell[373290, 7849, 2713, 73, 70, "Input",ExpressionUUID->"cbb741d4-5f5a-4963-aedc-d47e8d04e8db",
 CellID->8269313],
Cell[376006, 7924, 2753, 57, 70, "Output",ExpressionUUID->"6f3ae1de-be1e-4e66-90e2-65b133667d20",
 CellID->1612107671]
}, Open  ]],
Cell[378774, 7984, 518, 10, 70, "Text",ExpressionUUID->"2be3db95-5e97-4cb1-953b-b552f7612749",
 CellID->248112568],
Cell[379295, 7996, 1108, 23, 70, "Text",ExpressionUUID->"f72d2f5b-13c9-46a6-af63-80c9885ef544",
 CellID->56662543],
Cell[380406, 8021, 932, 18, 70, "Text",ExpressionUUID->"0c784ca1-2002-4b4b-9f3b-4bd72fea6874",
 CellID->168805416]
}, Open  ]],
Cell[CellGroupData[{
Cell[381375, 8044, 114, 1, 70, "Section",ExpressionUUID->"5da43072-7e0a-400a-b9e1-f82e02b01f90",
 CellID->69945931],
Cell[381492, 8047, 2762, 66, 70, "Text",ExpressionUUID->"33ee0fcc-0c6b-4647-a70c-69c9f5be42ea",
 CellID->84302324],
Cell[384257, 8115, 656, 10, 70, "Text",ExpressionUUID->"5a83c0d5-01cd-4b7f-a7b8-6ee3032b87e4",
 CellID->527165396],
Cell[384916, 8127, 569, 9, 70, "Text",ExpressionUUID->"eef2732b-24fc-4105-9424-b62b4c9abb0f",
 CellID->192463844],
Cell[385488, 8138, 175, 3, 70, "MathCaption",ExpressionUUID->"99db0f72-f401-4c89-9f9c-62f74ca16f3d",
 CellID->26982531],
Cell[385666, 8143, 384, 11, 70, "Input",ExpressionUUID->"7bb235d5-708a-4dce-98c3-f8402b42f6e6",
 CellID->259967869],
Cell[CellGroupData[{
Cell[386075, 8158, 360, 10, 70, "Input",ExpressionUUID->"bd3cfd2b-07b4-4c99-8825-127b3d0d7dbf",
 CellID->69001025],
Cell[386438, 8170, 3494, 102, 148, "Output",ExpressionUUID->"edbce41e-7bac-41f6-92eb-71cea4a1d2f0",
 CellID->2039935945]
}, Open  ]],
Cell[389947, 8275, 205, 4, 70, "MathCaption",ExpressionUUID->"a913126d-9615-4452-87f7-0081f2901a58",
 CellID->58653631],
Cell[CellGroupData[{
Cell[390177, 8283, 675, 19, 70, "Input",ExpressionUUID->"2805fbb5-f864-40bf-9665-7beb42744cc8",
 CellID->533762247],
Cell[390855, 8304, 2466, 74, 150, "Output",ExpressionUUID->"ce29b336-8b5b-483f-b982-17adafed225b",
 CellID->627003260]
}, Open  ]],
Cell[CellGroupData[{
Cell[393358, 8383, 844, 23, 70, "Input",ExpressionUUID->"995a9def-ba28-48d4-99e9-6b34609ad705"],
Cell[394205, 8408, 2525, 73, 150, "Output",ExpressionUUID->"01641760-023b-474c-9894-3ff4da861765",
 CellID->341534991]
}, Open  ]],
Cell[396745, 8484, 539, 13, 70, "MathCaption",ExpressionUUID->"056b31d5-9e84-40a2-b46c-bf59a0ce258b",
 CellID->8791936],
Cell[CellGroupData[{
Cell[397309, 8501, 2196, 60, 70, "Input",ExpressionUUID->"969e5136-c602-4e08-9ed2-aaa1ea49de7a",
 CellID->258350227],
Cell[399508, 8563, 279292, 5197, 70, "Output",ExpressionUUID->"4b350e7f-1ee9-4f90-a3d5-4c7aebced31b",
 CellID->2102288953]
}, Open  ]],
Cell[678815, 13763, 1278, 32, 70, "Text",ExpressionUUID->"e8352e86-a61e-44d5-8036-60fbf5217619",
 CellID->218409195],
Cell[680096, 13797, 535, 10, 70, "Text",ExpressionUUID->"cfcd6f25-d82b-47af-89ce-a0f67f86949d",
 CellID->445693047],
Cell[680634, 13809, 625, 11, 70, "Text",ExpressionUUID->"5d9e7fb4-f661-422d-a252-e2d58c2d7064",
 CellID->29981939],
Cell[681262, 13822, 800, 13, 70, "Text",ExpressionUUID->"11e88b89-a911-4928-b940-eb8e82b13e2c",
 CellID->539741880]
}, Open  ]],
Cell[CellGroupData[{
Cell[682099, 13840, 131, 1, 70, "Section",ExpressionUUID->"7284defd-9622-4558-a3fb-a857d3ee3122",
 CellID->164439161],
Cell[682233, 13843, 728, 13, 70, "Text",ExpressionUUID->"d26e8e61-2b3f-4c60-8401-55676df3eff2",
 CellID->12811769],
Cell[682964, 13858, 218, 4, 70, "Text",ExpressionUUID->"c788fd18-bf64-4864-8275-ac2f298e7438",
 CellID->73493904],
Cell[683185, 13864, 130, 1, 70, "MathCaption",ExpressionUUID->"07e2ddae-1ddf-4827-80b9-e51ceebdf78b",
 CellID->360085939],
Cell[683318, 13867, 348, 10, 70, "Input",ExpressionUUID->"d5cf6d64-e037-4f79-882f-35428b02a660",
 CellID->111926304],
Cell[683669, 13879, 174, 3, 70, "MathCaption",ExpressionUUID->"687c771f-3e54-4057-925d-7ece3ee1e8d4",
 CellID->669161435],
Cell[CellGroupData[{
Cell[683868, 13886, 2455, 69, 70, "Input",ExpressionUUID->"846d1cd6-cd15-4a00-911d-ee8755cd0e44",
 CellID->91118326],
Cell[686326, 13957, 80271, 1322, 229, "Output",ExpressionUUID->"e82e8148-c2bf-4e51-8fc4-311c26fafb05",
 CellTags->"RasterizedOutput",
 CellID->1810823445]
}, Open  ]],
Cell[766612, 15282, 169, 3, 70, "Text",ExpressionUUID->"d8aa2676-81b0-45ba-a22f-5af050be9dcb",
 CellID->690304662],
Cell[766784, 15287, 776, 16, 70, "Text",ExpressionUUID->"2463ba7f-6b82-4057-8f75-d9c7f56b57d5",
 CellID->216379],
Cell[767563, 15305, 2511, 61, 70, "Text",ExpressionUUID->"323a99e2-b105-466e-b903-b84d83737c3f",
 CellID->284018439],
Cell[770077, 15368, 1098, 24, 70, "Text",ExpressionUUID->"b6a1295f-a06f-4caf-b9ae-99a1daa9e3d0",
 CellID->345728935]
}, Open  ]],
Cell[CellGroupData[{
Cell[771212, 15397, 103, 1, 70, "Section",ExpressionUUID->"f6c1d3f7-1f26-45ee-aa81-c23345570437",
 CellID->772480329],
Cell[771318, 15400, 500, 9, 70, "Text",ExpressionUUID->"b11eabe1-fbda-4a0d-a918-7a268d5a1a3c",
 CellID->39089004],
Cell[771821, 15411, 134, 1, 70, "MathCaption",ExpressionUUID->"6fbdb722-64ae-496c-b8e6-1577fdb987a0",
 CellID->21356044],
Cell[CellGroupData[{
Cell[771980, 15416, 233, 5, 70, "Input",ExpressionUUID->"7d60e5d8-f4e8-4eee-9a3a-df1243e3c7fa",
 CellID->340223584],
Cell[772216, 15423, 35679, 592, 247, "Output",ExpressionUUID->"ce19d937-7655-48a0-a0c6-acd5fcd93f85",
 CellID->1965876911]
}, Open  ]],
Cell[807910, 16018, 1241, 30, 70, "Text",ExpressionUUID->"a05eb474-d33b-40be-8892-a5b8b9fdcfe5",
 CellID->297645321]
}, Open  ]],
Cell[809166, 16051, 725, 18, 70, "TutorialMoreAboutSection",ExpressionUUID->"6fc9dc2b-2703-4856-9fe7-a8f46d0266ee"],
Cell[CellGroupData[{
Cell[809916, 16073, 1572, 39, 70, "RelatedTutorialsSection",ExpressionUUID->"0dd8fa91-f930-4d8b-8ee9-9b6be34518b9"],
Cell[811491, 16114, 81, 0, 70, "Input",ExpressionUUID->"4963dc86-2693-4423-878e-c025f54a0c88"]
}, Open  ]]
}, Open  ]],
Cell[811599, 16118, 78, 0, 70, "FooterCell",ExpressionUUID->"3bd3953e-bcf2-4fd2-8f12-99847ed927a6"]
}
]
*)

(* End of internal cache information *)

