(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    759929,      14669]
NotebookOptionsPosition[    750925,      14486]
NotebookOutlinePosition[    754180,      14556]
CellTagsIndexPosition[    754137,      14553]
WindowTitle->Hyperfine Structure: Breit-Rabi Diagram
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "da76fbb2-fef0-4ab4-b3a2-9f61e46da069"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "a7901816-baf1-4325-8081-a64cd75f688a"],
        Background->RGBColor[
         0.7450980392156863, 0.3254901960784314, 0.1411764705882353],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "136d4091-3c8e-4c4e-8813-03b76f2c5b3a"]
         }],ExpressionUUID->"40ffa7be-28dc-4392-aea1-1217e30718ff"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"TutorialMoreAboutSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "1e34c825-89ee-41a2-ba86-aba7f0a02201"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "917d7c9a-f57f-4ae8-a86c-159b6c6ea8a9"]
         }],ExpressionUUID->"88239f34-ffc7-48af-9f33-664f3de9c1e5"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/tutorial/\
HyperfineStructureBreitRabiDiagram\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
              "AtomicDensityMatrix/tutorial/\
HyperfineStructureBreitRabiDiagram"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
tutorial/HyperfineStructureBreitRabiDiagram.html"], StandardForm]], "Input", 
               TextClipboardType -> "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$71844], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/tutorial/\
HyperfineStructureBreitRabiDiagram" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "d8a23258-69eb-427d-b3c0-de408e8c1222"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "67159f84-4c1d-4858-9e98-f08ab53c600e"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1,ExpressionUUID->"09552178-a724-462a-b991-7cc2b523c867"],

Cell[CellGroupData[{

Cell["Hyperfine Structure: Breit-Rabi Diagram", "Title",
 CellID->201230558,ExpressionUUID->"cb559af1-b581-4372-a62a-6dec9740b2e8"],

Cell[TextData[{
 "The energy-level shifts of a system with hyperfine structure in response to \
a magnetic field have a different character depending on whether the shifts \
are smaller or larger than the hyperfine splitting. When the Larmor frequency \
is much smaller than the hyperfine splitting, the hyperfine sublevels behave \
as if they were isolated, and the shift of each Zeeman sublevel is \
proportional to ",
 Cell[BoxData[
  StyleBox[
   SubscriptBox["M", "F"], "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "eb72d3ef-4848-4b91-aec8-ca45c6300b36"],
 ". For large magnetic fields, for which the Larmor frequency is larger than \
the hyperfine splitting, the hyperfine sublevels are strongly mixed with each \
other, and the system is best represented by the uncoupled ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     RowBox[{"J", " ", 
      SubscriptBox["M", "J"], "I", " ", 
      SubscriptBox["M", "I"]}]}], "\[RightAngleBracket]"}], "InlineMath"]], 
  "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "8c190d89-b978-4360-a5f0-b9d2d689fbf8"],
 " basis. The energy spectrum then consists of manifolds of levels with the \
same ",
 Cell[BoxData[
  StyleBox[
   SubscriptBox["M", "J"], "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "b8d99a7f-1ad6-44bd-a821-fd58202ee258"],
 " and Zeeman shift proportional to ",
 Cell[BoxData[
  StyleBox[
   SubscriptBox["M", "I"], "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "2fcdfa06-546b-4b0e-8c5c-99f6c20e6ae7"],
 ". Here we analyze this situation for the ground state of ",
 Cell[BoxData[
  SuperscriptBox["", "87"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "a633109d-ba11-41c4-bedc-6bbac61073b6"],
 "Rb."
}], "Text",
 CellID->159395344,ExpressionUUID->"57723399-949c-4306-a6e0-2211b1026a2b"],

Cell["This loads the package.", "MathCaption",
 CellID->256544093,ExpressionUUID->"1a2a4611-0bf8-4014-a463-75250d165a4e"],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->233299521,ExpressionUUID->"d01a1d59-4f50-4974-9f9e-a61145d38389"],

Cell[TextData[{
 "Here is the label for the ground state of",
 Cell[BoxData[
  SuperscriptBox["", "87"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "69583005-2c07-4aa8-9cda-49981d9c64ab"],
 "Rb in the format used by the ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["AtomicData"]], "paclet:AtomicDensityMatrix/ref/AtomicData", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "b6695d9f-83bc-480f-a802-12ce292183e5"],
 " database."
}], "MathCaption",
 CellID->106106240,ExpressionUUID->"9aa8d446-6d22-4771-b9c6-aff4149e8c56"],

Cell[BoxData[
 RowBox[{
  RowBox[{"state", "=", 
   RowBox[{"{", 
    RowBox[{"\"\<Rb\>\"", ",", "87", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<Kr\>\"", ",", 
       RowBox[{"{", 
        RowBox[{"5", ",", "\"\<s\>\""}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "\"\<S\>\"", ",", 
       FractionBox["1", "2"]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->69768344,ExpressionUUID->"b5c4587c-0c06-4b9b-a32d-608e117e7ce0"],

Cell[TextData[{
 "Define the atomic system using values from the ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["AtomicData"]], "paclet:AtomicDensityMatrix/ref/AtomicData", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "7379a2fb-9657-4e4a-853f-1ab627ca0ed1"],
 " database."
}], "MathCaption",
 CellID->104575475,ExpressionUUID->"65ba2921-8404-41bc-862e-94773e280bb7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"system", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"AtomicData", "[", 
      RowBox[{"state", ",", 
       RowBox[{"{", 
        RowBox[{"J", ",", "L", ",", "S", ",", "Energy", ",", "NuclearSpin"}], 
        "}"}]}], "]"}]}], "]"}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->51306952,ExpressionUUID->"3d1f2efa-2282-49c0-9d38-ed5800dc03db"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "2"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "2"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "2"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->1992226058,ExpressionUUID->"22022fcf-1c98-4f16-a91a-52da3daf62d1"]
}, Open  ]],

Cell["\<\
The level diagram for the unperturbed system. For the diagrams, we use \
arbitrary units in which the hyperfine splitting is equal to 0.5.\
\>", "MathCaption",
 CellID->18473580,ExpressionUUID->"9186fa08-ef8a-4d42-89d0-c0659856b190"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"system", ",", 
   RowBox[{
    RowBox[{"Hamiltonian", "[", "system", "]"}], "/.", 
    RowBox[{
     RowBox[{"HyperfineA", "[", "1", "]"}], "\[Rule]", ".5"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->410187099,ExpressionUUID->"e6967005-9784-47bf-8644-06494142f757"],

Cell[BoxData[
 GraphicsBox[{{{{{}, LineBox[{{1.6, 0.375}, {2.4, 0.375}}]}, {{}, 
      LineBox[{{0.6, 0.375}, {1.4, 0.375}}]}, {{}, 
      LineBox[{{-0.4, 0.375}, {0.4, 0.375}}]}, {{}, 
      LineBox[{{-1.4, 0.375}, {-0.6, 0.375}}]}, {{}, 
      LineBox[{{-2.4, 0.375}, {-1.6, 0.375}}]}, {{}, 
      LineBox[{{0.6, -0.625}, {1.4, -0.625}}]}, {{}, 
      LineBox[{{-0.4, -0.625}, {0.4, -0.625}}]}, {{}, 
      LineBox[{{-1.4, -0.625}, {-0.6, -0.625}}]}}, {}, {}, 
    {EdgeForm[Hue[0.61, 0.54, 0.56]], FaceForm[None]}, 
    {RGBColor[0.9, 0.01, 0.01], 
     Arrowheads[{-0.03333333333333334, 
      0.03333333333333334}]}}, {{{{}, {}}, {{}, {}}, {{}, {}}, {{}, {}}, {{}, \
{}}, {{}, {}}, {{}, {}}, {{}, {}}}, {}, {}, 
    {EdgeForm[Hue[0.61, 0.54, 0.56]], FaceForm[None]}, 
    {RGBColor[0.9, 0.01, 0.01], 
     Arrowheads[{-0.03333333333333334, 0.03333333333333334}]}}},
  ImageSize->{{350}, {100}}]], "Output",
 CellLabel->"Out[4]=",
 CellID->976674248,ExpressionUUID->"f33b94af-5aca-44a9-ba15-0261c7a93824"]
}, Open  ]],

Cell[TextData[{
 "The Hamiltonian for the system subject to a ",
 Cell[BoxData[
  StyleBox["z", "InlineMath"]],ExpressionUUID->
  "6ff5b5fe-28ca-41c6-8d7f-f382d45ad920"],
 "-directed magnetic field, with nominal Larmor frequency ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[CapitalOmega]", "=", 
    RowBox[{
     SubscriptBox["\[Mu]", "B"], " ", "B"}]}], TraditionalForm]], 
  "InlineMath",ExpressionUUID->"ce585505-d143-4fca-88b5-8af079825c65"],
 ", where ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Mu]", "B"], TraditionalForm]], "InlineMath",ExpressionUUID->
  "574623c8-fc55-4e2f-bfd0-a9e86ec82e3e"],
 " is the Bohr magneton and ",
 Cell[BoxData[
  FormBox["B", TraditionalForm]], "InlineMath",ExpressionUUID->
  "3a895188-c39d-4e93-9796-f1bc53027901"],
 " is the magnetic-field strength. "
}], "MathCaption",
 CellID->27647117,ExpressionUUID->"5381a401-4bfb-4150-b43c-8e5a46c6e044"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"h", "=", 
   RowBox[{
    RowBox[{"Hamiltonian", "[", 
     RowBox[{"system", ",", 
      RowBox[{"MagneticField", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"\[CapitalOmega]", "/", "BohrMagneton"}]}], "}"}]}]}], "]"}],
     "/.", 
    RowBox[{
     RowBox[{"HyperfineA", "[", "1", "]"}], "\[Rule]", "hfa"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->332231951,ExpressionUUID->"2a32a5f9-3134-4718-8249-e22d65014371"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox[
        RowBox[{"3", " ", "hfa"}], "4"], "+", "\[CapitalOmega]"}], "0", "0", 
      "0", "0", "0", "0", "0"},
     {"0", 
      RowBox[{
       FractionBox[
        RowBox[{"3", " ", "hfa"}], "4"], "+", 
       FractionBox["\[CapitalOmega]", "2"]}], "0", "0", "0", 
      FractionBox[
       RowBox[{
        SqrtBox["3"], " ", "\[CapitalOmega]"}], "2"], "0", "0"},
     {"0", "0", 
      FractionBox[
       RowBox[{"3", " ", "hfa"}], "4"], "0", "0", "0", "\[CapitalOmega]", "0"},
     {"0", "0", "0", 
      RowBox[{
       FractionBox[
        RowBox[{"3", " ", "hfa"}], "4"], "-", 
       FractionBox["\[CapitalOmega]", "2"]}], "0", "0", "0", 
      FractionBox[
       RowBox[{
        SqrtBox["3"], " ", "\[CapitalOmega]"}], "2"]},
     {"0", "0", "0", "0", 
      RowBox[{
       FractionBox[
        RowBox[{"3", " ", "hfa"}], "4"], "-", "\[CapitalOmega]"}], "0", "0", 
      "0"},
     {"0", 
      FractionBox[
       RowBox[{
        SqrtBox["3"], " ", "\[CapitalOmega]"}], "2"], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"5", " ", "hfa"}], "4"]}], "-", 
       FractionBox["\[CapitalOmega]", "2"]}], "0", "0"},
     {"0", "0", "\[CapitalOmega]", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"5", " ", "hfa"}], "4"]}], "0"},
     {"0", "0", "0", 
      FractionBox[
       RowBox[{
        SqrtBox["3"], " ", "\[CapitalOmega]"}], "2"], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"5", " ", "hfa"}], "4"]}], "+", 
       FractionBox["\[CapitalOmega]", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[5]//MatrixForm=",
 CellID->2124513703,ExpressionUUID->"8a8170f5-5754-47b6-aa08-0993e45dcafa"]
}, Open  ]],

Cell["\<\
The level diagram showing diagonal shifts and hyperfine couplings induced by \
the magnetic field.\
\>", "MathCaption",
 CellID->59759439,ExpressionUUID->"4aaf3af8-9c13-49a4-ac12-e613ce3fd864"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"system", ",", 
   RowBox[{"h", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"hfa", "\[Rule]", ".5"}], ",", 
      RowBox[{"\[CapitalOmega]", "\[Rule]", ".1"}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->848123,ExpressionUUID->"3b12ff33-89d8-4ce0-a8b9-bae7cedc015e"],

Cell[BoxData[
 GraphicsBox[{{{{{}, 
      LineBox[{{1.6, 0.47499999999990905`}, {2.4, 
       0.47499999999990905`}}]}, {{}, 
      LineBox[{{0.6, 0.4249999999999545}, {1.4, 0.4249999999999545}}]}, {{}, 
      LineBox[{{-0.4, 0.375}, {0.4, 0.375}}]}, {{}, 
      LineBox[{{-1.4, 0.3250000000000455}, {-0.6, 0.3250000000000455}}]}, {{},
       LineBox[{{-2.4, 0.27500000000009095`}, {-1.6, 
       0.27500000000009095`}}]}, {{}, 
      LineBox[{{0.6, -0.6749999999999545}, {1.4, -0.6749999999999545}}]}, {{},
       LineBox[{{-0.4, -0.625}, {0.4, -0.625}}]}, {{}, 
      LineBox[{{-1.4, -0.5750000000000455}, {-0.6, -0.5750000000000455}}]}}, \
{}, {}, 
    {EdgeForm[Hue[0.61, 0.54, 0.56]], FaceForm[None]}, 
    {RGBColor[0.9, 0.01, 0.01], 
     Arrowheads[{-0.03333333333333334, 0.03333333333333334}], 
     ArrowBox[{{-1., -0.5750000000000455}, {-1., 0.3250000000000455}}], 
     ArrowBox[{{0., -0.625}, {0., 0.375}}], 
     ArrowBox[{{1., -0.6749999999999545}, {1., 
      0.4249999999999545}}]}}, {{{{}, {}}, {{}, {}}, {{}, {}}, {{}, {}}, {{}, \
{}}, {{}, {}}, {{}, {}}, {{}, {}}}, {}, {}, 
    {EdgeForm[Hue[0.61, 0.54, 0.56]], FaceForm[None]}, 
    {RGBColor[0.9, 0.01, 0.01], 
     Arrowheads[{-0.03333333333333334, 0.03333333333333334}], {}, {}, {}}}},
  ImageSize->{{350}, {100}}]], "Output",
 CellLabel->"Out[6]=",
 CellID->1623871874,ExpressionUUID->"5c9e6bf0-21ef-4a32-9556-f599bb230e6c"]
}, Open  ]],

Cell["\[LineSeparator]Find the eigenvalues and eigenvectors of the \
Hamiltonian.", "MathCaption",
 CellID->125276603,ExpressionUUID->"2a4fb097-04b2-4e5f-8d83-0817faad124f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "/@", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"energies", ",", "states"}], "}"}], "=", 
    RowBox[{"Eigensystem", "[", "h", "]"}]}], ")"}]}]], "Input",
 CellLabel->"In[7]:=",
 CellID->177189690,ExpressionUUID->"9ee1eb1f-5d77-4a8d-9b5e-42142336041b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"3", " ", "hfa"}], "-", 
            RowBox[{"4", " ", "\[CapitalOmega]"}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"3", " ", "hfa"}], "+", 
            RowBox[{"4", " ", "\[CapitalOmega]"}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "hfa"}], "-", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["hfa", "2"], "+", 
               SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "hfa"}], "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["hfa", "2"], "+", 
               SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "hfa"}], "-", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["hfa", "2"], "-", 
               RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
               SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "hfa"}], "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["hfa", "2"], "-", 
               RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
               SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "hfa"}], "-", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["hfa", "2"], "+", 
               RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
               SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "hfa"}], "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["hfa", "2"], "+", 
               RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
               SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], ")"}]}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.5599999999999999]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      Column], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0", "0", "0", "1", "0", "0", "0"},
       {"1", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", "hfa"}], "+", 
           SqrtBox[
            RowBox[{
             SuperscriptBox["hfa", "2"], "+", 
             SuperscriptBox["\[CapitalOmega]", "2"]}]]}], 
          "\[CapitalOmega]"]}], "0", "0", "0", "1", "0"},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", "hfa"}], "-", 
           SqrtBox[
            RowBox[{
             SuperscriptBox["hfa", "2"], "+", 
             SuperscriptBox["\[CapitalOmega]", "2"]}]]}], 
          "\[CapitalOmega]"]}], "0", "0", "0", "1", "0"},
       {"0", "0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox["3"], " ", "hfa"}], "+", 
           RowBox[{
            SqrtBox["3"], " ", "\[CapitalOmega]"}], "+", 
           RowBox[{"2", " ", 
            SqrtBox["3"], " ", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["hfa", "2"], "-", 
              RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], 
          RowBox[{"3", " ", "\[CapitalOmega]"}]]}], "0", "0", "0", "1"},
       {"0", "0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox["3"], " ", "hfa"}], "+", 
           RowBox[{
            SqrtBox["3"], " ", "\[CapitalOmega]"}], "-", 
           RowBox[{"2", " ", 
            SqrtBox["3"], " ", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["hfa", "2"], "-", 
              RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], 
          RowBox[{"3", " ", "\[CapitalOmega]"}]]}], "0", "0", "0", "1"},
       {"0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox["3"], " ", "hfa"}], "-", 
           RowBox[{
            SqrtBox["3"], " ", "\[CapitalOmega]"}], "+", 
           RowBox[{"2", " ", 
            SqrtBox["3"], " ", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["hfa", "2"], "+", 
              RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], 
          RowBox[{"3", " ", "\[CapitalOmega]"}]]}], "0", "0", "0", "1", "0", 
        "0"},
       {"0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox["3"], " ", "hfa"}], "-", 
           RowBox[{
            SqrtBox["3"], " ", "\[CapitalOmega]"}], "-", 
           RowBox[{"2", " ", 
            SqrtBox["3"], " ", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["hfa", "2"], "+", 
              RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], 
          RowBox[{"3", " ", "\[CapitalOmega]"}]]}], "0", "0", "0", "1", "0", 
        "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellLabel->"Out[7]=",
 CellID->1066618773,ExpressionUUID->"763295ec-ea57-4fce-854b-beab69d4048b"]
}, Open  ]],

Cell[TextData[{
 "Substitute in the numerical values of the hyperfine constant for ",
 Cell[BoxData[
  SuperscriptBox["", "87"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "3db10dbd-64e0-49fe-9e01-18db3772c6ab"],
 "Rb and the Bohr magneton."
}], "MathCaption",
 CellID->499179070,ExpressionUUID->"d8c364c8-4388-4fa1-9794-b42a96dcaaaf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"energies1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"energies", "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "\[Rule]", 
           RowBox[{"B", " ", "Gauss", " ", "BohrMagneton"}]}], ",", 
          RowBox[{"hfa", "\[Rule]", 
           RowBox[{"HyperfineA", "[", "1", "]"}]}]}], "}"}]}], "/.", 
       RowBox[{"AtomicData", "[", 
        RowBox[{"state", ",", 
         RowBox[{"StateLabel", "\[Rule]", "1"}]}], "]"}]}], "/.", 
      RowBox[{"BohrMagneton", "\[Rule]", 
       RowBox[{"Convert", "[", 
        RowBox[{
         RowBox[{"ElectronCharge", "/", 
          RowBox[{"(", 
           RowBox[{"2", " ", "ElectronMass"}], ")"}]}], ",", 
         RowBox[{"Mega", "/", 
          RowBox[{"(", 
           RowBox[{"Gauss", " ", "Second"}], ")"}]}]}], "]"}]}]}], "//", 
     "Simplify"}], "//", "PowerExpand"}], "//", "Simplify"}]}]], "Input",
 CellLabel->"In[8]:=",
 CellID->688429193,ExpressionUUID->"9a2b7920-785d-4798-87e4-f5104c97cf27"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"16103.841510026119`", "\[VeryThinSpace]", "-", 
       RowBox[{"8.794100744801886`", " ", "B"}]}], ")"}], " ", "Mega"}], 
    "Second"], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"16103.841510026119`", "\[VeryThinSpace]", "+", 
       RowBox[{"8.794100744801886`", " ", "B"}]}], ")"}], " ", "Mega"}], 
    "Second"], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "5367.947170008706`"}], "-", 
       RowBox[{"1.`", " ", 
        SqrtBox[
         RowBox[{"4.610377091200716`*^8", "+", 
          RowBox[{"77.33620790972509`", " ", 
           SuperscriptBox["B", "2"]}]}]]}]}], ")"}], " ", "Mega"}], "Second"],
    ",", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "5367.947170008706`"}], "+", 
       SqrtBox[
        RowBox[{"4.610377091200716`*^8", "+", 
         RowBox[{"77.33620790972509`", " ", 
          SuperscriptBox["B", "2"]}]}]]}], ")"}], " ", "Mega"}], "Second"], 
   ",", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "5367.947170008706`"}], "-", 
       RowBox[{"1.`", " ", 
        SqrtBox[
         RowBox[{"4.610377091200716`*^8", "-", 
          RowBox[{"188825.07282332296`", " ", "B"}], "+", 
          RowBox[{"77.33620790972509`", " ", 
           SuperscriptBox["B", "2"]}]}]]}]}], ")"}], " ", "Mega"}], "Second"],
    ",", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "5367.947170008706`"}], "+", 
       SqrtBox[
        RowBox[{"4.610377091200716`*^8", "-", 
         RowBox[{"188825.07282332296`", " ", "B"}], "+", 
         RowBox[{"77.33620790972509`", " ", 
          SuperscriptBox["B", "2"]}]}]]}], ")"}], " ", "Mega"}], "Second"], 
   ",", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "5367.947170008706`"}], "-", 
       RowBox[{"1.`", " ", 
        SqrtBox[
         RowBox[{"4.610377091200716`*^8", "+", 
          RowBox[{"188825.07282332296`", " ", "B"}], "+", 
          RowBox[{"77.33620790972509`", " ", 
           SuperscriptBox["B", "2"]}]}]]}]}], ")"}], " ", "Mega"}], "Second"],
    ",", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "5367.947170008706`"}], "+", 
       SqrtBox[
        RowBox[{"4.610377091200716`*^8", "+", 
         RowBox[{"188825.07282332296`", " ", "B"}], "+", 
         RowBox[{"77.33620790972509`", " ", 
          SuperscriptBox["B", "2"]}]}]]}], ")"}], " ", "Mega"}], "Second"]}], 
  "}"}]], "Output",
 CellLabel->"Out[8]=",
 CellID->1880962977,ExpressionUUID->"ba1874b1-4f1a-4969-a12e-ea23dc6703b7"]
}, Open  ]],

Cell["\<\
Rewrite the eigenenergies in GHz units, with the magnetic-field strength in \
kG.\
\>", "MathCaption",
 CellID->47800932,ExpressionUUID->"e892a43d-c8d1-4470-8c6e-f9cc7a90f0aa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"energiesGHz", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"energies1", "/", 
     RowBox[{"(", 
      RowBox[{"2", "\[Pi]", " ", 
       SuperscriptBox["10", "3"], 
       RowBox[{"Mega", "/", "Second"}]}], ")"}]}], "/.", 
    RowBox[{"B", "\[Rule]", 
     RowBox[{"BkG", " ", 
      SuperscriptBox["10", "3"]}]}]}], "//", "Simplify"}]}]], "Input",
 CellLabel->"In[9]:=",
 CellID->308923140,ExpressionUUID->"d92724b9-e9f1-4bc5-9c6a-088e766946d8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"2.563005979089109`", "\[VeryThinSpace]", "-", 
    RowBox[{"1.3996246035833386`", " ", "BkG"}]}], ",", 
   RowBox[{"2.563005979089109`", "\[VeryThinSpace]", "+", 
    RowBox[{"1.3996246035833386`", " ", "BkG"}]}], ",", 
   RowBox[{
    RowBox[{"-", "0.8543353263630363`"}], "-", 
    RowBox[{"0.00015915494309189535`", " ", 
     SqrtBox[
      RowBox[{"4.610377091200716`*^8", "+", 
       RowBox[{"7.733620790972508`*^7", " ", 
        SuperscriptBox["BkG", "2"]}]}]]}]}], ",", 
   RowBox[{"0.00015915494309189535`", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "5367.947170008706`"}], "+", 
      SqrtBox[
       RowBox[{"4.610377091200716`*^8", "+", 
        RowBox[{"7.733620790972508`*^7", " ", 
         SuperscriptBox["BkG", "2"]}]}]]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"-", "0.8543353263630363`"}], "-", 
    RowBox[{"0.00015915494309189535`", " ", 
     SqrtBox[
      RowBox[{"4.610377091200716`*^8", "-", 
       RowBox[{"1.8882507282332295`*^8", " ", "BkG"}], "+", 
       RowBox[{"7.733620790972508`*^7", " ", 
        SuperscriptBox["BkG", "2"]}]}]]}]}], ",", 
   RowBox[{"0.00015915494309189535`", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "5367.947170008706`"}], "+", 
      SqrtBox[
       RowBox[{"4.610377091200716`*^8", "-", 
        RowBox[{"1.8882507282332295`*^8", " ", "BkG"}], "+", 
        RowBox[{"7.733620790972508`*^7", " ", 
         SuperscriptBox["BkG", "2"]}]}]]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"-", "0.8543353263630363`"}], "-", 
    RowBox[{"0.00015915494309189535`", " ", 
     SqrtBox[
      RowBox[{"4.610377091200716`*^8", "+", 
       RowBox[{"1.8882507282332295`*^8", " ", "BkG"}], "+", 
       RowBox[{"7.733620790972508`*^7", " ", 
        SuperscriptBox["BkG", "2"]}]}]]}]}], ",", 
   RowBox[{"0.00015915494309189535`", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "5367.947170008706`"}], "+", 
      SqrtBox[
       RowBox[{"4.610377091200716`*^8", "+", 
        RowBox[{"1.8882507282332295`*^8", " ", "BkG"}], "+", 
        RowBox[{"7.733620790972508`*^7", " ", 
         SuperscriptBox["BkG", "2"]}]}]]}], ")"}]}]}], "}"}]], "Output",
 CellLabel->"Out[9]=",
 CellID->1691861088,ExpressionUUID->"eaa7bae7-a68e-4c1a-89eb-c68ba389146d"]
}, Open  ]],

Cell["\<\
Plot the energies. This plot is known as a Breit-Rabi diagram.\
\>", "MathCaption",
 CellID->815973947,ExpressionUUID->"5b5c46e5-0e9d-46ec-ac9a-0a72159034ae"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"energiesGHz", ",", 
   RowBox[{"{", 
    RowBox[{"BkG", ",", "0", ",", "5"}], "}"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<Magnetic field (kG)\>\"", ",", "\"\<Energy (GHz)\>\""}], 
     "}"}]}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"Axes", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->734598839,ExpressionUUID->"ad960dd6-e07c-48de-9211-e43f6831af31"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwB4QQe+yFib1JlAgAAAE0AAAACAAAAnX5iBjFkez5R5zE0CYEEQJ5a7DpX
IFk/OqbE66N8BEDZTYpyICBpPyNlV6M+eARAd0dZDgUgeT/14nwSdG8EQEbE
QFz3H4k/mt7H8N5dBECtgjSD8B+ZP+LVXa20OgRA4WGuFu0fqT9yxIkmYPQD
QHtRa2DrH7k/lKHhGLdnA0AJ+ZvJbC7KPxDShze7NgJAccJ/jOxy0z8y8v9K
9RkBQC6kk9G0rtk/1C5WasUCAEDlTmgc3zjgP2DDRYfXp/0/lxqGHaFg4z9i
CIMjkHL7PzlyuK8DzOY/2DmtM/UN+T/D15tQbyfqP1Ckk1uGtPY/MYz+PhhJ
7T8Q7h1tg4P0P0fmOt8wV/A/RySV8iwj8j/nLbZF9OzxP4pzYMOE1u8/e/yJ
M7x68z+MEA/RB33rPwcR6GlUKvU/eIaXxuPE5j8FzQVHC732P/S6Z4+XXeI/
+86tbJJx+D+wkCOASC/bP+VXrhkeHvo/iI9oQBLQ0T9BiG5tyK37P/AWek4X
JcI/lf64CUNf/T8AsLGOSBJ6v1scw0zc8/4/sDdGityCwr8MwCvsIlUAQBi/
V5jh19K/ZTWi9VksAUBQfpuMpEHcv3d+eFIg9QFAOOAn7duE4r+F6pPTzs4C
QFwoKKyMR+e/TCoPqAyaA0DwseCXZbnrv42tNsBMYQRAwGQQKnMK8L/KU6P8
dDkFQBKEQxSHZ/K/wM1vjCwDBkAexNIUL5z0v7JqgUDM3QZAtBd1oSoA978e
Sz84brQHQEgyWxb6WPm/Q/9cg598CECUbZ2hXYn7v2TWv/K4VQlAaLzyuBTp
/b8+gYK1YSAKQPwVUvMvEADAkm/xuwznCkBCsUx+PyYBwOKApeafvgtATtZQ
z/hTAsDrZblkwocMQLYLgyt8bQPA8G0SB81hDUDkyr5NqZ4EwK5Jy/xmLQ5A
bpooe6C7BcDmaDA2A/UOQHZNtJwB0wbAGqvak4fND0BEikmEDAIIwINgcqLN
SxBAbNcMd+EcCcD3/BmNS7kQQFqu2S9gTwrAKLuXmcokEUDGaMjcSHwLwDVj
xU8RiRFAjjPllPuUDMDAnBUYzPURQByICxNYxQ3AKMAVik5bEkAG7V+cfuEO
wE0F7B3SvhJAcDXWGQ/4D8Dw2+TDySoTQM8Dq64kkxDAb5yNE4mPE0AU9QHW
JiARwMwBJO9KkRNA9lHMd5wiEcAqZ7rKDJMTQNmulhkSJRHA5DHngZCWE0Cd
aCtd/SkRwFjHQPCXnRNAJdxU5NMzEcBC8vPMpqsTQDnDp/KARxHAFkhahsTH
E0BfkU0P224RwHOt8GGGyRNAQe4XsVBxEcDQEoc9SMsTQCNL4lLGcxHAi92z
9MvOE0DpBHeWsXgRwABzDWPT1RNAcnigHYiCEcDqncA/4uMTQIVf8ys1lhHA
RwNXG6TlE0BnvL3NqpgRwKRo7fZl5xNASRmIbyCbEcBfMxqu6eoTQA/THLML
oBHA1MhzHPHxE0CYRkY64qkRwDEuCviy8xNAeqMQ3FesEcCOk6DTdPUTQFwA
233NrhHASV7Nivj4E0Aium/BuLMRwKbDY2a6+hNABBc6Yy62EcAEKfpBfPwT
QOdzBAWkuBHAYY6QHT7+E0DK0M6mGbsRwL7zJvn//xNArC2ZSI+9EcDi/EIy

     "]]}, 
   {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwVxX081HcAB3APdx7Pw/m5k4d7cD8vifKipunJ92My5KHWhjxUHktNRPWy
okbk4UarLFao1UxaoVk1tHSvMHm4GymheolEoXVIDhfb/ni/3pYR8Vuj1VRU
VHz/8/8lxyI0HKOSXfoDsoO10xi4EDy+NlAYRD4UTl+OO8FAr684USjcQ/R6
I8a6chhI8gjSZwoPk3UhG1IunGHg80aEzghySMHOyZJVpQxUHP8kXS44R/xi
Qge2NzMwEF7JfSu4SuoPO8RU6zGR/MXXYWOCWlJc3HMo5DwT2rNFLbH2rUQY
uzIwsE0DCfe/zR1P7CIL3nVuvNeasC/N77xZ2UtCDaKsfBe18MovxqLf+QVJ
DTVps7bXQaFZJu9S2EuyWKtIafXUxZrEmir19mGy8dLL9ybJLDQ8KdoSv3SU
aMXKw/6+ogfH3AWXJV5viY2HXc8WiT48htf2OwTKCet6PCdFboCRFbfd349P
kCuGE5XOmYZIVuas+vPIFNHYsM43hs2GJvv1nq9sp4mXvVgWW84GU8r00L37
gdQt3e8f4GSEeVlF7JkEBdEbDr5nLDPCq8BKUz5/jggLAmitKAqu2XH7HlTM
kzC/N7kv3lE4u1Cj7bbzI8loS+3NyzJGiEWDz7OpBdK9pcpOyOGAJbEbF/mr
QKdoMCyrkoNop8vTQctV8bHb+hTtzkXSsW+2CqdVITBXayrt5OLEaH6XTKYG
K6vBZ3N7TOBja1DOOq+OAKegOSeFCfIqVkt8whnwdB5gl6UvQeuXPysPrmHC
QiWONWZmCok0Pne5ugaEHadZnHJTVO9NQ/tzDTCj695RrmbgexPnuJua+HVs
qt3jiRncFkPTL6Zo4eiRxqqwSHNEdd+brPHXxkrZuUN+8+ZwSTt+K1yoA66t
hqtljgXOxE/cYY3ooDYpXWOZMQ+Dqb8MX6zXBREzq5jXeBiLro26n8XCVCl/
e/OnfMj3GWlKw/Ugzlj/z/YOPiq92pS7Vuhjc+xERu8OAYZjHFarT+ujy/0P
jnhUALNrfflZUgPwJiWNmq5CpIclXpZ6G2J3U4Lq3SwhZpSmed61hhDNl1aF
PhLC5k7huVYrNuqvvugrEFjCKbJpMzuHjf3PRrIboi0hKeYsaZ9mIz8hobzv
N0vYSDhivxAjyMR/bRpSWMKXOc57WG+E1xZWe7NdRJA/HWposaVwkM2Y54pF
iC/Oo3K+p8AVV+n/2CFCu6rVu02nKWTV/ND/sFME2911rax8Corhwzf0ukQY
chxJO1VAoc9t49b0xyJsa4a8sITChY89Z+P6RPhscqq97BoFmwQ1nvuQCFzP
4MzGZgrrt/nbTc6IcKBCHp7ZQuF65lrl8lkROoyyNni2UeDfEkh3z4nw3fPf
37fJKKgYjcY9V4qgckAvsusxhaa2Y9UPVGmMlkjI4EsKfqR8zUVdGh7qgeal
ryhI9uXp9LFolMa8/RA9QsGhOPGpsT6NnavMKt+MUjCeXX9UbEjj0YMDFhMT
FHqqOyWHODQc7XUU1VMUvAZun77BpXEy/6eug9MU6gyKI8ZMaHjtkIoVCgol
sbsY4WY0yhoid9XNUdAv8n5cZE6DsWzONUVJIbXFoazbgkb4yVM8lwUKEzOc
JDafRv2U9eziIoUI63kPHwGNfwElTBh7
     "]]}, 
   {RGBColor[0.560181, 0.691569, 0.194885], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwd1Hk0lVsfB3BDpqI850mmwzmPJKGuITLE3pklhXt7jSXzkCgNSr0ylCm5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     "]]}, 
   {RGBColor[0.922526, 0.385626, 0.209179], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwd03k01vkXB3Dyfcju8UV4eJj5SWUrkmiMe8s22aaUrJMsZZkmDTVCR8lk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     "]]}, 
   {RGBColor[0.528488, 0.470624, 0.701351], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwV13k8VN0bAHDZUnHHGPsgW/gRUUIqz42QlFSWkrxkiTdb+6aksm+J0mJL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     "]]}, 
   {RGBColor[0.772079, 0.431554, 0.102387], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwV13k4VdsbB/CzzVwJ54SECClFV7kqyvuiDGWoFJJkjsxDGVKGSpRyDaUS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     "]]}, 
   {RGBColor[0.363898, 0.618501, 0.782349], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwVxXk4lHkcAHCMI43rnR9jnPOO962kUqg2nme9P7UlV5eVVR5HqLTJmkkH
ah27rqiWkCLlqOSh1eFpyvEVJYxrp9oV6ZiwiTXuo0m7+8fn+Qj2he8KUVFS
UvL4z//nn96nbhMc7WhXM3LIlkvAlT3DDt6kD8NlTfa5GRLQ7ZEqJMlQRqR4
nB3CI+C4s4+OGnmSeXnlZFeuMQFbGrHvDD+FiVSJjVDjE1AevzZBzs9lkiQ3
PT4uI+BdYAV3hF/KkFuEqjJ7AqJ3/hjwiS9mNA2d3l3yI0Bz7nLzYesWpv/p
0EJuJQERj39OGxZKGeZ5/Yw2iwPWxZld9yq6GVbVL3UBuznQv+2g6ZsNbxle
Nuf3oHscyDFONLsWIGOazgzFe+gisBc+uM2SDDAsccY6rUgEDX9e3hG+bIgZ
zXKNmOlBYJO24MhzGWFOnT/SHO2oD84DDm/WeMuZZFFJVm+ZPgyuqto8OTzG
zM/QF+30DSBakWJXHTXBBO8gt4fHGIAG8Xfo91ZTTJ+TMffcqAGotak5s2um
mV7f4ux6Xy58bi8/nBExy6h4bZQOP+dCv3eFkbn5PNNuKT570d0QnJKPhD0r
/8ys6hE+ya8xhKyFB5qb/L8wXg12oiJ7Huw1bXDvnVhgONMjfqUVPNCCFcMW
Xkq4QiHEYG0EIesKp3xWKuOU9K5kcbkRHD99Yhc5pYxFq3UEtkuM4dehTGl7
uwq2j/DUb7xhDO5Wuje1LrEwVRlM5FiYQHr5enAPVMUCy3rVjssm0OJZpDhq
r4b/aaGOLydNAdrC01ay1LGnekLy4TxTuHMoDkteq+OwidjmPsoMzN2YDUfu
aeCSG6ZlmaVmsOmrb0JBzCJcNRGdM7jUHIJf1o0/8NLEKgWyLNFtc3CMi78f
SC7GlQ/vPIpazYeM8LFHWoOL8a193zjHlPPhfWzJQEEtG/eks139TUj4FCIO
fpykhWMROVC0lwR5GEejLVAbPw3qrEu/RkKFS6ti/yodHHNX3KQtI2Hg4Jr1
rCkdfKXsWNwxSgDGZa8yk9p0cXXj4J7kUAEkBAgL29z0cOpSQatpmQBmFEbp
bmI93DXLDvcbF4Dlo5zcFprAk7pX/eI3WMC6oCfbiRQCZ43WafKiLADyDHiS
KQJnG73a71dvAZZgkLptLwdPuuAlOqoUeKgNm/1Ry8HswZyQc5spkPd8aGi2
QljEa7nQmEZBeF46SjmH8O4X36Xs7qBAokyPuv6GcOVPHVqxnRRYHXjYopWJ
sI92UUZpFwUfbAbjzmcj7JxMlSikFPzQhOU5+Qg3OJzqL/yLgo3jE5LrZQg7
FNhIR99RwN26J7GxCWEUfcH/zCQFonJ5YGIzwl62B1bcn6Kgk5P07dZWhCO1
I+f6pik48/ruZGs7wi1ROM92jgIlkXaQ9AXCGltTFd1fKBjKB+a9DOGRqtRl
yzVocGZ5mxT3I2xY3cv1XERD8cGR6ZBBhO34QYtOadLgb2dc8XEI4bCd7PFO
Ng3Pn4lMx8YQ7r5V8+aEHg021otn70wg3CG7/raQoOFs5lXp0SmEqwX1MgmH
Bhe/ttTZWYTlykly0oCG6w1B+x/OI7y2w2belUuD6vJ5pxgFwqEzbPVIQxoC
z543c1xAeJuegX4Bj4baiaVzX78iXHvbnW42ouFfRM1Agw==
     "]]}, 
   {RGBColor[1, 0.75, 0], AbsoluteThickness[1.6], Opacity[1.], 
    LineBox[CompressedData["
1:eJwVxX081HcAB3DccZzj3P2i8/y1V5tSeqXSK618P8tKeYpa81RxHkqFe3l4
pRBJESnVrXoJlYekOG2lrVKyyOOxcWuoWY+IWIdE6Gz74/16WwVJNodqqKmp
uf/n//OTgrTsQhIc1atGPXVS2LjoN7TKm/jSxvWzK1enstHtnhlNyG6a4pBf
KjnKRpyzr74mOUA3JHEtujLYWF+HbROWGfTourk7bpxhQ3Z4earSMode7w4z
iitm46W4wmjY8hp9Jp9O3dPIRoLX3sB3lnepLDJnzVOBJnQ+5TaFL26moW1D
+7t+0UTUo+SsoWgFNR64sKfGTwuLi6XtlRXdtKCcTIWqc9DrEWb2fOUL2hK+
+tneBxycN0kzLwh8TRf4DB2iMdpwiL5zgyXvo0U3V/fdd9RBbWeup8R6kMaH
l2+X8riwy1I5ijYO03PiD3p57Vw49616vsRbScusg0q2l+ui3/bndR+GRmj2
EnGZ7kEeEmYylt2PH6PBL72NU931wBG83f2dzTj1qXO9+miZPjRbNZ11H3yk
W6YCSq31+Zhuk4WfiZqkBYO5VkkqPnq9K4wtLKaoWdO38sF9BvjmWGREo2ya
xieoNJT9BjiruqPjFPCZFgU//HE8WAB/s1q3v8ZUNODcgbzpLgF4NQuHvtiq
hpk81UGhrxCh9oXjvovU0Wm7vV63S4i4pP2bybg6fv0tZ8eRTQyODkoVbW0a
SBc89zLqYOBmwy/lXWAhykvpMeA2BydkK2rcxGxIGt3WWtXPQfOWoplYB018
vfdGZYKLIWpaJVmLWFq4XKJfX11viJt7UiDv0cI9KY9j52EEC1e6MrKSg1Hn
0re9CiM4zW5LvZSoDdYPnCcOXnMR8ufD0TtbdbCJShSPu+fCMeXwbTHhQuXn
+EnuK8IZyUgVr5+LCY3aI22dIrw6dKXvUrUuWPcL2w3ExngXejfkUToPbg0t
OhdeGkMZIeS0ivXQtWvRg4gIE1RsbJnZaauPdZxZeYTSBH1hS1awxvWRMbEf
NMoUJmVPpemtfNQt8B8L+myK1MDowlZXAwQOtyqOHzLDxIzxCde7BvjndJEp
n2+O+VXnc5rnCbC8pmXq+1xz2Ac/3iTIEGBfsq7XYQsL1OQZiuTjAhxQUF2+
zALzawwzPfyFsF/OOxa51BLumkPmHdVCBEVWaUfdtoTy2ZvaJhsGOW+zbw1b
EUjyTjAZ2QwSr3BLk0MI5Orz3rucZtCJswuvhRLY7LrXzJMySO4J+6ljJ8Eb
u/6UU+cYRPgM1H65m8CnAcrz+QwGuE5seQTB2tExeUkZg0DJxIgojsBog19a
XQMDB1e/pMoMghiZUpzWxCBBw9bl70yC34Xpaza0MMjtWSXSziI43nPrQ0sb
gxEXrSr/kwRqMXrBiicMbEWepiwpwWB+DX31mgGT7rl+cx6BM8vbtLiXwZqs
QvvEfILisOGPof0MfN/Pty65SBCwzKRiYJCB1KrdYOoywR+NMWYjIwxm41NV
BVcI7BZzJ2+OMRi/FT7bUkJwUnpZETvO4NVImsbHqwQbd7RmTk4yMOpw47tc
JyipDd55b4qB36UJUWwZAXvB1DeJMwyyG9rnXSwnEJ88Ze6oYhD74unSRhlB
9dhXn2ZnGbxJFjqNVhD8C5XMIcA=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{False, False},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{
     FormBox["\"Energy (GHz)\"", TraditionalForm], None}, {
     FormBox["\"Magnetic field (kG)\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{"DefaultBoundaryStyle" -> Automatic, "ScalingFunctions" -> None},
  PlotRange->{{0, 5}, {-10.05036271511187, 9.561128854186965}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellLabel->"Out[10]=",
 CellID->91062980,ExpressionUUID->"1764100d-ead9-431a-891c-ee5fc9963a78"]
}, Open  ]],

Cell["\<\
The eigenvectors are the eigenstates in the presence of the magnetic field, \
written as a linear combination of the original sublevels. However, they are \
not listed in the order corresponding to the original sublevels. Here we \
reorder the eigenvalues and eigenvectors so that they match the unperturbed \
quantities when the magnetic field approaches zero.\
\>", "Text",
 CellID->271683158,ExpressionUUID->"1e40c2d2-c0cb-4d8d-a9e5-93fd911a42dd"],

Cell["\<\
Normalize the eigenvectors and take the limit as the magnetic field goes to \
zero.\
\>", "MathCaption",
 CellID->42403709,ExpressionUUID->"1612c9a9-a35b-490c-81fa-da5ba25f436c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"states1", "=", 
  RowBox[{"Limit", "[", 
   RowBox[{
    RowBox[{"Normalize", "/@", "states"}], ",", 
    RowBox[{"\[CapitalOmega]", "\[Rule]", "0"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"hfa", ">", "0"}]}], ",", 
    RowBox[{"Direction", "\[Rule]", 
     RowBox[{"-", "1"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[11]:=",
 CellID->322673577,ExpressionUUID->"8907592f-a866-42c9-891e-6bde3a93a25f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}]}], "}"}]], "Output",
 CellLabel->"Out[11]=",
 CellID->1489759700,ExpressionUUID->"5d3602ed-296d-4fc5-82b6-eac26ba6f26d"]
}, Open  ]],

Cell["\<\
Reorder the eigenvalues and eigenvectors to match the unperturbed eigenvalues \
and eigenvectors.\
\>", "MathCaption",
 CellID->589835931,ExpressionUUID->"b9427fde-4c87-4475-8ea7-4e260e5b8515"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "/@", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"orderedEnergies", ",", "orderedStates"}], "}"}], "=", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
        "energies", "\[LeftDoubleBracket]", "#", "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{
        "states", "\[LeftDoubleBracket]", "#", "\[RightDoubleBracket]"}]}], 
       "}"}], "&"}], "@", 
     RowBox[{"Reverse", "@", 
      RowBox[{"Ordering", "[", "states1", "]"}]}]}]}], ")"}]}]], "Input",
 CellLabel->"In[12]:=",
 CellID->429623164,ExpressionUUID->"8fd0889c-e51b-4411-8cd7-19653a00ea60"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"3", " ", "hfa"}], "+", 
            RowBox[{"4", " ", "\[CapitalOmega]"}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "hfa"}], "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["hfa", "2"], "+", 
               RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
               SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "hfa"}], "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["hfa", "2"], "+", 
               SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "hfa"}], "+", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["hfa", "2"], "-", 
               RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
               SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"3", " ", "hfa"}], "-", 
            RowBox[{"4", " ", "\[CapitalOmega]"}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "hfa"}], "-", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["hfa", "2"], "+", 
               RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
               SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "hfa"}], "-", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["hfa", "2"], "+", 
               SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "hfa"}], "-", 
            RowBox[{"4", " ", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["hfa", "2"], "-", 
               RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
               SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], ")"}]}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.5599999999999999]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      Column], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0", "0", "0", "0", "0"},
       {"0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox["3"], " ", "hfa"}], "-", 
           RowBox[{
            SqrtBox["3"], " ", "\[CapitalOmega]"}], "-", 
           RowBox[{"2", " ", 
            SqrtBox["3"], " ", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["hfa", "2"], "+", 
              RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], 
          RowBox[{"3", " ", "\[CapitalOmega]"}]]}], "0", "0", "0", "1", "0", 
        "0"},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", "hfa"}], "-", 
           SqrtBox[
            RowBox[{
             SuperscriptBox["hfa", "2"], "+", 
             SuperscriptBox["\[CapitalOmega]", "2"]}]]}], 
          "\[CapitalOmega]"]}], "0", "0", "0", "1", "0"},
       {"0", "0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox["3"], " ", "hfa"}], "+", 
           RowBox[{
            SqrtBox["3"], " ", "\[CapitalOmega]"}], "-", 
           RowBox[{"2", " ", 
            SqrtBox["3"], " ", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["hfa", "2"], "-", 
              RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], 
          RowBox[{"3", " ", "\[CapitalOmega]"}]]}], "0", "0", "0", "1"},
       {"0", "0", "0", "0", "1", "0", "0", "0"},
       {"0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox["3"], " ", "hfa"}], "-", 
           RowBox[{
            SqrtBox["3"], " ", "\[CapitalOmega]"}], "+", 
           RowBox[{"2", " ", 
            SqrtBox["3"], " ", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["hfa", "2"], "+", 
              RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], 
          RowBox[{"3", " ", "\[CapitalOmega]"}]]}], "0", "0", "0", "1", "0", 
        "0"},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", "hfa"}], "+", 
           SqrtBox[
            RowBox[{
             SuperscriptBox["hfa", "2"], "+", 
             SuperscriptBox["\[CapitalOmega]", "2"]}]]}], 
          "\[CapitalOmega]"]}], "0", "0", "0", "1", "0"},
       {"0", "0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SqrtBox["3"], " ", "hfa"}], "+", 
           RowBox[{
            SqrtBox["3"], " ", "\[CapitalOmega]"}], "+", 
           RowBox[{"2", " ", 
            SqrtBox["3"], " ", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["hfa", "2"], "-", 
              RowBox[{"hfa", " ", "\[CapitalOmega]"}], "+", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]]}]}], 
          RowBox[{"3", " ", "\[CapitalOmega]"}]]}], "0", "0", "0", "1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellLabel->"Out[12]=",
 CellID->1955648467,ExpressionUUID->"43d61d22-2000-4b39-8b3c-f2d3d3f4bf22"]
}, Open  ]],

Cell["\<\
We can use the correctly ordered energies to plot the level diagram for the \
modified energy eigenstates in the presence of the magnetic field. \
\>", "Text",
 CellID->50099780,ExpressionUUID->"c15ca15c-3ee7-46a1-b526-7acf99de2081"],

Cell["Here is the level diagram with an adjustable magnetic field.", \
"MathCaption",
 CellID->88210042,ExpressionUUID->"712b2708-01d3-404a-a7d3-8d67f5ae93cf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"system", "=", "system"}], ",", 
     RowBox[{"energies", "=", 
      RowBox[{"orderedEnergies", "/.", 
       RowBox[{"hfa", "\[Rule]", ".5"}]}]}]}], "}"}], ",", 
   RowBox[{"Manipulate", "[", 
    RowBox[{
     RowBox[{"LevelDiagram", "[", 
      RowBox[{"system", ",", "energies", ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "3"}], ",", "3"}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[CapitalOmega]", ",", ".1"}], "}"}], ",", 
       RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
     RowBox[{"Alignment", "\[Rule]", "Center"}], ",", 
     RowBox[{"SaveDefinitions", "\[Rule]", "True"}]}], "]"}]}], 
  "]"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->271690114,ExpressionUUID->"a2d1664f-42fe-4c18-b207-7efae4ca6187"],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`\[CapitalOmega]$$ = 0.1, Typeset`show$$ = 
    True, Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`\[CapitalOmega]$$], 0.1}, -2, 2}}, Typeset`size$$ = {
    180., {105., 110.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = False, $CellContext`\[CapitalOmega]$5166$$ = 0}, 
    
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`\[CapitalOmega]$$ = 0.1}, 
      "ControllerVariables" :> {
        Hold[$CellContext`\[CapitalOmega]$$, \
$CellContext`\[CapitalOmega]$5166$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> 
      AtomicDensityMatrix`LevelDiagram[{
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> Rational[1, 2], AtomicDensityMatrix`L -> 
          0, AtomicDensityMatrix`S -> Rational[1, 2], 
          AtomicDensityMatrix`Energy -> 0, AtomicDensityMatrix`NuclearSpin -> 
          Rational[3, 2], AtomicDensityMatrix`F -> 2, AtomicDensityMatrix`M -> 
          2], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> Rational[1, 2], AtomicDensityMatrix`L -> 
          0, AtomicDensityMatrix`S -> Rational[1, 2], 
          AtomicDensityMatrix`Energy -> 0, AtomicDensityMatrix`NuclearSpin -> 
          Rational[3, 2], AtomicDensityMatrix`F -> 2, AtomicDensityMatrix`M -> 
          1], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> Rational[1, 2], AtomicDensityMatrix`L -> 
          0, AtomicDensityMatrix`S -> Rational[1, 2], 
          AtomicDensityMatrix`Energy -> 0, AtomicDensityMatrix`NuclearSpin -> 
          Rational[3, 2], AtomicDensityMatrix`F -> 2, AtomicDensityMatrix`M -> 
          0], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> Rational[1, 2], AtomicDensityMatrix`L -> 
          0, AtomicDensityMatrix`S -> Rational[1, 2], 
          AtomicDensityMatrix`Energy -> 0, AtomicDensityMatrix`NuclearSpin -> 
          Rational[3, 2], AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> -1], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> Rational[1, 2], AtomicDensityMatrix`L -> 
          0, AtomicDensityMatrix`S -> Rational[1, 2], 
          AtomicDensityMatrix`Energy -> 0, AtomicDensityMatrix`NuclearSpin -> 
          Rational[3, 2], AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> -2], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> Rational[1, 2], AtomicDensityMatrix`L -> 
          0, AtomicDensityMatrix`S -> Rational[1, 2], 
          AtomicDensityMatrix`Energy -> 0, AtomicDensityMatrix`NuclearSpin -> 
          Rational[3, 2], AtomicDensityMatrix`F -> 1, AtomicDensityMatrix`M -> 
          1], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> Rational[1, 2], AtomicDensityMatrix`L -> 
          0, AtomicDensityMatrix`S -> Rational[1, 2], 
          AtomicDensityMatrix`Energy -> 0, AtomicDensityMatrix`NuclearSpin -> 
          Rational[3, 2], AtomicDensityMatrix`F -> 1, AtomicDensityMatrix`M -> 
          0], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> Rational[1, 2], AtomicDensityMatrix`L -> 
          0, AtomicDensityMatrix`S -> Rational[1, 2], 
          AtomicDensityMatrix`Energy -> 0, AtomicDensityMatrix`NuclearSpin -> 
          Rational[3, 2], AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> -1]}, {
        Rational[1, 4] (1.5 + 4 $CellContext`\[CapitalOmega]$$), 
         Rational[1, 4] (-0.5 + 
          4 (0.25 + 
             0.5 $CellContext`\[CapitalOmega]$$ + \
$CellContext`\[CapitalOmega]$$^2)^Rational[1, 2]), 
         Rational[1, 4] (-0.5 + 
          4 (0.25 + $CellContext`\[CapitalOmega]$$^2)^Rational[1, 2]), 
         Rational[1, 4] (-0.5 + 
          4 (0.25 - 
             0.5 $CellContext`\[CapitalOmega]$$ + \
$CellContext`\[CapitalOmega]$$^2)^Rational[1, 2]), 
         Rational[1, 4] (1.5 - 4 $CellContext`\[CapitalOmega]$$), 
         Rational[1, 4] (-0.5 - 
          4 (0.25 + 
            
            0.5 $CellContext`\[CapitalOmega]$$ + \
$CellContext`\[CapitalOmega]$$^2)^Rational[1, 2]), 
         Rational[1, 4] (-0.5 - 
          4 (0.25 + $CellContext`\[CapitalOmega]$$^2)^Rational[1, 2]), 
         Rational[1, 4] (-0.5 - 
          4 (0.25 - 
            0.5 $CellContext`\[CapitalOmega]$$ + \
$CellContext`\[CapitalOmega]$$^2)^Rational[1, 2])}, PlotRange -> {-3, 3}, 
        ImageSize -> Small], 
      "Specifications" :> {{{$CellContext`\[CapitalOmega]$$, 0.1}, -2, 2}}, 
      "Options" :> {Alignment -> Center}, "DefaultOptions" :> {}],
     ImageSizeCache->{244., {149., 155.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>({AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, 
         AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`LevelDiagram`Private`sys], 
         AtomicDensityMatrix`ZeroMatrix[
          Length[AtomicDensityMatrix`LevelDiagram`Private`sys]], 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
          Except[
           PatternTest[
            Blank[], MatchQ[
             Flatten[{#}], {
              RepeatedNull[
               Alternatives[
                Blank[Rule], 
                Blank[RuleDelayed]]]}]& ]]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, 
         AtomicDensityMatrix`LevelDiagram`Private`h, 
         AtomicDensityMatrix`ZeroMatrix[
          Length[AtomicDensityMatrix`LevelDiagram`Private`sys]], 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`energies, 
           Blank[]], VectorQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
          Except[
           PatternTest[
            Blank[], MatchQ[
             Flatten[{#}], {
              RepeatedNull[
               Alternatives[
                Blank[Rule], 
                Blank[RuleDelayed]]]}]& ]]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, 
         DiagonalMatrix[AtomicDensityMatrix`LevelDiagram`Private`energies], 
         AtomicDensityMatrix`LevelDiagram`Private`rho, 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
          Except[
           PatternTest[
            Blank[], MatchQ[
             Flatten[{#}], {
              RepeatedNull[
               Alternatives[
                Blank[Rule], 
                Blank[RuleDelayed]]]}]& ]]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pops, {
           Repeated[
            PatternTest[
             Blank[], NumericQ]]}], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, 
         AtomicDensityMatrix`LevelDiagram`Private`h, 
         DiagonalMatrix[AtomicDensityMatrix`LevelDiagram`Private`pops], 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
           Blank[]], AtomicDensityMatrix`OperatorQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
           Blank[]], AtomicDensityMatrix`OperatorQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`LevelDiagram[
        AtomicDensityMatrix`LevelDiagram`Private`sys, {{
          AtomicDensityMatrix`LevelDiagram`Private`h, 
           
           FilterRules[{AtomicDensityMatrix`LevelDiagram`Private`opts}, 
            AtomicDensityMatrix`ExtraArrows]}}, 
         AtomicDensityMatrix`LevelDiagram`Private`rho, 
         AtomicDensityMatrix`LevelDiagram`Private`opts], 
       AtomicDensityMatrix`LevelDiagram[
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`hlist, {
           Repeated[{
             PatternTest[
              Blank[], AtomicDensityMatrix`OperatorQ], 
             PatternTest[
              BlankNullSequence[], MatchQ[
               Flatten[{#}], {
                RepeatedNull[
                 Alternatives[
                  Blank[Rule], 
                  Blank[RuleDelayed]]]}]& ]}]}], 
         PatternTest[
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
           Blank[]], AtomicDensityMatrix`OperatorQ], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`\
quantumNumberSubscripts = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, 
            AtomicDensityMatrix`QuantumNumberSubscripts, 
            OptionValue[AtomicDensityMatrix`QuantumNumberSubscripts]], 
          AtomicDensityMatrix`LevelDiagram`Private`levelLength = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, AtomicDensityMatrix`LevelLength, 
            
            OptionValue[AtomicDensityMatrix`LevelLength]], 
          AtomicDensityMatrix`LevelDiagram`Private`levelSpacing = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, AtomicDensityMatrix`LevelSpacing, 
            OptionValue[AtomicDensityMatrix`LevelSpacing]], 
          AtomicDensityMatrix`LevelDiagram`Private`parityOffset = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, AtomicDensityMatrix`ParityOffset, 
            OptionValue[AtomicDensityMatrix`ParityOffset]], 
          AtomicDensityMatrix`LevelDiagram`Private`levelOffset = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, AtomicDensityMatrix`LevelOffset, 
            
            OptionValue[AtomicDensityMatrix`LevelOffset]], 
          AtomicDensityMatrix`LevelDiagram`Private`levelStyle = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, AtomicDensityMatrix`LevelStyle, 
            OptionValue[AtomicDensityMatrix`LevelStyle]], 
          AtomicDensityMatrix`LevelDiagram`Private`mLabel = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, AtomicDensityMatrix`MLabel, 
            OptionValue[AtomicDensityMatrix`MLabel]], 
          AtomicDensityMatrix`LevelDiagram`Private`mLabelPosition = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, 
            AtomicDensityMatrix`MLabelPosition, 
            OptionValue[AtomicDensityMatrix`MLabelPosition]], 
          AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSymbols = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, 
            AtomicDensityMatrix`QuantumNumberSymbols, 
            OptionValue[AtomicDensityMatrix`QuantumNumberSymbols]], 
          AtomicDensityMatrix`LevelDiagram`Private`labelStyle = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, LabelStyle, 
            OptionValue[LabelStyle]], 
          AtomicDensityMatrix`LevelDiagram`Private`minLabelSpacing = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, 
            AtomicDensityMatrix`MinLabelSpacing, 
            OptionValue[AtomicDensityMatrix`MinLabelSpacing]], 
          AtomicDensityMatrix`LevelDiagram`Private`fLabel = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, AtomicDensityMatrix`FLabel, 
            OptionValue[AtomicDensityMatrix`FLabel]], 
          AtomicDensityMatrix`LevelDiagram`Private`jLabel = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, AtomicDensityMatrix`JLabel, 
            OptionValue[AtomicDensityMatrix`JLabel]], 
          AtomicDensityMatrix`LevelDiagram`Private`stateLabel = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, AtomicDensityMatrix`StateLabel, 
            OptionValue[AtomicDensityMatrix`StateLabel]], 
          AtomicDensityMatrix`LevelDiagram`Private`stateLabelPosition = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, 
            AtomicDensityMatrix`StateLabelPosition, 
            OptionValue[AtomicDensityMatrix`StateLabelPosition]], 
          AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, AtomicDensityMatrix`ArrowSpacing, 
            OptionValue[AtomicDensityMatrix`ArrowSpacing]], 
          AtomicDensityMatrix`LevelDiagram`Private`populationFunction = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, 
            AtomicDensityMatrix`PopulationFunction, 
            OptionValue[AtomicDensityMatrix`PopulationFunction]], 
          AtomicDensityMatrix`LevelDiagram`Private`populationStyle = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, 
            AtomicDensityMatrix`PopulationStyle, 
            OptionValue[AtomicDensityMatrix`PopulationStyle]], 
          AtomicDensityMatrix`LevelDiagram`Private`stateLabels, 
          AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          AtomicDensityMatrix`LevelDiagram`Private`textOnTop = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram, AtomicDensityMatrix`TextOnTop, 
            OptionValue[AtomicDensityMatrix`TextOnTop]], 
          AtomicDensityMatrix`LevelDiagram`Private`jflabels, 
          AtomicDensityMatrix`LevelDiagram`Private`levels, 
          AtomicDensityMatrix`LevelDiagram`Private`mlabels, 
          AtomicDensityMatrix`LevelDiagram`Private`populations, 
          AtomicDensityMatrix`LevelDiagram`Private`levelPositions, 
          AtomicDensityMatrix`LevelDiagram`Private`width, 
          AtomicDensityMatrix`LevelDiagram`Private`xmax, 
          AtomicDensityMatrix`LevelDiagram`Private`xmin, 
          AtomicDensityMatrix`LevelDiagram`Private`ymax, 
          AtomicDensityMatrix`LevelDiagram`Private`ymin, 
          AtomicDensityMatrix`LevelDiagram`Private`height, 
          AtomicDensityMatrix`LevelDiagram`Private`defaultArrowStyle, 
          AtomicDensityMatrix`LevelDiagram`Private`defaultPopulationStyle, 
          AtomicDensityMatrix`LevelDiagram`Private`subscripts}, 
         Condition[
         AtomicDensityMatrix`LevelDiagram`Private`subscripts = 
           AtomicDensityMatrix`LevelDiagram`Private`UnrollOption[
            AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSubscripts, 
             3]; AtomicDensityMatrix`LevelDiagram`Private`stateLabels = 
           Union[
             AtomicDensityMatrix`StateLabel[
             AtomicDensityMatrix`LevelDiagram`Private`sys]]; {
            AtomicDensityMatrix`LevelDiagram`Private`levelPositions, 
             AtomicDensityMatrix`LevelDiagram`Private`xmin, 
             AtomicDensityMatrix`LevelDiagram`Private`xmax, 
             AtomicDensityMatrix`LevelDiagram`Private`width, 
             AtomicDensityMatrix`LevelDiagram`Private`ymin, 
             AtomicDensityMatrix`LevelDiagram`Private`ymax, 
             AtomicDensityMatrix`LevelDiagram`Private`height} = 
           AtomicDensityMatrix`LevelDiagram`Private`findLevelPositions[
            AtomicDensityMatrix`LevelDiagram`Private`sys, 
             First[
              First[AtomicDensityMatrix`LevelDiagram`Private`hlist]], 
             AtomicDensityMatrix`LevelDiagram`Private`stateLabels, 
             AtomicDensityMatrix`LevelDiagram`Private`levelLength, 
             AtomicDensityMatrix`LevelDiagram`Private`levelSpacing, 
             AtomicDensityMatrix`LevelDiagram`Private`parityOffset, 
             AtomicDensityMatrix`LevelDiagram`Private`levelOffset]; 
          AtomicDensityMatrix`LevelDiagram`Private`levels = 
           AtomicDensityMatrix`LevelDiagram`Private`makeLevels[
            AtomicDensityMatrix`LevelDiagram`Private`levelPositions, 
             AtomicDensityMatrix`LevelDiagram`Private`levelStyle, 
             AtomicDensityMatrix`LevelDiagram`Private`levelLength]; 
          AtomicDensityMatrix`LevelDiagram`Private`mlabels = 
           AtomicDensityMatrix`LevelDiagram`Private`makeMLabels[
            AtomicDensityMatrix`LevelDiagram`Private`sys, 
             AtomicDensityMatrix`LevelDiagram`Private`stateLabels, 
             AtomicDensityMatrix`LevelDiagram`Private`levelPositions, 
             AtomicDensityMatrix`LevelDiagram`Private`ymin, 
             AtomicDensityMatrix`LevelDiagram`Private`ymax, 
             AtomicDensityMatrix`LevelDiagram`Private`height, 
             AtomicDensityMatrix`LevelDiagram`Private`mLabel, 
             AtomicDensityMatrix`LevelDiagram`Private`mLabelPosition, 
             Part[
             AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSymbols, 
              3], 
             Part[AtomicDensityMatrix`LevelDiagram`Private`subscripts, 3], 
             AtomicDensityMatrix`LevelDiagram`Private`labelStyle]; 
          AtomicDensityMatrix`LevelDiagram`Private`jflabels = 
           AtomicDensityMatrix`LevelDiagram`Private`makeJFLabels[
            AtomicDensityMatrix`LevelDiagram`Private`sys, 
             AtomicDensityMatrix`LevelDiagram`Private`levelPositions, 
             AtomicDensityMatrix`LevelDiagram`Private`xmin, 
             AtomicDensityMatrix`LevelDiagram`Private`xmax, 
             AtomicDensityMatrix`LevelDiagram`Private`stateLabels, 
             AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSymbols, 
             AtomicDensityMatrix`LevelDiagram`Private`subscripts, 
             AtomicDensityMatrix`LevelDiagram`Private`labelStyle, 
             AtomicDensityMatrix`LevelDiagram`Private`levelLength, 
             First[AtomicDensityMatrix`LevelDiagram`Private`levelSpacing], 
             AtomicDensityMatrix`LevelDiagram`Private`minLabelSpacing, 
             AtomicDensityMatrix`LevelDiagram`Private`fLabel, 
             AtomicDensityMatrix`LevelDiagram`Private`jLabel, 
             AtomicDensityMatrix`LevelDiagram`Private`mLabel, 
             AtomicDensityMatrix`LevelDiagram`Private`stateLabel, 
             AtomicDensityMatrix`LevelDiagram`Private`stateLabelPosition]; 
          AtomicDensityMatrix`LevelDiagram`Private`arrows = Apply[Join, 
             Map[
             AtomicDensityMatrix`LevelDiagram`Private`setUpArrows[
              AtomicDensityMatrix`LevelDiagram`Private`sys, 
               First[#], AtomicDensityMatrix`LevelDiagram`Private`rho, 
               AtomicDensityMatrix`LevelDiagram`Private`levelPositions, 
               FilterRules[{
                 Rest[#], 
                 FilterRules[{AtomicDensityMatrix`LevelDiagram`Private`opts, 
                   Options[AtomicDensityMatrix`LevelDiagram]}, 
                  Except[AtomicDensityMatrix`ExtraArrows]]}, 
                Options[
                AtomicDensityMatrix`LevelDiagram`Private`setUpArrows]]]& , 
              AtomicDensityMatrix`LevelDiagram`Private`hlist]]; 
          AtomicDensityMatrix`LevelDiagram`Private`arrows = 
           AtomicDensityMatrix`LevelDiagram`Private`adjustArrows[
            AtomicDensityMatrix`LevelDiagram`Private`arrows, 
             AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing, 
             AtomicDensityMatrix`LevelDiagram`Private`levelLength]; 
          AtomicDensityMatrix`LevelDiagram`Private`arrows = 
           ReplaceAll[
            AtomicDensityMatrix`LevelDiagram`Private`arrows, 
             AtomicDensityMatrix`LevelDiagram`Private`arf -> (#3[#, #2]& )]; 
          AtomicDensityMatrix`LevelDiagram`Private`populations = 
           AtomicDensityMatrix`LevelDiagram`Private`makePopulations[
            AtomicDensityMatrix`LevelDiagram`Private`rho, 
             AtomicDensityMatrix`LevelDiagram`Private`levelPositions, 
             AtomicDensityMatrix`LevelDiagram`Private`populationFunction, 
             AtomicDensityMatrix`LevelDiagram`Private`populationStyle, 
             AtomicDensityMatrix`LevelDiagram`Private`levelLength]; 
          AtomicDensityMatrix`LevelDiagram`Private`defaultArrowStyle = 
           Directive[
             RGBColor[0.9, 0.01, 0.01], 
             
             Arrowheads[({-0.2, 0.2} 
               AtomicDensityMatrix`LevelDiagram`Private`levelLength)/
              AtomicDensityMatrix`LevelDiagram`Private`width]]; 
          AtomicDensityMatrix`LevelDiagram`Private`defaultPopulationStyle = 
           Directive[
             EdgeForm[
              Hue[0.61, 0.54, 0.56]], 
             FaceForm[]]; 
          If[AtomicDensityMatrix`LevelDiagram`Private`textOnTop, 
            AtomicDensityMatrix`TextOnTop, Identity][
            
            Graphics[{
             AtomicDensityMatrix`LevelDiagram`Private`levels, 
              AtomicDensityMatrix`LevelDiagram`Private`mlabels, 
              AtomicDensityMatrix`LevelDiagram`Private`jflabels, {
              AtomicDensityMatrix`LevelDiagram`Private`defaultPopulationStyle,
                AtomicDensityMatrix`LevelDiagram`Private`populations}, {
              AtomicDensityMatrix`LevelDiagram`Private`defaultArrowStyle, 
               AtomicDensityMatrix`LevelDiagram`Private`arrows}}, 
             DeleteCases[
              FilterRules[
               Join[{AtomicDensityMatrix`LevelDiagram`Private`opts}, 
                Options[AtomicDensityMatrix`LevelDiagram]], 
               Options[Graphics]], 
              Apply[Alternatives, 
               Options[Graphics]]]]], 
          
          FreeQ[{{AtomicDensityMatrix`LevelDiagram`Private`\
quantumNumberSubscripts, AtomicDensityMatrix`LevelDiagram`Private`levelLength,
              AtomicDensityMatrix`LevelDiagram`Private`levelSpacing, 
             AtomicDensityMatrix`LevelDiagram`Private`parityOffset, 
             AtomicDensityMatrix`LevelDiagram`Private`levelOffset, 
             AtomicDensityMatrix`LevelDiagram`Private`levelStyle, 
             AtomicDensityMatrix`LevelDiagram`Private`mLabel, 
             AtomicDensityMatrix`LevelDiagram`Private`mLabelPosition, 
             AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSymbols, 
             AtomicDensityMatrix`LevelDiagram`Private`labelStyle, 
             AtomicDensityMatrix`LevelDiagram`Private`minLabelSpacing, 
             AtomicDensityMatrix`LevelDiagram`Private`fLabel, 
             AtomicDensityMatrix`LevelDiagram`Private`jLabel, 
             AtomicDensityMatrix`LevelDiagram`Private`stateLabel, 
             AtomicDensityMatrix`LevelDiagram`Private`stateLabelPosition, 
             AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing, 
             AtomicDensityMatrix`LevelDiagram`Private`populationFunction, 
             AtomicDensityMatrix`LevelDiagram`Private`populationStyle, 
             AtomicDensityMatrix`LevelDiagram`Private`textOnTop}}, $Failed]]],
        Options[AtomicDensityMatrix`LevelDiagram] = {
        AtomicDensityMatrix`ArrowStyle -> {}, 
         AtomicDensityMatrix`ArrowSpacing -> 0.1, 
         AtomicDensityMatrix`ExtraArrows -> {}, 
         AtomicDensityMatrix`LevelStyle -> {}, 
         AtomicDensityMatrix`LevelLength -> 0.8, 
         AtomicDensityMatrix`LevelSpacing -> 0.2, AtomicDensityMatrix`MLabel -> 
         None, AtomicDensityMatrix`MLabelPosition -> Automatic, 
         AtomicDensityMatrix`FLabel -> None, AtomicDensityMatrix`JLabel -> 
         None, AtomicDensityMatrix`StateLabel -> None, 
         AtomicDensityMatrix`StateLabelPosition -> Left, LabelStyle -> {}, 
         AtomicDensityMatrix`MinLabelSpacing -> 0.3, 
         AtomicDensityMatrix`ParityOffset -> Automatic, 
         AtomicDensityMatrix`LevelOffset -> None, 
         AtomicDensityMatrix`MaxArcSlope -> 0.2, 
         AtomicDensityMatrix`ArcRadius -> -0.5, 
         AtomicDensityMatrix`SuppressOffResonantCouplings -> True, 
         AtomicDensityMatrix`AllowedCouplings -> All, 
         AtomicDensityMatrix`PopulationFunction -> Automatic, 
         AtomicDensityMatrix`PopulationStyle -> {}, 
         AtomicDensityMatrix`ArrowFunction -> Automatic, 
         AtomicDensityMatrix`ArrowOffset -> {0, 0}, 
         AtomicDensityMatrix`ArrowSetback -> 0, 
         AtomicDensityMatrix`QuantumNumberSymbols -> {
          AtomicDensityMatrix`J, AtomicDensityMatrix`F, 
           AtomicDensityMatrix`M}, 
         AtomicDensityMatrix`QuantumNumberSubscripts -> {True, True, False}, 
         AtomicDensityMatrix`TextOnTop -> True, ImageSize -> {{350}, {100}}, 
         AlignmentPoint -> Center, AspectRatio -> Automatic, Axes -> False, 
         AxesLabel -> None, AxesOrigin -> Automatic, AxesStyle -> {}, 
         Background -> None, BaselinePosition -> Automatic, BaseStyle -> {}, 
         ColorOutput -> Automatic, ContentSelectable -> Automatic, 
         CoordinatesToolOptions -> Automatic, 
         DisplayFunction :> $DisplayFunction, Epilog -> {}, FormatType :> 
         TraditionalForm, Frame -> False, FrameLabel -> None, 
         FrameStyle -> {}, FrameTicks -> Automatic, FrameTicksStyle -> {}, 
         GridLines -> None, GridLinesStyle -> {}, ImageMargins -> 0., 
         ImagePadding -> All, ImageSizeRaw -> Automatic, Method -> Automatic, 
         PlotLabel -> None, PlotRange -> All, PlotRangeClipping -> False, 
         PlotRangePadding -> Automatic, PlotRegion -> Automatic, 
         PreserveImageOptions -> Automatic, Prolog -> {}, RotateLabel -> True,
          Ticks -> Automatic, TicksStyle -> {}}, 
       TagSet[AtomicDensityMatrix`LevelDiagram, 
        MessageName[AtomicDensityMatrix`LevelDiagram, "usage"], 
        "\!\(\*TagBox[RowBox[{\"LevelDiagram[\", StyleBox[\"sys\", \"TI\"], \
\"] draws a level diagram for atomic system \", StyleBox[\"sys\", \"TI\"], \" \
using specified values of the AtomicState Energy parameter for the level \
energies, or default values if they are not specified.\", \
\"\[LineSeparator]\", \"LevelDiagram[\", StyleBox[RowBox[{\"sys, h\"}], \
\"TI\"], \"] uses energies specified in the Hamiltonian \", StyleBox[\"h\", \
\"TI\"], \" and draws arrows representing level couplings.\", \"\
\[LineSeparator]\", \"LevelDiagram[\", StyleBox[\"sys\", \"TI\"], \", \", \
StyleBox[\"h\", \"TI\"], \", \", StyleBox[\"dm\", \"TI\"], \"] draws \
populations for each level as specified by the diagonal elements of the \
density matrix \", StyleBox[\"dm\", \"TI\"], \".\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`AtomicSystemQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := MatchQ[AtomicDensityMatrix`AtomicSystem`Private`expr, 
         AtomicDensityMatrix`AtomicSystemPattern[]], 
       TagSet[AtomicDensityMatrix`AtomicSystemQ, 
        MessageName[AtomicDensityMatrix`AtomicSystemQ, "usage"], 
        "\!\(\*TagBox[RowBox[{\"AtomicSystemQ[\", StyleBox[\"expr\", \"TI\"], \
\"] tests if expression \", StyleBox[\"expr\", \"TI\"], \" has the form of an \
atomic system (list of AtomicState objects).\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`AtomicSystemPattern[] = {
         Repeated[
          Blank[AtomicDensityMatrix`AtomicState]]}, 
       TagSet[AtomicDensityMatrix`AtomicSystemPattern, 
        MessageName[AtomicDensityMatrix`AtomicSystemPattern, "usage"], ""], 
       UpSetDelayed[
        AtomicDensityMatrix`StateParameters[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]], 
        Rest[
         Apply[List, AtomicDensityMatrix`AtomicSystem`Private`state]]], 
       AtomicDensityMatrix`AtomicState[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`label, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`rules, 
           BlankNullSequence[Rule]]}] := 
       AtomicDensityMatrix`AtomicState[
        AtomicDensityMatrix`AtomicSystem`Private`label, 
         AtomicDensityMatrix`AtomicSystem`Private`rules], 
       TagSet[AtomicDensityMatrix`AtomicState, 
        MessageName[AtomicDensityMatrix`AtomicState, "usage"], 
        "\!\(\*TagBox[RowBox[{\"AtomicState[\", StyleBox[\"label\", \"TI\"], \
\"] represents a labeled atomic state. \", \"\[LineSeparator]\", \
\"AtomicState[\", StyleBox[\"label\", \"TI\"], \",\", \
SubscriptBox[StyleBox[\"par\", \"TI\"], StyleBox[\"1\", \"TR\"]], \
\"\[Rule]\", StyleBox[\"val\", \"TI\"], \",\", SubscriptBox[StyleBox[\"par\", \
\"TI\"], StyleBox[\"2\", \"TR\"]], \"\[Rule]\", StyleBox[\"val\", \"TI\"], \
\",\", StyleBox[\"\[Ellipsis]\", \"TR\"], \"] represents an atomic state with \
one or more specified atomic parameters\"}], DisplayForm]\)"], 
       TagSet[AtomicDensityMatrix`StateParameters, 
        MessageName[AtomicDensityMatrix`StateParameters, "usage"], 
        "StateParameters[\!\(\*\nStyleBox[\"state\", \"TI\"]\)] returns the \
state parameters of the AtomicState \!\(\*\nStyleBox[\"state\", \"TI\"]\)."], 
       AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0]] = 0,
        AtomicDensityMatrix`Energy[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = (
         2.1055962340701206`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = (
         2.2099578666293674`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         2.4949718469632683`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         2.110179504793416*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         5.751786570324602*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         5.798576475256555*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         2.4949718469632683`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         2.110179504793416*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         5.751786570324602*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         5.798576475256555*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = (
         1.5494714188784714`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = (
         1.5494783111595566`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = (3.1850255752395*^10 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = (
         3.1850069663593517`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = (
         3.1850055267711067`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = (
         3.1320876072969864`*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = (
         3.011129565898232*^10 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = (2.445956596069698*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = (2.456827149264637*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`Energy[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = (
         2.8073302517638264`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = (
         2.807394295917115*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = (4.1675338850332212`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Lu", {177, "m"}, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Lu", {177, "m"}, {
          "Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = (4.1675338850332212`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = (5.49515580877772*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = (5.495146390519883*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = (3.193951666696825*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = (
         3.1971907769791055`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = (6.507783722448681*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = (6.507777129668197*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = (5.701246315122138*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = (5.702299276348264*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = (4.848517438966578*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (
         2.3694355849920673`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (2.414190843897715*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (2.36943607313472*^9 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (
         2.4141913345832973`*^9 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`Energy[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`Energy[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`Energy[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`Energy, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`Energy -> AtomicDensityMatrix`Energy[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`Energy[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`Energy, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`Energy, 
        MessageName[AtomicDensityMatrix`Energy, "usage"], 
        "\!\(\*TagBox[RowBox[{\"Energy is a parameter for AtomicState that \
specifies the (fine\[Hyphen]structure) energy of the state in units of \
angular frequency.\", \"\[LineSeparator]\", \"Energy[\", StyleBox[\"state\", \
\"TI\"], \"] returns the value specified for Energy in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or Energy[StateLabel[\", StyleBox[\"state\", \
\"TI\"], \"]] if it is not specified.\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState["$3", AtomicDensityMatrix`J -> 1]] = 
       1, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState["$4", AtomicDensityMatrix`J -> 1]] = 
       1, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         "$3", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> -1]] = 1, 
       AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         "$3", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 0]] = 1, 
       AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         "$3", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 1]] = 1, 
       AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         "$4", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> -1]] = 1, 
       AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         "$4", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 0]] = 1, 
       AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         "$4", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 1]] = 1, 
       AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0]] = 
       1/2, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2]] = 1/2, 
       AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = 1/2, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = 1/2, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> -1]] = 1/2, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> 0]] = 1/2, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> 1]] = 1/2, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> -2]] = 1/2, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> -1]] = 1/2, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> 0]] = 1/2, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> 1]] = 1/2, AtomicDensityMatrix`J[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> 2]] = 1/2, 
       AtomicDensityMatrix`J[{"Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 5/2, 
       AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 5/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 
       0, AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 
       1, AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 
       2, AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 
       0, AtomicDensityMatrix`J[{"He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 
       1, AtomicDensityMatrix`J[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Lu", {177, "m"}, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{
         "Lu", {177, "m"}, {
          "Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {2, "D", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 
       5/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 5/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       3/2, AtomicDensityMatrix`J[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`J[{"Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`J[{"Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`J[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`J[AtomicDensityMatrix`AtomicSystem`Private`state] = 
        ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`J, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state]], 
          AtomicDensityMatrix`J -> 0]), AtomicDensityMatrix`J[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`J, 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       AtomicDensityMatrix`J[
         Pattern[AtomicDensityMatrix`AtomicData`Private`state, {
           Pattern[AtomicDensityMatrix`AtomicData`Private`name, 
            Blank[String]], 
           Alternatives[
            Pattern[AtomicDensityMatrix`AtomicData`Private`weight, 
             Blank[Integer]], {
             Pattern[AtomicDensityMatrix`AtomicData`Private`weight, 
              Blank[Integer]], 
             Pattern[AtomicDensityMatrix`AtomicData`Private`isomer, 
              Blank[String]]}], 
           Pattern[AtomicDensityMatrix`AtomicData`Private`configuration, {
             Alternatives[
              Pattern[AtomicDensityMatrix`AtomicData`Private`core, 
               Blank[String]], 
              Pattern[AtomicDensityMatrix`AtomicData`Private`electron, 
               Alternatives[{
                 Blank[Integer], 
                 Blank[String]}, {
                 Blank[Integer], 
                 Blank[String], 
                 Blank[Integer]}]]], 
             Pattern[AtomicDensityMatrix`AtomicData`Private`electrons, 
              RepeatedNull[
               Alternatives[{
                 Blank[Integer], 
                 Blank[String]}, {
                 Blank[Integer], 
                 Blank[String], 
                 Blank[Integer]}]]]}], 
           Pattern[AtomicDensityMatrix`AtomicData`Private`term, {
             Pattern[AtomicDensityMatrix`AtomicData`Private`multiplicity, 
              Blank[Integer]], 
             Pattern[AtomicDensityMatrix`AtomicData`Private`l, 
              Blank[String]], 
             Pattern[AtomicDensityMatrix`AtomicData`Private`j, 
              Alternatives[
               Blank[Rational], 
               Blank[Integer]]]}]}]] := 
       ReplaceAll[
        AtomicDensityMatrix`AtomicData`Private`state, 
         AtomicDensityMatrix`AtomicData`Private`StateDesignationPattern[] -> 
         AtomicDensityMatrix`AtomicData`Private`j], 
       TagSet[AtomicDensityMatrix`J, 
        MessageName[AtomicDensityMatrix`J, "usage"], 
        "\!\(\*TagBox[RowBox[{\"J is a parameter for AtomicState that \
specifies the total electronic angular\[Hyphen]momentum (orbital plus spin) \
quantum number for the state. \", \"\[LineSeparator]\", \"J[\", \
StyleBox[\"state\", \"TI\"], \"] returns the value specified for J in \
AtomicState \", StyleBox[\"state\", \"TI\"], \", or zero if it is not \
specified. \"}], DisplayForm]\)"], AtomicDensityMatrix`L[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0]] = 0,
        AtomicDensityMatrix`L[{"Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`L[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`L[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`L[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`L[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 
       1, AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 
       1, AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 
       1, AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 
       0, AtomicDensityMatrix`L[{"He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 
       0, AtomicDensityMatrix`L[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`L[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`L[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Lu", {177, "m"}, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = 2, 
       AtomicDensityMatrix`L[{
         "Lu", {177, "m"}, {
          "Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {2, "D", 3/2}}] = 
       2, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 
       2, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 
       2, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 
       2, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 
       2, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[{"Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1, AtomicDensityMatrix`L[{"Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       1, AtomicDensityMatrix`L[{"Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`L[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`L[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`L, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`L -> AtomicDensityMatrix`L[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`L[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`L, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`L, 
        MessageName[AtomicDensityMatrix`L, "usage"], 
        "\!\(\*TagBox[RowBox[{\"L is a parameter for AtomicState that \
specifies the electronic orbital angular\[Hyphen]momentum quantum number for \
the state. \", \"\[LineSeparator]\", \"L[\", StyleBox[\"state\", \"TI\"], \"] \
returns the value specified for L in AtomicState \", StyleBox[\"state\", \"TI\
\"], \", or L[StateLabel[\", StyleBox[\"state\", \"TI\"], \"]] if it is not \
specified.\"}], DisplayForm]\)"], AtomicDensityMatrix`S[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0]] = 
       1/2, AtomicDensityMatrix`S[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 
       1, AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 
       1, AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 
       1, AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 
       0, AtomicDensityMatrix`S[{"He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 
       1, AtomicDensityMatrix`S[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Lu", {177, "m"}, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{
         "Lu", {177, "m"}, {
          "Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {2, "D", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 1/2, 
       AtomicDensityMatrix`S[{"Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`S[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`S[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`S, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`S -> AtomicDensityMatrix`S[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`S[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`S, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`S, 
        MessageName[AtomicDensityMatrix`S, "usage"], 
        "\!\(\*TagBox[RowBox[{\"S is a parameter for AtomicState that \
specifies the electronic spin angular\[Hyphen]momentum quantum number. \", \"\
\[LineSeparator]\", \"S[\", StyleBox[\"state\", \"TI\"], \"] returns the \
value specified for S in AtomicState \", StyleBox[\"state\", \"TI\"], \", or \
S[StateLabel[\", StyleBox[\"state\", \"TI\"], \"]] if it is not \
specified.\"}], DisplayForm]\)"], 
       Attributes[AtomicDensityMatrix`AtomicSystem`Private`state$] = {
        Temporary}, AtomicDensityMatrix`StateLabel[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       First[AtomicDensityMatrix`AtomicSystem`Private`state], 
       AtomicDensityMatrix`StateLabel[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`StateLabel, 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`StateLabel, 
        MessageName[AtomicDensityMatrix`StateLabel, "usage"], 
        "\!\(\*TagBox[RowBox[{\"StateLabel[\", StyleBox[\"state\", \"TI\"], \
\"] gives the label (first argument) for the AtomicState \", StyleBox[\"state\
\", \"TI\"], \".\"}], DisplayForm]\)"], 
       Attributes[AtomicDensityMatrix`AtomicSystem`Private`sys$] = {
        Temporary}, AtomicDensityMatrix`NuclearSpin[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2]] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = 3/2, AtomicDensityMatrix`NuclearSpin[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = 3/2, AtomicDensityMatrix`NuclearSpin[{"Cs", 133}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{"Cu", 63}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"Cu", 65}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"H", 1}] = 1/2, 
       AtomicDensityMatrix`NuclearSpin[{"He", 2}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{"K", 39}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"Li", 3}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"Lu", 177}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{"Lu", {177, "m"}}] = 23/2, 
       AtomicDensityMatrix`NuclearSpin[{"Na", 23}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"Rb", 85}] = 5/2, 
       AtomicDensityMatrix`NuclearSpin[{"Rb", 87}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 
       1/2, AtomicDensityMatrix`NuclearSpin[{
         "H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 1/2, 
       AtomicDensityMatrix`NuclearSpin[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 
       1/2, AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 0, 
       AtomicDensityMatrix`NuclearSpin[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = 7/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Lu", {177, "m"}, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = 23/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Lu", {177, "m"}, {
          "Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {2, "D", 3/2}}] = 
       23/2, AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 5/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 5/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 5/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 3/2, 
       AtomicDensityMatrix`NuclearSpin[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`NuclearSpin[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`NuclearSpin, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`NuclearSpin -> AtomicDensityMatrix`NuclearSpin[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`NuclearSpin[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`NuclearSpin, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`NuclearSpin, 
        MessageName[AtomicDensityMatrix`NuclearSpin, "usage"], 
        "\!\(\*TagBox[RowBox[{\"NuclearSpin is a parameter for AtomicState \
that specifies the nuclear angular\[Hyphen]momentum quantum number for the \
atom. \", \"\[LineSeparator]\", \"NuclearSpin[\", StyleBox[\"state\", \
\"TI\"], \"] returns the value specified for NuclearSpin in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or NuclearSpin[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified. \"}], \
DisplayForm]\)"], AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         "$3", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> -1]] = 1, 
       AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         "$3", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 0]] = 1, 
       AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         "$3", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 1]] = 1, 
       AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         "$4", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> -1]] = 1, 
       AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         "$4", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 0]] = 1, 
       AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         "$4", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 1]] = 1, 
       AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = 1, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = 2, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> -1]] = 1, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> 0]] = 1, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> 1]] = 1, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> -2]] = 2, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> -1]] = 2, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> 0]] = 2, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> 1]] = 2, AtomicDensityMatrix`F[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> 2]] = 2, AtomicDensityMatrix`F[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`F[AtomicDensityMatrix`AtomicSystem`Private`state] = 
        ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`F, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state]], 
          AtomicDensityMatrix`F -> 
          AtomicDensityMatrix`J[
           AtomicDensityMatrix`AtomicSystem`Private`state]]), 
       AtomicDensityMatrix`F[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`F, 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`F, 
        MessageName[AtomicDensityMatrix`F, "usage"], 
        "\!\(\*TagBox[RowBox[{\"F is a parameter for AtomicState that \
specifies the total angular\[Hyphen]momentum (electronic plus nuclear) \
quantum number for the state. \", \"\[LineSeparator]\", \"F[\", \
StyleBox[\"state\", \"TI\"], \"] returns the value specified for F in \
AtomicState \", StyleBox[\"state\", \"TI\"], \", or J[\", StyleBox[\"state\", \
\"TI\"], \"] if it is not specified. \"}], DisplayForm]\)"], 
       AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         "$3", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> -1]] = -1,
        AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         "$3", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 0]] = 0, 
       AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         "$3", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 1]] = 1, 
       AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         "$4", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> -1]] = -1,
        AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         "$4", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 0]] = 0, 
       AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         "$4", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 1]] = 1, 
       AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> -1]] = -1, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> 0]] = 0, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> 1]] = 1, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> -2]] = -2, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> -1]] = -1, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> 0]] = 0, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> 1]] = 1, AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> 2]] = 2, AtomicDensityMatrix`M[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`M[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`M, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`M -> AtomicDensityMatrix`M[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`M[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`M, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`M, 
        MessageName[AtomicDensityMatrix`M, "usage"], 
        "\!\(\*TagBox[RowBox[{\"M is a parameter for AtomicState that \
specifies the total angular\[Hyphen]momentum projection quantum number for \
the state. \", \"\[LineSeparator]\", \"M[\", StyleBox[\"state\", \"TI\"], \"] \
returns the value specified for M in AtomicState \", StyleBox[\"state\", \"TI\
\"], \", or M[StateLabel[\", StyleBox[\"state\", \"TI\"], \"]] if it is not \
specified. \"}], DisplayForm]\)"], 
       AtomicDensityMatrix`AtomicData`Private`state = {
        "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}, 
       AtomicDensityMatrix`AtomicData`Private`StateDesignationPattern[] = {
         Pattern[AtomicDensityMatrix`AtomicData`Private`name, 
          Blank[String]], 
         Alternatives[
          Pattern[AtomicDensityMatrix`AtomicData`Private`weight, 
           Blank[Integer]], {
           Pattern[AtomicDensityMatrix`AtomicData`Private`weight, 
            Blank[Integer]], 
           Pattern[AtomicDensityMatrix`AtomicData`Private`isomer, 
            Blank[String]]}], 
         Pattern[AtomicDensityMatrix`AtomicData`Private`configuration, {
           Alternatives[
            Pattern[AtomicDensityMatrix`AtomicData`Private`core, 
             Blank[String]], 
            Pattern[AtomicDensityMatrix`AtomicData`Private`electron, 
             Alternatives[{
               Blank[Integer], 
               Blank[String]}, {
               Blank[Integer], 
               Blank[String], 
               Blank[Integer]}]]], 
           Pattern[AtomicDensityMatrix`AtomicData`Private`electrons, 
            RepeatedNull[
             Alternatives[{
               Blank[Integer], 
               Blank[String]}, {
               Blank[Integer], 
               Blank[String], 
               Blank[Integer]}]]]}], 
         Pattern[AtomicDensityMatrix`AtomicData`Private`term, {
           Pattern[AtomicDensityMatrix`AtomicData`Private`multiplicity, 
            Blank[Integer]], 
           Pattern[AtomicDensityMatrix`AtomicData`Private`l, 
            Blank[String]], 
           Pattern[AtomicDensityMatrix`AtomicData`Private`j, 
            Alternatives[
             Blank[Rational], 
             Blank[Integer]]]}]}, 
       TagSet[Units`Mega, 
        MessageName[Units`Mega, "symbol"], "M"], 
       TagSet[Units`Mega, 
        MessageName[Units`Mega, "usage"], 
        "Mega is the SI unit prefix denoting \!\(\*SuperscriptBox[\"10\", \"6\
\"]\)."], 
       TagSet[Units`Second, 
        MessageName[Units`Second, "symbol"], "s"], 
       TagSet[Units`Second, 
        MessageName[Units`Second, "usage"], 
        "Second is the fundamental SI unit of time."], 
       AtomicDensityMatrix`ZeroMatrix[
         Pattern[AtomicDensityMatrix`Common`Private`n, 
          Blank[Integer]]] := 
       ConstantArray[
        0, {AtomicDensityMatrix`Common`Private`n, 
          AtomicDensityMatrix`Common`Private`n}], 
       AtomicDensityMatrix`ZeroMatrix[
         Pattern[AtomicDensityMatrix`Common`Private`n, 
          Blank[Integer]], SparseArray] := 
       SparseArray[{}, {
         AtomicDensityMatrix`Common`Private`n, 
          AtomicDensityMatrix`Common`Private`n}], 
       TagSet[AtomicDensityMatrix`ZeroMatrix, 
        MessageName[AtomicDensityMatrix`ZeroMatrix, "usage"], ""], 
       AtomicDensityMatrix`OperatorQ[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`expr, 
          Blank[]]] := MatchQ[
         AtomicDensityMatrix`TensorType[
         AtomicDensityMatrix`TensorAlgebra`Private`expr, {""}], {
          Alternatives["Operator", "OneByOne"]}], 
       TagSet[AtomicDensityMatrix`OperatorQ, 
        MessageName[AtomicDensityMatrix`OperatorQ, "usage"], 
        "OperatorQ[expr] gives True if expr is in the form of a matrix \
operator, i.e., an n x n matrix, and gives False otherwise."], 
       AtomicDensityMatrix`TensorType[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Alternatives[
           Blank[List], 
           Blank[SparseArray]]], 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`default, 
           Blank[List]], {}]] := 
       AtomicDensityMatrix`TensorType[
        AtomicDensityMatrix`TensorAlgebra`Private`a, 
         AtomicDensityMatrix`ListDepth[
         AtomicDensityMatrix`TensorAlgebra`Private`a], 
         AtomicDensityMatrix`TensorAlgebra`Private`default], 
       AtomicDensityMatrix`TensorType[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Alternatives[
           Blank[List], 
           Blank[SparseArray]]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`depth, 
          Alternatives[
           Blank[Integer], Indeterminate]], 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`default, 
           Blank[List]], {}]] := ReplaceAll[
         Switch[{AtomicDensityMatrix`TensorAlgebra`Private`depth, 
           Dimensions[AtomicDensityMatrix`TensorAlgebra`Private`a], 
           Map[Dimensions, AtomicDensityMatrix`TensorAlgebra`Private`a]}, {
          1, 
           Blank[], 
           Blank[]}, {"Cartesian"}, {2, {1, 1}, 
           Blank[]}, {"OneByOne"}, {2, {1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           Blank[]}, {"Covariant"}, {2, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1}, 
           Blank[]}, {"Contravariant"}, {2, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           Blank[]}, {"Operator"}, {3, {1, 1, 1}, 
           Blank[]}, {"TensorDecomposition", "OneByOne"}, 
          Alternatives[{3, {1, 1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]]}, 
            Blank[]}, {3, {
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 1}, 
            AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{1, 
              Blank[]}]}], {"TensorDecomposition", "Covariant"}, 
          Alternatives[{3, {1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 1}, 
            Blank[]}, {3, {
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]]}, 
            AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{
              Blank[], 1}]}], {"TensorDecomposition", "Contravariant"}, 
          Alternatives[{3, {1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]]}, 
            Blank[]}, {3, {
             Blank[]}, 
            AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{
              Blank[], 
              Blank[]}]}], {"TensorDecomposition", "Operator"}, {3, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 1}, 
           Blank[]}, {"Cartesian", "OneByOne"}, {3, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]]}, 
           Blank[]}, {"Cartesian", "Covariant"}, {3, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]], 1}, 
           Blank[]}, {"Cartesian", "Contravariant"}, {3, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]]}, 
           Blank[]}, {"Cartesian", "Operator"}, {4, {1, 1, 1, 1}, 
           Blank[]}, {"OneByOne", "OneByOne"}, {4, {1, 1, 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           Blank[]}, {"OneByOne", "Covariant"}, {4, {1, 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1}, 
           Blank[]}, {"OneByOne", "Contravariant"}, {4, {1, 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           Blank[]}, {"OneByOne", "Operator"}, {4, {1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 1}, 
           Blank[]}, {"Covariant", "OneByOne"}, {4, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 1, 1}, 
           Blank[]}, {"Contravariant", "OneByOne"}, {4, {1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]]}, 
           Blank[]}, {"Covariant", "Covariant"}, {4, {1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]], 1}, 
           Blank[]}, {"Covariant", "Contravariant"}, {4, {1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]]}, 
           Blank[]}, {"Covariant", "Operator"}, {4, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]]}, 
           Blank[]}, {"Contravariant", "Covariant"}, {4, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]], 1}, 
           Blank[]}, {"Contravariant", "Contravariant"}, {4, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
             Blank[]]}, 
           Blank[]}, {"Contravariant", "Operator"}, {5, {
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 1, 1, 1}, 
           Blank[]}, {
          "TensorDecompositionMatrix", "TensorDecomposition", "OneByOne"}, {
          5, {1, 1, 1, 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
             Blank[]]}, 
           Blank[]}, {"TensorDecomposition", "OneByOne", "Operator"}, 
          Alternatives[{5, {1, 1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
              Blank[]]}, 
            Blank[]}, {5, {
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 1}, 
            AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{1, 
              Blank[], 
              Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
               Blank[]]}]}], {"TensorDecomposition", "Covariant", "Operator"}, 
          Alternatives[{5, {1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
              Blank[]]}, 
            Blank[]}, {5, {
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]]}, 
            AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[{
              Blank[], 1, 
              Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m, 
               Blank[]]}]}], {
          "TensorDecomposition", "Contravariant", "Operator"}, {6, 
           Blank[], 
           Blank[]}, 
          Switch[{
            Dimensions[AtomicDensityMatrix`TensorAlgebra`Private`a], 
            Flatten[
             ReplaceAll[
              Map[
              AtomicDensityMatrix`TensorType[#, 
                AtomicDensityMatrix`TensorAlgebra`Private`depth - 1, 
                AtomicDensityMatrix`TensorAlgebra`Private`default]& , 
               AtomicDensityMatrix`TensorAlgebra`Private`a, {1}], 
              AtomicDensityMatrix`TensorAlgebra`Private`assumeDecomposition], \
{{2}, {1}}]}, {{3, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecompositionMatrix"]}, {
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Contravariant", "OneByOne"]]}}}, {
           "Cartesian", "TensorDecompositionMatrix", "TensorDecomposition", 
            "Contravariant"}, {{3, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecompositionMatrix"]}, {
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Covariant", "OneByOne"]]}}}, {
           "Cartesian", "TensorDecompositionMatrix", "TensorDecomposition", 
            "Covariant"}, 
           Blank[], {}], {
           Alternatives[5, 7], 
           Blank[], 
           Blank[]}, 
          Switch[{
            Dimensions[AtomicDensityMatrix`TensorAlgebra`Private`a], 
            Flatten[
             ReplaceAll[
              Map[
              AtomicDensityMatrix`TensorType[#, 
                AtomicDensityMatrix`TensorAlgebra`Private`depth - 2, 
                AtomicDensityMatrix`TensorAlgebra`Private`default]& , 
               AtomicDensityMatrix`TensorAlgebra`Private`a, {2}], 
              AtomicDensityMatrix`TensorAlgebra`Private`assumeDecomposition], \
{{3}, {1, 2}}]}, {{
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecomposition"]}, {
              Repeated["OneByOne"]}, {
              Repeated["Operator"]}}}, {
           "TensorDecompositionMatrix", "TensorDecomposition", "OneByOne", 
            "Operator"}, {{
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Covariant", "OneByOne"]]}}}, {
           "TensorDecompositionMatrix", "TensorDecomposition", "Covariant"}, {{
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Covariant", "OneByOne"]]}, {
              Repeated["Operator"]}}}, {
           "TensorDecompositionMatrix", "TensorDecomposition", "Covariant", 
            "Operator"}, {{
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Contravariant", "OneByOne"]]}}}, {
           "TensorDecompositionMatrix", "TensorDecomposition", 
            "Contravariant"}, {{
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Contravariant", "OneByOne"]]}, {
              Repeated["Operator"]}}}, {
           "TensorDecompositionMatrix", "TensorDecomposition", 
            "Contravariant", "Operator"}, {{1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecomposition"]}, {
              Repeated["OneByOne"]}}}, {
           "Covariant", "TensorDecomposition", "OneByOne"}, {{1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Covariant", "OneByOne"]]}}}, {
           "Covariant", "TensorDecomposition", "Covariant"}, {{1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Contravariant", "OneByOne"]]}}}, {
           "Covariant", "TensorDecomposition", "Contravariant"}, {{1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecompositionMatrix"]}, {
              Repeated["TensorDecomposition"]}, {
              Repeated["OneByOne"]}}}, {
           "Covariant", "TensorDecompositionMatrix", "TensorDecomposition", 
            "OneByOne"}, {{1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecompositionMatrix"]}, {
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Covariant", "OneByOne"]]}}}, {
           "Covariant", "TensorDecompositionMatrix", "TensorDecomposition", 
            "Covariant"}, {{1, 
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 
             BlankNullSequence[]}, {{
              Repeated["TensorDecompositionMatrix"]}, {
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Contravariant", "OneByOne"]]}}}, {
           "Covariant", "TensorDecompositionMatrix", "TensorDecomposition", 
            "Contravariant"}, {{
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 1, 
             BlankNullSequence[]}, {{
              Repeated["TensorDecomposition"]}, {
              Repeated["OneByOne"]}}}, {
           "Contravariant", "TensorDecomposition", "OneByOne"}, {{
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 1, 
             BlankNullSequence[]}, {{
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Covariant", "OneByOne"]]}}}, {
           "Contravariant", "TensorDecomposition", "Covariant"}, {{
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 1, 
             BlankNullSequence[]}, {{
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Contravariant", "OneByOne"]]}}}, {
           "Contravariant", "TensorDecomposition", "Contravariant"}, {{
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 1, 
             BlankNullSequence[]}, {{
              Repeated["TensorDecompositionMatrix"]}, {
              Repeated["TensorDecomposition"]}, {
              Repeated["OneByOne"]}}}, {
           "Contravariant", "TensorDecompositionMatrix", 
            "TensorDecomposition", "OneByOne"}, {{
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 1, 
             BlankNullSequence[]}, {{
              Repeated["TensorDecompositionMatrix"]}, {
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Covariant", "OneByOne"]]}}}, {
           "Contravariant", "TensorDecompositionMatrix", 
            "TensorDecomposition", "Covariant"}, {{
             Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
              Blank[]], 1, 
             BlankNullSequence[]}, {{
              Repeated["TensorDecompositionMatrix"]}, {
              Repeated["TensorDecomposition"]}, {
              Repeated[
               Alternatives["Contravariant", "OneByOne"]]}}}, {
           "Contravariant", "TensorDecompositionMatrix", 
            "TensorDecomposition", "Contravariant"}, 
           Blank[], {}], 
          Blank[], {}], {} :> (
          If[AtomicDensityMatrix`TensorAlgebra`Private`default === {}, 
            Message[
             MessageName[AtomicDensityMatrix`TensorType, "unrec"], 
             AtomicDensityMatrix`TensorAlgebra`Private`a]]; 
          AtomicDensityMatrix`TensorAlgebra`Private`default)], 
       AtomicDensityMatrix`TensorType[
         Blank[], 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`default, 
           Blank[List]], {}]] := {"Scalar"}, 
       TagSet[AtomicDensityMatrix`TensorType, 
        MessageName[AtomicDensityMatrix`TensorType, "unrec"], 
        "The expression `1` does not have a recognized tensor structure."], 
       TagSet[AtomicDensityMatrix`TensorType, 
        MessageName[AtomicDensityMatrix`TensorType, "usage"], 
        "\!\(\*TagBox[RowBox[{\"TensorType[\", StyleBox[\"tens\", \"TI\"], \
\"] returns a list describing the structure of the tensor \", StyleBox[\"tens\
\", \"TI\"], \", from top level (outermost), to bottom level \
(innermost).\"}], DisplayForm]\)"], AtomicDensityMatrix`ListDepth[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[SparseArray]]] := 
       ArrayDepth[AtomicDensityMatrix`TensorAlgebra`Private`a], 
       AtomicDensityMatrix`ListDepth[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[List]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`i = 0, 
          AtomicDensityMatrix`TensorAlgebra`Private`depths}, While[
           AtomicDensityMatrix`TensorAlgebra`Private`matchAtLevel[
           AtomicDensityMatrix`TensorAlgebra`Private`a, 
            Blank[List], AtomicDensityMatrix`TensorAlgebra`Private`i], 
           Increment[AtomicDensityMatrix`TensorAlgebra`Private`i]]; Which[
           And[
            AtomicDensityMatrix`TensorAlgebra`Private`matchAtLevel[
            AtomicDensityMatrix`TensorAlgebra`Private`a, 
             Blank[SparseArray], AtomicDensityMatrix`TensorAlgebra`Private`i], 
            MatchQ[
            AtomicDensityMatrix`TensorAlgebra`Private`depths = Flatten[
               Map[
               AtomicDensityMatrix`ListDepth, 
                AtomicDensityMatrix`TensorAlgebra`Private`a, {
                AtomicDensityMatrix`TensorAlgebra`Private`i}]], {
              Repeated[
               Pattern[AtomicDensityMatrix`TensorAlgebra`Private`x, 
                Blank[Integer]]]}]], 
           AtomicDensityMatrix`TensorAlgebra`Private`i + 
           First[AtomicDensityMatrix`TensorAlgebra`Private`depths], 
           AtomicDensityMatrix`TensorAlgebra`Private`matchAtLevel[
           AtomicDensityMatrix`TensorAlgebra`Private`a, 
            Except[
             Alternatives[
              Blank[List], 
              Blank[SparseArray]]], 
            AtomicDensityMatrix`TensorAlgebra`Private`i], 
           AtomicDensityMatrix`TensorAlgebra`Private`i, True, Indeterminate]],
        AtomicDensityMatrix`ListDepth[
         Blank[]] := 0, 
       TagSet[AtomicDensityMatrix`ListDepth, 
        MessageName[AtomicDensityMatrix`ListDepth, "usage"], ""], 
       AtomicDensityMatrix`TensorAlgebra`Private`matchAtLevel[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`expr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`patt, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`level, 
          Blank[]]] := 
       MatchQ[AtomicDensityMatrix`TensorAlgebra`Private`expr, 
         Nest[{
           Repeated[#]}& , AtomicDensityMatrix`TensorAlgebra`Private`patt, 
          AtomicDensityMatrix`TensorAlgebra`Private`level]], 
       AtomicDensityMatrix`TensorAlgebra`Private`decompDimPattern[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`dims, 
          Blank[]]] := 
       With[{AtomicDensityMatrix`TensorAlgebra`Private`index = Flatten[
            Position[AtomicDensityMatrix`TensorAlgebra`Private`dims, 
             Verbatim[
              Blank[]], {1}, 1, Heads -> False]]}, 
         HoldPattern[
          Condition[
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`expr, {
             Repeated[AtomicDensityMatrix`TensorAlgebra`Private`dims]}], 
           And[
            Apply[And, 
             OddQ[
              Part[
              AtomicDensityMatrix`TensorAlgebra`Private`expr, 1, 
               AtomicDensityMatrix`TensorAlgebra`Private`index]]], 
            Or[Length[AtomicDensityMatrix`TensorAlgebra`Private`expr] == 1, 
             MatchQ[
              Differences[
               Part[
               AtomicDensityMatrix`TensorAlgebra`Private`expr, All, 
                AtomicDensityMatrix`TensorAlgebra`Private`index]], {
               Repeated[{
                 Repeated[2]}]}]]]]]], 
       AtomicDensityMatrix`TensorAlgebra`Private`assumeDecomposition = {
         "TensorDecompositionMatrix", "TensorDecomposition", "OneByOne"} -> {
         "TensorDecomposition", "OneByOne", "Operator"}, 
       TagSet[AtomicDensityMatrix`ExtraArrows, 
        MessageName[AtomicDensityMatrix`ExtraArrows, "usage"], ""], 
       ProcessOptions`ProcessOption[
         Pattern[ProcessOptions`Private`f, 
          Blank[]], 
         Pattern[ProcessOptions`Private`opt, 
          Blank[]], 
         Pattern[ProcessOptions`Private`val, 
          Blank[]]] := 
       With[{ProcessOptions`Private`processed = 
          ProcessOptions`OptionProcessor[ProcessOptions`Private`opt][
           ProcessOptions`Private`val]}, 
         If[
          Or[
           MatchQ[
            HoldComplete[ProcessOptions`Private`processed], 
            ProcessOptions`OptionValidator[ProcessOptions`Private`opt]], 
           MatchQ[ProcessOptions`Private`processed, 
            ProcessOptions`OptionValidator[ProcessOptions`Private`opt]]], 
          Unevaluated[ProcessOptions`Private`processed], Message[
            MessageName[ProcessOptions`Private`f, "adminvopt"], 
            ProcessOptions`Private`opt, 
            ProcessOptions`Private`val]; $Failed]], 
       TagSet[ProcessOptions`ProcessOption, 
        MessageName[ProcessOptions`ProcessOption, "usage"], ""], 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`AllowedCouplings] = 
       ReplaceAll[
         ReplaceAll[#, Automatic :> 
          OptionValue[
           AtomicDensityMatrix`WignerEckart, 
            AtomicDensityMatrix`AllowedCouplings]], {
         All -> True, None -> False}]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`ArcRadius] = 
       RotateRight[
         AtomicDensityMatrix`EnsureList[#]]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`ArrowFunction] = 
       ReplaceAll[#, Automatic -> (Arrow[#]& )]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`ArrowOffset] = 
       Replace[
         Replace[#, {None -> {{0, 0}}, PatternTest[
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
              Blank[]], NumericQ] -> {{
             AtomicDensityMatrix`LevelDiagram`Private`x, 0}}, 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, {
              PatternTest[
               Blank[], NumericQ], 
              PatternTest[
               Blank[], NumericQ]}] -> {
            AtomicDensityMatrix`LevelDiagram`Private`x}}], {
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, {
             PatternTest[
              Blank[], NumericQ], 
             PatternTest[
              Blank[], NumericQ]}] -> {
           AtomicDensityMatrix`LevelDiagram`Private`x, 
            AtomicDensityMatrix`LevelDiagram`Private`x}, None -> {0, 0}, 
          PatternTest[
            Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
             Blank[]], NumericQ] -> {
           AtomicDensityMatrix`LevelDiagram`Private`x, 0}}, {1}]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`ArrowSetback] = 
       Replace[
         Replace[#, {None -> {{0, 0}}, PatternTest[
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
              Blank[]], NumericQ] -> {{
             0, AtomicDensityMatrix`LevelDiagram`Private`x}}, 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, {
              PatternTest[
               Blank[], NumericQ], 
              PatternTest[
               Blank[], NumericQ]}] -> {
            AtomicDensityMatrix`LevelDiagram`Private`x}}], {PatternTest[
            Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
             Blank[]], NumericQ] -> {
           0, AtomicDensityMatrix`LevelDiagram`Private`x}, None -> {0, 0}}, {
         1}]& , ProcessOptions`OptionProcessor[
        AtomicDensityMatrix`ArrowStyle] = Replace[
         AtomicDensityMatrix`EnsureList[#], {} -> {{}}]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`DMLabel] = 
       ReplaceAll[
         ReplaceAll[#, Automatic -> 
          OptionValue[
           AtomicDensityMatrix`DensityMatrix, AtomicDensityMatrix`DMLabel]], 
         Alternatives[None, False] -> Sequence[]]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`ElectricField] = 
       Switch[#, {
          Repeated[{
            Blank[], 
            AtomicDensityMatrix`genericOptionsPattern[]}]}, #, {
          Blank[], 
          AtomicDensityMatrix`genericOptionsPattern[]}, {#}, 
         Blank[], {{#}}]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`HoldFixed] = 
       AtomicDensityMatrix`PlotAndFit`Private`makeVector, 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`Interaction] = 
       ReplaceAll[
         Switch[#, All, {
          "Internal", "ElectricDipole", "MagneticDipole", "Polarizability"}, 
          Automatic, {"Internal", "ElectricDipole", "MagneticDipole"}, 
          None, {}, 
          Blank[], 
          Flatten[{#}]], {
         AtomicDensityMatrix`Internal -> "Internal", AtomicDensityMatrix`E1 -> 
          "ElectricDipole", AtomicDensityMatrix`Magnetic -> "MagneticDipole", 
          AtomicDensityMatrix`Polarizability -> "Polarizability"}]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`LevelSpacing] = 
       Replace[#, PatternTest[
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
            Blank[]], NumericQ] -> {
          AtomicDensityMatrix`LevelDiagram`Private`x, 0}]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`MagneticField] = 
       Switch[#, {
          Repeated[{
            Blank[], 
            AtomicDensityMatrix`genericOptionsPattern[]}]}, #, {
          Blank[], 
          AtomicDensityMatrix`genericOptionsPattern[]}, {#}, 
         Blank[], {{#}}]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`MaxRanks] = 
       ReplaceAll[#, Automatic :> 
         OptionValue[
          AtomicDensityMatrix`PolarizationMoments, 
           AtomicDensityMatrix`MaxRanks]]& , 
       ProcessOptions`OptionProcessor[Method] = 
       AtomicDensityMatrix`EnsureList[#]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`MLabel] = ReplaceAll[
         Replace[#, {All -> True, None -> False}], Short -> "Short"]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`NeglectedCouplings] = 
       ReplaceAll[
         ReplaceAll[#, Automatic :> 
          OptionValue[
           AtomicDensityMatrix`WignerEckart, 
            AtomicDensityMatrix`NeglectedCouplings]], {
         All -> True, None -> False}]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`OpticalParameters] = 
       Replace[
         ReplaceAll[#, {
          Blank[AtomicDensityMatrix`OpticalParameters] -> {{0, 0}}, 
           Pattern[AtomicDensityMatrix`Hamiltonian`Private`x, {
              Repeated[{
                Blank[], 
                Repeated[
                 Except[
                  Blank[Rule]]], 
                AtomicDensityMatrix`genericOptionsPattern[]}]}] -> 
           AtomicDensityMatrix`Hamiltonian`Private`x, 
           Pattern[AtomicDensityMatrix`Hamiltonian`Private`x, {
              Blank[], 
              Repeated[
               Except[
                Blank[Rule]]], 
              AtomicDensityMatrix`genericOptionsPattern[]}] -> {
            AtomicDensityMatrix`Hamiltonian`Private`x}, 
           Pattern[AtomicDensityMatrix`Hamiltonian`Private`x, 
             Blank[]] -> {{AtomicDensityMatrix`Hamiltonian`Private`x}}}], {
           Pattern[AtomicDensityMatrix`Hamiltonian`Private`params, 
            BlankSequence[]], 
           Pattern[AtomicDensityMatrix`Hamiltonian`Private`opts, 
            AtomicDensityMatrix`genericOptionsPattern[]]} :> {{
           AtomicDensityMatrix`Hamiltonian`Private`params, 
            FilterRules[{AtomicDensityMatrix`Hamiltonian`Private`opts}, 
             Options[AtomicDensityMatrix`OpticalField]]}, 
           FilterRules[{AtomicDensityMatrix`Hamiltonian`Private`opts}, 
            Except[
             Options[AtomicDensityMatrix`OpticalField]]]}, {1}]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`Representation] = 
       ReplaceAll[
         Flatten[{
           
           ReplaceAll[#, Automatic -> 
            OptionValue[
             AtomicDensityMatrix`DensityMatrix, 
              AtomicDensityMatrix`Representation]]}], 
         AtomicDensityMatrix`PolarizationMoments -> "PolarizationMoments"]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`StateLabel] = 
       Replace[#, None -> False]& , 
       ProcessOptions`OptionProcessor[AtomicDensityMatrix`StateLabels] = 
       Switch[#, Automatic, 
         Function[AtomicDensityMatrix`AtomicData`Private`states, 
          Range[
           Length[AtomicDensityMatrix`AtomicData`Private`states]]], 
         OptionsPattern[], 
         Function[AtomicDensityMatrix`AtomicData`Private`states, 
          ReplaceAll[AtomicDensityMatrix`AtomicData`Private`states, #]], 
         Blank[List], 
         Function[AtomicDensityMatrix`AtomicData`Private`states, 
          PadRight[{}, 
           Length[AtomicDensityMatrix`AtomicData`Private`states], #]], 
         Blank[], 
         Function[AtomicDensityMatrix`AtomicData`Private`states, 
          Map[#, AtomicDensityMatrix`AtomicData`Private`states]]]& , 
       ProcessOptions`OptionProcessor[
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`opt, 
          Alternatives[
          AtomicDensityMatrix`TimeDependence, AtomicDensityMatrix`DMSymbol, 
           AtomicDensityMatrix`DMLabel, 
           AtomicDensityMatrix`ComplexExpandVariables, 
           AtomicDensityMatrix`TimeVariable, 
           AtomicDensityMatrix`AllowedElements, 
           AtomicDensityMatrix`NeglectedElements, 
           AtomicDensityMatrix`Subspace]]] := 
       ReplaceAll[#, Automatic :> 
         OptionValue[
          AtomicDensityMatrix`DensityMatrix, 
           AtomicDensityMatrix`DensityMatrix`Private`opt]]& , 
       ProcessOptions`OptionProcessor[
         Pattern[AtomicDensityMatrix`OpticalField`Private`opt, 
          Alternatives[
          AtomicDensityMatrix`PolarizationVector, 
           AtomicDensityMatrix`PropagationVector]]] := (Simplify[#/Sqrt[
          Dot[#, #]]]& )[
         AtomicDensityMatrix`ToCartesian[
          
          ReplaceAll[#, Automatic :> 
           OptionValue[
            AtomicDensityMatrix`OpticalField, 
             AtomicDensityMatrix`OpticalField`Private`opt]]]]& , 
       ProcessOptions`OptionProcessor[
         Pattern[AtomicDensityMatrix`OpticalField`Private`opt, 
          Alternatives[
          AtomicDensityMatrix`Parameterization, 
           AtomicDensityMatrix`CartesianCoordinates]]] := 
       ReplaceAll[#, Automatic :> 
         OptionValue[
          AtomicDensityMatrix`OpticalField, 
           AtomicDensityMatrix`OpticalField`Private`opt]]& , 
       ProcessOptions`OptionProcessor[
         Blank[]] = Identity, 
       TagSet[ProcessOptions`OptionProcessor, 
        MessageName[ProcessOptions`OptionProcessor, "usage"], ""], 
       AtomicDensityMatrix`ElectricField[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`ElectricField[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`ElectricField, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`ElectricField -> 
          AtomicDensityMatrix`ElectricField[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`ElectricField[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`ElectricField, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`ElectricField, 
        MessageName[AtomicDensityMatrix`ElectricField, "usage"], 
        "ElectricField is an option for Hamiltonian that specifies the \
applied external electric field."], 
       Attributes[AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = {
        Temporary}, 
       UpSetDelayed[
        AtomicDensityMatrix`RegionParameters[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]], 
        Rest[
         Apply[List, AtomicDensityMatrix`ExperimentalSystem`Private`reg]]], 
       AtomicDensityMatrix`ExperimentalRegion[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`label, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`rules, 
           BlankNullSequence[Rule]]}] := 
       AtomicDensityMatrix`ExperimentalRegion[
        AtomicDensityMatrix`ExperimentalSystem`Private`label, 
         AtomicDensityMatrix`ExperimentalSystem`Private`rules], 
       TagSet[AtomicDensityMatrix`ExperimentalRegion, 
        MessageName[AtomicDensityMatrix`ExperimentalRegion, "usage"], ""], 
       TagSet[AtomicDensityMatrix`RegionParameters, 
        MessageName[AtomicDensityMatrix`RegionParameters, "usage"], ""], 
       AtomicDensityMatrix`RegionLabel[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := 
       First[AtomicDensityMatrix`ExperimentalSystem`Private`reg], 
       AtomicDensityMatrix`RegionLabel[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`RegionLabel, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`RegionLabel, 
        MessageName[AtomicDensityMatrix`RegionLabel, "usage"], ""], 
       Attributes[AtomicDensityMatrix`ExperimentalSystem`Private`sys$] = {
        Temporary}, AtomicDensityMatrix`genericOptionsPattern[] = 
       PatternTest[
         BlankNullSequence[], MatchQ[
          Flatten[{#}], {
           RepeatedNull[
            Alternatives[
             Blank[Rule], 
             Blank[RuleDelayed]]]}]& ], 
       AtomicDensityMatrix`genericOptionsPattern[1] = PatternTest[
         Blank[], MatchQ[
          Flatten[{#}], {
           RepeatedNull[
            Alternatives[
             Blank[Rule], 
             Blank[RuleDelayed]]]}]& ], 
       TagSet[AtomicDensityMatrix`genericOptionsPattern, 
        MessageName[AtomicDensityMatrix`genericOptionsPattern, "usage"], ""], 
       
       TagSet[AtomicDensityMatrix`ArrowOffset, 
        MessageName[AtomicDensityMatrix`ArrowOffset, "usage"], ""], 
       AtomicDensityMatrix`OpticalParameters[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`OpticalParameters[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`OpticalParameters, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`OpticalParameters -> 
          AtomicDensityMatrix`OpticalParameters[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`OpticalParameters[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`OpticalParameters, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`OpticalParameters, 
        MessageName[AtomicDensityMatrix`OpticalParameters, "usage"], ""], 
       Condition[
         AtomicDensityMatrix`OpticalField[
          Pattern[AtomicDensityMatrix`OpticalField`Private`args, 
           BlankSequence[]], 
          Pattern[AtomicDensityMatrix`OpticalField`Private`opts, 
           OptionsPattern[]]], 2 <= 
         Length[{AtomicDensityMatrix`OpticalField`Private`args}] <= 3] := 
       Module[{AtomicDensityMatrix`OpticalField`Private`timeVariable = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`OpticalField, AtomicDensityMatrix`TimeVariable, 
            OptionValue[AtomicDensityMatrix`TimeVariable]], 
          AtomicDensityMatrix`OpticalField`Private`cartesianCoordinates = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`OpticalField, 
            AtomicDensityMatrix`CartesianCoordinates, 
            OptionValue[AtomicDensityMatrix`CartesianCoordinates]], 
          AtomicDensityMatrix`OpticalField`Private`parameterization = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`OpticalField, 
            AtomicDensityMatrix`Parameterization, 
            OptionValue[AtomicDensityMatrix`Parameterization]], 
          AtomicDensityMatrix`OpticalField`Private`polarizationVector = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`OpticalField, 
            AtomicDensityMatrix`PolarizationVector, 
            OptionValue[AtomicDensityMatrix`PolarizationVector]], 
          AtomicDensityMatrix`OpticalField`Private`propagationVector = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`OpticalField, 
            AtomicDensityMatrix`PropagationVector, 
            OptionValue[AtomicDensityMatrix`PropagationVector]], 
          AtomicDensityMatrix`OpticalField`Private`w, 
          AtomicDensityMatrix`OpticalField`Private`k0, 
          AtomicDensityMatrix`OpticalField`Private`E0, 
          AtomicDensityMatrix`OpticalField`Private`e, 
          AtomicDensityMatrix`OpticalField`Private`b, 
          AtomicDensityMatrix`OpticalField`Private`k, 
          AtomicDensityMatrix`OpticalField`Private`r, 
          AtomicDensityMatrix`OpticalField`Private`al, 
          AtomicDensityMatrix`OpticalField`Private`ep, 
          AtomicDensityMatrix`OpticalField`Private`chi, 
          AtomicDensityMatrix`OpticalField`Private`cphi, 
          AtomicDensityMatrix`OpticalField`Private`ph, 
          AtomicDensityMatrix`OpticalField`Private`S1, 
          AtomicDensityMatrix`OpticalField`Private`S2, 
          AtomicDensityMatrix`OpticalField`Private`S3, 
          AtomicDensityMatrix`OpticalField`Private`f, 
          AtomicDensityMatrix`OpticalField`Private`pol, AtomicDensityMatrix`t,
           AtomicDensityMatrix`OpticalField`Private`Ep, 
          AtomicDensityMatrix`OpticalField`Private`Em, 
          AtomicDensityMatrix`OpticalField`Private`php, 
          AtomicDensityMatrix`OpticalField`Private`phm, 
          AtomicDensityMatrix`OpticalField`Private`v0}, 
         Condition[{{
             AtomicDensityMatrix`OpticalField`Private`w, 
              AtomicDensityMatrix`OpticalField`Private`k0}, {
             AtomicDensityMatrix`OpticalField`Private`E0, 
              AtomicDensityMatrix`OpticalField`Private`cphi}, 
             AtomicDensityMatrix`OpticalField`Private`pol} = 
           AtomicDensityMatrix`standardizeOpticalFieldArguments[{
             AtomicDensityMatrix`OpticalField`Private`args}, 
             AtomicDensityMatrix`OpticalField`Private`parameterization]; {
            AtomicDensityMatrix`OpticalField`Private`e, 
             AtomicDensityMatrix`OpticalField`Private`k} = {
            AtomicDensityMatrix`OpticalField`Private`polarizationVector, 
             AtomicDensityMatrix`OpticalField`Private`propagationVector}; 
          AtomicDensityMatrix`t = 
           AtomicDensityMatrix`OpticalField`Private`timeVariable; 
          AtomicDensityMatrix`OpticalField`Private`r = 
           AtomicDensityMatrix`OpticalField`Private`cartesianCoordinates; 
          AtomicDensityMatrix`OpticalField`Private`b = 
           Cross[AtomicDensityMatrix`OpticalField`Private`k, 
             AtomicDensityMatrix`OpticalField`Private`e]; 
          AtomicDensityMatrix`OpticalField`Private`f = 
           AtomicDensityMatrix`OpticalField`Private`E0 
            E^(I (AtomicDensityMatrix`OpticalField`Private`k0 
                Dot[
                 AtomicDensityMatrix`OpticalField`Private`k, 
                  AtomicDensityMatrix`OpticalField`Private`r] + 
               AtomicDensityMatrix`OpticalField`Private`cphi - 
               AtomicDensityMatrix`t 
               AtomicDensityMatrix`OpticalField`Private`w)); 
          Switch[AtomicDensityMatrix`OpticalField`Private`parameterization, 
            "AngleEllipticity", {
              AtomicDensityMatrix`OpticalField`Private`al, 
               AtomicDensityMatrix`OpticalField`Private`ep} = 
             AtomicDensityMatrix`OpticalField`Private`pol; 
            AtomicDensityMatrix`OpticalField`Private`f Dot[
               
               AtomicDensityMatrix`OpticalField`Private`\
RodriguesRotationMatrix[
               AtomicDensityMatrix`OpticalField`Private`al, 
                AtomicDensityMatrix`OpticalField`Private`k], 
               Cos[AtomicDensityMatrix`OpticalField`Private`ep] 
                AtomicDensityMatrix`OpticalField`Private`e + 
               I Sin[AtomicDensityMatrix`OpticalField`Private`ep] 
                AtomicDensityMatrix`OpticalField`Private`b], 
            "RatioPhase", {
              AtomicDensityMatrix`OpticalField`Private`chi, 
               AtomicDensityMatrix`OpticalField`Private`ph} = 
             AtomicDensityMatrix`OpticalField`Private`pol; 
            AtomicDensityMatrix`OpticalField`Private`f (
              Cos[AtomicDensityMatrix`OpticalField`Private`chi] 
               AtomicDensityMatrix`OpticalField`Private`e + 
              Sin[AtomicDensityMatrix`OpticalField`Private`chi] 
               E^(I AtomicDensityMatrix`OpticalField`Private`ph) 
               AtomicDensityMatrix`OpticalField`Private`b), 
            "Stokes", {
              AtomicDensityMatrix`OpticalField`Private`S1, 
               AtomicDensityMatrix`OpticalField`Private`S2, 
               AtomicDensityMatrix`OpticalField`Private`S3} = 
             AtomicDensityMatrix`OpticalField`Private`pol; 
            AtomicDensityMatrix`OpticalField`Private`f (
              AtomicDensityMatrix`OpticalField`Private`b 
               E^(I If[
                  AtomicDensityMatrix`OpticalField`Private`S2 === 
                   AtomicDensityMatrix`OpticalField`Private`S3 === 0, Pi/4, 
                   ArcTan[
                   AtomicDensityMatrix`OpticalField`Private`S2, 
                    AtomicDensityMatrix`OpticalField`Private`S3]]) 
               Sqrt[1/2 - AtomicDensityMatrix`OpticalField`Private`S1/2] + (
                AtomicDensityMatrix`OpticalField`Private`e 
                Sqrt[1 + AtomicDensityMatrix`OpticalField`Private`S1])/Sqrt[
               2]), "SphericalPhase", {
              AtomicDensityMatrix`OpticalField`Private`Ep, 
               AtomicDensityMatrix`OpticalField`Private`php} = {
              AtomicDensityMatrix`OpticalField`Private`E0, 
               AtomicDensityMatrix`OpticalField`Private`cphi}; {
              AtomicDensityMatrix`OpticalField`Private`Em, 
               AtomicDensityMatrix`OpticalField`Private`phm} = 
             AtomicDensityMatrix`OpticalField`Private`pol; 
            AtomicDensityMatrix`OpticalField`Private`v0 = 
             AtomicDensityMatrix`ToCartesian[{{
                E^(I AtomicDensityMatrix`OpticalField`Private`php) 
                 AtomicDensityMatrix`OpticalField`Private`Ep}, {0}, {
                E^(I AtomicDensityMatrix`OpticalField`Private`phm) 
                 AtomicDensityMatrix`OpticalField`Private`Em}}]; 
            E^(I (AtomicDensityMatrix`OpticalField`Private`k0 
                 Dot[AtomicDensityMatrix`OpticalField`Private`k, 
                   AtomicDensityMatrix`OpticalField`Private`r] - 
                AtomicDensityMatrix`t 
                AtomicDensityMatrix`OpticalField`Private`w)) (
              Part[AtomicDensityMatrix`OpticalField`Private`v0, 1] 
               AtomicDensityMatrix`OpticalField`Private`e + 
              Part[AtomicDensityMatrix`OpticalField`Private`v0, 2] 
               AtomicDensityMatrix`OpticalField`Private`b)], 
          
          FreeQ[{{AtomicDensityMatrix`OpticalField`Private`timeVariable, 
             AtomicDensityMatrix`OpticalField`Private`cartesianCoordinates, 
             AtomicDensityMatrix`OpticalField`Private`parameterization, 
             AtomicDensityMatrix`OpticalField`Private`polarizationVector, 
             AtomicDensityMatrix`OpticalField`Private`propagationVector}}, \
$Failed]]], 
       Options[AtomicDensityMatrix`OpticalField] = {
        AtomicDensityMatrix`PolarizationVector -> {1, 0, 0}, 
         AtomicDensityMatrix`PropagationVector -> {0, 0, 1}, 
         AtomicDensityMatrix`Parameterization -> "AngleEllipticity", 
         AtomicDensityMatrix`CartesianCoordinates -> {
          AtomicDensityMatrix`Xx, AtomicDensityMatrix`Yy, 
           AtomicDensityMatrix`Zz}, AtomicDensityMatrix`TimeVariable -> 
         Automatic}, 
       TagSet[AtomicDensityMatrix`OpticalField, 
        MessageName[AtomicDensityMatrix`OpticalField, "trans"], 
        "PolarizationVector `1` must be transverse to PropagationVector \
`2`."], 
       TagSet[AtomicDensityMatrix`OpticalField, 
        MessageName[AtomicDensityMatrix`OpticalField, "usage"], 
        "\!\(\*TagBox[RowBox[{\"OpticalField[\", StyleBox[\"\[Omega]\", \
\"TR\"], \", \", StyleBox[\"a\", \"TI\"], \"] gives a complex \
time\[Hyphen]dependent electric field with angular frequency \", StyleBox[\"\
\[Omega]\", \"TR\"], \", real amplitude \", StyleBox[\"a\", \"TI\"], \", and \
default polarization. \", \"\[LineSeparator]\", \"OpticalField[\", \
StyleBox[\"\[Omega]\", \"TR\"], \",\", StyleBox[\"a\", \"TI\"], \",\", \
StyleBox[\"pol\", \"TI\"], \"] gives a field with polarization parameters \", \
StyleBox[\"pol\", \"TI\"], \". \", \"\[LineSeparator]\", \"OpticalField[{\", \
StyleBox[\"\[Omega]\", \"TR\"], \",\", StyleBox[\"k\", \"TI\"], \"),{\", \
StyleBox[\"a\", \"TI\"], \",\", StyleBox[\"\[CurlyPhi]\", \"TR\"], \"},\", \
StyleBox[\"pol\", \"TI\"], \"] gives a spatially dependent plane\[Hyphen]wave \
field with angular wavenumber \", StyleBox[\"k\", \"TI\"], \" and phase \", \
StyleBox[\"\[CurlyPhi]\", \"TR\"], \". \"}], DisplayForm]\)"], 
       TagSet[AtomicDensityMatrix`TimeVariable, 
        MessageName[AtomicDensityMatrix`TimeVariable, "usage"], 
        "TimeVariable is an option for DensityMatrix and related functions \
that specifies what symbol is to be used for the time variable."], 
       TagSet[AtomicDensityMatrix`CartesianCoordinates, 
        MessageName[AtomicDensityMatrix`CartesianCoordinates, "usage"], 
        "CartesianCoordinates is an option for OpticalField and related \
functions that specifies the variables to be used to denote the Cartesian \
coordinates."], 
       TagSet[AtomicDensityMatrix`Parameterization, 
        MessageName[AtomicDensityMatrix`Parameterization, "usage"], 
        "Parameterization is an option for OpticalField and related functions \
that specifies the parameterization used to describe the light \
polarization."], 
       TagSet[AtomicDensityMatrix`PolarizationVector, 
        MessageName[AtomicDensityMatrix`PolarizationVector, "usage"], 
        "PolarizationVector is an option for OpticalField and related \
functions that specifies the reference light polarization direction."], 
       TagSet[AtomicDensityMatrix`PropagationVector, 
        MessageName[AtomicDensityMatrix`PropagationVector, "usage"], 
        "PropagationVector is an option for OpticalField and related \
functions that specifies the light propagation direction."], 
       TagSet[AtomicDensityMatrix`t, 
        MessageName[AtomicDensityMatrix`t, "usage"], 
        "t is the default value for the option TimeVariable in DensityMatrix \
and other functions."], Condition[
         AtomicDensityMatrix`standardizeOpticalFieldArguments[
          Pattern[AtomicDensityMatrix`OpticalField`Private`args, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`OpticalField`Private`parameterization, 
           Blank[]]], 2 <= 
         Length[AtomicDensityMatrix`OpticalField`Private`args] <= 3] := 
       MapThread[PadRight[
          AtomicDensityMatrix`EnsureList[#], 
          Length[#2], #2]& , {
          PadRight[
          AtomicDensityMatrix`OpticalField`Private`args, 3, {{}}], {{0, 0}, {
           0, 0}, 
           AtomicDensityMatrix`defaultPolarization[
           AtomicDensityMatrix`OpticalField`Private`parameterization]}}], 
       Condition[
         AtomicDensityMatrix`standardizeOpticalFieldArguments[
          Pattern[AtomicDensityMatrix`OpticalField`Private`args, 
           Blank[]]], 2 <= 
         Length[AtomicDensityMatrix`OpticalField`Private`args] <= 3] := 
       Map[PadRight[
          AtomicDensityMatrix`EnsureList[#], 2, {0, 0}]& , 
         Take[AtomicDensityMatrix`OpticalField`Private`args, 2]], 
       TagSet[AtomicDensityMatrix`standardizeOpticalFieldArguments, 
        MessageName[
        AtomicDensityMatrix`standardizeOpticalFieldArguments, "usage"], ""], 
       AtomicDensityMatrix`EnsureList[
         Pattern[AtomicDensityMatrix`Common`Private`expr, 
          Blank[]]] := If[
         ListQ[AtomicDensityMatrix`Common`Private`expr], 
         AtomicDensityMatrix`Common`Private`expr, {
         AtomicDensityMatrix`Common`Private`expr}], 
       TagSet[AtomicDensityMatrix`EnsureList, 
        MessageName[AtomicDensityMatrix`EnsureList, "usage"], ""], 
       AtomicDensityMatrix`defaultPolarization["AngleEllipticity"] = {0, 0}, 
       AtomicDensityMatrix`defaultPolarization["RatioPhase"] = {0, 0}, 
       AtomicDensityMatrix`defaultPolarization["SphericalPhase"] = {0, 0}, 
       AtomicDensityMatrix`defaultPolarization["Stokes"] = {1, 0, 0}, 
       TagSet[AtomicDensityMatrix`defaultPolarization, 
        MessageName[AtomicDensityMatrix`defaultPolarization, "usage"], ""], 
       AtomicDensityMatrix`OpticalField`Private`RodriguesRotationMatrix[
         Pattern[AtomicDensityMatrix`OpticalField`Private`th, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`OpticalField`Private`v, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`OpticalField`Private`ident = 
          IdentityMatrix[3], 
          AtomicDensityMatrix`OpticalField`Private`omegaMat}, 
         AtomicDensityMatrix`OpticalField`Private`omegaMat = 
          Map[Cross[#, AtomicDensityMatrix`OpticalField`Private`v]& , 
            AtomicDensityMatrix`OpticalField`Private`ident]; 
         AtomicDensityMatrix`OpticalField`Private`ident + 
          AtomicDensityMatrix`OpticalField`Private`omegaMat 
           Sin[AtomicDensityMatrix`OpticalField`Private`th] + 
          Dot[AtomicDensityMatrix`OpticalField`Private`omegaMat, 
             AtomicDensityMatrix`OpticalField`Private`omegaMat] (1 - Cos[
            AtomicDensityMatrix`OpticalField`Private`th])], 
       AtomicDensityMatrix`ToCartesian[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {"OneByOne", 
            BlankNullSequence[]}]}] := 
       First[AtomicDensityMatrix`TensorAlgebra`Private`a], 
       AtomicDensityMatrix`ToCartesian[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Alternatives[{"Cartesian", 
            BlankNullSequence[]}, {"Scalar"}]}] := 
       AtomicDensityMatrix`TensorAlgebra`Private`a, 
       AtomicDensityMatrix`ToCartesian[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], {"Contravariant", 
           BlankNullSequence[]}}] := AtomicDensityMatrix`Components[
         Wedge[
          AtomicDensityMatrix`ToCartesianMatrix[
           AtomicDensityMatrix`Rank[
           AtomicDensityMatrix`TensorAlgebra`Private`a]], 
          AtomicDensityMatrix`TensorAlgebra`Private`a]], 
       AtomicDensityMatrix`ToCartesian[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], {"Covariant", 
           BlankNullSequence[]}}] := AtomicDensityMatrix`Components[
         Wedge[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`ECT[
           AtomicDensityMatrix`ToCartesianMatrix[
            AtomicDensityMatrix`Rank[
            AtomicDensityMatrix`TensorAlgebra`Private`a]]]]], 
       AtomicDensityMatrix`ToCartesian[
         PatternTest[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`op, 
           Blank[]], AtomicDensityMatrix`OperatorQ]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`mat = 
          AtomicDensityMatrix`BlockDiagonal[
            Map[AtomicDensityMatrix`ToCartesianMatrix, 
             Map[AtomicDensityMatrix`F, 
              AtomicDensityMatrix`RemoveZeemanSublevels[
              AtomicDensityMatrix`TensorAlgebra`Private`sys]]]]}, 
         CenterDot[
         AtomicDensityMatrix`TensorAlgebra`Private`mat, 
          AtomicDensityMatrix`TensorAlgebra`Private`op, 
          AtomicDensityMatrix`ECT[
          AtomicDensityMatrix`TensorAlgebra`Private`mat]]], 
       AtomicDensityMatrix`ToCartesian[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}] := Condition[Null, 
         Message[
          MessageName[AtomicDensityMatrix`ToCartesian, "wrongtype"], 
          AtomicDensityMatrix`TensorAlgebra`Private`type]], 
       AtomicDensityMatrix`ToCartesian[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Except[
           Alternatives[{
             Blank[], {
              Repeated[
               Alternatives[
               "Scalar", "Cartesian", "Contravariant", "Covariant", 
                "Operator", "OneByOne", "TensorDecomposition", 
                "TensorDecompositionMatrix"]]}}, {
             Repeated[
              Blank[AtomicDensityMatrix`AtomicState]]}]]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`type$ = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`a], 
          AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = True, 
          AtomicDensityMatrix`TensorAlgebra`Private`result$}, 
         AtomicDensityMatrix`TensorAlgebra`Private`result$ = Check[
            
            AtomicDensityMatrix`ToCartesian[{
             AtomicDensityMatrix`TensorAlgebra`Private`a, 
              AtomicDensityMatrix`TensorAlgebra`Private`type$}], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = False]; 
         Condition[AtomicDensityMatrix`TensorAlgebra`Private`result$, 
           And[
            AtomicDensityMatrix`TensorTypeQ[
            AtomicDensityMatrix`TensorAlgebra`Private`type$], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$, True]]], 
       TagSet[AtomicDensityMatrix`ToCartesian, 
        MessageName[AtomicDensityMatrix`ToCartesian, "usage"], 
        "\!\(\*TagBox[RowBox[{\"ToCartesian[\", StyleBox[\"tens\", \"TI\"], \
\"] converts a rank\[Hyphen]one covariant or contravariant spherical tensor \
\", StyleBox[\"tens\", \"TI\"], \" to the Cartesian basis.\"}], \
DisplayForm]\)"], 
       TagSet[AtomicDensityMatrix`ToCartesian, 
        MessageName[AtomicDensityMatrix`ToCartesian, "wrongtype"], 
        "Tensor of type `1` cannot be converted to Cartesian form."], 
       AtomicDensityMatrix`Components[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Alternatives["Scalar", "Cartesian", "TensorDecomposition"], 
            BlankNullSequence[]}]}] := 
       AtomicDensityMatrix`TensorAlgebra`Private`a, 
       AtomicDensityMatrix`Components[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Alternatives[
            "Covariant", "Contravariant", "OneByOne", "Operator", 
             "TensorDecompositionMatrix"], 
            BlankNullSequence[]}]}] := 
       Flatten[AtomicDensityMatrix`TensorAlgebra`Private`a, 1], 
       AtomicDensityMatrix`Components[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}] := Condition[Null, 
         Message[
          MessageName[AtomicDensityMatrix`Components, "wrongtype"], 
          AtomicDensityMatrix`TensorAlgebra`Private`type]], 
       AtomicDensityMatrix`Components[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Except[
           Alternatives[{
             Blank[], {
              Repeated[
               Alternatives[
               "Scalar", "Cartesian", "Contravariant", "Covariant", 
                "Operator", "OneByOne", "TensorDecomposition", 
                "TensorDecompositionMatrix"]]}}, {
             Repeated[
              Blank[AtomicDensityMatrix`AtomicState]]}]]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`type$ = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`a], 
          AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = True, 
          AtomicDensityMatrix`TensorAlgebra`Private`result$}, 
         AtomicDensityMatrix`TensorAlgebra`Private`result$ = Check[
            
            AtomicDensityMatrix`Components[{
             AtomicDensityMatrix`TensorAlgebra`Private`a, 
              AtomicDensityMatrix`TensorAlgebra`Private`type$}], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = False]; 
         Condition[AtomicDensityMatrix`TensorAlgebra`Private`result$, 
           And[
            AtomicDensityMatrix`TensorTypeQ[
            AtomicDensityMatrix`TensorAlgebra`Private`type$], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$, True]]], 
       TagSet[AtomicDensityMatrix`Components, 
        MessageName[AtomicDensityMatrix`Components, "usage"], ""], 
       Attributes[AtomicDensityMatrix`TensorAlgebra`Private`type$] = {
        Temporary}, 
       Attributes[AtomicDensityMatrix`TensorAlgebra`Private`noMessage$] = {
        Temporary}, 
       Attributes[AtomicDensityMatrix`TensorAlgebra`Private`result$] = {
        Temporary}, AtomicDensityMatrix`TensorTypeQ[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[]]] := MatchQ[AtomicDensityMatrix`TensorAlgebra`Private`a, 
         AtomicDensityMatrix`TensorTypePattern[]], 
       TagSet[AtomicDensityMatrix`TensorTypeQ, 
        MessageName[AtomicDensityMatrix`TensorTypeQ, "usage"], ""], 
       AtomicDensityMatrix`TensorTypePattern[] = {
         Repeated[
          Alternatives[
          "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
           "OneByOne", "TensorDecomposition", "TensorDecompositionMatrix"]]}, 
       
       TagSet[AtomicDensityMatrix`TensorTypePattern, 
        MessageName[AtomicDensityMatrix`TensorTypePattern, "usage"], ""], 
       Wedge = AtomicDensityMatrix`MatrixMultiply[
         SlotSequence[1], "MultiplyLevel" -> Top]& , 
       AtomicDensityMatrix`MatrixMultiply[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`c, 
          Repeated[
           Except[
            PatternTest[
             Blank[], OptionQ]]]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`opts, 
          OptionsPattern[]]] := AtomicDensityMatrix`MatrixMultiply[
         AtomicDensityMatrix`MatrixMultiply[
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`opts], 
         AtomicDensityMatrix`TensorAlgebra`Private`c, 
         AtomicDensityMatrix`TensorAlgebra`Private`opts], 
       AtomicDensityMatrix`MatrixMultiply[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
          Blank[]], 
         OptionsPattern[]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`scalarizeOneByOnes = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`MatrixMultiply, 
            AtomicDensityMatrix`ScalarizeOneByOnes, 
            OptionValue[AtomicDensityMatrix`ScalarizeOneByOnes]], 
          AtomicDensityMatrix`TensorAlgebra`Private`sumRanks = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`MatrixMultiply, AtomicDensityMatrix`SumRanks, 
            OptionValue[AtomicDensityMatrix`SumRanks]], 
          AtomicDensityMatrix`TensorAlgebra`Private`aType = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`a], 
          AtomicDensityMatrix`TensorAlgebra`Private`bType = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`b], 
          AtomicDensityMatrix`TensorAlgebra`Private`noMessage = True, 
          AtomicDensityMatrix`TensorAlgebra`Private`result}, 
         Condition[AtomicDensityMatrix`TensorAlgebra`Private`result = Check[
             AtomicDensityMatrix`TensorAlgebra`Private`QuietCheck[
              If[
              AtomicDensityMatrix`TensorAlgebra`Private`scalarizeOneByOnes, 
               AtomicDensityMatrix`ScalarizeOneByOnes, Identity][
               AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
                AtomicDensityMatrix`TensorAlgebra`Private`a, 
                 AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
                AtomicDensityMatrix`TensorAlgebra`Private`b, 
                 AtomicDensityMatrix`TensorAlgebra`Private`bType}, 
                OptionValue["MultiplyLevel"], 
                AtomicDensityMatrix`TensorAlgebra`Private`sumRanks, 
                OptionValue["AllowCartesianTimesOperator"]]], 
              Message[
               MessageName[AtomicDensityMatrix`MatrixMultiply, "dotsh"], 
               AtomicDensityMatrix`TensorAlgebra`Private`aType, 
               AtomicDensityMatrix`TensorAlgebra`Private`bType], {
               MessageName[Inner, "incom"], 
               MessageName[Dot, "dotsh"], 
               MessageName[MapThread, "mptc"], 
               MessageName[AtomicDensityMatrix`TensorType, "unrec"]}], 
             AtomicDensityMatrix`TensorAlgebra`Private`noMessage = False]; 
          Condition[
           AtomicDensityMatrix`TensorAlgebra`Private`result, 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage], 
          
          FreeQ[{{AtomicDensityMatrix`TensorAlgebra`Private`\
scalarizeOneByOnes, 
             AtomicDensityMatrix`TensorAlgebra`Private`sumRanks}}, $Failed]]],
        Options[AtomicDensityMatrix`MatrixMultiply] = {
        AtomicDensityMatrix`ScalarizeOneByOnes -> True, 
         AtomicDensityMatrix`SumRanks -> True, "MultiplyLevel" -> Automatic, 
         "AllowCartesianTimesOperator" -> False}, 
       TagSet[AtomicDensityMatrix`MatrixMultiply, 
        MessageName[AtomicDensityMatrix`MatrixMultiply, "coco"], 
        "Inner product attempted between two covariant or two contravariant \
tensors."], 
       TagSet[AtomicDensityMatrix`MatrixMultiply, 
        MessageName[AtomicDensityMatrix`MatrixMultiply, "dotsh"], 
        "Tensors of type `1` and `2` have incompatible dimensions."], 
       TagSet[AtomicDensityMatrix`MatrixMultiply, 
        MessageName[AtomicDensityMatrix`MatrixMultiply, "nomult"], 
        "Tensors of type `1` and `2` cannot be multiplied in this manner."], 
       TagSet[AtomicDensityMatrix`MatrixMultiply, 
        MessageName[AtomicDensityMatrix`MatrixMultiply, "opco"], 
        "Operator multiplication attempted on wrong side of covariant or \
contravariant tensor."], 
       TagSet[AtomicDensityMatrix`MatrixMultiply, 
        MessageName[AtomicDensityMatrix`MatrixMultiply, "sphca"], 
        "Inner product attempted between spherical and Cartesian tensors."], 
       TagSet[AtomicDensityMatrix`MatrixMultiply, 
        MessageName[AtomicDensityMatrix`MatrixMultiply, "usage"], 
        "MatrixMultiply[] MatrixMultiply"], 
       AtomicDensityMatrix`ScalarizeOneByOnes[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`type = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`a], 
          AtomicDensityMatrix`TensorAlgebra`Private`pos}, 
         AtomicDensityMatrix`TensorAlgebra`Private`pos = Flatten[
            Position[
            AtomicDensityMatrix`TensorAlgebra`Private`type, "OneByOne"]]; 
         Condition[
           Fold[
           AtomicDensityMatrix`ComponentMap[
            Part[#, 1, 1]& , {#, 
              AtomicDensityMatrix`TensorAlgebra`Private`type}, #2]& , 
            AtomicDensityMatrix`TensorAlgebra`Private`a, 
            Reverse[AtomicDensityMatrix`TensorAlgebra`Private`pos] - 1], 
           AtomicDensityMatrix`TensorTypeQ[
           AtomicDensityMatrix`TensorAlgebra`Private`type]]], 
       TagSet[AtomicDensityMatrix`ScalarizeOneByOnes, 
        MessageName[AtomicDensityMatrix`ScalarizeOneByOnes, "usage"], ""], 
       AtomicDensityMatrix`ComponentMap[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`f, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}, 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
           Blank[]], 1]] := 
       Map[AtomicDensityMatrix`TensorAlgebra`Private`f, 
         AtomicDensityMatrix`TensorAlgebra`Private`a, {
          
          AtomicDensityMatrix`TensorDepth[{
           AtomicDensityMatrix`TensorAlgebra`Private`a, 
            AtomicDensityMatrix`TensorAlgebra`Private`type}, 
           AtomicDensityMatrix`TensorAlgebra`Private`n]}], 
       AtomicDensityMatrix`ComponentMap[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`f, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Except[
           Alternatives[{
             Blank[], {
              Repeated[
               Alternatives[
               "Scalar", "Cartesian", "Contravariant", "Covariant", 
                "Operator", "OneByOne", "TensorDecomposition", 
                "TensorDecompositionMatrix"]]}}, {
             Repeated[
              Blank[AtomicDensityMatrix`AtomicState]]}]]], 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
           Blank[]], 1]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`type$ = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`a], 
          AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = True, 
          AtomicDensityMatrix`TensorAlgebra`Private`result$}, 
         AtomicDensityMatrix`TensorAlgebra`Private`result$ = Check[
            AtomicDensityMatrix`ComponentMap[
            AtomicDensityMatrix`TensorAlgebra`Private`f, {
             AtomicDensityMatrix`TensorAlgebra`Private`a, 
              AtomicDensityMatrix`TensorAlgebra`Private`type$}, 
             AtomicDensityMatrix`TensorAlgebra`Private`n], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = False]; 
         Condition[AtomicDensityMatrix`TensorAlgebra`Private`result$, 
           And[
            AtomicDensityMatrix`TensorTypeQ[
            AtomicDensityMatrix`TensorAlgebra`Private`type$], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$, True]]], 
       TagSet[AtomicDensityMatrix`ComponentMap, 
        MessageName[AtomicDensityMatrix`ComponentMap, "usage"], ""], 
       AtomicDensityMatrix`TensorDepth[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}, 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
           Blank[]], -1]] := Total[
         ReplaceAll[
          If[
           NonNegative[AtomicDensityMatrix`TensorAlgebra`Private`n], 
           Take[
           AtomicDensityMatrix`TensorAlgebra`Private`type, 
            AtomicDensityMatrix`TensorAlgebra`Private`n], 
           Drop[
           AtomicDensityMatrix`TensorAlgebra`Private`type, 
            AtomicDensityMatrix`TensorAlgebra`Private`n + 1]], 
          AtomicDensityMatrix`TensorAlgebra`Private`tensorLevels]], 
       AtomicDensityMatrix`TensorDepth[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Except[
           Alternatives[{
             Blank[], {
              Repeated[
               Alternatives[
               "Scalar", "Cartesian", "Contravariant", "Covariant", 
                "Operator", "OneByOne", "TensorDecomposition", 
                "TensorDecompositionMatrix"]]}}, {
             Repeated[
              Blank[AtomicDensityMatrix`AtomicState]]}]]], 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`n, 
           Blank[]], -1]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`type$ = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`a], 
          AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = True, 
          AtomicDensityMatrix`TensorAlgebra`Private`result$}, 
         AtomicDensityMatrix`TensorAlgebra`Private`result$ = Check[
            
            AtomicDensityMatrix`TensorDepth[{
             AtomicDensityMatrix`TensorAlgebra`Private`a, 
              AtomicDensityMatrix`TensorAlgebra`Private`type$}, 
             AtomicDensityMatrix`TensorAlgebra`Private`n], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = False]; 
         Condition[AtomicDensityMatrix`TensorAlgebra`Private`result$, 
           And[
            AtomicDensityMatrix`TensorTypeQ[
            AtomicDensityMatrix`TensorAlgebra`Private`type$], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$, True]]], 
       TagSet[AtomicDensityMatrix`TensorDepth, 
        MessageName[AtomicDensityMatrix`TensorDepth, "usage"], ""], 
       AtomicDensityMatrix`TensorAlgebra`Private`tensorLevels = 
       Dispatch[{
         "Scalar" -> 0, "Cartesian" -> 1, "TensorDecomposition" -> 1, 
          "Covariant" -> 2, "Contravariant" -> 2, "OneByOne" -> 2, "Operator" -> 
          2, "TensorDecompositionMatrix" -> 2}], 
       TagSet[AtomicDensityMatrix`SumRanks, 
        MessageName[AtomicDensityMatrix`SumRanks, "usage"], ""], 
       Attributes[AtomicDensityMatrix`TensorAlgebra`Private`QuietCheck] = {
        HoldAll}, AtomicDensityMatrix`TensorAlgebra`Private`QuietCheck[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`expr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`failexpr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`msgs, 
          Blank[]]] := Quiet[
         Check[
         AtomicDensityMatrix`TensorAlgebra`Private`expr, 
          AtomicDensityMatrix`TensorAlgebra`Private`failexpr, 
          AtomicDensityMatrix`TensorAlgebra`Private`msgs], 
         AtomicDensityMatrix`TensorAlgebra`Private`msgs], Condition[
         AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, {
             Repeated[
              Alternatives[
              "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator",
                "OneByOne", "TensorDecomposition", 
               "TensorDecompositionMatrix"]]}]}, {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
             Repeated[
              Alternatives[
              "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator",
                "OneByOne", "TensorDecomposition", 
               "TensorDecompositionMatrix"]]}]}, 
          BlankSequence[]], 
         MatchQ[{
          AtomicDensityMatrix`TensorAlgebra`Private`aType, 
           AtomicDensityMatrix`TensorAlgebra`Private`bType}, 
          Alternatives[{{"Cartesian"}, {
             Alternatives["Covariant", "Contravariant"], 
             BlankNullSequence[]}}, {{
             Alternatives["Covariant", "Contravariant"], 
             BlankNullSequence[]}, {"Cartesian"}}, {
            Alternatives[{"Covariant"}, {"Cartesian", 
              Alternatives["Operator", "Covariant"]}], 
            Alternatives[{"Covariant"}, {
              Alternatives["Covariant", "Cartesian"], "Covariant"}]}, {
            Alternatives[{"Contravariant"}, {
              Alternatives["Contravariant", "Cartesian"], "Contravariant"}], 
            Alternatives[{"Contravariant"}, {"Cartesian", 
              Alternatives["Operator", "Contravariant"]}]}, {{"Operator"}, 
            Alternatives[{"Covariant"}, {"Covariant", "Covariant"}]}, {
            
            Alternatives[{"Contravariant"}, {
             "Contravariant", "Contravariant"}], {"Operator"}}, {{"Cartesian", 
             Blank[]}, {
             Alternatives["Covariant", "Contravariant"], 
             Blank[]}}, {{
             Alternatives["Covariant", "Contravariant"], 
             Blank[]}, {"Cartesian", 
             Blank[]}}, {{"Covariant", 
             Blank[]}, {"Covariant", 
             Blank[]}}, {{"Contravariant", 
             Blank[]}, {
             Alternatives["Covariant", "Contravariant"], 
             Blank[]}}]]] := Message[
         MessageName[AtomicDensityMatrix`MatrixMultiply, "nomult"], 
         AtomicDensityMatrix`TensorAlgebra`Private`aType, 
         AtomicDensityMatrix`TensorAlgebra`Private`bType], 
       AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], {"Scalar"}}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}, 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorAlgebra`Private`a 
        AtomicDensityMatrix`TensorAlgebra`Private`b, 
       AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], {"Scalar"}}, 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorAlgebra`Private`a 
        AtomicDensityMatrix`TensorAlgebra`Private`b, 
       AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, {
            Alternatives[
            "Operator", "Covariant", "Contravariant", "OneByOne"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Alternatives[
            "Operator", "Covariant", "Contravariant", "OneByOne"]}]}, 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}], 
       AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], {"Cartesian"}}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], {"Cartesian"}}, 
         BlankSequence[]] := 
       Dot[AtomicDensityMatrix`TensorAlgebra`Private`a, 
         AtomicDensityMatrix`TensorAlgebra`Private`b], 
       AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, {
            Alternatives["Cartesian", "Operator"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Alternatives["Cartesian", "Operator"]}]}, 
         Blank[], 
         Blank[], True] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}], 
       AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, {
            Alternatives["Operator", "Covariant", "OneByOne"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Alternatives["Contravariant", "OneByOne"], 
            Alternatives[
            "Operator", "Covariant", "Contravariant", "OneByOne"]}]}, 
         Alternatives[Automatic, Top], 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}, Alignment -> Top],
        AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, {
            Alternatives["Operator", "Covariant", "OneByOne"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Alternatives["Covariant", "Contravariant", "OneByOne"], 
            Alternatives["Operator", "Contravariant", "OneByOne"]}]}, Bottom, 
         
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}, Alignment -> 
         Bottom], AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, {
            Alternatives["Covariant", "OneByOne"], 
            Alternatives[
            "Operator", "Covariant", "Contravariant", "OneByOne"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Alternatives["Operator", "Contravariant", "OneByOne"]}]}, 
         Alternatives[Automatic, Top], 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}, Alignment -> Top],
        AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, {
            Alternatives["Covariant", "Contravariant", "OneByOne"], 
            Alternatives["Operator", "Covariant", "OneByOne"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Alternatives["Operator", "Contravariant", "OneByOne"]}]}, Bottom, 
         
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}, Alignment -> 
         Bottom], AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, {
            Alternatives["Operator", "OneByOne"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`bType, {"Cartesian", 
            Alternatives[
            "Operator", "Covariant", "Contravariant", "OneByOne"]}]}, Top, 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}, Alignment -> Top],
        AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, {
            Alternatives["Operator", "Covariant", "OneByOne"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`bType, {"Cartesian", 
            Alternatives["Operator", "Contravariant", "OneByOne"]}]}, 
         Alternatives[Bottom, Automatic], 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}, Alignment -> 
         Bottom], AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`aType, {"Cartesian", 
            Alternatives[
            "Operator", "Covariant", "Contravariant", "OneByOne"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Alternatives["Operator", "OneByOne"]}]}, Top, 
         Blank[], True] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}, Alignment -> Top],
        AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`aType, {"Cartesian", 
            Alternatives["Operator", "Covariant", "OneByOne"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Alternatives["Operator", "Contravariant", "OneByOne"]}]}, 
         Alternatives[Bottom, Automatic], 
         Blank[], 
         Blank[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}, Alignment -> 
         Bottom], AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`aType, {"Cartesian", 
            Alternatives[
            "Operator", "Covariant", "Contravariant", "OneByOne"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`bType, {"Cartesian"}]}, 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}], 
       AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`aType, {"Cartesian"}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`bType, {"Cartesian", 
            Alternatives[
            "Operator", "Covariant", "Contravariant", "OneByOne"]}]}, 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}], 
       AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`aType, {
           "Contravariant"}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`bType, {
           "Cartesian", "Covariant"}]}, 
         Alternatives[Automatic, Bottom], 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}, Alignment -> 
         Bottom], AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`aType, {
           "Cartesian", "Contravariant"}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`bType, {"Covariant"}]}, 
         Alternatives[Automatic, Bottom], 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}, Alignment -> 
         Bottom], AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`aType, {"Cartesian", 
            Alternatives[
            "Operator", "Covariant", "Contravariant", "OneByOne"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`bType, {"Cartesian", 
            Alternatives[
            "Operator", "Covariant", "Contravariant", "OneByOne"]}]}, 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}], 
       AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, {
            Alternatives["Covariant", "Contravariant", "OneByOne"], 
            Alternatives[
            "Operator", "Covariant", "Contravariant", "OneByOne"]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Alternatives["Covariant", "Contravariant", "OneByOne"], 
            Alternatives[
            "Operator", "Covariant", "Contravariant", "OneByOne"]}]}, 
         BlankSequence[]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`aType}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}], 
       AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`aType, {
           "TensorDecomposition", 
            Alternatives["Covariant", "Operator", "OneByOne"], 
            BlankNullSequence[]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`bType, {
           "TensorDecomposition", 
            Alternatives["Contravariant", "Operator", "OneByOne"], 
            BlankNullSequence[]}]}, 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`multiplyLevel, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`sumRanks, 
          Blank[]], 
         Blank[]] := If[
         And[AtomicDensityMatrix`TensorAlgebra`Private`sumRanks, 
          MatchQ[
           
           Part[{AtomicDensityMatrix`TensorAlgebra`Private`aType, 
             AtomicDensityMatrix`TensorAlgebra`Private`bType}, All, 2], {
            Alternatives["Covariant", "OneByOne"], 
            Alternatives["Contravariant", "OneByOne"]}]], Total, Identity][
         MapThread[
         AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{#, 
            Rest[AtomicDensityMatrix`TensorAlgebra`Private`aType]}, {#2, 
            Rest[AtomicDensityMatrix`TensorAlgebra`Private`bType]}, 
           AtomicDensityMatrix`TensorAlgebra`Private`multiplyLevel, 
           AtomicDensityMatrix`TensorAlgebra`Private`sumRanks, False]& , {
          AtomicDensityMatrix`TensorAlgebra`Private`a, 
           AtomicDensityMatrix`TensorAlgebra`Private`b}]], 
       AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`aType, {
           "TensorDecompositionMatrix", "TensorDecomposition", 
            Alternatives["Covariant", "Operator", "OneByOne"], 
            BlankNullSequence[]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`bType, {
           "TensorDecompositionMatrix", "TensorDecomposition", 
            Alternatives["Contravariant", "Operator", "OneByOne"], 
            BlankNullSequence[]}]}, 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`multiplyLevel, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`sumRanks, 
          Blank[]], 
         Blank[]] := If[
         And[AtomicDensityMatrix`TensorAlgebra`Private`sumRanks, 
          MatchQ[
           
           Part[{AtomicDensityMatrix`TensorAlgebra`Private`aType, 
             AtomicDensityMatrix`TensorAlgebra`Private`bType}, All, 3], {
            Alternatives["Covariant", "OneByOne"], 
            Alternatives["Contravariant", "OneByOne"]}]], Total[#, 2]& , 
         Identity][
         MapThread[
         AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{#, 
            Rest[AtomicDensityMatrix`TensorAlgebra`Private`aType]}, {#2, 
            Rest[AtomicDensityMatrix`TensorAlgebra`Private`bType]}, 
           AtomicDensityMatrix`TensorAlgebra`Private`multiplyLevel, 
           AtomicDensityMatrix`TensorAlgebra`Private`sumRanks, False]& , {
          AtomicDensityMatrix`TensorAlgebra`Private`a, 
           AtomicDensityMatrix`TensorAlgebra`Private`b}, 2]], 
       AtomicDensityMatrix`TensorAlgebra`Private`matrixMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}, 
         BlankSequence[]] := Message[
         MessageName[AtomicDensityMatrix`MatrixMultiply, "nomult"], 
         AtomicDensityMatrix`TensorAlgebra`Private`aType, 
         AtomicDensityMatrix`TensorAlgebra`Private`bType], 
       AtomicDensityMatrix`TensorMultiply[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}, 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`alignment = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`TensorMultiply, Alignment, 
            OptionValue[Alignment]], 
          AtomicDensityMatrix`TensorAlgebra`Private`types}, 
         Condition[
         AtomicDensityMatrix`TensorAlgebra`Private`types = 
           AtomicDensityMatrix`TensorAlgebra`Private`alignTensorTypes[
            AtomicDensityMatrix`TensorAlgebra`Private`aType, 
             AtomicDensityMatrix`TensorAlgebra`Private`bType, 
             AtomicDensityMatrix`TensorAlgebra`Private`alignment]; Condition[
            AtomicDensityMatrix`InnerAt[
            AtomicDensityMatrix`TensorAlgebra`Private`a, 
             AtomicDensityMatrix`TensorAlgebra`Private`b, 
             Apply[Sequence, 
              AtomicDensityMatrix`TensorAlgebra`Private`TensorMultiplyIndices[
              AtomicDensityMatrix`TensorAlgebra`Private`types, 
               FilterRules[{AtomicDensityMatrix`TensorAlgebra`Private`opts, 
                 Options[AtomicDensityMatrix`TensorMultiply]}, 
                Options[
                AtomicDensityMatrix`TensorAlgebra`Private`\
TensorMultiplyIndices]]]]], 
            AtomicDensityMatrix`TensorAlgebra`Private`MessageIf[
             FreeQ[
              Transpose[AtomicDensityMatrix`TensorAlgebra`Private`types], 
              AtomicDensityMatrix`TensorAlgebra`Private`\
disallowedMultiplyPairs], 
             MessageName[AtomicDensityMatrix`MatrixMultiply, "nomult"], 
             AtomicDensityMatrix`TensorAlgebra`Private`aType, 
             AtomicDensityMatrix`TensorAlgebra`Private`bType]], 
          
          FreeQ[{{AtomicDensityMatrix`TensorAlgebra`Private`alignment}}, \
$Failed]]], AtomicDensityMatrix`TensorMultiply[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`TensorMultiply[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorType[
          AtomicDensityMatrix`TensorAlgebra`Private`a]}, {
         AtomicDensityMatrix`TensorAlgebra`Private`b, 
          AtomicDensityMatrix`TensorType[
          AtomicDensityMatrix`TensorAlgebra`Private`b]}, 
         AtomicDensityMatrix`TensorAlgebra`Private`opts], 
       Options[AtomicDensityMatrix`TensorMultiply] = {
        Alignment -> Top, 
         AtomicDensityMatrix`TraceOver -> {"TensorDecompositionMatrix"}}, 
       TagSet[AtomicDensityMatrix`TensorMultiply, 
        MessageName[AtomicDensityMatrix`TensorMultiply, "usage"], ""], 
       AtomicDensityMatrix`TensorAlgebra`Private`alignTensorTypes[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`aType, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`bType, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`alignment, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`TensorAlgebra`Private`alignment, {
         Top -> PadRight, Bottom -> PadLeft}][{
         AtomicDensityMatrix`TensorAlgebra`Private`aType, 
          AtomicDensityMatrix`TensorAlgebra`Private`bType}], 
       AtomicDensityMatrix`InnerAt[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`pairs, 
          Blank[]], 
         Optional[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`reordering, 
           Blank[]], {}]] := 
       Module[{}, {
           AtomicDensityMatrix`TensorAlgebra`Private`ia, 
            AtomicDensityMatrix`TensorAlgebra`Private`ib} = 
          Transpose[AtomicDensityMatrix`TensorAlgebra`Private`pairs]; {
           AtomicDensityMatrix`TensorAlgebra`Private`iaremain, 
            AtomicDensityMatrix`TensorAlgebra`Private`ibremain} = 
          MapThread[
           AtomicDensityMatrix`TensorAlgebra`Private`remainingIndices, {{
             AtomicDensityMatrix`TensorAlgebra`Private`a, 
              AtomicDensityMatrix`TensorAlgebra`Private`b}, {
             AtomicDensityMatrix`TensorAlgebra`Private`ia, 
              AtomicDensityMatrix`TensorAlgebra`Private`ib}}]; 
         AtomicDensityMatrix`TensorAlgebra`Private`atranspose = 
          Flatten[AtomicDensityMatrix`TensorAlgebra`Private`a, 
            Append[
            AtomicDensityMatrix`TensorAlgebra`Private`iaremain, 
             AtomicDensityMatrix`TensorAlgebra`Private`ia]]; 
         AtomicDensityMatrix`TensorAlgebra`Private`btranspose = 
          Flatten[AtomicDensityMatrix`TensorAlgebra`Private`b, 
            Prepend[
            AtomicDensityMatrix`TensorAlgebra`Private`ibremain, 
             AtomicDensityMatrix`TensorAlgebra`Private`ib]]; 
         AtomicDensityMatrix`TensorAlgebra`Private`transpose[
           Inner[
           Times, AtomicDensityMatrix`TensorAlgebra`Private`atranspose, 
            AtomicDensityMatrix`TensorAlgebra`Private`btranspose], 
           AtomicDensityMatrix`TensorAlgebra`Private`reordering]], 
       TagSet[AtomicDensityMatrix`InnerAt, 
        MessageName[AtomicDensityMatrix`InnerAt, "usage"], ""], 
       AtomicDensityMatrix`TensorAlgebra`Private`ia = {1}, 
       AtomicDensityMatrix`TensorAlgebra`Private`ib = {1}, 
       AtomicDensityMatrix`TensorAlgebra`Private`iaremain = {}, 
       AtomicDensityMatrix`TensorAlgebra`Private`ibremain = {{2}, {3}}, 
       AtomicDensityMatrix`TensorAlgebra`Private`remainingIndices[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`indices, 
          Blank[]]] := Map[List, 
         Delete[
          Range[
           AtomicDensityMatrix`TensorDepth[
           AtomicDensityMatrix`TensorAlgebra`Private`a]], 
          Map[List, AtomicDensityMatrix`TensorAlgebra`Private`indices]]], 
       AtomicDensityMatrix`TensorAlgebra`Private`atranspose = {
        0, 0, (-0.1)/Units`BohrMagneton}, 
       TagSet[Units`BohrMagneton, 
        MessageName[Units`BohrMagneton, "usage"], 
        "BohrMagneton is a unit of magnetic moment."], 
       AtomicDensityMatrix`TensorAlgebra`Private`btranspose = {{{
          0, (-Units`BohrMagneton)/2, 0, 0, 0, (Sqrt[3] Units`BohrMagneton)/2,
            0, 0}, {(-Units`BohrMagneton)/2, 
           0, (-(Sqrt[3/2] Units`BohrMagneton))/2, 0, 0, 
           0, (Sqrt[3/2] Units`BohrMagneton)/2, 0}, {
          0, (-(Sqrt[3/2] Units`BohrMagneton))/2, 
           0, (-(Sqrt[3/2] Units`BohrMagneton))/2, 0, (-Units`BohrMagneton)/(
           2 Sqrt[2]), 0, Units`BohrMagneton/(2 Sqrt[2])}, {
          0, 0, (-(Sqrt[3/2] Units`BohrMagneton))/2, 0, (-Units`BohrMagneton)/
           2, 0, (-(Sqrt[3/2] Units`BohrMagneton))/2, 0}, {
          0, 0, 0, (-Units`BohrMagneton)/2, 0, 0, 
           0, (-(Sqrt[3] Units`BohrMagneton))/
           2}, {(Sqrt[3] Units`BohrMagneton)/2, 0, (-Units`BohrMagneton)/(2 
           Sqrt[2]), 0, 0, 0, Units`BohrMagneton/(2 Sqrt[2]), 0}, {
          0, (Sqrt[3/2] Units`BohrMagneton)/2, 
           0, (-(Sqrt[3/2] Units`BohrMagneton))/2, 0, Units`BohrMagneton/(2 
           Sqrt[2]), 0, Units`BohrMagneton/(2 Sqrt[2])}, {
          0, 0, Units`BohrMagneton/(2 Sqrt[2]), 
           0, (-(Sqrt[3] Units`BohrMagneton))/2, 0, Units`BohrMagneton/(2 
           Sqrt[2]), 0}}, {{
          0, (I/2) Units`BohrMagneton, 0, 0, 0, ((-I)/2) Sqrt[3] 
           Units`BohrMagneton, 0, 0}, {((-I)/2) Units`BohrMagneton, 0, (I/2) 
           Sqrt[3/2] Units`BohrMagneton, 0, 0, 0, ((-I)/2) Sqrt[3/2] 
           Units`BohrMagneton, 0}, {
          0, ((-I)/2) Sqrt[3/2] Units`BohrMagneton, 0, (I/2) Sqrt[3/2] 
           Units`BohrMagneton, 0, (((-I)/2) Units`BohrMagneton)/Sqrt[2], 
           0, (((-I)/2) Units`BohrMagneton)/Sqrt[2]}, {
          0, 0, ((-I)/2) Sqrt[3/2] Units`BohrMagneton, 0, (I/2) 
           Units`BohrMagneton, 0, ((-I)/2) Sqrt[3/2] Units`BohrMagneton, 0}, {
          0, 0, 0, ((-I)/2) Units`BohrMagneton, 0, 0, 0, ((-I)/2) Sqrt[3] 
           Units`BohrMagneton}, {(I/2) Sqrt[3] Units`BohrMagneton, 
           0, ((I/2) Units`BohrMagneton)/Sqrt[2], 0, 0, 
           0, (((-I)/2) Units`BohrMagneton)/Sqrt[2], 0}, {
          0, (I/2) Sqrt[3/2] Units`BohrMagneton, 0, (I/2) Sqrt[3/2] 
           Units`BohrMagneton, 0, ((I/2) Units`BohrMagneton)/Sqrt[2], 
           0, (((-I)/2) Units`BohrMagneton)/Sqrt[2]}, {
          0, 0, ((I/2) Units`BohrMagneton)/Sqrt[2], 0, (I/2) Sqrt[3] 
           Units`BohrMagneton, 0, ((I/2) Units`BohrMagneton)/Sqrt[2], 0}}, {{-
           Units`BohrMagneton, 0, 0, 0, 0, 0, 0, 0}, {
          0, (-Units`BohrMagneton)/2, 0, 0, 
           0, (-(Sqrt[3] Units`BohrMagneton))/2, 0, 0}, {
          0, 0, 0, 0, 0, 0, -Units`BohrMagneton, 0}, {
          0, 0, 0, Units`BohrMagneton/2, 0, 0, 
           0, (-(Sqrt[3] Units`BohrMagneton))/2}, {
          0, 0, 0, 0, Units`BohrMagneton, 0, 0, 0}, {
          0, (-(Sqrt[3] Units`BohrMagneton))/2, 0, 0, 0, Units`BohrMagneton/2,
            0, 0}, {0, 0, -Units`BohrMagneton, 0, 0, 0, 0, 0}, {
          0, 0, 0, (-(Sqrt[3] Units`BohrMagneton))/2, 0, 0, 
           0, (-Units`BohrMagneton)/2}}}, 
       AtomicDensityMatrix`TensorAlgebra`Private`transpose[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`list, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`reordering, 
          Blank[]]] := 
       If[AtomicDensityMatrix`TensorAlgebra`Private`reordering === {}, 
         AtomicDensityMatrix`TensorAlgebra`Private`list, 
         Transpose[
         AtomicDensityMatrix`TensorAlgebra`Private`list, 
          AtomicDensityMatrix`TensorAlgebra`Private`reordering]], 
       AtomicDensityMatrix`TensorAlgebra`Private`TensorMultiplyIndices[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`types, 
          Blank[]], 
         OptionsPattern[]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`traceOver = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`TensorAlgebra`Private`TensorMultiplyIndices, 
            AtomicDensityMatrix`TraceOver, 
            OptionValue[AtomicDensityMatrix`TraceOver]], 
          AtomicDensityMatrix`TensorAlgebra`Private`levels, 
          AtomicDensityMatrix`TensorAlgebra`Private`pairs, 
          AtomicDensityMatrix`TensorAlgebra`Private`offsets, 
          AtomicDensityMatrix`TensorAlgebra`Private`remainingLevelsIndex, 
          AtomicDensityMatrix`TensorAlgebra`Private`remainingLevels, 
          AtomicDensityMatrix`TensorAlgebra`Private`reordering}, 
         Condition[
         AtomicDensityMatrix`TensorAlgebra`Private`levels = Transpose[
             ReplaceAll[
             AtomicDensityMatrix`TensorAlgebra`Private`types, {
              Apply[Alternatives, 
                 AtomicDensityMatrix`TensorAlgebra`Private`traceOver] -> 
               Sequence[0, 2], 
               Alternatives["TensorDecomposition", "Cartesian"] -> 1, 
               Alternatives[
                "Covariant", "Contravariant", "Operator", "OneByOne"] -> 2}]]; 
          AtomicDensityMatrix`TensorAlgebra`Private`offsets = Most[
             Accumulate[
              Prepend[
              AtomicDensityMatrix`TensorAlgebra`Private`levels, {0, 0}]]]; 
          AtomicDensityMatrix`TensorAlgebra`Private`pairs = ReplaceAll[
             Transpose[AtomicDensityMatrix`TensorAlgebra`Private`types], {
             Apply[Alternatives, 
                
                Transpose[{
                 AtomicDensityMatrix`TensorAlgebra`Private`traceOver, 
                  AtomicDensityMatrix`TensorAlgebra`Private`traceOver}]] -> 
              Sequence[{1, 2}, {2, 1}], Alternatives[{
                 Alternatives["Covariant", "Operator", "OneByOne"], 
                 Alternatives["Contravariant", "Operator", "OneByOne"]}, {
                 Alternatives["Contravariant", "OneByOne"], 
                 Alternatives["Covariant", "OneByOne"]}] -> {2, 1}, 
              Alternatives[{
                 Repeated["TensorDecomposition"]}, {
                 Repeated["Cartesian"]}] -> {1, 1}, {
               "Cartesian", "Operator"} -> {1, 1}, {
               "Operator", "Cartesian"} -> {2, 1}, Alternatives[{0, 
                 Blank[String]}, {
                 Blank[String], 0}] -> {0, 0}, {
                Blank[String], 
                Blank[String]} :> Message[
                MessageName[AtomicDensityMatrix`MatrixMultiply, "nomult"], 
                Apply[
                Sequence, AtomicDensityMatrix`TensorAlgebra`Private`types]]}]; 
          AtomicDensityMatrix`TensorAlgebra`Private`pairs = 
           Delete[AtomicDensityMatrix`TensorAlgebra`Private`pairs + 
             AtomicDensityMatrix`TensorAlgebra`Private`offsets, 
             Position[
             AtomicDensityMatrix`TensorAlgebra`Private`pairs, {0, 0}]]; 
          AtomicDensityMatrix`TensorAlgebra`Private`remainingLevels = 
           ReplaceAll[
             Transpose[AtomicDensityMatrix`TensorAlgebra`Private`types], {
             Apply[Alternatives, 
                
                Transpose[{
                 AtomicDensityMatrix`TensorAlgebra`Private`traceOver, 
                  AtomicDensityMatrix`TensorAlgebra`Private`traceOver}]] -> 
              Sequence[], Alternatives[{
                 Alternatives["Covariant", "Operator", "OneByOne"], 
                 Alternatives["Contravariant", "Operator", "OneByOne"]}, {
                 Alternatives["Contravariant", "OneByOne"], 
                 Alternatives["Covariant", "OneByOne"]}] -> {{1}, {1}}, 
              Alternatives[{
                 Repeated["TensorDecomposition"]}, {
                 Repeated["Cartesian"]}] -> 
              Sequence[], {"Cartesian", "Operator"} -> {{}, {1}}, {
               "Operator", "Cartesian"} -> {{1}, {}}, 
              Pattern[AtomicDensityMatrix`TensorAlgebra`Private`x, 
                Alternatives[{0, 
                  Blank[String]}, {
                  Blank[String], 0}]] :> 
              ReplaceAll[
               AtomicDensityMatrix`TensorAlgebra`Private`x, {
                0 -> {}, 
                 Alternatives["TensorDecomposition", "Cartesian"] -> {1}, 
                 Alternatives[
                  "Covariant", "Contravariant", "Operator", "OneByOne", 
                   "TensorDecompositionMatrix"] -> {1, 1}}], {
                Blank[String], 
                Blank[String]} :> Message[
                MessageName[AtomicDensityMatrix`MatrixMultiply, "nomult"], 
                Apply[
                Sequence, AtomicDensityMatrix`TensorAlgebra`Private`types]]}]; 
          AtomicDensityMatrix`TensorAlgebra`Private`remainingLevelsIndex = 
           AtomicDensityMatrix`TensorAlgebra`Private`accumulateMap[
            AtomicDensityMatrix`TensorAlgebra`Private`remainingLevels, {3}]; 
          AtomicDensityMatrix`TensorAlgebra`Private`reordering = Flatten[
             Transpose[
             AtomicDensityMatrix`TensorAlgebra`Private`remainingLevelsIndex]]; \
{AtomicDensityMatrix`TensorAlgebra`Private`pairs, 
            AtomicDensityMatrix`TensorAlgebra`Private`reordering}, 
          
          FreeQ[{{AtomicDensityMatrix`TensorAlgebra`Private`traceOver}}, \
$Failed]]], 
       Options[AtomicDensityMatrix`TensorAlgebra`Private`\
TensorMultiplyIndices] = {
        AtomicDensityMatrix`TraceOver -> {"TensorDecompositionMatrix"}}, 
       TagSet[AtomicDensityMatrix`TraceOver, 
        MessageName[AtomicDensityMatrix`TraceOver, "usage"], ""], 
       AtomicDensityMatrix`TensorAlgebra`Private`accumulateMap[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`expr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`levelspec, 
          Blank[]]] := 
       Block[{AtomicDensityMatrix`TensorAlgebra`Private`i = 0}, 
         Map[(AtomicDensityMatrix`TensorAlgebra`Private`i = 
          AtomicDensityMatrix`TensorAlgebra`Private`i + #)& , 
          AtomicDensityMatrix`TensorAlgebra`Private`expr, 
          AtomicDensityMatrix`TensorAlgebra`Private`levelspec]], 
       Attributes[AtomicDensityMatrix`TensorAlgebra`Private`MessageIf] = {
        HoldRest}, AtomicDensityMatrix`TensorAlgebra`Private`MessageIf[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`condition, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`message, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`args, 
          BlankNullSequence[]]] := (If[
          Not[AtomicDensityMatrix`TensorAlgebra`Private`condition], 
          Message[
          AtomicDensityMatrix`TensorAlgebra`Private`message, 
           AtomicDensityMatrix`TensorAlgebra`Private`args]]; 
        AtomicDensityMatrix`TensorAlgebra`Private`condition), 
       AtomicDensityMatrix`TensorAlgebra`Private`disallowedMultiplyPairs = 
       Alternatives[{"Covariant", "Covariant"}, {
         "Contravariant", "Contravariant"}, {"Cartesian", 
          Alternatives["Covariant", "Contravariant"]}, {
          Alternatives["Covariant", "Contravariant"], "Cartesian"}], 
       AtomicDensityMatrix`ToCartesianMatrix[
         PatternTest[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`rank, 
           Blank[]], AtomicDensityMatrix`HalfIntegerQ]] := Flatten[{Table[{
             Table[
              Switch[
              AtomicDensityMatrix`TensorAlgebra`Private`j, 
               AtomicDensityMatrix`TensorAlgebra`Private`i, -1, -
               AtomicDensityMatrix`TensorAlgebra`Private`i, 1, 
               Blank[], 0], {
              AtomicDensityMatrix`TensorAlgebra`Private`j, 
               AtomicDensityMatrix`TensorAlgebra`Private`rank, -
               AtomicDensityMatrix`TensorAlgebra`Private`rank, -1}], 
             Table[
              Switch[
              AtomicDensityMatrix`TensorAlgebra`Private`j, 
               AtomicDensityMatrix`TensorAlgebra`Private`i, -I, -
               AtomicDensityMatrix`TensorAlgebra`Private`i, -I, 
               Blank[], 0], {
              AtomicDensityMatrix`TensorAlgebra`Private`j, 
               AtomicDensityMatrix`TensorAlgebra`Private`rank, -
               AtomicDensityMatrix`TensorAlgebra`Private`rank, -1}]}, {
            AtomicDensityMatrix`TensorAlgebra`Private`i, 
             AtomicDensityMatrix`TensorAlgebra`Private`rank, 1/2, -1}]/Sqrt[
          2], {
           If[
            IntegerQ[AtomicDensityMatrix`TensorAlgebra`Private`rank], {
             Table[
              KroneckerDelta[AtomicDensityMatrix`TensorAlgebra`Private`j], {
              AtomicDensityMatrix`TensorAlgebra`Private`j, 
               AtomicDensityMatrix`TensorAlgebra`Private`rank, -
               AtomicDensityMatrix`TensorAlgebra`Private`rank, -1}]}, {}]}}, 
         2], 
       TagSet[AtomicDensityMatrix`ToCartesianMatrix, 
        MessageName[AtomicDensityMatrix`ToCartesianMatrix, "usage"], ""], 
       AtomicDensityMatrix`HalfIntegerQ[
         Pattern[AtomicDensityMatrix`Common`Private`x, 
          Blank[]]] := IntegerQ[2 AtomicDensityMatrix`Common`Private`x], 
       TagSet[AtomicDensityMatrix`HalfIntegerQ, 
        MessageName[AtomicDensityMatrix`HalfIntegerQ, "usage"], 
        "HalfIntegerQ[expr] gives True if expr is integer or half-integer, \
and False otherwise."], AtomicDensityMatrix`Rank[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, 
           Alternatives[{"Scalar"}, {"OneByOne", 
             BlankNullSequence[]}]]}] := 0, AtomicDensityMatrix`Rank[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], {"Covariant", 
           BlankNullSequence[]}}] := (Length[
           First[AtomicDensityMatrix`TensorAlgebra`Private`a]] - 1)/2, 
       AtomicDensityMatrix`Rank[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], {
           Alternatives["Contravariant", "Cartesian", "Operator"], 
           BlankNullSequence[]}}] := (
         Length[AtomicDensityMatrix`TensorAlgebra`Private`a] - 1)/2, 
       AtomicDensityMatrix`Rank[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, 
           Alternatives[{"TensorDecomposition", 
             BlankSequence[]}, {
            "TensorDecompositionMatrix", "TensorDecomposition", 
             BlankSequence[]}]]}] := 
       AtomicDensityMatrix`ComponentMap[AtomicDensityMatrix`Rank[{#, 
           Rest[AtomicDensityMatrix`TensorAlgebra`Private`type]}]& , {
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`type}, 1], 
       AtomicDensityMatrix`Rank[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}] := Condition[Null, 
         Message[
          MessageName[AtomicDensityMatrix`Rank, "wrongtype"], 
          AtomicDensityMatrix`TensorAlgebra`Private`type]], 
       AtomicDensityMatrix`Rank[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Except[
           Alternatives[{
             Blank[], {
              Repeated[
               Alternatives[
               "Scalar", "Cartesian", "Contravariant", "Covariant", 
                "Operator", "OneByOne", "TensorDecomposition", 
                "TensorDecompositionMatrix"]]}}, {
             Repeated[
              Blank[AtomicDensityMatrix`AtomicState]]}]]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`type$ = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`a], 
          AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = True, 
          AtomicDensityMatrix`TensorAlgebra`Private`result$}, 
         AtomicDensityMatrix`TensorAlgebra`Private`result$ = Check[
            
            AtomicDensityMatrix`Rank[{
             AtomicDensityMatrix`TensorAlgebra`Private`a, 
              AtomicDensityMatrix`TensorAlgebra`Private`type$}], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = False]; 
         Condition[AtomicDensityMatrix`TensorAlgebra`Private`result$, 
           And[
            AtomicDensityMatrix`TensorTypeQ[
            AtomicDensityMatrix`TensorAlgebra`Private`type$], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$, True]]], 
       TagSet[AtomicDensityMatrix`Rank, 
        MessageName[AtomicDensityMatrix`Rank, "usage"], 
        "\!\(\*TagBox[RowBox[{\"Rank[\", StyleBox[\"tens\", \"TI\"], \"] \
returns the tensor rank \[Kappa] of irreducible spherical tensor \", \
StyleBox[\"tens\", \"TI\"], \".\", \"\[LineSeparator]\", \"Rank[\", StyleBox[\
\"op\", \"TI\"], \"] returns the angular\[Hyphen]momentum quantum number j \
corresponding to the dimension of operator \", StyleBox[\"op\", \"TI\"], \
\".\", \"\[LineSeparator]\", \"Rank[\", StyleBox[\"decomp\", \"TI\"], \"] \
returns the list of ranks of the tensors making up a spherical\[Hyphen]tensor \
decomposition \", StyleBox[\"decomp\", \"TI\"], \".\", \"\[LineSeparator]\", \
\"Rank[\", StyleBox[\"mat\", \"TI\"], \"] returns a matrix of lists of ranks \
for the decompositions making up a tensor\[Hyphen]decomposition matrix \", \
StyleBox[\"mat\", \"TI\"], \".\"}], DisplayForm]\)"], AtomicDensityMatrix`ECT = 
       AtomicDensityMatrix`ExplicitConjugateTranspose, 
       TagSet[AtomicDensityMatrix`ECT, 
        MessageName[AtomicDensityMatrix`ECT, "usage"], 
        "ECT[expr] takes the Hermitian conjugate of a variety of types of \
expressions, explicitly assuming that all variables are real. If expr is a \
spherical tensor or matrix operator, the conjugate transpose is taken \
(converting covariant to contravariant, and vice versa). If expr is a tensor \
decomposition, the conjugate transpose of each tensor in the decomposition is \
taken. If expr is a Cartesian vector or a scalar, the complex conjugate is \
taken."], AtomicDensityMatrix`ExplicitConjugateTranspose[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}] := 
       AtomicDensityMatrix`TensorAlgebra`Private`conjugateTranspose[
        AtomicDensityMatrix`ExplicitConjugate, {
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`type}], 
       AtomicDensityMatrix`ExplicitConjugateTranspose[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Except[
           Alternatives[{
             Blank[], {
              Repeated[
               Alternatives[
               "Scalar", "Cartesian", "Contravariant", "Covariant", 
                "Operator", "OneByOne", "TensorDecomposition", 
                "TensorDecompositionMatrix"]]}}, {
             Repeated[
              Blank[AtomicDensityMatrix`AtomicState]]}]]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`type$ = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`a], 
          AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = True, 
          AtomicDensityMatrix`TensorAlgebra`Private`result$}, 
         AtomicDensityMatrix`TensorAlgebra`Private`result$ = Check[
            
            AtomicDensityMatrix`ExplicitConjugateTranspose[{
             AtomicDensityMatrix`TensorAlgebra`Private`a, 
              AtomicDensityMatrix`TensorAlgebra`Private`type$}], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = False]; 
         Condition[AtomicDensityMatrix`TensorAlgebra`Private`result$, 
           And[
            AtomicDensityMatrix`TensorTypeQ[
            AtomicDensityMatrix`TensorAlgebra`Private`type$], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$, True]]], 
       TagSet[AtomicDensityMatrix`ExplicitConjugateTranspose, 
        MessageName[AtomicDensityMatrix`ExplicitConjugateTranspose, "usage"], 
        "ExplicitConjugateTranspose[expr] takes the Hermitian conjugate of a \
variety of types of expressions, explicitly assuming that all variables are \
real. If expr is a spherical tensor or matrix operator, the conjugate \
transpose is taken (converting covariant to contravariant, and vice versa). \
If expr is a tensor decomposition, the conjugate transpose of each tensor in \
the decomposition is taken. If expr is a Cartesian vector or a scalar, the \
complex conjugate is taken."], 
       AtomicDensityMatrix`TensorAlgebra`Private`conjugateTranspose[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`conjugate, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Alternatives["Scalar", "Cartesian", "OneByOne"]}]}] := 
       AtomicDensityMatrix`TensorAlgebra`Private`conjugate[
        AtomicDensityMatrix`TensorAlgebra`Private`a], 
       AtomicDensityMatrix`TensorAlgebra`Private`conjugateTranspose[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`conjugate, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Alternatives["Covariant", "Contravariant", "Operator"]}]}] := 
       Transpose[
         AtomicDensityMatrix`TensorAlgebra`Private`conjugate[
         AtomicDensityMatrix`TensorAlgebra`Private`a]], 
       AtomicDensityMatrix`TensorAlgebra`Private`conjugateTranspose[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`conjugate, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Alternatives[
            "Cartesian", "TensorDecomposition", "OneByOne", 
             "TensorDecompositionMatrix"], 
            BlankSequence[]}]}] := 
       AtomicDensityMatrix`ComponentMap[
        AtomicDensityMatrix`TensorAlgebra`Private`conjugateTranspose[
         AtomicDensityMatrix`TensorAlgebra`Private`conjugate, {#, 
           Rest[AtomicDensityMatrix`TensorAlgebra`Private`type]}]& , {
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`type}], 
       AtomicDensityMatrix`TensorAlgebra`Private`conjugateTranspose[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`conjugate, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Alternatives["Covariant", "Contravariant", "Operator"], 
            BlankSequence[]}]}] := Transpose[
         AtomicDensityMatrix`ComponentMap[
         AtomicDensityMatrix`TensorAlgebra`Private`conjugateTranspose[
          AtomicDensityMatrix`TensorAlgebra`Private`conjugate, {#, 
            Rest[AtomicDensityMatrix`TensorAlgebra`Private`type]}]& , {
          AtomicDensityMatrix`TensorAlgebra`Private`a, 
           AtomicDensityMatrix`TensorAlgebra`Private`type}]], 
       AtomicDensityMatrix`TensorAlgebra`Private`conjugateTranspose[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}] := Condition[Null, 
         Message[
          MessageName[
          AtomicDensityMatrix`TensorAlgebra`Private`conjugateTranspose, 
           "wrongtype"], AtomicDensityMatrix`TensorAlgebra`Private`type]], 
       AtomicDensityMatrix`TensorAlgebra`Private`conjugateTranspose[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Except[
           Alternatives[{
             Blank[], {
              Repeated[
               Alternatives[
               "Scalar", "Cartesian", "Contravariant", "Covariant", 
                "Operator", "OneByOne", "TensorDecomposition", 
                "TensorDecompositionMatrix"]]}}, {
             Repeated[
              Blank[AtomicDensityMatrix`AtomicState]]}]]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`type$ = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`a], 
          AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = True, 
          AtomicDensityMatrix`TensorAlgebra`Private`result$}, 
         AtomicDensityMatrix`TensorAlgebra`Private`result$ = Check[
            
            AtomicDensityMatrix`TensorAlgebra`Private`conjugateTranspose[{
             AtomicDensityMatrix`TensorAlgebra`Private`a, 
              AtomicDensityMatrix`TensorAlgebra`Private`type$}], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = False]; 
         Condition[AtomicDensityMatrix`TensorAlgebra`Private`result$, 
           And[
            AtomicDensityMatrix`TensorTypeQ[
            AtomicDensityMatrix`TensorAlgebra`Private`type$], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$, True]]], 
       AtomicDensityMatrix`ExplicitConjugate[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[]]] := 
       AtomicDensityMatrix`SparseReplaceAll[
        AtomicDensityMatrix`TensorAlgebra`Private`a, Complex[
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`x, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`y, 
            Blank[]]] -> 
         Complex[AtomicDensityMatrix`TensorAlgebra`Private`x, -
           AtomicDensityMatrix`TensorAlgebra`Private`y]], 
       TagSet[AtomicDensityMatrix`ExplicitConjugate, 
        MessageName[AtomicDensityMatrix`ExplicitConjugate, "usage"], 
        "ExplicitConjugate[expr] takes the complex conjugate of expr, \
explicitly assuming that all variables are real."], 
       AtomicDensityMatrix`SparseReplaceAll[
         Pattern[AtomicDensityMatrix`MatrixRSolve`Private`s, 
          Blank[SparseArray]], 
         Pattern[AtomicDensityMatrix`MatrixRSolve`Private`rule, 
          Blank[]]] := 
       With[{AtomicDensityMatrix`MatrixRSolve`Private`elem = ReplaceAll[
            AtomicDensityMatrix`MatrixRSolve`Private`s["NonzeroValues"], 
            AtomicDensityMatrix`MatrixRSolve`Private`rule], 
          AtomicDensityMatrix`MatrixRSolve`Private`def = ReplaceAll[
            AtomicDensityMatrix`MatrixRSolve`Private`s["Background"], 
            AtomicDensityMatrix`MatrixRSolve`Private`rule]}, 
         Replace[
         AtomicDensityMatrix`MatrixRSolve`Private`s, Verbatim[SparseArray][
            Pattern[AtomicDensityMatrix`MatrixRSolve`Private`a, 
             BlankSequence[]], 
            Blank[], {
             Pattern[AtomicDensityMatrix`MatrixRSolve`Private`b, 
              BlankSequence[]], 
             Blank[]}] :> 
          SparseArray[
           AtomicDensityMatrix`MatrixRSolve`Private`a, 
            AtomicDensityMatrix`MatrixRSolve`Private`def, {
            AtomicDensityMatrix`MatrixRSolve`Private`b, 
             AtomicDensityMatrix`MatrixRSolve`Private`elem}]]], 
       AtomicDensityMatrix`SparseReplaceAll[
         Pattern[AtomicDensityMatrix`MatrixRSolve`Private`expr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`MatrixRSolve`Private`rule, 
          Blank[]]] := ReplaceAll[
         ReplaceAll[
         AtomicDensityMatrix`MatrixRSolve`Private`expr, 
          AtomicDensityMatrix`MatrixRSolve`Private`rule], 
         Pattern[AtomicDensityMatrix`MatrixRSolve`Private`s, 
           Blank[SparseArray]] :> 
         AtomicDensityMatrix`SparseReplaceAll[
          AtomicDensityMatrix`MatrixRSolve`Private`s, 
           AtomicDensityMatrix`MatrixRSolve`Private`rule]], 
       TagSet[AtomicDensityMatrix`SparseReplaceAll, 
        MessageName[AtomicDensityMatrix`SparseReplaceAll, "usage"], ""], 
       AtomicDensityMatrix`BlockDiagonal[
         Pattern[AtomicDensityMatrix`Common`Private`m, {
           PatternTest[
            BlankSequence[], MatrixQ]}]] := 
       Module[{AtomicDensityMatrix`Common`Private`d = 
          Map[Dimensions, AtomicDensityMatrix`Common`Private`m]}, 
         ArrayFlatten[
          Table[
           If[
           AtomicDensityMatrix`Common`Private`i === 
            AtomicDensityMatrix`Common`Private`j, 
            Part[
            AtomicDensityMatrix`Common`Private`m, 
             AtomicDensityMatrix`Common`Private`i], 
            Table[0, {
              Part[
              AtomicDensityMatrix`Common`Private`d, 
               AtomicDensityMatrix`Common`Private`i, 1]}, {
              Part[
              AtomicDensityMatrix`Common`Private`d, 
               AtomicDensityMatrix`Common`Private`j, 2]}]], {
           AtomicDensityMatrix`Common`Private`i, 
            Length[AtomicDensityMatrix`Common`Private`m]}, {
           AtomicDensityMatrix`Common`Private`j, 
            Length[AtomicDensityMatrix`Common`Private`m]}]]], 
       TagSet[AtomicDensityMatrix`BlockDiagonal, 
        MessageName[AtomicDensityMatrix`BlockDiagonal, "usage"], 
        "BlockDiagonal[matlist] forms a block diagonal matrix from a list of \
matrices matlist."], AtomicDensityMatrix`RemoveZeemanSublevels[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := Map[First, 
         Split[
          AtomicDensityMatrix`DeleteParameter[
          AtomicDensityMatrix`AtomicSystem`Private`sys, 
           AtomicDensityMatrix`M]]], 
       TagSet[AtomicDensityMatrix`RemoveZeemanSublevels, 
        MessageName[AtomicDensityMatrix`RemoveZeemanSublevels, "usage"], 
        "\!\(\*TagBox[RowBox[{\"RemoveZeemanSublevels[\", StyleBox[\"sys\", \
\"TI\"], \"] removes the M quantum number from each AtomicState of an atomic \
system \", StyleBox[\"sys\", \"TI\"], \" and leaves one  state for each J \
level (for Zeeman systems) or each F level (for hyperfine\[Dash]Zeeman \
systems). \"}], DisplayForm]\)"], AtomicDensityMatrix`DeleteParameter[
         AtomicDensityMatrix`AtomicState["$3", AtomicDensityMatrix`J -> 1], {
         AtomicDensityMatrix`M}] = 
       AtomicDensityMatrix`AtomicState["$3", AtomicDensityMatrix`J -> 1], 
       AtomicDensityMatrix`DeleteParameter[
         AtomicDensityMatrix`AtomicState["$4", AtomicDensityMatrix`J -> 1], {
         AtomicDensityMatrix`M}] = 
       AtomicDensityMatrix`AtomicState["$4", AtomicDensityMatrix`J -> 1], 
       AtomicDensityMatrix`DeleteParameter[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2], {AtomicDensityMatrix`F}] = 
       AtomicDensityMatrix`AtomicState[
        1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
         AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
         AtomicDensityMatrix`NuclearSpin -> 3/2], 
       AtomicDensityMatrix`DeleteParameter[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1], {AtomicDensityMatrix`M}] = 
       AtomicDensityMatrix`AtomicState[
        1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
         AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
         AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1], 
       AtomicDensityMatrix`DeleteParameter[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2], {AtomicDensityMatrix`M}] = 
       AtomicDensityMatrix`AtomicState[
        1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
         AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
         AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2], 
       AtomicDensityMatrix`DeleteParameter[{
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> 2], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> 1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> 0], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> -1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> -2], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1,
            AtomicDensityMatrix`M -> 1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1,
            AtomicDensityMatrix`M -> 0], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1,
            AtomicDensityMatrix`M -> -1]}, AtomicDensityMatrix`M] = {
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]}, AtomicDensityMatrix`DeleteParameter[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1],
          AtomicDensityMatrix`F, AtomicDensityMatrix`NuclearSpin] = 
       AtomicDensityMatrix`AtomicState[
        1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
         AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0], 
       AtomicDensityMatrix`DeleteParameter[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2],
          AtomicDensityMatrix`F, AtomicDensityMatrix`NuclearSpin] = 
       AtomicDensityMatrix`AtomicState[
        1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
         AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0], 
       AtomicDensityMatrix`DeleteParameter[{
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
           1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
           1]}, AtomicDensityMatrix`F, AtomicDensityMatrix`NuclearSpin] = {
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0]}, 
       AtomicDensityMatrix`DeleteParameter[{
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
           1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
           2]}, AtomicDensityMatrix`F, AtomicDensityMatrix`NuclearSpin] = {
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0]}, 
       AtomicDensityMatrix`DeleteParameter[{
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
           2], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
           1]}, AtomicDensityMatrix`F, AtomicDensityMatrix`NuclearSpin] = {
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0]}, 
       AtomicDensityMatrix`DeleteParameter[{
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
           2], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
           2]}, AtomicDensityMatrix`F, AtomicDensityMatrix`NuclearSpin] = {
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0], 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0]}, 
       AtomicDensityMatrix`DeleteParameter[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
          Alternatives[{
            Repeated[
             Blank[AtomicDensityMatrix`AtomicState]]}, 
           Blank[AtomicDensityMatrix`AtomicState]]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`x, 
          Alternatives[{
            Repeated[
             Alternatives[
             AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
              AtomicDensityMatrix`J, AtomicDensityMatrix`NuclearSpin, 
              AtomicDensityMatrix`F, AtomicDensityMatrix`M, 
              AtomicDensityMatrix`Parity, AtomicDensityMatrix`Energy, 
              AtomicDensityMatrix`NaturalWidth, AtomicDensityMatrix`GFactor, 
              AtomicDensityMatrix`BranchingRatio[
               Blank[]], AtomicDensityMatrix`LevelPosition, 
              AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
              
              AtomicDensityMatrix`Polarizability[
               Blank[]], 
              AtomicDensityMatrix`TransitionPolarizability[
               Blank[]]]]}, 
           Repeated[
            Alternatives[
            AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
             AtomicDensityMatrix`J, AtomicDensityMatrix`NuclearSpin, 
             AtomicDensityMatrix`F, AtomicDensityMatrix`M, 
             AtomicDensityMatrix`Parity, AtomicDensityMatrix`Energy, 
             AtomicDensityMatrix`NaturalWidth, AtomicDensityMatrix`GFactor, 
             AtomicDensityMatrix`BranchingRatio[
              Blank[]], AtomicDensityMatrix`LevelPosition, 
             AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
             AtomicDensityMatrix`Polarizability[
              Blank[]], 
             AtomicDensityMatrix`TransitionPolarizability[
              Blank[]]]]]]] := (
        AtomicDensityMatrix`DeleteParameter[
         AtomicDensityMatrix`AtomicSystem`Private`sys, 
          AtomicDensityMatrix`AtomicSystem`Private`x] = 
        DeleteCases[AtomicDensityMatrix`AtomicSystem`Private`sys, 
          Apply[Alternatives, 
           Thread[
           Flatten[{AtomicDensityMatrix`AtomicSystem`Private`x}] -> 
            Blank[]]], {
           ArrayDepth[{AtomicDensityMatrix`AtomicSystem`Private`sys}]}]), 
       AtomicDensityMatrix`DeleteParameter[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, 
          Alternatives[
          AtomicDensityMatrix`OpticalParameters, 
           AtomicDensityMatrix`ElectricField, 
           AtomicDensityMatrix`MagneticField, 
           AtomicDensityMatrix`TransitRate[
            Blank[]], AtomicDensityMatrix`Density, 
           AtomicDensityMatrix`VelocityGroupRecoilMomentum[
            Blank[]], AtomicDensityMatrix`SDampingRate]]] := 
       AtomicDensityMatrix`ExperimentalSystem`Private`MapOnParameters[
        DeleteCases[#, AtomicDensityMatrix`ExperimentalSystem`Private`x -> 
          Blank[]]& , AtomicDensityMatrix`ExperimentalSystem`Private`region], 
       AtomicDensityMatrix`DeleteParameter[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, {
           Repeated[
            Alternatives[
            AtomicDensityMatrix`OpticalParameters, 
             AtomicDensityMatrix`ElectricField, 
             AtomicDensityMatrix`MagneticField, 
             AtomicDensityMatrix`TransitRate[
              Blank[]], AtomicDensityMatrix`Density, 
             AtomicDensityMatrix`VelocityGroupRecoilMomentum[
              Blank[]], AtomicDensityMatrix`SDampingRate]]}]] := 
       Fold[AtomicDensityMatrix`DeleteParameter, 
         AtomicDensityMatrix`ExperimentalSystem`Private`region, 
         AtomicDensityMatrix`ExperimentalSystem`Private`x], 
       AtomicDensityMatrix`DeleteParameter[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, 
          Blank[]]] := 
       Map[AtomicDensityMatrix`DeleteParameter[#, 
          AtomicDensityMatrix`ExperimentalSystem`Private`x]& , 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`DeleteParameter, 
        MessageName[AtomicDensityMatrix`DeleteParameter, "usage"], 
        "DeleteParameter[\!\(\*\nStyleBox[\"state\", \"TI\"]\),\!\(\*\n\
StyleBox[\"param\", \"TI\"]\)] deletes any specification for state parameter \
\!\(\*\nStyleBox[\"param\", \"TI\"]\) from the AtomicState \!\(\*\n\
StyleBox[\"state\", \"TI\"]\).\nIf a list of states is supplied, the \
parameter is deleted from all of the states. If a list of parameters is \
supplied, all of the parameters are deleted.\nDeleteParameter behaves \
analogously with region parameters and regions in place of state parameters \
and states."], AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0]] = 
       AtomicDensityMatrix`Parity[1], 
       AtomicDensityMatrix`Parity[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{"He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{"K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{"K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Lu", {177, "m"}, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Lu", {177, "m"}, {
          "Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {2, "D", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, 
       AtomicDensityMatrix`Parity[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = 
       AtomicDensityMatrix`Odd, 
       AtomicDensityMatrix`Parity[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 
       AtomicDensityMatrix`Even, AtomicDensityMatrix`Parity[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`Parity[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`Parity, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`Parity -> AtomicDensityMatrix`Parity[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`Parity[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`Parity, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`Parity, 
        MessageName[AtomicDensityMatrix`Parity, "usage"], 
        "\!\(\*TagBox[RowBox[{\"Parity is a parameter for AtomicState that \
specifies the parity of the state.\", \"\[LineSeparator]\", \"Parity[\", \
StyleBox[\"state\", \"TI\"], \"] returns the value specified for Parity in \
AtomicState \", StyleBox[\"state\", \"TI\"], \", or Parity[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified.\"}], \
DisplayForm]\)"], 
       TagSet[AtomicDensityMatrix`Odd, 
        MessageName[AtomicDensityMatrix`Odd, "usage"], 
        "Odd is a possible value for the AtomicState parameter Parity \
specifying that the parity of the state is odd."], 
       TagSet[AtomicDensityMatrix`Even, 
        MessageName[AtomicDensityMatrix`Even, "usage"], 
        "Even is a possible value for the AtomicState parameter Parity \
specifying that the parity of the state is even."], 
       AtomicDensityMatrix`NaturalWidth[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = (28.743065735391337` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = (32.8893274132544 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         131.57894736842104` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         131.57894736842104` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         131.57894736842104` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         131.57894736842104` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`NaturalWidth[{
         "H", 1, {{2, "p"}}, {2, "P", 1/2}}] = (625. Units`Mega)/Units`Second,
        AtomicDensityMatrix`NaturalWidth[{
         "H", 1, {{2, "p"}}, {2, "P", 3/2}}] = (625. Units`Mega)/Units`Second,
        AtomicDensityMatrix`NaturalWidth[{
         "He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = (10.178760197630933` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = (10.178760197630933` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = (10.178760197630933` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = (37.32736095558044 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = (37.80718336483932 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = (
         36.764705882352935` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 3/2}}] = (
         36.764705882352935` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = (22.779043280182233` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Lu", {177, "m"}, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Lu", {177, "m"}, {
          "Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = (22.779043280182233` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = (51.47 Units`Mega)/
        Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = (51.4 Units`Mega)/
        Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = (61.35345726731702 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = (61.54149127341653 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = (19.130000000000003` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = (19.11 Units`Mega)/
        Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = (9.507000000000001 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = (9.692 Units`Mega)/
        Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = (26.400000000000002` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (36.12847284945265 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (38.11730983274124 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (36.12847284945265 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (38.11730983274124 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`NaturalWidth[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`NaturalWidth[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`NaturalWidth, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`NaturalWidth -> AtomicDensityMatrix`NaturalWidth[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`NaturalWidth[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`NaturalWidth, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`NaturalWidth, 
        MessageName[AtomicDensityMatrix`NaturalWidth, "usage"], 
        "\!\(\*TagBox[RowBox[{\"NaturalWidth is a parameter for AtomicState \
that specifies the natural width (radiative decay rate) of the state. \", \"\
\[LineSeparator]\", \"NaturalWidth[\", StyleBox[\"state\", \"TI\"], \"] \
returns the value specified for NaturalWidth in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or NaturalWidth[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified.\"}], \
DisplayForm]\)"], AtomicDensityMatrix`GFactor[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`GFactor[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`GFactor, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`GFactor -> AtomicDensityMatrix`GFactor[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`GFactor[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`GFactor, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`GFactor, 
        MessageName[AtomicDensityMatrix`GFactor, "usage"], 
        "\!\(\*TagBox[RowBox[{\"GFactor is a parameter for AtomicState that \
specifies the Land\[EAcute] \", SubscriptBox[\"g\", \"J\"], \"\[Hyphen]factor \
for the state, as an alternative to specifying values for L and S for the \
state. \", \"\[LineSeparator]\", \"GFactor[\", StyleBox[\"state\", \"TI\"], \
\"] returns the value specified for GFactor in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or GFactor[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified.\"}], \
DisplayForm]\)"], 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 0.01651414747028505, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 0.016405282707387538`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 0.014754436648782503`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 0.8334952399455994, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 0, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 0.5279665446941976, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 0.3333333333333333, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = 0.16650476005440062`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = 1, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 0.1055933089388395, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 0.6331763474620618, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = 0.6666666666666666, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 1, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = 1, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 0.28715683180814133`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 0.28373916632274043`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 0.3052796654469419, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = 0.061160480920020896`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}][{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = 0.36682365253793825`, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 1/2}}] = 0.6963290207215735, 
       AtomicDensityMatrix`BranchingRatio[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}][{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = 0.6851011143210896, 
       AtomicDensityMatrix`BranchingRatio[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := If[
         Or[
          And[
           AtomicDensityMatrix`DefinedQ[
           AtomicDensityMatrix`AtomicSystem`Private`state1, 
            AtomicDensityMatrix`BranchingRatio[
             AtomicDensityMatrix`StateLabel[
             AtomicDensityMatrix`AtomicSystem`Private`state2]]], 
           AtomicDensityMatrix`BranchingRatio[
             AtomicDensityMatrix`StateLabel[
             AtomicDensityMatrix`AtomicSystem`Private`state2]][
            AtomicDensityMatrix`AtomicSystem`Private`state1] =!= 0], 
          AtomicDensityMatrix`Parity[
           AtomicDensityMatrix`AtomicSystem`Private`state1] === 
          AtomicDensityMatrix`Parity[
           AtomicDensityMatrix`AtomicSystem`Private`state2]], 0, 
         AtomicDensityMatrix`BranchingRatio[
          AtomicDensityMatrix`StateLabel[
          AtomicDensityMatrix`AtomicSystem`Private`state1]][
         AtomicDensityMatrix`AtomicSystem`Private`state2]], 
       AtomicDensityMatrix`BranchingRatio[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`label, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`value}, 
         If[
          Or[
          AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state] === 
           AtomicDensityMatrix`AtomicSystem`Private`label, 
           AtomicDensityMatrix`NaturalWidth[
            AtomicDensityMatrix`AtomicSystem`Private`state] === 0], 0, 
          If[(AtomicDensityMatrix`AtomicSystem`Private`value = ReplaceAll[
              AtomicDensityMatrix`BranchingRatio[
              AtomicDensityMatrix`AtomicSystem`Private`label], 
              AtomicDensityMatrix`StateParameters[
              AtomicDensityMatrix`AtomicSystem`Private`state]]) =!= 
           AtomicDensityMatrix`BranchingRatio[
            AtomicDensityMatrix`AtomicSystem`Private`label], 
           AtomicDensityMatrix`AtomicSystem`Private`value, 
           AtomicDensityMatrix`BranchingRatio[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state], 
            AtomicDensityMatrix`AtomicSystem`Private`label]]]], Condition[
         AtomicDensityMatrix`BranchingRatio[
          Pattern[AtomicDensityMatrix`AtomicData`Private`state1, 
           Blank[]]][
          Pattern[AtomicDensityMatrix`AtomicData`Private`state2, 
           Blank[]]], 
         ReplaceAll[
          Or[
          AtomicDensityMatrix`Parity[
            AtomicDensityMatrix`AtomicData`Private`state1] == 
           AtomicDensityMatrix`Parity[
            AtomicDensityMatrix`AtomicData`Private`state2], 
           AtomicDensityMatrix`Energy[
            AtomicDensityMatrix`AtomicData`Private`state1] > 
           AtomicDensityMatrix`Energy[
            AtomicDensityMatrix`AtomicData`Private`state2], 
           Abs[AtomicDensityMatrix`J[
              AtomicDensityMatrix`AtomicData`Private`state1] - 
             AtomicDensityMatrix`J[
             AtomicDensityMatrix`AtomicData`Private`state2]] > 1], {
          Units`Mega -> 10^6, Units`Second -> 1}]] = 0, 
       TagSet[AtomicDensityMatrix`BranchingRatio, 
        MessageName[AtomicDensityMatrix`BranchingRatio, "usage"], 
        "\!\(\*TagBox[RowBox[{\"BranchingRatio[\", StyleBox[\"label\", \
\"TI\"], \"] is a parameter for AtomicState that specifies the branching \
ratio for radiative decay to the state with label \", StyleBox[\"label\", \
\"TI\"], \".\", \"\[LineSeparator]\", \"BranchingRatio[\", \
StyleBox[\"label\", \"TI\"], \"][\", StyleBox[\"state\", \"TI\"], \"] returns \
the branching ratio for the AtomicState \", StyleBox[\"state\", \"TI\"], \" \
to the state with label \", StyleBox[\"label\", \"TI\"], \", or \
BranchingRatio[StateLabel[\", StyleBox[\"state]\", \"TI\"], \",\", \
StyleBox[\"label\", \"TI\"], \"] if it is not specified.\"}], \
DisplayForm]\)"], AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`x, 
          Alternatives[
          AtomicDensityMatrix`S, AtomicDensityMatrix`L, AtomicDensityMatrix`J,
            AtomicDensityMatrix`NuclearSpin, AtomicDensityMatrix`F, 
           AtomicDensityMatrix`M, AtomicDensityMatrix`Parity, 
           AtomicDensityMatrix`Energy, AtomicDensityMatrix`NaturalWidth, 
           AtomicDensityMatrix`GFactor, 
           AtomicDensityMatrix`BranchingRatio[
            Blank[]], AtomicDensityMatrix`LevelPosition, 
           AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
           AtomicDensityMatrix`Polarizability[
            Blank[]], 
           AtomicDensityMatrix`TransitionPolarizability[
            Blank[]]]]] := MemberQ[
         Rest[AtomicDensityMatrix`AtomicSystem`Private`state], 
         AtomicDensityMatrix`AtomicSystem`Private`x -> Blank[]], 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
          Alternatives[
           Blank[AtomicDensityMatrix`AtomicState], {
            Repeated[
             Blank[AtomicDensityMatrix`AtomicState]]}]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`x, 
          Alternatives[{
            Repeated[
             Alternatives[
             AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
              AtomicDensityMatrix`J, AtomicDensityMatrix`NuclearSpin, 
              AtomicDensityMatrix`F, AtomicDensityMatrix`M, 
              AtomicDensityMatrix`Parity, AtomicDensityMatrix`Energy, 
              AtomicDensityMatrix`NaturalWidth, AtomicDensityMatrix`GFactor, 
              AtomicDensityMatrix`BranchingRatio[
               Blank[]], AtomicDensityMatrix`LevelPosition, 
              AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
              
              AtomicDensityMatrix`Polarizability[
               Blank[]], 
              AtomicDensityMatrix`TransitionPolarizability[
               Blank[]]]]}, 
           Repeated[
            Alternatives[
            AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
             AtomicDensityMatrix`J, AtomicDensityMatrix`NuclearSpin, 
             AtomicDensityMatrix`F, AtomicDensityMatrix`M, 
             AtomicDensityMatrix`Parity, AtomicDensityMatrix`Energy, 
             AtomicDensityMatrix`NaturalWidth, AtomicDensityMatrix`GFactor, 
             AtomicDensityMatrix`BranchingRatio[
              Blank[]], AtomicDensityMatrix`LevelPosition, 
             AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
             AtomicDensityMatrix`Polarizability[
              Blank[]], 
             AtomicDensityMatrix`TransitionPolarizability[
              Blank[]]]]]]] := Apply[And, 
         Flatten[
          Outer[AtomicDensityMatrix`DefinedQ, 
           Flatten[{AtomicDensityMatrix`AtomicSystem`Private`sys}], 
           Flatten[{AtomicDensityMatrix`AtomicSystem`Private`x}]]]], 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, 
          Alternatives[
          AtomicDensityMatrix`OpticalParameters, 
           AtomicDensityMatrix`ElectricField, 
           AtomicDensityMatrix`MagneticField, 
           AtomicDensityMatrix`TransitRate[
            Blank[]], AtomicDensityMatrix`Density, 
           AtomicDensityMatrix`VelocityGroupRecoilMomentum[
            Blank[]], AtomicDensityMatrix`SDampingRate]]] := 
       ReplaceAll[AtomicDensityMatrix`ExperimentalSystem`Private`x, 
          AtomicDensityMatrix`RegionParameters[
          AtomicDensityMatrix`ExperimentalSystem`Private`region]] =!= 
        AtomicDensityMatrix`ExperimentalSystem`Private`x, 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, {
           Repeated[
            Alternatives[
            AtomicDensityMatrix`OpticalParameters, 
             AtomicDensityMatrix`ElectricField, 
             AtomicDensityMatrix`MagneticField, 
             AtomicDensityMatrix`TransitRate[
              Blank[]], AtomicDensityMatrix`Density, 
             AtomicDensityMatrix`VelocityGroupRecoilMomentum[
              Blank[]], AtomicDensityMatrix`SDampingRate]]}]] := Apply[And, 
         Map[
         AtomicDensityMatrix`DefinedQ[
          AtomicDensityMatrix`ExperimentalSystem`Private`region, #]& , 
          AtomicDensityMatrix`ExperimentalSystem`Private`x]], 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}], 
         AtomicDensityMatrix`VelocityGroupRecoilMomentum] := Apply[Or, 
         Flatten[
          AtomicDensityMatrix`DirectProduct[AtomicDensityMatrix`DefinedQ[#, 
            AtomicDensityMatrix`VelocityGroupRecoilMomentum[#2]]& , 
           AtomicDensityMatrix`ExperimentalSystem`Private`sys, 
           AtomicDensityMatrix`RegionLabel[
           AtomicDensityMatrix`ExperimentalSystem`Private`sys]]]], 
       AtomicDensityMatrix`DefinedQ[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, 
          Blank[]]] := Apply[And, 
         Map[
         AtomicDensityMatrix`DefinedQ[#, 
           AtomicDensityMatrix`ExperimentalSystem`Private`x]& , 
          AtomicDensityMatrix`ExperimentalSystem`Private`sys]], 
       TagSet[AtomicDensityMatrix`DefinedQ, 
        MessageName[AtomicDensityMatrix`DefinedQ, "usage"], 
        "DefinedQ[\!\(\*\nStyleBox[\"state\", \"TI\"]\),\!\(\*\n\
StyleBox[\"param\", \"TI\"]\)] returns True if state parameter \!\(\*\n\
StyleBox[\"param\", \"TI\"]\) is specified in AtomicState \!\(\*\n\
StyleBox[\"state\", \"TI\"]\), and False otherwise.\nDefinedQ[\!\(\*\n\
StyleBox[\"state\", \"TI\"]\),{\!\(\*SubscriptBox[\nStyleBox[\"param\", \
\"TI\"], \"1\"]\),\!\(\*SubscriptBox[\nStyleBox[\"param\", \"TI\"], \"2\"]\),\
\[Ellipsis]}] returns True if all of the \!\(\*\n\
StyleBox[SubscriptBox[\"param\", \"i\"], \"TI\"]\) are specified in \!\(\*\n\
StyleBox[\"state\", \"TI\"]\), and False otherwise.\n\
DefinedQ[{\!\(\*SubscriptBox[\nStyleBox[\"state\", \"TI\"], \
\"1\"]\),\!\(\*SubscriptBox[\nStyleBox[\"state\", \"TI\"], \"2\"]\),\
\[Ellipsis]},\!\(\*\nStyleBox[\"param\", \"TI\"]\)] checks if \!\(\*\n\
StyleBox[\"param\", \"TI\"]\) is specified in all of the states.\nDefinedQ \
behaves analogously with region parameters and regions in place of state \
parameters and states."], AtomicDensityMatrix`LevelPosition[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`LevelPosition[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`LevelPosition, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`LevelPosition -> 
          AtomicDensityMatrix`LevelPosition[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`LevelPosition[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`LevelPosition, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`LevelPosition, 
        MessageName[AtomicDensityMatrix`LevelPosition, "usage"], ""], 
       AtomicDensityMatrix`HyperfineA[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = AtomicDensityMatrix`HyperfineA[1], 
       AtomicDensityMatrix`HyperfineA[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = AtomicDensityMatrix`HyperfineA[1], 
       AtomicDensityMatrix`HyperfineA[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = (1834.1880831903954` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = (315.97051918747997` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = (14439.752217894069` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         11565.620623276358` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         4690.292402599044 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         3176.778491309999 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         1224.5928163693013` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = (
         36862.94554239806 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         12356.754281546078` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         4746.80194961831 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = (
         3411.1413032677974` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 3/2}}] = (
         1306.2742253626361` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = (
         39486.112576292464` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = (
         8922.123136195012 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 
       0, AtomicDensityMatrix`HyperfineA[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 
       0, AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 0, 
       AtomicDensityMatrix`HyperfineA[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = (181.26989611213108` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = (38.07610296150829 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = (1450.5352809978547` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = (
         289.1773205776333 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {
          2, "P", 3/2}}] = ((-19.195131113433636`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = (
         2524.282535591937 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = (1224.2158252508707` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = ((-8978.04348542891) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Lu", {177, "m"}, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = (384.5309407993907 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Lu", {177, "m"}, {
          "Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = ((-2814.8670176164546`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = (3.311238656883642 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = (0.6817256058289851 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = (593.3840204100401 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = (116.45255648326645` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = (5565.7276311458045` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 3/2}}] = (1.350884841043611 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {4, "d"}}, {2, "D", 5/2}}] = (0.18221237390820802` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = (38.955748904513435` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Na", 23, {"Ne", {4, "s"}}, {2, "S", 1/2}}] = (1269.2034320502764` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (757.293475518434 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (157.092199050104 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = (6358.02315241775 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = (2558.7643844958147` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (532.3020344462938 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineA[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = (21471.788680034824` 
         Units`Mega)/Units`Second, AtomicDensityMatrix`HyperfineA[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`HyperfineA[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`HyperfineA, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`HyperfineA -> AtomicDensityMatrix`HyperfineA[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`HyperfineA[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`HyperfineA, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`HyperfineA, 
        MessageName[AtomicDensityMatrix`HyperfineA, "usage"], 
        "\!\(\*TagBox[RowBox[{\"HyperfineA is a parameter for AtomicState \
that parameterizes the hyperfine splitting of the state due to the electronic \
interaction with the nuclear magnetic dipole moment.\", \"\[LineSeparator]\", \
\"HyperfineA[\", StyleBox[\"state\", \"TI\"], \"] returns the value specified \
for HyperfineA in AtomicState \", StyleBox[\"state\", \"TI\"], \", or \
HyperfineA[StateLabel[\", StyleBox[\"state\", \"TI\"], \"]] if it is not \
specified.\"}], DisplayForm]\)"], AtomicDensityMatrix`HyperfineB[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = AtomicDensityMatrix`HyperfineB[1], 
       AtomicDensityMatrix`HyperfineB[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = AtomicDensityMatrix`HyperfineB[1], 
       AtomicDensityMatrix`HyperfineB[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cs", 133, {"Xe", {6, "p"}}, {2, "P", 3/2}}] = ((-3.100123630562408) 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cs", 133, {"Xe", {6, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         35.41264946540644 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         1349066061 Units`Mega Pi)/(250000000 Units`Second), 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "p"}}, {
          2, "P", 3/2}}] = ((-182.84069243892597`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 63, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 3/2}}] = (
         1349066061 Units`Mega Pi)/(250000000 Units`Second), 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 9}, {4, "s", 2}}, {2, "D", 5/2}}] = (
         6.969510799042757 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "p"}}, {
          2, "P", 3/2}}] = ((-169.01768476313086`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Cu", 65, {"Ar", {3, "d", 10}, {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{"H", 1, {{1, "s"}}, {2, "S", 1/2}}] = 
       0, AtomicDensityMatrix`HyperfineB[{"H", 1, {{2, "p"}}, {2, "P", 1/2}}] = 
       0, AtomicDensityMatrix`HyperfineB[{"H", 1, {{2, "p"}}, {2, "P", 3/2}}] = 
       0, AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s", 2}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 1}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "p"}}, {3, "P", 2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "s"}}, {1, "S", 0}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "He", 2, {{1, "s"}, {2, "s"}}, {3, "S", 1}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "K", 39, {"Ar", {4, "p"}}, {2, "P", 3/2}}] = (17.781414419318228` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "K", 39, {"Ar", {4, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Li", 3, {{1, "s", 2}, {2, "p"}}, {
          2, "P", 3/2}}] = ((-1.3885839528866886`) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Li", 3, {{1, "s", 2}, {2, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = (9215.61072189337 Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Lu", 177, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = ((-3041.06168867492) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Lu", {177, "m"}, {"Xe", {4, "f", 14}, {5, "d"}, {6, "s", 2}}, {
          2, "D", 3/2}}] = (15532.034079347937` Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Lu", {177, "m"}, {
          "Xe", {4, "f", 14}, {5, "d"}, {6, "s"}, {6, "p"}}, {
          2, "D", 3/2}}] = ((-5070.530542893926) Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 3/2}}] = (0.7916813487046279 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "d"}}, {2, "D", 5/2}}] = (1.124690169985146 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "p"}}, {2, "P", 3/2}}] = (17.115396776757194` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {3, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Na", 23, {"Ne", {4, "p"}}, {2, "P", 3/2}}] = (6.283185307179586 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 85, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (162.04334907216153` 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 85, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 87, {"Kr", {5, "p"}}, {2, "P", 3/2}}] = (78.51782519116969 
         Units`Mega)/Units`Second, 
       AtomicDensityMatrix`HyperfineB[{
         "Rb", 87, {"Kr", {5, "s"}}, {2, "S", 1/2}}] = 0, 
       AtomicDensityMatrix`HyperfineB[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state$, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`HyperfineB[
         AtomicDensityMatrix`AtomicSystem`Private`state$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`HyperfineB, 
           AtomicDensityMatrix`StateParameters[
           AtomicDensityMatrix`AtomicSystem`Private`state$]], 
          AtomicDensityMatrix`HyperfineB -> AtomicDensityMatrix`HyperfineB[
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state$]]]), 
       AtomicDensityMatrix`HyperfineB[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys$, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`HyperfineB, 
         AtomicDensityMatrix`AtomicSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`HyperfineB, 
        MessageName[AtomicDensityMatrix`HyperfineB, "usage"], 
        "\!\(\*TagBox[RowBox[{\"HyperfineB is a parameter for AtomicState \
that parameterizes the hyperfine splitting of the state due to the electronic \
interaction with the nuclear electric quadrupole moment.\", \
\"\[LineSeparator]\", \"HyperfineB[\", StyleBox[\"state\", \"TI\"], \"] \
returns the value specified for HyperfineB in AtomicState \", \
StyleBox[\"state\", \"TI\"], \", or HyperfineB[StateLabel[\", \
StyleBox[\"state\", \"TI\"], \"]] if it is not specified.\"}], \
DisplayForm]\)"], AtomicDensityMatrix`Polarizability[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`k, 
          BlankSequence[]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`value}, 
         If[(AtomicDensityMatrix`AtomicSystem`Private`value = ReplaceAll[
             AtomicDensityMatrix`Polarizability[
             AtomicDensityMatrix`AtomicSystem`Private`k], 
             AtomicDensityMatrix`StateParameters[
             AtomicDensityMatrix`AtomicSystem`Private`state]]) =!= 
          AtomicDensityMatrix`Polarizability[
           AtomicDensityMatrix`AtomicSystem`Private`k], 
          AtomicDensityMatrix`AtomicSystem`Private`value, 
          AtomicDensityMatrix`Polarizability[
          AtomicDensityMatrix`AtomicSystem`Private`k][
           AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`AtomicSystem`Private`state]]]], 
       TagSet[AtomicDensityMatrix`Polarizability, 
        MessageName[AtomicDensityMatrix`Polarizability, "usage"], 
        "Polarizability[\!\(\*\nStyleBox[\"k\", \"TI\"]\)] is a parameter \
specified in an AtomicState expression that specifies the scalar (\!\(\*\n\
StyleBox[\"k\", \"TI\"]\)=0), vector (\!\(\*\nStyleBox[\"k\", \"TI\"]\)=1), \
or tensor (\!\(\*\nStyleBox[\"k\", \"TI\"]\)=2) polarizability for the state. \
The value can be numeric or symbolic. \nPolarizability[\!\(\*\n\
StyleBox[\"k\", \"TI\"]\)][\!\(\*\nStyleBox[\"state\", \"TI\"]\)] returns the \
corresponding specified value for the polarizability of AtomicState \!\(\*\n\
StyleBox[\"state\", \"TI\"]\), or Polarizability[\!\(\*\nStyleBox[\"k\", \"TI\
\"]\)][StateLabel[\!\(\*\nStyleBox[\"state\", \"TI\"]\)]] if it is not \
specified."], AtomicDensityMatrix`TransitionPolarizability[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`k, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`value}, 
         Which[(AtomicDensityMatrix`AtomicSystem`Private`value = ReplaceAll[
             AtomicDensityMatrix`TransitionPolarizability[
             AtomicDensityMatrix`AtomicSystem`Private`k][
              AtomicDensityMatrix`StateLabel[
              AtomicDensityMatrix`AtomicSystem`Private`state1]], 
             AtomicDensityMatrix`StateParameters[
             AtomicDensityMatrix`AtomicSystem`Private`state2]]) =!= 
          AtomicDensityMatrix`TransitionPolarizability[
           AtomicDensityMatrix`AtomicSystem`Private`k][
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state1]], 
          AtomicDensityMatrix`AtomicSystem`Private`value, (
           AtomicDensityMatrix`AtomicSystem`Private`value = ReplaceAll[
             AtomicDensityMatrix`TransitionPolarizability[
             AtomicDensityMatrix`AtomicSystem`Private`k][
              AtomicDensityMatrix`StateLabel[
              AtomicDensityMatrix`AtomicSystem`Private`state2]], 
             AtomicDensityMatrix`StateParameters[
             AtomicDensityMatrix`AtomicSystem`Private`state1]]) =!= 
          AtomicDensityMatrix`TransitionPolarizability[
           AtomicDensityMatrix`AtomicSystem`Private`k][
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`AtomicSystem`Private`state2]], 
          AtomicDensityMatrix`AtomicSystem`Private`value, True, 
          AtomicDensityMatrix`TransitionPolarizability[
          AtomicDensityMatrix`AtomicSystem`Private`k][
           Apply[Sequence, 
            Sort[
             Map[
             AtomicDensityMatrix`StateLabel, {
              AtomicDensityMatrix`AtomicSystem`Private`state1, 
               AtomicDensityMatrix`AtomicSystem`Private`state2}]]]]]], 
       TagSet[AtomicDensityMatrix`TransitionPolarizability, 
        MessageName[AtomicDensityMatrix`TransitionPolarizability, "usage"], 
        ""], AtomicDensityMatrix`MagneticField[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`MagneticField[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`MagneticField, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`MagneticField -> 
          AtomicDensityMatrix`MagneticField[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`MagneticField[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`MagneticField, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`MagneticField, 
        MessageName[AtomicDensityMatrix`MagneticField, "usage"], 
        "MagneticField is an option for Hamiltonian that specifies the \
applied external magnetic field."], AtomicDensityMatrix`TransitRate[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg1, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]][
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg2, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := 
       AtomicDensityMatrix`TransitRate[
         AtomicDensityMatrix`RegionLabel[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg1]][
        AtomicDensityMatrix`ExperimentalSystem`Private`reg2], 
       AtomicDensityMatrix`TransitRate[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`label, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := 
       Which[AtomicDensityMatrix`RegionLabel[
          AtomicDensityMatrix`ExperimentalSystem`Private`region] === 
         AtomicDensityMatrix`ExperimentalSystem`Private`label, 0, 
         AtomicDensityMatrix`DefinedQ[
         AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          AtomicDensityMatrix`TransitRate[
          AtomicDensityMatrix`ExperimentalSystem`Private`label]], 
         ReplaceAll[
          AtomicDensityMatrix`TransitRate[
          AtomicDensityMatrix`ExperimentalSystem`Private`label], 
          AtomicDensityMatrix`RegionParameters[
          AtomicDensityMatrix`ExperimentalSystem`Private`region]], True, 
         AtomicDensityMatrix`TransitRate[
          AtomicDensityMatrix`RegionLabel[
          AtomicDensityMatrix`ExperimentalSystem`Private`region], 
          AtomicDensityMatrix`ExperimentalSystem`Private`label]], 
       TagSet[AtomicDensityMatrix`TransitRate, 
        MessageName[AtomicDensityMatrix`TransitRate, "usage"], ""], 
       AtomicDensityMatrix`Density[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`Density[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`Density, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`Density -> AtomicDensityMatrix`Density[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`Density[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`Density, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`Density, 
        MessageName[AtomicDensityMatrix`Density, "usage"], ""], 
       AtomicDensityMatrix`VelocityGroupRecoilMomentum[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg1, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]][
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg2, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := 
       AtomicDensityMatrix`VelocityGroupRecoilMomentum[
         AtomicDensityMatrix`RegionLabel[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg1]][
        AtomicDensityMatrix`ExperimentalSystem`Private`reg2], 
       AtomicDensityMatrix`VelocityGroupRecoilMomentum[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`label, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := 
       Which[AtomicDensityMatrix`RegionLabel[
          AtomicDensityMatrix`ExperimentalSystem`Private`region] === 
         AtomicDensityMatrix`ExperimentalSystem`Private`label, 0, 
         AtomicDensityMatrix`DefinedQ[
         AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          AtomicDensityMatrix`VelocityGroupRecoilMomentum[
          AtomicDensityMatrix`ExperimentalSystem`Private`label]], 
         ReplaceAll[
          AtomicDensityMatrix`VelocityGroupRecoilMomentum[
          AtomicDensityMatrix`ExperimentalSystem`Private`label], 
          AtomicDensityMatrix`RegionParameters[
          AtomicDensityMatrix`ExperimentalSystem`Private`region]], True, 0], 
       TagSet[AtomicDensityMatrix`VelocityGroupRecoilMomentum, 
        MessageName[AtomicDensityMatrix`VelocityGroupRecoilMomentum, "usage"],
         ""], AtomicDensityMatrix`SDampingRate[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg$, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := (
        AtomicDensityMatrix`SDampingRate[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg$] = ReplaceAll[
          ReplaceAll[AtomicDensityMatrix`SDampingRate, 
           AtomicDensityMatrix`RegionParameters[
           AtomicDensityMatrix`ExperimentalSystem`Private`reg$]], 
          AtomicDensityMatrix`SDampingRate -> AtomicDensityMatrix`SDampingRate[
            AtomicDensityMatrix`RegionLabel[
            AtomicDensityMatrix`ExperimentalSystem`Private`reg$]]]), 
       AtomicDensityMatrix`SDampingRate[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`sys$, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}]] := 
       Map[AtomicDensityMatrix`SDampingRate, 
         AtomicDensityMatrix`ExperimentalSystem`Private`sys$], 
       TagSet[AtomicDensityMatrix`SDampingRate, 
        MessageName[AtomicDensityMatrix`SDampingRate, "usage"], ""], 
       AtomicDensityMatrix`DirectProduct[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`f, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[List]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
          Blank[List]]] := 
       Outer[AtomicDensityMatrix`TensorAlgebra`Private`f, 
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
         AtomicDensityMatrix`TensorAlgebra`Private`b, 1], 
       AtomicDensityMatrix`DirectProduct[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[List]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`b, 
          Blank[List]]] := 
       AtomicDensityMatrix`DirectProduct[
        Times, AtomicDensityMatrix`TensorAlgebra`Private`a, 
         AtomicDensityMatrix`TensorAlgebra`Private`b], 
       TagSet[AtomicDensityMatrix`DirectProduct, 
        MessageName[AtomicDensityMatrix`DirectProduct, "usage"], ""], 
       AtomicDensityMatrix`ExperimentalSystem`Private`MapOnParameters[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`f, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`reg, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]]] := 
       AtomicDensityMatrix`ExperimentalRegion[
         AtomicDensityMatrix`RegionLabel[
         AtomicDensityMatrix`ExperimentalSystem`Private`reg], 
         AtomicDensityMatrix`ExperimentalSystem`Private`f[
          AtomicDensityMatrix`RegionParameters[
          AtomicDensityMatrix`ExperimentalSystem`Private`reg]]], CenterDot = 
       AtomicDensityMatrix`MatrixMultiply, 
       TagSet[AtomicDensityMatrix`Xx, 
        MessageName[AtomicDensityMatrix`Xx, "usage"], ""], 
       TagSet[AtomicDensityMatrix`Yy, 
        MessageName[AtomicDensityMatrix`Yy, "usage"], ""], 
       TagSet[AtomicDensityMatrix`Zz, 
        MessageName[AtomicDensityMatrix`Zz, "usage"], ""], 
       TagSet[AtomicDensityMatrix`Interaction, 
        MessageName[AtomicDensityMatrix`Interaction, "usage"], 
        "Interaction is an option for Hamiltonian that specifies which \
interactions should be taken into account when forming the Hamiltonian."], 
       TagSet[AtomicDensityMatrix`Internal, 
        MessageName[AtomicDensityMatrix`Internal, "usage"], ""], 
       TagSet[AtomicDensityMatrix`E1, 
        MessageName[AtomicDensityMatrix`E1, "usage"], ""], 
       TagSet[AtomicDensityMatrix`Magnetic, 
        MessageName[AtomicDensityMatrix`Magnetic, "usage"], ""], 
       TagSet[AtomicDensityMatrix`AllowedCouplings, 
        MessageName[AtomicDensityMatrix`AllowedCouplings, "usage"], 
        "AllowedCouplings is an option for WignerEckart and related functions \
that specifies matrix elements of operators that are allowed to be nonzero."],
        AtomicDensityMatrix`WignerEckart[
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`op, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`WignerEckart[
        AtomicDensityMatrix`WignerEckart`Private`sys, 
         AtomicDensityMatrix`WignerEckart`Private`op, 
         AtomicDensityMatrix`WignerEckart`Private`sys, 
         AtomicDensityMatrix`WignerEckart`Private`opts], 
       AtomicDensityMatrix`WignerEckart[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
          Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[Integer]]}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`opts, 
          OptionsPattern[]]] := Part[
         AtomicDensityMatrix`WignerEckart[{
          AtomicDensityMatrix`WignerEckart`Private`s1}, {
          AtomicDensityMatrix`WignerEckart`Private`a, 
           AtomicDensityMatrix`WignerEckart`Private`k}, {
          AtomicDensityMatrix`WignerEckart`Private`s2}, 
          AtomicDensityMatrix`WignerEckart`Private`opts], All, All, 1, 1], 
       AtomicDensityMatrix`WignerEckart[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
          Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[Integer]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`q, 
           Alternatives[
            Blank[Integer], {
             BlankSequence[Integer]}]]}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`opts, 
          OptionsPattern[]]] := Part[
         AtomicDensityMatrix`WignerEckart[{
          AtomicDensityMatrix`WignerEckart`Private`s1}, {
          AtomicDensityMatrix`WignerEckart`Private`a, 
           AtomicDensityMatrix`WignerEckart`Private`k, 
           AtomicDensityMatrix`WignerEckart`Private`q}, {
          AtomicDensityMatrix`WignerEckart`Private`s2}, 
          AtomicDensityMatrix`WignerEckart`Private`opts], 1, 1], 
       AtomicDensityMatrix`WignerEckart[
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
          Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[Integer]]}, 
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`WignerEckart[
        AtomicDensityMatrix`WignerEckart`Private`sys1, {
         AtomicDensityMatrix`WignerEckart`Private`a, 
          AtomicDensityMatrix`WignerEckart`Private`k, 
          Range[
          AtomicDensityMatrix`WignerEckart`Private`k, -
           AtomicDensityMatrix`WignerEckart`Private`k, -1]}, 
         AtomicDensityMatrix`WignerEckart`Private`sys2, 
         AtomicDensityMatrix`WignerEckart`Private`opts], 
       AtomicDensityMatrix`WignerEckart[
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
          Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[Integer]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`q, 
           Blank[Integer]]}, 
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`opts, 
          OptionsPattern[]]] := Part[
         AtomicDensityMatrix`WignerEckart[
         AtomicDensityMatrix`WignerEckart`Private`sys1, {
          AtomicDensityMatrix`WignerEckart`Private`a, 
           AtomicDensityMatrix`WignerEckart`Private`k, {
           AtomicDensityMatrix`WignerEckart`Private`q}}, 
          AtomicDensityMatrix`WignerEckart`Private`sys2, 
          AtomicDensityMatrix`WignerEckart`Private`opts], 1, 1], 
       AtomicDensityMatrix`WignerEckart[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`label, 
          Blank[]], 
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`j, 
           Blank[]], AtomicDensityMatrix`HalfIntegerQ], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`opts, 
          OptionsPattern[]]] := AtomicDensityMatrix`WignerEckart[
         AtomicDensityMatrix`ZeemanSystem[
         AtomicDensityMatrix`WignerEckart`Private`label, 
          AtomicDensityMatrix`WignerEckart`Private`j], 
         AtomicDensityMatrix`WignerEckart`Private`a, 
         AtomicDensityMatrix`WignerEckart`Private`opts], 
       AtomicDensityMatrix`WignerEckart[
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`j, 
           Blank[]], AtomicDensityMatrix`HalfIntegerQ], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`opts, 
          OptionsPattern[]]] := AtomicDensityMatrix`WignerEckart[
         AtomicDensityMatrix`ZeemanSystem[
         AtomicDensityMatrix`WignerEckart`Private`j], 
         AtomicDensityMatrix`WignerEckart`Private`a, 
         AtomicDensityMatrix`WignerEckart`Private`opts], Condition[
         AtomicDensityMatrix`WignerEckart[
          PatternTest[
           Pattern[AtomicDensityMatrix`WignerEckart`Private`sys1, 
            Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
           Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
            Blank[Integer]], {
            BlankSequence[Integer]}}, 
          PatternTest[
           Pattern[AtomicDensityMatrix`WignerEckart`Private`sys2, 
            Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`opts, 
           OptionsPattern[]]], 
         MatchQ[
          AtomicDensityMatrix`AtomicSystemType[
           Join[
           AtomicDensityMatrix`WignerEckart`Private`sys1, 
            AtomicDensityMatrix`WignerEckart`Private`sys2]], "Toy"]] := 
       Module[{AtomicDensityMatrix`WignerEckart`Private`allowedCouplings = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`WignerEckart, 
            AtomicDensityMatrix`AllowedCouplings, 
            OptionValue[AtomicDensityMatrix`AllowedCouplings]], 
          AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`WignerEckart, 
            AtomicDensityMatrix`NeglectedCouplings, 
            OptionValue[AtomicDensityMatrix`NeglectedCouplings]]}, 
         Condition[
          
          Normal[{{
            AtomicDensityMatrix`MatrixElementMask[
              AtomicDensityMatrix`WignerEckart`Private`sys1, 
               AtomicDensityMatrix`WignerEckart`Private`sys2, 
               AtomicDensityMatrix`WignerEckart`Private`allowedCouplings, 
               AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings] 
             AtomicDensityMatrix`ReducedME[
              AtomicDensityMatrix`WignerEckart`Private`sys1, {
               AtomicDensityMatrix`WignerEckart`Private`a, 
                AtomicDensityMatrix`WignerEckart`Private`k}, 
               AtomicDensityMatrix`WignerEckart`Private`sys2]}}], 
          
          FreeQ[{{AtomicDensityMatrix`WignerEckart`Private`allowedCouplings, 
             AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings}}, \
$Failed]]], Condition[
         AtomicDensityMatrix`WignerEckart[
          PatternTest[
           Pattern[AtomicDensityMatrix`WignerEckart`Private`sys1, 
            Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
           Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
            Blank[Integer]], {
            BlankSequence[Integer]}}, 
          PatternTest[
           Pattern[AtomicDensityMatrix`WignerEckart`Private`sys2, 
            Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`opts, 
           OptionsPattern[]]], 
         MatchQ[
          AtomicDensityMatrix`AtomicSystemType[
           Join[
           AtomicDensityMatrix`WignerEckart`Private`sys1, 
            AtomicDensityMatrix`WignerEckart`Private`sys2]], "Hyperfine"]] := 
       Module[{AtomicDensityMatrix`WignerEckart`Private`allowedCouplings = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`WignerEckart, 
            AtomicDensityMatrix`AllowedCouplings, 
            OptionValue[AtomicDensityMatrix`AllowedCouplings]], 
          AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`WignerEckart, 
            AtomicDensityMatrix`NeglectedCouplings, 
            OptionValue[AtomicDensityMatrix`NeglectedCouplings]]}, 
         Condition[
          
          Normal[{{(
              AtomicDensityMatrix`MatrixElementMask[
               AtomicDensityMatrix`WignerEckart`Private`sys1, 
                AtomicDensityMatrix`WignerEckart`Private`sys2, 
                AtomicDensityMatrix`WignerEckart`Private`allowedCouplings, 
                AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings] 
              AtomicDensityMatrix`ReducedME[
               AtomicDensityMatrix`WignerEckart`Private`sys1, {
                AtomicDensityMatrix`WignerEckart`Private`a, 
                 AtomicDensityMatrix`WignerEckart`Private`k}, 
                AtomicDensityMatrix`WignerEckart`Private`sys2])/If[
             AtomicDensityMatrix`WignerEckart`Private`k == 0, 
              Sqrt[
              2 AtomicDensityMatrix`F[
                 AtomicDensityMatrix`WignerEckart`Private`sys1] + 1], 1]}}], 
          
          FreeQ[{{AtomicDensityMatrix`WignerEckart`Private`allowedCouplings, 
             AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings}}, \
$Failed]]], AtomicDensityMatrix`WignerEckart[
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
          Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[Integer]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`qs, {
            BlankSequence[Integer]}]}, 
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`WignerEckart`Private`representation = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`WignerEckart, 
            AtomicDensityMatrix`Representation, 
            OptionValue[AtomicDensityMatrix`Representation]]}, 
         Condition[
          Switch[
          AtomicDensityMatrix`WignerEckart`Private`representation, {"Zeeman"}, 
           AtomicDensityMatrix`WignerEckart`Private`WignerEckartZ[
           AtomicDensityMatrix`WignerEckart`Private`sys1, {
            AtomicDensityMatrix`WignerEckart`Private`a, 
             AtomicDensityMatrix`WignerEckart`Private`k, 
             AtomicDensityMatrix`WignerEckart`Private`qs}, 
            AtomicDensityMatrix`WignerEckart`Private`sys2, 
            FilterRules[{AtomicDensityMatrix`WignerEckart`Private`opts, 
              Options[AtomicDensityMatrix`WignerEckart]}, 
             Options[
             AtomicDensityMatrix`WignerEckart`Private`WignerEckartZ]]], {
           "PolarizationMoments", 
            BlankNullSequence[]}, 
           AtomicDensityMatrix`WignerEckart`Private`WignerEckartPM[
           AtomicDensityMatrix`WignerEckart`Private`sys1, {
            AtomicDensityMatrix`WignerEckart`Private`a, 
             AtomicDensityMatrix`WignerEckart`Private`k, 
             AtomicDensityMatrix`WignerEckart`Private`qs}, 
            AtomicDensityMatrix`WignerEckart`Private`sys2, 
            Rest[AtomicDensityMatrix`WignerEckart`Private`representation], 
            FilterRules[{AtomicDensityMatrix`WignerEckart`Private`opts, 
              Options[AtomicDensityMatrix`WignerEckart]}, 
             Options[
             AtomicDensityMatrix`WignerEckart`Private`WignerEckartPM]]]], 
          
          FreeQ[{{AtomicDensityMatrix`WignerEckart`Private`representation}}, \
$Failed]]], 
       Options[AtomicDensityMatrix`WignerEckart] = {
        AtomicDensityMatrix`Representation -> Automatic, 
         AtomicDensityMatrix`AllowedCouplings -> All, 
         AtomicDensityMatrix`NeglectedCouplings -> None}, 
       TagSet[AtomicDensityMatrix`WignerEckart, 
        MessageName[AtomicDensityMatrix`WignerEckart, "usage"], 
        "\!\(\*TagBox[RowBox[{\"WignerEckart[\", StyleBox[\"sys\", \"TI\"], \
\", {\", StyleBox[\"op\", \"TI\"], \", \", StyleBox[\"k\", \"TI\"], \"}] \
returns the covariant tensor representing the rank\[Hyphen]\", \
StyleBox[\"k\", \"TI\"], \" operator \", StyleBox[\"op\", \"TI\"], \" with \
respect to the basis states of the atomic system \", StyleBox[\"sys\", \
\"TI\"], \".\", \"\[LineSeparator]\", \"WignerEckart[\", StyleBox[\"sys\", \
\"TI\"], \", {\", StyleBox[\"op\", \"TI\"], \",\", StyleBox[\"k\", \"TI\"], \
\",\", StyleBox[\"q\", \"TI\"], \"}] returns the \", StyleBox[\"q\", \"TI\"], \
\"\[Hyphen]th component of the tensor operator.\", \"\[LineSeparator]\", \
\"WignerEckart[\", SubscriptBox[StyleBox[\"state\", \"TI\"], StyleBox[\"1\", \
\"TR\"]], \",{\", StyleBox[\"op\", \"TI\"], \",\", StyleBox[\"k\", \"TI\"], \
\",\", StyleBox[\"q\", \"TI\"], \"},\", SubscriptBox[StyleBox[\"state\", \"TI\
\"], StyleBox[\"2\", \"TR\"]], \"] returns the matrix element of the operator \
between the atomic states \", SubscriptBox[StyleBox[\"state\", \"TI\"], \
StyleBox[\"1\", \"TR\"]], \" and \", SubscriptBox[StyleBox[\"state\", \
\"TI\"], StyleBox[\"2\", \"TR\"]], \".\", \"\[LineSeparator]\", \
\"WignerEckart[\", StyleBox[\"j\", \"TI\"], \",{\", StyleBox[\"op\", \"TI\"], \
\",\", StyleBox[\"k\", \"TI\"], \"}] returns the operator for a Zeeman system \
with angular momentum equal to integer or half-integer \", StyleBox[\"j\", \
\"TI\"], \".\"}], DisplayForm]\)"], AtomicDensityMatrix`ZeemanSystem[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`label, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`j, 
          Blank[]]] := AtomicDensityMatrix`ZeemanSublevels[
         AtomicDensityMatrix`AtomicState[
         AtomicDensityMatrix`AtomicSystem`Private`label, 
          AtomicDensityMatrix`J -> 
          AtomicDensityMatrix`AtomicSystem`Private`j]], 
       AtomicDensityMatrix`ZeemanSystem[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`j, 
          Blank[]]] := AtomicDensityMatrix`ZeemanSystem[
         ToString[
          Unique[]], AtomicDensityMatrix`AtomicSystem`Private`j], 
       TagSet[AtomicDensityMatrix`ZeemanSystem, 
        MessageName[AtomicDensityMatrix`ZeemanSystem, "usage"], 
        "ZeemanSystem[\!\(\*\nStyleBox[\"j\", \"TI\"]\)] returns a list of \
AtomicState objects describing the Zeeman sublevels of an atomic system with \
angular momentum \!\(\*\nStyleBox[\"j\", \"TI\"]\).\nZeemanSystem[\!\(\*\n\
StyleBox[\"label\", \"TI\"]\),\!\(\*\nStyleBox[\"j\", \"TI\"]\)] provides a \
specific label for the AtomicState objects."], 
       AtomicDensityMatrix`ZeemanSublevels[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Blank[AtomicDensityMatrix`AtomicState]]] := Switch[
         AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicSystem`Private`s], "Fine", 
         Reverse[
          Table[
           AtomicDensityMatrix`AddParameter[
           AtomicDensityMatrix`AtomicSystem`Private`s, AtomicDensityMatrix`M -> 
            AtomicDensityMatrix`AtomicSystem`Private`m], {
           AtomicDensityMatrix`AtomicSystem`Private`m, -
            AtomicDensityMatrix`J[AtomicDensityMatrix`AtomicSystem`Private`s], 
            AtomicDensityMatrix`J[
            AtomicDensityMatrix`AtomicSystem`Private`s]}]], "Hyperfine", 
         Reverse[
          Table[
           AtomicDensityMatrix`AddParameter[
           AtomicDensityMatrix`AtomicSystem`Private`s, AtomicDensityMatrix`M -> 
            AtomicDensityMatrix`AtomicSystem`Private`m], {
           AtomicDensityMatrix`AtomicSystem`Private`m, -
            AtomicDensityMatrix`F[AtomicDensityMatrix`AtomicSystem`Private`s], 
            AtomicDensityMatrix`F[
            AtomicDensityMatrix`AtomicSystem`Private`s]}]], 
         Blank[], AtomicDensityMatrix`AtomicSystem`Private`s], 
       AtomicDensityMatrix`ZeemanSublevels[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := Flatten[
         Map[
         AtomicDensityMatrix`ZeemanSublevels, 
          AtomicDensityMatrix`AtomicSystem`Private`sys]], 
       TagSet[AtomicDensityMatrix`ZeemanSublevels, 
        MessageName[AtomicDensityMatrix`ZeemanSublevels, "usage"], 
        "Sublevels[{\!\(\*SubscriptBox[\nStyleBox[\"state\", \"TI\"], \
\"1\"]\),\!\(\*SubscriptBox[\nStyleBox[\"state\", \"TI\"], \"2\"]\),\
\[Ellipsis]}] returns a list of AtomicState objects in which each \!\(\*\n\
StyleBox[SubscriptBox[\"state\", \"i\"], \"TI\"]\) that has a specified J or \
F parameter has been expanded into states representing each Zeeman sublevel \
of the state."], AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState["$3", AtomicDensityMatrix`J -> 1]] = 
       "Fine", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState["$4", AtomicDensityMatrix`J -> 1]] = 
       "Fine", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         "$3", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> -1]] = 
       "Zeeman", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         "$3", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 0]] = 
       "Zeeman", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         "$3", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 1]] = 
       "Zeeman", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         "$4", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> -1]] = 
       "Zeeman", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         "$4", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 0]] = 
       "Zeeman", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         "$4", AtomicDensityMatrix`J -> 1, AtomicDensityMatrix`M -> 1]] = 
       "Zeeman", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0]] = 
       "Fine", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2]] = "Fine", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = "Hyperfine", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = "Hyperfine", AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> -1]] = "HyperfineZeeman", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> 0]] = "HyperfineZeeman", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1, 
          AtomicDensityMatrix`M -> 1]] = "HyperfineZeeman", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> -2]] = "HyperfineZeeman", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> -1]] = "HyperfineZeeman", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> 0]] = "HyperfineZeeman", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> 1]] = "HyperfineZeeman", 
       AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2, 
          AtomicDensityMatrix`M -> 2]] = "HyperfineZeeman", 
       AtomicDensityMatrix`AtomicSystemType[{
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> 2], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> 1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> 0], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> -1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> -2], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1,
            AtomicDensityMatrix`M -> 1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1,
            AtomicDensityMatrix`M -> 0], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1,
            AtomicDensityMatrix`M -> -1]}] = "HyperfineZeeman", 
       AtomicDensityMatrix`AtomicSystemType[{
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> 2], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> 1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> 0], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> -1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> -2], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1,
            AtomicDensityMatrix`M -> 1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1,
            AtomicDensityMatrix`M -> 0], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1,
            AtomicDensityMatrix`M -> -1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> 2], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> 1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> 0], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> -1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2,
            AtomicDensityMatrix`M -> -2], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1,
            AtomicDensityMatrix`M -> 1], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1,
            AtomicDensityMatrix`M -> 0], 
          AtomicDensityMatrix`AtomicState[
          1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
           AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
           AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1,
            AtomicDensityMatrix`M -> -1]}] = "HyperfineZeeman", 
       AtomicDensityMatrix`AtomicSystemType[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`noMessage = True, 
          AtomicDensityMatrix`AtomicSystem`Private`result}, 
         AtomicDensityMatrix`AtomicSystem`Private`result = Check[
            
            Module[{AtomicDensityMatrix`AtomicSystem`Private`fDefined, 
              AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
              AtomicDensityMatrix`AtomicSystem`Private`mDefined}, {
               AtomicDensityMatrix`AtomicSystem`Private`fDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`mDefined} = 
              Map[AtomicDensityMatrix`AtomicSystem`Private`\
ValidQuantumNumberQ[AtomicDensityMatrix`AtomicSystem`Private`s, #]& , {
                AtomicDensityMatrix`F, AtomicDensityMatrix`J, 
                 AtomicDensityMatrix`M}]; Which[
               And[
               AtomicDensityMatrix`AtomicSystem`Private`fDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`mDefined], 
               "HyperfineZeeman", 
               And[
               AtomicDensityMatrix`AtomicSystem`Private`fDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                Not[AtomicDensityMatrix`AtomicSystem`Private`mDefined]], 
               "Hyperfine", 
               And[
                Not[AtomicDensityMatrix`AtomicSystem`Private`fDefined], 
                AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                AtomicDensityMatrix`AtomicSystem`Private`mDefined], "Zeeman", 
               
               And[AtomicDensityMatrix`AtomicSystem`Private`jDefined, 
                Not[AtomicDensityMatrix`AtomicSystem`Private`mDefined]], 
               "Fine", 
               And[
                Not[AtomicDensityMatrix`AtomicSystem`Private`jDefined], 
                Not[AtomicDensityMatrix`AtomicSystem`Private`mDefined]], 
               "Toy", True, 
               Message[
                MessageName[AtomicDensityMatrix`AtomicSystemType, "unrec"], 
                AtomicDensityMatrix`AtomicSystem`Private`s]]], 
            AtomicDensityMatrix`AtomicSystem`Private`noMessage = False]; 
         Condition[
          AtomicDensityMatrix`AtomicSystemType[
            AtomicDensityMatrix`AtomicSystem`Private`s] = 
           AtomicDensityMatrix`AtomicSystem`Private`result, 
           AtomicDensityMatrix`AtomicSystem`Private`noMessage]], 
       AtomicDensityMatrix`AtomicSystemType[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`noMessage = True, 
          AtomicDensityMatrix`AtomicSystem`Private`result}, 
         AtomicDensityMatrix`AtomicSystem`Private`result = Check[
            
            With[{AtomicDensityMatrix`AtomicSystem`Private`types = 
              Map[AtomicDensityMatrix`AtomicSystemType, 
                AtomicDensityMatrix`AtomicSystem`Private`sys]}, 
             If[
              MatchQ[
               Hold[AtomicDensityMatrix`AtomicSystem`Private`types], 
               Hold[{
                 Repeated[
                  Blank[String]]}]], 
              If[
               MatchQ[AtomicDensityMatrix`AtomicSystem`Private`types, {
                 Repeated[
                  First[AtomicDensityMatrix`AtomicSystem`Private`types]]}], 
               First[AtomicDensityMatrix`AtomicSystem`Private`types], 
               Message[
                MessageName[
                AtomicDensityMatrix`AtomicSystemType, "difftypes"], 
                First[AtomicDensityMatrix`AtomicSystem`Private`types]]]]], 
            AtomicDensityMatrix`AtomicSystem`Private`noMessage = False]; 
         Condition[
          AtomicDensityMatrix`AtomicSystemType[
            AtomicDensityMatrix`AtomicSystem`Private`sys] = 
           AtomicDensityMatrix`AtomicSystem`Private`result, 
           AtomicDensityMatrix`AtomicSystem`Private`noMessage]], 
       TagSet[AtomicDensityMatrix`AtomicSystemType, 
        MessageName[AtomicDensityMatrix`AtomicSystemType, "difftypes"], 
        "All atomic states in the system are not of the same type, `1`, as \
the first state."], 
       TagSet[AtomicDensityMatrix`AtomicSystemType, 
        MessageName[AtomicDensityMatrix`AtomicSystemType, "unrec"], 
        "The type of the atomic state `1` is not recognized."], 
       TagSet[AtomicDensityMatrix`AtomicSystemType, 
        MessageName[AtomicDensityMatrix`AtomicSystemType, "usage"], 
        "\!\(\*TagBox[RowBox[{\"AtomicSystemType[\", StyleBox[\"sys\", \
\"TI\"], \"] determines the type of atomic system \", StyleBox[\"sys\", \
\"TI\"], \".\"}], DisplayForm]\)"], 
       AtomicDensityMatrix`AtomicSystem`Private`ValidQuantumNumberQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`j, 
          Blank[]]] := And[
         AtomicDensityMatrix`DefinedQ[
         AtomicDensityMatrix`AtomicSystem`Private`s, 
          AtomicDensityMatrix`AtomicSystem`Private`j], 
         AtomicDensityMatrix`HalfIntegerQ[
          AtomicDensityMatrix`AtomicSystem`Private`j[
          AtomicDensityMatrix`AtomicSystem`Private`s]]], 
       AtomicDensityMatrix`AddParameter[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`rules, 
          Alternatives[{
            Repeated[
            Alternatives[
              AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
               AtomicDensityMatrix`J, AtomicDensityMatrix`NuclearSpin, 
               AtomicDensityMatrix`F, AtomicDensityMatrix`M, 
               AtomicDensityMatrix`Parity, AtomicDensityMatrix`Energy, 
               AtomicDensityMatrix`NaturalWidth, AtomicDensityMatrix`GFactor, 
               
               AtomicDensityMatrix`BranchingRatio[
                Blank[]], AtomicDensityMatrix`LevelPosition, 
               AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
               AtomicDensityMatrix`Polarizability[
                Blank[]], 
               AtomicDensityMatrix`TransitionPolarizability[
                Blank[]]] -> Blank[]]}, 
           Repeated[
           Alternatives[
             AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
              AtomicDensityMatrix`J, AtomicDensityMatrix`NuclearSpin, 
              AtomicDensityMatrix`F, AtomicDensityMatrix`M, 
              AtomicDensityMatrix`Parity, AtomicDensityMatrix`Energy, 
              AtomicDensityMatrix`NaturalWidth, AtomicDensityMatrix`GFactor, 
              AtomicDensityMatrix`BranchingRatio[
               Blank[]], AtomicDensityMatrix`LevelPosition, 
              AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
              
              AtomicDensityMatrix`Polarizability[
               Blank[]], 
              AtomicDensityMatrix`TransitionPolarizability[
               Blank[]]] -> Blank[]]]]] := Join[
         AtomicDensityMatrix`DeleteParameter[
         AtomicDensityMatrix`AtomicSystem`Private`state, 
          Part[
           Flatten[{AtomicDensityMatrix`AtomicSystem`Private`rules}], All, 
           1]], 
         Apply[AtomicDensityMatrix`AtomicState, 
          Flatten[{AtomicDensityMatrix`AtomicSystem`Private`rules}]]], 
       AtomicDensityMatrix`AddParameter[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`rules, 
          Alternatives[{
            Repeated[
            Alternatives[
              AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
               AtomicDensityMatrix`J, AtomicDensityMatrix`NuclearSpin, 
               AtomicDensityMatrix`F, AtomicDensityMatrix`M, 
               AtomicDensityMatrix`Parity, AtomicDensityMatrix`Energy, 
               AtomicDensityMatrix`NaturalWidth, AtomicDensityMatrix`GFactor, 
               
               AtomicDensityMatrix`BranchingRatio[
                Blank[]], AtomicDensityMatrix`LevelPosition, 
               AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
               AtomicDensityMatrix`Polarizability[
                Blank[]], 
               AtomicDensityMatrix`TransitionPolarizability[
                Blank[]]] -> Blank[]]}, 
           Repeated[
           Alternatives[
             AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
              AtomicDensityMatrix`J, AtomicDensityMatrix`NuclearSpin, 
              AtomicDensityMatrix`F, AtomicDensityMatrix`M, 
              AtomicDensityMatrix`Parity, AtomicDensityMatrix`Energy, 
              AtomicDensityMatrix`NaturalWidth, AtomicDensityMatrix`GFactor, 
              AtomicDensityMatrix`BranchingRatio[
               Blank[]], AtomicDensityMatrix`LevelPosition, 
              AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
              
              AtomicDensityMatrix`Polarizability[
               Blank[]], 
              AtomicDensityMatrix`TransitionPolarizability[
               Blank[]]] -> Blank[]]]]] := Thread[
         Unevaluated[
          AtomicDensityMatrix`AddParameter[
          AtomicDensityMatrix`AtomicSystem`Private`sys, 
           AtomicDensityMatrix`AtomicSystem`Private`rules]], List, 1], 
       AtomicDensityMatrix`AddParameter[
         Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          Blank[AtomicDensityMatrix`ExperimentalRegion]], 
         Pattern[
         AtomicDensityMatrix`ExperimentalSystem`Private`r, 
          Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`x, 
            Alternatives[
            AtomicDensityMatrix`OpticalParameters, 
             AtomicDensityMatrix`ElectricField, 
             AtomicDensityMatrix`MagneticField, 
             AtomicDensityMatrix`TransitRate[
              Blank[]], AtomicDensityMatrix`Density, 
             AtomicDensityMatrix`VelocityGroupRecoilMomentum[
              Blank[]], AtomicDensityMatrix`SDampingRate]] -> 
          Pattern[AtomicDensityMatrix`ExperimentalSystem`Private`value, 
            Blank[]]]] := 
       AtomicDensityMatrix`ExperimentalSystem`Private`MapOnParameters[
        Append[#, AtomicDensityMatrix`ExperimentalSystem`Private`r]& , 
         AtomicDensityMatrix`DeleteParameter[
         AtomicDensityMatrix`ExperimentalSystem`Private`region, 
          AtomicDensityMatrix`ExperimentalSystem`Private`x]], 
       TagSet[AtomicDensityMatrix`AddParameter, 
        MessageName[AtomicDensityMatrix`AddParameter, "usage"], 
        "AddParameter[\!\(\*\nStyleBox[\"state\", \"TI\"]\),\!\(\*\nStyleBox[\
\"param\", \"TI\"]\)->\!\(\*\nStyleBox[\"value\", \"TI\"]\)] adds the \
supplied parameter specification to AtomicState \!\(\*\nStyleBox[\"state\", \
\"TI\"]\), or replaces the existing specification.\nAddParameter behaves \
analogously with region parameters and regions in place of state parameters \
and states."], 
       TagSet[AtomicDensityMatrix`NeglectedCouplings, 
        MessageName[AtomicDensityMatrix`NeglectedCouplings, "usage"], ""], 
       AtomicDensityMatrix`MatrixElementMask[
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`allowedCouplings, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings, 
          Blank[]]] := Boole[
          AtomicDensityMatrix`TransitionQ[
          AtomicDensityMatrix`WignerEckart`Private`sys1, 
           AtomicDensityMatrix`WignerEckart`Private`sys2, 
           AtomicDensityMatrix`WignerEckart`Private`allowedCouplings]] (1 - 
         Boole[
          AtomicDensityMatrix`TransitionQ[
          AtomicDensityMatrix`WignerEckart`Private`sys1, 
           AtomicDensityMatrix`WignerEckart`Private`sys2, 
           AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings]]), 
       TagSet[AtomicDensityMatrix`MatrixElementMask, 
        MessageName[AtomicDensityMatrix`MatrixElementMask, "usage"], ""], 
       AtomicDensityMatrix`TransitionQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]]] := Or[
         AtomicDensityMatrix`DirectedTransitionQ[
         AtomicDensityMatrix`AtomicSystem`Private`state1, 
          AtomicDensityMatrix`AtomicSystem`Private`state2, 
          AtomicDensityMatrix`AtomicSystem`Private`crit], 
         AtomicDensityMatrix`DirectedTransitionQ[
         AtomicDensityMatrix`AtomicSystem`Private`state2, 
          AtomicDensityMatrix`AtomicSystem`Private`state1, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]], 
       AtomicDensityMatrix`TransitionQ[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`matrix = 
          AtomicDensityMatrix`DirectedTransitionQ[
           AtomicDensityMatrix`AtomicSystem`Private`sys1, 
            AtomicDensityMatrix`AtomicSystem`Private`sys2, 
            AtomicDensityMatrix`AtomicSystem`Private`crit]}, 
         MapThread[Or, {AtomicDensityMatrix`AtomicSystem`Private`matrix, 
           Transpose[AtomicDensityMatrix`AtomicSystem`Private`matrix]}, 2]], 
       AtomicDensityMatrix`TransitionQ[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]]] := 
       AtomicDensityMatrix`TransitionQ[
        AtomicDensityMatrix`AtomicSystem`Private`sys, 
         AtomicDensityMatrix`AtomicSystem`Private`sys, 
         AtomicDensityMatrix`AtomicSystem`Private`crit], 
       TagSet[AtomicDensityMatrix`TransitionQ, 
        MessageName[AtomicDensityMatrix`TransitionQ, "usage"], ""], 
       AtomicDensityMatrix`DirectedTransitionQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[List]]] := Apply[Or, 
         Map[
         AtomicDensityMatrix`DirectedTransitionQ[
          AtomicDensityMatrix`AtomicSystem`Private`state1, 
           AtomicDensityMatrix`AtomicSystem`Private`state2, #]& , 
          AtomicDensityMatrix`AtomicSystem`Private`crit]], 
       AtomicDensityMatrix`DirectedTransitionQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit1, 
           Blank[]] -> Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit2, 
           Blank[]]] := And[
         AtomicDensityMatrix`StateMatchQ[
         AtomicDensityMatrix`AtomicSystem`Private`state1, 
          AtomicDensityMatrix`AtomicSystem`Private`crit1], 
         AtomicDensityMatrix`StateMatchQ[
         AtomicDensityMatrix`AtomicSystem`Private`state2, 
          AtomicDensityMatrix`AtomicSystem`Private`crit2]], 
       AtomicDensityMatrix`DirectedTransitionQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]]] := TrueQ[
         ReplaceAll[
          ReplaceAll[
           AtomicDensityMatrix`TransitionEvaluate[
           AtomicDensityMatrix`AtomicSystem`Private`state1, 
            AtomicDensityMatrix`AtomicSystem`Private`state2, 
            ReplaceAll[
            AtomicDensityMatrix`AtomicSystem`Private`crit, 
             Pattern[AtomicDensityMatrix`AtomicSystem`Private`transition, 
               Blank[Rule]] :> 
             AtomicDensityMatrix`DirectedTransitionQ[
              AtomicDensityMatrix`AtomicSystem`Private`state1, 
               AtomicDensityMatrix`AtomicSystem`Private`state2, 
               AtomicDensityMatrix`AtomicSystem`Private`transition]]], {
           All -> True, None -> False}], {
          Equal -> SameQ, Unequal -> UnsameQ}]], 
       AtomicDensityMatrix`DirectedTransitionQ[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]]] := 
       AtomicDensityMatrix`DirectProduct[
        AtomicDensityMatrix`DirectedTransitionQ[#, #2, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]& , 
         AtomicDensityMatrix`AtomicSystem`Private`sys1, 
         AtomicDensityMatrix`AtomicSystem`Private`sys2], 
       AtomicDensityMatrix`DirectedTransitionQ[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]]] := 
       AtomicDensityMatrix`DirectedTransitionQ[
        AtomicDensityMatrix`AtomicSystem`Private`sys, 
         AtomicDensityMatrix`AtomicSystem`Private`sys, 
         AtomicDensityMatrix`AtomicSystem`Private`crit], 
       TagSet[AtomicDensityMatrix`DirectedTransitionQ, 
        MessageName[AtomicDensityMatrix`DirectedTransitionQ, "usage"], ""], 
       AtomicDensityMatrix`StateMatchQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit1, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit2, 
          BlankSequence[]]] := Apply[Or, 
         Map[
         AtomicDensityMatrix`StateMatchQ[
          AtomicDensityMatrix`AtomicSystem`Private`state, #]& , {
          AtomicDensityMatrix`AtomicSystem`Private`crit1, 
           AtomicDensityMatrix`AtomicSystem`Private`crit2}]], Condition[
         AtomicDensityMatrix`StateMatchQ[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
           Blank[AtomicDensityMatrix`AtomicState]], 
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
           Blank[]]], 
         AtomicDensityMatrix`StateLabelQ[
         AtomicDensityMatrix`AtomicSystem`Private`state, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]] := True, 
       AtomicDensityMatrix`StateMatchQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]]] := TrueQ[
         ReplaceAll[
          ReplaceAll[
           ReplaceAll[
            AtomicDensityMatrix`StateEvaluate[
            AtomicDensityMatrix`AtomicSystem`Private`state, 
             AtomicDensityMatrix`AtomicSystem`Private`crit], {
            All -> True, None -> False}], {
           Equal -> SameQ, Unequal -> UnsameQ}], 
          AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`AtomicSystem`Private`state] -> True]], 
       AtomicDensityMatrix`StateMatchQ[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          BlankSequence[]]] := 
       Map[AtomicDensityMatrix`StateMatchQ[#, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]& , 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`StateMatchQ, 
        MessageName[AtomicDensityMatrix`StateMatchQ, "usage"], ""], 
       AtomicDensityMatrix`StateLabelQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := MatchQ[
         AtomicDensityMatrix`StateLabel[
         AtomicDensityMatrix`AtomicSystem`Private`state], 
         AtomicDensityMatrix`AtomicSystem`Private`expr], 
       AtomicDensityMatrix`StateLabelQ[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := MemberQ[
         AtomicDensityMatrix`StateLabel[
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
         AtomicDensityMatrix`AtomicSystem`Private`expr], 
       TagSet[AtomicDensityMatrix`StateLabelQ, 
        MessageName[AtomicDensityMatrix`StateLabelQ, "usage"], ""], 
       AtomicDensityMatrix`StateEvaluate[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       AtomicDensityMatrix`StateEvaluate[
        AtomicDensityMatrix`AtomicSystem`Private`s, 
         AtomicDensityMatrix`AtomicSystem`Private`expr], 
       AtomicDensityMatrix`StateEvaluate[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`AtomicSystem`Private`expr, 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`param, 
           AtomicDensityMatrix`AtomicSystem`Private`StateQuantityPattern[]] :> 
         AtomicDensityMatrix`AtomicSystem`Private`param[
          AtomicDensityMatrix`AtomicSystem`Private`state]], 
       AtomicDensityMatrix`StateEvaluate[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       Map[AtomicDensityMatrix`StateEvaluate[#, 
          AtomicDensityMatrix`AtomicSystem`Private`expr]& , 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       TagSet[AtomicDensityMatrix`StateEvaluate, 
        MessageName[AtomicDensityMatrix`StateEvaluate, "usage"], ""], 
       AtomicDensityMatrix`AtomicSystem`Private`StateQuantityPattern[] = 
       Alternatives[
         Alternatives[
         AtomicDensityMatrix`S, AtomicDensityMatrix`L, AtomicDensityMatrix`J, 
          AtomicDensityMatrix`NuclearSpin, AtomicDensityMatrix`F, 
          AtomicDensityMatrix`M, AtomicDensityMatrix`Parity, 
          AtomicDensityMatrix`Energy, AtomicDensityMatrix`NaturalWidth, 
          AtomicDensityMatrix`GFactor, 
          AtomicDensityMatrix`BranchingRatio[
           Blank[]], AtomicDensityMatrix`LevelPosition, 
          AtomicDensityMatrix`HyperfineA, AtomicDensityMatrix`HyperfineB, 
          AtomicDensityMatrix`Polarizability[
           Blank[]], 
          AtomicDensityMatrix`TransitionPolarizability[
           Blank[]]], AtomicDensityMatrix`StateLabel, 
         AtomicDensityMatrix`GroundStateQ], 
       Attributes[AtomicDensityMatrix`GroundStateQ] = {Listable}, 
       AtomicDensityMatrix`GroundStateQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`AtomicSystem`Private`state] === 0, 
       TagSet[AtomicDensityMatrix`GroundStateQ, 
        MessageName[AtomicDensityMatrix`GroundStateQ, "usage"], 
        "GroundStateQ[\!\(\*\nStyleBox[\"state\", \"TI\"]\)] returns True if \
NaturalWidth[\!\(\*\nStyleBox[\"state\", \"TI\"]\)] is zero, and False \
otherwise."], AtomicDensityMatrix`TransitionEvaluate[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       AtomicDensityMatrix`StateEvaluate[
        AtomicDensityMatrix`AtomicSystem`Private`state1][
         AtomicDensityMatrix`AtomicSystem`Private`StateEvaluatePrimed[
         AtomicDensityMatrix`AtomicSystem`Private`state2][
          ReplaceAll[
          AtomicDensityMatrix`AtomicSystem`Private`expr, (
            Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr1, 
              Blank[]] -> 
            Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr2, 
              Blank[]]) :> (
            AtomicDensityMatrix`StateEvaluate[
             AtomicDensityMatrix`AtomicSystem`Private`state1, 
              AtomicDensityMatrix`AtomicSystem`Private`expr1] -> 
            AtomicDensityMatrix`StateEvaluate[
             AtomicDensityMatrix`AtomicSystem`Private`state2, 
              AtomicDensityMatrix`AtomicSystem`Private`expr2])]]], 
       AtomicDensityMatrix`TransitionEvaluate[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       AtomicDensityMatrix`DirectProduct[
        AtomicDensityMatrix`TransitionEvaluate[#, #2, 
          AtomicDensityMatrix`AtomicSystem`Private`expr]& , 
         AtomicDensityMatrix`AtomicSystem`Private`sys1, 
         AtomicDensityMatrix`AtomicSystem`Private`sys2], 
       AtomicDensityMatrix`TransitionEvaluate[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       AtomicDensityMatrix`TransitionEvaluate[
        AtomicDensityMatrix`AtomicSystem`Private`sys, 
         AtomicDensityMatrix`AtomicSystem`Private`sys, 
         AtomicDensityMatrix`AtomicSystem`Private`expr], 
       TagSet[AtomicDensityMatrix`TransitionEvaluate, 
        MessageName[AtomicDensityMatrix`TransitionEvaluate, "usage"], ""], 
       AtomicDensityMatrix`AtomicSystem`Private`StateEvaluatePrimed[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       AtomicDensityMatrix`AtomicSystem`Private`StateEvaluatePrimed[
        AtomicDensityMatrix`AtomicSystem`Private`s, 
         AtomicDensityMatrix`AtomicSystem`Private`expr], 
       AtomicDensityMatrix`AtomicSystem`Private`StateEvaluatePrimed[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       ReplaceAll[AtomicDensityMatrix`AtomicSystem`Private`expr, Derivative[1][
           Pattern[AtomicDensityMatrix`AtomicSystem`Private`param, 
            AtomicDensityMatrix`AtomicSystem`Private`StateQuantityPattern[]]] :> 
         AtomicDensityMatrix`AtomicSystem`Private`param[
          AtomicDensityMatrix`AtomicSystem`Private`state]], 
       AtomicDensityMatrix`AtomicSystem`Private`StateEvaluatePrimed[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`expr, 
          Blank[]]] := 
       Map[AtomicDensityMatrix`AtomicSystem`Private`StateEvaluatePrimed[#, 
          AtomicDensityMatrix`AtomicSystem`Private`expr]& , 
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
       Attributes[Derivative] = {NHoldAll, ReadProtected}, 
       AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0], {
         AtomicDensityMatrix`Dipole, 1}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0]] = 0,
        AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1], {AtomicDensityMatrix`Dipole, 1}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = 0, AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1], {AtomicDensityMatrix`Dipole, 1}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = 0, AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1], {AtomicDensityMatrix`MagneticMoment, 1}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = Sqrt[3/2] Units`BohrMagneton, AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1], {AtomicDensityMatrix`MagneticMoment, 1}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = Sqrt[15/2] Units`BohrMagneton, AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1], {AtomicDensityMatrix`Zero, 0}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = 0, AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1], {AtomicDensityMatrix`Zero, 0}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = 0, AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2], {AtomicDensityMatrix`Dipole, 1}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = 0, AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2], {AtomicDensityMatrix`Dipole, 1}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = 0, AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2], {AtomicDensityMatrix`MagneticMoment, 1}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = -(Sqrt[15/2] Units`BohrMagneton), 
       AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2], {AtomicDensityMatrix`MagneticMoment, 1}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = -(Sqrt[15/2] Units`BohrMagneton), 
       AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2], {AtomicDensityMatrix`Zero, 0}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = 0, AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2], {AtomicDensityMatrix`Zero, 0}, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = 0, AtomicDensityMatrix`ReducedME[
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
          Pattern[AtomicDensityMatrix`WignerEckart`Private`op, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[]]}] := 
       AtomicDensityMatrix`ReducedME[
        AtomicDensityMatrix`WignerEckart`Private`sys, {
         AtomicDensityMatrix`WignerEckart`Private`op, 
          AtomicDensityMatrix`WignerEckart`Private`k}, 
         AtomicDensityMatrix`WignerEckart`Private`sys], 
       AtomicDensityMatrix`ReducedME[
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
          Pattern[AtomicDensityMatrix`WignerEckart`Private`op, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[]]}, 
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       ArrayFlatten[AtomicDensityMatrix`DirectProduct[ConstantArray[1, {
             SlotSequence[1]}]& , 
           AtomicDensityMatrix`CountZeemanSublevels[
           AtomicDensityMatrix`WignerEckart`Private`sys1], 
           AtomicDensityMatrix`CountZeemanSublevels[
           AtomicDensityMatrix`WignerEckart`Private`sys2]] 
         AtomicDensityMatrix`DirectProduct[
          AtomicDensityMatrix`ReducedME[#, {
            AtomicDensityMatrix`WignerEckart`Private`op, 
             AtomicDensityMatrix`WignerEckart`Private`k}, #2]& , 
           AtomicDensityMatrix`RemoveZeemanSublevels[
           AtomicDensityMatrix`WignerEckart`Private`sys1], 
           AtomicDensityMatrix`RemoveZeemanSublevels[
           AtomicDensityMatrix`WignerEckart`Private`sys2]]], 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
         AtomicDensityMatrix`Polarization, 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[Integer]]}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Boole[AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`WignerEckart`Private`s1] === 
          AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`WignerEckart`Private`s2]] 
        Sqrt[2 AtomicDensityMatrix`WignerEckart`Private`k + 1], 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
          AtomicDensityMatrix`Polarization[{
            Pattern[AtomicDensityMatrix`WignerEckart`Private`s1p, 
             Blank[]], 
            PatternTest[
             Pattern[AtomicDensityMatrix`WignerEckart`Private`f1, 
              Blank[]], NumericQ]}, {
            Pattern[AtomicDensityMatrix`WignerEckart`Private`s2p, 
             Blank[]], 
            PatternTest[
             Pattern[AtomicDensityMatrix`WignerEckart`Private`f2, 
              Blank[]], NumericQ]}], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[Integer]]}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := Boole[{
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`WignerEckart`Private`s1], 
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`WignerEckart`Private`s2], 
            AtomicDensityMatrix`F[
            AtomicDensityMatrix`WignerEckart`Private`s1], 
            AtomicDensityMatrix`F[
            AtomicDensityMatrix`WignerEckart`Private`s2]} === {
           AtomicDensityMatrix`WignerEckart`Private`s1p, 
            AtomicDensityMatrix`WignerEckart`Private`s2p, 
            AtomicDensityMatrix`WignerEckart`Private`f1, 
            AtomicDensityMatrix`WignerEckart`Private`f2}] 
        Sqrt[2 AtomicDensityMatrix`WignerEckart`Private`k + 1], 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
          AtomicDensityMatrix`Polarization[
           Pattern[AtomicDensityMatrix`WignerEckart`Private`s1p, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`WignerEckart`Private`s2p, 
            Blank[]]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[Integer]]}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := Boole[{
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`WignerEckart`Private`s1], 
            AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`WignerEckart`Private`s2]} === {
           AtomicDensityMatrix`WignerEckart`Private`s1p, 
            AtomicDensityMatrix`WignerEckart`Private`s2p}] 
        Sqrt[2 AtomicDensityMatrix`WignerEckart`Private`k + 1], Condition[
         AtomicDensityMatrix`ReducedME[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
           Blank[AtomicDensityMatrix`AtomicState]], {
          AtomicDensityMatrix`StatisticalWeight, 0}, 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
           Blank[AtomicDensityMatrix`AtomicState]]], 
         AtomicDensityMatrix`HyperfineTypeSystem[
         AtomicDensityMatrix`WignerEckart`Private`s1, 
          AtomicDensityMatrix`WignerEckart`Private`s2]] := 
       Module[{AtomicDensityMatrix`WignerEckart`Private`j1, 
          AtomicDensityMatrix`WignerEckart`Private`i1, 
          AtomicDensityMatrix`WignerEckart`Private`f1, 
          AtomicDensityMatrix`WignerEckart`Private`j2, 
          AtomicDensityMatrix`WignerEckart`Private`i2, 
          AtomicDensityMatrix`WignerEckart`Private`f2, 
          AtomicDensityMatrix`WignerEckart`Private`sJ1, 
          AtomicDensityMatrix`WignerEckart`Private`sJ2}, {{
            AtomicDensityMatrix`WignerEckart`Private`i1, 
             AtomicDensityMatrix`WignerEckart`Private`j1, 
             AtomicDensityMatrix`WignerEckart`Private`f1}, {
            AtomicDensityMatrix`WignerEckart`Private`i2, 
             AtomicDensityMatrix`WignerEckart`Private`j2, 
             AtomicDensityMatrix`WignerEckart`Private`f2}} = Map[Through, 
            
            Map[{AtomicDensityMatrix`NuclearSpin, AtomicDensityMatrix`J, 
              AtomicDensityMatrix`F}, {
             AtomicDensityMatrix`WignerEckart`Private`s1, 
              AtomicDensityMatrix`WignerEckart`Private`s2}]]; {
           AtomicDensityMatrix`WignerEckart`Private`sJ1, 
            AtomicDensityMatrix`WignerEckart`Private`sJ2} = 
          AtomicDensityMatrix`DeleteParameter[{
            AtomicDensityMatrix`WignerEckart`Private`s1, 
             AtomicDensityMatrix`WignerEckart`Private`s2}, 
            AtomicDensityMatrix`F, 
            AtomicDensityMatrix`NuclearSpin]; ((-1)^(
             AtomicDensityMatrix`WignerEckart`Private`j1 + 
             AtomicDensityMatrix`WignerEckart`Private`i1 + 
             AtomicDensityMatrix`WignerEckart`Private`f2) 
           Sqrt[(2 AtomicDensityMatrix`WignerEckart`Private`f1 + 1) (
              2 AtomicDensityMatrix`WignerEckart`Private`f2 + 1)] 
           AtomicDensityMatrix`SJS[{
             AtomicDensityMatrix`WignerEckart`Private`j1, 
              AtomicDensityMatrix`WignerEckart`Private`f1, 
              AtomicDensityMatrix`WignerEckart`Private`i1}, {
             AtomicDensityMatrix`WignerEckart`Private`f2, 
              AtomicDensityMatrix`WignerEckart`Private`j2, 0}] 
           AtomicDensityMatrix`ReducedME[
            AtomicDensityMatrix`WignerEckart`Private`sJ1, {
             AtomicDensityMatrix`StatisticalWeight, 0}, 
             AtomicDensityMatrix`WignerEckart`Private`sJ2])/(
          2 AtomicDensityMatrix`WignerEckart`Private`i1 + 1)], Condition[
         AtomicDensityMatrix`ReducedME[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
           Blank[AtomicDensityMatrix`AtomicState]], {
          AtomicDensityMatrix`Energy, 0}, 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
           Blank[AtomicDensityMatrix`AtomicState]]], 
         AtomicDensityMatrix`HyperfineTypeSystem[
         AtomicDensityMatrix`WignerEckart`Private`s1, 
          AtomicDensityMatrix`WignerEckart`Private`s2]] := 
       Module[{AtomicDensityMatrix`WignerEckart`Private`sJ1, 
          AtomicDensityMatrix`WignerEckart`Private`sJ2}, {
           AtomicDensityMatrix`WignerEckart`Private`sJ1, 
            AtomicDensityMatrix`WignerEckart`Private`sJ2} = 
          AtomicDensityMatrix`DeleteParameter[{
            AtomicDensityMatrix`WignerEckart`Private`s1, 
             AtomicDensityMatrix`WignerEckart`Private`s2}, 
            AtomicDensityMatrix`F, AtomicDensityMatrix`NuclearSpin]; 
         AtomicDensityMatrix`hyperfineRMEFactor[
           AtomicDensityMatrix`WignerEckart`Private`s1, 0, 
            AtomicDensityMatrix`WignerEckart`Private`s2] (
           AtomicDensityMatrix`ReducedME[
            AtomicDensityMatrix`WignerEckart`Private`sJ1, {
             AtomicDensityMatrix`Energy, 0}, 
             AtomicDensityMatrix`WignerEckart`Private`sJ2] + 
           AtomicDensityMatrix`HyperfineShift[
             AtomicDensityMatrix`WignerEckart`Private`s1] 
            AtomicDensityMatrix`ReducedME[
             AtomicDensityMatrix`WignerEckart`Private`sJ1, {Identity, 0}, 
              AtomicDensityMatrix`WignerEckart`Private`sJ2])], Condition[
         AtomicDensityMatrix`ReducedME[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
           Blank[AtomicDensityMatrix`AtomicState]], {
           Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
            Blank[Integer]]}, 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
           Blank[AtomicDensityMatrix`AtomicState]]], 
         AtomicDensityMatrix`HyperfineTypeSystem[
         AtomicDensityMatrix`WignerEckart`Private`s1, 
          AtomicDensityMatrix`WignerEckart`Private`s2]] := (
        AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`WignerEckart`Private`s1, {
          AtomicDensityMatrix`WignerEckart`Private`a, 
           AtomicDensityMatrix`WignerEckart`Private`k}, 
          AtomicDensityMatrix`WignerEckart`Private`s2] = 
        AtomicDensityMatrix`hyperfineRMEFactor[
          AtomicDensityMatrix`WignerEckart`Private`s1, 
           AtomicDensityMatrix`WignerEckart`Private`k, 
           AtomicDensityMatrix`WignerEckart`Private`s2] 
         AtomicDensityMatrix`ReducedME[
           AtomicDensityMatrix`DeleteParameter[
           AtomicDensityMatrix`WignerEckart`Private`s1, AtomicDensityMatrix`F,
             AtomicDensityMatrix`NuclearSpin], {
           AtomicDensityMatrix`WignerEckart`Private`a, 
            AtomicDensityMatrix`WignerEckart`Private`k}, 
           AtomicDensityMatrix`DeleteParameter[
           AtomicDensityMatrix`WignerEckart`Private`s2, AtomicDensityMatrix`F,
             AtomicDensityMatrix`NuclearSpin]]), AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
         AtomicDensityMatrix`Zero, 0}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] = 0, 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {Identity, 0}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Boole[AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`WignerEckart`Private`s1] === 
          AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`WignerEckart`Private`s2]] 
        Sqrt[2 AtomicDensityMatrix`J[
            AtomicDensityMatrix`WignerEckart`Private`s1] + 1], 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
         AtomicDensityMatrix`GroundState, 0}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := Boole[
          AtomicDensityMatrix`GroundStateQ[
          AtomicDensityMatrix`WignerEckart`Private`s1]] 
        AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`WignerEckart`Private`s1, {Identity, 0}, 
          AtomicDensityMatrix`WignerEckart`Private`s2], 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
         AtomicDensityMatrix`ExcitedState, 0}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := Boole[
          Not[
           AtomicDensityMatrix`GroundStateQ[
           AtomicDensityMatrix`WignerEckart`Private`s1]]] 
        AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`WignerEckart`Private`s1, {Identity, 0}, 
          AtomicDensityMatrix`WignerEckart`Private`s2], 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
         AtomicDensityMatrix`NaturalWidth, 0}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       AtomicDensityMatrix`NaturalWidth[
         AtomicDensityMatrix`WignerEckart`Private`s1] 
        AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`WignerEckart`Private`s1, {Identity, 0}, 
          AtomicDensityMatrix`WignerEckart`Private`s2], 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
         AtomicDensityMatrix`StatisticalWeight, 0}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (1 
         AtomicDensityMatrix`ReducedME[
          AtomicDensityMatrix`WignerEckart`Private`s1, {Identity, 0}, 
           AtomicDensityMatrix`WignerEckart`Private`s2])/(
        2 AtomicDensityMatrix`J[AtomicDensityMatrix`WignerEckart`Private`s1] + 
        1), AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
         AtomicDensityMatrix`Energy, 0}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       AtomicDensityMatrix`Energy[AtomicDensityMatrix`WignerEckart`Private`s1]
          AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`WignerEckart`Private`s1, {Identity, 0}, 
          AtomicDensityMatrix`WignerEckart`Private`s2], Condition[
         AtomicDensityMatrix`ReducedME[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
           Blank[AtomicDensityMatrix`AtomicState]], {
          AtomicDensityMatrix`Dipole, 1}, 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
           Blank[AtomicDensityMatrix`AtomicState]]], 
         Or[
         AtomicDensityMatrix`Parity[
           AtomicDensityMatrix`WignerEckart`Private`s1] === 
          AtomicDensityMatrix`Parity[
           AtomicDensityMatrix`WignerEckart`Private`s2], 
          AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`WignerEckart`Private`s1] === 
          AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`WignerEckart`Private`s2]]] := (
        AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`WignerEckart`Private`s1, {
          AtomicDensityMatrix`Dipole, 1}, 
          AtomicDensityMatrix`WignerEckart`Private`s2] = 0), 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
         AtomicDensityMatrix`Dipole, 1}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`WignerEckart`Private`s1, {
          AtomicDensityMatrix`Dipole, 1}, 
          AtomicDensityMatrix`WignerEckart`Private`s2] = 
        With[{AtomicDensityMatrix`WignerEckart`Private`lab1 = 
           AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`WignerEckart`Private`s1], 
           AtomicDensityMatrix`WignerEckart`Private`lab2 = 
           AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`WignerEckart`Private`s2]}, 
          If[
           
           OrderedQ[{
            AtomicDensityMatrix`WignerEckart`Private`lab1, 
             AtomicDensityMatrix`WignerEckart`Private`lab2}], 
           AtomicDensityMatrix`ReducedME[
           AtomicDensityMatrix`WignerEckart`Private`lab1, {
            AtomicDensityMatrix`Dipole, 1}, 
            AtomicDensityMatrix`WignerEckart`Private`lab2], If[
             MatchQ[
              AtomicDensityMatrix`AtomicSystemType[
              AtomicDensityMatrix`WignerEckart`Private`s1], 
              Alternatives["Fine", "Zeeman"]], (-1)^(
              AtomicDensityMatrix`J[
               AtomicDensityMatrix`WignerEckart`Private`s1] - 
              AtomicDensityMatrix`J[
              AtomicDensityMatrix`WignerEckart`Private`s2]), 1] 
           AtomicDensityMatrix`ReducedME[
            AtomicDensityMatrix`WignerEckart`Private`lab2, {
             AtomicDensityMatrix`Dipole, 1}, 
             AtomicDensityMatrix`WignerEckart`Private`lab1]]]), Condition[
         AtomicDensityMatrix`ReducedME[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
           Blank[AtomicDensityMatrix`AtomicState]], {"NormalizedDipole", 1}, 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
           Blank[AtomicDensityMatrix`AtomicState]]], 
         Or[
         AtomicDensityMatrix`Parity[
           AtomicDensityMatrix`WignerEckart`Private`s1] === 
          AtomicDensityMatrix`Parity[
           AtomicDensityMatrix`WignerEckart`Private`s2], 
          AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`WignerEckart`Private`s1] === 
          AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`WignerEckart`Private`s2]]] := (
        AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`WignerEckart`Private`s1, {"NormalizedDipole", 1},
           AtomicDensityMatrix`WignerEckart`Private`s2] = 0), 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {"NormalizedDipole", 1}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := (
        AtomicDensityMatrix`ReducedME[
         AtomicDensityMatrix`WignerEckart`Private`s1, {"NormalizedDipole", 1},
           AtomicDensityMatrix`WignerEckart`Private`s2] = 
        With[{AtomicDensityMatrix`WignerEckart`Private`lab1 = 
           AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`WignerEckart`Private`s1], 
           AtomicDensityMatrix`WignerEckart`Private`lab2 = 
           AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`WignerEckart`Private`s2]}, 
          If[
           
           OrderedQ[{
            AtomicDensityMatrix`WignerEckart`Private`lab1, 
             AtomicDensityMatrix`WignerEckart`Private`lab2}], 1, 
           If[
            MatchQ[
             AtomicDensityMatrix`AtomicSystemType[
             AtomicDensityMatrix`WignerEckart`Private`s1], 
             Alternatives["Fine", "Zeeman"]], (-1)^(
             AtomicDensityMatrix`J[
              AtomicDensityMatrix`WignerEckart`Private`s1] - 
             AtomicDensityMatrix`J[
             AtomicDensityMatrix`WignerEckart`Private`s2]), 1]]]), 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {AtomicDensityMatrix`J, 1}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Sqrt[AtomicDensityMatrix`J[
           AtomicDensityMatrix`WignerEckart`Private`s1] (
           AtomicDensityMatrix`J[AtomicDensityMatrix`WignerEckart`Private`s1] + 
           1) (2 AtomicDensityMatrix`J[
             AtomicDensityMatrix`WignerEckart`Private`s1] + 1)] 
        Boole[AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`WignerEckart`Private`s1] === 
          AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`WignerEckart`Private`s2]], 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]], {AtomicDensityMatrix`S, 1}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`WignerEckart`Private`s1, 
          AtomicDensityMatrix`WignerEckart`Private`l1, 
          AtomicDensityMatrix`WignerEckart`Private`j1, 
          AtomicDensityMatrix`WignerEckart`Private`s2, 
          AtomicDensityMatrix`WignerEckart`Private`l2, 
          AtomicDensityMatrix`WignerEckart`Private`j2, 
          AtomicDensityMatrix`WignerEckart`Private`lab1, 
          AtomicDensityMatrix`WignerEckart`Private`lab2}, {{
            AtomicDensityMatrix`WignerEckart`Private`s1, 
             AtomicDensityMatrix`WignerEckart`Private`l1, 
             AtomicDensityMatrix`WignerEckart`Private`j1, 
             AtomicDensityMatrix`WignerEckart`Private`lab1}, {
            AtomicDensityMatrix`WignerEckart`Private`s2, 
             AtomicDensityMatrix`WignerEckart`Private`l2, 
             AtomicDensityMatrix`WignerEckart`Private`j2, 
             AtomicDensityMatrix`WignerEckart`Private`lab2}} = Map[Through, 
            
            Map[{AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
              AtomicDensityMatrix`J, AtomicDensityMatrix`StateLabel}, {
             AtomicDensityMatrix`WignerEckart`Private`state1, 
              AtomicDensityMatrix`WignerEckart`Private`state2}]]; 
         Which[AtomicDensityMatrix`WignerEckart`Private`lab1 === 
           AtomicDensityMatrix`WignerEckart`Private`lab2, 
           If[
           AtomicDensityMatrix`WignerEckart`Private`j1 < 1/2, 
            0, (Sqrt[
              AtomicDensityMatrix`WignerEckart`Private`j1 (
                AtomicDensityMatrix`WignerEckart`Private`j1 + 1) (
                2 AtomicDensityMatrix`WignerEckart`Private`j1 + 1)] (
              AtomicDensityMatrix`WignerEckart`Private`j1 (
                AtomicDensityMatrix`WignerEckart`Private`j1 + 1) + 
              AtomicDensityMatrix`WignerEckart`Private`s1 (
                AtomicDensityMatrix`WignerEckart`Private`s1 + 1) - 
              AtomicDensityMatrix`WignerEckart`Private`l1 (
               AtomicDensityMatrix`WignerEckart`Private`l1 + 1)))/(2 
            AtomicDensityMatrix`WignerEckart`Private`j1 (
             AtomicDensityMatrix`WignerEckart`Private`j1 + 1))], 
           AtomicDensityMatrix`FineStructureStatesQ[
           AtomicDensityMatrix`WignerEckart`Private`state1, 
            AtomicDensityMatrix`WignerEckart`Private`state2], 
           If[
            
            AtomicDensityMatrix`DefinedQ[{
             AtomicDensityMatrix`WignerEckart`Private`state1, 
              AtomicDensityMatrix`WignerEckart`Private`state2}, {
             AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
              AtomicDensityMatrix`J}], 
            If[
             Or[
             AtomicDensityMatrix`WignerEckart`Private`s1 =!= 
              AtomicDensityMatrix`WignerEckart`Private`s2, 
              AtomicDensityMatrix`WignerEckart`Private`l1 =!= 
              AtomicDensityMatrix`WignerEckart`Private`l2], 
             0, (-1)^(AtomicDensityMatrix`WignerEckart`Private`s1 + 
               AtomicDensityMatrix`WignerEckart`Private`l1 + 
               AtomicDensityMatrix`WignerEckart`Private`j2 + 1) 
             Sqrt[AtomicDensityMatrix`WignerEckart`Private`s1 (
                AtomicDensityMatrix`WignerEckart`Private`s1 + 1) (
                2 AtomicDensityMatrix`WignerEckart`Private`s1 + 1) (
                2 AtomicDensityMatrix`WignerEckart`Private`j1 + 1) (
                2 AtomicDensityMatrix`WignerEckart`Private`j2 + 1)] 
             AtomicDensityMatrix`SJS[{
               AtomicDensityMatrix`WignerEckart`Private`s1, 
                AtomicDensityMatrix`WignerEckart`Private`j1, 
                AtomicDensityMatrix`WignerEckart`Private`l1}, {
               AtomicDensityMatrix`WignerEckart`Private`j2, 
                AtomicDensityMatrix`WignerEckart`Private`s1, 1}]], 
            AtomicDensityMatrix`ReducedME[
            AtomicDensityMatrix`WignerEckart`Private`lab1, {
             AtomicDensityMatrix`S, 1}, 
             AtomicDensityMatrix`WignerEckart`Private`lab2]], True, 0]], 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]], {AtomicDensityMatrix`L, 1}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`WignerEckart`Private`s1, 
          AtomicDensityMatrix`WignerEckart`Private`l1, 
          AtomicDensityMatrix`WignerEckart`Private`j1, 
          AtomicDensityMatrix`WignerEckart`Private`s2, 
          AtomicDensityMatrix`WignerEckart`Private`l2, 
          AtomicDensityMatrix`WignerEckart`Private`j2, 
          AtomicDensityMatrix`WignerEckart`Private`lab1, 
          AtomicDensityMatrix`WignerEckart`Private`lab2}, {{
            AtomicDensityMatrix`WignerEckart`Private`s1, 
             AtomicDensityMatrix`WignerEckart`Private`l1, 
             AtomicDensityMatrix`WignerEckart`Private`j1, 
             AtomicDensityMatrix`WignerEckart`Private`lab1}, {
            AtomicDensityMatrix`WignerEckart`Private`s2, 
             AtomicDensityMatrix`WignerEckart`Private`l2, 
             AtomicDensityMatrix`WignerEckart`Private`j2, 
             AtomicDensityMatrix`WignerEckart`Private`lab2}} = Map[Through, 
            
            Map[{AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
              AtomicDensityMatrix`J, AtomicDensityMatrix`StateLabel}, {
             AtomicDensityMatrix`WignerEckart`Private`state1, 
              AtomicDensityMatrix`WignerEckart`Private`state2}]]; 
         Which[AtomicDensityMatrix`WignerEckart`Private`lab1 === 
           AtomicDensityMatrix`WignerEckart`Private`lab2, 
           If[
           AtomicDensityMatrix`WignerEckart`Private`j1 < 1/2, 
            0, (Sqrt[
              AtomicDensityMatrix`WignerEckart`Private`j1 (
                AtomicDensityMatrix`WignerEckart`Private`j1 + 1) (
                2 AtomicDensityMatrix`WignerEckart`Private`j1 + 1)] (
              AtomicDensityMatrix`WignerEckart`Private`j1 (
                AtomicDensityMatrix`WignerEckart`Private`j1 + 1) + 
              AtomicDensityMatrix`WignerEckart`Private`l1 (
                AtomicDensityMatrix`WignerEckart`Private`l1 + 1) - 
              AtomicDensityMatrix`WignerEckart`Private`s1 (
               AtomicDensityMatrix`WignerEckart`Private`s1 + 1)))/(2 
            AtomicDensityMatrix`WignerEckart`Private`j1 (
             AtomicDensityMatrix`WignerEckart`Private`j1 + 1))], 
           AtomicDensityMatrix`FineStructureStatesQ[
           AtomicDensityMatrix`WignerEckart`Private`state1, 
            AtomicDensityMatrix`WignerEckart`Private`state2], 
           If[
            
            AtomicDensityMatrix`DefinedQ[{
             AtomicDensityMatrix`WignerEckart`Private`state1, 
              AtomicDensityMatrix`WignerEckart`Private`state2}, {
             AtomicDensityMatrix`S, AtomicDensityMatrix`L, 
              AtomicDensityMatrix`J}], 
            If[
             Or[
             AtomicDensityMatrix`WignerEckart`Private`s1 =!= 
              AtomicDensityMatrix`WignerEckart`Private`s2, 
              AtomicDensityMatrix`WignerEckart`Private`l1 =!= 
              AtomicDensityMatrix`WignerEckart`Private`l2], 
             0, (-1)^(AtomicDensityMatrix`WignerEckart`Private`s1 + 
               AtomicDensityMatrix`WignerEckart`Private`l1 + 
               AtomicDensityMatrix`WignerEckart`Private`j2 + 1) 
             Sqrt[AtomicDensityMatrix`WignerEckart`Private`l1 (
                AtomicDensityMatrix`WignerEckart`Private`l1 + 1) (
                2 AtomicDensityMatrix`WignerEckart`Private`l1 + 1) (
                2 AtomicDensityMatrix`WignerEckart`Private`j1 + 1) (
                2 AtomicDensityMatrix`WignerEckart`Private`j2 + 1)] 
             AtomicDensityMatrix`SJS[{
               AtomicDensityMatrix`WignerEckart`Private`l1, 
                AtomicDensityMatrix`WignerEckart`Private`j1, 
                AtomicDensityMatrix`WignerEckart`Private`s1}, {
               AtomicDensityMatrix`WignerEckart`Private`j2, 
                AtomicDensityMatrix`WignerEckart`Private`l1, 1}]], 
            AtomicDensityMatrix`ReducedME[
            AtomicDensityMatrix`WignerEckart`Private`lab1, {
             AtomicDensityMatrix`L, 1}, 
             AtomicDensityMatrix`WignerEckart`Private`lab2]], True, 0]], 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
         AtomicDensityMatrix`MagneticMoment, 1}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := -(Units`BohrMagneton 
         Which[AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`WignerEckart`Private`s1] === 
           AtomicDensityMatrix`StateLabel[
            AtomicDensityMatrix`WignerEckart`Private`s2], Which[
             AtomicDensityMatrix`DefinedQ[
             AtomicDensityMatrix`WignerEckart`Private`s1, 
              AtomicDensityMatrix`GFactor], 
             AtomicDensityMatrix`GFactor[
             AtomicDensityMatrix`WignerEckart`Private`s1], 
             AtomicDensityMatrix`DefinedQ[
             AtomicDensityMatrix`WignerEckart`Private`s1, {
              AtomicDensityMatrix`J, AtomicDensityMatrix`L, 
               AtomicDensityMatrix`S}], 
             AtomicDensityMatrix`LandeGJ[
             AtomicDensityMatrix`WignerEckart`Private`s1], True, 
             AtomicDensityMatrix`GFactor[
             AtomicDensityMatrix`WignerEckart`Private`s1]] 
           AtomicDensityMatrix`ReducedME[
            AtomicDensityMatrix`WignerEckart`Private`s1, {
             AtomicDensityMatrix`J, 1}, 
             AtomicDensityMatrix`WignerEckart`Private`s2], 
           AtomicDensityMatrix`FineStructureStatesQ[
           AtomicDensityMatrix`WignerEckart`Private`s1, 
            AtomicDensityMatrix`WignerEckart`Private`s2], 
           AtomicDensityMatrix`ReducedME[
            AtomicDensityMatrix`WignerEckart`Private`s1, {
             AtomicDensityMatrix`L, 1}, 
             AtomicDensityMatrix`WignerEckart`Private`s2] + 
           2 AtomicDensityMatrix`ReducedME[
             AtomicDensityMatrix`WignerEckart`Private`s1, {
              AtomicDensityMatrix`S, 1}, 
              AtomicDensityMatrix`WignerEckart`Private`s2], True, 0]), 
       AtomicDensityMatrix`ReducedME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], {
         AtomicDensityMatrix`Polarizability, 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[Integer]]}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       AtomicDensityMatrix`WignerEckart`Private`alphaFactor[
         AtomicDensityMatrix`WignerEckart`Private`k, 
          AtomicDensityMatrix`J[AtomicDensityMatrix`WignerEckart`Private`s1]] 
        AtomicDensityMatrix`Polarizability[
         AtomicDensityMatrix`WignerEckart`Private`k][
         AtomicDensityMatrix`WignerEckart`Private`s1] 
        Boole[AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`WignerEckart`Private`s1] === 
          AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`WignerEckart`Private`s2]], 
       TagSet[AtomicDensityMatrix`ReducedME, 
        MessageName[AtomicDensityMatrix`ReducedME, "usage"], ""], 
       TagSet[AtomicDensityMatrix`Zero, 
        MessageName[AtomicDensityMatrix`Zero, "usage"], ""], 
       TagSet[AtomicDensityMatrix`Dipole, 
        MessageName[AtomicDensityMatrix`Dipole, "usage"], ""], 
       TagSet[AtomicDensityMatrix`MagneticMoment, 
        MessageName[AtomicDensityMatrix`MagneticMoment, "usage"], ""], 
       AtomicDensityMatrix`CountZeemanSublevels[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := Map[Length, 
         Split[
          AtomicDensityMatrix`DeleteParameter[
          AtomicDensityMatrix`AtomicSystem`Private`sys, 
           AtomicDensityMatrix`M]]], 
       TagSet[AtomicDensityMatrix`CountZeemanSublevels, 
        MessageName[AtomicDensityMatrix`CountZeemanSublevels, "usage"], ""], 
       AtomicDensityMatrix`Polarization[
         PatternTest[
          Pattern[AtomicDensityMatrix`Observables`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`Observables`Private`transformMatrix, 
           Blank[]], AtomicDensityMatrix`OperatorQ], 
         Pattern[AtomicDensityMatrix`Observables`Private`opts, 
          OptionsPattern[]]] := Map[Tr[
          Dot[
           AtomicDensityMatrix`DMFromRotatingDM[
           AtomicDensityMatrix`Observables`Private`sys, 
            AtomicDensityMatrix`Observables`Private`transformMatrix, 
            FilterRules[{AtomicDensityMatrix`Observables`Private`opts, 
              Options[AtomicDensityMatrix`Polarization]}, 
             Options[AtomicDensityMatrix`DMFromRotatingDM]]], #]]& , 
         AtomicDensityMatrix`ToCartesian[
          AtomicDensityMatrix`WignerEckart[
          AtomicDensityMatrix`Observables`Private`sys, {
           AtomicDensityMatrix`Dipole, 1}]]], 
       Options[AtomicDensityMatrix`Polarization] = {
        AtomicDensityMatrix`TimeDependence -> Automatic, 
         AtomicDensityMatrix`Representation -> Automatic, 
         AtomicDensityMatrix`DMSymbol -> Automatic, 
         AtomicDensityMatrix`DMLabel -> Automatic, 
         AtomicDensityMatrix`ComplexExpandVariables -> Automatic, 
         AtomicDensityMatrix`TimeVariable -> Automatic, 
         AtomicDensityMatrix`AllowedElements -> Automatic, 
         AtomicDensityMatrix`NeglectedElements -> Automatic, 
         AtomicDensityMatrix`Subspace -> Automatic}, 
       TagSet[AtomicDensityMatrix`Polarization, 
        MessageName[AtomicDensityMatrix`Polarization, "usage"], ""], 
       AtomicDensityMatrix`DMFromRotatingDM[
         PatternTest[
          Pattern[AtomicDensityMatrix`Observables`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`Observables`Private`transformMatrix, 
           Blank[]], AtomicDensityMatrix`OperatorQ], 
         Pattern[AtomicDensityMatrix`Observables`Private`opts, 
          OptionsPattern[]]] := 
       Dot[AtomicDensityMatrix`Observables`Private`transformMatrix, 
         AtomicDensityMatrix`DensityMatrix[
         AtomicDensityMatrix`Observables`Private`sys, 
          FilterRules[{AtomicDensityMatrix`Observables`Private`opts, 
            Options[AtomicDensityMatrix`DMFromRotatingDM]}, 
           Options[AtomicDensityMatrix`DensityMatrix]]], 
         AtomicDensityMatrix`ECT[
         AtomicDensityMatrix`Observables`Private`transformMatrix]], 
       Options[AtomicDensityMatrix`DMFromRotatingDM] = {
        AtomicDensityMatrix`TimeDependence -> Automatic, 
         AtomicDensityMatrix`Representation -> Automatic, 
         AtomicDensityMatrix`DMSymbol -> Automatic, 
         AtomicDensityMatrix`DMLabel -> Automatic, 
         AtomicDensityMatrix`ComplexExpandVariables -> Automatic, 
         AtomicDensityMatrix`TimeVariable -> Automatic, 
         AtomicDensityMatrix`AllowedElements -> Automatic, 
         AtomicDensityMatrix`NeglectedElements -> Automatic, 
         AtomicDensityMatrix`Subspace -> Automatic}, 
       TagSet[AtomicDensityMatrix`DMFromRotatingDM, 
        MessageName[AtomicDensityMatrix`DMFromRotatingDM, "usage"], ""], 
       AtomicDensityMatrix`DensityMatrix[
         PatternTest[
          Pattern[AtomicDensityMatrix`DensityMatrix`Private`system, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`DensityMatrix`Private`subspace = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DensityMatrix, AtomicDensityMatrix`Subspace, 
            OptionValue[AtomicDensityMatrix`Subspace]], 
          AtomicDensityMatrix`DensityMatrix`Private`representation = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DensityMatrix, 
            AtomicDensityMatrix`Representation, 
            OptionValue[AtomicDensityMatrix`Representation]], 
          AtomicDensityMatrix`DensityMatrix`Private`timeDependence = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DensityMatrix, 
            AtomicDensityMatrix`TimeDependence, 
            OptionValue[AtomicDensityMatrix`TimeDependence]], 
          AtomicDensityMatrix`DensityMatrix`Private`timeVariable = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DensityMatrix, 
            AtomicDensityMatrix`TimeVariable, 
            OptionValue[AtomicDensityMatrix`TimeVariable]], 
          AtomicDensityMatrix`DensityMatrix`Private`dmLabel = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DensityMatrix, AtomicDensityMatrix`DMLabel, 
            OptionValue[AtomicDensityMatrix`DMLabel]], 
          AtomicDensityMatrix`DensityMatrix`Private`dmSymbol = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DensityMatrix, AtomicDensityMatrix`DMSymbol, 
            OptionValue[AtomicDensityMatrix`DMSymbol]], 
          AtomicDensityMatrix`DensityMatrix`Private`complexExpandVariables = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DensityMatrix, 
            AtomicDensityMatrix`ComplexExpandVariables, 
            OptionValue[AtomicDensityMatrix`ComplexExpandVariables]], 
          AtomicDensityMatrix`DensityMatrix`Private`allowedElements = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DensityMatrix, 
            AtomicDensityMatrix`AllowedElements, 
            OptionValue[AtomicDensityMatrix`AllowedElements]], 
          AtomicDensityMatrix`DensityMatrix`Private`neglectedElements = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DensityMatrix, 
            AtomicDensityMatrix`NeglectedElements, 
            OptionValue[AtomicDensityMatrix`NeglectedElements]], 
          AtomicDensityMatrix`DensityMatrix`Private`labels, 
          AtomicDensityMatrix`DensityMatrix`Private`pos, 
          AtomicDensityMatrix`DensityMatrix`Private`elements, 
          AtomicDensityMatrix`DensityMatrix`Private`sys}, 
         Condition[
         AtomicDensityMatrix`DensityMatrix`Private`sys = 
           If[AtomicDensityMatrix`DensityMatrix`Private`subspace =!= All, 
             AtomicDensityMatrix`SelectStates[
             AtomicDensityMatrix`DensityMatrix`Private`system, 
              AtomicDensityMatrix`DensityMatrix`Private`subspace], 
             AtomicDensityMatrix`DensityMatrix`Private`system]; 
          Switch[AtomicDensityMatrix`DensityMatrix`Private`representation, {
            "Zeeman"}, 
            AtomicDensityMatrix`DensityMatrix`Private`labels = 
             AtomicDensityMatrix`SublevelLabel[
              AtomicDensityMatrix`DensityMatrix`Private`sys]; 
            AtomicDensityMatrix`DensityMatrix`Private`pos = 
             Apply[Complement, 
               Map[
               AtomicDensityMatrix`MatrixElementPosition[
                AtomicDensityMatrix`DensityMatrix`Private`sys, #]& , {
                AtomicDensityMatrix`DensityMatrix`Private`allowedElements, 
                 AtomicDensityMatrix`DensityMatrix`Private`neglectedElements}]\
]; If[AtomicDensityMatrix`DensityMatrix`Private`pos === {}, 
              AtomicDensityMatrix`ZeroMatrix[
               Length[AtomicDensityMatrix`DensityMatrix`Private`sys]], 
              AtomicDensityMatrix`DensityMatrix`Private`elements = 
               MapThread[
                Subscript[
                 AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
                  AtomicDensityMatrix`DensityMatrix`Private`dmLabel, 
                  SlotSequence[1]]& , 
                 Map[
                 Part[AtomicDensityMatrix`DensityMatrix`Private`labels, #]& , 
                  
                  Transpose[AtomicDensityMatrix`DensityMatrix`Private`pos]]]; 
              If[AtomicDensityMatrix`DensityMatrix`Private`timeDependence, 
                AtomicDensityMatrix`DensityMatrix`Private`elements = Through[
                  AtomicDensityMatrix`DensityMatrix`Private`elements[
                  AtomicDensityMatrix`DensityMatrix`Private`timeVariable]]]; 
              If[
                MatchQ[
                AtomicDensityMatrix`DensityMatrix`Private`\
complexExpandVariables, 
                 Alternatives[True, Subscript]], 
                AtomicDensityMatrix`DensityMatrix`Private`elements = 
                ReplaceAll[AtomicDensityMatrix`DensityMatrix`Private`elements, 
                  AtomicDensityMatrix`ExpandDMVariablesRule[
                  AtomicDensityMatrix`DensityMatrix`Private`sys, 
                   
                   FilterRules[{
                    AtomicDensityMatrix`DensityMatrix`Private`opts, 
                    Options[AtomicDensityMatrix`DensityMatrix]}, 
                    Options[AtomicDensityMatrix`ExpandDMVariablesRule]]]]]; 
              Normal[
                SparseArray[
                AtomicDensityMatrix`DensityMatrix`Private`pos -> 
                 AtomicDensityMatrix`DensityMatrix`Private`elements, {
                  Length[AtomicDensityMatrix`DensityMatrix`Private`sys], 
                  Length[AtomicDensityMatrix`DensityMatrix`Private`sys]}]]], {
            "PolarizationMoments", 
             BlankNullSequence[]}, 
            AtomicDensityMatrix`PolarizationMoments[
            AtomicDensityMatrix`DensityMatrix`Private`sys, 
             Rest[AtomicDensityMatrix`DensityMatrix`Private`representation], 
             FilterRules[{AtomicDensityMatrix`DensityMatrix`Private`opts, 
               Options[AtomicDensityMatrix`DensityMatrix]}, 
              Options[AtomicDensityMatrix`PolarizationMoments]]]], 
          
          FreeQ[{{AtomicDensityMatrix`DensityMatrix`Private`subspace, 
             AtomicDensityMatrix`DensityMatrix`Private`representation, 
             AtomicDensityMatrix`DensityMatrix`Private`timeDependence, 
             AtomicDensityMatrix`DensityMatrix`Private`timeVariable, 
             AtomicDensityMatrix`DensityMatrix`Private`dmLabel, 
             AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
             AtomicDensityMatrix`DensityMatrix`Private`complexExpandVariables,
              AtomicDensityMatrix`DensityMatrix`Private`allowedElements, 
             AtomicDensityMatrix`DensityMatrix`Private`neglectedElements}}, \
$Failed]]], AtomicDensityMatrix`DensityMatrix[
         PatternTest[
          Pattern[AtomicDensityMatrix`DensityMatrix`Private`as, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`es, {
           Repeated[
            Blank[AtomicDensityMatrix`ExperimentalRegion]]}], 
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`opts, 
          OptionsPattern[]]] := 
       Map[AtomicDensityMatrix`DensityMatrix[
         AtomicDensityMatrix`DensityMatrix`Private`as, 
          AtomicDensityMatrix`DMLabel -> AtomicDensityMatrix`RegionLabel[#], 
          AtomicDensityMatrix`DensityMatrix`Private`opts]& , 
         AtomicDensityMatrix`DensityMatrix`Private`es], 
       Options[AtomicDensityMatrix`DensityMatrix] = {
        AtomicDensityMatrix`TimeDependence -> True, 
         AtomicDensityMatrix`Representation -> "Zeeman", 
         AtomicDensityMatrix`DMSymbol -> AtomicDensityMatrix`\[Rho], 
         AtomicDensityMatrix`DMLabel -> None, 
         AtomicDensityMatrix`ComplexExpandVariables -> False, 
         AtomicDensityMatrix`TimeVariable -> AtomicDensityMatrix`t, 
         AtomicDensityMatrix`AllowedElements -> All, 
         AtomicDensityMatrix`NeglectedElements -> None, 
         AtomicDensityMatrix`Subspace -> All}, 
       TagSet[AtomicDensityMatrix`DensityMatrix, 
        MessageName[AtomicDensityMatrix`DensityMatrix, "usage"], 
        "\!\(\*TagBox[RowBox[{\"DensityMatrix[\", StyleBox[\"sys\", \"TI\"], \
\"] forms the density matrix for an atomic system (list of AtomicState \
objects) \", StyleBox[\"sys\", \"TI\"], \".\"}], DisplayForm]\)"], 
       TagSet[AtomicDensityMatrix`Subspace, 
        MessageName[AtomicDensityMatrix`Subspace, "usage"], ""], 
       TagSet[AtomicDensityMatrix`Representation, 
        MessageName[AtomicDensityMatrix`Representation, "usage"], 
        "Representation is an option for DensityMatrix and related functions \
that specifies the representation basis for the density matrix."], 
       TagSet[AtomicDensityMatrix`TimeDependence, 
        MessageName[AtomicDensityMatrix`TimeDependence, "usage"], 
        "TimeDependence is an option for DensityMatrix and related functions \
that specifies whether density\[Hyphen]matrix elements should have explicit \
time dependence."], 
       TagSet[AtomicDensityMatrix`DMLabel, 
        MessageName[AtomicDensityMatrix`DMLabel, "usage"], 
        "DMLabel is an option for DensityMatrix and related functions that \
specifies an additional label for density\[Hyphen]matrix elements."], 
       TagSet[AtomicDensityMatrix`DMSymbol, 
        MessageName[AtomicDensityMatrix`DMSymbol, "usage"], 
        "DMSymbol is an option for DensityMatrix and related functions that \
specifies the symbol to use to represent the density matrix."], 
       TagSet[AtomicDensityMatrix`ComplexExpandVariables, 
        MessageName[AtomicDensityMatrix`ComplexExpandVariables, "usage"], 
        "ComplexExpandVariables is an option for DensityMatrix and related \
functions that specifies whether density\[Hyphen]matrix elements should be \
written in terms of their real and imaginary parts."], 
       TagSet[AtomicDensityMatrix`AllowedElements, 
        MessageName[AtomicDensityMatrix`AllowedElements, "usage"], ""], 
       TagSet[AtomicDensityMatrix`NeglectedElements, 
        MessageName[AtomicDensityMatrix`NeglectedElements, "usage"], ""], 
       AtomicDensityMatrix`SelectStates[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          BlankSequence[]]] := 
       Extract[AtomicDensityMatrix`AtomicSystem`Private`sys, 
         AtomicDensityMatrix`StatePosition[
         AtomicDensityMatrix`AtomicSystem`Private`sys, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]], 
       TagSet[AtomicDensityMatrix`SelectStates, 
        MessageName[AtomicDensityMatrix`SelectStates, "usage"], 
        "\!\(\*TagBox[RowBox[{\"SelectStates[\", StyleBox[\"sys\", \"TI\"], \
\", \", StyleBox[\"crit\", \"TI\"], \"] selects the atomic states from the \
atomic system \", StyleBox[\"sys\", \"TI\"], \" that satisfy the state\
\[Hyphen]selection criteria \", StyleBox[\"crit\", \"TI\"], \". \"}], \
DisplayForm]\)"], AtomicDensityMatrix`StatePosition[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit1, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit2, 
          BlankSequence[]]] := Apply[Union, 
         Map[
         AtomicDensityMatrix`StatePosition[
          AtomicDensityMatrix`AtomicSystem`Private`sys, #]& , {
          AtomicDensityMatrix`AtomicSystem`Private`crit1, 
           AtomicDensityMatrix`AtomicSystem`Private`crit2}]], Condition[
         AtomicDensityMatrix`StatePosition[
          PatternTest[
           Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
            Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
           Blank[]]], 
         AtomicDensityMatrix`StateLabelQ[
         AtomicDensityMatrix`AtomicSystem`Private`sys, 
          AtomicDensityMatrix`AtomicSystem`Private`crit]] := Position[
         AtomicDensityMatrix`StateLabel[
         AtomicDensityMatrix`AtomicSystem`Private`sys], 
         AtomicDensityMatrix`AtomicSystem`Private`crit, {1}, Infinity, Heads -> 
         False], Condition[
         AtomicDensityMatrix`StatePosition[
          PatternTest[
           Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
            Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
           Blank[]]], 
         Not[
          AtomicDensityMatrix`StateLabelQ[
          AtomicDensityMatrix`AtomicSystem`Private`sys, 
           AtomicDensityMatrix`AtomicSystem`Private`crit]]] := 
       Position[AtomicDensityMatrix`AtomicSystem`Private`sys, 
         Condition[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`state, 
           Blank[]], 
          AtomicDensityMatrix`StateMatchQ[
          AtomicDensityMatrix`AtomicSystem`Private`state, 
           AtomicDensityMatrix`AtomicSystem`Private`crit]], {1}, Infinity, 
         Heads -> False], 
       TagSet[AtomicDensityMatrix`StatePosition, 
        MessageName[AtomicDensityMatrix`StatePosition, "usage"], 
        "\!\(\*TagBox[RowBox[{\"StatePosition[\", StyleBox[\"sys\", \"TI\"], \
\",\", StyleBox[\"crit\", \"TI\"], \"] gives the position in the atomic \
system \", StyleBox[\"sys\", \"TI\"], \" of the states satisfying the state\
\[Hyphen]selection criteria \", StyleBox[\"crit\", \"TI\"], \".\"}], \
DisplayForm]\)"], Attributes[AtomicDensityMatrix`SublevelLabel] = {Listable}, 
       AtomicDensityMatrix`SublevelLabel[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Blank[AtomicDensityMatrix`AtomicState]]] := Switch[
         AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicSystem`Private`s], 
         Alternatives["Toy", "Fine"], 
         AtomicDensityMatrix`StateLabel[
         AtomicDensityMatrix`AtomicSystem`Private`s], "Zeeman", {
          AtomicDensityMatrix`StateLabel[
          AtomicDensityMatrix`AtomicSystem`Private`s], 
          AtomicDensityMatrix`M[AtomicDensityMatrix`AtomicSystem`Private`s]}, 
         "Hyperfine", {
          AtomicDensityMatrix`StateLabel[
          AtomicDensityMatrix`AtomicSystem`Private`s], 
          AtomicDensityMatrix`F[AtomicDensityMatrix`AtomicSystem`Private`s]}, 
         "HyperfineZeeman", {
          AtomicDensityMatrix`StateLabel[
          AtomicDensityMatrix`AtomicSystem`Private`s], 
          AtomicDensityMatrix`F[AtomicDensityMatrix`AtomicSystem`Private`s], 
          AtomicDensityMatrix`M[AtomicDensityMatrix`AtomicSystem`Private`s]}], 
       TagSet[AtomicDensityMatrix`SublevelLabel, 
        MessageName[AtomicDensityMatrix`SublevelLabel, "usage"], ""], 
       AtomicDensityMatrix`MatrixElementPosition[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit1, 
           Blank[]] -> Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit2, 
           Blank[]]] := 
       Module[{AtomicDensityMatrix`AtomicSystem`Private`pos1, 
          AtomicDensityMatrix`AtomicSystem`Private`pos2}, {
           AtomicDensityMatrix`AtomicSystem`Private`pos1, 
            AtomicDensityMatrix`AtomicSystem`Private`pos2} = Map[Flatten[
             AtomicDensityMatrix`StatePosition[
             AtomicDensityMatrix`AtomicSystem`Private`sys, #]]& , {
            AtomicDensityMatrix`AtomicSystem`Private`crit1, 
             AtomicDensityMatrix`AtomicSystem`Private`crit2}]; (Union[#, 
           Map[Reverse, #]]& )[
           Flatten[
            Outer[
            List, AtomicDensityMatrix`AtomicSystem`Private`pos1, 
             AtomicDensityMatrix`AtomicSystem`Private`pos2], 1]]], 
       AtomicDensityMatrix`MatrixElementPosition[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Alternatives[All, True]] := Tuples[
         Range[
          Length[AtomicDensityMatrix`AtomicSystem`Private`sys]], 2], 
       AtomicDensityMatrix`MatrixElementPosition[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Alternatives[None, False]] := {}, 
       AtomicDensityMatrix`MatrixElementPosition[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`crit, 
          Blank[]]] := Position[
         AtomicDensityMatrix`TransitionQ[
         AtomicDensityMatrix`AtomicSystem`Private`sys, 
          AtomicDensityMatrix`AtomicSystem`Private`crit], True, {2}, Infinity,
          Heads -> False], 
       TagSet[AtomicDensityMatrix`MatrixElementPosition, 
        MessageName[AtomicDensityMatrix`MatrixElementPosition, "usage"], ""], 
       Attributes[Subscript] = {NHoldRest}, 
       AtomicDensityMatrix`ExpandDMVariablesRule[
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`DensityMatrix`Private`sublevelLabels = 
          Map[AtomicDensityMatrix`SublevelLabel, 
            AtomicDensityMatrix`DensityMatrix`Private`sys], 
          AtomicDensityMatrix`DensityMatrix`Private`patt, 
          AtomicDensityMatrix`DensityMatrix`Private`rep, 
          AtomicDensityMatrix`DensityMatrix`Private`imp, 
          AtomicDensityMatrix`DensityMatrix`Private`elem, 
          AtomicDensityMatrix`DensityMatrix`Private`rept, 
          AtomicDensityMatrix`DensityMatrix`Private`impt, 
          AtomicDensityMatrix`DensityMatrix`Private`rep1, 
          AtomicDensityMatrix`DensityMatrix`Private`imp1, 
          AtomicDensityMatrix`DensityMatrix`Private`rept1, 
          AtomicDensityMatrix`DensityMatrix`Private`impt1, 
          AtomicDensityMatrix`DensityMatrix`Private`elemt, 
          AtomicDensityMatrix`DensityMatrix`Private`e, 
          AtomicDensityMatrix`DensityMatrix`Private`r, 
          AtomicDensityMatrix`DensityMatrix`Private`i, 
          AtomicDensityMatrix`DensityMatrix`Private`r1, 
          AtomicDensityMatrix`DensityMatrix`Private`i1, 
          AtomicDensityMatrix`DensityMatrix`Private`complexExpandVariables = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`ExpandDMVariablesRule, 
            AtomicDensityMatrix`ComplexExpandVariables, 
            OptionValue[AtomicDensityMatrix`ComplexExpandVariables]], 
          AtomicDensityMatrix`DensityMatrix`Private`dmSymbol = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`ExpandDMVariablesRule, 
            AtomicDensityMatrix`DMSymbol, 
            OptionValue[AtomicDensityMatrix`DMSymbol]], 
          AtomicDensityMatrix`DensityMatrix`Private`dmLabel = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`ExpandDMVariablesRule, 
            AtomicDensityMatrix`DMLabel, 
            OptionValue[AtomicDensityMatrix`DMLabel]]}, 
         Condition[
         AtomicDensityMatrix`DensityMatrix`Private`patt = 
           AtomicDensityMatrix`DMElementPattern[
            AtomicDensityMatrix`ComplexExpandVariables -> False, 
             AtomicDensityMatrix`TimeDependence -> All, 
             FilterRules[{AtomicDensityMatrix`DensityMatrix`Private`opts, 
               Options[AtomicDensityMatrix`ExpandDMVariablesRule]}, 
              Options[AtomicDensityMatrix`DMElementPattern]]]; 
          Switch[AtomicDensityMatrix`DensityMatrix`Private`\
complexExpandVariables, True, 
            ReplaceAll[
            Pattern[AtomicDensityMatrix`DensityMatrix`Private`v, 
               AtomicDensityMatrix`DensityMatrix`Private`patt] :> 
             Switch[AtomicDensityMatrix`DensityMatrix`Private`e = 
                If[{AtomicDensityMatrix`Time} == {}, 
                  AtomicDensityMatrix`DensityMatrix`Private`elem, 
                  AtomicDensityMatrix`DensityMatrix`Private`elemt]; Order[
                 Position[
                 AtomicDensityMatrix`DensityMatrix`Private`sublevelLabels, 
                  AtomicDensityMatrix`State1, {1}], 
                 Position[
                 AtomicDensityMatrix`DensityMatrix`Private`sublevelLabels, 
                  AtomicDensityMatrix`State2, {1}]], -1, 
               Re[AtomicDensityMatrix`DensityMatrix`Private`e] - I 
               Im[AtomicDensityMatrix`DensityMatrix`Private`e], 0, 
               Re[AtomicDensityMatrix`DensityMatrix`Private`v], 1, 
               Re[AtomicDensityMatrix`DensityMatrix`Private`v] + 
               I Im[AtomicDensityMatrix`DensityMatrix`Private`v]], {
             AtomicDensityMatrix`DensityMatrix`Private`elem -> 
              Subscript[
               AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
                AtomicDensityMatrix`DensityMatrix`Private`dmLabel, 
                AtomicDensityMatrix`State2, AtomicDensityMatrix`State1], 
              AtomicDensityMatrix`DensityMatrix`Private`elemt -> 
              Derivative[AtomicDensityMatrix`TimeDerivative][
                Subscript[
                AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
                 AtomicDensityMatrix`DensityMatrix`Private`dmLabel, 
                 AtomicDensityMatrix`State2, AtomicDensityMatrix`State1]][
               AtomicDensityMatrix`Time]}], Subscript, 
            ReplaceAll[
            Pattern[AtomicDensityMatrix`DensityMatrix`Private`v, 
               AtomicDensityMatrix`DensityMatrix`Private`patt] :> 
             Switch[{AtomicDensityMatrix`DensityMatrix`Private`r, 
                  AtomicDensityMatrix`DensityMatrix`Private`i, 
                  AtomicDensityMatrix`DensityMatrix`Private`r1, 
                  AtomicDensityMatrix`DensityMatrix`Private`i1} = 
                If[{AtomicDensityMatrix`Time} == {}, {
                  AtomicDensityMatrix`DensityMatrix`Private`rep, 
                   AtomicDensityMatrix`DensityMatrix`Private`imp, 
                   AtomicDensityMatrix`DensityMatrix`Private`rep1, 
                   AtomicDensityMatrix`DensityMatrix`Private`imp1}, {
                  AtomicDensityMatrix`DensityMatrix`Private`rept, 
                   AtomicDensityMatrix`DensityMatrix`Private`impt, 
                   AtomicDensityMatrix`DensityMatrix`Private`rept1, 
                   AtomicDensityMatrix`DensityMatrix`Private`impt1}]; Order[
                 Position[
                 AtomicDensityMatrix`DensityMatrix`Private`sublevelLabels, 
                  AtomicDensityMatrix`State1, {1}], 
                 Position[
                 AtomicDensityMatrix`DensityMatrix`Private`sublevelLabels, 
                  AtomicDensityMatrix`State2, {1}]], -1, 
               AtomicDensityMatrix`DensityMatrix`Private`r1 - I 
               AtomicDensityMatrix`DensityMatrix`Private`i1, 0, 
               AtomicDensityMatrix`DensityMatrix`Private`r, 1, 
               AtomicDensityMatrix`DensityMatrix`Private`r + 
               I AtomicDensityMatrix`DensityMatrix`Private`i], {
             AtomicDensityMatrix`DensityMatrix`Private`rep -> 
              Subscript[
               AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, Re, 
                AtomicDensityMatrix`DensityMatrix`Private`dmLabel, 
                AtomicDensityMatrix`State1, AtomicDensityMatrix`State2], 
              AtomicDensityMatrix`DensityMatrix`Private`imp -> 
              Subscript[
               AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, Im, 
                AtomicDensityMatrix`DensityMatrix`Private`dmLabel, 
                AtomicDensityMatrix`State1, AtomicDensityMatrix`State2], 
              AtomicDensityMatrix`DensityMatrix`Private`rept -> 
              Derivative[AtomicDensityMatrix`TimeDerivative][
                Subscript[
                AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, Re, 
                 AtomicDensityMatrix`DensityMatrix`Private`dmLabel, 
                 AtomicDensityMatrix`State1, AtomicDensityMatrix`State2]][
               AtomicDensityMatrix`Time], 
              AtomicDensityMatrix`DensityMatrix`Private`impt -> 
              Derivative[AtomicDensityMatrix`TimeDerivative][
                Subscript[
                AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, Im, 
                 AtomicDensityMatrix`DensityMatrix`Private`dmLabel, 
                 AtomicDensityMatrix`State1, AtomicDensityMatrix`State2]][
               AtomicDensityMatrix`Time], 
              AtomicDensityMatrix`DensityMatrix`Private`rep1 -> 
              Subscript[
               AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, Re, 
                AtomicDensityMatrix`DensityMatrix`Private`dmLabel, 
                AtomicDensityMatrix`State2, AtomicDensityMatrix`State1], 
              AtomicDensityMatrix`DensityMatrix`Private`imp1 -> 
              Subscript[
               AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, Im, 
                AtomicDensityMatrix`DensityMatrix`Private`dmLabel, 
                AtomicDensityMatrix`State2, AtomicDensityMatrix`State1], 
              AtomicDensityMatrix`DensityMatrix`Private`rept1 -> 
              Derivative[AtomicDensityMatrix`TimeDerivative][
                Subscript[
                AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, Re, 
                 AtomicDensityMatrix`DensityMatrix`Private`dmLabel, 
                 AtomicDensityMatrix`State2, AtomicDensityMatrix`State1]][
               AtomicDensityMatrix`Time], 
              AtomicDensityMatrix`DensityMatrix`Private`impt1 -> 
              Derivative[AtomicDensityMatrix`TimeDerivative][
                Subscript[
                AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, Im, 
                 AtomicDensityMatrix`DensityMatrix`Private`dmLabel, 
                 AtomicDensityMatrix`State2, AtomicDensityMatrix`State1]][
               AtomicDensityMatrix`Time]}], 
            Blank[], {}], 
          
          FreeQ[{{AtomicDensityMatrix`DensityMatrix`Private`\
complexExpandVariables, AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
             AtomicDensityMatrix`DensityMatrix`Private`dmLabel}}, $Failed]]], 
       Options[AtomicDensityMatrix`ExpandDMVariablesRule] = {
        AtomicDensityMatrix`TimeDependence -> Automatic, 
         AtomicDensityMatrix`DMSymbol -> Automatic, 
         AtomicDensityMatrix`DMLabel -> Automatic, 
         AtomicDensityMatrix`ComplexExpandVariables -> Automatic, 
         AtomicDensityMatrix`AllowedElements -> Automatic, 
         AtomicDensityMatrix`NeglectedElements -> Automatic, 
         AtomicDensityMatrix`Subspace -> Automatic}, 
       TagSet[AtomicDensityMatrix`ExpandDMVariablesRule, 
        MessageName[AtomicDensityMatrix`ExpandDMVariablesRule, "usage"], ""], 
       AtomicDensityMatrix`DMElementPattern[
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`DensityMatrix`Private`representation = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DMElementPattern, 
            AtomicDensityMatrix`Representation, 
            OptionValue[AtomicDensityMatrix`Representation]], 
          AtomicDensityMatrix`DensityMatrix`Private`dmSymbol = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DMElementPattern, AtomicDensityMatrix`DMSymbol, 
            OptionValue[AtomicDensityMatrix`DMSymbol]], 
          AtomicDensityMatrix`DensityMatrix`Private`complexExpandVariables = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DMElementPattern, 
            AtomicDensityMatrix`ComplexExpandVariables, 
            OptionValue[AtomicDensityMatrix`ComplexExpandVariables]], 
          AtomicDensityMatrix`DensityMatrix`Private`timeDependence = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`DMElementPattern, 
            AtomicDensityMatrix`TimeDependence, 
            OptionValue[AtomicDensityMatrix`TimeDependence]]}, 
         Condition[
          Switch[{
            First[AtomicDensityMatrix`DensityMatrix`Private`representation], 
            AtomicDensityMatrix`DensityMatrix`Private`complexExpandVariables, 
            AtomicDensityMatrix`DensityMatrix`Private`timeDependence}, {
           "Zeeman", 
            Alternatives[True, False], False}, 
           AtomicDensityMatrix`DensityMatrix`Private`dmElementPattern[
           AtomicDensityMatrix`DensityMatrix`Private`dmSymbol], {"Zeeman", 
            Alternatives[True, False], True}, 
           AtomicDensityMatrix`DensityMatrix`Private`dmElementTDPattern[
           AtomicDensityMatrix`DensityMatrix`Private`dmSymbol], {"Zeeman", 
            Alternatives[True, False], All}, 
           Alternatives[
            AtomicDensityMatrix`DensityMatrix`Private`dmElementPattern[
            AtomicDensityMatrix`DensityMatrix`Private`dmSymbol], 
            AtomicDensityMatrix`DensityMatrix`Private`dmElementTDPattern[
            AtomicDensityMatrix`DensityMatrix`Private`dmSymbol]], {
           "Zeeman", Subscript, False}, 
           AtomicDensityMatrix`DensityMatrix`Private`dmElementPartPattern[
           AtomicDensityMatrix`DensityMatrix`Private`dmSymbol], {
           "Zeeman", Subscript, True}, 
           AtomicDensityMatrix`DensityMatrix`Private`dmElementPartTDPattern[
           AtomicDensityMatrix`DensityMatrix`Private`dmSymbol], {
           "Zeeman", Subscript, All}, 
           Alternatives[
            AtomicDensityMatrix`DensityMatrix`Private`dmElementPartPattern[
            AtomicDensityMatrix`DensityMatrix`Private`dmSymbol], 
            AtomicDensityMatrix`DensityMatrix`Private`dmElementPartTDPattern[
            AtomicDensityMatrix`DensityMatrix`Private`dmSymbol]], {
           "PolarizationMoments", 
            Alternatives[True, False], False}, 
           AtomicDensityMatrix`DensityMatrix`Private`pmPattern[
           AtomicDensityMatrix`DensityMatrix`Private`dmSymbol], {
           "PolarizationMoments", 
            Alternatives[True, False], True}, 
           AtomicDensityMatrix`DensityMatrix`Private`pmTDPattern[
           AtomicDensityMatrix`DensityMatrix`Private`dmSymbol], {
           "PolarizationMoments", 
            Alternatives[True, False], All}, 
           Alternatives[
            AtomicDensityMatrix`DensityMatrix`Private`pmPattern[
            AtomicDensityMatrix`DensityMatrix`Private`dmSymbol], 
            AtomicDensityMatrix`DensityMatrix`Private`pmTDPattern[
            AtomicDensityMatrix`DensityMatrix`Private`dmSymbol]], {
           "PolarizationMoments", Subscript, False}, 
           AtomicDensityMatrix`DensityMatrix`Private`pmPartPattern[
           AtomicDensityMatrix`DensityMatrix`Private`dmSymbol], {
           "PolarizationMoments", Subscript, True}, 
           AtomicDensityMatrix`DensityMatrix`Private`pmPartTDPattern[
           AtomicDensityMatrix`DensityMatrix`Private`dmSymbol], {
           "PolarizationMoments", Subscript, All}, 
           Alternatives[
            AtomicDensityMatrix`DensityMatrix`Private`pmPartPattern[
            AtomicDensityMatrix`DensityMatrix`Private`dmSymbol], 
            AtomicDensityMatrix`DensityMatrix`Private`pmPartTDPattern[
            AtomicDensityMatrix`DensityMatrix`Private`dmSymbol]]], 
          
          FreeQ[{{AtomicDensityMatrix`DensityMatrix`Private`representation, 
             AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
             AtomicDensityMatrix`DensityMatrix`Private`complexExpandVariables,
              AtomicDensityMatrix`DensityMatrix`Private`timeDependence}}, \
$Failed]]], 
       Options[AtomicDensityMatrix`DMElementPattern] = {
        AtomicDensityMatrix`TimeDependence -> Automatic, 
         AtomicDensityMatrix`Representation -> Automatic, 
         AtomicDensityMatrix`DMSymbol -> Automatic, 
         AtomicDensityMatrix`ComplexExpandVariables -> Automatic, 
         AtomicDensityMatrix`AllowedElements -> Automatic, 
         AtomicDensityMatrix`NeglectedElements -> Automatic, 
         AtomicDensityMatrix`Subspace -> Automatic}, 
       TagSet[AtomicDensityMatrix`DMElementPattern, 
        MessageName[AtomicDensityMatrix`DMElementPattern, "usage"], ""], 
       AtomicDensityMatrix`DensityMatrix`Private`dmElementPattern[
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
          Blank[]]] = 
       Subscript[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
         Alternatives[
          PatternSequence[], 
          Pattern[AtomicDensityMatrix`DMLabel, 
           Except[
            Alternatives[Re, Im]]]], 
         Pattern[AtomicDensityMatrix`State1, 
          Alternatives[{
            Pattern[AtomicDensityMatrix`StateLabel1, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`F1, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`M1, 
             Blank[]]}, {
            Pattern[AtomicDensityMatrix`StateLabel1, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`M1, 
             Blank[]]}, 
           PatternTest[
            Pattern[AtomicDensityMatrix`StateLabel1, 
             Blank[]], Not[
             ListQ[#]]& ]]], 
         Pattern[AtomicDensityMatrix`State2, 
          Alternatives[{
            Pattern[AtomicDensityMatrix`StateLabel2, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`F2, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`M2, 
             Blank[]]}, {
            Pattern[AtomicDensityMatrix`StateLabel2, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`M2, 
             Blank[]]}, 
           PatternTest[
            Pattern[AtomicDensityMatrix`StateLabel2, 
             Blank[]], Not[
             ListQ[#]]& ]]]], 
       TagSet[AtomicDensityMatrix`State1, 
        MessageName[AtomicDensityMatrix`State1, "usage"], ""], 
       TagSet[AtomicDensityMatrix`StateLabel1, 
        MessageName[AtomicDensityMatrix`StateLabel1, "usage"], ""], 
       TagSet[AtomicDensityMatrix`F1, 
        MessageName[AtomicDensityMatrix`F1, "usage"], ""], 
       TagSet[AtomicDensityMatrix`M1, 
        MessageName[AtomicDensityMatrix`M1, "usage"], ""], 
       TagSet[AtomicDensityMatrix`State2, 
        MessageName[AtomicDensityMatrix`State2, "usage"], ""], 
       TagSet[AtomicDensityMatrix`StateLabel2, 
        MessageName[AtomicDensityMatrix`StateLabel2, "usage"], ""], 
       TagSet[AtomicDensityMatrix`F2, 
        MessageName[AtomicDensityMatrix`F2, "usage"], ""], 
       TagSet[AtomicDensityMatrix`M2, 
        MessageName[AtomicDensityMatrix`M2, "usage"], ""], 
       AtomicDensityMatrix`DensityMatrix`Private`dmElementTDPattern[
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
          Blank[]]] = Alternatives[
         Subscript[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
          Alternatives[
           PatternSequence[], 
           Pattern[AtomicDensityMatrix`DMLabel, 
            Except[
             Alternatives[Re, Im]]]], 
          Pattern[AtomicDensityMatrix`State1, 
           Alternatives[{
             Pattern[AtomicDensityMatrix`StateLabel1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`F1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`M1, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`StateLabel1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`M1, 
              Blank[]]}, 
            PatternTest[
             Pattern[AtomicDensityMatrix`StateLabel1, 
              Blank[]], Not[
              ListQ[#]]& ]]], 
          Pattern[AtomicDensityMatrix`State2, 
           Alternatives[{
             Pattern[AtomicDensityMatrix`StateLabel2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`F2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`M2, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`StateLabel2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`M2, 
              Blank[]]}, 
            PatternTest[
             Pattern[AtomicDensityMatrix`StateLabel2, 
              Blank[]], Not[
              ListQ[#]]& ]]]][
          Pattern[AtomicDensityMatrix`Time, 
           Blank[]]], 
         Derivative[
          Pattern[AtomicDensityMatrix`TimeDerivative, 
           Blank[]]][
          Subscript[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
           Alternatives[
            PatternSequence[], 
            Pattern[AtomicDensityMatrix`DMLabel, 
             Except[
              Alternatives[Re, Im]]]], 
           Pattern[AtomicDensityMatrix`State1, 
            Alternatives[{
              Pattern[AtomicDensityMatrix`StateLabel1, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`F1, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`M1, 
               Blank[]]}, {
              Pattern[AtomicDensityMatrix`StateLabel1, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`M1, 
               Blank[]]}, 
             PatternTest[
              Pattern[AtomicDensityMatrix`StateLabel1, 
               Blank[]], Not[
               ListQ[#]]& ]]], 
           Pattern[AtomicDensityMatrix`State2, 
            Alternatives[{
              Pattern[AtomicDensityMatrix`StateLabel2, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`F2, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`M2, 
               Blank[]]}, {
              Pattern[AtomicDensityMatrix`StateLabel2, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`M2, 
               Blank[]]}, 
             PatternTest[
              Pattern[AtomicDensityMatrix`StateLabel2, 
               Blank[]], Not[
               ListQ[#]]& ]]]]][
          Pattern[AtomicDensityMatrix`Time, 
           Blank[]]]], 
       TagSet[AtomicDensityMatrix`Time, 
        MessageName[AtomicDensityMatrix`Time, "usage"], ""], 
       TagSet[AtomicDensityMatrix`TimeDerivative, 
        MessageName[AtomicDensityMatrix`TimeDerivative, "usage"], ""], 
       AtomicDensityMatrix`DensityMatrix`Private`dmElementPartPattern[
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
          Blank[]]] = 
       Subscript[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
         Pattern[Part, 
          Alternatives[Re, Im]], 
         Alternatives[
          PatternSequence[], 
          Pattern[AtomicDensityMatrix`DMLabel, 
           Except[
            Alternatives[Re, Im]]]], 
         Pattern[AtomicDensityMatrix`State1, 
          Alternatives[{
            Pattern[AtomicDensityMatrix`StateLabel1, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`F1, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`M1, 
             Blank[]]}, {
            Pattern[AtomicDensityMatrix`StateLabel1, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`M1, 
             Blank[]]}, 
           PatternTest[
            Pattern[AtomicDensityMatrix`StateLabel1, 
             Blank[]], Not[
             ListQ[#]]& ]]], 
         Pattern[AtomicDensityMatrix`State2, 
          Alternatives[{
            Pattern[AtomicDensityMatrix`StateLabel2, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`F2, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`M2, 
             Blank[]]}, {
            Pattern[AtomicDensityMatrix`StateLabel2, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`M2, 
             Blank[]]}, 
           PatternTest[
            Pattern[AtomicDensityMatrix`StateLabel2, 
             Blank[]], Not[
             ListQ[#]]& ]]]], 
       AtomicDensityMatrix`DensityMatrix`Private`dmElementPartTDPattern[
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
          Blank[]]] = Alternatives[
         Subscript[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
          Pattern[Part, 
           Alternatives[Re, Im]], 
          Alternatives[
           PatternSequence[], 
           Pattern[AtomicDensityMatrix`DMLabel, 
            Except[
             Alternatives[Re, Im]]]], 
          Pattern[AtomicDensityMatrix`State1, 
           Alternatives[{
             Pattern[AtomicDensityMatrix`StateLabel1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`F1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`M1, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`StateLabel1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`M1, 
              Blank[]]}, 
            PatternTest[
             Pattern[AtomicDensityMatrix`StateLabel1, 
              Blank[]], Not[
              ListQ[#]]& ]]], 
          Pattern[AtomicDensityMatrix`State2, 
           Alternatives[{
             Pattern[AtomicDensityMatrix`StateLabel2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`F2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`M2, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`StateLabel2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`M2, 
              Blank[]]}, 
            PatternTest[
             Pattern[AtomicDensityMatrix`StateLabel2, 
              Blank[]], Not[
              ListQ[#]]& ]]]][
          Pattern[AtomicDensityMatrix`Time, 
           Blank[]]], 
         Derivative[
          Pattern[AtomicDensityMatrix`TimeDerivative, 
           Blank[]]][
          Subscript[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
           Pattern[Part, 
            Alternatives[Re, Im]], 
           Alternatives[
            PatternSequence[], 
            Pattern[AtomicDensityMatrix`DMLabel, 
             Except[
              Alternatives[Re, Im]]]], 
           Pattern[AtomicDensityMatrix`State1, 
            Alternatives[{
              Pattern[AtomicDensityMatrix`StateLabel1, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`F1, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`M1, 
               Blank[]]}, {
              Pattern[AtomicDensityMatrix`StateLabel1, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`M1, 
               Blank[]]}, 
             PatternTest[
              Pattern[AtomicDensityMatrix`StateLabel1, 
               Blank[]], Not[
               ListQ[#]]& ]]], 
           Pattern[AtomicDensityMatrix`State2, 
            Alternatives[{
              Pattern[AtomicDensityMatrix`StateLabel2, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`F2, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`M2, 
               Blank[]]}, {
              Pattern[AtomicDensityMatrix`StateLabel2, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`M2, 
               Blank[]]}, 
             PatternTest[
              Pattern[AtomicDensityMatrix`StateLabel2, 
               Blank[]], Not[
               ListQ[#]]& ]]]]][
          Pattern[AtomicDensityMatrix`Time, 
           Blank[]]]], AtomicDensityMatrix`DensityMatrix`Private`pmPattern[
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
          Blank[]]] = 
       Subscript[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
         Alternatives[
          PatternSequence[], 
          Pattern[AtomicDensityMatrix`DMLabel, 
           Except[
            Alternatives[Re, Im]]]], {
          Pattern[AtomicDensityMatrix`StateLabel1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`StateLabel2, 
           Blank[]]}, {
          Pattern[AtomicDensityMatrix`Rank, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`Component, 
           Blank[]]}], AtomicDensityMatrix`Component[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`type, {"Scalar"}]}] := 
       AtomicDensityMatrix`TensorAlgebra`Private`a, Condition[
         AtomicDensityMatrix`Component[{
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, 
            Alternatives[{"OneByOne", 
              BlankNullSequence[]}, {"TensorDecompositionMatrix", 
              BlankSequence[]}]]}], 
         MatchQ[
          Dimensions[AtomicDensityMatrix`TensorAlgebra`Private`a], {1, 1, 
           BlankNullSequence[]}]] := 
       Part[AtomicDensityMatrix`TensorAlgebra`Private`a, 1, 1], 
       AtomicDensityMatrix`Component[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, 
           Alternatives[{"Operator"}, {"OneByOne", 
             BlankNullSequence[]}]]}, {
          PatternTest[
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m1, 
            Blank[]], AtomicDensityMatrix`HalfIntegerQ], 
          PatternTest[
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`m2, 
            Blank[]], AtomicDensityMatrix`HalfIntegerQ]}] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`rank = 
          AtomicDensityMatrix`Rank[{
            AtomicDensityMatrix`TensorAlgebra`Private`a, 
             AtomicDensityMatrix`TensorAlgebra`Private`type}]}, 
         Part[
         AtomicDensityMatrix`TensorAlgebra`Private`a, -(
           AtomicDensityMatrix`TensorAlgebra`Private`m1 + 
           AtomicDensityMatrix`TensorAlgebra`Private`rank + 1), -(
           AtomicDensityMatrix`TensorAlgebra`Private`m2 + 
           AtomicDensityMatrix`TensorAlgebra`Private`rank + 1)]], 
       AtomicDensityMatrix`Component[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Alternatives["Scalar", "OneByOne"], 
            BlankNullSequence[]}]}, 0] := 
       AtomicDensityMatrix`Component[{
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`TensorAlgebra`Private`type}], 
       AtomicDensityMatrix`Component[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`type, {"Cartesian", 
            BlankNullSequence[]}]}, 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`i, 
          Blank[Integer]]] := 
       Part[AtomicDensityMatrix`TensorAlgebra`Private`a, 
         AtomicDensityMatrix`TensorAlgebra`Private`i], 
       AtomicDensityMatrix`Component[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`type, {
           "TensorDecomposition", 
            BlankSequence[]}]}, 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`k, 
          Blank[Integer]]] := First[
         Select[
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
          AtomicDensityMatrix`Rank[{#, 
             Rest[AtomicDensityMatrix`TensorAlgebra`Private`type]}] == 
          AtomicDensityMatrix`TensorAlgebra`Private`k& , 1]], 
       AtomicDensityMatrix`Component[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`type, {"Covariant", 
            BlankNullSequence[]}]}, 
         PatternTest[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`q, 
           Blank[]], AtomicDensityMatrix`HalfIntegerQ]] := 
       Part[AtomicDensityMatrix`TensorAlgebra`Private`a, 
         1, -(AtomicDensityMatrix`TensorAlgebra`Private`q + 
          AtomicDensityMatrix`Rank[{
            AtomicDensityMatrix`TensorAlgebra`Private`a, 
             AtomicDensityMatrix`TensorAlgebra`Private`type}] + 1)], 
       AtomicDensityMatrix`Component[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`type, {"Contravariant", 
            BlankNullSequence[]}]}, 
         PatternTest[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`q, 
           Blank[]], AtomicDensityMatrix`HalfIntegerQ]] := 
       Part[AtomicDensityMatrix`TensorAlgebra`Private`a, -(
          AtomicDensityMatrix`TensorAlgebra`Private`q + 
          AtomicDensityMatrix`Rank[{
            AtomicDensityMatrix`TensorAlgebra`Private`a, 
             AtomicDensityMatrix`TensorAlgebra`Private`type}] + 1), 1], 
       AtomicDensityMatrix`Component[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}, 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`q, 
          Blank[]]] := Message[
         MessageName[AtomicDensityMatrix`Component, "wrongspec"], 
         AtomicDensityMatrix`TensorAlgebra`Private`type, 
         AtomicDensityMatrix`TensorAlgebra`Private`q], Condition[
         AtomicDensityMatrix`Component[{
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
             Repeated[
              Alternatives[
              "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator",
                "OneByOne", "TensorDecomposition", 
               "TensorDecompositionMatrix"]]}]}, 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`indices, 
           BlankSequence[]]], 
         Length[{AtomicDensityMatrix`TensorAlgebra`Private`indices}] <= 
         Length[AtomicDensityMatrix`TensorAlgebra`Private`type]] := First[
         Fold[{
           AtomicDensityMatrix`Component[
            SlotSequence[1]], 
           Rest[
            Last[#]]}& , {
          AtomicDensityMatrix`TensorAlgebra`Private`a, 
           AtomicDensityMatrix`TensorAlgebra`Private`type}, {
          AtomicDensityMatrix`TensorAlgebra`Private`indices}]], 
       AtomicDensityMatrix`Component[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}, 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`indices, 
          BlankSequence[]]] := Message[
         MessageName[AtomicDensityMatrix`Component, "extraindices"], 
         AtomicDensityMatrix`TensorAlgebra`Private`type, 
         Length[{AtomicDensityMatrix`TensorAlgebra`Private`type}], 
         Length[{AtomicDensityMatrix`TensorAlgebra`Private`indices}]], 
       AtomicDensityMatrix`Component[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Except[
           Alternatives[{
             Blank[], {
              Repeated[
               Alternatives[
               "Scalar", "Cartesian", "Contravariant", "Covariant", 
                "Operator", "OneByOne", "TensorDecomposition", 
                "TensorDecompositionMatrix"]]}}, {
             Repeated[
              Blank[AtomicDensityMatrix`AtomicState]]}]]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`args, 
          BlankSequence[]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`type = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`a], 
          AtomicDensityMatrix`TensorAlgebra`Private`noMessage = True, 
          AtomicDensityMatrix`TensorAlgebra`Private`result}, 
         AtomicDensityMatrix`TensorAlgebra`Private`result = Check[
            AtomicDensityMatrix`TensorAlgebra`Private`QuietCheck[
             
             AtomicDensityMatrix`Component[{
              AtomicDensityMatrix`TensorAlgebra`Private`a, 
               AtomicDensityMatrix`TensorAlgebra`Private`type}, 
              AtomicDensityMatrix`TensorAlgebra`Private`args], 
             If[Length[{AtomicDensityMatrix`TensorAlgebra`Private`args}] == 1, 
              Message[
               MessageName[AtomicDensityMatrix`Component, "noexist"], 
               AtomicDensityMatrix`TensorAlgebra`Private`type, 
               AtomicDensityMatrix`TensorAlgebra`Private`args], 
              Message[
               MessageName[AtomicDensityMatrix`Component, "noexistn"], 
               AtomicDensityMatrix`TensorAlgebra`Private`type, {
               AtomicDensityMatrix`TensorAlgebra`Private`args}]], {
              MessageName[Part, "partw"]}], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage = False]; 
         Condition[
          AtomicDensityMatrix`TensorAlgebra`Private`result, 
           AtomicDensityMatrix`TensorAlgebra`Private`noMessage]], 
       AtomicDensityMatrix`Component[
         PatternTest[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, 
           Alternatives[{"Operator"}, {"OneByOne", 
             BlankNullSequence[]}]]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`s1, 
           Blank[AtomicDensityMatrix`AtomicState]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`s2, 
           Blank[AtomicDensityMatrix`AtomicState]]}] := 
       AtomicDensityMatrix`MatrixElement[
        AtomicDensityMatrix`TensorAlgebra`Private`sys, 
         AtomicDensityMatrix`TensorAlgebra`Private`a, {
         AtomicDensityMatrix`TensorAlgebra`Private`s1, 
          AtomicDensityMatrix`TensorAlgebra`Private`s2}], 
       AtomicDensityMatrix`Component[
         PatternTest[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[
          AtomicDensityMatrix`TensorAlgebra`Private`type, {
           "TensorDecompositionMatrix", 
            BlankSequence[]}]}, {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`s1, 
           Blank[AtomicDensityMatrix`AtomicState]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`s2, 
           Blank[AtomicDensityMatrix`AtomicState]]}] := 
       AtomicDensityMatrix`MatrixElement[
         AtomicDensityMatrix`RemoveZeemanSublevels[
         AtomicDensityMatrix`TensorAlgebra`Private`sys], 
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
         Map[
         AtomicDensityMatrix`DeleteParameter[#, AtomicDensityMatrix`M]& , {
          AtomicDensityMatrix`TensorAlgebra`Private`s1, 
           AtomicDensityMatrix`TensorAlgebra`Private`s2}]], 
       AtomicDensityMatrix`Component[
         PatternTest[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}, 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`k, 
          Blank[]]] := Message[
         MessageName[AtomicDensityMatrix`Component, "wrongspec"], 
         AtomicDensityMatrix`TensorAlgebra`Private`type, 
         AtomicDensityMatrix`TensorAlgebra`Private`k], Condition[
         AtomicDensityMatrix`Component[
          PatternTest[
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`sys, 
            Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
             Repeated[
              Alternatives[
              "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator",
                "OneByOne", "TensorDecomposition", 
               "TensorDecompositionMatrix"]]}]}, 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`indices, 
           BlankSequence[]]], 
         Length[{AtomicDensityMatrix`TensorAlgebra`Private`indices}] <= 
         Length[AtomicDensityMatrix`TensorAlgebra`Private`type]] := First[
         Fold[{
           If[
            MatchQ[
             Part[#, 2, 1], 
             Alternatives["Operator", "TensorDecompositionMatrix"]], 
            AtomicDensityMatrix`Component[
            AtomicDensityMatrix`TensorAlgebra`Private`sys, 
             SlotSequence[1]], 
            AtomicDensityMatrix`Component[
             SlotSequence[1]]], 
           Rest[
            Last[#]]}& , {
          AtomicDensityMatrix`TensorAlgebra`Private`a, 
           AtomicDensityMatrix`TensorAlgebra`Private`type}, {
          AtomicDensityMatrix`TensorAlgebra`Private`indices}]], 
       AtomicDensityMatrix`Component[
         PatternTest[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}, 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`indices, 
          BlankSequence[]]] := Message[
         MessageName[AtomicDensityMatrix`Component, "extraindices"], 
         AtomicDensityMatrix`TensorAlgebra`Private`type, 
         Length[{AtomicDensityMatrix`TensorAlgebra`Private`type}], 
         Length[{AtomicDensityMatrix`TensorAlgebra`Private`indices}]], 
       AtomicDensityMatrix`Component[
         PatternTest[
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Except[{
            Blank[], {
             Repeated[
              Alternatives[
              "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator",
                "OneByOne", "TensorDecomposition", 
               "TensorDecompositionMatrix"]]}}]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`args, 
          BlankSequence[]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`type = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`a], 
          AtomicDensityMatrix`TensorAlgebra`Private`noMessage = True, 
          AtomicDensityMatrix`TensorAlgebra`Private`result}, 
         AtomicDensityMatrix`TensorAlgebra`Private`result = Check[
            AtomicDensityMatrix`TensorAlgebra`Private`QuietCheck[
             AtomicDensityMatrix`Component[
             AtomicDensityMatrix`TensorAlgebra`Private`sys, {
              AtomicDensityMatrix`TensorAlgebra`Private`a, 
               AtomicDensityMatrix`TensorAlgebra`Private`type}, 
              AtomicDensityMatrix`TensorAlgebra`Private`args], 
             If[Length[{AtomicDensityMatrix`TensorAlgebra`Private`args}] == 1, 
              Message[
               MessageName[AtomicDensityMatrix`Component, "noexist"], 
               AtomicDensityMatrix`TensorAlgebra`Private`type, 
               AtomicDensityMatrix`TensorAlgebra`Private`args], 
              Message[
               MessageName[AtomicDensityMatrix`Component, "noexistn"], 
               AtomicDensityMatrix`TensorAlgebra`Private`type, {
               AtomicDensityMatrix`TensorAlgebra`Private`args}]], {
              MessageName[Part, "partw"], 
              MessageName[Extract, "psl1"]}], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage = False]; 
         Condition[
          AtomicDensityMatrix`TensorAlgebra`Private`result, 
           AtomicDensityMatrix`TensorAlgebra`Private`noMessage]], 
       AtomicDensityMatrix`Component[{
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`TensorAlgebra`Private`type, {
            Repeated[
             Alternatives[
             "Scalar", "Cartesian", "Contravariant", "Covariant", "Operator", 
              "OneByOne", "TensorDecomposition", 
              "TensorDecompositionMatrix"]]}]}] := Condition[Null, 
         Message[
          MessageName[AtomicDensityMatrix`Component, "wrongtype"], 
          AtomicDensityMatrix`TensorAlgebra`Private`type]], 
       AtomicDensityMatrix`Component[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Except[
           Alternatives[{
             Blank[], {
              Repeated[
               Alternatives[
               "Scalar", "Cartesian", "Contravariant", "Covariant", 
                "Operator", "OneByOne", "TensorDecomposition", 
                "TensorDecompositionMatrix"]]}}, {
             Repeated[
              Blank[AtomicDensityMatrix`AtomicState]]}]]]] := 
       Module[{AtomicDensityMatrix`TensorAlgebra`Private`type$ = 
          AtomicDensityMatrix`TensorType[
           AtomicDensityMatrix`TensorAlgebra`Private`a], 
          AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = True, 
          AtomicDensityMatrix`TensorAlgebra`Private`result$}, 
         AtomicDensityMatrix`TensorAlgebra`Private`result$ = Check[
            
            AtomicDensityMatrix`Component[{
             AtomicDensityMatrix`TensorAlgebra`Private`a, 
              AtomicDensityMatrix`TensorAlgebra`Private`type$}], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$ = False]; 
         Condition[AtomicDensityMatrix`TensorAlgebra`Private`result$, 
           And[
            AtomicDensityMatrix`TensorTypeQ[
            AtomicDensityMatrix`TensorAlgebra`Private`type$], 
            AtomicDensityMatrix`TensorAlgebra`Private`noMessage$, True]]], 
       TagSet[AtomicDensityMatrix`Component, 
        MessageName[AtomicDensityMatrix`Component, "extraindices"], 
        "`3` indices specified for tensor of type `1`, which can take at most \
`2`."], 
       TagSet[AtomicDensityMatrix`Component, 
        MessageName[AtomicDensityMatrix`Component, "noexist"], 
        "The component `2` of tensor of type `1` does not exist."], 
       TagSet[AtomicDensityMatrix`Component, 
        MessageName[AtomicDensityMatrix`Component, "noexistn"], 
        "The component of tensor of type `1` specified by the sequence `2` \
does not exist."], 
       TagSet[AtomicDensityMatrix`Component, 
        MessageName[AtomicDensityMatrix`Component, "usage"], 
        "\!\(\*TagBox[RowBox[{\"Component[\", StyleBox[RowBox[{\"tens,q\"}], \
\"TI\"], \"] extracts the \", StyleBox[\"q\", \"TI\"], \"\[Hyphen]th \
component of a spherical tensor \", StyleBox[\"tens\", \"TI\"], \".\", \"\
\[LineSeparator]\", \"Component[\", StyleBox[\"cart\", \"TI\"], \",\", \
StyleBox[\"i\", \"TI\"], \"] extracts the \", StyleBox[\"i\", \"TI\"], \"\
\[Hyphen]th component of a Cartesian vector \", StyleBox[\"cart\", \"TI\"], \
\".\", \"\[LineSeparator]\", \"Component[\", StyleBox[\"decomp\", \"TI\"], \
\", \", StyleBox[\"k\", \"TI\"], \"] extracts the spherical tensor of rank \
\", StyleBox[\"k\", \"TI\"], \" from a tensor decomposition \", \
StyleBox[\"decomp\", \"TI\"], \".\", \"\[LineSeparator]\", \"Component[\", \
StyleBox[\"op\", \"TI\"], \",{\", SubscriptBox[StyleBox[\"m\", \"TI\"], \
StyleBox[\"1\", \"TR\"]], \",\", SubscriptBox[StyleBox[\"m\", \"TI\"], \
StyleBox[\"2\", \"TR\"]], \"}] extracts the matrix element corresponding to \
sublevels with angular\[Hyphen]momentum\[Hyphen]projection quantum numbers \
\", SubscriptBox[StyleBox[\"m\", \"TI\"], StyleBox[\"1\", \"TR\"]], \" and \
\", SubscriptBox[StyleBox[\"m\", \"TI\"], StyleBox[\"2\", \"TR\"]], \" from \
an operator \", StyleBox[\"op\", \"TI\"], \".\", \"\[LineSeparator]\", \
\"Component[\", StyleBox[\"sys\", \"TI\"], \",\", StyleBox[\"op\", \"TI\"], \
\",{\", SubscriptBox[StyleBox[\"s\", \"TI\"], StyleBox[\"1\", \"TR\"]], \
\",\", SubscriptBox[StyleBox[\"s\", \"TI\"], StyleBox[\"2\", \"TR\"]], \"}] \
extracts the matrix element of operator \", StyleBox[\"op\", \"TI\"], \" \
corresponding to the states \", SubscriptBox[StyleBox[\"s\", \"TI\"], \
StyleBox[\"1\", \"TR\"]], \" and \", SubscriptBox[StyleBox[\"s\", \"TI\"], \
StyleBox[\"2\", \"TR\"]], \" of atomic system \", StyleBox[\"sys\", \"TI\"], \
\".\", \"\[LineSeparator]\", \"Component[\", StyleBox[\"sys\", \"TI\"], \
\",\", StyleBox[\"mat\", \"TI\"], \",{\", SubscriptBox[StyleBox[\"s\", \
\"TI\"], StyleBox[\"1\", \"TR\"]], \",\", SubscriptBox[StyleBox[\"s\", \
\"TI\"], StyleBox[\"2\", \"TR\"]], \"}] extracts the tensor decomposition \
from the tensor\[Hyphen]decomposition matrix \", StyleBox[\"mat\", \"TI\"], \
\" corresponding to the states \", SubscriptBox[StyleBox[\"s\", \"TI\"], \
StyleBox[\"1\", \"TR\"]], \" and \", SubscriptBox[StyleBox[\"s\", \"TI\"], \
StyleBox[\"2\", \"TR\"]], \".\"}], DisplayForm]\)"], 
       TagSet[AtomicDensityMatrix`Component, 
        MessageName[AtomicDensityMatrix`Component, "wrongspec"], 
        "`2` is not an allowed component specification for tensor of type \
`1`."], 
       TagSet[AtomicDensityMatrix`Component, 
        MessageName[AtomicDensityMatrix`Component, "wrongtype"], 
        "Tensor of type `1` does not have a single component."], 
       AtomicDensityMatrix`MatrixElement[
         PatternTest[
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`a, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`s1, 
           Blank[AtomicDensityMatrix`AtomicState]], 
          Pattern[AtomicDensityMatrix`AtomicSystem`Private`s2, 
           Blank[AtomicDensityMatrix`AtomicState]]}] := 
       Extract[AtomicDensityMatrix`AtomicSystem`Private`a, 
         Map[Part[
           Position[
           AtomicDensityMatrix`AtomicSystem`Private`sys, #, {1}, 1, Heads -> 
            False], 1, 1]& , {
          AtomicDensityMatrix`AtomicSystem`Private`s1, 
           AtomicDensityMatrix`AtomicSystem`Private`s2}]], 
       TagSet[AtomicDensityMatrix`MatrixElement, 
        MessageName[AtomicDensityMatrix`MatrixElement, "usage"], ""], 
       AtomicDensityMatrix`DensityMatrix`Private`pmTDPattern[
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
          Blank[]]] = Alternatives[
         Subscript[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
          Alternatives[
           PatternSequence[], 
           Pattern[AtomicDensityMatrix`DMLabel, 
            Except[
             Alternatives[Re, Im]]]], {
           Pattern[AtomicDensityMatrix`StateLabel1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`StateLabel2, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`Rank, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`Component, 
            Blank[]]}][
          Pattern[AtomicDensityMatrix`Time, 
           Blank[]]], 
         Derivative[
          Pattern[AtomicDensityMatrix`TimeDerivative, 
           Blank[]]][
          Subscript[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
           Alternatives[
            PatternSequence[], 
            Pattern[AtomicDensityMatrix`DMLabel, 
             Except[
              Alternatives[Re, Im]]]], {
            Pattern[AtomicDensityMatrix`StateLabel1, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`StateLabel2, 
             Blank[]]}, {
            Pattern[AtomicDensityMatrix`Rank, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`Component, 
             Blank[]]}]][
          Pattern[AtomicDensityMatrix`Time, 
           Blank[]]]], AtomicDensityMatrix`DensityMatrix`Private`pmPartPattern[
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
          Blank[]]] = 
       Subscript[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
         Pattern[Part, 
          Alternatives[Re, Im]], 
         Alternatives[
          PatternSequence[], 
          Pattern[AtomicDensityMatrix`DMLabel, 
           Except[
            Alternatives[Re, Im]]]], {
          Pattern[AtomicDensityMatrix`StateLabel1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`StateLabel2, 
           Blank[]]}, {
          Pattern[AtomicDensityMatrix`Rank, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`Component, 
           Blank[]]}], 
       AtomicDensityMatrix`DensityMatrix`Private`pmPartTDPattern[
         Pattern[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
          Blank[]]] = Alternatives[
         Subscript[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
          Pattern[Part, 
           Alternatives[Re, Im]], 
          Alternatives[
           PatternSequence[], 
           Pattern[AtomicDensityMatrix`DMLabel, 
            Except[
             Alternatives[Re, Im]]]], {
           Pattern[AtomicDensityMatrix`StateLabel1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`StateLabel2, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`Rank, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`Component, 
            Blank[]]}][
          Pattern[AtomicDensityMatrix`Time, 
           Blank[]]], 
         Derivative[
          Pattern[AtomicDensityMatrix`TimeDerivative, 
           Blank[]]][
          Subscript[AtomicDensityMatrix`DensityMatrix`Private`dmSymbol, 
           Pattern[Part, 
            Alternatives[Re, Im]], 
           Alternatives[
            PatternSequence[], 
            Pattern[AtomicDensityMatrix`DMLabel, 
             Except[
              Alternatives[Re, Im]]]], {
            Pattern[AtomicDensityMatrix`StateLabel1, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`StateLabel2, 
             Blank[]]}, {
            Pattern[AtomicDensityMatrix`Rank, 
             Blank[]], 
            Pattern[AtomicDensityMatrix`Component, 
             Blank[]]}]][
          Pattern[AtomicDensityMatrix`Time, 
           Blank[]]]], AtomicDensityMatrix`PolarizationMoments[
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`j, 
           Blank[]], AtomicDensityMatrix`HalfIntegerQ], 
         Pattern[AtomicDensityMatrix`PolarizationMoments`Private`opts, 
          OptionsPattern[]]] := AtomicDensityMatrix`PolarizationMoments[
         AtomicDensityMatrix`ZeemanSystem[
         AtomicDensityMatrix`PolarizationMoments`Private`j], 
         AtomicDensityMatrix`PolarizationMoments`Private`opts], 
       AtomicDensityMatrix`PolarizationMoments[
         Pattern[AtomicDensityMatrix`PolarizationMoments`Private`label, 
          Blank[]], 
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`j, 
           Blank[]], AtomicDensityMatrix`HalfIntegerQ], 
         Pattern[AtomicDensityMatrix`PolarizationMoments`Private`opts, 
          OptionsPattern[]]] := AtomicDensityMatrix`PolarizationMoments[
         AtomicDensityMatrix`ZeemanSystem[
         AtomicDensityMatrix`PolarizationMoments`Private`label, 
          AtomicDensityMatrix`PolarizationMoments`Private`j], 
         AtomicDensityMatrix`PolarizationMoments`Private`opts], 
       AtomicDensityMatrix`PolarizationMoments[
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`PolarizationMoments`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`PolarizationMoments`Private`dmSymbol = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`PolarizationMoments, 
            AtomicDensityMatrix`DMSymbol, 
            OptionValue[AtomicDensityMatrix`DMSymbol]], 
          AtomicDensityMatrix`PolarizationMoments`Private`dmLabel = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`PolarizationMoments, 
            AtomicDensityMatrix`DMLabel, 
            OptionValue[AtomicDensityMatrix`DMLabel]], 
          AtomicDensityMatrix`PolarizationMoments`Private`timeVariable = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`PolarizationMoments, 
            AtomicDensityMatrix`TimeVariable, 
            OptionValue[AtomicDensityMatrix`TimeVariable]], 
          AtomicDensityMatrix`PolarizationMoments`Private`timeDependence = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`PolarizationMoments, 
            AtomicDensityMatrix`TimeDependence, 
            OptionValue[AtomicDensityMatrix`TimeDependence]], 
          AtomicDensityMatrix`PolarizationMoments`Private`allowedElements = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`PolarizationMoments, 
            AtomicDensityMatrix`AllowedElements, 
            OptionValue[AtomicDensityMatrix`AllowedElements]], 
          AtomicDensityMatrix`PolarizationMoments`Private`neglectedElements = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`PolarizationMoments, 
            AtomicDensityMatrix`NeglectedElements, 
            OptionValue[AtomicDensityMatrix`NeglectedElements]], 
          AtomicDensityMatrix`PolarizationMoments`Private`rank, 
          AtomicDensityMatrix`PolarizationMoments`Private`rankList, 
          AtomicDensityMatrix`PolarizationMoments`Private`elements, 
          AtomicDensityMatrix`PolarizationMoments`Private`levels, 
          AtomicDensityMatrix`PolarizationMoments`Private`labels, 
          AtomicDensityMatrix`PolarizationMoments`Private`pos, 
          AtomicDensityMatrix`PolarizationMoments`Private`zero, 
          AtomicDensityMatrix`PolarizationMoments`Private`f}, 
         Condition[
         AtomicDensityMatrix`PolarizationMoments`Private`levels = 
           AtomicDensityMatrix`RemoveZeemanSublevels[
            AtomicDensityMatrix`PolarizationMoments`Private`sys]; 
          AtomicDensityMatrix`PolarizationMoments`Private`labels = 
           AtomicDensityMatrix`LevelLabel[
            AtomicDensityMatrix`PolarizationMoments`Private`levels]; 
          AtomicDensityMatrix`PolarizationMoments`Private`pos = 
           Apply[Complement, 
             Map[
             AtomicDensityMatrix`PolarizationMomentPosition[
              AtomicDensityMatrix`PolarizationMoments`Private`sys, #, 
               
               FilterRules[{
                AtomicDensityMatrix`PolarizationMoments`Private`opts, 
                 Options[AtomicDensityMatrix`PolarizationMoments]}, 
                Options[AtomicDensityMatrix`PolarizationMomentPosition]]]& , {
              AtomicDensityMatrix`PolarizationMoments`Private`allowedElements,
                AtomicDensityMatrix`PolarizationMoments`Private`\
neglectedElements}]]; 
          AtomicDensityMatrix`PolarizationMoments`Private`f = 
           AtomicDensityMatrix`F[
            AtomicDensityMatrix`PolarizationMoments`Private`levels]; 
          AtomicDensityMatrix`PolarizationMoments`Private`zero = 
           AtomicDensityMatrix`ZeroTensorDecompositionMatrix[
            AtomicDensityMatrix`PolarizationMoments`Private`sys, 
             
             FilterRules[{
              AtomicDensityMatrix`PolarizationMoments`Private`opts, 
               Options[AtomicDensityMatrix`PolarizationMoments]}, 
              Options[AtomicDensityMatrix`ZeroTensorDecompositionMatrix]]]; 
          AtomicDensityMatrix`PolarizationMoments`Private`rank = 
           AtomicDensityMatrix`Rank[
            AtomicDensityMatrix`PolarizationMoments`Private`zero]; 
          AtomicDensityMatrix`PolarizationMoments`Private`rankList = 
           Map[Extract[AtomicDensityMatrix`PolarizationMoments`Private`rank, 
              Take[#, 3]]& , 
             AtomicDensityMatrix`PolarizationMoments`Private`pos]; 
          AtomicDensityMatrix`PolarizationMoments`Private`elements = 
           MapThread[
            Subscript[
             AtomicDensityMatrix`PolarizationMoments`Private`dmSymbol, 
              AtomicDensityMatrix`PolarizationMoments`Private`dmLabel, 
              Part[AtomicDensityMatrix`PolarizationMoments`Private`labels, 
               Take[#, 2]], {#2, -Part[#, 4] + #2 + 1}]& , {
             AtomicDensityMatrix`PolarizationMoments`Private`pos, 
              AtomicDensityMatrix`PolarizationMoments`Private`rankList}]; 
          If[AtomicDensityMatrix`PolarizationMoments`Private`timeDependence, 
            AtomicDensityMatrix`PolarizationMoments`Private`elements = Through[
              AtomicDensityMatrix`PolarizationMoments`Private`elements[
              AtomicDensityMatrix`PolarizationMoments`Private`timeVariable]]]; 
          AtomicDensityMatrix`PolarizationMoments`Private`ExpandPMVariables[
           AtomicDensityMatrix`PolarizationMoments`Private`sys, 
            ReplacePart[
            AtomicDensityMatrix`PolarizationMoments`Private`zero, 
             Thread[
             AtomicDensityMatrix`PolarizationMoments`Private`pos -> 
              AtomicDensityMatrix`PolarizationMoments`Private`elements]], 
            FilterRules[{AtomicDensityMatrix`PolarizationMoments`Private`opts, 
              Options[AtomicDensityMatrix`PolarizationMoments]}, 
             Options[
             AtomicDensityMatrix`PolarizationMoments`Private`\
ExpandPMVariables]]], 
          
          FreeQ[{{AtomicDensityMatrix`PolarizationMoments`Private`dmSymbol, 
             AtomicDensityMatrix`PolarizationMoments`Private`dmLabel, 
             AtomicDensityMatrix`PolarizationMoments`Private`timeVariable, 
             AtomicDensityMatrix`PolarizationMoments`Private`timeDependence, 
             AtomicDensityMatrix`PolarizationMoments`Private`allowedElements, 
             AtomicDensityMatrix`PolarizationMoments`Private`\
neglectedElements}}, $Failed]]], 
       Options[AtomicDensityMatrix`PolarizationMoments] = {
        AtomicDensityMatrix`TimeDependence -> Automatic, 
         AtomicDensityMatrix`DMSymbol -> Automatic, 
         AtomicDensityMatrix`DMLabel -> Automatic, 
         AtomicDensityMatrix`ComplexExpandVariables -> Automatic, 
         AtomicDensityMatrix`TimeVariable -> Automatic, 
         AtomicDensityMatrix`AllowedElements -> Automatic, 
         AtomicDensityMatrix`NeglectedElements -> Automatic, 
         AtomicDensityMatrix`Subspace -> Automatic, 
         AtomicDensityMatrix`MaxRanks -> Infinity}, 
       TagSet[AtomicDensityMatrix`PolarizationMoments, 
        MessageName[AtomicDensityMatrix`PolarizationMoments, "usage"], ""], 
       Attributes[AtomicDensityMatrix`LevelLabel] = {Listable}, 
       AtomicDensityMatrix`LevelLabel[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Blank[AtomicDensityMatrix`AtomicState]]] := Switch[
         AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicSystem`Private`s], 
         Alternatives["Toy", "Zeeman", "Fine"], 
         AtomicDensityMatrix`StateLabel[
         AtomicDensityMatrix`AtomicSystem`Private`s], 
         Alternatives["HyperfineZeeman", "Hyperfine"], {
          AtomicDensityMatrix`StateLabel[
          AtomicDensityMatrix`AtomicSystem`Private`s], 
          AtomicDensityMatrix`F[AtomicDensityMatrix`AtomicSystem`Private`s]}], 
       TagSet[AtomicDensityMatrix`LevelLabel, 
        MessageName[AtomicDensityMatrix`LevelLabel, "usage"], ""], 
       AtomicDensityMatrix`PolarizationMomentPosition[
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Alternatives[All, True], 
         Pattern[AtomicDensityMatrix`PolarizationMoments`Private`opts, 
          OptionsPattern[]]] := Position[
         AtomicDensityMatrix`ZeroTensorDecompositionMatrix[
         AtomicDensityMatrix`PolarizationMoments`Private`sys, 
          FilterRules[{AtomicDensityMatrix`PolarizationMoments`Private`opts, 
            Options[AtomicDensityMatrix`PolarizationMomentPosition]}, 
           Options[AtomicDensityMatrix`ZeroTensorDecompositionMatrix]]], 0], 
       AtomicDensityMatrix`PolarizationMomentPosition[
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Alternatives[None, False], 
         OptionsPattern[]] := {}, 
       Options[AtomicDensityMatrix`PolarizationMomentPosition] = {
        AtomicDensityMatrix`MaxRanks -> Automatic}, 
       TagSet[AtomicDensityMatrix`PolarizationMomentPosition, 
        MessageName[AtomicDensityMatrix`PolarizationMomentPosition, "usage"], 
        ""], AtomicDensityMatrix`ZeroTensorDecompositionMatrix[
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`PolarizationMoments`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`ZeroTensorDecompositionMatrix[
        AtomicDensityMatrix`PolarizationMoments`Private`sys, 
         AtomicDensityMatrix`PolarizationMoments`Private`sys, 
         AtomicDensityMatrix`PolarizationMoments`Private`opts], 
       AtomicDensityMatrix`ZeroTensorDecompositionMatrix[
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         OptionsPattern[]] := 
       Module[{AtomicDensityMatrix`PolarizationMoments`Private`maxRanks = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`ZeroTensorDecompositionMatrix, 
            AtomicDensityMatrix`MaxRanks, 
            OptionValue[AtomicDensityMatrix`MaxRanks]], 
          AtomicDensityMatrix`PolarizationMoments`Private`flist1 = 
          AtomicDensityMatrix`F[
            AtomicDensityMatrix`RemoveZeemanSublevels[
            AtomicDensityMatrix`PolarizationMoments`Private`sys1]], 
          AtomicDensityMatrix`PolarizationMoments`Private`flist2 = 
          AtomicDensityMatrix`F[
            AtomicDensityMatrix`RemoveZeemanSublevels[
            AtomicDensityMatrix`PolarizationMoments`Private`sys2]]}, 
         Condition[
          Table[
           Transpose[{
             Table[
             0, {AtomicDensityMatrix`PolarizationMoments`Private`q, -
               AtomicDensityMatrix`PolarizationMoments`Private`k, 
               AtomicDensityMatrix`PolarizationMoments`Private`k}]}], {
           AtomicDensityMatrix`PolarizationMoments`Private`f1, 
            AtomicDensityMatrix`PolarizationMoments`Private`flist1}, {
           AtomicDensityMatrix`PolarizationMoments`Private`f2, 
            AtomicDensityMatrix`PolarizationMoments`Private`flist2}, {
           AtomicDensityMatrix`PolarizationMoments`Private`k, 
            Abs[
            AtomicDensityMatrix`PolarizationMoments`Private`f1 - 
             AtomicDensityMatrix`PolarizationMoments`Private`f2], 
            Min[
            AtomicDensityMatrix`PolarizationMoments`Private`f1 + 
             AtomicDensityMatrix`PolarizationMoments`Private`f2, 
             Abs[AtomicDensityMatrix`PolarizationMoments`Private`f1 - 
               AtomicDensityMatrix`PolarizationMoments`Private`f2] + 
             AtomicDensityMatrix`PolarizationMoments`Private`maxRanks - 1]}], 
          
          
          FreeQ[{{AtomicDensityMatrix`PolarizationMoments`Private`maxRanks}}, \
$Failed]]], 
       Options[AtomicDensityMatrix`ZeroTensorDecompositionMatrix] = {
        AtomicDensityMatrix`MaxRanks -> Automatic}, 
       TagSet[AtomicDensityMatrix`ZeroTensorDecompositionMatrix, 
        MessageName[
        AtomicDensityMatrix`ZeroTensorDecompositionMatrix, "usage"], ""], 
       TagSet[AtomicDensityMatrix`MaxRanks, 
        MessageName[AtomicDensityMatrix`MaxRanks, "usage"], ""], 
       AtomicDensityMatrix`PolarizationMoments`Private`ExpandPMVariables[
         Pattern[AtomicDensityMatrix`PolarizationMoments`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`PolarizationMoments`Private`expr, 
          Blank[]], 
         OptionsPattern[]] := 
       Module[{AtomicDensityMatrix`PolarizationMoments`Private`dmLabel = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`PolarizationMoments`Private`ExpandPMVariables, 
            AtomicDensityMatrix`DMLabel, 
            OptionValue[AtomicDensityMatrix`DMLabel]], 
          AtomicDensityMatrix`PolarizationMoments`Private`dmSymbol = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`PolarizationMoments`Private`ExpandPMVariables, 
            AtomicDensityMatrix`DMSymbol, 
            OptionValue[AtomicDensityMatrix`DMSymbol]], 
          AtomicDensityMatrix`PolarizationMoments`Private`\
complexExpandVariables = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`PolarizationMoments`Private`ExpandPMVariables, 
            AtomicDensityMatrix`ComplexExpandVariables, 
            OptionValue[AtomicDensityMatrix`ComplexExpandVariables]], 
          AtomicDensityMatrix`PolarizationMoments`Private`levels, 
          AtomicDensityMatrix`PolarizationMoments`Private`p, 
          AtomicDensityMatrix`PolarizationMoments`Private`f}, 
         Condition[
          If[
          AtomicDensityMatrix`PolarizationMoments`Private`\
complexExpandVariables === False, 
           AtomicDensityMatrix`PolarizationMoments`Private`expr, 
           AtomicDensityMatrix`PolarizationMoments`Private`levels = 
            AtomicDensityMatrix`RemoveZeemanSublevels[
             AtomicDensityMatrix`PolarizationMoments`Private`sys]; {
             AtomicDensityMatrix`PolarizationMoments`Private`p, 
              AtomicDensityMatrix`PolarizationMoments`Private`f} = 
            Map[AtomicDensityMatrix`PolarizationMoments`Private`myAssociation[
              
               Thread[
               AtomicDensityMatrix`LevelLabel[
                 AtomicDensityMatrix`PolarizationMoments`Private`levels] -> \
#]]& , {
               Range[
                Length[
                AtomicDensityMatrix`PolarizationMoments`Private`levels]], 
               AtomicDensityMatrix`F[
               AtomicDensityMatrix`PolarizationMoments`Private`levels]}]; 
           With[{AtomicDensityMatrix`PolarizationMoments`Private`patt = 
              Subscript[
               AtomicDensityMatrix`PolarizationMoments`Private`dmSymbol, 
                AtomicDensityMatrix`PolarizationMoments`Private`dmLabel, {
                 Pattern[AtomicDensityMatrix`PolarizationMoments`Private`l1, 
                  Blank[]], 
                 Pattern[AtomicDensityMatrix`PolarizationMoments`Private`l2, 
                  Blank[]]}, {
                 Pattern[AtomicDensityMatrix`PolarizationMoments`Private`k, 
                  Blank[]], 
                 Pattern[AtomicDensityMatrix`PolarizationMoments`Private`q, 
                  Blank[]]}], 
              AtomicDensityMatrix`PolarizationMoments`Private`elem = 
              Subscript[
               AtomicDensityMatrix`PolarizationMoments`Private`dmSymbol, #, 
                AtomicDensityMatrix`PolarizationMoments`Private`dmLabel, {
                AtomicDensityMatrix`PolarizationMoments`Private`l1, 
                 AtomicDensityMatrix`PolarizationMoments`Private`l2}, {
                AtomicDensityMatrix`PolarizationMoments`Private`k, 
                 AtomicDensityMatrix`PolarizationMoments`Private`q}, 
                SlotSequence[2]]& , 
              AtomicDensityMatrix`PolarizationMoments`Private`partPatt = 
              Subscript[
               AtomicDensityMatrix`PolarizationMoments`Private`dmSymbol, 
                Pattern[AtomicDensityMatrix`PolarizationMoments`Private`r, 
                 Alternatives[Re, Im]], 
                AtomicDensityMatrix`PolarizationMoments`Private`dmLabel, {
                 Pattern[AtomicDensityMatrix`PolarizationMoments`Private`l1, 
                  Blank[]], 
                 Pattern[AtomicDensityMatrix`PolarizationMoments`Private`l2, 
                  Blank[]]}, {
                 Pattern[AtomicDensityMatrix`PolarizationMoments`Private`k, 
                  Blank[]], 
                 Pattern[AtomicDensityMatrix`PolarizationMoments`Private`q, 
                  Blank[]]}, 
                Alternatives[
                 PatternSequence[], 
                 PatternSequence[
                  Pattern[AtomicDensityMatrix`t, 
                   Blank[]]], 
                 PatternSequence[
                  Pattern[AtomicDensityMatrix`t, 
                   Blank[]], 
                  Pattern[AtomicDensityMatrix`PolarizationMoments`Private`d, 
                   Blank[]]]]], 
              AtomicDensityMatrix`PolarizationMoments`Private`partElem = 
              Subscript[
               AtomicDensityMatrix`PolarizationMoments`Private`dmSymbol, 
                AtomicDensityMatrix`PolarizationMoments`Private`r, 
                AtomicDensityMatrix`PolarizationMoments`Private`dmLabel, {
                 SlotSequence[1]}, {
                AtomicDensityMatrix`PolarizationMoments`Private`k, -
                 AtomicDensityMatrix`PolarizationMoments`Private`q}, 
                AtomicDensityMatrix`t, 
                AtomicDensityMatrix`PolarizationMoments`Private`d]& }, 
             ReplaceAll[
              ReplaceAll[
               ReplaceAll[
                ReplaceAll[
                AtomicDensityMatrix`PolarizationMoments`Private`expr, {
                 Derivative[
                    Pattern[AtomicDensityMatrix`PolarizationMoments`Private`d, 
                    Blank[]]][
                   AtomicDensityMatrix`PolarizationMoments`Private`patt][
                    Pattern[AtomicDensityMatrix`t, 
                    Blank[]]] -> 
                  AtomicDensityMatrix`PolarizationMoments`Private`elem[
                    Re, AtomicDensityMatrix`t, 
                    AtomicDensityMatrix`PolarizationMoments`Private`d] + 
                   I AtomicDensityMatrix`PolarizationMoments`Private`elem[
                    Im, AtomicDensityMatrix`t, 
                    AtomicDensityMatrix`PolarizationMoments`Private`d], 
                  AtomicDensityMatrix`PolarizationMoments`Private`patt[
                    Pattern[AtomicDensityMatrix`t, 
                    Blank[]]] -> 
                  AtomicDensityMatrix`PolarizationMoments`Private`elem[
                    Re, AtomicDensityMatrix`t] + 
                   I AtomicDensityMatrix`PolarizationMoments`Private`elem[
                    Im, AtomicDensityMatrix`t], 
                  AtomicDensityMatrix`PolarizationMoments`Private`patt -> 
                  AtomicDensityMatrix`PolarizationMoments`Private`elem[Re] + 
                   I AtomicDensityMatrix`PolarizationMoments`Private`elem[
                    Im]}], {
                Condition[
                  AtomicDensityMatrix`PolarizationMoments`Private`partPatt, 
                   And[
                   AtomicDensityMatrix`PolarizationMoments`Private`r == Re, 
                    AtomicDensityMatrix`PolarizationMoments`Private`p[
                    AtomicDensityMatrix`PolarizationMoments`Private`l1] > 
                    AtomicDensityMatrix`PolarizationMoments`Private`p[
                    AtomicDensityMatrix`PolarizationMoments`Private`l2]]] :> \
(-1)^(AtomicDensityMatrix`PolarizationMoments`Private`f[
                    AtomicDensityMatrix`PolarizationMoments`Private`l1] - 
                    AtomicDensityMatrix`PolarizationMoments`Private`f[
                    AtomicDensityMatrix`PolarizationMoments`Private`l2] + 
                    AtomicDensityMatrix`PolarizationMoments`Private`q) 
                  AtomicDensityMatrix`PolarizationMoments`Private`partElem[
                   AtomicDensityMatrix`PolarizationMoments`Private`l2, 
                    AtomicDensityMatrix`PolarizationMoments`Private`l1], 
                 Condition[
                  AtomicDensityMatrix`PolarizationMoments`Private`partPatt, 
                   And[
                   AtomicDensityMatrix`PolarizationMoments`Private`r == Im, 
                    AtomicDensityMatrix`PolarizationMoments`Private`p[
                    AtomicDensityMatrix`PolarizationMoments`Private`l1] > 
                    AtomicDensityMatrix`PolarizationMoments`Private`p[
                    AtomicDensityMatrix`PolarizationMoments`Private`l2]]] :> \
-((-1)^(AtomicDensityMatrix`PolarizationMoments`Private`f[
                    AtomicDensityMatrix`PolarizationMoments`Private`l1] - 
                    AtomicDensityMatrix`PolarizationMoments`Private`f[
                    AtomicDensityMatrix`PolarizationMoments`Private`l2] + 
                    AtomicDensityMatrix`PolarizationMoments`Private`q) 
                   AtomicDensityMatrix`PolarizationMoments`Private`partElem[
                    AtomicDensityMatrix`PolarizationMoments`Private`l2, 
                    AtomicDensityMatrix`PolarizationMoments`Private`l1]), 
                 Condition[
                  AtomicDensityMatrix`PolarizationMoments`Private`partPatt, 
                   And[
                   AtomicDensityMatrix`PolarizationMoments`Private`r == Re, 
                    AtomicDensityMatrix`PolarizationMoments`Private`p[
                    AtomicDensityMatrix`PolarizationMoments`Private`l1] == 
                    AtomicDensityMatrix`PolarizationMoments`Private`p[
                    AtomicDensityMatrix`PolarizationMoments`Private`l2], 
                    AtomicDensityMatrix`PolarizationMoments`Private`q <= 
                    0]] :> (-1)^
                   AtomicDensityMatrix`PolarizationMoments`Private`q 
                  AtomicDensityMatrix`PolarizationMoments`Private`partElem[
                   AtomicDensityMatrix`PolarizationMoments`Private`l1, 
                    AtomicDensityMatrix`PolarizationMoments`Private`l2], 
                 Condition[
                  AtomicDensityMatrix`PolarizationMoments`Private`partPatt, 
                   And[
                   AtomicDensityMatrix`PolarizationMoments`Private`r == Im, 
                    AtomicDensityMatrix`PolarizationMoments`Private`p[
                    AtomicDensityMatrix`PolarizationMoments`Private`l1] == 
                    AtomicDensityMatrix`PolarizationMoments`Private`p[
                    AtomicDensityMatrix`PolarizationMoments`Private`l2], 
                    AtomicDensityMatrix`PolarizationMoments`Private`q <= 0]] :> 
                 Sign[AtomicDensityMatrix`PolarizationMoments`Private`q] (-1)^
                   AtomicDensityMatrix`PolarizationMoments`Private`q 
                  AtomicDensityMatrix`PolarizationMoments`Private`partElem[
                   AtomicDensityMatrix`PolarizationMoments`Private`l1, 
                    AtomicDensityMatrix`PolarizationMoments`Private`l2]}], 
               Switch[
               AtomicDensityMatrix`PolarizationMoments`Private`\
complexExpandVariables, True, 
                AtomicDensityMatrix`PolarizationMoments`Private`partPatt -> 
                AtomicDensityMatrix`PolarizationMoments`Private`r[
                  Derivative[
                  AtomicDensityMatrix`PolarizationMoments`Private`d][
                   AtomicDensityMatrix`PolarizationMoments`Private`elem[
                    Unevaluated[]]][AtomicDensityMatrix`t]], Subscript, 
                AtomicDensityMatrix`PolarizationMoments`Private`partPatt -> 
                Derivative[AtomicDensityMatrix`PolarizationMoments`Private`d][
                 
                  AtomicDensityMatrix`PolarizationMoments`Private`elem[
                  AtomicDensityMatrix`PolarizationMoments`Private`r]][
                 AtomicDensityMatrix`t]]], 
              Pattern[AtomicDensityMatrix`PolarizationMoments`Private`s, 
                Alternatives[
                AtomicDensityMatrix`PolarizationMoments`Private`patt, 
                 AtomicDensityMatrix`PolarizationMoments`Private`partPatt]][] :> 
              AtomicDensityMatrix`PolarizationMoments`Private`s]]], 
          
          FreeQ[{{AtomicDensityMatrix`PolarizationMoments`Private`dmLabel, 
             AtomicDensityMatrix`PolarizationMoments`Private`dmSymbol, 
             AtomicDensityMatrix`PolarizationMoments`Private`\
complexExpandVariables}}, $Failed]]], 
       Options[AtomicDensityMatrix`PolarizationMoments`Private`\
ExpandPMVariables] = {
        AtomicDensityMatrix`DMSymbol -> Automatic, 
         AtomicDensityMatrix`DMLabel -> Automatic, 
         AtomicDensityMatrix`ComplexExpandVariables -> Automatic}, 
       AtomicDensityMatrix`PolarizationMoments`Private`myAssociation[
         Pattern[AtomicDensityMatrix`PolarizationMoments`Private`rules, {
           BlankSequence[Rule]}]] := 
       Apply[Function[{AtomicDensityMatrix`PolarizationMoments`Private`key}, 
          Switch[AtomicDensityMatrix`PolarizationMoments`Private`key, 
           SlotSequence[1]]]& , 
         Flatten[
         AtomicDensityMatrix`PolarizationMoments`Private`rules, Infinity, 
          Rule]], 
       TagSet[AtomicDensityMatrix`\[Rho], 
        MessageName[AtomicDensityMatrix`\[Rho], "usage"], 
        "Default variable used for the density matrix."], 
       TagSet[AtomicDensityMatrix`StatisticalWeight, 
        MessageName[AtomicDensityMatrix`StatisticalWeight, "usage"], ""], 
       AtomicDensityMatrix`HyperfineTypeSystem[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Alternatives[
           Blank[AtomicDensityMatrix`AtomicState], {
            Repeated[
             Blank[AtomicDensityMatrix`AtomicState]]}]]] := MatchQ[
         AtomicDensityMatrix`AtomicSystemType[
         AtomicDensityMatrix`AtomicSystem`Private`s], 
         Alternatives["Hyperfine", "HyperfineZeeman"]], 
       AtomicDensityMatrix`HyperfineTypeSystem[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s, 
          Alternatives[
           Repeated[
            Blank[AtomicDensityMatrix`AtomicState]], 
           Repeated[{
             Repeated[
              Blank[AtomicDensityMatrix`AtomicState]]}]]]] := Apply[And, 
         Map[
         AtomicDensityMatrix`HyperfineTypeSystem, {
          AtomicDensityMatrix`AtomicSystem`Private`s}]], 
       TagSet[AtomicDensityMatrix`HyperfineTypeSystem, 
        MessageName[AtomicDensityMatrix`HyperfineTypeSystem, "usage"], ""], 
       AtomicDensityMatrix`SJS[{1/2, 1, 3/2}, {1, 1/2, 0}] = -(1/Sqrt[6]), 
       AtomicDensityMatrix`SJS[{1/2, 1, 3/2}, {1, 1/2, 1}] = (-1)/6, 
       AtomicDensityMatrix`SJS[{1/2, 1, 3/2}, {2, 1/2, 0}] = 0, 
       AtomicDensityMatrix`SJS[{1/2, 1, 3/2}, {2, 1/2, 1}] = 1/(2 Sqrt[3]), 
       AtomicDensityMatrix`SJS[{1/2, 2, 3/2}, {1, 1/2, 0}] = 0, 
       AtomicDensityMatrix`SJS[{1/2, 2, 3/2}, {1, 1/2, 1}] = 1/(2 Sqrt[3]), 
       AtomicDensityMatrix`SJS[{1/2, 2, 3/2}, {2, 1/2, 0}] = 1/Sqrt[10], 
       AtomicDensityMatrix`SJS[{1/2, 2, 3/2}, {2, 1/2, 1}] = (-1)/(2 Sqrt[5]),
        Condition[
         AtomicDensityMatrix`SJS[{
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j12, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j3, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j23, 
            Blank[]]}], 
         Or[
         Abs[AtomicDensityMatrix`CouplingCoefficients`Private`j1 - 
            AtomicDensityMatrix`CouplingCoefficients`Private`j2] > 
          AtomicDensityMatrix`CouplingCoefficients`Private`j12, 
          AtomicDensityMatrix`CouplingCoefficients`Private`j1 + 
           AtomicDensityMatrix`CouplingCoefficients`Private`j2 < 
          AtomicDensityMatrix`CouplingCoefficients`Private`j12]] := (
        AtomicDensityMatrix`SJS[{
          AtomicDensityMatrix`CouplingCoefficients`Private`j1, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j2, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j12}, {
          AtomicDensityMatrix`CouplingCoefficients`Private`j3, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j23}] = 0), 
       Condition[
         AtomicDensityMatrix`SJS[{
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j12, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j3, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j23, 
            Blank[]]}], 
         Or[
         Abs[AtomicDensityMatrix`CouplingCoefficients`Private`j12 - 
            AtomicDensityMatrix`CouplingCoefficients`Private`j3] > 
          AtomicDensityMatrix`CouplingCoefficients`Private`j, 
          AtomicDensityMatrix`CouplingCoefficients`Private`j12 + 
           AtomicDensityMatrix`CouplingCoefficients`Private`j3 < 
          AtomicDensityMatrix`CouplingCoefficients`Private`j]] := (
        AtomicDensityMatrix`SJS[{
          AtomicDensityMatrix`CouplingCoefficients`Private`j1, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j2, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j12}, {
          AtomicDensityMatrix`CouplingCoefficients`Private`j3, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j23}] = 0), 
       Condition[
         AtomicDensityMatrix`SJS[{
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j12, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j3, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j23, 
            Blank[]]}], 
         Or[
         Abs[AtomicDensityMatrix`CouplingCoefficients`Private`j2 - 
            AtomicDensityMatrix`CouplingCoefficients`Private`j3] > 
          AtomicDensityMatrix`CouplingCoefficients`Private`j23, 
          AtomicDensityMatrix`CouplingCoefficients`Private`j2 + 
           AtomicDensityMatrix`CouplingCoefficients`Private`j3 < 
          AtomicDensityMatrix`CouplingCoefficients`Private`j23]] := (
        AtomicDensityMatrix`SJS[{
          AtomicDensityMatrix`CouplingCoefficients`Private`j1, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j2, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j12}, {
          AtomicDensityMatrix`CouplingCoefficients`Private`j3, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j23}] = 0), 
       Condition[
         AtomicDensityMatrix`SJS[{
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j12, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j3, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j23, 
            Blank[]]}], 
         Or[
         Abs[AtomicDensityMatrix`CouplingCoefficients`Private`j23 - 
            AtomicDensityMatrix`CouplingCoefficients`Private`j1] > 
          AtomicDensityMatrix`CouplingCoefficients`Private`j, 
          AtomicDensityMatrix`CouplingCoefficients`Private`j23 + 
           AtomicDensityMatrix`CouplingCoefficients`Private`j1 < 
          AtomicDensityMatrix`CouplingCoefficients`Private`j]] := (
        AtomicDensityMatrix`SJS[{
          AtomicDensityMatrix`CouplingCoefficients`Private`j1, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j2, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j12}, {
          AtomicDensityMatrix`CouplingCoefficients`Private`j3, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j23}] = 0), 
       AtomicDensityMatrix`SJS[{
          Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j2, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j12, 
           Blank[]]}, {
          Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j3, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`j23, 
           Blank[]]}] := (
        AtomicDensityMatrix`SJS[{
          AtomicDensityMatrix`CouplingCoefficients`Private`j1, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j2, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j12}, {
          AtomicDensityMatrix`CouplingCoefficients`Private`j3, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j23}] = 
        SixJSymbol[{
          AtomicDensityMatrix`CouplingCoefficients`Private`j1, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j2, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j12}, {
          AtomicDensityMatrix`CouplingCoefficients`Private`j3, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j, 
           AtomicDensityMatrix`CouplingCoefficients`Private`j23}]), 
       TagSet[AtomicDensityMatrix`SJS, 
        MessageName[AtomicDensityMatrix`SJS, "usage"], ""], 
       AtomicDensityMatrix`hyperfineRMEFactor[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1],
          0, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = Sqrt[3/2], AtomicDensityMatrix`hyperfineRMEFactor[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1],
          0, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = 0, AtomicDensityMatrix`hyperfineRMEFactor[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1],
          1, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = (-1)/2, AtomicDensityMatrix`hyperfineRMEFactor[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 1],
          1, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = (-Sqrt[5])/2, AtomicDensityMatrix`hyperfineRMEFactor[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2],
          0, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = 0, AtomicDensityMatrix`hyperfineRMEFactor[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2],
          0, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = Sqrt[5/2], AtomicDensityMatrix`hyperfineRMEFactor[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2],
          1, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          1]] = Sqrt[5]/2, AtomicDensityMatrix`hyperfineRMEFactor[
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 2],
          1, 
         AtomicDensityMatrix`AtomicState[
         1, AtomicDensityMatrix`J -> 1/2, AtomicDensityMatrix`L -> 0, 
          AtomicDensityMatrix`S -> 1/2, AtomicDensityMatrix`Energy -> 0, 
          AtomicDensityMatrix`NuclearSpin -> 3/2, AtomicDensityMatrix`F -> 
          2]] = Sqrt[5]/2, AtomicDensityMatrix`hyperfineRMEFactor[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s1, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
          Blank[Integer]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s2, 
          Blank[]]] := (
        AtomicDensityMatrix`hyperfineRMEFactor[
         AtomicDensityMatrix`WignerEckart`Private`s1, 
          AtomicDensityMatrix`WignerEckart`Private`k, 
          AtomicDensityMatrix`WignerEckart`Private`s2] = (-1)^(
           AtomicDensityMatrix`J[AtomicDensityMatrix`WignerEckart`Private`s1] + 
           AtomicDensityMatrix`NuclearSpin[
            AtomicDensityMatrix`WignerEckart`Private`s1] + 
           AtomicDensityMatrix`F[AtomicDensityMatrix`WignerEckart`Private`s2] + 
           AtomicDensityMatrix`WignerEckart`Private`k) 
         Sqrt[(2 AtomicDensityMatrix`F[
              AtomicDensityMatrix`WignerEckart`Private`s1] + 1) (
            2 AtomicDensityMatrix`F[
              AtomicDensityMatrix`WignerEckart`Private`s2] + 1)] 
         AtomicDensityMatrix`SJS[{
            AtomicDensityMatrix`J[
            AtomicDensityMatrix`WignerEckart`Private`s1], 
            AtomicDensityMatrix`F[
            AtomicDensityMatrix`WignerEckart`Private`s1], 
            AtomicDensityMatrix`NuclearSpin[
            AtomicDensityMatrix`WignerEckart`Private`s1]}, {
            AtomicDensityMatrix`F[
            AtomicDensityMatrix`WignerEckart`Private`s2], 
            AtomicDensityMatrix`J[
            AtomicDensityMatrix`WignerEckart`Private`s2], 
            AtomicDensityMatrix`WignerEckart`Private`k}]), 
       TagSet[AtomicDensityMatrix`hyperfineRMEFactor, 
        MessageName[AtomicDensityMatrix`hyperfineRMEFactor, "usage"], ""], 
       Condition[
         AtomicDensityMatrix`HyperfineShift[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`s, 
           Blank[AtomicDensityMatrix`AtomicState]]], 
         AtomicDensityMatrix`HyperfineTypeSystem[
         AtomicDensityMatrix`WignerEckart`Private`s]] := 
       AtomicDensityMatrix`EvaluateHyperfineShift[
         AtomicDensityMatrix`HyperfineShift[
          AtomicDensityMatrix`J[AtomicDensityMatrix`WignerEckart`Private`s], 
          AtomicDensityMatrix`NuclearSpin[
          AtomicDensityMatrix`WignerEckart`Private`s], 
          AtomicDensityMatrix`F[AtomicDensityMatrix`WignerEckart`Private`s], 
          AtomicDensityMatrix`HyperfineA[
          AtomicDensityMatrix`WignerEckart`Private`s], 
          AtomicDensityMatrix`HyperfineB[
          AtomicDensityMatrix`WignerEckart`Private`s]]], 
       AtomicDensityMatrix`HyperfineShift[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 0, 
       AtomicDensityMatrix`HyperfineShift[
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`s, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ]] := 
       Map[AtomicDensityMatrix`HyperfineShift, 
         AtomicDensityMatrix`WignerEckart`Private`s], 
       TagSet[AtomicDensityMatrix`HyperfineShift, 
        MessageName[AtomicDensityMatrix`HyperfineShift, "usage"], ""], 
       AtomicDensityMatrix`EvaluateHyperfineShift[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`expr, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`WignerEckart`Private`expr, 
         AtomicDensityMatrix`HyperfineShift[
           Pattern[AtomicDensityMatrix`WignerEckart`Private`j, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`WignerEckart`Private`i, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`WignerEckart`Private`f, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`WignerEckart`Private`b, 
            Blank[]]] :> 
         With[{AtomicDensityMatrix`WignerEckart`Private`k = 
            AtomicDensityMatrix`WignerEckart`Private`hyperfineK[
             AtomicDensityMatrix`WignerEckart`Private`j, 
              AtomicDensityMatrix`WignerEckart`Private`i, 
              AtomicDensityMatrix`WignerEckart`Private`f]}, (1 
             AtomicDensityMatrix`WignerEckart`Private`a 
             AtomicDensityMatrix`WignerEckart`Private`k)/2 + 
           Piecewise[{{(
                AtomicDensityMatrix`WignerEckart`Private`b ((3 
                   AtomicDensityMatrix`WignerEckart`Private`k (
                    AtomicDensityMatrix`WignerEckart`Private`k + 1))/2 - 2 
                 AtomicDensityMatrix`WignerEckart`Private`i (
                  AtomicDensityMatrix`WignerEckart`Private`i + 1) 
                 AtomicDensityMatrix`WignerEckart`Private`j (
                  AtomicDensityMatrix`WignerEckart`Private`j + 1)))/(2 
               AtomicDensityMatrix`WignerEckart`Private`i (
                2 AtomicDensityMatrix`WignerEckart`Private`i - 1) 2 
               AtomicDensityMatrix`WignerEckart`Private`j (
                2 AtomicDensityMatrix`WignerEckart`Private`j - 1)), 
               And[
               AtomicDensityMatrix`WignerEckart`Private`j > 1/2, 
                AtomicDensityMatrix`WignerEckart`Private`i > 1/2]}}]]], 
       TagSet[AtomicDensityMatrix`EvaluateHyperfineShift, 
        MessageName[AtomicDensityMatrix`EvaluateHyperfineShift, "usage"], ""],
        AtomicDensityMatrix`WignerEckart`Private`hyperfineK[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`j, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`i, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`f, 
          Blank[]]] = 
       AtomicDensityMatrix`WignerEckart`Private`f (1 + 
          AtomicDensityMatrix`WignerEckart`Private`f) - 
        AtomicDensityMatrix`WignerEckart`Private`i (1 + 
         AtomicDensityMatrix`WignerEckart`Private`i) - 
        AtomicDensityMatrix`WignerEckart`Private`j (1 + 
         AtomicDensityMatrix`WignerEckart`Private`j), 
       TagSet[AtomicDensityMatrix`GroundState, 
        MessageName[AtomicDensityMatrix`GroundState, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ExcitedState, 
        MessageName[AtomicDensityMatrix`ExcitedState, "usage"], ""], 
       AtomicDensityMatrix`FineStructureStatesQ[
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s1, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`AtomicSystem`Private`s2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := And[
         ListQ[
          AtomicDensityMatrix`StateLabel[
          AtomicDensityMatrix`AtomicSystem`Private`s1]], 
         ListQ[
          AtomicDensityMatrix`StateLabel[
          AtomicDensityMatrix`AtomicSystem`Private`s2]], First[
           AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`AtomicSystem`Private`s1]] === First[
           AtomicDensityMatrix`StateLabel[
           AtomicDensityMatrix`AtomicSystem`Private`s2]]], 
       TagSet[AtomicDensityMatrix`FineStructureStatesQ, 
        MessageName[AtomicDensityMatrix`FineStructureStatesQ, "usage"], ""], 
       Attributes[AtomicDensityMatrix`LandeGJ] = {Listable}, 
       AtomicDensityMatrix`LandeGJ[0, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`l, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s, 
          Blank[]]] = 0, AtomicDensityMatrix`LandeGJ[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`j, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`l, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s, 
          Blank[]]] = 
       1 + (AtomicDensityMatrix`WignerEckart`Private`j (1 + 
            AtomicDensityMatrix`WignerEckart`Private`j) - 
          AtomicDensityMatrix`WignerEckart`Private`l (1 + 
           AtomicDensityMatrix`WignerEckart`Private`l) + 
          AtomicDensityMatrix`WignerEckart`Private`s (1 + 
            AtomicDensityMatrix`WignerEckart`Private`s))/(2 
         AtomicDensityMatrix`WignerEckart`Private`j (1 + 
          AtomicDensityMatrix`WignerEckart`Private`j)), 
       AtomicDensityMatrix`LandeGJ[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`s, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       AtomicDensityMatrix`LandeGJ[
         AtomicDensityMatrix`J[AtomicDensityMatrix`WignerEckart`Private`s], 
         AtomicDensityMatrix`L[AtomicDensityMatrix`WignerEckart`Private`s], 
         AtomicDensityMatrix`S[AtomicDensityMatrix`WignerEckart`Private`s]], 
       TagSet[AtomicDensityMatrix`LandeGJ, 
        MessageName[AtomicDensityMatrix`LandeGJ, "usage"], ""], Condition[
         AtomicDensityMatrix`WignerEckart`Private`alphaFactor[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[Integer]], 
          PatternTest[
           Pattern[AtomicDensityMatrix`WignerEckart`Private`j, 
            Blank[]], AtomicDensityMatrix`HalfIntegerQ]], 
         AtomicDensityMatrix`WignerEckart`Private`k >= 
         2 AtomicDensityMatrix`WignerEckart`Private`j + 1] := 0, 
       AtomicDensityMatrix`WignerEckart`Private`alphaFactor[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
          Blank[Integer]], 
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`j, 
           Blank[]], AtomicDensityMatrix`HalfIntegerQ]] := (
        AtomicDensityMatrix`WignerEckart`Private`alphaFactor[
         AtomicDensityMatrix`WignerEckart`Private`k, 
          AtomicDensityMatrix`WignerEckart`Private`j] = 
        Simplify[-(((1/2) 
            Sqrt[2 AtomicDensityMatrix`WignerEckart`Private`j + 1])/(
           AtomicDensityMatrix`CG[{1, 
              Mod[AtomicDensityMatrix`WignerEckart`Private`k, 2]}, {
             1, -Mod[AtomicDensityMatrix`WignerEckart`Private`k, 2]}, {
             AtomicDensityMatrix`WignerEckart`Private`k, 0}] 
           AtomicDensityMatrix`CG[{
             AtomicDensityMatrix`WignerEckart`Private`j, 
              AtomicDensityMatrix`WignerEckart`Private`j}, {
             AtomicDensityMatrix`WignerEckart`Private`k, 0}, {
             AtomicDensityMatrix`WignerEckart`Private`j, 
              AtomicDensityMatrix`WignerEckart`Private`j}])), 
          Element[2 AtomicDensityMatrix`WignerEckart`Private`j, Integers]]), 
       AtomicDensityMatrix`CG[{1, -1}, {0, 0}, {1, -1}] = 1, 
       AtomicDensityMatrix`CG[{1, -1}, {1, -1}, {2, -2}] = 1, 
       AtomicDensityMatrix`CG[{1, -1}, {1, 0}, {1, -1}] = -(1/Sqrt[2]), 
       AtomicDensityMatrix`CG[{1, -1}, {1, 0}, {2, -1}] = 1/Sqrt[2], 
       AtomicDensityMatrix`CG[{1, -1}, {1, 1}, {1, 0}] = -(1/Sqrt[2]), 
       AtomicDensityMatrix`CG[{1, -1}, {1, 1}, {2, 0}] = 1/Sqrt[6], 
       AtomicDensityMatrix`CG[{1, 0}, {0, 0}, {1, 0}] = 1, 
       AtomicDensityMatrix`CG[{1, 0}, {1, -1}, {1, -1}] = 1/Sqrt[2], 
       AtomicDensityMatrix`CG[{1, 0}, {1, -1}, {2, -1}] = 1/Sqrt[2], 
       AtomicDensityMatrix`CG[{1, 0}, {1, 0}, {1, 0}] = 0, 
       AtomicDensityMatrix`CG[{1, 0}, {1, 0}, {2, 0}] = Sqrt[2/3], 
       AtomicDensityMatrix`CG[{1, 0}, {1, 1}, {1, 1}] = -(1/Sqrt[2]), 
       AtomicDensityMatrix`CG[{1, 0}, {1, 1}, {2, 1}] = 1/Sqrt[2], 
       AtomicDensityMatrix`CG[{1, 1}, {0, 0}, {1, 1}] = 1, 
       AtomicDensityMatrix`CG[{1, 1}, {1, -1}, {1, 0}] = 1/Sqrt[2], 
       AtomicDensityMatrix`CG[{1, 1}, {1, -1}, {2, 0}] = 1/Sqrt[6], 
       AtomicDensityMatrix`CG[{1, 1}, {1, 0}, {1, 1}] = 1/Sqrt[2], 
       AtomicDensityMatrix`CG[{1, 1}, {1, 0}, {2, 1}] = 1/Sqrt[2], 
       AtomicDensityMatrix`CG[{1, 1}, {1, 1}, {2, 2}] = 1, 
       AtomicDensityMatrix`CG[{2, -2}, {0, 0}, {2, -2}] = 1, 
       AtomicDensityMatrix`CG[{2, -2}, {1, 0}, {2, -2}] = -Sqrt[2/3], 
       AtomicDensityMatrix`CG[{2, -2}, {1, 1}, {1, -1}] = Sqrt[3/5], 
       AtomicDensityMatrix`CG[{2, -2}, {1, 1}, {2, -1}] = -(1/Sqrt[3]), 
       AtomicDensityMatrix`CG[{2, -1}, {0, 0}, {2, -1}] = 1, 
       AtomicDensityMatrix`CG[{2, -1}, {1, -1}, {2, -2}] = 1/Sqrt[3], 
       AtomicDensityMatrix`CG[{2, -1}, {1, 0}, {1, -1}] = -Sqrt[3/10], 
       AtomicDensityMatrix`CG[{2, -1}, {1, 0}, {2, -1}] = -(1/Sqrt[6]), 
       AtomicDensityMatrix`CG[{2, -1}, {1, 1}, {1, 0}] = Sqrt[3/10], 
       AtomicDensityMatrix`CG[{2, -1}, {1, 1}, {2, 0}] = -(1/Sqrt[2]), 
       AtomicDensityMatrix`CG[{2, 0}, {0, 0}, {2, 0}] = 1, 
       AtomicDensityMatrix`CG[{2, 0}, {1, -1}, {1, -1}] = 1/Sqrt[10], 
       AtomicDensityMatrix`CG[{2, 0}, {1, -1}, {2, -1}] = 1/Sqrt[2], 
       AtomicDensityMatrix`CG[{2, 0}, {1, 0}, {1, 0}] = -Sqrt[2/5], 
       AtomicDensityMatrix`CG[{2, 0}, {1, 0}, {2, 0}] = 0, 
       AtomicDensityMatrix`CG[{2, 0}, {1, 1}, {1, 1}] = 1/Sqrt[10], 
       AtomicDensityMatrix`CG[{2, 0}, {1, 1}, {2, 1}] = -(1/Sqrt[2]), 
       AtomicDensityMatrix`CG[{2, 1}, {0, 0}, {2, 1}] = 1, 
       AtomicDensityMatrix`CG[{2, 1}, {1, -1}, {1, 0}] = Sqrt[3/10], 
       AtomicDensityMatrix`CG[{2, 1}, {1, -1}, {2, 0}] = 1/Sqrt[2], 
       AtomicDensityMatrix`CG[{2, 1}, {1, 0}, {1, 1}] = -Sqrt[3/10], 
       AtomicDensityMatrix`CG[{2, 1}, {1, 0}, {2, 1}] = 1/Sqrt[6], 
       AtomicDensityMatrix`CG[{2, 1}, {1, 1}, {2, 2}] = -(1/Sqrt[3]), 
       AtomicDensityMatrix`CG[{2, 2}, {0, 0}, {2, 2}] = 1, 
       AtomicDensityMatrix`CG[{2, 2}, {1, -1}, {1, 1}] = Sqrt[3/5], 
       AtomicDensityMatrix`CG[{2, 2}, {1, -1}, {2, 1}] = 1/Sqrt[3], 
       AtomicDensityMatrix`CG[{2, 2}, {1, 0}, {2, 2}] = Sqrt[2/3], Condition[
         AtomicDensityMatrix`CG[{
           Pattern[AtomicDensityMatrix`F1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`m1, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`F2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`m2, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`F3, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`m3, 
            Blank[]]}], 
         Or[
         Abs[AtomicDensityMatrix`F1 - AtomicDensityMatrix`F2] > 
          AtomicDensityMatrix`CouplingCoefficients`Private`F3, 
          AtomicDensityMatrix`F1 + AtomicDensityMatrix`F2 < 
          AtomicDensityMatrix`CouplingCoefficients`Private`F3]] := (
        AtomicDensityMatrix`CG[{
          AtomicDensityMatrix`F1, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m1}, {
          AtomicDensityMatrix`F2, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m2}, {
          AtomicDensityMatrix`CouplingCoefficients`Private`F3, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m3}] = 0), 
       Condition[
         AtomicDensityMatrix`CG[{
           Pattern[AtomicDensityMatrix`F1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`m1, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`F2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`m2, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`F3, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`m3, 
            Blank[]]}], 
         AtomicDensityMatrix`CouplingCoefficients`Private`m1 + 
          AtomicDensityMatrix`CouplingCoefficients`Private`m2 != 
         AtomicDensityMatrix`CouplingCoefficients`Private`m3] := (
        AtomicDensityMatrix`CG[{
          AtomicDensityMatrix`F1, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m1}, {
          AtomicDensityMatrix`F2, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m2}, {
          AtomicDensityMatrix`CouplingCoefficients`Private`F3, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m3}] = 0), 
       Condition[
         AtomicDensityMatrix`CG[{
           Pattern[AtomicDensityMatrix`F1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`m1, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`F2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`m2, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`F3, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`m3, 
            Blank[]]}], 
         Or[
         Abs[AtomicDensityMatrix`CouplingCoefficients`Private`m1] > 
          AtomicDensityMatrix`F1, 
          Abs[AtomicDensityMatrix`CouplingCoefficients`Private`m2] > 
          AtomicDensityMatrix`F2, 
          Abs[AtomicDensityMatrix`CouplingCoefficients`Private`m3] > 
          AtomicDensityMatrix`CouplingCoefficients`Private`F3]] := (
        AtomicDensityMatrix`CG[{
          AtomicDensityMatrix`F1, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m1}, {
          AtomicDensityMatrix`F2, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m2}, {
          AtomicDensityMatrix`CouplingCoefficients`Private`F3, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m3}] = 0), 
       AtomicDensityMatrix`CG[{
          Pattern[AtomicDensityMatrix`F1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`m1, 
           Blank[]]}, {
          Pattern[AtomicDensityMatrix`F2, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`m2, 
           Blank[]]}, {
          Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`F3, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`CouplingCoefficients`Private`m3, 
           Blank[]]}] := (
        AtomicDensityMatrix`CG[{
          AtomicDensityMatrix`F1, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m1}, {
          AtomicDensityMatrix`F2, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m2}, {
          AtomicDensityMatrix`CouplingCoefficients`Private`F3, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m3}] = 
        ClebschGordan[{
          AtomicDensityMatrix`F1, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m1}, {
          AtomicDensityMatrix`F2, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m2}, {
          AtomicDensityMatrix`CouplingCoefficients`Private`F3, 
           AtomicDensityMatrix`CouplingCoefficients`Private`m3}]), 
       TagSet[AtomicDensityMatrix`CG, 
        MessageName[AtomicDensityMatrix`CG, "usage"], ""], 
       AtomicDensityMatrix`WignerEckart`Private`WignerEckartZ[
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
          Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[Integer]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`qs, {
            BlankSequence[Integer]}]}, 
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         OptionsPattern[]] := 
       Module[{AtomicDensityMatrix`WignerEckart`Private`allowedCouplings = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`WignerEckart`Private`WignerEckartZ, 
            AtomicDensityMatrix`AllowedCouplings, 
            OptionValue[AtomicDensityMatrix`AllowedCouplings]], 
          AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`WignerEckart`Private`WignerEckartZ, 
            AtomicDensityMatrix`NeglectedCouplings, 
            OptionValue[AtomicDensityMatrix`NeglectedCouplings]], 
          AtomicDensityMatrix`WignerEckart`Private`fm1, 
          AtomicDensityMatrix`WignerEckart`Private`fm2, 
          AtomicDensityMatrix`WignerEckart`Private`rme, 
          AtomicDensityMatrix`WignerEckart`Private`mask}, 
         Condition[{
            AtomicDensityMatrix`WignerEckart`Private`fm1, 
             AtomicDensityMatrix`WignerEckart`Private`fm2} = Map[Transpose, 
             Map[Through, 
              
              Map[{AtomicDensityMatrix`F, AtomicDensityMatrix`M}, {
               AtomicDensityMatrix`WignerEckart`Private`sys1, 
                AtomicDensityMatrix`WignerEckart`Private`sys2}]]]; 
          AtomicDensityMatrix`WignerEckart`Private`rme = 
           AtomicDensityMatrix`ReducedME[
            AtomicDensityMatrix`WignerEckart`Private`sys1, {
             AtomicDensityMatrix`WignerEckart`Private`a, 
              AtomicDensityMatrix`WignerEckart`Private`k}, 
             AtomicDensityMatrix`WignerEckart`Private`sys2]; 
          AtomicDensityMatrix`WignerEckart`Private`mask = 
           AtomicDensityMatrix`MatrixElementMask[
            AtomicDensityMatrix`WignerEckart`Private`sys1, 
             AtomicDensityMatrix`WignerEckart`Private`sys2, 
             AtomicDensityMatrix`WignerEckart`Private`allowedCouplings, 
             AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings]; 
          Expand[{
             Map[
             AtomicDensityMatrix`WignerEckart`Private`rme 
              AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[
               AtomicDensityMatrix`WignerEckart`Private`fm1, {
                AtomicDensityMatrix`WignerEckart`Private`k, #}, 
                AtomicDensityMatrix`WignerEckart`Private`fm2, 
                AtomicDensityMatrix`WignerEckart`Private`mask]& , 
              AtomicDensityMatrix`WignerEckart`Private`qs]}], 
          
          FreeQ[{{AtomicDensityMatrix`WignerEckart`Private`allowedCouplings, 
             AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings}}, \
$Failed]]], 
       Options[AtomicDensityMatrix`WignerEckart`Private`WignerEckartZ] = {
        AtomicDensityMatrix`AllowedCouplings -> All, 
         AtomicDensityMatrix`NeglectedCouplings -> None}, 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, -1}, {
         0, 0}, {1, -1}] = 1/Sqrt[3], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, -1}, {
         1, -1}, {1, 0}] = 1/Sqrt[6], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, -1}, {
         1, -1}, {2, 0}] = 1/Sqrt[30], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, -1}, {
         1, 0}, {1, -1}] = -(1/Sqrt[6]), 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, -1}, {
         1, 0}, {2, -1}] = -(1/Sqrt[10]), 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, -1}, {
         1, 1}, {2, -2}] = 1/Sqrt[5], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 0}, {0,
          0}, {1, 0}] = 1/Sqrt[3], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 0}, {
         1, -1}, {1, 1}] = 1/Sqrt[6], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 0}, {
         1, -1}, {2, 1}] = 1/Sqrt[10], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 0}, {1,
          0}, {1, 0}] = 0, 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 0}, {1,
          0}, {2, 0}] = -Sqrt[2/15], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 0}, {1,
          1}, {1, -1}] = -(1/Sqrt[6]), 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 0}, {1,
          1}, {2, -1}] = 1/Sqrt[10], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 1}, {0,
          0}, {1, 1}] = 1/Sqrt[3], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 1}, {
         1, -1}, {2, 2}] = 1/Sqrt[5], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 1}, {1,
          0}, {1, 1}] = 1/Sqrt[6], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 1}, {1,
          0}, {2, 1}] = -(1/Sqrt[10]), 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 1}, {1,
          1}, {1, 0}] = -(1/Sqrt[6]), 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{1, 1}, {1,
          1}, {2, 0}] = 1/Sqrt[30], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, -2}, {
         0, 0}, {2, -2}] = 1/Sqrt[5], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, -2}, {
         1, -1}, {1, -1}] = 1/Sqrt[5], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, -2}, {
         1, -1}, {2, -1}] = 1/Sqrt[15], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, -2}, {
         1, 0}, {2, -2}] = -Sqrt[2/15], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, -1}, {
         0, 0}, {2, -1}] = 1/Sqrt[5], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, -1}, {
         1, -1}, {1, 0}] = 1/Sqrt[10], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, -1}, {
         1, -1}, {2, 0}] = 1/Sqrt[10], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, -1}, {
         1, 0}, {1, -1}] = 1/Sqrt[10], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, -1}, {
         1, 0}, {2, -1}] = -(1/Sqrt[30]), 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, -1}, {
         1, 1}, {2, -2}] = -(1/Sqrt[15]), 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 0}, {0,
          0}, {2, 0}] = 1/Sqrt[5], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 0}, {
         1, -1}, {1, 1}] = 1/Sqrt[30], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 0}, {
         1, -1}, {2, 1}] = 1/Sqrt[10], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 0}, {1,
          0}, {1, 0}] = Sqrt[2/15], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 0}, {1,
          0}, {2, 0}] = 0, 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 0}, {1,
          1}, {1, -1}] = 1/Sqrt[30], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 0}, {1,
          1}, {2, -1}] = -(1/Sqrt[10]), 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 1}, {0,
          0}, {2, 1}] = 1/Sqrt[5], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 1}, {
         1, -1}, {2, 2}] = 1/Sqrt[15], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 1}, {1,
          0}, {1, 1}] = 1/Sqrt[10], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 1}, {1,
          0}, {2, 1}] = 1/Sqrt[30], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 1}, {1,
          1}, {1, 0}] = 1/Sqrt[10], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 1}, {1,
          1}, {2, 0}] = -(1/Sqrt[10]), 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 2}, {0,
          0}, {2, 2}] = 1/Sqrt[5], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 2}, {1,
          0}, {2, 2}] = Sqrt[2/15], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 2}, {1,
          1}, {1, 1}] = 1/Sqrt[5], 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{2, 2}, {1,
          1}, {2, 1}] = -(1/Sqrt[15]), 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{{2, 2}, {
         2, 1}, {2, 0}, {2, -1}, {2, -2}, {1, 1}, {1, 0}, {1, -1}}, {0, 0}, {{
         2, 2}, {2, 1}, {2, 0}, {2, -1}, {2, -2}, {1, 1}, {1, 0}, {1, -1}}, {{
         1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1,
          1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1,
          1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 
         1}}] = {{1/Sqrt[5], 0, 0, 0, 0, 0, 0, 0}, {
         0, 1/Sqrt[5], 0, 0, 0, 0, 0, 0}, {0, 0, 1/Sqrt[5], 0, 0, 0, 0, 0}, {
         0, 0, 0, 1/Sqrt[5], 0, 0, 0, 0}, {0, 0, 0, 0, 1/Sqrt[5], 0, 0, 0}, {
         0, 0, 0, 0, 0, 1/Sqrt[3], 0, 0}, {0, 0, 0, 0, 0, 0, 1/Sqrt[3], 0}, {
         0, 0, 0, 0, 0, 0, 0, 1/Sqrt[3]}}, 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{{2, 2}, {
         2, 1}, {2, 0}, {2, -1}, {2, -2}, {1, 1}, {1, 0}, {1, -1}}, {
         1, -1}, {{2, 2}, {2, 1}, {2, 0}, {2, -1}, {2, -2}, {1, 1}, {1, 0}, {
         1, -1}}, {{1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 
         1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 
         1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 
         1, 1, 1, 1}}] = {{0, 0, 0, 0, 0, 0, 0, 0}, {
         1/Sqrt[15], 0, 0, 0, 0, 0, 0, 0}, {
         0, 1/Sqrt[10], 0, 0, 0, 1/Sqrt[30], 0, 0}, {
         0, 0, 1/Sqrt[10], 0, 0, 0, 1/Sqrt[10], 0}, {
         0, 0, 0, 1/Sqrt[15], 0, 0, 0, 1/Sqrt[5]}, {
         1/Sqrt[5], 0, 0, 0, 0, 0, 0, 0}, {
         0, 1/Sqrt[10], 0, 0, 0, 1/Sqrt[6], 0, 0}, {
         0, 0, 1/Sqrt[30], 0, 0, 0, 1/Sqrt[6], 0}}, 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{{2, 2}, {
         2, 1}, {2, 0}, {2, -1}, {2, -2}, {1, 1}, {1, 0}, {1, -1}}, {1, 0}, {{
         2, 2}, {2, 1}, {2, 0}, {2, -1}, {2, -2}, {1, 1}, {1, 0}, {1, -1}}, {{
         1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1,
          1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1,
          1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 
         1}}] = {{
          Sqrt[2/15], 0, 0, 0, 0, 0, 0, 0}, {
         0, 1/Sqrt[30], 0, 0, 0, 1/Sqrt[10], 0, 0}, {0, 0, 0, 0, 0, 0, 
          Sqrt[2/15], 0}, {0, 0, 0, -(1/Sqrt[30]), 0, 0, 0, 1/Sqrt[10]}, {
         0, 0, 0, 0, -Sqrt[2/15], 0, 0, 0}, {
         0, -(1/Sqrt[10]), 0, 0, 0, 1/Sqrt[6], 0, 0}, {
         0, 0, -Sqrt[2/15], 0, 0, 0, 0, 0}, {
         0, 0, 0, -(1/Sqrt[10]), 0, 0, 0, -(1/Sqrt[6])}}, 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{{2, 2}, {
         2, 1}, {2, 0}, {2, -1}, {2, -2}, {1, 1}, {1, 0}, {1, -1}}, {1, 1}, {{
         2, 2}, {2, 1}, {2, 0}, {2, -1}, {2, -2}, {1, 1}, {1, 0}, {1, -1}}, {{
         1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1,
          1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1,
          1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 
         1}}] = {{0, -(1/Sqrt[15]), 0, 0, 0, 1/Sqrt[5], 0, 0}, {
         0, 0, -(1/Sqrt[10]), 0, 0, 0, 1/Sqrt[10], 0}, {
         0, 0, 0, -(1/Sqrt[10]), 0, 0, 0, 1/Sqrt[30]}, {
         0, 0, 0, 0, -(1/Sqrt[15]), 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {
         0, 0, 1/Sqrt[30], 0, 0, 0, -(1/Sqrt[6]), 0}, {
         0, 0, 0, 1/Sqrt[10], 0, 0, 0, -(1/Sqrt[6])}, {
         0, 0, 0, 0, 1/Sqrt[5], 0, 0, 0}}, 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`fm1, {
           Repeated[{
             Blank[], 
             Blank[]}]}], {
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`q, 
           Blank[]]}, 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`fm2, {
           Repeated[{
             Blank[], 
             Blank[]}]}], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`mask, 
          Blank[]]] := (
        AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[
         AtomicDensityMatrix`WignerEckart`Private`fm1, {
          AtomicDensityMatrix`WignerEckart`Private`k, 
           AtomicDensityMatrix`WignerEckart`Private`q}, 
          AtomicDensityMatrix`WignerEckart`Private`fm2, 
          AtomicDensityMatrix`WignerEckart`Private`mask] = 
        MapThread[
         AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[
           Part[#, 1], {
           AtomicDensityMatrix`WignerEckart`Private`k, 
            AtomicDensityMatrix`WignerEckart`Private`q}, 
           Part[#, 2], #2]& , {
           AtomicDensityMatrix`DirectProduct[
           List, AtomicDensityMatrix`WignerEckart`Private`fm1, 
            AtomicDensityMatrix`WignerEckart`Private`fm2], 
           AtomicDensityMatrix`WignerEckart`Private`mask}, 2]), 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{
          Blank[], 
          Blank[]}, {
          Blank[], 
          Blank[]}, {
          Blank[], 
          Blank[]}, 0] = 0, Condition[
         AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{
           Pattern[AtomicDensityMatrix`WignerEckart`Private`f1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`WignerEckart`Private`m1, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`WignerEckart`Private`q, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`WignerEckart`Private`f2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`WignerEckart`Private`m2, 
            Blank[]]}, 1], 
         Or[
         AtomicDensityMatrix`WignerEckart`Private`m2 + 
           AtomicDensityMatrix`WignerEckart`Private`q != 
          AtomicDensityMatrix`WignerEckart`Private`m1, 
          Abs[AtomicDensityMatrix`WignerEckart`Private`f2 - 
            AtomicDensityMatrix`WignerEckart`Private`k] > 
          AtomicDensityMatrix`WignerEckart`Private`f1, 
          AtomicDensityMatrix`WignerEckart`Private`f2 + 
           AtomicDensityMatrix`WignerEckart`Private`k < 
          AtomicDensityMatrix`WignerEckart`Private`f1, 
          Abs[AtomicDensityMatrix`WignerEckart`Private`m2] > 
          AtomicDensityMatrix`WignerEckart`Private`f2, 
          Abs[AtomicDensityMatrix`WignerEckart`Private`q] > 
          AtomicDensityMatrix`WignerEckart`Private`k, 
          Abs[AtomicDensityMatrix`WignerEckart`Private`m1] > 
          AtomicDensityMatrix`WignerEckart`Private`f1]] := 0, 
       AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{
          Pattern[AtomicDensityMatrix`WignerEckart`Private`f1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`m1, 
           Blank[]]}, {
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`q, 
           Blank[]]}, {
          Pattern[AtomicDensityMatrix`WignerEckart`Private`f2, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`m2, 
           Blank[]]}, 1] := (
        AtomicDensityMatrix`WignerEckart`Private`wignerEckartFactor[{
          AtomicDensityMatrix`WignerEckart`Private`f1, 
           AtomicDensityMatrix`WignerEckart`Private`m1}, {
          AtomicDensityMatrix`WignerEckart`Private`k, 
           AtomicDensityMatrix`WignerEckart`Private`q}, {
          AtomicDensityMatrix`WignerEckart`Private`f2, 
           AtomicDensityMatrix`WignerEckart`Private`m2}] = 
        AtomicDensityMatrix`CG[{
           AtomicDensityMatrix`WignerEckart`Private`f2, 
            AtomicDensityMatrix`WignerEckart`Private`m2}, {
           AtomicDensityMatrix`WignerEckart`Private`k, 
            AtomicDensityMatrix`WignerEckart`Private`q}, {
           AtomicDensityMatrix`WignerEckart`Private`f1, 
            AtomicDensityMatrix`WignerEckart`Private`m1}]/(
          2 AtomicDensityMatrix`WignerEckart`Private`f1 + 1)^(2^(-1))), 
       AtomicDensityMatrix`WignerEckart`Private`WignerEckartPM[
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], {
          Pattern[AtomicDensityMatrix`WignerEckart`Private`a, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`k, 
           Blank[Integer]], 
          Pattern[AtomicDensityMatrix`WignerEckart`Private`qs, {
            BlankSequence[Integer]}]}, 
         PatternTest[
          Pattern[AtomicDensityMatrix`WignerEckart`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`WignerEckart`Private`allowedCouplings = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`WignerEckart`Private`WignerEckartPM, 
            AtomicDensityMatrix`AllowedCouplings, 
            OptionValue[AtomicDensityMatrix`AllowedCouplings]], 
          AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`WignerEckart`Private`WignerEckartPM, 
            AtomicDensityMatrix`NeglectedCouplings, 
            OptionValue[AtomicDensityMatrix`NeglectedCouplings]], 
          AtomicDensityMatrix`WignerEckart`Private`reducedSys1, 
          AtomicDensityMatrix`WignerEckart`Private`reducedSys2, 
          AtomicDensityMatrix`WignerEckart`Private`rme}, 
         Condition[{
            AtomicDensityMatrix`WignerEckart`Private`reducedSys1, 
             AtomicDensityMatrix`WignerEckart`Private`reducedSys2} = 
           Map[AtomicDensityMatrix`RemoveZeemanSublevels, {
             AtomicDensityMatrix`WignerEckart`Private`sys1, 
              AtomicDensityMatrix`WignerEckart`Private`sys2}]; 
          AtomicDensityMatrix`WignerEckart`Private`rme = 
           AtomicDensityMatrix`MatrixElementMask[
             AtomicDensityMatrix`WignerEckart`Private`reducedSys1, 
              AtomicDensityMatrix`WignerEckart`Private`reducedSys2, 
              AtomicDensityMatrix`WignerEckart`Private`allowedCouplings, 
              AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings] 
            AtomicDensityMatrix`ReducedME[
             AtomicDensityMatrix`WignerEckart`Private`reducedSys1, {
              AtomicDensityMatrix`WignerEckart`Private`a, 
               AtomicDensityMatrix`WignerEckart`Private`k}, 
              AtomicDensityMatrix`WignerEckart`Private`reducedSys2]; Normal[{
             
             Map[(AtomicDensityMatrix`WignerEckart`Private`rme #)/Sqrt[
              2 AtomicDensityMatrix`WignerEckart`Private`k + 1]& , 
              AtomicDensityMatrix`PolarizationMoment[
              AtomicDensityMatrix`WignerEckart`Private`reducedSys1, 
               AtomicDensityMatrix`WignerEckart`Private`reducedSys2, All, {
               AtomicDensityMatrix`WignerEckart`Private`k, 
                AtomicDensityMatrix`WignerEckart`Private`qs}, 
               FilterRules[{AtomicDensityMatrix`WignerEckart`Private`opts, 
                 Options[
                 AtomicDensityMatrix`WignerEckart`Private`WignerEckartPM]}, 
                Options[AtomicDensityMatrix`PolarizationMoment]]]]}], 
          
          FreeQ[{{AtomicDensityMatrix`WignerEckart`Private`allowedCouplings, 
             AtomicDensityMatrix`WignerEckart`Private`neglectedCouplings}}, \
$Failed]]], 
       Options[AtomicDensityMatrix`WignerEckart`Private`WignerEckartPM] = {
        AtomicDensityMatrix`MaxRanks -> Automatic, 
         AtomicDensityMatrix`AllowedCouplings -> All, 
         AtomicDensityMatrix`NeglectedCouplings -> None}, 
       AtomicDensityMatrix`PolarizationMoment[
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`sys, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], All, {
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`k, 
           Blank[Integer]], 
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`q, 
           Alternatives[
            Blank[Integer], {
             BlankSequence[Integer]}]]}, 
         Pattern[AtomicDensityMatrix`PolarizationMoments`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`PolarizationMoment[
        AtomicDensityMatrix`PolarizationMoments`Private`sys, 
         AtomicDensityMatrix`PolarizationMoments`Private`sys, All, {
         AtomicDensityMatrix`PolarizationMoments`Private`k, 
          AtomicDensityMatrix`PolarizationMoments`Private`q}, 
         AtomicDensityMatrix`PolarizationMoments`Private`opts], 
       AtomicDensityMatrix`PolarizationMoment[
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], All, {
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`k, 
           Blank[Integer]], 
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`q, 
           Blank[Integer]]}, 
         Pattern[AtomicDensityMatrix`PolarizationMoments`Private`opts, 
          OptionsPattern[]]] := 
       AtomicDensityMatrix`PolarizationMoment[
        AtomicDensityMatrix`PolarizationMoments`Private`sys1, 
         AtomicDensityMatrix`PolarizationMoments`Private`sys2, All, {
         AtomicDensityMatrix`PolarizationMoments`Private`k, {
          AtomicDensityMatrix`PolarizationMoments`Private`q}}, 
         AtomicDensityMatrix`PolarizationMoments`Private`opts], 
       AtomicDensityMatrix`PolarizationMoment[
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`sys1, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], 
         PatternTest[
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`sys2, 
           Blank[]], AtomicDensityMatrix`AtomicSystemQ], All, {
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`k, 
           Blank[Integer]], 
          Pattern[AtomicDensityMatrix`PolarizationMoments`Private`qs, {
            BlankSequence[Integer]}]}, 
         Pattern[AtomicDensityMatrix`PolarizationMoments`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`PolarizationMoments`Private`zero = 
          AtomicDensityMatrix`ZeroTensorDecompositionMatrix[
           AtomicDensityMatrix`PolarizationMoments`Private`sys1, 
            AtomicDensityMatrix`PolarizationMoments`Private`sys2, 
            AtomicDensityMatrix`PolarizationMoments`Private`opts], 
          AtomicDensityMatrix`PolarizationMoments`Private`kPosition}, 
         AtomicDensityMatrix`PolarizationMoments`Private`kPosition = 
          Position[
            AtomicDensityMatrix`Rank[
            AtomicDensityMatrix`PolarizationMoments`Private`zero], 
            AtomicDensityMatrix`PolarizationMoments`Private`k]; Table[
           ReplacePart[
           AtomicDensityMatrix`PolarizationMoments`Private`zero, Apply[{
               SlotSequence[
               1], -AtomicDensityMatrix`PolarizationMoments`Private`q + 
               AtomicDensityMatrix`PolarizationMoments`Private`k + 1, 1}& , 
              AtomicDensityMatrix`PolarizationMoments`Private`kPosition, {1}] -> 
            1], {AtomicDensityMatrix`PolarizationMoments`Private`q, 
            AtomicDensityMatrix`PolarizationMoments`Private`qs}]], 
       Options[AtomicDensityMatrix`PolarizationMoment] = {
        AtomicDensityMatrix`MaxRanks -> Automatic}, 
       TagSet[AtomicDensityMatrix`PolarizationMoment, 
        MessageName[AtomicDensityMatrix`PolarizationMoment, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArcRadius, 
        MessageName[AtomicDensityMatrix`ArcRadius, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArrowStyle, 
        MessageName[AtomicDensityMatrix`ArrowStyle, "usage"], ""], 
       TagSet[AtomicDensityMatrix`HoldFixed, 
        MessageName[AtomicDensityMatrix`HoldFixed, "usage"], ""], 
       AtomicDensityMatrix`PlotAndFit`Private`makeVector[
         Pattern[AtomicDensityMatrix`PlotAndFit`Private`expr, 
          Blank[]]] := If[
         VectorQ[AtomicDensityMatrix`PlotAndFit`Private`expr], 
         AtomicDensityMatrix`PlotAndFit`Private`expr, {
         AtomicDensityMatrix`PlotAndFit`Private`expr}], 
       TagSet[AtomicDensityMatrix`MLabel, 
        MessageName[AtomicDensityMatrix`MLabel, "usage"], ""], 
       TagSet[AtomicDensityMatrix`StateLabels, 
        MessageName[AtomicDensityMatrix`StateLabels, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArrowFunction, 
        MessageName[AtomicDensityMatrix`ArrowFunction, "usage"], ""], 
       TagSet[AtomicDensityMatrix`LevelSpacing, 
        MessageName[AtomicDensityMatrix`LevelSpacing, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArrowSetback, 
        MessageName[AtomicDensityMatrix`ArrowSetback, "usage"], ""], 
       ProcessOptions`OptionValidator[
        AtomicDensityMatrix`ComplexExpandVariables] = 
       Alternatives[True, False, Subscript], 
       ProcessOptions`OptionValidator[AtomicDensityMatrix`DMSymbol] = 
       Blank[Symbol], 
       ProcessOptions`OptionValidator[AtomicDensityMatrix`ExpandDipoleRME] = 
       Alternatives[True, False], 
       ProcessOptions`OptionValidator[AtomicDensityMatrix`Interaction] = {
         RepeatedNull[
          Alternatives[
          "Internal", "ElectricDipole", "MagneticDipole", "Polarizability"]]},
        ProcessOptions`OptionValidator[AtomicDensityMatrix`LevelSpacing] = 
       Alternatives[
         PatternTest[
          Blank[], NumericQ], {
          PatternTest[
           Blank[], NumericQ], 
          PatternTest[
           Blank[], NumericQ]}], 
       ProcessOptions`OptionValidator[AtomicDensityMatrix`MaxRanks] = 
       Alternatives[
         PatternTest[
          Blank[Integer], Positive], Infinity], 
       ProcessOptions`OptionValidator[AtomicDensityMatrix`Representation] = 
       Alternatives[{"Zeeman"}, {"PolarizationMoments", 
          BlankNullSequence[Rule]}], 
       ProcessOptions`OptionValidator[AtomicDensityMatrix`TimeDependence] = 
       Alternatives[True, False, All], 
       ProcessOptions`OptionValidator[AtomicDensityMatrix`TimeVariable] = 
       Alternatives[
         Blank[Symbol], 
         PatternTest[
          Blank[], NumericQ]], 
       ProcessOptions`OptionValidator[AtomicDensityMatrix`TransformMatrix] = 
       Alternatives[
         PatternTest[
          Blank[], AtomicDensityMatrix`OperatorQ], Automatic], 
       ProcessOptions`OptionValidator[
         Blank[]] = Blank[], 
       TagSet[ProcessOptions`OptionValidator, 
        MessageName[ProcessOptions`OptionValidator, "usage"], ""], 
       TagSet[AtomicDensityMatrix`TransformMatrix, 
        MessageName[AtomicDensityMatrix`TransformMatrix, "usage"], 
        "TransformMatrix is an option for RotatingWaveApproximation and \
related functions that can be used to explicitly specify the unitary \
transformation to the rotating frame."], AtomicDensityMatrix`ExpandDipoleRME[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`expr, 
          Blank[]]] := 
       ReplaceAll[AtomicDensityMatrix`WignerEckart`Private`expr, 
         Flatten[
          AtomicDensityMatrix`DirectSelfProduct[
          AtomicDensityMatrix`DipoleExpansion, 
           Union[
           AtomicDensityMatrix`WignerEckart`Private`sys, 
            SameTest -> (AtomicDensityMatrix`StateLabel[#] === 
             AtomicDensityMatrix`StateLabel[#2]& )]]]], 
       TagSet[AtomicDensityMatrix`ExpandDipoleRME, 
        MessageName[AtomicDensityMatrix`ExpandDipoleRME, "usage"], ""], 
       AtomicDensityMatrix`DirectSelfProduct[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`f, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[List]]] := 
       AtomicDensityMatrix`DirectProduct[
        AtomicDensityMatrix`TensorAlgebra`Private`f, 
         AtomicDensityMatrix`TensorAlgebra`Private`a, 
         AtomicDensityMatrix`TensorAlgebra`Private`a], 
       AtomicDensityMatrix`DirectSelfProduct[
         Pattern[AtomicDensityMatrix`TensorAlgebra`Private`a, 
          Blank[List]]] := 
       AtomicDensityMatrix`DirectProduct[
        AtomicDensityMatrix`TensorAlgebra`Private`a, 
         AtomicDensityMatrix`TensorAlgebra`Private`a], 
       TagSet[AtomicDensityMatrix`DirectSelfProduct, 
        MessageName[AtomicDensityMatrix`DirectSelfProduct, "usage"], ""], 
       AtomicDensityMatrix`DipoleExpansion[
         Pattern[AtomicDensityMatrix`WignerEckart`Private`state1, 
          Blank[AtomicDensityMatrix`AtomicState]], 
         Pattern[AtomicDensityMatrix`WignerEckart`Private`state2, 
          Blank[AtomicDensityMatrix`AtomicState]]] := 
       Module[{AtomicDensityMatrix`WignerEckart`Private`l1, 
          AtomicDensityMatrix`WignerEckart`Private`j1, 
          AtomicDensityMatrix`WignerEckart`Private`l2, 
          AtomicDensityMatrix`WignerEckart`Private`j2, 
          AtomicDensityMatrix`WignerEckart`Private`lab1, 
          AtomicDensityMatrix`WignerEckart`Private`lab2, 
          AtomicDensityMatrix`WignerEckart`Private`w1, 
          AtomicDensityMatrix`WignerEckart`Private`w2, 
          AtomicDensityMatrix`WignerEckart`Private`gam1, 
          AtomicDensityMatrix`WignerEckart`Private`gam2, 
          AtomicDensityMatrix`WignerEckart`Private`br12, 
          AtomicDensityMatrix`WignerEckart`Private`br21}, {{
            AtomicDensityMatrix`WignerEckart`Private`l1, 
             AtomicDensityMatrix`WignerEckart`Private`j1, 
             AtomicDensityMatrix`WignerEckart`Private`w1, 
             AtomicDensityMatrix`WignerEckart`Private`lab1, 
             AtomicDensityMatrix`WignerEckart`Private`gam1}, {
            AtomicDensityMatrix`WignerEckart`Private`l2, 
             AtomicDensityMatrix`WignerEckart`Private`j2, 
             AtomicDensityMatrix`WignerEckart`Private`w2, 
             AtomicDensityMatrix`WignerEckart`Private`lab2, 
             AtomicDensityMatrix`WignerEckart`Private`gam2}} = Map[Through, 
            
            Map[{AtomicDensityMatrix`L, AtomicDensityMatrix`J, 
              AtomicDensityMatrix`Energy, AtomicDensityMatrix`StateLabel, 
              AtomicDensityMatrix`NaturalWidth}, {
             AtomicDensityMatrix`WignerEckart`Private`state1, 
              AtomicDensityMatrix`WignerEckart`Private`state2}]]; {
           AtomicDensityMatrix`WignerEckart`Private`br12, 
            AtomicDensityMatrix`WignerEckart`Private`br21} = {
            AtomicDensityMatrix`BranchingRatio[
            AtomicDensityMatrix`WignerEckart`Private`state1][
            AtomicDensityMatrix`WignerEckart`Private`state2], 
            AtomicDensityMatrix`BranchingRatio[
            AtomicDensityMatrix`WignerEckart`Private`state2][
            AtomicDensityMatrix`WignerEckart`Private`state1]}; 
         AtomicDensityMatrix`ReducedME[
           AtomicDensityMatrix`WignerEckart`Private`lab1, {
            AtomicDensityMatrix`Dipole, 1}, 
            AtomicDensityMatrix`WignerEckart`Private`lab2] -> Which[
            And[
            AtomicDensityMatrix`WignerEckart`Private`br21 === 0, 
             AtomicDensityMatrix`WignerEckart`Private`br12 =!= 0], (Sqrt[3] 
             Sqrt[((2 AtomicDensityMatrix`WignerEckart`Private`j2 + 1) 
                AtomicDensityMatrix`WignerEckart`Private`gam2 
                AtomicDensityMatrix`WignerEckart`Private`br12)/(
                AtomicDensityMatrix`WignerEckart`Private`w2 - 
                AtomicDensityMatrix`WignerEckart`Private`w1)^3])/2, 
            And[
            AtomicDensityMatrix`WignerEckart`Private`br12 === 0, 
             AtomicDensityMatrix`WignerEckart`Private`br21 =!= 0], (Sqrt[3] 
             Sqrt[((2 AtomicDensityMatrix`WignerEckart`Private`j1 + 1) 
                AtomicDensityMatrix`WignerEckart`Private`gam1 
                AtomicDensityMatrix`WignerEckart`Private`br21)/(
                AtomicDensityMatrix`WignerEckart`Private`w1 - 
                AtomicDensityMatrix`WignerEckart`Private`w2)^3])/2, True, 
            AtomicDensityMatrix`ReducedME[
            AtomicDensityMatrix`WignerEckart`Private`lab1, {
             AtomicDensityMatrix`Dipole, 1}, 
             AtomicDensityMatrix`WignerEckart`Private`lab2]]], 
       TagSet[AtomicDensityMatrix`DipoleExpansion, 
        MessageName[AtomicDensityMatrix`DipoleExpansion, "usage"], ""], 
       TagSet[AtomicDensityMatrix`QuantumNumberSubscripts, 
        MessageName[AtomicDensityMatrix`QuantumNumberSubscripts, "usage"], 
        ""], 
       TagSet[AtomicDensityMatrix`LevelLength, 
        MessageName[AtomicDensityMatrix`LevelLength, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ParityOffset, 
        MessageName[AtomicDensityMatrix`ParityOffset, "usage"], ""], 
       TagSet[AtomicDensityMatrix`LevelOffset, 
        MessageName[AtomicDensityMatrix`LevelOffset, "usage"], ""], 
       TagSet[AtomicDensityMatrix`LevelStyle, 
        MessageName[AtomicDensityMatrix`LevelStyle, "usage"], ""], 
       TagSet[AtomicDensityMatrix`MLabelPosition, 
        MessageName[AtomicDensityMatrix`MLabelPosition, "usage"], ""], 
       TagSet[AtomicDensityMatrix`QuantumNumberSymbols, 
        MessageName[AtomicDensityMatrix`QuantumNumberSymbols, "usage"], ""], 
       TagSet[AtomicDensityMatrix`MinLabelSpacing, 
        MessageName[AtomicDensityMatrix`MinLabelSpacing, "usage"], ""], 
       TagSet[AtomicDensityMatrix`FLabel, 
        MessageName[AtomicDensityMatrix`FLabel, "usage"], ""], 
       TagSet[AtomicDensityMatrix`JLabel, 
        MessageName[AtomicDensityMatrix`JLabel, "usage"], ""], 
       TagSet[AtomicDensityMatrix`StateLabelPosition, 
        MessageName[AtomicDensityMatrix`StateLabelPosition, "usage"], ""], 
       TagSet[AtomicDensityMatrix`ArrowSpacing, 
        MessageName[AtomicDensityMatrix`ArrowSpacing, "usage"], ""], 
       TagSet[AtomicDensityMatrix`PopulationFunction, 
        MessageName[AtomicDensityMatrix`PopulationFunction, "usage"], ""], 
       TagSet[AtomicDensityMatrix`PopulationStyle, 
        MessageName[AtomicDensityMatrix`PopulationStyle, "usage"], ""], 
       AtomicDensityMatrix`TextOnTop[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`g, 
          Blank[Graphics]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`heads = {
           AtomicDensityMatrix`LevelDiagram`Private`AffineHalfSpace, 
            AtomicDensityMatrix`LevelDiagram`Private`AffineSpace, 
            AtomicDensityMatrix`LevelDiagram`Private`Annulus, Arrow, ArrowBox,
             Ball, BezierCurve, BezierCurveBox, BoundaryMeshRegion, 
            BSplineCurve, BSplineCurveBox, BSplineSurface, 
            BSplineSurface3DBox, 
            AtomicDensityMatrix`LevelDiagram`Private`CapsuleShape, Circle, 
            CircleBox, Cone, ConeBox, ConicHullRegion, ConicHullRegion3DBox, 
            ConicHullRegionBox, Cuboid, CuboidBox, Cylinder, CylinderBox, 
            Disk, DiskBox, 
            AtomicDensityMatrix`LevelDiagram`Private`DiskSegment, Ellipsoid, 
            FilledCurve, FilledCurveBox, GeoGraphics, GeometricTransformation,
             GeometricTransformationBox, GraphicsComplex, GraphicsComplexBox, 
            GraphicsGroup, GraphicsGroupBox, HalfLine, HalfPlane, 
            AtomicDensityMatrix`LevelDiagram`Private`HalfSpace, Hexahedron, 
            HexahedronBox, 
            AtomicDensityMatrix`LevelDiagram`Private`Hyperplane, InfiniteLine,
             InfinitePlane, InfinitePlane, JoinedCurve, JoinedCurveBox, 
            Legended, Line, LineBox, LineLegend, MeshRegion, Panel, PanelBox, 
            Parallelepiped, Parallelogram, Placed, Point, PointBox, Polygon, 
            PolygonBox, Prism, PrismBox, Pyramid, PyramidBox, Raster, 
            Raster3D, Raster3DBox, RasterBox, Rectangle, RectangleBox, 
            AtomicDensityMatrix`LevelDiagram`Private`RegularPolygon, Rotate, 
            Scale, Simplex, Sphere, SphereBox, 
            AtomicDensityMatrix`LevelDiagram`Private`SphericalShell, 
            AtomicDensityMatrix`LevelDiagram`Private`StadiumShape, 
            SurfaceGraphics, Tetrahedron, TetrahedronBox, Texture, Translate, 
            Triangle, Tube, TubeBox}, 
          AtomicDensityMatrix`LevelDiagram`Private`glist, 
          AtomicDensityMatrix`LevelDiagram`Private`opts}, 
         AtomicDensityMatrix`LevelDiagram`Private`glist = 
          ReplaceAll[
           AtomicDensityMatrix`LevelDiagram`Private`g, {{Blank[Text] -> {}}, {
             Apply[Alternatives, 
                Map[
                Blank, AtomicDensityMatrix`LevelDiagram`Private`heads]] -> \
{}}}]; AtomicDensityMatrix`LevelDiagram`Private`opts = DeleteCases[
            Table[
            AtomicDensityMatrix`LevelDiagram`Private`opt -> DeleteCases[
               Map[Part[
                 Options[#, AtomicDensityMatrix`LevelDiagram`Private`opt], 1, 
                 2]& , AtomicDensityMatrix`LevelDiagram`Private`glist], {}], {
             AtomicDensityMatrix`LevelDiagram`Private`opt, {Prolog, Epilog}}],
             Blank[] -> {}]; 
         Show[AtomicDensityMatrix`LevelDiagram`Private`glist, 
           Apply[Sequence, AtomicDensityMatrix`LevelDiagram`Private`opts]]], 
       TagSet[AtomicDensityMatrix`TextOnTop, 
        MessageName[AtomicDensityMatrix`TextOnTop, "usage"], ""], 
       Attributes[ConicHullRegionBox] = {HoldAll, ReadProtected}, 
       AtomicDensityMatrix`LevelDiagram`Private`UnrollOption[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`value, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`n, 
          Blank[]]] := 
       PadRight[{}, AtomicDensityMatrix`LevelDiagram`Private`n, 
         AtomicDensityMatrix`LevelDiagram`Private`value], 
       AtomicDensityMatrix`LevelDiagram`Private`findLevelPositions[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`stateLabels, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`spacing, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`parityOffset, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelOffset, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`xPositions, 
          AtomicDensityMatrix`LevelDiagram`Private`yPositions, 
          AtomicDensityMatrix`LevelDiagram`Private`xmin, 
          AtomicDensityMatrix`LevelDiagram`Private`xmax, 
          AtomicDensityMatrix`LevelDiagram`Private`width, 
          AtomicDensityMatrix`LevelDiagram`Private`ymin, 
          AtomicDensityMatrix`LevelDiagram`Private`ymax, 
          AtomicDensityMatrix`LevelDiagram`Private`height}, 
         AtomicDensityMatrix`LevelDiagram`Private`xPositions = 
          ReplaceAll[(AtomicDensityMatrix`LevelDiagram`Private`length + 
             First[AtomicDensityMatrix`LevelDiagram`Private`spacing]) 
            Map[AtomicDensityMatrix`M, 
              AtomicDensityMatrix`LevelDiagram`Private`sys], 
            Blank[AtomicDensityMatrix`M] -> 0]; 
         AtomicDensityMatrix`LevelDiagram`Private`yPositions = ReplaceAll[
            ReplaceAll[
             ReplaceAll[
              Diagonal[AtomicDensityMatrix`LevelDiagram`Private`h], 
              Thread[
              Map[AtomicDensityMatrix`Energy, 
                 AtomicDensityMatrix`LevelDiagram`Private`stateLabels] -> 
               Range[
                  Length[
                  AtomicDensityMatrix`LevelDiagram`Private`stateLabels]] - 
                1]], {AtomicDensityMatrix`HyperfineA[
                Blank[]] -> 0.2, AtomicDensityMatrix`HyperfineB[
                Blank[]] -> 0.05}], Blank[AtomicDensityMatrix`M] -> 0]; If[
           And[
            AtomicDensityMatrix`DefinedQ[
            AtomicDensityMatrix`LevelDiagram`Private`sys, 
             AtomicDensityMatrix`Parity], 
            Or[
             NumericQ[AtomicDensityMatrix`LevelDiagram`Private`parityOffset], 
             
             ReplaceAll[
             AtomicDensityMatrix`LevelDiagram`Private`parityOffset, Automatic -> 
              And[Length[
                 AtomicDensityMatrix`LevelDiagram`Private`stateLabels] > 2, 
                AtomicDensityMatrix`AtomicSystemType[
                 AtomicDensityMatrix`LevelDiagram`Private`sys] != 
                "HyperfineZeeman"]]]], 
           AtomicDensityMatrix`LevelDiagram`Private`width = 
            Max[AtomicDensityMatrix`LevelDiagram`Private`xPositions] - Min[
             AtomicDensityMatrix`LevelDiagram`Private`xPositions] + 
             AtomicDensityMatrix`LevelDiagram`Private`length; 
           AddTo[AtomicDensityMatrix`LevelDiagram`Private`xPositions, 
             
             ReplaceAll[((AtomicDensityMatrix`LevelDiagram`Private`width + 
                First[AtomicDensityMatrix`LevelDiagram`Private`spacing]) 
               AtomicDensityMatrix`LevelDiagram`Private`parityOffset 
               AtomicDensityMatrix`Parity[
                AtomicDensityMatrix`LevelDiagram`Private`sys])/2, {
              Alternatives[True, Automatic] -> 1, 
               AtomicDensityMatrix`Even -> -1, AtomicDensityMatrix`Odd -> 
               1}]]; Null]; 
         AddTo[AtomicDensityMatrix`LevelDiagram`Private`xPositions, 
           AtomicDensityMatrix`LevelDiagram`Private`levelOffsetList[
           AtomicDensityMatrix`LevelDiagram`Private`sys, 
            AtomicDensityMatrix`LevelDiagram`Private`levelOffset]]; 
         AtomicDensityMatrix`LevelDiagram`Private`yPositions = 
          AtomicDensityMatrix`LevelDiagram`Private`spacePoints[
            AtomicDensityMatrix`LevelDiagram`Private`yPositions + 
             1000 AtomicDensityMatrix`LevelDiagram`Private`xPositions, 
             Last[AtomicDensityMatrix`LevelDiagram`Private`spacing]] - 1000 
           AtomicDensityMatrix`LevelDiagram`Private`xPositions; {
           AtomicDensityMatrix`LevelDiagram`Private`xmin, 
            AtomicDensityMatrix`LevelDiagram`Private`xmax} = {
           Min[AtomicDensityMatrix`LevelDiagram`Private`xPositions] - 
            AtomicDensityMatrix`LevelDiagram`Private`length/2, 
            Max[AtomicDensityMatrix`LevelDiagram`Private`xPositions] + 
            AtomicDensityMatrix`LevelDiagram`Private`length/2}; 
         AtomicDensityMatrix`LevelDiagram`Private`width = 
          AtomicDensityMatrix`LevelDiagram`Private`xmax - 
           AtomicDensityMatrix`LevelDiagram`Private`xmin; {
           AtomicDensityMatrix`LevelDiagram`Private`ymin, 
            AtomicDensityMatrix`LevelDiagram`Private`ymax} = {
            Min[AtomicDensityMatrix`LevelDiagram`Private`yPositions], 
            Max[AtomicDensityMatrix`LevelDiagram`Private`yPositions]}; 
         AtomicDensityMatrix`LevelDiagram`Private`height = 
          AtomicDensityMatrix`LevelDiagram`Private`ymax - 
           AtomicDensityMatrix`LevelDiagram`Private`ymin; {
           
           Transpose[{
            AtomicDensityMatrix`LevelDiagram`Private`xPositions, 
             AtomicDensityMatrix`LevelDiagram`Private`yPositions}], 
           AtomicDensityMatrix`LevelDiagram`Private`xmin, 
           AtomicDensityMatrix`LevelDiagram`Private`xmax, 
           AtomicDensityMatrix`LevelDiagram`Private`width, 
           AtomicDensityMatrix`LevelDiagram`Private`ymin, 
           AtomicDensityMatrix`LevelDiagram`Private`ymax, 
           AtomicDensityMatrix`LevelDiagram`Private`height}], 
       AtomicDensityMatrix`LevelDiagram`Private`levelOffsetList[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelOffset, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`offsetVal = 
          Flatten[{AtomicDensityMatrix`LevelDiagram`Private`levelOffset}]}, 
         Switch[AtomicDensityMatrix`LevelDiagram`Private`offsetVal, 
          Alternatives[{}, {None}], 
          ConstantArray[0, 
           Length[AtomicDensityMatrix`LevelDiagram`Private`sys]], {
           Repeated[
            PatternTest[
             Blank[], NumericQ]]}, 
          AtomicDensityMatrix`LevelDiagram`Private`UnrollOption[
          AtomicDensityMatrix`LevelDiagram`Private`offsetVal, 
           Length[AtomicDensityMatrix`LevelDiagram`Private`sys]], {
           Repeated[
            Blank[Rule]]}, 
          Total[
           Apply[Boole[
              AtomicDensityMatrix`StateMatchQ[
              AtomicDensityMatrix`LevelDiagram`Private`sys, #]] 
            AtomicDensityMatrix`StateEvaluate[
             AtomicDensityMatrix`LevelDiagram`Private`sys, #2]& , 
            AtomicDensityMatrix`LevelDiagram`Private`offsetVal, {1}]]]], 
       AtomicDensityMatrix`LevelDiagram`Private`spacePoints[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`minSpacing, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`pos, 
          AtomicDensityMatrix`LevelDiagram`Private`p, 
          AtomicDensityMatrix`LevelDiagram`Private`startpos, 
          AtomicDensityMatrix`LevelDiagram`Private`ord, 
          AtomicDensityMatrix`LevelDiagram`Private`sortpos}, 
         AtomicDensityMatrix`LevelDiagram`Private`ord = 
          Ordering[AtomicDensityMatrix`LevelDiagram`Private`opos]; 
         AtomicDensityMatrix`LevelDiagram`Private`sortpos = 
          Part[AtomicDensityMatrix`LevelDiagram`Private`opos, 
            AtomicDensityMatrix`LevelDiagram`Private`ord]; If[Min[
             Differences[AtomicDensityMatrix`LevelDiagram`Private`sortpos]] >= 
           AtomicDensityMatrix`LevelDiagram`Private`minSpacing, 
           Return[AtomicDensityMatrix`LevelDiagram`Private`opos]]; 
         AtomicDensityMatrix`LevelDiagram`Private`pos = 
          Array[AtomicDensityMatrix`LevelDiagram`Private`p, 
            Length[AtomicDensityMatrix`LevelDiagram`Private`opos]]; 
         AtomicDensityMatrix`LevelDiagram`Private`startpos = 
          AtomicDensityMatrix`LevelDiagram`Private`minSpacing (Range[
              Length[AtomicDensityMatrix`LevelDiagram`Private`opos]] - (
             Length[AtomicDensityMatrix`LevelDiagram`Private`opos] - 1)/2 - 
            1.); Part[
           AtomicDensityMatrix`LevelDiagram`Private`sortpos, 
            AtomicDensityMatrix`LevelDiagram`Private`ord] = 
          ReplaceAll[AtomicDensityMatrix`LevelDiagram`Private`pos, 
            Last[
             FindMinimum[{
               
               Total[(AtomicDensityMatrix`LevelDiagram`Private`pos - 
                 AtomicDensityMatrix`LevelDiagram`Private`sortpos)^2], 
               Apply[And, 
                Thread[
                Most[AtomicDensityMatrix`LevelDiagram`Private`pos] + 
                  AtomicDensityMatrix`LevelDiagram`Private`minSpacing/2 < 
                 Rest[AtomicDensityMatrix`LevelDiagram`Private`pos] - 
                  AtomicDensityMatrix`LevelDiagram`Private`minSpacing/2]]}, 
              
              Transpose[{
               AtomicDensityMatrix`LevelDiagram`Private`pos, 
                AtomicDensityMatrix`LevelDiagram`Private`startpos}]]]]; 
         AtomicDensityMatrix`LevelDiagram`Private`sortpos], 
       AtomicDensityMatrix`LevelDiagram`Private`makeLevels[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelStyle, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`levels, 
          AtomicDensityMatrix`LevelDiagram`Private`levelStyles}, 
         AtomicDensityMatrix`LevelDiagram`Private`levelStyles = (Replace[
            AtomicDensityMatrix`EnsureList[#], {} -> {{}}]& )[
           AtomicDensityMatrix`LevelDiagram`Private`levelStyle]; 
         AtomicDensityMatrix`LevelDiagram`Private`levels = 
          Map[Line[{#, #} + 
             AtomicDensityMatrix`LevelDiagram`Private`length {{(-1)/2, 0}, {
                1/2, 0}}]& , AtomicDensityMatrix`LevelDiagram`Private`pos]; 
         AtomicDensityMatrix`LevelDiagram`Private`levelStyles = 
          AtomicDensityMatrix`LevelDiagram`Private`UnrollOption[
           AtomicDensityMatrix`LevelDiagram`Private`levelStyles, 
            Length[AtomicDensityMatrix`LevelDiagram`Private`levels]]; 
         AtomicDensityMatrix`LevelDiagram`Private`levels = 
          ReplacePart[
           AtomicDensityMatrix`LevelDiagram`Private`levels, 
            Position[AtomicDensityMatrix`LevelDiagram`Private`levelStyles, 
              Alternatives[None, False]] -> {}]; 
         AtomicDensityMatrix`LevelDiagram`Private`levelStyles = 
          ReplaceAll[
           AtomicDensityMatrix`LevelDiagram`Private`levelStyles, 
            Alternatives[None, False] -> {}]; 
         Transpose[{
           AtomicDensityMatrix`LevelDiagram`Private`levelStyles, 
            AtomicDensityMatrix`LevelDiagram`Private`levels}]], 
       AtomicDensityMatrix`LevelDiagram`Private`makeMLabels[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`stateLabels, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`ymin, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`ymax, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`height, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`mLabel, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`mLabelPosition, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`m, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`msub, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`labelStyle, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`mLabels, 
          AtomicDensityMatrix`LevelDiagram`Private`mLabelPositions, 
          AtomicDensityMatrix`LevelDiagram`Private`mLabelText, 
          AtomicDensityMatrix`LevelDiagram`Private`shortPos, 
          AtomicDensityMatrix`LevelDiagram`Private`duplicatePositions}, If[
           Not[AtomicDensityMatrix`LevelDiagram`Private`mLabel], 
           Return[{}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`mLabels = 
          AtomicDensityMatrix`LevelDiagram`Private`UnrollOption[
           AtomicDensityMatrix`LevelDiagram`Private`mLabel, 
            Length[AtomicDensityMatrix`LevelDiagram`Private`sys]]; 
         AtomicDensityMatrix`LevelDiagram`Private`mLabelPositions = 
          AtomicDensityMatrix`LevelDiagram`Private`UnrollOption[
           AtomicDensityMatrix`LevelDiagram`Private`mLabelPosition, 
            Length[AtomicDensityMatrix`LevelDiagram`Private`sys]]; 
         AtomicDensityMatrix`LevelDiagram`Private`mLabelPositions = Map[If[
             ListQ[#], #, {#, {0, 0}}]& , 
            AtomicDensityMatrix`LevelDiagram`Private`mLabelPositions]; 
         AtomicDensityMatrix`LevelDiagram`Private`mLabelPositions = 
          MapThread[Switch[
              Part[#, 1], Top, {{
                Part[#2, 1], AtomicDensityMatrix`LevelDiagram`Private`ymax}, 
               1}, Bottom, {{
                Part[#2, 1], 
                AtomicDensityMatrix`LevelDiagram`Private`ymin}, -1}, 
              Above, {#2, 1}, Below, {#2, -1}, Automatic, {#2, 
               If[
               Part[#2, 2] > 
                AtomicDensityMatrix`LevelDiagram`Private`height/2, 1, -1]}] + {
              Part[#, 2], 0}& , {
            AtomicDensityMatrix`LevelDiagram`Private`mLabelPositions, 
             AtomicDensityMatrix`LevelDiagram`Private`pos}]; 
         AtomicDensityMatrix`LevelDiagram`Private`mLabelText = MapThread[If[
             Not[
              AtomicDensityMatrix`DefinedQ[#2, AtomicDensityMatrix`M]], "", 
             Switch[#, 
              Alternatives[True, Automatic, "Short"], 
              AtomicDensityMatrix`LevelDiagram`Private`QuantumNumberSymbol[#2,
                 AtomicDensityMatrix`LevelDiagram`Private`m, 
                AtomicDensityMatrix`LevelDiagram`Private`msub, 
                AtomicDensityMatrix`LevelDiagram`Private`stateLabels] == 
              AtomicDensityMatrix`M[#2], "Bare", 
              AtomicDensityMatrix`M[#2], 
              Alternatives[False, None], "", 
              Blank[], #]]& , {
            AtomicDensityMatrix`LevelDiagram`Private`mLabels, 
             AtomicDensityMatrix`LevelDiagram`Private`sys}]; 
         AtomicDensityMatrix`LevelDiagram`Private`duplicatePositions = 
          SortBy[
            Range[
             Length[
             AtomicDensityMatrix`LevelDiagram`Private`mLabelPositions]], {
             Part[
             AtomicDensityMatrix`LevelDiagram`Private`mLabelPositions, #], 
             AtomicDensityMatrix`F[
              Part[AtomicDensityMatrix`LevelDiagram`Private`sys, #]]}& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`duplicatePositions = Flatten[
            Map[Most, 
             SplitBy[
             AtomicDensityMatrix`LevelDiagram`Private`duplicatePositions, 
              Part[AtomicDensityMatrix`LevelDiagram`Private`mLabelPositions, \
#]& ]]]; Part[
           AtomicDensityMatrix`LevelDiagram`Private`mLabelText, 
            AtomicDensityMatrix`LevelDiagram`Private`duplicatePositions] = ""; 
         AtomicDensityMatrix`LevelDiagram`Private`shortPos = Flatten[
            Position[
            AtomicDensityMatrix`LevelDiagram`Private`mLabels 
             AtomicDensityMatrix`LevelDiagram`Private`mLabelText, "Short" 
             Except[""]]]; 
         AtomicDensityMatrix`LevelDiagram`Private`shortPos = 
          SortBy[AtomicDensityMatrix`LevelDiagram`Private`shortPos, Reverse[
             Flatten[
              Part[
              AtomicDensityMatrix`LevelDiagram`Private`mLabelPositions, #]]]& \
]; AtomicDensityMatrix`LevelDiagram`Private`shortPos = Flatten[
            Map[Rest, 
             SplitBy[AtomicDensityMatrix`LevelDiagram`Private`shortPos, Most[
               Reverse[
                Flatten[
                 Part[
                 AtomicDensityMatrix`LevelDiagram`Private`mLabelPositions, \
#]]]]& ]]]; 
         Part[AtomicDensityMatrix`LevelDiagram`Private`mLabelText, 
            AtomicDensityMatrix`LevelDiagram`Private`shortPos] = Part[
            AtomicDensityMatrix`M[
            AtomicDensityMatrix`LevelDiagram`Private`sys], 
            AtomicDensityMatrix`LevelDiagram`Private`shortPos]; Union[
           If[
           Union[AtomicDensityMatrix`LevelDiagram`Private`mLabelText] === {
             ""}, {}, 
            MapThread[Text[
              
              Style[#2, "InlineMath", Background -> None, 
               AtomicDensityMatrix`LevelDiagram`Private`labelStyle], 
              First[#], {
               If[
                And[#3 === Short, Head[#2] === Equal], 0.75, 0], 0.1 - 1.3 
               Part[#, 2]}]& , {
             AtomicDensityMatrix`LevelDiagram`Private`mLabelPositions, 
              AtomicDensityMatrix`LevelDiagram`Private`mLabelText, 
              AtomicDensityMatrix`LevelDiagram`Private`mLabels}]]]], 
       AtomicDensityMatrix`LevelDiagram`Private`QuantumNumberSymbol[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`state, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`symbol, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sub, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`stateLabels, 
          Blank[]]] := 
       Switch[AtomicDensityMatrix`LevelDiagram`Private`sub, True, 
         Subscript[AtomicDensityMatrix`LevelDiagram`Private`symbol, 
          AtomicDensityMatrix`StateLabel[
          AtomicDensityMatrix`LevelDiagram`Private`state]], Primes, 
         Derivative[Part[
            Position[AtomicDensityMatrix`LevelDiagram`Private`stateLabels, 
             AtomicDensityMatrix`StateLabel[
             AtomicDensityMatrix`LevelDiagram`Private`state], {1}, 1, Heads -> 
             False], 1, 1] - 1][
         AtomicDensityMatrix`LevelDiagram`Private`symbol], 
         Blank[], AtomicDensityMatrix`LevelDiagram`Private`symbol], 
       AtomicDensityMatrix`LevelDiagram`Private`makeJFLabels[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`xmin, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`xmax, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`stateLabels, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSymbols, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSubscripts, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`labelStyle, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelLength, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelSpacing, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`minLabelSpacing, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`fLabel, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`jLabel, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`mLabel, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`stateLabel, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`stateLabelPosition, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`j, 
          AtomicDensityMatrix`LevelDiagram`Private`f, 
          AtomicDensityMatrix`LevelDiagram`Private`m, 
          AtomicDensityMatrix`LevelDiagram`Private`jsub, 
          AtomicDensityMatrix`LevelDiagram`Private`fsub, 
          AtomicDensityMatrix`LevelDiagram`Private`msub, 
          AtomicDensityMatrix`LevelDiagram`Private`fStates, 
          AtomicDensityMatrix`LevelDiagram`Private`fLabelText, 
          AtomicDensityMatrix`LevelDiagram`Private`jStates, 
          AtomicDensityMatrix`LevelDiagram`Private`jLabelText, 
          AtomicDensityMatrix`LevelDiagram`Private`stateLabelText, 
          AtomicDensityMatrix`LevelDiagram`Private`labelText, 
          AtomicDensityMatrix`LevelDiagram`Private`xPositions, 
          AtomicDensityMatrix`LevelDiagram`Private`yPositions, 
          AtomicDensityMatrix`LevelDiagram`Private`statePos, 
          AtomicDensityMatrix`LevelDiagram`Private`side, 
          AtomicDensityMatrix`LevelDiagram`Private`s}, {
           AtomicDensityMatrix`LevelDiagram`Private`j, 
            AtomicDensityMatrix`LevelDiagram`Private`f, 
            AtomicDensityMatrix`LevelDiagram`Private`m} = 
          AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSymbols; {
           AtomicDensityMatrix`LevelDiagram`Private`jsub, 
            AtomicDensityMatrix`LevelDiagram`Private`fsub, 
            AtomicDensityMatrix`LevelDiagram`Private`msub} = 
          AtomicDensityMatrix`LevelDiagram`Private`quantumNumberSubscripts; 
         AtomicDensityMatrix`LevelDiagram`Private`fStates = 
          Union[AtomicDensityMatrix`LevelDiagram`Private`sys, 
            SameTest -> (And[
             AtomicDensityMatrix`StateLabel[#] === 
              AtomicDensityMatrix`StateLabel[#2], AtomicDensityMatrix`F[#] === 
              AtomicDensityMatrix`F[#2]]& )]; 
         AtomicDensityMatrix`LevelDiagram`Private`fLabelText = If[
            And[
            AtomicDensityMatrix`AtomicSystemType[
              AtomicDensityMatrix`LevelDiagram`Private`sys] == 
             "HyperfineZeeman", 
             Not[
              MatchQ[AtomicDensityMatrix`LevelDiagram`Private`fLabel, 
               Alternatives[None, False]]]], 
            Replace[
            AtomicDensityMatrix`LevelDiagram`Private`fLabel, 
             Alternatives[Automatic, All, True] -> 
             Map[AtomicDensityMatrix`LevelDiagram`Private`QuantumNumberSymbol[\
#, AtomicDensityMatrix`LevelDiagram`Private`f, 
                 AtomicDensityMatrix`LevelDiagram`Private`fsub, 
                 AtomicDensityMatrix`LevelDiagram`Private`stateLabels] == 
               AtomicDensityMatrix`F[#]& , 
               AtomicDensityMatrix`LevelDiagram`Private`fStates]], {}]; 
         AtomicDensityMatrix`LevelDiagram`Private`jStates = Map[Last, 
            Split[
             SortBy[AtomicDensityMatrix`LevelDiagram`Private`fStates, {
               AtomicDensityMatrix`StateLabel[#], 
               AtomicDensityMatrix`J[#], 
               AtomicDensityMatrix`F[#]}& ], And[
             AtomicDensityMatrix`StateLabel[#] === 
              AtomicDensityMatrix`StateLabel[#2], AtomicDensityMatrix`J[#] === 
              AtomicDensityMatrix`J[#2]]& ]]; 
         AtomicDensityMatrix`LevelDiagram`Private`jLabelText = If[
            And[
            AtomicDensityMatrix`AtomicSystemType[
              AtomicDensityMatrix`LevelDiagram`Private`sys] != "Toy", 
             Not[
              MatchQ[AtomicDensityMatrix`LevelDiagram`Private`jLabel, 
               Alternatives[None, False]]]], 
            Replace[
            AtomicDensityMatrix`LevelDiagram`Private`jLabel, 
             Alternatives[Automatic, All, True] -> 
             Map[AtomicDensityMatrix`LevelDiagram`Private`QuantumNumberSymbol[\
#, AtomicDensityMatrix`LevelDiagram`Private`j, 
                 AtomicDensityMatrix`LevelDiagram`Private`jsub, 
                 AtomicDensityMatrix`LevelDiagram`Private`stateLabels] == 
               AtomicDensityMatrix`J[#]& , 
               AtomicDensityMatrix`LevelDiagram`Private`jStates]], Null]; 
         AtomicDensityMatrix`LevelDiagram`Private`stateLabelText = If[
            Not[
             MatchQ[AtomicDensityMatrix`LevelDiagram`Private`stateLabel, 
              Alternatives[None, False]]], 
            Replace[
            AtomicDensityMatrix`LevelDiagram`Private`stateLabel, 
             Alternatives[Automatic, All, True] -> 
             AtomicDensityMatrix`StateLabel[
              AtomicDensityMatrix`LevelDiagram`Private`jStates]], Null]; 
         AtomicDensityMatrix`LevelDiagram`Private`stateLabelText = 
          If[AtomicDensityMatrix`LevelDiagram`Private`jLabelText === 
            AtomicDensityMatrix`LevelDiagram`Private`stateLabelText === 
            Null, {}, 
            ReplaceAll[
             Map[Row[#, ","]& , 
              Thread[
               Map[AtomicDensityMatrix`LevelDiagram`Private`UnrollOption[#, 
                 Length[
                 AtomicDensityMatrix`LevelDiagram`Private`jStates]]& , {
                AtomicDensityMatrix`LevelDiagram`Private`stateLabelText, 
                 AtomicDensityMatrix`LevelDiagram`Private`jLabelText}]]], 
             Null -> Sequence[]]]; 
         AtomicDensityMatrix`LevelDiagram`Private`labelText = 
          Switch[{AtomicDensityMatrix`LevelDiagram`Private`fLabelText, 
             AtomicDensityMatrix`LevelDiagram`Private`stateLabelText}, {{}, \
{}}, 
            Return[{}], {{}, 
             Blank[]}, 
            AtomicDensityMatrix`LevelDiagram`Private`stateLabelText, {
             Blank[], {}}, 
            AtomicDensityMatrix`LevelDiagram`Private`fLabelText, 
            Blank[], 
            MapThread[Row[
              Join[
               
               If[(AtomicDensityMatrix`LevelDiagram`Private`statePos = 
                 Position[
                  AtomicDensityMatrix`LevelDiagram`Private`jStates, #]) != \
{}, {
                 Extract[
                 AtomicDensityMatrix`LevelDiagram`Private`stateLabelText, 
                  First[AtomicDensityMatrix`LevelDiagram`Private`statePos]], 
                 ", "}, {}], {#2}]]& , {
             AtomicDensityMatrix`LevelDiagram`Private`fStates, 
              AtomicDensityMatrix`LevelDiagram`Private`fLabelText}]]; {
           AtomicDensityMatrix`LevelDiagram`Private`xPositions, 
            AtomicDensityMatrix`LevelDiagram`Private`yPositions} = Transpose[
            Map[Transpose[
              Extract[AtomicDensityMatrix`LevelDiagram`Private`pos, #]]& , 
             Map[
             AtomicDensityMatrix`StatePosition[
              AtomicDensityMatrix`LevelDiagram`Private`sys, 
               And[
               AtomicDensityMatrix`StateLabel == 
                AtomicDensityMatrix`StateLabel[#], AtomicDensityMatrix`F == 
                AtomicDensityMatrix`F[#]]]& , 
              If[
              AtomicDensityMatrix`LevelDiagram`Private`fLabelText == {}, 
               AtomicDensityMatrix`LevelDiagram`Private`jStates, 
               AtomicDensityMatrix`LevelDiagram`Private`fStates]]]]; {
           AtomicDensityMatrix`LevelDiagram`Private`xPositions, 
            AtomicDensityMatrix`LevelDiagram`Private`side} = Transpose[
            MapThread[
            Switch[#, Left, {
              AtomicDensityMatrix`LevelDiagram`Private`xmin - 
               AtomicDensityMatrix`LevelDiagram`Private`levelSpacing, -1}, 
              Right, {AtomicDensityMatrix`LevelDiagram`Private`xmax + 
               AtomicDensityMatrix`LevelDiagram`Private`levelSpacing, 1}, 
              Automatic, 
              AtomicDensityMatrix`LevelDiagram`Private`s = 
               Sign[Mean[#2] - 
                 Mean[{AtomicDensityMatrix`LevelDiagram`Private`xmin, 
                   AtomicDensityMatrix`LevelDiagram`Private`xmax}] - 
                 10^(-6)]; {(
                  AtomicDensityMatrix`LevelDiagram`Private`s (
                   AtomicDensityMatrix`LevelDiagram`Private`levelLength + 
                   AtomicDensityMatrix`LevelDiagram`Private`levelSpacing))/2 + 
                If[AtomicDensityMatrix`LevelDiagram`Private`s < 0, 
                  Min[#2], 
                  Max[#2]], AtomicDensityMatrix`LevelDiagram`Private`s}]& , {
              AtomicDensityMatrix`LevelDiagram`Private`UnrollOption[
              AtomicDensityMatrix`LevelDiagram`Private`stateLabelPosition, 
               Length[AtomicDensityMatrix`LevelDiagram`Private`xPositions]], 
              AtomicDensityMatrix`LevelDiagram`Private`xPositions}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`yPositions = 
          AtomicDensityMatrix`LevelDiagram`Private`spacePoints[
            1000 AtomicDensityMatrix`LevelDiagram`Private`xPositions + 
             Map[Mean, AtomicDensityMatrix`LevelDiagram`Private`yPositions], 
             AtomicDensityMatrix`LevelDiagram`Private`minLabelSpacing] - 1000 
           AtomicDensityMatrix`LevelDiagram`Private`xPositions; If[
           Alternatives[
           AtomicDensityMatrix`LevelDiagram`Private`mLabel === Short, 
            "Short"], AtomicDensityMatrix`LevelDiagram`Private`labelText = 
           Map[Row[{#, 
               Invisible["M="]}]& , 
             AtomicDensityMatrix`LevelDiagram`Private`labelText]]; 
         MapThread[Text[
            TraditionalForm[
             
             Style[#3, "InlineMath", Background -> None, 
              AtomicDensityMatrix`LevelDiagram`Private`labelStyle]], #, {-#2, 
             0}]& , {
            
            Transpose[{
             AtomicDensityMatrix`LevelDiagram`Private`xPositions, 
              AtomicDensityMatrix`LevelDiagram`Private`yPositions}], 
            AtomicDensityMatrix`LevelDiagram`Private`side, 
            AtomicDensityMatrix`LevelDiagram`Private`labelText}]], 
       AtomicDensityMatrix`LevelDiagram`Private`setUpArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`sys, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`h, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`arcRadius = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram`Private`setUpArrows, 
            AtomicDensityMatrix`ArcRadius, 
            OptionValue[AtomicDensityMatrix`ArcRadius]], 
          AtomicDensityMatrix`LevelDiagram`Private`arrowOffset = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram`Private`setUpArrows, 
            AtomicDensityMatrix`ArrowOffset, 
            OptionValue[AtomicDensityMatrix`ArrowOffset]], 
          AtomicDensityMatrix`LevelDiagram`Private`arrowSetback = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram`Private`setUpArrows, 
            AtomicDensityMatrix`ArrowSetback, 
            OptionValue[AtomicDensityMatrix`ArrowSetback]], 
          AtomicDensityMatrix`LevelDiagram`Private`allowedCouplings = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram`Private`setUpArrows, 
            AtomicDensityMatrix`AllowedCouplings, 
            OptionValue[AtomicDensityMatrix`AllowedCouplings]], 
          AtomicDensityMatrix`LevelDiagram`Private`arrowStyle = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram`Private`setUpArrows, 
            AtomicDensityMatrix`ArrowStyle, 
            OptionValue[AtomicDensityMatrix`ArrowStyle]], 
          AtomicDensityMatrix`LevelDiagram`Private`arrowFunction = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram`Private`setUpArrows, 
            AtomicDensityMatrix`ArrowFunction, 
            OptionValue[AtomicDensityMatrix`ArrowFunction]], 
          AtomicDensityMatrix`LevelDiagram`Private`\
suppressOffResonantCouplings = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram`Private`setUpArrows, 
            AtomicDensityMatrix`SuppressOffResonantCouplings, 
            OptionValue[AtomicDensityMatrix`SuppressOffResonantCouplings]], 
          AtomicDensityMatrix`LevelDiagram`Private`levelLength = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram`Private`setUpArrows, 
            AtomicDensityMatrix`LevelLength, 
            OptionValue[AtomicDensityMatrix`LevelLength]], 
          AtomicDensityMatrix`LevelDiagram`Private`maxArcSlope = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram`Private`setUpArrows, 
            AtomicDensityMatrix`MaxArcSlope, 
            OptionValue[AtomicDensityMatrix`MaxArcSlope]], 
          AtomicDensityMatrix`LevelDiagram`Private`extraArrows = 
          ProcessOptions`ProcessOption[
           AtomicDensityMatrix`LevelDiagram`Private`setUpArrows, 
            AtomicDensityMatrix`ExtraArrows, 
            OptionValue[AtomicDensityMatrix`ExtraArrows]], 
          AtomicDensityMatrix`LevelDiagram`Private`mixing, 
          AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          AtomicDensityMatrix`LevelDiagram`Private`thisarrsty, 
          AtomicDensityMatrix`LevelDiagram`Private`matelem, 
          AtomicDensityMatrix`LevelDiagram`Private`freqs, 
          AtomicDensityMatrix`LevelDiagram`Private`x1, 
          AtomicDensityMatrix`LevelDiagram`Private`y1, 
          AtomicDensityMatrix`LevelDiagram`Private`x2, 
          AtomicDensityMatrix`LevelDiagram`Private`y2, 
          AtomicDensityMatrix`LevelDiagram`Private`arr, 
          AtomicDensityMatrix`LevelDiagram`Private`setback, 
          AtomicDensityMatrix`LevelDiagram`Private`thisarcrad, 
          AtomicDensityMatrix`LevelDiagram`Private`mask}, 
         Condition[
         AtomicDensityMatrix`LevelDiagram`Private`mask = 
           If[AtomicDensityMatrix`LevelDiagram`Private`allowedCouplings === 
             "Populations", 
             Clip[
              (# + Transpose[#]& )[
               ConstantArray[
                Diagonal[AtomicDensityMatrix`LevelDiagram`Private`rho], 
                Length[AtomicDensityMatrix`LevelDiagram`Private`rho]]]], 
             Normal[
              AtomicDensityMatrix`MatrixElementMask[
              AtomicDensityMatrix`LevelDiagram`Private`sys, 
               AtomicDensityMatrix`LevelDiagram`Private`sys, 
               AtomicDensityMatrix`LevelDiagram`Private`allowedCouplings]]]; 
          AtomicDensityMatrix`LevelDiagram`Private`mixing = DeleteCases[
             Join[
              Position[
              AtomicDensityMatrix`LevelDiagram`Private`mask 
               AtomicDensityMatrix`LevelDiagram`Private`h, 
               Condition[
                Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                 Blank[]], 
                Not[
                 PossibleZeroQ[
                 AtomicDensityMatrix`LevelDiagram`Private`x]]], {2}, Heads -> 
               False], 
              Apply[List, 
               Union[
                Flatten[
                 Map[{
                   Reverse[#], #}& , 
                  Flatten[
                   Map[Tuples, 
                    Flatten[
                    Map[Flatten[
                    AtomicDensityMatrix`StatePosition[
                    AtomicDensityMatrix`LevelDiagram`Private`sys, #]]& , 
                    
                    Flatten[{
                    AtomicDensityMatrix`LevelDiagram`Private`extraArrows}], {
                    2}]]]]]]], {1}]], {
              Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
               Blank[]], 
              Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
               Blank[]]}]; 
          If[AtomicDensityMatrix`LevelDiagram`Private`mixing == {}, 
            Return[{}]]; 
          AtomicDensityMatrix`LevelDiagram`Private`arrows = Last[
             Last[
              Reap[
               
               Map[({{AtomicDensityMatrix`LevelDiagram`Private`x1, 
                    AtomicDensityMatrix`LevelDiagram`Private`y1}, {
                   AtomicDensityMatrix`LevelDiagram`Private`x2, 
                    AtomicDensityMatrix`LevelDiagram`Private`y2}} = 
                 Part[AtomicDensityMatrix`LevelDiagram`Private`pos, #]; If[
                  And[
                   Or[
                   AtomicDensityMatrix`LevelDiagram`Private`y1 < 
                    AtomicDensityMatrix`LevelDiagram`Private`y2, 
                    And[
                    AtomicDensityMatrix`LevelDiagram`Private`y1 == 
                    AtomicDensityMatrix`LevelDiagram`Private`y2, 
                    AtomicDensityMatrix`LevelDiagram`Private`x1 < 
                    AtomicDensityMatrix`LevelDiagram`Private`x2]], (
                    AtomicDensityMatrix`LevelDiagram`Private`thisarrsty = 
                    AtomicDensityMatrix`PopAppend[
                    AtomicDensityMatrix`LevelDiagram`Private`arrowStyle]) =!= 
                   None], AtomicDensityMatrix`LevelDiagram`Private`matelem = 
                   ExpandAll[
                    TrigToExp[
                    Extract[AtomicDensityMatrix`LevelDiagram`Private`h, #]]]; 
                  AtomicDensityMatrix`LevelDiagram`Private`freqs = 
                   ReplaceAll[
                    Union[
                    
                    Cases[{AtomicDensityMatrix`LevelDiagram`Private`matelem}, 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
                    Blank[]] E^(Complex[
                    Alternatives[0, 0.], 
                    PatternTest[
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                    Blank[]], NumericQ]] Optional[
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`w, 
                    Blank[]]] AtomicDensityMatrix`t) :> {
                    AtomicDensityMatrix`LevelDiagram`Private`x, 
                    AtomicDensityMatrix`LevelDiagram`Private`a, 
                    AtomicDensityMatrix`LevelDiagram`Private`w}, 2]], {} -> {{
                    AtomicDensityMatrix`LevelDiagram`Private`y2 - 
                    AtomicDensityMatrix`LevelDiagram`Private`y1, 
                    AtomicDensityMatrix`LevelDiagram`Private`matelem, 
                    AtomicDensityMatrix`LevelDiagram`Private`w}}]; 
                  If[AtomicDensityMatrix`LevelDiagram`Private`\
suppressOffResonantCouplings, AtomicDensityMatrix`LevelDiagram`Private`freqs = 
                    DeleteCases[
                    AtomicDensityMatrix`LevelDiagram`Private`freqs, 
                    Condition[
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`f, 
                    Blank[]], 
                    Negative[
                    First[AtomicDensityMatrix`LevelDiagram`Private`f]]]]]; 
                  AtomicDensityMatrix`LevelDiagram`Private`freqs = 
                   ReplaceAll[
                    AtomicDensityMatrix`LevelDiagram`Private`freqs, {
                    Condition[{
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                    Blank[]], 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
                    Blank[]], 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`w, 
                    Blank[]]}, 
                    Not[
                    NumericQ[
                    AtomicDensityMatrix`LevelDiagram`Private`w]]] :> {
                    AtomicDensityMatrix`LevelDiagram`Private`y2 - 
                    AtomicDensityMatrix`LevelDiagram`Private`y1, 
                    AtomicDensityMatrix`LevelDiagram`Private`a}, {
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
                    Blank[]], 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
                    Blank[]], 
                    Pattern[AtomicDensityMatrix`LevelDiagram`Private`w, 
                    Blank[]]} :> {
                    AtomicDensityMatrix`LevelDiagram`Private`x, 
                    AtomicDensityMatrix`LevelDiagram`Private`a}}]; 
                  AtomicDensityMatrix`LevelDiagram`Private`arr = 
                   Map[(AtomicDensityMatrix`LevelDiagram`Private`y2 = 
                    AtomicDensityMatrix`LevelDiagram`Private`y1 + 
                    Part[#, 1]; {{
                    AtomicDensityMatrix`LevelDiagram`Private`x1, 
                    AtomicDensityMatrix`LevelDiagram`Private`y1}, {
                    AtomicDensityMatrix`LevelDiagram`Private`x2, 
                    AtomicDensityMatrix`LevelDiagram`Private`y2}} + 
                    AtomicDensityMatrix`LevelDiagram`Private`levelLength 
                    AtomicDensityMatrix`PopAppend[
                    AtomicDensityMatrix`LevelDiagram`Private`arrowOffset] {{
                    Order[
                    AtomicDensityMatrix`LevelDiagram`Private`x1, 
                    AtomicDensityMatrix`LevelDiagram`Private`x2], 
                    Order[
                    AtomicDensityMatrix`LevelDiagram`Private`y1, 
                    AtomicDensityMatrix`LevelDiagram`Private`y2]}, {
                    Order[
                    AtomicDensityMatrix`LevelDiagram`Private`x2, 
                    AtomicDensityMatrix`LevelDiagram`Private`x1], 
                    Order[
                    AtomicDensityMatrix`LevelDiagram`Private`y2, 
                    AtomicDensityMatrix`LevelDiagram`Private`y1]}})& , 
                    AtomicDensityMatrix`LevelDiagram`Private`freqs]; 
                  AtomicDensityMatrix`LevelDiagram`Private`arr = 
                   Map[(AtomicDensityMatrix`LevelDiagram`Private`setback = (
                    AtomicDensityMatrix`LevelDiagram`Private`levelLength 
                    AtomicDensityMatrix`PopAppend[
                    AtomicDensityMatrix`LevelDiagram`Private`arrowSetback])/
                    Norm[
                    Apply[Subtract, #]]; {
                    AtomicDensityMatrix`LevelDiagram`Private`line[#, 
                    Part[
                    AtomicDensityMatrix`LevelDiagram`Private`setback, 1]], 
                    
                    AtomicDensityMatrix`LevelDiagram`Private`line[#, 1 - Part[
                    AtomicDensityMatrix`LevelDiagram`Private`setback, 2]]})& ,
                     AtomicDensityMatrix`LevelDiagram`Private`arr]; 
                  AtomicDensityMatrix`LevelDiagram`Private`thisarcrad = 
                   First[AtomicDensityMatrix`LevelDiagram`Private`arcRadius = 
                    RotateLeft[
                    AtomicDensityMatrix`LevelDiagram`Private`arcRadius]]; 
                  AtomicDensityMatrix`LevelDiagram`Private`thisarrsty = 
                   Replace[
                    AtomicDensityMatrix`LevelDiagram`Private`thisarrsty, List -> 
                    Sequence, {1}, Heads -> True]; 
                  Apply[Sow[{
                    AtomicDensityMatrix`LevelDiagram`Private`thisarrsty, 
                    If[Abs[
                    AtomicDensityMatrix`Slope[#]] <= 
                    AtomicDensityMatrix`LevelDiagram`Private`maxArcSlope, 
                    
                    AtomicDensityMatrix`LevelDiagram`Private`arf[#, 
                    AtomicDensityMatrix`LevelDiagram`Private`thisarcrad, 
                    AtomicDensityMatrix`ConnectArc], 
                    
                    AtomicDensityMatrix`LevelDiagram`Private`arf[#, #2, 
                    AtomicDensityMatrix`LevelDiagram`Private`arrowFunction]]}]\
& , 
                    Transpose[{AtomicDensityMatrix`LevelDiagram`Private`arr, 
                    Part[
                    AtomicDensityMatrix`LevelDiagram`Private`freqs, All, 
                    2]}], {1}]]; Null)& , 
                AtomicDensityMatrix`LevelDiagram`Private`mixing]]]], 
          
          FreeQ[{{AtomicDensityMatrix`LevelDiagram`Private`arcRadius, 
             AtomicDensityMatrix`LevelDiagram`Private`arrowOffset, 
             AtomicDensityMatrix`LevelDiagram`Private`arrowSetback, 
             AtomicDensityMatrix`LevelDiagram`Private`allowedCouplings, 
             AtomicDensityMatrix`LevelDiagram`Private`arrowStyle, 
             AtomicDensityMatrix`LevelDiagram`Private`arrowFunction, 
             AtomicDensityMatrix`LevelDiagram`Private`\
suppressOffResonantCouplings, 
             AtomicDensityMatrix`LevelDiagram`Private`levelLength, 
             AtomicDensityMatrix`LevelDiagram`Private`maxArcSlope, 
             AtomicDensityMatrix`LevelDiagram`Private`extraArrows}}, \
$Failed]]], 
       Options[AtomicDensityMatrix`LevelDiagram`Private`setUpArrows] = {
        AtomicDensityMatrix`ExtraArrows -> {}, 
         AtomicDensityMatrix`ArcRadius -> {}, 
         AtomicDensityMatrix`ArrowOffset -> {}, 
         AtomicDensityMatrix`ArrowSetback -> {}, 
         AtomicDensityMatrix`ArrowStyle -> {}, 
         AtomicDensityMatrix`SuppressOffResonantCouplings -> {}, 
         AtomicDensityMatrix`MaxArcSlope -> {}, 
         AtomicDensityMatrix`ArrowFunction -> {}, 
         AtomicDensityMatrix`LevelLength -> {}, 
         AtomicDensityMatrix`AllowedCouplings -> {}}, 
       TagSet[AtomicDensityMatrix`SuppressOffResonantCouplings, 
        MessageName[
        AtomicDensityMatrix`SuppressOffResonantCouplings, "usage"], ""], 
       TagSet[AtomicDensityMatrix`MaxArcSlope, 
        MessageName[AtomicDensityMatrix`MaxArcSlope, "usage"], ""], 
       Attributes[AtomicDensityMatrix`PopAppend] = {HoldFirst}, 
       AtomicDensityMatrix`PopAppend[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`list, 
          Blank[]]] := (
        AtomicDensityMatrix`LevelDiagram`Private`list = 
         RotateLeft[AtomicDensityMatrix`LevelDiagram`Private`list]; 
        Last[AtomicDensityMatrix`LevelDiagram`Private`list]), 
       TagSet[AtomicDensityMatrix`PopAppend, 
        MessageName[AtomicDensityMatrix`PopAppend, "usage"], ""], 
       AtomicDensityMatrix`LevelDiagram`Private`line[{{
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`x1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`y1, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`x2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`y2, 
            Blank[]]}}, 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`s, 
          Blank[]]] = {
        AtomicDensityMatrix`LevelDiagram`Private`x1 + 
         AtomicDensityMatrix`LevelDiagram`Private`s (-
            AtomicDensityMatrix`LevelDiagram`Private`x1 + 
           AtomicDensityMatrix`LevelDiagram`Private`x2), 
         AtomicDensityMatrix`LevelDiagram`Private`y1 + 
         AtomicDensityMatrix`LevelDiagram`Private`s (-
            AtomicDensityMatrix`LevelDiagram`Private`y1 + 
           AtomicDensityMatrix`LevelDiagram`Private`y2)}, 
       AtomicDensityMatrix`Slope[{{
           Pattern[AtomicDensityMatrix`Common`Private`x1, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`Common`Private`y1, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`Common`Private`x2, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`Common`Private`y2, 
            Blank[]]}}] := 
       If[AtomicDensityMatrix`Common`Private`x2 != 
         AtomicDensityMatrix`Common`Private`x1, (
          AtomicDensityMatrix`Common`Private`y2 - 
          AtomicDensityMatrix`Common`Private`y1)/(
         AtomicDensityMatrix`Common`Private`x2 - 
         AtomicDensityMatrix`Common`Private`x1), Infinity], 
       TagSet[AtomicDensityMatrix`Slope, 
        MessageName[AtomicDensityMatrix`Slope, "usage"], ""], 
       AtomicDensityMatrix`ConnectArc[{
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`p1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`p2, 
           Blank[]]}, 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`o, 
          Blank[]]] := Cases[
         Flatten[
          First[
           ParametricPlot[
            Evaluate[
             
             Splines`SplineFit[{
              AtomicDensityMatrix`LevelDiagram`Private`p1, 
               Mean[{AtomicDensityMatrix`LevelDiagram`Private`p1, 
                  AtomicDensityMatrix`LevelDiagram`Private`p2}] + 
               AtomicDensityMatrix`LevelDiagram`Private`o 
                Dot[{{0, -1}, {1, 0}}, 
                  Abs[
                  AtomicDensityMatrix`LevelDiagram`Private`p2 - 
                   AtomicDensityMatrix`LevelDiagram`Private`p1]], 
               AtomicDensityMatrix`LevelDiagram`Private`p2}, Splines`Bezier][
             AtomicDensityMatrix`LevelDiagram`Private`x]], {
            AtomicDensityMatrix`LevelDiagram`Private`x, 0, 2}]]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`line, 
           Blank[Line]] :> 
         Apply[Arrow, AtomicDensityMatrix`LevelDiagram`Private`line], 
         Infinity], 
       TagSet[AtomicDensityMatrix`ConnectArc, 
        MessageName[AtomicDensityMatrix`ConnectArc, "usage"], ""], 
       Splines`SplineFit[
         PatternTest[
          Pattern[Splines`Private`pts, 
           Blank[List]], MatrixQ[#, NumberQ[
            N[#]]& ]& ], 
         PatternTest[
          Pattern[Splines`Private`type, 
           Blank[Symbol]], 
          MemberQ[{
           Splines`Cubic, Splines`Bezier, Splines`CompositeBezier}, #]& ]] := 
       Splines`SplineFunction[Splines`Private`type, {0., 
          N[Length[Splines`Private`pts] - 1]}, Splines`Private`pts, 
         Splines`Private`splineinternal[
         Splines`Private`pts, Splines`Private`type]], 
       TagSet[Splines`SplineFit, 
        MessageName[Splines`SplineFit, "cbezlen"], 
        "Points are needed to generate a spline."], 
       TagSet[Splines`SplineFit, 
        MessageName[Splines`SplineFit, "usage"], 
        "\!\(\*RowBox[{\"SplineFit\", \"[\", RowBox[{RowBox[{\"{\", \
RowBox[{SubscriptBox[StyleBox[\"pt\", \"TI\"], StyleBox[\"1\", \"TR\"]], \
\",\", SubscriptBox[StyleBox[\"pt\", \"TI\"], StyleBox[\"2\", \"TR\"]], \
\",\", StyleBox[\"\[Ellipsis]\", \"TR\"]}], \"}\"}], \",\", \
StyleBox[\"type\", \"TI\"]}], \"]\"}]\) generates a SplineFunction object of \
the specified \!\(\*StyleBox[\"type\", \"TI\"]\) from the points \
\!\(\*RowBox[{SubscriptBox[StyleBox[\"pt\", \"TI\"], StyleBox[\"1\", \
\"TR\"]], \",\", SubscriptBox[StyleBox[\"pt\", \"TI\"], StyleBox[\"2\", \
\"TR\"]], \",\", StyleBox[\"\[Ellipsis]\", \"TR\"]}]\)."], 
       TagSet[Splines`Cubic, 
        MessageName[Splines`Cubic, "usage"], 
        "Cubic is a setting specifying the type of spline generated by Spline \
and SplineFit."], 
       TagSet[Splines`Bezier, 
        MessageName[Splines`Bezier, "usage"], 
        "Bezier is a setting specifying the type of spline generated by \
Spline and SplineFit."], 
       TagSet[Splines`CompositeBezier, 
        MessageName[Splines`CompositeBezier, "usage"], 
        "CompositeBezier is a setting specifying the type of spline generated \
by Spline and SplineFit."], Splines`SplineFunction[
         Pattern[Splines`Private`type, 
          Blank[]], {
          Pattern[Splines`Private`min, 
           Blank[]], 
          Pattern[Splines`Private`max, 
           Blank[]]}, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]][
         PatternTest[
          Pattern[Splines`Private`in, 
           Blank[]], NumberQ[
           N[#]]& ]] := Module[{Splines`Private`out}, If[
           Or[
           Splines`Private`in < Splines`Private`min, Splines`Private`in > 
            Splines`Private`max], Message[
             MessageName[Splines`SplineFunction, "dmval"], 
             Splines`Private`in]; Splines`Private`out = $Failed, 
           Splines`Private`out = Splines`Private`evalspline[
             Which[Splines`Private`in == Splines`Private`max, 
              Min[Splines`Private`max, Splines`Private`in], 
              Splines`Private`in == Splines`Private`min, 
              Max[Splines`Private`min, Splines`Private`in], True, 
              Splines`Private`in], Splines`Private`type, Splines`Private`pts, 
             Splines`Private`internal]]; 
         Condition[Splines`Private`out, Splines`Private`out =!= $Failed]], 
       UpSetDelayed[
        MakeBoxes[
         Splines`SplineFunction[
          Pattern[Splines`Private`t, 
           Blank[]], 
          Pattern[Splines`Private`r, 
           Blank[]], 
          Pattern[Splines`Private`b, 
           BlankSequence[]]], 
         Pattern[FormatType, 
          Blank[]]], 
        Format[
         Row[{
          "SplineFunction[", Splines`Private`t, ", ", Splines`Private`r, ", ",
            "<>", "]"}], FormatType]], Format[
         Splines`SplineFunction[
          Pattern[Splines`Private`t, 
           Blank[]], 
          Pattern[Splines`Private`r, 
           Blank[]], 
          Pattern[Splines`Private`b, 
           BlankSequence[]]]] := 
       Row[{"SplineFunction[", Splines`Private`t, ", ", Splines`Private`r, 
          ", ", "<>", "]"}], 
       TagSet[Splines`SplineFunction, 
        MessageName[Splines`SplineFunction, "dmval"], 
        "Input value `1` lies outside the domain of the spline function."], 
       TagSet[Splines`SplineFunction, 
        MessageName[Splines`SplineFunction, "usage"], 
        "\!\(\*RowBox[{\"SplineFunction\", \"[\", RowBox[{StyleBox[\"type\", \
\"TI\"], \",\", StyleBox[\"domain\", \"TI\"], \",\", StyleBox[\"internal\", \
\"TI\"]}], \"]\"}]\) represents a spline function created by the SplineFit \
function parametrizing a curve with the parameter in the specified \
\!\(\*StyleBox[\"domain\", \"TI\"]\). When given a parameter value as an \
argument it returns the corresponding point on the curve."], 
       Splines`Private`evalspline[
         PatternTest[
          Pattern[Splines`Private`pt, 
           Blank[]], # == 0& ], Splines`Cubic, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]] := Part[Splines`Private`internal, 1, All, 1], 
       Splines`Private`evalspline[
         Pattern[Splines`Private`pt, 
          Blank[]], Splines`Cubic, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]] := Module[{Splines`Private`tmp}, 
         Dot[
          ({1, #, #^2, #^3}& )[
           
           If[(Splines`Private`tmp = Mod[Splines`Private`pt, 1]) == 0, 1, 
            Splines`Private`tmp]], 
          Transpose[
           Part[Splines`Private`internal, 
            Ceiling[Splines`Private`pt]]]]], Splines`Private`evalspline[
         Pattern[Splines`Private`pt, 
          Blank[]], Splines`CompositeBezier, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]] := 
       Module[{Splines`Private`ln = Length[Splines`Private`pts] - 1}, 
         Splines`Private`evalspline[
          If[
          Splines`Private`ln <= 3, Splines`Private`pt/Splines`Private`ln, 
           Splines`Private`pt (1/2 - If[
             OddQ[Splines`Private`ln], 1/(2 Splines`Private`ln), 0])], 
          Splines`Cubic, Splines`Private`pts, Splines`Private`internal]], 
       Splines`Private`evalspline[
         Pattern[Splines`Private`pt, 
          Blank[]], Splines`Bezier, 
         Pattern[Splines`Private`pts, 
          Blank[]], 
         Pattern[Splines`Private`internal, 
          Blank[]]] := 
       Splines`Private`internal[
        Splines`Private`pt/(Length[Splines`Private`pts] - 1)], 
       Attributes[MakeBoxes] = {HoldAllComplete}, 
       Splines`Private`splineinternal[
         Pattern[Splines`Private`pts, 
          Blank[List]], Splines`Cubic] := Transpose[
         Map[Splines`Private`splinecoord, 
          Transpose[Splines`Private`pts]]], Splines`Private`splineinternal[
         Pattern[Splines`Private`pts, 
          Blank[List]], Splines`CompositeBezier] := 
       Module[{Splines`Private`eqns, Splines`Private`gpts = 
          Splines`Private`pts, Splines`Private`ln = 
          Length[Splines`Private`pts], Splines`Private`end}, If[
           Or[Splines`Private`ln < 3, 
            OddQ[Splines`Private`ln]], 
           Which[Splines`Private`ln == 1, Splines`Private`gpts = Flatten[
              Table[Splines`Private`gpts, {4}]], Splines`Private`ln == 2, 
            Splines`Private`gpts = {
              Part[Splines`Private`gpts, 1], 
              Part[Splines`Private`gpts, 1], 
              Part[Splines`Private`gpts, 2], 
              Part[Splines`Private`gpts, 2]}, 
            OddQ[Splines`Private`ln], 
            AppendTo[Splines`Private`gpts, 
             Last[Splines`Private`gpts]], True, Message[
              MessageName[Splines`SplineFit, "cbezlen"]]; Return[
              InString[$Line]]]]; 
         Splines`Private`end = Take[Splines`Private`gpts, -4]; 
         Splines`Private`gpts = Partition[
            Drop[Splines`Private`gpts, -2], 4, 2]; 
         Splines`Private`gpts = 
          Apply[{#, #2, #3 - (#4 - #3), #3}& , Splines`Private`gpts, {1}]; 
         AppendTo[Splines`Private`gpts, Splines`Private`end]; 
         Apply[Transpose[{#, 3 (#2 - #), 3 (#3 - 2 #2 + #), #4 - 3 #3 + 
             3 #2 - #}]& , Splines`Private`gpts, {1}]], 
       Splines`Private`splineinternal[
         Pattern[Splines`Private`pts, 
          Blank[List]], Splines`Bezier] := 
       Module[{Splines`Private`n, Splines`Private`eq, Splines`Private`deg = 
          Length[Splines`Private`pts] - 1}, 
         Splines`Private`eq = 
          Table[(CellLabel -> "Out[13]=")^
             Splines`Private`n (1 - (CellLabel -> "Out[13]="))^(
              Splines`Private`deg - Splines`Private`n), {
            Splines`Private`n, 0, Splines`Private`deg}]; Evaluate[
           Apply[Plus, Splines`Private`pts Table[
              Binomial[Splines`Private`deg, Splines`Private`n], {
              Splines`Private`n, 0, Splines`Private`deg}] 
            Splines`Private`eq]]& ], Splines`Private`splinecoord[
         Pattern[Splines`Private`vals, 
          Blank[]]] := 
       Module[{Splines`Private`lst, Splines`Private`ln = 
          Length[Splines`Private`vals], Splines`Private`d, Splines`Private`n},
          Splines`Private`lst = 
          Join[{3 (Part[Splines`Private`vals, 2] - Part[
              Splines`Private`vals, 1])}, 
            Table[
            3 (Part[Splines`Private`vals, Splines`Private`n + 2] - Part[
              Splines`Private`vals, Splines`Private`n]), {
             Splines`Private`n, Splines`Private`ln - 2}], {
            3 (Part[Splines`Private`vals, Splines`Private`ln] - Part[
              Splines`Private`vals, Splines`Private`ln - 1])}]; 
         Splines`Private`d = 
          Splines`Private`trisolve[Splines`Private`lst, Splines`Private`ln]; 
         Table[{
            Part[Splines`Private`vals, Splines`Private`n], 
            Part[Splines`Private`d, Splines`Private`n], 
            3 (Part[Splines`Private`vals, Splines`Private`n + 1] - Part[
              Splines`Private`vals, Splines`Private`n]) - 2 
            Part[Splines`Private`d, Splines`Private`n] - Part[
            Splines`Private`d, Splines`Private`n + 1], 
            2 (Part[Splines`Private`vals, Splines`Private`n] - Part[
              Splines`Private`vals, Splines`Private`n + 1]) + 
            Part[Splines`Private`d, Splines`Private`n] + 
            Part[Splines`Private`d, Splines`Private`n + 1]}, {
           Splines`Private`n, 1, Splines`Private`ln - 1}]], 
       Splines`Private`trisolve[
         Pattern[Splines`Private`lst, 
          Blank[]], 
         Pattern[Splines`Private`ln, 
          Blank[]]] := Module[{}, 
         LinearSolve[
          SparseArray[{Band[{1, 1}] -> Join[{2}, 
              Table[4, {Splines`Private`ln - 2}], {2}], Band[{1, 2}] -> 1, 
            Band[{2, 1}] -> 1}], Splines`Private`lst]], $Line = 35, 
       AtomicDensityMatrix`LevelDiagram`Private`adjustArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelLength, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`xpos, 
          AtomicDensityMatrix`LevelDiagram`Private`vertxranges, 
          AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`otherArrows}, If[
           Or[
            Not[
             NumericQ[AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing]],
             AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing == 0, 
            AtomicDensityMatrix`LevelDiagram`Private`arrows == {}], 
           Return[AtomicDensityMatrix`LevelDiagram`Private`arrows]]; {
           AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`otherArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
           AtomicDensityMatrix`LevelDiagram`Private`arrows, 
            Chop[AtomicDensityMatrix`LevelDiagram`Private`tx[#] - 
              AtomicDensityMatrix`LevelDiagram`Private`bx[#]] == 0& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          SortBy[AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`bx]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Split[AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
            Abs[AtomicDensityMatrix`LevelDiagram`Private`bx[#] - 
              AtomicDensityMatrix`LevelDiagram`Private`bx[#2]] < 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Map[SortBy[#, AtomicDensityMatrix`LevelDiagram`Private`by[#] - 
             AtomicDensityMatrix`LevelDiagram`Private`ty[#]& ]& , 
            AtomicDensityMatrix`LevelDiagram`Private`vertArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Map[AtomicDensityMatrix`LevelDiagram`Private`\
partitionVerticalArrows, AtomicDensityMatrix`LevelDiagram`Private`vertArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`xpos = 
          Map[AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing 
             AtomicDensityMatrix`LevelDiagram`Private`levelLength (Range[
                Length[#]] - (Length[#] + 1)/2) + Mean[
              Map[AtomicDensityMatrix`LevelDiagram`Private`tx, 
               Part[#, All, 1]]]& , 
            AtomicDensityMatrix`LevelDiagram`Private`vertArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Map[MapThread[
            AtomicDensityMatrix`LevelDiagram`Private`setTopBottom, #]& , 
            
            Transpose[{
             AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
              AtomicDensityMatrix`LevelDiagram`Private`xpos}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertxranges = Map[{
             Min[#], 
             Max[#]}& , 
            Map[
            AtomicDensityMatrix`LevelDiagram`Private`tx, 
             AtomicDensityMatrix`LevelDiagram`Private`vertArrows, {3}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`vertArrows = 
          Flatten[AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 2]; 
         AtomicDensityMatrix`LevelDiagram`Private`otherArrows = 
          Map[AtomicDensityMatrix`LevelDiagram`Private`clearLeftRight[#, 
             AtomicDensityMatrix`LevelDiagram`Private`vertxranges]& , 
            AtomicDensityMatrix`LevelDiagram`Private`otherArrows]; {
           AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`otherArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
           AtomicDensityMatrix`LevelDiagram`Private`otherArrows, Or[
            AtomicDensityMatrix`LevelDiagram`Private`ar[#] > 0, 
             And[
             AtomicDensityMatrix`LevelDiagram`Private`ar[#] == 0, 
              AtomicDensityMatrix`LevelDiagram`Private`slope[#] == 0]]& ]; {
           AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`otherArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
           AtomicDensityMatrix`LevelDiagram`Private`otherArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`ar[#] < 0& ]; {
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
           AtomicDensityMatrix`LevelDiagram`Private`otherArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`slope[#] > 0& ]; {
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`lx, 
            AtomicDensityMatrix`LevelDiagram`Private`ly, 
            AtomicDensityMatrix`LevelDiagram`Private`setLeft, 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing, 
            AtomicDensityMatrix`LevelDiagram`Private`levelLength]; {
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`rx, 
            AtomicDensityMatrix`LevelDiagram`Private`ry, 
            AtomicDensityMatrix`LevelDiagram`Private`setRight, 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing, -
            AtomicDensityMatrix`LevelDiagram`Private`levelLength]; {
           AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`DivideList[
            Join[
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
             AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows], Or[
            AtomicDensityMatrix`LevelDiagram`Private`ar[#] < 0, 
             And[
             AtomicDensityMatrix`LevelDiagram`Private`ar[#] == 0, 
              AtomicDensityMatrix`LevelDiagram`Private`slope[#] == 0]]& ]; {
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`rx, 
            AtomicDensityMatrix`LevelDiagram`Private`ry, 
            AtomicDensityMatrix`LevelDiagram`Private`setRight, 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing, -
            AtomicDensityMatrix`LevelDiagram`Private`levelLength]; {
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows} = 
          AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows, 
            AtomicDensityMatrix`LevelDiagram`Private`lx, 
            AtomicDensityMatrix`LevelDiagram`Private`ly, 
            AtomicDensityMatrix`LevelDiagram`Private`setLeft, 
            AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing, 
            AtomicDensityMatrix`LevelDiagram`Private`levelLength]; 
         Join[
          AtomicDensityMatrix`LevelDiagram`Private`vertArrows, 
           AtomicDensityMatrix`LevelDiagram`Private`posSlantArrows, 
           AtomicDensityMatrix`LevelDiagram`Private`negSlantArrows, 
           AtomicDensityMatrix`LevelDiagram`Private`aboveHorizArrows, 
           AtomicDensityMatrix`LevelDiagram`Private`belowHorizArrows]], 
       AtomicDensityMatrix`LevelDiagram`Private`DivideList[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`list, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`func, 
          Blank[]]] := ({
         Extract[AtomicDensityMatrix`LevelDiagram`Private`list, #], 
         Delete[AtomicDensityMatrix`LevelDiagram`Private`list, #]}& )[
         Position[AtomicDensityMatrix`LevelDiagram`Private`list, 
          PatternTest[
           Blank[], AtomicDensityMatrix`LevelDiagram`Private`func], {1}, 
          Heads -> False]], AtomicDensityMatrix`LevelDiagram`Private`tx[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         AtomicDensityMatrix`LevelDiagram`Private`tpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`tpts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         SortBy[
          AtomicDensityMatrix`LevelDiagram`Private`pts[
          AtomicDensityMatrix`LevelDiagram`Private`arr], Reverse]], 
       AtomicDensityMatrix`LevelDiagram`Private`pts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := 
       Part[AtomicDensityMatrix`LevelDiagram`Private`arr, -1, 1], 
       AtomicDensityMatrix`LevelDiagram`Private`bx[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         AtomicDensityMatrix`LevelDiagram`Private`bpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`bpts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         SortBy[
          AtomicDensityMatrix`LevelDiagram`Private`pts[
          AtomicDensityMatrix`LevelDiagram`Private`arr], Reverse]], 
       AtomicDensityMatrix`LevelDiagram`Private`by[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         AtomicDensityMatrix`LevelDiagram`Private`bpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`ty[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         AtomicDensityMatrix`LevelDiagram`Private`tpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`partitions, 
          Blank[]], {}] := 
       AtomicDensityMatrix`LevelDiagram`Private`partitions, 
       AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          Blank[]]] := 
       AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[{{
           First[AtomicDensityMatrix`LevelDiagram`Private`arrows]}}, 
         Rest[AtomicDensityMatrix`LevelDiagram`Private`arrows]], 
       AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`partitions, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`interval, 
          AtomicDensityMatrix`LevelDiagram`Private`position}, 
         AtomicDensityMatrix`LevelDiagram`Private`interval = Apply[Interval, 
            Map[{
              AtomicDensityMatrix`LevelDiagram`Private`by[#], 
              AtomicDensityMatrix`LevelDiagram`Private`ty[#]}& , 
             Last[AtomicDensityMatrix`LevelDiagram`Private`partitions]]]; 
         AtomicDensityMatrix`LevelDiagram`Private`interval = 
          Interval[{10.^(-10), (-1) 10.^(-10)} + 
            First[AtomicDensityMatrix`LevelDiagram`Private`interval]]; 
         AtomicDensityMatrix`LevelDiagram`Private`position = 
          Position[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
            Condition[
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
              Blank[List]], 
             IntervalIntersection[
              AtomicDensityMatrix`LevelDiagram`Private`interval, 
               Interval[{
                 AtomicDensityMatrix`LevelDiagram`Private`by[
                 AtomicDensityMatrix`LevelDiagram`Private`arr], 
                 AtomicDensityMatrix`LevelDiagram`Private`ty[
                 AtomicDensityMatrix`LevelDiagram`Private`arr]}]] == 
             Interval[]], {1}, 1]; 
         If[AtomicDensityMatrix`LevelDiagram`Private`position == {}, 
           AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
            Append[AtomicDensityMatrix`LevelDiagram`Private`partitions, {
              First[AtomicDensityMatrix`LevelDiagram`Private`arrows]}], 
            Rest[AtomicDensityMatrix`LevelDiagram`Private`arrows]], 
           AtomicDensityMatrix`LevelDiagram`Private`partitionVerticalArrows[
            MapAt[Append[#, 
              Part[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
               Part[
               AtomicDensityMatrix`LevelDiagram`Private`position, 1, 1]]]& , 
             AtomicDensityMatrix`LevelDiagram`Private`partitions, -1], 
            Delete[AtomicDensityMatrix`LevelDiagram`Private`arrows, 
             Part[
             AtomicDensityMatrix`LevelDiagram`Private`position, 1, 1]]]]], 
       AtomicDensityMatrix`LevelDiagram`Private`setTopBottom[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`shift, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`LevelDiagram`Private`arr, 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y1, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y2, 
              Blank[]]}}, 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
            BlankSequence[]]] -> 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
            AtomicDensityMatrix`LevelDiagram`Private`shift, 
             AtomicDensityMatrix`LevelDiagram`Private`y1}, {
            AtomicDensityMatrix`LevelDiagram`Private`shift, 
             AtomicDensityMatrix`LevelDiagram`Private`y2}}, 
           AtomicDensityMatrix`LevelDiagram`Private`a]], 
       AtomicDensityMatrix`LevelDiagram`Private`clearLeftRight[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`ranges, 
          Blank[]]] := 
       Fold[AtomicDensityMatrix`LevelDiagram`Private`clearEndpoint[#, 
          AtomicDensityMatrix`LevelDiagram`Private`ranges, #2]& , 
         AtomicDensityMatrix`LevelDiagram`Private`arr, {{
          AtomicDensityMatrix`LevelDiagram`Private`lx, 
           AtomicDensityMatrix`LevelDiagram`Private`setLeft, Max}, {
          AtomicDensityMatrix`LevelDiagram`Private`rx, 
           AtomicDensityMatrix`LevelDiagram`Private`setRight, Min}}], 
       AtomicDensityMatrix`LevelDiagram`Private`clearEndpoint[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`ranges, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`p, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`setFunc, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`minmax, 
           Blank[]]}] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`range = 
          Apply[Interval, 
            Cases[AtomicDensityMatrix`LevelDiagram`Private`ranges, 
             Condition[{
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`min, 
                Blank[]], 
               Pattern[AtomicDensityMatrix`LevelDiagram`Private`max, 
                Blank[]]}, AtomicDensityMatrix`LevelDiagram`Private`min < 
              AtomicDensityMatrix`LevelDiagram`Private`p[
               AtomicDensityMatrix`LevelDiagram`Private`arr] < 
              AtomicDensityMatrix`LevelDiagram`Private`max]]]}, 
         If[
         AtomicDensityMatrix`LevelDiagram`Private`range === Interval[], 
          AtomicDensityMatrix`LevelDiagram`Private`arr, 
          AtomicDensityMatrix`LevelDiagram`Private`setFunc[
          AtomicDensityMatrix`LevelDiagram`Private`arr, 
           AtomicDensityMatrix`LevelDiagram`Private`minmax[
            First[AtomicDensityMatrix`LevelDiagram`Private`range]]]]], 
       AtomicDensityMatrix`LevelDiagram`Private`lx[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         AtomicDensityMatrix`LevelDiagram`Private`lpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`lpts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         Sort[
          AtomicDensityMatrix`LevelDiagram`Private`pts[
          AtomicDensityMatrix`LevelDiagram`Private`arr]]], 
       AtomicDensityMatrix`LevelDiagram`Private`setLeft[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`shift, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`LevelDiagram`Private`arr, 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y1, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y2, 
              Blank[]]}}, 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
            BlankSequence[]]] :> 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
            AtomicDensityMatrix`LevelDiagram`Private`x1 + (
               AtomicDensityMatrix`LevelDiagram`Private`shift - 
               AtomicDensityMatrix`LevelDiagram`Private`x1) 
              Boole[AtomicDensityMatrix`LevelDiagram`Private`x1 < 
                AtomicDensityMatrix`LevelDiagram`Private`x2], 
             AtomicDensityMatrix`LevelDiagram`Private`y1}, {
            AtomicDensityMatrix`LevelDiagram`Private`x2 + (
               AtomicDensityMatrix`LevelDiagram`Private`shift - 
               AtomicDensityMatrix`LevelDiagram`Private`x2) 
              Boole[AtomicDensityMatrix`LevelDiagram`Private`x2 < 
                AtomicDensityMatrix`LevelDiagram`Private`x1], 
             AtomicDensityMatrix`LevelDiagram`Private`y2}}, 
           AtomicDensityMatrix`LevelDiagram`Private`a]], 
       AtomicDensityMatrix`LevelDiagram`Private`rx[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := First[
         AtomicDensityMatrix`LevelDiagram`Private`rpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`rpts[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         Sort[
          AtomicDensityMatrix`LevelDiagram`Private`pts[
          AtomicDensityMatrix`LevelDiagram`Private`arr]]], 
       AtomicDensityMatrix`LevelDiagram`Private`setRight[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`shift, 
          Blank[]]] := 
       ReplaceAll[
        AtomicDensityMatrix`LevelDiagram`Private`arr, 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x1, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y1, 
              Blank[]]}, {
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`x2, 
              Blank[]], 
             Pattern[AtomicDensityMatrix`LevelDiagram`Private`y2, 
              Blank[]]}}, 
           Pattern[AtomicDensityMatrix`LevelDiagram`Private`a, 
            BlankSequence[]]] :> 
         AtomicDensityMatrix`LevelDiagram`Private`arf[{{
            AtomicDensityMatrix`LevelDiagram`Private`x1 + (
               AtomicDensityMatrix`LevelDiagram`Private`shift - 
               AtomicDensityMatrix`LevelDiagram`Private`x1) 
              Boole[AtomicDensityMatrix`LevelDiagram`Private`x1 > 
                AtomicDensityMatrix`LevelDiagram`Private`x2], 
             AtomicDensityMatrix`LevelDiagram`Private`y1}, {
            AtomicDensityMatrix`LevelDiagram`Private`x2 + (
               AtomicDensityMatrix`LevelDiagram`Private`shift - 
               AtomicDensityMatrix`LevelDiagram`Private`x2) 
              Boole[AtomicDensityMatrix`LevelDiagram`Private`x2 > 
                AtomicDensityMatrix`LevelDiagram`Private`x1], 
             AtomicDensityMatrix`LevelDiagram`Private`y2}}, 
           AtomicDensityMatrix`LevelDiagram`Private`a]], 
       AtomicDensityMatrix`LevelDiagram`Private`ar[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := 
       If[Part[AtomicDensityMatrix`LevelDiagram`Private`arr, -1, 3] === 
         AtomicDensityMatrix`ConnectArc, 
         Part[AtomicDensityMatrix`LevelDiagram`Private`arr, -1, 2], 0], 
       AtomicDensityMatrix`LevelDiagram`Private`slope[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := AtomicDensityMatrix`Slope[
         AtomicDensityMatrix`LevelDiagram`Private`pts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`adjustQuadrant[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`slantArrows, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`horizArrows, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`y, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`setFunc, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelLength, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, 
          AtomicDensityMatrix`LevelDiagram`Private`xpos}, 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = Join[
            Map[{#, {0, -Abs[
                 AtomicDensityMatrix`LevelDiagram`Private`slope[#]]}}& , 
             AtomicDensityMatrix`LevelDiagram`Private`slantArrows], 
            
            Map[{#, {
              1, -(AtomicDensityMatrix`LevelDiagram`Private`rx[#] - 
                AtomicDensityMatrix`LevelDiagram`Private`lx[#])}}& , 
             AtomicDensityMatrix`LevelDiagram`Private`horizArrows]]; 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = 
          SortBy[AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, Through[
             {
             AtomicDensityMatrix`LevelDiagram`Private`y, 
              AtomicDensityMatrix`LevelDiagram`Private`x}[
              First[#]]]& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = 
          Split[AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, And[
            Chop[AtomicDensityMatrix`LevelDiagram`Private`y[
                 First[#]] - AtomicDensityMatrix`LevelDiagram`Private`y[
                First[#2]]] == 0, 
             Abs[AtomicDensityMatrix`LevelDiagram`Private`x[
                 First[#]] - AtomicDensityMatrix`LevelDiagram`Private`x[
                First[#2]]] < 
             AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing]& ]; 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = Map[Part[
             SortBy[#, Last], All, 1]& , 
            AtomicDensityMatrix`LevelDiagram`Private`shiftArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`xpos = 
          Map[AtomicDensityMatrix`LevelDiagram`Private`arrowSpacing 
             AtomicDensityMatrix`LevelDiagram`Private`levelLength Range[
               Length[#]] + Mean[
              Map[AtomicDensityMatrix`LevelDiagram`Private`x, #]]& , 
            AtomicDensityMatrix`LevelDiagram`Private`shiftArrows]; 
         AtomicDensityMatrix`LevelDiagram`Private`shiftArrows = 
          MapThread[AtomicDensityMatrix`LevelDiagram`Private`setFunc, {
             Flatten[AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, 1], 
             Flatten[AtomicDensityMatrix`LevelDiagram`Private`xpos]}]; 
         AtomicDensityMatrix`LevelDiagram`Private`DivideList[
          AtomicDensityMatrix`LevelDiagram`Private`shiftArrows, And[
           AtomicDensityMatrix`LevelDiagram`Private`ar[#] == 0, 
            AtomicDensityMatrix`LevelDiagram`Private`slope[#] != 0]& ]], 
       AtomicDensityMatrix`LevelDiagram`Private`ly[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         AtomicDensityMatrix`LevelDiagram`Private`lpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`ry[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`arr, 
          Blank[]]] := Last[
         AtomicDensityMatrix`LevelDiagram`Private`rpts[
         AtomicDensityMatrix`LevelDiagram`Private`arr]], 
       AtomicDensityMatrix`LevelDiagram`Private`makePopulations[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`rho, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[
         AtomicDensityMatrix`LevelDiagram`Private`populationFunction, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`populationStyle, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`levelLength, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`LevelDiagram`Private`popsty, 
          AtomicDensityMatrix`LevelDiagram`Private`popfunc, 
          AtomicDensityMatrix`LevelDiagram`Private`pops}, If[
           MatchQ[AtomicDensityMatrix`LevelDiagram`Private`rho, {
             Repeated[{
               Repeated[0]}]}], 
           Return[{}]]; 
         AtomicDensityMatrix`LevelDiagram`Private`popsty = 
          Replace[AtomicDensityMatrix`LevelDiagram`Private`populationStyle, 
            List -> Sequence, {1}, Heads -> True]; 
         AtomicDensityMatrix`LevelDiagram`Private`popfunc = 
          ReplaceAll[
           AtomicDensityMatrix`LevelDiagram`Private`populationFunction, {
            Alternatives[Automatic, "DiskTriangle"] -> 
             AtomicDensityMatrix`LevelDiagram`Private`diskTrianglePopFunc, 
             "Bar" -> AtomicDensityMatrix`LevelDiagram`Private`barPopFunc}]; 
         AtomicDensityMatrix`LevelDiagram`Private`pops = 
          MapThread[
           AtomicDensityMatrix`LevelDiagram`Private`popfunc[#, #2, 
             AtomicDensityMatrix`LevelDiagram`Private`levelLength]& , {
            AtomicDensityMatrix`LevelDiagram`Private`pos, 
             Diagonal[AtomicDensityMatrix`LevelDiagram`Private`rho]}]; {
          AtomicDensityMatrix`LevelDiagram`Private`popsty, 
           AtomicDensityMatrix`LevelDiagram`Private`pops}], 
       AtomicDensityMatrix`LevelDiagram`Private`diskTrianglePopFunc[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pop, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]]] := AtomicDensityMatrix`TakeFraction[
         AtomicDensityMatrix`DiskTriangle[
         AtomicDensityMatrix`LevelDiagram`Private`pos + {
           0, 0.075 AtomicDensityMatrix`LevelDiagram`Private`length}, 6, 0.15 
          AtomicDensityMatrix`LevelDiagram`Private`length, 0.07 
          AtomicDensityMatrix`LevelDiagram`Private`length], 
         AtomicDensityMatrix`LevelDiagram`Private`pop], 
       AtomicDensityMatrix`TakeFraction[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`expr, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`x, 
          Blank[]]] := Take[AtomicDensityMatrix`LevelDiagram`Private`expr, 
         Round[
         AtomicDensityMatrix`LevelDiagram`Private`x 
          Length[AtomicDensityMatrix`LevelDiagram`Private`expr]]], 
       TagSet[AtomicDensityMatrix`TakeFraction, 
        MessageName[AtomicDensityMatrix`TakeFraction, "usage"], 
        "TakeFraction[\!\(\*\nStyleBox[\"list\", \"TI\"]\),\!\(\*\n\
StyleBox[\"f\", \"TI\"]\)] takes a fraction \!\(\*\nStyleBox[\"f\", \"TI\"]\) \
of the elements of \!\(\*\nStyleBox[\"list\", \"TI\"]\), rounded to the \
nearest element."], AtomicDensityMatrix`DiskTriangle[{
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`x0, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`LevelDiagram`Private`y0, 
           Blank[]]}, 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`n, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`s, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`r, 
          Blank[]]] := Flatten[
         Table[
          Disk[
          AtomicDensityMatrix`LevelDiagram`Private`s {
             AtomicDensityMatrix`LevelDiagram`Private`x, (Sqrt[3] 
               AtomicDensityMatrix`LevelDiagram`Private`y)/2.} + {
            AtomicDensityMatrix`LevelDiagram`Private`x0, 
             AtomicDensityMatrix`LevelDiagram`Private`y0}, 
           AtomicDensityMatrix`LevelDiagram`Private`r], {
          AtomicDensityMatrix`LevelDiagram`Private`y, 0, 
           AtomicDensityMatrix`LevelDiagram`Private`n - 1}, {
          AtomicDensityMatrix`LevelDiagram`Private`x, -((
             AtomicDensityMatrix`LevelDiagram`Private`n - 
             AtomicDensityMatrix`LevelDiagram`Private`y - 1)/2), (
            AtomicDensityMatrix`LevelDiagram`Private`n - 
            AtomicDensityMatrix`LevelDiagram`Private`y - 1)/2}]], 
       TagSet[AtomicDensityMatrix`DiskTriangle, 
        MessageName[AtomicDensityMatrix`DiskTriangle, "usage"], 
        "Draws a filled triangle made up of individual disks."], 
       AtomicDensityMatrix`LevelDiagram`Private`barPopFunc[
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pos, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`pop, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`LevelDiagram`Private`length, 
          Blank[]]] := 
       Rectangle[
        AtomicDensityMatrix`LevelDiagram`Private`pos + {(-0.2) 
           AtomicDensityMatrix`LevelDiagram`Private`length, 0}, 
         AtomicDensityMatrix`LevelDiagram`Private`pos + {
          0.2 AtomicDensityMatrix`LevelDiagram`Private`length, 
           AtomicDensityMatrix`LevelDiagram`Private`pop}], $DisplayFunction = 
       Identity}; Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellLabel->"Out[13]=",
 CellID->1192538831,ExpressionUUID->"1fd4e089-46c1-46e0-8f4f-349dfb75e816"]
}, Open  ]],

Cell[TextData[{
 "For a small field, the states are best described in the coupled basis ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"|", 
     RowBox[{"J", " ", "I", " ", "F", " ", 
      SubscriptBox["M", "F"]}]}], "\[RightAngleBracket]"}], TraditionalForm]],
   "InlineMath",ExpressionUUID->"63c4a23f-ca31-478d-bb4a-90774db9ef87"],
 ", with three ",
 Cell[BoxData[
  FormBox[
   RowBox[{"F", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "03785c78-b19f-48bd-8d78-1669ff762c26"],
 " ",
 StyleBox["sublevels (with ",
  Deletable->True],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["M", "F"], "=", 
     RowBox[{"-", "1"}]}], ",", "0", ",", "1"}], TraditionalForm]], 
  "InlineMath",ExpressionUUID->"b5780592-3aaa-43bc-b2d0-8e7845bf1b93"],
 StyleBox["), and five ",
  Deletable->True],
 Cell[BoxData[
  FormBox[
   RowBox[{"F", "=", "2"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "aad87861-31ec-4333-8467-a87526e771fe"],
 " sublevels (with ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["M", "F"], "=", 
     RowBox[{"-", "2"}]}], ",", "...", ",", "2"}], TraditionalForm]], 
  "InlineMath",ExpressionUUID->"0166d114-dc66-414b-b183-1d44b9ce6579"],
 "). For a large field, the states are best described in the uncoupled basis ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     RowBox[{"J", " ", 
      SubscriptBox["M", "J"], "I", " ", 
      SubscriptBox["M", "I"]}]}], "\[RightAngleBracket]"}], "InlineMath"]], 
  "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "7c638ab6-e7ad-4ec1-a157-51b2f0fbaeb7"],
 ", with four ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    SubscriptBox["M", "J"], "=", 
    RowBox[{"1", "/", "2"}]}], "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "e158487e-0d49-4f68-8cbd-81f154574326"],
 " states (with ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["M", "I"], "=", 
     RowBox[{
      RowBox[{"-", "3"}], "/", "2"}]}], ",", "...", ",", 
    RowBox[{"3", "/", "2"}]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "653ecca5-b02e-4c46-aa2a-b108a1af479b"],
 "), and four ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    SubscriptBox["M", "J"], "=", 
    RowBox[{
     RowBox[{"-", "1"}], "/", "2"}]}], "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "e85d1c5f-b861-45c2-805e-f26636de68b4"],
 " states."
}], "Text",
 CellID->202409836,ExpressionUUID->"15874b0b-165b-4620-ae3f-396a1f1d6fde"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "TutorialMoreAboutSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "AtomicDensityMatrix Package",
         BaseStyle->"Link",
         ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]],
          "TutorialMoreAbout",ExpressionUUID->
         "3eedbfa3-138c-4caf-85fd-7b2ddc9b3e08"]}]}
     }]}
  }]], "TutorialMoreAboutSection",ExpressionUUID->"37ed8042-6b3b-4a18-b6d1-\
23c5d4e651b4"],

Cell[BoxData[""], "Input",ExpressionUUID->"042f3874-4978-49a4-b0b1-9794e7866c60"],

Cell[BoxData[""], "Input",ExpressionUUID->"f5e79643-475e-41ba-adef-27557c7f69d5"]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"dccd5ab0-6797-4cc2-a29d-1bfe526bdb52"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Hyperfine Structure: Breit-Rabi Diagram",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}}, 
  "NewStyles" -> True, "CitationPopupData" -> {$Failed, ""}, "ShowCitation" -> 
  False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 18, 0, 20.096577}", 
    "history" -> {"10.07", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Tutorial", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "The energy-level shifts of a system with hyperfine structure in response \
to a magnetic field have a different character depending on whether the \
shifts are smaller or larger than the hyperfine splitting. When the Larmor \
frequency is much smaller than the hyperfine splitting, the hyperfine \
sublevels behave as if they were isolated, and the shift of each Zeeman \
sublevel is proportional to M_F. For large magnetic fields, for which the \
Larmor frequency is larger than the hyperfine splitting, the hyperfine \
sublevels are strongly mixed with each other, and the system is best \
represented by the uncoupled |J M_JI M_I\\[RightAngleBracket] basis. The \
energy spectrum then consists of manifolds of levels with the same M_J and \
Zeeman shift proportional to M_I. Here we analyze this situation for the \
ground state of ^87Rb. This loads the package. Here is the label for the \
ground state of^87Rb in the format used by the AtomicData database.", 
    "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$71808, "title" -> 
    "Hyperfine Structure: Breit-Rabi Diagram", "titlemodifier" -> "", 
    "metadescription" -> "", "windowtitle" -> 
    "Hyperfine Structure: Breit-Rabi Diagram", "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/HyperfineStructureBreitRabiDiagram"}},
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> Notebook], 
   Cell[
    StyleData["Output"], CellContext -> Notebook], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"e2767012-6057-4e58-8d17-4d85737f8297"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[611, 21, 4634, 110, 57, "AnchorBarGrid",ExpressionUUID->"09552178-a724-462a-b991-7cc2b523c867",
 CellID->1],
Cell[CellGroupData[{
Cell[5270, 135, 131, 1, 63, "Title",ExpressionUUID->"cb559af1-b581-4372-a62a-6dec9740b2e8",
 CellID->201230558],
Cell[5404, 138, 1922, 45, 180, "Text",ExpressionUUID->"57723399-949c-4306-a6e0-2211b1026a2b",
 CellID->159395344],
Cell[7329, 185, 121, 1, 36, "MathCaption",ExpressionUUID->"1a2a4611-0bf8-4014-a463-75250d165a4e",
 CellID->256544093],
Cell[7453, 188, 162, 3, 29, "Input",ExpressionUUID->"d01a1d59-4f50-4974-9f9e-a61145d38389",
 CellID->233299521],
Cell[7618, 193, 676, 18, 38, "MathCaption",ExpressionUUID->"9aa8d446-6d22-4771-b9c6-aff4149e8c56",
 CellID->106106240],
Cell[8297, 213, 471, 13, 46, "Input",ExpressionUUID->"b5c4587c-0c06-4b9b-a32d-608e117e7ce0",
 CellID->69768344],
Cell[8771, 228, 495, 13, 38, "MathCaption",ExpressionUUID->"65ba2921-8404-41bc-862e-94773e280bb7",
 CellID->104575475],
Cell[CellGroupData[{
Cell[9291, 245, 433, 11, 29, "Input",ExpressionUUID->"3d1f2efa-2282-49c0-9d38-ed5800dc03db",
 CellID->51306952],
Cell[9727, 258, 3802, 103, 276, "Output",ExpressionUUID->"22022fcf-1c98-4f16-a91a-52da3daf62d1",
 CellID->1992226058]
}, Open  ]],
Cell[13544, 364, 243, 4, 36, "MathCaption",ExpressionUUID->"9186fa08-ef8a-4d42-89d0-c0659856b190",
 CellID->18473580],
Cell[CellGroupData[{
Cell[13812, 372, 336, 9, 29, "Input",ExpressionUUID->"e6967005-9784-47bf-8644-06494142f757",
 CellID->410187099],
Cell[14151, 383, 1009, 19, 105, "Output",ExpressionUUID->"f33b94af-5aca-44a9-ba15-0261c7a93824",
 CellID->976674248]
}, Open  ]],
Cell[15175, 405, 890, 23, 70, "MathCaption",ExpressionUUID->"5381a401-4bfb-4150-b43c-8e5a46c6e044",
 CellID->27647117],
Cell[CellGroupData[{
Cell[16090, 432, 528, 15, 70, "Input",ExpressionUUID->"2a32a5f9-3134-4718-8249-e22d65014371",
 CellID->332231951],
Cell[16621, 449, 2296, 68, 244, "Output",ExpressionUUID->"8a8170f5-5754-47b6-aa08-0993e45dcafa",
 CellID->2124513703]
}, Open  ]],
Cell[18932, 520, 203, 4, 70, "MathCaption",ExpressionUUID->"4aaf3af8-9c13-49a4-ac12-e613ce3fd864",
 CellID->59759439],
Cell[CellGroupData[{
Cell[19160, 528, 351, 10, 70, "Input",ExpressionUUID->"3b12ff33-89d8-4ce0-a8b9-bae7cedc015e",
 CellID->848123],
Cell[19514, 540, 1400, 26, 116, "Output",ExpressionUUID->"5c9e6bf0-21ef-4a32-9556-f599bb230e6c",
 CellID->1623871874]
}, Open  ]],
Cell[20929, 569, 173, 2, 70, "MathCaption",ExpressionUUID->"2a4fb097-04b2-4e5f-8d83-0817faad124f",
 CellID->125276603],
Cell[CellGroupData[{
Cell[21127, 575, 307, 8, 70, "Input",ExpressionUUID->"9ee1eb1f-5d77-4a8d-9b5e-42142336041b",
 CellID->177189690],
Cell[21437, 585, 7346, 212, 451, "Output",ExpressionUUID->"763295ec-ea57-4fce-854b-beab69d4048b",
 CellID->1066618773]
}, Open  ]],
Cell[28798, 800, 361, 8, 70, "MathCaption",ExpressionUUID->"d8c364c8-4388-4fa1-9794-b42a96dcaaaf",
 CellID->499179070],
Cell[CellGroupData[{
Cell[29184, 812, 1057, 28, 70, "Input",ExpressionUUID->"9a2b7920-785d-4798-87e4-f5104c97cf27",
 CellID->688429193],
Cell[30244, 842, 2741, 83, 229, "Output",ExpressionUUID->"ba1874b1-4f1a-4969-a12e-ea23dc6703b7",
 CellID->1880962977]
}, Open  ]],
Cell[33000, 928, 186, 4, 70, "MathCaption",ExpressionUUID->"e892a43d-c8d1-4470-8c6e-f9cc7a90f0aa",
 CellID->47800932],
Cell[CellGroupData[{
Cell[33211, 936, 467, 13, 70, "Input",ExpressionUUID->"d92724b9-e9f1-4bc5-9c6a-088e766946d8",
 CellID->308923140],
Cell[33681, 951, 2289, 57, 155, "Output",ExpressionUUID->"eaa7bae7-a68e-4c1a-89eb-c68ba389146d",
 CellID->1691861088]
}, Open  ]],
Cell[35985, 1011, 168, 3, 70, "MathCaption",ExpressionUUID->"5b5c46e5-0e9d-46ec-ac9a-0a72159034ae",
 CellID->815973947],
Cell[CellGroupData[{
Cell[36178, 1018, 495, 12, 70, "Input",ExpressionUUID->"ad960dd6-e07c-48de-9211-e43f6831af31",
 CellID->734598839],
Cell[36676, 1032, 25785, 444, 183, "Output",ExpressionUUID->"1764100d-ead9-431a-891c-ee5fc9963a78",
 CellID->91062980]
}, Open  ]],
Cell[62476, 1479, 460, 7, 70, "Text",ExpressionUUID->"1e40c2d2-c0cb-4d8d-a9e5-93fd911a42dd",
 CellID->271683158],
Cell[62939, 1488, 188, 4, 70, "MathCaption",ExpressionUUID->"1612c9a9-a35b-490c-81fa-da5ba25f436c",
 CellID->42403709],
Cell[CellGroupData[{
Cell[63152, 1496, 443, 11, 70, "Input",ExpressionUUID->"8907592f-a866-42c9-891e-6bde3a93a25f",
 CellID->322673577],
Cell[63598, 1509, 1193, 36, 55, "Output",ExpressionUUID->"5d3602ed-296d-4fc5-82b6-eac26ba6f26d",
 CellID->1489759700]
}, Open  ]],
Cell[64806, 1548, 203, 4, 70, "MathCaption",ExpressionUUID->"b9427fde-4c87-4475-8ea7-4e260e5b8515",
 CellID->589835931],
Cell[CellGroupData[{
Cell[65034, 1556, 653, 19, 70, "Input",ExpressionUUID->"8fd0889c-e51b-4411-8cd7-19653a00ea60",
 CellID->429623164],
Cell[65690, 1577, 7347, 212, 451, "Output",ExpressionUUID->"43d61d22-2000-4b39-8b3c-f2d3d3f4bf22",
 CellID->1955648467]
}, Open  ]],
Cell[73052, 1792, 243, 4, 70, "Text",ExpressionUUID->"c15ca15c-3ee7-46a1-b526-7acf99de2081",
 CellID->50099780],
Cell[73298, 1798, 159, 2, 70, "MathCaption",ExpressionUUID->"712b2708-01d3-404a-a7d3-8d67f5ae93cf",
 CellID->88210042],
Cell[CellGroupData[{
Cell[73482, 1804, 988, 27, 70, "Input",ExpressionUUID->"a2d1664f-42fe-4c18-b207-7efae4ca6187",
 CellID->271690114],
Cell[74473, 1833, 672876, 12540, 70, "Output",ExpressionUUID->"1fd4e089-46c1-46e0-8f4f-349dfb75e816",
 CellID->1192538831]
}, Open  ]],
Cell[747364, 14376, 2534, 78, 70, "Text",ExpressionUUID->"15874b0b-165b-4620-ae3f-396a1f1d6fde",
 CellID->202409836],
Cell[CellGroupData[{
Cell[749923, 14458, 725, 18, 70, "TutorialMoreAboutSection",ExpressionUUID->"37ed8042-6b3b-4a18-b6d1-23c5d4e651b4"],
Cell[750651, 14478, 81, 0, 70, "Input",ExpressionUUID->"042f3874-4978-49a4-b0b1-9794e7866c60"],
Cell[750735, 14480, 81, 0, 70, "Input",ExpressionUUID->"f5e79643-475e-41ba-adef-27557c7f69d5"]
}, Open  ]]
}, Open  ]],
Cell[750843, 14484, 78, 0, 70, "FooterCell",ExpressionUUID->"dccd5ab0-6797-4cc2-a29d-1bfe526bdb52"]
}
]
*)

(* End of internal cache information *)

