(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    132472,       3114]
NotebookOptionsPosition[    125981,       2979]
NotebookOutlinePosition[    128526,       3040]
CellTagsIndexPosition[    128483,       3037]
WindowTitle->Light Polarization Demonstration
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell[
          "ATOMIC DENSITY MATRIX PACKAGE TUTORIAL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "6c136db3-12fa-42c8-8edb-0f5c4d4e5aec"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "dbdaa00c-4446-477e-9ff5-7236d32d6ed1"],
        Background->RGBColor[
         0.7450980392156863, 0.3254901960784314, 0.1411764705882353],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "ce2f7646-d098-4b7f-bfef-0aa9c24d3f2f"]
         }],ExpressionUUID->"5519cc52-b1c3-4282-b308-5685c4ead49b"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"TutorialMoreAboutSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "b07c432c-c331-451f-8693-8ba028ac5c88"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "1f53c69a-3ae0-4bfa-9b01-4c88612b76fb"]
         }],ExpressionUUID->"9ab7e95a-e122-4896-a345-3cb426bf8e50"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/tutorial/\
LightPolarizationDemonstration1\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
              "AtomicDensityMatrix/tutorial/LightPolarizationDemonstration1"]}\
, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
tutorial/LightPolarizationDemonstration1.html"], StandardForm]], "Input", 
               TextClipboardType -> "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$72917], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/tutorial/LightPolarizationDemonstration1" <> 
             ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "ae73e2a2-d922-4bf7-9404-0ccc4556c9c0"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "b99a2d73-10a9-487e-aa25-97093ddf9aac"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1,ExpressionUUID->"2783cfe6-61a4-4a65-bd1b-389e079dd373"],

Cell[CellGroupData[{

Cell["Light Polarization Demonstration", "Title",
 CellID->509267359,ExpressionUUID->"3a9edbd3-e383-4a2b-a3d2-bd0c59d9752f"],

Cell[BoxData[GridBox[{
   {
    TemplateBox[{
      Cell["Demonstration code"], 
      "paclet:AtomicDensityMatrix/tutorial/LightPolarizationDemonstration1#\
869375336", 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.3843137254901961, 0.4627450980392157, 0.7019607843137254], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False], 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.9686274509803922, 0.4666666666666667, 0.], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False]},
     "GrayLinkWithIcon",
     BaseStyle->{"TutorialJumpBoxLink"}], 
    TemplateBox[{
      Cell["Demonstration"], 
      "paclet:AtomicDensityMatrix/tutorial/LightPolarizationDemonstration1#\
1148058029", 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.3843137254901961, 0.4627450980392157, 0.7019607843137254], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False], 
      StyleBox[
       GraphicsBox[{
         Thickness[0.18], 
         RGBColor[0.9686274509803922, 0.4666666666666667, 0.], 
         LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]}, AspectRatio -> 1, 
        PlotRange -> {{-3, 4}, {-1, 1}}, ImageSize -> 20], Magnification -> 
       0.68 Inherited, StripOnInput -> False]},
     "GrayLinkWithIcon",
     BaseStyle->{"TutorialJumpBoxLink"}]}
  }]], "TutorialJumpBox",ExpressionUUID->"f0462ec2-1220-4c8c-a953-\
441c7c6fff57"],

Cell["\<\
An interactive demonstration illustrating parametrizations for light \
polarization. Light polarization can be selected using the \
\[Alpha]-\[Epsilon], x-\[Phi], and Stokes parametrizations. The polarization \
ellipse and Poincar\[EAcute] sphere are plotted.\
\>", "Text",
 CellID->1534169418,ExpressionUUID->"ed67dd32-7e29-4444-8244-9749cece286f"],

Cell[CellGroupData[{

Cell["Demonstration code", "Section",
 CellID->869375336,ExpressionUUID->"e8d8a06e-3861-448c-847d-a5afe3e1096b"],

Cell[CellGroupData[{

Cell["Graphics setup", "Subsection",
 CellID->686213985,ExpressionUUID->"e3abb13a-5498-42e5-bc73-e0c02da43a6b"],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[29]:=",
 CellID->171085568,ExpressionUUID->"17063df7-5ed7-44fb-8d1f-bfeb76620a1b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MyNumberForm", "[", "x_", "]"}], ":=", 
   RowBox[{"NumberForm", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"x", ",", "2"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}], ",", 
     RowBox[{"NumberSigns", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<-\>\"", ",", "\"\<   \>\""}], "}"}]}], ",", 
     RowBox[{"ExponentFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"Null", "&"}], ")"}]}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[30]:=",
 CellID->109334777,ExpressionUUID->"784d4e45-12c2-42be-b376-a9c5b586b460"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"PaddedInputField", ",", "HoldAll"}], "]"}], ";"}]], "Input",
 CellLabel->"In[31]:=",
 CellID->343416248,ExpressionUUID->"7268d3a5-5f87-4be6-ab77-a5a602db03f7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PaddedInputField", "[", 
    RowBox[{"x_", ",", "func_"}], "]"}], ":=", 
   RowBox[{"InputField", "[", 
    RowBox[{
     RowBox[{"Dynamic", "[", 
      RowBox[{
       RowBox[{"DisplayForm", "@", 
        RowBox[{"StyleBox", "[", 
         RowBox[{"ToString", "@", 
          RowBox[{"MyNumberForm", "[", "x", "]"}]}], "]"}]}], ",", "func"}], 
      "]"}], ",", 
     RowBox[{"FieldSize", "\[Rule]", "5"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[32]:=",
 CellID->56403217,ExpressionUUID->"21d11d47-2c45-4151-9622-4b0d2c1d3ab6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PaddedInputField", "[", 
    RowBox[{"x_", ",", "func_", ",", "p_"}], "]"}], ":=", 
   RowBox[{"InputField", "[", 
    RowBox[{
     RowBox[{"Dynamic", "[", 
      RowBox[{
       RowBox[{"DisplayForm", "@", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ToString", "@", 
            RowBox[{"MyNumberForm", "[", 
             RowBox[{"x", "/", "p"}], "]"}]}], ",", 
           RowBox[{"TraditionalForm", "@", "p"}]}], "}"}], "]"}]}], ",", 
       "func"}], "]"}], ",", 
     RowBox[{"FieldSize", "\[Rule]", "5"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[33]:=",
 CellID->11061968,ExpressionUUID->"aefa15e2-662f-482b-aa5c-e7d1878a838c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Circle3D", ",", 
    RowBox[{"LabelPosition", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1.2", ",", "0"}], "}"}]}]}], "]"}], ";"}]], "Input",
 CellLabel->"In[34]:=",
 CellID->177524866,ExpressionUUID->"16dcb780-6a4d-4aa4-a673-3567eff6c990"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Arc", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Label", "\[Rule]", "None"}], ",", 
     RowBox[{"LabelPosition", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1.1"}], "}"}]}], ",", 
     RowBox[{"LabelStyle", "\[Rule]", 
      RowBox[{"{", "}"}]}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[35]:=",
 CellID->228198244,ExpressionUUID->"be2b0669-8a57-4c28-9d78-0cc9fd8c3ba1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Arc", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x_", ",", "y_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r1_", ",", "r2_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]1_", ",", "\[Theta]2_"}], "}"}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pos", "=", 
       RowBox[{"OptionValue", "@", "LabelPosition"}]}], "}"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"\[Theta]1", "==", "\[Theta]2"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Arrow", "@@", 
          RowBox[{
           RowBox[{"GetLines", "[", 
            RowBox[{"ParametricPlot", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"x", "+", 
                 RowBox[{"r1", " ", 
                  RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ",", 
                RowBox[{"y", "+", 
                 RowBox[{"r2", " ", 
                  RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"\[Theta]", ",", "\[Theta]1", ",", "\[Theta]2"}], 
               "}"}]}], "]"}], "]"}], "\[LeftDoubleBracket]", "1", 
           "\[RightDoubleBracket]"}]}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"OptionValue", "[", "Label", "]"}], "=!=", "None"}], ",", 
           
           RowBox[{"Rotate", "[", 
            RowBox[{
             RowBox[{"Text", "[", 
              RowBox[{
               RowBox[{"OptionValue", "[", "Label", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Mean", "[", 
                   RowBox[{"{", 
                    RowBox[{"r1", ",", "r2"}], "}"}], "]"}], 
                  RowBox[{
                  "pos", "\[LeftDoubleBracket]", "2", 
                   "\[RightDoubleBracket]"}]}], ",", "0"}], "}"}]}], "]"}], 
             ",", 
             RowBox[{
              RowBox[{
               RowBox[{
               "pos", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
               
               RowBox[{"(", 
                RowBox[{"\[Theta]2", "-", "\[Theta]1"}], ")"}]}], "+", 
              RowBox[{"Mean", "[", 
               RowBox[{"{", 
                RowBox[{"\[Theta]1", ",", "\[Theta]2"}], "}"}], "]"}]}], ",", 
             
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}]}], "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[36]:=",
 CellID->338406235,ExpressionUUID->"8237ca62-a26c-4401-8a30-68b7bdcaea8c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ColorAll", "[", "col_", "]"}], ":=", 
   RowBox[{"Sequence", "[", 
    RowBox[{"col", ",", 
     RowBox[{"Specularity", "[", "0", "]"}], ",", 
     RowBox[{"EdgeForm", "[", "col", "]"}], ",", 
     RowBox[{"FaceForm", "[", "Black", "]"}], ",", 
     RowBox[{"Glow", "[", "col", "]"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[37]:=",
 CellID->2931987,ExpressionUUID->"c0530541-359b-4691-80a1-d3ca1a40d524"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"MyManipulator", ",", "HoldAll"}], "]"}], ";"}]], "Input",
 CellLabel->"In[38]:=",
 CellID->282891712,ExpressionUUID->"d73e78d9-b8b5-4575-9c66-e17e03bb0d55"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MyManipulator", "[", 
    RowBox[{"var_", ",", "range_", ",", "func_", ",", 
     RowBox[{"Scale", "\[Rule]", "scale_"}]}], "]"}], ":=", 
   RowBox[{"Row", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Manipulator", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"var", ",", "func"}], "]"}], ",", "range"}], "]"}], ",", 
       RowBox[{"PaddedInputField", "[", 
        RowBox[{"var", ",", "func", ",", "scale"}], "]"}]}], "}"}], ",", 
     RowBox[{"Spacer", "[", "5", "]"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[39]:=",
 CellID->218396106,ExpressionUUID->"108441c9-4ac7-4d6f-8952-05a68c142f04"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MyManipulator", "[", 
    RowBox[{"var_", ",", "range_", ",", "func_"}], "]"}], ":=", 
   RowBox[{"Row", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Manipulator", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"var", ",", "func"}], "]"}], ",", "range"}], "]"}], ",", 
       RowBox[{"PaddedInputField", "[", 
        RowBox[{"var", ",", "func"}], "]"}]}], "}"}], ",", 
     RowBox[{"Spacer", "[", "5", "]"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[40]:=",
 CellID->74104170,ExpressionUUID->"5c7127ab-391a-4992-a3ea-22751f948824"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ColoredBar", "[", 
    RowBox[{"names_", ",", "color_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"CheckboxBar", "[", 
     RowBox[{"#", ",", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "\[Rule]", 
          RowBox[{"Style", "[", 
           RowBox[{"#1", ",", "#2"}], "]"}]}], "&"}], ",", 
        RowBox[{"{", 
         RowBox[{"names", ",", 
          RowBox[{"Take", "[", 
           RowBox[{"color", ",", 
            RowBox[{"Length", "[", "names", "]"}]}], "]"}]}], "}"}]}], 
       "]"}]}], "]"}], "&"}]}], ";"}]], "Input",
 CellLabel->"In[41]:=",
 CellID->17081472,ExpressionUUID->"2bcd1de3-7d03-4921-bd20-5db71da43c6e"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generate demonstration", "Subsection",
 CellID->1186851093,ExpressionUUID->"da29ca8e-d0f6-4f22-ac18-8e1507f470b9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NormalizeStokes", "[", 
    RowBox[{"{", 
     RowBox[{"s1_", ",", "s2_", ",", "s3_"}], "}"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "a", "}"}], ",", 
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Abs", "[", "s2", "]"}], "<", ".01"}], "&&", 
        RowBox[{
         RowBox[{"Abs", "[", "s3", "]"}], "<", ".01"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["s1", "2"]}]], 
          SqrtBox["2"]], ",", 
         FractionBox[
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["s1", "2"]}]], 
          SqrtBox["2"]]}], "}"}], ",", 
       RowBox[{
        RowBox[{"Abs", "[", "s1", "]"}], "\[Equal]", "1."}], ",", 
       RowBox[{"{", 
        RowBox[{"0.", ",", "0."}], "}"}], ",", "True", ",", 
       RowBox[{
        RowBox[{"a", "=", 
         SqrtBox[
          FractionBox[
           RowBox[{"1", "-", 
            SuperscriptBox["s1", "2"]}], 
           RowBox[{
            SuperscriptBox["s2", "2"], "+", 
            SuperscriptBox["s3", "2"]}]]]}], ";", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"s2", " ", "a"}], ",", 
          RowBox[{"s3", " ", "a"}]}], "}"}]}]}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[42]:=",
 CellID->3740002,ExpressionUUID->"12f2a92f-a13a-4a83-8a94-efefc056f744"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SToAE", "[", "st_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"S1", "\[Equal]", "S2", "\[Equal]", "0."}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{
        FractionBox["1", "4"], " ", "\[Pi]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"KroneckerDelta", "[", "S3", "]"}], "+", 
          RowBox[{"Sign", "[", "S3", "]"}]}], ")"}]}]}], "}"}], ",", 
     RowBox[{"ReparameterizeField", "[", 
      RowBox[{"st", ",", 
       RowBox[{"\"\<Stokes\>\"", "\[Rule]", "\"\<AngleEllipticity\>\""}]}], 
      "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SToRP", "[", "st_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"S2", "\[Equal]", "S3", "\[Equal]", "0."}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ArcCos", "[", 
        FractionBox[
         SqrtBox[
          RowBox[{"1", "+", "S1"}]], 
         SqrtBox["2"]], "]"}], ",", 
       FractionBox["\[Pi]", "4"]}], "}"}], ",", 
     RowBox[{"ReparameterizeField", "[", 
      RowBox[{"st", ",", 
       RowBox[{"\"\<Stokes\>\"", "\[Rule]", "\"\<RatioPhase\>\""}]}], "]"}]}],
     "]"}]}], ";"}]}], "Input",
 CellLabel->"In[43]:=",
 CellID->13348457,ExpressionUUID->"e8b8032b-f00f-434e-8b2e-3fda6122dd6c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RPToS", "[", "st_", "]"}], ":=", 
   RowBox[{"ReparameterizeField", "[", 
    RowBox[{"st", ",", 
     RowBox[{"\"\<RatioPhase\>\"", "\[Rule]", "\"\<Stokes\>\""}]}], "]"}]}], 
  ";", 
  RowBox[{
   RowBox[{"RPToAE", "[", "st_", "]"}], ":=", 
   RowBox[{"ReparameterizeField", "[", 
    RowBox[{"st", ",", 
     RowBox[{"\"\<RatioPhase\>\"", "\[Rule]", "\"\<AngleEllipticity\>\""}]}], 
    "]"}]}], ";", 
  RowBox[{
   RowBox[{"AEToRP", "[", "st_", "]"}], ":=", 
   RowBox[{"ReparameterizeField", "[", 
    RowBox[{"st", ",", 
     RowBox[{"\"\<AngleEllipticity\>\"", "\[Rule]", "\"\<RatioPhase\>\""}]}], 
    "]"}]}], ";", 
  RowBox[{
   RowBox[{"AEToS", "[", "st_", "]"}], ":=", 
   RowBox[{"ReparameterizeField", "[", 
    RowBox[{"st", ",", 
     RowBox[{"\"\<AngleEllipticity\>\"", "\[Rule]", "\"\<Stokes\>\""}]}], 
    "]"}]}], ";", 
  RowBox[{"NS", "=", "NormalizeStokes"}], ";"}]], "Input",
 CellLabel->"In[45]:=",
 CellID->780677788,ExpressionUUID->"25ea20ae-1a43-48ba-b253-dd29ec477012"],

Cell[BoxData[
 RowBox[{
  RowBox[{"color", "=", 
   RowBox[{"ColorData", "[", 
    RowBox[{"1", ",", "\"\<ColorList\>\""}], "]"}]}], ";", 
  RowBox[{"dash", "=", 
   RowBox[{"Dashing", "[", 
    RowBox[{"{", 
     RowBox[{".02", ",", ".02"}], "}"}], "]"}]}], ";", 
  RowBox[{"ax", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ColorAll", "@", "Black"}], ",", 
     RowBox[{"Axes3D", "[", 
      RowBox[{"1.3", ",", 
       RowBox[{"Label", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<\!\(\*SubscriptBox[StyleBox[\"S\",FontSlant->\"Italic\"], \
\"1\"]\)\>\"", ",", 
          "\"\<\!\(\*SubscriptBox[StyleBox[\"S\",FontSlant->\"Italic\"], \
\"2\"]\)\>\"", ",", 
          "\"\<\!\(\*SubscriptBox[StyleBox[\"S\",FontSlant->\"Italic\"], \
\"3\"]\)\>\""}], "}"}]}], ",", 
       RowBox[{"LabelStyle", "\[Rule]", 
        RowBox[{"{", "12", "}"}]}], ",", 
       RowBox[{"RenderStyle", "\[Rule]", "Flat"}], ",", 
       RowBox[{"Scale", "\[Rule]", "1"}], ",", 
       RowBox[{"LabelPosition", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{".9", ",", "13", ",", 
            FractionBox["\[Pi]", "4"]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{".9", ",", "10", ",", 
            FractionBox["\[Pi]", "4"]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{".9", ",", "13", ",", 
            FractionBox[
             RowBox[{"3", " ", "\[Pi]"}], "4"]}], "}"}]}], "}"}]}]}], "]"}]}],
     "}"}]}], ";", 
  RowBox[{"arr3d", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ColorAll", "@", 
      RowBox[{"color", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ",", 
     RowBox[{"Thickness", "[", ".007", "]"}], ",", 
     RowBox[{
      RowBox[{"RotateY", "[", 
       RowBox[{"\[Pi]", "/", "2"}], "]"}], "@", 
      RowBox[{"Arrow3D", "[", 
       RowBox[{"1", ",", 
        RowBox[{"RenderStyle", "\[Rule]", "Flat"}], ",", 
        RowBox[{"Scale", "\[Rule]", "1.5"}]}], "]"}]}]}], "}"}]}], ";", 
  RowBox[{"EF", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", "t", "]"}], " ", 
      RowBox[{"Cos", "[", "\[Chi]", "]"}]}], ",", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"t", "-", "\[Phi]"}], "]"}], " ", 
      RowBox[{"Sin", "[", "\[Chi]", "]"}]}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"\[Alpha]\[Epsilon]F", "[", 
    RowBox[{"\[Alpha]_", ",", "\[Epsilon]_", ",", "t_"}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "t", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], "-", 
      RowBox[{
       RowBox[{"Sin", "[", "t", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "t", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "t", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}]}], "}"}]}], ";"}]], "Input",\

 CellLabel->"In[50]:=",
 CellID->415357996,ExpressionUUID->"c63924e0-5537-4b8c-8ee1-6f01a8c68c3a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ellipsePlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"e1_", ",", "e2_", ",", "e3_", ",", "e4_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"co_", ",", "si_"}], "}"}], ",", "labels_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Arrowheads", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", ".035"}], ",", ".035"}], "}"}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"labels", ",", "\"\<\[Alpha]\>\""}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
         "color", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], ",", 
         RowBox[{"Arc", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{".6", ",", ".6"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "\[Alpha]"}], "}"}], ",", 
           RowBox[{"Label", "\[Rule]", "\"\<\[Alpha]\>\""}]}], "]"}]}], "}"}],
        ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"labels", ",", "\"\<\[Epsilon]\>\""}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
         "color", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], ",", 
         RowBox[{"Arc", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{".6", ",", ".6"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"\[Alpha]", ",", 
             RowBox[{"\[Alpha]", "+", "\[Epsilon]"}]}], "}"}], ",", 
           RowBox[{"Label", "\[Rule]", "\"\<\[Epsilon]\>\""}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"e3", "+", "e2"}], ",", "e2"}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
          "\"\<\!\(\*StyleBox[\"a\",FontSlant->\"Italic\"]\)\>\"", ",", 
           RowBox[{
            RowBox[{"e3", "/", "2"}], "+", "e2", "+", 
            RowBox[{".08", 
             RowBox[{"Normalize", "[", "e2", "]"}]}]}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"e3", "+", "e2"}], ",", "e3"}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
          "\"\<\!\(\*StyleBox[\"b\",FontSlant->\"Italic\"]\)\>\"", ",", 
           RowBox[{
            RowBox[{".08", 
             RowBox[{"Normalize", "[", "e3", "]"}]}], "+", "e3", "+", 
            RowBox[{"e2", "/", "2"}]}]}], "]"}], ",", "dash", ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"e1", "+", "e2"}], ",", 
            RowBox[{"e1", "+", "e4"}], ",", 
            RowBox[{"e3", "+", "e4"}], ",", 
            RowBox[{"e3", "+", "e2"}], ",", 
            RowBox[{"e1", "+", "e2"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"e1", "+", "e2"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}]}], "}"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"labels", ",", 
         RowBox[{"\"\<\[Epsilon]\>\"", "|", "\"\<\[Alpha]\>\""}]}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
         "color", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",",
          "dash", ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{"e1", ",", "e3"}], "}"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{"e2", ",", "e4"}], "}"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"labels", ",", "\"\<\[Chi]\>\""}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
         "color", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], ",", 
         RowBox[{"Arc", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{".4", ",", ".4"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "\[Chi]"}], "}"}], ",", 
           RowBox[{"Label", "\[Rule]", "\"\<\[Chi]\>\""}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", 
               RowBox[{"Sin", "[", "\[Chi]", "]"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Cos", "[", "\[Chi]", "]"}], ",", 
              RowBox[{"-", 
               RowBox[{"Sin", "[", "\[Chi]", "]"}]}]}], "}"}]}], "}"}], "]"}],
          ",", 
         RowBox[{"Text", "[", 
          RowBox[{
          "\"\<\!\(\*SubsuperscriptBox[\"\[ScriptCapitalE]\", \
StyleBox[\"x\",FontSlant->\"Italic\"], \"0\"]\)\>\"", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"co", "/", "2"}], ",", 
             RowBox[{
              RowBox[{"-", "si"}], "-", ".1"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Arrow", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"co", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"co", ",", 
              RowBox[{"-", "si"}]}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
          "\"\<\!\(\*SubsuperscriptBox[\(\[ScriptCapitalE]\), \(y\), \(0\)]\)\
\>\"", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"co", "+", ".1"}], ",", 
             RowBox[{
              RowBox[{"-", "si"}], "/", "2"}]}], "}"}]}], "]"}], ",", "dash", 
         ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"co", ",", "si"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "co"}], ",", "si"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "co"}], ",", 
              RowBox[{"-", "si"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"co", ",", 
              RowBox[{"-", "si"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"co", ",", "si"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}]}], "}"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Arrowheads", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{".035", ",", "i"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", ".025", ",", 
            RowBox[{"1", "-", ".025"}], ",", ".05"}], "}"}]}], "]"}], "]"}], 
       ",", 
       RowBox[{
        RowBox[{
         RowBox[{"ParametricPlot", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "t", "]"}], " ", "co"}], ",", 
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"t", "-", "\[Phi]"}], "]"}], "si"}]}], "}"}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", "0", ",", 
             RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "/.", 
        RowBox[{"Line", "\[Rule]", "Arrow"}]}]}], "}"}]}], "}"}]}], 
  ";"}]], "Input",
 CellID->1146864269,ExpressionUUID->"f6eeb60b-6bfe-477f-b4ad-a895e28c3faf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"poincarePlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Alpha]_", ",", "\[Epsilon]_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Chi]_", ",", "\[Phi]_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"S1_", ",", "S2_", ",", "S3_"}], "}"}], ",", "labels_"}], "]"}],
    ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"MemberQ", "[", 
         RowBox[{"labels", ",", "\"\<\[Alpha]\>\""}], "]"}], "&&", 
        RowBox[{"\[Alpha]", "\[Element]", "Reals"}], "&&", 
        RowBox[{"\[Alpha]", "\[NotEqual]", "0"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ColorAll", "@", 
          RowBox[{
          "color", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
         ",", 
         RowBox[{"Circle3D", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", ".5", ",", 
           RowBox[{"{", 
            RowBox[{"0.", ",", 
             RowBox[{"2", "\[Alpha]"}]}], "}"}], ",", 
           RowBox[{"Label", "\[Rule]", "\"\<2\[Alpha]\>\""}], ",", 
           RowBox[{"Arrowheads", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}]}], "}"}], ",", 
       
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"MemberQ", "[", 
         RowBox[{"labels", ",", "\"\<\[Epsilon]\>\""}], "]"}], "&&", 
        RowBox[{"\[Epsilon]", "\[NotEqual]", "0"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ColorAll", "@", 
          RowBox[{
          "color", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}], 
         ",", 
         RowBox[{
          RowBox[{"RotateZ", "[", 
           RowBox[{"2", " ", "\[Alpha]"}], "]"}], "@", 
          RowBox[{
           RowBox[{"RotateX", "[", 
            RowBox[{"\[Pi]", "/", "2"}], "]"}], "@", 
           RowBox[{"Circle3D", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", ".5", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"2", "\[Epsilon]"}]}], "}"}], ",", 
             RowBox[{"Label", "\[Rule]", "\"\<2\[Epsilon]\>\""}], ",", 
             RowBox[{"Arrowheads", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}]}]}]}], "}"}],
        ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"labels", ",", 
         RowBox[{"\"\<\[Epsilon]\>\"", "|", "\"\<\[Alpha]\>\""}]}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
         "color", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"S1", ",", "S2", ",", "0"}], "}"}]}], "}"}], "]"}], ",", 
         
         RowBox[{
          RowBox[{"RotateZ", "[", 
           RowBox[{"2", " ", "\[Alpha]"}], "]"}], "@", 
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "}"}], "]"}]}]}], 
        "}"}], ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"MemberQ", "[", 
         RowBox[{"labels", ",", "\"\<\[Chi]\>\""}], "]"}], "&&", 
        RowBox[{"\[Chi]", "\[NotEqual]", "0"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ColorAll", "@", 
          RowBox[{
          "color", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}]}], 
         ",", 
         RowBox[{
          RowBox[{"RotateX", "[", "\[Phi]", "]"}], "@", 
          RowBox[{"Circle3D", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", ".5", ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"2", "\[Chi]"}]}], "}"}], ",", 
            RowBox[{"Label", "\[Rule]", "\"\<2\[Chi]\>\""}], ",", 
            RowBox[{"Arrowheads", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}]}]}], "}"}], 
       ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"MemberQ", "[", 
         RowBox[{"labels", ",", "\"\<\[Phi]\>\""}], "]"}], "&&", 
        RowBox[{"\[Phi]", "\[NotEqual]", "0"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ColorAll", "@", 
          RowBox[{
          "color", "\[LeftDoubleBracket]", "5", "\[RightDoubleBracket]"}]}], 
         ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"Normalize", "@", 
             RowBox[{"{", 
              RowBox[{"0", ",", "S2", ",", "S3"}], "}"}]}]}], "}"}], "]"}], 
         ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "S2", ",", "S3"}], "}"}]}], "}"}], "]"}], ",", 
         
         RowBox[{
          RowBox[{"RotateZ", "[", 
           RowBox[{"\[Pi]", "/", "2"}], "]"}], "@", 
          RowBox[{
           RowBox[{"RotateX", "[", 
            RowBox[{"\[Pi]", "/", "2"}], "]"}], "@", 
           RowBox[{"Circle3D", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", ".5", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "\[Phi]"}], "}"}], ",", 
             RowBox[{"Label", "\[Rule]", "\"\<\[Phi]\>\""}], ",", 
             RowBox[{"Arrowheads", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}]}]}]}], "}"}],
        ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"loci", ",", "\"\<\[Alpha]\>\""}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
         "color", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], ",", 
         RowBox[{
          RowBox[{"RotateZ", "[", 
           RowBox[{"2", "\[Alpha]"}], "]"}], "@", 
          RowBox[{
           RowBox[{"RotateX", "[", 
            RowBox[{"\[Pi]", "/", "2"}], "]"}], "@", 
           RowBox[{"Circle3D", "[", "1", "]"}]}]}]}], "}"}], ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"loci", ",", "\"\<\[Epsilon]\>\""}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
         "color", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], ",", 
         RowBox[{
          RowBox[{"TranslateZ", "[", 
           RowBox[{"Sin", "[", 
            RowBox[{"2", "\[Epsilon]"}], "]"}], "]"}], "@", 
          RowBox[{"Circle3D", "[", 
           RowBox[{"Cos", "[", 
            RowBox[{"2", "\[Epsilon]"}], "]"}], "]"}]}]}], "}"}], ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"loci", ",", "\"\<\[Chi]\>\""}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
         "color", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], ",", 
         RowBox[{
          RowBox[{"TranslateX", "[", 
           RowBox[{"Cos", "[", 
            RowBox[{"2", "\[Chi]"}], "]"}], "]"}], "@", 
          RowBox[{
           RowBox[{"RotateY", "[", 
            RowBox[{"\[Pi]", "/", "2"}], "]"}], "@", 
           RowBox[{"Circle3D", "[", 
            RowBox[{"Sin", "[", 
             RowBox[{"2", "\[Chi]"}], "]"}], "]"}]}]}]}], "}"}], ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"loci", ",", "\"\<\[Phi]\>\""}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
         "color", "\[LeftDoubleBracket]", "5", "\[RightDoubleBracket]"}], ",", 
         RowBox[{
          RowBox[{"RotateX", "[", "\[Phi]", "]"}], "@", 
          RowBox[{"Circle3D", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "1", ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "\[Pi]"}], "}"}]}], "]"}]}]}], "}"}], ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"RotateZ", "[", 
       RowBox[{"2", " ", "\[Alpha]"}], "]"}], "@", 
      RowBox[{
       RowBox[{"RotateY", "[", 
        RowBox[{
         RowBox[{"-", "2"}], " ", "\[Epsilon]"}], "]"}], "@", "arr3d"}]}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Opacity", "[", ".06", "]"}], ",", 
       RowBox[{"Specularity", "[", 
        RowBox[{"White", ",", "5"}], "]"}], ",", "Blue", ",", 
       RowBox[{"Sphere", "[", "]"}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellID->681870644,ExpressionUUID->"e8fd2647-a0d1-4df7-9d35-9ef3dd1f375e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LightPolDemo", "[", "]"}], ":=", 
   RowBox[{"Manipulate", "[", 
    RowBox[{
     RowBox[{"Row", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"e1", ",", "e2", ",", "e3", ",", "e4"}], "}"}], "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\[Alpha]\[Epsilon]F", "[", 
             RowBox[{"\[Alpha]", ",", "\[Epsilon]", ",", "0"}], "]"}], ",", 
            RowBox[{"\[Alpha]\[Epsilon]F", "[", 
             RowBox[{"\[Alpha]", ",", "\[Epsilon]", ",", 
              RowBox[{"\[Pi]", "/", "2"}]}], "]"}], ",", 
            RowBox[{"\[Alpha]\[Epsilon]F", "[", 
             RowBox[{"\[Alpha]", ",", "\[Epsilon]", ",", "\[Pi]"}], "]"}], 
            ",", 
            RowBox[{"\[Alpha]\[Epsilon]F", "[", 
             RowBox[{"\[Alpha]", ",", "\[Epsilon]", ",", 
              RowBox[{"3", 
               RowBox[{"\[Pi]", "/", "2"}]}]}], "]"}]}], "}"}]}], ";", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"co", ",", "si"}], "}"}], "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Cos", "[", "\[Chi]", "]"}], ",", 
            RowBox[{"Sin", "[", "\[Chi]", "]"}]}], "}"}]}], ";", 
         RowBox[{"Graphics", "[", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{"plotEllipse", ",", 
             RowBox[{"ellipsePlot", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"e1", ",", "e2", ",", "e3", ",", "e4"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"co", ",", "si"}], "}"}], ",", "labels"}], "]"}], ",", 
             RowBox[{"{", "}"}]}], "]"}], ",", 
           RowBox[{"Frame", "\[Rule]", "True"}], ",", 
           RowBox[{"FrameLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
               "\"\<\!\(\*SubscriptBox[\"\[ScriptCapitalE]\", \
StyleBox[\"x\",FontSlant->\"Italic\"]]\)\>\"", ",", "12"}], "]"}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{
               "\"\<\!\(\*SubscriptBox[\(\[ScriptCapitalE]\), \(y\)]\)\>\"", 
                ",", "12"}], "]"}]}], "}"}]}], ",", 
           RowBox[{"PlotRange", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Axes", "\[Rule]", "True"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
            RowBox[{"3.5", " ", "72"}]}]}], "]"}]}], ",", 
        RowBox[{"Graphics3D", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"ax", ",", 
            RowBox[{"If", "[", 
             RowBox[{"plotPoincare", ",", 
              RowBox[{"poincarePlot", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], ",", "labels"}],
                "]"}], ",", 
              RowBox[{"{", "}"}]}], "]"}]}], "}"}], ",", 
          RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
          RowBox[{"ViewPoint", "\[Rule]", 
           RowBox[{"10", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1.2", ",", ".9"}], "}"}]}]}], ",", 
          RowBox[{"ViewVertical", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ",", 
          RowBox[{"PlotRange", "\[Rule]", "1.3"}], ",", 
          RowBox[{"PlotRegion", "\[Rule]", 
           RowBox[{"Crop", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{".21", ",", ".78"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{".25", ",", ".81"}], "}"}]}], "}"}], "]"}]}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"3.5", " ", "72"}]}], ",", 
          RowBox[{"Lighting", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"\"\<Point\>\"", ",", "White", ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2", ",", "5"}], "}"}]}], "}"}], "}"}]}]}], 
         "]"}]}], "}"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Alpha]", ",", "0.", ",", "\"\<\[Alpha]\>\""}], "}"}], ",", 
       
       RowBox[{
        RowBox[{"MyManipulator", "[", 
         RowBox[{"\[Alpha]", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[Pi]"}], "/", "2."}], ",", 
            RowBox[{"\[Pi]", "/", "2."}]}], "}"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"NumericQ", "[", "#", "]"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], "=", 
                RowBox[{"AEToRP", "[", 
                 RowBox[{"{", 
                  RowBox[{"#", ",", "\[Epsilon]"}], "}"}], "]"}]}], ";", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], "=", 
                RowBox[{"AEToS", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\[Alpha]", "=", "#"}], ",", "\[Epsilon]"}], "}"}],
                  "]"}]}]}]}], "]"}], ")"}], "&"}], ",", 
          RowBox[{"Scale", "\[Rule]", "\[Pi]"}]}], "]"}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Epsilon]", ",", "0.", ",", "\"\<\[Epsilon]\>\""}], "}"}], 
       ",", 
       RowBox[{
        RowBox[{"MyManipulator", "[", 
         RowBox[{"\[Epsilon]", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[Pi]"}], "/", "4."}], ",", 
            RowBox[{"\[Pi]", "/", "4."}]}], "}"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"NumericQ", "[", "#", "]"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], "=", 
                RowBox[{"AEToRP", "[", 
                 RowBox[{"{", 
                  RowBox[{"\[Alpha]", ",", "#"}], "}"}], "]"}]}], ";", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], "=", 
                RowBox[{"AEToS", "[", 
                 RowBox[{"{", 
                  RowBox[{"\[Alpha]", ",", 
                   RowBox[{"\[Epsilon]", "=", "#"}]}], "}"}], "]"}]}]}]}], 
             "]"}], ")"}], "&"}], ",", 
          RowBox[{"Scale", "\[Rule]", "\[Pi]"}]}], "]"}], "&"}]}], "}"}], ",",
      "Delimiter", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Chi]", ",", "0."}], "}"}], ",", 
       RowBox[{
        RowBox[{"MyManipulator", "[", 
         RowBox[{"\[Chi]", ",", 
          RowBox[{"{", 
           RowBox[{"0.", ",", 
            RowBox[{"\[Pi]", "/", "2."}]}], "}"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"NumericQ", "[", "#", "]"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], "=", 
                RowBox[{"RPToAE", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\[Chi]", "=", "#"}], ",", "\[Phi]"}], "}"}], 
                 "]"}]}], ";", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], "=", 
                RowBox[{"RPToS", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\[Chi]", "=", "#"}], ",", "\[Phi]"}], "}"}], 
                 "]"}]}]}]}], "]"}], ")"}], "&"}], ",", 
          RowBox[{"Scale", "\[Rule]", "\[Pi]"}]}], "]"}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Phi]", ",", "0."}], "}"}], ",", 
       RowBox[{
        RowBox[{"MyManipulator", "[", 
         RowBox[{"\[Phi]", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "1."}], "\[Pi]"}], ",", 
            RowBox[{"1.", "\[Pi]"}]}], "}"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"NumericQ", "[", "#", "]"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], "=", 
                RowBox[{"RPToAE", "[", 
                 RowBox[{"{", 
                  RowBox[{"\[Chi]", ",", 
                   RowBox[{"\[Phi]", "=", "#"}]}], "}"}], "]"}]}], ";", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], "=", 
                RowBox[{"RPToS", "[", 
                 RowBox[{"{", 
                  RowBox[{"\[Chi]", ",", 
                   RowBox[{"\[Phi]", "=", "#"}]}], "}"}], "]"}]}]}]}], "]"}], 
            ")"}], "&"}], ",", 
          RowBox[{"Scale", "\[Rule]", "\[Pi]"}]}], "]"}], "&"}]}], "}"}], ",",
      "Delimiter", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "S1", ",", "1.", ",", 
         "\"\<\!\(\*SubscriptBox[StyleBox[\"S\",FontSlant->\"Italic\"], \
\"1\"]\)\>\""}], "}"}], ",", 
       RowBox[{
        RowBox[{"MyManipulator", "[", 
         RowBox[{"S1", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1."}], ",", "1."}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"s2", "=", "S2"}], ";", 
               RowBox[{"s3", "=", "S3"}]}], ")"}], "&"}], ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"NumericQ", "[", "#", "]"}], ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"S2", ",", "S3"}], "}"}], "=", 
                  RowBox[{"NS", "[", 
                   RowBox[{"{", 
                    RowBox[{"#", ",", "s2", ",", "s3"}], "}"}], "]"}]}], ";", 
                 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], "=", 
                  RowBox[{"SToAE", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"S1", "=", "#"}], ",", "S2", ",", "S3"}], "}"}], 
                   "]"}]}], ";", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", "#", "]"}], "<", "1"}], ",", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], "=", 
                    RowBox[{"SToRP", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"S1", "=", "#"}], ",", "S2", ",", "S3"}], "}"}], 
                    "]"}]}], ",", 
                   RowBox[{"\[Chi]", "=", 
                    RowBox[{
                    RowBox[{"SToRP", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"S1", "=", "#"}], ",", "S2", ",", "S3"}], "}"}], 
                    "]"}], "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}]}], "]"}]}]}], "]"}], ")"}], 
             "&"}], ",", "Identity"}], "}"}]}], "]"}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "S2", ",", "0.", ",", "\"\<\!\(\*SubscriptBox[\(S\), \(2\)]\)\>\""}], 
        "}"}], ",", 
       RowBox[{
        RowBox[{"MyManipulator", "[", 
         RowBox[{"S2", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1."}], ",", "1."}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"s1", "=", "S1"}], ";", 
               RowBox[{"s3", "=", "S3"}]}], ")"}], "&"}], ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"NumericQ", "[", "#", "]"}], ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"S1", ",", "S3"}], "}"}], "=", 
                  RowBox[{"NS", "[", 
                   RowBox[{"{", 
                    RowBox[{"#", ",", "S1", ",", "S3"}], "}"}], "]"}]}], ";", 
                 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], "=", 
                  RowBox[{"SToAE", "[", 
                   RowBox[{"{", 
                    RowBox[{"S1", ",", 
                    RowBox[{"S2", "=", "#"}], ",", "S3"}], "}"}], "]"}]}], 
                 ";", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], "=", 
                  RowBox[{"SToRP", "[", 
                   RowBox[{"{", 
                    RowBox[{"S1", ",", 
                    RowBox[{"S2", "=", "#"}], ",", "S3"}], "}"}], "]"}]}]}]}],
                "]"}], ")"}], "&"}], ",", "Identity"}], "}"}]}], "]"}], 
        "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "S3", ",", "0.", ",", 
         "\"\<\!\(\*SubscriptBox[StyleBox[\"S\",FontSlant->\"Italic\"], \
\"3\"]\)\>\""}], "}"}], ",", 
       RowBox[{
        RowBox[{"MyManipulator", "[", 
         RowBox[{"S3", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1."}], ",", "1."}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"s1", "=", "S1"}], ";", 
               RowBox[{"s2", "=", "S2"}]}], ")"}], "&"}], ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"NumericQ", "[", "#", "]"}], ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"S1", ",", "S2"}], "}"}], "=", 
                  RowBox[{"NS", "[", 
                   RowBox[{"{", 
                    RowBox[{"#", ",", "S1", ",", "S2"}], "}"}], "]"}]}], ";", 
                 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Abs", "[", "#", "]"}], "<", "1"}], ",", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], "=", 
                    RowBox[{"SToAE", "[", 
                    RowBox[{"{", 
                    RowBox[{"S1", ",", "S2", ",", 
                    RowBox[{"S3", "=", "#"}]}], "}"}], "]"}]}], ",", 
                   RowBox[{"\[Epsilon]", "=", 
                    RowBox[{
                    RowBox[{"SToAE", "[", 
                    RowBox[{"{", 
                    RowBox[{"S1", ",", "S2", ",", 
                    RowBox[{"S3", "=", "#"}]}], "}"}], "]"}], 
                    "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}]}], "]"}], ";", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], "=", 
                  RowBox[{"SToRP", "[", 
                   RowBox[{"{", 
                    RowBox[{"S1", ",", "S2", ",", 
                    RowBox[{"S3", "=", "#"}]}], "}"}], "]"}]}]}]}], "]"}], 
              ")"}], "&"}], ",", "Identity"}], "}"}]}], "]"}], "&"}]}], "}"}],
      ",", "Delimiter", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "plotEllipse", ",", "True", ",", "\"\<Polarization ellipse:\>\""}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "plotPoincare", ",", "True", ",", 
         "\"\<Poincar\[EAcute] sphere:\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"labels", ",", 
         RowBox[{"{", 
          RowBox[{"\"\<\[Alpha]\>\"", ",", "\"\<\[Epsilon]\>\""}], "}"}], 
         ",", "\"\<Angles:\>\""}], "}"}], ",", 
       RowBox[{"ColoredBar", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "\"\<\[Alpha]\>\"", ",", "\"\<\[Epsilon]\>\"", ",", 
           "\"\<\[Chi]\>\"", ",", "\"\<\[Phi]\>\""}], "}"}], ",", 
         RowBox[{"Rest", "@", "color"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"loci", ",", 
         RowBox[{"{", 
          RowBox[{"\"\<\[Alpha]\>\"", ",", "\"\<\[Epsilon]\>\""}], "}"}], 
         ",", "\"\<Loci:\>\""}], "}"}], ",", 
       RowBox[{"ColoredBar", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "\"\<\[Alpha]\>\"", ",", "\"\<\[Epsilon]\>\"", ",", 
           "\"\<\[Chi]\>\"", ",", "\"\<\[Phi]\>\""}], "}"}], ",", 
         RowBox[{"Rest", "@", "color"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"SaveDefinitions", "\[Rule]", "True"}], ",", 
     RowBox[{"ControlPlacement", "\[Rule]", "Top"}]}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[56]:=",
 CellID->649053163,ExpressionUUID->"fbaf1ced-52df-4436-98ba-4dda2d0fbbf5"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Demonstration", "Section",
 CellID->1148058029,ExpressionUUID->"d3cfa0be-4170-4d74-b2a4-e2b0e0ba1cf9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LightPolDemo", "[", "]"}]], "Input",
 CellLabel->"In[57]:=",
 CellID->554108093,ExpressionUUID->"71892ac4-958a-4ed0-bd48-4abc6d5fe540"],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`labels$$ = {
    "\[Alpha]", "\[Epsilon]"}, $CellContext`loci$$ = {
    "\[Alpha]", "\[Epsilon]"}, $CellContext`plotEllipse$$ = 
    True, $CellContext`plotPoincare$$ = True, $CellContext`S1$$ = 
    0.47396841397229783`, $CellContext`S2$$ = -0.4783508626122027, \
$CellContext`S3$$ = 
    0.7392796458680208, $CellContext`\[Alpha]$$ = -0.395, $CellContext`\
\[Epsilon]$$ = 
    0.4159999999999999, $CellContext`\[Phi]$$ = -0.9964977469038019, \
$CellContext`\[Chi]$$ = 0.5385021002303518, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`\[Alpha]$$], 0., "\[Alpha]"}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`\[Alpha]$$, {(-Pi)/2., 
         Pi/2.}, If[
         NumericQ[#], {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`AEToRP[{#, $CellContext`\[Epsilon]$$}]; {$CellContext`S1$$, \
$CellContext`S2$$, $CellContext`S3$$} = $CellContext`AEToS[{$CellContext`\
\[Alpha]$$ = #, $CellContext`\[Epsilon]$$}]]& , Scale -> Pi]& ]}, {{
       Hold[$CellContext`\[Epsilon]$$], 0., "\[Epsilon]"}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`\[Epsilon]$$, {(-Pi)/4.,
          Pi/4.}, If[
         NumericQ[#], {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`AEToRP[{$CellContext`\[Alpha]$$, #}]; {$CellContext`S1$$, \
$CellContext`S2$$, $CellContext`S3$$} = $CellContext`AEToS[{$CellContext`\
\[Alpha]$$, $CellContext`\[Epsilon]$$ = #}]]& , Scale -> Pi]& ]}, {{
       Hold[$CellContext`\[Chi]$$], 0.}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`\[Chi]$$, {0., Pi/2.}, 
        If[
         NumericQ[#], {$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`RPToAE[{$CellContext`\[Chi]$$ = #, $CellContext`\[Phi]$$}]; \
{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$} = \
$CellContext`RPToS[{$CellContext`\[Chi]$$ = #, $CellContext`\[Phi]$$}]]& , 
        Scale -> Pi]& ]}, {{
       Hold[$CellContext`\[Phi]$$], 0.}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`\[Phi]$$, {-Pi, 1. Pi}, 
        If[
         NumericQ[#], {$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`RPToAE[{$CellContext`\[Chi]$$, $CellContext`\[Phi]$$ = #}]; \
{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$} = \
$CellContext`RPToS[{$CellContext`\[Chi]$$, $CellContext`\[Phi]$$ = #}]]& , 
        Scale -> Pi]& ]}, {{
       Hold[$CellContext`S1$$], 1., 
       "\!\(\*SubscriptBox[\n StyleBox[\"S\",\nFontSlant->\"Italic\"], \"1\"]\
\)"}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`S1$$, {-1., 
        1.}, {($CellContext`s2 = $CellContext`S2$$; $CellContext`s3 = \
$CellContext`S3$$)& , If[
          
          NumericQ[#], {$CellContext`S2$$, $CellContext`S3$$} = \
$CellContext`NS[{#, $CellContext`s2, $CellContext`s3}]; \
{$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`SToAE[{$CellContext`S1$$ = #, $CellContext`S2$$, \
$CellContext`S3$$}]; 
          If[Abs[#] < 
            1, {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`SToRP[{$CellContext`S1$$ = #, $CellContext`S2$$, \
$CellContext`S3$$}], $CellContext`\[Chi]$$ = Part[
              $CellContext`SToRP[{$CellContext`S1$$ = #, $CellContext`S2$$, \
$CellContext`S3$$}], 1]]]& , Identity}]& ]}, {{
       Hold[$CellContext`S2$$], 0., "\!\(\*SubscriptBox[\(S\), \(2\)]\)"}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`S2$$, {-1., 
        1.}, {($CellContext`s1 = $CellContext`S1$$; $CellContext`s3 = \
$CellContext`S3$$)& , If[
          
          NumericQ[#], {$CellContext`S1$$, $CellContext`S3$$} = \
$CellContext`NS[{#, $CellContext`S1$$, $CellContext`S3$$}]; {$CellContext`\
\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`SToAE[{$CellContext`S1$$, $CellContext`S2$$ = #, \
$CellContext`S3$$}]; {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`SToRP[{$CellContext`S1$$, $CellContext`S2$$ = #, \
$CellContext`S3$$}]]& , Identity}]& ]}, {{
       Hold[$CellContext`S3$$], 0., 
       "\!\(\*SubscriptBox[\n StyleBox[\"S\",\nFontSlant->\"Italic\"], \"3\"]\
\)"}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`S3$$, {-1., 
        1.}, {($CellContext`s1 = $CellContext`S1$$; $CellContext`s2 = \
$CellContext`S2$$)& , If[
          
          NumericQ[#], {$CellContext`S1$$, $CellContext`S2$$} = \
$CellContext`NS[{#, $CellContext`S1$$, $CellContext`S2$$}]; 
          If[Abs[#] < 
            1, {$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`SToAE[{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$ = \
#}], $CellContext`\[Epsilon]$$ = Part[
              $CellContext`SToAE[{$CellContext`S1$$, $CellContext`S2$$, \
$CellContext`S3$$ = #}], 
              2]]; {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`SToRP[{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$ = \
#}]]& , Identity}]& ]}, {{
       Hold[$CellContext`plotEllipse$$], True, "Polarization ellipse:"}, {
      True, False}}, {{
       Hold[$CellContext`plotPoincare$$], True, "Poincar\[EAcute] sphere:"}, {
      True, False}}, {{
       Hold[$CellContext`labels$$], {"\[Alpha]", "\[Epsilon]"}, "Angles:"}, 
      CheckboxBar[#, 
       MapThread[# -> 
        Style[#, #2]& , {{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}, 
         Take[{
           RGBColor[0.6, 0.24, 0.4428931686004542], 
           RGBColor[0.6, 0.5470136627990908, 0.24], 
           RGBColor[0.24, 0.6, 0.33692049419863584`], 
           RGBColor[0.24, 0.3531726744018182, 0.6], 
           RGBColor[0.6, 0.24, 0.5632658430022722], 
           RGBColor[0.6, 0.42664098839727194`, 0.24], 
           RGBColor[0.2634521802031821, 0.6, 0.24], 
           RGBColor[0.24, 0.47354534880363613`, 0.6], 
           RGBColor[0.5163614825959097, 0.24, 0.6], 
           RGBColor[0.6, 0.3062683139954558, 0.24], 
           RGBColor[0.3838248546049982, 0.6, 0.24], 
           RGBColor[0.24, 0.5939180232054561, 0.6], 
           RGBColor[0.39598880819409377`, 0.24, 0.6], 
           RGBColor[0.6, 0.24, 0.2941043604063603]}, 
          Length[{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}]]}]]& }, {{
       Hold[$CellContext`loci$$], {"\[Alpha]", "\[Epsilon]"}, "Loci:"}, 
      CheckboxBar[#, 
       MapThread[# -> 
        Style[#, #2]& , {{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}, 
         Take[{
           RGBColor[0.6, 0.24, 0.4428931686004542], 
           RGBColor[0.6, 0.5470136627990908, 0.24], 
           RGBColor[0.24, 0.6, 0.33692049419863584`], 
           RGBColor[0.24, 0.3531726744018182, 0.6], 
           RGBColor[0.6, 0.24, 0.5632658430022722], 
           RGBColor[0.6, 0.42664098839727194`, 0.24], 
           RGBColor[0.2634521802031821, 0.6, 0.24], 
           RGBColor[0.24, 0.47354534880363613`, 0.6], 
           RGBColor[0.5163614825959097, 0.24, 0.6], 
           RGBColor[0.6, 0.3062683139954558, 0.24], 
           RGBColor[0.3838248546049982, 0.6, 0.24], 
           RGBColor[0.24, 0.5939180232054561, 0.6], 
           RGBColor[0.39598880819409377`, 0.24, 0.6], 
           RGBColor[0.6, 0.24, 0.2941043604063603]}, 
          Length[{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}]]}]]& }}, 
    Typeset`size$$ = {504., {134., 138.}}, Typeset`update$$ = 0, 
    Typeset`initDone$$, Typeset`skipInitDone$$ = 
    False, $CellContext`plotEllipse$5796$$ = 
    False, $CellContext`plotPoincare$5797$$ = False}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`labels$$ = {
         "\[Alpha]", "\[Epsilon]"}, $CellContext`loci$$ = {
         "\[Alpha]", "\[Epsilon]"}, $CellContext`plotEllipse$$ = 
        True, $CellContext`plotPoincare$$ = True, $CellContext`S1$$ = 
        1., $CellContext`S2$$ = 0., $CellContext`S3$$ = 
        0., $CellContext`\[Alpha]$$ = 0., $CellContext`\[Epsilon]$$ = 
        0., $CellContext`\[Phi]$$ = 0., $CellContext`\[Chi]$$ = 0.}, 
      "ControllerVariables" :> {
        Hold[$CellContext`plotEllipse$$, $CellContext`plotEllipse$5796$$, 
         False], 
        Hold[$CellContext`plotPoincare$$, $CellContext`plotPoincare$5797$$, 
         False]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> 
      Row[{{$CellContext`e1, $CellContext`e2, $CellContext`e3, \
$CellContext`e4} = {
            $CellContext`\[Alpha]\[Epsilon]F[$CellContext`\[Alpha]$$, \
$CellContext`\[Epsilon]$$, 0], 
            $CellContext`\[Alpha]\[Epsilon]F[$CellContext`\[Alpha]$$, \
$CellContext`\[Epsilon]$$, Pi/2], 
            $CellContext`\[Alpha]\[Epsilon]F[$CellContext`\[Alpha]$$, \
$CellContext`\[Epsilon]$$, Pi], 
            $CellContext`\[Alpha]\[Epsilon]F[$CellContext`\[Alpha]$$, \
$CellContext`\[Epsilon]$$, 3 (Pi/2)]}; {$CellContext`co, $CellContext`si} = {
            Cos[$CellContext`\[Chi]$$], 
            Sin[$CellContext`\[Chi]$$]}; Graphics[
           If[$CellContext`plotEllipse$$, {
             Arrowheads[{-0.035, 0.035}], 
             If[
              MemberQ[$CellContext`labels$$, "\[Alpha]"], {
               Part[$CellContext`color, 2], 
               $CellContext`Arc[{0, 0}, {0.6, 0.6}, {
                0, $CellContext`\[Alpha]$$}, Label -> "\[Alpha]"]}, {}], 
             If[
              MemberQ[$CellContext`labels$$, "\[Epsilon]"], {
               Part[$CellContext`color, 3], 
               $CellContext`Arc[{0, 0}, {0.6, 
                0.6}, {$CellContext`\[Alpha]$$, $CellContext`\[Alpha]$$ + \
$CellContext`\[Epsilon]$$}, Label -> "\[Epsilon]"], 
               Arrow[{$CellContext`e3 + $CellContext`e2, $CellContext`e2}], 
               Text[
               "\!\(\*\nStyleBox[\"a\",\nFontSlant->\"Italic\"]\)", \
$CellContext`e3/2 + $CellContext`e2 + 0.08 Normalize[$CellContext`e2]], 
               Arrow[{$CellContext`e3 + $CellContext`e2, $CellContext`e3}], 
               Text[
               "\!\(\*\nStyleBox[\"b\",\nFontSlant->\"Italic\"]\)", 
                0.08 Normalize[$CellContext`e3] + $CellContext`e3 + \
$CellContext`e2/2], $CellContext`dash, 
               
               Line[{$CellContext`e1 + $CellContext`e2, $CellContext`e1 + \
$CellContext`e4, $CellContext`e3 + $CellContext`e4, $CellContext`e3 + \
$CellContext`e2, $CellContext`e1 + $CellContext`e2, {0, 0}}], 
               Line[{$CellContext`e1 + $CellContext`e2, {0, 0}}]}, {}], 
             If[
              MemberQ[$CellContext`labels$$, 
               Alternatives["\[Epsilon]", "\[Alpha]"]], {
               Part[$CellContext`color, 1], $CellContext`dash, 
               Line[{$CellContext`e1, $CellContext`e3}], 
               Line[{$CellContext`e2, $CellContext`e4}]}, {}], 
             If[
              MemberQ[$CellContext`labels$$, "\[Chi]"], {
               Part[$CellContext`color, 4], 
               $CellContext`Arc[{0, 0}, {0.4, 0.4}, {
                0, $CellContext`\[Chi]$$}, Label -> "\[Chi]"], 
               Arrow[{{0, -Sin[$CellContext`\[Chi]$$]}, {
                  Cos[$CellContext`\[Chi]$$], -Sin[$CellContext`\[Chi]$$]}}], 
               
               Text[
               "\!\(\*SubsuperscriptBox[\"\[ScriptCapitalE]\", \n \
StyleBox[\"x\",\nFontSlant->\"Italic\"], \"0\"]\)", {$CellContext`co/
                 2, -$CellContext`si - 0.1}], 
               
               Arrow[{{$CellContext`co, 
                  0}, {$CellContext`co, -$CellContext`si}}], 
               Text[
               "\!\(\*SubsuperscriptBox[\(\[ScriptCapitalE]\), \(y\), \
\(0\)]\)", {$CellContext`co + 0.1, (-$CellContext`si)/2}], $CellContext`dash, 
               
               
               Line[{{$CellContext`co, $CellContext`si}, {-$CellContext`co, \
$CellContext`si}, {-$CellContext`co, -$CellContext`si}, {$CellContext`co, \
-$CellContext`si}, {$CellContext`co, $CellContext`si}, {0, 0}}]}, {}], {
              Arrowheads[
               
               Table[{0.035, $CellContext`i}, {$CellContext`i, 0.025, 1 - 
                 0.025, 0.05}]], 
              ReplaceAll[
               Part[
                
                ParametricPlot[{{
                  Cos[AtomicDensityMatrix`t] $CellContext`co, 
                   Cos[
                    AtomicDensityMatrix`t - $CellContext`\[Phi]$$] \
$CellContext`si}}, {AtomicDensityMatrix`t, 0, 2 Pi}], 1], Line -> 
               Arrow]}}, {}], Frame -> True, FrameLabel -> {
             Style[
             "\!\(\*SubscriptBox[\"\[ScriptCapitalE]\", \n StyleBox[\"x\",\n\
FontSlant->\"Italic\"]]\)", 12], 
             Style["\!\(\*SubscriptBox[\(\[ScriptCapitalE]\), \(y\)]\)", 12]},
            PlotRange -> {{-1, 1}, {-1, 1}}, Axes -> True, ImageSize -> 
           3.5 72], 
         Graphics3D[{$CellContext`ax, 
           If[$CellContext`plotPoincare$$, {
             If[
              And[
               MemberQ[$CellContext`labels$$, "\[Alpha]"], 
               
               Element[$CellContext`\[Alpha]$$, 
                Reals], $CellContext`\[Alpha]$$ != 0], {
               AtomicDensityMatrix`Arrow3D`ColorAll[
                Part[$CellContext`color, 2]], 
               
               AtomicDensityMatrix`Arrow3D`Circle3D[{0, 0, 0}, 0.5, {
                0., 2 $CellContext`\[Alpha]$$}, Label -> "2\[Alpha]", 
                Arrowheads -> {-1, 1}]}, {}], 
             If[
              And[
               
               MemberQ[$CellContext`labels$$, 
                "\[Epsilon]"], $CellContext`\[Epsilon]$$ != 0], {
               AtomicDensityMatrix`Arrow3D`ColorAll[
                Part[$CellContext`color, 3]], 
               AtomicDensityMatrix`GraphicsUtilities`RotateZ[
               2 $CellContext`\[Alpha]$$][
                AtomicDensityMatrix`GraphicsUtilities`RotateX[Pi/2][
                 
                 AtomicDensityMatrix`Arrow3D`Circle3D[{0, 0, 0}, 0.5, {
                  0, 2 $CellContext`\[Epsilon]$$}, Label -> "2\[Epsilon]", 
                  Arrowheads -> {-1, 1}]]]}, {}], 
             If[
              MemberQ[$CellContext`labels$$, 
               Alternatives["\[Epsilon]", "\[Alpha]"]], {
               Part[$CellContext`color, 1], 
               
               Line[{{$CellContext`S1$$, $CellContext`S2$$, \
$CellContext`S3$$}, {$CellContext`S1$$, $CellContext`S2$$, 0}}], 
               AtomicDensityMatrix`GraphicsUtilities`RotateZ[
               2 $CellContext`\[Alpha]$$][
                Line[{{0, 0, 0}, {1, 0, 0}}]]}, {}], 
             If[
              And[
               
               MemberQ[$CellContext`labels$$, 
                "\[Chi]"], $CellContext`\[Chi]$$ != 0], {
               AtomicDensityMatrix`Arrow3D`ColorAll[
                Part[$CellContext`color, 4]], 
               
               AtomicDensityMatrix`GraphicsUtilities`RotateX[$CellContext`\
\[Phi]$$][
                
                AtomicDensityMatrix`Arrow3D`Circle3D[{0, 0, 0}, 0.5, {
                 0, 2 $CellContext`\[Chi]$$}, Label -> "2\[Chi]", 
                 Arrowheads -> {-1, 1}]]}, {}], 
             If[
              And[
               
               MemberQ[$CellContext`labels$$, 
                "\[Phi]"], $CellContext`\[Phi]$$ != 0], {
               AtomicDensityMatrix`Arrow3D`ColorAll[
                Part[$CellContext`color, 5]], 
               Line[{{0, 0, 0}, 
                 Normalize[{0, $CellContext`S2$$, $CellContext`S3$$}]}], 
               
               Line[{{$CellContext`S1$$, $CellContext`S2$$, \
$CellContext`S3$$}, {0, $CellContext`S2$$, $CellContext`S3$$}}], 
               AtomicDensityMatrix`GraphicsUtilities`RotateZ[Pi/2][
                AtomicDensityMatrix`GraphicsUtilities`RotateX[Pi/2][
                 
                 AtomicDensityMatrix`Arrow3D`Circle3D[{0, 0, 0}, 0.5, {
                  0, $CellContext`\[Phi]$$}, Label -> "\[Phi]", 
                  Arrowheads -> {-1, 1}]]]}, {}], 
             If[
              MemberQ[$CellContext`loci$$, "\[Alpha]"], {
               Part[$CellContext`color, 2], 
               AtomicDensityMatrix`GraphicsUtilities`RotateZ[
               2 $CellContext`\[Alpha]$$][
                AtomicDensityMatrix`GraphicsUtilities`RotateX[Pi/2][
                 AtomicDensityMatrix`Arrow3D`Circle3D[1]]]}, {}], 
             If[
              MemberQ[$CellContext`loci$$, "\[Epsilon]"], {
               Part[$CellContext`color, 3], 
               AtomicDensityMatrix`GraphicsUtilities`TranslateZ[
                Sin[2 $CellContext`\[Epsilon]$$]][
                AtomicDensityMatrix`Arrow3D`Circle3D[
                 Cos[2 $CellContext`\[Epsilon]$$]]]}, {}], 
             If[
              MemberQ[$CellContext`loci$$, "\[Chi]"], {
               Part[$CellContext`color, 4], 
               AtomicDensityMatrix`GraphicsUtilities`TranslateX[
                Cos[2 $CellContext`\[Chi]$$]][
                AtomicDensityMatrix`GraphicsUtilities`RotateY[Pi/2][
                 AtomicDensityMatrix`Arrow3D`Circle3D[
                  Sin[2 $CellContext`\[Chi]$$]]]]}, {}], 
             If[
              MemberQ[$CellContext`loci$$, "\[Phi]"], {
               Part[$CellContext`color, 5], 
               
               AtomicDensityMatrix`GraphicsUtilities`RotateX[$CellContext`\
\[Phi]$$][
                
                AtomicDensityMatrix`Arrow3D`Circle3D[{0, 0, 0}, 1, {
                 0, Pi}]]}, {}], 
             AtomicDensityMatrix`GraphicsUtilities`RotateZ[
             2 $CellContext`\[Alpha]$$][
              
              AtomicDensityMatrix`GraphicsUtilities`RotateY[(-2) \
$CellContext`\[Epsilon]$$][$CellContext`arr3d]], {
              Opacity[0.06], 
              Specularity[White, 5], Blue, 
              Sphere[]}}, {}]}, Boxed -> False, ViewPoint -> 10 {1, 1.2, 0.9},
           ViewVertical -> {0, 0, 1}, PlotRange -> 1.3, PlotRegion -> 
          AtomicDensityMatrix`GraphicsUtilities`Crop[{{0.21, 0.78}, {0.25, 
            0.81}}], ImageSize -> 3.5 72, 
          Lighting -> {{"Point", White, {1, 2, 5}}}]}], 
      "Specifications" :> {{{$CellContext`\[Alpha]$$, 0., "\[Alpha]"}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`\[Alpha]$$, {(-Pi)/
            2., Pi/2.}, If[
            
            NumericQ[#], {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`AEToRP[{#, $CellContext`\[Epsilon]$$}]; {$CellContext`S1$$, \
$CellContext`S2$$, $CellContext`S3$$} = $CellContext`AEToS[{$CellContext`\
\[Alpha]$$ = #, $CellContext`\[Epsilon]$$}]]& , Scale -> 
           Pi]& ]}, {{$CellContext`\[Epsilon]$$, 0., "\[Epsilon]"}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`\[Epsilon]$$, {(-Pi)/
            4., Pi/4.}, If[
            
            NumericQ[#], {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`AEToRP[{$CellContext`\[Alpha]$$, #}]; {$CellContext`S1$$, \
$CellContext`S2$$, $CellContext`S3$$} = $CellContext`AEToS[{$CellContext`\
\[Alpha]$$, $CellContext`\[Epsilon]$$ = #}]]& , Scale -> Pi]& ]}, 
        Delimiter, {{$CellContext`\[Chi]$$, 0.}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`\[Chi]$$, {
           0., Pi/2.}, If[
            
            NumericQ[#], {$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`RPToAE[{$CellContext`\[Chi]$$ = #, $CellContext`\[Phi]$$}]; \
{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$} = \
$CellContext`RPToS[{$CellContext`\[Chi]$$ = #, $CellContext`\[Phi]$$}]]& , 
           Scale -> Pi]& ]}, {{$CellContext`\[Phi]$$, 0.}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`\[Phi]$$, {-Pi, 1. 
            Pi}, If[
            
            NumericQ[#], {$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`RPToAE[{$CellContext`\[Chi]$$, $CellContext`\[Phi]$$ = #}]; \
{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$} = \
$CellContext`RPToS[{$CellContext`\[Chi]$$, $CellContext`\[Phi]$$ = #}]]& , 
           Scale -> Pi]& ]}, 
        Delimiter, {{$CellContext`S1$$, 1., 
          "\!\(\*SubscriptBox[\n StyleBox[\"S\",\nFontSlant->\"Italic\"], \"1\
\"]\)"}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`S1$$, {-1., 
           1.}, {($CellContext`s2 = $CellContext`S2$$; $CellContext`s3 = \
$CellContext`S3$$)& , If[
             
             NumericQ[#], {$CellContext`S2$$, $CellContext`S3$$} = \
$CellContext`NS[{#, $CellContext`s2, $CellContext`s3}]; \
{$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`SToAE[{$CellContext`S1$$ = #, $CellContext`S2$$, \
$CellContext`S3$$}]; 
             If[Abs[#] < 
               1, {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`SToRP[{$CellContext`S1$$ = #, $CellContext`S2$$, \
$CellContext`S3$$}], $CellContext`\[Chi]$$ = Part[
                 $CellContext`SToRP[{$CellContext`S1$$ = #, \
$CellContext`S2$$, $CellContext`S3$$}], 1]]]& , 
            Identity}]& ]}, {{$CellContext`S2$$, 0., 
          "\!\(\*SubscriptBox[\(S\), \(2\)]\)"}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`S2$$, {-1., 
           1.}, {($CellContext`s1 = $CellContext`S1$$; $CellContext`s3 = \
$CellContext`S3$$)& , If[
             
             NumericQ[#], {$CellContext`S1$$, $CellContext`S3$$} = \
$CellContext`NS[{#, $CellContext`S1$$, $CellContext`S3$$}]; {$CellContext`\
\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`SToAE[{$CellContext`S1$$, $CellContext`S2$$ = #, \
$CellContext`S3$$}]; {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`SToRP[{$CellContext`S1$$, $CellContext`S2$$ = #, \
$CellContext`S3$$}]]& , Identity}]& ]}, {{$CellContext`S3$$, 0., 
          "\!\(\*SubscriptBox[\n StyleBox[\"S\",\nFontSlant->\"Italic\"], \"3\
\"]\)"}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`S3$$, {-1., 
           1.}, {($CellContext`s1 = $CellContext`S1$$; $CellContext`s2 = \
$CellContext`S2$$)& , If[
             
             NumericQ[#], {$CellContext`S1$$, $CellContext`S2$$} = \
$CellContext`NS[{#, $CellContext`S1$$, $CellContext`S2$$}]; 
             If[Abs[#] < 
               1, {$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`SToAE[{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$ = \
#}], $CellContext`\[Epsilon]$$ = Part[
                 $CellContext`SToAE[{$CellContext`S1$$, $CellContext`S2$$, \
$CellContext`S3$$ = #}], 
                 2]]; {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`SToRP[{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$ = \
#}]]& , Identity}]& ]}, 
        Delimiter, {{$CellContext`plotEllipse$$, True, 
          "Polarization ellipse:"}, {
         True, False}}, {{$CellContext`plotPoincare$$, True, 
          "Poincar\[EAcute] sphere:"}, {
         True, False}}, {{$CellContext`labels$$, {"\[Alpha]", "\[Epsilon]"}, 
          "Angles:"}, CheckboxBar[#, 
          
          MapThread[# -> 
           Style[#, #2]& , {{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}, 
            Take[{
              RGBColor[0.6, 0.24, 0.4428931686004542], 
              RGBColor[0.6, 0.5470136627990908, 0.24], 
              RGBColor[0.24, 0.6, 0.33692049419863584`], 
              RGBColor[0.24, 0.3531726744018182, 0.6], 
              RGBColor[0.6, 0.24, 0.5632658430022722], 
              RGBColor[0.6, 0.42664098839727194`, 0.24], 
              RGBColor[0.2634521802031821, 0.6, 0.24], 
              RGBColor[0.24, 0.47354534880363613`, 0.6], 
              RGBColor[0.5163614825959097, 0.24, 0.6], 
              RGBColor[0.6, 0.3062683139954558, 0.24], 
              RGBColor[0.3838248546049982, 0.6, 0.24], 
              RGBColor[0.24, 0.5939180232054561, 0.6], 
              RGBColor[0.39598880819409377`, 0.24, 0.6], 
              RGBColor[0.6, 0.24, 0.2941043604063603]}, 
             
             Length[{"\[Alpha]", "\[Epsilon]", "\[Chi]", 
               "\[Phi]"}]]}]]& }, {{$CellContext`loci$$, {
          "\[Alpha]", "\[Epsilon]"}, "Loci:"}, CheckboxBar[#, 
          
          MapThread[# -> 
           Style[#, #2]& , {{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}, 
            Take[{
              RGBColor[0.6, 0.24, 0.4428931686004542], 
              RGBColor[0.6, 0.5470136627990908, 0.24], 
              RGBColor[0.24, 0.6, 0.33692049419863584`], 
              RGBColor[0.24, 0.3531726744018182, 0.6], 
              RGBColor[0.6, 0.24, 0.5632658430022722], 
              RGBColor[0.6, 0.42664098839727194`, 0.24], 
              RGBColor[0.2634521802031821, 0.6, 0.24], 
              RGBColor[0.24, 0.47354534880363613`, 0.6], 
              RGBColor[0.5163614825959097, 0.24, 0.6], 
              RGBColor[0.6, 0.3062683139954558, 0.24], 
              RGBColor[0.3838248546049982, 0.6, 0.24], 
              RGBColor[0.24, 0.5939180232054561, 0.6], 
              RGBColor[0.39598880819409377`, 0.24, 0.6], 
              RGBColor[0.6, 0.24, 0.2941043604063603]}, 
             Length[{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}]]}]]& }}, 
      "Options" :> {ControlPlacement -> Top}, "DefaultOptions" :> {}],
     ImageSizeCache->{546., {327., 332.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>({$CellContext`e1 = {
        0.7349778049358368, -0.5472231841345019}, $CellContext`e2 = {
        0.23914259748049768`, 
        0.32119344804599764`}, $CellContext`e3 = {-0.7349778049358368, 
        0.5472231841345019}, $CellContext`e4 = {-0.23914259748049768`, \
-0.32119344804599764`}, $CellContext`\[Alpha]\[Epsilon]F[
         Pattern[$CellContext`\[Alpha], 
          Blank[]], 
         Pattern[$CellContext`\[Epsilon], 
          Blank[]], 
         Pattern[AtomicDensityMatrix`t, 
          
          Blank[]]] = {(Cos[AtomicDensityMatrix`t] Cos[$CellContext`\[Alpha]])
            Cos[$CellContext`\[Epsilon]] - (Sin[AtomicDensityMatrix`t] 
          Sin[$CellContext`\[Alpha]]) 
         Sin[$CellContext`\[Epsilon]], (Cos[AtomicDensityMatrix`t] 
           Cos[$CellContext`\[Epsilon]]) 
          Sin[$CellContext`\[Alpha]] + (Cos[$CellContext`\[Alpha]] 
           Sin[AtomicDensityMatrix`t]) Sin[$CellContext`\[Epsilon]]}, 
       TagSet[AtomicDensityMatrix`t, 
        MessageName[AtomicDensityMatrix`t, "usage"], 
        "t is the default value for the option TimeVariable in DensityMatrix \
and other functions."], $CellContext`co = 0.7729046226268932, $CellContext`si = 
       0.6345222173588407, $CellContext`color = {
         RGBColor[0.24720000000000014`, 0.24, 0.6], 
         RGBColor[0.6, 0.24, 0.4428931686004542], 
         RGBColor[0.6, 0.5470136627990908, 0.24], 
         RGBColor[0.24, 0.6, 0.33692049419863584`], 
         RGBColor[0.24, 0.3531726744018182, 0.6], 
         RGBColor[0.6, 0.24, 0.5632658430022722], 
         RGBColor[0.6, 0.42664098839727194`, 0.24], 
         RGBColor[0.2634521802031821, 0.6, 0.24], 
         RGBColor[0.24, 0.47354534880363613`, 0.6], 
         RGBColor[0.5163614825959097, 0.24, 0.6], 
         RGBColor[0.6, 0.3062683139954558, 0.24], 
         RGBColor[0.3838248546049982, 0.6, 0.24], 
         RGBColor[0.24, 0.5939180232054561, 0.6], 
         RGBColor[0.39598880819409377`, 0.24, 0.6], 
         RGBColor[0.6, 0.24, 0.2941043604063603]}, $CellContext`Arc[{
          Pattern[$CellContext`x, 
           Blank[]], 
          Pattern[$CellContext`y, 
           Blank[]]}, {
          Pattern[$CellContext`r1, 
           Blank[]], 
          Pattern[$CellContext`r2, 
           Blank[]]}, {
          Pattern[$CellContext`\[Theta]1, 
           Blank[]], 
          Pattern[$CellContext`\[Theta]2, 
           Blank[]]}, 
         OptionsPattern[]] := 
       Module[{$CellContext`pos = 
          OptionValue[AtomicDensityMatrix`Arrow3D`LabelPosition]}, 
         If[$CellContext`\[Theta]1 == $CellContext`\[Theta]2, {}, {
           Apply[Arrow, 
            Part[
             AtomicDensityMatrix`GraphicsUtilities`GetLines[
              
              ParametricPlot[{$CellContext`x + $CellContext`r1 
                 Cos[$CellContext`\[Theta]], $CellContext`y + $CellContext`r2 
                 Sin[$CellContext`\[Theta]]}, {$CellContext`\[Theta], \
$CellContext`\[Theta]1, $CellContext`\[Theta]2}]], 1]], 
           If[OptionValue[Label] =!= None, 
            Rotate[
             Text[
              OptionValue[Label], {
              Mean[{$CellContext`r1, $CellContext`r2}] 
               Part[$CellContext`pos, 2], 0}], 
             Part[$CellContext`pos, 
                1] ($CellContext`\[Theta]2 - $CellContext`\[Theta]1) + 
             Mean[{$CellContext`\[Theta]1, $CellContext`\[Theta]2}], {0, 
             0}], {}]}]], 
       Options[$CellContext`Arc] = {
        Label -> None, AtomicDensityMatrix`Arrow3D`LabelPosition -> {0, 1.1}, 
         LabelStyle -> {}}, 
       TagSet[AtomicDensityMatrix`Arrow3D`LabelPosition, 
        MessageName[AtomicDensityMatrix`Arrow3D`LabelPosition, "usage"], ""], 
       AtomicDensityMatrix`GraphicsUtilities`GetLines[
         Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`g, 
          Alternatives[
           Blank[Graphics], 
           Blank[Graphics3D]]]] := Cases[
         First[AtomicDensityMatrix`GraphicsUtilities`Private`g], 
         Blank[Line], Infinity], 
       TagSet[AtomicDensityMatrix`GraphicsUtilities`GetLines, 
        MessageName[AtomicDensityMatrix`GraphicsUtilities`GetLines, "usage"], 
        ""], $CellContext`dash = Dashing[{0.02, 0.02}], $CellContext`ax = {
         GrayLevel[0], 
         Specularity[0], 
         EdgeForm[
          GrayLevel[0]], 
         FaceForm[
          GrayLevel[0]], 
         Glow[
          GrayLevel[0]], {
          Rotate[
           Translate[
            Rotate[{
              GrayLevel[0.5], {
               Line[{{0, 0, 0}, {0, 0, 2.5100000000000002`}}]}, {
               Translate[
                Rotate[
                 Rotate[
                  Translate[
                   
                   Polygon[{{-0.027, 0, -0.009000000000000001}, {
                    0, 0, 0.09000000000000001}, {
                    0.027, 0, -0.009000000000000001}, {0, 0, 
                    0}, {-0.027, 0, -0.009000000000000001}}], {
                   0, 0, -0.09000000000000001}], 0, {1, 0, 0}], 0, {0, 0, 
                 1}], {0, 0, 2.6}]}, 
              Rotate[
               Style[
                Text[
                "\!\(\*SubscriptBox[\n StyleBox[\"S\",\n\
FontSlant->\"Italic\"], \"1\"]\)", {0.13, 0, 2.3400000000000003`}], {12}], Pi/
               4, {0, 0, 1}]}, {{0, 0, 1}, {1., 0., 0.}}], {-1.3, 0, 0}], Pi/
           2, {1, 0, 0}], 
          Translate[
           Rotate[{
             GrayLevel[0.5], {
              Line[{{0, 0, 0}, {0, 0, 2.5100000000000002`}}]}, {
              Translate[
               Rotate[
                Rotate[
                 Translate[
                  
                  Polygon[{{-0.027, 0, -0.009000000000000001}, {
                    0, 0, 0.09000000000000001}, {
                    0.027, 0, -0.009000000000000001}, {0, 0, 
                    0}, {-0.027, 0, -0.009000000000000001}}], {
                  0, 0, -0.09000000000000001}], 0, {1, 0, 0}], 0, {0, 0, 
                1}], {0, 0, 2.6}]}, 
             Rotate[
              Style[
               Text[
               "\!\(\*SubscriptBox[\n StyleBox[\"S\",\n\
FontSlant->\"Italic\"], \"2\"]\)", {0.1, 0, 2.3400000000000003`}], {12}], Pi/
              4, {0, 0, 1}]}, {{0, 0, 1}, {0., 1., 0.}}], {0, -1.3, 0}], 
          Translate[
           Rotate[{
             GrayLevel[0.5], {
              Line[{{0, 0, 0}, {0, 0, 2.5100000000000002`}}]}, {
              Translate[
               Rotate[
                Rotate[
                 Translate[
                  
                  Polygon[{{-0.027, 0, -0.009000000000000001}, {
                    0, 0, 0.09000000000000001}, {
                    0.027, 0, -0.009000000000000001}, {0, 0, 
                    0}, {-0.027, 0, -0.009000000000000001}}], {
                  0, 0, -0.09000000000000001}], 0, {1, 0, 0}], 0, {0, 0, 
                1}], {0, 0, 2.6}]}, 
             Rotate[
              Style[
               Text[
               "\!\(\*SubscriptBox[\n StyleBox[\"S\",\n\
FontSlant->\"Italic\"], \"3\"]\)", {0.13, 0, 2.3400000000000003`}], {12}], (3 
               Pi)/4, {0, 0, 1}]}, {{0, 0, 1}, {0., 0., 1.}}], {
           0, 0, -1.3}]}}, AtomicDensityMatrix`Arrow3D`ColorAll[
         Pattern[$CellContext`col, 
          Blank[]]] := Sequence[$CellContext`col, 
         Specularity[0], 
         EdgeForm[$CellContext`col], 
         FaceForm[Black], 
         Glow[$CellContext`col]], 
       TagSet[AtomicDensityMatrix`Arrow3D`ColorAll, 
        MessageName[AtomicDensityMatrix`Arrow3D`ColorAll, "usage"], ""], 
       AtomicDensityMatrix`Arrow3D`Circle3D[
         Pattern[AtomicDensityMatrix`Arrow3D`Private`r, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`opts, 
          BlankNullSequence[Rule]]] := 
       AtomicDensityMatrix`Arrow3D`Circle3D[{0, 0, 0}, 
         AtomicDensityMatrix`Arrow3D`Private`r, {0, 2 Pi}, 
         AtomicDensityMatrix`Arrow3D`Private`opts], 
       AtomicDensityMatrix`Arrow3D`Circle3D[
         Pattern[AtomicDensityMatrix`Arrow3D`Private`p, {
           Pattern[AtomicDensityMatrix`Arrow3D`Private`x, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`Arrow3D`Private`y, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`Arrow3D`Private`z, 
            Blank[]]}], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`r, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`opts, 
          BlankNullSequence[Rule]]] := 
       AtomicDensityMatrix`Arrow3D`Circle3D[
        AtomicDensityMatrix`Arrow3D`Private`p, 
         AtomicDensityMatrix`Arrow3D`Private`r, {0, 2 Pi}, 
         AtomicDensityMatrix`Arrow3D`Private`opts], 
       AtomicDensityMatrix`Arrow3D`Circle3D[
         Pattern[AtomicDensityMatrix`Arrow3D`Private`p, {
           Pattern[AtomicDensityMatrix`Arrow3D`Private`x, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`Arrow3D`Private`y, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`Arrow3D`Private`z, 
            Blank[]]}], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`r, 
          Blank[]], {
          Pattern[AtomicDensityMatrix`Arrow3D`Private`t1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`Arrow3D`Private`t2, 
           Blank[]]}, 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`Arrow3D`Private`lp = 
          OptionValue[AtomicDensityMatrix`Arrow3D`LabelPosition], 
          AtomicDensityMatrix`Arrow3D`Private`w, 
          AtomicDensityMatrix`Arrow3D`Private`rs = 
          OptionValue[AtomicDensityMatrix`Arrow3D`RenderStyle], 
          AtomicDensityMatrix`Arrow3D`Private`ppopts, 
          AtomicDensityMatrix`Arrow3D`Private`ah, 
          AtomicDensityMatrix`Arrow3D`Private`t1a, 
          AtomicDensityMatrix`Arrow3D`Private`t2a, 
          AtomicDensityMatrix`Arrow3D`Private`ppt = 
          OptionValue[PlotPoints]}, {AtomicDensityMatrix`Arrow3D`Private`w} = 
          ReplaceAll[
            ReplaceAll[
             
             ReplaceAll[{Scale AtomicDensityMatrix`Arrow3D`Width}, {
              AtomicDensityMatrix`Arrow3D`Private`opts}], 
             Options[AtomicDensityMatrix`Arrow3D`Circle3D]], Automatic -> 
            AtomicDensityMatrix`Arrow3D`Private`r]; 
         AtomicDensityMatrix`Arrow3D`Private`ah = 
          AtomicDensityMatrix`Arrow3D`fixArrowheadSpecs[
            OptionValue[Arrowheads], 
            OptionValue[AtomicDensityMatrix`Arrow3D`ArrowShape], 
            OptionValue[Scale], 
            Sign[AtomicDensityMatrix`Arrow3D`Private`t2 - 
              AtomicDensityMatrix`Arrow3D`Private`t1] 
            AtomicDensityMatrix`Arrow3D`Private`r]; 
         AtomicDensityMatrix`Arrow3D`Private`ppopts = DeleteCases[
            FilterRules[
             Join[{AtomicDensityMatrix`Arrow3D`Private`opts}, 
              Options[AtomicDensityMatrix`Arrow3D`Circle3D]], 
             Options[ParametricPlot3D]], PlotPoints -> Blank[]]; {
           AtomicDensityMatrix`Arrow3D`Private`t1a, 
            AtomicDensityMatrix`Arrow3D`Private`t2a} = {
            AtomicDensityMatrix`Arrow3D`Private`t1, 
             AtomicDensityMatrix`Arrow3D`Private`t2} - {
            If[
             And[
             Length[AtomicDensityMatrix`Arrow3D`Private`ah] > 0, 
              Part[AtomicDensityMatrix`Arrow3D`Private`ah, 1, 1] == 0, 
              Sign[AtomicDensityMatrix`Arrow3D`Private`t2 - 
                 AtomicDensityMatrix`Arrow3D`Private`t1] 
               Part[AtomicDensityMatrix`Arrow3D`Private`ah, 1, 2, 1] < 0], 
             Part[AtomicDensityMatrix`Arrow3D`Private`ah, 1, 2, 1]/
             AtomicDensityMatrix`Arrow3D`Private`r, 0], 
            If[
             And[
             Length[AtomicDensityMatrix`Arrow3D`Private`ah] > 0, 
              Part[AtomicDensityMatrix`Arrow3D`Private`ah, -1, 1] == 1, 
              Sign[AtomicDensityMatrix`Arrow3D`Private`t2 - 
                 AtomicDensityMatrix`Arrow3D`Private`t1] 
               Part[AtomicDensityMatrix`Arrow3D`Private`ah, -1, 2, 1] > 0], 
             Part[AtomicDensityMatrix`Arrow3D`Private`ah, -1, 2, 1]/
             AtomicDensityMatrix`Arrow3D`Private`r, 0]}; Translate[{
            Switch[AtomicDensityMatrix`Arrow3D`Private`rs, Full, 
             Part[
              
              ParametricPlot3D[{(AtomicDensityMatrix`Arrow3D`Private`r + 
                 AtomicDensityMatrix`Arrow3D`Private`w 
                  Cos[AtomicDensityMatrix`Arrow3D`Private`v]) 
                Cos[AtomicDensityMatrix`Arrow3D`Private`u], (
                 AtomicDensityMatrix`Arrow3D`Private`r + 
                 AtomicDensityMatrix`Arrow3D`Private`w 
                  Cos[AtomicDensityMatrix`Arrow3D`Private`v]) 
                Sin[AtomicDensityMatrix`Arrow3D`Private`u], 
                AtomicDensityMatrix`Arrow3D`Private`w 
                Sin[AtomicDensityMatrix`Arrow3D`Private`v]}, {
               AtomicDensityMatrix`Arrow3D`Private`u, 
                AtomicDensityMatrix`Arrow3D`Private`t1a, 
                AtomicDensityMatrix`Arrow3D`Private`t2a}, {
               AtomicDensityMatrix`Arrow3D`Private`v, 0, 2 Pi}, Mesh -> False,
                PlotPoints -> 
               Part[AtomicDensityMatrix`Arrow3D`Private`ppt, 1], 
               Evaluate[
                Apply[Sequence, AtomicDensityMatrix`Arrow3D`Private`ppopts]]],
               1], Flat, 
             AtomicDensityMatrix`GraphicsUtilities`GetLines[
              ParametricPlot3D[AtomicDensityMatrix`Arrow3D`Private`r {
                 Cos[AtomicDensityMatrix`Arrow3D`Private`t], 
                 Sin[AtomicDensityMatrix`Arrow3D`Private`t], 0}, {
               AtomicDensityMatrix`Arrow3D`Private`t, 
                AtomicDensityMatrix`Arrow3D`Private`t1a, 
                AtomicDensityMatrix`Arrow3D`Private`t2a}, PlotPoints -> 
               Part[AtomicDensityMatrix`Arrow3D`Private`ppt, 1], 
               Evaluate[AtomicDensityMatrix`Arrow3D`Private`ppopts]]]], 
            Map[
            AtomicDensityMatrix`GraphicsUtilities`RotateZ[
             AtomicDensityMatrix`Arrow3D`Private`t1 + 
              Part[#, 1] (AtomicDensityMatrix`Arrow3D`Private`t2 - 
                AtomicDensityMatrix`Arrow3D`Private`t1)][
              AtomicDensityMatrix`GraphicsUtilities`TranslateX[
              AtomicDensityMatrix`Arrow3D`Private`r][
               AtomicDensityMatrix`GraphicsUtilities`RotateX[-(Pi/2)][
                AtomicDensityMatrix`GraphicsUtilities`RotateY[
                Part[#, 2, 1]/(2 AtomicDensityMatrix`Arrow3D`Private`r)][
                 Switch[
                 AtomicDensityMatrix`Arrow3D`Private`rs, Full, 
                  AtomicDensityMatrix`Arrow3D`FatHead, Flat, 
                  AtomicDensityMatrix`Arrow3D`FlatHead][
                  Apply[Sequence, 
                   Part[#, 2]], PlotPoints -> 
                  Part[AtomicDensityMatrix`Arrow3D`Private`ppt, 2]]]]]]& , 
             AtomicDensityMatrix`Arrow3D`Private`ah], 
            If[OptionValue[Label] =!= None, 
             
             AtomicDensityMatrix`GraphicsUtilities`RotateZ[(
                AtomicDensityMatrix`Arrow3D`Private`t1 + 
                AtomicDensityMatrix`Arrow3D`Private`t2)/
               2 + (Part[AtomicDensityMatrix`Arrow3D`Private`lp, 1] (
                 AtomicDensityMatrix`Arrow3D`Private`t2 - 
                 AtomicDensityMatrix`Arrow3D`Private`t1))/2][
              Text[
               OptionValue[Label], {
               AtomicDensityMatrix`Arrow3D`Private`r 
                Part[AtomicDensityMatrix`Arrow3D`Private`lp, 2], 0, 
                AtomicDensityMatrix`Arrow3D`Private`r 
                Part[AtomicDensityMatrix`Arrow3D`Private`lp, 3]}, 
               Apply[Sequence, 
                If[Length[AtomicDensityMatrix`Arrow3D`Private`lp] > 3, 
                 Drop[AtomicDensityMatrix`Arrow3D`Private`lp, 3], {}]], 
               (If[Head[#] === List, 
                Apply[Sequence, #], #]& )[
                OptionValue[LabelStyle]]]], {}]}, 
           AtomicDensityMatrix`Arrow3D`Private`p]], 
       Options[AtomicDensityMatrix`Arrow3D`Circle3D] := {
        Label -> None, 
         AtomicDensityMatrix`Arrow3D`LabelPosition -> {0, 1.2, 0}, 
         LabelStyle -> {}, AtomicDensityMatrix`Arrow3D`RenderStyle -> Flat, 
         AtomicDensityMatrix`Arrow3D`Width -> 0.01, Arrowheads -> {}, 
         AtomicDensityMatrix`Arrow3D`ArrowShape -> {0.1, 0.03, 0.01}, Scale -> 
         Automatic, PlotPoints -> {Automatic, Automatic}}, 
       TagSet[AtomicDensityMatrix`Arrow3D`Circle3D, 
        MessageName[AtomicDensityMatrix`Arrow3D`Circle3D, "usage"], ""], 
       TagSet[AtomicDensityMatrix`Arrow3D`RenderStyle, 
        MessageName[AtomicDensityMatrix`Arrow3D`RenderStyle, "usage"], ""], 
       TagSet[AtomicDensityMatrix`Arrow3D`Width, 
        MessageName[AtomicDensityMatrix`Arrow3D`Width, "usage"], ""], 
       AtomicDensityMatrix`Arrow3D`fixArrowheadSpecs[
         Pattern[AtomicDensityMatrix`Arrow3D`Private`s, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`default, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`scale, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`length, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`Arrow3D`Private`heads = 
          AtomicDensityMatrix`Arrow3D`Private`s}, 
         AtomicDensityMatrix`Arrow3D`Private`heads = 
          If[Head[AtomicDensityMatrix`Arrow3D`Private`heads] =!= List, {
            AtomicDensityMatrix`Arrow3D`Private`heads}, 
            AtomicDensityMatrix`Arrow3D`Private`heads]; 
         AtomicDensityMatrix`Arrow3D`Private`heads = Sort[
            ReplaceAll[
             MapIndexed[
             AtomicDensityMatrix`Arrow3D`Private`fixArrowheadSpec[#, 
               Part[#2, 1], 
               Length[AtomicDensityMatrix`Arrow3D`Private`heads], 
               AtomicDensityMatrix`Arrow3D`Private`default, 
               AtomicDensityMatrix`Arrow3D`Private`scale]& , 
              AtomicDensityMatrix`Arrow3D`Private`heads], Automatic -> 
             AtomicDensityMatrix`Arrow3D`Private`length], OrderedQ[{
              Part[#, 2], 
              Part[#2, 2]}]& ]], 
       TagSet[AtomicDensityMatrix`Arrow3D`fixArrowheadSpecs, 
        MessageName[AtomicDensityMatrix`Arrow3D`fixArrowheadSpecs, "usage"], 
        ""], AtomicDensityMatrix`Arrow3D`Private`fixArrowheadSpec[
         Pattern[AtomicDensityMatrix`Arrow3D`Private`s, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`i, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`n, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`default, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`scale, 
          Blank[]]] := 
       Module[{AtomicDensityMatrix`Arrow3D`Private`spec = 
          AtomicDensityMatrix`Arrow3D`Private`s, 
          AtomicDensityMatrix`Arrow3D`Private`defs}, 
         If[Head[AtomicDensityMatrix`Arrow3D`Private`spec] =!= List, 
           AtomicDensityMatrix`Arrow3D`Private`spec = {
            AtomicDensityMatrix`Arrow3D`Private`spec}]; 
         AtomicDensityMatrix`Arrow3D`Private`defs = {1, 
            If[
            AtomicDensityMatrix`Arrow3D`Private`n == 1, 
             1, (AtomicDensityMatrix`Arrow3D`Private`i - 1)/(
             AtomicDensityMatrix`Arrow3D`Private`n - 1)], 
            AtomicDensityMatrix`Arrow3D`Private`default, {0, 0}}; 
         AtomicDensityMatrix`Arrow3D`Private`spec = 
          Join[AtomicDensityMatrix`Arrow3D`Private`spec, 
            Drop[AtomicDensityMatrix`Arrow3D`Private`defs, 
             Length[AtomicDensityMatrix`Arrow3D`Private`spec]]]; 
         AtomicDensityMatrix`Arrow3D`Private`spec = 
          MapThread[
           ReplaceAll[#, Automatic -> #2]& , {
            AtomicDensityMatrix`Arrow3D`Private`spec, 
             AtomicDensityMatrix`Arrow3D`Private`defs}]; {
           Part[
           AtomicDensityMatrix`Arrow3D`Private`spec, 2], (
            AtomicDensityMatrix`Arrow3D`Private`scale 
            Part[AtomicDensityMatrix`Arrow3D`Private`spec, 1]) 
           Part[AtomicDensityMatrix`Arrow3D`Private`spec, 3], 
           Part[AtomicDensityMatrix`Arrow3D`Private`spec, 4]}], 
       TagSet[AtomicDensityMatrix`Arrow3D`ArrowShape, 
        MessageName[AtomicDensityMatrix`Arrow3D`ArrowShape, "usage"], ""], 
       AtomicDensityMatrix`GraphicsUtilities`RotateZ[
         Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`theta, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`g, 
          Blank[]]] := 
       Rotate[AtomicDensityMatrix`GraphicsUtilities`Private`g, 
         AtomicDensityMatrix`GraphicsUtilities`Private`theta, {0, 0, 1}], 
       TagSet[AtomicDensityMatrix`GraphicsUtilities`RotateZ, 
        MessageName[AtomicDensityMatrix`GraphicsUtilities`RotateZ, "usage"], 
        ""], AtomicDensityMatrix`GraphicsUtilities`TranslateX[
         Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`x, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`g, 
          Blank[]]] := 
       Translate[
        AtomicDensityMatrix`GraphicsUtilities`Private`g, {
         AtomicDensityMatrix`GraphicsUtilities`Private`x, 0, 0}], 
       TagSet[AtomicDensityMatrix`GraphicsUtilities`TranslateX, 
        MessageName[
        AtomicDensityMatrix`GraphicsUtilities`TranslateX, "usage"], ""], 
       AtomicDensityMatrix`GraphicsUtilities`RotateX[
         Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`theta, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`g, 
          Blank[]]] := 
       Rotate[AtomicDensityMatrix`GraphicsUtilities`Private`g, 
         AtomicDensityMatrix`GraphicsUtilities`Private`theta, {1, 0, 0}], 
       TagSet[AtomicDensityMatrix`GraphicsUtilities`RotateX, 
        MessageName[AtomicDensityMatrix`GraphicsUtilities`RotateX, "usage"], 
        ""], AtomicDensityMatrix`GraphicsUtilities`RotateY[
         Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`theta, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`g, 
          Blank[]]] := 
       Rotate[AtomicDensityMatrix`GraphicsUtilities`Private`g, 
         AtomicDensityMatrix`GraphicsUtilities`Private`theta, {0, 1, 0}], 
       TagSet[AtomicDensityMatrix`GraphicsUtilities`RotateY, 
        MessageName[AtomicDensityMatrix`GraphicsUtilities`RotateY, "usage"], 
        ""], AtomicDensityMatrix`Arrow3D`FatHead[
         Pattern[AtomicDensityMatrix`Arrow3D`Private`length, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`width, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`inset, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`opts, 
          BlankNullSequence[Rule]]] := 
       AtomicDensityMatrix`GraphicsUtilities`TranslateZ[-
          AtomicDensityMatrix`Arrow3D`Private`inset - 
         AtomicDensityMatrix`Arrow3D`Private`length][{
          AtomicDensityMatrix`Arrow3D`Cone3D[
          AtomicDensityMatrix`Arrow3D`Private`width, 
           AtomicDensityMatrix`Arrow3D`Private`inset, Opening -> Down, 
           AtomicDensityMatrix`Arrow3D`Private`opts], 
          AtomicDensityMatrix`Arrow3D`Cone3D[
          AtomicDensityMatrix`Arrow3D`Private`width, 
           AtomicDensityMatrix`Arrow3D`Private`inset + 
           AtomicDensityMatrix`Arrow3D`Private`length, Opening -> Down, 
           AtomicDensityMatrix`Arrow3D`Private`opts]}], 
       TagSet[AtomicDensityMatrix`Arrow3D`FatHead, 
        MessageName[AtomicDensityMatrix`Arrow3D`FatHead, "usage"], ""], 
       AtomicDensityMatrix`GraphicsUtilities`TranslateZ[
         Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`x, 
          Blank[]]][
         Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`g, 
          Blank[]]] := 
       Translate[
        AtomicDensityMatrix`GraphicsUtilities`Private`g, {
         0, 0, AtomicDensityMatrix`GraphicsUtilities`Private`x}], 
       TagSet[AtomicDensityMatrix`GraphicsUtilities`TranslateZ, 
        MessageName[
        AtomicDensityMatrix`GraphicsUtilities`TranslateZ, "usage"], ""], 
       AtomicDensityMatrix`Arrow3D`Cone3D[
         Pattern[AtomicDensityMatrix`Arrow3D`Private`r, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`h, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`opts, 
          OptionsPattern[]]] := 
       Module[{AtomicDensityMatrix`Arrow3D`Private`rp3dopts = FilterRules[
            Join[{AtomicDensityMatrix`Arrow3D`Private`opts}, 
             Options[AtomicDensityMatrix`Arrow3D`Cone3D]], 
            Options[RevolutionPlot3D]], 
          AtomicDensityMatrix`Arrow3D`Private`pp}, 
         If[OptionValue[AtomicDensityMatrix`Arrow3D`RenderStyle] === Full, 
          If[$VersionNumber < 7., 
           ReplaceAll[
            If[OptionValue[Opening] === Down, 
             Normal[
              Part[
               RevolutionPlot3D[
               AtomicDensityMatrix`Arrow3D`Private`h (1 - 
                 AtomicDensityMatrix`Arrow3D`Private`t/
                 AtomicDensityMatrix`Arrow3D`Private`r), {
                AtomicDensityMatrix`Arrow3D`Private`t, 0, 
                 AtomicDensityMatrix`Arrow3D`Private`r}, Mesh -> False, 
                Evaluate[
                 Apply[
                 Sequence, AtomicDensityMatrix`Arrow3D`Private`rp3dopts]]], 
               1]], 
             Part[
              RevolutionPlot3D[
              AtomicDensityMatrix`Arrow3D`Private`h (
                AtomicDensityMatrix`Arrow3D`Private`t/
                AtomicDensityMatrix`Arrow3D`Private`r), {
               AtomicDensityMatrix`Arrow3D`Private`t, 0, 
                AtomicDensityMatrix`Arrow3D`Private`r}, Mesh -> False, 
               Evaluate[
                Apply[
                Sequence, AtomicDensityMatrix`Arrow3D`Private`rp3dopts]]], 
              1]], {(Lighting -> Blank[]) :> Sequence[], RGBColor[
               BlankSequence[]] :> Sequence[], Specularity[
               BlankNullSequence[]] :> Sequence[]}], 
           If[OptionValue[Opening] === Down, {
             EdgeForm[], 
             Cone[{{0, 0, 0}, {0, 0, AtomicDensityMatrix`Arrow3D`Private`h}}, 
              AtomicDensityMatrix`Arrow3D`Private`r]}, {
             EdgeForm[], 
             
             Cone[{{0, 0, AtomicDensityMatrix`Arrow3D`Private`h}, {0, 0, 0}}, 
              AtomicDensityMatrix`Arrow3D`Private`r]}]], 
          AtomicDensityMatrix`Arrow3D`Private`pp = ReplaceAll[
             OptionValue[PlotPoints], Automatic -> 10]; 
          If[OptionValue[Opening] === Down, {
             
             AtomicDensityMatrix`Arrow3D`Circle3D[{0, 0, 0}, 
              AtomicDensityMatrix`Arrow3D`Private`r], 
             Table[
              
              Line[{{0, 0, AtomicDensityMatrix`Arrow3D`Private`h}, {
                AtomicDensityMatrix`Arrow3D`Private`r 
                 Sin[AtomicDensityMatrix`Arrow3D`Private`t], 
                 AtomicDensityMatrix`Arrow3D`Private`r 
                 Cos[AtomicDensityMatrix`Arrow3D`Private`t], 0}}], {
              AtomicDensityMatrix`Arrow3D`Private`t, 0, 2 Pi - (2 Pi)/
               AtomicDensityMatrix`Arrow3D`Private`pp, (2 Pi)/
               AtomicDensityMatrix`Arrow3D`Private`pp}]}, {
             
             AtomicDensityMatrix`Arrow3D`Circle3D[{
              0, 0, AtomicDensityMatrix`Arrow3D`Private`h}, 
              AtomicDensityMatrix`Arrow3D`Private`r], 
             Table[
              
              Line[{{0, 0, 0}, {
                AtomicDensityMatrix`Arrow3D`Private`r 
                 Sin[AtomicDensityMatrix`Arrow3D`Private`t], 
                 AtomicDensityMatrix`Arrow3D`Private`r 
                 Cos[AtomicDensityMatrix`Arrow3D`Private`t], 
                 AtomicDensityMatrix`Arrow3D`Private`h}}], {
              AtomicDensityMatrix`Arrow3D`Private`t, 0, 2 Pi - (2 Pi)/
               AtomicDensityMatrix`Arrow3D`Private`pp, (2 Pi)/
               AtomicDensityMatrix`Arrow3D`Private`pp}]}]]], 
       Options[AtomicDensityMatrix`Arrow3D`Cone3D] = {
        Opening -> Down, PlotPoints -> Automatic, 
         AtomicDensityMatrix`Arrow3D`RenderStyle -> Full}, 
       TagSet[AtomicDensityMatrix`Arrow3D`Cone3D, 
        MessageName[AtomicDensityMatrix`Arrow3D`Cone3D, "usage"], ""], 
       AtomicDensityMatrix`Arrow3D`FlatHead[
         Pattern[AtomicDensityMatrix`Arrow3D`Private`length, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`width, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`inset, 
          Blank[]], 
         Pattern[AtomicDensityMatrix`Arrow3D`Private`opts, 
          BlankNullSequence[Rule]]] := 
       AtomicDensityMatrix`GraphicsUtilities`TranslateZ[-
         AtomicDensityMatrix`Arrow3D`Private`length][
         Polygon[{{-AtomicDensityMatrix`Arrow3D`Private`width, 0, -
            AtomicDensityMatrix`Arrow3D`Private`inset}, {
           0, 0, AtomicDensityMatrix`Arrow3D`Private`length}, {
           AtomicDensityMatrix`Arrow3D`Private`width, 0, -
            AtomicDensityMatrix`Arrow3D`Private`inset}, {0, 0, 
           0}, {-AtomicDensityMatrix`Arrow3D`Private`width, 0, -
            AtomicDensityMatrix`Arrow3D`Private`inset}}]], 
       TagSet[AtomicDensityMatrix`Arrow3D`FlatHead, 
        MessageName[AtomicDensityMatrix`Arrow3D`FlatHead, "usage"], 
        ""], $CellContext`arr3d = {
         RGBColor[0.24720000000000014`, 0.24, 0.6], 
         Specularity[0], 
         EdgeForm[
          RGBColor[0.24720000000000014`, 0.24, 0.6]], 
         FaceForm[
          GrayLevel[0]], 
         Glow[
          RGBColor[0.24720000000000014`, 0.24, 0.6]], 
         Thickness[0.007], 
         Rotate[{{
            Line[{{0, 0, 0}, {0, 0, 0.85}}]}, {
            Translate[
             Rotate[
              Rotate[
               Translate[
                
                Polygon[{{-0.045, 0, -0.015}, {0, 0, 0.15000000000000002`}, {
                  0.045, 0, -0.015}, {0, 0, 0}, {-0.045, 0, -0.015}}], {
                0, 0, -0.15000000000000002`}], 0, {1, 0, 0}], 0, {0, 0, 1}], {
             0, 0, 1}]}, {}}, Pi/2, {0, 1, 0}]}, 
       AtomicDensityMatrix`GraphicsUtilities`Crop[{{
           Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`xmin, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`xmax, 
            Blank[]]}, {
           Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`ymin, 
            Blank[]], 
           Pattern[AtomicDensityMatrix`GraphicsUtilities`Private`ymax, 
            Blank[]]}}] := {{0, 
          1} + {-AtomicDensityMatrix`GraphicsUtilities`Private`xmin, 1 - 
            AtomicDensityMatrix`GraphicsUtilities`Private`xmax}/(
          AtomicDensityMatrix`GraphicsUtilities`Private`xmax - 
          AtomicDensityMatrix`GraphicsUtilities`Private`xmin), {0, 
          1} + {-AtomicDensityMatrix`GraphicsUtilities`Private`ymin, 1 - 
            AtomicDensityMatrix`GraphicsUtilities`Private`ymax}/(
          AtomicDensityMatrix`GraphicsUtilities`Private`ymax - 
          AtomicDensityMatrix`GraphicsUtilities`Private`ymin)}, 
       TagSet[AtomicDensityMatrix`GraphicsUtilities`Crop, 
        MessageName[AtomicDensityMatrix`GraphicsUtilities`Crop, "usage"], ""],
        Attributes[$CellContext`MyManipulator] = {
        HoldAll}, $CellContext`MyManipulator[
         Pattern[$CellContext`var, 
          Blank[]], 
         Pattern[$CellContext`range, 
          Blank[]], 
         Pattern[$CellContext`func, 
          Blank[]], Scale -> Pattern[$CellContext`scale, 
           Blank[]]] := Row[{
          Manipulator[
           
           Dynamic[$CellContext`var, $CellContext`func], $CellContext`range], \

          $CellContext`PaddedInputField[$CellContext`var, $CellContext`func, \
$CellContext`scale]}, 
         Spacer[5]], $CellContext`MyManipulator[
         Pattern[$CellContext`var, 
          Blank[]], 
         Pattern[$CellContext`range, 
          Blank[]], 
         Pattern[$CellContext`func, 
          Blank[]]] := Row[{
          Manipulator[
           
           Dynamic[$CellContext`var, $CellContext`func], $CellContext`range], \

          $CellContext`PaddedInputField[$CellContext`var, $CellContext`func]}, 
         Spacer[5]], 
       Attributes[$CellContext`PaddedInputField] = {
        HoldAll}, $CellContext`PaddedInputField[
         Pattern[$CellContext`x, 
          Blank[]], 
         Pattern[$CellContext`func, 
          Blank[]]] := InputField[
         Dynamic[
          DisplayForm[
           StyleBox[
            ToString[
             $CellContext`MyNumberForm[$CellContext`x]]]], $CellContext`func],
          FieldSize -> 5], $CellContext`PaddedInputField[
         Pattern[$CellContext`x, 
          Blank[]], 
         Pattern[$CellContext`func, 
          Blank[]], 
         Pattern[$CellContext`p, 
          Blank[]]] := InputField[
         Dynamic[
          DisplayForm[
           RowBox[{
             ToString[
              $CellContext`MyNumberForm[$CellContext`x/$CellContext`p]], 
             TraditionalForm[$CellContext`p]}]], $CellContext`func], 
         FieldSize -> 5], $CellContext`MyNumberForm[
         Pattern[$CellContext`x, 
          Blank[]]] := NumberForm[
         N[$CellContext`x, 2], {2, 2}, NumberSigns -> {"-", "   "}, 
         ExponentFunction -> (Null& )], $CellContext`AEToRP[
         Pattern[$CellContext`st, 
          Blank[]]] := 
       AtomicDensityMatrix`ReparameterizeField[$CellContext`st, 
         "AngleEllipticity" -> "RatioPhase"], 
       AtomicDensityMatrix`ReparameterizeField[{
          Pattern[AtomicDensityMatrix`OpticalField`Private`S1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`OpticalField`Private`S2, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`OpticalField`Private`S3, 
           Blank[]]}, "Stokes" -> "RatioPhase"] := {
         ArcCos[
         Sqrt[1 + AtomicDensityMatrix`OpticalField`Private`S1]/Sqrt[2]], 
         If[
         N[AtomicDensityMatrix`OpticalField`Private`S2] === 
          N[AtomicDensityMatrix`OpticalField`Private`S3] === 0., Pi/4, 
          ArcTan[
          AtomicDensityMatrix`OpticalField`Private`S2, 
           AtomicDensityMatrix`OpticalField`Private`S3]]}, 
       AtomicDensityMatrix`ReparameterizeField[{
          Pattern[AtomicDensityMatrix`OpticalField`Private`chi, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`OpticalField`Private`ph, 
           Blank[]]}, "RatioPhase" -> "Stokes"] := {
         Cos[2 AtomicDensityMatrix`OpticalField`Private`chi], 
         Cos[AtomicDensityMatrix`OpticalField`Private`ph] 
         Sin[2 AtomicDensityMatrix`OpticalField`Private`chi], 
         Sin[AtomicDensityMatrix`OpticalField`Private`ph] 
         Sin[2 AtomicDensityMatrix`OpticalField`Private`chi]}, 
       AtomicDensityMatrix`ReparameterizeField[{
          Pattern[AtomicDensityMatrix`OpticalField`Private`al, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`OpticalField`Private`ep, 
           Blank[]]}, "AngleEllipticity" -> "Stokes"] := {
        Cos[2 AtomicDensityMatrix`OpticalField`Private`al] 
         Cos[2 AtomicDensityMatrix`OpticalField`Private`ep], 
         Cos[2 AtomicDensityMatrix`OpticalField`Private`ep] 
         Sin[2 AtomicDensityMatrix`OpticalField`Private`al], 
         Sin[2 AtomicDensityMatrix`OpticalField`Private`ep]}, 
       AtomicDensityMatrix`ReparameterizeField[{
          Pattern[AtomicDensityMatrix`OpticalField`Private`S1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`OpticalField`Private`S2, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`OpticalField`Private`S3, 
           Blank[]]}, "Stokes" -> "AngleEllipticity"] := {
        If[N[AtomicDensityMatrix`OpticalField`Private`S1] === 
           N[AtomicDensityMatrix`OpticalField`Private`S2] === 0., 0, 
           ArcTan[
           AtomicDensityMatrix`OpticalField`Private`S1, 
            AtomicDensityMatrix`OpticalField`Private`S2]]/2, 
         ArcSin[AtomicDensityMatrix`OpticalField`Private`S3]/2}, 
       AtomicDensityMatrix`ReparameterizeField[{
          Pattern[AtomicDensityMatrix`OpticalField`Private`chi, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`OpticalField`Private`ph, 
           Blank[]]}, "RatioPhase" -> "AngleEllipticity"] := {
        ArcTan[Tan[2 AtomicDensityMatrix`OpticalField`Private`chi] 
           Cos[AtomicDensityMatrix`OpticalField`Private`ph]]/2, 
         ArcSin[Sin[2 AtomicDensityMatrix`OpticalField`Private`chi] 
           Sin[AtomicDensityMatrix`OpticalField`Private`ph]]/2}, 
       AtomicDensityMatrix`ReparameterizeField[{
          Pattern[AtomicDensityMatrix`OpticalField`Private`al, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`OpticalField`Private`ep, 
           Blank[]]}, "AngleEllipticity" -> "RatioPhase"] := {
        ArcCos[Cos[2 AtomicDensityMatrix`OpticalField`Private`al] 
           Cos[2 AtomicDensityMatrix`OpticalField`Private`ep]]/2, 
         ArcTan[
         Csc[2 AtomicDensityMatrix`OpticalField`Private`al] 
          Tan[2 AtomicDensityMatrix`OpticalField`Private`ep]]}, 
       TagSet[AtomicDensityMatrix`ReparameterizeField, 
        MessageName[AtomicDensityMatrix`ReparameterizeField, "usage"], 
        ""], $CellContext`AEToS[
         Pattern[$CellContext`st, 
          Blank[]]] := 
       AtomicDensityMatrix`ReparameterizeField[$CellContext`st, 
         "AngleEllipticity" -> "Stokes"], $CellContext`RPToAE[
         Pattern[$CellContext`st, 
          Blank[]]] := 
       AtomicDensityMatrix`ReparameterizeField[$CellContext`st, "RatioPhase" -> 
         "AngleEllipticity"], $CellContext`RPToS[
         Pattern[$CellContext`st, 
          Blank[]]] := 
       AtomicDensityMatrix`ReparameterizeField[$CellContext`st, "RatioPhase" -> 
         "Stokes"], $CellContext`NS = $CellContext`NormalizeStokes, \
$CellContext`NormalizeStokes[{
          Pattern[$CellContext`s1, 
           Blank[]], 
          Pattern[$CellContext`s2, 
           Blank[]], 
          Pattern[$CellContext`s3, 
           Blank[]]}] := Module[{$CellContext`a}, 
         Which[
          And[Abs[$CellContext`s2] < 0.01, Abs[$CellContext`s3] < 0.01], {
          Sqrt[1 - $CellContext`s1^2]/Sqrt[2], Sqrt[1 - $CellContext`s1^2]/
           Sqrt[2]}, Abs[$CellContext`s1] == 1., {0., 0.}, 
          True, $CellContext`a = 
           Sqrt[(1 - $CellContext`s1^2)/($CellContext`s2^2 + \
$CellContext`s3^2)]; {$CellContext`s2 $CellContext`a, $CellContext`s3 \
$CellContext`a}]], $CellContext`SToAE[
         Pattern[$CellContext`st$, 
          Blank[]]] := 
       If[$CellContext`S1$$ == $CellContext`S2$$ == 0., {
         0, ((1/4) Pi) (KroneckerDelta[$CellContext`S3$$] + 
           Sign[$CellContext`S3$$])}, 
         AtomicDensityMatrix`ReparameterizeField[$CellContext`st$, "Stokes" -> 
          "AngleEllipticity"]], $CellContext`SToRP[
         Pattern[$CellContext`st$, 
          Blank[]]] := If[$CellContext`S2$$ == $CellContext`S3$$ == 0., {
          ArcCos[Sqrt[1 + $CellContext`S1$$]/Sqrt[2]], Pi/4}, 
         AtomicDensityMatrix`ReparameterizeField[$CellContext`st$, "Stokes" -> 
          "RatioPhase"]]}; Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellLabel->"Out[57]=",
 CellID->1750948083,ExpressionUUID->"727e9802-0532-45fa-b1a7-443067d43293"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "TutorialMoreAboutSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "AtomicDensityMatrix Package",
         BaseStyle->"Link",
         ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]],
          "TutorialMoreAbout",ExpressionUUID->
         "19a03221-43b2-496e-b228-4c88c654147a"]}]}
     }]}
  }]], "TutorialMoreAboutSection",ExpressionUUID->"084434fa-a915-4881-935d-\
aacec1645991"],

Cell[BoxData[""], "Input",ExpressionUUID->"8e5c7bfe-793a-4f1f-b2c9-cba0658c26a1"],

Cell[BoxData[""], "Input",ExpressionUUID->"d116aab0-1b2d-4393-a241-7ae302b361a4"]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"5bcc3ef8-8e1e-480c-840c-51d4ff7d6722"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Light Polarization Demonstration",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}}, 
  "NewStyles" -> True, "CitationPopupData" -> {$Failed, ""}, "ShowCitation" -> 
  False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 18, 0, 23.190764}", 
    "history" -> {"XX", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Package Tutorial", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix Package", "status" -> "None", "summary" -> 
    "An interactive demonstration illustrating parametrizations for light \
polarization. Light polarization can be selected using the \
\\[Alpha]-\\[Epsilon], x-\\[Phi], and Stokes parametrizations. The \
polarization ellipse and Poincar\[EAcute] sphere are plotted.", 
    "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$72887, "title" -> 
    "Light Polarization Demonstration", "titlemodifier" -> "", 
    "metadescription" -> "", "windowtitle" -> 
    "Light Polarization Demonstration", "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/LightPolarizationDemonstration1"}},
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> Notebook], 
   Cell[
    StyleData["Output"], CellContext -> Notebook], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"401be38c-af30-4d7c-8dbe-fa6a917e2480"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 4653, 111, 57, "AnchorBarGrid",ExpressionUUID->"2783cfe6-61a4-4a65-bd1b-389e079dd373",
 CellID->1],
Cell[CellGroupData[{
Cell[5282, 136, 124, 1, 63, "Title",ExpressionUUID->"3a9edbd3-e383-4a2b-a3d2-bd0c59d9752f",
 CellID->509267359],
Cell[5409, 139, 1863, 43, 47, "TutorialJumpBox",ExpressionUUID->"f0462ec2-1220-4c8c-a953-441c7c6fff57"],
Cell[7275, 184, 359, 6, 60, "Text",ExpressionUUID->"ed67dd32-7e29-4444-8244-9749cece286f",
 CellID->1534169418],
Cell[CellGroupData[{
Cell[7659, 194, 112, 1, 71, "Section",ExpressionUUID->"e8d8a06e-3861-448c-847d-a5afe3e1096b",
 CellID->869375336],
Cell[CellGroupData[{
Cell[7796, 199, 111, 1, 70, "Subsection",ExpressionUUID->"e3abb13a-5498-42e5-bc73-e0c02da43a6b",
 CellID->686213985],
Cell[7910, 202, 163, 3, 70, "Input",ExpressionUUID->"17063df7-5ed7-44fb-8d1f-bfeb76620a1b",
 CellID->171085568],
Cell[8076, 207, 617, 17, 70, "Input",ExpressionUUID->"784d4e45-12c2-42be-b376-a9c5b586b460",
 CellID->109334777],
Cell[8696, 226, 228, 5, 70, "Input",ExpressionUUID->"7268d3a5-5f87-4be6-ab77-a5a602db03f7",
 CellID->343416248],
Cell[8927, 233, 580, 16, 70, "Input",ExpressionUUID->"21d11d47-2c45-4151-9622-4b0d2c1d3ab6",
 CellID->56403217],
Cell[9510, 251, 735, 20, 70, "Input",ExpressionUUID->"aefa15e2-662f-482b-aa5c-e7d1878a838c",
 CellID->11061968],
Cell[10248, 273, 319, 8, 70, "Input",ExpressionUUID->"16dcb780-6a4d-4aa4-a673-3567eff6c990",
 CellID->177524866],
Cell[10570, 283, 465, 13, 70, "Input",ExpressionUUID->"be2b0669-8a57-4c28-9d78-0cc9fd8c3ba1",
 CellID->228198244],
Cell[11038, 298, 2804, 76, 70, "Input",ExpressionUUID->"8237ca62-a26c-4401-8a30-68b7bdcaea8c",
 CellID->338406235],
Cell[13845, 376, 456, 11, 70, "Input",ExpressionUUID->"c0530541-359b-4691-80a1-d3ca1a40d524",
 CellID->2931987],
Cell[14304, 389, 225, 5, 70, "Input",ExpressionUUID->"d73e78d9-b8b5-4575-9c66-e17e03bb0d55",
 CellID->282891712],
Cell[14532, 396, 700, 18, 70, "Input",ExpressionUUID->"108441c9-4ac7-4d6f-8952-05a68c142f04",
 CellID->218396106],
Cell[15235, 416, 634, 17, 70, "Input",ExpressionUUID->"5c7127ab-391a-4992-a3ea-22751f948824",
 CellID->74104170],
Cell[15872, 435, 720, 21, 70, "Input",ExpressionUUID->"2bcd1de3-7d03-4921-bd20-5db71da43c6e",
 CellID->17081472]
}, Open  ]],
Cell[CellGroupData[{
Cell[16629, 461, 120, 1, 70, "Subsection",ExpressionUUID->"da29ca8e-d0f6-4f22-ac18-8e1507f470b9",
 CellID->1186851093],
Cell[16752, 464, 1491, 47, 70, "Input",ExpressionUUID->"12f2a92f-a13a-4a83-8a94-efefc056f744",
 CellID->3740002],
Cell[18246, 513, 1332, 38, 70, "Input",ExpressionUUID->"e8b8032b-f00f-434e-8b2e-3fda6122dd6c",
 CellID->13348457],
Cell[19581, 553, 1043, 28, 70, "Input",ExpressionUUID->"25ea20ae-1a43-48ba-b253-dd29ec477012",
 CellID->780677788],
Cell[20627, 583, 3284, 91, 70, "Input",ExpressionUUID->"c63924e0-5537-4b8c-8ee1-6f01a8c68c3a",
 CellID->415357996],
Cell[23914, 676, 7904, 216, 70, "Input",ExpressionUUID->"f6eeb60b-6bfe-477f-b4ad-a895e28c3faf",
 CellID->1146864269],
Cell[31821, 894, 9558, 261, 70, "Input",ExpressionUUID->"e8fd2647-a0d1-4df7-9d35-9ef3dd1f375e",
 CellID->681870644],
Cell[41382, 1157, 18082, 468, 70, "Input",ExpressionUUID->"fbaf1ced-52df-4436-98ba-4dda2d0fbbf5",
 CellID->649053163]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[59513, 1631, 108, 1, 51, "Section",ExpressionUUID->"d3cfa0be-4170-4d74-b2a4-e2b0e0ba1cf9",
 CellID->1148058029],
Cell[CellGroupData[{
Cell[59646, 1636, 159, 3, 29, "Input",ExpressionUUID->"71892ac4-958a-4ed0-bd48-4abc6d5fe540",
 CellID->554108093],
Cell[59808, 1641, 65122, 1304, 682, "Output",ExpressionUUID->"727e9802-0532-45fa-b1a7-443067d43293",
 CellID->1750948083]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[124979, 2951, 725, 18, 70, "TutorialMoreAboutSection",ExpressionUUID->"084434fa-a915-4881-935d-aacec1645991"],
Cell[125707, 2971, 81, 0, 70, "Input",ExpressionUUID->"8e5c7bfe-793a-4f1f-b2c9-cba0658c26a1"],
Cell[125791, 2973, 81, 0, 70, "Input",ExpressionUUID->"d116aab0-1b2d-4393-a241-7ae302b361a4"]
}, Open  ]]
}, Open  ]],
Cell[125899, 2977, 78, 0, 70, "FooterCell",ExpressionUUID->"5bcc3ef8-8e1e-480c-840c-51d4ff7d6722"]
}
]
*)

(* End of internal cache information *)

