(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    296712,       7612]
NotebookOptionsPosition[    282838,       7329]
NotebookOutlinePosition[    285605,       7393]
CellTagsIndexPosition[    285562,       7390]
WindowTitle->Nonlinear Magneto-Optical Rotation in an Alkali Atom
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "6e011b4d-0fcd-4579-8095-725fb64107e7"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "1c7fc4d6-1f8b-44b8-9bde-e131bdc15db6"],
        Background->RGBColor[
         0.7450980392156863, 0.3254901960784314, 0.1411764705882353],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "b28d36bb-3fbe-43cc-b6ca-d83b5ffe18a0"]
         }],ExpressionUUID->"99229b82-0fed-4b28-b369-70036ae03e3f"],
         StripOnInput->
          False], {"\<\"Nonlinear Magneto-Optical Rotation with \
Frequency-Modulated Light\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/\
NonlinearMagnetoOpticalRotationWithFrequencyModulatedLight"], "\<\"Zeeman \
Structure: Nonlinear Magneto-Optical Rotation\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/\
ZeemanStructureNonlinearMagnetoOpticalRotation"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"RelatedTutorialsSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "d964a7c6-1f95-42e0-8ce7-48b4a875acd8"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "2191acbc-9026-41f5-ab2c-e631d049b5d6"]
         }],ExpressionUUID->"49041823-4bc1-497b-afe5-86aae1b358b7"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"TutorialMoreAboutSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "eb5e26a7-3ad0-4dbd-9d21-b3981de764b2"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "e497ecbf-0dc2-4414-b231-aa310593f9ef"]
         }],ExpressionUUID->"8c94a2ee-f01c-46c9-8600-41485af0cd23"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/tutorial/\
NonlinearMagnetoOpticalRotationInAnAlkaliAtom\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
              "AtomicDensityMatrix/tutorial/\
NonlinearMagnetoOpticalRotationInAnAlkaliAtom"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
tutorial/NonlinearMagnetoOpticalRotationInAnAlkaliAtom.html"], StandardForm]],
                "Input", TextClipboardType -> "PlainText"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$74404], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/tutorial/\
NonlinearMagnetoOpticalRotationInAnAlkaliAtom" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "50f06115-7cba-4b5a-a96d-577f6ba2eb91"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "0c150ff3-19cd-466c-982d-f8c0fc65e17f"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"773355eb-7fd4-41ef-93ab-990b58d512db"],

Cell[CellGroupData[{

Cell["Nonlinear Magneto-Optical Rotation in an Alkali Atom", "Title",
 CellID->509267359,ExpressionUUID->"62d742e2-4379-4952-93b0-4763ba1a5811"],

Cell[TextData[{
 "Here we examine the interaction of linearly polarized light and a \
longitudinal magnetic field with an atomic sample, as in the tutorial ",
 ButtonBox["\"Zeeman Structure: Nonlinear Magneto-Optical Rotation\"",
  BaseStyle->"Link",
  ButtonData->
   "paclet:AtomicDensityMatrix/tutorial/\
ZeemanStructureNonlinearMagnetoOpticalRotation"],
 ". In this case, we consider the D1 line of the ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["", "87"], " ", "Rb"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"d3b116ab-966e-46fa-aece-1c848a9efa1b"],
 " atom, and write the input parameters in units appropriate for comparison \
with experimental results."
}], "Text",
 CellID->1410553583,ExpressionUUID->"7916e742-97ad-4507-a6b1-6640a3c45e97"],

Cell["Load the package.", "MathCaption",
 CellID->428702736,ExpressionUUID->"82ec763d-192d-4cb3-b27b-5317584cf06b"],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->399248267,ExpressionUUID->"0d02c8e3-02f4-48c6-aa85-9a2fa76d1485"],

Cell[TextData[{
 "Set options for ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["DensityMatrix"]], 
    "paclet:AtomicDensityMatrix/ref/DensityMatrix", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "00134922-a7cd-4160-8eb5-c828089197a7"],
 " and plotting function."
}], "MathCaption",
 CellID->1679141539,ExpressionUUID->"18c2d9a1-95ff-4a45-97ca-178878631f19"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"DensityMatrix", ",", 
    RowBox[{"TimeDependence", "\[Rule]", "False"}], ",", 
    RowBox[{"ComplexExpandVariables", "\[Rule]", "Subscript"}]}], "]"}], 
  ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1063678041,ExpressionUUID->"607207b0-d601-4d6b-9fbb-c74887d9cd9b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLinePlot", ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "Medium"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ";"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1867164128,ExpressionUUID->"900dcc2a-8834-4673-a24d-a17819c72851"],

Cell[TextData[{
 "First we set up the atomic system. We could enter the various atomic-state \
parameters by hand, but in this case it is convenient to pull them from a \
database. In this example we will focus on transitions originating from the \
ground-state ",
 Cell[BoxData[
  FormBox[
   RowBox[{"F", "=", "2"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "f2fa832b-d15f-460d-bd1a-76158e49008d"],
 " hyperfine sublevel, and so we truncate the system by deleting the \
ground-state ",
 Cell[BoxData[
  FormBox[
   RowBox[{"F", "=", "1"}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "51c51da2-776b-43bb-8d56-4bc89fc83d04"],
 " sublevels. "
}], "Text",
 CellID->594387048,ExpressionUUID->"a79d4713-a18b-4599-bb67-6822e2335802"],

Cell[TextData[{
 "Choose a transition. ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["AtomicTransition"]], 
    "paclet:AtomicDensityMatrix/ref/AtomicTransition", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "3517de0d-f595-40ec-825b-48c50c7066f5"],
 " just returns the names of the states associated with the given transition, \
which we can use to find the associated data in the ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["AtomicData"]], "paclet:AtomicDensityMatrix/ref/AtomicData", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "d4f9077b-f2bf-4dcb-9937-e73be5cec220"],
 " database."
}], "MathCaption",
 CellID->1890496939,ExpressionUUID->"6e8c8086-33ef-4d93-bdcc-421a80a784e9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"gstate", ",", "estate"}], "}"}], "=", 
  RowBox[{"AtomicTransition", "[", 
   RowBox[{"\"\<Rb87\>\"", ",", "\"\<D1\>\""}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->255182439,ExpressionUUID->"8c85b7e1-30be-4e42-85e8-f368f1863149"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"Rb\"\>", ",", "87", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Kr\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"5", ",", "\<\"s\"\>"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "\<\"S\"\>", ",", 
       FractionBox["1", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"Rb\"\>", ",", "87", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Kr\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"5", ",", "\<\"p\"\>"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "\<\"P\"\>", ",", 
       FractionBox["1", "2"]}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellLabel->"Out[4]=",
 CellID->1395651866,ExpressionUUID->"f530a804-23ac-42a7-8607-c76b687b4310"]
}, Open  ]],

Cell["\<\
Get the list of quantum numbers and other information that we will use to set \
up the atomic system. We could also include the additional numerical atomic \
parameters in this list, but it can be more convenient to substitute their \
values in later.\
\>", "MathCaption",
 CellID->331090632,ExpressionUUID->"1d4ee46d-f9e6-42b6-8aa4-75a23d610925"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"gQuantumNumbers", ",", "eQuantumNumbers"}], "}"}], "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicData", "[", 
     RowBox[{"gstate", ",", 
      RowBox[{"{", 
       RowBox[{
       "J", ",", "L", ",", "S", ",", "NuclearSpin", ",", "NaturalWidth", ",", 
        "Energy"}], "}"}]}], "]"}], ",", 
    RowBox[{"AtomicData", "[", 
     RowBox[{"estate", ",", 
      RowBox[{"{", 
       RowBox[{"J", ",", "L", ",", "S", ",", "NuclearSpin"}], "}"}]}], 
     "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->2064101732,ExpressionUUID->"2c22c9fa-f92a-4ba0-95f9-1f40eadb6f80"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["3", "2"]}]}], "}"}]}], "}"}]], "Output",
 CellLabel->"Out[5]=",
 CellID->81516297,ExpressionUUID->"13a91ec8-c2c7-4db4-9487-53d9748e68a0"]
}, Open  ]],

Cell[TextData[{
 "Create the list of sublevels in the atomic system. We specify ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    TemplateBox[{
      Cell[
       TextData["BranchingRatio"]], 
      "paclet:AtomicDensityMatrix/ref/BranchingRatio", 
      "AtomicDensityMatrix Package Symbol"},
     "PackageLink",
     BaseStyle->"InlineFormula"], "[", "1", "]"}], "\[Rule]", "1"}]], 
  "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "0ff44a9f-bc10-4af1-b954-d6684f66eb94"],
 ", which means that the upper ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["J", "\[Prime]",
    MultilineFunction->None], TraditionalForm]], "InlineMath",ExpressionUUID->
  "65147544-a309-4233-8a48-5f24e3a411d8"],
 StyleBox[" state decays with 100% probability to the lower ",
  Deletable->True],
 Cell[BoxData[
  FormBox["J", TraditionalForm]], "InlineMath",ExpressionUUID->
  "36648b9c-05e7-455f-945a-90f88bdd9d32"],
 StyleBox[" state. The individual ",
  Deletable->True],
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["F", "\[Prime]",
     MultilineFunction->None], "\[Rule]", "F"}], TraditionalForm]], 
  "InlineMath",ExpressionUUID->"a699edbe-6e5c-413e-93ff-1b1107d4e409"],
 StyleBox[" branching ratios are calculated automatically.",
  Deletable->True]
}], "MathCaption",
 CellID->270820281,ExpressionUUID->"bf5fffca-30b7-45c1-b891-89be1db9c915"],

Cell[BoxData[
 RowBox[{
  RowBox[{"system", "=", 
   RowBox[{"Sublevels", "@", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"AtomicState", "[", 
       RowBox[{"1", ",", "gQuantumNumbers"}], "]"}], ",", 
      RowBox[{"AtomicState", "[", 
       RowBox[{"2", ",", 
        RowBox[{"Append", "[", 
         RowBox[{"eQuantumNumbers", ",", 
          RowBox[{
           RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}]}], 
         "]"}]}], "]"}]}], "}"}]}]}], ";"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->314100305,ExpressionUUID->"914561f9-23a7-4985-902b-55e7d623ea2a"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["DeleteStates"]], "paclet:AtomicDensityMatrix/ref/DeleteStates",
     "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "df5e2977-82ad-44bd-9ab2-027c5e252717"],
 " removes the states satisfying the given criterion from the list of atomic \
states."
}], "MathCaption",
 CellID->927847299,ExpressionUUID->"4a040ff3-5989-4a64-a872-bd5a519c899c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Style", "[", 
  RowBox[{
   RowBox[{"TableForm", "[", 
    RowBox[{"system", "=", 
     RowBox[{"DeleteStates", "[", 
      RowBox[{"system", ",", 
       RowBox[{
        RowBox[{"StateLabel", "\[Equal]", "1"}], "&&", 
        RowBox[{"F", "\[Equal]", "1"}]}]}], "]"}]}], "]"}], ",", "Small"}], 
  "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->1471499099,ExpressionUUID->"29151052-e963-4d01-add2-76a578f77560"],

Cell[BoxData[
 StyleBox[
  TagBox[
   TagBox[GridBox[{
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"1", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "0"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
         RowBox[{"Energy", "\[Rule]", "0"}], ",", 
         RowBox[{"F", "\[Rule]", "2"}], ",", 
         RowBox[{"M", "\[Rule]", "2"}]}], "]"}]},
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"1", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "0"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
         RowBox[{"Energy", "\[Rule]", "0"}], ",", 
         RowBox[{"F", "\[Rule]", "2"}], ",", 
         RowBox[{"M", "\[Rule]", "1"}]}], "]"}]},
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"1", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "0"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
         RowBox[{"Energy", "\[Rule]", "0"}], ",", 
         RowBox[{"F", "\[Rule]", "2"}], ",", 
         RowBox[{"M", "\[Rule]", "0"}]}], "]"}]},
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"1", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "0"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
         RowBox[{"Energy", "\[Rule]", "0"}], ",", 
         RowBox[{"F", "\[Rule]", "2"}], ",", 
         RowBox[{"M", "\[Rule]", 
          RowBox[{"-", "1"}]}]}], "]"}]},
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"1", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "0"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
         RowBox[{"Energy", "\[Rule]", "0"}], ",", 
         RowBox[{"F", "\[Rule]", "2"}], ",", 
         RowBox[{"M", "\[Rule]", 
          RowBox[{"-", "2"}]}]}], "]"}]},
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"2", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "1"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{
          RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
         RowBox[{"F", "\[Rule]", "2"}], ",", 
         RowBox[{"M", "\[Rule]", "2"}]}], "]"}]},
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"2", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "1"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{
          RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
         RowBox[{"F", "\[Rule]", "2"}], ",", 
         RowBox[{"M", "\[Rule]", "1"}]}], "]"}]},
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"2", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "1"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{
          RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
         RowBox[{"F", "\[Rule]", "2"}], ",", 
         RowBox[{"M", "\[Rule]", "0"}]}], "]"}]},
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"2", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "1"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{
          RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
         RowBox[{"F", "\[Rule]", "2"}], ",", 
         RowBox[{"M", "\[Rule]", 
          RowBox[{"-", "1"}]}]}], "]"}]},
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"2", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "1"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{
          RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
         RowBox[{"F", "\[Rule]", "2"}], ",", 
         RowBox[{"M", "\[Rule]", 
          RowBox[{"-", "2"}]}]}], "]"}]},
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"2", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "1"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{
          RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
         RowBox[{"F", "\[Rule]", "1"}], ",", 
         RowBox[{"M", "\[Rule]", "1"}]}], "]"}]},
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"2", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "1"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{
          RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
         RowBox[{"F", "\[Rule]", "1"}], ",", 
         RowBox[{"M", "\[Rule]", "0"}]}], "]"}]},
      {
       RowBox[{"AtomicState", "[", 
        RowBox[{"2", ",", 
         RowBox[{"J", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"L", "\[Rule]", "1"}], ",", 
         RowBox[{"S", "\[Rule]", 
          FractionBox["1", "2"]}], ",", 
         RowBox[{"NuclearSpin", "\[Rule]", 
          FractionBox["3", "2"]}], ",", 
         RowBox[{
          RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
         RowBox[{"F", "\[Rule]", "1"}], ",", 
         RowBox[{"M", "\[Rule]", 
          RowBox[{"-", "1"}]}]}], "]"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column],
   Function[BoxForm`e$, 
    TableForm[BoxForm`e$]]],
  StripOnInput->False,
  FontSize->Small]], "Output",
 CellLabel->"Out[7]=",
 CellID->1117540021,ExpressionUUID->"aa063981-5f6b-4e8f-954a-b06eab5d501e"]
}, Open  ]],

Cell["\<\
Here are the remaining numerical parameters for the atomic system that we \
will substitute in later.\
\>", "MathCaption",
 CellID->262224642,ExpressionUUID->"10dc5659-be69-4ab5-9cb9-167aa640746a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"atomicData", "=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"AtomicData", "[", 
     RowBox[{"gstate", ",", 
      RowBox[{"StateLabel", "\[Rule]", "1"}]}], "]"}], ",", 
    RowBox[{"AtomicData", "[", 
     RowBox[{"estate", ",", 
      RowBox[{"StateLabel", "\[Rule]", "2"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"c", "\[Rule]", "SpeedOfLight"}], ",", 
      RowBox[{"\[HBar]", "\[Rule]", "PlanckConstantReduced"}], ",", 
      RowBox[{"\[Epsilon]0", "\[Rule]", "VacuumPermittivity"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[8]:=",
 CellID->708150996,ExpressionUUID->"9935844c-02a8-4035-bb8d-cf8c527f3adc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"ElementName", "[", "1", "]"}], "\[Rule]", "\<\"Rubidium\"\>"}], 
   ",", 
   RowBox[{
    RowBox[{"ElementSymbol", "[", "1", "]"}], "\[Rule]", "\<\"Rb\"\>"}], ",", 
   
   RowBox[{
    RowBox[{"AtomicNumber", "[", "1", "]"}], "\[Rule]", "37"}], ",", 
   RowBox[{
    RowBox[{"AtomicWeight", "[", "1", "]"}], "\[Rule]", "87"}], ",", 
   RowBox[{
    RowBox[{"Abundance", "[", "1", "]"}], "\[Rule]", "0.27835`"}], ",", 
   RowBox[{
    RowBox[{"NuclearSpin", "[", "1", "]"}], "\[Rule]", 
    FractionBox["3", "2"]}], ",", 
   RowBox[{
    RowBox[{"J", "[", "1", "]"}], "\[Rule]", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{"L", "[", "1", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"S", "[", "1", "]"}], "\[Rule]", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{"NaturalWidth", "[", "1", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"Energy", "[", "1", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"HyperfineA", "[", "1", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{"21471.788680034824`", " ", "Mega"}], "Second"]}], ",", 
   RowBox[{
    RowBox[{"HyperfineB", "[", "1", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"Parity", "[", "1", "]"}], "\[Rule]", "Even"}], ",", 
   RowBox[{
    RowBox[{"Wavenumber", "[", "1", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"Lifetime", "[", "1", "]"}], "\[Rule]", 
    RowBox[{"Second", " ", "\[Infinity]"}]}], ",", 
   RowBox[{
    RowBox[{"ElementName", "[", "2", "]"}], "\[Rule]", "\<\"Rubidium\"\>"}], 
   ",", 
   RowBox[{
    RowBox[{"ElementSymbol", "[", "2", "]"}], "\[Rule]", "\<\"Rb\"\>"}], ",", 
   
   RowBox[{
    RowBox[{"AtomicNumber", "[", "2", "]"}], "\[Rule]", "37"}], ",", 
   RowBox[{
    RowBox[{"AtomicWeight", "[", "2", "]"}], "\[Rule]", "87"}], ",", 
   RowBox[{
    RowBox[{"Abundance", "[", "2", "]"}], "\[Rule]", "0.27835`"}], ",", 
   RowBox[{
    RowBox[{"NuclearSpin", "[", "2", "]"}], "\[Rule]", 
    FractionBox["3", "2"]}], ",", 
   RowBox[{
    RowBox[{"J", "[", "2", "]"}], "\[Rule]", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{"L", "[", "2", "]"}], "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"S", "[", "2", "]"}], "\[Rule]", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{"NaturalWidth", "[", "2", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{"36.12847284945265`", " ", "Mega"}], "Second"]}], ",", 
   RowBox[{
    RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{"2.36943607313472`*^9", " ", "Mega"}], "Second"]}], ",", 
   RowBox[{
    RowBox[{"HyperfineA", "[", "2", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{"2558.7643844958147`", " ", "Mega"}], "Second"]}], ",", 
   RowBox[{
    RowBox[{"HyperfineB", "[", "2", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"Parity", "[", "2", "]"}], "\[Rule]", "Odd"}], ",", 
   RowBox[{
    RowBox[{"Wavenumber", "[", "2", "]"}], "\[Rule]", 
    FractionBox["12578.95098147`", "Centimeter"]}], ",", 
   RowBox[{
    RowBox[{"Lifetime", "[", "2", "]"}], "\[Rule]", 
    RowBox[{"27.679`", " ", "Nano", " ", "Second"}]}], ",", 
   RowBox[{"c", "\[Rule]", 
    FractionBox[
     RowBox[{"299792458", " ", "Meter"}], "Second"]}], ",", 
   RowBox[{"\[HBar]", "\[Rule]", 
    RowBox[{"1.054571628251774`*^-34", " ", "Joule", " ", "Second"}]}], ",", 
   RowBox[{"\[Epsilon]0", "\[Rule]", 
    FractionBox[
     RowBox[{"625000", " ", "Ampere", " ", "Second"}], 
     RowBox[{
     "22468879468420441", " ", "Meter", " ", "\[Pi]", " ", "Volt"}]]}]}], 
  "}"}]], "Output",
 CellLabel->"Out[8]=",
 CellID->1846321168,ExpressionUUID->"78035c6e-0e56-4c91-aa72-5deccb4b9bfb"]
}, Open  ]],

Cell["\<\
Now we form the Hamiltonian, relaxation and repopulation matrices, and \
Liouville equation assuming the steady-state condition.\
\>", "Text",
 CellID->2130696078,ExpressionUUID->"86ba6976-d537-4eb3-957f-eea94289189a"],

Cell[TextData[{
 "Form the Hamiltonian assuming an ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]], "InlineMath",ExpressionUUID->
  "3692db01-b45f-438c-a45e-246afd91d272"],
 "-polarized optical field with frequency \[Omega] and reduced Rabi frequency \
",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[CapitalOmega]", "R"], TraditionalForm]], "InlineMath",
  ExpressionUUID->"573384d5-8d41-4d4b-a158-02c9b3b27d70"],
 ", and a ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath",ExpressionUUID->
  "9e3cb25e-ff01-47e6-b178-9b257588a012"],
 "-directed magnetic field with nominal Larmor frequency ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[CapitalOmega]", "L"], TraditionalForm]], "InlineMath",
  ExpressionUUID->"32e5b6b7-c636-464f-bfe1-070186bfe29a"],
 "."
}], "MathCaption",
 CellID->1277669421,ExpressionUUID->"c6526a5f-fbfd-4c14-b11c-dc7984a16a47"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{"Hamiltonian", "[", 
     RowBox[{"system", ",", 
      RowBox[{"ElectricField", "\[Rule]", 
       RowBox[{"OpticalField", "[", 
        RowBox[{"\[Omega]", ",", 
         RowBox[{"\[CapitalOmega]R", "/", 
          RowBox[{"ReducedME", "[", 
           RowBox[{"1", ",", 
            RowBox[{"{", 
             RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], 
        "]"}]}], ",", 
      RowBox[{"MagneticField", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"\[CapitalOmega]L", "/", "BohrMagneton"}]}], "}"}]}]}], 
     "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->1209378368,ExpressionUUID->"b33c2863-18c7-4f50-8dd5-e7d4cdc8f907"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"\[CapitalOmega]L", "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "1", "]"}]}], "4"]}], "0", "0", "0", "0", 
      "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", 
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]], "0", "0"},
     {"0", 
      RowBox[{
       FractionBox["\[CapitalOmega]L", "2"], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "1", "]"}]}], "4"]}], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "0", "0", "0", 
      RowBox[{
       FractionBox["1", "4"], " ", "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "0"},
     {"0", "0", 
      FractionBox[
       RowBox[{"3", " ", 
        RowBox[{"HyperfineA", "[", "1", "]"}]}], "4"], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        RowBox[{"4", " ", 
         SqrtBox["3"]}]]}], "0", 
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
       RowBox[{"4", " ", 
        SqrtBox["3"]}]]},
     {"0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "2"]}], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "1", "]"}]}], "4"]}], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "0"},
     {"0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]L"}], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "1", "]"}]}], "4"]}], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", 
      RowBox[{
       FractionBox["\[CapitalOmega]L", "3"], "+", 
       RowBox[{"Energy", "[", "2", "]"}], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0", "0", "0", "0", 
      "0", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "0", "0", "0", 
      RowBox[{
       FractionBox["\[CapitalOmega]L", "6"], "+", 
       RowBox[{"Energy", "[", "2", "]"}], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]L", 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]], "0", "0"},
     {"0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "0", "0", "0", 
      RowBox[{
       RowBox[{"Energy", "[", "2", "]"}], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]L", "3"], "0"},
     {"0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "6"]}], "+", 
       RowBox[{"Energy", "[", "2", "]"}], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]L", 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]]},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "3"]}], "+", 
       RowBox[{"Energy", "[", "2", "]"}], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0", "0", "0"},
     {
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        RowBox[{"4", " ", 
         SqrtBox["3"]}]]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]L", 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "6"]}], "+", 
       RowBox[{"Energy", "[", "2", "]"}], "-", 
       FractionBox[
        RowBox[{"5", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0", "0"},
     {"0", 
      RowBox[{
       FractionBox["1", "4"], " ", "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]L", "3"], "0", "0", "0", 
      RowBox[{
       RowBox[{"Energy", "[", "2", "]"}], "-", 
       FractionBox[
        RowBox[{"5", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0"},
     {"0", "0", 
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
       RowBox[{"4", " ", 
        SqrtBox["3"]}]], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]L", 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]], "0", "0", "0", 
      RowBox[{
       FractionBox["\[CapitalOmega]L", "6"], "+", 
       RowBox[{"Energy", "[", "2", "]"}], "-", 
       FractionBox[
        RowBox[{"5", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[9]//MatrixForm=",
 CellID->9439803,ExpressionUUID->"95bb933b-58f2-40f4-88f8-ba5ebb6ccdfd"]
}, Open  ]],

Cell["\<\
Draw the level diagram for the truncated system, showing the optical and \
magnetic-field interactions.\
\>", "MathCaption",
 CellID->460749553,ExpressionUUID->"683dda77-0406-48a4-81d7-ac2df9b64512"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"system", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"h", "/.", 
      RowBox[{
       RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", "3"}]}], "/.", 
     "atomicData"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Mega", "\[Rule]", " ", 
       RowBox[{"10", "^", 
        RowBox[{"-", "4"}]}]}], ",", 
      RowBox[{"Second", "\[Rule]", "1"}], ",", 
      RowBox[{"\[CapitalOmega]L", "\[Rule]", ".1"}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->1893193157,ExpressionUUID->"417f1157-d400-4629-8733-c0e84b786dd5"],

Cell[BoxData[
 GraphicsBox[{{{{{}, 
      LineBox[{{1.6, 1.710384151002612}, {2.4, 1.710384151002612}}]}, {{}, 
      LineBox[{{0.6, 1.660384151002612}, {1.4, 1.660384151002612}}]}, {{}, 
      LineBox[{{-0.4, 1.610384151002612}, {0.4, 1.610384151002612}}]}, {{}, 
      LineBox[{{-1.4, 1.560384151002612}, {-0.6, 1.560384151002612}}]}, {{}, 
      LineBox[{{-2.4, 1.510384151002612}, {-1.6, 1.510384151002612}}]}, {{}, 
      LineBox[{{1.6, 3.225240662170519}, {2.4, 3.225240662170519}}]}, {{}, 
      LineBox[{{0.6, 3.2085739955038526`}, {1.4, 3.2085739955038526`}}]}, {{},
       LineBox[{{-0.4, 3.191907328837186}, {0.4, 3.191907328837186}}]}, {{}, 
      LineBox[{{-1.4, 3.1752406621705194`}, {-0.6, 
       3.1752406621705194`}}]}, {{}, 
      LineBox[{{-2.4, 3.1585739955038528`}, {-1.6, 
       3.1585739955038528`}}]}, {{}, 
      LineBox[{{0.6, 2.6634877852713563`}, {1.4, 2.6634877852713563`}}]}, {{},
       LineBox[{{-0.4, 2.680154451938023}, {0.4, 2.680154451938023}}]}, {{}, 
      LineBox[{{-1.4, 2.6968211186046895`}, {-0.6, 
       2.6968211186046895`}}]}}, {}, {}, 
    {EdgeForm[Hue[0.61, 0.54, 0.56]], FaceForm[None]}, 
    {RGBColor[0.9, 0.01, 0.01], 
     Arrowheads[{-0.03333333333333334, 0.03333333333333334}], 
     ArrowBox[{{-1., 2.6968211186046895`}, {-1., 3.1752406621705194`}}], 
     ArrowBox[{{0., 2.680154451938023}, {0., 3.191907328837186}}], 
     ArrowBox[{{1., 2.6634877852713563`}, {1., 3.2085739955038526`}}], 
     ArrowBox[{{0.16000000000000003`, 1.610384151002612}, {0.9199999999999999,
       2.6634877852713563`}}], 
     ArrowBox[{{-0.84, 1.560384151002612}, {-0.08000000000000002, 
      2.680154451938023}}], 
     ArrowBox[{{-1.8399999999999999`, 1.510384151002612}, {-1.08, 
      2.6968211186046895`}}], 
     ArrowBox[{{-1.92, 1.510384151002612}, {-1.08, 3.1752406621705194`}}], 
     ArrowBox[{{-0.9199999999999999, 
      1.560384151002612}, {-0.08000000000000002, 3.191907328837186}}], 
     ArrowBox[{{0.08000000000000002, 1.610384151002612}, {0.9199999999999999, 
      3.2085739955038526`}}], 
     ArrowBox[{{1.08, 1.660384151002612}, {1.92, 3.225240662170519}}], 
     ArrowBox[{{1.8399999999999999`, 1.710384151002612}, {1.08, 
      2.6634877852713563`}}], 
     ArrowBox[{{0.84, 1.660384151002612}, {0.08000000000000002, 
      2.680154451938023}}], 
     ArrowBox[{{-0.16000000000000003`, 
      1.610384151002612}, {-0.9199999999999999, 2.6968211186046895`}}], 
     ArrowBox[{{-1.08, 1.560384151002612}, {-1.92, 3.1585739955038528`}}], 
     ArrowBox[{{-0.08000000000000002, 
      1.610384151002612}, {-0.9199999999999999, 3.1752406621705194`}}], 
     ArrowBox[{{0.9199999999999999, 1.660384151002612}, {0.08000000000000002, 
      3.191907328837186}}], 
     ArrowBox[{{1.92, 1.710384151002612}, {1.08, 
      3.2085739955038526`}}]}}, {{{{}, {}}, {{}, {}}, {{}, {}}, {{}, {}}, \
{{}, {}}, {{}, {}}, {{}, {}}, {{}, {}}, {{}, {}}, {{}, {}}, {{}, {}}, {{}, \
{}}, {{}, {}}}, {}, {}, 
    {EdgeForm[Hue[0.61, 0.54, 0.56]], FaceForm[None]}, 
    {RGBColor[0.9, 0.01, 0.01], 
     Arrowheads[{-0.03333333333333334, 
      0.03333333333333334}], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}}}},
  ImageSize->{{350}, {100}}]], "Output",
 CellLabel->"Out[10]=",
 CellID->536238841,ExpressionUUID->"0bbb1f38-1529-4554-9b67-2ddbf0078ab4"]
}, Open  ]],

Cell[TextData[{
 "Apply the rotating-wave approximation to the Hamiltonian, and write the \
optical frequency in terms of the detuning ",
 Cell[BoxData[
  FormBox["\[CapitalDelta]", TraditionalForm]], "InlineMath",ExpressionUUID->
  "74c730fd-82d7-4a71-83b4-a26f46c77817"],
 "."
}], "MathCaption",
 CellID->1348929297,ExpressionUUID->"436b1c98-f14f-4ba1-ba3d-f55187e4ba8f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"hrwa", "=", 
    RowBox[{
     RowBox[{"RotatingWaveApproximation", "[", 
      RowBox[{"system", ",", "h", ",", "\[Omega]"}], "]"}], "/.", 
     RowBox[{"{", 
      RowBox[{"\[Omega]", "\[Rule]", 
       RowBox[{
        RowBox[{"Energy", "[", "2", "]"}], "+", "\[CapitalDelta]"}]}], 
      "}"}]}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->858044413,ExpressionUUID->"4cb31068-f48c-496e-b03f-f257507b7059"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"\[CapitalOmega]L", "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "1", "]"}]}], "4"]}], "0", "0", "0", "0", 
      "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"4", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]R", 
       RowBox[{"4", " ", 
        SqrtBox["2"]}]], "0", "0"},
     {"0", 
      RowBox[{
       FractionBox["\[CapitalOmega]L", "2"], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "1", "]"}]}], "4"]}], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"4", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "8"]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]R", "8"], "0"},
     {"0", "0", 
      FractionBox[
       RowBox[{"3", " ", 
        RowBox[{"HyperfineA", "[", "1", "]"}]}], "4"], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "8"]}], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "8"]}], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"8", " ", 
         SqrtBox["3"]}]]}], "0", 
      FractionBox["\[CapitalOmega]R", 
       RowBox[{"8", " ", 
        SqrtBox["3"]}]]},
     {"0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "2"]}], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "1", "]"}]}], "4"]}], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "8"]}], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"4", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "8"]}], "0"},
     {"0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]L"}], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "1", "]"}]}], "4"]}], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"4", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"4", " ", 
         SqrtBox["2"]}]]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"4", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalDelta]"}], "+", 
       FractionBox["\[CapitalOmega]L", "3"], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0", "0", "0", "0", 
      "0", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"4", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "8"]}], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalDelta]"}], "+", 
       FractionBox["\[CapitalOmega]L", "6"], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]L", 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]], "0", "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "8"]}], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "8"]}], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalDelta]"}], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]L", "3"], "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "8"]}], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"4", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalDelta]"}], "-", 
       FractionBox["\[CapitalOmega]L", "6"], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]L", 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]]},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"4", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalDelta]"}], "-", 
       FractionBox["\[CapitalOmega]L", "3"], "+", 
       FractionBox[
        RowBox[{"3", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0", "0", "0"},
     {
      FractionBox["\[CapitalOmega]R", 
       RowBox[{"4", " ", 
        SqrtBox["2"]}]], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"8", " ", 
         SqrtBox["3"]}]]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]L", 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalDelta]"}], "-", 
       FractionBox["\[CapitalOmega]L", "6"], "-", 
       FractionBox[
        RowBox[{"5", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0", "0"},
     {"0", 
      FractionBox["\[CapitalOmega]R", "8"], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "8"]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]L", "3"], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalDelta]"}], "-", 
       FractionBox[
        RowBox[{"5", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}], "0"},
     {"0", "0", 
      FractionBox["\[CapitalOmega]R", 
       RowBox[{"8", " ", 
        SqrtBox["3"]}]], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"4", " ", 
         SqrtBox["2"]}]]}], "0", "0", "0", 
      FractionBox["\[CapitalOmega]L", 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]], "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalDelta]"}], "+", 
       FractionBox["\[CapitalOmega]L", "6"], "-", 
       FractionBox[
        RowBox[{"5", " ", 
         RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[11]//MatrixForm=",
 CellID->1190252317,ExpressionUUID->"1e6fe180-9f2d-441c-9477-a6dd38aa3e80"]
}, Open  ]],

Cell["\<\
Create the matrix describing relaxation due to spontaneous decay and atomic \
transit.\
\>", "MathCaption",
 CellID->1645761088,ExpressionUUID->"831b6345-1daf-4947-8efc-cc2d84b8ae46"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"relax", "=", 
   RowBox[{
    RowBox[{"IntrinsicRelaxation", "[", "system", "]"}], "+", 
    RowBox[{"TransitRelaxation", "[", 
     RowBox[{"system", ",", "\[Gamma]"}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[12]:=",
 CellID->460896029,ExpressionUUID->"3af42477-781f-48ca-8151-18dc0e7e07be"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"\[Gamma]", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0"},
     {"0", "\[Gamma]", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0"},
     {"0", "0", "\[Gamma]", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0"},
     {"0", "0", "0", "\[Gamma]", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0"},
     {"0", "0", "0", "0", "\[Gamma]", "0", "0", "0", "0", "0", "0", "0", 
      "0"},
     {"0", "0", "0", "0", "0", 
      RowBox[{"\[Gamma]", "+", 
       RowBox[{"NaturalWidth", "[", "2", "]"}]}], "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{"\[Gamma]", "+", 
       RowBox[{"NaturalWidth", "[", "2", "]"}]}], "0", "0", "0", "0", "0", 
      "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"\[Gamma]", "+", 
       RowBox[{"NaturalWidth", "[", "2", "]"}]}], "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"\[Gamma]", "+", 
       RowBox[{"NaturalWidth", "[", "2", "]"}]}], "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"\[Gamma]", "+", 
       RowBox[{"NaturalWidth", "[", "2", "]"}]}], "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"\[Gamma]", "+", 
       RowBox[{"NaturalWidth", "[", "2", "]"}]}], "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"\[Gamma]", "+", 
       RowBox[{"NaturalWidth", "[", "2", "]"}]}], "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"\[Gamma]", "+", 
       RowBox[{"NaturalWidth", "[", "2", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[12]//MatrixForm=",
 CellID->1557636288,ExpressionUUID->"dd1d18d5-54c1-4d96-b87b-a5396448fec2"]
}, Open  ]],

Cell["\<\
Create the matrix describing repopulation due to spontaneous decay and atomic \
transit.\
\>", "MathCaption",
 CellID->793381933,ExpressionUUID->"f293e617-ce64-48e0-ba92-d8ce478ad6ee"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"repop", "=", 
   RowBox[{
    RowBox[{"OpticalRepopulation", "[", "system", "]"}], "+", 
    RowBox[{"TransitRepopulation", "[", 
     RowBox[{"system", ",", "\[Gamma]"}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->469501353,ExpressionUUID->"f9bbdd32-4eef-4f39-8d30-3c05f4658c17"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["\[Gamma]", "8"], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "3"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]]}]}], 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "+", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], ")"}]}]}], 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}]}]]}], ")"}]}], "-", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "3"]}], " ", 
       RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[ImaginaryI]", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", 
             RowBox[{"-", "2"}]}], "}"}]}]]}], ")"}]}], "0", "0", "0", "0", 
      "0", "0", "0", "0"},
     {
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "+", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], ")"}]}]}], 
      RowBox[{
       FractionBox["\[Gamma]", "8"], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "12"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]]}]}], 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"4", " ", 
         SqrtBox["3"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", 
                RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "-", 
       RowBox[{
        FractionBox["1", "12"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "6"]}], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}]}]]}], ")"}]}], "+", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}]}], "0", "0", "0", "0",
       "0", "0", "0", "0"},
     {
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"4", " ", 
         SqrtBox["3"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       FractionBox["\[Gamma]", "8"], "+", 
       RowBox[{
        FractionBox["1", "12"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "3"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "12"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}]}], 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], ")"}]}], 
        RowBox[{"4", " ", 
         SqrtBox["3"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", 
                RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], ")"}]}]}], 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", "0", "0", "0", "0", "0"},
     {
      RowBox[{
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}]}]]}], ")"}]}], "-", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}]}], 
      RowBox[{
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", 
                RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "-", 
       RowBox[{
        FractionBox["1", "12"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], ")"}]}], 
        RowBox[{"4", " ", 
         SqrtBox["3"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", 
                RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], ")"}]}]}], 
      RowBox[{
       FractionBox["\[Gamma]", "8"], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "2"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "12"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}]}], 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]], "+", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}]}]]}], ")"}]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", "0", "0", "0", "0", "0"},
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "3"]}], " ", 
       RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", 
             RowBox[{"-", "2"}]}], "}"}]}]]}], ")"}]}], 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "6"]}], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}]}]]}], ")"}]}], "+", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}]}], 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]], "+", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Im", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}]}]]}], ")"}]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            SubscriptBox["\[Rho]", 
             RowBox[{"Im", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2", ",", 
                RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], ")"}]}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       FractionBox["\[Gamma]", "8"], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "3"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "2"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]]}]}], "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[13]//MatrixForm=",
 CellID->1367435486,ExpressionUUID->"36f70ff3-565b-4f57-a9c3-3987c7d46e91"]
}, Open  ]],

Cell["\<\
Form the Liouville equation for the steady-state density matrix.\
\>", "MathCaption",
 CellID->1283804320,ExpressionUUID->"96861be4-63ec-441d-a359-8acee7f36a34"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "[", 
  RowBox[{
   RowBox[{"eqs", "=", 
    RowBox[{"Flatten", "@", 
     RowBox[{"LiouvilleEquation", "[", 
      RowBox[{"system", ",", "hrwa", ",", "relax", ",", "repop"}], "]"}]}]}], 
   ",", "15"}], "]"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->1081996554,ExpressionUUID->"3f945e9e-1b9b-4175-851b-fb28717e5837"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"0", "\[Equal]", 
     RowBox[{
      FractionBox["\[Gamma]", "8"], "-", 
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]], "+", 
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], 
       RowBox[{"2", " ", 
        SqrtBox["6"]}]], "-", 
      RowBox[{"\[Gamma]", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}]}]]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
      RowBox[{
       FractionBox["1", "6"], " ", 
       RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
      RowBox[{
       FractionBox["1", "3"], " ", 
       RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]]}]}]}], ",", 
    RowBox[{"0", "\[Equal]", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Im", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], 
        RowBox[{"4", " ", 
         SqrtBox["2"]}]]}], "+", 
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], 
       RowBox[{"4", " ", 
        SqrtBox["6"]}]], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", "\[CapitalOmega]L", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "1"}], "}"}]}]]}], "-", 
      RowBox[{
       FractionBox["1", "8"], " ", "\[CapitalOmega]R", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
      RowBox[{
       FractionBox["1", "8"], " ", "\[CapitalOmega]R", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]]}], 
       RowBox[{"4", " ", 
        SqrtBox["6"]}]], "-", 
      RowBox[{"\[Gamma]", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], 
       RowBox[{"2", " ", 
        SqrtBox["6"]}]], "+", 
      RowBox[{
       FractionBox["1", "6"], " ", 
       RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}]}]}], ",", 
    RowBox[{"\[LeftSkeleton]", "165", "\[RightSkeleton]"}], ",", 
    RowBox[{"0", "\[Equal]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[Gamma]"}], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "-", 
      RowBox[{
       RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "-", 
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", 
            RowBox[{"-", "2"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], 
       RowBox[{"4", " ", 
        SqrtBox["2"]}]], "+", 
      RowBox[{
       FractionBox["1", "8"], " ", "\[CapitalOmega]R", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], 
       RowBox[{"8", " ", 
        SqrtBox["3"]}]], "-", 
      RowBox[{
       FractionBox["1", "8"], " ", "\[CapitalOmega]R", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
      RowBox[{
       FractionBox["1", "6"], " ", "\[CapitalOmega]L", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
      FractionBox[
       RowBox[{"\[CapitalOmega]L", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Re", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], 
       RowBox[{"2", " ", 
        SqrtBox["3"]}]], "-", 
      RowBox[{
       FractionBox["1", "3"], " ", "\[CapitalOmega]L", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}]}]}], ",", 
    RowBox[{"0", "\[Equal]", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Im", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", 
             RowBox[{"-", "2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]]}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]]}], "+", 
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]]}], 
       RowBox[{"4", " ", 
        SqrtBox["3"]}]], "+", 
      FractionBox[
       RowBox[{"\[CapitalOmega]L", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]]}], 
       SqrtBox["3"]], "-", 
      RowBox[{"\[Gamma]", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "-", 
      RowBox[{
       RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}]}]}]}], "}"}],
  Short[#, 15]& ]], "Output",
 CellLabel->"Out[14]//Short=",
 CellID->118223008,ExpressionUUID->"fee6f769-8513-4092-a971-8e03cf89967d"]
}, Open  ]],

Cell["The list of density-matrix variables.", "MathCaption",
 CellID->1175348008,ExpressionUUID->"4932046b-183a-4c79-b8ac-3d70b77805f9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vars", "=", 
  RowBox[{"DMVariables", "[", "system", "]"}]}]], "Input",
 CellLabel->"In[15]:=",
 CellID->1055891795,ExpressionUUID->"ac70f6e3-397f-48de-a0b9-76a38eb0a8e7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Im", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]], ",", 
   SubscriptBox["\[Rho]", 
    RowBox[{"Re", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]]}], "}"}]], "Output",
 CellLabel->"Out[15]=",
 CellID->551721981,ExpressionUUID->"39020b0f-3f81-4293-ba2f-bd9d4413b12b"]
}, Open  ]],

Cell["\<\
Now we find the changes in light polarization parameters in terms of the \
atomic density-matrix elements.\
\>", "Text",
 CellID->1380373434,ExpressionUUID->"a301a73a-69e5-4363-a18d-a995d2ebdf6a"],

Cell["\<\
The absorption, phase-shift, optical rotation, and change of ellipticity per \
unit path length and unit density. \
\>", "MathCaption",
 CellID->1386887899,ExpressionUUID->"eb2db6ce-3ce5-49b3-8727-a19a63c7914f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"observables", "=", 
  RowBox[{
   RowBox[{"Observables", "[", 
    RowBox[{"system", ",", 
     RowBox[{"Energy", "[", "2", "]"}], ",", 
     RowBox[{"\[CapitalOmega]R", "/", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], "]"}], "//",
    "Together"}]}]], "Input",
 CellLabel->"In[16]:=",
 CellID->1716023404,ExpressionUUID->"906786e1-0528-46fc-b486-90699f3935f8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{"2", " ", "\[CapitalOmega]R", " ", 
        SuperscriptBox[
         RowBox[{"Energy", "[", "2", "]"}], "2"]}]], 
      RowBox[{
       SqrtBox[
        FractionBox["3", "2"]], " ", "\[Pi]", " ", 
       RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          SqrtBox["3"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "-", 
         RowBox[{
          SqrtBox["2"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["2"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "-", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]]}], "-", 
         RowBox[{"2", " ", 
          SqrtBox["3"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}]}], ")"}]}]}], ",", 
     
     RowBox[{
      FractionBox["1", 
       RowBox[{"2", " ", "\[CapitalOmega]R", " ", 
        SuperscriptBox[
         RowBox[{"Energy", "[", "2", "]"}], "2"]}]], 
      RowBox[{
       SqrtBox[
        FractionBox["3", "2"]], " ", "\[Pi]", " ", 
       RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          SqrtBox["3"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "-", 
         RowBox[{
          SqrtBox["2"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["2"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "-", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]]}], "-", 
         RowBox[{"2", " ", 
          SqrtBox["3"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Re", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}]}], ")"}]}]}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", " ", "\[CapitalOmega]R", " ", 
         SuperscriptBox[
          RowBox[{"Energy", "[", "2", "]"}], "2"]}]], 
       RowBox[{
        SqrtBox[
         FractionBox["3", "2"]], " ", "\[Pi]", " ", 
        RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", 
           SqrtBox["3"], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          RowBox[{"2", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          RowBox[{
           SqrtBox["6"], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "-", 
          RowBox[{"2", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
          RowBox[{
           SqrtBox["6"], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
          RowBox[{
           SqrtBox["2"], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          RowBox[{
           SqrtBox["2"], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "-", 
          RowBox[{
           SqrtBox["6"], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", 
               RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
          RowBox[{
           SqrtBox["6"], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
          RowBox[{
           SqrtBox["6"], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "-", 
          RowBox[{
           SqrtBox["6"], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
          RowBox[{"2", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]]}], "+", 
          RowBox[{"2", " ", 
           SqrtBox["3"], " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "-", 
          RowBox[{"2", " ", 
           SubscriptBox["\[Rho]", 
            RowBox[{"Re", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}]}], ")"}]}]}]}], 
     ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"2", " ", "\[CapitalOmega]R", " ", 
        SuperscriptBox[
         RowBox[{"Energy", "[", "2", "]"}], "2"]}]], 
      RowBox[{
       SqrtBox[
        FractionBox["3", "2"]], " ", "\[Pi]", " ", 
       RowBox[{"NaturalWidth", "[", "2", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          SqrtBox["3"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "-", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["2"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["2"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "-", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "-", 
         RowBox[{
          SqrtBox["6"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]]}], "+", 
         RowBox[{"2", " ", 
          SqrtBox["3"], " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "-", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Rho]", 
           RowBox[{"Im", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}]}], ")"}]}]}]}], 
    "}"}]}], "}"}]], "Output",
 CellLabel->"Out[16]=",
 CellID->2104430568,ExpressionUUID->"48782e43-7d60-420d-8c78-e36a6ed26362"]
}, Open  ]],

Cell["\<\
Now we write the various input parameters in terms of experimentally relevant \
quantities.\
\>", "Text",
 CellID->1838084779,ExpressionUUID->"e555c4ec-d261-4755-b9af-c9d607abf0c1"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["ExpandDipoleRME"]], 
    "paclet:AtomicDensityMatrix/ref/ExpandDipoleRME", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "9d86de43-f676-40c9-9087-f76a743d3c6c"],
 " expresses the reduced dipole matrix element in terms of the natural width \
and energy of the transition."
}], "MathCaption",
 CellID->2119188793,ExpressionUUID->"e340acbd-80f6-4208-af19-504b8c5e28f0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dADM", "=", 
  RowBox[{"ExpandDipoleRME", "[", 
   RowBox[{"system", ",", 
    RowBox[{"ReducedME", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[17]:=",
 CellID->499971818,ExpressionUUID->"4a8b83b8-8f76-4b34-aa36-1af82cc04e6e"],

Cell[BoxData[
 RowBox[{
  SqrtBox[
   FractionBox["3", "2"]], " ", 
  SqrtBox[
   FractionBox[
    RowBox[{"NaturalWidth", "[", "2", "]"}], 
    SuperscriptBox[
     RowBox[{"Energy", "[", "2", "]"}], "3"]]]}]], "Output",
 CellLabel->"Out[17]=",
 CellID->108890286,ExpressionUUID->"1738bcb7-2ee3-4660-bbc4-a158f19f6ea8"]
}, Open  ]],

Cell[TextData[{
 "Convert ADM units to cgs by multiplying by ",
 Cell[BoxData[
  FormBox[
   SqrtBox[
    RowBox[{"\[HBar]", " ", 
     SuperscriptBox["c", "3"]}]], TraditionalForm]], "InlineMath",
  ExpressionUUID->"bebe2f99-c0a4-4e4a-b59b-1b00a200b54c"],
 ", and then to SI by multiplying by ",
 Cell[BoxData[
  FormBox[
   SqrtBox[
    RowBox[{"4", " ", "\[Pi]", " ", 
     SubscriptBox["\[Epsilon]", "0"]}]], TraditionalForm]], "InlineMath",
  ExpressionUUID->"6f3b5951-49dd-4696-88ad-833fdf1eb485"],
 "."
}], "MathCaption",
 CellID->1167398770,ExpressionUUID->"4bd165e2-4670-4725-961b-bab00eb30c09"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dSI", "=", 
  RowBox[{"Convert", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"dADM", 
      SqrtBox[
       RowBox[{"\[HBar]", " ", 
        SuperscriptBox["c", "3"]}]], 
      SqrtBox[
       RowBox[{"4", " ", "\[Pi]", " ", "\[Epsilon]0"}]]}], "/.", 
     "atomicData"}], ",", 
    RowBox[{"Coulomb", " ", "Meter"}]}], "]"}]}]], "Input",
 CellLabel->"In[18]:=",
 CellID->972219711,ExpressionUUID->"c4423be7-a776-4471-8ace-6e5f2dacfaf1"],

Cell[BoxData[
 RowBox[{"3.5888171420507105`*^-29", " ", "Coulomb", " ", "Meter"}]], "Output",\

 CellLabel->"Out[18]=",
 CellID->462969558,ExpressionUUID->"d7b3dd2e-8e24-4a65-84f4-6690df01d72f"]
}, Open  ]],

Cell[TextData[{
 "Write the optical electric field amplitude (in ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["V",
     FontSlant->"Plain"], "/", 
    StyleBox["m",
     FontSlant->"Plain"]}], TraditionalForm]], "InlineMath",ExpressionUUID->
  "e9a3b8e9-6e98-43a8-a214-a2a2630ad450"],
 ")  in terms of the light intensity (in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"mW", "/", 
    SuperscriptBox["cm", "2"]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"0423833f-e89d-4f47-8a16-171107ae985d"],
 ")."
}], "MathCaption",
 CellID->2139412245,ExpressionUUID->"04da1a9c-8d0e-42ae-be61-ea63359775ab"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eAmpSI", "=", 
  RowBox[{"Convert", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      SqrtBox[
       RowBox[{"2", "Int", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Milli", " ", 
           RowBox[{"Watt", "/", 
            SuperscriptBox["Centimeter", "2"]}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"c", " ", "\[Epsilon]0"}], ")"}]}]}]], "/.", "atomicData"}],
      "//", "N"}], ",", 
    RowBox[{"Volt", "/", "Meter"}]}], "]"}]}]], "Input",
 CellLabel->"In[19]:=",
 CellID->1349320912,ExpressionUUID->"79d163c5-ce61-4d25-999c-50ddb9dfa273"],

Cell[BoxData[
 FractionBox[
  RowBox[{"86.80210982018475`", " ", 
   SqrtBox["Int"], " ", "Volt"}], "Meter"]], "Output",
 CellLabel->"Out[19]=",
 CellID->796108225,ExpressionUUID->"5c8e5f7b-68b2-4baa-bb45-675bbe7a2fb8"]
}, Open  ]],

Cell["Write the Rabi frequency in terms of the light intensity.", \
"MathCaption",
 CellID->915261302,ExpressionUUID->"f6ad26a2-eaaa-46b5-bc56-82be8b185f76"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rabi", "=", 
  RowBox[{"\[CapitalOmega]R", "\[Rule]", 
   RowBox[{"Convert", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"eAmpSI", " ", 
       RowBox[{"dSI", "/", "\[HBar]"}]}], "/.", "atomicData"}], ",", 
     RowBox[{"1", "/", "Second"}]}], "]"}]}]}]], "Input",
 CellLabel->"In[20]:=",
 CellID->557915952,ExpressionUUID->"f7fb1ff7-3089-41e9-b729-1fb7e1e94bf4"],

Cell[BoxData[
 RowBox[{"\[CapitalOmega]R", "\[Rule]", 
  FractionBox[
   RowBox[{"2.9539662488859802`*^7", " ", 
    SqrtBox["Int"]}], "Second"]}]], "Output",
 CellLabel->"Out[20]=",
 CellID->1367816765,ExpressionUUID->"d510efd3-f503-4018-ac4e-e3b8e9413658"]
}, Open  ]],

Cell["\<\
Write the Larmor frequency in terms of the magnetic field in Gauss.\
\>", "MathCaption",
 CellID->1825228082,ExpressionUUID->"7e8216b6-a969-4227-a4c6-a68292042047"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"larmor", "=", 
  RowBox[{"\[CapitalOmega]L", "\[Rule]", 
   RowBox[{"Convert", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"b", " ", "Gauss", " ", 
       RowBox[{"BohrMagneton", "/", "\[HBar]"}]}], "/.", "atomicData"}], ",", 
     
     RowBox[{"1", "/", "Second"}]}], "]"}]}]}]], "Input",
 CellLabel->"In[21]:=",
 CellID->635373638,ExpressionUUID->"3de3a2e5-b05c-4da3-a951-624bb00a0cc3"],

Cell[BoxData[
 RowBox[{"\[CapitalOmega]L", "\[Rule]", 
  FractionBox[
   RowBox[{"8.794106679480923`*^6", " ", "b"}], "Second"]}]], "Output",
 CellLabel->"Out[21]=",
 CellID->83928220,ExpressionUUID->"5264cfc2-4189-4792-8155-1ffd670ab031"]
}, Open  ]],

Cell[TextData[{
 "Write the total absorption and optical rotation in terms of the path length \
(in ",
 Cell[BoxData[
  FormBox["cm", TraditionalForm]], "InlineMath",ExpressionUUID->
  "c609ad6c-30c6-46d4-a620-d6d64c1889f8"],
 "), and the atomic density (in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["cm", 
    RowBox[{"-", "3"}]], TraditionalForm]], "InlineMath",ExpressionUUID->
  "371d3c3f-0024-459c-ad2c-c3fb8a08ac6f"],
 ")."
}], "MathCaption",
 CellID->943359433,ExpressionUUID->"b11b47c7-781a-4b58-a999-079eda6bcf08"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"observables1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Convert", "[", 
     RowBox[{"#", ",", "1"}], "]"}], "&"}], "/@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"observables", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], " ", 
       SuperscriptBox["c", "2"], "length", " ", 
       RowBox[{"(", "Centimeter", ")"}], " ", "density", 
       RowBox[{"(", 
        RowBox[{"1", "/", 
         SuperscriptBox["Centimeter", "3"]}], ")"}]}], "/.", "atomicData"}], "/.",
      "rabi"}], ")"}]}]}]], "Input",
 CellLabel->"In[22]:=",
 CellID->2119559488,ExpressionUUID->"09960496-40a1-48da-9bcb-be7e055be3f9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     SqrtBox["Int"]], 
    RowBox[{"3.7666996855596813`*^-10", " ", "density", " ", "length", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", 
            RowBox[{"-", "2"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
       RowBox[{"2", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", 
            RowBox[{"-", "2"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
       RowBox[{
        SqrtBox["6"], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
       RowBox[{"2", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
       RowBox[{
        SqrtBox["6"], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "-", 
       RowBox[{
        SqrtBox["2"], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
       RowBox[{
        SqrtBox["2"], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
       RowBox[{
        SqrtBox["6"], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
       RowBox[{
        SqrtBox["6"], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "-", 
       RowBox[{
        SqrtBox["6"], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
       RowBox[{
        SqrtBox["6"], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
       RowBox[{"2", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]]}], "-", 
       RowBox[{"2", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
       RowBox[{"2", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"Im", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}]}], ")"}]}]}], ",", 
   RowBox[{"-", 
    RowBox[{
     FractionBox["1", 
      SqrtBox["Int"]], 
     RowBox[{"3.7666996855596813`*^-10", " ", "density", " ", "length", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", 
         SqrtBox["3"], " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", 
             RowBox[{"-", "2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
        RowBox[{"2", " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", 
             RowBox[{"-", "2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
        RowBox[{
         SqrtBox["6"], " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", 
             RowBox[{"-", "1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "-", 
        RowBox[{"2", " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", 
             RowBox[{"-", "1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", 
             RowBox[{"-", "2"}]}], "}"}]}]]}], "+", 
        RowBox[{
         SqrtBox["6"], " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", 
             RowBox[{"-", "1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
        RowBox[{
         SqrtBox["2"], " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
        RowBox[{
         SqrtBox["2"], " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "-", 
        RowBox[{
         SqrtBox["6"], " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", 
             RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
        RowBox[{
         SqrtBox["6"], " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
        RowBox[{
         SqrtBox["6"], " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "-", 
        RowBox[{
         SqrtBox["6"], " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
        RowBox[{"2", " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]]}], "+", 
        RowBox[{"2", " ", 
         SqrtBox["3"], " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "-", 
        RowBox[{"2", " ", 
         SubscriptBox["\[Rho]", 
          RowBox[{"Re", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}]}], ")"}]}]}]}]}], 
  "}"}]], "Output",
 CellLabel->"Out[22]=",
 CellID->1832321108,ExpressionUUID->"74e97dbf-7752-47cb-a3f5-550d40003fd4"]
}, Open  ]],

Cell["\<\
Substitute all of the above relations and the atomic parameters into the \
Liouville equation.\
\>", "MathCaption",
 CellID->980998741,ExpressionUUID->"4daf65b4-3fa5-4bf7-b570-506918917095"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "[", 
  RowBox[{
   RowBox[{"eqs1", "=", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"eqs", "/.", "rabi"}], "/.", "larmor"}], "/.", "atomicData"}], 
     "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Mega", "\[Rule]", 
        SuperscriptBox["10", "6"]}], ",", 
       RowBox[{"Second", "\[Rule]", "1"}]}], "}"}]}]}], ",", "20"}], 
  "]"}]], "Input",
 CellLabel->"In[23]:=",
 CellID->1909933110,ExpressionUUID->"76d2f59b-e2ee-490e-998d-e5eaf7b3f1f0"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"0", "\[Equal]", 
     RowBox[{
      FractionBox["\[Gamma]", "8"], "-", 
      RowBox[{"1.0443847829917327`*^7", " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
      RowBox[{"6.029758355978259`*^6", " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "-", 
      RowBox[{"\[Gamma]", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}]}]]}], "+", 
      RowBox[{"1.806423642472633`*^7", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
      RowBox[{"6.021412141575443`*^6", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
      RowBox[{"1.2042824283150885`*^7", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]]}]}]}], ",", 
    RowBox[{"0", "\[Equal]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "5.221923914958663`*^6"}], " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]]}], "+", 
      RowBox[{"3.0148791779891294`*^6", " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
      RowBox[{"4.397053339740462`*^6", " ", "b", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "1"}], "}"}]}]]}], "-", 
      RowBox[{"3.6924578111074753`*^6", " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
      RowBox[{"3.6924578111074753`*^6", " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
      RowBox[{"3.0148791779891294`*^6", " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]]}], "-", 
      RowBox[{"\[Gamma]", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "1"}], "}"}]}]]}], "+", 
      RowBox[{"1.277334407288102`*^7", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
      RowBox[{"7.374693638929569`*^6", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "0"}], "}"}]}]]}], "+", 
      RowBox[{"6.021412141575443`*^6", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "1"}], "}"}]}]]}]}]}], ",", 
    RowBox[{"\[LeftSkeleton]", "165", "\[RightSkeleton]"}], ",", 
    RowBox[{"0", "\[Equal]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "3.612847284945266`*^7"}], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "-", 
      RowBox[{"\[Gamma]", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "-", 
      RowBox[{"5.221923914958663`*^6", " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", 
           RowBox[{"-", "2"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "+", 
      RowBox[{"3.6924578111074753`*^6", " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
      RowBox[{"2.1318415112142377`*^6", " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "-", 
      RowBox[{"3.6924578111074753`*^6", " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
      RowBox[{"1.465684446580154`*^6", " ", "b", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
      RowBox[{"2.5386399293402988`*^6", " ", "b", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "0"}], "}"}]}]]}], "-", 
      RowBox[{"2.931368893160308`*^6", " ", "b", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}]}]}], ",", 
    RowBox[{"0", "\[Equal]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1.0443847829917327`*^7"}], " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", 
           RowBox[{"-", "2"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
      RowBox[{"4.263683022428475`*^6", " ", 
       SqrtBox["Int"], " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "+", 
      RowBox[{"5.0772798586805975`*^6", " ", "b", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Im", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "-", 
      RowBox[{"3.612847284945266`*^7", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}], "-", 
      RowBox[{"\[Gamma]", " ", 
       SubscriptBox["\[Rho]", 
        RowBox[{"Re", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]]}]}]}]}], "}"}],
  Short[#, 20]& ]], "Output",
 CellLabel->"Out[23]//Short=",
 CellID->905364176,ExpressionUUID->"ba3f64d0-93f7-46ce-8209-0665d2d5e238"]
}, Open  ]],

Cell["\<\
Finally, we plot the fractional electric-field amplitude absorption, and \
optical rotation (in radians). We can incorporate the effect of Doppler \
broadening by treating the Doppler shift as a shift in the light frequency. \
Thus the Doppler-broadened signal is given by the convolution of the \
Doppler-free signal and the Doppler profile.\
\>", "Text",
 CellID->1106334849,ExpressionUUID->"8db34143-7d4b-4f09-8b8e-d45c14c31e7c"],

Cell["\<\
Plot the Doppler-free absorption and rotation signals at low magnetic field \
and fairly high light intensity to see the nonlinear magneto-optical effect. \
Note that for the chosen set of parameters there is significant power \
broadening of the Doppler-free signal.\
\>", "MathCaption",
 CellID->1698227118,ExpressionUUID->"ecdf6b9f-d0ad-4149-903e-700d29f61084"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"params", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Int", "\[Rule]", ".5"}], " ", 
     RowBox[{"(*", " ", 
      RowBox[{"mW", "/", 
       SuperscriptBox["cm", "2"]}], " ", "*)"}], ",", 
     RowBox[{"\[Gamma]", "\[Rule]", 
      RowBox[{"1.", " ", 
       SuperscriptBox["10", "3"]}]}], " ", 
     RowBox[{"(*", " ", 
      RowBox[{"1", "/", "s"}], " ", "*)"}], ",", 
     RowBox[{"b", "\[Rule]", 
      RowBox[{"0.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "3"}]]}]}], 
     RowBox[{"(*", " ", "G", " ", "*)"}], ",", 
     RowBox[{"length", "\[Rule]", "1."}], " ", 
     RowBox[{"(*", " ", "cm", " ", "*)"}], ",", 
     RowBox[{"density", "\[Rule]", 
      RowBox[{"1.", " ", 
       SuperscriptBox["10", "9"]}]}], " ", 
     RowBox[{"(*", " ", 
      RowBox[{"1", "/", 
       SuperscriptBox["cm", "3"]}], " ", "*)"}], ",", 
     RowBox[{"\[CapitalDelta]", "\[Rule]", 
      RowBox[{"2", "\[Pi]", " ", 
       SuperscriptBox["10", "9"], "d"}]}]}], " ", 
    RowBox[{"(*", " ", "GHz", " ", "*)"}], "}"}]}], ";", 
  RowBox[{"eqarr", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "1"}]}], "}"}], 
    RowBox[{"Reverse", "@", 
     RowBox[{"CoefficientArrays", "[", 
      RowBox[{
       RowBox[{"eqs1", "/.", "params"}], ",", "vars"}], "]"}]}]}]}], ";", 
  RowBox[{"obsarr", "=", 
   RowBox[{
    RowBox[{"CoefficientArrays", "[", 
     RowBox[{
      RowBox[{"observables1", "/.", "params"}], ",", "vars"}], "]"}], 
    "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], ";", 
  RowBox[{"tab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"d", ",", 
       RowBox[{"obsarr", ".", 
        RowBox[{"LinearSolve", "@@", "eqarr"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", 
       RowBox[{"-", "5"}], ",", "0", ",", ".01"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"ListLinePlot", "[", 
   RowBox[{
    RowBox[{"Transpose", "@", 
     RowBox[{"tab", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}]}], ",", 
    RowBox[{"DataRange", "\[Rule]", 
     RowBox[{"tab", "\[LeftDoubleBracket]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", "1"}], "\[RightDoubleBracket]"}]}],
     ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", "\"\<Detuning (GHz)\>\"", "}"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[24]:=",
 CellID->2045503596,ExpressionUUID->"5e3b4dd4-528f-4cf3-ae1d-5348cdd3694d"],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.006944444444444445], 
     AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJw12Xc81fsfB/CD49icoaJS6la0B+2iKWlvtymNXxpudY1yLxeFQjdp6Cqy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      "]]}, 
    {RGBColor[0.880722, 0.611041, 0.142051], PointSize[0.006944444444444445], 
     AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJw12HlcjFsYB/C3aZ+2Qbrcitxkv+lSyqV3RpasSSmRZSwRkkRE0ghJtrQp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      "]]}}, {}, {}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {
     FormBox["\"Detuning (GHz)\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->Medium,
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
         Part[#, 1]], 
        (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
         Part[#, 1]], 
        (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-5., 0}, {-0.00020724276076205855`, 0.0001408555041881224}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellLabel->"Out[24]=",
 CellID->1534067037,ExpressionUUID->"14d9c75c-e303-4810-b8b5-d516f87fa649"]
}, Open  ]],

Cell["\<\
Convolve the signals with the Doppler distribution to obtain the \
Doppler-broadened signal.\
\>", "MathCaption",
 CellID->1410322758,ExpressionUUID->"4dfa27b5-194e-445a-8812-7d3a1175fc92"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"dw", "=", 
   RowBox[{
    RowBox[{"DopplerWidth", "[", 
     RowBox[{"gstate", ",", "estate", ",", "293"}], " ", 
     RowBox[{"(*", " ", "Kelvin", " ", "*)"}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Mega", "\[Rule]", 
       SuperscriptBox["10", "6"]}], ",", 
      RowBox[{"Second", "\[Rule]", "1"}]}], "}"}]}]}], ";", 
  RowBox[{"doppler", "=", 
   RowBox[{"0.01", " ", "2", "\[Pi]", " ", 
    SuperscriptBox["10", "9"], 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Voigt", "[", 
       RowBox[{
        RowBox[{"2", "\[Pi]", " ", 
         SuperscriptBox["10", "9"], "d"}], ",", "0", ",", "dw"}], "]"}], ",", 
      
      RowBox[{"{", 
       RowBox[{"d", ",", 
        RowBox[{"-", "1"}], ",", "1", ",", ".01"}], "}"}]}], "]"}]}]}], ";", 
  RowBox[{"conv", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ListConvolve", "[", 
       RowBox[{"doppler", ",", "#", ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", "0"}], "]"}], 
      "\[LeftDoubleBracket]", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Length", "[", "doppler", "]"}], "-", "1"}], ")"}], "/", 
         "2"}], "+", "1"}], ";;", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Length", "[", "doppler", "]"}], "-", "1"}], ")"}]}], "/",
          "2"}], "-", "1"}]}], "\[RightDoubleBracket]"}], "&"}], "/@", 
    RowBox[{"Transpose", "@", 
     RowBox[{"tab", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}]}]}]}], ";", 
  RowBox[{"ListLinePlot", "[", 
   RowBox[{"conv", ",", 
    RowBox[{"DataRange", "\[Rule]", 
     RowBox[{"tab", "\[LeftDoubleBracket]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", "1"}], "\[RightDoubleBracket]"}]}],
     ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", "\"\<Detuning (GHz)\>\"", "}"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[25]:=",
 CellID->1039383475,ExpressionUUID->"05c46bac-a47e-4a5b-8c5e-13fae7dc4898"],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.006944444444444445], 
     AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJw12XlcTPv/B/CpppqmmuWMNSRXyHapbF1Kcrl2ietrlxC/KHFdutmS7NkL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      "]]}, 
    {RGBColor[0.880722, 0.611041, 0.142051], PointSize[0.006944444444444445], 
     AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJw12HlcTN8bB/A7WzPTOjPZvvgm1Zek7KWf5U4SZU+W0CIqS0hFJFuRkFTK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      "]]}}, {}, {}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {
     FormBox["\"Detuning (GHz)\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->Medium,
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
         Part[#, 1]], 
        (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
         Part[#, 1]], 
        (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-5., 0}, {-0.00007306820815335668, 0.000049016050747593254`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellLabel->"Out[25]=",
 CellID->376024977,ExpressionUUID->"125f8b2c-a078-46e3-aeae-f990086d7a1c"]
}, Open  ]],

Cell["\<\
Choose higher magnetic field and lower light intensity to see the linear \
magneto-optical effect.\
\>", "MathCaption",
 CellID->2042989794,ExpressionUUID->"f5bc167f-cc00-4c10-8070-12e9a4a84bf7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"params", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Int", "\[Rule]", ".005"}], 
     RowBox[{"(*", " ", 
      RowBox[{"mW", "/", 
       SuperscriptBox["cm", "2"]}], " ", "*)"}], ",", 
     RowBox[{"\[Gamma]", "\[Rule]", 
      RowBox[{"1.", " ", 
       SuperscriptBox["10", "3"]}]}], " ", 
     RowBox[{"(*", " ", 
      RowBox[{"1", "/", "s"}], " ", "*)"}], ",", 
     RowBox[{"b", "\[Rule]", "100."}], 
     RowBox[{"(*", " ", "G", " ", "*)"}], ",", 
     RowBox[{"length", "\[Rule]", "1."}], " ", 
     RowBox[{"(*", " ", "cm", " ", "*)"}], ",", 
     RowBox[{"density", "\[Rule]", 
      RowBox[{"1.", " ", 
       SuperscriptBox["10", "9"]}]}], " ", 
     RowBox[{"(*", " ", 
      RowBox[{"1", "/", 
       SuperscriptBox["cm", "3"]}], " ", "*)"}], ",", 
     RowBox[{"\[CapitalDelta]", "\[Rule]", 
      RowBox[{"2", "\[Pi]", " ", 
       SuperscriptBox["10", "9"], "d"}]}]}], " ", 
    RowBox[{"(*", " ", "GHz", " ", "*)"}], "}"}]}], ";", 
  RowBox[{"eqarr", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "1"}]}], "}"}], 
    RowBox[{"Reverse", "@", 
     RowBox[{"CoefficientArrays", "[", 
      RowBox[{
       RowBox[{"eqs1", "/.", "params"}], ",", "vars"}], "]"}]}]}]}], ";", 
  RowBox[{"obsarr", "=", 
   RowBox[{
    RowBox[{"CoefficientArrays", "[", 
     RowBox[{
      RowBox[{"observables1", "/.", "params"}], ",", "vars"}], "]"}], 
    "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], ";", 
  RowBox[{"tab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"d", ",", 
       RowBox[{"obsarr", ".", 
        RowBox[{"LinearSolve", "@@", "eqarr"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", 
       RowBox[{"-", "5"}], ",", "0", ",", ".01"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"ListLinePlot", "[", 
   RowBox[{
    RowBox[{"Transpose", "@", 
     RowBox[{"tab", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}]}], ",", 
    RowBox[{"DataRange", "\[Rule]", 
     RowBox[{"tab", "\[LeftDoubleBracket]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", "1"}], "\[RightDoubleBracket]"}]}],
     ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", "\"\<Detuning (GHz)\>\"", "}"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[26]:=",
 CellID->1537136575,ExpressionUUID->"123fd5b0-4c58-40ee-b11a-93f42fd81e43"],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.006944444444444445], 
     AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJw12Xk4ldsXB/Dj4Jg5gy7VLaW6NJd0S/dHGi4liq5KowZp0KBBA5o1umnO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      "]]}, 
    {RGBColor[0.880722, 0.611041, 0.142051], PointSize[0.006944444444444445], 
     AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJw12Xk81OsXB/DZMMZgFi3WlFupG9lJ9f2in6JV2rvqUknUtaduCpW6UlrV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      "]]}}, {}, {}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {
     FormBox["\"Detuning (GHz)\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->Medium,
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
         Part[#, 1]], 
        (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
         Part[#, 1]], 
        (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-5., 0}, {-0.007773008983618113, 0.007862517371855404}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellLabel->"Out[26]=",
 CellID->1954898965,ExpressionUUID->"191f0e1c-ee2e-4b20-b071-5ba315eb3c37"]
}, Open  ]],

Cell["Convolve the signal with the Doppler distribution.", "MathCaption",
 CellID->708089953,ExpressionUUID->"fbad73ec-03f7-49a4-9618-d2fd22598151"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"dw", "=", 
   RowBox[{
    RowBox[{"DopplerWidth", "[", 
     RowBox[{"gstate", ",", "estate", ",", "293"}], " ", 
     RowBox[{"(*", " ", "Kelvin", " ", "*)"}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Mega", "\[Rule]", 
       SuperscriptBox["10", "6"]}], ",", 
      RowBox[{"Second", "\[Rule]", "1"}]}], "}"}]}]}], ";", 
  RowBox[{"doppler", "=", 
   RowBox[{"0.01", " ", "2", "\[Pi]", " ", 
    SuperscriptBox["10", "9"], 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Voigt", "[", 
       RowBox[{
        RowBox[{"2", "\[Pi]", " ", 
         SuperscriptBox["10", "9"], "d"}], ",", "0", ",", "dw"}], "]"}], ",", 
      
      RowBox[{"{", 
       RowBox[{"d", ",", 
        RowBox[{"-", "1"}], ",", "1", ",", ".01"}], "}"}]}], "]"}]}]}], ";", 
  RowBox[{"conv", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ListConvolve", "[", 
       RowBox[{"doppler", ",", "#", ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", "0"}], "]"}], 
      "\[LeftDoubleBracket]", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Length", "[", "doppler", "]"}], "-", "1"}], ")"}], "/", 
         "2"}], "+", "1"}], ";;", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Length", "[", "doppler", "]"}], "-", "1"}], ")"}]}], "/",
          "2"}], "-", "1"}]}], "\[RightDoubleBracket]"}], "&"}], "/@", 
    RowBox[{"Transpose", "@", 
     RowBox[{"tab", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}]}]}]}], ";", 
  RowBox[{"ListLinePlot", "[", 
   RowBox[{"conv", ",", 
    RowBox[{"DataRange", "\[Rule]", 
     RowBox[{"tab", "\[LeftDoubleBracket]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", "1"}], "\[RightDoubleBracket]"}]}],
     ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", "\"\<Detuning (GHz)\>\"", "}"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[27]:=",
 CellID->646178458,ExpressionUUID->"e0e53662-8868-438b-b7fe-ac30e538ba5e"],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.006944444444444445], 
     AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJw92Xk4VdsbB/Bt5pjOOUmaRKPcRpGSeUoUkiRp0qRB0y23uqVudK80GEqD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      "]]}, 
    {RGBColor[0.880722, 0.611041, 0.142051], PointSize[0.006944444444444445], 
     AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJw12XlczNsbB/CZaZumqWZJJUmlXTElZf1+QzdJiO5NIXLta7j2nyV7l66b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      "]]}}, {}, {}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {
     FormBox["\"Detuning (GHz)\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->Medium,
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
         Part[#, 1]], 
        (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Part[{{Identity, Identity}, {Identity, Identity}}, 1, 2][#]& )[
         Part[#, 1]], 
        (Part[{{Identity, Identity}, {Identity, Identity}}, 2, 2][#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-5., 0}, {-0.0010293402304985687`, 0.0003551559461169749}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellLabel->"Out[27]=",
 CellID->1634589302,ExpressionUUID->"821d6a2e-4831-4006-b41a-8e4ede69de11"]
}, Open  ]],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "TutorialMoreAboutSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "AtomicDensityMatrix Package",
         BaseStyle->"Link",
         ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]],
          "TutorialMoreAbout",ExpressionUUID->
         "5cf95960-afa6-42e0-b82c-a435d41238c2"]}]}
     }]}
  }]], "TutorialMoreAboutSection",ExpressionUUID->"93aa045d-3a2b-46a1-a56a-\
3dd3cc965800"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Tech", " ", "Notes"}], 
        "RelatedTutorialsSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "Nonlinear Magneto-Optical Rotation with Frequency-Modulated Light",
         BaseStyle->"Link",
         ButtonData->
          "paclet:AtomicDensityMatrix/tutorial/\
NonlinearMagnetoOpticalRotationWithFrequencyModulatedLight"]], 
         "RelatedTutorials",ExpressionUUID->
         "eb79d6e2-0472-44ba-8afa-58953edfdad9"]}]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "Zeeman Structure: Nonlinear Magneto-Optical Rotation",
         BaseStyle->"Link",
         ButtonData->
          "paclet:AtomicDensityMatrix/tutorial/\
ZeemanStructureNonlinearMagnetoOpticalRotation"]], "RelatedTutorials",
         ExpressionUUID->"5553feb5-d879-4b5e-958e-a4b5ff5718bc"]}]}
     }]}
  }]], "RelatedTutorialsSection",ExpressionUUID->"d078aab5-daa8-4aaa-8a44-\
4c263298ac00"],

Cell[BoxData[""], "Input",ExpressionUUID->"abe289cd-cead-4ceb-984d-5f247988a189"]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"bd0b0ff5-b872-4dfe-878c-ba668f0b0f12"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Nonlinear Magneto-Optical Rotation in an Alkali Atom",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}}, 
  "NewStyles" -> True, "CitationPopupData" -> {$Failed, ""}, "ShowCitation" -> 
  False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 18, 0, 25.802680}", 
    "history" -> {"", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Tutorial", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "Here we examine the interaction of linearly polarized light and a \
longitudinal magnetic field with an atomic sample, as in the tutorial \
\"Zeeman Structure: Nonlinear Magneto-Optical Rotation\". In this case, we \
consider the D1 line of the ^87 Rb atom, and write the input parameters in \
units appropriate for comparison with experimental results. Load the package. \
Set options for DensityMatrix and plotting function.", "synonyms" -> {}, 
    "tabletags" -> DocumentationBuild`Make`Private`tabletaggingrules$74361, 
    "title" -> "Nonlinear Magneto-Optical Rotation in an Alkali Atom", 
    "titlemodifier" -> "", "metadescription" -> "", "windowtitle" -> 
    "Nonlinear Magneto-Optical Rotation in an Alkali Atom", "type" -> 
    "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/\
NonlinearMagnetoOpticalRotationInAnAlkaliAtom"}},
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> Notebook], 
   Cell[
    StyleData["Output"], CellContext -> Notebook], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"72841721-fbd6-4488-910f-8467beb2db79"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[624, 21, 5835, 138, 57, "AnchorBarGrid",ExpressionUUID->"773355eb-7fd4-41ef-93ab-990b58d512db",
 CellID->1],
Cell[CellGroupData[{
Cell[6484, 163, 144, 1, 110, "Title",ExpressionUUID->"62d742e2-4379-4952-93b0-4763ba1a5811",
 CellID->509267359],
Cell[6631, 166, 776, 17, 84, "Text",ExpressionUUID->"7916e742-97ad-4507-a6b1-6640a3c45e97",
 CellID->1410553583],
Cell[7410, 185, 115, 1, 36, "MathCaption",ExpressionUUID->"82ec763d-192d-4cb3-b27b-5317584cf06b",
 CellID->428702736],
Cell[7528, 188, 162, 3, 29, "Input",ExpressionUUID->"0d02c8e3-02f4-48c6-aa85-9a2fa76d1485",
 CellID->399248267],
Cell[7693, 193, 489, 14, 38, "MathCaption",ExpressionUUID->"18c2d9a1-95ff-4a45-97ca-178878631f19",
 CellID->1679141539],
Cell[8185, 209, 337, 8, 29, "Input",ExpressionUUID->"607207b0-d601-4d6b-9fbb-c74887d9cd9b",
 CellID->1063678041],
Cell[8525, 219, 358, 8, 29, "Input",ExpressionUUID->"900dcc2a-8834-4673-a24d-a17819c72851",
 CellID->1867164128],
Cell[8886, 229, 746, 17, 84, "Text",ExpressionUUID->"a79d4713-a18b-4599-bb67-6822e2335802",
 CellID->594387048],
Cell[9635, 248, 942, 25, 59, "MathCaption",ExpressionUUID->"6e8c8086-33ef-4d93-bdcc-421a80a784e9",
 CellID->1890496939],
Cell[CellGroupData[{
Cell[10602, 277, 291, 7, 29, "Input",ExpressionUUID->"8c85b7e1-30be-4e42-85e8-f368f1863149",
 CellID->255182439],
Cell[10896, 286, 778, 22, 52, "Output",ExpressionUUID->"f530a804-23ac-42a7-8607-c76b687b4310",
 CellID->1395651866]
}, Open  ]],
Cell[11689, 311, 357, 6, 55, "MathCaption",ExpressionUUID->"1d4ee46d-f9e6-42b6-8aa4-75a23d610925",
 CellID->331090632],
Cell[CellGroupData[{
Cell[12071, 321, 639, 18, 66, "Input",ExpressionUUID->"2c22c9fa-f92a-4ba0-95f9-1f40eadb6f80",
 CellID->2064101732],
Cell[12713, 341, 834, 24, 52, "Output",ExpressionUUID->"13a91ec8-c2c7-4db4-9487-53d9748e68a0",
 CellID->81516297]
}, Open  ]],
Cell[13562, 368, 1358, 37, 57, "MathCaption",ExpressionUUID->"bf5fffca-30b7-45c1-b891-89be1db9c915",
 CellID->270820281],
Cell[14923, 407, 587, 16, 48, "Input",ExpressionUUID->"914561f9-23a7-4985-902b-55e7d623ea2a",
 CellID->314100305],
Cell[15513, 425, 521, 13, 70, "MathCaption",ExpressionUUID->"4a040ff3-5989-4a64-a872-bd5a519c899c",
 CellID->927847299],
Cell[CellGroupData[{
Cell[16059, 442, 438, 12, 70, "Input",ExpressionUUID->"29151052-e963-4d01-add2-76a578f77560",
 CellID->1471499099],
Cell[16500, 456, 7957, 208, 331, "Output",ExpressionUUID->"aa063981-5f6b-4e8f-954a-b06eab5d501e",
 CellID->1117540021]
}, Open  ]],
Cell[24472, 667, 207, 4, 70, "MathCaption",ExpressionUUID->"10dc5659-be69-4ab5-9cb9-167aa640746a",
 CellID->262224642],
Cell[CellGroupData[{
Cell[24704, 675, 673, 17, 70, "Input",ExpressionUUID->"9935844c-02a8-4035-bb8d-cf8c527f3adc",
 CellID->708150996],
Cell[25380, 694, 3710, 100, 258, "Output",ExpressionUUID->"78035c6e-0e56-4c91-aa72-5deccb4b9bfb",
 CellID->1846321168]
}, Open  ]],
Cell[29105, 797, 228, 4, 70, "Text",ExpressionUUID->"86ba6976-d537-4eb3-957f-eea94289189a",
 CellID->2130696078],
Cell[29336, 803, 871, 22, 70, "MathCaption",ExpressionUUID->"c6526a5f-fbfd-4c14-b11c-dc7984a16a47",
 CellID->1277669421],
Cell[CellGroupData[{
Cell[30232, 829, 797, 21, 70, "Input",ExpressionUUID->"b33c2863-18c7-4f50-8dd5-e7d4cdc8f907",
 CellID->1209378368],
Cell[31032, 852, 9838, 284, 404, "Output",ExpressionUUID->"95bb933b-58f2-40f4-88f8-ba5ebb6ccdfd",
 CellID->9439803]
}, Open  ]],
Cell[40885, 1139, 209, 4, 70, "MathCaption",ExpressionUUID->"683dda77-0406-48a4-81d7-ac2df9b64512",
 CellID->460749553],
Cell[CellGroupData[{
Cell[41119, 1147, 602, 18, 70, "Input",ExpressionUUID->"417f1157-d400-4629-8733-c0e84b786dd5",
 CellID->1893193157],
Cell[41724, 1167, 3321, 58, 121, "Output",ExpressionUUID->"0bbb1f38-1529-4554-9b67-2ddbf0078ab4",
 CellID->536238841]
}, Open  ]],
Cell[45060, 1228, 373, 8, 70, "MathCaption",ExpressionUUID->"436b1c98-f14f-4ba1-ba3d-f55187e4ba8f",
 CellID->1348929297],
Cell[CellGroupData[{
Cell[45458, 1240, 492, 13, 70, "Input",ExpressionUUID->"4cb31068-f48c-496e-b03f-f257507b7059",
 CellID->858044413],
Cell[45953, 1255, 6792, 197, 404, "Output",ExpressionUUID->"1e6fe180-9f2d-441c-9477-a6dd38aa3e80",
 CellID->1190252317]
}, Open  ]],
Cell[52760, 1455, 193, 4, 70, "MathCaption",ExpressionUUID->"831b6345-1daf-4947-8efc-cc2d84b8ae46",
 CellID->1645761088],
Cell[CellGroupData[{
Cell[52978, 1463, 350, 8, 70, "Input",ExpressionUUID->"3af42477-781f-48ca-8151-18dc0e7e07be",
 CellID->460896029],
Cell[53331, 1473, 2307, 53, 252, "Output",ExpressionUUID->"dd1d18d5-54c1-4d96-b87b-a5396448fec2",
 CellID->1557636288]
}, Open  ]],
Cell[55653, 1529, 194, 4, 70, "MathCaption",ExpressionUUID->"f293e617-ce64-48e0-ba92-d8ce478ad6ee",
 CellID->793381933],
Cell[CellGroupData[{
Cell[55872, 1537, 352, 8, 70, "Input",ExpressionUUID->"f9bbdd32-4eef-4f39-8d30-3c05f4658c17",
 CellID->469501353],
Cell[56227, 1547, 52074, 1417, 328, "Output",ExpressionUUID->"36f70ff3-565b-4f57-a9c3-3987c7d46e91",
 CellID->1367435486]
}, Open  ]],
Cell[108316, 2967, 171, 3, 70, "MathCaption",ExpressionUUID->"96861be4-63ec-441d-a359-8acee7f36a34",
 CellID->1283804320],
Cell[CellGroupData[{
Cell[108512, 2974, 353, 9, 70, "Input",ExpressionUUID->"3f945e9e-1b9b-4175-851b-fb28717e5837",
 CellID->1081996554],
Cell[108868, 2985, 10634, 304, 344, "Output",ExpressionUUID->"fee6f769-8513-4092-a971-8e03cf89967d",
 CellID->118223008]
}, Open  ]],
Cell[119517, 3292, 136, 1, 70, "MathCaption",ExpressionUUID->"4932046b-183a-4c79-b8ac-3d70b77805f9",
 CellID->1175348008],
Cell[CellGroupData[{
Cell[119678, 3297, 195, 4, 70, "Input",ExpressionUUID->"ac70f6e3-397f-48de-a0b9-76a38eb0a8e7",
 CellID->1055891795],
Cell[119876, 3303, 36942, 1148, 572, "Output",ExpressionUUID->"39020b0f-3f81-4293-ba2f-bd9d4413b12b",
 CellID->551721981]
}, Open  ]],
Cell[156833, 4454, 206, 4, 70, "Text",ExpressionUUID->"a301a73a-69e5-4363-a18d-a995d2ebdf6a",
 CellID->1380373434],
Cell[157042, 4460, 221, 4, 70, "MathCaption",ExpressionUUID->"eb2db6ce-3ce5-49b3-8727-a19a63c7914f",
 CellID->1386887899],
Cell[CellGroupData[{
Cell[157288, 4468, 492, 13, 70, "Input",ExpressionUUID->"906786e1-0528-46fc-b486-90699f3935f8",
 CellID->1716023404],
Cell[157783, 4483, 19135, 529, 431, "Output",ExpressionUUID->"48782e43-7d60-420d-8c78-e36a6ed26362",
 CellID->2104430568]
}, Open  ]],
Cell[176933, 5015, 191, 4, 70, "Text",ExpressionUUID->"e555c4ec-d261-4755-b9af-c9d607abf0c1",
 CellID->1838084779],
Cell[177127, 5021, 555, 14, 70, "MathCaption",ExpressionUUID->"e340acbd-80f6-4208-af19-504b8c5e28f0",
 CellID->2119188793],
Cell[CellGroupData[{
Cell[177707, 5039, 360, 10, 70, "Input",ExpressionUUID->"4a8b83b8-8f76-4b34-aa36-1af82cc04e6e",
 CellID->499971818],
Cell[178070, 5051, 320, 10, 64, "Output",ExpressionUUID->"1738bcb7-2ee3-4660-bbc4-a158f19f6ea8",
 CellID->108890286]
}, Open  ]],
Cell[178405, 5064, 604, 17, 70, "MathCaption",ExpressionUUID->"4bd165e2-4670-4725-961b-bab00eb30c09",
 CellID->1167398770],
Cell[CellGroupData[{
Cell[179034, 5085, 461, 14, 70, "Input",ExpressionUUID->"c4423be7-a776-4471-8ace-6e5f2dacfaf1",
 CellID->972219711],
Cell[179498, 5101, 194, 4, 38, "Output",ExpressionUUID->"d7b3dd2e-8e24-4a65-84f4-6690df01d72f",
 CellID->462969558]
}, Open  ]],
Cell[179707, 5108, 612, 18, 70, "MathCaption",ExpressionUUID->"04da1a9c-8d0e-42ae-be61-ea63359775ab",
 CellID->2139412245],
Cell[CellGroupData[{
Cell[180344, 5130, 601, 18, 70, "Input",ExpressionUUID->"79d163c5-ce61-4d25-999c-50ddb9dfa273",
 CellID->1349320912],
Cell[180948, 5150, 219, 5, 56, "Output",ExpressionUUID->"5c8e5f7b-68b2-4baa-bb45-675bbe7a2fb8",
 CellID->796108225]
}, Open  ]],
Cell[181182, 5158, 157, 2, 70, "MathCaption",ExpressionUUID->"f6ad26a2-eaaa-46b5-bc56-82be8b185f76",
 CellID->915261302],
Cell[CellGroupData[{
Cell[181364, 5164, 390, 10, 70, "Input",ExpressionUUID->"f7fb1ff7-3089-41e9-b729-1fb7e1e94bf4",
 CellID->557915952],
Cell[181757, 5176, 258, 6, 56, "Output",ExpressionUUID->"d510efd3-f503-4018-ac4e-e3b8e9413658",
 CellID->1367816765]
}, Open  ]],
Cell[182030, 5185, 174, 3, 70, "MathCaption",ExpressionUUID->"7e8216b6-a969-4227-a4c6-a68292042047",
 CellID->1825228082],
Cell[CellGroupData[{
Cell[182229, 5192, 416, 11, 70, "Input",ExpressionUUID->"3de3a2e5-b05c-4da3-a951-624bb00a0cc3",
 CellID->635373638],
Cell[182648, 5205, 239, 5, 55, "Output",ExpressionUUID->"5264cfc2-4189-4792-8155-1ffd670ab031",
 CellID->83928220]
}, Open  ]],
Cell[182902, 5213, 528, 14, 70, "MathCaption",ExpressionUUID->"b11b47c7-781a-4b58-a999-079eda6bcf08",
 CellID->943359433],
Cell[CellGroupData[{
Cell[183455, 5231, 704, 19, 70, "Input",ExpressionUUID->"09960496-40a1-48da-9bcb-be7e055be3f9",
 CellID->2119559488],
Cell[184162, 5252, 8845, 254, 209, "Output",ExpressionUUID->"74e97dbf-7752-47cb-a3f5-550d40003fd4",
 CellID->1832321108]
}, Open  ]],
Cell[193022, 5509, 200, 4, 70, "MathCaption",ExpressionUUID->"4daf65b4-3fa5-4bf7-b570-506918917095",
 CellID->980998741],
Cell[CellGroupData[{
Cell[193247, 5517, 507, 16, 70, "Input",ExpressionUUID->"76d2f59b-e2ee-490e-998d-e5eaf7b3f1f0",
 CellID->1909933110],
Cell[193757, 5535, 9561, 260, 225, "Output",ExpressionUUID->"ba3f64d0-93f7-46ce-8209-0665d2d5e238",
 CellID->905364176]
}, Open  ]],
Cell[203333, 5798, 442, 7, 70, "Text",ExpressionUUID->"8db34143-7d4b-4f09-8b8e-d45c14c31e7c",
 CellID->1106334849],
Cell[203778, 5807, 374, 6, 70, "MathCaption",ExpressionUUID->"ecdf6b9f-d0ad-4149-903e-700d29f61084",
 CellID->1698227118],
Cell[CellGroupData[{
Cell[204177, 5817, 2535, 71, 70, "Input",ExpressionUUID->"5e3b4dd4-528f-4cf3-ae1d-5348cdd3694d",
 CellID->2045503596],
Cell[206715, 5890, 16384, 282, 252, "Output",ExpressionUUID->"14d9c75c-e303-4810-b8b5-d516f87fa649",
 CellID->1534067037]
}, Open  ]],
Cell[223114, 6175, 199, 4, 70, "MathCaption",ExpressionUUID->"4dfa27b5-194e-445a-8812-7d3a1175fc92",
 CellID->1410322758],
Cell[CellGroupData[{
Cell[223338, 6183, 2200, 64, 70, "Input",ExpressionUUID->"05c46bac-a47e-4a5b-8c5e-13fae7dc4898",
 CellID->1039383475],
Cell[225541, 6249, 16568, 285, 251, "Output",ExpressionUUID->"125f8b2c-a078-46e3-aeae-f990086d7a1c",
 CellID->376024977]
}, Open  ]],
Cell[242124, 6537, 205, 4, 70, "MathCaption",ExpressionUUID->"f5bc167f-cc00-4c10-8070-12e9a4a84bf7",
 CellID->2042989794],
Cell[CellGroupData[{
Cell[242354, 6545, 2452, 68, 70, "Input",ExpressionUUID->"123fd5b0-4c58-40ee-b11a-93f42fd81e43",
 CellID->1537136575],
Cell[244809, 6615, 16759, 289, 258, "Output",ExpressionUUID->"191f0e1c-ee2e-4b20-b071-5ba315eb3c37",
 CellID->1954898965]
}, Open  ]],
Cell[261583, 6907, 148, 1, 70, "MathCaption",ExpressionUUID->"fbad73ec-03f7-49a4-9618-d2fd22598151",
 CellID->708089953],
Cell[CellGroupData[{
Cell[261756, 6912, 2199, 64, 70, "Input",ExpressionUUID->"e0e53662-8868-438b-b7fe-ac30e538ba5e",
 CellID->646178458],
Cell[263958, 6978, 16688, 287, 256, "Output",ExpressionUUID->"821d6a2e-4831-4006-b41a-8e4ede69de11",
 CellID->1634589302]
}, Open  ]],
Cell[280661, 7268, 725, 18, 70, "TutorialMoreAboutSection",ExpressionUUID->"93aa045d-3a2b-46a1-a56a-3dd3cc965800"],
Cell[CellGroupData[{
Cell[281411, 7290, 1234, 31, 70, "RelatedTutorialsSection",ExpressionUUID->"d078aab5-daa8-4aaa-8a44-4c263298ac00"],
Cell[282648, 7323, 81, 0, 70, "Input",ExpressionUUID->"abe289cd-cead-4ceb-984d-5f247988a189"]
}, Open  ]]
}, Open  ]],
Cell[282756, 7327, 78, 0, 70, "FooterCell",ExpressionUUID->"bd0b0ff5-b872-4dfe-878c-ba668f0b0f12"]
}
]
*)

(* End of internal cache information *)

