(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     63912,       1519]
NotebookOptionsPosition[     56762,       1365]
NotebookOutlinePosition[     59533,       1433]
CellTagsIndexPosition[     59453,       1428]
WindowTitle->Stark Mixing
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "91a9782f-3b28-4364-9cff-0fca70866f22"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "6a8233d1-cffc-47ef-b191-60368bdcb381"],
        Background->RGBColor[
         0.7450980392156863, 0.3254901960784314, 0.1411764705882353],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "c0f32bfe-b1bb-4251-adf0-8b5d5dd9d7d3"]
         }],ExpressionUUID->"e29302d2-a2c0-446e-98a9-322c77d44524"],
         StripOnInput->
          False], {"\<\"Hyperfine Structure: Breit-Rabi Diagram\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/\
HyperfineStructureBreitRabiDiagram"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"RelatedTutorialsSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "102ab84a-76d0-4620-a211-10348f039797"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "1d32e092-cc19-4991-aadd-b13c1a0d61f9"]
         }],ExpressionUUID->"24b471b3-c5a3-4b9d-80c8-f1fcda4d7240"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"TutorialMoreAboutSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "62544372-da18-4ad7-96a2-f622449e6180"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "239d4e0d-9a72-4c2e-b524-4eb38c4c1d7a"]
         }],ExpressionUUID->"56bf5cef-1a2c-4202-b550-cba333d732d8"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/tutorial/StarkMixing\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell["AtomicDensityMatrix/tutorial/StarkMixing"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
tutorial/StarkMixing.html"], StandardForm]], "Input", TextClipboardType -> 
               "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$77075], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/tutorial/StarkMixing" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "0e5d9805-030b-4cb0-9fb1-beb047710cc1"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "0682d6da-1619-4560-9328-26094f17794c"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"4575657a-c193-482e-961f-8116c32fbf15"],

Cell[CellGroupData[{

Cell["Stark Mixing", "Title",
 CellID->122350,ExpressionUUID->"17e5fe65-b3d5-403a-959c-2619c4a48e5f"],

Cell["\<\
Electric fields cause mixing of opposite-parity atomic states, and consequent \
energy shifts. If all relevant atomic states are included in the system, the \
mixing and splitting can be found by finding the eigenvalues and eigenvectors \
of the Hamiltonian. \
\>", "Text",
 CellID->217979270,ExpressionUUID->"e9c605ba-d33e-47fd-8e43-00e8d6275b6f"],

Cell[TextData[{
 "Here we analyze a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "2"}], "InlineMath"]],ExpressionUUID->
  "02d445bd-29a3-4030-8e23-feb20b5a0ca1"],
 " state mixed with a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "1"}], "InlineMath"]],ExpressionUUID->
  "ad4a3b8f-1348-4017-9e18-273fa3c193ed"],
 " state by a ",
 Cell[BoxData[
  StyleBox["z", "InlineMath"]],ExpressionUUID->
  "7069b35e-f72e-43fd-b030-0497deba5eb2"],
 "-directed electric field."
}], "Text",
 CellID->14981418,ExpressionUUID->"bd9d4140-d6fb-4bf1-bccd-018722a41122"],

Cell["This loads the package.", "MathCaption",
 CellID->159403208,ExpressionUUID->"87aec354-8328-4bac-a64a-70947644fa22"],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->75905070,ExpressionUUID->"8a0c5e81-2d6d-404b-92d3-6b7cbe1a9df7"],

Cell["Define the atomic system.", "MathCaption",
 CellID->210450481,ExpressionUUID->"62285337-d1f0-451e-b082-8547376ff75d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"system", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "2"}], ",", 
       RowBox[{"L", "\[Rule]", "2"}], ",", 
       RowBox[{"S", "\[Rule]", "0"}], ",", 
       RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "1"}], ",", 
       RowBox[{"L", "\[Rule]", "1"}], ",", 
       RowBox[{"S", "\[Rule]", "0"}], ",", 
       RowBox[{"Energy", "\[Rule]", "\[CapitalDelta]"}]}], "]"}]}], "}"}], 
   "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->877256330,ExpressionUUID->"6aea4082-5f70-4715-a4b4-06bfd849d54b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "2"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "2"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[CapitalDelta]"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[CapitalDelta]"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[CapitalDelta]"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1004032225,ExpressionUUID->"f7d67c22-aba9-449b-939c-06887ab870ac"]
}, Open  ]],

Cell[TextData[{
 "The Hamiltonian for the system subject to a ",
 Cell[BoxData[
  StyleBox["z", "InlineMath"]],ExpressionUUID->
  "de8f49df-49e0-4273-a797-4ed10d23577e"],
 "-directed electric field, in terms of the \"reduced\" Rabi frequency:"
}], "MathCaption",
 CellID->198653609,ExpressionUUID->"cbd479b9-e3e5-49e7-84d2-f93e8b00f3f8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"h", "=", 
   RowBox[{"Hamiltonian", "[", 
    RowBox[{"system", ",", 
     RowBox[{"ElectricField", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{"\[CapitalOmega]R", "/", 
         RowBox[{"ReducedME", "[", 
          RowBox[{"1", ",", 
           RowBox[{"{", 
            RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], 
       "}"}]}]}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->528282370,ExpressionUUID->"0ddff828-5112-4833-9a7f-9e7171ab5209"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        SqrtBox["10"]]}], "0", "0"},
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox[
         FractionBox["2", "15"]]}], " ", "\[CapitalOmega]R"}], "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        SqrtBox["10"]]}]},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        SqrtBox["10"]]}], "0", "0", "0", "\[CapitalDelta]", "0", "0"},
     {"0", "0", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox[
         FractionBox["2", "15"]]}], " ", "\[CapitalOmega]R"}], "0", "0", "0", 
      "\[CapitalDelta]", "0"},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        SqrtBox["10"]]}], "0", "0", "0", "\[CapitalDelta]"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[3]//MatrixForm=",
 CellID->331283732,ExpressionUUID->"4eea07da-cca5-4c5f-b184-43b756ccbd3c"]
}, Open  ]],

Cell["\<\
The level diagram for the system, showing the mixing induced by the electric \
field.\
\>", "MathCaption",
 CellID->18473580,ExpressionUUID->"5472cdf8-9acc-4788-b3b8-a28494b4c04c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"system", ",", 
   RowBox[{"h", "/.", 
    RowBox[{"\[CapitalDelta]", "\[Rule]", "1"}]}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->359462651,ExpressionUUID->"656e3ac3-2390-4ec4-986f-29f332c7bba4"],

Cell[BoxData[
 GraphicsBox[{{{{{}, LineBox[{{1.6, 0.}, {2.4, 0.}}]}, {{}, 
      LineBox[{{0.6, 0.}, {1.4, 0.}}]}, {{}, 
      LineBox[{{-0.4, 0.}, {0.4, 0.}}]}, {{}, 
      LineBox[{{-1.4, 0.}, {-0.6, 0.}}]}, {{}, 
      LineBox[{{-2.4, 0.}, {-1.6, 0.}}]}, {{}, 
      LineBox[{{0.6, 1.}, {1.4, 1.}}]}, {{}, 
      LineBox[{{-0.4, 1.}, {0.4, 1.}}]}, {{}, 
      LineBox[{{-1.4, 1.}, {-0.6, 1.}}]}}, {}, {}, 
    {EdgeForm[Hue[0.61, 0.54, 0.56]], FaceForm[None]}, 
    {RGBColor[0.9, 0.01, 0.01], 
     Arrowheads[{-0.03333333333333334, 0.03333333333333334}], 
     ArrowBox[{{-1., 0.}, {-1., 1.}}], ArrowBox[{{0., 0.}, {0., 1.}}], 
     ArrowBox[{{1., 0.}, {1., 
      1.}}]}}, {{{{}, {}}, {{}, {}}, {{}, {}}, {{}, {}}, {{}, {}}, {{}, {}}, \
{{}, {}}, {{}, {}}}, {}, {}, 
    {EdgeForm[Hue[0.61, 0.54, 0.56]], FaceForm[None]}, 
    {RGBColor[0.9, 0.01, 0.01], 
     Arrowheads[{-0.03333333333333334, 0.03333333333333334}], {}, {}, {}}}},
  ImageSize->{{350}, {100}}]], "Output",
 CellLabel->"Out[4]=",
 CellID->64516156,ExpressionUUID->"59dfe415-4b8f-43f9-968c-0f1e30870fc5"]
}, Open  ]],

Cell["Find the eigenvalues and eigenvectors of the Hamiltonian.", \
"MathCaption",
 CellID->125276603,ExpressionUUID->"ee6d8667-7e6a-427f-b204-111255b6e07c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "/@", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"energies", ",", "states"}], "}"}], "=", 
    RowBox[{"Eigensystem", "[", "h", "]"}]}], ")"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->622964901,ExpressionUUID->"3f2f8616-a734-4898-a2c7-2285969cf87c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {"0"},
        {"0"},
        {
         RowBox[{
          FractionBox["1", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "\[CapitalDelta]"}], "-", 
            RowBox[{
             SqrtBox["5"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "\[CapitalDelta]"}], "-", 
            RowBox[{
             SqrtBox["5"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "\[CapitalDelta]"}], "+", 
            RowBox[{
             SqrtBox["5"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "10"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "\[CapitalDelta]"}], "+", 
            RowBox[{
             SqrtBox["5"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"5", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "30"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"15", " ", "\[CapitalDelta]"}], "-", 
            RowBox[{
             SqrtBox["15"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"15", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"8", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
        {
         RowBox[{
          FractionBox["1", "30"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"15", " ", "\[CapitalDelta]"}], "+", 
            RowBox[{
             SqrtBox["15"], " ", 
             SqrtBox[
              RowBox[{
               RowBox[{"15", " ", 
                SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
               RowBox[{"8", " ", 
                SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.5599999999999999]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      Column], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0", "0", "0", "1", "0", "0", "0"},
       {"1", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             SqrtBox["10"]}], " ", "\[CapitalDelta]"}], "-", 
           RowBox[{
            SqrtBox["2"], " ", 
            SqrtBox[
             RowBox[{
              RowBox[{"5", " ", 
               SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
          RowBox[{"2", " ", "\[CapitalOmega]R"}]]}], "0", "0", "0", "1"},
       {"0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             SqrtBox["10"]}], " ", "\[CapitalDelta]"}], "-", 
           RowBox[{
            SqrtBox["2"], " ", 
            SqrtBox[
             RowBox[{
              RowBox[{"5", " ", 
               SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
          RowBox[{"2", " ", "\[CapitalOmega]R"}]]}], "0", "0", "0", "1", "0", 
        "0"},
       {"0", "0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             SqrtBox["10"]}], " ", "\[CapitalDelta]"}], "+", 
           RowBox[{
            SqrtBox["2"], " ", 
            SqrtBox[
             RowBox[{
              RowBox[{"5", " ", 
               SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
          RowBox[{"2", " ", "\[CapitalOmega]R"}]]}], "0", "0", "0", "1"},
       {"0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             SqrtBox["10"]}], " ", "\[CapitalDelta]"}], "+", 
           RowBox[{
            SqrtBox["2"], " ", 
            SqrtBox[
             RowBox[{
              RowBox[{"5", " ", 
               SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
          RowBox[{"2", " ", "\[CapitalOmega]R"}]]}], "0", "0", "0", "1", "0", 
        "0"},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             SqrtBox["30"]}], " ", "\[CapitalDelta]"}], "-", 
           RowBox[{
            SqrtBox["2"], " ", 
            SqrtBox[
             RowBox[{
              RowBox[{"15", " ", 
               SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
              RowBox[{"8", " ", 
               SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
          RowBox[{"4", " ", "\[CapitalOmega]R"}]]}], "0", "0", "0", "1", 
        "0"},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             SqrtBox["30"]}], " ", "\[CapitalDelta]"}], "+", 
           RowBox[{
            SqrtBox["2"], " ", 
            SqrtBox[
             RowBox[{
              RowBox[{"15", " ", 
               SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
              RowBox[{"8", " ", 
               SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], 
          RowBox[{"4", " ", "\[CapitalOmega]R"}]]}], "0", "0", "0", "1", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellLabel->"Out[5]=",
 CellID->1909529964,ExpressionUUID->"269a2fca-c81a-42b3-8d60-a01017094ca5"]
}, Open  ]],

Cell["\<\
The eigenvalues are the new energies. Here is a plot of them as a function of \
electric field.\
\>", "MathCaption",
 CellID->499179070,ExpressionUUID->"d4b38b1d-34c1-499b-b01a-d2ae13deebe6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"energies", "/.", 
     RowBox[{"\[CapitalDelta]", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalOmega]R", ",", "0", ",", "5"}], "}"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"Axes", "\[Rule]", "False"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->83467549,ExpressionUUID->"c7439010-bfcc-4cd5-88ac-9a7a333de568"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3QlYVNfdP/C0Sd7uS7r37d6+bdqmSZN/Y8y+J02aJs3WJm0ak7gRNxBQ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    "], {{0, 157.}, {240., 0}}, {0, 255},
    ColorFunction->RGBColor,
    ImageResolution->{144., 144.},
    SmoothingQuality->"High"],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{240., 157.},
  PlotRange->{{0, 240.}, {0, 157.}}]], "Output",
 CellTags->"RasterizedOutput",
 CellLabel->"Out[6]=",
 CellID->619417895,ExpressionUUID->"143a8845-57ba-4bac-9957-698c69fecee8"]
}, Open  ]],

Cell["\<\
The eigenvectors are the eigenstates in the presence of the electric field, \
written as a linear combination of the original sublevels. However, they are \
not listed in the order corresponding to the original sublevels. Here we \
reorder the eigenvalues so that they match the unperturbed quantities when \
the electric field approaches zero.\
\>", "Text",
 CellID->271683158,ExpressionUUID->"d6682d75-c798-4ef4-87c8-76311cd2b537"],

Cell["\<\
Normalize the eigenvectors and take the limit as the Rabi frequency goes to \
zero.\
\>", "MathCaption",
 CellID->468478964,ExpressionUUID->"f7d2b0e1-03fc-4731-b320-86b5f4eb53ac"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"states1", "=", 
  RowBox[{"Limit", "[", 
   RowBox[{
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{"Normalize", "/@", "states"}], ",", 
      RowBox[{
       RowBox[{"\[CapitalDelta]", ">", "0"}], "&&", 
       RowBox[{"\[CapitalOmega]R", ">", "0"}]}]}], "]"}], ",", 
    RowBox[{"\[CapitalOmega]R", "\[Rule]", "0"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"\[CapitalDelta]", ">", "0"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[7]:=",
 CellID->1679606168,ExpressionUUID->"b5f15785-3d39-481f-8c12-bb2b374b2a68"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}]}], "}"}]], "Output",
 CellLabel->"Out[7]=",
 CellID->1423019644,ExpressionUUID->"03cd085d-56da-40c3-99e4-52c255d9ac84"]
}, Open  ]],

Cell["\<\
Reorder the eigenvalues to match the unperturbed eigenvalues.\
\>", "MathCaption",
 CellID->589835931,ExpressionUUID->"8eaaf633-3b9b-4b9c-a18e-8a3a177bc070"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"energies", "=", 
    RowBox[{"energies", "\[LeftDoubleBracket]", 
     RowBox[{"Reverse", "@", 
      RowBox[{"Ordering", "@", "states1"}]}], "\[RightDoubleBracket]"}]}], 
   ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->429623164,ExpressionUUID->"fcbd21db-1354-4b78-80b7-34bdbb8440bd"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {
       RowBox[{
        FractionBox["1", "10"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"5", " ", "\[CapitalDelta]"}], "-", 
          RowBox[{
           SqrtBox["5"], " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"5", " ", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
      {
       RowBox[{
        FractionBox["1", "30"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"15", " ", "\[CapitalDelta]"}], "-", 
          RowBox[{
           SqrtBox["15"], " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"15", " ", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
      {
       RowBox[{
        FractionBox["1", "10"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"5", " ", "\[CapitalDelta]"}], "-", 
          RowBox[{
           SqrtBox["5"], " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"5", " ", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
      {"0"},
      {
       RowBox[{
        FractionBox["1", "10"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"5", " ", "\[CapitalDelta]"}], "+", 
          RowBox[{
           SqrtBox["5"], " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"5", " ", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
      {
       RowBox[{
        FractionBox["1", "30"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"15", " ", "\[CapitalDelta]"}], "+", 
          RowBox[{
           SqrtBox["15"], " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"15", " ", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]},
      {
       RowBox[{
        FractionBox["1", "10"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"5", " ", "\[CapitalDelta]"}], "+", 
          RowBox[{
           SqrtBox["5"], " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"5", " ", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["\[CapitalOmega]R", "2"]}]}]]}]}], ")"}]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[8]//MatrixForm=",
 CellID->165780069,ExpressionUUID->"ab2dedbf-540e-4047-906e-23f6cc3ded8c"]
}, Open  ]],

Cell["\<\
Here we use the correctly ordered energies to plot the level diagram for the \
energy eigenstates in the presence of the electric field.\
\>", "MathCaption",
 CellID->88210042,ExpressionUUID->"cc20972a-b76c-4d12-8433-ec9f6c17bda6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"LevelDiagram", "[", 
    RowBox[{"system", ",", 
     RowBox[{"energies", "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\[CapitalDelta]", "\[Rule]", "\[CapitalDelta]1"}], ",", 
        RowBox[{"\[CapitalOmega]R", "\[Rule]", "\[CapitalOmega]R1"}]}], 
       "}"}]}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "3.5"}], ",", "3.5"}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[CapitalDelta]1", ",", "1"}], "}"}], ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[CapitalOmega]R1", ",", "2"}], "}"}], ",", "0", ",", "5"}], 
    "}"}], ",", 
   RowBox[{"Alignment", "\[Rule]", "Center"}]}], "]"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->66370400,ExpressionUUID->"a563e203-44f3-4ec6-98e0-72d9b2500e08"],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`\[CapitalDelta]1$$ = 
    1, $CellContext`\[CapitalOmega]R1$$ = 2, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`\[CapitalDelta]1$$], 1}, -2, 2}, {{
       Hold[$CellContext`\[CapitalOmega]R1$$], 2}, 0, 5}}, Typeset`size$$ = {
    155., {106., 110.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`\[CapitalDelta]1$52891$$ = 
    0, $CellContext`\[CapitalOmega]R1$52892$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`\[CapitalDelta]1$$ = 
        1, $CellContext`\[CapitalOmega]R1$$ = 2}, "ControllerVariables" :> {
        Hold[$CellContext`\[CapitalDelta]1$$, \
$CellContext`\[CapitalDelta]1$52891$$, 0], 
        Hold[$CellContext`\[CapitalOmega]R1$$, \
$CellContext`\[CapitalOmega]R1$52892$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> 
      AtomicDensityMatrix`LevelDiagram[$CellContext`system, 
        ReplaceAll[$CellContext`energies, {$CellContext`\[CapitalDelta] -> \
$CellContext`\[CapitalDelta]1$$, $CellContext`\[CapitalOmega]R -> \
$CellContext`\[CapitalOmega]R1$$}], PlotRange -> {-3.5, 3.5}, ImageSize -> 
        Small], "Specifications" :> {{{$CellContext`\[CapitalDelta]1$$, 
          1}, -2, 2}, {{$CellContext`\[CapitalOmega]R1$$, 2}, 0, 5}}, 
      "Options" :> {Alignment -> Center}, "DefaultOptions" :> {}],
     ImageSizeCache->{255., {164., 169.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellLabel->"Out[9]=",
 CellID->1173673272,ExpressionUUID->"3e47b173-5ce5-4153-a206-61278c52b6dd"]
}, Open  ]],

Cell[TextData[{
 "We can see that sublevels with the same ",
 Cell[BoxData[
  StyleBox["M", "InlineMath"]],ExpressionUUID->
  "5e8e7099-fd53-4442-805b-4379f8c58e13"],
 " are mixed by the electric field, causing them to repel. There are no ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"M", "=", 
    RowBox[{"\[PlusMinus]", "2"}]}], "InlineMath"]],ExpressionUUID->
  "3cf66c85-351b-434a-94c5-ea4fbfeeb046"],
 " sublevels of the upper state, so the ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"M", "=", 
    RowBox[{"\[PlusMinus]", "2"}]}], "InlineMath"]],ExpressionUUID->
  "a0437237-86ce-4d39-9eec-47bbf89c9e68"],
 " sublevels of the lower state do not shift."
}], "Text",
 CellID->264880464,ExpressionUUID->"c7c584f1-7087-459c-84da-51140e2ece3a"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "TutorialMoreAboutSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "AtomicDensityMatrix Package",
         BaseStyle->"Link",
         ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]],
          "TutorialMoreAbout",ExpressionUUID->
         "26c911f8-1fbd-46ad-9ec3-e4494281a668"]}]}
     }]}
  }]], "TutorialMoreAboutSection",ExpressionUUID->"a029d1b3-2439-4c7e-9747-\
f025d7e72916"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Tech", " ", "Notes"}], 
        "RelatedTutorialsSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "Hyperfine Structure: Breit-Rabi Diagram",
         BaseStyle->"Link",
         ButtonData->
          "paclet:AtomicDensityMatrix/tutorial/\
HyperfineStructureBreitRabiDiagram"]], "RelatedTutorials",ExpressionUUID->
         "52e1376b-0ef2-4280-b9f0-f01b8aecded5"]}]}
     }]}
  }]], "RelatedTutorialsSection",ExpressionUUID->"82b4d731-76d3-4090-846e-\
62567da9d7eb"],

Cell[BoxData[""], "Input",ExpressionUUID->"6fdd7501-d2a8-413a-bb9a-4a752a70ed2a"]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"81740441-f4f8-4d3f-92bb-38eb25794f3e"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Stark Mixing",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}}, 
  "NewStyles" -> True, "CitationPopupData" -> {$Failed, ""}, "ShowCitation" -> 
  False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 18, 0, 35.299131}", 
    "history" -> {"10.07", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Tutorial", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "Electric fields cause mixing of opposite-parity atomic states, and \
consequent energy shifts. If all relevant atomic states are included in the \
system, the mixing and splitting can be found by finding the eigenvalues and \
eigenvectors of the Hamiltonian. Here we analyze a J=2 state mixed with a J=1 \
state by a z-directed electric field. This loads the package.", 
    "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$77041, "title" -> 
    "Stark Mixing", "titlemodifier" -> "", "metadescription" -> "", 
    "windowtitle" -> "Stark Mixing", "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/StarkMixing"}},
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> Notebook], 
   Cell[
    StyleData["Output"], CellContext -> Notebook], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"219072ad-0e3d-40a6-8de5-c6b09c971593"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "RasterizedOutput"->{
  Cell[23870, 667, 20306, 339, 178, "Output",ExpressionUUID->"143a8845-57ba-4bac-9957-698c69fecee8",
   CellTags->"RasterizedOutput",
   CellID->619417895]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"RasterizedOutput", 59272, 1421}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[584, 21, 5446, 131, 57, "AnchorBarGrid",ExpressionUUID->"4575657a-c193-482e-961f-8116c32fbf15",
 CellID->1],
Cell[CellGroupData[{
Cell[6055, 156, 101, 1, 63, "Title",ExpressionUUID->"17e5fe65-b3d5-403a-959c-2619c4a48e5f",
 CellID->122350],
Cell[6159, 159, 358, 6, 60, "Text",ExpressionUUID->"e9c605ba-d33e-47fd-8e43-00e8d6275b6f",
 CellID->217979270],
Cell[6520, 167, 561, 17, 36, "Text",ExpressionUUID->"bd9d4140-d6fb-4bf1-bccd-018722a41122",
 CellID->14981418],
Cell[7084, 186, 121, 1, 36, "MathCaption",ExpressionUUID->"87aec354-8328-4bac-a64a-70947644fa22",
 CellID->159403208],
Cell[7208, 189, 161, 3, 29, "Input",ExpressionUUID->"8a0c5e81-2d6d-404b-92d3-6b7cbe1a9df7",
 CellID->75905070],
Cell[7372, 194, 123, 1, 36, "MathCaption",ExpressionUUID->"62285337-d1f0-451e-b082-8547376ff75d",
 CellID->210450481],
Cell[CellGroupData[{
Cell[7520, 199, 733, 19, 48, "Input",ExpressionUUID->"6aea4082-5f70-4715-a4b4-06bfd849d54b",
 CellID->877256330],
Cell[8256, 220, 2492, 63, 89, "Output",ExpressionUUID->"f7d67c22-aba9-449b-939c-06887ab870ac",
 CellID->1004032225]
}, Open  ]],
Cell[10763, 286, 337, 7, 36, "MathCaption",ExpressionUUID->"cbd479b9-e3e5-49e7-84d2-f93e8b00f3f8",
 CellID->198653609],
Cell[CellGroupData[{
Cell[11125, 297, 568, 15, 29, "Input",ExpressionUUID->"0ddff828-5112-4833-9a7f-9e7171ab5209",
 CellID->528282370],
Cell[11696, 314, 1638, 46, 238, "Output",ExpressionUUID->"4eea07da-cca5-4c5f-b184-43b756ccbd3c",
 CellID->331283732]
}, Open  ]],
Cell[13349, 363, 190, 4, 36, "MathCaption",ExpressionUUID->"5472cdf8-9acc-4788-b3b8-a28494b4c04c",
 CellID->18473580],
Cell[CellGroupData[{
Cell[13564, 371, 261, 6, 29, "Input",ExpressionUUID->"656e3ac3-2390-4ec4-986f-29f332c7bba4",
 CellID->359462651],
Cell[13828, 379, 1076, 21, 105, "Output",ExpressionUUID->"59dfe415-4b8f-43f9-968c-0f1e30870fc5",
 CellID->64516156]
}, Open  ]],
Cell[14919, 403, 157, 2, 70, "MathCaption",ExpressionUUID->"ee6d8667-7e6a-427f-b204-111255b6e07c",
 CellID->125276603],
Cell[CellGroupData[{
Cell[15101, 409, 307, 8, 70, "Input",ExpressionUUID->"3f2f8616-a734-4898-a2c7-2285969cf87c",
 CellID->622964901],
Cell[15411, 419, 7705, 223, 233, "Output",ExpressionUUID->"269a2fca-c81a-42b3-8d60-a01017094ca5",
 CellID->1909529964]
}, Open  ]],
Cell[23131, 645, 201, 4, 70, "MathCaption",ExpressionUUID->"d4b38b1d-34c1-499b-b01a-d2ae13deebe6",
 CellID->499179070],
Cell[CellGroupData[{
Cell[23357, 653, 510, 12, 70, "Input",ExpressionUUID->"c7439010-bfcc-4cd5-88ac-9a7a333de568",
 CellID->83467549],
Cell[23870, 667, 20306, 339, 178, "Output",ExpressionUUID->"143a8845-57ba-4bac-9957-698c69fecee8",
 CellTags->"RasterizedOutput",
 CellID->619417895]
}, Open  ]],
Cell[44191, 1009, 443, 7, 70, "Text",ExpressionUUID->"d6682d75-c798-4ef4-87c8-76311cd2b537",
 CellID->271683158],
Cell[44637, 1018, 189, 4, 70, "MathCaption",ExpressionUUID->"f7d2b0e1-03fc-4731-b320-86b5f4eb53ac",
 CellID->468478964],
Cell[CellGroupData[{
Cell[44851, 1026, 564, 14, 70, "Input",ExpressionUUID->"b5f15785-3d39-481f-8c12-bb2b374b2a68",
 CellID->1679606168],
Cell[45418, 1042, 1192, 36, 55, "Output",ExpressionUUID->"03cd085d-56da-40c3-99e4-52c255d9ac84",
 CellID->1423019644]
}, Open  ]],
Cell[46625, 1081, 167, 3, 70, "MathCaption",ExpressionUUID->"8eaaf633-3b9b-4b9c-a18e-8a3a177bc070",
 CellID->589835931],
Cell[CellGroupData[{
Cell[46817, 1088, 363, 9, 70, "Input",ExpressionUUID->"fcbd21db-1354-4b78-80b7-34bdbb8440bd",
 CellID->429623164],
Cell[47183, 1099, 3431, 105, 222, "Output",ExpressionUUID->"ab2dedbf-540e-4047-906e-23f6cc3ded8c",
 CellID->165780069]
}, Open  ]],
Cell[50629, 1207, 241, 4, 70, "MathCaption",ExpressionUUID->"cc20972a-b76c-4d12-8433-ec9f6c17bda6",
 CellID->88210042],
Cell[CellGroupData[{
Cell[50895, 1215, 1011, 28, 70, "Input",ExpressionUUID->"a563e203-44f3-4ec6-98e0-72d9b2500e08",
 CellID->66370400],
Cell[51909, 1245, 2365, 45, 70, "Output",ExpressionUUID->"3e47b173-5ce5-4153-a206-61278c52b6dd",
 CellID->1173673272]
}, Open  ]],
Cell[54289, 1293, 740, 19, 70, "Text",ExpressionUUID->"c7c584f1-7087-459c-84da-51140e2ece3a",
 CellID->264880464],
Cell[55032, 1314, 725, 18, 70, "TutorialMoreAboutSection",ExpressionUUID->"a029d1b3-2439-4c7e-9747-f025d7e72916"],
Cell[CellGroupData[{
Cell[55782, 1336, 787, 21, 70, "RelatedTutorialsSection",ExpressionUUID->"82b4d731-76d3-4090-846e-62567da9d7eb"],
Cell[56572, 1359, 81, 0, 70, "Input",ExpressionUUID->"6fdd7501-d2a8-413a-bb9a-4a752a70ed2a"]
}, Open  ]]
}, Open  ]],
Cell[56680, 1363, 78, 0, 70, "FooterCell",ExpressionUUID->"81740441-f4f8-4d3f-92bb-38eb25794f3e"]
}
]
*)

(* End of internal cache information *)

