(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     90639,       2390]
NotebookOptionsPosition[     76980,       2112]
NotebookOutlinePosition[     80042,       2184]
CellTagsIndexPosition[     79962,       2179]
WindowTitle->The Rotating-Wave Approximation
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "04dc99c6-410a-4a4e-a1fd-87055396a20a"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "66be36fc-5053-493b-8401-046c118a6594"],
        Background->RGBColor[
         0.7450980392156863, 0.3254901960784314, 0.1411764705882353],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Tech Notes",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "43478ed6-03e6-41b9-8d02-0d224f2fd5e3"]
         }],ExpressionUUID->"8c342c38-7adb-4c9a-8d90-1573fd7f1781"],
         StripOnInput->False], {"\<\"Constructing the Hamiltonian\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"RelatedTutorialsSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "c73a42e1-a56a-4f53-8627-142c18bed87d"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "d43c925b-6dea-45c5-8e5e-80ddb45810de"]
         }],ExpressionUUID->"9556f59e-f577-4c94-b25f-66cc4edefcf1"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"TutorialMoreAboutSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "4d104740-f23d-42cf-9b01-041dabe56556"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Functions",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "9241ea4c-96cb-4906-b80c-14e2eba27582"]
         }],ExpressionUUID->"cd2a9e7c-ecae-40ff-9c26-87341be7e328"],
         StripOnInput->False], {"\<\"DropFastTerms\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/DropFastTerms"], \
"\<\"EffectiveHamiltonian\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/EffectiveHamiltonian"], \
"\<\"RotatingWaveApproximation\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"], \
"\<\"RotatingWaveTransformMatrix\"\>":>Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/ref/RotatingWaveTransformMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"TutorialFunction"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "f0aa6939-26a0-46bf-8183-709c268db9f2"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "b3010729-4c11-4dbe-a8e4-1f75a0bdff04"]
         }],ExpressionUUID->"699ddc6f-72f9-4311-8ddf-87fd7392da83"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/tutorial/\
TheRotatingWaveApproximation\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
              "AtomicDensityMatrix/tutorial/TheRotatingWaveApproximation"]}, 
             Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
tutorial/TheRotatingWaveApproximation.html"], StandardForm]], "Input", 
               TextClipboardType -> "PlainText"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$78366], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/tutorial/TheRotatingWaveApproximation" <> 
             ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "78e55b86-656c-4702-87b5-fa869c8bb9ba"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "889b7a89-9a20-4cdb-9129-92ac307ec03d"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"f9a9b995-e1ea-45b4-8f01-d840abd668a9"],

Cell[CellGroupData[{

Cell["The Rotating-Wave Approximation", "Title",
 CellID->509267359,ExpressionUUID->"f25bfa5d-3aca-481a-892e-a928963f8d71"],

Cell[TextData[{
 "The Hamiltonian for a light field interacting with an atomic transition has \
matrix elements that oscillate at the optical frequency. However, by a \
suitable change of basis and neglecting terms corresponding to very \
far-off-resonant  optical coupling, the time dependence can often be \
eliminated from the Hamiltonian, greatly simplifying calculations. In this \
tutorial, we discuss this approximation, known as the ",
 StyleBox["rotating-wave approximation",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellID->1534169418,ExpressionUUID->"b6153360-f181-4378-9517-e835979689e9"],

Cell["This loads the package.", "MathCaption",
 CellID->339534619,ExpressionUUID->"1ae3fc85-27c0-4557-a947-7e4e491c9a39"],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->87034352,ExpressionUUID->"b9cf74b5-c471-4bf7-8a9a-0403d84dcdf9"],

Cell["\<\
As a simple example, we consider two atomic states coupled by a near-resonant \
monochromatic light field.\
\>", "Text",
 CellID->209068752,ExpressionUUID->"bab26105-95ef-4d96-8c17-eaf9b813db4b"],

Cell["A two-level atomic system.", "MathCaption",
 CellID->70779043,ExpressionUUID->"4605791d-d841-4fe1-ae9a-4fb1645cd7af"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"Energy", "\[Rule]", "0"}], ",", 
      RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"2", ",", 
      RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
      RowBox[{"Parity", "\[Rule]", "Odd"}]}], "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->29838874,ExpressionUUID->"2543cefa-720b-49ee-8e96-5f251ba06388"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
     RowBox[{"Parity", "\[Rule]", "Odd"}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->90189934,ExpressionUUID->"33483dd4-ccf2-4594-87bd-ef74e2b8ad2f"]
}, Open  ]],

Cell[TextData[{
 "The Hamiltonian for this system interacting with a monochromatic optical \
field with frequency ",
 Cell[BoxData[
  StyleBox["\[Omega]", "InlineMath"]],ExpressionUUID->
  "10fec53d-0f2d-41fd-b71e-598fe6b1159a"],
 " and induced Rabi frequency ",
 Cell[BoxData[
  StyleBox[
   SubscriptBox["\[CapitalOmega]", "R"], "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "21163b66-262f-4782-b926-0021c2e14925"],
 "."
}], "MathCaption",
 CellID->457381827,ExpressionUUID->"8a345bf0-b6bf-427e-8f15-23d0757dcbfe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{"Hamiltonian", "[", 
     RowBox[{"sys", ",", 
      RowBox[{"ElectricField", "\[Rule]", 
       RowBox[{"OpticalField", "[", 
        RowBox[{"\[Omega]", ",", 
         RowBox[{"\[CapitalOmega]R", "/", " ", 
          RowBox[{"ReducedME", "[", 
           RowBox[{"1", ",", 
            RowBox[{"{", 
             RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], 
        "]"}]}]}], "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->692860306,ExpressionUUID->"31360a97-fe41-4707-bcec-91cca0e60590"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]R"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]R"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "\[Omega]0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[3]//MatrixForm=",
 CellID->1550829805,ExpressionUUID->"47e062b4-2950-4b18-84c2-836a40463d25"]
}, Open  ]],

Cell["\<\
If we write the matrix elements of the light-atom interaction Hamiltonian in \
terms of exponentials, rather than trigonometric functions, each off-diagonal \
matrix element is composed of two terms.\
\>", "Text",
 CellID->395087951,ExpressionUUID->"d0c4e520-1718-4286-96b5-a2a957cfaea5"],

Cell["The Hamiltonian expressed in terms of exponential functions.", \
"MathCaption",
 CellID->114000830,ExpressionUUID->"ac9dc825-61a1-4506-b5a7-2e20307e435c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "//", "TrigToExp"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->9490531,ExpressionUUID->"c0cf329d-64f8-43ad-ba4a-7e0a1842b195"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]R"}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]R"}]}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]R"}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]R"}]}], "\[Omega]0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[4]//MatrixForm=",
 CellID->109698176,ExpressionUUID->"efdeb85c-c810-4f49-ad8f-cbca4b4c6d1e"]
}, Open  ]],

Cell["\<\
We can show that, for each of these matrix elements, one of the terms induces \
a near-resonant coupling, while the other induces a far-off-resonant coupling.\
\>", "Text",
 CellID->87359988,ExpressionUUID->"fa22b2d7-20c4-410b-a316-821d4fca8634"],

Cell[TextData[{
 "Consider one of the matrix elements written above: ",
 "\n\t",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    StyleBox["\[LeftAngleBracket]", "InlineMath"], 
    RowBox[{
     StyleBox["0", "InlineMath"], 
     StyleBox["|", "InlineMath"], 
     StyleBox["H", "InlineMath"], 
     StyleBox["|", "InlineMath"], 
     SubscriptBox[
      StyleBox["\[Omega]", "InlineMath"], "0"]}], 
    StyleBox["\[RightAngleBracket]", "InlineMath"]}], 
   StyleBox["=", "InlineMath"], 
   StyleBox[
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", "2"]}], 
     SubscriptBox["\[CapitalOmega]", "R"], 
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"0", "|", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]", " ", "t"}]], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}], "|", 
       SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}]}], 
    "InlineMath"]}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "4dc1517a-9846-47e8-a946-8ba3d50635bb"],
 ","
}], "Text",
 CellID->383056238,ExpressionUUID->"ac695e52-4369-487e-8453-9970b349e9d2"],

Cell[TextData[{
 "where ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"\[VerticalSeparator]", "0"}], "\[RightAngleBracket]"}], 
   TraditionalForm]], "InlineMath",ExpressionUUID->
  "da5f57c1-670f-4c02-ac57-fe08c4b6fbb7"],
 " is the lower state with energy zero, and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"\[VerticalSeparator]", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   TraditionalForm]], "InlineMath",ExpressionUUID->
  "fd658ec0-6ad7-4e06-b7de-43e669d06f42"],
 " is the upper state with energy ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Omega]", "0"], TraditionalForm]], "InlineMath",
  ExpressionUUID->"12f835f4-4c31-4854-af49-a5ff1f21079c"],
 ". For a near-resonant transition, the energy of the state ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"H", "\[VerticalSeparator]", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   TraditionalForm]], "InlineMath",ExpressionUUID->
  "18edba5a-ecf4-4a14-bcbf-5aa6bef5b9f3"],
 " should be close to that of ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"\[VerticalSeparator]", "0"}], "\[RightAngleBracket]"}], 
   TraditionalForm]], "InlineMath",ExpressionUUID->
  "26c9a610-b09e-4b4d-b49c-a76ad54d5616"],
 ", i.e., zero. "
}], "Text",
 CellID->74222856,ExpressionUUID->"09652ea1-cc68-48df-ab2c-a98812c6fc72"],

Cell[TextData[{
 "First we consider the term ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]], "|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "d4043b8e-10c9-44cf-a5dd-06febed73a3a"],
 ". Applying the energy operator ",
 Cell[BoxData[
  FormBox[
   RowBox[{"E", "=", 
    RowBox[{"\[ImaginaryI]", " ", 
     FractionBox["d", 
      RowBox[{"d", " ", "t"}]]}]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"333fc15f-545d-4b3c-ac16-a148fc44a3c7"],
 " (with ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[HBar]", "=", "0"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"df699e82-666b-453c-a205-e23426ff2cb0"],
 "), we have\n\t",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[ImaginaryI]", 
      FractionBox["d", 
       RowBox[{"d", "\[VeryThinSpace]", "t"}]]}], ")"}], 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}], "InlineMath"]],
  ExpressionUUID->"e4ddbec7-ac26-437d-91a0-a3ddd167e4cd"],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "431d6979-b03a-4056-ad7a-cb3ba154f39b"],
 Cell[BoxData[
  StyleBox[
   RowBox[{" ", "="}], "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "0ca32a4c-ad7c-471a-a2a2-3b0037df0053"],
 Cell[BoxData[
  StyleBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"-", "\[Omega]"}], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}]}], 
   "InlineMath"]],ExpressionUUID->"632dd5e1-8c0b-4ed2-b1f1-8e32b90fed3a"],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "658abfec-e085-4501-82ee-9d0ad8c853d4"],
 " ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"+", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}], "InlineMath"]], 
  "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "583f73a1-ea6c-4891-8844-d8344db7e80b"],
 Cell[BoxData[
  StyleBox[
   RowBox[{"(", 
    RowBox[{"\[ImaginaryI]", 
     FractionBox["d", 
      RowBox[{"d", "\[VeryThinSpace]", "t"}]]}], ")"}], "InlineMath"]],
  ExpressionUUID->"27a149f7-9315-4e80-b260-622699fc1689"],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "bd69eccd-0bce-4fd6-a116-89f97a616462"],
 "\n\t\t\t",
 Cell[BoxData[
  StyleBox["=", "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "bc3ef036-3b58-4edc-8398-fb782179c270"],
 Cell[BoxData[
  StyleBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"-", "\[Omega]"}], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}]}], 
   "InlineMath"]],ExpressionUUID->"0808d7a1-9544-44c0-8d12-9dba9370eea1"],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "c513af8e-57e0-4be0-a816-ae4f188a2ab1"],
 " ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"+", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}], "InlineMath"]], 
  "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "28410e6f-a637-466f-b923-667e776890c8"],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"E", "|", 
       SubscriptBox["\[Omega]", "0"]}]}], "\[RightAngleBracket]"}], ")"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "8df6c7c6-dc52-43c7-a606-a3f03f41d418"],
 "\n\t\t\t",
 Cell[BoxData[
  StyleBox["=", "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "5c61dfcb-d142-4724-ba46-cd543c3322e1"],
 Cell[BoxData[
  StyleBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"-", "\[Omega]"}], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}]}], 
   "InlineMath"]],ExpressionUUID->"1745076e-6188-4d8a-98eb-4645165577b4"],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "cde4d087-8b4d-4460-8b80-7d40c8ebf606"],
 " ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"+", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}], "InlineMath"]], 
  "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "97f2b9ed-e150-4538-8a8e-d9a8e8c62afb"],
 Cell[BoxData[
  StyleBox[
   SubscriptBox["\[Omega]", "0"], "InlineMath"]],ExpressionUUID->
  "2cd2287d-f107-44d2-b8cf-79ab122862c8"],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "38fa8d98-c323-4bae-a832-88858f16823f"],
 " \n\t\t\t",
 Cell[BoxData[
  StyleBox["=", "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "14486e4c-8370-48ac-8081-76e0a3a9af6f"],
 Cell[BoxData[
  RowBox[{
   StyleBox[" ", "InlineMath"], 
   RowBox[{
    RowBox[{
     StyleBox["(", "InlineMath"], 
     RowBox[{
      SubscriptBox[
       StyleBox["\[Omega]", "InlineMath"], "0"], 
      StyleBox["-", "InlineMath"], 
      StyleBox["\[Omega]", "InlineMath"]}], 
     StyleBox[")", "InlineMath"]}], 
    StyleBox[" ", "InlineMath"], 
    StyleBox[
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]], 
     "InlineMath"]}]}]],ExpressionUUID->
  "8a81d602-0842-49a9-ba11-707d44211b21"],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "7676d4ef-485b-4760-95af-2631ef0288cf"]
}], "Text",
 CellID->408772018,ExpressionUUID->"76b2da9a-46c2-4de8-9377-f1656cd6695b"],

Cell[TextData[{
 "In other words, the energy of ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]], "|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "0afd6902-ae6a-4f91-bb0a-d99e784c3d22"],
 " is ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox[
    StyleBox["\[Omega]", "InlineMath"], "0"], 
   StyleBox["-", "InlineMath"], 
   StyleBox["\[Omega]", "InlineMath"]}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "8050b5bd-a734-434f-ab56-5267a46c6104"],
 ", which, if ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    SubscriptBox["\[Omega]", "0"], "\[TildeTilde]", "\[Omega]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "4380cef7-c656-4147-9cfe-ea43aea416b4"],
 ", is near zero, the energy of the state ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", "0"}], "\[RightAngleBracket]"}], "InlineMath"]], 
  "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "e8ac5db6-b1ec-4f52-9158-c4c35d56db3b"],
 ". Thus, if ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["\[Omega]", "InlineMath"], "0"], 
    StyleBox["-", "InlineMath"], 
    StyleBox["\[Omega]", "InlineMath"]}], 
   StyleBox["\[LessTilde]", "InlineMath"], 
   StyleBox["\[CapitalGamma]", "InlineMath"]}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "1c7298a7-b198-4c25-88c6-6c3552eb2402"],
 ", where \[CapitalGamma] is the line width of the upper state, the term ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{"0", "|", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]], "|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "31640d96-032c-4a01-b436-f3f904dfd5d7"],
 " represents a resonant transition, for which energy is conserved. On the \
other hand, performing a calculation similar to the above, we find that the \
energy of ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]", " ", "t"}]], "|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "08edae66-e171-4492-b69d-ace31af0f0ad"],
 " is ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox[
    StyleBox["\[Omega]", "InlineMath"], "0"], "+", 
   StyleBox["\[Omega]", "InlineMath"]}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "5302d1bb-16b9-4e60-b745-0683d874bd3f"],
 ". If ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    SubscriptBox["\[Omega]", "0"], "\[TildeTilde]", "\[Omega]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "fb847184-f63e-4eee-bef4-152bb0511a7b"],
 ", then this energy is much greater than the energy of the lower state (",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["\[Omega]", "InlineMath"], "0"], "+", 
    StyleBox["\[Omega]", "InlineMath"]}], 
   StyleBox[">>", "InlineMath"], 
   StyleBox["\[CapitalGamma]", "InlineMath"]}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "2629e438-a81f-4276-85ee-c6bd094bc863"],
 " for optical frequencies). The term ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{"0", "|", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]", " ", "t"}]], "|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "cc1df12f-876b-493b-9add-b0ef50702d3f"],
 " represents a far-off-resonant transition. This sort of transition is \
highly suppressed, and can be neglected."
}], "Text",
 CellID->131956570,ExpressionUUID->"be0a5aae-98c5-4c9c-820e-1f3010956df5"],

Cell["\<\
We can visualize the situation by drawing a level diagram, and indicating the \
resonant and off-resonant couplings.\
\>", "Text",
 CellID->119515781,ExpressionUUID->"89c309d0-d88f-4aaf-a703-d7291f8915af"],

Cell["\<\
Level diagram for the system, showing both resonant and off-resonant \
couplings.\
\>", "MathCaption",
 CellID->295356471,ExpressionUUID->"a81161d9-7860-47c6-a0eb-0c4d041a0986"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"h", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Omega]0", "\[Rule]", "1"}], ",", 
      RowBox[{"\[Omega]", "\[Rule]", "0.9"}]}], "}"}]}], ",", 
   RowBox[{"SuppressOffResonantCouplings", "\[Rule]", "False"}], ",", 
   RowBox[{"ParityOffset", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->738472575,ExpressionUUID->"09aa60fd-5a29-4eff-bf4d-c572c7280851"],

Cell[BoxData[
 GraphicsBox[{{{{{}, LineBox[{{-0.9, 0.}, {-0.09999999999999998, 0.}}]}, {{}, 
      LineBox[{{0.09999999999999998, 1.}, {0.9, 1.}}]}}, {}, {}, 
    {EdgeForm[Hue[0.61, 0.54, 0.56]], FaceForm[None]}, 
    {RGBColor[0.9, 0.01, 0.01], 
     Arrowheads[{-0.0888888888888889, 0.0888888888888889}], 
     ArrowBox[{{-0.42, 0.}, {0.42, 0.9}}], 
     ArrowBox[{{-0.42, 0.}, {0.42, -0.9}}]}}, {{{{}, {}}, {{}, {}}}, {}, {}, 
    {EdgeForm[Hue[0.61, 0.54, 0.56]], FaceForm[None]}, 
    {RGBColor[0.9, 0.01, 0.01], 
     Arrowheads[{-0.0888888888888889, 0.0888888888888889}], {}, {}}}},
  ImageSize->{{350}, {100}}]], "Output",
 CellLabel->"Out[5]=",
 CellID->1031612852,ExpressionUUID->"42452252-5a87-461e-994f-d9a6c43c7ce4"]
}, Open  ]],

Cell[TextData[{
 "One arrow, pointing up from the lower level, nearly matches the separation \
between the lower and upper states, and represents an optical field detuned \
by ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Omega]", "-", 
    SubscriptBox["\[Omega]", "0"]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"a41c9b96-dbbd-47d3-88dc-b63b9dfa8647"],
 " from resonance. The other arrow points down from the lower level, and \
couples the lower level to a point far below resonance (by an amount ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Omega]", "+", 
    SubscriptBox["\[Omega]", "0"]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"700f59eb-a8d8-4bea-8e7b-fd87957e3a45"],
 ") with the excited state."
}], "Text",
 CellID->67742302,ExpressionUUID->"6ee5ace9-5b3a-4faa-b20c-9047b383cd23"],

Cell["\<\
In order to see how we might remove the optical frequencies from the \
Hamiltonian, we first consider a physically analogous situation \[LongDash] \
that of a spin 1/2 atomic system subject to an oscillating magnetic field.\
\>", "Text",
 CellID->5846930,ExpressionUUID->"97b2357f-360b-4f73-9c3a-2294c6f0145d"],

Cell["\<\
Define a second system consisting of the Zeeman sublevels of a spin-1/2 state.\
\>", "MathCaption",
 CellID->240378968,ExpressionUUID->"e54c6728-b976-4c72-9937-f3fdf33ea028"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys2", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", 
       RowBox[{"1", "/", "2"}]}], ",", 
      RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->76640165,ExpressionUUID->"9fe2832f-de09-493c-ae35-1dcc8e72fb9a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      FractionBox["1", "2"]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", 
       FractionBox["1", "2"]}]}]}], "]"}]}], "}"}]], "Output",
 CellLabel->"Out[6]=",
 CellID->1242226802,ExpressionUUID->"9fb180a0-7f40-47a2-997d-940b0c812079"]
}, Open  ]],

Cell[TextData[{
 "The Hamiltonian for this system subject to an oscillating magnetic field \
directed along ",
 StyleBox["x",
  FontSlant->"Italic"],
 " and a static magnetic field directed along ",
 StyleBox["z",
  FontSlant->"Italic"],
 " is formally identical to the optically coupled two-level system above \
(allowing for an arbitrary shift in the zero reference energy by adding a \
constant term to the diagonal)."
}], "Text",
 CellID->207411124,ExpressionUUID->"31ff8cd2-d65b-4824-9612-f08c9c27eaab"],

Cell[TextData[{
 "Find the Hamiltonian for this system interacting with a magnetic field \
directed along ",
 StyleBox["x",
  FontSlant->"Italic"],
 " and oscillating with frequency \[Omega]."
}], "MathCaption",
 CellID->311487406,ExpressionUUID->"ef0e02f6-546e-4d83-8096-91a9f315339c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h2", "=", 
    RowBox[{
     RowBox[{"Hamiltonian", "[", 
      RowBox[{"sys2", ",", 
       RowBox[{"MagneticField", "\[Rule]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], "\[CapitalOmega]L", " ", 
            RowBox[{"Cos", "[", 
             RowBox[{"\[Omega]", " ", "t"}], "]"}]}], ",", "0", ",", 
           RowBox[{"-", "\[Omega]0"}]}], "}"}], "/", 
         RowBox[{"(", 
          RowBox[{"BohrMagneton", "  ", 
           RowBox[{"GFactor", "[", "1", "]"}]}], ")"}]}]}]}], "]"}], "//", 
     "TrigToExp"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->253774865,ExpressionUUID->"5a6b3ce5-f829-405a-b898-799bc3337e5c"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", 
       FractionBox["\[Omega]0", "2"]}], 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]L"}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]L"}]}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]L"}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]L"}]}], 
      FractionBox["\[Omega]0", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[7]//MatrixForm=",
 CellID->325211587,ExpressionUUID->"47cd0391-f8f4-46d8-95b3-11cede15f9bd"]
}, Open  ]],

Cell[TextData[{
 "The x-directed oscillating magnetic field can be thought of as the sum of \
two counter-rotating magnetic fields, one rotating clockwise around the ",
 StyleBox["z",
  FontSlant->"Italic"],
 "-axis and the other rotating counterclockwise. Each term in the \
off-diagonal elements of the Hamiltonian corresponds to one or the other of \
the rotating fields. "
}], "Text",
 CellID->52559842,ExpressionUUID->"0cc35dd3-cd96-4fb7-a6cd-c86ab82bdec0"],

Cell[TextData[{
 "Physically, we expect that if we transform into a frame rotating about the ",
 StyleBox["z",
  FontSlant->"Italic"],
 "-axis at frequency \[Omega], the component of the magnetic field that the \
frame is co-rotating with will appear static, while the counter-rotating \
field will appear to rotate at twice the frequency it has in the non-rotating \
frame. The unitary transformation required to perform this task is given by \
the matrix for rotations about the z axis:"
}], "Text",
 CellID->244684399,ExpressionUUID->"9da5b30c-71c4-43d5-a010-3fc62e3e3644"],

Cell[TextData[{
 "Matrix for rotation by an angle ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"-", "\[Omega]"}], " ", "t"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"ed49c867-9ca3-4607-a48a-739aabb81d17"],
 " about the ",
 StyleBox["z",
  FontSlant->"Italic"],
 "-axis."
}], "MathCaption",
 CellID->23996460,ExpressionUUID->"06afec6e-aae7-4f96-b8a4-93735328bb45"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"u2", "=", 
    RowBox[{"WignerD", "[", 
     RowBox[{"sys2", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[Omega]"}], " ", "t"}], ",", "0", ",", "0"}], "}"}]}],
      "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->191574436,ExpressionUUID->"063ba6a2-4275-4e14-b0db-00ce4f0f1e5a"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}], "2"]], "0"},
     {"0", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", "\[ImaginaryI]", " ", "t", " ", 
        "\[Omega]"}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[8]//MatrixForm=",
 CellID->398402687,ExpressionUUID->"532c42c3-287c-470a-a4b1-e223f64e76b0"]
}, Open  ]],

Cell[TextData[{
 "There is a slight complication in applying the transform to the \
Hamiltonian, however, due to the time dependence of the unitary \
transformation. We would like the transformed Hamiltonian to have the \
properties of a Hamiltonian, i.e., to satisfy the Schr\[ODoubleDot]dinger \
equation ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"H", "|", "\[Psi]"}], "\[RightAngleBracket]"}], "=", 
    RowBox[{"\[ImaginaryI]", " ", 
     FractionBox["d", 
      RowBox[{"d", " ", "t"}]]}]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"334d00a7-79cc-4389-a197-f97f387cb5f6"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"|", "\[Psi]"}], "\[RightAngleBracket]"}], TraditionalForm]], 
  "InlineMath",ExpressionUUID->"0667ae6e-bfc0-4847-b1a8-7ef752d97895"],
 " in the rotating frame. The fact that the rotating frame is non-inertial, \
however, means that the Schr\[ODoubleDot]dinger equation must be modified by \
a correction term, analogous to the fictitious force used in classical \
mechanics to account for the modifications that Newton's laws undergo in an \
accelerating frame. Alternatively, it is more convenient to define a modified \
effective Hamiltonian in the rotating frame, so that the \
Schr\[ODoubleDot]dinger equation is the same in all frames. If we define a \
modified effective Hamiltonian in the rotating frame by ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["H", "eff"], "=", 
    RowBox[{
     RowBox[{
      SuperscriptBox["U", "\[Dagger]"], " ", "H", " ", "U"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", 
      SuperscriptBox["U", "\[Dagger]"], " ", 
      FractionBox["dU", "dt"]}]}]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"e1f4d3c5-2847-43a2-bb77-a2d23ca244a9"],
 ", it can be easily shown, starting from the Schr\[ODoubleDot]dinger \
equation in the stationary frame, that this results in the same form for the \
Schr\[ODoubleDot]dinger equation in both the stationary and rotating frames."
}], "Text",
 CellID->305054736,ExpressionUUID->"f2199bda-cfe0-4786-84c0-078a32506f7e"],

Cell["Find the effective Hamiltonian in the rotating frame.", "MathCaption",
 CellID->216972968,ExpressionUUID->"b3e19c8d-6a21-4daf-92d5-9dc2aed1a3bf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox["u2", "\[Dagger]"], ".", "h2", ".", "u2"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{
       SuperscriptBox["u2", "\[Dagger]"], ".", 
       RowBox[{"D", "[", 
        RowBox[{"u2", ",", "t"}], "]"}]}]}]}], "//", "ComplexExpand"}], "//", 
   "TrigToExp"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->331600442,ExpressionUUID->"89a3ff74-c7d0-44d7-bf94-63dd79168755"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["\[Omega]", "2"], "-", 
       FractionBox["\[Omega]0", "2"]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "t", " ", 
          "\[Omega]"}]], " ", "\[CapitalOmega]L"}]}]},
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ",
         "\[CapitalOmega]L"}]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[Omega]", "2"]}], "+", 
       FractionBox["\[Omega]0", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[9]//MatrixForm=",
 CellID->1492611582,ExpressionUUID->"661c592f-10d6-46d1-b513-253bba6c5aec"]
}, Open  ]],

Cell[TextData[{
 "The function ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["EffectiveHamiltonian"]], 
    "paclet:AtomicDensityMatrix/ref/EffectiveHamiltonian", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "3a968565-5c85-441e-9e57-e69eed08b315"],
 " can be used to give the same result."
}], "MathCaption",
 CellID->270489364,ExpressionUUID->"81d6743a-c70b-4c32-a108-62a29062263f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EffectiveHamiltonian", "[", 
    RowBox[{"h2", ",", "u2", ",", "t"}], "]"}], "//", "Expand"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->391661896,ExpressionUUID->"da8bf4c1-a8a8-4d3c-ac22-9ee0dd7b93b3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["\[Omega]", "2"], "-", 
       FractionBox["\[Omega]0", "2"]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "t", " ", 
          "\[Omega]"}]], " ", "\[CapitalOmega]L"}]}]},
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ",
         "\[CapitalOmega]L"}]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[Omega]", "2"]}], "+", 
       FractionBox["\[Omega]0", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[10]//MatrixForm=",
 CellID->1820970491,ExpressionUUID->"c60ed043-c3c6-4d2d-bcac-415d5d59e939"]
}, Open  ]],

Cell["\<\
We see that transforming the Hamiltonian to the effective rotating-frame \
Hamiltonian has two effects: the oscillation frequencies in the off-diagonal \
elements are shifted by \[Omega], and the energy splitting between the \
diagonal terms is shifted by the same amount. This second effect is a result \
of the correction term in the formula for the effective Hamiltonian.\
\>", "Text",
 CellID->319046361,ExpressionUUID->"48332734-743e-4dbe-a273-691a1cc3ec88"],

Cell["\<\
In the optical case that we considered initially, the analogous unitary \
transformation does not have the same physical interpretation as taking the \
stationary frame to a rotating frame. Nonetheless, on the strength of the \
analogy, we continue to refer to the transformed frame as a rotating frame.\
\>", "Text",
 CellID->119866632,ExpressionUUID->"7ace1f84-058d-4311-9fb3-289e96d451e3"],

Cell[TextData[{
 "In constructing the unitary transformation matrix for the optical case, we \
can think of shifting the upper state down by a frequency \[Omega] in order \
to simultaneously shift the optical frequency in the resonant coupling term \
to zero. The unitary transformation is then written as ",
 Cell[BoxData[
  FormBox[
   RowBox[{"U", "=", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", "t", " ", "D"}]]}], TraditionalForm]], 
  "InlineMath",ExpressionUUID->"709241a8-8f44-496f-bc02-8a32e3ee5184"],
 ", where ",
 Cell[BoxData[
  FormBox["D", TraditionalForm]], "InlineMath",ExpressionUUID->
  "a39d7562-b4b5-4bd4-bcc7-1361b1573bf1"],
 " is a diagonal matrix with the desired energy shift for each atomic state \
on the diagonal:"
}], "Text",
 CellID->12796374,ExpressionUUID->"fa173661-fac0-4509-b1e8-a2ab45cb9ff9"],

Cell["\<\
The unitary matrix for transformation to the interaction frame in the optical \
case.\
\>", "MathCaption",
 CellID->568113300,ExpressionUUID->"4e12f8c9-4479-4bd4-8bb8-33466cef55bb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"u", "=", 
    RowBox[{"MatrixExp", "[", 
     RowBox[{"\[ImaginaryI]", " ", "t", " ", 
      RowBox[{"DiagonalMatrix", "[", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "\[Omega]"}]}], "}"}], "]"}]}], "]"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->186586323,ExpressionUUID->"ba3b9496-954d-45c9-a940-4920a8b5e660"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[11]//MatrixForm=",
 CellID->1440598470,ExpressionUUID->"ed6267bb-69c3-4b72-aa3a-373171e9040e"]
}, Open  ]],

Cell["\<\
The unitary matrix that we find by this method is equivalent to the one used \
in the spin-1/2 case, up to an overall phase factor. We then find the \
effective Hamiltonian in the rotating frame:\
\>", "Text",
 CellID->5994744,ExpressionUUID->"36ee0739-1a9f-4d9d-b2fe-b6f8ffa0d24b"],

Cell[TextData[{
 "Apply ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["EffectiveHamiltonian"]], 
    "paclet:AtomicDensityMatrix/ref/EffectiveHamiltonian", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "592f3ae2-61a0-4927-bbb1-d99611df9c8d"],
 " to the stationary frame and chosen unitary matrix."
}], "MathCaption",
 CellID->398631076,ExpressionUUID->"b84210ee-291e-45ab-8713-fe79d31981a4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"hEff", "=", 
    RowBox[{
     RowBox[{"EffectiveHamiltonian", "[", 
      RowBox[{"h", ",", "u", ",", "t"}], "]"}], "//", "TrigToExp"}]}], ")"}], 
  "//", "MatrixForm"}]], "Input",
 CellLabel->"In[12]:=",
 CellID->222156589,ExpressionUUID->"0e862307-f06b-4bbc-8777-096e9761e772"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]R", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "t", " ", 
          "\[Omega]"}]], " ", "\[CapitalOmega]R"}]}]},
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]R", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ",
         "\[CapitalOmega]R"}]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", "\[Omega]0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[12]//MatrixForm=",
 CellID->158297418,ExpressionUUID->"fde9084a-a397-4b99-a29e-4ec9ba496cec"]
}, Open  ]],

Cell[TextData[{
 "The level diagram helps us visualize what we have accomplished. The upper \
state has been shifted down by the optical frequency \[Omega], so that it now \
is only ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Omega]", "0"], "-", "\[Omega]"}], TraditionalForm]], 
  "InlineMath",ExpressionUUID->"be2f1644-10b2-4492-8be9-05310aee91b7"],
 " above the lower state. The frequencies of the two optical fields have been \
shifted by the same amount, so that the frequency of one of them is zero (the \
two ends of the arrow are at the same energy) and the frequency of the other \
is ",
 Cell[BoxData[
  FormBox[
   RowBox[{"2", " ", "\[Omega]"}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"10b23ab3-1351-4ebc-935a-fe7dffa44d82"],
 ". Note, however, that each field has the same detuning from resonance as it \
did in the stationary frame: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Omega]", "0"], "-", "\[Omega]"}], TraditionalForm]], 
  "InlineMath",ExpressionUUID->"47e3f251-b6b4-4af9-b4aa-925d729aeb87"],
 " below resonance for the near-resonant field, and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Omega]", "+", 
    SubscriptBox["\[Omega]", "0"]}], TraditionalForm]], "InlineMath",
  ExpressionUUID->"47252dd8-673a-404b-ac21-cae81c93da34"],
 " below resonance for the off-resonant field."
}], "Text",
 CellID->1668820,ExpressionUUID->"5c7ba479-8d23-4080-8a8a-97fac3eef523"],

Cell["\<\
Level diagram for the system in the rotating frame, showing both resonant and \
off-resonant couplings.\
\>", "MathCaption",
 CellID->77373423,ExpressionUUID->"02ea66d2-9a67-419d-9ee9-13a90c7f5299"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"sys", ",", 
   RowBox[{
    RowBox[{"EffectiveHamiltonian", "[", 
     RowBox[{"h", ",", 
      RowBox[{"MatrixExp", "[", 
       RowBox[{"\[ImaginaryI]", " ", "t", " ", 
        RowBox[{"DiagonalMatrix", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "\[Omega]1"}]}], "}"}], "]"}]}], "]"}], ",", "t"}], 
     "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Omega]0", "\[Rule]", "1"}], ",", 
      RowBox[{"\[Omega]", "\[Rule]", "0.9"}], ",", 
      RowBox[{"\[Omega]1", "\[Rule]", "0.901"}]}], "}"}]}], ",", 
   RowBox[{"SuppressOffResonantCouplings", "\[Rule]", "False"}], ",", 
   RowBox[{"ParityOffset", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->230965145,ExpressionUUID->"3fd1f537-c5b3-4d8e-ad86-df7d7a23727a"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3QlUVGUbB3DPpwkaKu6KuGEqiVquoZXmQlauoahlWnpASAuOJmopKuae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    "], {{0, 100.}, {95., 0}}, {0, 255},
    ColorFunction->RGBColor,
    ImageResolution->{144., 144.},
    SmoothingQuality->"High"],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{95., 100.},
  PlotRange->{{0, 95.}, {0, 100.}}]], "Output",
 CellTags->"RasterizedOutput",
 CellLabel->"Out[13]=",
 CellID->268101009,ExpressionUUID->"bf49993e-9c64-4b95-b40f-e99e0c0ef953"]
}, Open  ]],

Cell["\<\
Finally, we note that, in a typical atomic system, the far-off-resonant terms \
(those that oscillate at twice the optical frequency in the effective \
Hamiltonian) lead to excitations that are so weak that the terms can be \
neglected to an excellent approximation. This is the rotating-wave \
approximation.\
\>", "Text",
 CellID->8916765,ExpressionUUID->"4eb76054-dac0-4414-bba7-cd2d177702eb"],

Cell[TextData[{
 "The function ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["DropFastTerms"]], 
    "paclet:AtomicDensityMatrix/ref/DropFastTerms", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "818fb2f6-d682-406d-8495-b53967e62ce9"],
 " sets terms that oscillate at twice the optical frequency to zero."
}], "MathCaption",
 CellID->131611831,ExpressionUUID->"914278a0-e4d8-426e-a5f5-59aa44031456"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"hRWA", "=", 
    RowBox[{"DropFastTerms", "[", 
     RowBox[{"hEff", ",", "\[Omega]", ",", "t"}], "]"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->612776079,ExpressionUUID->"50813666-dd57-4b94-b553-206ecfaa2c3a"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", "\[Omega]0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[14]//MatrixForm=",
 CellID->1925914466,ExpressionUUID->"0f70edc5-25d1-4cc0-97b7-2d597ac43fea"]
}, Open  ]],

Cell[TextData[{
 "In the case considered here, we have eliminated all time dependence from \
the Hamiltonian. Furthermore, when written in terms of the optical detuning \
",
 Cell[BoxData[
  StyleBox["\[CapitalDelta]", "InlineMath"]],ExpressionUUID->
  "31045240-dcc2-4a5f-9029-b024bd20cbe0"],
 ", there is no longer any explicit dependence on either the optical or \
transition frequency."
}], "Text",
 CellID->618247489,ExpressionUUID->"6bd02dbf-a254-48c3-9c84-466756158425"],

Cell["\<\
Write the optical frequency in terms of detuning \[CapitalDelta] from \
resonance.\
\>", "MathCaption",
 CellID->494812334,ExpressionUUID->"c2a76ebf-82a0-4792-be14-47ee060bd0c9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"hRWA", "/.", 
   RowBox[{"\[Omega]", "\[Rule]", 
    RowBox[{"\[Omega]0", "+", "\[CapitalDelta]"}]}]}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[15]:=",
 CellID->190456385,ExpressionUUID->"8d9d3db4-6291-4064-b465-9a778eb62a49"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}], 
      RowBox[{"-", "\[CapitalDelta]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[15]//MatrixForm=",
 CellID->1377290753,ExpressionUUID->"912b4679-aa6f-4f37-aa8f-35acba022b5a"]
}, Open  ]],

Cell["\<\
All succeeding calculations can be performed using this approximate effective \
Hamiltonian, and the results can be transformed back into the stationary \
frame, if necessary.\
\>", "Text",
 CellID->713011104,ExpressionUUID->"f7c84ba0-1150-4863-8316-2e61a81fe4f2"],

Cell[TextData[{
 "In order to make the procedure more convenient, functions are available \
that perform the various steps of the rotating-wave approximation \
automatically. ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["RotatingWaveTransformMatrix"]], 
    "paclet:AtomicDensityMatrix/ref/RotatingWaveTransformMatrix", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "90c4ee60-47a2-426f-834b-162ec27846cc"],
 " can be used to automatically create an appropriate transformation matrix \
for going to the rotating frame. ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["RotatingWaveApproximation"]], 
    "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "9e4e8e20-0950-42cf-b062-818131e813ed"],
 " can call this function, perform the transformation, and drop the \
fast-oscillating terms, thus implementing the RWA in one step."
}], "Text",
 CellID->33346025,ExpressionUUID->"126231a0-1bc5-4fb9-bd4b-5e267e8ce3ce"],

Cell[BoxData[GridBox[{
   {
    RowBox[{
     TemplateBox[{
       Cell[
        TextData["EffectiveHamiltonian"]], 
       "paclet:AtomicDensityMatrix/ref/EffectiveHamiltonian", 
       "AtomicDensityMatrix Package Symbol"},
      "PackageLink",
      BaseStyle->{"DefinitionBox", CellFrame -> 0}], "[", 
     RowBox[{
      StyleBox["h", "TI"], ",", 
      StyleBox["u", "TI"], ",", 
      StyleBox["t", "TI"]}], "]"}], Cell[TextData[{
     "apply the unitary transformation matrix ",
     Cell[BoxData[
      StyleBox["u", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "481e8873-84b3-480a-925a-8bc36253ff3e"],
     " to the Hamiltonian ",
     Cell[BoxData[
      StyleBox["h", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "d3dd3d35-e4ef-49d7-860f-71938b4b15a4"],
     ", assuming time variable ",
     Cell[BoxData[
      StyleBox["t", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "3114e7fc-3889-462e-9988-2ce3de34ac13"]
    }], "TableText",ExpressionUUID->"d0f869fa-5dfa-4f1b-80ba-7679977bbfc7"]},
   {
    RowBox[{
     TemplateBox[{
       Cell[
        TextData["DropFastTerms"]], 
       "paclet:AtomicDensityMatrix/ref/DropFastTerms", 
       "AtomicDensityMatrix Package Symbol"},
      "PackageLink",
      BaseStyle->{"DefinitionBox", CellFrame -> 0}], "[", 
     RowBox[{
      StyleBox["h", "TI"], ",", 
      StyleBox["\[Omega]", "TR"], ",", 
      StyleBox["t", "TI"]}], "]"}], Cell[TextData[{
     "drop terms from ",
     Cell[BoxData[
      StyleBox["h", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "45900992-8215-4d90-9dcc-6e5439957389"],
     " that oscillate at twice the frequency ",
     Cell[BoxData[
      StyleBox["\[Omega]", "TR"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "010655b3-1f86-4324-bfdd-4e3a128da739"]
    }], "TableText",ExpressionUUID->"63a8d384-656e-4828-8d01-f1f91ddf3e92"]},
   {
    RowBox[{
     TemplateBox[{
       Cell[
        TextData["RotatingWaveTransformMatrix"]], 
       "paclet:AtomicDensityMatrix/ref/RotatingWaveTransformMatrix", 
       "AtomicDensityMatrix Package Symbol"},
      "PackageLink",
      BaseStyle->{"DefinitionBox", CellFrame -> 0}], "[", 
     RowBox[{
      StyleBox["sys", "TI"], ",", 
      StyleBox["\[Omega]", "TR"]}], "]"}], Cell[TextData[{
     "automatically (for simple systems) create a unitary matrix appropriate \
for performing the RWA for a atomic system ",
     Cell[BoxData[
      StyleBox["sys", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "91faf166-fd5d-432d-935a-d53e0206d7ca"],
     " subject to an optical field of frequency ",
     Cell[BoxData[
      StyleBox["\[Omega]", "TR"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "bcba2f43-0ef3-4bcd-84e5-8c7983b09958"]
    }], "TableText",ExpressionUUID->"b79ee0a8-435f-4cca-b2dc-133b630b295e"]},
   {
    RowBox[{
     TemplateBox[{
       Cell[
        TextData["RotatingWaveApproximation"]], 
       "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation", 
       "AtomicDensityMatrix Package Symbol"},
      "PackageLink",
      BaseStyle->{"DefinitionBox", CellFrame -> 0}], "[", 
     RowBox[{
      StyleBox["sys", "TI"], 
      StyleBox[",", "TI"], 
      StyleBox["h", "TI"], ",", 
      StyleBox["\[Omega]", "TR"]}], "]"}], Cell[TextData[{
     "automatically transform the Hamiltonian ",
     Cell[BoxData[
      StyleBox["h", "TI"]], "InlineFormula",
      FontFamily->"Source Sans Pro",ExpressionUUID->
      "33c58621-1682-4f90-a378-035486740c0b"],
     " to the rotating frame and drop fast-oscillating terms"
    }], "TableText",ExpressionUUID->"f73c846f-bced-4e82-82fa-382dfca431a8"]}
  }]], "DefinitionBox",
 CellID->1334,ExpressionUUID->"fcaaf3a0-5965-4847-b186-3b65a88d85e3"],

Cell["Making the rotating-wave approximation.", "Caption",
 CellID->164610213,ExpressionUUID->"b0d169f5-a290-453b-8bfc-5d7ea70fcfe2"],

Cell[TextData[{
 "For a simple system, ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["RotatingWaveApproximation"]], 
    "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "48bb375d-eb42-42b6-8674-f97444fbdc82"],
 " generates a unitary transformation matrix by assuming that states with ",
 Cell[BoxData[
  RowBox[{"Energy", "\[Rule]", "0"}]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "ea7eae33-db24-40ab-8e62-81658dd2f575"],
 " are lower states that should remain unshifted, while states with energies \
that are not explicitly zero are upper states that should be shifted down by \
the optical frequency \[Omega]. The RWA is then applied using this \
transformation. ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["RotatingWaveTransformMatrix"]], 
    "paclet:AtomicDensityMatrix/ref/RotatingWaveTransformMatrix", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "74695f03-a50e-443c-92f7-1168c3e1df0e"],
 " can be used to return the transform matrix itself."
}], "Text",
 CellID->555006801,ExpressionUUID->"272023c1-aa4d-4313-b9fb-d9e3de0417df"],

Cell["\<\
Automatically apply the RWA to a Hamiltonian, assuming an optical field of \
frequency \[Omega].\
\>", "MathCaption",
 CellID->91728896,ExpressionUUID->"5161bcad-0a00-4717-a00e-f978e4160c47"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RotatingWaveApproximation", "[", 
   RowBox[{"sys", ",", "h", ",", "\[Omega]"}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[16]:=",
 CellID->42004999,ExpressionUUID->"663143b0-0c43-4e55-bef3-7a2740215c87"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", "\[Omega]0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[16]//MatrixForm=",
 CellID->207633127,ExpressionUUID->"255786ef-36f8-4c99-848f-0ca3bdb58627"]
}, Open  ]],

Cell["Return the automatically generated transform matrix.", "MathCaption",
 CellID->251677183,ExpressionUUID->"c3e353b7-973a-4837-a746-6bfc3c21b2a6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RotatingWaveTransformMatrix", "[", 
   RowBox[{"sys", ",", "\[Omega]"}], "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[17]:=",
 CellID->390115046,ExpressionUUID->"9ebd5dbf-02b6-4812-8258-bbe0371362fc"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[17]//MatrixForm=",
 CellID->519578833,ExpressionUUID->"d4a04ab7-de0a-4211-9d3f-ef02bb2bdefa"]
}, Open  ]],

Cell["\<\
Automatically generate and apply the transform to the Hamiltonian, without \
dropping fast-oscillating terms.\
\>", "MathCaption",
 CellID->16178055,ExpressionUUID->"51f6737a-e074-44be-a85f-e048990726dc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RotatingWaveApproximation", "[", 
    RowBox[{"sys", ",", "h", ",", "\[Omega]", ",", " ", 
     RowBox[{"Method", "\[Rule]", "\"\<KeepFastTerms\>\""}]}], "]"}], "//", 
   "TrigToExp"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[18]:=",
 CellID->280989001,ExpressionUUID->"488c945b-adc4-4262-a191-380272f6ef3a"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]R", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "t", " ", 
          "\[Omega]"}]], " ", "\[CapitalOmega]R"}]}]},
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]R", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ",
         "\[CapitalOmega]R"}]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", "\[Omega]0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[18]//MatrixForm=",
 CellID->1879599553,ExpressionUUID->"53a736b1-55fc-4f7c-bb37-fb509cd3d6e6"]
}, Open  ]],

Cell[TextData[{
 "For more complicated systems, possibly including multiple optical fields, \
this simple method of generating the transformation to the rotating frame \
does not work. In this case, more information can be supplied to ",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["RotatingWaveApproximation"]], 
    "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "10a8769c-2de5-435a-b12f-142b86a59ae6"],
 ", allowing an appropriate transform matrix to be generated, or the \
transform matrix itself can be supplied directly. See the documentation for \
",
 Cell[BoxData[
  TemplateBox[{
    Cell[
     TextData["RotatingWaveApproximation"]], 
    "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation", 
    "AtomicDensityMatrix Package Symbol"},
   "PackageLink",
   BaseStyle->"InlineFormula"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "d8f7c2e3-85e3-48c2-8ad2-41d712238315"],
 " for more information."
}], "Text",
 CellID->6388417,ExpressionUUID->"386fdca2-aac8-4c13-8e9b-c9b89b6b7092"],

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "TutorialMoreAboutSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "AtomicDensityMatrix Package",
         BaseStyle->"Link",
         ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]],
          "TutorialMoreAbout",ExpressionUUID->
         "f5788aaf-9432-420f-9935-1725c671cf61"]}]}
     }]}
  }]], "TutorialMoreAboutSection",ExpressionUUID->"4266ec1d-3789-41fd-9a8f-\
7b0f5835ecf2"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, 
       "RelatedTutorial.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Tech", " ", "Notes"}], 
        "RelatedTutorialsSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "Constructing the Hamiltonian",
         BaseStyle->"Link",
         ButtonData->
          "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian"]], 
         "RelatedTutorials",ExpressionUUID->
         "9f477866-d735-4993-9ebd-c2898ea62092"]}]}
     }]}
  }]], "RelatedTutorialsSection",ExpressionUUID->"7e3b5d7d-ef19-465d-9413-\
c795f79f4778"],

Cell[BoxData[""], "Input",ExpressionUUID->"48558e82-b3e6-42f0-a5cf-63ac489fbe8d"]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"8774154e-6686-44d3-b160-90f4f3c05b8a"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"The Rotating-Wave Approximation",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}}, 
  "NewStyles" -> True, "CitationPopupData" -> {$Failed, ""}, "ShowCitation" -> 
  False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 18, 0, 37.919736}", 
    "history" -> {"XX", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Tutorial", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "The Hamiltonian for a light field interacting with an atomic transition \
has matrix elements that oscillate at the optical frequency. However, by a \
suitable change of basis and neglecting terms corresponding to very \
far-off-resonant optical coupling, the time dependence can often be \
eliminated from the Hamiltonian, greatly simplifying calculations. In this \
tutorial, we discuss this approximation, known as the rotating-wave \
approximation. This loads the package. As a simple example, we consider two \
atomic states coupled by a near-resonant monochromatic light field.", 
    "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$78308, "title" -> 
    "The Rotating-Wave Approximation", "titlemodifier" -> "", 
    "metadescription" -> "", "windowtitle" -> 
    "The Rotating-Wave Approximation", "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/TheRotatingWaveApproximation"}},
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> Notebook], 
   Cell[
    StyleData["Output"], CellContext -> Notebook], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"a11fbf35-7b44-4167-95f7-7c6b70d841b9"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "RasterizedOutput"->{
  Cell[53256, 1497, 5188, 91, 121, "Output",ExpressionUUID->"bf49993e-9c64-4b95-b40f-e99e0c0ef953",
   CellTags->"RasterizedOutput",
   CellID->268101009]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"RasterizedOutput", 79782, 2172}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[603, 21, 6900, 164, 57, "AnchorBarGrid",ExpressionUUID->"f9a9b995-e1ea-45b4-8f01-d840abd668a9",
 CellID->1],
Cell[CellGroupData[{
Cell[7528, 189, 123, 1, 63, "Title",ExpressionUUID->"f25bfa5d-3aca-481a-892e-a928963f8d71",
 CellID->509267359],
Cell[7654, 192, 601, 11, 108, "Text",ExpressionUUID->"b6153360-f181-4378-9517-e835979689e9",
 CellID->1534169418],
Cell[8258, 205, 121, 1, 36, "MathCaption",ExpressionUUID->"1ae3fc85-27c0-4557-a947-7e4e491c9a39",
 CellID->339534619],
Cell[8382, 208, 161, 3, 29, "Input",ExpressionUUID->"b9cf74b5-c471-4bf7-8a9a-0403d84dcdf9",
 CellID->87034352],
Cell[8546, 213, 205, 4, 36, "Text",ExpressionUUID->"bab26105-95ef-4d96-8c17-eaf9b813db4b",
 CellID->209068752],
Cell[8754, 219, 123, 1, 36, "MathCaption",ExpressionUUID->"4605791d-d841-4fe1-ae9a-4fb1645cd7af",
 CellID->70779043],
Cell[CellGroupData[{
Cell[8902, 224, 512, 13, 29, "Input",ExpressionUUID->"2543cefa-720b-49ee-8e96-5f251ba06388",
 CellID->29838874],
Cell[9417, 239, 479, 12, 37, "Output",ExpressionUUID->"33483dd4-ccf2-4594-87bd-ef74e2b8ad2f",
 CellID->90189934]
}, Open  ]],
Cell[9911, 254, 554, 14, 37, "MathCaption",ExpressionUUID->"8a345bf0-b6bf-427e-8f15-23d0757dcbfe",
 CellID->457381827],
Cell[CellGroupData[{
Cell[10490, 272, 614, 16, 48, "Input",ExpressionUUID->"31360a97-fe41-4707-bcec-91cca0e60590",
 CellID->692860306],
Cell[11107, 290, 976, 27, 66, "Output",ExpressionUUID->"47e062b4-2950-4b18-84c2-836a40463d25",
 CellID->1550829805]
}, Open  ]],
Cell[12098, 320, 298, 5, 60, "Text",ExpressionUUID->"d0c4e520-1718-4286-96b5-a2a957cfaea5",
 CellID->395087951],
Cell[12399, 327, 160, 2, 36, "MathCaption",ExpressionUUID->"ac9dc825-61a1-4506-b5a7-2e20307e435c",
 CellID->114000830],
Cell[CellGroupData[{
Cell[12584, 333, 187, 4, 29, "Input",ExpressionUUID->"c0cf329d-64f8-43ad-ba4a-7e0a1842b195",
 CellID->9490531],
Cell[12774, 339, 1627, 45, 82, "Output",ExpressionUUID->"efdeb85c-c810-4f49-ad8f-cbca4b4c6d1e",
 CellID->109698176]
}, Open  ]],
Cell[14416, 387, 256, 4, 60, "Text",ExpressionUUID->"fa22b2d7-20c4-410b-a316-821d4fca8634",
 CellID->87359988],
Cell[14675, 393, 1226, 35, 77, "Text",ExpressionUUID->"ac695e52-4369-487e-8453-9970b349e9d2",
 CellID->383056238],
Cell[15904, 430, 1343, 38, 70, "Text",ExpressionUUID->"09652ea1-cc68-48df-ab2c-a98812c6fc72",
 CellID->74222856],
Cell[17250, 470, 6616, 203, 70, "Text",ExpressionUUID->"76b2da9a-46c2-4de8-9377-f1656cd6695b",
 CellID->408772018],
Cell[23869, 675, 4172, 116, 70, "Text",ExpressionUUID->"be0a5aae-98c5-4c9c-820e-1f3010956df5",
 CellID->131956570],
Cell[28044, 793, 215, 4, 70, "Text",ExpressionUUID->"89c309d0-d88f-4aaf-a703-d7291f8915af",
 CellID->119515781],
Cell[28262, 799, 187, 4, 70, "MathCaption",ExpressionUUID->"a81161d9-7860-47c6-a0eb-0c4d041a0986",
 CellID->295356471],
Cell[CellGroupData[{
Cell[28474, 807, 472, 11, 70, "Input",ExpressionUUID->"09aa60fd-5a29-4eff-bf4d-c572c7280851",
 CellID->738472575],
Cell[28949, 820, 730, 13, 121, "Output",ExpressionUUID->"42452252-5a87-461e-994f-d9a6c43c7ce4",
 CellID->1031612852]
}, Open  ]],
Cell[29694, 836, 808, 18, 70, "Text",ExpressionUUID->"6ee5ace9-5b3a-4faa-b20c-9047b383cd23",
 CellID->67742302],
Cell[30505, 856, 320, 5, 70, "Text",ExpressionUUID->"97b2357f-360b-4f73-9c3a-2294c6f0145d",
 CellID->5846930],
Cell[30828, 863, 184, 3, 70, "MathCaption",ExpressionUUID->"e54c6728-b976-4c72-9937-f3fdf33ea028",
 CellID->240378968],
Cell[CellGroupData[{
Cell[31037, 870, 384, 10, 70, "Input",ExpressionUUID->"9fe2832f-de09-493c-ae35-1dcc8e72fb9a",
 CellID->76640165],
Cell[31424, 882, 665, 19, 52, "Output",ExpressionUUID->"9fb180a0-7f40-47a2-997d-940b0c812079",
 CellID->1242226802]
}, Open  ]],
Cell[32104, 904, 508, 12, 70, "Text",ExpressionUUID->"31ff8cd2-d65b-4824-9612-f08c9c27eaab",
 CellID->207411124],
Cell[32615, 918, 286, 7, 70, "MathCaption",ExpressionUUID->"ef0e02f6-546e-4d83-8096-91a9f315339c",
 CellID->311487406],
Cell[CellGroupData[{
Cell[32926, 929, 774, 21, 70, "Input",ExpressionUUID->"5a6b3ce5-f829-405a-b898-799bc3337e5c",
 CellID->253774865],
Cell[33703, 952, 1708, 48, 82, "Output",ExpressionUUID->"47cd0391-f8f4-46d8-95b3-11cede15f9bd",
 CellID->325211587]
}, Open  ]],
Cell[35426, 1003, 462, 9, 70, "Text",ExpressionUUID->"0cc35dd3-cd96-4fb7-a6cd-c86ab82bdec0",
 CellID->52559842],
Cell[35891, 1014, 576, 10, 70, "Text",ExpressionUUID->"9da5b30c-71c4-43d5-a010-3fc62e3e3644",
 CellID->244684399],
Cell[36470, 1026, 383, 12, 70, "MathCaption",ExpressionUUID->"06afec6e-aae7-4f96-b8a4-93735328bb45",
 CellID->23996460],
Cell[CellGroupData[{
Cell[36878, 1042, 402, 12, 70, "Input",ExpressionUUID->"063ba6a2-4275-4e14-b0db-00ce4f0f1e5a",
 CellID->191574436],
Cell[37283, 1056, 991, 27, 86, "Output",ExpressionUUID->"532c42c3-287c-470a-a4b1-e223f64e76b0",
 CellID->398402687]
}, Open  ]],
Cell[38289, 1086, 2077, 43, 70, "Text",ExpressionUUID->"f2199bda-cfe0-4786-84c0-078a32506f7e",
 CellID->305054736],
Cell[40369, 1131, 151, 1, 70, "MathCaption",ExpressionUUID->"b3e19c8d-6a21-4daf-92d5-9dc2aed1a3bf",
 CellID->216972968],
Cell[CellGroupData[{
Cell[40545, 1136, 496, 14, 70, "Input",ExpressionUUID->"89a3ff74-c7d0-44d7-bf94-63dd79168755",
 CellID->331600442],
Cell[41044, 1152, 1524, 43, 82, "Output",ExpressionUUID->"661c592f-10d6-46d1-b513-253bba6c5aec",
 CellID->1492611582]
}, Open  ]],
Cell[42583, 1198, 513, 14, 70, "MathCaption",ExpressionUUID->"81d6743a-c70b-4c32-a108-62a29062263f",
 CellID->270489364],
Cell[CellGroupData[{
Cell[43121, 1216, 275, 7, 70, "Input",ExpressionUUID->"da8bf4c1-a8a8-4d3c-ac22-9ee0dd7b93b3",
 CellID->391661896],
Cell[43399, 1225, 1525, 43, 82, "Output",ExpressionUUID->"c60ed043-c3c6-4d2d-bcac-415d5d59e939",
 CellID->1820970491]
}, Open  ]],
Cell[44939, 1271, 473, 7, 70, "Text",ExpressionUUID->"48332734-743e-4dbe-a273-691a1cc3ec88",
 CellID->319046361],
Cell[45415, 1280, 402, 6, 70, "Text",ExpressionUUID->"7ace1f84-058d-4311-9fb3-289e96d451e3",
 CellID->119866632],
Cell[45820, 1288, 859, 18, 70, "Text",ExpressionUUID->"fa173661-fac0-4509-b1e8-a2ab45cb9ff9",
 CellID->12796374],
Cell[46682, 1308, 191, 4, 70, "MathCaption",ExpressionUUID->"4e12f8c9-4479-4bd4-8bb8-33466cef55bb",
 CellID->568113300],
Cell[CellGroupData[{
Cell[46898, 1316, 428, 12, 70, "Input",ExpressionUUID->"ba3b9496-954d-45c9-a940-4920a8b5e660",
 CellID->186586323],
Cell[47329, 1330, 820, 22, 68, "Output",ExpressionUUID->"ed6267bb-69c3-4b72-aa3a-373171e9040e",
 CellID->1440598470]
}, Open  ]],
Cell[48164, 1355, 292, 5, 70, "Text",ExpressionUUID->"36ee0739-1a9f-4d9d-b2fe-b6f8ffa0d24b",
 CellID->5994744],
Cell[48459, 1362, 520, 14, 70, "MathCaption",ExpressionUUID->"b84210ee-291e-45ab-8713-fe79d31981a4",
 CellID->398631076],
Cell[CellGroupData[{
Cell[49004, 1380, 332, 9, 70, "Input",ExpressionUUID->"0e862307-f06b-4bbc-8777-096e9761e772",
 CellID->222156589],
Cell[49339, 1391, 1377, 38, 82, "Output",ExpressionUUID->"fde9084a-a397-4b99-a29e-4ec9ba496cec",
 CellID->158297418]
}, Open  ]],
Cell[50731, 1432, 1434, 32, 70, "Text",ExpressionUUID->"5c7ba479-8d23-4080-8a8a-97fac3eef523",
 CellID->1668820],
Cell[52168, 1466, 208, 4, 70, "MathCaption",ExpressionUUID->"02ea66d2-9a67-419d-9ee9-13a90c7f5299",
 CellID->77373423],
Cell[CellGroupData[{
Cell[52401, 1474, 852, 21, 70, "Input",ExpressionUUID->"3fd1f537-c5b3-4d8e-ad86-df7d7a23727a",
 CellID->230965145],
Cell[53256, 1497, 5188, 91, 121, "Output",ExpressionUUID->"bf49993e-9c64-4b95-b40f-e99e0c0ef953",
 CellTags->"RasterizedOutput",
 CellID->268101009]
}, Open  ]],
Cell[58459, 1591, 406, 7, 70, "Text",ExpressionUUID->"4eb76054-dac0-4414-bba7-cd2d177702eb",
 CellID->8916765],
Cell[58868, 1600, 528, 14, 70, "MathCaption",ExpressionUUID->"914278a0-e4d8-426e-a5f5-59aa44031456",
 CellID->131611831],
Cell[CellGroupData[{
Cell[59421, 1618, 299, 8, 70, "Input",ExpressionUUID->"50813666-dd57-4b94-b553-206ecfaa2c3a",
 CellID->612776079],
Cell[59723, 1628, 888, 25, 82, "Output",ExpressionUUID->"0f70edc5-25d1-4cc0-97b7-2d597ac43fea",
 CellID->1925914466]
}, Open  ]],
Cell[60626, 1656, 477, 10, 70, "Text",ExpressionUUID->"6bd02dbf-a254-48c3-9c84-466756158425",
 CellID->618247489],
Cell[61106, 1668, 188, 4, 70, "MathCaption",ExpressionUUID->"c2a76ebf-82a0-4792-be14-47ee060bd0c9",
 CellID->494812334],
Cell[CellGroupData[{
Cell[61319, 1676, 272, 7, 70, "Input",ExpressionUUID->"8d9d3db4-6291-4064-b465-9a778eb62a49",
 CellID->190456385],
Cell[61594, 1685, 859, 24, 82, "Output",ExpressionUUID->"912b4679-aa6f-4f37-aa8f-35acba022b5a",
 CellID->1377290753]
}, Open  ]],
Cell[62468, 1712, 274, 5, 70, "Text",ExpressionUUID->"f7c84ba0-1150-4863-8316-2e61a81fe4f2",
 CellID->713011104],
Cell[62745, 1719, 1225, 29, 70, "Text",ExpressionUUID->"126231a0-1bc5-4fb9-bd4b-5e267e8ce3ce",
 CellID->33346025],
Cell[63973, 1750, 3909, 100, 70, "DefinitionBox",ExpressionUUID->"fcaaf3a0-5965-4847-b186-3b65a88d85e3",
 CellID->1334],
Cell[67885, 1852, 133, 1, 70, "Caption",ExpressionUUID->"b0d169f5-a290-453b-8bfc-5d7ea70fcfe2",
 CellID->164610213],
Cell[68021, 1855, 1383, 33, 70, "Text",ExpressionUUID->"272023c1-aa4d-4313-b9fb-d9e3de0417df",
 CellID->555006801],
Cell[69407, 1890, 201, 4, 70, "MathCaption",ExpressionUUID->"5161bcad-0a00-4717-a00e-f978e4160c47",
 CellID->91728896],
Cell[CellGroupData[{
Cell[69633, 1898, 255, 6, 70, "Input",ExpressionUUID->"663143b0-0c43-4e55-bef3-7a2740215c87",
 CellID->42004999],
Cell[69891, 1906, 887, 25, 82, "Output",ExpressionUUID->"255786ef-36f8-4c99-848f-0ca3bdb58627",
 CellID->207633127]
}, Open  ]],
Cell[70793, 1934, 150, 1, 70, "MathCaption",ExpressionUUID->"c3e353b7-973a-4837-a746-6bfc3c21b2a6",
 CellID->251677183],
Cell[CellGroupData[{
Cell[70968, 1939, 245, 5, 70, "Input",ExpressionUUID->"9ebd5dbf-02b6-4812-8258-bbe0371362fc",
 CellID->390115046],
Cell[71216, 1946, 819, 22, 68, "Output",ExpressionUUID->"d4a04ab7-de0a-4211-9d3f-ef02bb2bdefa",
 CellID->519578833]
}, Open  ]],
Cell[72050, 1971, 214, 4, 70, "MathCaption",ExpressionUUID->"51f6737a-e074-44be-a85f-e048990726dc",
 CellID->16178055],
Cell[CellGroupData[{
Cell[72289, 1979, 363, 8, 70, "Input",ExpressionUUID->"488c945b-adc4-4262-a191-380272f6ef3a",
 CellID->280989001],
Cell[72655, 1989, 1378, 38, 82, "Output",ExpressionUUID->"53a736b1-55fc-4f7c-bb37-fb509cd3d6e6",
 CellID->1879599553]
}, Open  ]],
Cell[74048, 2030, 1210, 29, 70, "Text",ExpressionUUID->"386fdca2-aac8-4c13-8e9b-c9b89b6b7092",
 CellID->6388417],
Cell[75261, 2061, 725, 18, 70, "TutorialMoreAboutSection",ExpressionUUID->"4266ec1d-3789-41fd-9a8f-7b0f5835ecf2"],
Cell[CellGroupData[{
Cell[76011, 2083, 776, 21, 70, "RelatedTutorialsSection",ExpressionUUID->"7e3b5d7d-ef19-465d-9413-c795f79f4778"],
Cell[76790, 2106, 81, 0, 70, "Input",ExpressionUUID->"48558e82-b3e6-42f0-a5cf-63ac489fbe8d"]
}, Open  ]]
}, Open  ]],
Cell[76898, 2110, 78, 0, 70, "FooterCell",ExpressionUUID->"8774154e-6686-44d3-b160-90f4f3c05b8a"]
}
]
*)

(* End of internal cache information *)

