(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    143130,       2795]
NotebookOptionsPosition[    134276,       2608]
NotebookOutlinePosition[    137594,       2683]
CellTagsIndexPosition[    137513,       2678]
WindowTitle->The State Vector and the Schr\366dinger Equation
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {GridBox[{
      {
       ItemBox[Cell[BoxData[
         RowBox[{
          TemplateBox[{12},
           "Spacer1"], Cell["ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell",
           TextAlignment->Center,ExpressionUUID->
           "9deec914-054d-4b2e-9933-940bcba7b884"], 
          TemplateBox[{8},
           "Spacer1"]}]],
         TextAlignment->Center,ExpressionUUID->
         "c192a888-5d81-4b46-a89a-6fe944a1e182"],
        Background->RGBColor[
         0.7450980392156863, 0.3254901960784314, 0.1411764705882353],
        ItemSize->Full], ""}
     },
     GridBoxAlignment->{"Rows" -> {{Center}}},
     GridBoxItemSize->{"Columns" -> {Full, 
         Scaled[0.02]}, "Rows" -> {{2.5}}}], Cell[TextData[{
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "Related Guides",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "fe6c2d19-e0a6-437d-8d8e-1253fae8f273"]
         }],ExpressionUUID->"a0cca607-790e-44fa-8a06-72f2708b85a0"],
         StripOnInput->False], {"\<\"AtomicDensityMatrix Package\"\>":>
        Documentation`HelpLookup[
        "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"TutorialMoreAboutSection"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "aa621d29-9596-4b56-8c91-edfd4b6ee34b"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      TagBox[
       ActionMenuBox[
        FrameBox[Cell[TextData[{
          "URL",
          " ",
          Cell[BoxData[
           GraphicsBox[
            {GrayLevel[0.66667], Thickness[0.13], 
             LineBox[{{-1.8, 0.5}, {0, 0}, {1.8, 0.5}}]},
            AspectRatio->1,
            ImageSize->20,
            PlotRange->{{-3, 4}, {-1, 1}}]],ExpressionUUID->
           "a2637e9d-b033-45a0-a3f4-7e69ff8bf080"]
         }],ExpressionUUID->"6b928770-c37d-4ccd-922c-f9a73c4f4be5"],
         StripOnInput->
          False], {"\<\"AtomicDensityMatrix/tutorial/\
TheStateVectorAndTheSchrodingerEquation\"\>":>
        None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
              "AtomicDensityMatrix/tutorial/\
TheStateVectorAndTheSchrodingerEquation"]}, Visible -> False]]; 
         SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; Null], 
        Delimiter, "\<\"Copy web URL\"\>":>
        Module[{DocumentationSearch`Private`nb$}, 
         DocumentationSearch`Private`nb$ = NotebookPut[
            Notebook[{
              Cell[
               BoxData[
                MakeBoxes[
                 Hyperlink[
                 "http://reference.wolfram.com/language/AtomicDensityMatrix/\
tutorial/TheStateVectorAndTheSchrodingerEquation.html"], StandardForm]], 
               "Input", TextClipboardType -> "PlainText"]}, Visible -> 
             False]]; SelectionMove[
          DocumentationSearch`Private`nb$, All, Notebook]; 
         FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
         NotebookClose[DocumentationSearch`Private`nb$]; 
         Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
          NotebookLocate[{
            URL[If[
               TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$78682], 
               "http://reference.wolfram.com/system-modeler/", 
               "http://reference.wolfram.com/language/"] <> 
             "AtomicDensityMatrix/tutorial/\
TheStateVectorAndTheSchrodingerEquation" <> ".html"], None}]}]},
        Appearance->None,
        MenuAppearance->Automatic,
        MenuStyle->"URLMenu"],
       MouseAppearanceTag["LinkHand"]]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "50c04cf4-85cd-4514-aea9-1207733a98c0"]
    }], "AnchorBar",
     CacheGraphics->False,ExpressionUUID->
     "b9bf53e8-9bd3-4d11-a142-e4023345cf24"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1,ExpressionUUID->"6d1db9f2-a2e8-464f-8a5e-58966f1c9c29"],

Cell[CellGroupData[{

Cell["The State Vector and the Schr\[ODoubleDot]dinger Equation", "Title",
 CellID->509267359,ExpressionUUID->"e5f5e389-38a4-432a-ba8d-05699aaef52b"],

Cell[TextData[{
 "The main question that the ",
 StyleBox["AtomicDensityMatrix",
  FontSlant->Italic],
 " package is intended to address is"
}], "Text",
 CellID->17510842,ExpressionUUID->"9c844591-cdc7-41cf-b0d8-dfdc98f4cd9d"],

Cell[CellGroupData[{

Cell["\<\
Given the initial state of an atomic system subject to light and/or other \
external fields and relaxation mechanisms, what is the subsequent evolution \
of the system and what effect does this evolution have on the interacting \
light fields?\
\>", "TextNote",
 CellID->18368332,ExpressionUUID->"cbb720b3-4d7b-42f5-87c5-80aa50b3e718"],

Cell[TextData[{
 "In the absence of relaxation, the evolution of a quantum-mechanical state \
vector ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", "\[Psi]"}], "\[RightAngleBracket]"}], "InlineMath"]], 
  "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "5237671d-db14-4941-b613-d7529e2f9a52"],
 " is governed by the Schr\[ODoubleDot]dinger equation ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"i", " ", "\[HBar]", 
        SubscriptBox["\[PartialD]", 
         StyleBox["t",
          FontSlant->"Italic"]]}], "|", 
       RowBox[{"\[Psi]", 
        RowBox[{"(", 
         StyleBox["t",
          FontSlant->"Italic"], ")"}]}]}], "\[RightAngleBracket]"}], "=", 
     RowBox[{"H", "|", 
      RowBox[{"\[Psi]", 
       RowBox[{"(", "t", ")"}]}]}]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "d43e5681-80aa-4f3c-a308-992c5a0f71f0"],
 ", where ",
 Cell[BoxData[
  StyleBox["H", "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "0c9496ee-8648-418a-9633-d7db664faa1f"],
 " is the Hamiltonian. (In the ADM package, we generally use units in which \
",
 Cell[BoxData[
  StyleBox["H", "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "8006656e-dbaa-41af-af1b-d76ab548b2c6"],
 " has units of frequency and the reduced Planck's constant \[HBar] is equal \
to one.)"
}], "Text",
 CellID->60640988,ExpressionUUID->"635a38a9-7a8c-4cec-8142-0862e03a48c5"],

Cell[TextData[{
 "As a simple example, we will find the evolution of system consisting of two \
opposite-parity states with no Zeeman or hyperfine substructure, separated by \
an energy ",
 Cell[BoxData[
  StyleBox["\[CapitalDelta]", "InlineMath"]], "InlineFormula",
  FontFamily->"Source Sans Pro",ExpressionUUID->
  "62313b86-058c-42e6-bf6a-2cc8ff3ed7e6"],
 " and subject to a static electric field."
}], "Text",
 CellID->663252305,ExpressionUUID->"9ef221ee-983f-4968-b716-2c0ce7ebfb38"],

Cell["Load the package.", "MathCaption",
 CellID->106720500,ExpressionUUID->"7f14a9da-1039-4648-a40f-5ff37c7032f6"],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->27959808,ExpressionUUID->"d4270865-b5d8-448a-9d3e-9f95190bf4a8"],

Cell["Define an atomic system and form its ket vector.", "MathCaption",
 CellID->200065976,ExpressionUUID->"4dfff816-a206-4cf6-ae96-1a67d50d9945"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"2", ",", 
      RowBox[{"Energy", "\[Rule]", "\[CapitalDelta]"}]}], "]"}]}], 
   "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->484360868,ExpressionUUID->"1d6c5db6-9ffb-450a-8c96-a0e9a7764031"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"Energy", "\[Rule]", "\[CapitalDelta]"}]}], "]"}]}], 
  "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->1522551713,ExpressionUUID->"982ce2fb-df10-4137-9a5a-5568f928cf5b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"ket", "=", 
    RowBox[{"Ket", "[", 
     RowBox[{"sys", ",", "c"}], "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",\

 CellLabel->"In[3]:=",
 CellID->67883978,ExpressionUUID->"ff45ca71-0aaa-4061-9c8c-fd95da5e9483"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["c", "1"], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["c", "2"], "[", "t", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[3]//MatrixForm=",
 CellID->2044782247,ExpressionUUID->"7ab7c8b1-57d5-4fa3-943e-d14cabe05f46"]
}, Open  ]],

Cell["\<\
The Hamiltonian describing the interaction with an electric field. We \
normalize the electric field to frequency units by dividing by the reduced \
dipole matrix element between states 1 and 2.\
\>", "MathCaption",
 CellID->265025652,ExpressionUUID->"b34c8c34-3492-4423-b60b-230cc10c68d4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{"Hamiltonian", "[", 
     RowBox[{"sys", ",", 
      RowBox[{"ElectricField", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"\[CapitalOmega]", "/", 
          RowBox[{"ReducedME", "[", 
           RowBox[{"1", ",", 
            RowBox[{"{", 
             RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], 
        "}"}]}]}], "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->90461799,ExpressionUUID->"79690b4c-c1c3-4da2-ae4a-1908f25d77c6"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", "\[CapitalOmega]"}]},
     {
      RowBox[{"-", "\[CapitalOmega]"}], "\[CapitalDelta]"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellLabel->"Out[4]//MatrixForm=",
 CellID->1294450535,ExpressionUUID->"d92d67d2-bbb7-48fb-a3b1-d13fc1749f3e"]
}, Open  ]],

Cell["The Schr\[ODoubleDot]dinger equation.", "MathCaption",
 CellID->886331892,ExpressionUUID->"dc3986ce-23b7-42e8-9b81-f8888173ac42"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "/@", 
  RowBox[{"(", 
   RowBox[{"eq", "=", 
    RowBox[{
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"D", "[", 
       RowBox[{"ket", ",", "t"}], "]"}]}], "\[Equal]", 
     RowBox[{"h", "\[CenterDot]", "ket"}]}]}], ")"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->367957306,ExpressionUUID->"a5870488-cb44-4aba-80eb-9569b621620a"],

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{
         SuperscriptBox[
          SubscriptBox["c", "1"], "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]},
      {
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{
         SuperscriptBox[
          SubscriptBox["c", "2"], "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], "\[Equal]", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       RowBox[{
        RowBox[{"-", "\[CapitalOmega]"}], " ", 
        RowBox[{
         SubscriptBox["c", "2"], "[", "t", "]"}]}]},
      {
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[CapitalOmega]"}], " ", 
         RowBox[{
          SubscriptBox["c", "1"], "[", "t", "]"}]}], "+", 
        RowBox[{"\[CapitalDelta]", " ", 
         RowBox[{
          SubscriptBox["c", "2"], "[", "t", "]"}]}]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]]}]], "Output",
 CellLabel->"Out[5]=",
 CellID->2058963840,ExpressionUUID->"ff6c26ac-d1fe-4671-8be0-ccaef2fc9915"]
}, Open  ]],

Cell["Create the initial conditions.", "MathCaption",
 CellID->639160661,ExpressionUUID->"6f9dca04-d460-4aa3-b4ac-cb149bb3a0b0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "/@", 
  RowBox[{"(", 
   RowBox[{"init", "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"ket", "/.", 
       RowBox[{"t", "\[Rule]", "0"}]}], ")"}], "==", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"1"},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]}]}], ")"}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->294592650,ExpressionUUID->"9687accc-e16e-468a-b8a9-19c19b9f3bf1"],

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       RowBox[{
        SubscriptBox["c", "1"], "[", "0", "]"}]},
      {
       RowBox[{
        SubscriptBox["c", "2"], "[", "0", "]"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], "\[Equal]", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"1"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]]}]], "Output",
 CellLabel->"Out[6]=",
 CellID->557378128,ExpressionUUID->"517ee047-45b6-471d-9ec2-2f1d5298a276"]
}, Open  ]],

Cell["A list of the dependent variables.", "MathCaption",
 CellID->197975652,ExpressionUUID->"2dd66fe4-a9f9-4e8f-8474-59f0525ec448"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vars", "=", 
  RowBox[{"Flatten", "[", "ket", "]"}]}]], "Input",
 CellLabel->"In[7]:=",
 CellID->276951613,ExpressionUUID->"6786e373-cfc6-4407-a743-adb050720cd3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["c", "1"], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["c", "2"], "[", "t", "]"}]}], "}"}]], "Output",
 CellLabel->"Out[7]=",
 CellID->90922671,ExpressionUUID->"1271e553-6d10-416c-8c4f-ea29d926cf3b"]
}, Open  ]],

Cell["Solve the Schr\[ODoubleDot]dinger equation.", "MathCaption",
 CellID->33833520,ExpressionUUID->"b5cd72e0-d2d7-4f2b-a618-1f8cf08339a1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"First", "@", 
     RowBox[{"DSolve", "[", 
      RowBox[{
       RowBox[{"LogicalExpand", "[", 
        RowBox[{"eq", "&&", "init"}], "]"}], ",", "vars", ",", "t"}], "]"}]}],
     ",", 
    RowBox[{
     RowBox[{"\[CapitalOmega]", ">", "0"}], "&&", 
     RowBox[{"\[CapitalDelta]", "\[Element]", "Reals"}]}]}], "]"}]}]], "Input",\

 CellLabel->"In[8]:=",
 CellID->24580560,ExpressionUUID->"9a256262-b3ea-4d95-bc5c-57861f786bba"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox["c", "1"], "[", "t", "]"}], "\[Rule]", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], " ", "\[ImaginaryI]", " ", "t", " ", 
       "\[CapitalDelta]"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Cos", "[", 
        RowBox[{
         FractionBox["1", "2"], " ", "t", " ", 
         SqrtBox[
          RowBox[{
           SuperscriptBox["\[CapitalDelta]", "2"], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}], "]"}], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "\[CapitalDelta]", " ", 
         RowBox[{"Sin", "[", 
          RowBox[{
           FractionBox["1", "2"], " ", "t", " ", 
           SqrtBox[
            RowBox[{
             SuperscriptBox["\[CapitalDelta]", "2"], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}], "]"}]}], 
        SqrtBox[
         RowBox[{
          SuperscriptBox["\[CapitalDelta]", "2"], "+", 
          RowBox[{"4", " ", 
           SuperscriptBox["\[CapitalOmega]", "2"]}]}]]]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["c", "2"], "[", "t", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{"2", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", "\[ImaginaryI]", " ", "t", " ", 
        "\[CapitalDelta]"}]], " ", "\[CapitalOmega]", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{
        FractionBox["1", "2"], " ", "t", " ", 
        SqrtBox[
         RowBox[{
          SuperscriptBox["\[CapitalDelta]", "2"], "+", 
          RowBox[{"4", " ", 
           SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}], "]"}]}], 
     SqrtBox[
      RowBox[{
       SuperscriptBox["\[CapitalDelta]", "2"], "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["\[CapitalOmega]", "2"]}]}]]]}]}], "}"}]], "Output",
 CellLabel->"Out[8]=",
 CellID->2073316615,ExpressionUUID->"041848a2-4878-46ab-a80f-570d18400025"]
}, Open  ]],

Cell["\<\
The real and imaginary parts of the elements of the state vector.\
\>", "MathCaption",
 CellID->96187871,ExpressionUUID->"1dd4c793-fc99-4c3e-9a1a-3716c1c927c1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vec", "=", 
  RowBox[{
   RowBox[{"ComplexExpand", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Re", "[", "vars", "]"}], ",", 
         RowBox[{"Im", "[", "vars", "]"}]}], "}"}], "]"}], "/.", "sol"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[CapitalOmega]", "\[Rule]", "1"}], ",", 
       RowBox[{"\[CapitalDelta]", "\[Rule]", "1"}]}], "}"}]}], "]"}], "//", 
   "Simplify"}]}]], "Input",
 CellLabel->"In[9]:=",
 CellID->340603720,ExpressionUUID->"136dad97-88dd-4939-b62f-f5d411288860"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox["t", "2"], "]"}], " ", 
       RowBox[{"Cos", "[", 
        FractionBox[
         RowBox[{
          SqrtBox["5"], " ", "t"}], "2"], "]"}]}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"Sin", "[", 
         FractionBox["t", "2"], "]"}], " ", 
        RowBox[{"Sin", "[", 
         FractionBox[
          RowBox[{
           SqrtBox["5"], " ", "t"}], "2"], "]"}]}], 
       SqrtBox["5"]]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         FractionBox[
          RowBox[{
           SqrtBox["5"], " ", "t"}], "2"], "]"}]}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["t", "2"], "]"}]}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"Cos", "[", 
         FractionBox["t", "2"], "]"}], " ", 
        RowBox[{"Sin", "[", 
         FractionBox[
          RowBox[{
           SqrtBox["5"], " ", "t"}], "2"], "]"}]}], 
       SqrtBox["5"]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", 
       RowBox[{"Sin", "[", 
        FractionBox["t", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox[
         RowBox[{
          SqrtBox["5"], " ", "t"}], "2"], "]"}]}], 
      SqrtBox["5"]], ",", 
     FractionBox[
      RowBox[{"2", " ", 
       RowBox[{"Cos", "[", 
        FractionBox["t", "2"], "]"}], " ", 
       RowBox[{"Sin", "[", 
        FractionBox[
         RowBox[{
          SqrtBox["5"], " ", "t"}], "2"], "]"}]}], 
      SqrtBox["5"]]}], "}"}]}], "}"}]], "Output",
 CellLabel->"Out[9]=",
 CellID->1917659497,ExpressionUUID->"31c952e3-44d9-4ef2-b88b-6b5f0dea9040"]
}, Open  ]],

Cell["\<\
Plot the trajectory of the elements of the state vector in the complex plane.\
\
\>", "MathCaption",
 CellID->219586286,ExpressionUUID->"ab8863c9-4aee-4837-aede-990559b46466"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Arrowheads", "[", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{".045", ",", "i"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "1", ",", ".04"}], "}"}]}], "]"}], "]"}],
      ",", 
     RowBox[{
      RowBox[{"First", "@", 
       RowBox[{"ParametricPlot", "[", 
        RowBox[{"vec", ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "0", ",", "20"}], "}"}]}], "]"}]}], "/.", 
      RowBox[{"Line", "\[Rule]", "Arrow"}]}]}], "}"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"Axes", "\[Rule]", "True"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<Re[c(t)]\>\"", ",", "\"\<Im[c(t)]\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->280333154,ExpressionUUID->"a2ae5e87-856b-4333-820f-4c10e722256a"],

Cell[BoxData[
 GraphicsBox[
  {Arrowheads[CompressedData["
1:eJxTTMoPSmViYGCQAmIQzXV9cYEt13J7BiiA8atF1rk/rFpij8rfAufvkGt9
HbhjH5r8ETh/1kwQOImm/hyc/yYQJHIRTf8VOB9CX0cz7yacrxnTf+irxh00
8+/B+UtAuhc/QLPvIZxvDAaP0ex/Aucf/qoBtOEpmnuew/lBYAtfoLnvJZz/
sApk4Cs0976B8wtBzit4i+b+d/ao8fHBHgDwJ7ax
    "]], {}, {}, 
   TagBox[
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], FaceForm[Opacity[0.3]], ArrowBox[CompressedData["
1:eJw0l3c81u/3+CWEUEKlSEpCmYnUWydpKDSNkhDKqFBJSsNOCAkRZY8KISvh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      "]]},
    Annotation[#, "Charting`Private`Tag$5798#1"]& ], 
   TagBox[
    {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
     1.], FaceForm[Opacity[0.3]], ArrowBox[CompressedData["
1:eJxcV3c81f/3VyqiktKwSqlESqIIOaEykrLKpjITIbRUyp5JiCQj2XtmHtl7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      "]]},
    Annotation[#, "Charting`Private`Tag$5798#1"]& ]},
  Axes->True,
  Frame->True,
  FrameLabel->{
    FormBox["\"Re[c(t)]\"", TraditionalForm], 
    FormBox["\"Im[c(t)]\"", TraditionalForm]}]], "Output",
 CellLabel->"Out[10]=",
 CellID->1998331390,ExpressionUUID->"0fbcf470-13a9-489d-94f2-000ed24de314"]
}, Open  ]],

Cell["The probability of finding each state as a function of time.", \
"MathCaption",
 CellID->94345139,ExpressionUUID->"0467abb0-cb62-447a-abdf-221ccfc9ca35"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"prob", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"Abs", "[", "vars", "]"}], "2"], "/.", "sol"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[CapitalOmega]", "\[Rule]", "1"}], ",", 
       RowBox[{"\[CapitalDelta]", "\[Rule]", "1"}]}], "}"}]}], ",", 
    RowBox[{"t", "\[Element]", "Reals"}]}], "]"}]}]], "Input",
 CellLabel->"In[11]:=",
 CellID->427371019,ExpressionUUID->"d1200d50-7053-444c-9b9d-54b353452800"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox["1", "5"], " ", 
    RowBox[{"(", 
     RowBox[{"3", "+", 
      RowBox[{"2", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{
         SqrtBox["5"], " ", "t"}], "]"}]}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["2", "5"]}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"Cos", "[", 
       RowBox[{
        SqrtBox["5"], " ", "t"}], "]"}]}], ")"}]}]}], "}"}]], "Output",
 CellLabel->"Out[11]=",
 CellID->56991241,ExpressionUUID->"d4ac2e03-9c25-44bf-ac4d-a92d48ac54c8"]
}, Open  ]],

Cell["Plot the probabilities.", "MathCaption",
 CellID->300686189,ExpressionUUID->"5a9b760f-f929-4f42-880a-f5271bc67e4c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"prob", ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t\>\"", ",", "\"\<Probability\>\""}], "}"}]}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[12]:=",
 CellID->33775256,ExpressionUUID->"6808252b-b889-4e28-a7cd-7034e835fd7f"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzsvfdbVFuePjr3fn+5P95/4T7PdDqnc47Tuae7Z7p7uqd7ema6W08UMR71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    "], {{0, 163.}, {240., 0}}, {0, 255},
    ColorFunction->RGBColor,
    ImageResolution->{144., 144.},
    SmoothingQuality->"High"],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{240., 163.},
  PlotRange->{{0, 240.}, {0, 163.}}]], "Output",
 CellTags->"RasterizedOutput",
 CellLabel->"Out[12]=",
 CellID->552966857,ExpressionUUID->"3cfb9aef-acc0-41b7-8dc0-4b8e06945fc8"]
}, Open  ]],

Cell[TextData[{
 "The state vector and Schr\[ODoubleDot]dinger equation describe the \
evolution of a single atom (or a completely polarized atomic ensemble) when \
there are no relaxation processes at work. However, we are often interested \
in the evolution, including relaxation mechanisms, of partially polarized or \
unpolarized ensembles, for which the experimental observables are averages \
over the ensemble. For this we use a formalism that generalizes the state \
vector: ",
 ButtonBox["the density matrix",
  BaseStyle->"Link",
  ButtonData->
   "paclet:AtomicDensityMatrix/tutorial/\
TheDensityMatrixAndTheLiouvilleEquation"],
 "."
}], "Text",
 CellID->148218043,ExpressionUUID->"c9872a23-ee97-40e4-a416-ce4c79e756dc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {
    DynamicBox[FEPrivate`ImportImage[
      FrontEnd`FileName[{"Documentation", "FooterIcons"}, "RelatedGuide.png"]],
     ImageSizeCache->{50., {27., 33.}}], GridBox[{
      {
       StyleBox[
        RowBox[{"Related", " ", "Guides"}], "TutorialMoreAboutSection"]},
      {
       RowBox[{
       "\[FilledVerySmallSquare]", Cell[TextData[ButtonBox[
        "AtomicDensityMatrix Package",
         BaseStyle->"Link",
         ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]],
          "TutorialMoreAbout",ExpressionUUID->
         "cabfe379-70d6-47eb-8bdc-f12513760678"]}]}
     }]}
  }]], "TutorialMoreAboutSection",ExpressionUUID->"e7643b71-10d6-41ba-800d-\
8b9b594aa444"],

Cell[BoxData[""], "Input",ExpressionUUID->"9e41169d-5557-4100-8b36-cf055af917d2"],

Cell[BoxData[""], "Input",ExpressionUUID->"8a88b379-9d16-443f-9bc4-f2002fa0156d"]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"4852d593-5073-432e-8f27-13ea29f24a5e"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{900, 830},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"The State Vector and the Schr\[ODoubleDot]dinger Equation",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "", "LinkTrails" -> "", 
  "ExampleCounter" -> 1, 
  "Openers" -> {
   "PrimaryExamplesSection" -> Open, "ExampleSection" -> {"0" -> Open}}, 
  "NewStyles" -> True, "CitationPopupData" -> {$Failed, ""}, "ShowCitation" -> 
  False, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2023, 4, 18, 18, 0, 38.616935}", 
    "history" -> {"10.07", "", "", ""}, "context" -> "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Atomic Density Matrix Tutorial", "language" -> "en", "paclet" -> 
    "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "The main question that the AtomicDensityMatrix package is intended to \
address is In the absence of relaxation, the evolution of a \
quantum-mechanical state vector |\\[Psi]\\[RightAngleBracket] is governed by \
the Schr\[ODoubleDot]dinger equation i \\[HBar] \
\\[PartialD]_t|\\[Psi](t)\\[RightAngleBracket]=H|\\[Psi](t)\\[\
RightAngleBracket], where H is the Hamiltonian. (In the ADM package, we \
generally use units in which H has units of frequency and the reduced \
Planck's constant \\[HBar] is equal to one.) As a simple example, we will \
find the evolution of system consisting of two opposite-parity states with no \
Zeeman or hyperfine substructure, separated by an energy \\[CapitalDelta] and \
subject to a static electric field.", "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$78645, "title" -> 
    "The State Vector and the Schr\[ODoubleDot]dinger Equation", 
    "titlemodifier" -> "", "metadescription" -> "", "windowtitle" -> 
    "The State Vector and the Schr\[ODoubleDot]dinger Equation", "type" -> 
    "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/TheStateVectorAndTheSchrodingerEquation"}},
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> Notebook], 
   Cell[
    StyleData["Output"], CellContext -> Notebook], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "13.2 for Mac OS X x86 (64-bit) (November 18, 2022)", 
  StyleDefinitions -> "Default.nb"],
ExpressionUUID->"7f9a1768-ef23-491e-94b3-7515ecc53d23"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "RasterizedOutput"->{
  Cell[91383, 1877, 41108, 680, 184, "Output",ExpressionUUID->"3cfb9aef-acc0-41b7-8dc0-4b8e06945fc8",
   CellTags->"RasterizedOutput",
   CellID->552966857]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"RasterizedOutput", 137331, 2671}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[620, 21, 4669, 111, 57, "AnchorBarGrid",ExpressionUUID->"6d1db9f2-a2e8-464f-8a5e-58966f1c9c29",
 CellID->1],
Cell[CellGroupData[{
Cell[5314, 136, 149, 1, 110, "Title",ExpressionUUID->"e5f5e389-38a4-432a-ba8d-05699aaef52b",
 CellID->509267359],
Cell[5466, 139, 226, 6, 36, "Text",ExpressionUUID->"9c844591-cdc7-41cf-b0d8-dfdc98f4cd9d",
 CellID->17510842],
Cell[CellGroupData[{
Cell[5717, 149, 345, 6, 72, "TextNote",ExpressionUUID->"cbb720b3-4d7b-42f5-87c5-80aa50b3e718",
 CellID->18368332],
Cell[6065, 157, 1571, 45, 84, "Text",ExpressionUUID->"635a38a9-7a8c-4cec-8142-0862e03a48c5",
 CellID->60640988],
Cell[7639, 204, 489, 10, 60, "Text",ExpressionUUID->"9ef221ee-983f-4968-b716-2c0ce7ebfb38",
 CellID->663252305],
Cell[8131, 216, 115, 1, 36, "MathCaption",ExpressionUUID->"7f14a9da-1039-4648-a40f-5ff37c7032f6",
 CellID->106720500],
Cell[8249, 219, 161, 3, 29, "Input",ExpressionUUID->"d4270865-b5d8-448a-9d3e-9f95190bf4a8",
 CellID->27959808],
Cell[8413, 224, 146, 1, 36, "MathCaption",ExpressionUUID->"4dfff816-a206-4cf6-ae96-1a67d50d9945",
 CellID->200065976],
Cell[CellGroupData[{
Cell[8584, 229, 422, 12, 29, "Input",ExpressionUUID->"1d6c5db6-9ffb-450a-8c96-a0e9a7764031",
 CellID->484360868],
Cell[9009, 243, 391, 11, 37, "Output",ExpressionUUID->"982ce2fb-df10-4137-9a5a-5568f928cf5b",
 CellID->1522551713]
}, Open  ]],
Cell[CellGroupData[{
Cell[9437, 259, 267, 8, 29, "Input",ExpressionUUID->"ff45ca71-0aaa-4061-9c8c-fd95da5e9483",
 CellID->67883978],
Cell[9707, 269, 804, 23, 66, "Output",ExpressionUUID->"7ab7c8b1-57d5-4fa3-943e-d14cabe05f46",
 CellID->2044782247]
}, Open  ]],
Cell[10526, 295, 300, 5, 55, "MathCaption",ExpressionUUID->"b34c8c34-3492-4423-b60b-230cc10c68d4",
 CellID->265025652],
Cell[CellGroupData[{
Cell[10851, 304, 594, 16, 29, "Input",ExpressionUUID->"79690b4c-c1c3-4da2-ae4a-1908f25d77c6",
 CellID->90461799],
Cell[11448, 322, 782, 21, 66, "Output",ExpressionUUID->"d92d67d2-bbb7-48fb-a3b1-d13fc1749f3e",
 CellID->1294450535]
}, Open  ]],
Cell[12245, 346, 135, 1, 36, "MathCaption",ExpressionUUID->"dc3986ce-23b7-42e8-9b81-f8888173ac42",
 CellID->886331892],
Cell[CellGroupData[{
Cell[12405, 351, 376, 10, 29, "Input",ExpressionUUID->"a5870488-cb44-4aba-80eb-9569b621620a",
 CellID->367957306],
Cell[12784, 363, 2036, 59, 53, "Output",ExpressionUUID->"ff6c26ac-d1fe-4671-8be0-ccaef2fc9915",
 CellID->2058963840]
}, Open  ]],
Cell[14835, 425, 128, 1, 70, "MathCaption",ExpressionUUID->"6f9dca04-d460-4aa3-b4ac-cb149bb3a0b0",
 CellID->639160661],
Cell[CellGroupData[{
Cell[14988, 430, 947, 27, 70, "Input",ExpressionUUID->"9687accc-e16e-468a-b8a9-19c19b9f3bf1",
 CellID->294592650],
Cell[15938, 459, 1405, 41, 53, "Output",ExpressionUUID->"517ee047-45b6-471d-9ec2-2f1d5298a276",
 CellID->557378128]
}, Open  ]],
Cell[17358, 503, 132, 1, 70, "MathCaption",ExpressionUUID->"2dd66fe4-a9f9-4e8f-8474-59f0525ec448",
 CellID->197975652],
Cell[CellGroupData[{
Cell[17515, 508, 186, 4, 70, "Input",ExpressionUUID->"6786e373-cfc6-4407-a743-adb050720cd3",
 CellID->276951613],
Cell[17704, 514, 276, 8, 37, "Output",ExpressionUUID->"1271e553-6d10-416c-8c4f-ea29d926cf3b",
 CellID->90922671]
}, Open  ]],
Cell[17995, 525, 140, 1, 70, "MathCaption",ExpressionUUID->"b5cd72e0-d2d7-4f2b-a618-1f8cf08339a1",
 CellID->33833520],
Cell[CellGroupData[{
Cell[18160, 530, 521, 15, 70, "Input",ExpressionUUID->"9a256262-b3ea-4d95-bc5c-57861f786bba",
 CellID->24580560],
Cell[18684, 547, 2139, 61, 79, "Output",ExpressionUUID->"041848a2-4878-46ab-a80f-570d18400025",
 CellID->2073316615]
}, Open  ]],
Cell[20838, 611, 170, 3, 70, "MathCaption",ExpressionUUID->"1dd4c793-fc99-4c3e-9a1a-3716c1c927c1",
 CellID->96187871],
Cell[CellGroupData[{
Cell[21033, 618, 604, 17, 70, "Input",ExpressionUUID->"136dad97-88dd-4939-b62f-f5d411288860",
 CellID->340603720],
Cell[21640, 637, 1753, 61, 115, "Output",ExpressionUUID->"31c952e3-44d9-4ef2-b88b-6b5f0dea9040",
 CellID->1917659497]
}, Open  ]],
Cell[23408, 701, 185, 4, 70, "MathCaption",ExpressionUUID->"ab8863c9-4aee-4837-aede-990559b46466",
 CellID->219586286],
Cell[CellGroupData[{
Cell[23618, 709, 948, 27, 70, "Input",ExpressionUUID->"a2ae5e87-856b-4333-820f-4c10e722256a",
 CellID->280333154],
Cell[24569, 738, 64912, 1073, 245, "Output",ExpressionUUID->"0fbcf470-13a9-489d-94f2-000ed24de314",
 CellID->1998331390]
}, Open  ]],
Cell[89496, 1814, 159, 2, 70, "MathCaption",ExpressionUUID->"0467abb0-cb62-447a-abdf-221ccfc9ca35",
 CellID->94345139],
Cell[CellGroupData[{
Cell[89680, 1820, 522, 14, 70, "Input",ExpressionUUID->"d1200d50-7053-444c-9b9d-54b353452800",
 CellID->427371019],
Cell[90205, 1836, 600, 21, 52, "Output",ExpressionUUID->"d4ac2e03-9c25-44bf-ac4d-a92d48ac54c8",
 CellID->56991241]
}, Open  ]],
Cell[90820, 1860, 121, 1, 70, "MathCaption",ExpressionUUID->"5a9b760f-f929-4f42-880a-f5271bc67e4c",
 CellID->300686189],
Cell[CellGroupData[{
Cell[90966, 1865, 414, 10, 70, "Input",ExpressionUUID->"6808252b-b889-4e28-a7cd-7034e835fd7f",
 CellID->33775256],
Cell[91383, 1877, 41108, 680, 184, "Output",ExpressionUUID->"3cfb9aef-acc0-41b7-8dc0-4b8e06945fc8",
 CellTags->"RasterizedOutput",
 CellID->552966857]
}, Open  ]],
Cell[132506, 2560, 731, 15, 70, "Text",ExpressionUUID->"c9872a23-ee97-40e4-a416-ce4c79e756dc",
 CellID->148218043]
}, Open  ]],
Cell[CellGroupData[{
Cell[133274, 2580, 725, 18, 70, "TutorialMoreAboutSection",ExpressionUUID->"e7643b71-10d6-41ba-800d-8b9b594aa444"],
Cell[134002, 2600, 81, 0, 70, "Input",ExpressionUUID->"9e41169d-5557-4100-8b36-cf055af917d2"],
Cell[134086, 2602, 81, 0, 70, "Input",ExpressionUUID->"8a88b379-9d16-443f-9bc4-f2002fa0156d"]
}, Open  ]]
}, Open  ]],
Cell[134194, 2606, 78, 0, 70, "FooterCell",ExpressionUUID->"4852d593-5073-432e-8f27-13ea29f24a5e"]
}
]
*)

(* End of internal cache information *)

